(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var RateLimiter = Package['rate-limit'].RateLimiter;
var ReactiveVar = Package['reactive-var'].ReactiveVar;
var ReactiveDict = Package['reactive-dict'].ReactiveDict;
var ECMAScript = Package.ecmascript.ECMAScript;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var Tracker = Package.tracker.Tracker;
var Deps = Package.tracker.Deps;
var DDPRateLimiter = Package['ddp-rate-limiter'].DDPRateLimiter;
var _ = Package.underscore._;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var s = Package['underscorestring:underscore.string'].s;
var CollectionHooks = Package['matb33:collection-hooks'].CollectionHooks;
var ServiceConfiguration = Package['service-configuration'].ServiceConfiguration;
var Streamer = Package['rocketchat:streamer'].Streamer;
var Logger = Package['rocketchat:logger'].Logger;
var TAPi18next = Package['tap:i18n'].TAPi18next;
var TAPi18n = Package['tap:i18n'].TAPi18n;
var babelHelpers = Package['babel-runtime'].babelHelpers;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var __coffeescriptShare, RocketChat, translations;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/core.coffee.js                                                                          //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
                                                                                                                       // 1
/*                                                                                                                     // 1
 * Kick off the global namespace for RocketChat.                                                                       //
 * @namespace RocketChat                                                                                               //
 */                                                                                                                    //
                                                                                                                       // 1
                                                                                                                       //
RocketChat = {                                                                                                         // 1
  models: {}                                                                                                           // 7
};                                                                                                                     //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/debug.js                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.debugLevel = 'debug';                                                                                       // 1
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 3
	RocketChat.settings.onload('Debug_Level', function (key, value /*, initialLoad*/) {                                   // 4
		if (value) {                                                                                                         // 5
			RocketChat.debugLevel = value;                                                                                      // 6
		}                                                                                                                    //
	});                                                                                                                   //
                                                                                                                       //
	var value = RocketChat.settings.get('Debug_Level');                                                                   // 10
	if (value) {                                                                                                          // 11
		RocketChat.debugLevel = value;                                                                                       // 12
	}                                                                                                                     //
});                                                                                                                    //
                                                                                                                       //
var wrapMethods = function (name, originalHandler, methodsMap) {                                                       // 16
	methodsMap[name] = function () {                                                                                      // 17
		if (RocketChat.debugLevel === 'debug') {                                                                             // 18
			var args = name === 'ufsWrite' ? Array.prototype.slice.call(arguments, 1) : arguments;                              // 19
			console.log('[methods]'.green, name, '-> userId:', Meteor.userId(), ', arguments: ', args);                         // 20
		}                                                                                                                    //
                                                                                                                       //
		return originalHandler.apply(this, arguments);                                                                       // 23
	};                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var originalMeteorMethods = Meteor.methods;                                                                            // 27
                                                                                                                       //
Meteor.methods = function (methodMap) {                                                                                // 29
	_.each(methodMap, function (handler, name) {                                                                          // 30
		wrapMethods(name, handler, methodMap);                                                                               // 31
	});                                                                                                                   //
	originalMeteorMethods(methodMap);                                                                                     // 33
};                                                                                                                     //
                                                                                                                       //
var originalMeteorPublish = Meteor.publish;                                                                            // 36
                                                                                                                       //
Meteor.publish = function (name, func) {                                                                               // 38
	return originalMeteorPublish(name, function () {                                                                      // 39
		if (RocketChat.debugLevel === 'debug') {                                                                             // 40
			console.log('[publish]'.green, name, '-> userId:', this.userId, ', arguments: ', arguments);                        // 41
		}                                                                                                                    //
                                                                                                                       //
		return func.apply(this, arguments);                                                                                  // 44
	});                                                                                                                   //
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/settings.coffee.js                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
                                                                                                                       // 1
/*                                                                                                                     // 1
 * RocketChat.settings holds all packages settings                                                                     //
 * @namespace RocketChat.settings                                                                                      //
 */                                                                                                                    //
RocketChat.settings = {                                                                                                // 1
  callbacks: {},                                                                                                       // 6
  ts: new Date,                                                                                                        // 6
  get: function(_id) {                                                                                                 // 6
    var ref;                                                                                                           // 10
    return (ref = Meteor.settings) != null ? ref[_id] : void 0;                                                        // 10
  },                                                                                                                   //
  get: function(_id, callback) {                                                                                       // 6
    var ref, ref1, ref2;                                                                                               // 13
    if (callback != null) {                                                                                            // 13
      RocketChat.settings.onload(_id, callback);                                                                       // 14
      if (((ref = Meteor.settings) != null ? ref[_id] : void 0) != null) {                                             // 15
        return callback(_id, (ref1 = Meteor.settings) != null ? ref1[_id] : void 0);                                   //
      }                                                                                                                //
    } else {                                                                                                           //
      return (ref2 = Meteor.settings) != null ? ref2[_id] : void 0;                                                    // 18
    }                                                                                                                  //
  },                                                                                                                   //
  set: function(_id, value, callback) {                                                                                // 6
    return Meteor.call('saveSetting', _id, value, callback);                                                           //
  },                                                                                                                   //
  batchSet: function(settings, callback) {                                                                             // 6
    var actions, save;                                                                                                 // 28
    save = function(setting) {                                                                                         // 28
      return function(callback) {                                                                                      // 29
        return Meteor.call('saveSetting', setting._id, setting.value, callback);                                       //
      };                                                                                                               //
    };                                                                                                                 //
    actions = _.map(settings, function(setting) {                                                                      // 28
      return save(setting);                                                                                            //
    });                                                                                                                //
    return _(actions).reduceRight(_.wrap, function(err, success) {                                                     //
      return callback(err, success);                                                                                   // 33
    })();                                                                                                              //
  },                                                                                                                   //
  load: function(key, value, initialLoad) {                                                                            // 6
    var callback, i, j, len, len1, ref, ref1, results;                                                                 // 36
    if (RocketChat.settings.callbacks[key] != null) {                                                                  // 36
      ref = RocketChat.settings.callbacks[key];                                                                        // 37
      for (i = 0, len = ref.length; i < len; i++) {                                                                    // 37
        callback = ref[i];                                                                                             //
        callback(key, value, initialLoad);                                                                             // 38
      }                                                                                                                // 37
    }                                                                                                                  //
    if (RocketChat.settings.callbacks['*'] != null) {                                                                  // 40
      ref1 = RocketChat.settings.callbacks['*'];                                                                       // 41
      results = [];                                                                                                    // 41
      for (j = 0, len1 = ref1.length; j < len1; j++) {                                                                 //
        callback = ref1[j];                                                                                            //
        results.push(callback(key, value, initialLoad));                                                               // 42
      }                                                                                                                // 41
      return results;                                                                                                  //
    }                                                                                                                  //
  },                                                                                                                   //
  onload: function(key, callback) {                                                                                    // 6
    var base, i, k, keys, len, results;                                                                                // 52
    keys = [].concat(key);                                                                                             // 52
    results = [];                                                                                                      // 54
    for (i = 0, len = keys.length; i < len; i++) {                                                                     //
      k = keys[i];                                                                                                     //
      if ((base = RocketChat.settings.callbacks)[k] == null) {                                                         //
        base[k] = [];                                                                                                  //
      }                                                                                                                //
      results.push(RocketChat.settings.callbacks[k].push(callback));                                                   // 55
    }                                                                                                                  // 54
    return results;                                                                                                    //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/configLogger.coffee.js                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.settings.get('Log_Package', function(key, value) {                                                          // 1
  return typeof LoggerManager !== "undefined" && LoggerManager !== null ? LoggerManager.showPackage = value : void 0;  //
});                                                                                                                    // 1
                                                                                                                       //
RocketChat.settings.get('Log_File', function(key, value) {                                                             // 1
  return typeof LoggerManager !== "undefined" && LoggerManager !== null ? LoggerManager.showFileAndLine = value : void 0;
});                                                                                                                    // 4
                                                                                                                       //
RocketChat.settings.get('Log_Level', function(key, value) {                                                            // 1
  if (value != null) {                                                                                                 // 8
    if (typeof LoggerManager !== "undefined" && LoggerManager !== null) {                                              //
      LoggerManager.logLevel = parseInt(value);                                                                        //
    }                                                                                                                  //
    return Meteor.setTimeout(function() {                                                                              //
      return typeof LoggerManager !== "undefined" && LoggerManager !== null ? LoggerManager.enable(true) : void 0;     //
    }, 200);                                                                                                           //
  }                                                                                                                    //
});                                                                                                                    // 7
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/callbacks.coffee.js                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
                                                                                                                       // 3
/*                                                                                                                     // 3
 * Callback hooks provide an easy way to add extra steps to common operations.                                         //
 * @namespace RocketChat.callbacks                                                                                     //
 */                                                                                                                    //
RocketChat.callbacks = {};                                                                                             // 3
                                                                                                                       //
RocketChat.callbacks.showTime = false;                                                                                 // 3
                                                                                                                       //
                                                                                                                       // 11
/*                                                                                                                     // 11
 * Callback priorities                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.callbacks.priority = {                                                                                      // 3
  HIGH: -1000,                                                                                                         // 15
  MEDIUM: 0,                                                                                                           // 15
  LOW: 1000                                                                                                            // 15
};                                                                                                                     //
                                                                                                                       //
                                                                                                                       // 19
/*                                                                                                                     // 19
 * Add a callback function to a hook                                                                                   //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Function} callback - The callback function                                                                  //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.callbacks.add = function(hook, callback, priority, id) {                                                    // 3
  var base, cb, err, i, len, ref;                                                                                      // 26
  if (priority == null) {                                                                                              //
    priority = RocketChat.callbacks.priority.MEDIUM;                                                                   //
  }                                                                                                                    //
  if (!_.isNumber(priority)) {                                                                                         // 27
    priority = RocketChat.callbacks.priority.MEDIUM;                                                                   // 28
  }                                                                                                                    //
  callback.priority = priority;                                                                                        // 26
  callback.id = id || Random.id();                                                                                     // 26
  if ((base = RocketChat.callbacks)[hook] == null) {                                                                   //
    base[hook] = [];                                                                                                   //
  }                                                                                                                    //
  if (RocketChat.callbacks.showTime === true) {                                                                        // 33
    err = new Error;                                                                                                   // 34
    callback.stack = err.stack;                                                                                        // 34
  }                                                                                                                    //
  ref = RocketChat.callbacks[hook];                                                                                    // 38
  for (i = 0, len = ref.length; i < len; i++) {                                                                        // 38
    cb = ref[i];                                                                                                       //
    if (cb.id === callback.id) {                                                                                       // 39
      return;                                                                                                          // 40
    }                                                                                                                  //
  }                                                                                                                    // 38
  RocketChat.callbacks[hook].push(callback);                                                                           // 26
};                                                                                                                     // 24
                                                                                                                       //
                                                                                                                       // 45
/*                                                                                                                     // 45
 * Remove a callback from a hook                                                                                       //
 * @param {string} hook - The name of the hook                                                                         //
 * @param {string} id - The callback's id                                                                              //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.callbacks.remove = function(hookName, id) {                                                                 // 3
  RocketChat.callbacks[hookName] = _.reject(RocketChat.callbacks[hookName], function(callback) {                       // 52
    return callback.id === id;                                                                                         //
  });                                                                                                                  //
};                                                                                                                     // 51
                                                                                                                       //
                                                                                                                       // 56
/*                                                                                                                     // 56
 * Successively run all of a hook's callbacks on an item                                                               //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Object} item - The post, comment, modifier, etc. on which to run the callbacks                              //
 * @param {Object} [constant] - An optional constant that will be passed along to each callback                        //
 * @returns {Object} Returns the item after it's been through all the callbacks for this hook                          //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.callbacks.run = function(hook, item, constant) {                                                            // 3
  var callbacks;                                                                                                       // 65
  callbacks = RocketChat.callbacks[hook];                                                                              // 65
  if (!!(callbacks != null ? callbacks.length : void 0)) {                                                             // 66
    return _.sortBy(callbacks, function(callback) {                                                                    //
      return callback.priority || RocketChat.callbacks.priority.MEDIUM;                                                // 68
    }).reduce(function(result, callback) {                                                                             //
      var callbackResult, time;                                                                                        // 70
      if (RocketChat.callbacks.showTime === true) {                                                                    // 70
        time = Date.now();                                                                                             // 71
      }                                                                                                                //
      callbackResult = callback(result, constant);                                                                     // 70
      if (RocketChat.callbacks.showTime === true) {                                                                    // 75
        console.log(hook, Date.now() - time);                                                                          // 76
        console.log(callback.stack.split('\n')[2]);                                                                    // 76
      }                                                                                                                //
      return callbackResult;                                                                                           // 79
    }, item);                                                                                                          //
  } else {                                                                                                             //
    return item;                                                                                                       //
  }                                                                                                                    //
};                                                                                                                     // 64
                                                                                                                       //
                                                                                                                       // 85
/*                                                                                                                     // 85
 * Successively run all of a hook's callbacks on an item, in async mode (only works on server)                         //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Object} item - The post, comment, modifier, etc. on which to run the callbacks                              //
 * @param {Object} [constant] - An optional constant that will be passed along to each callback                        //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.callbacks.runAsync = function(hook, item, constant) {                                                       // 3
  var callbacks;                                                                                                       // 93
  callbacks = RocketChat.callbacks[hook];                                                                              // 93
  if (Meteor.isServer && !!(callbacks != null ? callbacks.length : void 0)) {                                          // 94
    Meteor.defer(function() {                                                                                          // 96
      _.sortBy(callbacks, function(callback) {                                                                         // 98
        return callback.priority || RocketChat.callbacks.priority.MEDIUM;                                              // 98
      }).forEach(function(callback) {                                                                                  //
        callback(item, constant);                                                                                      // 100
      });                                                                                                              //
    });                                                                                                                //
  } else {                                                                                                             //
    return item;                                                                                                       // 104
  }                                                                                                                    //
};                                                                                                                     // 92
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/fileUploadRestrictions.js                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.fileUploadMediaWhiteList = function () {                                                                    // 1
	var mediaTypeWhiteList = RocketChat.settings.get('FileUpload_MediaTypeWhiteList');                                    // 2
                                                                                                                       //
	if (!mediaTypeWhiteList || mediaTypeWhiteList === '*') {                                                              // 4
		return;                                                                                                              // 5
	}                                                                                                                     //
	return _.map(mediaTypeWhiteList.split(','), function (item) {                                                         // 7
		return item.trim();                                                                                                  // 8
	});                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
RocketChat.fileUploadIsValidContentType = function (type) {                                                            // 12
	var list, wildCardGlob, wildcards;                                                                                    // 13
	list = RocketChat.fileUploadMediaWhiteList();                                                                         // 14
	if (!list || _.contains(list, type)) {                                                                                // 15
		return true;                                                                                                         // 16
	} else {                                                                                                              //
		wildCardGlob = '/*';                                                                                                 // 18
		wildcards = _.filter(list, function (item) {                                                                         // 19
			return item.indexOf(wildCardGlob) > 0;                                                                              // 20
		});                                                                                                                  //
		if (_.contains(wildcards, type.replace(/(\/.*)$/, wildCardGlob))) {                                                  // 22
			return true;                                                                                                        // 23
		}                                                                                                                    //
	}                                                                                                                     //
	return false;                                                                                                         // 26
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/promises.coffee.js                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
                                                                                                                       // 3
/*                                                                                                                     // 3
 * Callback hooks provide an easy way to add extra steps to common operations.                                         //
 * @namespace RocketChat.promises                                                                                      //
 */                                                                                                                    //
RocketChat.promises = {};                                                                                              // 3
                                                                                                                       //
                                                                                                                       // 9
/*                                                                                                                     // 9
 * Callback priorities                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.promises.priority = {                                                                                       // 3
  HIGH: -1000,                                                                                                         // 13
  MEDIUM: 0,                                                                                                           // 13
  LOW: 1000                                                                                                            // 13
};                                                                                                                     //
                                                                                                                       //
                                                                                                                       // 17
/*                                                                                                                     // 17
 * Add a callback function to a hook                                                                                   //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Function} callback - The callback function                                                                  //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.promises.add = function(hook, callback, priority, id) {                                                     // 3
  var base, cb, i, len, ref;                                                                                           // 25
  if (priority == null) {                                                                                              //
    priority = RocketChat.promises.priority.MEDIUM;                                                                    //
  }                                                                                                                    //
  if (!_.isNumber(priority)) {                                                                                         // 26
    priority = RocketChat.promises.priority.MEDIUM;                                                                    // 27
  }                                                                                                                    //
  callback.priority = priority;                                                                                        // 25
  callback.id = id || Random.id();                                                                                     // 25
  if ((base = RocketChat.promises)[hook] == null) {                                                                    //
    base[hook] = [];                                                                                                   //
  }                                                                                                                    //
  ref = RocketChat.promises[hook];                                                                                     // 33
  for (i = 0, len = ref.length; i < len; i++) {                                                                        // 33
    cb = ref[i];                                                                                                       //
    if (cb.id === callback.id) {                                                                                       // 34
      return;                                                                                                          // 35
    }                                                                                                                  //
  }                                                                                                                    // 33
  RocketChat.promises[hook].push(callback);                                                                            // 25
};                                                                                                                     // 23
                                                                                                                       //
                                                                                                                       // 40
/*                                                                                                                     // 40
 * Remove a callback from a hook                                                                                       //
 * @param {string} hook - The name of the hook                                                                         //
 * @param {string} id - The callback's id                                                                              //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.promises.remove = function(hookName, id) {                                                                  // 3
  RocketChat.promises[hookName] = _.reject(RocketChat.promises[hookName], function(callback) {                         // 47
    return callback.id === id;                                                                                         //
  });                                                                                                                  //
};                                                                                                                     // 46
                                                                                                                       //
                                                                                                                       // 51
/*                                                                                                                     // 51
 * Successively run all of a hook's callbacks on an item                                                               //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Object} item - The post, comment, modifier, etc. on which to run the callbacks                              //
 * @param {Object} [constant] - An optional constant that will be passed along to each callback                        //
 * @returns {Object} Returns the item after it's been through all the callbacks for this hook                          //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.promises.run = function(hook, item, constant) {                                                             // 3
  var callbacks;                                                                                                       // 60
  callbacks = RocketChat.promises[hook];                                                                               // 60
  if (!!(callbacks != null ? callbacks.length : void 0)) {                                                             // 61
    callbacks = _.sortBy(callbacks, function(callback) {                                                               // 63
      return callback.priority || RocketChat.promises.priority.MEDIUM;                                                 // 63
    });                                                                                                                //
    return callbacks.reduce(function(previousPromise, callback) {                                                      // 64
      return new Promise(function(resolve, reject) {                                                                   // 65
        return previousPromise.then(function(result) {                                                                 //
          return callback(result, constant).then(resolve, reject);                                                     //
        });                                                                                                            //
      });                                                                                                              //
    }, Promise.resolve(item));                                                                                         //
  } else {                                                                                                             //
    return Promise.resolve(item);                                                                                      // 71
  }                                                                                                                    //
};                                                                                                                     // 59
                                                                                                                       //
                                                                                                                       // 73
/*                                                                                                                     // 73
 * Successively run all of a hook's callbacks on an item, in async mode (only works on server)                         //
 * @param {String} hook - The name of the hook                                                                         //
 * @param {Object} item - The post, comment, modifier, etc. on which to run the callbacks                              //
 * @param {Object} [constant] - An optional constant that will be passed along to each callback                        //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.promises.runAsync = function(hook, item, constant) {                                                        // 3
  var callbacks;                                                                                                       // 81
  callbacks = RocketChat.promises[hook];                                                                               // 81
  if (Meteor.isServer && !!(callbacks != null ? callbacks.length : void 0)) {                                          // 82
    Meteor.defer(function() {                                                                                          // 84
      _.sortBy(callbacks, function(callback) {                                                                         // 86
        return callback.priority || RocketChat.promises.priority.MEDIUM;                                               // 86
      }).forEach(function(callback) {                                                                                  //
        callback(item, constant);                                                                                      // 88
      });                                                                                                              //
    });                                                                                                                //
  } else {                                                                                                             //
    return item;                                                                                                       // 92
  }                                                                                                                    //
};                                                                                                                     // 80
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/slashCommand.coffee.js                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.slashCommands = {                                                                                           // 1
  commands: {}                                                                                                         // 2
};                                                                                                                     //
                                                                                                                       //
RocketChat.slashCommands.add = function(command, callback, options) {                                                  // 1
  RocketChat.slashCommands.commands[command] = {                                                                       // 5
    command: command,                                                                                                  // 6
    callback: callback,                                                                                                // 6
    params: options != null ? options.params : void 0,                                                                 // 6
    description: options != null ? options.description : void 0                                                        // 6
  };                                                                                                                   //
};                                                                                                                     // 4
                                                                                                                       //
RocketChat.slashCommands.run = function(command, params, item) {                                                       // 1
  var callback, ref;                                                                                                   // 14
  if (((ref = RocketChat.slashCommands.commands[command]) != null ? ref.callback : void 0) != null) {                  // 14
    callback = RocketChat.slashCommands.commands[command].callback;                                                    // 15
    return callback(command, params, item);                                                                            //
  }                                                                                                                    //
};                                                                                                                     // 13
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
  slashCommand: function(command) {                                                                                    // 20
    if (!Meteor.userId()) {                                                                                            // 21
      throw new Meteor.Error(203, t('User_logged_out'));                                                               // 22
    }                                                                                                                  //
    return RocketChat.slashCommands.run(command.cmd, command.params, command.msg);                                     //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/Message.coffee.js                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.Message = {                                                                                                 // 1
  parse: function(msg, language) {                                                                                     // 2
    var messageType, ref;                                                                                              // 3
    messageType = RocketChat.MessageTypes.getType(msg);                                                                // 3
    if ((messageType != null ? messageType.render : void 0) != null) {                                                 // 4
      return messageType.render(msg);                                                                                  // 5
    } else if ((messageType != null ? messageType.template : void 0) != null) {                                        //
                                                                                                                       // 6
    } else if ((messageType != null ? messageType.message : void 0) != null) {                                         //
      if (!language && (typeof localStorage !== "undefined" && localStorage !== null ? localStorage.getItem('userLanguage') : void 0)) {
        language = localStorage.getItem('userLanguage');                                                               // 10
      }                                                                                                                //
      if ((typeof messageType.data === "function" ? messageType.data(msg) : void 0) != null) {                         // 11
        return TAPi18n.__(messageType.message, messageType.data(msg), language);                                       // 12
      } else {                                                                                                         //
        return TAPi18n.__(messageType.message, {}, language);                                                          // 14
      }                                                                                                                //
    } else {                                                                                                           //
      if (((ref = msg.u) != null ? ref.username : void 0) === RocketChat.settings.get('Chatops_Username')) {           // 16
        msg.html = msg.msg;                                                                                            // 17
        return msg.html;                                                                                               // 18
      }                                                                                                                //
      msg.html = msg.msg;                                                                                              // 16
      if (_.trim(msg.html) !== '') {                                                                                   // 21
        msg.html = _.escapeHTML(msg.html);                                                                             // 22
      }                                                                                                                //
      msg.html = msg.html.replace(/\n/gm, '<br/>');                                                                    // 16
      return msg.html;                                                                                                 // 26
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/MessageTypes.coffee.js                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.MessageTypes = new ((function() {                                                                           // 1
  var getType, isSystemMessage, registerType, types;                                                                   // 2
                                                                                                                       //
  function _Class() {}                                                                                                 //
                                                                                                                       //
  types = {};                                                                                                          // 2
                                                                                                                       //
  registerType = function(options) {                                                                                   // 2
    return types[options.id] = options;                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  getType = function(message) {                                                                                        // 2
    return types[message != null ? message.t : void 0];                                                                // 8
  };                                                                                                                   //
                                                                                                                       //
  isSystemMessage = function(message) {                                                                                // 2
    var ref;                                                                                                           // 11
    return (ref = types[message != null ? message.t : void 0]) != null ? ref.system : void 0;                          // 11
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.registerType = registerType;                                                                        // 2
                                                                                                                       //
  _Class.prototype.getType = getType;                                                                                  // 2
                                                                                                                       //
  _Class.prototype.isSystemMessage = isSystemMessage;                                                                  // 2
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})());                                                                                                                 //
                                                                                                                       //
Meteor.startup(function() {                                                                                            // 1
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'r',                                                                                                           // 19
    system: true,                                                                                                      // 19
    message: 'Room_name_changed',                                                                                      // 19
    data: function(message) {                                                                                          // 19
      return {                                                                                                         // 23
        room_name: message.msg,                                                                                        // 23
        user_by: message.u.username                                                                                    // 23
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'au',                                                                                                          // 26
    system: true,                                                                                                      // 26
    message: 'User_added_by',                                                                                          // 26
    data: function(message) {                                                                                          // 26
      return {                                                                                                         // 30
        user_added: message.msg,                                                                                       // 30
        user_by: message.u.username                                                                                    // 30
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'ru',                                                                                                          // 33
    system: true,                                                                                                      // 33
    message: 'User_removed_by',                                                                                        // 33
    data: function(message) {                                                                                          // 33
      return {                                                                                                         // 37
        user_removed: message.msg,                                                                                     // 37
        user_by: message.u.username                                                                                    // 37
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'ul',                                                                                                          // 40
    system: true,                                                                                                      // 40
    message: 'User_left',                                                                                              // 40
    data: function(message) {                                                                                          // 40
      return {                                                                                                         // 44
        user_left: message.u.username                                                                                  // 44
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'uj',                                                                                                          // 47
    system: true,                                                                                                      // 47
    message: 'User_joined_channel',                                                                                    // 47
    data: function(message) {                                                                                          // 47
      return {                                                                                                         // 51
        user: message.u.username                                                                                       // 51
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'wm',                                                                                                          // 54
    system: true,                                                                                                      // 54
    message: 'Welcome',                                                                                                // 54
    data: function(message) {                                                                                          // 54
      return {                                                                                                         // 58
        user: message.u.username                                                                                       // 58
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'rm',                                                                                                          // 61
    system: true,                                                                                                      // 61
    message: 'Message_removed',                                                                                        // 61
    data: function(message) {                                                                                          // 61
      return {                                                                                                         // 65
        user: message.u.username                                                                                       // 65
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'rtc',                                                                                                         // 68
    render: function(message) {                                                                                        // 68
      return RocketChat.callbacks.run('renderRtcMessage', message);                                                    //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'user-muted',                                                                                                  // 73
    system: true,                                                                                                      // 73
    message: 'User_muted_by',                                                                                          // 73
    data: function(message) {                                                                                          // 73
      return {                                                                                                         // 77
        user_muted: message.msg,                                                                                       // 77
        user_by: message.u.username                                                                                    // 77
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'user-unmuted',                                                                                                // 80
    system: true,                                                                                                      // 80
    message: 'User_unmuted_by',                                                                                        // 80
    data: function(message) {                                                                                          // 80
      return {                                                                                                         // 84
        user_unmuted: message.msg,                                                                                     // 84
        user_by: message.u.username                                                                                    // 84
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  RocketChat.MessageTypes.registerType({                                                                               // 18
    id: 'subscription-role-added',                                                                                     // 87
    system: true,                                                                                                      // 87
    message: '__username__was_set__role__by__user_by_',                                                                // 87
    data: function(message) {                                                                                          // 87
      return {                                                                                                         // 91
        username: message.msg,                                                                                         // 91
        role: message.role,                                                                                            // 91
        user_by: message.u.username                                                                                    // 91
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
  return RocketChat.MessageTypes.registerType({                                                                        //
    id: 'subscription-role-removed',                                                                                   // 94
    system: true,                                                                                                      // 94
    message: '__username__is_no_longer__role__defined_by__user_by_',                                                   // 94
    data: function(message) {                                                                                          // 94
      return {                                                                                                         // 98
        username: message.msg,                                                                                         // 98
        role: message.role,                                                                                            // 98
        user_by: message.u.username                                                                                    // 98
      };                                                                                                               //
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    // 17
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/defaultBlockedDomainsList.js                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.emailDomainDefaultBlackList = ['0-mail.com', '0815.ru', '0815.su', '0clickemail.com', '0wnd.net', '0wnd.org', '10mail.org', '10minut.com.pl', '10minutemail.co.za', '10minutemail.com', '10minutemail.de', '123-m.com', '1chuan.com', '1fsdfdsfsdf.tk', '1pad.de', '1zhuan.com', '20email.eu', '20mail.eu', '20mail.it', '20minutemail.com', '21cn.com', '2fdgdfgdfgdf.tk', '2prong.com', '30minutemail.com', '33mail.com', '3d-painting.com', '3trtretgfrfe.tk', '4gfdsgfdgfd.tk', '4warding.com', '4warding.net', '4warding.org', '5ghgfhfghfgh.tk', '60minutemail.com', '675hosting.com', '675hosting.net', '675hosting.org', '6hjgjhgkilkj.tk', '6ip.us', '6paq.com', '6url.com', '75hosting.com', '75hosting.net', '75hosting.org', '7days-printing.com', '7tags.com', '99experts.com', '9ox.net', 'a-bc.net', 'a45.in', 'abcmail.email', 'abyssmail.com', 'acentri.com', 'advantimo.com', 'afrobacon.com', 'ag.us.to', 'agedmail.com', 'ahk.jp', 'ajaxapp.net', 'alivance.com', 'ama-trade.de', 'amail.com', 'amilegit.com', 'amiri.net', 'amiriindustries.com', 'anappthat.com', 'ano-mail.net', 'anonbox.net', 'anonmails.de', 'anonymail.dk', 'anonymbox.com', 'antichef.com', 'antichef.net', 'antireg.ru', 'antispam.de', 'antispammail.de', 'appixie.com', 'armyspy.com', 'artman-conception.com', 'aver.com', 'azmeil.tk', 'baxomale.ht.cx', 'beddly.com', 'beefmilk.com', 'bigprofessor.so', 'bigstring.com', 'binkmail.com', 'bio-muesli.net', 'blogmyway.org', 'bobmail.info', 'bofthew.com', 'bootybay.de', 'boun.cr', 'bouncr.com', 'boxformail.in', 'breakthru.com', 'brefmail.com', 'brennendesreich.de', 'broadbandninja.com', 'bsnow.net', 'bspamfree.org', 'bu.mintemail.com', 'buffemail.com', 'bugmenot.com', 'bumpymail.com', 'bund.us', 'bundes-li.ga', 'burnthespam.info', 'burstmail.info', 'buymoreplays.com', 'buyusedlibrarybooks.org', 'byom.de', 'c2.hu', 'cachedot.net', 'card.zp.ua', 'casualdx.com', 'cbair.com', 'cek.pm', 'cellurl.com', 'centermail.com', 'centermail.net', 'chammy.info', 'cheatmail.de', 'childsavetrust.org', 'chogmail.com', 'choicemail1.com', 'chong-mail.com', 'chong-mail.net', 'chong-mail.org', 'clixser.com', 'cmail.com', 'cmail.net', 'cmail.org', 'coldemail.info', 'consumerriot.com', 'cool.fr.nf', 'correo.blogos.net', 'cosmorph.com', 'courriel.fr.nf', 'courrieltemporaire.com', 'crapmail.org', 'crazymailing.com', 'cubiclink.com', 'curryworld.de', 'cust.in', 'cuvox.de', 'd3p.dk', 'dacoolest.com', 'daintly.com', 'dandikmail.com', 'dayrep.com', 'dbunker.com', 'dcemail.com', 'deadaddress.com', 'deadspam.com', 'deagot.com', 'dealja.com', 'delikkt.de', 'despam.it', 'despammed.com', 'devnullmail.com', 'dfgh.net', 'digitalsanctuary.com', 'dingbone.com', 'discard.email', 'discardmail.com', 'discardmail.de', 'disposableaddress.com', 'disposableemailaddresses.com', 'disposableemailaddresses.emailmiser.com', 'disposableinbox.com', 'dispose.it', 'disposeamail.com', 'disposemail.com', 'dispostable.com', 'dlemail.ru', 'dm.w3internet.co.uk', 'dm.w3internet.co.ukexample.com', 'dodgeit.com', 'dodgit.com', 'dodgit.org', 'doiea.com', 'domozmail.com', 'donemail.ru', 'dontreg.com', 'dontsendmespam.de', 'dotmsg.com', 'drdrb.com', 'drdrb.net', 'droplar.com', 'dropmail.me', 'dt.com', 'duam.net', 'dudmail.com', 'dump-email.info', 'dumpandjunk.com', 'dumpmail.de', 'dumpyemail.com', 'duskmail.com', 'e-mail.com', 'e-mail.org', 'e4ward.com', 'easytrashmail.com', 'einmalmail.de', 'einrot.com', 'einrot.de', 'eintagsmail.de', 'email60.com', 'emaildienst.de', 'emailgo.de', 'emailias.com', 'emailigo.de', 'emailinfive.com', 'emaillime.com', 'emailmiser.com', 'emailproxsy.com', 'emailsensei.com', 'emailtemporanea.com', 'emailtemporanea.net', 'emailtemporar.ro', 'emailtemporario.com.br', 'emailthe.net', 'emailtmp.com', 'emailto.de', 'emailwarden.com', 'emailx.at.hm', 'emailxfer.com', 'emeil.in', 'emeil.ir', 'emil.com', 'emz.net', 'enterto.com', 'ephemail.net', 'ero-tube.org', 'etranquil.com', 'etranquil.net', 'etranquil.org', 'evopo.com', 'explodemail.com', 'express.net.ua', 'eyepaste.com', 'fakeinbox.com', 'fakeinformation.com', 'fakemail.fr', 'fakemailz.com', 'fammix.com', 'fansworldwide.de', 'fantasymail.de', 'fastacura.com', 'fastchevy.com', 'fastchrysler.com', 'fastkawasaki.com', 'fastmazda.com', 'fastmitsubishi.com', 'fastnissan.com', 'fastsubaru.com', 'fastsuzuki.com', 'fasttoyota.com', 'fastyamaha.com', 'fatflap.com', 'fdfdsfds.com', 'fightallspam.com', 'figjs.com', 'fiifke.de', 'filzmail.com', 'fivemail.de', 'fixmail.tk', 'fizmail.com', 'fleckens.hu', 'flemail.ru', 'flyspam.com', 'footard.com', 'forgetmail.com', 'fr33mail.info', 'frapmail.com', 'freundin.ru', 'friendlymail.co.uk', 'front14.org', 'fuckingduh.com', 'fudgerub.com', 'fux0ringduh.com', 'fyii.de', 'garliclife.com', 'gehensiemirnichtaufdensack.de', 'gelitik.in', 'get1mail.com', 'get2mail.fr', 'getairmail.com', 'getmails.eu', 'getonemail.com', 'getonemail.net', 'ghosttexter.de', 'giantmail.de', 'girlsundertheinfluence.com', 'gishpuppy.com', 'gmial.com', 'goemailgo.com', 'gorillaswithdirtyarmpits.com', 'gotmail.com', 'gotmail.net', 'gotmail.org', 'gotti.otherinbox.com', 'gowikibooks.com', 'gowikicampus.com', 'gowikicars.com', 'gowikifilms.com', 'gowikigames.com', 'gowikimusic.com', 'gowikimusic.great-host.in', 'gowikinetwork.com', 'gowikitravel.com', 'gowikitv.com', 'grandmamail.com', 'grandmasmail.com', 'great-host.in', 'greensloth.com', 'grr.la', 'gsrv.co.uk', 'guerillamail.biz', 'guerillamail.com', 'guerillamail.net', 'guerillamail.org', 'guerrillamail.biz', 'guerrillamail.com', 'guerrillamail.de', 'guerrillamail.info', 'guerrillamail.net', 'guerrillamail.org', 'guerrillamailblock.com', 'gustr.com', 'h.mintemail.com', 'h8s.org', 'hacccc.com', 'haltospam.com', 'harakirimail.com', 'hartbot.de', 'hat-geld.de', 'hatespam.org', 'hellodream.mobi', 'herp.in', 'hidemail.de', 'hidzz.com', 'hmamail.com', 'hochsitze.com', 'hopemail.biz', 'hotpop.com', 'hulapla.de', 'iaoss.com', 'ieatspam.eu', 'ieatspam.info', 'ieh-mail.de', 'ihateyoualot.info', 'iheartspam.org', 'ikbenspamvrij.nl', 'imails.info', 'imgof.com', 'imstations.com', 'inbax.tk', 'inbox.si', 'inboxalias.com', 'inboxclean.com', 'inboxclean.org', 'inboxproxy.com', 'incognitomail.com', 'incognitomail.net', 'incognitomail.org', 'infocom.zp.ua', 'inoutmail.de', 'inoutmail.eu', 'inoutmail.info', 'inoutmail.net', 'insorg-mail.info', 'instant-mail.de', 'ip6.li', 'ipoo.org', 'irish2me.com', 'iwi.net', 'jamit.com.au', 'jetable.com', 'jetable.fr.nf', 'jetable.net', 'jetable.org', 'jnxjn.com', 'jourrapide.com', 'jsrsolutions.com', 'junk1e.com', 'kasmail.com', 'kaspop.com', 'keepmymail.com', 'killmail.com', 'killmail.net', 'kimsdisk.com', 'kingsq.ga', 'kir.ch.tc', 'klassmaster.com', 'klassmaster.net', 'klzlk.com', 'kook.ml', 'koszmail.pl', 'kulturbetrieb.info', 'kurzepost.de', 'l33r.eu', 'lackmail.net', 'lags.us', 'lawlita.com', 'lazyinbox.com', 'letthemeatspam.com', 'lhsdv.com', 'lifebyfood.com', 'link2mail.net', 'litedrop.com', 'loadby.us', 'login-email.ml', 'lol.ovpn.to', 'lolfreak.net', 'lookugly.com', 'lopl.co.cc', 'lortemail.dk', 'lovemeleaveme.com', 'lr78.com', 'lroid.com', 'lukop.dk', 'm21.cc', 'm4ilweb.info', 'maboard.com', 'mail-filter.com', 'mail-temporaire.fr', 'mail.by', 'mail.mezimages.net', 'mail.zp.ua', 'mail114.net', 'mail1a.de', 'mail21.cc', 'mail2rss.org', 'mail333.com', 'mail4trash.com', 'mailbidon.com', 'mailbiz.biz', 'mailblocks.com', 'mailbucket.org', 'mailcat.biz', 'mailcatch.com', 'mailde.de', 'mailde.info', 'maildrop.cc', 'maildx.com', 'maileater.com', 'mailed.ro', 'maileimer.de', 'mailexpire.com', 'mailfa.tk', 'mailforspam.com', 'mailfreeonline.com', 'mailfs.com', 'mailguard.me', 'mailimate.com', 'mailin8r.com', 'mailinater.com', 'mailinator.com', 'mailinator.net', 'mailinator.org', 'mailinator.us', 'mailinator2.com', 'mailincubator.com', 'mailismagic.com', 'mailmate.com', 'mailme.ir', 'mailme.lv', 'mailme24.com', 'mailmetrash.com', 'mailmetrash.comilzilla.org', 'mailmoat.com', 'mailms.com', 'mailnator.com', 'mailnesia.com', 'mailnull.com', 'mailorg.org', 'mailpick.biz', 'mailproxsy.com', 'mailquack.com', 'mailrock.biz', 'mailscrap.com', 'mailshell.com', 'mailsiphon.com', 'mailslapping.com', 'mailslite.com', 'mailtemp.info', 'mailtome.de', 'mailtothis.com', 'mailtrash.net', 'mailtv.net', 'mailtv.tv', 'mailzilla.com', 'mailzilla.org', 'mailzilla.orgmbx.cc', 'makemetheking.com', 'manifestgenerator.com', 'manybrain.com', 'mbx.cc', 'mega.zik.dj', 'meinspamschutz.de', 'meltmail.com', 'messagebeamer.de', 'mezimages.net', 'mierdamail.com', 'migumail.com', 'ministry-of-silly-walks.de', 'mintemail.com', 'misterpinball.de', 'mjukglass.nu', 'mmailinater.com', 'moakt.com', 'mobi.web.id', 'mobileninja.co.uk', 'moburl.com', 'mohmal.com', 'moncourrier.fr.nf', 'monemail.fr.nf', 'monmail.fr.nf', 'monumentmail.com', 'msa.minsmail.com', 'mt2009.com', 'mt2014.com', 'mx0.wwwnew.eu', 'my10minutemail.com', 'mycard.net.ua', 'mycleaninbox.net', 'myemailboxy.com', 'mymail-in.net', 'mymailoasis.com', 'mynetstore.de', 'mypacks.net', 'mypartyclip.de', 'myphantomemail.com', 'mysamp.de', 'myspaceinc.com', 'myspaceinc.net', 'myspaceinc.org', 'myspacepimpedup.com', 'myspamless.com', 'mytemp.email', 'mytempemail.com', 'mytempmail.com', 'mytrashmail.com', 'nabuma.com', 'neomailbox.com', 'nepwk.com', 'nervmich.net', 'nervtmich.net', 'netmails.com', 'netmails.net', 'netzidiot.de', 'neverbox.com', 'nice-4u.com', 'nincsmail.com', 'nincsmail.hu', 'nnh.com', 'no-spam.ws', 'noblepioneer.com', 'nobulk.com', 'noclickemail.com', 'nogmailspam.info', 'nomail.pw', 'nomail.xl.cx', 'nomail2me.com', 'nomorespamemails.com', 'nonspam.eu', 'nonspammer.de', 'noref.in', 'nospam.ze.tc', 'nospam4.us', 'nospamfor.us', 'nospammail.net', 'nospamthanks.info', 'notmailinator.com', 'notsharingmy.info', 'nowhere.org', 'nowmymail.com', 'nurfuerspam.de', 'nus.edu.sg', 'nwldx.com', 'objectmail.com', 'obobbo.com', 'odaymail.com', 'odnorazovoe.ru', 'one-time.email', 'oneoffemail.com', 'oneoffmail.com', 'onewaymail.com', 'onlatedotcom.info', 'online.ms', 'oopi.org', 'opayq.com', 'ordinaryamerican.net', 'otherinbox.codupmyspace.com', 'otherinbox.com', 'ourklips.com', 'outlawspam.com', 'ovpn.to', 'owlpic.com', 'pancakemail.com', 'paplease.com', 'pcusers.otherinbox.com', 'pepbot.com', 'pfui.ru', 'pimpedupmyspace.com', 'pjjkp.com', 'plexolan.de', 'poczta.onet.pl', 'politikerclub.de', 'pooae.com', 'poofy.org', 'pookmail.com', 'privacy.net', 'privatdemail.net', 'privy-mail.com', 'privymail.de', 'proxymail.eu', 'prtnx.com', 'prtz.eu', 'punkass.com', 'putthisinyourspamdatabase.com', 'pwrby.com', 'quickinbox.com', 'quickmail.nl', 'rcpt.at', 'reallymymail.com', 'realtyalerts.ca', 'recode.me', 'recursor.net', 'recyclemail.dk', 'regbypass.com', 'regbypass.comsafe-mail.net', 'rejectmail.com', 'reliable-mail.com', 'rhyta.com', 'rklips.com', 'rmqkr.net', 'royal.net', 'rppkn.com', 'rtrtr.com', 's0ny.net', 'safe-mail.net', 'safersignup.de', 'safetymail.info', 'safetypost.de', 'sandelf.de', 'saynotospams.com', 'schafmail.de', 'schrott-email.de', 'secretemail.de', 'secure-mail.biz', 'selfdestructingmail.com', 'selfdestructingmail.org', 'sendspamhere.com', 'sendspamhere.com', 'senseless-entertainment.com', 'services391.com', 'sharedmailbox.org', 'sharklasers.com', 'shieldedmail.com', 'shieldemail.com', 'shiftmail.com', 'shitmail.me', 'shitmail.org', 'shitware.nl', 'shmeriously.com', 'shortmail.net', 'shotmail.ru', 'showslow.de', 'sibmail.com', 'sinnlos-mail.de', 'siteposter.net', 'skeefmail.com', 'slapsfromlastnight.com', 'slaskpost.se', 'slipry.net', 'slopsbox.com', 'slushmail.com', 'smashmail.de', 'smellfear.com', 'smellrear.com', 'snakemail.com', 'sneakemail.com', 'sneakmail.de', 'snkmail.com', 'sofimail.com', 'sofort-mail.de', 'softpls.asia', 'sogetthis.com', 'sohu.com', 'solvemail.info', 'soodonims.com', 'spa.com', 'spaereplease.com', 'spam.la', 'spam.su', 'spam4.me', 'spamail.de', 'spamarrest.com', 'spamavert.com', 'spambob.com', 'spambob.net', 'spambob.org', 'spambog.com', 'spambog.de', 'spambog.net', 'spambog.ru', 'spambox.info', 'spambox.irishspringrealty.com', 'spambox.us', 'spamcannon.com', 'spamcannon.net', 'spamcero.com', 'spamcon.org', 'spamcorptastic.com', 'spamcowboy.com', 'spamcowboy.net', 'spamcowboy.org', 'spamday.com', 'spamex.com', 'spamfree.eu', 'spamfree24.com', 'spamfree24.de', 'spamfree24.eu', 'spamfree24.info', 'spamfree24.net', 'spamfree24.org', 'spamgoes.in', 'spamgourmet.com', 'spamgourmet.net', 'spamgourmet.org', 'spamherelots.com', 'spamhereplease.com', 'spamhole.com', 'spamify.com', 'spaminator.de', 'spamkill.info', 'spaml.com', 'spaml.de', 'spammotel.com', 'spamobox.com', 'spamoff.de', 'spamsalad.in', 'spamslicer.com', 'spamspot.com', 'spamstack.net', 'spamthis.co.uk', 'spamthisplease.com', 'spamtrail.com', 'spamtroll.net', 'speed.1s.fr', 'spikio.com', 'spoofmail.de', 'squizzy.de', 'ssoia.com', 'startkeys.com', 'stinkefinger.net', 'stop-my-spam.com', 'stuffmail.de', 'super-auswahl.de', 'supergreatmail.com', 'supermailer.jp', 'superrito.com', 'superstachel.de', 'suremail.info', 'svk.jp', 'sweetxxx.de', 'tagyourself.com', 'talkinator.com', 'tapchicuoihoi.com', 'teewars.org', 'teleosaurs.xyz', 'teleworm.com', 'teleworm.us', 'temp-mail.org', 'temp-mail.ru', 'temp.emeraldwebmail.com', 'temp.headstrong.de', 'tempalias.com', 'tempe-mail.com', 'tempemail.biz', 'tempemail.co.za', 'tempemail.com', 'tempemail.net', 'tempemail.net', 'tempinbox.co.uk', 'tempinbox.com', 'tempmail.eu', 'tempmail.it', 'tempmail2.com', 'tempmaildemo.com', 'tempmailer.com', 'tempmailer.de', 'tempomail.fr', 'temporarily.de', 'temporarioemail.com.br', 'temporaryemail.net', 'temporaryemail.us', 'temporaryforwarding.com', 'temporaryinbox.com', 'temporarymailaddress.com', 'tempsky.com', 'tempthe.net', 'tempymail.com', 'thanksnospam.info', 'thankyou2010.com', 'thc.st', 'thecloudindex.com', 'thelimestones.com', 'thisisnotmyrealemail.com', 'thismail.net', 'thrma.com', 'throwawayemailaddress.com', 'tilien.com', 'tittbit.in', 'tizi.com', 'tmail.ws', 'tmailinator.com', 'toiea.com', 'toomail.biz', 'topranklist.de', 'tradermail.info', 'trash-amil.com', 'trash-mail.at', 'trash-mail.com', 'trash-mail.de', 'trash2009.com', 'trash2010.com', 'trash2011.com', 'trashdevil.com', 'trashdevil.de', 'trashemail.de', 'trashmail.at', 'trashmail.com', 'trashmail.de', 'trashmail.me', 'trashmail.net', 'trashmail.org', 'trashmail.ws', 'trashmailer.com', 'trashymail.com', 'trashymail.net', 'trbvm.com', 'trbvn.com', 'trialmail.de', 'trillianpro.com', 'tryalert.com', 'turual.com', 'twinmail.de', 'twoweirdtricks.com', 'tyldd.com', 'uggsrock.com', 'umail.net', 'upliftnow.com', 'uplipht.com', 'uroid.com', 'us.af', 'username.e4ward.com', 'venompen.com', 'veryrealemail.com', 'vidchart.com', 'viditag.com', 'viewcastmedia.com', 'viewcastmedia.net', 'viewcastmedia.org', 'viewcastmediae', 'viralplays.com', 'vkcode.ru', 'vomoto.com', 'vpn.st', 'vsimcard.com', 'vubby.com', 'walala.org', 'walkmail.net', 'walkmail.ru', 'wasteland.rfc822.org', 'webemail.me', 'webm4il.info', 'webuser.in', 'wee.my', 'weg-werf-email.de', 'wegwerf-email-addressen.de', 'wegwerf-emails.de', 'wegwerfadresse.de', 'wegwerfemail.com', 'wegwerfemail.de', 'wegwerfmail.de', 'wegwerfmail.info', 'wegwerfmail.net', 'wegwerfmail.org', 'wetrainbayarea.com', 'wetrainbayarea.org', 'wh4f.org', 'whatiaas.com', 'whatpaas.com', 'whatsaas.com', 'whopy.com', 'whtjddn.33mail.com', 'whyspam.me', 'wilemail.com', 'willhackforfood.biz', 'willselfdestruct.com', 'winemaven.info', 'wronghead.com', 'wuzup.net', 'wuzupmail.net', 'www.e4ward.com', 'www.gishpuppy.com', 'www.mailinator.com', 'wwwnew.eu', 'x.ip6.li', 'xagloo.com', 'xemaps.com', 'xents.com', 'xmaily.com', 'xoxy.net', 'xyzfree.net', 'yapped.net', 'yeah.net', 'yep.it', 'yogamaven.com', 'yomail.info', 'yopmail.com', 'yopmail.fr', 'yopmail.net', 'yourdomain.com', 'ypmail.webarnak.fr.eu.org', 'yuurok.com', 'z1p.biz', 'za.com', 'zehnminuten.de', 'zehnminutenmail.de', 'zetmail.com', 'zippymail.info', 'zoaxe.com', 'zoemail.com', 'zoemail.net', 'zoemail.org', 'zomg.info', 'zxcv.com', 'zxcvbnm.com', 'zzz.com'];
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/notifyUsersOnMessage.js                                                          //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.callbacks.add('afterSaveMessage', function (message, room) {                                                // 1
	// skips this callback if the message was edited                                                                      //
	if (message.editedAt) {                                                                                               // 3
		return message;                                                                                                      // 4
	}                                                                                                                     //
                                                                                                                       //
	/**                                                                                                                   //
  * Chechs if a messages contains a user highlight                                                                     //
  *                                                                                                                    //
  * @param {string} message                                                                                            //
  * @param {array|undefined} highlights                                                                                //
  *                                                                                                                    //
  * @returns {boolean}                                                                                                 //
     */                                                                                                                //
	function messageContainsHighlight(message, highlights) {                                                              // 15
		if (!highlights || highlights.length === 0) {                                                                        // 16
			return false;                                                                                                       // 16
		}                                                                                                                    //
                                                                                                                       //
		var has = false;                                                                                                     // 18
		highlights.some(function (highlight) {                                                                               // 19
			var regexp = new RegExp(s.escapeRegExp(highlight), 'i');                                                            // 20
			if (regexp.test(message.msg)) {                                                                                     // 21
				has = true;                                                                                                        // 22
				return true;                                                                                                       // 23
			}                                                                                                                   //
		});                                                                                                                  //
                                                                                                                       //
		return has;                                                                                                          // 27
	}                                                                                                                     //
                                                                                                                       //
	if (room.t != null && room.t === 'd') {                                                                               // 30
		// Update the other subscriptions                                                                                    //
		RocketChat.models.Subscriptions.incUnreadOfDirectForRoomIdExcludingUserId(message.rid, message.u._id, 1);            // 32
	} else {                                                                                                              //
		var mentionIds, toAll, highlightsIds, highlights;                                                                    // 34
                                                                                                                       //
		mentionIds = [];                                                                                                     // 36
		highlightsIds = [];                                                                                                  // 37
		toAll = false;                                                                                                       // 38
		highlights = RocketChat.models.Users.findUsersByUsernamesWithHighlights(room.usernames, { fields: { '_id': 1, 'settings.preferences.highlights': 1 } }).fetch();
                                                                                                                       //
		if (message.mentions != null) {                                                                                      // 41
			message.mentions.forEach(function (mention) {                                                                       // 42
				if (!toAll && mention._id === 'all') {                                                                             // 43
					toAll = true;                                                                                                     // 44
				}                                                                                                                  //
				mentionIds.push(mention._id);                                                                                      // 46
			});                                                                                                                 //
		}                                                                                                                    //
                                                                                                                       //
		highlights.forEach(function (user) {                                                                                 // 50
			if (user && user.settings && user.settings.preferences && messageContainsHighlight(message, user.settings.preferences.highlights)) {
				highlightsIds.push(user._id);                                                                                      // 52
			}                                                                                                                   //
		});                                                                                                                  //
                                                                                                                       //
		if (toAll) {                                                                                                         // 56
			RocketChat.models.Subscriptions.incUnreadForRoomIdExcludingUserId(room._id, message.u._id);                         // 57
		} else if (mentionIds && mentionIds.length > 0 || highlightsIds && highlightsIds.length > 0) {                       //
			RocketChat.models.Subscriptions.incUnreadForRoomIdAndUserIds(room._id, _.compact(_.unique(mentionIds.concat(highlightsIds))));
		}                                                                                                                    //
	}                                                                                                                     //
                                                                                                                       //
	// Update all the room activity tracker fields                                                                        //
	RocketChat.models.Rooms.incMsgCountAndSetLastMessageTimestampById(message.rid, 1, message.ts);                        // 64
                                                                                                                       //
	// Update all other subscriptions to alert their owners but witout incrementing                                       //
	// the unread counter, as it is only for mentions and direct messages                                                 //
	RocketChat.models.Subscriptions.setAlertForRoomIdExcludingUserId(message.rid, message.u._id, true);                   // 68
                                                                                                                       //
	return message;                                                                                                       // 70
}, RocketChat.callbacks.priority.LOW);                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/RateLimiter.coffee.js                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.RateLimiter = new ((function() {                                                                            // 1
  function _Class() {}                                                                                                 //
                                                                                                                       //
  _Class.prototype.limitFunction = function(fn, numRequests, timeInterval, matchers) {                                 // 2
    var rateLimiter;                                                                                                   // 3
    rateLimiter = new RateLimiter();                                                                                   // 3
    rateLimiter.addRule(matchers, numRequests, timeInterval);                                                          // 3
    return function() {                                                                                                // 5
      var args, match, rateLimitResult;                                                                                // 6
      match = {};                                                                                                      // 6
      args = arguments;                                                                                                // 6
      _.each(matchers, function(matcher, key) {                                                                        // 6
        return match[key] = args[key];                                                                                 //
      });                                                                                                              //
      rateLimiter.increment(match);                                                                                    // 6
      rateLimitResult = rateLimiter.check(match);                                                                      // 6
      if (rateLimitResult.allowed) {                                                                                   // 13
        return fn.apply(null, arguments);                                                                              // 14
      } else {                                                                                                         //
        throw new Meteor.Error('too-many-requests', "Error, too many requests. Please slow down. You must wait " + (Math.ceil(rateLimitResult.timeToReset / 1000)) + " seconds before trying again.", {
          timeToReset: rateLimitResult.timeToReset                                                                     // 16
        });                                                                                                            //
      }                                                                                                                //
    };                                                                                                                 //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.limitMethod = function(methodName, numRequests, timeInterval, matchers) {                           // 2
    var match;                                                                                                         // 19
    match = {                                                                                                          // 19
      type: 'method',                                                                                                  // 20
      name: methodName                                                                                                 // 20
    };                                                                                                                 //
    _.each(matchers, function(matcher, key) {                                                                          // 19
      return match[key] = matchers[key];                                                                               //
    });                                                                                                                //
    return DDPRateLimiter.addRule(match, numRequests, timeInterval);                                                   //
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})());                                                                                                                 //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/roomTypes.coffee.js                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.roomTypes = new ((function() {                                                                              // 1
  var roomTypes, runPublish, setPublish;                                                                               // 2
                                                                                                                       //
  function _Class() {}                                                                                                 //
                                                                                                                       //
  roomTypes = {};                                                                                                      // 2
                                                                                                                       //
                                                                                                                       // 4
  /* add a publish for a room type                                                                                     // 4
  	@param roomType: room type (e.g.: c (for channels), d (for direct channels))                                        //
  	@param callback: function that will return the publish's data                                                       //
   */                                                                                                                  //
                                                                                                                       //
  setPublish = function(roomType, callback) {                                                                          // 2
    var ref;                                                                                                           // 9
    if (((ref = roomTypes[roomType]) != null ? ref.publish : void 0) != null) {                                        // 9
      throw new Meteor.Error('route-publish-exists', 'Publish for the given type already exists');                     // 10
    }                                                                                                                  //
    if (roomTypes[roomType] == null) {                                                                                 // 12
      roomTypes[roomType] = {};                                                                                        // 13
    }                                                                                                                  //
    return roomTypes[roomType].publish = callback;                                                                     //
  };                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 17
  /* run the publish for a room type                                                                                   // 17
  	@param roomType: room type (e.g.: c (for channels), d (for direct channels))                                        //
  	@param identifier: identifier of the room                                                                           //
   */                                                                                                                  //
                                                                                                                       //
  runPublish = function(roomType, identifier) {                                                                        // 2
    if (roomTypes[roomType].publish == null) {                                                                         // 22
      return;                                                                                                          // 22
    }                                                                                                                  //
    return roomTypes[roomType].publish.call(this, identifier);                                                         // 23
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setPublish = setPublish;                                                                            // 2
                                                                                                                       //
  _Class.prototype.runPublish = runPublish;                                                                            // 2
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})());                                                                                                                 //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/sendEmailOnMessage.js                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.callbacks.add('afterSaveMessage', function (message, room) {                                                // 1
	// skips this callback if the message was edited                                                                      //
	if (message.editedAt) {                                                                                               // 3
		return message;                                                                                                      // 4
	}                                                                                                                     //
                                                                                                                       //
	var emailSubject,                                                                                                     // 7
	    usersToSendEmail = {};                                                                                            //
                                                                                                                       //
	if (room.t === 'd') {                                                                                                 // 9
		usersToSendEmail[message.rid.replace(message.u._id, '')] = 1;                                                        // 10
                                                                                                                       //
		emailSubject = TAPi18n.__('Offline_DM_Email', {                                                                      // 12
			site: RocketChat.settings.get('Site_Name'),                                                                         // 13
			user: message.u.username                                                                                            // 14
		});                                                                                                                  //
	} else {                                                                                                              //
		if (message.mentions) {                                                                                              // 18
			message.mentions.forEach(function (mention) {                                                                       // 19
				usersToSendEmail[mention._id] = 1;                                                                                 // 20
			});                                                                                                                 //
		}                                                                                                                    //
                                                                                                                       //
		emailSubject = TAPi18n.__('Offline_Mention_Email', {                                                                 // 24
			site: RocketChat.settings.get('Site_Name'),                                                                         // 25
			user: message.u.username,                                                                                           // 26
			room: room.name                                                                                                     // 27
		});                                                                                                                  //
	}                                                                                                                     //
                                                                                                                       //
	// code duplicate of packages/rocketchat-ui-message/message/message.coffee                                            //
	message.html = s.escapeHTML(message.msg);                                                                             // 32
	message = RocketChat.callbacks.run('renderMessage', message);                                                         // 33
	if (message.tokens && message.tokens.length > 0) {                                                                    // 34
		message.tokens.forEach(function (token) {                                                                            // 35
			token.text = token.text.replace(/([^\$])(\$[^\$])/gm, '$1$$$2');                                                    // 36
			message.html = message.html.replace(token.token, token.text);                                                       // 37
		});                                                                                                                  //
	}                                                                                                                     //
	message.html = message.html.replace(/\n/gm, '<br/>');                                                                 // 40
                                                                                                                       //
	RocketChat.models.Subscriptions.findWithSendEmailByRoomId(room._id).forEach(function (sub) {                          // 42
		switch (sub.emailNotifications) {                                                                                    // 43
			case 'all':                                                                                                         // 44
				usersToSendEmail[sub.u._id] = 'force';                                                                             // 45
				break;                                                                                                             // 46
			case 'mentions':                                                                                                    // 46
				if (usersToSendEmail[sub.u._id]) {                                                                                 // 48
					usersToSendEmail[sub.u._id] = 'force';                                                                            // 49
				}                                                                                                                  //
				break;                                                                                                             // 51
			case 'nothing':                                                                                                     // 51
				delete usersToSendEmail[sub.u._id];                                                                                // 53
				break;                                                                                                             // 54
			case 'default':                                                                                                     // 54
				break;                                                                                                             // 56
		}                                                                                                                    // 56
	});                                                                                                                   //
                                                                                                                       //
	var userIdsToSendEmail = Object.keys(usersToSendEmail);                                                               // 60
                                                                                                                       //
	if (userIdsToSendEmail.length > 0) {                                                                                  // 62
		var usersOfMention = RocketChat.models.Users.getUsersToSendOfflineEmail(userIdsToSendEmail).fetch();                 // 63
                                                                                                                       //
		if (usersOfMention && usersOfMention.length > 0) {                                                                   // 65
			usersOfMention.forEach(function (user) {                                                                            // 66
				if (user.settings && user.settings.preferences && user.settings.preferences.emailNotificationMode && user.settings.preferences.emailNotificationMode === 'disabled' && usersToSendEmail[user._id] !== 'force') {
					return;                                                                                                           // 68
				}                                                                                                                  //
				user.emails.some(function (email) {                                                                                // 70
					if (email.verified) {                                                                                             // 71
						email = {                                                                                                        // 72
							to: email.address,                                                                                              // 73
							from: RocketChat.settings.get('From_Email'),                                                                    // 74
							subject: emailSubject,                                                                                          // 75
							html: '&gt; ' + message.html                                                                                    // 76
						};                                                                                                               //
                                                                                                                       //
						Email.send(email);                                                                                               // 79
                                                                                                                       //
						return true;                                                                                                     // 81
					}                                                                                                                 //
				});                                                                                                                //
			});                                                                                                                 //
		}                                                                                                                    //
	}                                                                                                                     //
                                                                                                                       //
	return message;                                                                                                       // 88
}, RocketChat.callbacks.priority.LOW);                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/sendNotificationsOnMessage.js                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
/* globals Push */                                                                                                     //
                                                                                                                       //
RocketChat.callbacks.add('afterSaveMessage', function (message, room) {                                                // 3
	// skips this callback if the message was edited                                                                      //
	if (message.editedAt) {                                                                                               // 5
		return message;                                                                                                      // 6
	}                                                                                                                     //
                                                                                                                       //
	var user = RocketChat.models.Users.findOneById(message.u._id);                                                        // 9
                                                                                                                       //
	/*                                                                                                                    //
 Increment unread couter if direct messages                                                                            //
  */                                                                                                                   //
	var indexOf = [].indexOf || function (item) {                                                                         // 14
		for (var i = 0, l = this.length; i < l; i++) {                                                                       // 15
			if (i in this && this[i] === item) {                                                                                // 16
				return i;                                                                                                          // 17
			}                                                                                                                   //
		}                                                                                                                    //
		return -1;                                                                                                           // 20
	};                                                                                                                    //
                                                                                                                       //
	var settings, desktopMentionIds, i, j, len, len1, highlights, mentionIds, highlightsIds, usersWithHighlights, mobileMentionIds, ref, ref1, toAll, userIdsToNotify, userIdsToPushNotify, userOfMention, userOfMentionId, usersOfDesktopMentions, usersOfMentionId, usersOfMentionItem, usersOfMobileMentions;
                                                                                                                       //
	/**                                                                                                                   //
  * Checks if a given user can be notified                                                                             //
  *                                                                                                                    //
  * @param {string} id                                                                                                 //
  * @param {string} type - mobile|desktop                                                                              //
  *                                                                                                                    //
  * @returns {boolean}                                                                                                 //
     */                                                                                                                //
	function canBeNotified(id, type) {                                                                                    // 33
		var types = {                                                                                                        // 34
			mobile: ['dontNotifyDesktopUsers', 'alwaysNotifyDesktopUsers'],                                                     // 35
			desktop: ['dontNotifyMobileUsers', 'alwaysNotifyMobileUsers']                                                       // 36
		};                                                                                                                   //
                                                                                                                       //
		return settings[types[type][0]].indexOf(id) === -1 || settings[types[type][1]].indexOf(id) !== -1;                   // 39
	}                                                                                                                     //
                                                                                                                       //
	/**                                                                                                                   //
  * Chechs if a messages contains a user highlight                                                                     //
  *                                                                                                                    //
  * @param {string} message                                                                                            //
  * @param {array|undefined} highlights                                                                                //
  *                                                                                                                    //
  * @returns {boolean}                                                                                                 //
  */                                                                                                                   //
	function messageContainsHighlight(message, highlights) {                                                              // 50
		if (!highlights || highlights.length === 0) {                                                                        // 51
			return false;                                                                                                       // 51
		}                                                                                                                    //
                                                                                                                       //
		var has = false;                                                                                                     // 53
		highlights.some(function (highlight) {                                                                               // 54
			var regexp = new RegExp(s.escapeRegExp(highlight), 'i');                                                            // 55
			if (regexp.test(message.msg)) {                                                                                     // 56
				has = true;                                                                                                        // 57
				return true;                                                                                                       // 58
			}                                                                                                                   //
		});                                                                                                                  //
                                                                                                                       //
		return has;                                                                                                          // 62
	}                                                                                                                     //
                                                                                                                       //
	settings = {};                                                                                                        // 65
                                                                                                                       //
	settings.alwaysNotifyDesktopUsers = [];                                                                               // 67
	settings.dontNotifyDesktopUsers = [];                                                                                 // 68
	settings.alwaysNotifyMobileUsers = [];                                                                                // 69
	settings.dontNotifyMobileUsers = [];                                                                                  // 70
	RocketChat.models.Subscriptions.findNotificationPreferencesByRoom(room._id).forEach(function (subscription) {         // 71
		if (subscription.desktopNotifications === 'all') {                                                                   // 72
			settings.alwaysNotifyDesktopUsers.push(subscription.u._id);                                                         // 73
		} else if (subscription.desktopNotifications === 'nothing') {                                                        //
			settings.dontNotifyDesktopUsers.push(subscription.u._id);                                                           // 75
		} else if (subscription.mobilePushNotifications === 'all') {                                                         //
			settings.alwaysNotifyMobileUsers.push(subscription.u._id);                                                          // 77
		} else if (subscription.mobilePushNotifications === 'nothing') {                                                     //
			settings.dontNotifyMobileUsers.push(subscription.u._id);                                                            // 79
		}                                                                                                                    //
	});                                                                                                                   //
                                                                                                                       //
	userIdsToNotify = [];                                                                                                 // 83
	userIdsToPushNotify = [];                                                                                             // 84
	usersWithHighlights = [];                                                                                             // 85
	highlights = RocketChat.models.Users.findUsersByUsernamesWithHighlights(room.usernames, { fields: { '_id': 1, 'settings.preferences.highlights': 1 } }).fetch();
                                                                                                                       //
	highlights.forEach(function (user) {                                                                                  // 88
		if (user && user.settings && user.settings.preferences && messageContainsHighlight(message, user.settings.preferences.highlights)) {
			usersWithHighlights.push(user);                                                                                     // 90
		}                                                                                                                    //
	});                                                                                                                   //
                                                                                                                       //
	var push_message = undefined;                                                                                         // 94
	//Set variables depending on Push Notification settings                                                               //
	if (RocketChat.settings.get('Push_show_message')) {                                                                   // 96
		push_message = message.msg;                                                                                          // 97
	} else {                                                                                                              //
		push_message = ' ';                                                                                                  // 99
	}                                                                                                                     //
                                                                                                                       //
	var push_username = undefined;                                                                                        // 102
	var push_room = undefined;                                                                                            // 103
	if (RocketChat.settings.get('Push_show_username_room')) {                                                             // 104
		push_username = '@' + user.username;                                                                                 // 105
		push_room = '#' + room.name + ' ';                                                                                   // 106
	} else {                                                                                                              //
		push_username = ' ';                                                                                                 // 108
		push_room = ' ';                                                                                                     // 109
	}                                                                                                                     //
                                                                                                                       //
	if (room.t == null || room.t === 'd') {                                                                               // 112
		userOfMentionId = message.rid.replace(message.u._id, '');                                                            // 113
		userOfMention = RocketChat.models.Users.findOne({                                                                    // 114
			_id: userOfMentionId                                                                                                // 115
		}, {                                                                                                                 //
			fields: {                                                                                                           // 117
				username: 1,                                                                                                       // 118
				statusConnection: 1                                                                                                // 119
			}                                                                                                                   //
		});                                                                                                                  //
		if (userOfMention != null && canBeNotified(userOfMentionId, 'mobile')) {                                             // 122
			RocketChat.Notifications.notifyUser(userOfMention._id, 'notification', {                                            // 123
				title: '@' + user.username,                                                                                        // 124
				text: message.msg,                                                                                                 // 125
				payload: {                                                                                                         // 126
					rid: message.rid,                                                                                                 // 127
					sender: message.u,                                                                                                // 128
					type: room.t,                                                                                                     // 129
					name: room.name                                                                                                   // 130
				}                                                                                                                  //
			});                                                                                                                 //
		}                                                                                                                    //
		if (userOfMention != null && canBeNotified(userOfMentionId, 'desktop')) {                                            // 134
			if (Push.enabled === true && userOfMention.statusConnection !== 'online') {                                         // 135
				Push.send({                                                                                                        // 136
					from: 'push',                                                                                                     // 137
					title: push_username,                                                                                             // 138
					text: push_message,                                                                                               // 139
					apn: {                                                                                                            // 140
						// ternary operator                                                                                              //
						text: push_username + (push_username !== ' ' && push_message !== ' ' ? ':\n' : '') + push_message                // 142
					},                                                                                                                //
					badge: 1,                                                                                                         // 144
					sound: 'chime',                                                                                                   // 145
					payload: {                                                                                                        // 146
						host: Meteor.absoluteUrl(),                                                                                      // 147
						rid: message.rid,                                                                                                // 148
						sender: message.u,                                                                                               // 149
						type: room.t,                                                                                                    // 150
						name: room.name                                                                                                  // 151
					},                                                                                                                //
					query: {                                                                                                          // 153
						userId: userOfMention._id                                                                                        // 154
					}                                                                                                                 //
				});                                                                                                                //
				return message;                                                                                                    // 157
			}                                                                                                                   //
		}                                                                                                                    //
	} else {                                                                                                              //
		mentionIds = [];                                                                                                     // 161
		if ((ref = message.mentions) != null) {                                                                              // 162
			ref.forEach(function (mention) {                                                                                    // 163
				return mentionIds.push(mention._id);                                                                               // 164
			});                                                                                                                 //
		}                                                                                                                    //
		toAll = mentionIds.indexOf('all') > -1;                                                                              // 167
		if (mentionIds.length > 0 || settings.alwaysNotifyDesktopUsers.length > 0) {                                         // 168
			desktopMentionIds = _.union(mentionIds, settings.alwaysNotifyDesktopUsers);                                         // 169
			desktopMentionIds = _.difference(desktopMentionIds, settings.dontNotifyDesktopUsers);                               // 170
			usersOfDesktopMentions = RocketChat.models.Users.find({                                                             // 171
				_id: {                                                                                                             // 172
					$in: desktopMentionIds                                                                                            // 173
				}                                                                                                                  //
			}, {                                                                                                                //
				fields: {                                                                                                          // 176
					_id: 1,                                                                                                           // 177
					username: 1                                                                                                       // 178
				}                                                                                                                  //
			}).fetch();                                                                                                         //
			if (room.t === 'c' && !toAll) {                                                                                     // 181
				var callJoin = function (usersOfMentionItem) {                                                                     // 182
					Meteor.runAsUser(usersOfMentionItem._id, function () {                                                            // 183
						return Meteor.call('joinRoom', room._id);                                                                        // 184
					});                                                                                                               //
				};                                                                                                                 //
				for (i = 0, len = usersOfDesktopMentions.length; i < len; i++) {                                                   // 187
					usersOfMentionItem = usersOfDesktopMentions[i];                                                                   // 188
					if (room.usernames.indexOf(usersOfMentionItem.username) === -1) {                                                 // 189
						callJoin(usersOfMentionItem);                                                                                    // 190
					}                                                                                                                 //
				}                                                                                                                  //
			}                                                                                                                   //
			userIdsToNotify = _.pluck(usersOfDesktopMentions, '_id');                                                           // 194
		}                                                                                                                    //
                                                                                                                       //
		if (mentionIds.length > 0 || settings.alwaysNotifyMobileUsers.length > 0) {                                          // 197
			mobileMentionIds = _.union(mentionIds, settings.alwaysNotifyMobileUsers);                                           // 198
			mobileMentionIds = _.difference(mobileMentionIds, settings.dontNotifyMobileUsers);                                  // 199
			usersOfMobileMentions = RocketChat.models.Users.find({                                                              // 200
				_id: {                                                                                                             // 201
					$in: mobileMentionIds                                                                                             // 202
				}                                                                                                                  //
			}, {                                                                                                                //
				fields: {                                                                                                          // 205
					_id: 1,                                                                                                           // 206
					username: 1,                                                                                                      // 207
					statusConnection: 1                                                                                               // 208
				}                                                                                                                  //
			}).fetch();                                                                                                         //
			userIdsToPushNotify = _.pluck(_.filter(usersOfMobileMentions, function (user) {                                     // 211
				return user.statusConnection !== 'online';                                                                         // 212
			}), '_id');                                                                                                         //
		}                                                                                                                    //
                                                                                                                       //
		if (toAll && ((ref1 = room.usernames) != null ? ref1.length : void 0) > 0) {                                         // 216
			RocketChat.models.Users.find({                                                                                      // 217
				username: {                                                                                                        // 218
					$in: room.usernames                                                                                               // 219
				},                                                                                                                 //
				_id: {                                                                                                             // 221
					$ne: user._id                                                                                                     // 222
				}                                                                                                                  //
			}, {                                                                                                                //
				fields: {                                                                                                          // 225
					_id: 1,                                                                                                           // 226
					username: 1,                                                                                                      // 227
					status: 1,                                                                                                        // 228
					statusConnection: 1                                                                                               // 229
				}                                                                                                                  //
			}).forEach(function (user) {                                                                                        //
				var ref2, ref3, ref4;                                                                                              // 232
				if (((ref2 = user.status) === 'online' || ref2 === 'away' || ref2 === 'busy') && (ref3 = user._id, indexOf.call(settings.dontNotifyDesktopUsers, ref3) < 0)) {
					userIdsToNotify.push(user._id);                                                                                   // 234
				}                                                                                                                  //
				if (user.statusConnection !== 'online' && (ref4 = user._id, indexOf.call(settings.dontNotifyMobileUsers, ref4) < 0)) {
					return userIdsToPushNotify.push(user._id);                                                                        // 237
				}                                                                                                                  //
			});                                                                                                                 //
		}                                                                                                                    //
                                                                                                                       //
		if (usersWithHighlights.length > 0) {                                                                                // 242
			highlightsIds = _.pluck(usersWithHighlights, '_id');                                                                // 243
			userIdsToNotify = userIdsToNotify.concat(highlightsIds);                                                            // 244
			userIdsToPushNotify = userIdsToPushNotify.concat(highlightsIds);                                                    // 245
		}                                                                                                                    //
                                                                                                                       //
		userIdsToNotify = _.compact(_.unique(userIdsToNotify));                                                              // 248
		userIdsToPushNotify = _.compact(_.unique(userIdsToPushNotify));                                                      // 249
                                                                                                                       //
		if (userIdsToNotify.length > 0) {                                                                                    // 251
			for (j = 0, len1 = userIdsToNotify.length; j < len1; j++) {                                                         // 252
				usersOfMentionId = userIdsToNotify[j];                                                                             // 253
				RocketChat.Notifications.notifyUser(usersOfMentionId, 'notification', {                                            // 254
					title: '@' + user.username + ' @ #' + room.name,                                                                  // 255
					text: message.msg,                                                                                                // 256
					payload: {                                                                                                        // 257
						rid: message.rid,                                                                                                // 258
						sender: message.u,                                                                                               // 259
						type: room.t,                                                                                                    // 260
						name: room.name                                                                                                  // 261
					}                                                                                                                 //
				});                                                                                                                //
			}                                                                                                                   //
		}                                                                                                                    //
                                                                                                                       //
		if (userIdsToPushNotify.length > 0) {                                                                                // 267
			if (Push.enabled === true) {                                                                                        // 268
				Push.send({                                                                                                        // 269
					from: 'push',                                                                                                     // 270
					title: push_room + push_username,                                                                                 // 271
					text: push_message,                                                                                               // 272
					apn: {                                                                                                            // 273
						// ternary operator                                                                                              //
						text: push_room + push_username + (push_username !== ' ' && push_room !== ' ' && push_message !== ' ' ? ':\n' : '') + push_message
					},                                                                                                                //
					badge: 1,                                                                                                         // 277
					sound: 'chime',                                                                                                   // 278
					payload: {                                                                                                        // 279
						host: Meteor.absoluteUrl(),                                                                                      // 280
						rid: message.rid,                                                                                                // 281
						sender: message.u,                                                                                               // 282
						type: room.t,                                                                                                    // 283
						name: room.name                                                                                                  // 284
					},                                                                                                                //
					query: {                                                                                                          // 286
						userId: {                                                                                                        // 287
							$in: userIdsToPushNotify                                                                                        // 288
						}                                                                                                                //
					}                                                                                                                 //
				});                                                                                                                //
			}                                                                                                                   //
		}                                                                                                                    //
	}                                                                                                                     //
                                                                                                                       //
	return message;                                                                                                       // 296
}, RocketChat.callbacks.priority.LOW);                                                                                 //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/lib/validateEmailDomain.js                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var dns = Npm.require('dns');                                                                                          // 1
                                                                                                                       //
var emailDomainBlackList = [];                                                                                         // 3
var emailDomainWhiteList = [];                                                                                         // 4
var useDefaultBlackList = false;                                                                                       // 5
var useDNSDomainCheck = false;                                                                                         // 6
                                                                                                                       //
RocketChat.settings.get('Accounts_BlockedDomainsList', function (key, value) {                                         // 8
	emailDomainBlackList = _.map(value.split(','), function (domain) {                                                    // 9
		return domain.trim();                                                                                                //
	});                                                                                                                   //
});                                                                                                                    //
RocketChat.settings.get('Accounts_AllowedDomainsList', function (key, value) {                                         // 11
	emailDomainWhiteList = _.map(value.split(','), function (domain) {                                                    // 12
		return domain.trim();                                                                                                //
	});                                                                                                                   //
});                                                                                                                    //
RocketChat.settings.get('Accounts_UseDefaultBlockedDomainsList', function (key, value) {                               // 14
	useDefaultBlackList = value;                                                                                          // 15
});                                                                                                                    //
RocketChat.settings.get('Accounts_UseDNSDomainCheck', function (key, value) {                                          // 17
	useDNSDomainCheck = value;                                                                                            // 18
});                                                                                                                    //
                                                                                                                       //
RocketChat.validateEmailDomain = function (email) {                                                                    // 21
	var emailValidation = /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
	if (!emailValidation.test(email)) {                                                                                   // 23
		throw new Meteor.Error('email-invalid', email + ' is not a valid e-mail');                                           // 24
	}                                                                                                                     //
                                                                                                                       //
	var emailDomain = email.substr(email.lastIndexOf('@') + 1);                                                           // 27
                                                                                                                       //
	// if not in whitelist                                                                                                //
	if (emailDomainWhiteList.indexOf(emailDomain) === -1) {                                                               // 30
		if (emailDomainBlackList.indexOf(emailDomain) !== -1 || useDefaultBlackList && RocketChat.emailDomainDefaultBlackList.indexOf(emailDomain) !== -1) {
			throw new Meteor.Error('email-domain-blacklisted', 'Email domain backlisted');                                      // 32
		}                                                                                                                    //
	}                                                                                                                     //
                                                                                                                       //
	if (useDNSDomainCheck) {                                                                                              // 36
		try {                                                                                                                // 37
			Meteor.wrapAsync(dns.resolveMx)(emailDomain);                                                                       // 38
		} catch (e) {                                                                                                        //
			throw new Meteor.Error('invalid-email', 'Invalid domain');                                                          // 40
		}                                                                                                                    //
	}                                                                                                                     //
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/_Base.coffee.js                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var slice = [].slice;                                                                                                  // 1
                                                                                                                       //
RocketChat.models._Base = (function() {                                                                                // 1
  function _Class() {}                                                                                                 //
                                                                                                                       //
  _Class.prototype._baseName = function() {                                                                            // 2
    return 'rocketchat_';                                                                                              // 3
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype._initModel = function(name) {                                                                       // 2
    check(name, String);                                                                                               // 6
    return this.model = new Mongo.Collection(this._baseName() + name);                                                 //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.find = function() {                                                                                 // 2
    return this.model.find.apply(this.model, arguments);                                                               // 11
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOne = function() {                                                                              // 2
    return this.model.findOne.apply(this.model, arguments);                                                            // 14
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.insert = function() {                                                                               // 2
    return this.model.insert.apply(this.model, arguments);                                                             // 17
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.insertOrUpsert = function() {                                                                       // 2
    var _id, args, ref;                                                                                                // 20
    args = 1 <= arguments.length ? slice.call(arguments, 0) : [];                                                      // 20
    if (((ref = args[0]) != null ? ref._id : void 0) != null) {                                                        // 20
      _id = args[0]._id;                                                                                               // 21
      delete args[0]._id;                                                                                              // 21
      args.unshift({                                                                                                   // 21
        _id: _id                                                                                                       // 24
      });                                                                                                              //
      this.model.upsert.apply(this.model, args);                                                                       // 21
      return _id;                                                                                                      // 26
    } else {                                                                                                           //
      return this.model.insert.apply(this.model, args);                                                                // 28
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.update = function() {                                                                               // 2
    return this.model.update.apply(this.model, arguments);                                                             // 31
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.upsert = function() {                                                                               // 2
    return this.model.upsert.apply(this.model, arguments);                                                             // 34
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.remove = function() {                                                                               // 2
    return this.model.remove.apply(this.model, arguments);                                                             // 37
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.allow = function() {                                                                                // 2
    return this.model.allow.apply(this.model, arguments);                                                              // 40
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.deny = function() {                                                                                 // 2
    return this.model.deny.apply(this.model, arguments);                                                               // 43
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.ensureIndex = function() {                                                                          // 2
    return this.model._ensureIndex.apply(this.model, arguments);                                                       // 46
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.dropIndex = function() {                                                                            // 2
    return this.model._dropIndex.apply(this.model, arguments);                                                         // 49
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.tryEnsureIndex = function() {                                                                       // 2
    var e;                                                                                                             // 52
    try {                                                                                                              // 52
      return this.ensureIndex.apply(this, arguments);                                                                  // 53
    } catch (_error) {                                                                                                 //
      e = _error;                                                                                                      // 55
      return console.log(e);                                                                                           //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.tryDropIndex = function() {                                                                         // 2
    var e;                                                                                                             // 58
    try {                                                                                                              // 58
      return this.dropIndex.apply(this, arguments);                                                                    // 59
    } catch (_error) {                                                                                                 //
      e = _error;                                                                                                      // 61
      return console.log(e);                                                                                           //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})();                                                                                                                  //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Messages.coffee.js                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Messages = new ((function(superClass) {                                                              // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('message');                                                                                        // 3
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1,                                                                                                        // 5
      'ts': 1                                                                                                          // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'ts': 1                                                                                                          // 6
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'u._id': 1                                                                                                       // 7
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'editedAt': 1                                                                                                    // 8
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 8
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'editedBy._id': 1                                                                                                // 9
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 9
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1,                                                                                                        // 10
      't': 1,                                                                                                          // 10
      'u._id': 1                                                                                                       // 10
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'expireAt': 1                                                                                                    // 11
    }, {                                                                                                               //
      expireAfterSeconds: 0                                                                                            // 11
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'msg': 'text'                                                                                                    // 12
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'file._id': 1                                                                                                    // 13
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 13
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'mentions.username': 1                                                                                           // 14
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 14
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'pinned': 1                                                                                                      // 15
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 15
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneById = function(_id, options) {                                                              // 2
    var query;                                                                                                         // 20
    query = {                                                                                                          // 20
      _id: _id                                                                                                         // 21
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 23
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByMention = function(username, options) {                                                       // 2
    var query;                                                                                                         // 27
    query = {                                                                                                          // 27
      "mentions.username": username                                                                                    // 28
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 30
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleByMentionAndRoomId = function(username, rid, options) {                                  // 2
    var query;                                                                                                         // 33
    query = {                                                                                                          // 33
      _hidden: {                                                                                                       // 34
        $ne: true                                                                                                      // 34
      },                                                                                                               //
      "mentions.username": username,                                                                                   // 34
      "rid": rid                                                                                                       // 34
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 38
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleByRoomId = function(roomId, options) {                                                   // 2
    var query;                                                                                                         // 41
    query = {                                                                                                          // 41
      _hidden: {                                                                                                       // 42
        $ne: true                                                                                                      // 43
      },                                                                                                               //
      rid: roomId                                                                                                      // 42
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 46
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findInvisibleByRoomId = function(roomId, options) {                                                 // 2
    var query;                                                                                                         // 49
    query = {                                                                                                          // 49
      _hidden: true,                                                                                                   // 50
      rid: roomId                                                                                                      // 50
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 53
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleByRoomIdAfterTimestamp = function(roomId, timestamp, options) {                          // 2
    var query;                                                                                                         // 56
    query = {                                                                                                          // 56
      _hidden: {                                                                                                       // 57
        $ne: true                                                                                                      // 58
      },                                                                                                               //
      rid: roomId,                                                                                                     // 57
      ts: {                                                                                                            // 57
        $gt: timestamp                                                                                                 // 61
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 63
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleByRoomIdBeforeTimestamp = function(roomId, timestamp, options) {                         // 2
    var query;                                                                                                         // 66
    query = {                                                                                                          // 66
      _hidden: {                                                                                                       // 67
        $ne: true                                                                                                      // 68
      },                                                                                                               //
      rid: roomId,                                                                                                     // 67
      ts: {                                                                                                            // 67
        $lt: timestamp                                                                                                 // 71
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 73
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleByRoomIdBetweenTimestamps = function(roomId, afterTimestamp, beforeTimestamp, options) {
    var query;                                                                                                         // 76
    query = {                                                                                                          // 76
      _hidden: {                                                                                                       // 77
        $ne: true                                                                                                      // 78
      },                                                                                                               //
      rid: roomId,                                                                                                     // 77
      ts: {                                                                                                            // 77
        $gt: afterTimestamp,                                                                                           // 81
        $lt: beforeTimestamp                                                                                           // 81
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 84
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findVisibleCreatedOrEditedAfterTimestamp = function(timestamp, options) {                           // 2
    var query;                                                                                                         // 87
    query = {                                                                                                          // 87
      _hidden: {                                                                                                       // 88
        $ne: true                                                                                                      // 88
      },                                                                                                               //
      $or: [                                                                                                           // 88
        {                                                                                                              //
          ts: {                                                                                                        // 90
            $gt: timestamp                                                                                             // 91
          }                                                                                                            //
        }, {                                                                                                           //
          'editedAt': {                                                                                                // 93
            $gt: timestamp                                                                                             // 94
          }                                                                                                            //
        }                                                                                                              //
      ]                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 97
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findStarredByUserAtRoom = function(userId, roomId, options) {                                       // 2
    var query;                                                                                                         // 100
    query = {                                                                                                          // 100
      _hidden: {                                                                                                       // 101
        $ne: true                                                                                                      // 101
      },                                                                                                               //
      'starred._id': userId,                                                                                           // 101
      rid: roomId                                                                                                      // 101
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 105
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findPinnedByRoom = function(roomId, options) {                                                      // 2
    var query;                                                                                                         // 108
    query = {                                                                                                          // 108
      t: {                                                                                                             // 109
        $ne: 'rm'                                                                                                      // 109
      },                                                                                                               //
      _hidden: {                                                                                                       // 109
        $ne: true                                                                                                      // 110
      },                                                                                                               //
      pinned: true,                                                                                                    // 109
      rid: roomId                                                                                                      // 109
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 114
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.getLastTimestamp = function(options) {                                                              // 2
    var query, ref, ref1, ref2;                                                                                        // 117
    if (options == null) {                                                                                             //
      options = {};                                                                                                    //
    }                                                                                                                  //
    query = {                                                                                                          // 117
      ts: {                                                                                                            // 117
        $exists: 1                                                                                                     // 117
      }                                                                                                                //
    };                                                                                                                 //
    options.sort = {                                                                                                   // 117
      ts: -1                                                                                                           // 118
    };                                                                                                                 //
    options.limit = 1;                                                                                                 // 117
    return (ref = this.find(query, options)) != null ? typeof ref.fetch === "function" ? (ref1 = ref.fetch()) != null ? (ref2 = ref1[0]) != null ? ref2.ts : void 0 : void 0 : void 0 : void 0;
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByRoomIdAndMessageIds = function(rid, messageIds, options) {                                    // 2
    var query;                                                                                                         // 124
    query = {                                                                                                          // 124
      rid: rid,                                                                                                        // 125
      _id: {                                                                                                           // 125
        $in: messageIds                                                                                                // 127
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 129
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.cloneAndSaveAsHistoryById = function(_id) {                                                         // 2
    var me, record, ref, ref1;                                                                                         // 132
    me = RocketChat.models.Users.findOneById(Meteor.userId());                                                         // 132
    record = this.findOneById(_id);                                                                                    // 132
    record._hidden = true;                                                                                             // 132
    record.parent = record._id;                                                                                        // 132
    record.editedAt = new Date;                                                                                        // 132
    record.editedBy = {                                                                                                // 132
      _id: Meteor.userId(),                                                                                            // 138
      username: me.username                                                                                            // 138
    };                                                                                                                 //
    record.pinned = record.pinned;                                                                                     // 132
    record.pinnedAt = record.pinnedAt;                                                                                 // 132
    record.pinnedBy = {                                                                                                // 132
      _id: (ref = record.pinnedBy) != null ? ref._id : void 0,                                                         // 143
      username: (ref1 = record.pinnedBy) != null ? ref1.username : void 0                                              // 143
    };                                                                                                                 //
    delete record._id;                                                                                                 // 132
    return this.insert(record);                                                                                        // 147
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setHiddenById = function(_id, hidden) {                                                             // 2
    var query, update;                                                                                                 // 151
    if (hidden == null) {                                                                                              //
      hidden = true;                                                                                                   //
    }                                                                                                                  //
    query = {                                                                                                          // 151
      _id: _id                                                                                                         // 152
    };                                                                                                                 //
    update = {                                                                                                         // 151
      $set: {                                                                                                          // 155
        _hidden: hidden                                                                                                // 156
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 158
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setAsDeletedById = function(_id) {                                                                  // 2
    var me, query, update;                                                                                             // 161
    me = RocketChat.models.Users.findOneById(Meteor.userId());                                                         // 161
    query = {                                                                                                          // 161
      _id: _id                                                                                                         // 163
    };                                                                                                                 //
    update = {                                                                                                         // 161
      $set: {                                                                                                          // 166
        msg: '',                                                                                                       // 167
        t: 'rm',                                                                                                       // 167
        urls: [],                                                                                                      // 167
        mentions: [],                                                                                                  // 167
        attachments: [],                                                                                               // 167
        editedAt: new Date(),                                                                                          // 167
        editedBy: {                                                                                                    // 167
          _id: Meteor.userId(),                                                                                        // 174
          username: me.username                                                                                        // 174
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 177
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setPinnedByIdAndUserId = function(_id, pinnedBy, pinned) {                                          // 2
    var query, update;                                                                                                 // 180
    if (pinned == null) {                                                                                              //
      pinned = true;                                                                                                   //
    }                                                                                                                  //
    query = {                                                                                                          // 180
      _id: _id                                                                                                         // 181
    };                                                                                                                 //
    update = {                                                                                                         // 180
      $set: {                                                                                                          // 184
        pinned: pinned,                                                                                                // 185
        pinnedAt: new Date,                                                                                            // 185
        pinnedBy: pinnedBy                                                                                             // 185
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 189
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUrlsById = function(_id, urls) {                                                                 // 2
    var query, update;                                                                                                 // 192
    query = {                                                                                                          // 192
      _id: _id                                                                                                         // 193
    };                                                                                                                 //
    update = {                                                                                                         // 192
      $set: {                                                                                                          // 196
        urls: urls                                                                                                     // 197
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 199
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateAllUsernamesByUserId = function(userId, username) {                                           // 2
    var query, update;                                                                                                 // 202
    query = {                                                                                                          // 202
      'u._id': userId                                                                                                  // 203
    };                                                                                                                 //
    update = {                                                                                                         // 202
      $set: {                                                                                                          // 206
        "u.username": username                                                                                         // 207
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 209
      multi: true                                                                                                      // 209
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateUsernameOfEditByUserId = function(userId, username) {                                         // 2
    var query, update;                                                                                                 // 212
    query = {                                                                                                          // 212
      'editedBy._id': userId                                                                                           // 213
    };                                                                                                                 //
    update = {                                                                                                         // 212
      $set: {                                                                                                          // 216
        "editedBy.username": username                                                                                  // 217
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 219
      multi: true                                                                                                      // 219
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateUsernameAndMessageOfMentionByIdAndOldUsername = function(_id, oldUsername, newUsername, newMessage) {
    var query, update;                                                                                                 // 222
    query = {                                                                                                          // 222
      _id: _id,                                                                                                        // 223
      "mentions.username": oldUsername                                                                                 // 223
    };                                                                                                                 //
    update = {                                                                                                         // 222
      $set: {                                                                                                          // 227
        "mentions.$.username": newUsername,                                                                            // 228
        "msg": newMessage                                                                                              // 228
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 231
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateUserStarById = function(_id, userId, starred) {                                               // 2
    var query, update;                                                                                                 // 234
    query = {                                                                                                          // 234
      _id: _id                                                                                                         // 235
    };                                                                                                                 //
    if (starred) {                                                                                                     // 237
      update = {                                                                                                       // 238
        $addToSet: {                                                                                                   // 239
          starred: {                                                                                                   // 240
            _id: userId                                                                                                // 240
          }                                                                                                            //
        }                                                                                                              //
      };                                                                                                               //
    } else {                                                                                                           //
      update = {                                                                                                       // 242
        $pull: {                                                                                                       // 243
          starred: {                                                                                                   // 244
            _id: Meteor.userId()                                                                                       // 244
          }                                                                                                            //
        }                                                                                                              //
      };                                                                                                               //
    }                                                                                                                  //
    return this.update(query, update);                                                                                 // 246
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.upgradeEtsToEditAt = function() {                                                                   // 2
    var query, update;                                                                                                 // 249
    query = {                                                                                                          // 249
      ets: {                                                                                                           // 250
        $exists: 1                                                                                                     // 250
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 249
      $rename: {                                                                                                       // 253
        "ets": "editedAt"                                                                                              // 254
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 256
      multi: true                                                                                                      // 256
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setMessageAttachments = function(_id, attachments) {                                                // 2
    var query, update;                                                                                                 // 259
    query = {                                                                                                          // 259
      _id: _id                                                                                                         // 260
    };                                                                                                                 //
    update = {                                                                                                         // 259
      $set: {                                                                                                          // 263
        attachments: attachments                                                                                       // 264
      }                                                                                                                //
    };                                                                                                                 //
    console.log(query, update);                                                                                        // 259
    return this.update(query, update);                                                                                 // 266
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createWithTypeRoomIdMessageAndUser = function(type, roomId, message, user, extraData) {             // 2
    var record;                                                                                                        // 271
    record = {                                                                                                         // 271
      t: type,                                                                                                         // 272
      rid: roomId,                                                                                                     // 272
      ts: new Date,                                                                                                    // 272
      msg: message,                                                                                                    // 272
      u: {                                                                                                             // 272
        _id: user._id,                                                                                                 // 277
        username: user.username                                                                                        // 277
      },                                                                                                               //
      groupable: false                                                                                                 // 272
    };                                                                                                                 //
    _.extend(record, extraData);                                                                                       // 271
    record._id = this.insertOrUpsert(record);                                                                          // 271
    return record;                                                                                                     // 284
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserJoinWithRoomIdAndUser = function(roomId, user, extraData) {                               // 2
    var message;                                                                                                       // 287
    message = user.username;                                                                                           // 287
    return this.createWithTypeRoomIdMessageAndUser('uj', roomId, message, user, extraData);                            // 288
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserLeaveWithRoomIdAndUser = function(roomId, user, extraData) {                              // 2
    var message;                                                                                                       // 291
    message = user.username;                                                                                           // 291
    return this.createWithTypeRoomIdMessageAndUser('ul', roomId, message, user, extraData);                            // 292
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserRemovedWithRoomIdAndUser = function(roomId, user, extraData) {                            // 2
    var message;                                                                                                       // 295
    message = user.username;                                                                                           // 295
    return this.createWithTypeRoomIdMessageAndUser('ru', roomId, message, user, extraData);                            // 296
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserAddedWithRoomIdAndUser = function(roomId, user, extraData) {                              // 2
    var message;                                                                                                       // 299
    message = user.username;                                                                                           // 299
    return this.createWithTypeRoomIdMessageAndUser('au', roomId, message, user, extraData);                            // 300
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createCommandWithRoomIdAndUser = function(command, roomId, user, extraData) {                       // 2
    return this.createWithTypeRoomIdMessageAndUser('command', roomId, command, user, extraData);                       // 303
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserMutedWithRoomIdAndUser = function(roomId, user, extraData) {                              // 2
    var message;                                                                                                       // 306
    message = user.username;                                                                                           // 306
    return this.createWithTypeRoomIdMessageAndUser('user-muted', roomId, message, user, extraData);                    // 307
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createUserUnmutedWithRoomIdAndUser = function(roomId, user, extraData) {                            // 2
    var message;                                                                                                       // 310
    message = user.username;                                                                                           // 310
    return this.createWithTypeRoomIdMessageAndUser('user-unmuted', roomId, message, user, extraData);                  // 311
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createNewModeratorWithRoomIdAndUser = function(roomId, user, extraData) {                           // 2
    var message;                                                                                                       // 314
    message = user.username;                                                                                           // 314
    return this.createWithTypeRoomIdMessageAndUser('new-moderator', roomId, message, user, extraData);                 // 315
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createModeratorRemovedWithRoomIdAndUser = function(roomId, user, extraData) {                       // 2
    var message;                                                                                                       // 318
    message = user.username;                                                                                           // 318
    return this.createWithTypeRoomIdMessageAndUser('moderator-removed', roomId, message, user, extraData);             // 319
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createNewOwnerWithRoomIdAndUser = function(roomId, user, extraData) {                               // 2
    var message;                                                                                                       // 322
    message = user.username;                                                                                           // 322
    return this.createWithTypeRoomIdMessageAndUser('new-owner', roomId, message, user, extraData);                     // 323
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createOwnerRemovedWithRoomIdAndUser = function(roomId, user, extraData) {                           // 2
    var message;                                                                                                       // 326
    message = user.username;                                                                                           // 326
    return this.createWithTypeRoomIdMessageAndUser('owner-removed', roomId, message, user, extraData);                 // 327
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createSubscriptionRoleAddedWithRoomIdAndUser = function(roomId, user, extraData) {                  // 2
    var message;                                                                                                       // 330
    message = user.username;                                                                                           // 330
    return this.createWithTypeRoomIdMessageAndUser('subscription-role-added', roomId, message, user, extraData);       // 331
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createSubscriptionRoleRemovedWithRoomIdAndUser = function(roomId, user, extraData) {                // 2
    var message;                                                                                                       // 334
    message = user.username;                                                                                           // 334
    return this.createWithTypeRoomIdMessageAndUser('subscription-role-removed', roomId, message, user, extraData);     // 335
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeById = function(_id) {                                                                        // 2
    var query;                                                                                                         // 339
    query = {                                                                                                          // 339
      _id: _id                                                                                                         // 340
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 342
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByRoomId = function(roomId) {                                                                 // 2
    var query;                                                                                                         // 345
    query = {                                                                                                          // 345
      rid: roomId                                                                                                      // 346
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 348
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByUserId = function(userId) {                                                                 // 2
    var query;                                                                                                         // 351
    query = {                                                                                                          // 351
      "u._id": userId                                                                                                  // 352
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 354
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.getMessageByFileId = function(fileID) {                                                             // 2
    return this.findOne({                                                                                              // 357
      'file._id': fileID                                                                                               // 357
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Reports.coffee.js                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Reports = new ((function(superClass) {                                                               // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('reports');                                                                                        // 3
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.createWithMessageDescriptionAndUserId = function(message, description, userId, extraData) {         // 2
    var record;                                                                                                        // 8
    record = {                                                                                                         // 8
      message: message,                                                                                                // 9
      description: description,                                                                                        // 9
      ts: new Date(),                                                                                                  // 9
      userId: userId                                                                                                   // 9
    };                                                                                                                 //
    _.extend(record, extraData);                                                                                       // 8
    record._id = this.insert(record);                                                                                  // 8
    return record;                                                                                                     // 17
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Rooms.coffee.js                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Rooms = new ((function(superClass) {                                                                 // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('room');                                                                                           // 3
    this.tryEnsureIndex({                                                                                              // 3
      'name': 1                                                                                                        // 5
    }, {                                                                                                               //
      unique: 1,                                                                                                       // 5
      sparse: 1                                                                                                        // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'default': 1                                                                                                     // 6
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'usernames': 1                                                                                                   // 7
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      't': 1                                                                                                           // 8
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'u._id': 1                                                                                                       // 9
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneById = function(_id, options) {                                                              // 2
    var query;                                                                                                         // 14
    query = {                                                                                                          // 14
      _id: _id                                                                                                         // 15
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 17
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByName = function(name, options) {                                                           // 2
    var query;                                                                                                         // 20
    query = {                                                                                                          // 20
      name: name                                                                                                       // 21
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 23
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByNameAndType = function(name, type, options) {                                              // 2
    var query;                                                                                                         // 26
    query = {                                                                                                          // 26
      name: name,                                                                                                      // 27
      t: type                                                                                                          // 27
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 30
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByIdContainigUsername = function(_id, username, options) {                                   // 2
    var query;                                                                                                         // 33
    query = {                                                                                                          // 33
      _id: _id,                                                                                                        // 34
      usernames: username                                                                                              // 34
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 37
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByNameAndTypeNotContainigUsername = function(name, type, username, options) {                // 2
    var query;                                                                                                         // 40
    query = {                                                                                                          // 40
      name: name,                                                                                                      // 41
      t: type,                                                                                                         // 41
      usernames: {                                                                                                     // 41
        $ne: username                                                                                                  // 44
      }                                                                                                                //
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 46
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findById = function(roomId) {                                                                       // 2
    return this.find({                                                                                                 // 51
      _id: roomId                                                                                                      // 51
    }, options);                                                                                                       //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByType = function(type, options) {                                                              // 2
    var query;                                                                                                         // 54
    query = {                                                                                                          // 54
      t: type                                                                                                          // 55
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 57
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypes = function(types, options) {                                                            // 2
    var query;                                                                                                         // 60
    query = {                                                                                                          // 60
      t: {                                                                                                             // 61
        $in: types                                                                                                     // 62
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 64
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByUserId = function(userId, options) {                                                          // 2
    var query;                                                                                                         // 67
    query = {                                                                                                          // 67
      "u._id": userId                                                                                                  // 68
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 70
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByNameContaining = function(name, options) {                                                    // 2
    var nameRegex, query;                                                                                              // 73
    nameRegex = new RegExp(s.trim(s.escapeRegExp(name)), "i");                                                         // 73
    query = {                                                                                                          // 73
      $or: [                                                                                                           // 76
        {                                                                                                              //
          name: nameRegex                                                                                              // 77
        }, {                                                                                                           //
          t: 'd',                                                                                                      // 79
          usernames: nameRegex                                                                                         // 79
        }                                                                                                              //
      ]                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 83
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByNameContainingAndTypes = function(name, types, options) {                                     // 2
    var nameRegex, query;                                                                                              // 86
    nameRegex = new RegExp(s.trim(s.escapeRegExp(name)), "i");                                                         // 86
    query = {                                                                                                          // 86
      t: {                                                                                                             // 89
        $in: types                                                                                                     // 90
      },                                                                                                               //
      $or: [                                                                                                           // 89
        {                                                                                                              //
          name: nameRegex                                                                                              // 92
        }, {                                                                                                           //
          t: 'd',                                                                                                      // 94
          usernames: nameRegex                                                                                         // 94
        }                                                                                                              //
      ]                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 98
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByNameStartingAndTypes = function(name, types, options) {                                       // 2
    var nameRegex, query;                                                                                              // 101
    nameRegex = new RegExp("^" + s.trim(s.escapeRegExp(name)), "i");                                                   // 101
    query = {                                                                                                          // 101
      t: {                                                                                                             // 104
        $in: types                                                                                                     // 105
      },                                                                                                               //
      $or: [                                                                                                           // 104
        {                                                                                                              //
          name: nameRegex                                                                                              // 107
        }, {                                                                                                           //
          t: 'd',                                                                                                      // 109
          usernames: nameRegex                                                                                         // 109
        }                                                                                                              //
      ]                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 113
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByDefaultAndTypes = function(defaultValue, types, options) {                                    // 2
    var query;                                                                                                         // 116
    query = {                                                                                                          // 116
      "default": defaultValue,                                                                                         // 117
      t: {                                                                                                             // 117
        $in: types                                                                                                     // 119
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 121
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypeContainigUsername = function(type, username, options) {                                   // 2
    var query;                                                                                                         // 124
    query = {                                                                                                          // 124
      t: type,                                                                                                         // 125
      usernames: username                                                                                              // 125
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 128
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypeContainigUsernames = function(type, username, options) {                                  // 2
    var query;                                                                                                         // 131
    query = {                                                                                                          // 131
      t: type,                                                                                                         // 132
      usernames: {                                                                                                     // 132
        $all: [].concat(username)                                                                                      // 133
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 135
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypesAndNotUserIdContainingUsername = function(types, userId, username, options) {            // 2
    var query;                                                                                                         // 138
    query = {                                                                                                          // 138
      t: {                                                                                                             // 139
        $in: types                                                                                                     // 140
      },                                                                                                               //
      uid: {                                                                                                           // 139
        $ne: userId                                                                                                    // 142
      },                                                                                                               //
      usernames: username                                                                                              // 139
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 145
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByContainigUsername = function(username, options) {                                             // 2
    var query;                                                                                                         // 148
    query = {                                                                                                          // 148
      usernames: username                                                                                              // 149
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 151
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypeAndName = function(type, name, options) {                                                 // 2
    var query;                                                                                                         // 154
    query = {                                                                                                          // 154
      name: name,                                                                                                      // 155
      t: type                                                                                                          // 155
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 158
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypeAndNameContainigUsername = function(type, name, username, options) {                      // 2
    var query;                                                                                                         // 161
    query = {                                                                                                          // 161
      name: name,                                                                                                      // 162
      t: type,                                                                                                         // 162
      usernames: username                                                                                              // 162
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 166
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByTypeAndArchivationState = function(type, archivationstate, options) {                         // 2
    var query;                                                                                                         // 169
    query = {                                                                                                          // 169
      t: type                                                                                                          // 170
    };                                                                                                                 //
    if (archivationstate) {                                                                                            // 172
      query.archived = true;                                                                                           // 173
    } else {                                                                                                           //
      query.archived = {                                                                                               // 175
        $ne: true                                                                                                      // 175
      };                                                                                                               //
    }                                                                                                                  //
    return this.find(query, options);                                                                                  // 177
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByVisitorToken = function(visitorToken, options) {                                              // 2
    var query;                                                                                                         // 180
    query = {                                                                                                          // 180
      "v.token": visitorToken                                                                                          // 181
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 183
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.archiveById = function(_id) {                                                                       // 2
    var query, update;                                                                                                 // 188
    query = {                                                                                                          // 188
      _id: _id                                                                                                         // 189
    };                                                                                                                 //
    update = {                                                                                                         // 188
      $set: {                                                                                                          // 192
        archived: true                                                                                                 // 193
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 195
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unarchiveById = function(_id) {                                                                     // 2
    var query, update;                                                                                                 // 198
    query = {                                                                                                          // 198
      _id: _id                                                                                                         // 199
    };                                                                                                                 //
    update = {                                                                                                         // 198
      $set: {                                                                                                          // 202
        archived: false                                                                                                // 203
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 205
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.addUsernameById = function(_id, username) {                                                         // 2
    var query, update;                                                                                                 // 208
    query = {                                                                                                          // 208
      _id: _id                                                                                                         // 209
    };                                                                                                                 //
    update = {                                                                                                         // 208
      $addToSet: {                                                                                                     // 212
        usernames: username                                                                                            // 213
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 215
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.addUsernamesById = function(_id, usernames) {                                                       // 2
    var query, update;                                                                                                 // 218
    query = {                                                                                                          // 218
      _id: _id                                                                                                         // 219
    };                                                                                                                 //
    update = {                                                                                                         // 218
      $addToSet: {                                                                                                     // 222
        usernames: {                                                                                                   // 223
          $each: usernames                                                                                             // 224
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 226
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.addUsernameByName = function(name, username) {                                                      // 2
    var query, update;                                                                                                 // 229
    query = {                                                                                                          // 229
      name: name                                                                                                       // 230
    };                                                                                                                 //
    update = {                                                                                                         // 229
      $addToSet: {                                                                                                     // 233
        usernames: username                                                                                            // 234
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 236
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeUsernameById = function(_id, username) {                                                      // 2
    var query, update;                                                                                                 // 239
    query = {                                                                                                          // 239
      _id: _id                                                                                                         // 240
    };                                                                                                                 //
    update = {                                                                                                         // 239
      $pull: {                                                                                                         // 243
        usernames: username                                                                                            // 244
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 246
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeUsernamesById = function(_id, usernames) {                                                    // 2
    var query, update;                                                                                                 // 249
    query = {                                                                                                          // 249
      _id: _id                                                                                                         // 250
    };                                                                                                                 //
    update = {                                                                                                         // 249
      $pull: {                                                                                                         // 253
        usernames: {                                                                                                   // 254
          $in: usernames                                                                                               // 255
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 257
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeUsernameFromAll = function(username) {                                                        // 2
    var query, update;                                                                                                 // 260
    query = {};                                                                                                        // 260
    update = {                                                                                                         // 260
      $pull: {                                                                                                         // 263
        usernames: username                                                                                            // 264
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 266
      multi: true                                                                                                      // 266
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeUsernameByName = function(name, username) {                                                   // 2
    var query, update;                                                                                                 // 269
    query = {                                                                                                          // 269
      name: name                                                                                                       // 270
    };                                                                                                                 //
    update = {                                                                                                         // 269
      $pull: {                                                                                                         // 273
        usernames: username                                                                                            // 274
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 276
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setNameById = function(_id, name) {                                                                 // 2
    var query, update;                                                                                                 // 279
    query = {                                                                                                          // 279
      _id: _id                                                                                                         // 280
    };                                                                                                                 //
    update = {                                                                                                         // 279
      $set: {                                                                                                          // 283
        name: name                                                                                                     // 284
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 286
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.incMsgCountAndSetLastMessageTimestampById = function(_id, inc, lastMessageTimestamp) {              // 2
    var query, update;                                                                                                 // 289
    if (inc == null) {                                                                                                 //
      inc = 1;                                                                                                         //
    }                                                                                                                  //
    query = {                                                                                                          // 289
      _id: _id                                                                                                         // 290
    };                                                                                                                 //
    update = {                                                                                                         // 289
      $set: {                                                                                                          // 293
        lm: lastMessageTimestamp                                                                                       // 294
      },                                                                                                               //
      $inc: {                                                                                                          // 293
        msgs: inc                                                                                                      // 296
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 298
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.replaceUsername = function(previousUsername, username) {                                            // 2
    var query, update;                                                                                                 // 301
    query = {                                                                                                          // 301
      usernames: previousUsername                                                                                      // 302
    };                                                                                                                 //
    update = {                                                                                                         // 301
      $set: {                                                                                                          // 305
        "usernames.$": username                                                                                        // 306
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 308
      multi: true                                                                                                      // 308
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.replaceMutedUsername = function(previousUsername, username) {                                       // 2
    var query, update;                                                                                                 // 311
    query = {                                                                                                          // 311
      muted: previousUsername                                                                                          // 312
    };                                                                                                                 //
    update = {                                                                                                         // 311
      $set: {                                                                                                          // 315
        "muted.$": username                                                                                            // 316
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 318
      multi: true                                                                                                      // 318
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.replaceUsernameOfUserByUserId = function(userId, username) {                                        // 2
    var query, update;                                                                                                 // 321
    query = {                                                                                                          // 321
      "u._id": userId                                                                                                  // 322
    };                                                                                                                 //
    update = {                                                                                                         // 321
      $set: {                                                                                                          // 325
        "u.username": username                                                                                         // 326
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 328
      multi: true                                                                                                      // 328
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUserById = function(_id, user) {                                                                 // 2
    var query, update;                                                                                                 // 331
    query = {                                                                                                          // 331
      _id: _id                                                                                                         // 332
    };                                                                                                                 //
    update = {                                                                                                         // 331
      $set: {                                                                                                          // 335
        u: {                                                                                                           // 336
          _id: user._id,                                                                                               // 337
          username: user.username                                                                                      // 337
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 340
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setTypeById = function(_id, type) {                                                                 // 2
    var query, update;                                                                                                 // 343
    query = {                                                                                                          // 343
      _id: _id                                                                                                         // 344
    };                                                                                                                 //
    update = {                                                                                                         // 343
      $set: {                                                                                                          // 347
        t: type                                                                                                        // 348
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 350
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setTopicById = function(_id, topic) {                                                               // 2
    var query, update;                                                                                                 // 353
    query = {                                                                                                          // 353
      _id: _id                                                                                                         // 354
    };                                                                                                                 //
    update = {                                                                                                         // 353
      $set: {                                                                                                          // 357
        topic: topic                                                                                                   // 358
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 360
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.muteUsernameByRoomId = function(_id, username) {                                                    // 2
    var query, update;                                                                                                 // 363
    query = {                                                                                                          // 363
      _id: _id                                                                                                         // 364
    };                                                                                                                 //
    update = {                                                                                                         // 363
      $addToSet: {                                                                                                     // 367
        muted: username                                                                                                // 368
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 370
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unmuteUsernameByRoomId = function(_id, username) {                                                  // 2
    var query, update;                                                                                                 // 373
    query = {                                                                                                          // 373
      _id: _id                                                                                                         // 374
    };                                                                                                                 //
    update = {                                                                                                         // 373
      $pull: {                                                                                                         // 377
        muted: username                                                                                                // 378
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 380
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.saveDefaultById = function(_id, defaultValue) {                                                     // 2
    var query, update;                                                                                                 // 383
    query = {                                                                                                          // 383
      _id: _id                                                                                                         // 384
    };                                                                                                                 //
    update = {                                                                                                         // 383
      $set: {                                                                                                          // 387
        "default": defaultValue === 'true'                                                                             // 388
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 390
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createWithTypeNameUserAndUsernames = function(type, name, user, usernames, extraData) {             // 2
    var room;                                                                                                          // 394
    room = {                                                                                                           // 394
      name: name,                                                                                                      // 395
      t: type,                                                                                                         // 395
      usernames: usernames,                                                                                            // 395
      msgs: 0,                                                                                                         // 395
      u: {                                                                                                             // 395
        _id: user._id,                                                                                                 // 400
        username: user.username                                                                                        // 400
      }                                                                                                                //
    };                                                                                                                 //
    _.extend(room, extraData);                                                                                         // 394
    room._id = this.insert(room);                                                                                      // 394
    return room;                                                                                                       // 406
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createWithIdTypeAndName = function(_id, type, name, extraData) {                                    // 2
    var room;                                                                                                          // 409
    room = {                                                                                                           // 409
      _id: _id,                                                                                                        // 410
      ts: new Date(),                                                                                                  // 410
      t: type,                                                                                                         // 410
      name: name,                                                                                                      // 410
      usernames: [],                                                                                                   // 410
      msgs: 0                                                                                                          // 410
    };                                                                                                                 //
    _.extend(room, extraData);                                                                                         // 409
    this.insert(room);                                                                                                 // 409
    return room;                                                                                                       // 420
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeById = function(_id) {                                                                        // 2
    var query;                                                                                                         // 425
    query = {                                                                                                          // 425
      _id: _id                                                                                                         // 426
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 428
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByTypeContainingUsername = function(type, username) {                                         // 2
    var query;                                                                                                         // 431
    query = {                                                                                                          // 431
      t: type,                                                                                                         // 432
      usernames: username                                                                                              // 432
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 435
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Settings.coffee.js                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Settings = new ((function(superClass) {                                                              // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('settings');                                                                                       // 3
    this.tryEnsureIndex({                                                                                              // 3
      'blocked': 1                                                                                                     // 5
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'hidden': 1                                                                                                      // 6
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 6
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneById = function(_id, options) {                                                              // 2
    var query;                                                                                                         // 10
    query = {                                                                                                          // 10
      _id: _id                                                                                                         // 11
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 13
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findById = function(_id) {                                                                          // 2
    var query;                                                                                                         // 17
    query = {                                                                                                          // 17
      _id: _id                                                                                                         // 18
    };                                                                                                                 //
    return this.find(query);                                                                                           // 20
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByIds = function(_id) {                                                                         // 2
    var query;                                                                                                         // 23
    if (_id == null) {                                                                                                 //
      _id = [];                                                                                                        //
    }                                                                                                                  //
    _id = [].concat(_id);                                                                                              // 23
    query = {                                                                                                          // 23
      _id: {                                                                                                           // 26
        $in: _id                                                                                                       // 27
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query);                                                                                           // 29
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByRole = function(role, options) {                                                              // 2
    var query;                                                                                                         // 32
    query = {                                                                                                          // 32
      role: role                                                                                                       // 33
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 35
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findPublic = function(options) {                                                                    // 2
    var query;                                                                                                         // 38
    query = {                                                                                                          // 38
      "public": true                                                                                                   // 39
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 41
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findNotHiddenPublic = function(ids) {                                                               // 2
    var filter;                                                                                                        // 44
    if (ids == null) {                                                                                                 //
      ids = [];                                                                                                        //
    }                                                                                                                  //
    filter = {                                                                                                         // 44
      hidden: {                                                                                                        // 45
        $ne: true                                                                                                      // 45
      },                                                                                                               //
      "public": true                                                                                                   // 45
    };                                                                                                                 //
    if (ids.length > 0) {                                                                                              // 48
      filter._id = {                                                                                                   // 49
        $in: ids                                                                                                       // 50
      };                                                                                                               //
    }                                                                                                                  //
    return this.find(filter, {                                                                                         // 52
      fields: {                                                                                                        // 52
        _id: 1,                                                                                                        // 52
        value: 1                                                                                                       // 52
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findNotHidden = function() {                                                                        // 2
    return this.find({                                                                                                 // 55
      hidden: {                                                                                                        // 55
        $ne: true                                                                                                      // 55
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateValueById = function(_id, value) {                                                            // 2
    var query, update;                                                                                                 // 59
    query = {                                                                                                          // 59
      blocked: {                                                                                                       // 60
        $ne: true                                                                                                      // 60
      },                                                                                                               //
      _id: _id                                                                                                         // 60
    };                                                                                                                 //
    update = {                                                                                                         // 59
      $set: {                                                                                                          // 64
        value: value                                                                                                   // 65
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 67
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateOptionsById = function(_id, options) {                                                        // 2
    var query, update;                                                                                                 // 70
    query = {                                                                                                          // 70
      blocked: {                                                                                                       // 71
        $ne: true                                                                                                      // 71
      },                                                                                                               //
      _id: _id                                                                                                         // 71
    };                                                                                                                 //
    update = {                                                                                                         // 70
      $set: options                                                                                                    // 75
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 77
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createWithIdAndValue = function(_id, value) {                                                       // 2
    var record;                                                                                                        // 81
    record = {                                                                                                         // 81
      _id: _id,                                                                                                        // 82
      value: value,                                                                                                    // 82
      _createdAt: new Date                                                                                             // 82
    };                                                                                                                 //
    return this.insert(record);                                                                                        // 86
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeById = function(_id) {                                                                        // 2
    var query;                                                                                                         // 90
    query = {                                                                                                          // 90
      blocked: {                                                                                                       // 91
        $ne: true                                                                                                      // 91
      },                                                                                                               //
      _id: _id                                                                                                         // 91
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 94
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Subscriptions.coffee.js                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Subscriptions = new ((function(superClass) {                                                         // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('subscription');                                                                                   // 3
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1,                                                                                                        // 5
      'u._id': 1                                                                                                       // 5
    }, {                                                                                                               //
      unique: 1                                                                                                        // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1,                                                                                                        // 6
      'alert': 1,                                                                                                      // 6
      'u._id': 1                                                                                                       // 6
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1,                                                                                                        // 7
      'roles': 1                                                                                                       // 7
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'u._id': 1,                                                                                                      // 8
      'name': 1,                                                                                                       // 8
      't': 1                                                                                                           // 8
    }, {                                                                                                               //
      unique: 1                                                                                                        // 8
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'open': 1                                                                                                        // 9
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'alert': 1                                                                                                       // 10
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'unread': 1                                                                                                      // 11
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'ts': 1                                                                                                          // 12
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'ls': 1                                                                                                          // 13
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'desktopNotifications': 1                                                                                        // 14
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 14
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'mobilePushNotifications': 1                                                                                     // 15
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 15
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'emailNotifications': 1                                                                                          // 16
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 16
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneByRoomIdAndUserId = function(roomId, userId) {                                               // 2
    var query;                                                                                                         // 21
    query = {                                                                                                          // 21
      rid: roomId,                                                                                                     // 22
      "u._id": userId                                                                                                  // 22
    };                                                                                                                 //
    return this.findOne(query);                                                                                        // 25
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByUserId = function(userId, options) {                                                          // 2
    var query;                                                                                                         // 29
    query = {                                                                                                          // 29
      "u._id": userId                                                                                                  // 30
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 32
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByRoomIdAndRoles = function(roomId, roles, options) {                                           // 2
    var query;                                                                                                         // 36
    roles = [].concat(roles);                                                                                          // 36
    query = {                                                                                                          // 36
      "rid": roomId,                                                                                                   // 38
      "roles": {                                                                                                       // 38
        $in: roles                                                                                                     // 39
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 41
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByType = function(types, options) {                                                             // 2
    var query;                                                                                                         // 44
    query = {                                                                                                          // 44
      t: {                                                                                                             // 45
        $in: types                                                                                                     // 46
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 48
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByNameContainingAndTypes = function(name, types, options) {                                     // 2
    var nameRegex, query;                                                                                              // 51
    nameRegex = new RegExp(s.trim(s.escapeRegExp(name)), "i");                                                         // 51
    query = {                                                                                                          // 51
      t: {                                                                                                             // 54
        $in: types,                                                                                                    // 55
        name: nameRegex                                                                                                // 55
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 58
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.getLastSeen = function(options) {                                                                   // 2
    var query, ref, ref1, ref2;                                                                                        // 61
    if (options == null) {                                                                                             //
      options = {};                                                                                                    //
    }                                                                                                                  //
    query = {                                                                                                          // 61
      ls: {                                                                                                            // 61
        $exists: 1                                                                                                     // 61
      }                                                                                                                //
    };                                                                                                                 //
    options.sort = {                                                                                                   // 61
      ls: -1                                                                                                           // 62
    };                                                                                                                 //
    options.limit = 1;                                                                                                 // 61
    return (ref = this.find(query, options)) != null ? typeof ref.fetch === "function" ? (ref1 = ref.fetch()) != null ? (ref2 = ref1[0]) != null ? ref2.ls : void 0 : void 0 : void 0 : void 0;
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.archiveByRoomIdAndUserId = function(roomId, userId) {                                               // 2
    var query, update;                                                                                                 // 69
    query = {                                                                                                          // 69
      rid: roomId,                                                                                                     // 70
      'u._id': userId                                                                                                  // 70
    };                                                                                                                 //
    update = {                                                                                                         // 69
      $set: {                                                                                                          // 74
        alert: false,                                                                                                  // 75
        open: false,                                                                                                   // 75
        archived: true                                                                                                 // 75
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 79
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unarchiveByRoomIdAndUserId = function(roomId, userId) {                                             // 2
    var query, update;                                                                                                 // 82
    query = {                                                                                                          // 82
      rid: roomId,                                                                                                     // 83
      'u._id': userId                                                                                                  // 83
    };                                                                                                                 //
    update = {                                                                                                         // 82
      $set: {                                                                                                          // 87
        alert: false,                                                                                                  // 88
        open: true,                                                                                                    // 88
        archived: false                                                                                                // 88
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 92
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.hideByRoomIdAndUserId = function(roomId, userId) {                                                  // 2
    var query, update;                                                                                                 // 95
    query = {                                                                                                          // 95
      rid: roomId,                                                                                                     // 96
      'u._id': userId                                                                                                  // 96
    };                                                                                                                 //
    update = {                                                                                                         // 95
      $set: {                                                                                                          // 100
        alert: false,                                                                                                  // 101
        open: false                                                                                                    // 101
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 104
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.openByRoomIdAndUserId = function(roomId, userId) {                                                  // 2
    var query, update;                                                                                                 // 107
    query = {                                                                                                          // 107
      rid: roomId,                                                                                                     // 108
      'u._id': userId                                                                                                  // 108
    };                                                                                                                 //
    update = {                                                                                                         // 107
      $set: {                                                                                                          // 112
        open: true                                                                                                     // 113
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 115
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setAsReadByRoomIdAndUserId = function(roomId, userId) {                                             // 2
    var query, update;                                                                                                 // 118
    query = {                                                                                                          // 118
      rid: roomId,                                                                                                     // 119
      'u._id': userId                                                                                                  // 119
    };                                                                                                                 //
    update = {                                                                                                         // 118
      $set: {                                                                                                          // 123
        open: true,                                                                                                    // 124
        alert: false,                                                                                                  // 124
        unread: 0,                                                                                                     // 124
        ls: new Date                                                                                                   // 124
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 129
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setFavoriteByRoomIdAndUserId = function(roomId, userId, favorite) {                                 // 2
    var query, update;                                                                                                 // 132
    if (favorite == null) {                                                                                            //
      favorite = true;                                                                                                 //
    }                                                                                                                  //
    query = {                                                                                                          // 132
      rid: roomId,                                                                                                     // 133
      'u._id': userId                                                                                                  // 133
    };                                                                                                                 //
    update = {                                                                                                         // 132
      $set: {                                                                                                          // 137
        f: favorite                                                                                                    // 138
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 140
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateNameByRoomId = function(roomId, name) {                                                       // 2
    var query, update;                                                                                                 // 143
    query = {                                                                                                          // 143
      rid: roomId                                                                                                      // 144
    };                                                                                                                 //
    update = {                                                                                                         // 143
      $set: {                                                                                                          // 147
        name: name,                                                                                                    // 148
        alert: true                                                                                                    // 148
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 151
      multi: true                                                                                                      // 151
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUserUsernameByUserId = function(userId, username) {                                              // 2
    var query, update;                                                                                                 // 154
    query = {                                                                                                          // 154
      "u._id": userId                                                                                                  // 155
    };                                                                                                                 //
    update = {                                                                                                         // 154
      $set: {                                                                                                          // 158
        "u.username": username                                                                                         // 159
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 161
      multi: true                                                                                                      // 161
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setNameForDirectRoomsWithOldName = function(oldName, name) {                                        // 2
    var query, update;                                                                                                 // 164
    query = {                                                                                                          // 164
      name: oldName,                                                                                                   // 165
      t: "d"                                                                                                           // 165
    };                                                                                                                 //
    update = {                                                                                                         // 164
      $set: {                                                                                                          // 169
        name: name                                                                                                     // 170
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 172
      multi: true                                                                                                      // 172
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.incUnreadOfDirectForRoomIdExcludingUserId = function(roomId, userId, inc) {                         // 2
    var query, update;                                                                                                 // 175
    if (inc == null) {                                                                                                 //
      inc = 1;                                                                                                         //
    }                                                                                                                  //
    query = {                                                                                                          // 175
      rid: roomId,                                                                                                     // 176
      t: 'd',                                                                                                          // 176
      'u._id': {                                                                                                       // 176
        $ne: userId                                                                                                    // 179
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 175
      $set: {                                                                                                          // 182
        alert: true,                                                                                                   // 183
        open: true                                                                                                     // 183
      },                                                                                                               //
      $inc: {                                                                                                          // 182
        unread: inc                                                                                                    // 186
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 188
      multi: true                                                                                                      // 188
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.incUnreadForRoomIdExcludingUserId = function(roomId, userId, inc) {                                 // 2
    var query, update;                                                                                                 // 191
    if (inc == null) {                                                                                                 //
      inc = 1;                                                                                                         //
    }                                                                                                                  //
    query = {                                                                                                          // 191
      rid: roomId,                                                                                                     // 192
      'u._id': {                                                                                                       // 192
        $ne: userId                                                                                                    // 194
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 191
      $set: {                                                                                                          // 197
        alert: true,                                                                                                   // 198
        open: true                                                                                                     // 198
      },                                                                                                               //
      $inc: {                                                                                                          // 197
        unread: inc                                                                                                    // 201
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 203
      multi: true                                                                                                      // 203
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.incUnreadForRoomIdAndUserIds = function(roomId, userIds, inc) {                                     // 2
    var query, update;                                                                                                 // 206
    if (inc == null) {                                                                                                 //
      inc = 1;                                                                                                         //
    }                                                                                                                  //
    query = {                                                                                                          // 206
      rid: roomId,                                                                                                     // 207
      'u._id': {                                                                                                       // 207
        $in: userIds                                                                                                   // 209
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 206
      $set: {                                                                                                          // 212
        alert: true,                                                                                                   // 213
        open: true                                                                                                     // 213
      },                                                                                                               //
      $inc: {                                                                                                          // 212
        unread: inc                                                                                                    // 216
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 218
      multi: true                                                                                                      // 218
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setAlertForRoomIdExcludingUserId = function(roomId, userId, alert) {                                // 2
    var query, update;                                                                                                 // 221
    if (alert == null) {                                                                                               //
      alert = true;                                                                                                    //
    }                                                                                                                  //
    query = {                                                                                                          // 221
      rid: roomId,                                                                                                     // 222
      alert: {                                                                                                         // 222
        $ne: alert                                                                                                     // 224
      },                                                                                                               //
      'u._id': {                                                                                                       // 222
        $ne: userId                                                                                                    // 226
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 221
      $set: {                                                                                                          // 229
        alert: alert,                                                                                                  // 230
        open: true                                                                                                     // 230
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 233
      multi: true                                                                                                      // 233
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateTypeByRoomId = function(roomId, type) {                                                       // 2
    var query, update;                                                                                                 // 236
    query = {                                                                                                          // 236
      rid: roomId                                                                                                      // 237
    };                                                                                                                 //
    update = {                                                                                                         // 236
      $set: {                                                                                                          // 240
        t: type                                                                                                        // 241
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update, {                                                                                // 243
      multi: true                                                                                                      // 243
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.addRoleById = function(_id, role) {                                                                 // 2
    var query, update;                                                                                                 // 246
    query = {                                                                                                          // 246
      _id: _id                                                                                                         // 247
    };                                                                                                                 //
    update = {                                                                                                         // 246
      $addToSet: {                                                                                                     // 250
        roles: role                                                                                                    // 251
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 253
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeRoleById = function(_id, role) {                                                              // 2
    var query, update;                                                                                                 // 256
    query = {                                                                                                          // 256
      _id: _id                                                                                                         // 257
    };                                                                                                                 //
    update = {                                                                                                         // 256
      $pull: {                                                                                                         // 260
        roles: role                                                                                                    // 261
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 263
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.createWithRoomAndUser = function(room, user, extraData) {                                           // 2
    var subscription;                                                                                                  // 267
    subscription = {                                                                                                   // 267
      open: false,                                                                                                     // 268
      alert: false,                                                                                                    // 268
      unread: 0,                                                                                                       // 268
      ts: room.ts,                                                                                                     // 268
      rid: room._id,                                                                                                   // 268
      name: room.name,                                                                                                 // 268
      t: room.t,                                                                                                       // 268
      u: {                                                                                                             // 268
        _id: user._id,                                                                                                 // 276
        username: user.username                                                                                        // 276
      }                                                                                                                //
    };                                                                                                                 //
    _.extend(subscription, extraData);                                                                                 // 267
    return this.insert(subscription);                                                                                  // 281
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByUserId = function(userId) {                                                                 // 2
    var query;                                                                                                         // 286
    query = {                                                                                                          // 286
      "u._id": userId                                                                                                  // 287
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 289
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByRoomId = function(roomId) {                                                                 // 2
    var query;                                                                                                         // 292
    query = {                                                                                                          // 292
      rid: roomId                                                                                                      // 293
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 295
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeByRoomIdAndUserId = function(roomId, userId) {                                                // 2
    var query;                                                                                                         // 298
    query = {                                                                                                          // 298
      rid: roomId,                                                                                                     // 299
      "u._id": userId                                                                                                  // 299
    };                                                                                                                 //
    return this.remove(query);                                                                                         // 302
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Uploads.coffee.js                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Uploads = new ((function(superClass) {                                                               // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this._initModel('uploads');                                                                                        // 3
    this.tryEnsureIndex({                                                                                              // 3
      'rid': 1                                                                                                         // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'uploadedAt': 1                                                                                                  // 6
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneById = function(fileId) {                                                                    // 2
    return this.findOne({                                                                                              //
      _id: fileId                                                                                                      // 9
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findNotHiddenFilesOfRoom = function(roomId, limit) {                                                // 2
    var fileOptions, fileQuery;                                                                                        // 12
    fileQuery = {                                                                                                      // 12
      rid: roomId,                                                                                                     // 13
      complete: true,                                                                                                  // 13
      uploading: false,                                                                                                // 13
      _hidden: {                                                                                                       // 13
        $ne: true                                                                                                      // 17
      }                                                                                                                //
    };                                                                                                                 //
    fileOptions = {                                                                                                    // 12
      limit: limit,                                                                                                    // 20
      sort: {                                                                                                          // 20
        uploadedAt: -1                                                                                                 // 22
      },                                                                                                               //
      fields: {                                                                                                        // 20
        _id: 1,                                                                                                        // 24
        userId: 1,                                                                                                     // 24
        rid: 1,                                                                                                        // 24
        name: 1,                                                                                                       // 24
        type: 1,                                                                                                       // 24
        url: 1,                                                                                                        // 24
        uploadedAt: 1                                                                                                  // 24
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(fileQuery, fileOptions);                                                                          // 32
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.insertFileInit = function(roomId, userId, store, file, extra) {                                     // 2
    var fileData, ref;                                                                                                 // 35
    fileData = {                                                                                                       // 35
      rid: roomId,                                                                                                     // 36
      userId: userId,                                                                                                  // 36
      store: store,                                                                                                    // 36
      complete: false,                                                                                                 // 36
      uploading: true,                                                                                                 // 36
      progress: 0,                                                                                                     // 36
      extension: s.strRightBack(file.name, '.'),                                                                       // 36
      uploadedAt: new Date()                                                                                           // 36
    };                                                                                                                 //
    _.extend(fileData, file, extra);                                                                                   // 35
    if (((ref = this.model.direct) != null ? ref.insert : void 0) != null) {                                           // 47
      file = this.model.direct.insert(fileData);                                                                       // 48
    } else {                                                                                                           //
      file = this.insert(fileData);                                                                                    // 50
    }                                                                                                                  //
    return file;                                                                                                       // 52
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateFileComplete = function(fileId, userId, file) {                                               // 2
    var filter, ref, result, update;                                                                                   // 55
    if (!fileId) {                                                                                                     // 55
      return;                                                                                                          // 56
    }                                                                                                                  //
    filter = {                                                                                                         // 55
      _id: fileId,                                                                                                     // 59
      userId: userId                                                                                                   // 59
    };                                                                                                                 //
    update = {                                                                                                         // 55
      $set: {                                                                                                          // 63
        complete: true,                                                                                                // 64
        uploading: false,                                                                                              // 64
        progress: 1                                                                                                    // 64
      }                                                                                                                //
    };                                                                                                                 //
    update.$set = _.extend(file, update.$set);                                                                         // 55
    if (((ref = this.model.direct) != null ? ref.insert : void 0) != null) {                                           // 70
      result = this.model.direct.update(filter, update);                                                               // 71
    } else {                                                                                                           //
      result = this.update(filter, update);                                                                            // 73
    }                                                                                                                  //
    return result;                                                                                                     // 75
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/models/Users.coffee.js                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;                                                                                         //
                                                                                                                       //
RocketChat.models.Users = new ((function(superClass) {                                                                 // 1
  extend(_Class, superClass);                                                                                          // 2
                                                                                                                       //
  function _Class() {                                                                                                  // 2
    this.model = Meteor.users;                                                                                         // 3
    this.tryEnsureIndex({                                                                                              // 3
      'roles': 1                                                                                                       // 5
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 5
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'name': 1                                                                                                        // 6
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'lastLogin': 1                                                                                                   // 7
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'status': 1                                                                                                      // 8
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'active': 1                                                                                                      // 9
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 9
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'statusConnection': 1                                                                                            // 10
    }, {                                                                                                               //
      sparse: 1                                                                                                        // 10
    });                                                                                                                //
    this.tryEnsureIndex({                                                                                              // 3
      'type': 1                                                                                                        // 11
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.findOneById = function(_id, options) {                                                              // 2
    return this.findOne(_id, options);                                                                                 // 16
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByUsername = function(username, options) {                                                   // 2
    var query;                                                                                                         // 19
    query = {                                                                                                          // 19
      username: username                                                                                               // 20
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 22
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByEmailAddress = function(emailAddress, options) {                                           // 2
    var query;                                                                                                         // 25
    query = {                                                                                                          // 25
      'emails.address': emailAddress                                                                                   // 26
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 28
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneVerifiedFromSameDomain = function(email, options) {                                          // 2
    var domain, query;                                                                                                 // 31
    domain = s.strRight(email, '@');                                                                                   // 31
    query = {                                                                                                          // 31
      emails: {                                                                                                        // 33
        $elemMatch: {                                                                                                  // 34
          address: {                                                                                                   // 35
            $regex: new RegExp("@" + domain + "$", "i"),                                                               // 36
            $ne: email                                                                                                 // 36
          },                                                                                                           //
          verified: true                                                                                               // 35
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 40
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneAdmin = function(admin, options) {                                                           // 2
    var query;                                                                                                         // 43
    query = {                                                                                                          // 43
      admin: admin                                                                                                     // 44
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 46
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findOneByIdAndLoginToken = function(_id, token, options) {                                          // 2
    var query;                                                                                                         // 49
    query = {                                                                                                          // 49
      _id: _id,                                                                                                        // 50
      'services.resume.loginTokens.hashedToken': Accounts._hashLoginToken(token)                                       // 50
    };                                                                                                                 //
    return this.findOne(query, options);                                                                               // 53
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findUsersNotOffline = function(options) {                                                           // 2
    var query;                                                                                                         // 58
    query = {                                                                                                          // 58
      username: {                                                                                                      // 59
        $exists: 1                                                                                                     // 60
      },                                                                                                               //
      status: {                                                                                                        // 59
        $in: ['online', 'away', 'busy']                                                                                // 62
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 64
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByUsername = function(username, options) {                                                      // 2
    var query;                                                                                                         // 68
    query = {                                                                                                          // 68
      username: username                                                                                               // 69
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 71
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findUsersByUsernamesWithHighlights = function(usernames, options) {                                 // 2
    var query;                                                                                                         // 74
    query = {                                                                                                          // 74
      username: {                                                                                                      // 75
        $in: usernames                                                                                                 // 75
      },                                                                                                               //
      'settings.preferences.highlights': {                                                                             // 75
        $exists: true                                                                                                  // 77
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 79
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findActiveByUsernameRegexWithExceptions = function(username, exceptions, options) {                 // 2
    var query, usernameRegex;                                                                                          // 82
    if (exceptions == null) {                                                                                          //
      exceptions = [];                                                                                                 //
    }                                                                                                                  //
    if (options == null) {                                                                                             //
      options = {};                                                                                                    //
    }                                                                                                                  //
    if (!_.isArray(exceptions)) {                                                                                      // 82
      exceptions = [exceptions];                                                                                       // 83
    }                                                                                                                  //
    usernameRegex = new RegExp(username, "i");                                                                         // 82
    query = {                                                                                                          // 82
      $and: [                                                                                                          // 87
        {                                                                                                              //
          active: true                                                                                                 // 88
        }, {                                                                                                           //
          username: {                                                                                                  // 89
            $nin: exceptions                                                                                           // 89
          }                                                                                                            //
        }, {                                                                                                           //
          username: usernameRegex                                                                                      // 90
        }                                                                                                              //
      ],                                                                                                               //
      type: {                                                                                                          // 87
        $in: ['user', 'bot']                                                                                           // 93
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 95
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByActiveUsersUsernameExcept = function(username, except, options) {                             // 2
    var query;                                                                                                         // 98
    query = {                                                                                                          // 98
      active: true,                                                                                                    // 99
      $and: [                                                                                                          // 99
        {                                                                                                              //
          username: {                                                                                                  // 101
            $nin: except                                                                                               // 101
          }                                                                                                            //
        }, {                                                                                                           //
          username: username                                                                                           // 102
        }                                                                                                              //
      ]                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 105
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findUsersByNameOrUsername = function(nameOrUsername, options) {                                     // 2
    var query;                                                                                                         // 108
    query = {                                                                                                          // 108
      username: {                                                                                                      // 109
        $exists: 1                                                                                                     // 110
      },                                                                                                               //
      $or: [                                                                                                           // 109
        {                                                                                                              //
          name: nameOrUsername                                                                                         // 113
        }, {                                                                                                           //
          username: nameOrUsername                                                                                     // 114
        }                                                                                                              //
      ],                                                                                                               //
      type: {                                                                                                          // 109
        $in: ['user']                                                                                                  // 118
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 120
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findByUsernameNameOrEmailAddress = function(usernameNameOrEmailAddress, options) {                  // 2
    var query;                                                                                                         // 123
    query = {                                                                                                          // 123
      $or: [                                                                                                           // 124
        {                                                                                                              //
          name: usernameNameOrEmailAddress                                                                             // 125
        }, {                                                                                                           //
          username: usernameNameOrEmailAddress                                                                         // 126
        }, {                                                                                                           //
          'emails.address': usernameNameOrEmailAddress                                                                 // 127
        }                                                                                                              //
      ],                                                                                                               //
      type: {                                                                                                          // 124
        $in: ['user', 'bot']                                                                                           // 130
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 132
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findLDAPUsers = function(options) {                                                                 // 2
    var query;                                                                                                         // 135
    query = {                                                                                                          // 135
      ldap: true                                                                                                       // 136
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 138
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.getLastLogin = function(options) {                                                                  // 2
    var query, ref, ref1, ref2;                                                                                        // 141
    if (options == null) {                                                                                             //
      options = {};                                                                                                    //
    }                                                                                                                  //
    query = {                                                                                                          // 141
      lastLogin: {                                                                                                     // 141
        $exists: 1                                                                                                     // 141
      }                                                                                                                //
    };                                                                                                                 //
    options.sort = {                                                                                                   // 141
      lastLogin: -1                                                                                                    // 142
    };                                                                                                                 //
    options.limit = 1;                                                                                                 // 141
    return (ref = this.find(query, options)) != null ? typeof ref.fetch === "function" ? (ref1 = ref.fetch()) != null ? (ref2 = ref1[0]) != null ? ref2.lastLogin : void 0 : void 0 : void 0 : void 0;
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.findUsersByUsernames = function(usernames, options) {                                               // 2
    var query;                                                                                                         // 148
    query = {                                                                                                          // 148
      username: {                                                                                                      // 149
        $in: usernames                                                                                                 // 150
      }                                                                                                                //
    };                                                                                                                 //
    return this.find(query, options);                                                                                  // 152
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.updateLastLoginById = function(_id) {                                                               // 2
    var update;                                                                                                        // 156
    update = {                                                                                                         // 156
      $set: {                                                                                                          // 157
        lastLogin: new Date                                                                                            // 158
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 160
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setServiceId = function(_id, serviceName, serviceId) {                                              // 2
    var serviceIdKey, update;                                                                                          // 163
    update = {                                                                                                         // 163
      $set: {}                                                                                                         // 164
    };                                                                                                                 //
    serviceIdKey = "services." + serviceName + ".id";                                                                  // 163
    update.$set[serviceIdKey] = serviceId;                                                                             // 163
    return this.update(_id, update);                                                                                   // 169
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUsername = function(_id, username) {                                                             // 2
    var update;                                                                                                        // 172
    update = {                                                                                                         // 172
      $set: {                                                                                                          // 173
        username: username                                                                                             // 173
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 175
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setEmail = function(_id, email) {                                                                   // 2
    var update;                                                                                                        // 178
    update = {                                                                                                         // 178
      $set: {                                                                                                          // 179
        'emails.0.address': email,                                                                                     // 180
        'emails.0.verified': false                                                                                     // 180
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 183
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setEmailVerified = function(_id, email) {                                                           // 2
    var query, update;                                                                                                 // 186
    query = {                                                                                                          // 186
      _id: _id,                                                                                                        // 187
      emails: {                                                                                                        // 187
        $elemMatch: {                                                                                                  // 189
          address: email,                                                                                              // 190
          verified: false                                                                                              // 190
        }                                                                                                              //
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 186
      $set: {                                                                                                          // 194
        'emails.$.verified': true                                                                                      // 195
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 197
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setName = function(_id, name) {                                                                     // 2
    var update;                                                                                                        // 200
    update = {                                                                                                         // 200
      $set: {                                                                                                          // 201
        name: name                                                                                                     // 202
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 204
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setAvatarOrigin = function(_id, origin) {                                                           // 2
    var update;                                                                                                        // 207
    update = {                                                                                                         // 207
      $set: {                                                                                                          // 208
        avatarOrigin: origin                                                                                           // 209
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 211
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unsetAvatarOrigin = function(_id) {                                                                 // 2
    var update;                                                                                                        // 214
    update = {                                                                                                         // 214
      $unset: {                                                                                                        // 215
        avatarOrigin: 1                                                                                                // 216
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 218
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUserActive = function(_id, active) {                                                             // 2
    var update;                                                                                                        // 221
    if (active == null) {                                                                                              //
      active = true;                                                                                                   //
    }                                                                                                                  //
    update = {                                                                                                         // 221
      $set: {                                                                                                          // 222
        active: active                                                                                                 // 223
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 225
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setAllUsersActive = function(active) {                                                              // 2
    var update;                                                                                                        // 228
    update = {                                                                                                         // 228
      $set: {                                                                                                          // 229
        active: active                                                                                                 // 230
      }                                                                                                                //
    };                                                                                                                 //
    return this.update({}, update, {                                                                                   // 232
      multi: true                                                                                                      // 232
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unsetLoginTokens = function(_id) {                                                                  // 2
    var update;                                                                                                        // 235
    update = {                                                                                                         // 235
      $set: {                                                                                                          // 236
        "services.resume.loginTokens": []                                                                              // 237
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 239
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.unsetRequirePasswordChange = function(_id) {                                                        // 2
    var update;                                                                                                        // 242
    update = {                                                                                                         // 242
      $unset: {                                                                                                        // 243
        "requirePasswordChange": true,                                                                                 // 244
        "requirePasswordChangeReason": true                                                                            // 244
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 247
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.resetPasswordAndSetRequirePasswordChange = function(_id, requirePasswordChange, requirePasswordChangeReason) {
    var update;                                                                                                        // 250
    update = {                                                                                                         // 250
      $unset: {                                                                                                        // 251
        "services.password": 1                                                                                         // 252
      },                                                                                                               //
      $set: {                                                                                                          // 251
        "requirePasswordChange": requirePasswordChange,                                                                // 254
        "requirePasswordChangeReason": requirePasswordChangeReason                                                     // 254
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 257
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setLanguage = function(_id, language) {                                                             // 2
    var update;                                                                                                        // 260
    update = {                                                                                                         // 260
      $set: {                                                                                                          // 261
        language: language                                                                                             // 262
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 264
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setProfile = function(_id, profile) {                                                               // 2
    var update;                                                                                                        // 267
    update = {                                                                                                         // 267
      $set: {                                                                                                          // 268
        "settings.profile": profile                                                                                    // 269
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 271
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setPreferences = function(_id, preferences) {                                                       // 2
    var update;                                                                                                        // 274
    update = {                                                                                                         // 274
      $set: {                                                                                                          // 275
        "settings.preferences": preferences                                                                            // 276
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(_id, update);                                                                                   // 278
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.setUtcOffset = function(_id, utcOffset) {                                                           // 2
    var query, update;                                                                                                 // 281
    query = {                                                                                                          // 281
      _id: _id,                                                                                                        // 282
      utcOffset: {                                                                                                     // 282
        $ne: utcOffset                                                                                                 // 284
      }                                                                                                                //
    };                                                                                                                 //
    update = {                                                                                                         // 281
      $set: {                                                                                                          // 287
        utcOffset: utcOffset                                                                                           // 288
      }                                                                                                                //
    };                                                                                                                 //
    return this.update(query, update);                                                                                 // 290
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.create = function(data) {                                                                           // 2
    var user;                                                                                                          // 295
    user = {                                                                                                           // 295
      createdAt: new Date,                                                                                             // 296
      avatarOrigin: 'none'                                                                                             // 296
    };                                                                                                                 //
    _.extend(user, data);                                                                                              // 295
    return this.insert(user);                                                                                          // 301
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.removeById = function(_id) {                                                                        // 2
    return this.remove(_id);                                                                                           // 306
  };                                                                                                                   //
                                                                                                                       //
                                                                                                                       // 308
  /*                                                                                                                   // 308
  	Find users to send a message by email if:                                                                           //
  	- he is not online                                                                                                  //
  	- has a verified email                                                                                              //
  	- has not disabled email notifications                                                                              //
   */                                                                                                                  //
                                                                                                                       //
  _Class.prototype.getUsersToSendOfflineEmail = function(usersIds) {                                                   // 2
    var query;                                                                                                         // 315
    query = {                                                                                                          // 315
      _id: {                                                                                                           // 316
        $in: usersIds                                                                                                  // 317
      },                                                                                                               //
      status: 'offline',                                                                                               // 316
      statusConnection: {                                                                                              // 316
        $ne: 'online'                                                                                                  // 320
      },                                                                                                               //
      'emails.verified': true                                                                                          // 316
    };                                                                                                                 //
    return this.find(query, {                                                                                          // 323
      fields: {                                                                                                        // 323
        name: 1,                                                                                                       // 323
        username: 1,                                                                                                   // 323
        emails: 1,                                                                                                     // 323
        'settings.preferences.emailNotificationMode': 1                                                                // 323
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})(RocketChat.models._Base));                                                                                          //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/publications/settings.coffee.js                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.publish('settings', function(ids) {                                                                             // 1
  if (ids == null) {                                                                                                   //
    ids = [];                                                                                                          //
  }                                                                                                                    //
  return RocketChat.models.Settings.findNotHiddenPublic(ids);                                                          // 2
});                                                                                                                    // 1
                                                                                                                       //
Meteor.publish('admin-settings', function() {                                                                          // 1
  if (!this.userId) {                                                                                                  // 5
    return this.ready();                                                                                               // 6
  }                                                                                                                    //
  if (RocketChat.authz.hasPermission(this.userId, 'view-privileged-setting')) {                                        // 8
    return RocketChat.models.Settings.findNotHidden();                                                                 // 9
  } else {                                                                                                             //
    return this.ready();                                                                                               // 11
  }                                                                                                                    //
});                                                                                                                    // 4
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/checkUsernameAvailability.coffee.js                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.checkUsernameAvailability = function(username) {                                                            // 1
  return !Meteor.users.findOne({                                                                                       // 2
    username: {                                                                                                        // 2
      $regex: new RegExp("^" + s.trim(s.escapeRegExp(username)) + "$", "i")                                            // 2
    }                                                                                                                  //
  });                                                                                                                  //
};                                                                                                                     // 1
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/checkEmailAvailability.js                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.checkEmailAvailability = function (email) {                                                                 // 1
	return !Meteor.users.findOne({ 'emails.address': { $regex: new RegExp('^' + s.trim(s.escapeRegExp(email)) + '$', 'i') } });
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/deleteUser.js                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
/* globals RocketChat */                                                                                               //
RocketChat.deleteUser = function (userId) {                                                                            // 2
	var user = RocketChat.models.Users.findOneById(userId);                                                               // 3
                                                                                                                       //
	RocketChat.models.Messages.removeByUserId(userId); // Remove user messages                                            // 5
	RocketChat.models.Subscriptions.findByUserId(userId).forEach(function (subscription) {                                // 6
		var room = RocketChat.models.Rooms.findOneById(subscription.rid);                                                    // 7
		if (room) {                                                                                                          // 8
			if (room.t !== 'c' && room.usernames.length === 1) {                                                                // 9
				RocketChat.models.Rooms.removeById(subscription.rid); // Remove non-channel rooms with only 1 user (the one being deleted)
			}                                                                                                                   //
			if (room.t === 'd') {                                                                                               // 12
				RocketChat.models.Subscriptions.removeByRoomId(subscription.rid);                                                  // 13
				RocketChat.models.Messages.removeByRoomId(subscription.rid);                                                       // 14
			}                                                                                                                   //
		}                                                                                                                    //
	});                                                                                                                   //
                                                                                                                       //
	RocketChat.models.Subscriptions.removeByUserId(userId); // Remove user subscriptions                                  // 19
	RocketChat.models.Rooms.removeByTypeContainingUsername('d', user.username); // Remove direct rooms with the user      // 20
	RocketChat.models.Rooms.removeUsernameFromAll(user.username); // Remove user from all other rooms                     // 21
                                                                                                                       //
	// removes user's avatar                                                                                              //
	if (user.avatarOrigin === 'upload' || user.avatarOrigin === 'url') {                                                  // 24
		RocketChatFileAvatarInstance.deleteFile(encodeURIComponent(user.username + '.jpg'));                                 // 25
	}                                                                                                                     //
                                                                                                                       //
	RocketChat.models.Users.removeById(userId); // Remove user from users database                                        // 28
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/sendMessage.coffee.js                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.sendMessage = function(user, message, room, options) {                                                      // 1
  var urls;                                                                                                            // 2
  if (!user || !message || !room._id) {                                                                                // 2
    return false;                                                                                                      // 3
  }                                                                                                                    //
  if (message.ts == null) {                                                                                            // 5
    message.ts = new Date();                                                                                           // 6
  }                                                                                                                    //
  message.u = _.pick(user, ['_id', 'username']);                                                                       // 2
  message.rid = room._id;                                                                                              // 2
  if (room.usernames == null) {                                                                                        // 12
    room = RocketChat.models.Rooms.findOneById(room._id);                                                              // 13
  }                                                                                                                    //
  if (message.parseUrls !== false) {                                                                                   // 15
    if (urls = message.msg.match(/([A-Za-z]{3,9}):\/\/([-;:&=\+\$,\w]+@{1})?([-A-Za-z0-9\.]+)+:?(\d+)?((\/[-\+=!:~%\/\.@\,\w]*)?\??([-\+=&!:;%@\/\.\,\w]+)?(?:#([^\s\)]+))?)?/g)) {
      message.urls = urls.map(function(url) {                                                                          // 17
        return {                                                                                                       //
          url: url                                                                                                     // 17
        };                                                                                                             //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
  message = RocketChat.callbacks.run('beforeSaveMessage', message);                                                    // 2
  if ((message._id != null) && (options != null ? options.upsert : void 0) === true) {                                 // 21
    RocketChat.models.Messages.upsert({                                                                                // 22
      _id: message._id                                                                                                 // 22
    }, message);                                                                                                       //
  } else {                                                                                                             //
    message._id = RocketChat.models.Messages.insert(message);                                                          // 24
  }                                                                                                                    //
                                                                                                                       // 26
  /*                                                                                                                   // 26
  	Defer other updates as their return is not interesting to the user                                                  //
   */                                                                                                                  //
  Meteor.defer(function() {                                                                                            // 2
    return RocketChat.callbacks.run('afterSaveMessage', message, room);                                                //
  });                                                                                                                  //
  return message;                                                                                                      // 33
};                                                                                                                     // 1
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/settings.coffee.js                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var blockedSettings, hiddenSettings, ref, ref1;                                                                        // 1
                                                                                                                       //
blockedSettings = {};                                                                                                  // 1
                                                                                                                       //
if ((ref = process.env.SETTINGS_BLOCKED) != null) {                                                                    //
  ref.split(',').forEach(function(settingId) {                                                                         //
    return blockedSettings[settingId] = 1;                                                                             //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
hiddenSettings = {};                                                                                                   // 1
                                                                                                                       //
if ((ref1 = process.env.SETTINGS_HIDDEN) != null) {                                                                    //
  ref1.split(',').forEach(function(settingId) {                                                                        //
    return hiddenSettings[settingId] = 1;                                                                              //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
RocketChat.settings._sorter = 0;                                                                                       // 1
                                                                                                                       //
                                                                                                                       // 11
/*                                                                                                                     // 11
 * Add a setting                                                                                                       //
 * @param {String} _id                                                                                                 //
 * @param {Mixed} value                                                                                                //
 * @param {Object} setting                                                                                             //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.add = function(_id, value, options) {                                                              // 1
  var ref2, ref3, ref4, updateOperations;                                                                              // 20
  if (options == null) {                                                                                               //
    options = {};                                                                                                      //
  }                                                                                                                    //
  if (!_id || (value == null)) {                                                                                       // 20
    return false;                                                                                                      // 21
  }                                                                                                                    //
  options.packageValue = value;                                                                                        // 20
  options.valueSource = 'packageValue';                                                                                // 20
  options.ts = new Date;                                                                                               // 20
  options.hidden = false;                                                                                              // 20
  options.blocked = options.blocked || false;                                                                          // 20
  if (options.sorter == null) {                                                                                        //
    options.sorter = RocketChat.settings._sorter++;                                                                    //
  }                                                                                                                    //
  if (options.enableQuery != null) {                                                                                   // 30
    options.enableQuery = JSON.stringify(options.enableQuery);                                                         // 31
  }                                                                                                                    //
  if ((typeof process !== "undefined" && process !== null ? (ref2 = process.env) != null ? ref2[_id] : void 0 : void 0) != null) {
    value = process.env[_id];                                                                                          // 34
    if (value.toLowerCase() === "true") {                                                                              // 35
      value = true;                                                                                                    // 36
    } else if (value.toLowerCase() === "false") {                                                                      //
      value = false;                                                                                                   // 38
    }                                                                                                                  //
    options.processEnvValue = value;                                                                                   // 34
    options.valueSource = 'processEnvValue';                                                                           // 34
  } else if (((ref3 = Meteor.settings) != null ? ref3[_id] : void 0) != null) {                                        //
    value = Meteor.settings[_id];                                                                                      // 43
    options.meteorSettingsValue = value;                                                                               // 43
    options.valueSource = 'meteorSettingsValue';                                                                       // 43
  }                                                                                                                    //
  if (options.i18nLabel == null) {                                                                                     // 47
    options.i18nLabel = _id;                                                                                           // 48
  }                                                                                                                    //
  if (options.i18nDescription == null) {                                                                               // 51
    options.i18nDescription = _id + "_Description";                                                                    // 52
  }                                                                                                                    //
  if (blockedSettings[_id] != null) {                                                                                  // 54
    options.blocked = true;                                                                                            // 55
  }                                                                                                                    //
  if (hiddenSettings[_id] != null) {                                                                                   // 57
    options.hidden = true;                                                                                             // 58
  }                                                                                                                    //
  if ((typeof process !== "undefined" && process !== null ? (ref4 = process.env) != null ? ref4['OVERWRITE_SETTING_' + _id] : void 0 : void 0) != null) {
    value = process.env['OVERWRITE_SETTING_' + _id];                                                                   // 61
    if (value.toLowerCase() === "true") {                                                                              // 62
      value = true;                                                                                                    // 63
    } else if (value.toLowerCase() === "false") {                                                                      //
      value = false;                                                                                                   // 65
    }                                                                                                                  //
    options.value = value;                                                                                             // 61
    options.processEnvValue = value;                                                                                   // 61
    options.valueSource = 'processEnvValue';                                                                           // 61
  }                                                                                                                    //
  updateOperations = {                                                                                                 // 20
    $set: options,                                                                                                     // 71
    $setOnInsert: {                                                                                                    // 71
      createdAt: new Date                                                                                              // 73
    }                                                                                                                  //
  };                                                                                                                   //
  if (options.value == null) {                                                                                         // 75
    if (options.force === true) {                                                                                      // 76
      updateOperations.$set.value = options.packageValue;                                                              // 77
    } else {                                                                                                           //
      updateOperations.$setOnInsert.value = value;                                                                     // 79
    }                                                                                                                  //
  }                                                                                                                    //
  if (options.section == null) {                                                                                       // 81
    updateOperations.$unset = {                                                                                        // 82
      section: 1                                                                                                       // 82
    };                                                                                                                 //
  }                                                                                                                    //
  return RocketChat.models.Settings.upsert({                                                                           // 84
    _id: _id                                                                                                           // 84
  }, updateOperations);                                                                                                //
};                                                                                                                     // 17
                                                                                                                       //
                                                                                                                       // 88
/*                                                                                                                     // 88
 * Add a setting group                                                                                                 //
 * @param {String} _id                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.addGroup = function(_id, options, cb) {                                                            // 1
  if (options == null) {                                                                                               //
    options = {};                                                                                                      //
  }                                                                                                                    //
  if (!_id) {                                                                                                          // 95
    return false;                                                                                                      // 96
  }                                                                                                                    //
  if (_.isFunction(options)) {                                                                                         // 98
    cb = options;                                                                                                      // 99
    options = {};                                                                                                      // 99
  }                                                                                                                    //
  if (options.i18nLabel == null) {                                                                                     // 102
    options.i18nLabel = _id;                                                                                           // 103
  }                                                                                                                    //
  if (options.i18nDescription == null) {                                                                               // 105
    options.i18nDescription = _id + "_Description";                                                                    // 106
  }                                                                                                                    //
  options.ts = new Date;                                                                                               // 95
  options.blocked = false;                                                                                             // 95
  options.hidden = false;                                                                                              // 95
  if (blockedSettings[_id] != null) {                                                                                  // 112
    options.blocked = true;                                                                                            // 113
  }                                                                                                                    //
  if (hiddenSettings[_id] != null) {                                                                                   // 115
    options.hidden = true;                                                                                             // 116
  }                                                                                                                    //
  RocketChat.models.Settings.upsert({                                                                                  // 95
    _id: _id                                                                                                           // 118
  }, {                                                                                                                 //
    $set: options,                                                                                                     // 119
    $setOnInsert: {                                                                                                    // 119
      type: 'group',                                                                                                   // 121
      createdAt: new Date                                                                                              // 121
    }                                                                                                                  //
  });                                                                                                                  //
  if (cb != null) {                                                                                                    // 124
    cb.call({                                                                                                          // 125
      add: function(id, value, options) {                                                                              // 126
        if (options == null) {                                                                                         //
          options = {};                                                                                                //
        }                                                                                                              //
        options.group = _id;                                                                                           // 127
        return RocketChat.settings.add(id, value, options);                                                            //
      },                                                                                                               //
      section: function(section, cb) {                                                                                 // 126
        return cb.call({                                                                                               //
          add: function(id, value, options) {                                                                          // 132
            if (options == null) {                                                                                     //
              options = {};                                                                                            //
            }                                                                                                          //
            options.group = _id;                                                                                       // 133
            options.section = section;                                                                                 // 133
            return RocketChat.settings.add(id, value, options);                                                        //
          }                                                                                                            //
        });                                                                                                            //
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
};                                                                                                                     // 92
                                                                                                                       //
                                                                                                                       // 140
/*                                                                                                                     // 140
 * Remove a setting by id                                                                                              //
 * @param {String} _id                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.removeById = function(_id) {                                                                       // 1
  if (!_id) {                                                                                                          // 147
    return false;                                                                                                      // 148
  }                                                                                                                    //
  return RocketChat.models.Settings.removeById(_id);                                                                   // 150
};                                                                                                                     // 144
                                                                                                                       //
                                                                                                                       // 153
/*                                                                                                                     // 153
 * Update a setting by id                                                                                              //
 * @param {String} _id                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.updateById = function(_id, value) {                                                                // 1
  if (!_id || (value == null)) {                                                                                       // 160
    return false;                                                                                                      // 161
  }                                                                                                                    //
  value._updatedAt = new Date;                                                                                         // 160
  return RocketChat.models.Settings.updateValueById(_id, value);                                                       // 165
};                                                                                                                     // 157
                                                                                                                       //
                                                                                                                       // 168
/*                                                                                                                     // 168
 * Update options of a setting by id                                                                                   //
 * @param {String} _id                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.updateOptionsById = function(_id, options) {                                                       // 1
  if (!_id || (options == null)) {                                                                                     // 175
    return false;                                                                                                      // 176
  }                                                                                                                    //
  return RocketChat.models.Settings.updateOptionsById(_id, options);                                                   // 178
};                                                                                                                     // 172
                                                                                                                       //
                                                                                                                       // 181
/*                                                                                                                     // 181
 * Update a setting by id                                                                                              //
 * @param {String} _id                                                                                                 //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.clearById = function(_id) {                                                                        // 1
  if (_id == null) {                                                                                                   // 188
    return false;                                                                                                      // 189
  }                                                                                                                    //
  return RocketChat.models.Settings.updateValueById(_id, void 0);                                                      // 191
};                                                                                                                     // 185
                                                                                                                       //
                                                                                                                       // 194
/*                                                                                                                     // 194
 * Update a setting by id                                                                                              //
 */                                                                                                                    //
                                                                                                                       //
RocketChat.settings.init = function() {                                                                                // 1
  var initialLoad;                                                                                                     // 198
  initialLoad = true;                                                                                                  // 198
  RocketChat.models.Settings.find().observe({                                                                          // 198
    added: function(record) {                                                                                          // 200
      Meteor.settings[record._id] = record.value;                                                                      // 201
      if (record.env === true) {                                                                                       // 202
        process.env[record._id] = record.value;                                                                        // 203
      }                                                                                                                //
      return RocketChat.settings.load(record._id, record.value, initialLoad);                                          //
    },                                                                                                                 //
    changed: function(record) {                                                                                        // 200
      Meteor.settings[record._id] = record.value;                                                                      // 206
      if (record.env === true) {                                                                                       // 207
        process.env[record._id] = record.value;                                                                        // 208
      }                                                                                                                //
      return RocketChat.settings.load(record._id, record.value, initialLoad);                                          //
    },                                                                                                                 //
    removed: function(record) {                                                                                        // 200
      delete Meteor.settings[record._id];                                                                              // 211
      if (record.env === true) {                                                                                       // 212
        delete process.env[record._id];                                                                                // 213
      }                                                                                                                //
      return RocketChat.settings.load(record._id, void 0, initialLoad);                                                //
    }                                                                                                                  //
  });                                                                                                                  //
  return initialLoad = false;                                                                                          //
};                                                                                                                     // 197
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/setUsername.coffee.js                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat._setUsername = function(userId, username) {                                                                 // 1
  var nameValidation, previousUsername, ref, rs, user, ws;                                                             // 2
  username = s.trim(username);                                                                                         // 2
  if (!userId || !username) {                                                                                          // 3
    return false;                                                                                                      // 4
  }                                                                                                                    //
  try {                                                                                                                // 6
    nameValidation = new RegExp('^' + RocketChat.settings.get('UTF8_Names_Validation') + '$');                         // 7
  } catch (_error) {                                                                                                   //
    nameValidation = new RegExp('^[0-9a-zA-Z-_.]+$');                                                                  // 9
  }                                                                                                                    //
  if (!nameValidation.test(username)) {                                                                                // 11
    return false;                                                                                                      // 12
  }                                                                                                                    //
  user = RocketChat.models.Users.findOneById(userId);                                                                  // 2
  if (user.username === username) {                                                                                    // 17
    return user;                                                                                                       // 18
  }                                                                                                                    //
  previousUsername = user.username;                                                                                    // 2
  if (!previousUsername || !(username.toLowerCase() === previousUsername.toLowerCase())) {                             // 23
    if (!RocketChat.checkUsernameAvailability(username)) {                                                             // 24
      return false;                                                                                                    // 25
    }                                                                                                                  //
  }                                                                                                                    //
  if (!previousUsername && ((ref = user.emails) != null ? ref.length : void 0) > 0 && RocketChat.settings.get('Accounts_Enrollment_Email')) {
    Accounts.sendEnrollmentEmail(user._id);                                                                            // 31
  }                                                                                                                    //
  if (previousUsername) {                                                                                              // 34
    RocketChat.models.Messages.updateAllUsernamesByUserId(user._id, username);                                         // 35
    RocketChat.models.Messages.updateUsernameOfEditByUserId(user._id, username);                                       // 35
    RocketChat.models.Messages.findByMention(previousUsername).forEach(function(msg) {                                 // 35
      var updatedMsg;                                                                                                  // 39
      updatedMsg = msg.msg.replace(new RegExp("@" + previousUsername, "ig"), "@" + username);                          // 39
      return RocketChat.models.Messages.updateUsernameAndMessageOfMentionByIdAndOldUsername(msg._id, previousUsername, username, updatedMsg);
    });                                                                                                                //
    RocketChat.models.Rooms.replaceUsername(previousUsername, username);                                               // 35
    RocketChat.models.Rooms.replaceMutedUsername(previousUsername, username);                                          // 35
    RocketChat.models.Rooms.replaceUsernameOfUserByUserId(user._id, username);                                         // 35
    RocketChat.models.Subscriptions.setUserUsernameByUserId(user._id, username);                                       // 35
    RocketChat.models.Subscriptions.setNameForDirectRoomsWithOldName(previousUsername, username);                      // 35
    rs = RocketChatFileAvatarInstance.getFileWithReadStream(encodeURIComponent(previousUsername + ".jpg"));            // 35
    if (rs != null) {                                                                                                  // 50
      RocketChatFileAvatarInstance.deleteFile(encodeURIComponent(username + ".jpg"));                                  // 51
      ws = RocketChatFileAvatarInstance.createWriteStream(encodeURIComponent(username + ".jpg"), rs.contentType);      // 51
      ws.on('end', Meteor.bindEnvironment(function() {                                                                 // 51
        return RocketChatFileAvatarInstance.deleteFile(encodeURIComponent(previousUsername + ".jpg"));                 //
      }));                                                                                                             //
      rs.readStream.pipe(ws);                                                                                          // 51
    }                                                                                                                  //
  }                                                                                                                    //
  RocketChat.models.Users.setUsername(user._id, username);                                                             // 2
  user.username = username;                                                                                            // 2
  return user;                                                                                                         // 60
};                                                                                                                     // 1
                                                                                                                       //
RocketChat.setUsername = RocketChat.RateLimiter.limitFunction(RocketChat._setUsername, 1, 60000, {                     // 1
  0: function() {                                                                                                      // 63
    return !Meteor.userId() || !RocketChat.authz.hasPermission(Meteor.userId(), 'edit-other-user-info');               // 63
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/setEmail.js                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat._setEmail = function (userId, email) {                                                                      // 1
	email = s.trim(email);                                                                                                // 2
	if (!userId) {                                                                                                        // 3
		throw new Meteor.Error('invalid-user', '[methods] setEmail -> Invalid user');                                        // 4
	}                                                                                                                     //
                                                                                                                       //
	if (!email) {                                                                                                         // 7
		throw new Meteor.Error('invalid-email', '[methods] setEmail -> Invalid email');                                      // 8
	}                                                                                                                     //
                                                                                                                       //
	RocketChat.validateEmailDomain(email);                                                                                // 11
                                                                                                                       //
	var user = RocketChat.models.Users.findOneById(userId);                                                               // 13
                                                                                                                       //
	// User already has desired username, return                                                                          //
	if (user.emails && user.emails[0] && user.emails[0].address === email) {                                              // 16
		return user;                                                                                                         // 17
	}                                                                                                                     //
                                                                                                                       //
	// Check e-mail availability                                                                                          //
	if (!RocketChat.checkEmailAvailability(email)) {                                                                      // 21
		throw new Meteor.Error('email-unavailable', email + ' is already in use :(');                                        // 22
	}                                                                                                                     //
                                                                                                                       //
	// Set new email                                                                                                      //
	RocketChat.models.Users.setEmail(user._id, email);                                                                    // 26
	user.email = email;                                                                                                   // 27
	return user;                                                                                                          // 28
};                                                                                                                     //
                                                                                                                       //
RocketChat.setEmail = RocketChat.RateLimiter.limitFunction(RocketChat._setEmail, 1, 60000, {                           // 31
	0: function () {                                                                                                      // 32
		return !Meteor.userId() || !RocketChat.authz.hasPermission(Meteor.userId(), 'edit-other-user-info');                 // 32
	} // Administrators have permission to change others emails, so don't limit those                                     //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/functions/Notifications.coffee.js                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var func,                                                                                                              // 1
  slice = [].slice;                                                                                                    //
                                                                                                                       //
RocketChat.Notifications = new ((function() {                                                                          // 1
  function _Class() {                                                                                                  // 2
    var self;                                                                                                          // 3
    self = this;                                                                                                       // 3
    this.debug = false;                                                                                                // 3
    this.streamAll = new Meteor.Streamer('notify-all');                                                                // 3
    this.streamRoom = new Meteor.Streamer('notify-room');                                                              // 3
    this.streamUser = new Meteor.Streamer('notify-user');                                                              // 3
    this.streamAll.allowWrite('none');                                                                                 // 3
    this.streamRoom.allowWrite('none');                                                                                // 3
    this.streamUser.allowWrite('logged');                                                                              // 3
    this.streamAll.allowRead('logged');                                                                                // 3
    this.streamRoom.allowRead(function(eventName) {                                                                    // 3
      var roomId, user;                                                                                                // 19
      if (this.userId == null) {                                                                                       // 19
        return false;                                                                                                  // 19
      }                                                                                                                //
      roomId = eventName.split('/')[0];                                                                                // 19
      user = Meteor.users.findOne(this.userId, {                                                                       // 19
        fields: {                                                                                                      // 23
          username: 1                                                                                                  // 23
        }                                                                                                              //
      });                                                                                                              //
      return RocketChat.models.Rooms.findOneByIdContainigUsername(roomId, user.username, {                             // 24
        fields: {                                                                                                      //
          _id: 1                                                                                                       //
        }                                                                                                              //
      }) != null;                                                                                                      //
    });                                                                                                                //
    this.streamUser.allowRead(function(eventName) {                                                                    // 3
      var userId;                                                                                                      // 27
      userId = eventName.split('/')[0];                                                                                // 27
      return (this.userId != null) && this.userId === userId;                                                          // 28
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  _Class.prototype.notifyAll = function() {                                                                            // 2
    var args, eventName;                                                                                               // 32
    eventName = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];                            // 32
    if (this.debug === true) {                                                                                         // 32
      console.log('notifyAll', arguments);                                                                             // 32
    }                                                                                                                  //
    args.unshift(eventName);                                                                                           // 32
    return this.streamAll.emit.apply(this.streamAll, args);                                                            //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.notifyRoom = function() {                                                                           // 2
    var args, eventName, room;                                                                                         // 38
    room = arguments[0], eventName = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];       // 38
    if (this.debug === true) {                                                                                         // 38
      console.log('notifyRoom', arguments);                                                                            // 38
    }                                                                                                                  //
    args.unshift(room + "/" + eventName);                                                                              // 38
    return this.streamRoom.emit.apply(this.streamRoom, args);                                                          //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.notifyUser = function() {                                                                           // 2
    var args, eventName, userId;                                                                                       // 44
    userId = arguments[0], eventName = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];     // 44
    if (this.debug === true) {                                                                                         // 44
      console.log('notifyUser', arguments);                                                                            // 44
    }                                                                                                                  //
    args.unshift(userId + "/" + eventName);                                                                            // 44
    return this.streamUser.emit.apply(this.streamUser, args);                                                          //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.notifyAllInThisInstance = function() {                                                              // 2
    var args, eventName;                                                                                               // 51
    eventName = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];                            // 51
    if (this.debug === true) {                                                                                         // 51
      console.log('notifyAll', arguments);                                                                             // 51
    }                                                                                                                  //
    args.unshift(eventName);                                                                                           // 51
    return this.streamAll.emitWithoutBroadcast.apply(this.streamAll, args);                                            //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.notifyRoomInThisInstance = function() {                                                             // 2
    var args, eventName, room;                                                                                         // 57
    room = arguments[0], eventName = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];       // 57
    if (this.debug === true) {                                                                                         // 57
      console.log('notifyRoomAndBroadcast', arguments);                                                                // 57
    }                                                                                                                  //
    args.unshift(room + "/" + eventName);                                                                              // 57
    return this.streamRoom.emitWithoutBroadcast.apply(this.streamRoom, args);                                          //
  };                                                                                                                   //
                                                                                                                       //
  _Class.prototype.notifyUserInThisInstance = function() {                                                             // 2
    var args, eventName, userId;                                                                                       // 63
    userId = arguments[0], eventName = arguments[1], args = 3 <= arguments.length ? slice.call(arguments, 2) : [];     // 63
    if (this.debug === true) {                                                                                         // 63
      console.log('notifyUserAndBroadcast', arguments);                                                                // 63
    }                                                                                                                  //
    args.unshift(userId + "/" + eventName);                                                                            // 63
    return this.streamUser.emitWithoutBroadcast.apply(this.streamUser, args);                                          //
  };                                                                                                                   //
                                                                                                                       //
  return _Class;                                                                                                       //
                                                                                                                       //
})());                                                                                                                 //
                                                                                                                       //
func = function(eventName, username, typing) {                                                                         // 1
  var e, ref, room, user;                                                                                              // 73
  ref = eventName.split('/'), room = ref[0], e = ref[1];                                                               // 73
  if (e === 'webrtc') {                                                                                                // 75
    return true;                                                                                                       // 76
  }                                                                                                                    //
  if (e === 'typing') {                                                                                                // 78
    user = Meteor.users.findOne(this.userId, {                                                                         // 79
      fields: {                                                                                                        // 79
        username: 1                                                                                                    // 79
      }                                                                                                                //
    });                                                                                                                //
    if ((user != null ? user.username : void 0) === username) {                                                        // 80
      return true;                                                                                                     // 81
    }                                                                                                                  //
  }                                                                                                                    //
  return false;                                                                                                        // 83
};                                                                                                                     // 72
                                                                                                                       //
RocketChat.Notifications.streamRoom.allowWrite(func);                                                                  // 1
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/addOAuthService.coffee.js                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  addOAuthService: function(name) {                                                                                    // 2
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] addOAuthService -> Invalid user");                             // 4
    }                                                                                                                  //
    if (RocketChat.authz.hasPermission(Meteor.userId(), 'add-oauth-service') !== true) {                               // 6
      throw new Meteor.Error('not-authorized', '[methods] addOAuthService -> Not authorized');                         // 7
    }                                                                                                                  //
    name = name.toLowerCase().replace(/[^a-z0-9]/g, '');                                                               // 3
    name = s.capitalize(name);                                                                                         // 3
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name, false, {                                                  // 3
      type: 'boolean',                                                                                                 // 11
      group: 'OAuth',                                                                                                  // 11
      section: "Custom OAuth: " + name,                                                                                // 11
      i18nLabel: 'Accounts_OAuth_Custom_Enable',                                                                       // 11
      persistent: true                                                                                                 // 11
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_url", '', {                                            // 3
      type: 'string',                                                                                                  // 12
      group: 'OAuth',                                                                                                  // 12
      section: "Custom OAuth: " + name,                                                                                // 12
      i18nLabel: 'Accounts_OAuth_Custom_URL',                                                                          // 12
      persistent: true                                                                                                 // 12
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_token_path", '/oauth/token', {                         // 3
      type: 'string',                                                                                                  // 13
      group: 'OAuth',                                                                                                  // 13
      section: "Custom OAuth: " + name,                                                                                // 13
      i18nLabel: 'Accounts_OAuth_Custom_Token_Path',                                                                   // 13
      persistent: true                                                                                                 // 13
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_identity_path", '/me', {                               // 3
      type: 'string',                                                                                                  // 14
      group: 'OAuth',                                                                                                  // 14
      section: "Custom OAuth: " + name,                                                                                // 14
      i18nLabel: 'Accounts_OAuth_Custom_Identity_Path',                                                                // 14
      persistent: true                                                                                                 // 14
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_authorize_path", '/oauth/authorize', {                 // 3
      type: 'string',                                                                                                  // 15
      group: 'OAuth',                                                                                                  // 15
      section: "Custom OAuth: " + name,                                                                                // 15
      i18nLabel: 'Accounts_OAuth_Custom_Authorize_Path',                                                               // 15
      persistent: true                                                                                                 // 15
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_token_sent_via", 'payload', {                          // 3
      type: 'select',                                                                                                  // 16
      group: 'OAuth',                                                                                                  // 16
      section: "Custom OAuth: " + name,                                                                                // 16
      i18nLabel: 'Accounts_OAuth_Custom_Token_Sent_Via',                                                               // 16
      persistent: true,                                                                                                // 16
      values: [                                                                                                        // 16
        {                                                                                                              //
          key: 'header',                                                                                               // 16
          i18nLabel: 'Header'                                                                                          // 16
        }, {                                                                                                           //
          key: 'payload',                                                                                              // 16
          i18nLabel: 'Payload'                                                                                         // 16
        }                                                                                                              //
      ]                                                                                                                //
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_id", '', {                                             // 3
      type: 'string',                                                                                                  // 17
      group: 'OAuth',                                                                                                  // 17
      section: "Custom OAuth: " + name,                                                                                // 17
      i18nLabel: 'Accounts_OAuth_Custom_id',                                                                           // 17
      persistent: true                                                                                                 // 17
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_secret", '', {                                         // 3
      type: 'string',                                                                                                  // 18
      group: 'OAuth',                                                                                                  // 18
      section: "Custom OAuth: " + name,                                                                                // 18
      i18nLabel: 'Accounts_OAuth_Custom_Secret',                                                                       // 18
      persistent: true                                                                                                 // 18
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_login_style", 'popup', {                               // 3
      type: 'select',                                                                                                  // 19
      group: 'OAuth',                                                                                                  // 19
      section: "Custom OAuth: " + name,                                                                                // 19
      i18nLabel: 'Accounts_OAuth_Custom_Login_Style',                                                                  // 19
      persistent: true,                                                                                                // 19
      values: [                                                                                                        // 19
        {                                                                                                              //
          key: 'redirect',                                                                                             // 19
          i18nLabel: 'Redirect'                                                                                        // 19
        }, {                                                                                                           //
          key: 'popup',                                                                                                // 19
          i18nLabel: 'Popup'                                                                                           // 19
        }, {                                                                                                           //
          key: '',                                                                                                     // 19
          i18nLabel: 'Default'                                                                                         // 19
        }                                                                                                              //
      ]                                                                                                                //
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_button_label_text", '', {                              // 3
      type: 'string',                                                                                                  // 20
      group: 'OAuth',                                                                                                  // 20
      section: "Custom OAuth: " + name,                                                                                // 20
      i18nLabel: 'Accounts_OAuth_Custom_Button_Label_Text',                                                            // 20
      persistent: true                                                                                                 // 20
    });                                                                                                                //
    RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_button_label_color", '#FFFFFF', {                      // 3
      type: 'string',                                                                                                  // 21
      group: 'OAuth',                                                                                                  // 21
      section: "Custom OAuth: " + name,                                                                                // 21
      i18nLabel: 'Accounts_OAuth_Custom_Button_Label_Color',                                                           // 21
      persistent: true                                                                                                 // 21
    });                                                                                                                //
    return RocketChat.settings.add("Accounts_OAuth_Custom_" + name + "_button_color", '#13679A', {                     //
      type: 'string',                                                                                                  // 22
      group: 'OAuth',                                                                                                  // 22
      section: "Custom OAuth: " + name,                                                                                // 22
      i18nLabel: 'Accounts_OAuth_Custom_Button_Color',                                                                 // 22
      persistent: true                                                                                                 // 22
    });                                                                                                                //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/checkRegistrationSecretURL.coffee.js                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  checkRegistrationSecretURL: function(hash) {                                                                         // 2
    return hash === RocketChat.settings.get('Accounts_RegistrationForm_SecretURL');                                    // 3
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/deleteUserOwnAccount.js                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
	deleteUserOwnAccount: function (password) {                                                                           // 2
		if (!Meteor.userId()) {                                                                                              // 3
			throw new Meteor.Error('error-invalid-user', 'Invalid user', { method: 'deleteUserOwnAccount' });                   // 4
		}                                                                                                                    //
                                                                                                                       //
		if (!RocketChat.settings.get('Accounts_AllowDeleteOwnAccount')) {                                                    // 7
			throw new Meteor.Error('error-not-allowed', 'Not allowed', { method: 'deleteUserOwnAccount' });                     // 8
		}                                                                                                                    //
                                                                                                                       //
		var userId = Meteor.userId();                                                                                        // 11
		var user = RocketChat.models.Users.findOneById(userId);                                                              // 12
                                                                                                                       //
		if (!user) {                                                                                                         // 14
			throw new Meteor.Error('error-invalid-user', 'Invalid user', { method: 'deleteUserOwnAccount' });                   // 15
		}                                                                                                                    //
                                                                                                                       //
		if (user.services && user.services.password && s.trim(user.services.password.bcrypt)) {                              // 18
			var result = Accounts._checkPassword(user, { digest: password, algorithm: 'sha-256' });                             // 19
			if (result.error) {                                                                                                 // 20
				throw new Meteor.Error('error-invalid-password', 'Invalid password', { method: 'deleteUserOwnAccount' });          // 21
			}                                                                                                                   //
		} else if (user.username !== s.trim(password)) {                                                                     //
			throw new Meteor.Error('error-invalid-username', 'Invalid username', { method: 'deleteUserOwnAccount' });           // 24
		}                                                                                                                    //
                                                                                                                       //
		Meteor.defer(function () {                                                                                           // 27
			RocketChat.deleteUser(userId);                                                                                      // 28
		});                                                                                                                  //
                                                                                                                       //
		return true;                                                                                                         // 31
	}                                                                                                                     //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/getRoomRoles.js                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
	getRoomRoles: function (rid) {                                                                                        // 2
		if (!Meteor.userId()) {                                                                                              // 3
			throw new Meteor.Error('error-invalid-user', 'Invalid user', { method: 'getRoomRoles' });                           // 4
		}                                                                                                                    //
                                                                                                                       //
		check(rid, String);                                                                                                  // 7
                                                                                                                       //
		var options = {                                                                                                      // 9
			sort: {                                                                                                             // 10
				'u.username': 1                                                                                                    // 11
			},                                                                                                                  //
			fields: {                                                                                                           // 13
				rid: 1,                                                                                                            // 14
				u: 1,                                                                                                              // 15
				roles: 1                                                                                                           // 16
			}                                                                                                                   //
		};                                                                                                                   //
                                                                                                                       //
		var roles = RocketChat.models.Roles.find({ scope: 'Subscriptions', description: { $exists: 1, $ne: '' } }).fetch();  // 20
		return RocketChat.models.Subscriptions.findByRoomIdAndRoles(rid, _.pluck(roles, '_id'), options).fetch();            // 21
	}                                                                                                                     //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/getUserRoles.js                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
	getUserRoles: function () {                                                                                           // 2
		if (!Meteor.userId()) {                                                                                              // 3
			throw new Meteor.Error('error-invalid-user', 'Invalid user', { method: 'getUserRoles' });                           // 4
		}                                                                                                                    //
                                                                                                                       //
		var options = {                                                                                                      // 7
			sort: {                                                                                                             // 8
				'username': 1                                                                                                      // 9
			},                                                                                                                  //
			fields: {                                                                                                           // 11
				username: 1,                                                                                                       // 12
				roles: 1                                                                                                           // 13
			}                                                                                                                   //
		};                                                                                                                   //
                                                                                                                       //
		var roles = RocketChat.models.Roles.find({ scope: 'Users', description: { $exists: 1, $ne: '' } }).fetch();          // 17
		var roleIds = _.pluck(roles, '_id');                                                                                 // 18
                                                                                                                       //
		// Security issue: we should not send all user's roles to all clients, only the 'public' roles                       //
		// We must remove all roles that are not part of the query from the returned users                                   //
		var users = RocketChat.models.Users.findUsersInRoles(roleIds, null, options).fetch();                                // 22
		for (var _iterator = users, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
			var _ref;                                                                                                           //
                                                                                                                       //
			if (_isArray) {                                                                                                     //
				if (_i >= _iterator.length) break;                                                                                 //
				_ref = _iterator[_i++];                                                                                            //
			} else {                                                                                                            //
				_i = _iterator.next();                                                                                             //
				if (_i.done) break;                                                                                                //
				_ref = _i.value;                                                                                                   //
			}                                                                                                                   //
                                                                                                                       //
			var user = _ref;                                                                                                    //
                                                                                                                       //
			user.roles = _.intersection(user.roles, roleIds);                                                                   // 24
		}                                                                                                                    //
		return users;                                                                                                        // 26
	}                                                                                                                     //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/joinDefaultChannels.coffee.js                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  joinDefaultChannels: function(silenced) {                                                                            // 2
    var defaultRooms, user;                                                                                            // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] joinDefaultChannels -> Invalid user");                         // 4
    }                                                                                                                  //
    this.unblock();                                                                                                    // 3
    user = Meteor.user();                                                                                              // 3
    RocketChat.callbacks.run('beforeJoinDefaultChannels', user);                                                       // 3
    defaultRooms = RocketChat.models.Rooms.findByDefaultAndTypes(true, ['c', 'p'], {                                   // 3
      fields: {                                                                                                        // 12
        usernames: 0                                                                                                   // 12
      }                                                                                                                //
    }).fetch();                                                                                                        //
    return defaultRooms.forEach(function(room) {                                                                       //
      RocketChat.models.Rooms.addUsernameById(room._id, user.username);                                                // 17
      if (RocketChat.models.Subscriptions.findOneByRoomIdAndUserId(room._id, user._id) == null) {                      // 19
        RocketChat.models.Subscriptions.createWithRoomAndUser(room, user, {                                            // 22
          ts: new Date(),                                                                                              // 23
          open: true,                                                                                                  // 23
          alert: true,                                                                                                 // 23
          unread: 1                                                                                                    // 23
        });                                                                                                            //
        if (!silenced) {                                                                                               // 29
          return RocketChat.models.Messages.createUserJoinWithRoomIdAndUser(room._id, user);                           //
        }                                                                                                              //
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/removeOAuthService.coffee.js                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  removeOAuthService: function(name) {                                                                                 // 2
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] removeOAuthService -> Invalid user");                          // 4
    }                                                                                                                  //
    if (RocketChat.authz.hasPermission(Meteor.userId(), 'add-oauth-service') !== true) {                               // 6
      throw new Meteor.Error('not-authorized', '[methods] removeOAuthService -> Not authorized');                      // 7
    }                                                                                                                  //
    name = name.toLowerCase().replace(/[^a-z0-9]/g, '');                                                               // 3
    name = s.capitalize(name);                                                                                         // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name);                                                   // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_url");                                          // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_token_path");                                   // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_identity_path");                                // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_authorize_path");                               // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_token_sent_via");                               // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_id");                                           // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_secret");                                       // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_button_label_text");                            // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_button_label_color");                           // 3
    RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_button_color");                                 // 3
    return RocketChat.settings.removeById("Accounts_OAuth_Custom_" + name + "_login_style");                           //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/robotMethods.coffee.js                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  'robot.modelCall': function(model, method, args) {                                                                   // 2
    var call, ref;                                                                                                     // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', '[methods] robot.modelCall -> Invalid user');                             // 4
    }                                                                                                                  //
    if (!RocketChat.authz.hasRole(Meteor.userId(), 'robot')) {                                                         // 6
      throw new Meteor.Error('unauthorized', '[methods] robot.modelCall -> Unauthorized');                             // 7
    }                                                                                                                  //
    if (!_.isFunction((ref = RocketChat.models[model]) != null ? ref[method] : void 0)) {                              // 9
      throw new Meteor.Error('invalid-method', '[methods] robot.modelCall -> Invalid method');                         // 10
    }                                                                                                                  //
    call = RocketChat.models[model][method].apply(RocketChat.models[model], args);                                     // 3
    if ((call != null ? typeof call.fetch === "function" ? call.fetch() : void 0 : void 0) != null) {                  // 14
      return call.fetch();                                                                                             // 15
    } else {                                                                                                           //
      return call;                                                                                                     // 17
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/saveSetting.coffee.js                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  saveSetting: function(_id, value) {                                                                                  // 2
    var user;                                                                                                          // 3
    if (Meteor.userId() != null) {                                                                                     // 3
      user = Meteor.users.findOne(Meteor.userId());                                                                    // 4
    }                                                                                                                  //
    if (RocketChat.authz.hasPermission(Meteor.userId(), 'edit-privileged-setting') !== true) {                         // 6
      throw new Meteor.Error(503, 'Not authorized');                                                                   // 7
    }                                                                                                                  //
    RocketChat.settings.updateById(_id, value);                                                                        // 3
    return true;                                                                                                       // 11
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/sendInvitationEmail.coffee.js                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  sendInvitationEmail: function(emails) {                                                                              // 2
    var email, i, len, rfcMailPattern, validEmails;                                                                    // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] sendInvitationEmail -> Invalid user");                         // 4
    }                                                                                                                  //
    if (!RocketChat.authz.hasRole(Meteor.userId(), 'admin')) {                                                         // 6
      throw new Meteor.Error('not-authorized', '[methods] sendInvitationEmail -> Not authorized');                     // 7
    }                                                                                                                  //
    rfcMailPattern = /^[a-zA-Z0-9.!#$%&'*+\/=?^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$/;
    validEmails = _.compact(_.map(emails, function(email) {                                                            // 3
      if (rfcMailPattern.test(email)) {                                                                                // 10
        return email;                                                                                                  // 10
      }                                                                                                                //
    }));                                                                                                               //
    for (i = 0, len = validEmails.length; i < len; i++) {                                                              // 12
      email = validEmails[i];                                                                                          //
      this.unblock();                                                                                                  // 13
      Email.send({                                                                                                     // 13
        to: email,                                                                                                     // 16
        from: RocketChat.settings.get('From_Email'),                                                                   // 16
        subject: RocketChat.settings.get('Invitation_Subject'),                                                        // 16
        html: RocketChat.settings.get('Invitation_HTML')                                                               // 16
      });                                                                                                              //
    }                                                                                                                  // 12
    return validEmails;                                                                                                // 22
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/sendMessage.coffee.js                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
  sendMessage: function(message, options) {                                                                            // 2
    var ref, ref1, room, user;                                                                                         // 3
    if (((ref = message.msg) != null ? ref.length : void 0) > RocketChat.settings.get('Message_MaxAllowedSize')) {     // 3
      throw new Meteor.Error(400, '[methods] sendMessage -> Message size exceed Message_MaxAllowedSize');              // 4
    }                                                                                                                  //
    if (!Meteor.userId()) {                                                                                            // 6
      throw new Meteor.Error('invalid-user', "[methods] sendMessage -> Invalid user");                                 // 7
    }                                                                                                                  //
    user = RocketChat.models.Users.findOneById(Meteor.userId(), {                                                      // 3
      fields: {                                                                                                        // 9
        username: 1                                                                                                    // 9
      }                                                                                                                //
    });                                                                                                                //
    room = Meteor.call('canAccessRoom', message.rid, user._id);                                                        // 3
    if (!room) {                                                                                                       // 13
      return false;                                                                                                    // 14
    }                                                                                                                  //
    if (ref1 = user.username, indexOf.call(room.muted || [], ref1) >= 0) {                                             // 16
      RocketChat.Notifications.notifyUser(Meteor.userId(), 'message', {                                                // 17
        _id: Random.id(),                                                                                              // 17
        rid: room._id,                                                                                                 // 17
        ts: new Date,                                                                                                  // 17
        msg: TAPi18n.__('You_have_been_muted', {}, user.language)                                                      // 17
      });                                                                                                              //
      return false;                                                                                                    // 23
    }                                                                                                                  //
    return RocketChat.sendMessage(user, message, room, options);                                                       //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/sendSMTPTestEmail.coffee.js                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  sendSMTPTestEmail: function() {                                                                                      // 2
    var ref, ref1, user;                                                                                               // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] sendSMTPTestEmail -> Invalid user");                           // 4
    }                                                                                                                  //
    user = Meteor.user();                                                                                              // 3
    if (!((ref = user.emails) != null ? (ref1 = ref[0]) != null ? ref1.address : void 0 : void 0)) {                   // 7
      throw new Meteor.Error('invalid-email', "[methods] sendSMTPTestEmail -> Invalid e-mail");                        // 8
    }                                                                                                                  //
    this.unblock();                                                                                                    // 3
    Email.send({                                                                                                       // 3
      to: user.emails[0].address,                                                                                      // 13
      from: RocketChat.settings.get('From_Email'),                                                                     // 13
      subject: "SMTP Test E-mail",                                                                                     // 13
      html: "You have successfully sent an e-mail"                                                                     // 13
    });                                                                                                                //
    console.log('Sending email to ' + user.emails[0].address);                                                         // 3
    return {                                                                                                           // 20
      message: "Your_mail_was_sent_to_s",                                                                              // 20
      params: [user.emails[0].address]                                                                                 // 20
    };                                                                                                                 //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
DDPRateLimiter.addRule({                                                                                               // 1
  type: 'method',                                                                                                      // 27
  name: 'sendSMTPTestEmail',                                                                                           // 27
  userId: function(userId) {                                                                                           // 27
    return true;                                                                                                       // 30
  }                                                                                                                    //
}, 1, 1000);                                                                                                           //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/setAdminStatus.coffee.js                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  setAdminStatus: function(userId, admin) {                                                                            // 2
    var user;                                                                                                          // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] setAdminStatus -> Invalid user");                              // 4
    }                                                                                                                  //
    if (RocketChat.authz.hasPermission(Meteor.userId(), 'assign-admin-role') !== true) {                               // 6
      throw new Meteor.Error('not-authorized', '[methods] setAdminStatus -> Not authorized');                          // 7
    }                                                                                                                  //
    user = Meteor.users.findOne({                                                                                      // 3
      _id: userId                                                                                                      // 9
    }, {                                                                                                               //
      fields: {                                                                                                        // 9
        username: 1                                                                                                    // 9
      }                                                                                                                //
    });                                                                                                                //
    if (admin) {                                                                                                       // 11
      return Meteor.call('authorization:addUserToRole', 'admin', user.username);                                       // 12
    } else {                                                                                                           //
      return Meteor.call('authorization:removeUserFromRole', 'admin', user.username);                                  // 14
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/setRealName.coffee.js                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  setRealName: function(name) {                                                                                        // 2
    var user;                                                                                                          // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] setRealName -> Invalid user");                                 // 4
    }                                                                                                                  //
    user = Meteor.user();                                                                                              // 3
    if (user.name === name) {                                                                                          // 8
      return name;                                                                                                     // 9
    }                                                                                                                  //
    if (_.trim(name)) {                                                                                                // 11
      name = _.trim(name);                                                                                             // 12
    }                                                                                                                  //
    if (!RocketChat.models.Users.setName(Meteor.userId(), name)) {                                                     // 14
      throw new Meteor.Error('could-not-change-name', "Could not change name");                                        // 15
    }                                                                                                                  //
    return name;                                                                                                       // 17
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/setUsername.coffee.js                                                        //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  setUsername: function(username) {                                                                                    // 2
    var nameValidation, user;                                                                                          // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] setUsername -> Invalid user");                                 // 4
    }                                                                                                                  //
    user = Meteor.user();                                                                                              // 3
    if ((user.username != null) && !RocketChat.settings.get("Accounts_AllowUsernameChange")) {                         // 8
      throw new Meteor.Error(403, "[methods] setUsername -> Username change not allowed");                             // 9
    }                                                                                                                  //
    if (user.username === username) {                                                                                  // 11
      return username;                                                                                                 // 12
    }                                                                                                                  //
    try {                                                                                                              // 14
      nameValidation = new RegExp('^' + RocketChat.settings.get('UTF8_Names_Validation') + '$');                       // 15
    } catch (_error) {                                                                                                 //
      nameValidation = new RegExp('^[0-9a-zA-Z-_.]+$');                                                                // 17
    }                                                                                                                  //
    if (!nameValidation.test(username)) {                                                                              // 19
      throw new Meteor.Error('username-invalid', username + " is not a valid username, use only letters, numbers, dots, hyphens and underscores");
    }                                                                                                                  //
    if (user.username !== void 0) {                                                                                    // 22
      if (!username.toLowerCase() === user.username.toLowerCase()) {                                                   // 23
        if (!RocketChat.checkUsernameAvailability(username)) {                                                         // 24
          throw new Meteor.Error('username-unavailable', username + " is already in use :(");                          // 25
        }                                                                                                              //
      }                                                                                                                //
    } else {                                                                                                           //
      if (!RocketChat.checkUsernameAvailability(username)) {                                                           // 27
        throw new Meteor.Error('username-unavailable', username + " is already in use :(");                            // 28
      }                                                                                                                //
    }                                                                                                                  //
    if (!RocketChat.setUsername(user._id, username)) {                                                                 // 30
      throw new Meteor.Error('could-not-change-username', "Could not change username");                                // 31
    }                                                                                                                  //
    return username;                                                                                                   // 33
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
RocketChat.RateLimiter.limitMethod('setUsername', 1, 1000, {                                                           // 1
  userId: function(userId) {                                                                                           // 36
    return true;                                                                                                       // 36
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/insertOrUpdateUser.coffee.js                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  insertOrUpdateUser: function(userData) {                                                                             // 2
    var _id, canAddUser, canEditUser, canEditUserPassword, createUser, nameValidation, updateUser, user;               // 3
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] updateUser -> Invalid user");                                  // 4
    }                                                                                                                  //
    user = Meteor.user();                                                                                              // 3
    canEditUser = RocketChat.authz.hasPermission(user._id, 'edit-other-user-info');                                    // 3
    canAddUser = RocketChat.authz.hasPermission(user._id, 'create-user');                                              // 3
    if (userData._id && user._id !== userData._id && canEditUser !== true) {                                           // 11
      throw new Meteor.Error('not-authorized', '[methods] updateUser -> Not authorized');                              // 12
    }                                                                                                                  //
    if (!userData._id && canAddUser !== true) {                                                                        // 14
      throw new Meteor.Error('not-authorized', '[methods] updateUser -> Not authorized');                              // 15
    }                                                                                                                  //
    if (!s.trim(userData.name)) {                                                                                      // 17
      throw new Meteor.Error('name-is-required', 'Name field is required');                                            // 18
    }                                                                                                                  //
    if (!s.trim(userData.username)) {                                                                                  // 20
      throw new Meteor.Error('user-name-is-required', 'Username field is required');                                   // 21
    }                                                                                                                  //
    try {                                                                                                              // 23
      nameValidation = new RegExp('^' + RocketChat.settings.get('UTF8_Names_Validation') + '$');                       // 24
    } catch (_error) {                                                                                                 //
      nameValidation = new RegExp('^[0-9a-zA-Z-_.]+$');                                                                // 26
    }                                                                                                                  //
    if (!nameValidation.test(userData.username)) {                                                                     // 28
      throw new Meteor.Error('username-invalid', username + " is not a valid username");                               // 29
    }                                                                                                                  //
    if (!userData._id && !userData.password) {                                                                         // 31
      throw new Meteor.Error('password-is-required', 'Password is required when adding a user');                       // 32
    }                                                                                                                  //
    if (!userData._id) {                                                                                               // 34
      if (!RocketChat.checkUsernameAvailability(userData.username)) {                                                  // 35
        throw new Meteor.Error('username-unavailable', userData.username + " is already in use :(");                   // 36
      }                                                                                                                //
      if (userData.email && !RocketChat.checkEmailAvailability(userData.email)) {                                      // 38
        throw new Meteor.Error('email-unavailable', userData.email + " is already in use :(");                         // 39
      }                                                                                                                //
      RocketChat.validateEmailDomain(userData.email);                                                                  // 35
      createUser = {                                                                                                   // 35
        username: userData.username,                                                                                   // 44
        password: userData.password                                                                                    // 44
      };                                                                                                               //
      if (userData.email) {                                                                                            // 45
        createUser.email = userData.email;                                                                             // 46
      }                                                                                                                //
      _id = Accounts.createUser(createUser);                                                                           // 35
      updateUser = {                                                                                                   // 35
        $set: {                                                                                                        // 51
          name: userData.name                                                                                          // 52
        }                                                                                                              //
      };                                                                                                               //
      if (userData.requirePasswordChange) {                                                                            // 54
        updateUser.$set.requirePasswordChange = userData.requirePasswordChange;                                        // 55
      }                                                                                                                //
      Meteor.users.update({                                                                                            // 35
        _id: _id                                                                                                       // 57
      }, updateUser);                                                                                                  //
      return _id;                                                                                                      // 59
    } else {                                                                                                           //
      Meteor.users.update({                                                                                            // 62
        _id: userData._id                                                                                              // 62
      }, {                                                                                                             //
        $set: {                                                                                                        // 62
          name: userData.name,                                                                                         // 62
          requirePasswordChange: userData.requirePasswordChange                                                        // 62
        }                                                                                                              //
      });                                                                                                              //
      RocketChat.setUsername(userData._id, userData.username);                                                         // 62
      RocketChat.setEmail(userData._id, userData.email);                                                               // 62
      canEditUserPassword = RocketChat.authz.hasPermission(user._id, 'edit-other-user-password');                      // 62
      if (canEditUserPassword && userData.password.trim()) {                                                           // 67
        Accounts.setPassword(userData._id, userData.password.trim());                                                  // 68
      }                                                                                                                //
      return true;                                                                                                     // 70
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/setEmail.js                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
Meteor.methods({                                                                                                       // 1
	setEmail: function (email) {                                                                                          // 2
		if (!Meteor.userId()) {                                                                                              // 3
			throw new Meteor.Error('invalid-user', '[methods] setEmail -> Invalid user');                                       // 4
		}                                                                                                                    //
                                                                                                                       //
		var user = Meteor.user();                                                                                            // 7
                                                                                                                       //
		if (!RocketChat.settings.get('Accounts_AllowEmailChange')) {                                                         // 9
			throw new Meteor.Error(403, '[methods] setEmail -> E-mail change not allowed');                                     // 10
		}                                                                                                                    //
                                                                                                                       //
		if (user.emails && user.emails[0] && user.emails[0].address === email) {                                             // 13
			return email;                                                                                                       // 14
		}                                                                                                                    //
                                                                                                                       //
		if (!RocketChat.setEmail(user._id, email)) {                                                                         // 17
			throw new Meteor.Error('could-not-change-email', 'Could not change email');                                         // 18
		}                                                                                                                    //
                                                                                                                       //
		return email;                                                                                                        // 21
	}                                                                                                                     //
});                                                                                                                    //
                                                                                                                       //
RocketChat.RateLimiter.limitMethod('setEmail', 1, 1000, {                                                              // 25
	userId: function () /*userId*/{                                                                                       // 26
		return true;                                                                                                         // 26
	}                                                                                                                     //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/methods/restartServer.coffee.js                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
Meteor.methods({                                                                                                       // 1
  restart_server: function() {                                                                                         // 2
    if (!Meteor.userId()) {                                                                                            // 3
      throw new Meteor.Error('invalid-user', "[methods] restart_server -> Invalid user");                              // 4
    }                                                                                                                  //
    if (RocketChat.authz.hasRole(Meteor.userId(), 'admin') !== true) {                                                 // 6
      throw new Meteor.Error('not-authorized', '[methods] restart_server -> Not authorized');                          // 7
    }                                                                                                                  //
    Meteor.setTimeout(function() {                                                                                     // 3
      return process.exit(1);                                                                                          //
    }, 2000);                                                                                                          //
    return {                                                                                                           // 13
      message: "The_server_will_restart_in_s_seconds",                                                                 // 14
      params: [2]                                                                                                      // 14
    };                                                                                                                 //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/startup/settingsOnLoadCdnPrefix.coffee.js                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.settings.onload('CDN_PREFIX', function(key, value, initialLoad) {                                           // 1
  if (_.isString(value)) {                                                                                             // 2
    return typeof WebAppInternals !== "undefined" && WebAppInternals !== null ? WebAppInternals.setBundledJsCssPrefix(value) : void 0;
  }                                                                                                                    //
});                                                                                                                    // 1
                                                                                                                       //
Meteor.startup(function() {                                                                                            // 1
  var value;                                                                                                           // 6
  value = RocketChat.settings.get('CDN_PREFIX');                                                                       // 6
  if (_.isString(value)) {                                                                                             // 7
    return typeof WebAppInternals !== "undefined" && WebAppInternals !== null ? WebAppInternals.setBundledJsCssPrefix(value) : void 0;
  }                                                                                                                    //
});                                                                                                                    // 5
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/startup/settingsOnLoadSMTP.coffee.js                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var buildMailURL;                                                                                                      // 1
                                                                                                                       //
buildMailURL = _.debounce(function() {                                                                                 // 1
  console.log('Updating process.env.MAIL_URL');                                                                        // 2
  if (RocketChat.settings.get('SMTP_Host')) {                                                                          // 3
    process.env.MAIL_URL = "smtp://";                                                                                  // 4
    if (RocketChat.settings.get('SMTP_Username') && RocketChat.settings.get('SMTP_Password')) {                        // 5
      process.env.MAIL_URL += encodeURIComponent(RocketChat.settings.get('SMTP_Username')) + ':' + encodeURIComponent(RocketChat.settings.get('SMTP_Password')) + '@';
    }                                                                                                                  //
    process.env.MAIL_URL += encodeURIComponent(RocketChat.settings.get('SMTP_Host'));                                  // 4
    if (RocketChat.settings.get('SMTP_Port')) {                                                                        // 8
      return process.env.MAIL_URL += ':' + parseInt(RocketChat.settings.get('SMTP_Port'));                             //
    }                                                                                                                  //
  }                                                                                                                    //
}, 500);                                                                                                               // 1
                                                                                                                       //
RocketChat.settings.onload('SMTP_Host', function(key, value, initialLoad) {                                            // 1
  if (_.isString(value)) {                                                                                             // 13
    return buildMailURL();                                                                                             //
  }                                                                                                                    //
});                                                                                                                    // 12
                                                                                                                       //
RocketChat.settings.onload('SMTP_Port', function(key, value, initialLoad) {                                            // 1
  return buildMailURL();                                                                                               //
});                                                                                                                    // 16
                                                                                                                       //
RocketChat.settings.onload('SMTP_Username', function(key, value, initialLoad) {                                        // 1
  if (_.isString(value)) {                                                                                             // 20
    return buildMailURL();                                                                                             //
  }                                                                                                                    //
});                                                                                                                    // 19
                                                                                                                       //
RocketChat.settings.onload('SMTP_Password', function(key, value, initialLoad) {                                        // 1
  if (_.isString(value)) {                                                                                             // 24
    return buildMailURL();                                                                                             //
  }                                                                                                                    //
});                                                                                                                    // 23
                                                                                                                       //
Meteor.startup(function() {                                                                                            // 1
  return buildMailURL();                                                                                               //
});                                                                                                                    // 27
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/startup/oAuthServicesUpdate.coffee.js                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
var OAuthServicesRemove, OAuthServicesUpdate, logger, timer;                                                           // 1
                                                                                                                       //
logger = new Logger('rocketchat:lib', {                                                                                // 1
  methods: {                                                                                                           // 2
    oauth_updated: {                                                                                                   // 3
      type: 'info'                                                                                                     // 4
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
timer = void 0;                                                                                                        // 1
                                                                                                                       //
OAuthServicesUpdate = function() {                                                                                     // 1
  if (timer != null) {                                                                                                 // 8
    Meteor.clearTimeout(timer);                                                                                        // 8
  }                                                                                                                    //
  return timer = Meteor.setTimeout(function() {                                                                        //
    var data, i, len, ref, ref1, ref10, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, results, service, serviceName, services;
    services = RocketChat.models.Settings.find({                                                                       // 11
      _id: /^(Accounts_OAuth_|Accounts_OAuth_Custom_)[a-z0-9_-]+$/i                                                    // 11
    }).fetch();                                                                                                        //
    results = [];                                                                                                      // 12
    for (i = 0, len = services.length; i < len; i++) {                                                                 //
      service = services[i];                                                                                           //
      logger.oauth_updated(service._id);                                                                               // 13
      serviceName = service._id.replace('Accounts_OAuth_', '');                                                        // 13
      if (serviceName === 'Meteor') {                                                                                  // 16
        serviceName = 'meteor-developer';                                                                              // 17
      }                                                                                                                //
      if (/Accounts_OAuth_Custom_/.test(service._id)) {                                                                // 19
        serviceName = service._id.replace('Accounts_OAuth_Custom_', '');                                               // 20
      }                                                                                                                //
      if (service.value === true) {                                                                                    // 22
        data = {                                                                                                       // 23
          clientId: (ref = RocketChat.models.Settings.findOneById(service._id + "_id")) != null ? ref.value : void 0,  // 24
          secret: (ref1 = RocketChat.models.Settings.findOneById(service._id + "_secret")) != null ? ref1.value : void 0
        };                                                                                                             //
        if (/Accounts_OAuth_Custom_/.test(service._id)) {                                                              // 28
          data.custom = true;                                                                                          // 29
          data.serverURL = (ref2 = RocketChat.models.Settings.findOneById(service._id + "_url")) != null ? ref2.value : void 0;
          data.tokenPath = (ref3 = RocketChat.models.Settings.findOneById(service._id + "_token_path")) != null ? ref3.value : void 0;
          data.identityPath = (ref4 = RocketChat.models.Settings.findOneById(service._id + "_identity_path")) != null ? ref4.value : void 0;
          data.authorizePath = (ref5 = RocketChat.models.Settings.findOneById(service._id + "_authorize_path")) != null ? ref5.value : void 0;
          data.buttonLabelText = (ref6 = RocketChat.models.Settings.findOneById(service._id + "_button_label_text")) != null ? ref6.value : void 0;
          data.buttonLabelColor = (ref7 = RocketChat.models.Settings.findOneById(service._id + "_button_label_color")) != null ? ref7.value : void 0;
          data.loginStyle = (ref8 = RocketChat.models.Settings.findOneById(service._id + "_login_style")) != null ? ref8.value : void 0;
          data.buttonColor = (ref9 = RocketChat.models.Settings.findOneById(service._id + "_button_color")) != null ? ref9.value : void 0;
          data.tokenSentVia = (ref10 = RocketChat.models.Settings.findOneById(service._id + "_token_sent_via")) != null ? ref10.value : void 0;
          new CustomOAuth(serviceName.toLowerCase(), {                                                                 // 29
            serverURL: data.serverURL,                                                                                 // 40
            tokenPath: data.tokenPath,                                                                                 // 40
            identityPath: data.identityPath,                                                                           // 40
            authorizePath: data.authorizePath,                                                                         // 40
            loginStyle: data.loginStyle,                                                                               // 40
            tokenSentVia: data.tokenSentVia                                                                            // 40
          });                                                                                                          //
        }                                                                                                              //
        if (serviceName === 'Facebook') {                                                                              // 47
          data.appId = data.clientId;                                                                                  // 48
          delete data.clientId;                                                                                        // 48
        }                                                                                                              //
        if (serviceName === 'Twitter') {                                                                               // 51
          data.consumerKey = data.clientId;                                                                            // 52
          delete data.clientId;                                                                                        // 52
        }                                                                                                              //
        results.push(ServiceConfiguration.configurations.upsert({                                                      // 23
          service: serviceName.toLowerCase()                                                                           // 54
        }, {                                                                                                           //
          $set: data                                                                                                   // 54
        }));                                                                                                           //
      } else {                                                                                                         //
        results.push(ServiceConfiguration.configurations.remove({                                                      //
          service: serviceName.toLowerCase()                                                                           // 56
        }));                                                                                                           //
      }                                                                                                                //
    }                                                                                                                  // 12
    return results;                                                                                                    //
  }, 2000);                                                                                                            //
};                                                                                                                     // 7
                                                                                                                       //
OAuthServicesRemove = function(_id) {                                                                                  // 1
  var serviceName;                                                                                                     // 61
  serviceName = _id.replace('Accounts_OAuth_Custom_', '');                                                             // 61
  return ServiceConfiguration.configurations.remove({                                                                  //
    service: serviceName.toLowerCase()                                                                                 // 62
  });                                                                                                                  //
};                                                                                                                     // 60
                                                                                                                       //
RocketChat.models.Settings.find().observe({                                                                            // 1
  added: function(record) {                                                                                            // 66
    if (/^Accounts_OAuth_.+/.test(record._id)) {                                                                       // 67
      return OAuthServicesUpdate();                                                                                    //
    }                                                                                                                  //
  },                                                                                                                   //
  changed: function(record) {                                                                                          // 66
    if (/^Accounts_OAuth_.+/.test(record._id)) {                                                                       // 71
      return OAuthServicesUpdate();                                                                                    //
    }                                                                                                                  //
  },                                                                                                                   //
  removed: function(record) {                                                                                          // 66
    if (/^Accounts_OAuth_Custom.+/.test(record._id)) {                                                                 // 75
      return OAuthServicesRemove(record._id);                                                                          //
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/server/startup/settings.coffee.js                                                           //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
if (!RocketChat.models.Settings.findOneById('uniqueID')) {                                                             // 2
  RocketChat.models.Settings.createWithIdAndValue('uniqueID', process.env.DEPLOYMENT_ID || Random.id());               // 3
}                                                                                                                      //
                                                                                                                       //
RocketChat.settings.addGroup('Accounts', function() {                                                                  // 2
  this.add('Accounts_AllowDeleteOwnAccount', false, {                                                                  // 6
    type: 'boolean',                                                                                                   // 6
    "public": true,                                                                                                    // 6
    enableQuery: {                                                                                                     // 6
      _id: 'Accounts_AllowUserProfileChange',                                                                          // 6
      value: true                                                                                                      // 6
    }                                                                                                                  //
  });                                                                                                                  //
  this.add('Accounts_AllowUserProfileChange', true, {                                                                  // 6
    type: 'boolean',                                                                                                   // 7
    "public": true                                                                                                     // 7
  });                                                                                                                  //
  this.add('Accounts_AllowUserAvatarChange', true, {                                                                   // 6
    type: 'boolean',                                                                                                   // 8
    "public": true                                                                                                     // 8
  });                                                                                                                  //
  this.add('Accounts_AllowUsernameChange', true, {                                                                     // 6
    type: 'boolean',                                                                                                   // 9
    "public": true                                                                                                     // 9
  });                                                                                                                  //
  this.add('Accounts_AllowEmailChange', true, {                                                                        // 6
    type: 'boolean',                                                                                                   // 10
    "public": true                                                                                                     // 10
  });                                                                                                                  //
  this.add('Accounts_AllowPasswordChange', true, {                                                                     // 6
    type: 'boolean',                                                                                                   // 11
    "public": true                                                                                                     // 11
  });                                                                                                                  //
  this.add('Accounts_RequireNameForSignUp', true, {                                                                    // 6
    type: 'boolean',                                                                                                   // 12
    "public": true                                                                                                     // 12
  });                                                                                                                  //
  this.add('Accounts_LoginExpiration', 90, {                                                                           // 6
    type: 'int',                                                                                                       // 13
    "public": true                                                                                                     // 13
  });                                                                                                                  //
  this.add('Accounts_ShowFormLogin', true, {                                                                           // 6
    type: 'boolean',                                                                                                   // 14
    "public": true                                                                                                     // 14
  });                                                                                                                  //
  this.add('Accounts_EmailOrUsernamePlaceholder', '', {                                                                // 6
    type: 'string',                                                                                                    // 15
    "public": true,                                                                                                    // 15
    i18nLabel: 'Placeholder_for_email_or_username_login_field'                                                         // 15
  });                                                                                                                  //
  this.add('Accounts_PasswordPlaceholder', '', {                                                                       // 6
    type: 'string',                                                                                                    // 16
    "public": true,                                                                                                    // 16
    i18nLabel: 'Placeholder_for_password_login_field'                                                                  // 16
  });                                                                                                                  //
  this.section('Registration', function() {                                                                            // 6
    this.add('Accounts_EmailVerification', false, {                                                                    // 19
      type: 'boolean',                                                                                                 // 19
      "public": true,                                                                                                  // 19
      enableQuery: {                                                                                                   // 19
        _id: 'SMTP_Host',                                                                                              // 19
        value: {                                                                                                       // 19
          $exists: 1,                                                                                                  // 19
          $ne: ""                                                                                                      // 19
        }                                                                                                              //
      }                                                                                                                //
    });                                                                                                                //
    this.add('Accounts_ManuallyApproveNewUsers', false, {                                                              // 19
      type: 'boolean'                                                                                                  // 20
    });                                                                                                                //
    this.add('Accounts_AllowedDomainsList', '', {                                                                      // 19
      type: 'string',                                                                                                  // 21
      "public": true                                                                                                   // 21
    });                                                                                                                //
    this.add('Accounts_BlockedDomainsList', '', {                                                                      // 19
      type: 'string'                                                                                                   // 23
    });                                                                                                                //
    this.add('Accounts_UseDefaultBlockedDomainsList', true, {                                                          // 19
      type: 'boolean'                                                                                                  // 24
    });                                                                                                                //
    this.add('Accounts_UseDNSDomainCheck', true, {                                                                     // 19
      type: 'boolean'                                                                                                  // 25
    });                                                                                                                //
    this.add('Accounts_RegistrationForm', 'Public', {                                                                  // 19
      type: 'select',                                                                                                  // 27
      "public": true,                                                                                                  // 27
      values: [                                                                                                        // 27
        {                                                                                                              //
          key: 'Public',                                                                                               // 27
          i18nLabel: 'Accounts_RegistrationForm_Public'                                                                // 27
        }, {                                                                                                           //
          key: 'Disabled',                                                                                             // 27
          i18nLabel: 'Accounts_RegistrationForm_Disabled'                                                              // 27
        }, {                                                                                                           //
          key: 'Secret URL',                                                                                           // 27
          i18nLabel: 'Accounts_RegistrationForm_Secret_URL'                                                            // 27
        }                                                                                                              //
      ]                                                                                                                //
    });                                                                                                                //
    this.add('Accounts_RegistrationForm_SecretURL', Random.id(), {                                                     // 19
      type: 'string'                                                                                                   // 28
    });                                                                                                                //
    this.add('Accounts_RegistrationForm_LinkReplacementText', 'New user registration is currently disabled', {         // 19
      type: 'string',                                                                                                  // 29
      "public": true                                                                                                   // 29
    });                                                                                                                //
    this.add('Accounts_Registration_AuthenticationServices_Enabled', true, {                                           // 19
      type: 'boolean',                                                                                                 // 30
      "public": true                                                                                                   // 30
    });                                                                                                                //
    return this.add('Accounts_PasswordReset', true, {                                                                  //
      type: 'boolean',                                                                                                 // 31
      "public": true                                                                                                   // 31
    });                                                                                                                //
  });                                                                                                                  //
  return this.section('Avatar', function() {                                                                           //
    this.add('Accounts_AvatarResize', true, {                                                                          // 34
      type: 'boolean'                                                                                                  // 34
    });                                                                                                                //
    this.add('Accounts_AvatarSize', 200, {                                                                             // 34
      type: 'int',                                                                                                     // 35
      enableQuery: {                                                                                                   // 35
        _id: 'Accounts_AvatarResize',                                                                                  // 35
        value: true                                                                                                    // 35
      }                                                                                                                //
    });                                                                                                                //
    this.add('Accounts_AvatarStoreType', 'GridFS', {                                                                   // 34
      type: 'select',                                                                                                  // 36
      values: [                                                                                                        // 36
        {                                                                                                              //
          key: 'GridFS',                                                                                               // 36
          i18nLabel: 'GridFS'                                                                                          // 36
        }, {                                                                                                           //
          key: 'FileSystem',                                                                                           // 36
          i18nLabel: 'FileSystem'                                                                                      // 36
        }                                                                                                              //
      ]                                                                                                                //
    });                                                                                                                //
    return this.add('Accounts_AvatarStorePath', '', {                                                                  //
      type: 'string',                                                                                                  // 37
      enableQuery: {                                                                                                   // 37
        _id: 'Accounts_AvatarStoreType',                                                                               // 37
        value: 'FileSystem'                                                                                            // 37
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 5
                                                                                                                       //
RocketChat.settings.addGroup('OAuth', function() {                                                                     // 2
  this.section('Facebook', function() {                                                                                // 41
    var enableQuery;                                                                                                   // 42
    enableQuery = {                                                                                                    // 42
      _id: 'Accounts_OAuth_Facebook',                                                                                  // 42
      value: true                                                                                                      // 42
    };                                                                                                                 //
    this.add('Accounts_OAuth_Facebook', false, {                                                                       // 42
      type: 'boolean',                                                                                                 // 43
      "public": true                                                                                                   // 43
    });                                                                                                                //
    this.add('Accounts_OAuth_Facebook_id', '', {                                                                       // 42
      type: 'string',                                                                                                  // 44
      enableQuery: enableQuery                                                                                         // 44
    });                                                                                                                //
    this.add('Accounts_OAuth_Facebook_secret', '', {                                                                   // 42
      type: 'string',                                                                                                  // 45
      enableQuery: enableQuery                                                                                         // 45
    });                                                                                                                //
    return this.add('Accounts_OAuth_Facebook_callback_url', '_oauth/facebook', {                                       //
      type: 'relativeUrl',                                                                                             // 46
      readonly: true,                                                                                                  // 46
      force: true,                                                                                                     // 46
      enableQuery: enableQuery                                                                                         // 46
    });                                                                                                                //
  });                                                                                                                  //
  this.section('Google', function() {                                                                                  // 41
    var enableQuery;                                                                                                   // 49
    enableQuery = {                                                                                                    // 49
      _id: 'Accounts_OAuth_Google',                                                                                    // 49
      value: true                                                                                                      // 49
    };                                                                                                                 //
    this.add('Accounts_OAuth_Google', false, {                                                                         // 49
      type: 'boolean',                                                                                                 // 50
      "public": true                                                                                                   // 50
    });                                                                                                                //
    this.add('Accounts_OAuth_Google_id', '', {                                                                         // 49
      type: 'string',                                                                                                  // 51
      enableQuery: enableQuery                                                                                         // 51
    });                                                                                                                //
    this.add('Accounts_OAuth_Google_secret', '', {                                                                     // 49
      type: 'string',                                                                                                  // 52
      enableQuery: enableQuery                                                                                         // 52
    });                                                                                                                //
    return this.add('Accounts_OAuth_Google_callback_url', '_oauth/google', {                                           //
      type: 'relativeUrl',                                                                                             // 53
      readonly: true,                                                                                                  // 53
      force: true,                                                                                                     // 53
      enableQuery: enableQuery                                                                                         // 53
    });                                                                                                                //
  });                                                                                                                  //
  this.section('GitHub', function() {                                                                                  // 41
    var enableQuery;                                                                                                   // 56
    enableQuery = {                                                                                                    // 56
      _id: 'Accounts_OAuth_Github',                                                                                    // 56
      value: true                                                                                                      // 56
    };                                                                                                                 //
    this.add('Accounts_OAuth_Github', false, {                                                                         // 56
      type: 'boolean',                                                                                                 // 57
      "public": true                                                                                                   // 57
    });                                                                                                                //
    this.add('Accounts_OAuth_Github_id', '', {                                                                         // 56
      type: 'string',                                                                                                  // 58
      enableQuery: enableQuery                                                                                         // 58
    });                                                                                                                //
    this.add('Accounts_OAuth_Github_secret', '', {                                                                     // 56
      type: 'string',                                                                                                  // 59
      enableQuery: enableQuery                                                                                         // 59
    });                                                                                                                //
    return this.add('Accounts_OAuth_Github_callback_url', '_oauth/github', {                                           //
      type: 'relativeUrl',                                                                                             // 60
      readonly: true,                                                                                                  // 60
      force: true,                                                                                                     // 60
      enableQuery: enableQuery                                                                                         // 60
    });                                                                                                                //
  });                                                                                                                  //
  this.section('Linkedin', function() {                                                                                // 41
    var enableQuery;                                                                                                   // 63
    enableQuery = {                                                                                                    // 63
      _id: 'Accounts_OAuth_Linkedin',                                                                                  // 63
      value: true                                                                                                      // 63
    };                                                                                                                 //
    this.add('Accounts_OAuth_Linkedin', false, {                                                                       // 63
      type: 'boolean',                                                                                                 // 64
      "public": true                                                                                                   // 64
    });                                                                                                                //
    this.add('Accounts_OAuth_Linkedin_id', '', {                                                                       // 63
      type: 'string',                                                                                                  // 65
      enableQuery: enableQuery                                                                                         // 65
    });                                                                                                                //
    this.add('Accounts_OAuth_Linkedin_secret', '', {                                                                   // 63
      type: 'string',                                                                                                  // 66
      enableQuery: enableQuery                                                                                         // 66
    });                                                                                                                //
    return this.add('Accounts_OAuth_Linkedin_callback_url', '_oauth/linkedin', {                                       //
      type: 'relativeUrl',                                                                                             // 67
      readonly: true,                                                                                                  // 67
      force: true,                                                                                                     // 67
      enableQuery: enableQuery                                                                                         // 67
    });                                                                                                                //
  });                                                                                                                  //
  this.section('Meteor', function() {                                                                                  // 41
    var enableQuery;                                                                                                   // 70
    enableQuery = {                                                                                                    // 70
      _id: 'Accounts_OAuth_Meteor',                                                                                    // 70
      value: true                                                                                                      // 70
    };                                                                                                                 //
    this.add('Accounts_OAuth_Meteor', false, {                                                                         // 70
      type: 'boolean',                                                                                                 // 71
      "public": true                                                                                                   // 71
    });                                                                                                                //
    this.add('Accounts_OAuth_Meteor_id', '', {                                                                         // 70
      type: 'string',                                                                                                  // 72
      enableQuery: enableQuery                                                                                         // 72
    });                                                                                                                //
    this.add('Accounts_OAuth_Meteor_secret', '', {                                                                     // 70
      type: 'string',                                                                                                  // 73
      enableQuery: enableQuery                                                                                         // 73
    });                                                                                                                //
    return this.add('Accounts_OAuth_Meteor_callback_url', '_oauth/meteor', {                                           //
      type: 'relativeUrl',                                                                                             // 74
      readonly: true,                                                                                                  // 74
      force: true,                                                                                                     // 74
      enableQuery: enableQuery                                                                                         // 74
    });                                                                                                                //
  });                                                                                                                  //
  return this.section('Twitter', function() {                                                                          //
    var enableQuery;                                                                                                   // 77
    enableQuery = {                                                                                                    // 77
      _id: 'Accounts_OAuth_Twitter',                                                                                   // 77
      value: true                                                                                                      // 77
    };                                                                                                                 //
    this.add('Accounts_OAuth_Twitter', false, {                                                                        // 77
      type: 'boolean',                                                                                                 // 78
      "public": true                                                                                                   // 78
    });                                                                                                                //
    this.add('Accounts_OAuth_Twitter_id', '', {                                                                        // 77
      type: 'string',                                                                                                  // 79
      enableQuery: enableQuery                                                                                         // 79
    });                                                                                                                //
    this.add('Accounts_OAuth_Twitter_secret', '', {                                                                    // 77
      type: 'string',                                                                                                  // 80
      enableQuery: enableQuery                                                                                         // 80
    });                                                                                                                //
    return this.add('Accounts_OAuth_Twitter_callback_url', '_oauth/twitter', {                                         //
      type: 'relativeUrl',                                                                                             // 81
      readonly: true,                                                                                                  // 81
      force: true,                                                                                                     // 81
      enableQuery: enableQuery                                                                                         // 81
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 39
                                                                                                                       //
RocketChat.settings.addGroup('General', function() {                                                                   // 2
  this.add('Site_Url', typeof __meteor_runtime_config__ !== "undefined" && __meteor_runtime_config__ !== null ? __meteor_runtime_config__.ROOT_URL : void 0, {
    type: 'string',                                                                                                    // 86
    i18nDescription: 'Site_Url_Description',                                                                           // 86
    "public": true                                                                                                     // 86
  });                                                                                                                  //
  this.add('Site_Name', 'Rocket.Chat', {                                                                               // 86
    type: 'string',                                                                                                    // 87
    "public": true                                                                                                     // 87
  });                                                                                                                  //
  this.add('Language', '', {                                                                                           // 86
    type: 'language',                                                                                                  // 88
    "public": true                                                                                                     // 88
  });                                                                                                                  //
  this.add('Allow_Invalid_SelfSigned_Certs', false, {                                                                  // 86
    type: 'boolean'                                                                                                    // 89
  });                                                                                                                  //
  this.add('Disable_Favorite_Rooms', false, {                                                                          // 86
    type: 'boolean'                                                                                                    // 90
  });                                                                                                                  //
  this.add('CDN_PREFIX', '', {                                                                                         // 86
    type: 'string'                                                                                                     // 91
  });                                                                                                                  //
  this.add('Force_SSL', false, {                                                                                       // 86
    type: 'boolean',                                                                                                   // 92
    "public": true                                                                                                     // 92
  });                                                                                                                  //
  this.add('GoogleTagManager_id', '', {                                                                                // 86
    type: 'string',                                                                                                    // 93
    "public": true                                                                                                     // 93
  });                                                                                                                  //
  this.add('Restart', 'restart_server', {                                                                              // 86
    type: 'action',                                                                                                    // 94
    actionText: 'Restart_the_server'                                                                                   // 94
  });                                                                                                                  //
  this.section('UTF8', function() {                                                                                    // 86
    this.add('UTF8_Names_Validation', '[0-9a-zA-Z-_.]+', {                                                             // 97
      type: 'string',                                                                                                  // 97
      "public": true,                                                                                                  // 97
      i18nDescription: 'UTF8_Names_Validation_Description'                                                             // 97
    });                                                                                                                //
    return this.add('UTF8_Names_Slugify', true, {                                                                      //
      type: 'boolean',                                                                                                 // 98
      "public": true                                                                                                   // 98
    });                                                                                                                //
  });                                                                                                                  //
  return this.section('Reporting', function() {                                                                        //
    return this.add('Statistics_opt_out', false, {                                                                     //
      type: 'boolean',                                                                                                 // 101
      i18nLabel: "Opt_out_statistics"                                                                                  // 101
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 84
                                                                                                                       //
RocketChat.settings.addGroup('SMTP', function() {                                                                      // 2
  this.add('SMTP_Host', '', {                                                                                          // 105
    type: 'string',                                                                                                    // 105
    env: true                                                                                                          // 105
  });                                                                                                                  //
  this.add('SMTP_Port', '', {                                                                                          // 105
    type: 'string',                                                                                                    // 106
    env: true                                                                                                          // 106
  });                                                                                                                  //
  this.add('SMTP_Username', '', {                                                                                      // 105
    type: 'string',                                                                                                    // 107
    env: true                                                                                                          // 107
  });                                                                                                                  //
  this.add('SMTP_Password', '', {                                                                                      // 105
    type: 'password',                                                                                                  // 108
    env: true                                                                                                          // 108
  });                                                                                                                  //
  this.add('From_Email', '', {                                                                                         // 105
    type: 'string',                                                                                                    // 109
    placeholder: 'email@domain'                                                                                        // 109
  });                                                                                                                  //
  this.add('SMTP_Test_Button', 'sendSMTPTestEmail', {                                                                  // 105
    type: 'action',                                                                                                    // 110
    actionText: 'Send_a_test_mail_to_my_user'                                                                          // 110
  });                                                                                                                  //
  return this.section('Invitation', function() {                                                                       //
    this.add('Invitation_Subject', 'You have been invited to Rocket.Chat', {                                           // 113
      type: 'string'                                                                                                   // 113
    });                                                                                                                //
    this.add('Invitation_HTML', '<h2>You have been invited to <h1>Rocket.Chat</h1></h2><p>Go to ' + (typeof __meteor_runtime_config__ !== "undefined" && __meteor_runtime_config__ !== null ? __meteor_runtime_config__.ROOT_URL : void 0) + ' and try the best open source chat solution available today!</p>', {
      type: 'string',                                                                                                  // 114
      multiline: true                                                                                                  // 114
    });                                                                                                                //
    return this.add('Accounts_Enrollment_Email', '', {                                                                 //
      type: 'string',                                                                                                  // 115
      multiline: true                                                                                                  // 115
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 104
                                                                                                                       //
RocketChat.settings.addGroup('Message', function() {                                                                   // 2
  this.add('Message_AllowEditing', true, {                                                                             // 119
    type: 'boolean',                                                                                                   // 119
    "public": true                                                                                                     // 119
  });                                                                                                                  //
  this.add('Message_AllowEditing_BlockEditInMinutes', 0, {                                                             // 119
    type: 'int',                                                                                                       // 120
    "public": true,                                                                                                    // 120
    i18nDescription: 'Message_AllowEditing_BlockEditInMinutesDescription'                                              // 120
  });                                                                                                                  //
  this.add('Message_AllowDeleting', true, {                                                                            // 119
    type: 'boolean',                                                                                                   // 121
    "public": true                                                                                                     // 121
  });                                                                                                                  //
  this.add('Message_AllowDeleting_BlockDeleteInMinutes', 0, {                                                          // 119
    type: 'int',                                                                                                       // 122
    "public": true,                                                                                                    // 122
    i18nDescription: 'Message_AllowDeleting_BlockDeleteInMinutes'                                                      // 122
  });                                                                                                                  //
  this.add('Message_AllowPinning', true, {                                                                             // 119
    type: 'boolean',                                                                                                   // 123
    "public": true                                                                                                     // 123
  });                                                                                                                  //
  this.add('Message_ShowEditedStatus', true, {                                                                         // 119
    type: 'boolean',                                                                                                   // 124
    "public": true                                                                                                     // 124
  });                                                                                                                  //
  this.add('Message_ShowDeletedStatus', false, {                                                                       // 119
    type: 'boolean',                                                                                                   // 125
    "public": true                                                                                                     // 125
  });                                                                                                                  //
  this.add('Message_KeepHistory', false, {                                                                             // 119
    type: 'boolean',                                                                                                   // 126
    "public": true                                                                                                     // 126
  });                                                                                                                  //
  this.add('Message_MaxAll', 0, {                                                                                      // 119
    type: 'int',                                                                                                       // 127
    "public": true                                                                                                     // 127
  });                                                                                                                  //
  this.add('Message_MaxAllowedSize', 5000, {                                                                           // 119
    type: 'int',                                                                                                       // 128
    "public": true                                                                                                     // 128
  });                                                                                                                  //
  this.add('Message_ShowFormattingTips', true, {                                                                       // 119
    type: 'boolean',                                                                                                   // 129
    "public": true                                                                                                     // 129
  });                                                                                                                  //
  this.add('Message_AudioRecorderEnabled', true, {                                                                     // 119
    type: 'boolean',                                                                                                   // 130
    "public": true,                                                                                                    // 130
    i18nDescription: 'Message_AudioRecorderEnabledDescription'                                                         // 130
  });                                                                                                                  //
  this.add('Message_GroupingPeriod', 300, {                                                                            // 119
    type: 'int',                                                                                                       // 131
    "public": true,                                                                                                    // 131
    i18nDescription: 'Message_GroupingPeriodDescription'                                                               // 131
  });                                                                                                                  //
  this.add('API_Embed', true, {                                                                                        // 119
    type: 'boolean',                                                                                                   // 132
    "public": true                                                                                                     // 132
  });                                                                                                                  //
  this.add('API_EmbedDisabledFor', '', {                                                                               // 119
    type: 'string',                                                                                                    // 133
    "public": true,                                                                                                    // 133
    i18nDescription: 'API_EmbedDisabledFor_Description'                                                                // 133
  });                                                                                                                  //
  this.add('Message_TimeFormat', 'LT', {                                                                               // 119
    type: 'string',                                                                                                    // 134
    "public": true,                                                                                                    // 134
    i18nDescription: 'Message_TimeFormat_Description'                                                                  // 134
  });                                                                                                                  //
  return this.add('Message_DateFormat', 'LL', {                                                                        //
    type: 'string',                                                                                                    // 135
    "public": true,                                                                                                    // 135
    i18nDescription: 'Message_DateFormat_Description'                                                                  // 135
  });                                                                                                                  //
});                                                                                                                    // 118
                                                                                                                       //
RocketChat.settings.addGroup('Meta', function() {                                                                      // 2
  this.add('Meta_language', '', {                                                                                      // 139
    type: 'string'                                                                                                     // 139
  });                                                                                                                  //
  this.add('Meta_fb_app_id', '', {                                                                                     // 139
    type: 'string'                                                                                                     // 140
  });                                                                                                                  //
  this.add('Meta_robots', '', {                                                                                        // 139
    type: 'string'                                                                                                     // 141
  });                                                                                                                  //
  this.add('Meta_google-site-verification', '', {                                                                      // 139
    type: 'string'                                                                                                     // 142
  });                                                                                                                  //
  return this.add('Meta_msvalidate01', '', {                                                                           //
    type: 'string'                                                                                                     // 143
  });                                                                                                                  //
});                                                                                                                    // 138
                                                                                                                       //
RocketChat.settings.addGroup('Push', function() {                                                                      // 2
  this.add('Push_debug', false, {                                                                                      // 147
    type: 'boolean',                                                                                                   // 147
    "public": true                                                                                                     // 147
  });                                                                                                                  //
  this.add('Push_enable', true, {                                                                                      // 147
    type: 'boolean',                                                                                                   // 148
    "public": true                                                                                                     // 148
  });                                                                                                                  //
  this.add('Push_enable_gateway', true, {                                                                              // 147
    type: 'boolean'                                                                                                    // 149
  });                                                                                                                  //
  this.add('Push_gateway', 'https://rocket.chat', {                                                                    // 147
    type: 'string'                                                                                                     // 150
  });                                                                                                                  //
  this.add('Push_production', true, {                                                                                  // 147
    type: 'boolean',                                                                                                   // 151
    "public": true                                                                                                     // 151
  });                                                                                                                  //
  this.add('Push_test_push', 'push_test', {                                                                            // 147
    type: 'action',                                                                                                    // 152
    actionText: 'Send_a_test_push_to_my_user'                                                                          // 152
  });                                                                                                                  //
  this.section('Certificates_and_Keys', function() {                                                                   // 147
    this.add('Push_apn_passphrase', '', {                                                                              // 155
      type: 'string'                                                                                                   // 155
    });                                                                                                                //
    this.add('Push_apn_key', '', {                                                                                     // 155
      type: 'string',                                                                                                  // 156
      multiline: true                                                                                                  // 156
    });                                                                                                                //
    this.add('Push_apn_cert', '', {                                                                                    // 155
      type: 'string',                                                                                                  // 157
      multiline: true                                                                                                  // 157
    });                                                                                                                //
    this.add('Push_apn_dev_passphrase', '', {                                                                          // 155
      type: 'string'                                                                                                   // 158
    });                                                                                                                //
    this.add('Push_apn_dev_key', '', {                                                                                 // 155
      type: 'string',                                                                                                  // 159
      multiline: true                                                                                                  // 159
    });                                                                                                                //
    this.add('Push_apn_dev_cert', '', {                                                                                // 155
      type: 'string',                                                                                                  // 160
      multiline: true                                                                                                  // 160
    });                                                                                                                //
    this.add('Push_gcm_api_key', '', {                                                                                 // 155
      type: 'string'                                                                                                   // 161
    });                                                                                                                //
    return this.add('Push_gcm_project_number', '', {                                                                   //
      type: 'string',                                                                                                  // 162
      "public": true                                                                                                   // 162
    });                                                                                                                //
  });                                                                                                                  //
  return this.section('Privacy', function() {                                                                          //
    this.add('Push_show_username_room', true, {                                                                        // 165
      type: 'boolean',                                                                                                 // 165
      "public": true                                                                                                   // 165
    });                                                                                                                //
    return this.add('Push_show_message', true, {                                                                       //
      type: 'boolean',                                                                                                 // 166
      "public": true                                                                                                   // 166
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 146
                                                                                                                       //
RocketChat.settings.addGroup('Layout', function() {                                                                    // 2
  this.section('Content', function() {                                                                                 // 171
    this.add('Layout_Home_Title', 'Home', {                                                                            // 172
      type: 'string',                                                                                                  // 172
      "public": true                                                                                                   // 172
    });                                                                                                                //
    this.add('Layout_Home_Body', 'Welcome to Rocket.Chat <br> Go to APP SETTINGS -> Layout to customize this intro.', {
      type: 'code',                                                                                                    // 173
      code: 'text/html',                                                                                               // 173
      multiline: true,                                                                                                 // 173
      "public": true                                                                                                   // 173
    });                                                                                                                //
    this.add('Layout_Terms_of_Service', 'Terms of Service <br> Go to APP SETTINGS -> Layout to customize this page.', {
      type: 'code',                                                                                                    // 174
      code: 'text/html',                                                                                               // 174
      multiline: true,                                                                                                 // 174
      "public": true                                                                                                   // 174
    });                                                                                                                //
    this.add('Layout_Privacy_Policy', 'Privacy Policy <br> Go to APP SETTINGS -> Layout to customize this page.', {    // 172
      type: 'code',                                                                                                    // 175
      code: 'text/html',                                                                                               // 175
      multiline: true,                                                                                                 // 175
      "public": true                                                                                                   // 175
    });                                                                                                                //
    return this.add('Layout_Sidenav_Footer', '<div><a href="https://github.com/RocketChat/Rocket.Chat" class="logo" target="_blank"> <img src="images/logo/logo.svg?v=3" /></a><div class="github-tagline"><span class="icon-pencil" style="color: #994C00"></span> with <span class="icon-heart" style="color: red"></span> on <span class="icon-github-circled"></span></div></div>', {
      type: 'code',                                                                                                    // 176
      code: 'text/html',                                                                                               // 176
      "public": true,                                                                                                  // 176
      i18nDescription: 'Layout_Sidenav_Footer_description'                                                             // 176
    });                                                                                                                //
  });                                                                                                                  //
  this.section('Custom Scripts', function() {                                                                          // 171
    this.add('Custom_Script_Logged_Out', '//Add your script', {                                                        // 179
      type: 'code',                                                                                                    // 179
      multiline: true,                                                                                                 // 179
      "public": true                                                                                                   // 179
    });                                                                                                                //
    return this.add('Custom_Script_Logged_In', '//Add your script', {                                                  //
      type: 'code',                                                                                                    // 180
      multiline: true,                                                                                                 // 180
      "public": true                                                                                                   // 180
    });                                                                                                                //
  });                                                                                                                  //
  return this.section('Login', function() {                                                                            //
    return this.add('Layout_Login_Terms', 'By proceeding to create your account and use Rocket.Chat, you are agreeing to our <a href="/terms-of-service">Terms of Service</a> and <a href="/privacy-policy">Privacy Policy</a>. If you do not agree, you cannot use Rocket.Chat.', {
      type: 'string',                                                                                                  // 183
      multiline: true,                                                                                                 // 183
      "public": true                                                                                                   // 183
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    // 169
                                                                                                                       //
RocketChat.settings.addGroup('Logs', function() {                                                                      // 2
  this.add('Debug_Level', 'error', {                                                                                   // 187
    type: 'select',                                                                                                    // 187
    values: [                                                                                                          // 187
      {                                                                                                                //
        key: 'error',                                                                                                  // 187
        i18nLabel: 'Only_errors'                                                                                       // 187
      }, {                                                                                                             //
        key: 'debug',                                                                                                  // 187
        i18nLabel: 'All_logs'                                                                                          // 187
      }                                                                                                                //
    ]                                                                                                                  //
  });                                                                                                                  //
  this.add('Log_Level', '0', {                                                                                         // 187
    type: 'select',                                                                                                    // 188
    values: [                                                                                                          // 188
      {                                                                                                                //
        key: '0',                                                                                                      // 188
        i18nLabel: '0_Errors_Only'                                                                                     // 188
      }, {                                                                                                             //
        key: '1',                                                                                                      // 188
        i18nLabel: '1_Errors_and_Information'                                                                          // 188
      }, {                                                                                                             //
        key: '2',                                                                                                      // 188
        i18nLabel: '2_Erros_Information_and_Debug'                                                                     // 188
      }                                                                                                                //
    ],                                                                                                                 //
    "public": true                                                                                                     // 188
  });                                                                                                                  //
  this.add('Log_Package', false, {                                                                                     // 187
    type: 'boolean',                                                                                                   // 189
    "public": true                                                                                                     // 189
  });                                                                                                                  //
  this.add('Log_File', false, {                                                                                        // 187
    type: 'boolean',                                                                                                   // 190
    "public": true                                                                                                     // 190
  });                                                                                                                  //
  return this.add('Log_View_Limit', 1000, {                                                                            //
    type: 'int'                                                                                                        // 191
  });                                                                                                                  //
});                                                                                                                    // 186
                                                                                                                       //
RocketChat.settings.init();                                                                                            // 2
                                                                                                                       //
Meteor.startup(function() {                                                                                            // 2
  return RocketChat.models.Settings.update({                                                                           //
    ts: {                                                                                                              // 198
      $lt: RocketChat.settings.ts                                                                                      // 198
    },                                                                                                                 //
    persistent: {                                                                                                      // 198
      $ne: true                                                                                                        // 198
    }                                                                                                                  //
  }, {                                                                                                                 //
    $set: {                                                                                                            // 198
      hidden: true                                                                                                     // 198
    }                                                                                                                  //
  }, {                                                                                                                 //
    multi: true                                                                                                        // 198
  });                                                                                                                  //
});                                                                                                                    // 197
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/lib/startup/settingsOnLoadSiteUrl.coffee.js                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
__coffeescriptShare = typeof __coffeescriptShare === 'object' ? __coffeescriptShare : {}; var share = __coffeescriptShare;
RocketChat.settings.get('Site_Url', function(key, value) {                                                             // 1
  var host, match, prefix, ref;                                                                                        // 2
  if ((value != null ? value.trim() : void 0) !== '') {                                                                // 2
    host = value.replace(/\/$/, '');                                                                                   // 3
    prefix = "";                                                                                                       // 3
    match = value.match(/([^\/]+\/{2}[^\/]+)(\/.+)/);                                                                  // 3
    if (match != null) {                                                                                               // 6
      host = match[1];                                                                                                 // 7
      prefix = match[2].replace(/\/$/, '');                                                                            // 7
    }                                                                                                                  //
    __meteor_runtime_config__.ROOT_URL = host;                                                                         // 3
    if (((ref = Meteor.absoluteUrl.defaultOptions) != null ? ref.rootUrl : void 0) != null) {                          // 13
      Meteor.absoluteUrl.defaultOptions.rootUrl = host;                                                                // 14
    }                                                                                                                  //
    if (Meteor.isServer) {                                                                                             // 16
      RocketChat.hostname = host.replace(/^https?:\/\//, '');                                                          // 17
      process.env.MOBILE_ROOT_URL = host;                                                                              // 17
      process.env.MOBILE_DDP_URL = host;                                                                               // 17
      if (typeof WebAppInternals !== "undefined" && WebAppInternals !== null ? WebAppInternals.generateBoilerplate : void 0) {
        return WebAppInternals.generateBoilerplate();                                                                  //
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
});                                                                                                                    // 1
                                                                                                                       //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/rocketchat.info.js                                                                          //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
RocketChat.Info = {                                                                                                    // 1
    "version": "0.27.0",                                                                                               // 2
    "build": {                                                                                                         // 3
        "date": "2016-04-19T00:08:39.860Z",                                                                            // 4
        "nodeVersion": "v0.10.40",                                                                                     // 5
        "arch": "x64",                                                                                                 // 6
        "platform": "linux",                                                                                           // 7
        "osRelease": "3.13.0-40-generic",                                                                              // 8
        "totalMemmory": 63320141824,                                                                                   // 9
        "freeMemmory": 38858166272,                                                                                    // 10
        "cpus": 32                                                                                                     // 11
    },                                                                                                                 // 12
    "travis": {                                                                                                        // 13
        "buildNumber": "4080",                                                                                         // 14
        "branch": "0.27.0",                                                                                            // 15
        "tag": "0.27.0"                                                                                                // 16
    },                                                                                                                 // 17
    "commit": {                                                                                                        // 18
        "hash": "0dcdfeee250d51bafc0fa301c624f1b1b0ad0b91",                                                            // 19
        "date": "Mon Apr 18 20:56:57 2016 -0300",                                                                      // 20
        "author": "Gabriel Engel",                                                                                     // 21
        "subject": "version bump to 0.27.0",                                                                           // 22
        "tag": "0.27.0",                                                                                               // 23
        "branch": "HEAD"                                                                                               // 24
    }                                                                                                                  // 25
}                                                                                                                      // 26
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ar.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ar"] = ["Arabic","العربية"];                                                                  // 8
TAPi18n._enable({"helper_name":"_","supported_languages":null,"i18n_files_route":"/tap-i18n","preloaded_langs":[],"cdn_path":null});
TAPi18n.languages_names["en"] = ["English","English"];                                                                 // 10
if(_.isUndefined(TAPi18n.translations["ar"])) {                                                                        // 11
  TAPi18n.translations["ar"] = {};                                                                                     // 12
}                                                                                                                      // 13
                                                                                                                       // 14
if(_.isUndefined(TAPi18n.translations["ar"][namespace])) {                                                             // 15
  TAPi18n.translations["ar"][namespace] = {};                                                                          // 16
}                                                                                                                      // 17
                                                                                                                       // 18
_.extend(TAPi18n.translations["ar"][namespace], {"500":"خطأ في الخادم الداخلي","0_Errors_Only":"0 - أخطاء فقط","1_Errors_and_Information":"1 - أخطاء ومعلومات","2_Erros_Information_and_Debug":"2 - Erros والمعلومات وتصحيح","__username__was_set__role__by__user_by_":"تم تعيين __username__ __role__ التي كتبها __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ لم يعد __role__، من خلال __user_by__","Access_not_authorized":"وصول غير مخول","Access_online_demo":"الدخول إلى العرض التجريبي","Access_Online_Demo":"الدخول إلى العرض التجريبي","Access_Token_URL":"URL الوصول رمز","Accounts":"الحسابات","Accounts_AllowDeleteOwnAccount":"السماح للمستخدمين حذف الحساب الخاص","Accounts_AllowedDomainsList":"قائمة النطاقات المسموحة","Accounts_AllowedDomainsList_Description":"قائمة مفصولة بفواصل من المجالات المسموح بها","Accounts_AllowEmailChange":"السماح بتغيير البريد الاليكتروني","Accounts_AllowPasswordChange":"السماح بتغيير كلمة السر","Accounts_AllowUserAvatarChange":"السماح بتغيير الصورة الرمزية","Accounts_AllowUsernameChange":"السماح بتغيير اسم المستخدم","Accounts_AllowUserProfileChange":"السماح بتعديل الملف الشخصي للعضو","Accounts_AvatarResize":"تغيير حجم الصور الرمزية","Accounts_AvatarSize":"حجم الصورة الرمزية","Accounts_AvatarStorePath":"مسار تخزين الصورة الرمزية","Accounts_AvatarStoreType":"نوع تخزين الصورة الرمزية","Accounts_BlockedDomainsList":"محظور قائمة المجالات","Accounts_BlockedDomainsList_Description":"قائمة مفصولة بفواصل من المجالات سدت","Accounts_denyUnverifiedEmail":"رفض البريد الإلكتروني لم يتم التحقق منها","Accounts_EmailVerification":"التحقق من البريد الإلكتروني","Accounts_EmailVerification_Description":"تأكد أن لديك إعدادات SMTP الصحيحة لاستخدام هذه الميزة","Accounts_Enrollment_Email":"البريد الإلكتروني E-التحاق","Accounts_Enrollment_Email_Description":"يمكنك استخدام [اسم]، [fname]، [lname] عن الاسم الكامل للمستخدم، الاسم الأول أو اسم العائلة، على التوالي. <br /> يمكنك استخدام [البريد الإلكتروني] للبريد الإلكتروني الخاص بالمستخدم.","Accounts_Iframe_api_method":"الطريقة المعهد","Accounts_Iframe_api_url":"المعهد رابط","Accounts_iframe_enabled":"تمكين","Accounts_iframe_url":"الإطار من رابط","Accounts_LoginExpiration":"انتهاء الصلاحية الدخول في أيام","Accounts_ManuallyApproveNewUsers":"الموافقة على المستخدمين الجدد يدويا","Accounts_OAuth_Custom_Token_Sent_Via":"رمزي المرسلة عن طريق","Accounts_OAuth_Custom_Authorize_Path":"يأذن مسار","Accounts_OAuth_Custom_Button_Color":"زر اللون","Accounts_OAuth_Custom_Button_Label_Color":"زر لون الخط","Accounts_OAuth_Custom_Button_Label_Text":"زر كتابة","Accounts_OAuth_Custom_Enable":"تمكين","Accounts_OAuth_Custom_id":"هوية شخصية","Accounts_OAuth_Custom_Identity_Path":"مسار الهوية","Accounts_OAuth_Custom_Login_Style":"الدخول ستايل","Accounts_OAuth_Custom_Secret":"سر","Accounts_OAuth_Custom_Token_Path":"مسار رمزي","Accounts_OAuth_Custom_URL":"الرابط","Accounts_OAuth_Facebook":"تسجيل الدخول الى الفيسبوك","Accounts_OAuth_Facebook_callback_url":"URL الفيسبوك الاستدعاء","Accounts_OAuth_Facebook_id":"الفيسبوك معرف التطبيق","Accounts_OAuth_Facebook_secret":"الفيسبوك السرية","Accounts_OAuth_Github":"أوث ممكن","Accounts_OAuth_Github_callback_url":"URL جيثب الاستدعاء","Accounts_OAuth_GitHub_Enterprise":"أوث ممكن","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL جيثب المؤسسة الاستدعاء","Accounts_OAuth_GitHub_Enterprise_id":"رقم العميل","Accounts_OAuth_Github_id":"رقم العميل","Accounts_OAuth_Github_secret":"سر العميل","Accounts_OAuth_Gitlab":"أوث ممكن","Accounts_OAuth_Gitlab_callback_url":"URL GitLab الاستدعاء","Accounts_OAuth_Gitlab_id":"GitLab رقم","Accounts_OAuth_Gitlab_secret":"سر العميل","Accounts_OAuth_Google":"جوجل الدخول","Accounts_OAuth_Google_callback_url":"عنوان البريد الإلكتروني الاستدعاء","Accounts_OAuth_Google_id":"جوجل إيد","Accounts_OAuth_Google_secret":"جوجل السري","Accounts_OAuth_Linkedin":"ينكدين الدخول","Accounts_OAuth_Linkedin_callback_url":"URL تابعني على الاستدعاء","Accounts_OAuth_Linkedin_id":"ينكدين رقم","Accounts_OAuth_Linkedin_secret":"ينكدين السرية","Accounts_OAuth_Meteor":"نيزك الدخول","Accounts_OAuth_Meteor_callback_url":"URL نيزك الاستدعاء","Accounts_OAuth_Meteor_id":"نيزك رقم","Accounts_OAuth_Meteor_secret":"نيزك السرية","Accounts_OAuth_Twitter":"تويتر الدخول","Accounts_OAuth_Twitter_callback_url":"URL تويتر الاستدعاء","Accounts_OAuth_Twitter_id":"تويتر إيد","Accounts_OAuth_Twitter_secret":"تويتر السرية","Accounts_OAuth_Wordpress":"وورد اسم الدخول","Accounts_OAuth_Wordpress_callback_url":"URL ورد الاستدعاء","Accounts_OAuth_Wordpress_id":"وورد إيد","Accounts_OAuth_Wordpress_secret":"وورد السرية","Accounts_PasswordReset":"إعادة تعيين كلمة السر","Accounts_Registration_AuthenticationServices_Enabled":"تسجيل مع خدمات المصادقة","Accounts_RegistrationForm":"استمارة التسجيل","Accounts_RegistrationForm_Disabled":"معطل","Accounts_RegistrationForm_LinkReplacementText":"نص نموذج التسجيل رابط بديل","Accounts_RegistrationForm_Public":"عام","Accounts_RegistrationForm_Secret_URL":"رابط سري","Accounts_RegistrationForm_SecretURL":"رابط استمارة التسجيل السري","Accounts_RegistrationForm_SecretURL_Description":"يجب توفير سلسلة العشوائية التي ستضاف إلى URL تسجيلك. على سبيل المثال: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"التسجيل مطلوب","Accounts_RequireNameForSignUp":"تتطلب اسم للاشتراك","Accounts_ShowFormLogin":"يستند النموذج مشاهدة الدخول","Accounts_UseDefaultBlockedDomainsList":"استخدام الافتراضي محظور قائمة المجالات","Accounts_UseDNSDomainCheck":"استخدام المجال DNS تحقق","Activate":"تفعيل","Activity":"نشاط","Add":"إضافة","Add_agent":"أضف وكيل","Add_custom_oauth":"إضافة أوث مخصصة","Add_manager":"أضف مدير","Add_Members":"إضافة الأعضاء","Add_User":"إضافة مستخدم","Add_user":"إضافة مستخدم","Add_users":"إضافة مستخدمين","Additional_emails":"عناوين إلكترونية إضافية","Additional_Feedback":"ملاحظات إضافية","Administration":"الإدارة","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"بعد المصادقة في OAuth2، سيتم إعادة توجيه المستخدمين إلى هذا الرابط","Agent_added":"تمت إضافة الوكيل","Agent_removed":"تمت إزالة الوكيل","Alias":"الاسم المستعار","All":"الكل","All_channels":"جميع القنوات","All_logs":"كل السجلات","All_messages":"كل الرسائل","Allow_Invalid_SelfSigned_Certs":"موقعة ذاتيا غير صالح للسماح موتس","Allow_Invalid_SelfSigned_Certs_Description":"السماح لشهادة SSL غير صحيحة وموقعة ذاتيا للتأكد من صحة الرابط ومعاينات.","and":"و","And_more":"وأكثر من ذلك __length __...","Animals_and_Nature":"حيوانات و طبيعة","API":"API","API_Analytics":"التحليلات","API_Embed":"تضمين","API_EmbedDisabledFor":"تضمين تعطيل للمستخدمين","API_EmbedDisabledFor_Description":"قائمة مفصولة بفواصل من أسماء المستخدمين","API_GitHub_Enterprise_URL":"URL الخادم","API_GitHub_Enterprise_URL_Description":"مثال: http://domain.com (بدون الشرطة المائلة في الأخير)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"URL ورد","Appearance":"مظهر","Application_added":"تم إضافة التطبيق","Application_Name":"اسم التطبيق","Application_updated":"تحديث التطبيق","Apply_and_refresh_all_clients":"تطبيق وتحديث كافة عملاء","Archive":"الأرشيف","Archive_Unarchive":"أرشفة/إلغاء الأرشفة","are_also_typing":"هم أيضا يكتبون","are_typing":"يكتبون","Are_you_sure":"هل أنت متأكد؟","Are_you_sure_you_want_to_delete_your_account":"هل أنت متأكد من أنك تريد حذف حسابك؟","Authorization_URL":"URL التخويل","Authorize":"يأذن","AutoLinker_StripPrefix":"AutoLinker قطاع البادئة","AutoLinker_StripPrefix_Description":"عرض قصير. على سبيل المثال https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL التعبير منتظم","AutoLinker_Email":"AutoLinker البريد الإلكتروني","AutoLinker_Phone":"AutoLinker الهاتف","AutoLinker_Phone_Description":"ترتبط آليا عن أرقام الهاتف. على سبيل المثال `(123) 456-7890`","Auto_Load_Images":"تحميل تلقائي للصور","Available":"متاح","Available_agents":"الوكلاء الموجودون","Avatar":"تغيير الصورة الرمزية","Avatar_changed_successfully":"تم تغيير الصورة الرمزية بنجاح","Avatar_URL":"الصورة الرمزية URL","Avatar_url_invalid_or_error":"عنوان الموقع شريطة أن يكون غير صالح أو لا يمكن الوصول إليها. يرجى المحاولة مرة أخرى، ولكن مع رابط مختلفة.","away":"بعيد","Away":"بعيد","away_female":"بعيدة","Away_female":"بعيدة","away_male":"بعيد","Away_male":"بعيد","Back":"العودة","Back_to_applications":"العودة إلى التطبيقات","Back_to_integrations":"العودة إلى التكامل","Back_to_login":"العودة إلى تسجيل الدخول","Back_to_permissions":"العودة إلى التصريحات","Body":"الجسم","bold":"عريض","busy":"مشغول","Busy":"مشغول","busy_female":"مشغولة","Busy_female":"مشغولة","busy_male":"مشغول","Busy_male":"مشغول","Cancel":"إلغاء","Cannot_delete_a_protected_role":"لا يمكنك حذف دور محمية","Cannot_delete_role_because_its_in_use":"لا يمكن حذف دور لأنه في استخدام","Cannot_invite_users_to_direct_rooms":"لا يمكن دعوة المستخدمين إلى غرف توجيه","CDN_PREFIX":"كندي البادئة","Certificates_and_Keys":"شهادات ومفاتيح","Channel":"قناة","Channel_doesnt_exist":"القناة '#%s' غير موجودة.","Channels":"القنوات","Channels_list":"قائمة القنوات العامة","Chat_Rooms":"غرف المحادثة","Chatops_Enabled":"تمكين Chatops","Chatops_Title":"لوحة Chatops","Chatops_Username":"Chatops اسم المستخدم","Choose_a_room":"اختيار غرفة","Choose_messages":"اختر الرسائل","Choose_the_alias_that_will_appear_before_the_username_in_messages":"اختيار الاسم المستعار الذي سيمثل أمام اسم المستخدم في الرسائل.","Choose_the_username_that_this_integration_will_post_as":"اختيار اسم المستخدم أن هذا التكامل سوف منصب.","Clear_all_unreads_question":"مسح كافة الغير مقروءة؟","Client_ID":"معرف العميل","Client_Secret":"سر العميل","Clients_will_refresh_in_a_few_seconds":"سوف عملاء تجديد في بضع ثوان","close":"غلق","Closed":"مغلق","Collapse_Embedded_Media_By_Default":"طي سائل الإعلام جزءا لا يتجزأ من افتراضيا","coming_soon":"قريبا","Commands":"الأوامر","Compact_View":"عرض متراص","Confirm_password":"تأكيد كلمة السر","Contact":"اتصال","Conversation":"محادثة","Convert_Ascii_Emojis":"حول محارف الأسكي إلى اموجي","Copied":"نسخ","COPY_TO_CLIPBOARD":"نسخ","Copy_to_clipboard":"نسخ إلى الحافظة","Count":"عد","Create":"خلق","Create_new":"إنشاء جديد","Created_at":"أنشئت في","Created_at_s_by_s":"أنشئت <strong>في %s</strong> <strong>بواسطة %s</strong>","Custom_Fields":"الحقول المخصصة","Custom_oauth_helper":"عند إعداد مزود أوث الخاص بك، سيكون لديك لإبلاغ URL الاستدعاء. استعمال <pre style=\";text-align:right;direction:rtl\"> ٪ الصورة </pre> .","Custom_oauth_unique_name":"اسم فريد أوث مخصص","Custom_Script_Logged_In":"سيناريو المخصصة لتسجيل الدخول للمستخدمين","Custom_Script_Logged_Out":"سيناريو مخصصة للمستخدمين تسجيل الخروج","Dashboard":"لوحة القيادة","days":"أيام","Deactivate":"تعطيل","Debug_Level":"التصحيح مستوى","Default":"افتراضي","Delete":"حذف","Delete_my_account":"حذف حسابي","Delete_Room_Warning":"حذف الغرفة، يحذف جميع الرسائل المرسلة داخل الغرفة.، هذا لا يمكن التراجع عنه.","Delete_User_Warning":"سوف حذف مستخدم حذف كل الرسائل من هذا المستخدم أيضا. هذا لا يمكن التراجع عنها.","Deleted":"تم الحذف!","Department_not_found":"قسم غير موجود","Department_removed":"قسم إزالة","Departments":"الأقسام","Description":"الوصف","Desktop":"سطح المكتب","Desktop_Notification_Test":"اختبار تنبيهات سطح المكتب","Desktop_Notifications":"تنبيهات سطح المكتب","Desktop_Notifications_Disabled":"تنبيهات سطح المكتب معطلة. قم بتغيير إعدادات المتصفح إذا أردت تفعيلها.","Desktop_Notifications_Enabled":"تنبيهات سطح المكتب مفعلة","Direct_message_someone":"رسالة شخص المباشر","Direct_Messages":"الرسائل المباشرة","Direct_Messages_list":"الرسائل الخاصة","Disable_Favorite_Rooms":"تعطيل المفضلة","Disable_New_Message_Notification":"تعطيل التنبيه عن رسالة جديدة","Disable_New_Room_Notification":"تعطيل التنبيهات الجديدة في الغرفة","Displays_action_text":"نص العمل يعرض","Do_you_want_to_change_to_s_question":"هل تريد التغيير إلى <strong>%s</strong>؟","Drop_to_upload_file":"إسقاط لتحميل الملف","Dry_run":"تنفيذ تجريبي","Dry_run_description":"سيتم إرسال رسالة بريدية واحدة إلى نفس العنوان الموجود في خانة \"من\". تأكد من كون ذلك العنوان البريدي فعال","Duplicate_archived_channel_name":"توجد قناة مؤرشفة باسم '%s'","Duplicate_archived_private_group_name":"توجد مجموعة خاصة مؤرشفة باسم '%s'","Duplicate_private_group_name":"توجد مجموعة خاصة باسم '%s'","E-mail":"البريد اﻹلكتروني","Edit":"تعديل","Edit_Custom_Field":"تحرير حقل مخصص","Edit_Department":"وزارة تحرير","edited":"تم العديل","Email":"البريد الإلكتروني","Email_already_exists":"البريد الالكتروني موجود مسبقا","Email_body":"هيئة البريد الإلكتروني","Email_Change_Disabled":"تم تعطيل المسؤول Rocket.Chat الخاص بك تغيير البريد الإلكتروني","Email_from":"من","Email_Notification_Mode":"تنبيهات البريد الإلكتروني","Email_Notification_Mode_All":"كل الرسائل الخاصة و التنويهات","Email_Notification_Mode_Disabled":"معطلة","Email_or_username":"البريد الإلكتروني أو اسم المستخدم","Email_subject":"الموضوع","Email_verified":"تم التحقق من البريد الإلكتروني","Emoji":"رمز تعبيري (اموجي)","Empty_title":"عنوان فارغ","Enable":"تمكين","Enable_Desktop_Notifications":"تفعيل تنبيهات سطح المكتب","Enabled":"مفعل","Encrypted_message":"رسالة مشفرة","End_OTR":"إنهاء المحادثة السرية","Enter_a_regex":"أدخل التعابير المنطقية","Enter_a_room_name":"أدخل اسم الغرفة","Enter_a_username":"أدخل اسم المستخدم","Enter_info":"ادخل المعلومات الخاصة بك","Enter_name_here":"أدخل اسم هنا","Enter_to":"ادخل الى","Error":"خطأ","error-cant-invite-for-direct-room":"لا يمكن دعوة المستخدم إلى غرف المباشرة","error-duplicate-channel-name":"توجد قناة باسم '%s'","error-invalid-custom-field":"حقل مخصص غير صالح","error-invalid-custom-field-name":"اسم الحقل المخصص غير صالح. استخدام حروف أو أرقام أو الواصلات والشرطات السفلية.","error-invalid-password":"كلمة مرور غير صالحة","error-invalid-room":"غرفة غير صالحة","error-invalid-room-name":"<strong> %s</strong> ليس اسما غرفة صحيح، <br/> استخدام حروف أو أرقام أو الواصلات والشرطات","error-invalid-user":"مستخدم غير صالح","error-invalid-username":"اسم المستخدم غير صالح","error-not-allowed":"غير مسموح","error-not-authorized":"غير مخول","error-remove-last-owner":"هذا هو صاحب الماضي. يرجى تحديد المالك الجديد قبل إزالة هذه واحدة.","error-role-name-required":"مطلوب اسم الدور","error-user-not-in-room":"المستخدم ليس في هذه الغرفة","Error_changing_password":"خطأ في تغيير كلمة السر","Error_sending_confirmation_email":"خطأ أثناء إرسال رسالة تأكيد بالبريد الإلكتروني","Error_too_many_requests":"خطأ، الكثير من الطلبات. من فضلك أبطء السرعة. عليك الانتظار %s ثانية قبل المحاولة مرة أخرى","Esc_to":"خروج ل","Example_s":"على سبيل المثال: <code class=\"inline\">%s</code>","False":"لا","Favorites":"المفضلة","Field":"حقل","Field_removed":"إزالة الميدان","File_exceeds_allowed_size_of_bytes":"يتجاوز حجم الملف المسموح به بايت __size__","FileUpload":"تحميل الملف","FileUpload_Enabled":"تحميل الملفات مفعلة","FileUpload_File_Empty":"ملف فارغ","FileUpload_FileSystemPath":"مسار النظام","FileUpload_MaxFileSize":"الحد الأقصى لتحميل الملف الحجم (بايت)","FileUpload_MediaType_NotAccepted":"أنواع وسائل الإعلام ليس مقبول","FileUpload_MediaTypeWhiteList":"أنواع الوسائط المقبولة","FileUpload_MediaTypeWhiteListDescription":"قائمة أنواع وسائل الإعلام مفصولة بفواصل. اتركه فارغا لقبول جميع أنواع وسائل الإعلام.","FileUpload_ProtectFiles":"حماية الملفات المحملة","FileUpload_ProtectFilesDescription":"سوف فقط المستخدمين المصادق عليهم الوصول","FileUpload_S3_Acl":"الأمازون S3 دوري أبطال آسيا","FileUpload_S3_AWSAccessKeyId":"الأمازون S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"الأمازون S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"الأمازون S3 اسم دلو","FileUpload_S3_BucketURL":"URL دلو","FileUpload_S3_CDN":"نطاق كندي للتنزيل","FileUpload_S3_Region":"منطقة","FileUpload_Storage_Type":"نوع التخزين","Flags":"أعلام","Follow_social_profiles":"اتبع محات اجتماعية لدينا، مفترق لنا على جيثب وتبادل الأفكار حول التطبيق rocket.chat على متن trello لدينا.","Food_and_Drink":"طعام و مشروبات","For_your_security_you_must_re_enter_your_password_to_continue":"ﻷسباب أمنية، عليك إعادة إدخال كلمة المرور للمتابعة","Force_SSL":"قوة SSL","Force_SSL_Description":"* الحذر! * لا ينبغي أبدا أن تستخدم _Force SSL_ مع وكيل عكسي. إذا كان لديك وكيل عكسي، يجب القيام إعادة التوجيه هناك. يوجد هذا الخيار لنشر مثل Heroku، لا يسمح التكوين إعادة توجيه في كيل عكسي.","Forgot_password":"نسيت كلمة السر","Fork_it_on_github":"مفترق على جيثب","Frequently_Used":"الأكثر استعمالا","From":"من","From_Email":"من البريد الإلكتروني","From_email_is_required":"من هو مطلوب البريد الإلكتروني","From_email_warning":"<b>تحذير:</b> حقل <b>من</b> يخضع لإعدادات خادم البريد الخاص بك.","General":"العامة","Get_to_know_the_team":"تعرف على Rocket.Team","github_no_public_email":"ليس لديك أي بريد الإلكتروني عام في حسابك على Github","Give_a_unique_name_for_the_custom_oauth":"تعطي اسما فريدا لأوث مخصصة","Give_the_application_a_name_This_will_be_seen_by_your_users":"إعطاء التطبيق اسما. وسوف يظهر هذا من قبل المستخدمين.","Global":"عالمي","GoogleTagManager_id":"جوجل مدير العلامات معرف","Has_more":"يوجد المزيد","Have_your_own_chat":"هل لديك الدردشة على شبكة الإنترنت الخاصة بك. وضعت مع Meteor.com، وRocket.Chat هو حل كبير للمطورين نتطلع لبناء وتتطور على منصة الدردشة الخاصة.","Header":"رأس","Hidden":"مخفي","Hide_Group_Warning":"هل أنت متأكد من أنك تريد إخفاء المجموعة \"%s\"؟","Hide_Private_Warning":"هل أنت متأكد من أنك تريد إخفاء المحادثة مع \"%s\"؟","Hide_room":"إخفاء الغرفة","Hide_Room_Warning":"هل أنت متأكد من أنك تريد إخفاء الغرفة \"%s\"؟","Highlights":"التظليل","Highlights_How_To":"إذا أردت أن يتم تنبيهك عندما يذكر احدهم كلمة ما أضفها هنا. قم بفصل الكلمات بفاصلة ,  الكلمات الأعجمية المظللة لا تتأثر بحالة الحرف (صغير أو كبير).","Highlights_List":"تظليل الكلمات","History":"تاريخ","hours":"ساعة","How_friendly_was_the_chat_agent":"كيف ودية وكان وكيل الدردشة؟","How_knowledgeable_was_the_chat_agent":"معرفة كيف كان وكيل الدردشة؟","How_responsive_was_the_chat_agent":"كيف تستجيب كان وكيل الدردشة؟","How_satisfied_were_you_with_this_chat":"ما مدى رضاك ​​مع هذه الدردشة؟","If_you_are_sure_type_in_your_password":"إدا كنت متأكد أدخل كلمة المرور الخاصة بك:","If_you_are_sure_type_in_your_username":"إذا كنت متأكدا من نوع في اسم المستخدم الخاص بك:","Importer_Archived":"مؤرشفة","Importer_done":"استيراد كاملة!","Importer_finishing":"حتى الانتهاء من الاستيراد.","Importer_From_Description":"واردات __from البيانات __ الصورة في Rocket.Chat.","Importer_import_cancelled":"إلغاء الاستيراد.","Importer_import_failed":"حدث خطأ أثناء تشغيل الاستيراد.","Importer_importing_channels":"استيراد القنوات.","Importer_importing_messages":"استيراد الرسائل","Importer_importing_started":"بدء عملية الاستيراد.","Importer_importing_users":"استيراد المستخدمين.","Importer_not_defined_properly":"لم يتم تعريف المستورد بشكل صحيح، أنه يفتقد الطبقة استيراد.","Importer_not_in_progress":"المستورد لا يعمل حاليا.","Importer_Prepare_Restart_Import":"استئناف استيراد","Importer_Prepare_Start_Import":"بدء استيراد","Importer_Prepare_Uncheck_Archived_Channels":"القنوات الأرشيف ازل","Importer_Prepare_Uncheck_Deleted_Users":"المستخدمين قم بإلغاء التحديد محذوفة","Importer_progress_error":"فشل في الحصول على التقدم للاستيراد.","Importer_setup_error":"حدث خطأ أثناء إعداد المستورد.","Incorrect_Password":"كلمة السر غير صحيحة","inline_code":"نص_برمجي","Install_Extension":"تثبيت التمديد","Install_FxOs":"تثبيت Rocket.Chat على فايرفوكس","Install_FxOs_done":"عظيم! يمكنك الآن استخدام Rocket.Chat عبر أيقونة على الشاشة الرئيسية الخاصة بك. نلهو مع Rocket.Chat!","Install_FxOs_error":"عذرا، لم ينجح على النحو المنشود! ظهر الخطأ التالي:","Install_FxOs_follow_instructions":"الرجاء التأكد من تثبيت التطبيق على جهازك (اضغط على \"تثبيت\" عندما دفع).","Installation":"تركيب","Integration_added":"تمت إضافة التكامل","Integration_Incoming_WebHook":"واردة التكامل WebHook","Integration_New":"التكامل الجديد","Integration_Outgoing_WebHook":"المنتهية ولايته التكامل WebHook","Integration_updated":"تم تحديث التكامل","Integrations":"التكامل","Invalid_asset":"الأصول غير صالح","Invalid_confirm_pass":"تأكيد كلمة السر لا تطابق كلمة السر","Invalid_email":"البريد الإلكتروني المدخل غير صحيح","Invalid_Export_File":"الملف الذي تم تحميله ليس ملف التصدير٪ صالحة الصورة.","Invalid_file_height":"ارتفاع ملف غير صالح","Invalid_file_type":"نوع الملف غير صالح","Invalid_file_width":"عرض ملف غير صالح","Invalid_Import_File_Type":"نوع ملف استيراد صالح.","Invalid_name":"لا يجب أن يكون الاسم فارغ","Invalid_notification_setting_s":"وضع إشعار صالح:٪ ق","Invalid_pass":"لا يجب أن تكون كلمة السر فارغة","Invalid_room_name":"<strong>%s</strong> لا يصلح كاسم،<br/>استخدم حروفا و أرقاما وشرطات فقط","Invalid_room_type":"<strong>٪ ق</strong> ليس نوع الغرفة صالح.","Invalid_Secret_URL":"URL السري غير صالح","Invalid_secret_URL_message":"عنوان URL المقدمة غير صالح.","invisible":"خفي","Invisible":"خفي","Invitation_HTML":"دعوة HTML","Invitation_Subject":"موضوع الدعوة","Invite_user_to_join_channel":"دعوة مستخدم واحد لهذه القناة","Invite_Users":"دعوة المستخدمين","is_also_typing":"هو أيضا يكتب","is_also_typing_female":"هي أيضا تكتب","is_also_typing_male":"هو أيضا يكتب","is_typing":"يكتب","is_typing_female":"تكتب","is_typing_male":"يكتب","italics":"مائل","join":"انضم","Join_audio_call":"انضم للاتصال الصوتي","Join_the_Community":"إنظم للمجتمع","Join_the_given_channel":"انضم للقناة","Join_video_call":"انضم للاتصال المرئي","Joined":"المنضم إليها","Jump":"الانتقال السريع ل","Jump_to_first_unread":"الذهاب إلى أول رسالة غير مقرؤة","Jump_to_message":"القفز إلى الرسالة","Jump_to_recent_messages":"اذهب إلى الرسائل الأخيرة","Katex_Enabled":"كاتكس ممكن","Label":"ملصق","Language":"اللغة","Language_Version":"النسخة الإنجليزية","Last_login":"آخر تسجيل دخول","Last_message":"آخر رسالة","Last_seen":"آخر مشاهدة","Layout":"التصميم","Layout_Home_Body":"الصفحة الرئيسية الجسم","Layout_Home_Title":"عنوان الصفحة الرئيسية","Layout_Login_Terms":"شروط الدخول","Layout_Privacy_Policy":"سياسة الخصوصية","Layout_Sidenav_Footer":"الجانب الإنتقال تذييل","Layout_Sidenav_Footer_description":"حجم تذييل هو 260 س 70px","Layout_Terms_of_Service":"شروط الخدمة","LDAP":"LDAP","LDAP_CA_Cert":"CA سيرت","LDAP_Custom_Domain_Search":"البحث المجال مخصص","LDAP_Custom_Domain_Search_Description":"قطعة من JSON الذي يحكم ربط واتصال من المعلومات وهو النموذج: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"المجال الافتراضي","LDAP_Description":"LDAP هي قاعدة بيانات هرمية التي تستخدم العديد من الشركات لتقديم إشارة واحدة على - مرفق لتقاسم كلمة مرور واحدة بين المواقع وخدمات متعددة. للحصول على معلومات التكوين المتقدمة والأمثلة، يرجى الرجوع لدينا ويكي: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"قاعدة المجال","LDAP_Domain_Base_Description":"اسم المؤهل بالكامل المميز (DN) من الشجرة الفرعية LDAP تريد البحث للمستخدمين والمجموعات. يمكنك إضافة ما تريد. ومع ذلك، يجب أن تحدد كل مجموعة في قاعدة نطاق نفس المستخدمين التي تنتمي إليها. إذا قمت بتحديد مجموعات المستخدمين المحظورة، وفقط للمستخدمين الذين ينتمون لتلك الجماعات أن يكون في نطاق. نوصي تحديد المستوى الخاص بك شجرة دليل LDAP كقاعدة المجال الخاص بك واستخدام فلتر البحث للتحكم في الوصول.","LDAP_Domain_Search_Filter":"نطاق البحث تصفية","LDAP_Domain_Search_Filter_Description":"إذا كان سيتم السماح محددة، فقط للمستخدمين تطابق هذا المرشح لتسجيل الدخول. إذا لم يتم تحديد مرشح، جميع المستخدمين ضمن نطاق قاعدة المجال المحدد سوف تكون قادرة على تسجيل الدخول. <br/> على سبيل المثال ل Active Directory `memberOf = CN = ROCKET_CHAT، أوو = العام Groups`. <br/> على سبيل المثال لب OpenLDAP (للمد بحث مباراة) `أوو: DN: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"المجال كائن البحث التصنيف","LDAP_Domain_Search_Object_Category_Description":"و* objectCategory * أن تحديد المستخدمين. <br/> اتركه فارغا ل* ب OpenLDAP *. <br/> على سبيل المثال `person`، الخ","LDAP_Domain_Search_Object_Class":"نطاق فئة كائن البحث","LDAP_Domain_Search_Object_Class_Description":"و* objectclass * أن تحديد المستخدمين. <br/> على سبيل المثال `organizationalPerson`،` user`، `inetOrgPerson`، الخ","LDAP_Domain_Search_Password":"بحث نطاق كلمة المرور","LDAP_Domain_Search_Password_Description":"كلمة السر للمستخدم البحث المجال.","LDAP_Domain_Search_User":"نطاق البحث العضو","LDAP_Domain_Search_User_Description":"المستخدم LDAP التي تنفذ عمليات البحث المستخدم لمصادقة المستخدمين الآخرين عند تسجيل الدخول. <br/> هذا هو عادة حساب خدمة أنشئت خصيصا لالتكامل طرف ثالث. استخدام اسم مؤهل بشكل كامل، مثل `CN = مسؤول، CN = المستخدمين، DC = المثال، DC = com`.","LDAP_Domain_Search_User_ID":"بحث نطاق هوية المستخدم","LDAP_Domain_Search_User_ID_Description":"السمة LDAP أن يحدد المستخدم LDAP الذي يحاول المصادقة. وينبغي أن يكون هذا المجال `sAMAccountName` للمنشآت الأكثر نشاطا دليل، ولكنه قد يكون` uid` عن حلول LDAP الأخرى، مثل ب OpenLDAP. يمكنك استخدام `mail` لتعريف المستخدمين عن طريق البريد الإلكتروني أو أيا كان السمة التي تريد. <br> يمكنك استخدام قيم متعددة مفصولة بفواصل للسماح للمستخدمين تسجيل الدخول باستخدام معرفات متعددة مثل اسم المستخدم أو البريد الإلكتروني.","LDAP_Enable":"تفعيل","LDAP_Enable_Description":"محاولة استخدام LDAP للمصادقة.","LDAP_Encryption":"التشفير","LDAP_Encryption_Description":"طريقة التشفير المستخدمة لتأمين الاتصالات إلى خادم LDAP. ومن الأمثلة `plain` (بدون تشفير)،` SSL / LDAPS` (مشفرة من البداية)، و`StartTLS` (الترقية إلى الاتصالات المشفرة مرة واحدة متصلة).","LDAP_Host":"مضيف","LDAP_Host_Description":"المضيف LDAP، على سبيل المثال `ldap.example.com` أو` 10.0.0.30`.","LDAP_Port":"منفذ","LDAP_Port_Description":"ميناء للوصول LDAP. على سبيل المثال: `389` أو` 636` لLDAPS","LDAP_Reject_Unauthorized":"رفض غير مصرح بها","LDAP_Sync_User_Avatar":"تزامن العضو الرمزية","LDAP_Sync_User_Data":"مزامنة البيانات","LDAP_Sync_User_Data_Description":"حافظ على بيانات المستخدم في تزامن مع الخادم على تسجيل الدخول (على سبيل المثال: الاسم، البريد الإلكتروني).","LDAP_Sync_User_Data_FieldMap":"العضو بيانات خريطة الميدان","LDAP_Sync_User_Data_FieldMap_Description":"تكوين كيف يتم ملؤها الحقول حساب المستخدم (مثل البريد الإلكتروني) من مستوى قياسي في LDAP (وجدت مرة واحدة). <br/> وكمثال على ذلك، `{\" CN \":\" اسم \"،\" البريد الإلكتروني \":\" البريد الإلكتروني \"}` سيختار اسم الشخص البشري للقراءة من سمة CN، وبريدهم الإلكتروني من السمة البريد. <br/> وتشمل المجالات المتاحة `name`، و` email`.","LDAP_Sync_Users":"المستخدمين مزامنة","LDAP_Test_Connection":"اختبار الاتصال","LDAP_Unique_Identifier_Field":"معرف الميدان وفريدة من نوعها","LDAP_Unique_Identifier_Field_Description":"التي الحقل سيتم استخدامها لربط المستخدم LDAP والمستخدم Rocket.Chat. يمكنك إبلاغ قيم متعددة مفصولة بفواصل في محاولة للحصول على قيمة من سجل LDAP. <br/> القيمة الافتراضية هي `objectGUID يتم، آي بي إم، entryUUID، GUID، dominoUNID، nsuniqueId، uidNumber`","LDAP_Use_Custom_Domain_Search":"استخدام البحث المجال مخصص","LDAP_Use_Custom_Domain_Search_Description":"إرسال الفلتر الخاص للمستخدمين البحث في خادم LDAP.","LDAP_Username_Field":"اسم المستخدم الميدان","LDAP_Username_Field_Description":"التي المجال سوف تستخدم * اسم المستخدم * للمستخدمين الجدد. اتركه فارغا لاستخدام اسم المستخدم على علم صفحة تسجيل الدخول. <br/> يمكنك استخدام العلامات قالب جدا، مثل `# {givenName} # {التعطيل}`. <br/> القيمة الافتراضية هي `sAMAccountName`.","Leave_Group_Warning":"هل أنت متأكد من أنك تريد مغادرة المجموعة \"%s\"؟","Leave_Private_Warning":"هل أنت متأكد من أنك تريد مغادرة المحادثة مع \"%s\"؟","Leave_room":"مغادرة الغرفة","Leave_Room_Warning":"هل أنت متأكد من أنك تريد مغادرة الغرفة \"%s\"؟","line":"خط","List_of_Direct_Messages":"قائمة الرسائل الخاصة","Live_sessions":"جلسات حية","Livechat_agents":"وكلاء المحادثات الحية","Livechat_Dashboard":"لوحة المحادثات الحية","Livechat_enabled":"تفعيل المحادثات الحية","Livechat_Manager":"مدير المحادثات الحية","Livechat_managers":"مدراء المحادثات الحية","Livechat_title":"عنوان المحادثة الحية","Livechat_title_color":"لون خلفية عنوان المحادثة الحية","Livechat_Users":"مستخدمي المحادثات الحية","Load_more":"اعرض أكثر","Loading...":"تحميل ...","Loading_more_from_history":"تحميل المزيد من التاريخ","Loading_suggestion":"تحميل الاقتراحات ...","Localization":"اللغة","Log_File":"عرض الملفات والخط","Log_Level":"مستوى السجل","Log_Package":"عرض مجموعة","Log_View_Limit":"تسجيل عرض الحد","Logged_out_of_other_clients_successfully":"تم تسجيل الخروج من اﻷجهزة اﻷخرى بنجاح","Login":"تسجيل الدخول","Login_with":"تسجيل الدخول بـ %s","login_with":"أو الدخول مباشرة بـ","Logout":"تسجيل خروج","Logout_Others":"تسجيل الخروج من الأجهزة الأخرى","Mail_Message_Invalid_emails":"لقد قدمت رسائل البريد الإلكتروني واحدة أو أكثر غير صالحة:٪ ق","Mail_Message_Missing_to":"يجب عليك اختيار واحد أو أكثر من المستخدمين أو تقديم واحدة أو أكثر من عناوين البريد الإلكتروني، مفصولة بفواصل.","Mail_Message_No_messages_selected_select_all":"لم تقم بتحديد أي رسالة. هل تريد أن <a href='#' class='select-all'>تحدد جميع</a> الرسائل الظاهرة؟","Mail_Messages":"إرسال الرسائل للبريد الألكتروني","Mail_Messages_Instructions":"حدد الرسائل المراد إرسالها بالبريد الإلكتروني بالضغط على تلك الرسائل","Mail_Messages_Subject":"مجموعة مختارة من رسائل %s","Mailer":"الارسال","Mailer_body_tags":"<b>يجب</b> عليك استخدام [إلغاء الاشتراك] للارتباط إلغاء الاشتراك. <br /> يمكنك استخدام [اسم]، [fname]، [lname] عن الاسم الكامل للمستخدم، الاسم الأول أو اسم العائلة، على التوالي. <br /> يمكنك استخدام [البريد الإلكتروني] للبريد الإلكتروني الخاص بالمستخدم.","Make_Admin":"جعل مدير","Manager_added":"تمت إضافة المدير","Manager_removed":"إزالة مدير","Mark_as_read":"تعليم كمقروء","Markdown_Headers":"رؤوس تخفيض السعر","Markdown_SupportSchemesForLink":"أنظمة دعم تخفيض السعر لينك","Markdown_SupportSchemesForLink_Description":"قائمة مفصولة بفواصل من مخططات سمح","Members_List":"قائمة الأعضاء","Mentions":"تنويهات","Mentions_default":"تنويهات (افتراضي)","Message":"رسالة","Message_AllowDeleting":"السماح بحذف الرسائل","Message_AllowEditing":"السماح بتعديل الرسائل","Message_AllowEditing_BlockEditInMinutes":"امنع تعديل الرسائل بعد هذا العدد من الدقائق","Message_AllowEditing_BlockEditInMinutesDescription":"أدخل 0 لتعطيل الحظر.","Message_AllowPinning":"السماح بتثبيت الرسائل","Message_AllowPinning_Description":"السماح رسائل يتم معلقة على أي من القنوات.","Message_AllowStarring":"السماح رسالة بطولة","Message_AudioRecorderEnabled":"تسجيل أغنية ممكن","Message_AudioRecorderEnabledDescription":"يتطلب '/ WAV الصوت \"الملفات إلى أن يكون نوع وسائط المقبولة في إعدادات' ملف تحميل\".","Message_DateFormat":"صيغة التاريخ","Message_DateFormat_Description":"انظر أيضا: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"حذف الرسائل غير مسموح","Message_editing_blocked":"لا يمكن تعديل هذه الرسالة بعد الآن","Message_editing_not_allowed":"تعديل الرسائل غير مسموح","Message_GroupingPeriod":"تجمع الفترة (بالثواني)","Message_GroupingPeriodDescription":"سيتم تجميع الرسائل مع الرسالة السابقة إذا كان كلاهما من نفس المستخدم والوقت المنقضي كان أقل من الوقت مستنير في ثوان.","Message_KeepHistory":"إبقاء محفوظات الرسائل","Message_MaxAllowedSize":"الحجم الأقصى المسموح للرسالة","Message_MaxAll":"الحد الأقصى لحجم قناة لجميع رسالة","Message_pinned":"تم تثبيث الرسالة","Message_pinning_not_allowed":"تثبيث الرسائل غير مسموح","Message_removed":"تم حذف الرسالة","Message_ShowDeletedStatus":"عرض حالة التعديل","Message_ShowEditedStatus":"عرض حالة الحذف","Message_ShowFormattingTips":"اظهار نصائح التنسيق","Message_TimeFormat":"تنسيق الوقت","Message_TimeFormat_Description":"انظر أيضا: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"رسالة طويلة جدا","Messages":"الرسائل","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"وسوف يتم نشر الرسائل التي يتم إرسالها إلى الواردة WebHook هنا.","Meta":"ميتا","Meta_fb_app_id":"معرف تطبيق الفيسبوك","Meta_google-site-verification":"التأكيد موقع Google","Meta_language":"اللغة","Meta_msvalidate01":"MSValidate.01","Meta_robots":"الروبوتات","minutes":"دقيقة","Mobile_push":"دفع المحمول","More_channels":"المزيد من القنوات","More_direct_messages":"المزيد من الرسائل الخاصة","More_groups":"المزيد من المجموعات الخاصة","More_unreads":"المزيد غير مقروءة","Msgs":"رسائل","multi":"متعدد","Mute_someone_in_room":"إسكات شخص في الغرفة","Mute_user":"اسكات المستخدم","Muted":"صامتة","My_Account":"حسابي","n_messages":"%s رسائل","N_new_messages":"%s رسالة جديدة","Name":"الإسم","Name_cant_be_empty":"اﻹسم لا يمكن أن يكون فارغا","Name_of_agent":"اسم الوكيل","Name_optional":"اﻹسم (اختياري)","Navigation_History_20_last_pages":"الإنتقال التاريخ (20 صفحة الأخيرة)","New_Application":"تطبيق جديد","New_Custom_Field":"حقل مخصص جديد","New_Department":"الإدارة الجديدة","New_integration":"التكامل الجديد","New_logs":"سجلات جديدة","New_messages":"رسائل جديدة","New_password":"كلمة سر جديدة","New_role":"دور جديد","No_channel_with_name_%s_was_found":"لا توجد قناة باسم <strong>\"%s\"</strong>","No_channels_yet":"لست جزء من أي قناة حتى الآن.","No_direct_messages_yet":"لم تبدأ أي محادثات حتى الآن.","No_Encryption":"لا التشفير","No_favorites_yet":"لم تقم بإضافة مفضلات بعد.","No_group_with_name_%s_was_found":"لا توجد مجموعة خاصة باسم <strong>\"%s\"</strong>","No_groups_yet":"لا يوجد لديك مجموعات خاصة حتى الآن.","No_livechats":"ليس لديك محادثات حية","No_mentions_found":"لا يوجد تنويهات","No_permission_to_view_room":"ليس لديك صلاحية لرؤية هذه الغرفة","No_pinned_messages":"لا توجد رسائل مثبتة","No_results_found":"لا توجد نتائج","No_starred_messages":"لا توجد رسائل مميزة","no_tokens_for_this_user":"لا توجد الرموز لهذا المستخدم","No_user_with_username_%s_was_found":"لا يوجد مستخدم باسم <strong>\"%s\"</strong>","Not_allowed":"غير مسموح","Not_authorized":"غير مصرح","Not_Available":"غير متاح","Not_found_or_not_allowed":"غير موجود أو غير مسموح","Nothing":"لا شيء","Nothing_found":"لا يوجد شيء","Notifications":"الإشعارات","Notify_all_in_this_room":"إخطار جميع من في هذه الغرفة","Num_Agents":"وكلاء","Number_of_messages":"عدد الرسائل","OAuth_Application":"أوث التطبيق","OAuth_Applications":"تطبيقات أوث","Objects":"أشياء","Off_the_record_conversation":"خارج على تسجيل المحادثة","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"المحادثة السرية غير متوفرة لمتصفحك أو جهازك","Offline_DM_Email":"[__site__] لقد تم بعث برسالة مباشرة من قبل __user__","Offline_Mention_Email":"[__site__] تم التنويه باسمك بواسطة __user__ في #__room__","Old_and_new_password_must_be_different":"كلمة المرور الجديدة يجب أن تكون مختلفة عن القديمة","Old_and_new_password_required":"تحتاج إلى كتابة كلمة السر القديمة والجديدة لتغيير كلمة السر الخاصة بك.","Online":"متواجد","Only_errors":"أخطاء فقط","Only_you_can_see_this_message":"يمكنك أنت فقط رؤية هذه الرسالة","Oops!":"عذرا","Open":"فتح","Opened":"افتتح","Opt_out_statistics":"لا ترسل إحصاءات الموقع لRocket.Chat","Opt_out_statistics_warning":"عن طريق إرسال الإحصاءات الخاصة بك، عليك أن تساعدنا على تحديد كيف تنتشر حالات كثيرة من Rocket.Chat، وكذلك كيف جيدة يتصرف النظام، حتى نتمكن من مواصلة تحسين ذلك. لا داعي للقلق، كما يتم إرسال أية معلومات المستخدم وتحفظ جميع المعلومات التي نتلقاها سرية. إذا كنت ترغب في الاستمرار في ارسال لنا الإحصاءات الخاصة بك، قم بإلغاء تحديد خانة أعلاه. شكرا.","optional":"اختياري","Order":"طلب","OS_Arch":"بنية النظام","OS_Cpus":"عدد أنوية النظام","OS_Freemem":"الذاكرة الحرة","OS_Loadavg":"متوسط التحميل","OS_Platform":"منصة النظام","OS_Release":"إصدار النظام","OS_Totalmem":"نظام التشغيل الذاكرة مجموع","OS_Type":"نوع النظام","OS_Uptime":"نظام التشغيل الجهوزية","others":"آخرون","OTR":"محادثة سرية","OTR_is_only_available_when_both_users_are_online":"المحادثة السرية ممكنة فقط في حال تواجد كلا الطرفين","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL تجاوز إلى التي يتم تحميل الملفات. يعطى هذا الرابط تستخدم أيضا لتحميل ما لم كندي","Password":"كلمة السر","Password_Change_Disabled":"مدير الموقع منع تغيير كلمة السر","Password_changed_successfully":"تم تغيير كلمة السر بنجاح","Payload":"الحمولة","People":"الناس","Permissions":"التصريحات","Pin_Message":"تثبيث الرسالة","Pinned_a_message":"دبس رسالة:","Pinned_Messages":"رسائل مثبتة","Placeholder_for_email_or_username_login_field":"نائب عن البريد الإلكتروني أو تسجيل الدخول باسم المستخدم المجال","Placeholder_for_password_login_field":"نائب عن مجال تسجيل الدخول كلمة المرور","Please_answer_survey":"يرجى ان نتوقف لحظة للرد على مسح سريع حول هذه الدردشة","Please_enter_value_for_url":"الرجاء إدخال قيمة للرابط من صورتك.","Please_enter_your_new_password_below":"الرجاء إدخال كلمة المرور الجديدة أدناه:","Please_fill_a_label":"يرجى ملء التسمية","Please_fill_a_name":"الرجاء تعبئة اسم","Please_fill_a_username":"يرجى ملء اسم المستخدم","Please_fill_name_and_email":"الرجاء تعبئة اسم والبريد الإلكتروني","Please_re_enter_your_password":"الرجاء إعادة إدخال كلمة المرور","Please_select_enabled_yes_or_no":"الرجاء تحديد خيار لتمكين","Please_wait":"يرجى الانتظار","Please_wait_activation":"يرجى الانتظار، قد يستغرق بعض الوقت.","Please_wait_statistics":"يرجى الانتظار إلى أن يتم حساب الإحصائيات","Please_wait_while_OTR_is_being_established":"الرجاء الانتظار بينما يتم إعداد المحادثة السرية","Please_wait_while_your_account_is_being_deleted":"الرجاء اﻹنتظار جاري حذف حسابك....","Please_wait_while_your_profile_is_being_saved":"الرجاء اﻹنتظار ... جاري حفظ ملفك الشخصي...","Post_as":"منصب","Post_to_Channel":"أضف إلى القناة","Post_to_s_as_s":"آخر <strong>إلى %s</strong> <strong>ك %s</strong>","Powered_by":"مشغل بواسطة","Preferences":"التفضيلات","Preferences_saved":"تم حفظ التفضيلات","Privacy":"الخصوصية","Private_Group":"مجموعة خاصة","Private_Groups":"مجموعات خاصة","Private_Groups_list":"قائمة المجموعات الخاصة","Profile":"الملف الشخصي","Profile_saved_successfully":"تم حفظ الملف الشخصي بنجاح","Proudly_developed":"وضعت بفخر مع النيزك","Push":"إدفع","Push_apn_cert":"APN سيرت","Push_apn_dev_cert":"APN ديف سيرت","Push_apn_dev_key":"APN ديف مفتاح","Push_apn_dev_passphrase":"APN ديف عبارة المرور","Push_apn_key":"APN مفتاح","Push_apn_passphrase":"APN عبارة المرور","Push_debug":"التصحيح","push_disabled":"دفع المعوقين","Push_enable":"تمكين","Push_enable_gateway":"تمكين بوابة","Push_gateway":"بوابة","Push_gcm_api_key":"GCM مفتاح API","Push_gcm_project_number":"GCM رقم المشروع","Push_production":"الإنتاج","Push_show_message":"عرض الرسالة في التنبيه","Push_show_username_room":"عرض القناة\\المجموعة\\اسم المستخدم في النبيه","Push_test_push":"تجربة","Query":"سؤال","Query_description":"شروط إضافية لتحديد أي من المستخدمين لإرسال رسالة إلكترونية إلى. تتم إزالة المستخدمين غير المشتركين تلقائيا من الاستعلام. يجب أن يكون JSON صالح. على سبيل المثال: \"{\" createdAt \": {\" $ GT \": {\" تاريخ $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"بحث سريع","quote":"اقتباس","Reactions":"ردود الفعل","Recents":"حديثي","Record":"سجل","Redirect_URI":"إعادة توجيه URI","Refresh_keys":"تحديث المفاتيح","Refresh_your_page_after_install_to_enable_screen_sharing":"تحديث الصفحة بعد تثبيت لتمكين مشاركة الشاشة","Register":"تسجيل حساب جديد","Registration_Succeeded":"تم التسجيل بنجاح","Remember_me":"تذكرني","Remove":"إزالة","Remove_Admin":"إزالة مدير","Remove_as_moderator":"إزالة كمشرف","Remove_as_owner":"إزالة كمالك","Remove_custom_oauth":"إزالة أوث مخصصة","Remove_from_room":"إزالة من الغرفة","Remove_someone_from_room":"إزالة شخص من الغرفة","Removed":"تمت اﻹزالة","Require_password_change":"تتطلب تغيير كلمة المرور","Resend_verification_email":"اعد إرسال بريد التحقق","Reset":"إعادة التعيين","Reset_password":"إعادة تعيين كلمة السر","Restart":"إعادة التشغيل","Restart_the_server":"إعادة تشغيل السيرفر","RocketBot_Enabled":"RocketBot ممكن","RocketBot_Name":"اسم RocketBot","RocketBot_Name_Description":"يجب أن يكون اسم RocketBot اسم مستخدم صالح مسجلة على الخادم الخاص بك.","Role":"دور","Role_Editing":"دور التحرير","Role_removed":"دور إزالة","Room":"غرفة","Room_archivation_state":"الحالة","Room_archivation_state_false":"نشطة","Room_archivation_state_true":"مؤرشفة","Room_archived":"غرفة مؤرشفة","room_changed_privacy":"تم تغيير نوع الغرفة إلى: <em>__room_type__</em> بواسطة <em>__user_by__</em>","room_changed_topic":"تم تغيير موضوع الغرفة إلى: <em>__room_topic__</em> بواسطة <em>__user_by__</em>","Room_has_been_deleted":"تم حذف الغرفة","Room_Info":"معلومات الغرفة","Room_name_changed":"تم تغيير اسم الغرفة إلى: <em>__room_name__</em> بواسطة <em>__user_by__</em>","Room_name_changed_successfully":"تم تغيير اسم الغرفة بنجاح","Room_not_found":"لم يتم العثور على الغرفة","Room_topic_changed_successfully":"تغيير موضوع الغرفة بنجاح","Room_type_changed_successfully":"تم تغيير نوع الغرفة بنجاح","Room_unarchived":"غرفة نشطة","Room_uploaded_file_list":"قائمة الملفات","Room_uploaded_file_list_empty":"لا يوجد ملفات.","room_user_count":"% مستخدم","Rooms":"الغرف","S_new_messages_since_s":"% رسالة جديدة منذ %","SAML":"SAML","SAML_Custom_Cert":"شهادة مخصصة","SAML_Custom_Entry_point":"عرف نقطة إدخال","SAML_Custom_Generate_Username":"توليد اسم المستخدم","SAML_Custom_Issuer":"المصدر مخصص","SAML_Custom_Provider":"مزود مخصص","Save":"حفظ","Save_changes":"حفظ التغيرات","Save_Mobile_Bandwidth":"توفير استهلاك الانترنت","Save_to_enable_this_action":"حفظ لتمكين هذا العمل","Saved":"تم الحفظ","Saving":"جاري الحفظ","Scope":"نطاق","Screen_Share":"شاشة حصة","Script_Enabled":"السيناريو ممكن","Search":"بحث","Search_by_username":"البحث عن طريق اسم المستخدم","Search_Channels":"بحث القنوات","Search_Direct_Messages":"البحث في الرسائل الخاصة","Search_Messages":"بحث الرسائل","Search_Private_Groups":"البحث في المجموعات الخاصة","Search_settings":"إعدادات البحث","seconds":"ثواني","See_all":"عرض الكل","See_only_online":"المتصلون فقط","Select_a_department":"حدد القسم","Select_an_avatar":"اختر صورة","Select_file":"اختر ملفا","Select_service_to_login":"اختر خدمة للدخول إليها لتحميل صورتك أو قم بالتحميل مباشرة من جهازك","Select_user":"حدد المستخدم","Select_users":"حدد المستخدمين","Selected_agents":"الوكلاء المختارون","Selected_users":"أعضاء مختارين","Send":"إرسال","Send_a_message":"إرسال رسالة","Send_a_test_mail_to_my_user":"إرسال بريد إلكتروني إلى اختبار المستخدم الخاص بي","Send_a_test_push_to_my_user":"إرسال دفعة اختبار لالمستخدم الخاص بي","Send_confirmation_email":"إرسال رسالة تأكيد","Send_data_into_RocketChat_in_realtime":"إرسال البيانات إلى Rocket.Chat في الوقت الحقيقي.","Send_email":"إرسال البريد الإلكتروني","Send_invitation_email":"ارسال رسالة دعوة","Send_invitation_email_error":"هل لم تقدم أي عنوان بريد إلكتروني صالح.","Send_invitation_email_info":"يمكنك إرسال عدة دعوات البريد الإلكتروني في وقت واحد.","Send_invitation_email_success":"لقد أرسلت بنجاح دعوة عبر البريد الإلكتروني إلى العناوين التالية:","Send_invitation_email_warning":"من أجل إرسال رسائل البريد الإلكتروني الدعوة، يجب عليك أولا تكوين إعدادات SMTP.","Send_Message":"أرسل رسالة","Send_your_JSON_payloads_to_this_URL":"إرسال حمولات JSON لهذا الرابط.","Sending":"جار الإرسال...","Set_as_moderator":"إضافة كمشرف","Set_as_owner":"إضافة إلى مالك","Settings":"اﻹعدادات","Settings_updated":"تم تحديث الإعدادات","Should_be_a_URL_of_an_image":"يجب أن يكون عنوان URL للصورة.","Should_exists_a_user_with_this_username":"يجب على المستخدم موجودة بالفعل.","Show_all":"عرض الكل","Show_more":"عرض المزيد","Show_only_online":"عرض المتصلين فقط","Show_preregistration_form":"عرض استمارة التسجيل المسبق","Showing_archived_results":"\n<p>عرض <b>%s</b> نتائج مؤرشفة</p>\n","Showing_online_users":"عرض <b>__total_showing__</b>من __total__ عضو","Showing_results":"<p>يعرض <b>%s</b> نتائج</p>","Silence":"الصمت","since_creation":"منذ %s","Site_Name":"اسم الموقع","Site_Url":"رابط الموقع","Site_Url_Description":"مثال: https://chat.domain.com","Skip":"تخطي","Smileys_and_People":"ابتسامات و أشخاص","SMTP":"SMTP","SMTP_Host":"المضيف SMTP","SMTP_Password":"SMTP كلمة المرور","SMTP_Port":"ميناء SMTP","SMTP_Test_Button":"إعدادات اختبار SMTP","SMTP_Username":"SMTP اسم المستخدم","Sound":"الصوت","Star_Message":"نجمة رسالة","Starred_Messages":"رسائل مميزة","Start_audio_call":"بدء المكالمة الصوتية","Start_Chat":"بدأ الدردشة","Start_of_conversation":"بداية المحادثة","Start_OTR":"بدء المحادثة السرية","Start_video_call":"بدء مكالمة فيديو","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"تبدأ <code class=\"inline\">%s</code> للمستخدم أو <code class=\"inline\">%s</code> للقناة. على سبيل المثال: <code class=\"inline\">%s</code> أو <code class=\"inline\">%s</code>","Statistics":"الإحصائيات","Stats_Active_Users":"الأعضاء النشيطين","Stats_Avg_Channel_Users":"متوسط مستخدمي القناة","Stats_Avg_Private_Group_Users":"متوسط مستخدمي المجموعات الخاصة","Stats_Away_Users":"المستخدمين البعيدين","Stats_Max_Room_Users":"أقصى عدد للمستخدمين في الغرف","Stats_Non_Active_Users":"المستخدمين الغير نشطين","Stats_Offline_Users":"المستخدمون الغير متصلون","Stats_Online_Users":"المستخدمون المتصلون","Stats_Total_Channels":"مجموع القنوات","Stats_Total_Direct_Messages":"إجمالي عدد غرف الرسالة المباشرة","Stats_Total_Messages":"مجموع الرسائل","Stats_Total_Private_Groups":"عدد المجموعات الخاصة","Stats_Total_Rooms":"عدد الغرف","Stats_Total_Users":"عدد الأعضاء","Stop_Recording":"إيقاف التسجيل","strike":"شطب","Subject":"الموضوع","Submit":"تقديم","Success":"نجاح","Survey":"الدراسة الاستقصائية","Survey_instructions":"معدل كل سؤال وفقا لالارتياح الخاص بك، 1 وهذا يعني أنك غير راضي تماما و 5 يعني كنت راضيا تماما.","Symbols":"رموز","Sync_success":"نجاح المزامنة","Sync_Users":"المستخدمين مزامنة","Test_Connection":"اختبار اﻹتصال","Test_Desktop_Notifications":"تجربيب تنبيهات سطح المكتب","Thank_you_for_your_feedback":"شكرا لأفادتك","The_application_name_is_required":"مطلوب اسم التطبيق","The_channel_name_is_required":"اسم القناة مطلوب","The_emails_are_being_sent":"يتم إرسال رسائل البريد الإلكتروني.","The_field_is_required":"هذا الحقل %s مطلوب.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"وتغيير الحجم صورة لا تعمل لأننا لا يمكن الكشف عن يماغيماغيك أو GraphicsMagick المثبتة على الخادم الخاص بك.","The_redirectUri_is_required":"مطلوب redirectUri","The_server_will_restart_in_s_seconds":"سيتم إعادة تشغيل الخادم في %s ثانية","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"تم تكوين <strong>الإعداد %s</strong> <strong>إلى %s</strong> والتي يتم الوصول <strong>من %s!</strong>","The_user_will_be_removed_from_s":"سيتم إزالة المستخدم من %s","The_user_wont_be_able_to_type_in_s":"المستخدم لن يكون قادرا على كتابة في٪ الصورة","Theme":"موضوع","theme-color-action-buttons-color":"الإجراءات أزرار اللون","theme-color-active-channel-background-color":"نشط قناة لون الخلفية","theme-color-active-channel-font-color":"نشط قناة لون الخط","theme-color-blockquote-background":"لون خلفية الاقتباس","theme-color-clean-buttons-color":"أزرار نظيفة اللون","theme-color-code-background":"كود لون الخلفية","theme-color-code-border":"كود لون الحدود","theme-color-code-color":"كود اللون","theme-color-content-background-color":"المحتوى لون الخلفية","theme-color-custom-scrollbar-color":"مخصص شريط التمرير اللون","theme-color-info-active-font-color":"معلومات النشط لون الخط","theme-color-info-font-color":"معلومات لون الخط","theme-color-input-font-color":"إدخال لون الخط","theme-color-link-font-color":"رابط لون الخط","theme-color-message-hover-background-color":"رسالة تحوم BG اللون","theme-color-primary-background-color":"الابتدائي لون الخلفية","theme-color-primary-font-color":"الابتدائية لون الخط","theme-color-quaternary-font-color":"رباعي لون الخط","theme-color-secondary-background-color":"الثانوية لون الخلفية","theme-color-secondary-font-color":"الثانوية لون الخط","theme-color-smallprint-font-color":"صغيرة طباعة لون الخط","theme-color-smallprint-hover-color":"صغيرة طباعة تحوم اللون","theme-color-status-away":"لون حالة بعيد","theme-color-status-busy":"لون حالة مشغول","theme-color-status-offline":"حاليا وضع اللون","theme-color-status-online":"الحالة عبر الإنترنت اللون","theme-color-tertiary-background-color":"التعليم العالي لون الخلفية","theme-color-tertiary-font-color":"التعليم العالي لون الخط","theme-color-unread-notification-color":"غير مقروء الإخطارات اللون","theme-custom-css":"لغة تنسيق ويب حسب الطلب","There_are_no_agents_added_to_this_department_yet":"لا يوجد وكلاء مضافون لهذا القسم","There_are_no_integrations":"لا توجد التكامل","There_are_no_users_in_this_role":"هناك مستخدمين في هذا الدور.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"وقد تم بالفعل استخدام هذا البريد الإلكتروني ولم يتم التحقق منها. الرجاء قم بتغيير كلمة المرور الخاصة بك.","This_is_a_desktop_notification":"مثال على تنبيهات سطح المكتب","This_is_a_push_test_messsage":"هذا هو بإرسال رسالة اختبار الضغط","Time_in_seconds":"الوقت بالثواني","Title_bar_color":"شريط العنوان اللون","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"لتركيب المحادثات الحية في موقعك انسخ و الصق النص التالي قبل آخر علامة <strong>&lt;/body&gt;</strong> في موقعك.","To_users":"إلى","Topic":"الموضوع","Travel_and_Places":"سفر و أماكن","Trigger_removed":"الزناد إزالة","Trigger_Words":"الكلمات الزناد","Triggers":"محفزات","True":"نعم","Type":"النوع","Type_your_new_password":"اكتب كلمة المرور الجديدة","Unarchive":"إزالة من الأرشيف","Unmute_someone_in_room":"إلغاء إسكات شخص في هذه الغرفة","Unmute_user":"إلغاء اسكات المستخدم","Unnamed":"غير مسمى","Unpin_Message":"إلغاء تثبيث الرسالة","Unread_Rooms":"الغرف غير مقروءة","Unread_Rooms_Mode":"وضع الغرف الغير مقروءة","Unstar_Message":"إزالة نجمة","Upload_file_question":"تحميل الملف؟","Uploading_file":"تحميل الملف ...","Use_account_preference":"استخدم تفضيلات الحساب","Use_Emojis":"استخدم الرموز التعبيرية (ايموجي)","Use_initials_avatar":"استخدم الأحرف الأولى من اسم المستخدم","use_menu":"استخدم القائمة الجانبية للوصول إلى الغرف الخاصة بك والمحادثات","Use_service_avatar":"استخدام %s الرمزية","Use_this_username":"استخدم هذا الاسم","Use_uploaded_avatar":"استخدم الصورة المحملة","Use_url_for_avatar":"استخدم رابط للصورة الرمزية","User__username__is_now_a_moderator_of__room_name_":"__username__ المستخدم الآن مشرفة من __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ المستخدم هو الآن صاحب __room_name__","User__username__removed_from__room_name__moderators":"__username__ المستخدم إزالتها من المشرفين __room_name__","User__username__removed_from__room_name__owners":"__username__ المستخدم إزالتها من أصحاب __room_name__","User_added":"تمت إضافة المستخدم","User_added_by":"تم إضافة <em>__user_added__</em> بواسطة <em>__user_by__</em>.","User_added_successfully":"تمت إضافة المستخدم بنجاح","User_Channels":"قنوات المستخدم","User_doesnt_exist":"لا يوجد مستخدم بالاسم `@%s`","User_has_been_activated":"تم تفعيل المستخدم","User_has_been_deactivated":"تم إلغاء تنشيط المستخدم","User_has_been_deleted":"تم حذف العضو","User_has_been_muted_in_s":"لم يصدر المستخدم في٪ الصورة","User_has_been_removed_from_s":"تمت إزالة العضو من %s","User_has_disconnected":"وقد قطع العضو","User_Info":"معلومات المستخدم","User_is_no_longer_an_admin":"المستخدم لم يعد مديرا","User_is_not_activated":"العضو غير مفعل","User_is_now_an_admin":"المستخدم الآن مدير","User_joined_channel":"انضم للقناة.","User_joined_channel_female":"انضمت للقناة","User_joined_channel_male":"انضم للقناة.","User_left":"غادر القناة.","User_left_female":"غادرت القناة.","User_left_male":"غادر القناة.","User_logged_out":"المستخدم سجل الخروج","User_management":"إدارةالمستخدم","User_muted_by":"تم اسكات <em>__user_muted__</em> بواسطة <em>__user_by__</em>.","User_muted_in_room":"المستخدم كتم في الغرفة","User_not_found":"لم يتم العثور على المستخدم","User_not_found_or_incorrect_password":"لم يتم العثور على المستخدم أو كلمة المرور غير صحيحة","User_or_channel_name":"المستخدم أو القناة اسم","User_removed":"تم إزالة المستخدم","User_removed_by":"تم حذف <em>__user_removed__</em> بواسطة <em>__user_by__</em>.","User_removed_from_room":"تم إزالة المستخدم من الغرفة","User_Settings":"إعدادات المستخدم","User_unmuted_by":"تم إلغاء اسكات <em>__user_unmuted__</em> بواسطة <em>__user_by__</em>.","User_unmuted_in_room":"العضو إلغاء كتم صوت في الغرفة","User_updated_successfully":"تم تحديث العضو بنجاح","Username":"اسم المستخدم","Username_and_message_must_not_be_empty":"اسم المستخدم ورسالة يجب أن لا تكون فارغة.","Username_cant_be_empty":"اسم المستخدم لا يمكن أن يكون فارغا","Username_Change_Disabled":"مدير الموقع منع تغيير اسم المستخدم","Username_denied_the_OTR_session":"__username__ رفض جلسة المحادثة السرية","Username_description":"يتم استخدام اسم المستخدم للسماح للآخرين بذكرك في الرسائل.","Username_doesnt_exist":"عدم وجود اسم المستخدم ` %s`.","Username_ended_the_OTR_session":"__username__ أنهى جلسة المحادثة السرية","Username_invalid":"<strong>%s</strong> لا يصلح كإسم مستخدم،<br/> استخدم فقط حروفا وأرقاما وشرطات","Username_is_already_in_here":"`@ %s` بالفعل هنا.","Username_is_not_in_this_room":"المستخدم `#%s` غير موجود في الغرفة","Username_not_found":"اسم المستخدم لم يتم العثور","Username_title":"تسجيل اسم المستخدم","Username_unavaliable":"<strong>%s</strong> مستخدم مسبقا :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ يريد أن يبدأ محادثة سرية. هل توافق؟","Users":"المستخدمين","Users_in_role":"المستخدمين في دور","UTF8_Names_Slugify":"UTF8 أسماء Slugify","UTF8_Names_Validation":"UTF8 أسماء التحقق","UTF8_Names_Validation_Description":"لا تسمح باستخدام رموز خاصة و مسافات. يمكنك استخدام العلامات التالية - _  . لكن لا تسمح بهن في نهاية الاسم.","Verification_email_sent":"تم ارسال رسالة التحقق","View_All":"مشاهدة الكل","View_Logs":"عرض سجلات","Visibility":"رؤية","Visible":"مرئي","Visitor":"زائر","Visitor_page_URL":"URL صفحة الزوار","Visitor_time_on_site":"الساعة الزوار في الموقع","Wait_activation_warning":"يجب تفعيل حسابك من قبل المدير قبل أن تتمكن من الولوج","We_are_offline_Sorry_for_the_inconvenience":"نحن حاليا. آسف للإزعاج.","We_have_sent_password_email":"لقد قمنا بإرسال رسالة بريد إلكتروني مع إرشادات إعادة تعيين كلمة السر. إذا لم يصلك البريد الإلكتروني قريبا، يرجى العودة والمحاولة مرة أخرى.","We_have_sent_registration_email":"لقد قمنا بإرسال رسالة بريد إلكتروني لتأكيد تسجيلك. إذا لم يصلك البريد الإلكتروني قريبا، يرجى العودة والمحاولة مرة أخرى.","WebRTC_Enable_Channel":"تمكين للقنوات العامة","WebRTC_Enable_Direct":"تمكين للرسائل المباشرة","WebRTC_Enable_Private":"تمكين للقنوات الخاصة","WebRTC_Servers":"خوادم أذهل / TURN","WebRTC_Servers_Description":"قائمة الخوادم أذهل وTURN مفصولة بفواصل. <br/> ويسمح المستخدم، كلمة المرور و ميناء في شكل `اسم المستخدم: كلمة المرور @ الصاعقة: المضيف: port` أو` اسم المستخدم: كلمة المرور @ بدوره: المضيف: port`.","Welcome":"مرحبا بك يا <em>%s</em>.","Welcome_to_the":"أهلا بك في","will_be_able_to":"سوف يكون قادر على","With_whom":"مع من","Yes":"نعم","Yes_clear_all":"نعم، حذف الكل!","Yes_delete_it":"نعم، أحذف!","Yes_hide_it":"نعم، إخفاء!","Yes_leave_it":"نعم، مغادرة!","Yes_mute_user":"نعم، المستعمل أخرس!","Yes_remove_user":"نعم، إزالة المستخدم!","you_are_in_preview_mode_of":"كنت في وضع المعاينة من قناة # <strong>__room_name__</strong>","You_are_logged_in_as":"لقد تم تسجيل دخولك كما","You_are_not_authorized_to_view_this_page":"لا تملك الصلاحية لمشاهدة هذه الصفحة.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"كنت صاحب الماضي. الرجاء تعيين المالك الجديد قبل مغادرة الغرفة.","You_can_change_a_different_avatar_too":"يمكنك تجاوز الرمزية المستخدمة للنشر من هذا التكامل.","You_can_use_an_emoji_as_avatar":"تستطيع استخدام ايموجي كصورة رمزية","You_have_been_muted":"لقد تم اسكاتك ولا يمكنك التحدث في هذه الغرفة","You_have_not_verified_your_email":"لم يتم التحقق من بريدك الإلكتروني.","You_have_successfully_unsubscribed":"لقد تم إلغاء اشتراكك بنجاح من القائمة البريدية لدينا.","You_informed_an_invalid_FROM_address":"كنت على علم غير صالح من عنوان.","You_must_provide_the_unsubscribe_link":"يجب توفير رابط [إلغاء الاشتراك].","You_need_confirm_email":"تحتاج إلى تأكيد بريدك الإلكتروني لتسجيل الدخول!","You_need_install_an_extension_to_allow_screen_sharing":"تحتاج إلى تركيب إضافة للسماح بمشاركة الشاشة","You_need_to_change_your_password":"يجب عليك تغيير كلمة المرور","You_need_to_type_in_your_password_in_order_to_do_this":"تحتاج إلى كتابة كلمة السر لتفعل هذا","You_need_to_type_in_your_username_in_order_to_do_this":"تحتاج إلى كتابة اسم المستخدم من أجل القيام بذلك!","You_need_to_verifiy_your_email_address_to_get_notications":"تحتاج إلى تأكيد بريدك الإلكتروني لتصلك التنبيهات","You_should_name_it_to_easily_manage_your_integrations":"يجب أن سمها ما شئت بسهولة لإدارة التكامل بك.","You_will_not_be_able_to_recover":"لن تستطيع استرداد هذه الرسالة!","You_will_not_be_able_to_recover_file":"لن تستطيع استعادة هذا الملف!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"لن تتلقى إخطارات البريد الإلكتروني لأنك لم تثبت صحة البريد الإلكتروني الخاص بك.","Your_email_has_been_queued_for_sending":"وقد تم في قائمة الانتظار البريد الإلكتروني لإرسال","Your_entry_has_been_deleted":"لقد تم حذف رسالتك","Your_file_has_been_deleted":"لقد تم حذف الملف.","Your_mail_was_sent_to_s":"وأرسل البريد إلى %s","Your_Open_Source_solution":"تطبيق المحادثة الخاص بك المفتوح المصدر","Your_password_is_wrong":"كلمة السر خاطئة","Your_push_was_sent_to_s_devices":"وقد أرسلت دفعك إلى أجهزة٪ الصورة"});
TAPi18n._registerServerTranslator("ar", namespace);                                                                    // 20
                                                                                                                       // 21
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/cs.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["cs"] = ["Czech","čeština‎"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["cs"])) {                                                                        // 9
  TAPi18n.translations["cs"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["cs"][namespace])) {                                                             // 13
  TAPi18n.translations["cs"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["cs"][namespace], {"500":"Internal Server Error","0_Errors_Only":"0 - Chyby Pouze","1_Errors_and_Information":"1 - Chyby a informační","2_Erros_Information_and_Debug":"2 - Erros, informační a ladění","__username__was_set__role__by__user_by_":"uživatelské jméno __username__ byl stanoven __role__ podle __user_by__","__username__is_no_longer__role__defined_by__user_by_":"uživatelské jméno __username__ již není __role__, které __user_by__","Access_not_authorized":"Přístup není povoleno","Access_online_demo":"Přístup k online demo","Access_Online_Demo":"Přístup k online demo","Access_Token_URL":"Adresa URL přístupového klíče","Accounts":"účty","Accounts_AllowDeleteOwnAccount":"Povolit uživatelům odstranit vlastní účet","Accounts_AllowedDomainsList":"Povoleno Seznam Domény","Accounts_AllowedDomainsList_Description":"Čárkami oddělený seznam povolených domén","Accounts_AllowEmailChange":"Povolit e-mailu Změna","Accounts_AllowPasswordChange":"Umožnit Změna hesla","Accounts_AllowUserAvatarChange":"Umožnit Uživatelský avatar Změna","Accounts_AllowUsernameChange":"Povolit uživatelské jméno Změna","Accounts_AllowUserProfileChange":"Umožnit profilu uživatele Změna","Accounts_AvatarResize":"Změna velikosti avatary","Accounts_AvatarSize":"avatar Velikost","Accounts_AvatarStorePath":"Avatar Storage Path","Accounts_AvatarStoreType":"Avatar Storage Type","Accounts_BlockedDomainsList":"Seznam blokovaných domén","Accounts_BlockedDomainsList_Description":"Čárkami oddělený seznam blokovaných domén","Accounts_denyUnverifiedEmail":"Deny neověřenou e-mailovou","Accounts_EmailVerification":"Potvrzení e-mailu","Accounts_EmailVerification_Description":"Ujistěte se, že máte správné nastavení SMTP Pro použití této funkce","Accounts_Enrollment_Email":"Zápis E-mail","Accounts_Enrollment_Email_Description":"Můžete použít [name], [fname], [lname] pro uživatele jména a příjmení, křestní jméno nebo příjmení, resp. <br /> na e-mail uživatele, můžete použít [email].","Accounts_Iframe_api_method":"Api Metoda","Accounts_Iframe_api_url":"Api URL","Accounts_iframe_enabled":"povoleno","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"Vstup vypršení platnosti Dnů","Accounts_ManuallyApproveNewUsers":"Ručně schvalovat nové uživatele","Accounts_OAuth_Custom_Token_Sent_Via":"Token odesílány prostřednictvím","Accounts_OAuth_Custom_Authorize_Path":"povolit Path","Accounts_OAuth_Custom_Button_Color":"tlačítko Color","Accounts_OAuth_Custom_Button_Label_Color":"Tlačítko Barva textu","Accounts_OAuth_Custom_Button_Label_Text":"tlačítko Text","Accounts_OAuth_Custom_Enable":"Umožnit","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"identita Path","Accounts_OAuth_Custom_Login_Style":"Vstup Style","Accounts_OAuth_Custom_Secret":"Tajný","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Přihlášení","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Enabled","Accounts_OAuth_Github_callback_url":"GitHub zpětného volání URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise zpětného volání URL","Accounts_OAuth_GitHub_Enterprise_id":"Číslo klienta","Accounts_OAuth_GitHub_Enterprise_secret":"klient Secret","Accounts_OAuth_Github_id":"Číslo klienta","Accounts_OAuth_Github_secret":"klient Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab zpětného volání URL","Accounts_OAuth_Gitlab_id":"Id GitLab","Accounts_OAuth_Gitlab_secret":"klient Secret","Accounts_OAuth_Google":"Google Přihlášení","Accounts_OAuth_Google_callback_url":"Google zpětného volání URL","Accounts_OAuth_Google_id":"Id Google","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Přihlášení","Accounts_OAuth_Linkedin_callback_url":"Linkedin zpětného volání URL","Accounts_OAuth_Linkedin_id":"Id LinkedIn","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Přihlášení","Accounts_OAuth_Meteor_callback_url":"Meteor zpětného volání URL","Accounts_OAuth_Meteor_id":"Id Meteor","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Přihlášení","Accounts_OAuth_Twitter_callback_url":"Twitter zpětného volání URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Přihlášení","Accounts_OAuth_Wordpress_callback_url":"Wordpress zpětného volání URL","Accounts_OAuth_Wordpress_id":"Id WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Resetovat heslo","Accounts_Registration_AuthenticationServices_Enabled":"Registrace u služby ověřování","Accounts_RegistrationForm":"Registrační formulář","Accounts_RegistrationForm_Disabled":"invalidní","Accounts_RegistrationForm_LinkReplacementText":"Registrační formulář Link Replacement Text","Accounts_RegistrationForm_Public":"Veřejnost","Accounts_RegistrationForm_Secret_URL":"Tajné URL","Accounts_RegistrationForm_SecretURL":"Registrační formulář Secret URL","Accounts_RegistrationForm_SecretURL_Description":"Musíte poskytnout náhodný řetězec, který bude přidán do vašeho registračního URL. Příklad: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Je vyžadována registrace","Accounts_RequireNameForSignUp":"Vyžadují Name pro SIGNUP","Accounts_ShowFormLogin":"Show form-založené Přihlásit","Accounts_UseDefaultBlockedDomainsList":"Použít výchozí seznam blokovaných domén","Accounts_UseDNSDomainCheck":"Použít domény DNS Check","Activate":"Aktivovat","Activity":"Aktivita","Add":"Přidat","Add_agent":"Přidat agenta","Add_custom_oauth":"Přidat vlastní OAuth","Add_manager":"Přidat správce","Add_Members":"Přidat členy","Add_User":"Přidat uživatele","Add_user":"Přidat uživatele","Add_users":"Přidat uživatele","Additional_emails":"Další e-maily","Additional_Feedback":"dodatečné Feedback","Administration":"Správa","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Po ověření OAuth2, budou uživatelé přesměrováni na tuto adresu URL","Agent_added":"Agent z přidané","Agent_removed":"Agent odstraněno","Alias":"přezdívka","All":"Všechno","All_channels":"Všechny kanály","All_logs":"Všechny protokoly","All_messages":"Všechny zprávy","Allow_Invalid_SelfSigned_Certs":"Umožnit Neplatný s vlastním podpisem CÚ","Allow_Invalid_SelfSigned_Certs_Description":"Umožňují neplatné a vlastním podpisem SSL certifikát pro ověření spojení a náhledy.","and":"a","And_more":"A další __length __...","Animals_and_Nature":"Zvířata & Nature","API":"API","API_Analytics":"analytika","API_Embed":"Vložit","API_EmbedDisabledFor":"Zakázat Vložit pro uživatele","API_EmbedDisabledFor_Description":"Čárkami oddělený seznam jmen uživatelů","API_GitHub_Enterprise_URL":"Adresa URL serveru","API_GitHub_Enterprise_URL_Description":"Příklad: http://domain.com (bez lomítka)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Vzhled","Application_added":"přidané aplikace","Application_Name":"Název aplikace","Application_updated":"aplikace aktualizováno","Apply_and_refresh_all_clients":"Použít a aktualizovat všechny klienty","Archive":"Archiv","Archive_Unarchive":"Archiv / Zrušit archivaci","are_also_typing":"také píší","are_typing":"píší","Are_you_sure":"Jsi si jistá?","Are_you_sure_you_want_to_delete_your_account":"Jste si jisti, že chcete smazat svůj účet?","Authorization_URL":"autorizace URL","Authorize":"Povolit","AutoLinker_StripPrefix":"AutoLinker Strip Prefix","AutoLinker_StripPrefix_Description":"Short displej. např https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL regulárních výrazů","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Automaticky propojeny pro telefonní čísla. např `(123) 456-7890`","Auto_Load_Images":"Auto Load Obrázky","Available":"Dostupný","Available_agents":"dostupné agenti","Avatar":"avatar","Avatar_changed_successfully":"Avatar byl úspěšně změněn","Avatar_URL":"avatar URL","Avatar_url_invalid_or_error":"Url pokud je neplatný nebo není přístupný. Zkuste to prosím znovu, ale s jiným URL.","away":"pryč","Away":"Pryč","away_female":"pryč","Away_female":"Pryč","away_male":"pryč","Away_male":"Pryč","Back":"Zadní","Back_to_applications":"Zpět k aplikacím","Back_to_integrations":"Zpět na integraci","Back_to_login":"Zpět na přihlašovací formulář","Back_to_permissions":"Zpět na oprávnění","Body":"Tělo","bold":"tučný","busy":"zaneprázdněný","Busy":"Zaneprázdněný","busy_female":"zaneprázdněný","Busy_female":"Zaneprázdněný","busy_male":"zaneprázdněný","Busy_male":"Zaneprázdněný","Cancel":"Zrušit","Cannot_delete_a_protected_role":"Nelze odstranit chráněné roli","Cannot_delete_role_because_its_in_use":"Nelze smazat roli, protože to je v provozu","Cannot_invite_users_to_direct_rooms":"Nelze pozvat uživatele, aby směrují pokoje","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certifikáty a klíče","Channel":"Kanál","Channel_doesnt_exist":"Kanál `# %s` neexistuje.","Channels":"Kanály","Channels_list":"Seznam veřejných kanálů","Chat_Rooms":"Konverzační místnosti","Chatops_Enabled":"Aktivovat Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Uživatelské jméno","Choose_a_room":"Vyberte si pokoj","Choose_messages":"Výběr zpráv","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Vyberte alias, který se objeví před uživatelské jméno ve zprávách.","Choose_the_username_that_this_integration_will_post_as":"Vyberte uživatelské jméno, které tato integrace zaúčtuje jako.","Clear_all_unreads_question":"Vymazat všechny unreads?","Client_ID":"ID klienta","Client_Secret":"klient Secret","Clients_will_refresh_in_a_few_seconds":"Klienti se obnoví během několika sekund","close":"zavřít","Closed":"Zavřeno","Collapse_Embedded_Media_By_Default":"Sbalit vloženého média ve výchozím nastavení","coming_soon":"už brzy","Commands":"příkazy","Compact_View":"kompaktní View","Confirm_password":"Potvrzení hesla","Contact":"Kontakt","Conversation":"Konverzace","Convert_Ascii_Emojis":"Převod ASCII Emoji","Copied":"zkopírovány","COPY_TO_CLIPBOARD":"ZKOPÍROVAT DO SCHRÁNKY","Copy_to_clipboard":"Zkopírovat do schránky","Count":"Počítat","Create":"Vytvořit","Create_new":"Vytvořit nový","Created_at":"vytvořena v","Created_at_s_by_s":"Vytvořen <strong>v %s</strong> <strong>pomocí %s</strong>","Custom_Fields":"Vlastní Fields","Custom_oauth_helper":"Při nastavování OAuth poskytovatele, budete muset informovat zpětného volání URL. Použití <pre> %s </pre> ,","Custom_oauth_unique_name":"Custom OAuth jedinečný název","Custom_Script_Logged_In":"Custom Script pro přihlášené uživatele","Custom_Script_Logged_Out":"Custom Script pro přihlášené uživatele out","Dashboard":"přístrojová deska","days":"dny","Deactivate":"deaktivovat","Debug_Level":"Debug Level","Default":"standardní","Delete":"Vymazat","Delete_my_account":"Smazat svůj účet","Delete_Room_Warning":"Odstranění místnost smaže všechny zprávy poslané v rámci místnosti. To nelze vrátit zpět.","Delete_User_Warning":"Odstranění uživatele smaže všechny zprávy od daného uživatele stejně. To nelze vrátit zpět.","Deleted":"Smazán!","Department_not_found":"Oddělení nebyl nalezen","Department_removed":"Oddělení odstraněno","Departments":"Pracoviště","Description":"Popis","Desktop":"Desktop","Desktop_Notification_Test":"Desktop Notification test","Desktop_Notifications":"Desktop Oznámení","Desktop_Notifications_Disabled":"Desktop oznámení vypnuta. Změnit nastavení svého prohlížeče, pokud budete potřebovat oznámení povolena.","Desktop_Notifications_Enabled":"Desktop Oznámení jsou Enabled","Direct_message_someone":"někdo přímou zprávu","Direct_Messages":"Přímé zprávy","Direct_Messages_list":"Přímé Zprávy","Disable_Favorite_Rooms":"Zakázat Oblíbené","Disable_New_Message_Notification":"Zakázat oznámení Nová zpráva","Disable_New_Room_Notification":"Zakázat nová místnost oznámení","Displays_action_text":"Zobrazuje text akce","Do_you_want_to_change_to_s_question":"Chcete <strong>změnit %s?</strong>","Drop_to_upload_file":"Drop nahrát soubor","Dry_run":"chodu naprázdno","Dry_run_description":"Bude odesílat pouze jeden e-mail, na stejnou adresu jako v Z. V e-mailu musí patřit platný uživatel.","Duplicate_archived_channel_name":"Archivovaný kanál s názvem ' %s' existuje","Duplicate_archived_private_group_name":"Archivovaná Private Skupina s názvem ' %s' existuje","Duplicate_private_group_name":"Soukromou skupinu s názvem existuje ' %s'","E-mail":"E-mail","Edit":"editovat","Edit_Custom_Field":"Upravit vlastní pole","Edit_Department":"editovat Oddělení","edited":"upraveno","Email":"E-mail","Email_already_exists":"Email již existuje","Email_body":"E-mail tělo","Email_Change_Disabled":"Váš Rocket.Chat Administrátor zablokoval výměna e-mailů","Email_from":"Od","Email_Notification_Mode":"Offline Upozornění e-mailem","Email_Notification_Mode_All":"Každá zmínka / DM","Email_Notification_Mode_Disabled":"invalidní","Email_or_username":"E-mail nebo uživatelské jméno","Email_subject":"Předmět","Email_verified":"Email ověřen","Emoji":"emodži","Empty_title":"prázdný titul","Enable":"Umožnit","Enable_Desktop_Notifications":"Aktivovat Upozornění na ploše","Enabled":"povoleno","Encrypted_message":"zašifrovaná zpráva","End_OTR":"konec OTR","Enter_a_regex":"Zadejte regex","Enter_a_room_name":"Zadejte název místnosti","Enter_a_username":"Zadat uživatelské jméno","Enter_info":"Zadejte své údaje","Enter_name_here":"Zadejte název zde","Enter_to":"Vstup do","Error":"Chyba","error-cant-invite-for-direct-room":"Nelze pozvat uživatele k přímým místností","error-duplicate-channel-name":"Kanál s názvem ' %s' existuje","error-invalid-custom-field":"Neplatná vlastní pole","error-invalid-custom-field-name":"Neplatný název vlastní pole. Používejte pouze písmena, číslice, pomlčky a podtržítka.","error-invalid-password":"Neplatné heslo","error-invalid-room":"Neplatný pokoj","error-invalid-room-name":"<strong> %s</strong> není platný název místnosti, <br/> použijte pouze písmena, číslice, pomlčky a podtržítka","error-invalid-user":"Neplatný uživatel","error-invalid-username":"Neplatné uživatelské jméno","error-not-allowed":"Nepovoleno","error-not-authorized":"není povoleno","error-remove-last-owner":"Toto je poslední majitel. Prosím nastavit nový majitel Před vyjmutím tenhle.","error-role-name-required":"Název role je vyžadována","error-user-not-in-room":"Uživatel není v této místnosti","Error_changing_password":"Chyba změny hesla","Error_sending_confirmation_email":"Chyba při odesílání e-mailu s potvrzením","Error_too_many_requests":"Chyba, příliš mnoho požadavků. Prosím zpomal. Musíte počkat %s sekund před dalším pokusem","Esc_to":"Esc","Example_s":"Příklad: <code class=\"inline\">%s</code>","False":"Falešný","Favorites":"Oblíbené","Field":"Pole","Field_removed":"pole odebrána","File_exceeds_allowed_size_of_bytes":"Soubor překračuje povolenou velikost __size__ bajtů","FileUpload":"Nahrání souboru","FileUpload_Enabled":"Nahrávání souborů povoleno","FileUpload_File_Empty":"soubor prázdný","FileUpload_FileSystemPath":"systém Path","FileUpload_MaxFileSize":"Maximální Nahrát soubor velikost (v bytech)","FileUpload_MediaType_NotAccepted":"Druhy tiskových médií Nebyla přijata","FileUpload_MediaTypeWhiteList":"Přijaté typy médií","FileUpload_MediaTypeWhiteListDescription":"Čárkami oddělený seznam typů médií. Ponechte prázdné pro příjem všech typů médií.","FileUpload_ProtectFiles":"Chránit nahrané soubory","FileUpload_ProtectFilesDescription":"Pouze ověření uživatelé budou mít přístup","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 název kbelík","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN doména ke stažení","FileUpload_S3_Region":"Kraj","FileUpload_Storage_Type":"Typ úložiště","Flags":"Vlajky","Follow_social_profiles":"Sledujte naše sociální profily, vidlice se k nám na github a sdílet své myšlenky o rocket.chat app na našem Trello palubě.","Food_and_Drink":"Jídlo pití","For_your_security_you_must_re_enter_your_password_to_continue":"Pro vaši bezpečnost, je nutné znovu zadat heslo, aby i nadále","Force_SSL":"Force SSL","Force_SSL_Description":"* Pozor! * _Force SSL_ by nikdy neměl být používán s reverzní proxy. Máte-li reverzní proxy, byste měli udělat přesměrování tam. Tato možnost existuje pro nasazení jako Heroku, který neumožňuje konfiguraci přesměrování na reverzní proxy.","Forgot_password":"Zapomněli jste heslo","Fork_it_on_github":"Vyklopit ho na github","Frequently_Used":"často používané","From":"Od","From_Email":"z e-mailem","From_email_is_required":"Od je zapotřebí e-mail","From_email_warning":"<b>Upozornění:</b> Pole <b>Od</b> podléhá nastavení poštovního serveru.","General":"Generál","Get_to_know_the_team":"Poznejte Rocket.Team","github_no_public_email":"Nemáte žádné e-maily jako veřejný e-mail ve svém účtu GitHub","Give_a_unique_name_for_the_custom_oauth":"Dát jedinečný název pro vlastní OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Dejte aplikačního jméno. To bude vidět vaše uživatele.","Global":"Globální","GoogleTagManager_id":"Id Správce značek Google","Has_more":"má více","Have_your_own_chat":"Mít svůj vlastní web chat. Vyvinuto ve spolupráci s Meteor.com je Rocket.Chat je skvělým řešením pro vývojáře, kteří dopředu budovat a rozvíjet své vlastní chatu platformu.","Header":"hlavička","Hidden":"Schovaný","Hide_Group_Warning":"Jste si jisti, že chcete skrýt skupiny \" %s\"?","Hide_Private_Warning":"Jste si jisti, že chcete skrýt diskusi s \" %s\"?","Hide_room":"Skrýt místnost","Hide_Room_Warning":"Jste si jisti, že chcete skrýt místnost \" %s\"?","Highlights":"Přednosti","Highlights_How_To":"Chcete-li být upozorněni, když někdo zmíní slovo nebo frázi, přidejte jej sem. Můžete oddělit slova nebo fráze čárkami. Zvýraznit slova nejsou malá a velká písmena.","Highlights_List":"Zvýraznit slova","History":"Dějiny","hours":"hodiny","How_friendly_was_the_chat_agent":"Jak přátelský byl chatu agentem?","How_knowledgeable_was_the_chat_agent":"Jak dobře informovaný byl chatu agentem?","How_responsive_was_the_chat_agent":"Jak reagovat bylo chatu agentem?","How_satisfied_were_you_with_this_chat":"Jak jste spokojeni jste byli s tímto chatu?","If_you_are_sure_type_in_your_password":"Pokud jste si jisti, zadejte heslo:","If_you_are_sure_type_in_your_username":"Pokud jste si jisti, zadejte své uživatelské jméno:","Importer_Archived":"archivovány","Importer_done":"Import dokončen!","Importer_finishing":"Dokončení importu.","Importer_From_Description":"Dovoz __from __ \"y dat do Rocket.Chat.","Importer_import_cancelled":"Import zrušen.","Importer_import_failed":"Došlo k chybě při spuštění importu.","Importer_importing_channels":"Import kanálů.","Importer_importing_messages":"Import zpráv.","Importer_importing_started":"Spuštění importu.","Importer_importing_users":"Import uživatelů.","Importer_not_defined_properly":"Dovozce nebyla definována správně, chybí třídu Import.","Importer_not_in_progress":"Dovozce je v současné době neběží.","Importer_Prepare_Restart_Import":"restart import","Importer_Prepare_Start_Import":"začít Import","Importer_Prepare_Uncheck_Archived_Channels":"Zrušte zaškrtnutí Archivoval Kanály","Importer_Prepare_Uncheck_Deleted_Users":"Zrušte zaškrtnutí odstraněné uživatelů","Importer_progress_error":"Nepodařilo se získat pokrok při importu.","Importer_setup_error":"při nastavování nástroje pro import došlo k chybě.","Incorrect_Password":"Nesprávné heslo","inline_code":"inline_code","Install_Extension":"nainstalovat rozšíření","Install_FxOs":"Nainstalovat Rocket.Chat na svůj Firefox","Install_FxOs_done":"Velký! Nyní můžete používat Rocket.Chat přes ikonu na úvodní obrazovce. Bavte se s Rocket.Chat!","Install_FxOs_error":"Je nám líto, že nefungovala, jak bylo zamýšleno! se objevila následující chyba:","Install_FxOs_follow_instructions":"Prosím potvrďte instalaci aplikace na vašem přístroji (stiskněte tlačítko \"Install\" po výzvě).","Installation":"Instalace","Integration_added":"Integrace byla přidána","Integration_Incoming_WebHook":"Příchozí WebHook Integrace","Integration_New":"Nová integrace","Integration_Outgoing_WebHook":"Odchozí WebHook Integrace","Integration_updated":"Integrace byla aktualizována","Integrations":"integrace","Invalid_asset":"Neplatný aktivum","Invalid_confirm_pass":"Potvrzení heslo neodpovídá heslo","Invalid_email":"E-mailová zadali, je neplatný","Invalid_Export_File":"Soubor nahrál není platný %s soubor exportu.","Invalid_file_height":"Neplatná výška pořadače","Invalid_file_type":"Neplatný typ souboru","Invalid_file_width":"Neplatná šířka soubor","Invalid_Import_File_Type":"Neplatný typ importovaného souboru.","Invalid_name":"Název nesmí být prázdný","Invalid_notification_setting_s":"Neplatné nastavení upozornění: %s","Invalid_pass":"Heslo nesmí být prázdné","Invalid_room_name":"<strong>%s</strong> není platné jméno místnosti,<br/> použijte pouze písmena, číslice a pomlčky","Invalid_room_type":"<strong> %s</strong> není platný typ pokoje.","Invalid_Secret_URL":"Neplatná Secret URL","Invalid_secret_URL_message":"Adresa URL je neplatná.","invisible":"neviditelný","Invisible":"Neviditelný","Invitation_HTML":"výzva HTML","Invitation_Subject":"Pozvánka Subject","Invite_user_to_join_channel":"Pozvat jednoho uživatele, aby se připojily k tomuto kanálu","Invite_Users":"Pozvat uživatele","is_also_typing":"také píše","is_also_typing_female":"Je také psaní","is_also_typing_male":"Je také psaní","is_typing":"píše","is_typing_female":"píše","is_typing_male":"píše","italics":"kurzíva","join":"Připojit","Join_audio_call":"Připojit zvukovou výzvu","Join_the_Community":"Zapojte se do společenství","Join_the_given_channel":"Přidejte se daný kanál","Join_video_call":"Přidejte se k videohovoru","Joined":"připojil","Jump":"Skok","Jump_to_first_unread":"Přejít na první nepřečtený","Jump_to_message":"Přejít na zprávy","Jump_to_recent_messages":"Přejít na nedávných zpráv","Katex_Enabled":"Katex Enabled","Label":"Označení","Language":"Jazyk","Language_Version":"Anglická verze","Last_login":"Poslední přihlášení","Last_message":"Poslední zpráva","Last_seen":"Naposledy viděn","Layout":"dispozice","Layout_Home_Body":"Domů Body","Layout_Home_Title":"Home Název","Layout_Login_Terms":"Smluvní podmínky přihlášení","Layout_Privacy_Policy":"Zásady ochrany osobních údajů","Layout_Sidenav_Footer":"Boční navigace","Layout_Sidenav_Footer_description":"Velikost zápatí je 260 x 70 pixelů","Layout_Terms_of_Service":"Podmínky služby","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Search","LDAP_Custom_Domain_Search_Description":"Kousek JSON, který řídí vazby a informací o připojení a je ve tvaru: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Výchozí domény","LDAP_Description":"LDAP je hierarchické databáze, která mnohé společnosti používají poskytovat jednotné přihlášení - zařízení pro sdílení jedno heslo mezi více webů a služeb. Pro pokročilé konfigurační informace a příklady naleznete na našich wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"doména Základna","LDAP_Domain_Base_Description":"Plně kvalifikovaný rozlišující název (DN) z podstromu LDAP, který chcete vyhledat pro uživatele a skupiny. Můžete přidat tolik, kolik chcete; Nicméně, každá skupina musí být definovány ve stejném základu doméně jako uživatele, které patří do něj. Zadáte-li omezené skupiny uživatelů, bude pouze uživatelé, kteří patří do těchto skupin být v rozsahu. Doporučujeme, abyste určit nejvyšší úroveň vaší LDAP adresářové struktuře jako svou základnu domény a použít vyhledávací filtr pro řízení přístupu.","LDAP_Domain_Search_Filter":"Domain Search Filter","LDAP_Domain_Search_Filter_Description":"Pokud je zadáno, pouze uživatelé, které odpovídají tomuto filtru budou moci přihlásit. Pokud není zadán žádný filtr, všichni uživatelé v rozsahu určeném základny domény budou moci přihlásit. <br/> Např Active Directory `memberOf = CN = ROCKET_CHAT, ou = General Groups`. <br/> Například pro OpenLDAP (rozšiřitelný zápas vyhledávání) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Kategorie","LDAP_Domain_Search_Object_Category_Description":"Znak * * objectCategory které identifikují svým uživatelům. <br/> Nechte prázdné pro * * OpenLDAP. <br/> Např `Person, atd.","LDAP_Domain_Search_Object_Class":"Domain Search třídy objektu","LDAP_Domain_Search_Object_Class_Description":"Znak * * objectclass, které identifikují svým uživatelům. <br/> Např `organizationalPerson`,` user`, `inetOrgPerson`, atd.","LDAP_Domain_Search_Password":"Domain Search Password","LDAP_Domain_Search_Password_Description":"Heslo pro uživatele doménu vyhledávání.","LDAP_Domain_Search_User":"Domain Search Uživatel","LDAP_Domain_Search_User_Description":"Uživatel LDAP, který provádí uživatelem vyhledávání ověřovat ostatním uživatelům při přihlášení. <br/> To je obvykle účet služby vytvořené speciálně pro integraci třetích stran. Použijte plně kvalifikovaný název, jako je například `cn = správce, CN = Uživatelé, DC = priklad, DC = com`.","LDAP_Domain_Search_User_ID":"Domain Search ID uživatele","LDAP_Domain_Search_User_ID_Description":"Atribut LDAP, který identifikuje uživatele LDAP, který pokusů o ověření. Toto pole by mělo být `sAMAccountName` pro instalace většinu Active Directory, ale to může být` uid` jiná řešení LDAP, například OpenLDAP. Můžete použít `mail` k identifikaci uživatele pomocí e-mailu nebo cokoliv atribut, který chcete. <br> Můžete použít více hodnot oddělených čárkou, která uživatelům umožňuje přihlášení pomocí více identifikátorů, jako jsou uživatelské jméno nebo e-mailu.","LDAP_Enable":"Umožnit","LDAP_Enable_Description":"Pokus využít LDAP pro autentizaci.","LDAP_Encryption":"šifrování","LDAP_Encryption_Description":"Metoda šifrování používá k zabezpečení komunikace se serverem LDAP. Jako příklady lze uvést `plain` (bez šifrování),` SSL / LDAPS` (šifrovaný od začátku), a `StartTLS` (upgrade pro šifrovanou komunikaci po připojení).","LDAP_Host":"Hostitel","LDAP_Host_Description":"Hostitel LDAP, například `` ldap.example.com` nebo 10.0.0.30`.","LDAP_Port":"Přístav","LDAP_Port_Description":"Port pro přístup k LDAP. např: `` 389` nebo 636` pro LDAPS","LDAP_Reject_Unauthorized":"odmítnout Neoprávněné","LDAP_Sync_User_Avatar":"Synchronizace User Avatar","LDAP_Sync_User_Data":"synchronizace dat","LDAP_Sync_User_Data_Description":"Udržujte uživatelská data v synchronizaci se serverem po přihlášení (např: jméno, e-mail).","LDAP_Sync_User_Data_FieldMap":"Uživatelská data pole Mapa","LDAP_Sync_User_Data_FieldMap_Description":"Konfiguruje pole uživatelských účtů (například e-maily) osídlené ze záznamu v LDAP (jednou našel). <br/> Jako příklad lze uvést, `{\" CN \":\" name \",\" mail \":\" email \"}` vybere člověka člověka srozumitelný název z atributu CN, a jejich e-maily z atributu pošty. <br/> Volné pole obsahují `name` a` email`.","LDAP_Sync_Users":"Sync Uživatelé","LDAP_Test_Connection":"Test připojení","LDAP_Unique_Identifier_Field":"Jedinečný identifikátor pole","LDAP_Unique_Identifier_Field_Description":"Které pole budou použity k propojení uživatelů LDAP a uživatel Rocket.Chat. Můžete informovat více hodnot oddělených čárkou aby se pokusili dostat hodnotu z LDAP záznamu. <br/> Výchozí hodnota je `objectGUID, IBM entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Použijte Custom Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Napište svůj vlastní filtr vyhledávat uživatele v LDAP serveru.","LDAP_Username_Field":"Uživatelské jméno pole","LDAP_Username_Field_Description":"Které pole budou použity jako * Jméno * pro nové uživatele. Ponechte prázdné použít jméno informován o přihlašovací stránce. <br/> Můžete použít šablony tagy také jako `# {} givenName. # {Sn}`. <br/> Výchozí hodnota je `sAMAccountName`.","Leave_Group_Warning":"Jste si jisti, že chcete opustit skupinu \" %s\"?","Leave_Private_Warning":"Jste si jisti, že chcete opustit diskusi s \" %s\"?","Leave_room":"Opustit místnost","Leave_Room_Warning":"Jste si jisti, že chcete opustit místnost \" %s\"?","line":"čára","List_of_Direct_Messages":"Seznam přímé zasílání zpráv","Live_sessions":"živé sezení","Livechat_agents":"LiveChat agenti","Livechat_Dashboard":"Livechat Dashboard","Livechat_enabled":"Livechat povoleno","Livechat_Manager":"Livechat Manažer","Livechat_managers":"manažeři LIVECHAT","Livechat_title":"Livechat Název","Livechat_title_color":"Livechat Název Barva pozadí","Livechat_Users":"LiveChat Uživatelé","Load_more":"Načíst další","Loading...":"Loading ...","Loading_more_from_history":"Zakládání více z historie","Loading_suggestion":"Načítání návrhů ...","Localization":"lokalizace","Log_File":"Zobrazit souborů a linka","Log_Level":"Log Level","Log_Package":"Show Package","Log_View_Limit":"Log View Limit","Logged_out_of_other_clients_successfully":"Odhlášen z jiných klientů úspěšně","Login":"Přihlásit se","Login_with":"Přihlášení pomocí %s","login_with":"Nebo se přihlašte přímo s","Logout":"Odhlásit se","Logout_Others":"Odhlášení z jiných přihlášen Locations","Mail_Message_Invalid_emails":"Poskytli jste jeden nebo více neplatných e-maily: %s","Mail_Message_Missing_to":"Musíte vybrat jednoho nebo více uživatelů nebo poskytovat jednu nebo více e-mailových adres oddělených čárkami.","Mail_Message_No_messages_selected_select_all":"Nevybrali jste žádné zprávy. Chtěli byste <a href='#' class='select-all'>vybrat všechny</a> viditelné zprávy?","Mail_Messages":"mailových zpráv","Mail_Messages_Instructions":"Vyberte si, které zprávy chcete poslat e-mailem kliknutím na zprávy","Mail_Messages_Subject":"Zde je vybraná část %s zpráv","Mailer":"Mailer","Mailer_body_tags":"Je <b>nutné</b> použít [odhlásit] pro odhlášení odkazu. <br /> Můžete použít [name], [fname], [lname] pro uživatele jména a příjmení, křestní jméno nebo příjmení, resp. <br /> na e-mail uživatele, můžete použít [email].","Make_Admin":"Udělat Správce","Manager_added":"přidal manažer","Manager_removed":"Manažer odstraněn","Mark_as_read":"Označit jako přečtené","Markdown_Headers":"markdown Hlavičky","Markdown_SupportSchemesForLink":"Markdown podpor pro Link","Markdown_SupportSchemesForLink_Description":"Čárkami oddělený seznam povolených režimů","Members_List":"Seznam členů","Mentions":"Zmínky","Mentions_default":"Zmínky (výchozí)","Message":"Zpráva","Message_AllowDeleting":"Povolit Message Mazání","Message_AllowEditing":"Umožnit editaci zpráv","Message_AllowEditing_BlockEditInMinutes":"Blok Zpráva Úprava Po (n) minuty","Message_AllowEditing_BlockEditInMinutesDescription":"Zadáním hodnoty 0 vypnete blokování.","Message_AllowPinning":"Povolit Message sbírky Pins","Message_AllowPinning_Description":"Povolení zpráv, které mají být přitlačen na některou z kanálů.","Message_AllowStarring":"Povolit Message Hrají","Message_AudioRecorderEnabled":"Audio Recorder Enabled","Message_AudioRecorderEnabledDescription":"Vyžaduje \"audio / wav 'soubory, které mají být přijaty typ média v nastavení' 'soubor nahrát.","Message_DateFormat":"Formát data","Message_DateFormat_Description":"Viz také: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Zpráva smazání není povoleno","Message_editing_blocked":"Tuto zprávu nelze upravovat již","Message_editing_not_allowed":"editace zprávy není povoleno","Message_GroupingPeriod":"Seskupení období (v sekundách)","Message_GroupingPeriodDescription":"Zprávy budou seskupeny s předchozí zprávou, pokud jsou obě od stejného uživatele a uplynulá doba byla kratší než informovaného čas v sekundách.","Message_KeepHistory":"Udržujte historie zpráv","Message_MaxAllowedSize":"Maximální povolená velikost zprávy","Message_MaxAll":"Maximální velikost kanál pro všechny zprávy","Message_pinned":"zpráva připnul","Message_pinning_not_allowed":"Zpráva fixací není povoleno","Message_removed":"odstraněny Message","Message_ShowDeletedStatus":"Show Deleted Status","Message_ShowEditedStatus":"Zobrazit upraveného stav","Message_ShowFormattingTips":"Zobrazit tipů na formátování","Message_TimeFormat":"Časový formát","Message_TimeFormat_Description":"Viz také: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Zpráva je příliš dlouhá","Messages":"zprávy","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Zprávy, které jsou odesílány do příchozí WebHook budou zveřejněny zde.","Meta":"meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Ověření stránek Google","Meta_language":"Jazyk","Meta_msvalidate01":"MSValidate.01","Meta_robots":"roboti","minutes":"zápis","Mobile_push":"mobilní Push","More_channels":"Další kanály","More_direct_messages":"Další přímé zprávy","More_groups":"Více Soukromé skupiny","More_unreads":"více unreads","Msgs":"zpr","multi":"multi","Mute_someone_in_room":"Mute někdo v místnosti","Mute_user":"Mute uživatel","Muted":"Muted","My_Account":"Můj účet","n_messages":" %s Zprávy","N_new_messages":" %s nových zpráv","Name":"Jméno","Name_cant_be_empty":"Název nemůže být prázdný","Name_of_agent":"Název agenta","Name_optional":"Jméno (volitelně)","Navigation_History_20_last_pages":"Navigace History (posledních 20 stran)","New_Application":"Nová aplikace","New_Custom_Field":"New Vlastní pole","New_Department":"nový odbor","New_integration":"Nová integrace","New_logs":"Nové protokoly","New_messages":"Nové zprávy","New_password":"Nové heslo","New_role":"Nová role","No_channel_with_name_%s_was_found":"Nebyl nalezen žádný kanál s názvem <strong>\" %s\"!</strong>","No_channels_yet":"Zatím se neúčastníte v žádném kanálu.","No_direct_messages_yet":"Zatím jste nezačali žádné konverzace.","No_Encryption":"Bez šifrování","No_favorites_yet":"Zatím jste nepřidali žádné oblíbené.","No_group_with_name_%s_was_found":"Nebyla nalezena žádná soukromá skupina s názvem <strong>\" %s\"!</strong>","No_groups_yet":"Zatím nemáte žádné soukromé skupiny.","No_livechats":"Nemáte žádné livechats.","No_mentions_found":"Neobsahuje výzvu k nalezeno","No_permission_to_view_room":"Nemáte oprávnění k zobrazení této místnosti","No_pinned_messages":"Žádné zprávy připnuté","No_results_found":"Nebyly nalezeny žádné výsledky","No_starred_messages":"Žádné zprávy s hvězdičkou","no_tokens_for_this_user":"Neexistují žádné tokeny pro tohoto uživatele","No_user_with_username_%s_was_found":"Nebyl nalezen žádný uživatel s uživatelským jménem <strong>\" %s\"!</strong>","Not_allowed":"Nepovoleno","Not_authorized":"není povoleno","Not_Available":"Není dostupný","Not_found_or_not_allowed":"Nebyl nalezen nebo není povolena","Nothing":"Nic","Nothing_found":"Nic nalezeno","Notifications":"oznámení","Notify_all_in_this_room":"Oznámit všechny v této místnosti","Num_Agents":"# Agents","Number_of_messages":"Počet zpráv","OAuth_Application":"OAuth Aplikace","OAuth_Applications":"OAuth Aplikace","Objects":"objekty","Off_the_record_conversation":"Off-the-záznamu konverzace","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record rozhovor není k dispozici pro prohlížeče nebo zařízení.","Offline_DM_Email":"[__site__] Byli jste přímý messaged podle __user__","Offline_Mention_Email":"[__site__] Jste bylo zmíněno __user__ v #__room__","Old_and_new_password_must_be_different":"Nové heslo musí být odlišný od starého hesla.","Old_and_new_password_required":"Je třeba poskytnout staré i nové heslo pro změnu hesla.","Online":"On-line","Only_errors":"pouze chyby","Only_you_can_see_this_message":"Pouze vidíte tuto zprávu","Oops!":"Oops","Open":"Otevřít","Opened":"Otevřený","Opt_out_statistics":"Neposílejte své statistiky Rocket.Chat","Opt_out_statistics_warning":"Zasláním své statistiky, budete nám pomáhá určit, jak jsou nasazeny mnoho příkladů Rocket.Chat, a jak dobře se systém chová, takže můžeme dále vylepšit. Nebojte se, protože žádné informace o uživateli je odeslána a všechny informace dostáváme se udržuje v tajnosti. Chcete-li pokračovat v odesílání nám své statistiky, zrušte zaškrtnutí políčka výše. Děkuji.","optional":"volitelný","Order":"Objednat","OS_Arch":"OS Arch","OS_Cpus":"OS Počet CPU","OS_Freemem":"OS volné paměti","OS_Loadavg":"OS zatížení Průměrná","OS_Platform":"OS Platform","OS_Release":"OS release","OS_Totalmem":"OS Celková paměť","OS_Type":"Typ OS","OS_Uptime":"OS Uptime","others":"ostatní","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR je k dispozici pouze pokud oba uživatelé online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Přepis URL, které soubory jsou nahrány. Tato adresa URL také použít pro stahování ledaže CDN je dána","Password":"Heslo","Password_Change_Disabled":"Váš Rocket.Chat správce zakázal změnu hesel","Password_changed_successfully":"Heslo úspěšně změněno","Payload":"Užitečné zatížení","People":"Lidé","Permissions":"oprávnění","Pin_Message":"pin Message","Pinned_a_message":"Připnul zprávu:","Pinned_Messages":"připnuté Zprávy","Placeholder_for_email_or_username_login_field":"Zástupný symbol pro e-mail nebo uživatelské jméno pro přihlášení pole","Placeholder_for_password_login_field":"Zástupný symbol pro heslo pro přihlášení pole","Please_answer_survey":"Věnujte prosím chvilku odpovědět rychlý přehled o tomto chatu","Please_enter_value_for_url":"Prosím, zadejte hodnotu pro adresu URL vašeho avatara.","Please_enter_your_new_password_below":"Níže zadejte své nové heslo:","Please_fill_a_label":"Prosím, vyplňte štítek","Please_fill_a_name":"Prosím vyplňte název","Please_fill_a_username":"Prosím vyplňte uživatelské jméno","Please_fill_name_and_email":"Prosím vyplňte jméno a e-mail","Please_re_enter_your_password":"Prosím znovu zadat heslo","Please_select_enabled_yes_or_no":"Vyberte volbu pro Enabled","Please_wait":"Prosím, čekejte","Please_wait_activation":"Prosím, vyčkejte, to může trvat delší dobu.","Please_wait_statistics":"Prosím vyčkejte, statistiky jsou generovány.","Please_wait_while_OTR_is_being_established":"Počkejte prosím, OTR je založena","Please_wait_while_your_account_is_being_deleted":"Prosím čekejte, váš účet je smazán ...","Please_wait_while_your_profile_is_being_saved":"Počkejte prosím, než váš profil je uložen ...","Post_as":"Post as","Post_to_Channel":"Příspěvek ke kanálu","Post_to_s_as_s":"Příspěvek <strong>k %s</strong> <strong>jako %s</strong>","Powered_by":"Běží na","Preferences":"Předvolby","Preferences_saved":"Nastavení uloženo","Privacy":"Soukromí","Private_Group":"Private Group","Private_Groups":"Soukromé skupiny","Private_Groups_list":"Seznam Soukromé skupiny","Profile":"Profil","Profile_saved_successfully":"Profil byl úspěšně uložen","Proudly_developed":"Hrdě vyvinuta s Meteor","Push":"Tlačit","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Přístupové heslo","Push_debug":"Ladit","push_disabled":"tlačit tělesně postižené","Push_enable":"Umožnit","Push_enable_gateway":"Zapnout brána","Push_gateway":"Brána","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Číslo projektu","Push_production":"Výroba","Push_show_message":"Zobrazit zprávu v oznámení","Push_show_username_room":"Zobrazit kanál / skupina / uživatelské jméno v oznámení","Push_test_push":"Test","Query":"Dotaz","Query_description":"Dodatečné podmínky pro určení toho, které uživatelům odeslat e-mail. Neupsané uživatelé jsou automaticky odstraněny z dotazu. Musí být platný JSON. Příklad: \"{\" createdAt \": {\" $ gt \": {\" Datum $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Rychlé vyhledávání","quote":"citát","Reactions":"reakce","Recents":"Nedávné","Record":"Záznam","Redirect_URI":"přesměrování URI","Refresh_keys":"Obnovit klíče","Refresh_your_page_after_install_to_enable_screen_sharing":"Obnovte stránku po instalaci umožní sdílení obrazovky","Register":"Zaregistrovat nový účet","Registration_Succeeded":"Registrace Uspěl","Remember_me":"Zapamatuj si mě","Remove":"Odstranit","Remove_Admin":"Odebrat Správce","Remove_as_moderator":"Odstraňte jako moderátor","Remove_as_owner":"Odstraňte jako vlastník","Remove_custom_oauth":"Odebrat vlastní OAuth","Remove_from_room":"Odstraňte z místnosti","Remove_someone_from_room":"Odeberte někoho z místnosti","Removed":"odstraněno","Require_password_change":"Požadovat změnu hesla","Resend_verification_email":"Opětovné zaslání ověřovacího e-mailu","Reset":"resetovat","Reset_password":"Obnovit heslo","Restart":"restart","Restart_the_server":"Restartujte server","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"Jméno RocketBot","RocketBot_Name_Description":"Název RocketBot musí mít platné uživatelské jméno registrováno na svém serveru.","Role":"Role","Role_Editing":"Role Editace","Role_removed":"odstraněna úloha","Room":"Pokoj","Room_archivation_state":"Stát","Room_archivation_state_false":"Aktivní","Room_archivation_state_true":"archivovány","Room_archived":"pokoj archivovány","room_changed_privacy":"Typ pokoje změněn na: <em>__room_type__</em> podle <em>__user_by__</em>","room_changed_topic":"Téma Room změněn na: <em>__room_topic__</em> podle <em>__user_by__</em>","Room_has_been_deleted":"Pokoj byl smazán","Room_Info":"pokoj Info","Room_name_changed":"Jméno místnosti změněno na: <em>__room_name__</em> uživatelem <em>__user_by__</em>","Room_name_changed_successfully":"Změna jména místnosti proběhla úspěšně","Room_not_found":"Pokoj nebyl nalezen","Room_topic_changed_successfully":"Téma pokoj úspěšně změněna","Room_type_changed_successfully":"Typ pokoje úspěšně změněna","Room_unarchived":"pokoj nearchivované","Room_uploaded_file_list":"Seznam souborů","Room_uploaded_file_list_empty":"Žádné soubory k dispozici.","room_user_count":"Uživatelé %s","Rooms":"Rooms","S_new_messages_since_s":" %s nové zprávy od %s","SAML":"SAML","SAML_Custom_Cert":"Custom Certifikát","SAML_Custom_Entry_point":"Custom vstupní bod","SAML_Custom_Generate_Username":"generovat jméno","SAML_Custom_Issuer":"Custom Emitent","SAML_Custom_Provider":"Custom Provider","Save":"Uložit","Save_changes":"Uložit změny","Save_Mobile_Bandwidth":"Save Mobile Bandwidth","Save_to_enable_this_action":"Uložit k tomu, aby tuto akci","Saved":"uložen","Saving":"spoření","Scope":"Rozsah","Screen_Share":"Screen Share","Script_Enabled":"Script Enabled","Search":"Vyhledávání","Search_by_username":"Vyhledávání podle jména","Search_Channels":"hledání kanálů","Search_Direct_Messages":"Vyhledávání přímé zasílání zpráv","Search_Messages":"Hledat zprávy","Search_Private_Groups":"Vyhledávání uzavřenou společnost","Search_settings":"nastavení vyhledávání","seconds":"sekundy","See_all":"Zobrazit všechny","See_only_online":"Pouze online","Select_a_department":"Vyberte oddělení","Select_an_avatar":"Vyberte avatar","Select_file":"Zvolte soubor","Select_service_to_login":"Vyberte službu pro přihlášení do načíst obrázek nebo nahrát jeden přímo z vašeho počítače","Select_user":"Vybrat uživatel","Select_users":"Vyberte uživatele","Selected_agents":"Vybrané agenti","Selected_users":"Vybraní členové","Send":"Poslat","Send_a_message":"Poslat zprávu","Send_a_test_mail_to_my_user":"Odeslání testovacího e-mailu na můj uživatele","Send_a_test_push_to_my_user":"Odeslat zkušební tlak do mého uživatele","Send_confirmation_email":"Zaslat potvrzovací e-mail","Send_data_into_RocketChat_in_realtime":"Posílat data do Rocket.Chat v reálném čase.","Send_email":"Poslat e-mailem","Send_invitation_email":"Poslat e-mailem pozvánku","Send_invitation_email_error":"Jste neposkytli žádnou platnou e-mailovou adresu.","Send_invitation_email_info":"Můžete odeslat více e-mailové pozvánky najednou.","Send_invitation_email_success":"Úspěšně jste poslali e-mailem pozvánku na následujících adresách:","Send_invitation_email_warning":"Aby bylo možné odeslat pozvánku e-maily, musíte nejprve konfigurovat nastavení SMTP.","Send_Message":"Poslat zprávu","Send_your_JSON_payloads_to_this_URL":"Pošlete své JSON užitečné zatížení na tuto adresu URL.","Sending":"Odesílání ...","Set_as_moderator":"Nastavit jako moderátor","Set_as_owner":"Nastavit jako vlastník","Settings":"Nastavení","Settings_updated":"Nastavení aktualizováno","Should_be_a_URL_of_an_image":"By měla být URL obrázku.","Should_exists_a_user_with_this_username":"Uživatel musí již existovat.","Show_all":"Ukázat vše","Show_more":"Zobrazit více","Show_only_online":"Pouze on-line","Show_preregistration_form":"Ukázat pre-registrační formulář","Showing_archived_results":"<p> <b>Ukazovat %s</b> archivované výsledky </p>","Showing_online_users":"Viditelných <b>__total_showing__</b> z __total__ users","Showing_results":"<p> <b>Ukazovat %s</b> výsledky </p>","Silence":"Umlčet","since_creation":"Od %s","Site_Name":"Jméno stránky","Site_Url":"Site URL","Site_Url_Description":"Příklad: https://chat.domain.com/","Skip":"Přeskočit","Smileys_and_People":"Smajlíky & Lidé","SMTP":"SMTP","SMTP_Host":"Hostitel SMTP","SMTP_Password":"Heslo SMTP","SMTP_Port":"Port SMTP","SMTP_Test_Button":"Nastavení Test SMTP","SMTP_Username":"SMTP Uživatelské jméno","Sound":"Zvuk","Star_Message":"hvězda Message","Starred_Messages":"Zprávy s hvězdičkou","Start_audio_call":"Spuštění zvuku volání","Start_Chat":"Spustit chat","Start_of_conversation":"Začít konverzaci","Start_OTR":"Začátek OTR","Start_video_call":"Začít videohovor","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Začněte s <code class=\"inline\">%s</code> pro uživatele nebo <code class=\"inline\">%s</code> pro kanál. Např: <code class=\"inline\">%s</code> nebo <code class=\"inline\">%s</code>","Statistics":"Statistika","Stats_Active_Users":"Aktivní uživatelé","Stats_Avg_Channel_Users":"Průměrného uživatele Channel","Stats_Avg_Private_Group_Users":"Průměrné soukromé skupiny uživatelů","Stats_Away_Users":"daleko Uživatelé","Stats_Max_Room_Users":"Maximální počet pokojů Uživatelé","Stats_Non_Active_Users":"neaktivní Uživatelé","Stats_Offline_Users":"Offline Uživatelé","Stats_Online_Users":"Online uživatelé","Stats_Total_Channels":"Celkový počet kanálů","Stats_Total_Direct_Messages":"Celkem Přímé pokoje zpráv","Stats_Total_Messages":"Celkem zpráv","Stats_Total_Private_Groups":"Celkem Soukromé skupiny","Stats_Total_Rooms":"Celkem pokojů","Stats_Total_Users":"Celkem uživatelů","Stop_Recording":"Zastavit záznam","strike":"stávka","Subject":"Předmět","Submit":"Předložit","Success":"Úspěch","Survey":"Průzkum","Survey_instructions":"Hodnotit každou otázku dle vaší spokojenosti, 1 což znamená, že jsou zcela nespokojeni a 5 což znamená, že jsou zcela spokojeni.","Symbols":"symboly","Sync_success":"Sync úspěch","Sync_Users":"Sync Uživatelé","Test_Connection":"Test připojení","Test_Desktop_Notifications":"Testovací Desktop Oznámení","Thank_you_for_your_feedback":"Děkujeme vám za vaši reakci","The_application_name_is_required":"Název aplikace je vyžadováno","The_channel_name_is_required":"Název kanálu je požadováno","The_emails_are_being_sent":"Tyto e-maily jsou odesílány.","The_field_is_required":"Je vyžadován pole %s.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Obraz resize nebude fungovat, protože nemůžeme zjistit ImageMagick nebo GraphicsMagick nainstalován na serveru.","The_redirectUri_is_required":"Je vyžadován redirectUri","The_server_will_restart_in_s_seconds":"Server bude restartován za %s sekund","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Nastavení %s</strong> je nakonfigurován tak, <strong>aby %sa</strong> přistupujete <strong>z %s!</strong>","The_user_will_be_removed_from_s":"Uživatel bude odstraněna z %s","The_user_wont_be_able_to_type_in_s":"Uživatel nebude moci psát v %s","Theme":"Téma","theme-color-action-buttons-color":"Akce Tlačítka Color","theme-color-active-channel-background-color":"Aktivní kanál Barva pozadí","theme-color-active-channel-font-color":"Aktivní kanál Barva písma","theme-color-blockquote-background":"Blockquote Barva pozadí","theme-color-clean-buttons-color":"Čisté Tlačítka Color","theme-color-code-background":"Kód Barva pozadí","theme-color-code-border":"Kód Barva rámečku","theme-color-code-color":"kód Color","theme-color-content-background-color":"Obsah Barva pozadí","theme-color-custom-scrollbar-color":"Vlastní barva Scrollbar","theme-color-info-active-font-color":"Aktivní Info Barva písma","theme-color-info-font-color":"Info Barva písma","theme-color-input-font-color":"Vstupní Barva písma","theme-color-link-font-color":"Link Barva písma","theme-color-message-hover-background-color":"Zpráva Hover BG Color","theme-color-primary-background-color":"Primární Barva pozadí","theme-color-primary-font-color":"Primární Barva písma","theme-color-quaternary-font-color":"Kvartérní Barva písma","theme-color-secondary-background-color":"Sekundární Barva pozadí","theme-color-secondary-font-color":"Sekundární Barva písma","theme-color-smallprint-font-color":"Small Print Barva písma","theme-color-smallprint-hover-color":"Small Print Hover Color","theme-color-status-away":"Pryč Status Color","theme-color-status-busy":"Busy Status Color","theme-color-status-offline":"Offline Stav Color","theme-color-status-online":"Online stav Color","theme-color-tertiary-background-color":"Terciární Barva pozadí","theme-color-tertiary-font-color":"Terciární Barva písma","theme-color-unread-notification-color":"Nepřečtená upozornění Color","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"Neexistují žádné přidané do tohoto oddělení, ale činidla.","There_are_no_integrations":"Neexistují žádná integrace","There_are_no_users_in_this_role":"Nejsou žádné uživatelé v této roli.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Tento e-mail již byla použita a nebyl ověřen. Změňte své heslo.","This_is_a_desktop_notification":"Jedná se o oznámení desktop","This_is_a_push_test_messsage":"To je tlak testovací zprávu uživateli","Time_in_seconds":"Čas v sekundách","Title_bar_color":"Záhlaví barva","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Chcete-li nainstalovat Rocket.Chat LiveChat na své webové stránky, copy & paste tento kód nad posledním <strong></ body></strong> značku na vašich stránkách.","To_users":"uživatelům","Topic":"Téma","Travel_and_Places":"Travel & Místa","Trigger_removed":"Trigger odstraněno","Trigger_Words":"spouštěcí slova","Triggers":"Triggers","True":"Skutečný","Type":"Typ","Type_your_new_password":"Zadejte nové heslo","Unarchive":"Zrušit archivaci","Unmute_someone_in_room":"Nahlas někdo v místnosti","Unmute_user":"Nahlas uživatel","Unnamed":"nejmenovaný","Unpin_Message":"Uvolnit Message","Unread_Rooms":"nepřečtených pokoje","Unread_Rooms_Mode":"Nepřečtených pokoje Mode","Unstar_Message":"Odebrat hvězdičku","Upload_file_question":"Nahrát soubor?","Uploading_file":"Nahrávání souboru ...","Use_account_preference":"Použít účet preferenci","Use_Emojis":"Použijte emodži","Use_initials_avatar":"Použijte své uživatelské jméno iniciály","use_menu":"Pomocí nabídky postranní přístup ke svým pokoje a chaty","Use_service_avatar":"Použijte %s avatar","Use_this_username":"Pomocí tohoto uživatelského jména","Use_uploaded_avatar":"Použít nahranou avatar","Use_url_for_avatar":"Použijte URL pro avatar","User__username__is_now_a_moderator_of__room_name_":"Uživatel uživatelské jméno __username__ je nyní moderátor __room_name__","User__username__is_now_a_owner_of__room_name_":"Uživatel uživatelské jméno __username__ je nyní vlastníkem __room_name__","User__username__removed_from__room_name__moderators":"Uživatel uživatelské jméno __username__ odstraněn z __room_name__ moderátorů","User__username__removed_from__room_name__owners":"Uživatel uživatelské jméno __username__ odstraněn z __room_name__ majitelů","User_added":"přidán User","User_added_by":"<em>__user_by__</em> přidal uživatele <em>__user_added__</em>.","User_added_successfully":"Uživatel byl úspěšně přidán","User_Channels":"Uživatelské kanály","User_doesnt_exist":"Žádný uživatel existuje pod názvem `@ %s`.","User_has_been_activated":"Uživatel byl aktivován","User_has_been_deactivated":"Uživatel byl deaktivován","User_has_been_deleted":"Uživatel byl smazán","User_has_been_muted_in_s":"Uživatel byl ztlumen v %s","User_has_been_removed_from_s":"Uživatel byl odebrán z %s","User_has_disconnected":"Uživatel se odpojil","User_Info":"Informace o uživateli","User_is_no_longer_an_admin":"Uživatel je už ne admin","User_is_not_activated":"Uživatel není aktivován","User_is_now_an_admin":"Uživatel je nyní admin","User_joined_channel":"Se připojil ke kanálu.","User_joined_channel_female":"Se připojil ke kanálu.","User_joined_channel_male":"Se připojil ke kanálu.","User_left":"Opustil(a) kanál.","User_left_female":"Opustil kanál.","User_left_male":"Opustil kanál.","User_logged_out":"Uživatel je odhlášen","User_management":"Správa uživatelů","User_muted_by":"Uživatel <em>__user_muted__</em> ztlumen <em>__user_by__.</em>","User_muted_in_room":"Uživatel ztlumen v pokoji","User_not_found":"Uživatel nenalezen","User_not_found_or_incorrect_password":"Uživatel nebyl nalezen nebo nesprávné heslo","User_or_channel_name":"Uživatel nebo kanál název","User_removed":"Uživatel odstraněn","User_removed_by":"<em>__user_by__</em> odstranil uživatele <em>__user_removed__</em>.","User_removed_from_room":"Uživatel byl odstraněn z místnosti","User_Settings":"Uživatelská nastavení","User_unmuted_by":"Uživatel <em>__user_unmuted__</em> ignorován podle <em>__user_by__.</em>","User_unmuted_in_room":"Uživatel ignorován v pokoji","User_updated_successfully":"Uživatel úspěšně aktualizováno","Username":"Uživatelské jméno","Username_and_message_must_not_be_empty":"Uživatelské jméno a zprávy nesmí být prázdné.","Username_cant_be_empty":"Uživatelské jméno nemůže být prázdný","Username_Change_Disabled":"Váš Rocket.Chat správce zakázal výměnu uživatelských jmen","Username_denied_the_OTR_session":"uživatelské jméno __username__ popřel relaci OTR","Username_description":"Uživatelské jméno se používá k umožnit ostatním, aby vás zmínil ve zprávách.","Username_doesnt_exist":"Uživatelské jméno ` %s` neexistuje.","Username_ended_the_OTR_session":"uživatelské jméno __username__ ukončil relaci OTR","Username_invalid":"<strong> %s</strong> není platné uživatelské jméno, <br/> použijte pouze písmena, číslice, tečky, pomlčky a podtržítka","Username_is_already_in_here":"`@ %s` už je tady.","Username_is_not_in_this_room":"Uživatel `# %s` není v této místnosti.","Username_not_found":"Uživatelské jméno nebyl nalezen","Username_title":"registrovat uživatelské jméno","Username_unavaliable":"<strong> %s</strong> je již v provozu :(","Username_wants_to_start_otr_Do_you_want_to_accept":"uživatelské jméno __username__ chce začít OTR. Chcete přijmout?","Users":"uživatelé","Users_in_role":"Uživatelé v roli","UTF8_Names_Slugify":"UTF8 Jména Slugify","UTF8_Names_Validation":"UTF8 Jména Validation","UTF8_Names_Validation_Description":"Neumožňují speciální znaky a mezery. Můžete použít - _ a. ale ne na konci názvu","Verification_email_sent":"Ověřovací email odeslán","View_All":"Zobrazit vše","View_Logs":"Zobrazení protokolů","Visibility":"Viditelnost","Visible":"viditelný","Visitor":"Návštěvník","Visitor_page_URL":"Stránka návštěvník URL","Visitor_time_on_site":"Doba návštěvník na místě","Wait_activation_warning":"Předtím, než se můžete přihlásit, váš účet musí být ručně aktivovat správce.","We_are_offline_Sorry_for_the_inconvenience":"Jsme offline. Omluvám se za nepříjemnost.","We_have_sent_password_email":"Zaslali jsme vám e-mail s pokyny k resetování hesla. Pokud nechcete obdržíte e-mail, prosím, vrátit se a zkuste to znovu.","We_have_sent_registration_email":"Jsme vám poslali e-mail pro potvrzení registrace. Pokud nechcete obdržíte e-mail, prosím, vrátit se a zkuste to znovu.","WebRTC_Enable_Channel":"Povolit veřejnoprávních kanálů","WebRTC_Enable_Direct":"Aktivovat pro přímé zasílání zpráv","WebRTC_Enable_Private":"Aktivovat pro soukromé kanály","WebRTC_Servers":"STUN / TURN servery","WebRTC_Servers_Description":"Seznam STUN a otočit serverů oddělených čárkou. <br/> Uživatelské jméno, heslo a port jsou povoleny ve formátu `uživatelské jméno: heslo @ omráčení: host: port` nebo` uživatelské jméno: heslo @ Turn: Host: port`.","Welcome":"Vítej <em>%s</em>.","Welcome_to_the":"Vítejte v","will_be_able_to":"budou moci","With_whom":"S kým","Yes":"Ano","Yes_clear_all":"Ano, vymazat všechny!","Yes_delete_it":"Ano, odstraňte ji!","Yes_hide_it":"Ano, skrýt!","Yes_leave_it":"Ano, nech toho!","Yes_mute_user":"Ano, mute uživatel!","Yes_remove_user":"Ano, odstranit daného uživatele!","you_are_in_preview_mode_of":"Nacházíte se v režimu náhledu kanálu # <strong>__room_name__</strong>","You_are_logged_in_as":"Jste přihlášeni jako","You_are_not_authorized_to_view_this_page":"Nemáte oprávnění k zobrazení této stránky.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Jste poslední vlastníkem. Před opuštěním místnosti Prosím nastavte nového majitele.","You_can_change_a_different_avatar_too":"Můžete přepsat avatar slouží k přidání z této integrace.","You_can_use_an_emoji_as_avatar":"Můžete také použít emodži jako avatar.","You_have_been_muted":"Byli jste utlumen a nemůže mluvit v této místnosti","You_have_not_verified_your_email":"Jste neověřili e-mail.","You_have_successfully_unsubscribed":"Úspěšně jste se odhlásili z našeho seznamu emailové.","You_informed_an_invalid_FROM_address":"Informoval jste neplatný FROM adresu.","You_must_provide_the_unsubscribe_link":"Je nutné poskytnout [Zrušit registraci] odkazu.","You_need_confirm_email":"Musíte potvrdit svůj e-mail a přihlásit se!","You_need_install_an_extension_to_allow_screen_sharing":"Musíte nainstalovat rozšíření dovolit sdílení obrazovky","You_need_to_change_your_password":"Musíte změnit své heslo","You_need_to_type_in_your_password_in_order_to_do_this":"Je potřeba zadat heslo, aby se tak stalo!","You_need_to_type_in_your_username_in_order_to_do_this":"Musíte zadat své uživatelské jméno, aby se tak stalo!","You_need_to_verifiy_your_email_address_to_get_notications":"Musíte ověření, že e-mailovou adresu dostávat oznámení","You_should_name_it_to_easily_manage_your_integrations":"Měli byste pojmenovat to, aby snadno spravovat integrace.","You_will_not_be_able_to_recover":"Nebudete moci obnovit tuto zprávu!","You_will_not_be_able_to_recover_file":"Nebudete moci obnovit tento soubor!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Nebudete dostávat e-mailová oznámení, protože jste neověřili svůj e-mail.","Your_email_has_been_queued_for_sending":"Váš e-mail byl zařazen do fronty pro odesílání","Your_entry_has_been_deleted":"Váš příspěvek byl smazán.","Your_file_has_been_deleted":"Váš soubor byl odstraněn.","Your_mail_was_sent_to_s":"Váš mail byl odeslán %s","Your_Open_Source_solution":"Vaše vlastní řešení s otevřeným zdrojovým kódem chatu","Your_password_is_wrong":"Vaše heslo je špatně!","Your_push_was_sent_to_s_devices":"Váš tlak byl poslán do %s přístroji"});
TAPi18n._registerServerTranslator("cs", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/de.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["de"] = ["German","Deutsch"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["de"])) {                                                                        // 9
  TAPi18n.translations["de"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["de"][namespace])) {                                                             // 13
  TAPi18n.translations["de"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["de"][namespace], {"500":"Interner Severfehler","0_Errors_Only":"0 - nur Fehler","1_Errors_and_Information":"1 - Fehler und Informationen","2_Erros_Information_and_Debug":"2 - Fehler, Informationen und Debug-Meldungen","__username__was_set__role__by__user_by_":"__username__ ist jetzt __role__, geändert von __user_by_","__username__is_no_longer__role__defined_by__user_by_":"__username__ ist nicht länger __role__, geändert von __user_by__","Access_not_authorized":"Der Zugriff ist nicht gestattet.","Access_online_demo":"Öffne die Online-Demo","Access_Online_Demo":"Öffne die Online Demo","Access_Token_URL":"URL des Access-Token","Accounts":"Konten","Accounts_AllowDeleteOwnAccount":"Benutzern erlauben, ihr Konto zu löschen","Accounts_AllowedDomainsList":"Liste von erlaubten Domains","Accounts_AllowedDomainsList_Description":"Durch Kommata getrennte Liste von erlaubten Domains","Accounts_AllowEmailChange":"Ändern der E-Mail-Adresse erlauben","Accounts_AllowPasswordChange":"Ändern des Passworts zulassen","Accounts_AllowUserAvatarChange":"Benutzern das Ändern des Profilbilds erlauben","Accounts_AllowUsernameChange":"Ändern von Benutzernamen erlauben","Accounts_AllowUserProfileChange":"Benutzern das Ändern des Profils erlauben","Accounts_AvatarResize":"Größe des Profilbilds anpassen","Accounts_AvatarSize":"Größe des Profilbilds","Accounts_AvatarStorePath":"Speicherpfad des Profilbilds","Accounts_AvatarStoreType":"Speichertyp des Profilbilds","Accounts_BlockedDomainsList":"Liste von geblockten Domains","Accounts_BlockedDomainsList_Description":"Kommata getrennte Liste von geblockten Domains","Accounts_denyUnverifiedEmail":"Nicht verifizierte E-Mail-Adressen ablehnen","Accounts_EmailVerification":"E-Mail-Verifizierung","Accounts_EmailVerification_Description":"Um diese Funktion nutzen zu können, stellen Sie bitte sicher, dass ihre SMTP-Einstellungen korrekt sind.","Accounts_Enrollment_Email":"Registrierungsmail","Accounts_Enrollment_Email_Description":"Sie können [name] für den Vor- und Nachnamen, [fname] für den Vornamen oder [lname] für den Nachnamen des Benutzers verwenden. <br />Ebenfalls können Sie [email] verwenden, um die E-Mail-Adresse des Benutzers anzugeben.","Accounts_Iframe_api_method":"API-Methode","Accounts_Iframe_api_url":"API-URL","Accounts_iframe_enabled":"aktiviert","Accounts_iframe_url":"iFrame-URL","Accounts_LoginExpiration":"Ablauffrist der Anmeldung","Accounts_ManuallyApproveNewUsers":"Neue Benutzer manuell aktivieren","Accounts_OAuth_Custom_Token_Sent_Via":"Token gesendet über","Accounts_OAuth_Custom_Authorize_Path":"Autorisierungspfad","Accounts_OAuth_Custom_Button_Color":"Buttonfarbe","Accounts_OAuth_Custom_Button_Label_Color":"Farbe des Buttontexts","Accounts_OAuth_Custom_Button_Label_Text":"Text des Buttons","Accounts_OAuth_Custom_Enable":"Aktivieren","Accounts_OAuth_Custom_id":"ID","Accounts_OAuth_Custom_Identity_Path":"Identitätspfad","Accounts_OAuth_Custom_Login_Style":"Anmeldungsart","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Pfad des Token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Anmeldung über Facebook erlauben","Accounts_OAuth_Facebook_callback_url":"Facebook-Callback-URL","Accounts_OAuth_Facebook_id":"Facebook-App-ID","Accounts_OAuth_Facebook_secret":"Facebook-Secret","Accounts_OAuth_Github":"OAuth aktivieren","Accounts_OAuth_Github_callback_url":"GitHub-Callback-URL","Accounts_OAuth_GitHub_Enterprise":"OAuth aktivieren","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub-Enterprise-Callback-URL","Accounts_OAuth_GitHub_Enterprise_id":"Client-ID","Accounts_OAuth_GitHub_Enterprise_secret":"Client-Secret","Accounts_OAuth_Github_id":"Client-ID","Accounts_OAuth_Github_secret":"Client-Secret","Accounts_OAuth_Gitlab":"OAuth aktivieren","Accounts_OAuth_Gitlab_callback_url":"GitLab-Callback-URL","Accounts_OAuth_Gitlab_id":"GitLab-ID","Accounts_OAuth_Gitlab_secret":"Client-Secret","Accounts_OAuth_Google":"Google-Anmeldung erlauben","Accounts_OAuth_Google_callback_url":"Google-Callback-URL","Accounts_OAuth_Google_id":"Google-ID","Accounts_OAuth_Google_secret":"Google-Secret","Accounts_OAuth_Linkedin":"Anmeldung über LinkedIn erlauben","Accounts_OAuth_Linkedin_callback_url":"LinkedIn-Callback-URL","Accounts_OAuth_Linkedin_id":"LinkedIn-ID","Accounts_OAuth_Linkedin_secret":"Linkeding-Secret","Accounts_OAuth_Meteor":"Anmeldung über Meteor erlauben","Accounts_OAuth_Meteor_callback_url":"Meteor-Callback-URL","Accounts_OAuth_Meteor_id":"Meteor-ID","Accounts_OAuth_Meteor_secret":"Meteor-Secret","Accounts_OAuth_Twitter":"Anmeldung über Twitter erlauben","Accounts_OAuth_Twitter_callback_url":"Twitter-Callback-URL","Accounts_OAuth_Twitter_id":"Twitter-ID","Accounts_OAuth_Twitter_secret":"Twitter-Secret","Accounts_OAuth_Wordpress":"Anmeldung über Wordpress","Accounts_OAuth_Wordpress_callback_url":"Wordpress-Callback-URL","Accounts_OAuth_Wordpress_id":"WordPress-ID","Accounts_OAuth_Wordpress_secret":"Wordpress-Secret","Accounts_PasswordReset":"Passwort zurücksetzen","Accounts_Registration_AuthenticationServices_Enabled":"Anmeldung mit Authentifizierungsdiensten","Accounts_RegistrationForm":"Anmeldeformular","Accounts_RegistrationForm_Disabled":"Deaktiviert","Accounts_RegistrationForm_LinkReplacementText":"Ersatztext für den Registrierungslink","Accounts_RegistrationForm_Public":"Öffentlich","Accounts_RegistrationForm_Secret_URL":"Geheime URL","Accounts_RegistrationForm_SecretURL":"Geheime URL für die Registrierungsseite","Accounts_RegistrationForm_SecretURL_Description":"Sie müssen eine zufällige Zeichenfolge, die der Registrierungs-URL hinzugefügt wird, verwenden. Beispiel: https://demo.rocket.chat/registrieren/[geheimer_schluessel]","Accounts_RegistrationRequired":"Anmeldung erforderlich","Accounts_RequireNameForSignUp":"Namen für die Anmeldung verlangen","Accounts_ShowFormLogin":"Anmeldeformular zeigen","Accounts_UseDefaultBlockedDomainsList":"Standardliste für blockierte Domains verwenden","Accounts_UseDNSDomainCheck":"DNS-Domain-Check verwenden","Activate":"Aktivieren","Activity":"Aktivität","Add":"Hinzufügen","Add_agent":"Agent hinzufügen","Add_custom_oauth":"Benutzerdefiniertes OAuth-Konto hinzufügen","Add_manager":"Manager hinzufügen","Add_Members":"Mitglieder hinzufügen","Add_User":"Benutzer hinzufügen","Add_user":"Benutzer hinzufügen","Add_users":"Benutzer hinzufügen","Additional_emails":"Zusätzliche E-Mails","Additional_Feedback":"Zusätzliches Feedback","Administration":"Administration","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Nach der OAuth2-Authentifizierung werden die Benutzer auf diese URL weitergeleitet.","Agent_added":"Der Agent wurde hinzugefügt.","Agent_removed":"Der Agent wurde gelöscht.","Alias":"Alias","All":"Alle","All_channels":"Alle Kanäle","All_logs":"Alle Protokolle","All_messages":"Alle Nachrichten","Allow_Invalid_SelfSigned_Certs":"Ungültige und selbstsignierte SSL-Zertifikate erlauben","Allow_Invalid_SelfSigned_Certs_Description":"Ungültige und selbstsignierte SSL-Zertifikate für die Link-Validierung und die Vorschau zulassen","and":"und","And_more":"Und mehr __length__...","Animals_and_Nature":"Tiere & Natur","API":"API","API_Analytics":"Analytics","API_Embed":"Einbetten","API_EmbedDisabledFor":"Einbettungen für Benutzer deaktivieren","API_EmbedDisabledFor_Description":"Durch Kommata getrennte Liste von Benutzernamen","API_GitHub_Enterprise_URL":"Server-URL","API_GitHub_Enterprise_URL_Description":"Beispiel: http://domain.com (ohne Schrägstrich am Ende)","API_Gitlab_URL":"GitLab-URL","API_Wordpress_URL":"Wordpress-URL","Appearance":"Erscheinungsbild","Application_added":"Die Anwendung wurde hinzugefügt.","Application_Name":"Name der Anwendung","Application_updated":"Die Anwendung wurde aktualisiert.","Apply_and_refresh_all_clients":"Alle Clients anwenden und aktualisieren","Archive":"Archivieren","Archive_Unarchive":"Archivieren / Wiederherstellen","are_also_typing":"schreiben auch","are_typing":"schreiben","Are_you_sure":"Sind Sie sicher?","Are_you_sure_you_want_to_delete_your_account":"Sind Sie sicher, dass Sie Ihr Konto löschen möchten?","Authorization_URL":"Autorisierungs-URL","Authorize":"Berechtigen","AutoLinker_StripPrefix":"AutoLinker entferne Prefix","AutoLinker_StripPrefix_Description":"Kurze Anzeige. z.B. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker-URL","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker E-Mail","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"Automatisch für Telefonnummern verknüpft. zB `(123) 456-7890`","Auto_Load_Images":"Automatisches Laden der Bilder","Available":"Verfügbar","Available_agents":"Verfügbare Agenten","Avatar":"Profilbild","Avatar_changed_successfully":"Das Profilbild wurde erfolgreich geändert.","Avatar_URL":"URL des Profilbilds","Avatar_url_invalid_or_error":"Die angegebene Internetadresse ist ungültig oder nicht verfügbar. Bitte versuchen Sie es mit einer anderen Internetadresse erneut.","away":"abwesend","Away":"Abwesend","away_female":"abwesend","Away_female":"Abwesend","away_male":"abwesend","Away_male":"Abwesend","Back":"Zurück","Back_to_applications":"Zurück zu den Anwendungen","Back_to_integrations":"Zurück zu Integrationen","Back_to_login":"Zurück zum Login","Back_to_permissions":"Zurück zu den Berechtigungen","Body":"Body","bold":"fett","busy":"beschäftigt","Busy":"Beschäftigt","busy_female":"beschäftigt","Busy_female":"Beschäftigt","busy_male":"beschäftigt","Busy_male":"Beschäftigt","Cancel":"Abbrechen","Cannot_delete_a_protected_role":"Eine geschützte Rolle kann nicht gelöscht werden.","Cannot_delete_role_because_its_in_use":"Die Rolle kann nicht gelöscht werden, da sie gerade verwendet wird.","Cannot_invite_users_to_direct_rooms":"Benutzer können nicht in private Nachrichtenräume eingeladen werden","CDN_PREFIX":"CDN-Präfix","Certificates_and_Keys":"Zertifikate und Schlüssel","Channel":"Kanal","Channel_doesnt_exist":"Der Kanal `# %s` existiert nicht.","Channels":"Kanäle","Channels_list":"Liste der öffentlichen Kanäle","Chat_Rooms":"Chaträume","Chatops_Enabled":"ChatOps aktivieren","Chatops_Title":"ChatOps-Panel","Chatops_Username":"ChatOps-Benutzername","Choose_a_room":"Raum auswählen","Choose_messages":"Nachrichten auswählen","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Wählen Sie den Alias, der vor dem Benutzernamen in den Nachrichten angezeigt wird.","Choose_the_username_that_this_integration_will_post_as":"Wählen Sie den Benutzernamen, der die Integration veröffentlicht.","Clear_all_unreads_question":"Möchten Sie alle ungelesenen Nachrichten löschen?","Client_ID":"Client-ID","Client_Secret":"Client-Secret","Clients_will_refresh_in_a_few_seconds":"Clients werden in wenigen Sekunden aktualisiert","close":"Schließen","Closed":"Geschlossen","Collapse_Embedded_Media_By_Default":"Eingebettete Medien standardmäßig ausblenden","coming_soon":"kommt bald","Commands":"Befehle","Compact_View":"Kompaktansicht","Confirm_password":"Bestätigen Sie Ihr Passwort.","Contact":"Kontakt","Conversation":"Konversation","Convert_Ascii_Emojis":"ASCII zu Emoji konvertieren","Copied":"Kopiert","COPY_TO_CLIPBOARD":"IN DIE ZWISCHENABLAGE KOPIEREN","Copy_to_clipboard":"In die Zwischenablage kopieren","Count":"Zähler","Create":"Erstellen","Create_new":"Neu erstellen","Created_at":"Erstellt am","Created_at_s_by_s":"Erstellt am <strong>%s</strong> von <strong>%s</strong>","Custom_Fields":"Benutzerdefinierte Felder","Custom_oauth_helper":"Bei der Einrichtung muss eine Rückruf-URL angegeben werden. Benutze dafür folgende URL: <pre>%s</pre>","Custom_oauth_unique_name":"Name des OAuth-Kontos","Custom_Script_Logged_In":"Benutzerdefiniertes Script für angemeldete Benutzer","Custom_Script_Logged_Out":"Benutzerdefiniertes Script für abgemeldete Benutzer","Dashboard":"Dashboard","days":"Tage","Deactivate":"Deaktivieren","Debug_Level":"Debug-Level","Default":"Voreinstellung","Delete":"Löschen","Delete_my_account":"Mein Konto löschen","Delete_Room_Warning":"Beim Löschen eines Raums werden alle Nachrichten in diesem Raum unwiderruflich gelöscht.","Delete_User_Warning":"Beim Löschen eines Benutzers werden alle Nachrichten des Benutzers unwiderruflich gelöscht.","Deleted":"Gelöscht!","Department_not_found":"Abteilung konnte nicht gefunden werden.","Department_removed":"Die Abteilung wurde gelöscht.","Departments":"Abteilungen","Description":"Beschreibung","Desktop":"Desktop","Desktop_Notification_Test":"Desktop-Benachrichtigungstest","Desktop_Notifications":"Desktop-Benachrichtigungen","Desktop_Notifications_Disabled":"Desktop-Benachrichtigungen sind deaktiviert. Ändern Sie Ihre Browsereinstellungen, wenn Sie Benachrichtigungen erhalten wollen.","Desktop_Notifications_Enabled":"Desktop-Benachrichtigungen sind bereits aktiviert.","Direct_message_someone":"Jemandem eine private Nachricht schicken","Direct_Messages":"Private Nachrichten","Direct_Messages_list":"Direktnachrichten","Disable_Favorite_Rooms":"Favoriten deaktivieren","Disable_New_Message_Notification":"Benachrichtigungen bei neuen Nachrichten deaktivieren","Disable_New_Room_Notification":"Benachrichtigungen bei neuen Nachrichten in einem Raum deaktivieren","Displays_action_text":"Zeigt Aktionstext","Do_you_want_to_change_to_s_question":"Möchten Sie dies zu <strong>%s</strong> ändern?","Drop_to_upload_file":"Ablegen, um Datei hochzuladen","Dry_run":"Probelauf","Dry_run_description":"Es wird nur eine E-Mail an den Empfänger gesendet. Die E-Mail muss einem gültigen Benutzer gehören.","Duplicate_archived_channel_name":"Ein archivierter Kanal mit dem Namen '%s' existiert bereits.","Duplicate_archived_private_group_name":"Eine archivierte private Gruppe mit dem Namen '%s' existiert bereits.","Duplicate_private_group_name":"Eine private Gruppe mit dem Namen '%s' existiert bereits.","E-mail":"E-Mail","Edit":"Bearbeiten","Edit_Custom_Field":"Bearbeite benutzerdefinierte Felder","Edit_Department":"Abteilung bearbeiten","edited":"bearbeitet","Email":"E-Mail","Email_already_exists":"Die E-Mail-Adresse existiert bereits.","Email_body":"Nachricht","Email_Change_Disabled":"Der Rocket.Chat-Administrator hat das Ändern der E-Mail-Adresse deaktiviert.","Email_from":"Absender","Email_Notification_Mode":"Offline-E-Mail-Benachrichtigungen","Email_Notification_Mode_All":"Jede Erwähnung/DM","Email_Notification_Mode_Disabled":"deaktiviert","Email_or_username":"E-Mail-Adresse oder Nutzername","Email_subject":"Betreff","Email_verified":"Die E-Mail-Adresse wurde bestätigt.","Emoji":"Emoji","Empty_title":"Es wurde kein Titel angegeben.","Enable":"Aktivieren","Enable_Desktop_Notifications":"Aktivieren","Enabled":"Aktiviert","Encrypted_message":"Verschlüsselte Nachricht","End_OTR":"OTR beenden","Enter_a_regex":"Regex eingeben","Enter_a_room_name":"Raumnamen eingeben","Enter_a_username":"Geben Sie einen Benutzernamen ein","Enter_info":"Geben Sie Ihre Anmeldedaten an.","Enter_name_here":"Namen hier eingeben","Enter_to":"Betreten, um","Error":"Fehler","error-cant-invite-for-direct-room":"Nutzer können nicht in private Nachrichtenräume eingeladen werden.","error-duplicate-channel-name":"Ein Kanal mit dem Namen '%s' existiert bereits.","error-invalid-custom-field":"Ungültiges benutzerdefiniertes Feld","error-invalid-custom-field-name":"Unzulässiger Name für ein benutzerdefiniertes Feld. Benutze nur Buchstaben, Nummern und Bindestriche.","error-invalid-password":"Falsches Passwort","error-invalid-room":"Ungültiger Raum","error-invalid-room-name":"<strong>%s</strong> ist kein zulässiger Raumname.<br/>Benutze nur Buchstaben, Nummern, Binde- und Unterstriche.","error-invalid-user":"Ungültiger Benutzer","error-invalid-username":"Ungültiger Benutzername","error-not-allowed":"Nicht erlaubt","error-not-authorized":"Nicht berechtigt","error-remove-last-owner":"Das ist der letzte Besitzer. Bitte bestimmen Sie einen neuen Besitzer, bevor Sie diesen Raum löschen.","error-role-name-required":"Ein Rollenname muss angegeben werden","error-user-not-in-room":"Der Benutzer ist nicht in diesem Raum.","Error_changing_password":"Fehler beim Ändern des Passwortes","Error_sending_confirmation_email":"Fehler beim Versenden der Bestätigungsmail","Error_too_many_requests":"Fehler, zu viele Anfragen. Warte %s Sekunden, bevor du es erneut probierst.","Esc_to":"Verlassen, um","Example_s":"Beispiel: <code class=\"inline\">%s</code>","False":"Nein","Favorites":"Favoriten","Field":"Feld","Field_removed":"Feld entfernt","File_exceeds_allowed_size_of_bytes":"Die Datei ist größer als das erlaubte Maximum von __size__ Bytes","FileUpload":"Dateien hochladen","FileUpload_Enabled":"Hochladen von Dateien aktivieren","FileUpload_File_Empty":"Datei ist leer","FileUpload_FileSystemPath":"Systempfad","FileUpload_MaxFileSize":"Max. Größe für hochgeladene Dateien (in Bytes)","FileUpload_MediaType_NotAccepted":"Medientypen werden nicht akzeptiert","FileUpload_MediaTypeWhiteList":"Erlaubte Medientypen","FileUpload_MediaTypeWhiteListDescription":"Durch Kommata getrennte Liste von Medientypen. Um alle Medientypen zuzulassen, lassen Sie die Liste leer.","FileUpload_ProtectFiles":"Hochgeladene Dateien schützen","FileUpload_ProtectFilesDescription":"Nur bestätigte Benutzer dürfen Dateien hochladen.","FileUpload_S3_Acl":"Amazon S3 acI","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWS-Access-Key-ID","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWS-Secret-Access-Key","FileUpload_S3_Bucket":"Amazon S3 Bucketname","FileUpload_S3_BucketURL":"Bucket-URL","FileUpload_S3_CDN":"CDN-Domain für Downloads","FileUpload_S3_Region":"Region","FileUpload_Storage_Type":"Speichertyp","Flags":"Flaggen","Follow_social_profiles":"Folge uns in sozialen Netzwerken, fork uns auf GitHub und teile deine Gedanken über die Rocket.Chat-App auf unserem Trello-Board.","Food_and_Drink":"Essen & Trinken","For_your_security_you_must_re_enter_your_password_to_continue":"Geben Sie Ihr Passwort zu Ihrer Sicherheit erneut ein.","Force_SSL":"SSL erzwingen","Force_SSL_Description":"*Achtung!* _Force SSL_ solte niemals mit einem Reverse-Proxy verwendet werden. Falls Sie einen Reverse-Proxy verwenden, sollten Sie die Weiterleitung DORT einrichten. Dies Option existiert für Anwendungen wie Heroku, die keine Weiterleitungskonfigurationen für Reverse-Proxy erlauben.","Forgot_password":"Passwort vergessen?","Fork_it_on_github":"Fork es auf GitHub","Frequently_Used":"Häufig verwendet","From":"Absender","From_Email":"Absender","From_email_is_required":"Ein Absender muss angegeben werden.","From_email_warning":"<b>Warnung</b>: Der <b>Absender</b> ist Gegenstand deiner Mail-Server-Einstellungen.","General":"Allgemeines","Get_to_know_the_team":"Lernen Sie das Rocket.Team kennen.","github_no_public_email":"Sie haben keine öffentliche E-Mail-Adresse in Ihrem GitHub-Account.","Give_a_unique_name_for_the_custom_oauth":"Geben Sie dem benutzerdefinierten OAuth-Konto einen eindeutigen Namen.","Give_the_application_a_name_This_will_be_seen_by_your_users":"Geben Sie der Anwendung einen Namen. Die Nutzer können den Namen sehen.","Global":"Weltweit","GoogleTagManager_id":"Google-Tag-Manager-ID","Has_more":"Mehr","Have_your_own_chat":"Starte deinen eigenen Internet-Chat. Entwickelt mit Meteor.com. Rocket.Chat ist eine tolle Lösung für Entwickler, die schnell und einfach eine eigene Chat-Plattform aufbauen möchten.","Header":"Kopfzeile","Hidden":"Versteckt","Hide_Group_Warning":"Sind sie sicher, die Gruppe\"%s\" zu verstecken?","Hide_Private_Warning":"Sind sie sicher, das Gespräch mit \"%s\" zu verstecken?","Hide_room":"Raum verstecken","Hide_Room_Warning":"Sind sie sicher, den Raum \"%s\" zu verstecken?","Highlights":"Hervorhebungen","Highlights_How_To":"Um benachrichtigt zu werden, wenn ein Wort oder Ausdruck erwähnt wird, fügen Sie ihn hier hinzu. Sie können Wörter und Ausdrücke mit Kommata trennen. Die Wörter zur Hervorhebung beachten die Groß- und Kleinschreibung nicht.","Highlights_List":"Wörter hervorheben","History":"Chronik","hours":"Stunden","How_friendly_was_the_chat_agent":"Wie freundlich war der Chat-Agent?","How_knowledgeable_was_the_chat_agent":"Wie sachkundig war der Chat-Agent?","How_responsive_was_the_chat_agent":"Wie reaktionsschnell war der Chat-Agent?","How_satisfied_were_you_with_this_chat":"Wie zufrieden waren Sie mit diesem Chat?","If_you_are_sure_type_in_your_password":"Wenn Sie sich sicher sind, geben Sie ihr Passwort ein.","If_you_are_sure_type_in_your_username":"Wenn Sie sich sicher sind, geben Sie Ihren Benutzernamen ein:","Importer_Archived":"archiviert","Importer_done":"Die Daten wurden erfolgreich importiert!","Importer_finishing":"Import abgeschlossen.","Importer_From_Description":"Importiert Daten von __from__ nach Rocket.Chat.","Importer_import_cancelled":"Der Import wurde abgebrochen.","Importer_import_failed":"Während des Importierens ist ein Fehler aufgetreten.","Importer_importing_channels":"Importiere die Kanäle.","Importer_importing_messages":"Importiere die Nachrichten.","Importer_importing_started":"Starte den Importer.","Importer_importing_users":"Importiere die Benutzer.","Importer_not_defined_properly":"Der Importer wurde nicht richtig definiert, eine Importklasse fehlt.","Importer_not_in_progress":"Der Importer läuft derzeit nicht.","Importer_Prepare_Restart_Import":"Import neu starten","Importer_Prepare_Start_Import":"Import starten","Importer_Prepare_Uncheck_Archived_Channels":"Markierung für archivierte Kanäle entfernen","Importer_Prepare_Uncheck_Deleted_Users":"Gelöschte Nutzer deaktivieren","Importer_progress_error":"Fehler beim Erhalt des Verlaufs des Imports.","Importer_setup_error":"Bei der Konfiguration des Importers ist ein Fehler aufgetreten.","Incorrect_Password":"Das angegebene Passwort ist falsch.","inline_code":"Code","Install_Extension":"Erweiterung installieren","Install_FxOs":"Rocket.Chat in deinem Firefox-Browser aktivieren","Install_FxOs_done":"Super! Du kannst Rocket.Chat nun über das Icon auf deinem Startbildschirm nutzen. Viel Spaß mit Rocket.Chat!","Install_FxOs_error":"Schade, das hat leider nicht geklappt! Der folgende Fehler ist aufgetreten:","Install_FxOs_follow_instructions":"Bitte bestätige die Installation der App, indem du auf \"Installieren\" klickst.","Installation":"Installation","Integration_added":"Die Integration wurde hinzugefügt.","Integration_Incoming_WebHook":"Eingehende WebHook-Integration","Integration_New":"Neue Integration","Integration_Outgoing_WebHook":"Ausgehende WebHook-Integration","Integration_updated":"Die Integration wurde aktualisiert.\n","Integrations":"Integrationen","Invalid_asset":"Ungültiger Wert","Invalid_confirm_pass":"Die Passwörter stimmen nicht überein.","Invalid_email":"Die eingegebene E-Mail-Adresse ist ungültig.","Invalid_Export_File":"Die angegebene Datei ist keine gültige %s Exportdatei.","Invalid_file_height":"Ungültige Dateihöhe","Invalid_file_type":"Ungültiges Dateiformat.","Invalid_file_width":"Ungültige Dateibreite","Invalid_Import_File_Type":"Ungültiges Dateiformat zum Importieren.","Invalid_name":"Es muss ein Name angegeben werden.","Invalid_notification_setting_s":"Ungültige Benachrichtigungseinstellung: %s","Invalid_pass":"Es muss ein Passwort angegeben werden.","Invalid_room_name":"<strong>%s</strong> ist kein zulässiger Raumname.<br/> Benutze nur Buchstaben, Nummern, Binde- und Unterstriche.","Invalid_room_type":"<strong>%s</strong> ist kein gültiger Raumtyp.","Invalid_Secret_URL":"Ungültige geheime URL","Invalid_secret_URL_message":"Die angegebene URL ist ungültig.","invisible":"unsichtbar","Invisible":"Unsichtbar","Invitation_HTML":"Einladungstext (HTML)","Invitation_Subject":"Einladungsbetreff","Invite_user_to_join_channel":"Benutzer in diesen Kanal einladen","Invite_Users":"Benutzer einladen","is_also_typing":"schreibt auch","is_also_typing_female":"schreibt auch","is_also_typing_male":"schreibt auch","is_typing":"schreibt","is_typing_female":"schreibt","is_typing_male":"schreibt","italics":"kursiv","join":"Beitreten","Join_audio_call":"Anruf beitreiten","Join_the_Community":"Trete der Community bei","Join_the_given_channel":"Angegebenen Kanal beitreten","Join_video_call":"Videoanruf beitreten","Joined":"Beigetreten","Jump":"Springen","Jump_to_first_unread":"Erste ungelesene Nachricht anzeigen","Jump_to_message":"Diese Nachricht im Chat anzeigen","Jump_to_recent_messages":"Neue Nachricht im Chat anzeigen","Katex_Enabled":"Katex ist aktiviert.","Label":"Etikette","Language":"Sprache","Language_Version":"Deutsche Version","Last_login":"Letzte Anmeldung","Last_message":"Letzte Nachricht","Last_seen":"Zuletzt online","Layout":"Layout","Layout_Home_Body":"Inhalt der Startseite","Layout_Home_Title":"Titel der Startseite","Layout_Login_Terms":"Anmeldebedingungen","Layout_Privacy_Policy":"Datenschutzbestimmungen","Layout_Sidenav_Footer":"Seitenfußzeile","Layout_Sidenav_Footer_description":"Die Größe der Fußzeile beträgt 260 x 70 Pixel.","Layout_Terms_of_Service":"Nutzungsbedingungen","LDAP":"LDAP","LDAP_CA_Cert":"CA-Cert","LDAP_Custom_Domain_Search":"Benutzerdefinierte Domainsuche","LDAP_Custom_Domain_Search_Description":"Ein Teil aus JSON, welches Bindungs- und Verbindungsinformationen regelt und folgende Struktur besitzt: <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Standard-Domain","LDAP_Description":"LDAP ist ein  Frontend zu hierarchischen Datenbanken, die viele Unternehmen nutzen, um eine eine Einmalanmeldung (SSO) zu ermöglichen. Über SSO kann \"ein Benutzer nach einer einmaligen Authentifizierung an einem Arbeitsplatz auf alle Rechner und Dienste, für die er lokal berechtigt ist, am selben Arbeitsplatz zugreifen kann, ohne sich jedes Mal neu anmelden zu müssen\". Genauere Informationen zur Konfiguration von LDAP mit Konfigurationsbeispielen erhalten Sie unter folgendem Link: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":"LDAP-DN","LDAP_Domain_Base":"Domainbasis","LDAP_Domain_Base_Description":"Der volle Distinguished Name (DN) von einem LDAP-Unterverzeichnis, den Sie nach Benutzern und Gruppen durchsuchen möchten. SIe können so viele hinzufügen wie sie möchten. Jede Gruppe muss aber der selben Domainbasis angehören, in der sich die Benutzer befindet. Wenn Sie beschränkte Nutzergruppen angeben, werden nur Benutzer, die diesen Gruppen angehören, im Anwendungsbereich liegen. Wir empfehlen, die oberste Ebene des LDAP-Verzeichnisbaums als Domainbasis anzugeben und Suchfilter zu verwenden, um den Zugriff zu kontrollieren.","LDAP_Domain_Search_Filter":"Filter der Domainsuche","LDAP_Domain_Search_Filter_Description":"Wenn angegeben, wird nur Benutzern, die dem Filter entsprechen, erlaubt, sich anzumelden. Wenn kein Filter angegeben ist, werden sich alle Benutzer in dem Bereich der angegebenen Domainbasis anmelden können.<br/>Ein Beispiel für Active-Directory: `memberOf=cn=ROCKET_CHAT,ou=General Groups`<br/>Ein Beispiel für OpenLDAP (erweiterbare Übereinstimmungssuche): `ou:dn:=ROCKET_CHAT`","LDAP_Domain_Search_Object_Category":"Objektkategorie der Domainsuche","LDAP_Domain_Search_Object_Category_Description":"Die *objectCategory*, die Ihre Nutzer identifizert. Lassen Sie das Feld leer, um *OpenLDAP* zu aktivieren. <br/> Beispiel: `person`, etc.","LDAP_Domain_Search_Object_Class":"Objektklasse der Domainsuche","LDAP_Domain_Search_Object_Class_Description":"Die *objectclass*, die Ihre Nutzer identifizert. <br/> Beispiel: `organizationalPerson`, `user`, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Passwort der Domainsuche","LDAP_Domain_Search_Password_Description":"Das Passwort für die Benuzer der Domainsuche","LDAP_Domain_Search_User":"Domain Search User","LDAP_Domain_Search_User_Description":"Der LDAP-Benutzer, der eine Benutzersuche durchführt, um andere Nutzer bei der Anmeldung zu authentifizieren. <br/>Dies ist in der Regel ein Servicekonto, welches für Drittintegrationen erstellt worden ist. Verwenden Sie einen vollen Namen, wie zum Beispiel `cn=Administrator,cn=Users,dc=Example,dc=com`.","LDAP_Domain_Search_User_ID":"Domain Search User ID","LDAP_Domain_Search_User_ID_Description":"Das LDAP-Attribut, welches die LDAP Benutzer identifiziert, welche sich versuchen, zu authentifizieren. Das Feld ist für die meisten Active-Directory-Installationen `sAMAccountName`, für andere LDAP-Lösungen wie OpenLDAP kann dieses jedoch auch `uid` sein. Sie können `mail` verwenden, um Benutzer mit Ihrer E-Mail-Adresse oder einem benutzerdefinierten Attribut zu identifizieren. <br>Sie können mehrere Werte, getrennt mit Kommata, verwenden, um es Benutzern zu erlauben, sich mit mehreren Kennungen anzumelden, wie zum Beispiel einem Benutzernamen und der E-Mail-Adresse.","LDAP_Enable":"LDAP aktivieren","LDAP_Enable_Description":"LDAP für die Authentifizierung verwenden.","LDAP_Encryption":"Verschlüsselung","LDAP_Encryption_Description":"Die Verschlüsselungsmethode für sichere Kommunikation mit dem LDAP-Server. Die Beispiele enthalten `plain` (keine Verschlüsselung), `SSL/LDAPS` (von Anfang an verschlüsselt) und `StartTLS` (zur verschlüsselten Kommunikation wechseln, sobald verbunden)","LDAP_Host":"LDAP-Host","LDAP_Host_Description":"Der LDAP-Host, z.B. `ldap.example.com` oder `10.0.0.30`.","LDAP_Port":"LDAP-Port","LDAP_Port_Description":"Port für den Zugriff auf LDAP. Beispiel: Port 389 oder 636 für LDAPS","LDAP_Reject_Unauthorized":"Unberechtigte ablehnen","LDAP_Sync_User_Avatar":"Profilbilder synchronisieren","LDAP_Sync_User_Data":"Daten synchronisieren","LDAP_Sync_User_Data_Description":"Bei der Anmeldung die Benutzerdaten mit dem Server synchronisieren (Beispiel: Name, E-Mail).","LDAP_Sync_User_Data_FieldMap":"Nutzerdaten-Feldkarte","LDAP_Sync_User_Data_FieldMap_Description":"Konfigurieren Sie, wie Benutzer-Account-Felder (wie die E-Mail-Adresse) aus einem LDAP-Datensatz (falls gefunden) geladen werden.<br/>Beispiel: {\"cn\":\"name\", \"mail\":\"email\"} nimmt einen von Menschen lesbaren Namen von dem cn-Attribut und die E-Mail-Adresse vom Mail-Attribut.<br/>Verfügbare Felder beinhalten den Namen und die E-Mail-Adresse.","LDAP_Sync_Users":"Benutzer synchronisieren","LDAP_Test_Connection":"Testverbindung","LDAP_Unique_Identifier_Field":"Eindeutige Kennung des Felds","LDAP_Unique_Identifier_Field_Description":"Dieses Feld wird verwendet, um LDAP-Nutzer und Rocket.Chat-Nutzer zu verbinden. Sie können mehrere Kommata-getrennte Werte angeben, um die Werte vom LDAP-Eintrag zu erhalten.<br/>Der Standardwert ist `objectGUID,ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber`.","LDAP_Use_Custom_Domain_Search":"Benutzerdefinierte Domainsuche verwenden","LDAP_Use_Custom_Domain_Search_Description":"Schreiben Sie Ihren eigenen Filter, um Benutzer auf dem LDAP-Server zu suchen.","LDAP_Username_Field":"Nutzernamenfeld","LDAP_Username_Field_Description":"Geben Sie an, welches Feld als *Nutzername* für neue Benutzer verwendet werden soll. Lassen Sie das Feld leer, um den Nutzernamen zu verwenden, der auf der Anmeldeseite verwendet wird. Der Standardwert ist `sAMAccountName`.","Leave_Group_Warning":"Sind sie sicher, die Gruppe \"%s\" zu verlassen?","Leave_Private_Warning":"Sind sie sicher, das Gespräch mit \"%s\" zu verlassen?","Leave_room":"Raum verlassen","Leave_Room_Warning":"Sind sie sicher, den Raum \"%s\" zu verlassen?","line":"Zeilen","List_of_Direct_Messages":"Liste der Direktnachrichten","Live_sessions":"Live-Sitzungen","Livechat_agents":"LiveChat-Agent","Livechat_Dashboard":"LiveChat-Dashboard","Livechat_enabled":"LiveChat aktiviert","Livechat_Manager":"LiveChat-Manager","Livechat_managers":"LiveChat-Manager","Livechat_title":"LiveChat-Titel","Livechat_title_color":"Hintergrundfarbe des LiveChat-Titels","Livechat_Users":"LiveChat-Benutzer","Load_more":"Mehr laden","Loading...":"Wird geladen ...","Loading_more_from_history":"Mehr Nachrichten aus dem Verlauf anzeigen","Loading_suggestion":"Vorschläge werden geladen...","Localization":"Lokalisierung","Log_File":"Datei und Zeile anzeigen","Log_Level":"Loglevel","Log_Package":"Paket zeigen","Log_View_Limit":"Begrenzung der Logansicht","Logged_out_of_other_clients_successfully":"Sie wurden erfolgreich von anderen Geräten abgemeldet.","Login":"Anmelden","Login_with":"Anmelden mit %s","login_with":"Oder melden Sie sich direkt mit folgenden Accounts an","Logout":"Abmelden","Logout_Others":"Von anderen Geräten abmelden","Mail_Message_Invalid_emails":"Sie haben eine oder mehrere ungültige E-Mail-Adressen angegeben: %s","Mail_Message_Missing_to":"Sie müssen einen/mehrere Benutzer auswählen oder einen/mehrere E-Mail-Adressen durch Kommata getrennt angeben.","Mail_Message_No_messages_selected_select_all":"Sie haben keine Nachrichten ausgewählt. Möchten Sie <a href='#' class='select-all'>alle</a> sichtbaren Nachrichten auswählen?","Mail_Messages":"Nachrichten per E-Mail senden","Mail_Messages_Instructions":"Wählen Sie aus, welche Nachrichten Sie per E-Mail senden möchten, indem Sie die Nachrichten anklicken. ","Mail_Messages_Subject":"Hier ist ein ausgewählter Teil aus %s Nachrichten","Mailer":"Mailer","Mailer_body_tags":"Sie <b>müssen</b> [unsubscribe] verwenden, um einen Link zum Abmelden aus dem Verteiler zur Verfügung zu stellen. <br /> Sie können [name] für den Vor- und Nachnamen, [fname] für den Vornamen oder [lname] für den Nachnamen des Benutzers verwenden. <br />Ebenfalls können Sie [email] verwenden, um die E-Mail-Adresse des Benutzers anzugeben.","Make_Admin":"Benutzer zum Admin ernennen","Manager_added":"Der Manager wurde hinzugefügt.\n","Manager_removed":"Der Manager wurde gelöscht.","Mark_as_read":"Als gelesen markieren","Markdown_Headers":"Markdown-Überschriften","Markdown_SupportSchemesForLink":"Markdown-Support-System für Links","Markdown_SupportSchemesForLink_Description":"Kommata getrennte Liste von erlaubten Systemen","Members_List":"Mitglieder","Mentions":"Erwähnungen","Mentions_default":"Erwähnungen (Standard)","Message":"Nachricht","Message_AllowDeleting":"Das Löschen von Nachrichten erlauben","Message_AllowEditing":"Die Bearbeitung von Nachrichten erlauben","Message_AllowEditing_BlockEditInMinutes":"Bearbeiten von Nachrichten nach (in Minuten - 0 zum deaktivieren) blockieren ","Message_AllowEditing_BlockEditInMinutesDescription":"Geben Sie eine 0 ein, um das Bearbeiten von Nachrichten jederzeit zu erlauben.","Message_AllowPinning":"Das Fixieren von Nachrichten erlauben","Message_AllowPinning_Description":"Benutzern das Fixieren von Nachrichten in Kanälen erlauben","Message_AllowStarring":"Erlaube es, Nachrichten zu markieren","Message_AudioRecorderEnabled":"Audioaufnahme aktivieren","Message_AudioRecorderEnabledDescription":"'audio/wav'-Dateien sind erforderlich, damit der Medientyp in den \"Dateien-Upload\"-Einstellungen akzeptiert wird.","Message_DateFormat":"Datumsformat","Message_DateFormat_Description":"Siehe auch: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Das Löschen von Nachrichten ist nicht erlaubt.","Message_editing_blocked":"Diese Nachricht kann nicht mehr bearbeitet werden.","Message_editing_not_allowed":"Das Bearbeiten von Nachrichten ist nicht erlaubt.","Message_GroupingPeriod":"Gruppierungsdauer (in Sekunden)","Message_GroupingPeriodDescription":"Nachrichten werden einer vorherigen Nachricht zugeordnet, wenn beide Nachrichten von dem gleichen Benutzer kommen und die abgelaufene Zeit kleiner als die mitgeteilte Zeit in Sekunden war.","Message_KeepHistory":"Nachrichtenverlauf behalten","Message_MaxAllowedSize":"Maximal zulässige Größe der Nachrichten\n","Message_MaxAll":"Maximale Kanalgröße für ALL Nachricht","Message_pinned":"Die Nachricht wurde fixiert.","Message_pinning_not_allowed":"Das Fixieren von Nachrichten ist nicht erlaubt.","Message_removed":"Diese Nachricht wurde entfernt.","Message_ShowDeletedStatus":"Löschstatus zeigen","Message_ShowEditedStatus":"Bearbeitungsstatus zeigen","Message_ShowFormattingTips":"Formatierungstipps anzeigen","Message_TimeFormat":"Zeitformat","Message_TimeFormat_Description":"Siehe auch: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Diese Nachricht ist zu lang.","Messages":"Nachrichten","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Nachrichten, die an den eingehenden Webhook gesendet werden, werden hier veröffentlicht.","Meta":"Metadaten","Meta_fb_app_id":"Facebook-App-ID","Meta_google-site-verification":"Google-Seiten-Verifizierung","Meta_language":"Sprache","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Roboter","minutes":"Minuten","Mobile_push":"mobile Push-Benachrichtigungen","More_channels":"Mehr Kanäle","More_direct_messages":"Mehr Direktnachrichten","More_groups":"Weitere private Gruppen","More_unreads":"Mehr ungelesene Nachrichten","Msgs":"Nachrichten","multi":"mehrere","Mute_someone_in_room":"Jemanden das Chatten in einem Raum verbieten","Mute_user":"Benutzern das Chatten verbieten","Muted":"Stumm geschaltet","My_Account":"Mein Konto","n_messages":"%s Nachrichten","N_new_messages":"%s neue Nachrichten","Name":"Name","Name_cant_be_empty":"Es muss ein Name angegeben werden.","Name_of_agent":"Name des Agents","Name_optional":"Name (optional)","Navigation_History_20_last_pages":"Navigationsverlauf (die letzten 20 Seiten)","New_Application":"Neue Anwendung","New_Custom_Field":"Neues benutzerdefiniertes Feld","New_Department":"Neue Abteilung","New_integration":"Neue Integration","New_logs":"Neue Logdateien","New_messages":"Neue Nachrichten","New_password":"Neues Passwort","New_role":"Neue Rolle","No_channel_with_name_%s_was_found":"Es wurde kein Kanal mit dem Namen <strong>\"%s\"</strong> gefunden!","No_channels_yet":"Sie sind kein Mitglied eines Kanals.","No_direct_messages_yet":"Sie haben keine Konversation gestartet.","No_Encryption":"Keine Verschlüsselung","No_favorites_yet":"Sie haben noch keine Favoriten hinzugefügt.","No_group_with_name_%s_was_found":"Es wurde keine private Gruppe mit dem Namen <strong>\"%s\"</strong> gefunden!","No_groups_yet":"Sie sind kein Mitglied einer privaten Gruppe.","No_livechats":"Kein LiveChat vorhanden.","No_mentions_found":"Sie wurden bisher nirgendwo erwähnt.","No_permission_to_view_room":"Sie haben keine Berechtigung, diesen Raum zu betreten.","No_pinned_messages":"Es wurden bisher keine Nachrichten fixiert.","No_results_found":"Keine Ergebnisse gefunden.","No_starred_messages":"Es wurden bisher keine Nachrichten markiert.","no_tokens_for_this_user":"Es liegen keine Token für diesen Benutzer vor.","No_user_with_username_%s_was_found":"Es wurde kein Benutzer mit dem Namen <strong>\"%s\"</strong> gefunden!","Not_allowed":"Nicht erlaubt","Not_authorized":"Nicht berechtigt","Not_Available":"Nicht verfügbar","Not_found_or_not_allowed":"Nicht gefunden oder nicht erlaubt.","Nothing":"Nichts","Nothing_found":"Es wurde nichts gefunden.","Notifications":"Benachrichtigungen","Notify_all_in_this_room":"Alle Benutzer in diesem Raum benachrichtigen","Num_Agents":"# Agents","Number_of_messages":"Nachrichtenanzahl","OAuth_Application":"OAuth-Anwendung","OAuth_Applications":"OAuth-Anwendungen","Objects":"Objekte","Off_the_record_conversation":"Off-the-record-Gespräche","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record-Gespräche sind für Ihren Browser oder Ihr Gerät nicht verfügbar.","Offline_DM_Email":"[__site__] Sie haben eine private Nachricht von __user__ erhalten.","Offline_Mention_Email":"[__site__] Sie wurden von __user__ in #__room__ erwähnt.","Old_and_new_password_must_be_different":"Das neue Passwort muss sich vom dem alten Passwort unterscheiden.","Old_and_new_password_required":"Das alte und neue Passwort muss angegeben werden, um das derzeitige Passwort zu ändern.","Online":"Online","Only_errors":"Nur Fehler","Only_you_can_see_this_message":"Nur Sie können diese Nachricht sehen.","Oops!":"Hoppla","Open":"Öffnen","Opened":"Geöffnet","Opt_out_statistics":"Meine anonymisierten Statistiken nicht an Rocket.Chat senden","Opt_out_statistics_warning":"Indem Sie uns Ihre anonymisierten Statistiken zur Verfügung stellen, können wir feststellen, wie viele Personen Rocket.Chat installiert haben und wie gut Rocket.Chat funktioniert. Das hilft uns dabei, Rocket.Chat weiterzuentwickeln. Es werden keine Benutzerinformationen gesendet und die erhaltenen Daten werden vertraulich behandelt. Wenn Sie weiterhin Statistiken anonymisiert an uns senden möchten, deaktivieren Sie bitte das Kontrollkästchen oben. Vielen Dank.","optional":"optional","Order":"Auftrag","OS_Arch":"Architektur","OS_Cpus":"CPU-Anzahl","OS_Freemem":"Freier Arbeitsspeicher","OS_Loadavg":"Durchschnittliche Systemauslastung (\"Load\")","OS_Platform":"Plattform","OS_Release":"Version","OS_Totalmem":"Gesamter Arbeitsspeicher","OS_Type":"Betriebssystem","OS_Uptime":"Systemlaufzeit","others":"andere","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR ist nur möglich, wenn beide Benutzer online sind.","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL, wo die Dateien hochgeladen werden. Die URL wird auch für Downloads verwendet, wenn keine CDN angegeben wird.","Password":"Passwort","Password_Change_Disabled":"Der Administrator hat das Ändern des Passworts deaktiviert.","Password_changed_successfully":"Das Passwort wurde erfolgreich geändert.","Payload":"Nutzlast","People":"Menschen","Permissions":"Berechtigungen","Pin_Message":"Nachricht fixieren","Pinned_a_message":"hat eine Nachricht angeheftet:","Pinned_Messages":"Fixierte Nachrichten","Placeholder_for_email_or_username_login_field":"Platzhalter für das Feld der E-Mail-Adresse und des Benutzernamen","Placeholder_for_password_login_field":"Platzhalter für das Feld des Anmeldepassworts","Please_answer_survey":"Bitte nehmen Sie sich einen Moment Zeit, um kurz einige Fragen zu dem Chat zu beantworten.","Please_enter_value_for_url":"Bitte geben Sie eine URL für Ihr Profilbild ein.","Please_enter_your_new_password_below":"Bitte geben Sie Ihr neues Passwort ein:","Please_fill_a_label":"Bitte füllen Sie ein Etikett","Please_fill_a_name":"Bitte geben Sie einen Namen ein.","Please_fill_a_username":"Bitte geben Sie einen Benutzernamen ein.","Please_fill_name_and_email":"Bitte geben Sie einen Namen und eine E-Mail-Adresse ein.","Please_re_enter_your_password":"Bitte Passwort erneut eingeben","Please_select_enabled_yes_or_no":"Bitte wählen Sie eine Option für \"aktiviert\".","Please_wait":"Bitte warten","Please_wait_activation":"Bitte warten, der Vorgang kann einige Zeit in Anspruch nehmen.","Please_wait_statistics":"Bitte warten, die Statistiken werden erstellt.","Please_wait_while_OTR_is_being_established":"Bitte warten Sie, während OTR gestartet wird.","Please_wait_while_your_account_is_being_deleted":"Bitte warten Sie, während Ihr Konto gelöscht wird.","Please_wait_while_your_profile_is_being_saved":"Bitte warten Sie, während ihr Profil gespeichert wird...","Post_as":"Verschicken als","Post_to_Channel":"Im Kanal veröffentlichen","Post_to_s_as_s":"Versenden an <strong>%s</strong> als <strong>%s</strong>","Powered_by":"Powered by","Preferences":"Einstellungen","Preferences_saved":"Die Einstellungen wurden gespeichert.","Privacy":"Datenschutz","Private_Group":"Private Gruppe","Private_Groups":"Private Gruppen","Private_Groups_list":"Liste aller privaten Gruppen","Profile":"Profil","Profile_saved_successfully":"Das Profil wurde erfolgreich gespeichert","Proudly_developed":"Stolz mit Meteor entwickelt.","Push":"Push-Nachrichten","Push_apn_cert":"APN-Cert","Push_apn_dev_cert":"APN-Dev-Cert","Push_apn_dev_key":"APN-Dev-Key","Push_apn_dev_passphrase":"APN-Dev-Passphrase","Push_apn_key":"APN-Key","Push_apn_passphrase":"APN-Passphrase","Push_debug":"Debuggen","push_disabled":"Push-Nachrichten deaktiviert","Push_enable":"Aktivieren","Push_enable_gateway":"Gateway aktivieren","Push_gateway":"Gateway","Push_gcm_api_key":"GCM-API-Key","Push_gcm_project_number":"GCM-Projektnummer","Push_production":"Produktion","Push_show_message":"Nachricht in der Benachrichtigung zeigen","Push_show_username_room":"Kanal/Gruppe/Benutzername in der Benachrichtigung zeigen","Push_test_push":"Test","Query":"Abfrage","Query_description":"Zusätzliche Bedingungen für die Bestimmung, an welche Benutzer die E-Mails gesendet werden sollen. Ausgetragene Benutzer werden automatisch aus der Abfrage entfernt. Es muss ein gültiger JSON sein. Beispiel: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Schnellsuche","quote":"Zitat","Reactions":"Reaktionen","Recents":"Aktuell","Record":"Aufnehmen","Redirect_URI":"Weiterleitungs-URL","Refresh_keys":"Schlüssel aktualisieren","Refresh_your_page_after_install_to_enable_screen_sharing":"Aktualisieren Sie die Seite nach der Installation, um die Bildschirmübertragung zu aktivieren.","Register":"Neues Konto registrieren","Registration_Succeeded":"Ihre Registrierung war erfolgreich.","Remember_me":"Erinnere mich","Remove":"Entfernen","Remove_Admin":"Admin entfernen","Remove_as_moderator":"Moderatorenrechte entfernen","Remove_as_owner":"als Besitzer entfernen","Remove_custom_oauth":"OAuth-Konto entfernen","Remove_from_room":"Aus dem Raum entfernen","Remove_someone_from_room":"Jemanden aus dem Raum entfernen","Removed":"Entfernt","Require_password_change":"Passwortänderung verlangen","Resend_verification_email":"Bestätigungsmail erneut versenden","Reset":"Zurücksetzen","Reset_password":"Passwort zurücksetzen","Restart":"Neustart","Restart_the_server":"Server neustarten","RocketBot_Enabled":"RocketBot aktiviert","RocketBot_Name":"Name des RocketBots","RocketBot_Name_Description":"Der Name des RocketBots muss den Namen eines registrierten Benutzers auf dem Server besitzen.","Role":"Rolle","Role_Editing":"Rolle bearbeiten","Role_removed":"Die Rolle wurde entfernt.","Room":"Raum","Room_archivation_state":"Status","Room_archivation_state_false":"aktiv","Room_archivation_state_true":"archiviert","Room_archived":"Der Raum wurde archiviert.","room_changed_privacy":"Der Raum wurde von <em>__user_by__</em> zum/r <em>__room_type__</em> geändert.","room_changed_topic":"Das Thema des Raums wurde von <em>__user_by__</em> zu <em>__room_topic__</em> geändert.","Room_has_been_deleted":"Der Raum wurde gelöscht.","Room_Info":"Raum","Room_name_changed":"<em>__user_by__</em> hat den Raumnamen zu  <em>__room_name__</em> geändert.","Room_name_changed_successfully":"Der Raumname wurde erfolgreich geändert.","Room_not_found":"Der Raum konnte nicht gefunden werden.","Room_topic_changed_successfully":"Das Thema des Raums wurde erfolgreich geändert.","Room_type_changed_successfully":"Der Raumtyp wurde erfolgreich geändert.","Room_unarchived":"Der Raum wurde wiederhergestellt.","Room_uploaded_file_list":"Dateien","Room_uploaded_file_list_empty":"Es wurden noch keine Dateien hochgeladen.","room_user_count":"%s Benutzer","Rooms":"Räume","S_new_messages_since_s":"%s neue Nachrichten seit %s","SAML":"SAML","SAML_Custom_Cert":"Benutzerdefiniertes Zertifikat","SAML_Custom_Entry_point":"Einsprungspunkt","SAML_Custom_Generate_Username":"Benutzernamen generieren","SAML_Custom_Issuer":"Benutzerdefinierter Aussteller","SAML_Custom_Provider":"Benutzerdefinierter Provider","Save":"Speichern","Save_changes":"Änderungen speichern","Save_Mobile_Bandwidth":"Mobiles Datenvolumen sparen","Save_to_enable_this_action":"Speichern Sie die Angaben, um die Testverbindung zu ermöglichen.","Saved":"Gespeichert","Saving":"Speichern","Scope":"Umfang","Screen_Share":"Bildschirmübertragung","Script_Enabled":"Das Script ist aktiviert.","Search":"Suche","Search_by_username":"Anhand des Nutzernamen suchen","Search_Channels":"Kanäle suchen","Search_Direct_Messages":"Durchsuche Direktnachrichten","Search_Messages":"Nachrichten durchsuchen","Search_Private_Groups":"Durchsuche private Gruppen","Search_settings":"Sucheinstellungen","seconds":"Sekunden","See_all":"Alle anzeigen","See_only_online":"Nur online","Select_a_department":"Wählen Sie eine Abteilung","Select_an_avatar":"Profilbild auswählen","Select_file":"Datei wählen","Select_service_to_login":"Wählen Sie einen Dienst zum Anmelden aus, um ein Bild auszuwählen oder ein Bild direkt von Ihrem Computer hochzuladen.","Select_user":"Benutzer auswählen","Select_users":"Benutzer auswählen","Selected_agents":"Ausgewählte Agenten","Selected_users":"Ausgewählte Mitglieder","Send":"Senden","Send_a_message":"Eine Nachricht schicken","Send_a_test_mail_to_my_user":"Eine Test-E-Mail an die Benutzer senden","Send_a_test_push_to_my_user":"Eine Test-Push-Nachricht an mich senden","Send_confirmation_email":"Bestätigungsmail versenden","Send_data_into_RocketChat_in_realtime":"Daten in Rocket.Chat in Echtzeit senden.","Send_email":"E-Mail senden","Send_invitation_email":"Einladung per E-Mail senden","Send_invitation_email_error":"Sie haben keine gültige E-Mail-Adresse angegeben.","Send_invitation_email_info":"Sie können mehrere Einladungen per E-Mail gleichzeitig absenden.","Send_invitation_email_success":"Sie haben erfolgreich eine Einladung an folgende E-Mail-Adressen versendet:","Send_invitation_email_warning":"Um Einladungen per E-Mail zu versenden, müssen Sie zuerst die SMTP-Einstellungen konfigurieren.","Send_Message":"Nachricht senden","Send_your_JSON_payloads_to_this_URL":"Senden Sie Ihre JSON-Nutzlasten an diese URL.","Sending":"Senden...","Set_as_moderator":"Zum Moderator ernennen","Set_as_owner":"zum Besitzer machen","Settings":"Einstellungen","Settings_updated":"Die Einstellungen wurden aktualisiert.","Should_be_a_URL_of_an_image":"Dies soll die URL des Bildes sein.","Should_exists_a_user_with_this_username":"Der Benutzer muss bereits vorhanden sein.","Show_all":"Alle Nutzer zeigen","Show_more":"Mehr Nutzer zeigen","Show_only_online":"Nur Online-Nutzer zeigen","Show_preregistration_form":"Vorregistrierungsformular zeigen","Showing_archived_results":"<b>%s</b> archivierte Räume","Showing_online_users":"<b>__total_showing__</b> von __total__ Nutzer angezeigt","Showing_results":"<p><b>%s</b> Ergebnisse</p>","Silence":"Ruhe","since_creation":"seit %s","Site_Name":"Seitenname","Site_Url":"Website-URL","Site_Url_Description":"Beispiel: https://chat.domain.com/","Skip":"Überspringen","Smileys_and_People":"Gesichter & Personen","SMTP":"SMTP","SMTP_Host":"SMTP-Host","SMTP_Password":"SMTP-Passwort","SMTP_Port":"SMTP-Port","SMTP_Test_Button":"SMTP-Einstellungen testen","SMTP_Username":"SMTP-Benutzername","Sound":"Ton","Star_Message":"Nachricht markieren","Starred_Messages":"Markierte Nachrichten","Start_audio_call":"Anruf starten","Start_Chat":"Chat beginnen","Start_of_conversation":"Beginn der Konversation","Start_OTR":"OTR beginnen","Start_video_call":"Videoanruf starten","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Starten Sie mit <code class=\"inline\">%s</code> für Nutzer oder <code class=\"inline\">%s</code> für Kanäle. Beispiel: <code class=\"inline\">%s</code> oder <code class=\"inline\">%s</code>","Statistics":"Statistiken","Stats_Active_Users":"Aktive Benutzer","Stats_Avg_Channel_Users":"Durchschnittliche Benutzeranzahl pro Kanal","Stats_Avg_Private_Group_Users":"Durchschnittliche Benutzeranzahl in privaten Gruppen","Stats_Away_Users":"Abwesende Benutzer","Stats_Max_Room_Users":"Maximale Benutzeranzahl eines Raums","Stats_Non_Active_Users":"Nicht aktive Benutzer","Stats_Offline_Users":"Benutzer offline","Stats_Online_Users":"Benutzer online","Stats_Total_Channels":"Anzahl der Kanäle","Stats_Total_Direct_Messages":"Anzahl der privaten Nachrichtenräume","Stats_Total_Messages":"Anzahl aller Nachrichten","Stats_Total_Private_Groups":"Anzahl der privaten Gruppen","Stats_Total_Rooms":"Anzahl der Räume","Stats_Total_Users":"Anzahl der Benutzer","Stop_Recording":"Aufnahme stoppen","strike":"durchgestrichen","Subject":"Betreff","Submit":"Abschicken","Success":"Dieser Vorgang war erfolgreich.","Survey":"Umfrage","Survey_instructions":"Bewerten Sie jede Frage nach Ihrer Zufriedenheit. 1 bedeutet, dass Sie völlig unzufrieden sind und 5 bedeutet, dass Sie vollständig zufrieden sind.","Symbols":"Symbole","Sync_success":"Die Synchronisierung war erfolgreich.","Sync_Users":"Benutzer synchronisieren","Test_Connection":"Testverbindung","Test_Desktop_Notifications":"Desktop-Benachrichtigungen testen","Thank_you_for_your_feedback":"Vielen Dank für Ihre Rückmeldung.","The_application_name_is_required":"Es muss ein Name für diese Anwendung angegeben werden.","The_channel_name_is_required":"Ein Name für den Kanal muss angegeben werden.","The_emails_are_being_sent":"Die E-Mails werden gesendet.","The_field_is_required":"Das Feld %s ist erforderlich.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Die automatische Skalierung der Bilder funktioniert nicht, da ImageMagick oder GraphicsMagick nicht auf dem Server installiert sind.","The_redirectUri_is_required":"Es muss eine Weiterleitung-URL angegeben werden.","The_server_will_restart_in_s_seconds":"Der Server wird in %s Sekunden neu gestartet","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Die Einstellung <strong>%s</strong> wurde zu <strong>%s</strong> konfiguriert und Sie greifen von <strong>%s</strong> zu!","The_user_will_be_removed_from_s":"Der Benutzer wird von %s entfernt.","The_user_wont_be_able_to_type_in_s":"Der Benutzer kann nicht mehr in %s schreiben.","Theme":"Theme","theme-color-action-buttons-color":"Farbe des Aktionsbuttons","theme-color-active-channel-background-color":"Hintergrundfarbe von aktiven Kanälen","theme-color-active-channel-font-color":"Schriftfarbe von aktiven Kanälen","theme-color-blockquote-background":"Hintergrundfarbe der Blockquotes ","theme-color-clean-buttons-color":"Farbe des Säuberungsknopfs","theme-color-code-background":"Hintergrundfarbe des Codes","theme-color-code-border":"Randfarbe des Codes","theme-color-code-color":"Farbe des Codes","theme-color-content-background-color":"Hintergrundfarbe des Inhalts","theme-color-custom-scrollbar-color":"Benutzerdefinierte Farbe der Scrollbar","theme-color-info-active-font-color":"Schriftfarbe von aktiven Informationen","theme-color-info-font-color":"Schriftfarbe von Informationen","theme-color-input-font-color":"Schriftfarbe der Eingabe","theme-color-link-font-color":"Schriftfarbe des Links","theme-color-message-hover-background-color":"Hintergrundfarbe beim Mauskontakt mit einer Nachricht","theme-color-primary-background-color":"Primäre Hintergrundfarbe ","theme-color-primary-font-color":"Primäre Schriftfarbe","theme-color-quaternary-font-color":"Quartäre Schriftfarbe","theme-color-secondary-background-color":"Sekundäre Hintergrundfarbe","theme-color-secondary-font-color":"Sekundäre Schriftfarbe","theme-color-smallprint-font-color":"Schriftfarbe des Kleingedrucktem","theme-color-smallprint-hover-color":"Farbe bei Mauskontakt mit Kleingedrucktem","theme-color-status-away":"Farbe des Status \"abwesend\"","theme-color-status-busy":"Farbe des Status \"beschäftigt\"","theme-color-status-offline":"Farbe des Status \"offline\"\n","theme-color-status-online":"Farbe des Status \"online\"","theme-color-tertiary-background-color":"Tertiäre Hintergrundfarbe ","theme-color-tertiary-font-color":"Tertiäre Schriftfarbe","theme-color-unread-notification-color":"Farbe von ungelesenen Benachrichtigungen","theme-custom-css":"Benutzerdefiniertes CSS","There_are_no_agents_added_to_this_department_yet":"Es wurden bisher keine Agenten zu dieser Abteilung hinzugefügt.","There_are_no_integrations":"Es sind keine Integrationen vorhanden.","There_are_no_users_in_this_role":"Es sind dieser Rolle keine Benutzer zugeordnet.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Diese E-Mail wurde bereits verschickt, aber noch nicht bestätigt. Bitte ändern Sie Ihr Passwort.","This_is_a_desktop_notification":"Das ist eine Desktop-Benachrichtigung.","This_is_a_push_test_messsage":"Dies ist eine Test-Push-Nachricht.","Time_in_seconds":"Zeit in Sekunden","Title_bar_color":"Farbe der Titelleiste","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Um den Rocket.Chat-LiveChat auf Ihrer Webseite zu installieren, kopieren und fügen Sie den Code über den letzten <strong>&lt;/body&gt;</strong>-Tag Ihrer Seite ein.","To_users":"An die Benutzer","Topic":"Thema","Travel_and_Places":"Reisen & Orte","Trigger_removed":"Auslöser entfernt","Trigger_Words":"Trigger Words","Triggers":"Auslöser","True":"Ja","Type":"Typ","Type_your_new_password":"Geben Sie Ihr neues Passwort ein","Unarchive":"Wiederherstellen","Unmute_someone_in_room":"Jemanden das Chatten in einem Raum wieder erlauben","Unmute_user":"Benutzern das Chatten erlauben ","Unnamed":"Unbenannt","Unpin_Message":"Nachicht nicht mehr fixieren","Unread_Rooms":"Ungelesene Räume","Unread_Rooms_Mode":"Ungelesene Räume aufgelistet anzeigen ","Unstar_Message":"Markierung entfernen","Upload_file_question":"Möchten Sie eine Datei hochladen?","Uploading_file":"Datei wird hochgeladen...","Use_account_preference":"Kontoeinstellungen verwenden","Use_Emojis":"Emojis verwenden","Use_initials_avatar":"Anfangsbuchstaben deines Nutzernamens verwenden","use_menu":"Benutze das Seitenmenü, um deine Chats zu öffnen.","Use_service_avatar":"Benutze %s Profilbild","Use_this_username":"Benutzen Sie folgenden Benutzernamen","Use_uploaded_avatar":"Das hochgeladene Profilbild verwenden","Use_url_for_avatar":"URL für Profilbild verwenden","User__username__is_now_a_moderator_of__room_name_":"Der Benuzer __username__ ist jetzt ein Moderator des Raums __room_name__.","User__username__is_now_a_owner_of__room_name_":"Benutzer __username__ ist jetzt ein Besitzer von __room_name__","User__username__removed_from__room_name__moderators":"Der Benutzer __username__ wurde von einem Moderator aus __room_name__ entfernt.","User__username__removed_from__room_name__owners":"Benutzer __username__ wurde als Besitzer von __room_name__ entfernt.","User_added":"Der Benutzer <em>__user_added__</em> wurde hinzugefügt.","User_added_by":"Der Benutzer <em>__user_added__</em> wurde von <em>__user_by__</em> hinzugefügt.","User_added_successfully":"Benutzer erfolgreich hinzugefügt","User_Channels":"Benutzerkanäle","User_doesnt_exist":"Kein Benutzer mit dem Namen `@ %s` vorhanden.","User_has_been_activated":"Der Benutzer wurde aktiviert.","User_has_been_deactivated":"Der Benutzer wurde deaktiviert.","User_has_been_deleted":"Der Benutzer wurde gelöscht.","User_has_been_muted_in_s":"Dem Nutzer wurde das Schreiben in %s verboten.","User_has_been_removed_from_s":"Der Benutzer wurde von %s entfernt.","User_has_disconnected":"Der Benutzer hat die Verbindung getrennt.","User_Info":"Benutzerinformationen","User_is_no_longer_an_admin":"Der Benutzer ist kein Admin mehr.","User_is_not_activated":"Der Benutzer ist nicht aktiviert.","User_is_now_an_admin":"Der Benutzer ist jetzt ein Admin.","User_joined_channel":"Ist dem Kanal beigetreten.","User_joined_channel_female":"Ist dem Kanal beigetreten.","User_joined_channel_male":"Ist dem Kanal beigetreten.","User_left":"Der Benutzer <em>__user_left__</em> hat den Kanal verlassen.","User_left_female":"Der Benutzer <em>__user_left__</em> hat den Kanal verlassen.","User_left_male":"Der Benutzer <em>__user_left__</em> hat den Kanal verlassen.","User_logged_out":"Der Benutzer wurde abgemeldet.","User_management":"Benutzerverwaltung","User_muted_by":"Dem Benutzer <em>__user_muted__</em> wurde das Chatten von <em>__user_by__</em> verboten.","User_muted_in_room":"Dem Benutzer wurde das Chatten verboten.","User_not_found":"Der Benutzer konnte nicht gefunden werden.","User_not_found_or_incorrect_password":"Entweder konnte der Benutzer nicht gefunden werden oder Sie haben ein falsches Passwort angegeben.","User_or_channel_name":"Benutzer- oder Kanalname","User_removed":"Der Benutzer wurde gelöscht.","User_removed_by":"Der Benutzer <em>__user_removed__</em> wurde von <em>__user_by__</em> entfernt.","User_removed_from_room":"Der Benutzer wurde aus dem Raum entfernt.","User_Settings":"Benutzereinstellungen","User_unmuted_by":"Dem Benutzer <em>__user_unmuted__</em> wurde das Chatten von <em>__user_by__</em> wieder erlaubt. ","User_unmuted_in_room":"Dem Benutzer wurde das Chatten wieder erlaubt.","User_updated_successfully":"Der Benutzer wurde erfolgreich aktualisiert.","Username":"Benutzername","Username_and_message_must_not_be_empty":"Die Felder \"Benutzername\" und \"Nachricht\" dürfen nicht leer sein.","Username_cant_be_empty":"Sie müssen einen Benutzernamen angeben.","Username_Change_Disabled":"Der Administrator hat das Ändern von Benutzernamen deaktiviert.","Username_denied_the_OTR_session":"__username__ hat die OTR-Session abgelehnt.","Username_description":"Der Benutzername wird dazu benutzt, Sie in Nachrichten zu erwähnen.","Username_doesnt_exist":"Der Benutzer \"%s\" existiert nicht.","Username_ended_the_OTR_session":"__username__ hat die OTR-Session beendet.","Username_invalid":"<strong>%s</strong> ist kein zulässiger Benutzername.<br/> Benutze nur Buchstaben, Nummern, Punkte, Binde- und Unterstriche.","Username_is_already_in_here":"`@%s` wurde bereits hinzugefügt.","Username_is_not_in_this_room":"Der Benutzer `#%s` ist nicht in diesem Raum.","Username_not_found":"Der Benutzername konnte nicht gefunden werden.","Username_title":"Benutzernamen festlegen","Username_unavaliable":"<strong>%s</strong> wird leider schon verwendet. ","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ möchte ein OTR-Gespräch starten. Möchten Sie annehmen?","Users":"Benutzer","Users_in_role":"Zugeordnete Nutzer","UTF8_Names_Slugify":"UTF8-Namen-Slugify","UTF8_Names_Validation":"UTF8-Namen-Verifizierung","UTF8_Names_Validation_Description":"Erlauben Sie keine Sonderzeichen und Leerzeichen. Sie können - _ und . verwenden, aber nicht am Ende eines Namens.","Verification_email_sent":"Bestätigungsmail gesendet","View_All":"Alle ansehen","View_Logs":"Logs anzeigen","Visibility":"Sichtbarkeit","Visible":"Sichtbar","Visitor":"Besucher","Visitor_page_URL":"URL der Besucherseite","Visitor_time_on_site":"Besucherzeit auf der Seite","Wait_activation_warning":"Bevor Sie sich anmelden können, muss das Konto von einem Administrator manuell aktiviert werden.","We_are_offline_Sorry_for_the_inconvenience":"Wir sind offline. Entschuldigen Sie die Unannehmlichkeiten.","We_have_sent_password_email":"Wir haben Ihnen eine Anleitung zum Zurücksetzen des Passworts an Ihre E-Mail-Adresse gesendet. Wenn Sie keine E-Mail erhalten haben, versuchen Sie es bitte noch einmal.","We_have_sent_registration_email":"Wir haben Ihnen eine Bestätigungsmail gesendet. Wenn Sie keine E-Mail erhalten haben, versuchen Sie es bitte noch einmal.","WebRTC_Enable_Channel":"Für öffentliche Kanäle aktivieren","WebRTC_Enable_Direct":"Für private Nachrichten aktivieren","WebRTC_Enable_Private":"Für private Kanäle aktivieren","WebRTC_Servers":"STUN/TURN-Server","WebRTC_Servers_Description":"Kommata-getrennte Liste von STUN- und TURN-Servern.<br/>Benutzernamen, Passwörter und Ports sind in diesen Formaten erlaubt: `username:password@stun:host:port` oder `username:password@turn:host:port","Welcome":"Willkommen, <em>%s</em>.","Welcome_to_the":"Willkommen bei","will_be_able_to":"wird in der Lage sein,","With_whom":"Mit wem?","Yes":"Ja","Yes_clear_all":"Ja!","Yes_delete_it":"Ja!","Yes_hide_it":"Ja!","Yes_leave_it":"Ja!","Yes_mute_user":"Ja, Benutzer stumm schalten!\n","Yes_remove_user":"Ja, Nutzer entfernen!","you_are_in_preview_mode_of":"Sie befinden sich im Vorschaumodus des Kanals #<strong>__room_name__</strong>.","You_are_logged_in_as":"Sie sind angemeldet als","You_are_not_authorized_to_view_this_page":"Sie sind nicht berechtigt, diese Seite zu sehen.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Sie sind der letzte Besitzer. Bitte bestimmen Sie einen neuen Besitzer, bevor Sie den Raum verlassen.","You_can_change_a_different_avatar_too":"Sie können das aktuell verwendete Profilbild überschreiben, um von dieser Integration zu veröffentlichen.","You_can_use_an_emoji_as_avatar":"Sie können auch einen Emoji als Profilbild verwenden.","You_have_been_muted":"Ihnen wurde das Chatten in diesem Raum verboten. ","You_have_not_verified_your_email":"Sie haben Ihre E-Mail-Adresse nicht verifiziert.","You_have_successfully_unsubscribed":"Sie haben sich erfolgreich von unserem Verteiler abgemeldet.","You_informed_an_invalid_FROM_address":"Sie haben eine ungültige E-Mail-Adresse als Empfänger angegeben.","You_must_provide_the_unsubscribe_link":"Sie müssen einen Link zum Abmelden vom Verteiler angeben.","You_need_confirm_email":"Sie müssen Ihre E-Mail-Adresse bestätigen!","You_need_install_an_extension_to_allow_screen_sharing":"Sie müssen eine Erweiterung installieren, um eine Bildschirmübertragung zu starten.","You_need_to_change_your_password":"Sie müssen ihr Passwort ändern.","You_need_to_type_in_your_password_in_order_to_do_this":"Um diese Aktion auszuführen, müssen sie Ihr Passwort eingeben.","You_need_to_type_in_your_username_in_order_to_do_this":"Sie müssen Ihren Benutzernamen angeben, um diese Aktion durchzuführen!","You_need_to_verifiy_your_email_address_to_get_notications":"Sie müssen Ihre E-Mail-Adresse bestätigen, um Benachrichtigungen zu erhalten","You_should_name_it_to_easily_manage_your_integrations":"Zur einfachen Verwaltung der Integrationen empfehlen wir, der Integration einen Namen zuzuordnen.","You_will_not_be_able_to_recover":"Die Nachricht kann anschließend nicht wiederhergestellt werden.","You_will_not_be_able_to_recover_file":"Das Wiederherstellen dieser Datei wird nicht möglich sein.","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Sie werden keine E-Mail-Benachrichtigungen erhalten, da Sie ihre E-Mail-Adresse nicht verifiziert haben.","Your_email_has_been_queued_for_sending":"Ihre E-Mail wird in Kürze gesendet werden.","Your_entry_has_been_deleted":"Ihr Eintrag wurde gelöscht.","Your_file_has_been_deleted":"Deine Datei wurde erfolgreich gelöscht.","Your_mail_was_sent_to_s":"Ihre E-Mail wurde an %s gesendet.","Your_Open_Source_solution":"Deine eigene Open-Source-Chat-Lösung.","Your_password_is_wrong":"Falsches Passwort","Your_push_was_sent_to_s_devices":"Die Push-Nachricht wurde an %s Geräte gesendet."});
TAPi18n._registerServerTranslator("de", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/el.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["el"] = ["Greek","Ελληνικά"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["el"])) {                                                                        // 9
  TAPi18n.translations["el"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["el"][namespace])) {                                                             // 13
  TAPi18n.translations["el"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["el"][namespace], {"500":"Εσωτερικό Σφάλμα Διακομιστή","0_Errors_Only":"0 - Λάθη Μόνο","1_Errors_and_Information":"1 - Λάθη και Πληροφοριών","2_Erros_Information_and_Debug":"2 - erros, πληροφοριών και τον εντοπισμό σφαλμάτων","__username__was_set__role__by__user_by_":"χρήστη __username__ ορίστηκε __role__ από __user_by__","__username__is_no_longer__role__defined_by__user_by_":"χρήστη __username__ δεν είναι πλέον __role__, από __user_by__","Access_not_authorized":"Πρόσβαση δεν επιτρέπονται","Access_online_demo":"Δείτε το online demo","Access_Online_Demo":"Δείτε το Online Demo","Access_Token_URL":"Πρόσβαση Token URL","Accounts":"λογαριασμοί","Accounts_AllowDeleteOwnAccount":"Επιτρέπουν στους χρήστες να διαγράψετε ίδιο λογαριασμό","Accounts_AllowedDomainsList":"Κατοικίδια Λίστα Domains","Accounts_AllowedDomainsList_Description":"Διαχωρισμένες με κόμμα λίστα επιτρεπόμενων τομέων","Accounts_AllowEmailChange":"Επιτρέψτε E-mail Αλλαγή","Accounts_AllowPasswordChange":"Επιτρέψτε Αλλαγή κωδικού πρόσβασης","Accounts_AllowUserAvatarChange":"Επιτρέπει στο χρήστη Αλλαγή Avatar","Accounts_AllowUsernameChange":"Επιτρέψτε Όνομα Χρήστη Αλλαγή","Accounts_AllowUserProfileChange":"Επιτρέψτε Προφίλ Χρήστη Αλλαγή","Accounts_AvatarResize":"Αλλαγή μεγέθους Avatars","Accounts_AvatarSize":"Avatar Μέγεθος","Accounts_AvatarStorePath":"Path Avatar αποθήκευσης","Accounts_AvatarStoreType":"Avatar Τύπος αποθήκευσης","Accounts_BlockedDomainsList":"Λίστα αποκλεισμένων τομέων","Accounts_BlockedDomainsList_Description":"Διαχωρισμένες με κόμμα λίστα των αποκλεισμένων περιοχών","Accounts_denyUnverifiedEmail":"Άρνηση ανεπιβεβαίωτου e-mail","Accounts_EmailVerification":"Επιβεβαίωση E-mail","Accounts_EmailVerification_Description":"Βεβαιωθείτε ότι έχετε τις σωστές ρυθμίσεις SMTP για να χρησιμοποιήσετε αυτήν τη λειτουργία","Accounts_Enrollment_Email":"Εγγραφή E-mail","Accounts_Enrollment_Email_Description":"Μπορείτε να χρησιμοποιήσετε το [όνομα], [ΟΝΟΜΑ], [ΕΠΙΘΕΤΟ] για το πλήρες όνομα του χρήστη, το όνομα ή το επώνυμο, αντίστοιχα. <br /> Μπορείτε να χρησιμοποιήσετε το [e-mail] για το ηλεκτρονικό ταχυδρομείο του χρήστη.","Accounts_Iframe_api_method":"Μέθοδος Api","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"Ενεργοποιήθηκε","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Είσοδος Λήξη σε Ημέρες","Accounts_ManuallyApproveNewUsers":"Χειροκίνητη έγκριση νέων χρηστών","Accounts_OAuth_Custom_Token_Sent_Via":"Token αποστέλλονται μέσω","Accounts_OAuth_Custom_Authorize_Path":"Εξουσιοδότηση Path","Accounts_OAuth_Custom_Button_Color":"κουμπί χρώμα","Accounts_OAuth_Custom_Button_Label_Color":"Κουμπί Χρώμα κειμένου","Accounts_OAuth_Custom_Button_Label_Text":"κουμπί Κείμενο","Accounts_OAuth_Custom_Enable":"Καθιστώ ικανό","Accounts_OAuth_Custom_id":"Ταυτότητα","Accounts_OAuth_Custom_Identity_Path":"Path ταυτότητα","Accounts_OAuth_Custom_Login_Style":"Είσοδος Style","Accounts_OAuth_Custom_Secret":"Μυστικό","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Login","Accounts_OAuth_Facebook_callback_url":"Facebook επανάκλησης URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"GitHub Login","Accounts_OAuth_Github_callback_url":"GitHub επανάκλησης URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Επιχείρηση επανάκλησης URL","Accounts_OAuth_GitHub_Enterprise_id":"Αναγνωριστικό πελάτη","Accounts_OAuth_GitHub_Enterprise_secret":"πελάτη Secret","Accounts_OAuth_Github_id":"GitHub Id","Accounts_OAuth_Github_secret":"GitHub Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab επανάκλησης URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"πελάτη Secret","Accounts_OAuth_Google":"Google Login","Accounts_OAuth_Google_callback_url":"Google επανάκλησης URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Login","Accounts_OAuth_Linkedin_callback_url":"Linkedin επανάκλησης URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Login","Accounts_OAuth_Meteor_callback_url":"Meteor επανάκλησης URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Login","Accounts_OAuth_Twitter_callback_url":"Twitter επανάκλησης URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Είσοδος","Accounts_OAuth_Wordpress_callback_url":"Wordpress επανάκλησης URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Επανακαθορισμός κωδικού","Accounts_Registration_AuthenticationServices_Enabled":"Εγγραφή με έλεγχο ταυτότητας Υπηρεσίες","Accounts_RegistrationForm":"Φόρμα εγγραφής","Accounts_RegistrationForm_Disabled":"Ανάπηρος","Accounts_RegistrationForm_LinkReplacementText":"Φόρμα Εγγραφής Σύνδεσμος Αντικατάσταση κειμένου","Accounts_RegistrationForm_Public":"Δημόσιο","Accounts_RegistrationForm_Secret_URL":"μυστική URL","Accounts_RegistrationForm_SecretURL":"Αίτηση Εγγραφής μυστικό URL","Accounts_RegistrationForm_SecretURL_Description":"Πρέπει να δώσετε μια τυχαία σειρά που θα προστεθούν στο URL της εγγραφής σας. Παράδειγμα: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Απαιτείται Εγγραφή","Accounts_RequireNameForSignUp":"Απαιτούν Όνομα Για Εγγραφή","Accounts_ShowFormLogin":"Εμφάνιση μορφής βασίζεται Σύνδεση","Accounts_UseDefaultBlockedDomainsList":"Χρήση προεπιλεγμένων λίστα αποκλεισμένων τομέων","Accounts_UseDNSDomainCheck":"Χρησιμοποιήστε DNS Τομέα Έλεγχος","Activate":"Θέτω εις ενέργειαν","Activity":"Δραστηριότητα","Add":"Προσθέτω","Add_agent":"Προσθήκη παράγοντα","Add_custom_oauth":"Προσθήκη προσαρμοσμένων OAuth","Add_manager":"Προσθήκη διαχειριστή","Add_Members":"Προσθέστε Μέλη","Add_User":"Προσθήκη χρήστη","Add_user":"Προσθήκη χρήστη","Add_users":"Προσθήκη χρηστών","Additional_emails":"Πρόσθετες E-mails","Additional_Feedback":"πρόσθετες Σχόλια","Administration":"Διαχείριση","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Μετά τον έλεγχο ταυτότητας OAuth2, οι χρήστες θα πρέπει να στραφούν προς αυτή τη διεύθυνση URL","Agent_added":"παράγοντα που προστίθεται","Agent_removed":"Agent αφαιρεθεί","Alias":"Ψευδώνυμο","All":"Όλοι","All_channels":"Όλα τα κανάλια","All_logs":"Όλα τα αρχεία καταγραφής","All_messages":"Όλα τα μηνύματα","Allow_Invalid_SelfSigned_Certs":"Επιτρέψτε Άκυρη Self-Υπεγράφη Certs","Allow_Invalid_SelfSigned_Certs_Description":"Επιτρέψτε άκυρη και αυτο-υπογεγραμμένο το πιστοποιητικό SSL για την επικύρωση σύνδεσμο και προεπισκοπήσεις.","and":"και","And_more":"Και πιο __length __...","Animals_and_Nature":"Ζώα και Φύση","API":"API","API_Analytics":"Analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Απενεργοποίηση Ενσωματώστε για τους χρήστες","API_EmbedDisabledFor_Description":"Διαχωρισμένες με κόμμα λίστα ονομάτων χρήστη","API_GitHub_Enterprise_URL":"URL διακομιστή","API_GitHub_Enterprise_URL_Description":"Παράδειγμα: http://domain.com (εξαιρουμένων κάθετος)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress διεύθυνση URL","Appearance":"Εμφάνιση","Application_added":"πρόσθεσε εφαρμογή","Application_Name":"Όνομα εφαρμογής","Application_updated":"ενημερωμένη εφαρμογή","Apply_and_refresh_all_clients":"Εφαρμόστε και να ανανεώσετε όλους τους πελάτες","Archive":"Αρχείο","Archive_Unarchive":"Αρχείο / Κατάργηση αρχειοθέτησης","are_also_typing":"πληκτρολογεί επίσης","are_typing":"πληκτρολογεί","Are_you_sure":"Είστε σίγουρος?","Are_you_sure_you_want_to_delete_your_account":"Είστε σίγουροι ότι θέλετε να διαγράψετε τον λογαριασμό σας;","Authorization_URL":"URL εξουσιοδότησης","Authorize":"Εξουσιοδοτώ","AutoLinker_StripPrefix":"AutoLinker Γάζας Πρόθεμα","AutoLinker_StripPrefix_Description":"Σύντομη οθόνη. π.χ. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Κανονική Έκφραση","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Τηλέφωνο","AutoLinker_Phone_Description":"Συνδέεται αυτόματα για τους αριθμούς τηλεφώνου. π.χ. `(123) 456-7890`","Auto_Load_Images":"Αυτόματη Φόρτωση εικόνων","Available":"Διαθέσιμος","Available_agents":"διαθέσιμα μέσα","Avatar":"Αλλαγή avatar","Avatar_changed_successfully":"Το Avatar άλλαξε με επιτυχία","Avatar_URL":"Avatar URL","Avatar_url_invalid_or_error":"Η διεύθυνση URL που παρέχεται δεν είναι έγκυρο ή δεν είναι προσβάσιμο. Παρακαλώ δοκιμάστε ξανά, αλλά με μια διαφορετική διεύθυνση URL.","away":"λείπω","Away":"Λείπω","away_female":"λείπω","Away_female":"Λείπω","away_male":"λείπω","Away_male":"Λείπω","Back":"Πίσω","Back_to_applications":"Επιστροφή στις εφαρμογές","Back_to_integrations":"Επιστροφή στην ολοκληρώσεις","Back_to_login":"Επιστροφή στην σελίδα εισόδου","Back_to_permissions":"Επιστροφή στο άδειες","Body":"Σώμα","bold":"έντονα","busy":"απασχολημένος","Busy":"Απασχολημένος","busy_female":"απασχολημένη","Busy_female":"Απασχολημένος","busy_male":"απασχολημένος","Busy_male":"Απασχολημένος","Cancel":"Ακύρωση","Cannot_delete_a_protected_role":"Δεν μπορείτε να διαγράψετε μια προστατευμένη ρόλο","Cannot_delete_role_because_its_in_use":"Δεν μπορείτε να διαγράψετε ρόλο επειδή είναι σε χρήση","Cannot_invite_users_to_direct_rooms":"Δεν μπορείτε να προσκαλέσετε τους χρήστες να κατευθύνουν δωμάτια","CDN_PREFIX":"CDN Πρόθεμα","Certificates_and_Keys":"Πιστοποιητικά και κλειδιά","Channel":"Κανάλι","Channel_doesnt_exist":"Το κανάλι `# %s` δεν υπάρχει.","Channels":"Κανάλια","Channels_list":"Λίστα δημοσίων καναλιών","Chat_Rooms":"Δωμάτια Chat","Chatops_Enabled":"Ενεργοποίηση Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Όνομα Χρήστη","Choose_a_room":"Επιλέξτε ένα δωμάτιο","Choose_messages":"Επιλέξτε τα μηνύματα","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Επιλέξτε το ψευδώνυμο που θα εμφανιστεί πριν από το όνομα χρήστη στα μηνύματα.","Choose_the_username_that_this_integration_will_post_as":"Επιλέξτε το όνομα χρήστη που η ολοκλήρωση αυτή θα δημοσιεύσετε όπως.","Clear_all_unreads_question":"Καταργήστε όλα τα unreads;","Client_ID":"ID πελάτη","Client_Secret":"πελάτη Secret","Clients_will_refresh_in_a_few_seconds":"Οι πελάτες θα ανανεώσετε σε λίγα δευτερόλεπτα","close":"κλείσιμο","Closed":"Κλειστό","Collapse_Embedded_Media_By_Default":"Σύμπτυξη ενσωματωμένο media από προεπιλογή","coming_soon":"έρχεται σύντομα","Commands":"εντολές","Compact_View":"Compact View","Confirm_password":"Επιβεβαιώστε τον κωδικό σας","Contact":"Επικοινωνία","Conversation":"Συνομιλία","Convert_Ascii_Emojis":"Μετατροπή ASCII σε Emoji","Copied":"αντιγραφεί","COPY_TO_CLIPBOARD":"ΑΝΤΙΓΡΑΦΉ ΣΤΟ ΠΡΌΧΕΙΡΟ","Copy_to_clipboard":"Αντιγραφή στο πρόχειρο","Count":"Κόμης","Create":"Δημιουργώ","Create_new":"Δημιουργία νέου","Created_at":"Δημιουργήθηκε στις","Created_at_s_by_s":"Δημιουργήθηκε <strong>στο %s</strong> <strong>από %s</strong>","Custom_Fields":"προσαρμοσμένων πεδίων","Custom_oauth_helper":"Κατά τη ρύθμιση Provider OAuth σας, θα πρέπει να ενημερώσει μια διεύθυνση URL επανάκλησης. Χρήση <pre> %μικρό </pre> .","Custom_oauth_unique_name":"Προσαρμοσμένη OAuth μοναδικό όνομα","Custom_Script_Logged_In":"Προσαρμοσμένο Σενάριο για συνδεδεμένους χρήστες","Custom_Script_Logged_Out":"Προσαρμοσμένη δέσμη ενεργειών για την αποσύνδεση χρηστών","Dashboard":"Ταμπλό","days":"ημέρες","Deactivate":"απενεργοποίηση","Debug_Level":"debug Επίπεδο","Default":"Αθέτηση","Delete":"Διαγράφω","Delete_my_account":"Διαγραφή του λογαριασμού μου","Delete_Room_Warning":"Διαγραφή ενός δωματίου θα διαγράψει όλα τα μηνύματα που αποστέλλονται μέσα στο δωμάτιο. Αυτό δεν μπορεί να αναιρεθεί.","Delete_User_Warning":"Η διαγραφή ενός χρήστη θα διαγράψει επίσης και όλα τα μηνύματα αυτού του χρήστη. Αυτό δεν μπορεί να αναιρεθεί.","Deleted":"Διαγράφηκε!","Department_not_found":"Τμήμα δεν βρέθηκε","Department_removed":"Τμήμα αφαιρεθεί","Departments":"τμήματα","Description":"Περιγραφή","Desktop":"Desktop","Desktop_Notification_Test":"Δοκιμή Γνωστοποίηση Desktop","Desktop_Notifications":"Desktop Ειδοποιήσεις","Desktop_Notifications_Disabled":"Desktop Ειδοποιήσεις είναι άτομα με ειδικές ανάγκες. Αλλάξτε τις προτιμήσεις του προγράμματος περιήγησης σας, εάν χρειάζεστε Ειδοποιήσεις ενεργοποιημένη.","Desktop_Notifications_Enabled":"Ειδοποιήσεις επιφάνειας εργασίας είναι Ενεργοποιημένο","Direct_message_someone":"Άμεσο μήνυμα σε κάποιον","Direct_Messages":"Άμεσα μηνύματα","Direct_Messages_list":"Άμεσα μηνύματα","Disable_Favorite_Rooms":"Απενεργοποίηση Αγαπημένα","Disable_New_Message_Notification":"Απενεργοποίηση ειδοποίησης Νέο Μήνυμα","Disable_New_Room_Notification":"Απενεργοποίηση ειδοποίησης νέα αίθουσα","Displays_action_text":"κειμένου εμφανίζει δράση","Do_you_want_to_change_to_s_question":"Θέλετε να αλλάξετε <strong>σε %s;</strong>","Drop_to_upload_file":"Πετάξτε εδώ αρχεία για upload","Dry_run":"ξηρή λειτουργία","Dry_run_description":"Θα στείλει μόνο ένα email, στην ίδια διεύθυνση με in Από. Το e-mail πρέπει να ανήκει σε ένα έγκυρο χρήστη.","Duplicate_archived_channel_name":"Ένας αρχειοθετημένα κανάλι με το όνομα ' %s' υπάρχει","Duplicate_archived_private_group_name":"Ένας αρχειοθετημένα Ιδιωτική Ομάδα με υφίσταται όνομα ' %s'","Duplicate_private_group_name":"Υπάρχει ήδη ΄κλειστή ομάδα με όνομα '%s'","E-mail":"E-mail","Edit":"Επεξεργασία","Edit_Custom_Field":"Επεξεργασία προσαρμοσμένου πεδίου","Edit_Department":"Επεξεργασία Τμήμα","edited":"επεξεργ.","Email":"E-mail","Email_already_exists":"Το Email υπάρχει ήδη","Email_body":"σώμα E-mail","Email_Change_Disabled":"Rocket.Chat διαχειριστής σας έχει απενεργοποιήσει την αλλαγή του e-mail","Email_from":"Από","Email_Notification_Mode":"Offline Ειδοποιήσεις Email","Email_Notification_Mode_All":"Κάθε Μνεία / DM","Email_Notification_Mode_Disabled":"Ανάπηρος","Email_or_username":"Email ή όνομα χρήστη","Email_subject":"Θέμα","Email_verified":"Επιβεβαιώθηκε το Email","Emoji":"Emoji","Empty_title":"κενός τίτλος","Enable":"Καθιστώ ικανό","Enable_Desktop_Notifications":"Ενεργοποίηση ειδοποιήσεων επιφάνειας εργασίας","Enabled":"Ενεργοποιήθηκε","Encrypted_message":"κρυπτογραφημένο μήνυμα","End_OTR":"τέλος OTR","Enter_a_regex":"Πληκτρολογήστε ένα regex","Enter_a_room_name":"Πληκτρολογήστε ένα όνομα δωμάτιο","Enter_a_username":"Εισάγετε ένα όνομα χρήστη","Enter_info":"Εισάγετε στοιχεία σύνδεσης","Enter_name_here":"Πληκτρολογήστε το όνομα εδώ","Enter_to":"Enter για να","Error":"Λάθος","error-cant-invite-for-direct-room":"Δεν μπορείτε να προσκαλέσετε το χρήστη σε απευθείας δωμάτια","error-duplicate-channel-name":"Υπάρχει ήδη κανάλι με όνομα '%s'","error-invalid-custom-field":"Μη έγκυρο προσαρμοσμένο πεδίο","error-invalid-custom-field-name":"Μη έγκυρο όνομα προσαρμοσμένο πεδίο. Χρησιμοποιήστε μόνο γράμματα, αριθμούς, παύλες και τις κάτω παύλες.","error-invalid-password":"Λανθασμένος κωδικός","error-invalid-room":"Μη έγκυρη δωμάτιο","error-invalid-room-name":"<strong> %s</strong> δεν είναι έγκυρο όνομα του δωματίου, <br/> χρησιμοποιήστε μόνο γράμματα, αριθμούς, παύλες και τις κάτω παύλες","error-invalid-user":"Μη έγκυρος χρήστης","error-invalid-username":"Μη έγκυρο όνομα χρήστη","error-not-allowed":"Δεν επιτρέπεται","error-not-authorized":"δεν επιτρέπεται","error-remove-last-owner":"Αυτό είναι το τελευταίο ιδιοκτήτη. Παρακαλούμε να ορίσετε ένα νέο ιδιοκτήτη πριν από την αφαίρεση αυτό το ένα.","error-role-name-required":"Το όνομά ρόλος αυτός απαιτείται","error-user-not-in-room":"Ο χρήστης δεν είναι σε αυτό το δωμάτιο","Error_changing_password":"Ο κωδικός άλλαξε","Error_sending_confirmation_email":"Σφάλμα κατά την αποστολή e-mail επιβεβαίωσης","Error_too_many_requests":"Σφάλματος, πάρα πολλά αιτήματα. Παρακαλώ πήγαινε πιο σιγά. Θα πρέπει να περιμένετε %s δευτερόλεπτα πριν προσπαθήσετε ξανά","Esc_to":"Esc για να","Example_s":"Παράδειγμα: <code class=\"inline\">%s</code>","False":"Ψευδής","Favorites":"Αγαπημενα","Field":"Πεδίο","Field_removed":"Το πεδίο αφαιρεθεί","File_exceeds_allowed_size_of_bytes":"Αρχείο υπερβαίνει επιτρεπόμενο μέγεθος των __size__ bytes","FileUpload":"Ανέβασμα αρχείου","FileUpload_Enabled":"Ενεργοποιηθεί η μεταφόρτωση αρχείων","FileUpload_File_Empty":"αρχείο άδειο","FileUpload_FileSystemPath":"Διαδρομή του συστήματος","FileUpload_MaxFileSize":"Μέγιστο Μεταφόρτωση αρχείου Μέγεθος (σε bytes)","FileUpload_MediaType_NotAccepted":"Τύποι μέσων εκτύπωσης δεν γίνονται δεκτές","FileUpload_MediaTypeWhiteList":"Δεκτές Τύποι Media","FileUpload_MediaTypeWhiteListDescription":"Διαχωρισμένες με κόμμα λίστα των τύπων των μέσων ενημέρωσης. Αφήστε το κενό για την αποδοχή όλων των τύπων των μέσων ενημέρωσης.","FileUpload_ProtectFiles":"Προστατέψτε τα αρχεία που γίνονται upload","FileUpload_ProtectFilesDescription":"Μόνο πιστοποιημένοι χρήστες θα έχουν πρόσβαση","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 όνομα κουβά","FileUpload_S3_BucketURL":"URL κουβά","FileUpload_S3_CDN":"τομέα CDN για λήψεις","FileUpload_S3_Region":"Περιοχή","FileUpload_Storage_Type":"Τύπος αποθήκευσης","Flags":"σημαίες","Follow_social_profiles":"Ακολουθήστε μας στα κοινωνικά δίκτυα, κάντε μας fork στο github και μοιραστείτε τις σκέψεις σας για την εφαρμογή rocket.chat στον πίνακα trello.","Food_and_Drink":"Φαγητο ΠΟΤΟ","For_your_security_you_must_re_enter_your_password_to_continue":"Για την ασφάλειά σας, θα πρέπει να εισάγετε ξανά τον κωδικό πρόσβασής σας για να συνεχίσετε","Force_SSL":"Force SSL","Force_SSL_Description":"* Προσοχή! * _Force SSL_ δεν πρέπει ποτέ να χρησιμοποιείται με αντίστροφη proxy. Εάν έχετε μια αντίστροφη proxy, θα πρέπει να κάνετε την ανακατεύθυνση εκεί. υπάρχει αυτή η επιλογή για αναπτύξεις όπως Heroku, που δεν επιτρέπει τη διαμόρφωση ανακατεύθυνση σε αντίστροφη proxy.","Forgot_password":"Ξέχασα τον κωδικό μου","Fork_it_on_github":"Fork it on github","Frequently_Used":"συχνά χρησιμοποιούμενες","From":"Από","From_Email":"από Email","From_email_is_required":"Από Απαιτείται email","From_email_warning":"<b>Προειδοποίηση:</b> Το πεδίο <b>Από</b> υπόκειται στις ρυθμίσεις του διακομιστή αλληλογραφίας σας.","General":"Γενικός","Get_to_know_the_team":"Γνωρίστε την ομάδα του Rocket.Team","github_no_public_email":"Δεν έχετε κανένα δημόσιο email στον GitHub λογαριασμό σας","Give_a_unique_name_for_the_custom_oauth":"Δώστε ένα μοναδικό όνομα για την προσαρμοσμένη OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Δώστε στην εφαρμογή ένα όνομα. Αυτό θα φανεί από τους χρήστες σας.","Global":"Παγκόσμια","GoogleTagManager_id":"Id στο Google Tag Manager","Has_more":"έχει περισσότερα","Have_your_own_chat":"Αποκτήστε το δικό σας web chat. Αναπτύγμένο με το Meteor.com, το Rocket.Chat είναι μια πολύ καλή λύση για προγραμματιστές που θέλουν να φτιάξουν και να εξελίξουν την δικιά τους πλατφόρμα chat.","Header":"Επί κεφαλής","Hidden":"Κεκρυμμένος","Hide_Group_Warning":"Είστε σίγουροι ότι θέλετε να αποκρύψετε την ομάδα \" %s\";","Hide_Private_Warning":"Είστε βέβαιοι ότι θέλετε να αποκρύψετε τη συζήτηση με το \" %s\";","Hide_room":"Απόκρυψη δωματίου","Hide_Room_Warning":"Είστε σίγουροι ότι θέλετε να αποκρύψετε το δωμάτιο \" %s\";","Highlights":"Ανταύγειες","Highlights_How_To":"Να ειδοποιείται όταν κάποιος αναφέρει μια λέξη ή φράση, προσθέστε το εδώ. Μπορείτε να διαχωρίσετε λέξεις ή φράσεις με κόμματα. Λέξεις κυριώτερο δεν είναι ευαίσθητη υπόθεση.","Highlights_List":"λέξεις highlight","History":"Ιστορικό","hours":"ώρες","How_friendly_was_the_chat_agent":"Πόσο φιλικό ήταν ο πράκτορας συνομιλία;","How_knowledgeable_was_the_chat_agent":"Πώς γνώστες ήταν ο πράκτορας συνομιλία;","How_responsive_was_the_chat_agent":"Πώς ανταποκρίνεται ήταν ο πράκτορας συνομιλία;","How_satisfied_were_you_with_this_chat":"Πόσο ικανοποιημένοι είστε με αυτήν την κουβέντα;","If_you_are_sure_type_in_your_password":"Εάν είστε βέβαιοι πληκτρολογήστε τον κωδικό σας:","If_you_are_sure_type_in_your_username":"Εάν είστε βέβαιοι πληκτρολογήστε το όνομα χρήστη σας:","Importer_Archived":"Αρχειοθετημένα","Importer_done":"Εισαγωγή πλήρης!","Importer_finishing":"Ολοκλήρωση της εισαγωγής.","Importer_From_Description":"Οι εισαγωγές __from δεδομένων __ 's σε Rocket.Chat.","Importer_import_cancelled":"Εισαγωγής ακυρωθεί.","Importer_import_failed":"Παρουσιάστηκε σφάλμα κατά την εκτέλεση της εισαγωγής.","Importer_importing_channels":"Εισάγει τα κανάλια.","Importer_importing_messages":"Εισάγει τα μηνύματα.","Importer_importing_started":"Ξεκινώντας την εισαγωγή.","Importer_importing_users":"Εισαγωγή των χρηστών.","Importer_not_defined_properly":"Ο εισαγωγέας δεν ορίστηκε σωστά, λείπει η κατηγορία Import.","Importer_not_in_progress":"Ο εισαγωγέας αυτή τη στιγμή δεν λειτουργεί.","Importer_Prepare_Restart_Import":"επανεκκίνηση Εισαγωγή","Importer_Prepare_Start_Import":"Ξεκινήστε Εισαγωγή","Importer_Prepare_Uncheck_Archived_Channels":"Καταργήστε την επιλογή Αρχείο Κανάλια","Importer_Prepare_Uncheck_Deleted_Users":"Καταργήστε την επιλογή Διαγράφεται Χρήστες","Importer_progress_error":"Απέτυχε να πάρει την πρόοδο για την εισαγωγή.","Importer_setup_error":"Παρουσιάστηκε σφάλμα κατά τη δημιουργία του εισαγωγέα.","Incorrect_Password":"Λάθος κωδικός","inline_code":"γραμμή κώδικα","Install_Extension":"εγκαταστήστε Παράταση","Install_FxOs":"Εγκαταστήστε Rocket.Chat για τον Firefox","Install_FxOs_done":"Εξαιρετική! Μπορείτε τώρα να χρησιμοποιήσετε Rocket.Chat μέσω του εικονίδιο στην αρχική οθόνη σας. Καλή διασκέδαση με Rocket.Chat!","Install_FxOs_error":"Συγγνώμη, αυτό δεν λειτούργησε όπως θα έπρεπε! Το ακόλουθο μήνυμα λάθους εμφανίζεται:","Install_FxOs_follow_instructions":"Παρακαλούμε να επιβεβαιώσετε την εγκατάσταση εφαρμογών στη συσκευή σας (πατήστε \"Εγκατάσταση\" όταν σας ζητηθεί).","Installation":"Εγκατάσταση","Integration_added":"Ενσωμάτωση έχει προστεθεί","Integration_Incoming_WebHook":"Εισερχόμενη Ενσωμάτωση WebHook","Integration_New":"νέα Ενσωμάτωση","Integration_Outgoing_WebHook":"Εξερχόμενες Ενσωμάτωση WebHook","Integration_updated":"Ενσωμάτωση έχει ενημερωθεί","Integrations":"ολοκληρώσεις","Invalid_asset":"Μη έγκυρη ενεργητικού","Invalid_confirm_pass":"Η επιβεβαίωση κωδικού δεν ταιριάζει με τον αρχικό κωδικό","Invalid_email":"Το e-mail που δώσατε δεν είναι έγκυρο","Invalid_Export_File":"Το αρχείο δεν είναι έγκυρο %s αρχείο εξαγωγής.","Invalid_file_height":"Μη έγκυρο ύψος του αρχείου","Invalid_file_type":"Μη έγκυρος τύπος αρχείου","Invalid_file_width":"Μη έγκυρο πλάτος αρχείο","Invalid_Import_File_Type":"Μη έγκυρος τύπος αρχείου εισαγωγής.","Invalid_name":"Το όνομα δεν πρέπει να έιναι κενό","Invalid_notification_setting_s":"Μη έγκυρη ρύθμιση ειδοποίησης: %s","Invalid_pass":"Ο κωδικός δεν πρέπει να έιναι κενός","Invalid_room_name":"<strong>%s</strong> δεν είναι έγκυρο όνομα δωματίου,<br/> χρησιμοποιείστε μόνο γράμματα, αριθμούς και παύλες","Invalid_room_type":"<strong> %s</strong> δεν είναι έγκυρο τύπο δωματίου.","Invalid_Secret_URL":"Μη έγκυρη διεύθυνση URL Secret","Invalid_secret_URL_message":"Η διεύθυνση URL δεν είναι έγκυρη.","invisible":"αόρατος","Invisible":"Αόρατος","Invitation_HTML":"πρόσκληση HTML","Invitation_Subject":"πρόσκληση Θέμα","Invite_user_to_join_channel":"Προσκαλέστε ένα χρήστη να ενταχθούν σε αυτό το κανάλι","Invite_Users":"Προσκαλέστε χρήστες","is_also_typing":"πληκτρολογεί επίσης","is_also_typing_female":"πληκτρολογεί επίσης","is_also_typing_male":"πληκτρολογεί επίσης","is_typing":"πληκτρολογεί","is_typing_female":"πληκτρολογεί","is_typing_male":"πληκτρολογεί","italics":"πλάγια","join":"Γίνετε μέλος","Join_audio_call":"Συμμετοχή στην κλήση ήχου","Join_the_Community":"Γίνετε μέλος της Κοινότητας","Join_the_given_channel":"Γίνετε μέλος του συγκεκριμένου καναλιού","Join_video_call":"Συμμετοχή στην κλήση βίντεο","Joined":"Εντάχθηκαν","Jump":"Άλμα","Jump_to_first_unread":"Μετάβαση σε πρώτη αδιάβαστη","Jump_to_message":"Μετάβαση σε μήνυμα","Jump_to_recent_messages":"Μετάβαση σε πρόσφατα μηνύματα","Katex_Enabled":"Katex Enabled","Label":"Επιγραφή","Language":"Γλώσσα","Language_Version":"Ελληνική Έκδοση","Last_login":"Τελευταία σύνδεση","Last_message":"Τελευταίο μήνυμα","Last_seen":"Εθεάθη τελευταία","Layout":"Διάταξη","Layout_Home_Body":"Αρχική Σώμα","Layout_Home_Title":"Αρχική Τίτλος","Layout_Login_Terms":"Όροι Είσοδος","Layout_Privacy_Policy":"Πολιτική Προστασίας Προσωπικών Δεδομένων","Layout_Sidenav_Footer":"Πλευρά πλοήγησης Υποσέλιδο","Layout_Sidenav_Footer_description":"μέγεθος υποσέλιδου είναι 260 x 70 εικονοστοιχεία","Layout_Terms_of_Service":"Όροι χρήσης","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Αναζήτηση προσαρμοσμένο τομέα","LDAP_Custom_Domain_Search_Description":"Ένα κομμάτι του JSON που διέπει δεσμεύουν και σύνδεση πληροφορίες και είναι της μορφής: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"default Domain","LDAP_Description":"LDAP είναι μια ιεραρχική βάση δεδομένων που πολλές εταιρείες χρησιμοποιούν για να παρέχουν Single Sign On - μια εγκατάσταση για την κοινή χρήση ενός κωδικού πρόσβασης από πολλαπλές τοποθεσίες και υπηρεσίες. Για προχωρημένους πληροφορίες διαμόρφωσης και παραδείγματα, συμβουλευτείτε wiki μας: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"τομέα Βάσης","LDAP_Domain_Base_Description":"Το πλήρως αναγνωρισμένο αποκλειστικό όνομα (DN) του υποδένδρο LDAP που θέλετε να αναζητήσετε χρήστες και ομάδες. Μπορείτε να προσθέσετε όσες θέλετε? Ωστόσο, κάθε ομάδα πρέπει να ορίζεται στην ίδια βάση τομέα με τους χρήστες που ανήκουν σε αυτήν. Εάν καθορίσετε κλειστές ομάδες χρηστών, μόνο οι χρήστες που ανήκουν σε αυτές τις ομάδες θα είναι στο πεδίο. Σας συνιστούμε να καθορίσετε το ανώτερο επίπεδο του δέντρου καταλόγου LDAP σας ως βάση το domain σας και να χρησιμοποιήσετε το φίλτρο αναζήτησης για να ελέγξετε την πρόσβαση.","LDAP_Domain_Search_Filter":"Αναζήτηση Domain Φίλτρο","LDAP_Domain_Search_Filter_Description":"Αν καθοριστεί, μόνο οι χρήστες που ταιριάζουν με αυτό το φίλτρο θα επιτραπεί να συνδεθείτε. Εάν δεν έχει καθοριστεί φίλτρου, όλοι οι χρήστες εντός του πεδίου εφαρμογής της συγκεκριμένης βάσης τομέα θα είναι σε θέση να συνδεθείτε. <br/> Π.χ. για Active Directory `MemberOf = cn = ROCKET_CHAT, ou = Γενική Groups`. <br/> Π.χ. για OpenLDAP (αναζήτηση επεκτάσιμη αγώνα) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Αναζήτηση Domain Object Κατηγορία","LDAP_Domain_Search_Object_Category_Description":"Ο * objectCategory * που αναγνωρίζουν τους χρήστες σας. <br/> Αφήστε το κενό για * OpenLDAP *. <br/> Π.χ. `person`, κ.λπ.","LDAP_Domain_Search_Object_Class":"Τομέα Class Αναζήτηση Αντικείμενο","LDAP_Domain_Search_Object_Class_Description":"Ο * objectclass * που αναγνωρίζουν τους χρήστες σας. <br/> Π.χ. `organizationalPerson`,` Χρήστης των, `inetOrgPerson`, κ.λπ.","LDAP_Domain_Search_Password":"Αναζήτηση Domain Κωδικός","LDAP_Domain_Search_Password_Description":"Ο κωδικός πρόσβασης για το χρήστη αναζήτησης τομέα.","LDAP_Domain_Search_User":"Αναζήτηση Domain User","LDAP_Domain_Search_User_Description":"Ο χρήστης LDAP που εκτελεί αναζητήσεις του χρήστη για τον έλεγχο ταυτότητας σε άλλους χρήστες, όταν συνδεθείτε. <br/> Αυτό είναι συνήθως ένα λογαριασμό υπηρεσίας που δημιουργήθηκε ειδικά για την ενσωμάτωση τρίτων κατασκευαστών. Χρησιμοποιήστε ένα πλήρως αναγνωρισμένο όνομα, όπως `cn = διαχειριστή, CN = Users, dc = Παράδειγμα, dc = com`.","LDAP_Domain_Search_User_ID":"Αναζήτηση Domain Αναγνωριστικό χρήστη","LDAP_Domain_Search_User_ID_Description":"Το χαρακτηριστικό LDAP που προσδιορίζει το χρήστη LDAP ο οποίος επιχειρεί έλεγχο ταυτότητας. Αυτό το πεδίο πρέπει να είναι `sAMAccountName` για τις εγκαταστάσεις πιο Active Directory, αλλά μπορεί να είναι` uid` για άλλες λύσεις LDAP, όπως OpenLDAP. Μπορείτε να χρησιμοποιήσετε το `mail` για την αναγνώριση των χρηστών μέσω e-mail ή οτιδήποτε άλλο χαρακτηριστικό που θέλετε. <br> Μπορείτε να χρησιμοποιήσετε πολλές τιμές διαχωρισμένες με κόμμα για να επιτρέπει στους χρήστες να συνδεθείτε χρησιμοποιώντας πολλαπλές αναγνωριστικά, όπως το όνομα χρήστη ή e-mail.","LDAP_Enable":"Καθιστώ ικανό","LDAP_Enable_Description":"Προσπάθεια να χρησιμοποιούν το LDAP για έλεγχο ταυτότητας.","LDAP_Encryption":"κρυπτογράφηση","LDAP_Encryption_Description":"Η μέθοδος κρυπτογράφησης που χρησιμοποιούνται για τη διασφάλιση των επικοινωνιών στο διακομιστή LDAP. Παραδείγματα περιλαμβάνουν `plain` (χωρίς κρυπτογράφηση),` SSL / LDAPS` (κρυπτογραφημένα από την αρχή), και `StartTLS` (αναβάθμιση σε κρυπτογραφημένη επικοινωνία φορά που συνδέονται).","LDAP_Host":"Πλήθος","LDAP_Host_Description":"Ο οικοδεσπότης LDAP, π.χ. `ldap.example.com` ή` 10.0.0.30`.","LDAP_Port":"LDAP Θύρα","LDAP_Port_Description":"Θύρα για να αποκτήσετε πρόσβαση LDAP. π.χ: `389` ή` 636` για LDAPS","LDAP_Reject_Unauthorized":"Απόρριψη Μη εξουσιοδοτημένη","LDAP_Sync_User_Avatar":"Συγχρονισμός χρήστη Avatar","LDAP_Sync_User_Data":"Data Sync","LDAP_Sync_User_Data_Description":"Κρατήστε τα δεδομένα των χρηστών σε συγχρονισμό με το διακομιστή για την είσοδο (π.χ. όνομα, διεύθυνση ηλεκτρονικού ταχυδρομείου).","LDAP_Sync_User_Data_FieldMap":"Πεδίου δεδομένων χρήστη Χάρτης","LDAP_Sync_User_Data_FieldMap_Description":"Διαμορφώστε το πώς τα πεδία λογαριασμού χρήστη (όπως το ηλεκτρονικό ταχυδρομείο) κατοικείται από τα επίπεδα ρεκόρ στα LDAP (αφού διαπίστωσε). <br/> Ως παράδειγμα, `{\" ΣΟ \":\" όνομα \",\" mail \":\" e-mail \"}` θα επιλέξουν τα ανθρώπινα αναγνώσιμο όνομα ενός ατόμου από το χαρακτηριστικό cn, και το ηλεκτρονικό ταχυδρομείο τους από το χαρακτηριστικό αλληλογραφίας. <br/> Διαθέσιμα πεδία περιλαμβάνουν `name`, και` email`.","LDAP_Sync_Users":"Συγχρονισμός χρήστες","LDAP_Test_Connection":"δοκιμή σύνδεσης","LDAP_Unique_Identifier_Field":"Μοναδικό αναγνωριστικό πεδίο","LDAP_Unique_Identifier_Field_Description":"Ποιο πεδίο θα χρησιμοποιηθεί για να συνδέσει το χρήστη LDAP και του χρήστη Rocket.Chat. Μπορείτε να ενημερώσετε πολλαπλές τιμές διαχωρισμένες με κόμμα για να προσπαθήσει να πάρει την τιμή από LDAP ρεκόρ. <br/> Προεπιλεγμένη τιμή είναι `objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Χρησιμοποιήστε Αναζήτηση Προσαρμοσμένο Τομέα","LDAP_Use_Custom_Domain_Search_Description":"Γράψτε τη δική σας φίλτρο για να αναζητήσετε χρήστες στο διακομιστή LDAP.","LDAP_Username_Field":"Όνομα Χρήστη πεδίο","LDAP_Username_Field_Description":"Ποιο πεδίο θα πρέπει να χρησιμοποιηθεί ως * όνομα * για τους νέους χρήστες. Αφήστε το κενό για να χρησιμοποιήσετε το όνομα χρήστη ενήμερο για login σελίδα. <br/> Μπορείτε να χρησιμοποιήσετε ετικέτες πρότυπο πάρα πολύ, όπως το `# {givenName}. # {Sn}`. <br/> Προεπιλεγμένη τιμή είναι `sAMAccountName`.","Leave_Group_Warning":"Είστε σίγουροι ότι θέλετε να αποχωρήσετε από την ομάδα \" %s\";","Leave_Private_Warning":"Είστε σίγουροι ότι θέλετε να αφήσετε τη συζήτηση με το \" %s\";","Leave_room":"Έξοδος από το δωμάτιο","Leave_Room_Warning":"Είστε σίγουροι ότι θέλετε να φύγετε από το δωμάτιο \" %s\";","line":"γραμμές","List_of_Direct_Messages":"Κατάλογος άμεσων μηνυμάτων","Live_sessions":"ζωντανή συνεδρίες","Livechat_agents":"livechat πράκτορες","Livechat_Dashboard":"livechat ταμπλό","Livechat_enabled":"Livechat ενεργοποιημένη","Livechat_Manager":"livechat Διευθυντής","Livechat_managers":"διαχειριστές livechat","Livechat_title":"livechat Τίτλος","Livechat_title_color":"Livechat Τίτλος Χρώμα φόντου","Livechat_Users":"livechat χρήστες","Load_more":"Φόρτωση περισσότερων","Loading...":"Φορτώνει ...","Loading_more_from_history":"Φόρτωση περισσότερα από την ιστορία","Loading_suggestion":"Φόρτωση προτάσεων...","Localization":"Εντοπισμός","Log_File":"Εμφάνιση αρχείων και Γραμμή","Log_Level":"Επίπεδο καταγραφής","Log_Package":"Εμφάνιση Πακέτο","Log_View_Limit":"Συνδεθείτε Δείτε Όριο","Logged_out_of_other_clients_successfully":"Αποσυνδεθεί από άλλους πελάτες με επιτυχία","Login":"Είσοδος","Login_with":"Είσοδος με %s","login_with":"Συνδεθείτε απευθείας με","Logout":"Αποσύνδεση","Logout_Others":"Αποσύνδεση από άλλους εισέλθει Τοποθεσίες","Mail_Message_Invalid_emails":"Έχετε παρέχεται μία ή περισσότερες μη έγκυρες διευθύνσεις ηλεκτρονικού ταχυδρομείου: %s","Mail_Message_Missing_to":"Πρέπει να επιλέξετε έναν ή περισσότερους χρήστες ή παρέχουν μία ή περισσότερες διευθύνσεις ηλεκτρονικού ταχυδρομείου, διαχωρισμένες με κόμματα.","Mail_Message_No_messages_selected_select_all":"Δεν έχετε επιλέξει κανένα μήνυμα. Θέλετε να <a href='#' class='select-all'>επιλέξετε όλα τα</a> ορατά μηνύματα;","Mail_Messages":"μηνύματα ηλεκτρονικού ταχυδρομείου","Mail_Messages_Instructions":"Επιλέξτε τα μηνύματα που θέλετε να στείλετε μέσω e-mail πατώντας τα μηνύματα","Mail_Messages_Subject":"Εδώ είναι ένα επιλεγμένο τμήμα των μηνυμάτων %s","Mailer":"Μέιλερ","Mailer_body_tags":"Θα <b>πρέπει</b> να χρησιμοποιήσετε [unsubscribe] για το διαγραφής σύνδεσμο. <br /> Μπορείτε να χρησιμοποιήσετε το [όνομα], [ΟΝΟΜΑ], [ΕΠΙΘΕΤΟ] για το πλήρες όνομα του χρήστη, το όνομα ή το επώνυμο, αντίστοιχα. <br /> Μπορείτε να χρησιμοποιήσετε το [e-mail] για το ηλεκτρονικό ταχυδρομείο του χρήστη.","Make_Admin":"Κάντε Διαχειριστή","Manager_added":"πρόσθεσε Διευθυντής","Manager_removed":"αφαιρεθεί Διευθυντής","Mark_as_read":"Σημείωσε ως διαβασμένο","Markdown_Headers":"markdown κεφαλίδες","Markdown_SupportSchemesForLink":"Σχέδια Markdown Υποστήριξη για Link","Markdown_SupportSchemesForLink_Description":"Διαχωρισμένες με κόμμα λίστα των επιτρεπόμενων προγραμμάτων","Members_List":"Λίστα μελών","Mentions":"αναφέρει","Mentions_default":"Αναφέρει (προεπιλογή)","Message":"Μήνυμα","Message_AllowDeleting":"Επιτρέπεται διαγραφή μηνυμάτων","Message_AllowEditing":"Επιτρέπεται επεξεργασία μηνυμάτων","Message_AllowEditing_BlockEditInMinutes":"Αποκλεισμός μηνυμάτων Επεξεργασία Μετά (n) Λεπτά","Message_AllowEditing_BlockEditInMinutesDescription":"Εισάγετε 0 για να απενεργοποιήσετε το κλείδωμα.","Message_AllowPinning":"Επιτρέψτε Μήνυμα Καρφίτσωμα","Message_AllowPinning_Description":"Επιτρέψτε μηνύματα που πρέπει να καρφώθηκε σε κάποιο από τα κανάλια.","Message_AllowStarring":"Επιτρέψτε Μήνυμα Πρωταγωνιστούν","Message_AudioRecorderEnabled":"Εγγραφής ήχου Ενεργοποιήθηκε","Message_AudioRecorderEnabledDescription":"Απαιτεί '/ wav audio' αρχεία για να είναι μια αποδεκτή τύπο μέσου στο πλαίσιο των ρυθμίσεων «File Upload».","Message_DateFormat":"Μορφή ημερομηνίας","Message_DateFormat_Description":"Δείτε επίσης: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Δεν επιτρέπεται η διαγραφή μηνυμάτων","Message_editing_blocked":"Αυτό το μήνυμα δεν μπορεί να επεξεργαστεί πια","Message_editing_not_allowed":"Δεν επιτρέπεται η επεξεργασία μηνυμάτων","Message_GroupingPeriod":"Ομαδοποίηση Περίοδος (σε δευτερόλεπτα)","Message_GroupingPeriodDescription":"Τα μηνύματα θα πρέπει να ομαδοποιηθούν με προηγούμενο μήνυμα, αν και οι δύο είναι από τον ίδιο χρήστη και ο χρόνος που παρήλθε ήταν μικρότερη από την ενημέρωση του χρόνου σε δευτερόλεπτα.","Message_KeepHistory":"Κρατήστε ιστορικό μηνυμάτων","Message_MaxAllowedSize":"Μέγιστο επιτρεπόμενο μέγεθος μηνύματος","Message_MaxAll":"Μέγιστο μέγεθος καναλιού για όλα μηνύματος","Message_pinned":"μήνυμα καρφώθηκε","Message_pinning_not_allowed":"Μήνυμα δεν εναποθέτει επιτρέπεται","Message_removed":"Το μήνυμα αφαιρέθηκε","Message_ShowDeletedStatus":"Εμφάνιση Διαγραμμένης Κατάστασης","Message_ShowEditedStatus":"Εμφάνιση Επεξεργασμένης Κατάστασης","Message_ShowFormattingTips":"Εμφάνιση μορφοποίηση Συμβουλές","Message_TimeFormat":"Μορφή ώρας","Message_TimeFormat_Description":"Δείτε επίσης: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Μήνυμα πάρα πολύ καιρό","Messages":"μηνύματα","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Τα μηνύματα που αποστέλλονται στο Incoming WebHook θα αναρτηθούν εδώ.","Meta":"Meta","Meta_fb_app_id":"Facebook APP ID","Meta_google-site-verification":"Επαλήθευση ιστότοπου Google","Meta_language":"Γλώσσα","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Ρομπότ","minutes":"λεπτά","Mobile_push":"κινητό ώθηση","More_channels":"Περισσότερα κανάλια","More_direct_messages":"Πιο άμεσα μηνύματα","More_groups":"Περισσότερες ιδιωτικές ομάδες","More_unreads":"περισσότερα unreads","Msgs":"Μνμτα","multi":"πολλαπλές","Mute_someone_in_room":"Mute κάποιος στο δωμάτιο","Mute_user":"Σίγαση χρήστη","Muted":"Συγκρατημένα","My_Account":"Ο Λογαριασμός Μου","n_messages":"%s μηνύματα","N_new_messages":" %s νέα μηνύματα","Name":"Όνομα","Name_cant_be_empty":"Το όνομα δεν μπορεί να είναι κενό","Name_of_agent":"Όνομα πράκτορα","Name_optional":"Όνομα (προαιρετικό)","Navigation_History_20_last_pages":"Ιστορία πλοήγησης (20 τελευταίες σελίδες)","New_Application":"νέα Εφαρμογή","New_Custom_Field":"Νέα Προσαρμοσμένο πεδίο","New_Department":"νέο Τμήμα","New_integration":"νέα ένταξη","New_logs":"νέα κούτσουρα","New_messages":"Νέα μηνύματα","New_password":"Νέος κωδικός","New_role":"Ο νέος ρόλος","No_channel_with_name_%s_was_found":"Δεν κανάλι με το όνομα <strong>\" %s\"</strong> βρέθηκε!","No_channels_yet":"Δεν είστε σε κανένα κανάλι ακόμα.","No_direct_messages_yet":"Δεν έχετε ξεκινήσει συνομιλίες ακόμα.","No_Encryption":"Όχι Κρυπτογράφηση","No_favorites_yet":"Δεν έχετε προσθέσει αγαπημένα ακόμα.","No_group_with_name_%s_was_found":"Δεν ιδιωτική ομάδα με το όνομα <strong>\" %s\"</strong> βρέθηκε!","No_groups_yet":"Δεν έχετε κλειστές ομάδες ακόμα.","No_livechats":"Δεν έχετε livechats.","No_mentions_found":"Δεν βρέθηκαν μνείες","No_permission_to_view_room":"Δεν έχετε άδεια να δείτε αυτό το δωμάτιο.","No_pinned_messages":"Δεν καρφώθηκε μηνύματα","No_results_found":"Δεν βρέθηκαν αποτελέσματα","No_starred_messages":"Δεν αστέρι μηνύματα","no_tokens_for_this_user":"Δεν υπάρχουν κουπόνια για αυτόν τον χρήστη","No_user_with_username_%s_was_found":"Κανένας χρήστης δεν με όνομα <strong>\" %s\"</strong> βρέθηκε!","Not_allowed":"Δεν επιτρέπεται","Not_authorized":"δεν επιτρέπεται","Not_Available":"Μη διαθέσιμος","Not_found_or_not_allowed":"Δεν βρέθηκε ή δεν επιτρέπεται","Nothing":"Τίποτα","Nothing_found":"Τίποτα δεν βρέθηκε","Notifications":"Ειδοποιήσεις","Notify_all_in_this_room":"Ειδοποιείστε τους όλους στο δωμάτιο","Num_Agents":"# Πράκτορες","Number_of_messages":"Αριθμός μηνυμάτων","OAuth_Application":"OAuth Εφαρμογή","OAuth_Applications":"OAuth Εφαρμογές","Objects":"αντικείμενα","Off_the_record_conversation":"Off-the-record συνομιλία","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record συνομιλία δεν είναι διαθέσιμη για το πρόγραμμα περιήγησης ή τη συσκευή σας.","Offline_DM_Email":"[__site__] Σας έχουν άμεση ειδοποιήται από __user__","Offline_Mention_Email":"[__site__] Έχετε αναφερθεί από __user__ στην #__room__","Old_and_new_password_must_be_different":"Ο νέος κωδικός πρόσβασης πρέπει να είναι διαφορετικός από τον παλιό κωδικό πρόσβασης.","Old_and_new_password_required":"Θα πρέπει να παρέχουν τόσο παλιό και το νέο κωδικό πρόσβασης για αλλαγή του κωδικού πρόσβασής σας.","Online":"Συνδεδεμένος","Only_errors":"μόνο σφάλματα","Only_you_can_see_this_message":"Μόνο εσείς μπορείτε να δείτε αυτό το μήνυμα","Oops!":"Ουπς","Open":"Ανοιχτό","Opened":"άνοιξε","Opt_out_statistics":"Μην στέλνετε στατιστικά μου για να Rocket.Chat","Opt_out_statistics_warning":"Με την αποστολή των στατιστικών σας, θα μας βοηθήσει να εντοπίσουμε το πώς αναπτύσσονται πολλές περιπτώσεις Rocket.Chat, καθώς και πόσο καλό είναι το σύστημα συμπεριφέρεται, ώστε να μπορούμε να τη βελτιώσουμε περαιτέρω. Μην ανησυχείτε, καθώς δεν υπάρχουν πληροφορίες χρήστης έχει σταλεί και όλες οι πληροφορίες που λαμβάνουμε είναι εμπιστευτικές. Αν θέλετε να συνεχίσετε να μας στείλετε τα στατιστικά σας, καταργήστε την επιλογή του παραπάνω πλαισίου ελέγχου. Ευχαριστώ.","optional":"προαιρετικός","Order":"Παραγγελία","OS_Arch":"OS Arch","OS_Cpus":"OS Αριθμός CPU","OS_Freemem":"OS Ελεύθερη Μνήμη","OS_Loadavg":"OS Μέσος φόρτος","OS_Platform":"OS Πλατφόρμα","OS_Release":"OS Release","OS_Totalmem":"OS Συνολική μνήμη","OS_Type":"OS Τύπος","OS_Uptime":"OS Uptime","others":"άλλοι","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR είναι διαθέσιμη μόνο όταν και οι δύο χρήστες είναι online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Παράκαμψη URL στο οποίο φορτώνονται τα αρχεία. Αυτή η διεύθυνση URL που χρησιμοποιείται επίσης για λήψεις εκτός εάν ένα CDN δίνεται","Password":"Kωδικός","Password_Change_Disabled":"Rocket.Chat διαχειριστής σας έχει απενεργοποιήσει την αλλαγή των κωδικών πρόσβασης","Password_changed_successfully":"Ο κωδικός άλλαξε με επιτυχία","Payload":"Φορτίο επί πληρωμή","People":"Άνθρωποι","Permissions":"δικαιώματα","Pin_Message":"pin μηνύματος","Pinned_a_message":"Καρφώθηκε ένα μήνυμα:","Pinned_Messages":"καρφώθηκε Μηνύματα","Placeholder_for_email_or_username_login_field":"Σύμβολο κράτησης θέσης για e-mail ή Είσοδος Όνομα πεδίου","Placeholder_for_password_login_field":"Σύμβολο κράτησης θέσης για το πεδίο κωδικό σύνδεσης","Please_answer_survey":"Αφιερώστε λίγο χρόνο για να απαντήσετε σε μια σύντομη έρευνα σχετικά με αυτήν την κουβέντα","Please_enter_value_for_url":"Παρακαλώ εισάγετε μια τιμή για το url του avatar σας.","Please_enter_your_new_password_below":"Παρακαλώ εισάγετε το νέο κωδικό πρόσβασης:","Please_fill_a_label":"Παρακαλούμε συμπληρώστε μια ετικέτα","Please_fill_a_name":"Παρακαλούμε συμπληρώστε ένα όνομα","Please_fill_a_username":"Παρακαλούμε συμπληρώστε ένα όνομα χρήστη","Please_fill_name_and_email":"Παρακαλώ συμπληρώστε το όνομα και το email","Please_re_enter_your_password":"Παρακαλώ εισάγετε ξανά τον κωδικό πρόσβασής σας","Please_select_enabled_yes_or_no":"Παρακαλώ επιλέξτε μια επιλογή για Enabled","Please_wait":"Παρακαλούμε περιμένετε","Please_wait_activation":"Παρακαλούμε περιμένετε, αυτό μπορεί να πάρει λίγο χρόνο.","Please_wait_statistics":"Παρακαλούμε περιμένετε, τα στατιστικά παράγονται τώρα.","Please_wait_while_OTR_is_being_established":"Παρακαλώ περιμένετε ενώ OTR την καθιέρωσή","Please_wait_while_your_account_is_being_deleted":"Παρακαλώ περιμένετε ενώ ο λογαριασμός σας διαγράφεται ...","Please_wait_while_your_profile_is_being_saved":"Παρακαλώ περιμένετε ενώ το προφίλ σας αποθηκεύεται ...","Post_as":"Δημοσίευση ως","Post_to_Channel":"Αξιολογήστε στο κανάλι","Post_to_s_as_s":"Δημοσίευση <strong>στο %s</strong> <strong>ως %s</strong>","Powered_by":"Powered by","Preferences":"προτιμήσεις","Preferences_saved":"προτιμήσεις αποθηκεύονται","Privacy":"Ιδιωτικότητα","Private_Group":"ιδιωτική Ομάδα","Private_Groups":"Κλειστές Ομάδες","Private_Groups_list":"Λίστα των ιδιωτικών ομίλων","Profile":"Προφίλ","Profile_saved_successfully":"Το προφίλ αποθηκεύτηκε με επιτυχία","Proudly_developed":"Αναπτύχθηκε με Meteor","Push":"Σπρώξτε","Push_apn_cert":"APN Πιστοποιητικό","Push_apn_dev_cert":"APN Dev Πιστοποιητικό","Push_apn_dev_key":"APN Dev Κλειδί","Push_apn_dev_passphrase":"APN Dev Συνθηματικό","Push_apn_key":"APN Κλειδί","Push_apn_passphrase":"APN Συνθηματικό","Push_debug":"Αποσφαλμάτωση","push_disabled":"Σπρώξτε με ειδικές ανάγκες","Push_enable":"Ενεργοποίηση","Push_enable_gateway":"Ενεργοποίηση Πύλη","Push_gateway":"πύλη","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Αριθμός Έργου","Push_production":"Παραγωγή","Push_show_message":"Εμφάνιση μηνύματος στην κοινοποίηση","Push_show_username_room":"Εμφάνιση καναλιού / ομάδα / ψευδώνυμο στην κοινοποίηση","Push_test_push":"Δοκιμή","Query":"Ερώτηση","Query_description":"Πρόσθετες προϋποθέσεις για τον προσδιορισμό των χρηστών για να στείλετε το e-mail στο. Τα αδιάθετα χρήστες αφαιρούνται αυτόματα από το ερώτημα. Πρέπει να είναι ένα έγκυρο JSON. Παράδειγμα: \"{\" createdAt \": {\" $ GT \": {\" ημερομηνία $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Γρήγορη Αναζήτηση","quote":"παράθεση","Reactions":"αντιδράσεις","Recents":"Πρόσφατα","Record":"Ρεκόρ","Redirect_URI":"ανακατεύθυνση URI","Refresh_keys":"Ανανέωση κλειδιά","Refresh_your_page_after_install_to_enable_screen_sharing":"Ανανεώστε τη σελίδα σας μετά την εγκατάσταση για να ενεργοποιήσετε την κοινή χρήση οθόνης","Register":"Εγγραφή νέου λογαριασμού","Registration_Succeeded":"Εγγραφή Επιτυχής","Remember_me":"Να με θυμάσαι","Remove":"Αφαίρεση","Remove_Admin":"Αφαίρεση Διαχειριστή","Remove_as_moderator":"Αφαιρέστε ως συντονιστής","Remove_as_owner":"Αφαιρέστε ως ιδιοκτήτης","Remove_custom_oauth":"Κατάργηση έθιμο OAuth","Remove_from_room":"Αφαιρέστε από το δωμάτιο","Remove_someone_from_room":"Αφαιρέστε κάποιος από το δωμάτιο","Removed":"αφαιρέθηκε","Require_password_change":"Απαιτούν αλλαγή του κωδικού πρόσβασης","Resend_verification_email":"Επαναποστολή μηνύματος επιβεβαίωσης","Reset":"Επαναφορά","Reset_password":"Επαναφορά κωδικού","Restart":"Επανεκκίνηση","Restart_the_server":"Κάντε επανεκκίνηση του διακομιστή","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"Όνομα RocketBot","RocketBot_Name_Description":"Το όνομά RocketBot πρέπει να είναι ένα έγκυρο όνομα χρήστη καταχωρηθεί στο διακομιστή σας.","Role":"Ρόλος","Role_Editing":"ρόλος Επεξεργασία","Role_removed":"ρόλος αφαιρεθεί","Room":"Δωμάτιο","Room_archivation_state":"Κατάσταση","Room_archivation_state_false":"Ενεργός","Room_archivation_state_true":"Αρχειοθετημένα","Room_archived":"αρχειοθετούνται δωμάτιο","room_changed_privacy":"Τύπος δωματίου άλλαξε σε: <em>__room_type__</em> από <em>__user_by__</em>","room_changed_topic":"Θέμα δωμάτιο άλλαξε σε: <em>__room_topic__</em> από <em>__user_by__</em>","Room_has_been_deleted":"Δωμάτιο έχει διαγραφεί","Room_Info":"Πληροφορίες δωματίου","Room_name_changed":"Το όνομα του δωματίου άλλαξε σε: <em>__room_name__</em> από τον χρήστη <em>__user_by__</em>","Room_name_changed_successfully":"Το όνομα του δωματίου άλλαξε επιτυχώς","Room_not_found":"Δωμάτιο δεν βρέθηκε","Room_topic_changed_successfully":"θέμα δωμάτιο άλλαξε με επιτυχία","Room_type_changed_successfully":"Τύπος δωματίου άλλαξε με επιτυχία","Room_unarchived":"δωμάτιο αρχειοθετημένα","Room_uploaded_file_list":"Λίστα αρχείων","Room_uploaded_file_list_empty":"Δεν υπάρχουν διαθέσιμα αρχεία.","room_user_count":"%s χρήστες","Rooms":"Δωμάτια","S_new_messages_since_s":" %s νέα μηνύματα από το %s","SAML":"SAML","SAML_Custom_Cert":"Προσαρμοσμένη Πιστοποιητικό","SAML_Custom_Entry_point":"Προσαρμοσμένη Σημείο Εισόδου","SAML_Custom_Generate_Username":"Δημιουργήστε Όνομα Χρήστη","SAML_Custom_Issuer":"Προσαρμοσμένη Εκδότη","SAML_Custom_Provider":"Προσαρμοσμένη Provider","Save":"Αποθήκευση","Save_changes":"Αποθήκευση αλλαγών","Save_Mobile_Bandwidth":"Αποθήκευση Mobile Bandwidth","Save_to_enable_this_action":"Αποθήκευση για να ενεργοποιήσετε αυτήν την ενέργεια","Saved":"Αποθηκεύτηκε","Saving":"Οικονομία","Scope":"Έκταση","Screen_Share":"οθόνη Share","Script_Enabled":"script Enabled","Search":"Αναζήτηση","Search_by_username":"Αναζήτηση με το όνομα χρήστη","Search_Channels":"Αναζήτηση καναλιών","Search_Direct_Messages":"Απευθείας Μηνύματα","Search_Messages":"Αναζήτηση μηνυμάτων","Search_Private_Groups":"Αναζήτηση ιδιωτικούς ομίλους","Search_settings":"Ρυθμίσεις αναζήτησης","seconds":"δευτερόλεπτα","See_all":"Εμφάνιση όλων","See_only_online":"Μόνο online","Select_a_department":"Επιλέξτε ένα τμήμα","Select_an_avatar":"Επιλογή avatar","Select_file":"Επιλογή αρχείου","Select_service_to_login":"Επιλέξτε μια υπηρεσία να συνδεθείτε ώστε να φορτώσετε την εικόνα σας ή ανεβάστε μια απευθείας απ τον υπολογιστή σας.","Select_user":"Επιλέξτε χρήστη","Select_users":"Επιλέξτε τους χρήστες","Selected_agents":"επιλεγμένα πράκτορες","Selected_users":"Επιλεγμένα μέλη","Send":"Στέλνω","Send_a_message":"Στέλνω ένα μήνυμα","Send_a_test_mail_to_my_user":"Στείλτε ένα δοκιμαστικό μήνυμα στο χρήστη μου","Send_a_test_push_to_my_user":"Στείλτε ένα δοκιμαστικό ώθηση στο χρήστη μου","Send_confirmation_email":"Αποστολή email επιβεβαίωσης","Send_data_into_RocketChat_in_realtime":"Αποστολή δεδομένων σε Rocket.Chat σε πραγματικό χρόνο.","Send_email":"Να στείλετε e-mail","Send_invitation_email":"Αποστολή email πρόσκλησης","Send_invitation_email_error":"Δεν έχουν δώσει καμία έγκυρη διεύθυνση ηλεκτρονικού ταχυδρομείου.","Send_invitation_email_info":"Μπορείτε να στείλετε πολλές προσκλήσεις ηλεκτρονικού ταχυδρομείου ταυτόχρονα.","Send_invitation_email_success":"Έχετε στείλει με επιτυχία ένα email πρόσκληση στις ακόλουθες διευθύνσεις:","Send_invitation_email_warning":"Για να στείλετε μηνύματα ηλεκτρονικού ταχυδρομείου πρόσκληση, θα πρέπει πρώτα να διαμορφώσετε τις ρυθμίσεις SMTP.","Send_Message":"Αποστολή Μηνύματος","Send_your_JSON_payloads_to_this_URL":"Αποστολή ωφέλιμα φορτία JSON σας σε αυτή τη διεύθυνση URL.","Sending":"Αποστολή ...","Set_as_moderator":"Ορισμός ως συντονιστής","Set_as_owner":"Ορισμός ως ιδιοκτήτης","Settings":"Ρυθμίσεις","Settings_updated":"Οι ρυθμίσεις ενημερώθηκαν","Should_be_a_URL_of_an_image":"Πρέπει να είναι μια διεύθυνση URL μιας εικόνας.","Should_exists_a_user_with_this_username":"Ο χρήστης πρέπει να υπάρχει ήδη.","Show_all":"Προβολή όλων","Show_more":"Δείτε περισσότερα","Show_only_online":"Εμφάνιση μόνο online","Show_preregistration_form":"Εμφάνιση φόρμα προ-εγγραφής","Showing_archived_results":"<p> Εμφάνιση αρχειοθετημένα <b>αποτελέσματα %s</b> </p>","Showing_online_users":"Εμφανίζονται <b>__total_showing__</b> από __total__ users","Showing_results":"<p>Εμφανιζονται <b>%s</b> αποτελεσματα</p>","Silence":"Ησυχία","since_creation":"από %s","Site_Name":"Όνομα ιστοσελίδας","Site_Url":"URL Ιστοσελίδας","Site_Url_Description":"Παράδειγμα: https://chat.domain.com/","Skip":"Παραλείπω","Smileys_and_People":"Smileys & Άνθρωποι","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP Κωδικός","SMTP_Port":"SMTP Θύρα","SMTP_Test_Button":"Ρυθμίσεις δοκιμή SMTP","SMTP_Username":"SMTP Όνομα χρήστη","Sound":"Ήχος","Star_Message":"αστέρι μηνύματος","Starred_Messages":"αστέρι Μηνύματα","Start_audio_call":"Ξεκινήστε την κλήση ήχου","Start_Chat":"Έναρξη συνομιλίας","Start_of_conversation":"Αρχή της συνομιλίας","Start_OTR":"έναρξη OTR","Start_video_call":"Ξεκινήστε την κλήση βίντεο","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Ξεκινήστε με <code class=\"inline\">%s</code> για το χρήστη ή <code class=\"inline\">%s</code> για το κανάλι. Π.χ: <code class=\"inline\">%s</code> ή <code class=\"inline\">%s</code>","Statistics":"Στατιστική","Stats_Active_Users":"Ενεργοί χρήστες","Stats_Avg_Channel_Users":"Μέσος όρος χρηστών καναλιού","Stats_Avg_Private_Group_Users":"Μέσος όρος χρηστών κλειστής ομάδας","Stats_Away_Users":"μακριά χρήστες","Stats_Max_Room_Users":"Μέγιστοι Χρήστες Δωματίων","Stats_Non_Active_Users":"Ανενεργοί χρήστες","Stats_Offline_Users":"Αποσυνδεδεμένοι Χρήστες","Stats_Online_Users":"Συνδεδεμένοι Χρήστες","Stats_Total_Channels":"Συνολικά Κανάλια","Stats_Total_Direct_Messages":"Συνολικά άμεσα μηνύματα","Stats_Total_Messages":"Σύνολο μηνυμάτων","Stats_Total_Private_Groups":"Συνολικές κλειστές ομάδες","Stats_Total_Rooms":"Συνολικά Δωμάτια","Stats_Total_Users":"Συνολικοί χρήστες","Stop_Recording":"Διακοπή εγγραφής","strike":"σβήσιμο","Subject":"Θέμα","Submit":"Υποβολή","Success":"Επιτυχία","Survey":"Έρευνα","Survey_instructions":"Βαθμολογήστε κάθε ερώτηση, σύμφωνα με την ικανοποίησή σας, 1 που σημαίνει ότι θα είναι εντελώς ανικανοποίητοι και 5 σημαίνει ότι είστε απόλυτα ικανοποιημένοι.","Symbols":"σύμβολα","Sync_success":"Συγχρονισμός επιτυχία","Sync_Users":"Συγχρονισμός χρήστες","Test_Connection":"δοκιμή σύνδεσης","Test_Desktop_Notifications":"Δοκιμή Desktop Ειδοποιήσεις","Thank_you_for_your_feedback":"Ευχαριστούμε για την ανταπόκρισή σας","The_application_name_is_required":"Το όνομα της εφαρμογής απαιτείται","The_channel_name_is_required":"Το όνομα του καναλιού απαιτείται","The_emails_are_being_sent":"Τα μηνύματα ηλεκτρονικού ταχυδρομείου που αποστέλλονται.","The_field_is_required":"Το πεδίο %s απαιτείται.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Το μέγεθος της εικόνας δεν θα λειτουργήσει, επειδή δεν μπορεί να ανιχνεύσει ImageMagick ή GraphicsMagick εγκατεστημένο στον server σας.","The_redirectUri_is_required":"Η redirectUri απαιτείται","The_server_will_restart_in_s_seconds":"Ο διακομιστής θα κάνει επανεκκίνηση στο %s δευτερόλεπτα","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Η <strong>ρύθμιση %s</strong> έχει ρυθμιστεί <strong>στο %s</strong> και έχετε πρόσβαση <strong>από %s!</strong>","The_user_will_be_removed_from_s":"Ο χρήστης θα πρέπει να αφαιρεθεί από %s","The_user_wont_be_able_to_type_in_s":"Ο χρήστης δεν θα είναι σε θέση να πληκτρολογήσετε %s","Theme":"Θέμα","theme-color-action-buttons-color":"Δράσεις Κουμπιά Χρώμα","theme-color-active-channel-background-color":"Ενεργό κανάλι Χρώμα φόντου","theme-color-active-channel-font-color":"Ενεργό κανάλι Χρώμα γραμματοσειράς","theme-color-blockquote-background":"Blockquote Χρώμα φόντου","theme-color-clean-buttons-color":"Καθαρίστε Κουμπιά Χρώμα","theme-color-code-background":"Κωδικός Χρώμα φόντου","theme-color-code-border":"Κώδικα συνόρων του χρώματος","theme-color-code-color":"Κωδικός χρώμα","theme-color-content-background-color":"Περιεχόμενο Χρώμα φόντου","theme-color-custom-scrollbar-color":"Έθιμο κύλισης Χρώμα","theme-color-info-active-font-color":"Ενεργό Πληροφορίες Χρώμα γραμματοσειράς","theme-color-info-font-color":"Πληροφορίες Χρώμα γραμματοσειράς","theme-color-input-font-color":"Εισόδου Χρώμα γραμματοσειράς","theme-color-link-font-color":"Σύνδεσμος Χρώμα γραμματοσειράς","theme-color-message-hover-background-color":"Μήνυμα Hover BG Χρώμα","theme-color-primary-background-color":"Πρωτοβάθμια Χρώμα φόντου","theme-color-primary-font-color":"Πρωτοβάθμια Χρώμα γραμματοσειράς","theme-color-quaternary-font-color":"Τεταρτοταγούς Χρώμα γραμματοσειράς","theme-color-secondary-background-color":"Δευτεροβάθμιο χρώμα φόντου","theme-color-secondary-font-color":"Δευτεροβάθμια Χρώμα γραμματοσειράς","theme-color-smallprint-font-color":"Μικρές Εκτύπωση Χρώμα γραμματοσειράς","theme-color-smallprint-hover-color":"Μικρές Εκτύπωση Hover Χρώμα","theme-color-status-away":"Μακριά Χρώμα Κατάσταση","theme-color-status-busy":"Απασχολημένος Χρώμα Κατάσταση","theme-color-status-offline":"Offline Χρώμα Κατάσταση","theme-color-status-online":"Σε απευθείας σύνδεση Χρώμα Κατάσταση","theme-color-tertiary-background-color":"Τριτοβάθμια χρώμα φόντου","theme-color-tertiary-font-color":"Τριτοβάθμια χρώμα γραμματοσειράς","theme-color-unread-notification-color":"Αδιάβαστη Ειδοποιήσεις Χρώμα","theme-custom-css":"έθιμο CSS","There_are_no_agents_added_to_this_department_yet":"Δεν υπάρχουν παράγοντες που προστίθενται σε αυτό το τμήμα ακόμα.","There_are_no_integrations":"Δεν υπάρχουν ολοκληρώσεις","There_are_no_users_in_this_role":"Δεν υπάρχουν χρήστες σε αυτόν τον ρόλο.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Αυτό το ηλεκτρονικό μήνυμα έχει ήδη χρησιμοποιηθεί και δεν έχει επαληθευτεί. Παρακαλείστε να αλλάξετε τον κωδικό πρόσβασής σας.","This_is_a_desktop_notification":"Αυτή είναι μια ειδοποίηση στην επιφάνεια εργασίας","This_is_a_push_test_messsage":"Αυτή είναι μια δοκιμή ώθησης messsage","Time_in_seconds":"Χρόνος σε δευτερόλεπτα","Title_bar_color":"χρώμα τίτλο μπαρ","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Για να εγκαταστήσετε Rocket.Chat Livechat στην ιστοσελίδα σας, αντιγράψτε και επικολλήστε αυτόν τον κώδικα πάνω από την τελευταία <strong></ body></strong> στον ιστότοπό σας.","To_users":"Για χρήστες","Topic":"Θέμα","Travel_and_Places":"Ταξίδια & Μέρη","Trigger_removed":"σκανδάλη αφαιρεθεί","Trigger_Words":"Λέξεις σκανδάλη","Triggers":"εναύσματα","True":"Αληθής","Type":"Τύπος","Type_your_new_password":"Πληκτρολογήστε τον νέο κωδικό πρόσβασής σας","Unarchive":"Κατάργηση αρχειοθέτησης","Unmute_someone_in_room":"Με μικρόφωνο κάποιος στο δωμάτιο","Unmute_user":"Με μικρόφωνο χρήστη","Unnamed":"Ανώνυμο","Unpin_Message":"Ξεκαρφίτσωμα μηνύματος","Unread_Rooms":"αδιάβαστη Δωμάτια","Unread_Rooms_Mode":"Αδιάβαστη Δωμάτια Λειτουργία","Unstar_Message":"Κατάργηση αστεριών","Upload_file_question":"Να ανέβει το αρχείο;","Uploading_file":"Μεταφόρτωση αρχείου ...","Use_account_preference":"Χρησιμοποιήστε τις προτιμήσεις λογαριασμού","Use_Emojis":"χρήση Emojis","Use_initials_avatar":"Χρήση των αρχικών του username σας","use_menu":"Χρησιμοποιήστε το πλευρικό μενου για πρόσβαση στα δωμάτια και τις συνομιλίες σας","Use_service_avatar":"Χρήση %s avatar","Use_this_username":"Χρήση αυτού του username","Use_uploaded_avatar":"Χρηση ανεβασμένου avatar","Use_url_for_avatar":"Χρησιμοποιήστε url για avatar","User__username__is_now_a_moderator_of__room_name_":"χρήστη __username__ χρήστης είναι πλέον επόπτης της __room_name__","User__username__is_now_a_owner_of__room_name_":"χρήστη __username__ χρήστης είναι τώρα ένας ιδιοκτήτης των __room_name__","User__username__removed_from__room_name__moderators":"χρήστη __username__ χρήστης απομακρύνεται από τους συντονιστές __room_name__","User__username__removed_from__room_name__owners":"χρήστη __username__ χρήστης απομακρύνεται από __room_name__ ιδιοκτήτες","User_added":"Ο χρήστης <em>__user_added__</em> πρστέθηκε.","User_added_by":"Ο χρήστης <em>__user_added__</em> πρστέθηκε από τον <em>__user_by__</em>.","User_added_successfully":"ο χρήστης πρόσθεσε επιτυχώς","User_Channels":"Κανάλια χρήστη","User_doesnt_exist":"Κανένας χρήστης δεν υπάρχει το όνομα του `@ %s`.","User_has_been_activated":"Ο χρήστης έχει ενεργοποιηθεί","User_has_been_deactivated":"Ο χρήστης έχει απενεργοποιηθεί","User_has_been_deleted":"Ο χρήστης έχει διαγραφεί","User_has_been_muted_in_s":"Ο χρήστης έχει σίγαση σε %s","User_has_been_removed_from_s":"Ο χρήστης έχει αφαιρεθεί από %s","User_has_disconnected":"Ο χρήστης έχει αποσυνδεθεί","User_Info":"Πληροφορίες για το χρήστη","User_is_no_longer_an_admin":"Ο χρήστης δεν είναι πλέον διαχειριστής","User_is_not_activated":"Ο χρήστης δεν έχει ενεργοποιηθεί","User_is_now_an_admin":"Ο χρήστης είναι πλέον διαχειριστής","User_joined_channel":"Μπήκε στο κανάλι.","User_joined_channel_female":"Μπήκε στο κανάλι.","User_joined_channel_male":"Μπήκε στο κανάλι.","User_left":"Ο χρήστης <em>__user_left__</em> αποχώρησε.","User_left_female":"Η χρήστης <em>__user_left__</em> αποχώρησε.","User_left_male":"Ο χρήστης <em>__user_left__</em> αποχώρησε.","User_logged_out":"Ο χρήστης έχει αποσυνδεθεί","User_management":"Διαχείριση χρηστών","User_muted_by":"<em>__user_muted__</em> Χρήστη σίγαση από <em>__user_by__.</em>","User_muted_in_room":"Χρήστη σίγαση στο δωμάτιο","User_not_found":"Ο χρήστης δεν βρέθηκε","User_not_found_or_incorrect_password":"Ο χρήστης δεν βρέθηκε ή εσφαλμένο κωδικό πρόσβασης","User_or_channel_name":"Χρήστης ή το κανάλι όνομα","User_removed":"αφαιρεθεί χρήστη","User_removed_by":"Ο χρήστης <em>__user_removed__</em> αφαιρέθηκε από τον <em>__user_by__</em>.","User_removed_from_room":"Ο χρήστης έχει απομακρυνθεί από την αίθουσα","User_Settings":"Ρυθμίσεις χρήστη","User_unmuted_by":"<em>__user_unmuted__</em> Χρήστης κατάργησε τη σίγαση από <em>__user_by__.</em>","User_unmuted_in_room":"Ο χρήστης κατάργηση σίγασης στο δωμάτιο","User_updated_successfully":"Ο χρήστης ενημερώθηκε επιτυχώς","Username":"Όνομα χρήστη","Username_and_message_must_not_be_empty":"Όνομα Χρήστη και το μήνυμα δεν πρέπει να είναι κενό.","Username_cant_be_empty":"Το όνομα χρήστη δε μπορεί να είναι κενό","Username_Change_Disabled":"Rocket.Chat διαχειριστής σας έχει απενεργοποιήσει την αλλαγή των ονομάτων χρήστη","Username_denied_the_OTR_session":"χρήστη __username__ αρνήθηκε τη συνεδρία OTR","Username_description":"Το όνομα χρήστη χρησιμοποιείται για να επιτρέπεται σε άλλους να σας αναφέρουν στα μηνύματα.","Username_doesnt_exist":"Το όνομα χρήστη ` %s` δεν υπάρχει.","Username_ended_the_OTR_session":"χρήστη __username__ έληξε η συνεδρίαση OTR","Username_invalid":"<strong>%s</strong> δεν είναι έγκυρο όνομα χρήστη,<br/> χρησιμοποιείστε μόνο γράμματα, αριθμούς, τελείες και παύλες","Username_is_already_in_here":"`@ %s` είναι ήδη εδώ.","Username_is_not_in_this_room":"Ο χρήστης `# %s` δεν είναι σε αυτό το δωμάτιο.","Username_not_found":"Όνομα Χρήστη δεν βρέθηκε","Username_title":"Εγγραφή ονόματος χρήστη","Username_unavaliable":"<strong>%s</strong> χρησιμοποιείται ήδη :(","Username_wants_to_start_otr_Do_you_want_to_accept":"χρήστη __username__ θέλει να ξεκινήσει OTR. Θέλετε να δεχτεί;","Users":"χρήστες","Users_in_role":"Χρήστες σε ρόλο","UTF8_Names_Slugify":"UTF8 Ονόματα Slugify","UTF8_Names_Validation":"UTF8 Ονόματα Επικύρωση","UTF8_Names_Validation_Description":"Μην αφήνετε ειδικούς χαρακτήρες και κενά. Μπορείτε να χρησιμοποιήσετε - _ και. αλλά όχι στο τέλος του ονόματος","Verification_email_sent":"ηλεκτρονικού ταχυδρομείου επαλήθευσης εστάλη","View_All":"Εμφάνιση όλων","View_Logs":"Δείτε τα αρχεία καταγραφών","Visibility":"Ορατότητα","Visible":"Ορατός","Visitor":"Επισκέπτης","Visitor_page_URL":"Διεύθυνση URL της σελίδας επισκέπτης","Visitor_time_on_site":"επισκέπτη φορά στην ιστοσελίδα","Wait_activation_warning":"Για να μπορέσετε να συνδεθείτε, ο λογαριασμός σας θα πρέπει να ενεργοποιηθεί χειροκίνητα από κάποιον διαχειριστή.","We_are_offline_Sorry_for_the_inconvenience":"Είμαστε εκτός σύνδεσης. Συγγνώμη για την ταλαιπωρία.","We_have_sent_password_email":"Σας έχουμε αποστείλει email με οδηγίες επαναφοράς κωδικού. Εαν δεν λάβετε email σύντομα, παρακαλούμε επιστρέψτε και δοκιμάστε ξανά.","We_have_sent_registration_email":"Σας έχουμε αποστείλει email για επιβεβαίωση εγγραφής.  Εαν δεν λάβετε email σύντομα, παρακαλούμε επιστρέψτε και δοκιμάστε ξανά.","WebRTC_Enable_Channel":"Ενεργοποίηση για τη Δημόσια Κανάλια","WebRTC_Enable_Direct":"Ενεργοποίηση Άμεσων Μηνυμάτων","WebRTC_Enable_Private":"Ενεργοποίηση για Ιδιωτικά Κανάλια","WebRTC_Servers":"STUN / TURN Servers","WebRTC_Servers_Description":"Μια λίστα των STUN και TURN servers χωρίζονται με κόμμα. <br/> Όνομα, κωδικό και το λιμάνι επιτρέπεται σε μορφή `username: password @ αναισθητοποίησης: host: port` ή` username: password @ στροφή: υποδοχής: port`.","Welcome":"Καλως ήλθατε <em>%s</em>.","Welcome_to_the":"Καλως ήλθατε στο","will_be_able_to":"θα είναι σε θέση να","With_whom":"Με ποιον","Yes":"Ναί","Yes_clear_all":"Ναι, σαφή όλα!","Yes_delete_it":"Ναι, διέγραψέ το!","Yes_hide_it":"Ναι, να το κρύψει!","Yes_leave_it":"Ναι, αφήστε το!","Yes_mute_user":"Ναι, σίγαση του χρήστη!","Yes_remove_user":"Ναι, να καταργηθεί το χρήστη!","you_are_in_preview_mode_of":"Είστε σε κατάσταση προεπισκόπησης του καναλιού #<strong>__room_name__</strong>","You_are_logged_in_as":"Έχετε συνδεθεί ως","You_are_not_authorized_to_view_this_page":"Δεν έχετε δικαίωμα να δείτε αυτή τη σελίδα.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Είστε ο τελευταίος ιδιοκτήτης. Παρακαλούμε να ορίσετε νέο ιδιοκτήτη πριν αποχωρήσει από την αίθουσα.","You_can_change_a_different_avatar_too":"Μπορείτε να παρακάμψετε το avatar που χρησιμοποιείται για να δημοσιεύσετε από αυτή την ένταξη.","You_can_use_an_emoji_as_avatar":"Μπορείτε επίσης να χρησιμοποιήσετε ένα emoji ως avatar.","You_have_been_muted":"Έχετε σίγαση και δεν μπορεί να μιλήσει σε αυτό το δωμάτιο","You_have_not_verified_your_email":"Δεν έχετε επιβεβαιώσει το email σας.","You_have_successfully_unsubscribed":"Έχετε καταργήσει την εγγραφή σας με επιτυχία από το Ηλεκτρονικό ταχυδρομείο λίστα μας.","You_informed_an_invalid_FROM_address":"Μπορείτε ενημερωθείτε μια μη έγκυρη διεύθυνση Από.","You_must_provide_the_unsubscribe_link":"Πρέπει να δώσετε το σύνδεσμο [unsubscribe].","You_need_confirm_email":"Πρεπει να επιβεβαίώσετε το email σας για να συνδεθείτε!","You_need_install_an_extension_to_allow_screen_sharing":"Χρειάζεται να εγκαταστήσετε μια επέκταση για να επιτρέπει την κοινή χρήση οθόνης","You_need_to_change_your_password":"Θα πρέπει να αλλάξετε τον κωδικό πρόσβασής σας","You_need_to_type_in_your_password_in_order_to_do_this":"Θα πρέπει να πληκτρολογήσετε τον κωδικό πρόσβασης σας για να το κάνετε αυτό!","You_need_to_type_in_your_username_in_order_to_do_this":"Θα πρέπει να πληκτρολογήσετε το όνομα χρήστη σας για να το κάνετε αυτό!","You_need_to_verifiy_your_email_address_to_get_notications":"Θα πρέπει να εξακριβωθεί το email σας για να λαμβάνετε ειδοποιήσεις","You_should_name_it_to_easily_manage_your_integrations":"Θα πρέπει να αναφέρουμε ότι για να διαχειριστείτε εύκολα την ολοκληρώσεις σας.","You_will_not_be_able_to_recover":"Δεν θα μπορείτε να το επαναφέρετε!","You_will_not_be_able_to_recover_file":"Δεν θα είστε σε θέση να ανακτήσει αυτό το αρχείο!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Δεν θα λαμβάνετε ειδοποιήσεις ηλεκτρονικού ταχυδρομείου, επειδή δεν έχετε επαληθεύσει το email σας.","Your_email_has_been_queued_for_sending":"Το email σας έχει στην ουρά για την αποστολή","Your_entry_has_been_deleted":"Η καταχώρησή σας έχει διαγραφεί.","Your_file_has_been_deleted":"Το αρχείο σας έχει διαγραφεί.","Your_mail_was_sent_to_s":"mail σας στάλθηκε στο %s","Your_Open_Source_solution":"Η δικιά σου λύση ανοιχτού κώδικα","Your_password_is_wrong":"Ο κωδικός πρόσβασής σας είναι λάθος!","Your_push_was_sent_to_s_devices":"ώθηση σας στάλθηκε σε συσκευές %s"});
TAPi18n._registerServerTranslator("el", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/en.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
// integrate the fallback language translations                                                                        // 8
translations = {};                                                                                                     // 9
translations[namespace] = {"500":"Internal Server Error","0_Errors_Only":"0 - Errors Only","1_Errors_and_Information":"1 - Errors and Information","2_Erros_Information_and_Debug":"2 - Erros, Information and Debug","__username__was_set__role__by__user_by_":"__username__ was set __role__ by __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ is no longer __role__, by __user_by__","Access_not_authorized":"Access not authorized","Access_online_demo":"Access the online demo","Access_Online_Demo":"Access the Online Demo","Access_Token_URL":"Access Token URL","Accounts":"Accounts","Accounts_AllowDeleteOwnAccount":"Allow users to delete own account","Accounts_AllowedDomainsList":"Allowed Domains List","Accounts_AllowedDomainsList_Description":"Comma-separated list of allowed domains","Accounts_AllowEmailChange":"Allow E-mail Change","Accounts_AllowPasswordChange":"Allow Password Change","Accounts_AllowUserAvatarChange":"Allow User Avatar Change","Accounts_AllowUsernameChange":"Allow Username Change","Accounts_AllowUserProfileChange":"Allow User Profile Change","Accounts_AvatarResize":"Resize Avatars","Accounts_AvatarSize":"Avatar Size","Accounts_AvatarStorePath":"Avatar Storage Path","Accounts_AvatarStoreType":"Avatar Storage Type","Accounts_BlockedDomainsList":"Blocked Domains List","Accounts_BlockedDomainsList_Description":"Comma-separated list of blocked domains","Accounts_denyUnverifiedEmail":"Deny unverified email","Accounts_EmailVerification":"E-mail Verification","Accounts_EmailVerification_Description":"Make sure you have correct SMTP settings to use this feature","Accounts_Enrollment_Email":"Enrollment E-mail","Accounts_Enrollment_Email_Description":"You may use [name], [fname], [lname] for the user's full name, first name or last name, respectively.<br />You may use [email] for the user's email.","Accounts_Iframe_api_method":"Api Method","Accounts_Iframe_api_url":"API URL","Accounts_iframe_enabled":"Enabled","Accounts_iframe_url":"Iframe Url","Accounts_LoginExpiration":"Login Expiration in Days","Accounts_ManuallyApproveNewUsers":"Manually Approve New Users","Accounts_OAuth_Custom_Token_Sent_Via":"Token Sent Via","Accounts_OAuth_Custom_Authorize_Path":"Authorize Path","Accounts_OAuth_Custom_Button_Color":"Button Color","Accounts_OAuth_Custom_Button_Label_Color":"Button Text Color","Accounts_OAuth_Custom_Button_Label_Text":"Button Text","Accounts_OAuth_Custom_Enable":"Enable","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity Path","Accounts_OAuth_Custom_Login_Style":"Login Style","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Login","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Enabled","Accounts_OAuth_Github_callback_url":"Github Callback URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise Callback URL","Accounts_OAuth_GitHub_Enterprise_id":"Client Id","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Client Id","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab Callback URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google Login","Accounts_OAuth_Google_callback_url":"Google Callback URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Login","Accounts_OAuth_Linkedin_callback_url":"Linkedin Callback URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Login","Accounts_OAuth_Meteor_callback_url":"Meteor Callback URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Login","Accounts_OAuth_Twitter_callback_url":"Twitter Callback URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"Wordpress Callback URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Password Reset","Accounts_Registration_AuthenticationServices_Enabled":"Registration with Authentication Services","Accounts_RegistrationForm":"Registration Form","Accounts_RegistrationForm_Disabled":"Disabled","Accounts_RegistrationForm_LinkReplacementText":"Registration Form Link Replacement Text","Accounts_RegistrationForm_Public":"Public","Accounts_RegistrationForm_Secret_URL":"Secret URL","Accounts_RegistrationForm_SecretURL":"Registration Form Secret URL","Accounts_RegistrationForm_SecretURL_Description":"You must provide a random string that will be added to your registration URL. Example: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Registration Required","Accounts_RequireNameForSignUp":"Require Name For Signup","Accounts_ShowFormLogin":"Show form-based Login","Accounts_UseDefaultBlockedDomainsList":"Use Default Blocked Domains List","Accounts_UseDNSDomainCheck":"Use DNS Domain Check","Activate":"Activate","Activity":"Activity","Add":"Add","Add_agent":"Add agent","Add_custom_oauth":"Add custom oauth","Add_manager":"Add manager","Add_Members":"Add Members","Add_User":"Add User","Add_user":"Add user","Add_users":"Add users","Additional_emails":"Additional E-mails","Additional_Feedback":"Additional Feedback","Administration":"Administration","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"After OAuth2 authentication, users will be redirected to this URL","Agent_added":"Agent added","Agent_removed":"Agent removed","Alias":"Alias","All":"All","All_channels":"All channels","All_logs":"All logs","All_messages":"All messages","Allow_Invalid_SelfSigned_Certs":"Allow Invalid Self-Signed Certs","Allow_Invalid_SelfSigned_Certs_Description":"Allow invalid and self-signed SSL certificate's for link validation and previews.","and":"and","And_more":"And more __length__...","Animals_and_Nature":"Animals & Nature","API":"API","API_Analytics":"Analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Disable Embed for Users","API_EmbedDisabledFor_Description":"Comma-separated list of usernames","API_GitHub_Enterprise_URL":"Server URL","API_GitHub_Enterprise_URL_Description":"Example: http://domain.com (excluding trailing slash)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Appearance","Application_added":"Application added","Application_Name":"Application Name","Application_updated":"Application updated","Apply_and_refresh_all_clients":"Apply and refresh all clients","Archive":"Archive","Archive_Unarchive":"Archive / Unarchive","are_also_typing":"are also typing","are_typing":"are typing","Are_you_sure":"Are you sure?","Are_you_sure_you_want_to_delete_your_account":"Are you sure you want to delete your account?","Authorization_URL":"Authorization URL","Authorize":"Authorize","AutoLinker_StripPrefix":"AutoLinker Strip Prefix","AutoLinker_StripPrefix_Description":"Short display. e.g. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Automatically linked for Phone numbers. e.g. `(123)456-7890`","Auto_Load_Images":"Auto Load Images","Available":"Available","Available_agents":"Available agents","Avatar":"Avatar","Avatar_changed_successfully":"Avatar changed successfully","Avatar_URL":"Avatar URL","Avatar_url_invalid_or_error":"The url provided is invalid or not accessible. Please try again, but with a different url.","away":"away","Away":"Away","away_female":"away","Away_female":"Away","away_male":"away","Away_male":"Away","Back":"Back","Back_to_applications":"Back to applications","Back_to_integrations":"Back to integrations","Back_to_login":"Back to login","Back_to_permissions":"Back to permissions","Body":"Body","bold":"bold","busy":"busy","Busy":"Busy","busy_female":"busy","Busy_female":"Busy","busy_male":"busy","Busy_male":"Busy","Cancel":"Cancel","Cannot_delete_a_protected_role":"Cannot delete a protected role","Cannot_delete_role_because_its_in_use":"Cannot delete role because it's in use","Cannot_invite_users_to_direct_rooms":"Cannot invite users to direct rooms","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certificates and Keys","Channel":"Channel","Channel_doesnt_exist":"The channel `#%s` does not exist.","Channels":"Channels","Channels_list":"List of public channels","Chat_Rooms":"Chat Rooms","Chatops_Enabled":"Enable Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Username","Choose_a_room":"Choose a room","Choose_messages":"Choose messages","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Choose the alias that will appear before the username in messages.","Choose_the_username_that_this_integration_will_post_as":"Choose the username that this integration will post as.","Clear_all_unreads_question":"Clear all unreads?","Client_ID":"Client ID","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Clients will refresh in a few seconds","close":"close","Closed":"Closed","Collapse_Embedded_Media_By_Default":"Collapse embedded media by default","coming_soon":"coming soon","Commands":"Commands","Compact_View":"Compact View","Confirm_password":"Confirm your password","Contact":"Contact","Conversation":"Conversation","Convert_Ascii_Emojis":"Convert ASCII to Emoji","Copied":"Copied","COPY_TO_CLIPBOARD":"COPY TO CLIPBOARD","Copy_to_clipboard":"Copy to clipboard","Count":"Count","Create":"Create","Create_new":"Create new","Created_at":"Created at","Created_at_s_by_s":"Created at <strong>%s</strong> by <strong>%s</strong>","Custom_Fields":"Custom Fields","Custom_oauth_helper":"When setting up your OAuth Provider, you'll have to inform a Callback URL. Use <pre>%s</pre> .","Custom_oauth_unique_name":"Custom oauth unique name","Custom_Script_Logged_In":"Custom Script for logged in users","Custom_Script_Logged_Out":"Custom Script for logged out users","Dashboard":"Dashboard","days":"days","Deactivate":"Deactivate","Debug_Level":"Debug Level","Default":"Default","Delete":"Delete","Delete_my_account":"Delete my account","Delete_Room_Warning":"Deleting a room will delete all messages posted within the room. This cannot be undone.","Delete_User_Warning":"Deleting a user will delete all messages from that user as well. This cannot be undone.","Deleted":"Deleted!","Department_not_found":"Department not found","Department_removed":"Department removed","Departments":"Departments","Description":"Description","Desktop":"Desktop","Desktop_Notification_Test":"Desktop Notification Test","Desktop_Notifications":"Desktop Notifications","Desktop_Notifications_Disabled":"Desktop Notifications are Disabled. Change your browser preferences if you need Notifications enabled.","Desktop_Notifications_Enabled":"Desktop Notifications are Enabled","Direct_message_someone":"Direct message someone","Direct_Messages":"Direct Messages","Direct_Messages_list":"Direct Messages","Disable_Favorite_Rooms":"Disable Favorites","Disable_New_Message_Notification":"Disable New Message Notification","Disable_New_Room_Notification":"Disable New Room Notification","Displays_action_text":"Displays action text","Do_you_want_to_change_to_s_question":"Do you want to change to <strong>%s</strong>?","Drop_to_upload_file":"Drop to upload file","Dry_run":"Dry run","Dry_run_description":"Will only send one email, to the same address as in From. The email must belong to a valid user.","Duplicate_archived_channel_name":"An archived Channel with name '%s' exists","Duplicate_archived_private_group_name":"An archived Private Group with name '%s' exists","Duplicate_private_group_name":"A Private Group with name '%s' exists","E-mail":"E-mail","Edit":"Edit","Edit_Custom_Field":"Edit Custom Field","Edit_Department":"Edit Department","edited":"edited","Email":"Email","Email_already_exists":"Email already exists","Email_body":"E-mail body","Email_Change_Disabled":"Your Rocket.Chat administrator has disabled the changing of email","Email_from":"From","Email_Notification_Mode":"Offline Email Notifications","Email_Notification_Mode_All":"Every Mention/DM","Email_Notification_Mode_Disabled":"Disabled","Email_or_username":"Email or username","Email_subject":"Subject","Email_verified":"Email verified","Emoji":"Emoji","Empty_title":"Empty title","Enable":"Enable","Enable_Desktop_Notifications":"Enable Desktop Notifications","Enabled":"Enabled","Encrypted_message":"Encrypted message","End_OTR":"End OTR","Enter_a_regex":"Enter a regex","Enter_a_room_name":"Enter a room name","Enter_a_username":"Enter a username","Enter_info":"Enter your information","Enter_name_here":"Enter name here","Enter_to":"Enter to","Error":"Error","error-cant-invite-for-direct-room":"Can't invite user to direct rooms","error-duplicate-channel-name":"A Channel with name '%s' exists","error-invalid-custom-field":"Invalid custom field","error-invalid-custom-field-name":"Invalid custom field name. Use only letters, numbers, hyphens and underscores.","error-invalid-password":"Invalid password","error-invalid-room":"Invalid room","error-invalid-room-name":"<strong>%s</strong> is not a valid room name,<br/> use only letters, numbers, hyphens and underscores","error-invalid-user":"Invalid user","error-invalid-username":"Invalid username","error-not-allowed":"Not allowed","error-not-authorized":"Not authorized","error-remove-last-owner":"This is the last owner. Please set a new owner before removing this one.","error-role-name-required":"Role name is required","error-user-not-in-room":"User is not in this room","Error_changing_password":"Error changing password","Error_sending_confirmation_email":"Error sending confirmation email","Error_too_many_requests":"Error, too many requests. Please slow down. You must wait %s seconds before trying again","Esc_to":"Esc to","Example_s":"Example: <code class=\"inline\">%s</code>","False":"False","Favorites":"Favorites","Field":"Field","Field_removed":"Field removed","File_exceeds_allowed_size_of_bytes":"File exceeds allowed size of __size__ bytes","FileUpload":"File Upload","FileUpload_Enabled":"File Uploads Enabled","FileUpload_File_Empty":"File empty","FileUpload_FileSystemPath":"System Path","FileUpload_MaxFileSize":"Maximum File Upload Size (in bytes)","FileUpload_MediaType_NotAccepted":"Media Types Not Accepted","FileUpload_MediaTypeWhiteList":"Accepted Media Types","FileUpload_MediaTypeWhiteListDescription":"Comma-separated list of media types. Leave it blank for accepting all media types.","FileUpload_ProtectFiles":"Protect uploaded files","FileUpload_ProtectFilesDescription":"Only authenticated users will have access","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket name","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN domain for downloads","FileUpload_S3_Region":"Region","FileUpload_Storage_Type":"Storage Type","Flags":"Flags","Follow_social_profiles":"Follow our social profiles, fork us on github and share your thoughts about the rocket.chat app on our trello board.","Food_and_Drink":"Food & Drink","For_your_security_you_must_re_enter_your_password_to_continue":"For your security, you must re-enter your password to continue","Force_SSL":"Force SSL","Force_SSL_Description":"*Caution!* _Force SSL_ should never be used with reverse proxy. If you have a reverse proxy, you should do the redirect THERE. This option exists for deployments like Heroku, that does not allow the redirect configuration at the reverse proxy.","Forgot_password":"Forgot your password","Fork_it_on_github":"Fork it on github","Frequently_Used":"Frequently Used","From":"From","From_Email":"From Email","From_email_is_required":"From email is required","From_email_warning":"<b>Warning</b>: The field <b>From</b> is subject to your mail server settings.","General":"General","Get_to_know_the_team":"Get to know the Rocket.Team","github_no_public_email":"You don't have any email as public email in your GitHub account","Give_a_unique_name_for_the_custom_oauth":"Give a unique name for the custom oauth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Give the application a name. This will be seen by your users.","Global":"Global","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Has more","Have_your_own_chat":"Have your own web chat. Developed with Meteor.com, the Rocket.Chat is a great solution for developers looking forward to build and evolve their own chat platform.","Header":"Header","Hidden":"Hidden","Hide_Group_Warning":"Are you sure you want to hide the group \"%s\"?","Hide_Private_Warning":"Are you sure you want to hide the discussion with \"%s\"?","Hide_room":"Hide room","Hide_Room_Warning":"Are you sure you want to hide the room \"%s\"?","Highlights":"Highlights","Highlights_How_To":"To be notified when someone mentions a word or phrase, add it here. You can separate words or phrases with commas. Highlight Words are not case sensitive.","Highlights_List":"Highlight words","History":"History","hours":"hours","How_friendly_was_the_chat_agent":"How friendly was the chat agent?","How_knowledgeable_was_the_chat_agent":"How knowledgeable was the chat agent?","How_responsive_was_the_chat_agent":"How responsive was the chat agent?","How_satisfied_were_you_with_this_chat":"How satisfied were you with this chat?","If_you_are_sure_type_in_your_password":"If you are sure type in your password:","If_you_are_sure_type_in_your_username":"If you are sure type in your username:","Importer_Archived":"Archived","Importer_done":"Importing complete!","Importer_finishing":"Finishing up the import.","Importer_From_Description":"Imports __from__'s data into Rocket.Chat.","Importer_import_cancelled":"Import cancelled.","Importer_import_failed":"An error occured while running the import.","Importer_importing_channels":"Importing the channels.","Importer_importing_messages":"Importing the messages.","Importer_importing_started":"Starting the import.","Importer_importing_users":"Importing the users.","Importer_not_defined_properly":"The importer was not defined correctly, it is missing the Import class.","Importer_not_in_progress":"The importer is currently not running.","Importer_Prepare_Restart_Import":"Restart Import","Importer_Prepare_Start_Import":"Start Importing","Importer_Prepare_Uncheck_Archived_Channels":"Uncheck Archived Channels","Importer_Prepare_Uncheck_Deleted_Users":"Uncheck Deleted Users","Importer_progress_error":"Failed to get the progress for the import.","Importer_setup_error":"An error occured while setting up the importer.","Incorrect_Password":"Incorrect Password","inline_code":"inline_code","Install_Extension":"Install Extension","Install_FxOs":"Install Rocket.Chat on your Firefox","Install_FxOs_done":"Great! You can now use Rocket.Chat via the icon on your homescreen. Have fun with Rocket.Chat!","Install_FxOs_error":"Sorry, that did not work as intended! The following error appeared:","Install_FxOs_follow_instructions":"Please confirm the app installation on your device (press \"Install\" when prompted).","Installation":"Installation","Integration_added":"Integration has been added","Integration_Incoming_WebHook":"Incoming WebHook Integration","Integration_New":"New Integration","Integration_Outgoing_WebHook":"Outgoing WebHook Integration","Integration_updated":"Integration has been updated","Integrations":"Integrations","Invalid_asset":"Invalid asset","Invalid_confirm_pass":"The password confirmation does not match password","Invalid_email":"The email entered is invalid","Invalid_Export_File":"The file uploaded isn't a valid %s export file.","Invalid_file_height":"Invalid file height","Invalid_file_type":"Invalid file type","Invalid_file_width":"Invalid file width","Invalid_Import_File_Type":"Invalid Import file type.","Invalid_name":"The name must not be empty","Invalid_notification_setting_s":"Invalid notification setting: %s","Invalid_pass":"The password must not be empty","Invalid_room_name":"<strong>%s</strong> is not a valid room name,<br/> use only letters, numbers, hyphens and underscores","Invalid_room_type":"<strong>%s</strong> is not a valid room type.","Invalid_Secret_URL":"Invalid Secret URL","Invalid_secret_URL_message":"The URL provided is invalid.","invisible":"invisible","Invisible":"Invisible","Invitation_HTML":"Invitation HTML","Invitation_Subject":"Invitation Subject","Invite_user_to_join_channel":"Invite one user to join this channel","Invite_Users":"Invite Users","is_also_typing":"is also typing","is_also_typing_female":"is also typing","is_also_typing_male":"is also typing","is_typing":"is typing","is_typing_female":"is typing","is_typing_male":"is typing","italics":"italics","join":"Join","Join_audio_call":"Join audio call","Join_the_Community":"Join the Community","Join_the_given_channel":"Join the given channel","Join_video_call":"Join video call","Joined":"Joined","Jump":"Jump","Jump_to_first_unread":"Jump to first unread","Jump_to_message":"Jump to message","Jump_to_recent_messages":"Jump to recent messages","Katex_Enabled":"Katex Enabled","Label":"Label","Language":"Language","Language_Version":"English Version","Last_login":"Last login","Last_message":"Last message","Last_seen":"Last seen","Layout":"Layout","Layout_Home_Body":"Home Body","Layout_Home_Title":"Home Title","Layout_Login_Terms":"Login Terms","Layout_Privacy_Policy":"Privacy Policy","Layout_Sidenav_Footer":"Side Navigation Footer","Layout_Sidenav_Footer_description":"Footer size is 260 x 70px","Layout_Terms_of_Service":"Terms of Service","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Search","LDAP_Custom_Domain_Search_Description":"A piece of JSON that governs bind and connection info and is of the form:<br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"LDAP is a hierarchical database that many companies use to provide single sign on - a facility for sharing one password between multiple sites and services. For advanced configuration information and examples, please consult our wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Domain Base","LDAP_Domain_Base_Description":"The fully qualified Distinguished Name (DN) of an LDAP subtree you want to search for users and groups. You can add as many as you like; however, each group must be defined in the same domain base as the users that belong to it. If you specify restricted user groups, only users that belong to those groups will be in scope. We recommend that you specify the top level of your LDAP directory tree as your domain base and use search filter to control access.","LDAP_Domain_Search_Filter":"Domain Search Filter","LDAP_Domain_Search_Filter_Description":"If specified, only users that match this filter will be allowed to log in. If no filter is specified, all users within the scope of the specified domain base will be able to sign in.<br/>E.g. for Active Directory `memberOf=cn=ROCKET_CHAT,ou=General Groups`.<br/>E.g. for OpenLDAP (extensible match search) `ou:dn:=ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Category","LDAP_Domain_Search_Object_Category_Description":"The *objectCategory* that identify your users.<br/>Leave empty for *OpenLDAP*.<br/>E.g. `person`, etc.","LDAP_Domain_Search_Object_Class":"Domain Search Object Class","LDAP_Domain_Search_Object_Class_Description":"The *objectclass* that identify your users. <br/>E.g. `organizationalPerson`, `user`, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Domain Search Password","LDAP_Domain_Search_Password_Description":"The password for the domain search user.","LDAP_Domain_Search_User":"Domain Search User","LDAP_Domain_Search_User_Description":"The LDAP user that performs user lookups to authenticate other users when they sign in. <br/>This is typically a service account created specifically for third-party integrations. Use a fully qualified name, such as `cn=Administrator,cn=Users,dc=Example,dc=com`.","LDAP_Domain_Search_User_ID":"Domain Search User ID","LDAP_Domain_Search_User_ID_Description":"The LDAP attribute that identifies the LDAP user who attempts authentication. This field should be `sAMAccountName` for most Active Directory installations, but it may be `uid` for other LDAP solutions, such as OpenLDAP. You can use `mail` to identify users by email or whatever attribute you want.<br>You can use multiple values separated by comma to allow users to login using multiple identifiers like username or email.","LDAP_Enable":"Enable","LDAP_Enable_Description":"Attempt to utilize LDAP for authentication.","LDAP_Encryption":"Encryption","LDAP_Encryption_Description":"The encryption method used to secure communications to the LDAP server. Examples include `plain` (no encryption), `SSL/LDAPS` (encrypted from the start), and `StartTLS` (upgrade to encrypted communication once connected).","LDAP_Host":"Host","LDAP_Host_Description":"The LDAP host, e.g. `ldap.example.com` or `10.0.0.30`.","LDAP_Port":"Port","LDAP_Port_Description":"Port to access LDAP. eg: `389` or `636` for LDAPS","LDAP_Reject_Unauthorized":"Reject Unauthorized","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"Sync Data","LDAP_Sync_User_Data_Description":"Keep user data in sync with server on login (eg: name, email).","LDAP_Sync_User_Data_FieldMap":"User Data Field Map","LDAP_Sync_User_Data_FieldMap_Description":"Configure how user account fields (like email) are populated from a record in LDAP (once found). <br/>As an example, `{\"cn\":\"name\", \"mail\":\"email\"}` will choose a person's human readable name from the cn attribute, and their email from the mail attribute.<br/> Available fields include `name`, and `email`.","LDAP_Sync_Users":"Sync Users","LDAP_Test_Connection":"Test Connection","LDAP_Unique_Identifier_Field":"Unique Identifier Field","LDAP_Unique_Identifier_Field_Description":"Which field will be used to link the LDAP user and the Rocket.Chat user. You can inform multiple values separated by comma to try to get the value from LDAP record.<br/>Default value is `objectGUID,ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber`","LDAP_Use_Custom_Domain_Search":"Use Custom Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Write your own filter to search users in the LDAP server.","LDAP_Username_Field":"Username Field","LDAP_Username_Field_Description":"Which field will be used as *username* for new users. Leave empty to use the username informed on login page.<br/>You can use template tags too, like `#{givenName}.#{sn}`.<br/>Default value is `sAMAccountName`.","Leave_Group_Warning":"Are you sure you want to leave the group \"%s\"?","Leave_Private_Warning":"Are you sure you want to leave the discussion with \"%s\"?","Leave_room":"Leave room","Leave_Room_Warning":"Are you sure you want to leave the room \"%s\"?","line":"line","List_of_Direct_Messages":"List of Direct Messages","Live_sessions":"Live sessions","Livechat_agents":"Livechat agents","Livechat_Dashboard":"Livechat Dashboard","Livechat_enabled":"Livechat enabled","Livechat_Manager":"Livechat Manager","Livechat_managers":"Livechat managers","Livechat_title":"Livechat Title","Livechat_title_color":"Livechat Title Background Color","Livechat_Users":"Livechat Users","Load_more":"Load more","Loading...":"Loading...","Loading_more_from_history":"Loading more from history","Loading_suggestion":"Loading suggestions...","Localization":"Localization","Log_File":"Show File and Line","Log_Level":"Log Level","Log_Package":"Show Package","Log_View_Limit":"Log View Limit","Logged_out_of_other_clients_successfully":"Logged out of other clients successfully","Login":"Login","Login_with":"Login with %s","login_with":"Or login directly with","Logout":"Logout","Logout_Others":"Logout From Other Logged In Locations","Mail_Message_Invalid_emails":"You have provided one or more invalid emails: %s","Mail_Message_Missing_to":"You must select one or more users or provide one or more email addresses, separated by commas.","Mail_Message_No_messages_selected_select_all":"You haven't selected any messages. Would you like to <a href='#' class='select-all'>select all</a> visible messages?","Mail_Messages":"Mail Messages","Mail_Messages_Instructions":"Choose which messages you want to send via email by clicking the messages","Mail_Messages_Subject":"Here's a selected portion of %s messages","Mailer":"Mailer","Mailer_body_tags":"You <b>must</b> use [unsubscribe] for the unsubscription link.<br />You may use [name], [fname], [lname] for the user's full name, first name or last name, respectively.<br />You may use [email] for the user's email.","Make_Admin":"Make Admin","Manager_added":"Manager added","Manager_removed":"Manager removed","Mark_as_read":"Mark as read","Markdown_Headers":"Markdown Headers","Markdown_SupportSchemesForLink":"Markdown Support Schemes for Link","Markdown_SupportSchemesForLink_Description":"Comma-separated list of allowed schemes","Members_List":"Members List","Mentions":"Mentions","Mentions_default":"Mentions (default)","Message":"Message","Message_AllowDeleting":"Allow Message Deleting","Message_AllowDeleting_BlockDeleteInMinutes":"Block Message Deleting After (n) Minutes","Message_AllowDeleting_BlockDeleteInMinutesDescription":"Enter 0 to disable blocking.","Message_AllowEditing":"Allow Message Editing","Message_AllowEditing_BlockEditInMinutes":"Block Message Editing After (n) Minutes","Message_AllowEditing_BlockEditInMinutesDescription":"Enter 0 to disable blocking.","Message_AllowPinning":"Allow Message Pinning","Message_AllowPinning_Description":"Allow messages to be pinned to any of the channels.","Message_AllowStarring":"Allow Message Starring","Message_AudioRecorderEnabled":"Audio Recorder Enabled","Message_AudioRecorderEnabledDescription":"Requires 'audio/wav' files to be an accepted media type within 'File Upload' settings.","Message_DateFormat":"Date Format","Message_DateFormat_Description":"See also: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_blocked":"This message cannot be deleted anymore","Message_deleting_not_allowed":"Message deleting not allowed","Message_editing_blocked":"This message cannot be edited anymore","Message_editing_not_allowed":"Message editing not allowed","Message_GroupingPeriod":"Grouping Period (in seconds)","Message_GroupingPeriodDescription":"Messages will be grouped with previous message if both are from the same user and the elapsed time was less than the informed time in seconds.","Message_KeepHistory":"Keep Message History","Message_MaxAllowedSize":"Maximum Allowed Message Size","Message_MaxAll":"Maximum channel size for ALL message","Message_pinned":"Message pinned","Message_pinning_not_allowed":"Message pinning not allowed","Message_removed":"Message removed","Message_ShowDeletedStatus":"Show Deleted Status","Message_ShowEditedStatus":"Show Edited Status","Message_ShowFormattingTips":"Show Formatting Tips","Message_TimeFormat":"Time Format","Message_TimeFormat_Description":"See also: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Message too long","Messages":"Messages","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Messages that are sent to the Incoming WebHook will be posted here.","Meta":"Meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Site Verification","Meta_language":"Language","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minutes","Mobile_push":"Mobile push","More_channels":"More channels","More_direct_messages":"More direct messages","More_groups":"More private groups","More_unreads":"More unreads","Msgs":"Msgs","multi":"multi","Mute_someone_in_room":"Mute someone in the room","Mute_user":"Mute user","Muted":"Muted","My_Account":"My Account","n_messages":"%s messages","N_new_messages":"%s new messages","Name":"Name","Name_cant_be_empty":"Name can't be empty","Name_of_agent":"Name of agent","Name_optional":"Name (optional)","Navigation_History_20_last_pages":"Navigation History (20 last pages)","New_Application":"New Application","New_Custom_Field":"New Custom Field","New_Department":"New Department","New_integration":"New integration","New_logs":"New logs","New_messages":"New messages","New_password":"New password","New_role":"New role","No_channel_with_name_%s_was_found":"No channel with name <strong>\"%s\"</strong> was found!","No_channels_yet":"You aren't part of any channel yet.","No_direct_messages_yet":"You haven't started any conversations yet.","No_Encryption":"No Encryption","No_favorites_yet":"You haven't added any favorites yet.","No_group_with_name_%s_was_found":"No private group with name <strong>\"%s\"</strong> was found!","No_groups_yet":"You have no private groups yet.","No_livechats":"You have no livechats.","No_mentions_found":"No mentions found","No_permission_to_view_room":"You don't have permission to view this room","No_pinned_messages":"No pinned messages","No_results_found":"No results found","No_starred_messages":"No starred messages","no_tokens_for_this_user":"There are no tokens for this user","No_user_with_username_%s_was_found":"No user with username <strong>\"%s\"</strong> was found!","Not_allowed":"Not allowed","Not_authorized":"Not authorized","Not_Available":"Not Available","Not_found_or_not_allowed":"Not Found or Not Allowed","Nothing":"Nothing","Nothing_found":"Nothing found","Notifications":"Notifications","Notify_all_in_this_room":"Notify all in this room","Num_Agents":"# Agents","Number_of_messages":"Number of messages","OAuth_Application":"OAuth Application","OAuth_Applications":"OAuth Applications","Objects":"Objects","Off_the_record_conversation":"Off-the-record Conversation","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record conversation is not available for your browser or device.","Offline_DM_Email":"[__site__] You have been direct messaged by __user__","Offline_Mention_Email":"[__site__] You have been mentioned by __user__ in #__room__","Old_and_new_password_must_be_different":"The new password must be different from the old password.","Old_and_new_password_required":"You need to provide both old and new password for changing your password.","Online":"Online","Only_errors":"Only errors","Only_you_can_see_this_message":"Only you can see this message","Oops!":"Oops","Open":"Open","Opened":"Opened","Opt_out_statistics":"Don't send my statistics to Rocket.Chat","Opt_out_statistics_warning":"By sending your statistics, you'll help us identify how many instances of Rocket.Chat are deployed, as well as how good the system is behaving, so we can further improve it. Don't worry, as no user information is sent and all the information we receive is kept confidential. If you want to continue sending us your statistics, uncheck the above checkbox. Thank you.","optional":"optional","Order":"Order","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Count","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Average","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Total Memory","OS_Type":"OS Type","OS_Uptime":"OS Uptime","others":"others","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR is only available when both users are online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Override URL to which files are uploaded. This url also used for downloads unless a CDN is given","Password":"Password","Password_Change_Disabled":"Your Rocket.Chat administrator has disabled the changing of passwords","Password_changed_successfully":"Password changed successfully","Payload":"Payload","People":"People","Permissions":"Permissions","Pin_Message":"Pin Message","Pinned_a_message":"Pinned a message:","Pinned_Messages":"Pinned Messages","Placeholder_for_email_or_username_login_field":"Placeholder for email or username login field","Placeholder_for_password_login_field":"Placeholder for password login field","Please_answer_survey":"Please take a moment to answer a quick survey about this chat","Please_enter_value_for_url":"Please enter a value for the url of your avatar.","Please_enter_your_new_password_below":"Please enter your new password below:","Please_fill_a_label":"Please fill a label","Please_fill_a_name":"Please fill a name","Please_fill_a_username":"Please fill a username","Please_fill_name_and_email":"Please fill name and email","Please_re_enter_your_password":"Please re-enter your password","Please_select_enabled_yes_or_no":"Please select an option for Enabled","Please_wait":"Please wait","Please_wait_activation":"Please wait, this can take some time.","Please_wait_statistics":"Please wait, statistics are being generated.","Please_wait_while_OTR_is_being_established":"Please wait while OTR is being established","Please_wait_while_your_account_is_being_deleted":"Please wait while your account is being deleted...","Please_wait_while_your_profile_is_being_saved":"Please wait while your profile is being saved...","Post_as":"Post as","Post_to_Channel":"Post to Channel","Post_to_s_as_s":"Post to <strong>%s</strong> as <strong>%s</strong>","Powered_by":"Powered by","Preferences":"Preferences","Preferences_saved":"Preferences saved","Privacy":"Privacy","Private_Group":"Private Group","Private_Groups":"Private Groups","Private_Groups_list":"List of Private Groups","Profile":"Profile","Profile_saved_successfully":"Profile saved successfully","Proudly_developed":"Proudly developed with Meteor","Push":"Push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Debug","push_disabled":"Push disabled","Push_enable":"Enable","Push_enable_gateway":"Enable Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Project Number","Push_production":"Production","Push_show_message":"Show message in notification","Push_show_username_room":"Show channel/group/username in notification","Push_test_push":"Test","Query":"Query","Query_description":"Additional conditions for determining which users to send the email to. Unsubscribed users are automatically removed from the query. It must be a valid JSON. Example: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Quick Search","quote":"quote","Reactions":"Reactions","Recents":"Recents","Record":"Record","Redirect_URI":"Redirect URI","Refresh_keys":"Refresh keys","Refresh_your_page_after_install_to_enable_screen_sharing":"Refresh your page after install to enable screen sharing","Register":"Register a new account","Registration_Succeeded":"Registration Succeeded","Remember_me":"Remember me","Remove":"Remove","Remove_Admin":"Remove Admin","Remove_as_moderator":"Remove as moderator","Remove_as_owner":"Remove as owner","Remove_custom_oauth":"Remove custom oauth","Remove_from_room":"Remove from room","Remove_someone_from_room":"Remove someone from the room","Removed":"Removed","Require_password_change":"Require password change","Resend_verification_email":"Resend verification email","Reset":"Reset","Reset_password":"Reset password","Restart":"Restart","Restart_the_server":"Restart the server","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"RocketBot Name","RocketBot_Name_Description":"RocketBot name must be a valid username registered on your server.","Role":"Role","Role_Editing":"Role Editing","Role_removed":"Role removed","Room":"Room","Room_archivation_state":"State","Room_archivation_state_false":"Active","Room_archivation_state_true":"Archived","Room_archived":"Room archived","room_changed_privacy":"Room type changed to: <em>__room_type__</em> by <em>__user_by__</em>","room_changed_topic":"Room topic changed to: <em>__room_topic__</em> by <em>__user_by__</em>","Room_has_been_deleted":"Room has been deleted","Room_Info":"Room Info","Room_name_changed":"Room name changed to: <em>__room_name__</em> by <em>__user_by__</em>","Room_name_changed_successfully":"Room name changed successfully","Room_not_found":"Room not found","Room_topic_changed_successfully":"Room topic changed successfully","Room_type_changed_successfully":"Room type changed successfully","Room_unarchived":"Room unarchived","Room_uploaded_file_list":"Files List","Room_uploaded_file_list_empty":"No files available.","room_user_count":"%s users","Rooms":"Rooms","S_new_messages_since_s":"%s new messages since %s","SAML":"SAML","SAML_Custom_Cert":"Custom Certificate","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Generate Username","SAML_Custom_Issuer":"Custom Issuer","SAML_Custom_Provider":"Custom Provider","Save":"Save","Save_changes":"Save changes","Save_Mobile_Bandwidth":"Save Mobile Bandwidth","Save_to_enable_this_action":"Save to enable this action","Saved":"Saved","Saving":"Saving","Scope":"Scope","Screen_Share":"Screen Share","Script_Enabled":"Script Enabled","Search":"Search","Search_by_username":"Search by username","Search_Channels":"Search Channels","Search_Direct_Messages":"Search Direct Messages","Search_Messages":"Search Messages","Search_Private_Groups":"Search Private Groups","Search_settings":"Search settings","seconds":"seconds","See_all":"See all","See_only_online":"Only online","Select_a_department":"Select a department","Select_an_avatar":"Select an avatar","Select_file":"Select file","Select_service_to_login":"Select a service to login to load your picture or upload one directly from your computer","Select_user":"Select user","Select_users":"Select users","Selected_agents":"Selected agents","Selected_users":"Selected members","Send":"Send","Send_a_message":"Send a message","Send_a_test_mail_to_my_user":"Send a test mail to my user","Send_a_test_push_to_my_user":"Send a test push to my user","Send_confirmation_email":"Send confirmation email","Send_data_into_RocketChat_in_realtime":"Send data into Rocket.Chat in real-time.","Send_email":"Send E-mail","Send_invitation_email":"Send invitation email","Send_invitation_email_error":"You haven't provided any valid email address.","Send_invitation_email_info":"You can send multiple email invitations at once.","Send_invitation_email_success":"You have successfully sent an invitation email to the following addresses:","Send_invitation_email_warning":"In order to send invitation emails, you must first configure SMTP settings.","Send_Message":"Send Message","Send_your_JSON_payloads_to_this_URL":"Send your JSON payloads to this URL.","Sending":"Sending...","Set_as_moderator":"Set as moderator","Set_as_owner":"Set as owner","Settings":"Settings","Settings_updated":"Settings updated","Should_be_a_URL_of_an_image":"Should be a URL of an image.","Should_exists_a_user_with_this_username":"The user must already exist.","Show_all":"Show all","Show_more":"Show more","Show_only_online":"Show only online","Show_preregistration_form":"Show pre-registration form","Showing_archived_results":"<p>Showing <b>%s</b> archived results</p>","Showing_online_users":"Showing <b>__total_showing__</b> of __total__ users","Showing_results":"<p>Showing <b>%s</b> results</p>","Silence":"Silence","since_creation":"since %s","Site_Name":"Site Name","Site_Url":"Site URL","Site_Url_Description":"Example: https://chat.domain.com/","Skip":"Skip","Smileys_and_People":"Smileys & People","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP Password","SMTP_Port":"SMTP Port","SMTP_Test_Button":"Test SMTP Settings","SMTP_Username":"SMTP Username","Sound":"Sound","Star_Message":"Star Message","Starred_Messages":"Starred Messages","Start_audio_call":"Start audio call","Start_Chat":"Start Chat","Start_of_conversation":"Start of conversation","Start_OTR":"Start OTR","Start_video_call":"Start video call","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Start with <code class=\"inline\">%s</code> for user or <code class=\"inline\">%s</code> for channel. Eg: <code class=\"inline\">%s</code> or <code class=\"inline\">%s</code>","Statistics":"Statistics","Stats_Active_Users":"Active Users","Stats_Avg_Channel_Users":"Average Channel Users","Stats_Avg_Private_Group_Users":"Average Private Group Users","Stats_Away_Users":"Away Users","Stats_Max_Room_Users":"Max Rooms Users","Stats_Non_Active_Users":"Inactive Users","Stats_Offline_Users":"Offline Users","Stats_Online_Users":"Online Users","Stats_Total_Channels":"Total Channels","Stats_Total_Direct_Messages":"Total Direct Message Rooms","Stats_Total_Messages":"Total Messages","Stats_Total_Private_Groups":"Total Private Groups","Stats_Total_Rooms":"Total Rooms","Stats_Total_Users":"Total Users","Stop_Recording":"Stop Recording","strike":"strike","Subject":"Subject","Submit":"Submit","Success":"Success","Survey":"Survey","Survey_instructions":"Rate each question according to your satisfaction, 1 meaning you are completely unsatisfied and 5 meaning you are completely satisfied.","Symbols":"Symbols","Sync_success":"Sync success","Sync_Users":"Sync Users","Test_Connection":"Test Connection","Test_Desktop_Notifications":"Test Desktop Notifications","Thank_you_for_your_feedback":"Thank you for your feedback","The_application_name_is_required":"The application name is required","The_channel_name_is_required":"The channel name is required","The_emails_are_being_sent":"The emails are being sent.","The_field_is_required":"The field %s is required.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"The image resize will not work because we can not detect ImageMagick or GraphicsMagick installed on your server.","The_redirectUri_is_required":"The redirectUri is required","The_server_will_restart_in_s_seconds":"The server will restart in %s seconds","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"The setting <strong>%s</strong> is configured to <strong>%s</strong> and you are accessing from <strong>%s</strong>!","The_user_will_be_removed_from_s":"The user will be removed from %s","The_user_wont_be_able_to_type_in_s":"The user won't be able to type in %s","Theme":"Theme","theme-color-action-buttons-color":"Actions Buttons Color","theme-color-active-channel-background-color":"Active Channel Background Color","theme-color-active-channel-font-color":"Active Channel Font Color","theme-color-blockquote-background":"Blockquote Background Color","theme-color-clean-buttons-color":"Clean Buttons Color","theme-color-code-background":"Code Background Color","theme-color-code-border":"Code Border Color","theme-color-code-color":"Code Color","theme-color-content-background-color":"Content Background Color","theme-color-custom-scrollbar-color":"Custom Scrollbar Color","theme-color-info-active-font-color":"Active Info Font Color","theme-color-info-font-color":"Info Font Color","theme-color-input-font-color":"Input Font Color","theme-color-link-font-color":"Link Font Color","theme-color-message-hover-background-color":"Message Hover BG Color","theme-color-primary-background-color":"Primary Background Color","theme-color-primary-font-color":"Primary Font Color","theme-color-quaternary-font-color":"Quaternary Font Color","theme-color-secondary-background-color":"Secondary Background Color","theme-color-secondary-font-color":"Secondary Font Color","theme-color-smallprint-font-color":"Small Print Font Color","theme-color-smallprint-hover-color":"Small Print Hover Color","theme-color-status-away":"Away Status Color","theme-color-status-busy":"Busy Status Color","theme-color-status-offline":"Offline Status Color","theme-color-status-online":"Online Status Color","theme-color-tertiary-background-color":"Tertiary Background Color","theme-color-tertiary-font-color":"Tertiary Font Color","theme-color-unread-notification-color":"Unread Notifications Color","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"There are no agents added to this department yet.","There_are_no_integrations":"There are no integrations","There_are_no_users_in_this_role":"There are no users in this role.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"This email has already been used and has not been verified. Please change your password.","This_is_a_desktop_notification":"This is a desktop notification","This_is_a_push_test_messsage":"This is a push test messsage","Time_in_seconds":"Time in seconds","Title_bar_color":"Title bar color","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"To install Rocket.Chat Livechat in your website, copy &amp; paste this code above the last <strong>&lt;/body&gt;</strong> tag on your site.","To_users":"To Users","Topic":"Topic","Travel_and_Places":"Travel & Places","Trigger_removed":"Trigger removed","Trigger_Words":"Trigger Words","Triggers":"Triggers","True":"True","Type":"Type","Type_your_new_password":"Type your new password","Unarchive":"Unarchive","Unmute_someone_in_room":"Unmute someone in the room","Unmute_user":"Unmute user","Unnamed":"Unnamed","Unpin_Message":"Unpin Message","Unread_Rooms":"Unread Rooms","Unread_Rooms_Mode":"Unread Rooms Mode","Unstar_Message":"Remove Star","Upload_file_question":"Upload file?","Uploading_file":"Uploading file...","Use_account_preference":"Use account preference","Use_Emojis":"Use Emojis","Use_initials_avatar":"Use your username initials","use_menu":"Use the side menu to access your rooms and chats","Use_service_avatar":"Use %s avatar","Use_this_username":"Use this username","Use_uploaded_avatar":"Use uploaded avatar","Use_url_for_avatar":"Use url for avatar","User__username__is_now_a_moderator_of__room_name_":"User __username__ is now a moderator of __room_name__","User__username__is_now_a_owner_of__room_name_":"User __username__ is now a owner of __room_name__","User__username__removed_from__room_name__moderators":"User __username__ removed from __room_name__ moderators","User__username__removed_from__room_name__owners":"User __username__ removed from __room_name__ owners","User_added":"User added","User_added_by":"User <em>__user_added__</em> added by <em>__user_by__</em>.","User_added_successfully":"User added successfully","User_Channels":"User Channels","User_doesnt_exist":"No user exists by the name of `@%s`.","User_has_been_activated":"User has been activated","User_has_been_deactivated":"User has been deactivated","User_has_been_deleted":"User has been deleted","User_has_been_muted_in_s":"User has been muted in %s","User_has_been_removed_from_s":"User has been removed from %s","User_has_disconnected":"User has disconnected","User_Info":"User Info","User_is_no_longer_an_admin":"User is no longer an admin","User_is_not_activated":"User is not activated","User_is_now_an_admin":"User is now an admin","User_joined_channel":"Has joined the channel.","User_joined_channel_female":"Has joined the channel.","User_joined_channel_male":"Has joined the channel.","User_left":"Has left the channel.","User_left_female":"Has left the channel.","User_left_male":"Has left the channel.","User_logged_out":"User is logged out","User_management":"User Management","User_muted_by":"User <em>__user_muted__</em> muted by <em>__user_by__</em>.","User_muted_in_room":"User muted in room","User_not_found":"User not found","User_not_found_or_incorrect_password":"User not found or incorrect password","User_or_channel_name":"User or channel name","User_removed":"User removed","User_removed_by":"User <em>__user_removed__</em> removed by <em>__user_by__</em>.","User_removed_from_room":"The user has been removed from the room","User_Settings":"User Settings","User_unmuted_by":"User <em>__user_unmuted__</em> unmuted by <em>__user_by__</em>.","User_unmuted_in_room":"User unmuted in room","User_updated_successfully":"User updated successfully","Username":"Username","Username_and_message_must_not_be_empty":"Username and message must not be empty.","Username_cant_be_empty":"The username cannot be empty","Username_Change_Disabled":"Your Rocket.Chat administrator has disabled the changing of usernames","Username_denied_the_OTR_session":"__username__ denied the OTR session","Username_description":"The username is used to allow others to mention you in messages.","Username_doesnt_exist":"The username `%s` doesn't exist.","Username_ended_the_OTR_session":"__username__ ended the OTR session","Username_invalid":"<strong>%s</strong> is not a valid username,<br/> use only letters, numbers, dots, hyphens and underscores","Username_is_already_in_here":"`@%s` is already in here.","Username_is_not_in_this_room":"The user `#%s` is not in this room.","Username_not_found":"Username not found","Username_title":"Register username","Username_unavaliable":"<strong>%s</strong> is already in use :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ wants to start OTR. Do you want to accept?","Users":"Users","Users_in_role":"Users in role","UTF8_Names_Slugify":"UTF8 Names Slugify","UTF8_Names_Validation":"UTF8 Names Validation","UTF8_Names_Validation_Description":"Do not allow special characters and spaces. You can use - _ and . but not at the end of the name","Verification_email_sent":"Verification email sent","View_All":"View All","View_Logs":"View Logs","Visibility":"Visibility","Visible":"Visible","Visitor":"Visitor","Visitor_page_URL":"Visitor page URL","Visitor_time_on_site":"Visitor time on site","Wait_activation_warning":"Before you can login, your account must be manually activated by an administrator.","We_are_offline_Sorry_for_the_inconvenience":"We are offline. Sorry for the inconvenience.","We_have_sent_password_email":"We have sent you an email with password reset instructions. If you do not receive an email shortly, please come back and try again.","We_have_sent_registration_email":"We have sent you an email to confirm your registration. If you do not receive an email shortly, please come back and try again.","WebRTC_Enable_Channel":"Enable for Public Channels","WebRTC_Enable_Direct":"Enable for Direct Messages","WebRTC_Enable_Private":"Enable for Private Channels","WebRTC_Servers":"STUN/TURN Servers","WebRTC_Servers_Description":"A list of STUN and TURN servers separated by comma.<br/>Username, password and port are allowed in the format `username:password@stun:host:port` or `username:password@turn:host:port`.","Welcome":"Welcome <em>%s</em>.","Welcome_to_the":"Welcome to the","will_be_able_to":"will be able to","With_whom":"With whom","Yes":"Yes","Yes_clear_all":"Yes, clear all!","Yes_delete_it":"Yes, delete it!","Yes_hide_it":"Yes, hide it!","Yes_leave_it":"Yes, leave it!","Yes_mute_user":"Yes, mute user!","Yes_remove_user":"Yes, remove user!","you_are_in_preview_mode_of":"You are in preview mode of channel #<strong>__room_name__</strong>","You_are_logged_in_as":"You are logged in as","You_are_not_authorized_to_view_this_page":"You are not authorized to view this page.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"You are the last owner. Please set new owner before leaving the room.","You_can_change_a_different_avatar_too":"You can override the avatar used to post from this integration.","You_can_use_an_emoji_as_avatar":"You can also use an emoji as an avatar.","You_have_been_muted":"You have been muted and cannot speak in this room","You_have_not_verified_your_email":"You have not verified your email.","You_have_successfully_unsubscribed":"You have successfully unsubscribed from our Mailling List.","You_informed_an_invalid_FROM_address":"You informed an invalid FROM address.","You_must_provide_the_unsubscribe_link":"You must provide the [unsubscribe] link.","You_need_confirm_email":"You need to confirm your email to login!","You_need_install_an_extension_to_allow_screen_sharing":"You need install an extension to allow screen sharing","You_need_to_change_your_password":"You need to change your password","You_need_to_type_in_your_password_in_order_to_do_this":"You need to type in your password in order to do this!","You_need_to_type_in_your_username_in_order_to_do_this":"You need to type in your username in order to do this!","You_need_to_verifiy_your_email_address_to_get_notications":"You need to verifiy your email address to get notifications","You_should_name_it_to_easily_manage_your_integrations":"You should name it to easily manage your integrations.","You_will_not_be_able_to_recover":"You will not be able to recover this message!","You_will_not_be_able_to_recover_file":"You will not be able to recover this file!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"You won't receive email notifications because you have not verified your email.","Your_email_has_been_queued_for_sending":"Your email has been queued for sending","Your_entry_has_been_deleted":"Your entry has been deleted.","Your_file_has_been_deleted":"Your file has been deleted.","Your_mail_was_sent_to_s":"Your mail was sent to %s","Your_Open_Source_solution":"Your own Open Source chat solution","Your_password_is_wrong":"Your password is wrong!","Your_push_was_sent_to_s_devices":"Your push was sent to %s devices"};
TAPi18n._loadLangFileObject("en", translations);                                                                       // 11
TAPi18n._registerServerTranslator("en", namespace);                                                                    // 12
                                                                                                                       // 13
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/es.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["es"] = ["Spanish (Spain)","Español"];                                                         // 8
if(_.isUndefined(TAPi18n.translations["es"])) {                                                                        // 9
  TAPi18n.translations["es"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["es"][namespace])) {                                                             // 13
  TAPi18n.translations["es"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["es"][namespace], {"500":"error de servidor interno","0_Errors_Only":"Sólo Errores - 0","1_Errors_and_Information":"1 - Errores y Información","2_Erros_Information_and_Debug":"2 - Errores, Información y Depuración ","__username__was_set__role__by__user_by_":"__username__ se estableció __role__ por __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ ya no es __role__, por __user_by__","Access_not_authorized":"Acceso no autorizado","Access_online_demo":"Accede a la demo en línea","Access_Online_Demo":"Accede a la Demo En Línea","Access_Token_URL":"URL de Token de Acceso","Accounts":"Cuentas","Accounts_AllowDeleteOwnAccount":"Permitir a los usuarios eliminar cuenta propia","Accounts_AllowedDomainsList":"Lista de Dominios Permitidos","Accounts_AllowedDomainsList_Description":"Lista separada por comas de los dominios permitidos ","Accounts_AllowEmailChange":"Permitir E-mail Cambio","Accounts_AllowPasswordChange":"Permitir Cambio de Contraseña","Accounts_AllowUserAvatarChange":"Permitir al Usuario modificar su Avatar","Accounts_AllowUsernameChange":"Permitir el Cambio de Nombre de Usuario","Accounts_AllowUserProfileChange":"Permitir al Usuario modificar su Perfil","Accounts_AvatarResize":"Cambiar el Tamaño de los Avatars","Accounts_AvatarSize":"Tamaño de Avatar","Accounts_AvatarStorePath":"Ruta de Almacenamiento de Avatar","Accounts_AvatarStoreType":"Tipo de Almacenamiento de Avatar","Accounts_BlockedDomainsList":"Bloqueado lista de dominios","Accounts_BlockedDomainsList_Description":"Lista separada por comas de dominios bloqueados","Accounts_denyUnverifiedEmail":"Denegar correo electronico sin verificar","Accounts_EmailVerification":"Verificación de correo electronico","Accounts_EmailVerification_Description":"Asegúrese de que tiene la configuración SMTP correctas a usar esta característica","Accounts_Enrollment_Email":"Correo Electrónico de Inscripción ","Accounts_Enrollment_Email_Description":"Es posible utilizar [nombre], [fname], [lname] para el nombre completo del usuario, nombre o apellido, respectivamente. <br /> Es posible utilizar [e-mail] para el correo electrónico del usuario.","Accounts_Iframe_api_method":"Método api","Accounts_Iframe_api_url":"URL de la API","Accounts_iframe_enabled":"habilitado","Accounts_iframe_url":"Url iframe","Accounts_LoginExpiration":"Caducidad de Inicio de Sesión en Días.","Accounts_ManuallyApproveNewUsers":"Aprobar Manualmente Nuevos Usuarios","Accounts_OAuth_Custom_Token_Sent_Via":"Token Via Enviado","Accounts_OAuth_Custom_Authorize_Path":"Ruta de Autorización ","Accounts_OAuth_Custom_Button_Color":"Color del Botón","Accounts_OAuth_Custom_Button_Label_Color":"Color del Texto del Botón ","Accounts_OAuth_Custom_Button_Label_Text":"Texto del Botón ","Accounts_OAuth_Custom_Enable":"Habilitar","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Ruta de la Identidad","Accounts_OAuth_Custom_Login_Style":"Entrar Estilo","Accounts_OAuth_Custom_Secret":"Secreto","Accounts_OAuth_Custom_Token_Path":"Ruta del Token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Iniciar de sesión con Facebook","Accounts_OAuth_Facebook_callback_url":"URL de devolución de llamada Facebook","Accounts_OAuth_Facebook_id":"App Id de Facebook","Accounts_OAuth_Facebook_secret":"Secreto de Facebook","Accounts_OAuth_Github":"Habilitar OAuth","Accounts_OAuth_Github_callback_url":"URL de devolución de llamada Github","Accounts_OAuth_GitHub_Enterprise":"OAuth Habilitado","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub URL de devolución de llamada para empresas","Accounts_OAuth_GitHub_Enterprise_id":"Id de Cliente","Accounts_OAuth_GitHub_Enterprise_secret":"Secreto de Cliente","Accounts_OAuth_Github_id":"Id de Cliente","Accounts_OAuth_Github_secret":"Secreto de Cliente","Accounts_OAuth_Gitlab":"OAuth Habilitado","Accounts_OAuth_Gitlab_callback_url":"URL de devolución de llamada GitLab","Accounts_OAuth_Gitlab_id":"Id de GitLab","Accounts_OAuth_Gitlab_secret":"Secreto de Cliente","Accounts_OAuth_Google":"Iniciar de Sesión con Google","Accounts_OAuth_Google_callback_url":"Google URL de devolución de llamada","Accounts_OAuth_Google_id":"Id de Google","Accounts_OAuth_Google_secret":"Secreto de Google","Accounts_OAuth_Linkedin":"Iniciar Sesión con LinkedIn","Accounts_OAuth_Linkedin_callback_url":"URL de devolución de llamada Linkedin","Accounts_OAuth_Linkedin_id":"Id de LinkedIn","Accounts_OAuth_Linkedin_secret":"Secreto de LinkedIn","Accounts_OAuth_Meteor":"Iniciar Sesión con Meteor","Accounts_OAuth_Meteor_callback_url":"URL de devolución de llamada Meteor","Accounts_OAuth_Meteor_id":"Id de Meteor","Accounts_OAuth_Meteor_secret":"Secreto de Meteor","Accounts_OAuth_Twitter":"Inicio de Sesión con Twitter","Accounts_OAuth_Twitter_callback_url":"URL de devolución de llamada Twitter","Accounts_OAuth_Twitter_id":"Id de Twitter","Accounts_OAuth_Twitter_secret":"Secreto de Twitter","Accounts_OAuth_Wordpress":"Inicio de Sesion con Wordpress","Accounts_OAuth_Wordpress_callback_url":"URL de devolución de llamada Wordpress","Accounts_OAuth_Wordpress_id":"Id de Wordpress","Accounts_OAuth_Wordpress_secret":"Secreto de Wordpress","Accounts_PasswordReset":"Restablecer Contraseña","Accounts_Registration_AuthenticationServices_Enabled":"Registro mediante Servicios de Autenticacion","Accounts_RegistrationForm":"Formulario de Registro","Accounts_RegistrationForm_Disabled":"Deshabilitado","Accounts_RegistrationForm_LinkReplacementText":"Texto de Remplazo de Enlaces del Formulario de Registro","Accounts_RegistrationForm_Public":"Publico","Accounts_RegistrationForm_Secret_URL":"URL Secreto","Accounts_RegistrationForm_SecretURL":"URL Secreto del Fomulario de Registro","Accounts_RegistrationForm_SecretURL_Description":"Debe proporcionar una cadena de texto aleatorio que se añadirá al URL de registro. Ejemplo: https://demo.rocket.chat/register/[hash_secreto]","Accounts_RegistrationRequired":"Registro requerido","Accounts_RequireNameForSignUp":"Requerir un Nombre para el Registro","Accounts_ShowFormLogin":"Inicio de sesión basado en formularios Mostrar","Accounts_UseDefaultBlockedDomainsList":"Usar predeterminado Bloqueado lista de dominios","Accounts_UseDNSDomainCheck":"Utilice Comprobar dominio DNS","Activate":"Activar","Activity":"Actividad","Add":"Agregar","Add_agent":"Agregar agente","Add_custom_oauth":"Agregar oauth personalizado","Add_manager":"Agregar supervisor","Add_Members":"Agregar Miembros","Add_User":"Agregar usuario","Add_user":"Agregar Usuario","Add_users":"Agrerar suarios","Additional_emails":"Los correos electrónicos adicionales","Additional_Feedback":"Retroalimentación adicional","Administration":"Administración","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Después de la autenticación OAuth2, los usuarios serán redirigidos a esta URL","Agent_added":"Agente agregado","Agent_removed":"Agente eliminado","Alias":"Alias","All":"Todas","All_channels":"Todos los canales","All_logs":"Todos los registros","All_messages":"Todos los mensajes","Allow_Invalid_SelfSigned_Certs":"Permitir Certificados Auto-Firmados Invalidos","Allow_Invalid_SelfSigned_Certs_Description":"Permitir certificados SSL autofirmados e invalidos para validacion de enlaces y vistas previas.","and":"y","And_more":"Y más __length __...","Animals_and_Nature":"Animales y Naturaleza","API":"API","API_Analytics":"Datos Analiticos","API_Embed":"Incrustar","API_EmbedDisabledFor":"Deshabilitar el insertar vinculos para los Usuarios","API_EmbedDisabledFor_Description":"Lista separados por comas de nombres de usuarios ","API_GitHub_Enterprise_URL":"URL del Servidor","API_GitHub_Enterprise_URL_Description":"Ejemplo: http://domain.com (sin incluir la diagonal final)","API_Gitlab_URL":"URL de GitLab","API_Wordpress_URL":"URL de Wordpress","Appearance":"Apariencia","Application_added":"aplicación añadió","Application_Name":"Nombre de la aplicación","Application_updated":"aplicación actualizada","Apply_and_refresh_all_clients":"Aplicar y actualizar todos los clientes","Archive":"Archivo","Archive_Unarchive":"Archivo / Desarchivar","are_also_typing":"también están escribiendo","are_typing":"están escribiendo","Are_you_sure":"Estás seguro?","Are_you_sure_you_want_to_delete_your_account":"¿Está seguro de que quiere eliminar su cuenta?","Authorization_URL":"URL de Autorización","Authorize":"Autorizar","AutoLinker_StripPrefix":"AutoLinker Gaza Prefijo","AutoLinker_StripPrefix_Description":"presentación corta. por ejemplo https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL de expresiones regulares","AutoLinker_Email":"AutoLinker correo electrónico","AutoLinker_Phone":"AutoLinker Teléfono","AutoLinker_Phone_Description":"enlazadas automáticamente para los números de teléfono. por ejemplo, `(123) 456-7890`","Auto_Load_Images":"Cargar automáticamente las imagenes","Available":"Disponible","Available_agents":"agentes disponibles","Avatar":"Cambiar avatar","Avatar_changed_successfully":"Avatar cambiado correctamente","Avatar_URL":"URL del Avatar","Avatar_url_invalid_or_error":"El url proporcionado es invalido o no es accesible. Por favor intente otra vez, pero con un url diferente.","away":"lejos","Away":"Lejos","away_female":"ausente","Away_female":"Ausente","away_male":"ausente","Away_male":"Ausente","Back":"Atras","Back_to_applications":"Volver a las aplicaciones","Back_to_integrations":"De regreso a integraciones","Back_to_login":"Volver a identificarse","Back_to_permissions":"Regresar a permisos","Body":"Cuerpo","bold":"negrita","busy":"ocupado","Busy":"Ocupado","busy_female":"ocupada","Busy_female":"Ocupada","busy_male":"ocupado","Busy_male":"Ocupado","Cancel":"Cancelar","Cannot_delete_a_protected_role":"No puede eliminar un rol protegido","Cannot_delete_role_because_its_in_use":"No puede eliminar el rol porque esta en uso","Cannot_invite_users_to_direct_rooms":"No se puede invitar a los usuarios a las salas de dirigir","CDN_PREFIX":"Prefijo de CDN","Certificates_and_Keys":"Certificados y Llaves","Channel":"Canal","Channel_doesnt_exist":"El canal `#%s` no existe","Channels":"Canales","Channels_list":"Lista de canales públicos","Chat_Rooms":"Salas de Chat","Chatops_Enabled":"Habilitar Chatops","Chatops_Title":"Panel de Chatops","Chatops_Username":"Nombre de Usuario Chatops","Choose_a_room":"Elija una habitación","Choose_messages":"Elija mensajes","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Elije el alias que aparecerá antes del nombre de usuario en los mensajes.","Choose_the_username_that_this_integration_will_post_as":"Elige el nombre de usuario con el cual esta integración publicara.","Clear_all_unreads_question":"Borrar todos los mensajes no leidos?","Client_ID":"Identificación del cliente","Client_Secret":"cliente secreto","Clients_will_refresh_in_a_few_seconds":"Los clientes se actualizará en unos pocos segundos","close":"Cerrar","Closed":"Cerrado","Collapse_Embedded_Media_By_Default":"Contraer medios incorporados de forma predeterminada","coming_soon":"próximamente","Commands":"Comandos","Compact_View":"Vista Compacta","Confirm_password":"Confirma tu contraseña","Contact":"Contacto","Conversation":"Conversación","Convert_Ascii_Emojis":"Convierte ASCII a Emoji","Copied":"copiado","COPY_TO_CLIPBOARD":"COPIAR AL PORTAPAPELES","Copy_to_clipboard":"Copiar el Porta-papeles ","Count":"Contar","Create":"Crear","Create_new":"Crear nuevo","Created_at":"Creado en","Created_at_s_by_s":"Creado a las <strong>%s</strong> por <strong>%s</strong>","Custom_Fields":"Campos Personalizados","Custom_oauth_helper":"Mientras configura el Proveedor de OAuth, tendra que establecer un URL de Devolucion. Use <pre>%s</pre>.","Custom_oauth_unique_name":"Nombre único de oauth personalizado","Custom_Script_Logged_In":"Secuencia de personalización para los usuarios registrados","Custom_Script_Logged_Out":"Secuencia de personalización para los usuarios registrados a cabo","Dashboard":"Tablero","days":"días","Deactivate":"Desactivar","Debug_Level":"Nivel de depuración ","Default":"Defecto","Delete":"Eliminar","Delete_my_account":"Borrar mi cuenta","Delete_Room_Warning":"Eliminar un sala de chat eliminara todos los mensajes de la sala. Esto no se puede deshacer","Delete_User_Warning":"Eliminar a un usuario causara la eliminación de todos los mensajes creados por dicho usuario. Esta acción no se puede deshacer.","Deleted":"¡Eliminado!","Department_not_found":"Departamento no encontrado","Department_removed":"Departamento eliminado","Departments":"Departamentos","Description":"Descripción ","Desktop":"Escritorio","Desktop_Notification_Test":"Prueba de notificación en el escritorio","Desktop_Notifications":"Notificaciones de Escritorio","Desktop_Notifications_Disabled":"Las Notificaciones de Escritorio has sido Deshabilitadas. Cambia las preferencias en tu navegador si necesitas habilitar las Notificaciones.","Desktop_Notifications_Enabled":"Las Notificaciones de Escritorio están Habilitadas","Direct_message_someone":"mensaje de alguien directa","Direct_Messages":"Mensajes Directos","Direct_Messages_list":"Mensajes directos","Disable_Favorite_Rooms":"Deshabilitar Favoritos","Disable_New_Message_Notification":"Desactiva la Notificación de Nuevo Mensaje.","Disable_New_Room_Notification":"Desactiva la Notificación de Nuevo Canal","Displays_action_text":"Muestra texto de la acción","Do_you_want_to_change_to_s_question":"Desea cambiar a <strong>%s</strong>","Drop_to_upload_file":"Arrastra aqui para subir el archivo","Dry_run":"Funcionamiento en seco","Dry_run_description":"Se enviara únicamente un correo electronico, a la misma dirección establecida en el campo De. El correo electronico debe pertenecer a un usuario valido.","Duplicate_archived_channel_name":"Existe un canal archivada con el nombre ' %s'","Duplicate_archived_private_group_name":"Un grupo privado comprimidos con el nombre existe ' %s'","Duplicate_private_group_name":"Un Grupo Privado con el nombre  '%s' ya existe","E-mail":"Correo Electronico","Edit":"Editar","Edit_Custom_Field":"Editar campo personalizado","Edit_Department":"Editar Departamento","edited":"Editado","Email":"Email","Email_already_exists":"El correo electrónico ya existe","Email_body":"Cuerpo del Correo Electronico","Email_Change_Disabled":"Su administrador ha deshabilitado la Rocket.Chat el cambio de correo electrónico","Email_from":"De","Email_Notification_Mode":"Notificaciones por correo electrónico fuera de línea","Email_Notification_Mode_All":"Cada Mención / DM","Email_Notification_Mode_Disabled":"Discapacitado","Email_or_username":"Correo electrónico o nombre de usuario","Email_subject":"Asunto","Email_verified":"Correo electrónico verificado","Emoji":"Emoji","Empty_title":"Titulo Vacio","Enable":"Habilitar","Enable_Desktop_Notifications":"Habilitar Notificaciones de Escritorio","Enabled":"Habilitado","Encrypted_message":"mensaje cifrado","End_OTR":"fin OTR","Enter_a_regex":"Introduzca un regex","Enter_a_room_name":"Introduzca un nombre de la sala","Enter_a_username":"Ingrese un nombre de usuario","Enter_info":"Introduce tus datos de acceso","Enter_name_here":"Introduce el nombre aquí","Enter_to":"Entrar a","Error":"Error","error-cant-invite-for-direct-room":"No se puede invitar al usuario habitaciones directos","error-duplicate-channel-name":"Un canal con el nombre '%s' ya existe","error-invalid-custom-field":"campo personalizado no válido","error-invalid-custom-field-name":"No válido nombre de campo personalizado. Utilice sólo letras, números, guiones y guiones bajos.","error-invalid-password":"Contraseña invalida","error-invalid-room":"habitación no válido","error-invalid-room-name":"<strong> %s</strong> no es un nombre válido habitación, <br/> utilizar sólo letras, números, guiones y guiones bajos","error-invalid-user":"Usuario invalido","error-invalid-username":"Nombre de usuario no válido","error-not-allowed":"No permitido","error-not-authorized":"No autorizado","error-remove-last-owner":"Este es el último propietario. Por favor, establece un nuevo propietario antes de eliminar este.","error-role-name-required":"Se requiere nombre de rol","error-user-not-in-room":"El usuario no se encuentra en esta sala","Error_changing_password":"Error al cambiar de contraseña","Error_sending_confirmation_email":"el envío de correo electrónico de confirmación de error","Error_too_many_requests":"Error, demasiadas peticiones. Por favor baje el ritmo. Debe esperar %s segundos para intentar nuevamente.","Esc_to":"Esc a","Example_s":"Ejemplo: <code class=\"inline\">%s</code>","False":"Falso","Favorites":"Favoritos","Field":"Campo","Field_removed":"El campo eliminado","File_exceeds_allowed_size_of_bytes":"Archivo supera el tamaño permitido de bytes __size__","FileUpload":"Cargar  Archivo","FileUpload_Enabled":"Cargar Archivos Habilitado","FileUpload_File_Empty":"Archivo Vacio","FileUpload_FileSystemPath":"ruta del sistema","FileUpload_MaxFileSize":"Tamaño Maximo de Subida (en bytes)","FileUpload_MediaType_NotAccepted":"Tipos de medios no aceptados","FileUpload_MediaTypeWhiteList":"Tipos de Archivos Aceptados","FileUpload_MediaTypeWhiteListDescription":"Lista separada por comas de los tipos de archivos multimedia. Deje en blanco para aceptar todos los tipos.","FileUpload_ProtectFiles":"Proteger archivos cargados","FileUpload_ProtectFilesDescription":"Únicamente usuarios autenticados tendrán acceso ","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyID","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 nombre de depósito","FileUpload_S3_BucketURL":"URL cubeta","FileUpload_S3_CDN":"dominio CDN para descargas","FileUpload_S3_Region":"Región","FileUpload_Storage_Type":"Tipo de almacenamiento","Flags":"banderas","Follow_social_profiles":"Sigue nuestros perfiles sociales, realiza un fork en github y comparte tus pensamientos acerca de la aplicación rocket.chat en nuestro tablero de Trello.","Food_and_Drink":"Comer y beber","For_your_security_you_must_re_enter_your_password_to_continue":"Para su seguridad, debe volver a introducir su contraseña para continuar","Force_SSL":"fuerza SSL","Force_SSL_Description":"* Precaución! * _Force SSL_ nunca debe ser usado con proxy inverso. Si usted tiene un proxy inverso, que debe hacer la redirección HAY. Esta opción existe para los despliegues como Heroku, que no permite la configuración de redirección en el proxy inverso.","Forgot_password":"Olvidaste tu contraseña","Fork_it_on_github":"Háganos un fork en github","Frequently_Used":"Usado frecuentemente","From":"De","From_Email":"De Correo Electronico","From_email_is_required":"El campo De del correo electronico es requerido","From_email_warning":"<b>Advertencia</b>: El campo <b>De</b> esta sujeto a la configuración en tu servidor de correo.","General":"General","Get_to_know_the_team":"Conozca la Rocket.Team","github_no_public_email":"No tienes ningún correo electrónico como un correo público en tú cuenta de GitHub","Give_a_unique_name_for_the_custom_oauth":"Establezca un nombre único para el oauth personalizado","Give_the_application_a_name_This_will_be_seen_by_your_users":"Dar a la aplicación un nombre. Esto será visto por los usuarios.","Global":"Global","GoogleTagManager_id":"Id Google Administrador de etiquetas","Has_more":"Tiene mas","Have_your_own_chat":"Obtén tú propio web-chat. Desarrollado con Meteor.com, Rocket.Chat es una gran solución para los desarrolladores que buscan construir y desarrollar su propia plataforma de chat.","Header":"Encabezamiento","Hidden":"Oculto","Hide_Group_Warning":"¿Seguro que desea ocultar el grupo \" %s\"?","Hide_Private_Warning":"¿Está seguro de que desea ocultar la discusión con \" %s\"?","Hide_room":"Ocultar sala","Hide_Room_Warning":"¿Seguro que desea ocultar la habitación \" %s\"?","Highlights":"Reflejos","Highlights_How_To":"Para ser notificado cuando alguien menciona una palabra o frase, añadir aquí. Puede separar las palabras o frases con comas. Resaltar palabras no distinguen entre mayúsculas y minúsculas.","Highlights_List":"Resaltar palabras","History":"Historial","hours":"horas","How_friendly_was_the_chat_agent":"Que tan amigable fue nuestro agente de chat?","How_knowledgeable_was_the_chat_agent":"Que tanto sabia nuestro agente de chat?","How_responsive_was_the_chat_agent":"Que tan rápido respondió nuestro agente de chat?","How_satisfied_were_you_with_this_chat":"Que tan satisfecho quedo después de esta sesión de chat?","If_you_are_sure_type_in_your_password":"Si está seguro escriba su contraseña:","If_you_are_sure_type_in_your_username":"Si está seguro de tipo en su nombre de usuario:","Importer_Archived":"archivado","Importer_done":"Importación completa!","Importer_finishing":"Finalizar la importación.","Importer_From_Description":"Las importaciones __from datos __ 's en Rocket.Chat.","Importer_import_cancelled":"Importación cancelada.","Importer_import_failed":"Se produjo un error durante la ejecución de la importación.","Importer_importing_channels":"La importación de los canales.","Importer_importing_messages":"La importación de los mensajes.","Importer_importing_started":"A partir de la importación.","Importer_importing_users":"La importación de los usuarios.","Importer_not_defined_properly":"El importador no se definió correctamente, no se encuentra la clase de importación.","Importer_not_in_progress":"El importador actualmente no se está ejecutando.","Importer_Prepare_Restart_Import":"reinicio de importación","Importer_Prepare_Start_Import":"comenzar a importar","Importer_Prepare_Uncheck_Archived_Channels":"Canales archivados desactive los campos","Importer_Prepare_Uncheck_Deleted_Users":"Los usuarios desmarque eliminados","Importer_progress_error":"No se pudo obtener el progreso de la importación.","Importer_setup_error":"Se produjo un error al configurar el importador.","Incorrect_Password":"Contraseña Incorrecta","inline_code":"inline_code","Install_Extension":"Instalar extension","Install_FxOs":"Instalar Rocket.Chat en Firefox","Install_FxOs_done":"Grandioso! Ya puedes comenzar a utilizar Rocket.Chat mediante el icono de tu Escritorio. Diviértete usando Rocket.Chat!","Install_FxOs_error":"Sentimos que no funcionara como es debido! Apareció el siguiente error:","Install_FxOs_follow_instructions":"Por favor confirma la instalación de la aplicación en tu dispositivo (presione \"Instalar\" cuando se le solicite).","Installation":"Instalación ","Integration_added":"La Integración a sido añadida","Integration_Incoming_WebHook":"Integración WebHook de Entrada","Integration_New":"Nueva Integración","Integration_Outgoing_WebHook":"Integración web hook saliente","Integration_updated":"La Integración a sido actualizada","Integrations":"Integraciones","Invalid_asset":"Activo invalido","Invalid_confirm_pass":"La confirmación de la contraseña no coincide con la contraseña","Invalid_email":"El e-mail ingresado es invalido","Invalid_Export_File":"El archivo subido no es un fichero de exportación válida %s.","Invalid_file_height":"Altura Invalida de Archivo","Invalid_file_type":"Tipo Invalido de Archivo","Invalid_file_width":"Anchura Invalida de Archivo","Invalid_Import_File_Type":"Inválida tipo de archivo de importación.","Invalid_name":"El nombre no debe estar vacío","Invalid_notification_setting_s":"configuración de la notificación no válido: %s","Invalid_pass":"El password no debe estar vacio","Invalid_room_name":"<strong>%s</strong> no es un nombre de sala válido,<br/> usa solo letras, números y guiones","Invalid_room_type":"<strong>%s</strong> no es un tipo valido de sala.","Invalid_Secret_URL":"URL Secreto Invalido","Invalid_secret_URL_message":"El URL proporcionado es invalido.","invisible":"invisible","Invisible":"Invisible","Invitation_HTML":"HTML de la Invitación","Invitation_Subject":"Asunto de la Invitación","Invite_user_to_join_channel":"Invitar a un usuario a unirse a este canal","Invite_Users":"Invitar Usuarios","is_also_typing":"está también escribiendo","is_also_typing_female":"tambien esta escribiendo","is_also_typing_male":"tambien esta escribiendo","is_typing":"está escribiendo","is_typing_female":"esta escribiendo","is_typing_male":"esta escribiendo","italics":"cursiva","join":"Unirse","Join_audio_call":"Unirse a la llamada","Join_the_Community":"Únete a la Comunidad","Join_the_given_channel":"Unirse al canal dado","Join_video_call":"Unirse a la video llamada","Joined":"Unido","Jump":"Saltar","Jump_to_first_unread":"Saltar a la primera sin leer","Jump_to_message":"Ir al mensaje","Jump_to_recent_messages":"Ir a mensajes recientes","Katex_Enabled":"katex Habilitado","Label":"Etiqueta","Language":"Idioma","Language_Version":"Versión en Inglés","Last_login":"Ultimo inicio de sesion","Last_message":"Último mensaje","Last_seen":"Ultima vez visto","Layout":"Diseño","Layout_Home_Body":"Cuerpo de pagina de inicio","Layout_Home_Title":"Titulo de pagina de inicio","Layout_Login_Terms":"Términos de Inicio de Sesión ","Layout_Privacy_Policy":"Política de Privacidad","Layout_Sidenav_Footer":"Pie de Pagina de la Barra de Navegación Lateral","Layout_Sidenav_Footer_description":"El tamaño del Pie de Pagina es de 260 x 70px","Layout_Terms_of_Service":"Términos del Servicio","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Dominio Personalizado de Busqueda","LDAP_Custom_Domain_Search_Description":"Un pedazo de JSON que gobierna se unen y la conexión y la información es de la forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"dominio predeterminado","LDAP_Description":"LDAP es una base de datos jerárquica que muchas empresas utilizan para proporcionar inicio de sesión único - una instalación para compartir una contraseña entre múltiples sitios y servicios. Para obtener información avanzada de configuración y ejemplos, consulte nuestra wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"DN de LDAP","LDAP_Domain_Base":"Dominio Base","LDAP_Domain_Base_Description":"El nombre completo (DN) de un sub-árbol LDAP que desea buscar usuarios y grupos. Se pueden añadir tantos como quiera; sin embargo, cada grupo se debe definir en la misma base de dominio que los usuarios que pertenecen a la misma. Si especifica los grupos de usuarios restringidos, sólo los usuarios que pertenecen a esos grupos serán de alcance. Recomendamos que se especifica el nivel superior del árbol de directorios LDAP como su base de dominio y utiliza filtro de búsqueda para controlar el acceso.","LDAP_Domain_Search_Filter":"Filtro del Dominio de Busqueda","LDAP_Domain_Search_Filter_Description":"Si se les permitirá especificados, sólo los usuarios que coincidan con este filtro para iniciar sesión. Si no se especifica ningún filtro, todos los usuarios dentro del alcance de la base de dominio especificado serán capaces de iniciar sesión. <br/> Por ejemplo, para Active Directory `memberOf = cn = ROCKET_CHAT, ou = Groups` general. <br/> Por ejemplo, para OpenLDAP (búsqueda de coincidencia de extensible) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Contraseña del Dominio de Busqueda","LDAP_Domain_Search_Object_Category_Description":"El objectCategory * * que identifican a los usuarios. <br/> Dejar en blanco para OpenLDAP * *. <br/> Por ejemplo, `Person`, etc.","LDAP_Domain_Search_Object_Class":"Clase de dominio de búsqueda de objetos","LDAP_Domain_Search_Object_Class_Description":"La clase de objeto * * que identifican a los usuarios. <br/> Por ejemplo, `organizationalPerson`,` usuario de la red, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Búsqueda de dominio contraseña","LDAP_Domain_Search_Password_Description":"La contraseña para el usuario de búsqueda de dominios.","LDAP_Domain_Search_User":"Búsqueda de dominio del usuario","LDAP_Domain_Search_User_Description":"El usuario LDAP que realiza búsquedas de usuario para autenticar a otros usuarios cuando inician sesión en. <br/> Esta es normalmente una cuenta de servicio creado específicamente para integraciones de terceros. Utilizar un nombre completo, como `cn = Administrador, cn = Users, dc = ejemplo, dc = com`.","LDAP_Domain_Search_User_ID":"Dominio de búsqueda ID de usuario","LDAP_Domain_Search_User_ID_Description":"El atributo LDAP que identifica al usuario que intente LDAP autenticación. Este campo debe ser `sAMAccountName` para la mayoría de las instalaciones de Active Directory, pero puede ser` uid` para otras soluciones LDAP, como OpenLDAP. Puede utilizar `mail` para identificar a los usuarios por correo electrónico o cualquier atributo que desee. <br> Se pueden utilizar varios valores separados por comas para permitir a los usuarios acceder usando múltiples identificadores como nombre de usuario o correo electrónico.","LDAP_Enable":"Habilitado","LDAP_Enable_Description":"Intentar utilizar LDAP como método de autentican ","LDAP_Encryption":"Cifrado","LDAP_Encryption_Description":"Metodo de cifrado usado para la comunicacion segura hacia el servidor LDAP. Algunos ejemplos 'sin cifrado', 'SSL/LDAPS (cifrado desde el inicio), y 'StartTLS' ( actualizar a comunicaciones cifradas una ves conectado).","LDAP_Host":"Anfitrión","LDAP_Host_Description":"Anfitrión LDAP, ejem. `ldap.example.com` o`10.0.0.30`.","LDAP_Port":"Puerto","LDAP_Port_Description":"Puerto para accesar a LDAP. ej. `389` o `636` para LDAPS","LDAP_Reject_Unauthorized":"rechazar no autorizada","LDAP_Sync_User_Avatar":"Sincronizar usuario Avatar","LDAP_Sync_User_Data":"Sincronizar Datos","LDAP_Sync_User_Data_Description":"Mantener los datos del usuario en sincronía con el servidor al iniciar sesión (ej: nombre, correo electronico). ","LDAP_Sync_User_Data_FieldMap":"Mapa de campos de datos de usuario","LDAP_Sync_User_Data_FieldMap_Description":"Configurar como los campos de cuenta de usuario ( como el correo electronico) son llenados desde un registro en LDAP (una vez encontrados). <br/>A modo de ejemplo, `{\"cn\":\"name\", \"mail\":\"email\"}` elegira el nombre legible de una persona desde el atributo cn, y su correo electronico desde el atributo de correo electronico.</br/> Campos disponibles `nombre` y `correo electronico`.","LDAP_Sync_Users":"Los usuarios de sincronización","LDAP_Test_Connection":"Probar Conexión ","LDAP_Unique_Identifier_Field":"Campo de Identificador Único ","LDAP_Unique_Identifier_Field_Description":"Qué campo se utilizará para vincular al usuario LDAP y el usuario Rocket.Chat. Puede informar a varios valores separados por una coma para tratar de obtener el valor del registro de LDAP. <br/> El valor por defecto es `objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueid, uidNumber`","LDAP_Use_Custom_Domain_Search":"Usar la búsqueda de dominio personalizado","LDAP_Use_Custom_Domain_Search_Description":"Escribir su propio filtro a los usuarios buscar en el servidor LDAP.","LDAP_Username_Field":"Campo de Nombre de Usuario","LDAP_Username_Field_Description":"Qué campo se utilizará como nombre de usuario * * para los nuevos usuarios. Dejar en blanco para usar el nombre de usuario informado en la página de inicio de sesión. <br/> Puede utilizar etiquetas de plantilla también, como `# {} GivenName. # {Sn}`. <br/> El valor por defecto es `sAMAccountName`.","Leave_Group_Warning":"¿Seguro que quieres dejar el grupo \" %s\"?","Leave_Private_Warning":"¿Seguro que quieres salir de la discusión con \" %s\"?","Leave_room":"Salir de la sala","Leave_Room_Warning":"¿Seguro que quieres salir de la habitación \" %s\"?","line":"linea","List_of_Direct_Messages":"Lista de mensajes directos","Live_sessions":"Sesiones en vivo","Livechat_agents":"Agentes de livechat","Livechat_Dashboard":"Tablero de instrumentos Livechat","Livechat_enabled":"Livechat habilitado","Livechat_Manager":"Supervisor de livechat","Livechat_managers":"Supervisores de livechat","Livechat_title":"Titulo del Chat en Vivo","Livechat_title_color":"Color de Fondo del Titulo del Chat en Linea","Livechat_Users":"Los usuarios liveChat","Load_more":"Cargar más","Loading...":"Cargando...","Loading_more_from_history":"Cargando mas desde el historial","Loading_suggestion":"Cargando sugerencias...","Localization":"Localización","Log_File":"Mostrar Archivo y Linea","Log_Level":"Nivel de Registro","Log_Package":"Mostrar Paquete","Log_View_Limit":"Ver limite del registro","Logged_out_of_other_clients_successfully":"Cerrado la sesión de otros clientes con éxito","Login":"Iniciar Sesión","Login_with":"Inicia sesión con %s","login_with":"O inicia sesión directamente con","Logout":"Cerrar sesión","Logout_Others":"Cerrar sesión De Otros Lugares de sesión","Mail_Message_Invalid_emails":"Correos electrónicos que nos ha proporcionado uno o más válidos: %s","Mail_Message_Missing_to":"Debe seleccionar uno o más usuarios o proporcionar una o más direcciones de correo electrónico, separadas por comas.","Mail_Message_No_messages_selected_select_all":"No ha seleccionado ningún mensaje. ¿Le gustaría <a href='#' class='select-all'>seleccionar todos los</a> mensajes visibles?","Mail_Messages":"Los mensajes de correo","Mail_Messages_Instructions":"Seleccione los mensajes que desea enviar por correo electrónico haciendo clic en los mensajes","Mail_Messages_Subject":"Aquí hay una parte seleccionada de %s mensajes","Mailer":"Remitente","Mailer_body_tags":"<b>Debe</b> utilizar [darse de baja] para el enlace de anulación de la suscripción. <br /> Es posible utilizar [nombre], [fname], [lname] para el nombre completo del usuario, nombre o apellido, respectivamente. <br /> Es posible utilizar [e-mail] para el correo electrónico del usuario.","Make_Admin":"Crear admin","Manager_added":"Supervisor agregado","Manager_removed":"Supervisor eliminado","Mark_as_read":"Marcar como leido","Markdown_Headers":"Encabezados Markdown","Markdown_SupportSchemesForLink":"Planes de apoyo de rebajas de Enlace","Markdown_SupportSchemesForLink_Description":"Lista separada por comas de los esquemas permitidos","Members_List":"Lista de Miembros","Mentions":"Menciones","Mentions_default":"Menciones (por defecto)","Message":"Mensaje","Message_AllowDeleting":"Permitir la eliminacion de mensajes","Message_AllowEditing":"Permitir la edición de mensajes","Message_AllowEditing_BlockEditInMinutes":"Bloquear la Edicion de Mensajes Despues de (n) Minutos","Message_AllowEditing_BlockEditInMinutesDescription":"Ingrese 0 para deshabilitar el bloqueo.","Message_AllowPinning":"Permitir que se fijen los mensajes","Message_AllowPinning_Description":"Permitir que los mensajes se puedan anclar a cualquier canal.","Message_AllowStarring":"Permitir Destacar  un Mensaje","Message_AudioRecorderEnabled":"Grabadora de Audio Habilitada","Message_AudioRecorderEnabledDescription":"Requiere que los archivos del tipo 'audio/wav' sean un tipo de archivo valido dentro de las opciones de 'Carga de Archivos'.","Message_DateFormat":"Formato de fecha","Message_DateFormat_Description":"Ver también: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"La eliminación de mensajes no esta permitida","Message_editing_blocked":"Este mensaje ya no puede ser editado","Message_editing_not_allowed":"La edición de mensajes no esta permitida","Message_GroupingPeriod":"Periodo de Agrupamiento (en segundos)","Message_GroupingPeriodDescription":"Los mensajes se agruparan con mensajes previos si ambos provienen del mismo usuario y el tiempo transcurrido fue menor al tiempo informado en segundos.","Message_KeepHistory":"Mantener el historial de mensajes","Message_MaxAllowedSize":"Tamaño Máximo Permitido de Mensaje","Message_MaxAll":"El tamaño máximo de canales para el mensaje ALL","Message_pinned":"Mensaje fijado","Message_pinning_not_allowed":"No se permite el fijar mensajes","Message_removed":"Mensaje removido","Message_ShowDeletedStatus":"Mostrar el estado de eliminación","Message_ShowEditedStatus":"Mostrar el estado de edición","Message_ShowFormattingTips":"Mostrar Sugerencias de Formato","Message_TimeFormat":"Formato de tiempo","Message_TimeFormat_Description":"Ver también: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Mensaje demasiado largo","Messages":"Mensajes","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Los mensajes enviados al WebHook Entrante serán publicados aqui.","Meta":"Meta","Meta_fb_app_id":"App Id de Facebook","Meta_google-site-verification":"Verificación del sitio de Google","Meta_language":"Lenguaje","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minutos","Mobile_push":"Push Mobile","More_channels":"Más canales","More_direct_messages":"Más mensajes directos","More_groups":"Mas grupos privados","More_unreads":"Mas sin leer","Msgs":"Mensajes","multi":"multi","Mute_someone_in_room":"Silenciar a alguien en la sala","Mute_user":"Silenciar Usuario","Muted":"Silenciado","My_Account":"Mi cuenta","n_messages":"%s mensajes","N_new_messages":" %s nuevos mensajes","Name":"Nombre","Name_cant_be_empty":"El Nombre no puede estar vacio","Name_of_agent":"Nombre del Agente","Name_optional":"Nombre (opcional)","Navigation_History_20_last_pages":"Historial de Navegacion (Ultimas 20 paginas)","New_Application":"Nueva aplicación","New_Custom_Field":"Nuevo campo personalizado","New_Department":"Nuevo Departamento","New_integration":"Nueva integración ","New_logs":"nuevos registros","New_messages":"Nuevos mensajes","New_password":"Nueva contraseña","New_role":"Rol nuevo","No_channel_with_name_%s_was_found":"Ningún canal con el nombre <strong>\"%s\"</strong> a sido encontrado!","No_channels_yet":"Todavía no eres parte de un canal.","No_direct_messages_yet":"No has comenzado ninguna conversación aún\n","No_Encryption":"sin cifrado","No_favorites_yet":"No has añadido ningún favorito todavía.","No_group_with_name_%s_was_found":"Ningún grupo privado con el nombre <strong>\"%s\"</strong> a sido encontrado!","No_groups_yet":"Aún no tienes grupos privados.","No_livechats":"No tienes ningun chat en tiempo real.","No_mentions_found":"Ninguna mención encontrada ","No_permission_to_view_room":"No tienes permiso para ver esta sala","No_pinned_messages":"Ningún mensaje anclado","No_results_found":"No se han encontrado resultados","No_starred_messages":"Ningún mensaje destacado","no_tokens_for_this_user":"No hay ningún token para este usuario","No_user_with_username_%s_was_found":"Ningún usuario con el nombre <strong>\"%s\"</strong> a sido encontrado!","Not_allowed":"No permitido","Not_authorized":"No autorizado","Not_Available":"No disponible","Not_found_or_not_allowed":"No encontrado o no permitido","Nothing":"Nada","Nothing_found":"No se encontró nada","Notifications":"Notificaciones","Notify_all_in_this_room":"Notificar a todos en este canal","Num_Agents":"# de Agentes","Number_of_messages":"Número de mensajes","OAuth_Application":"Aplicación de OAuth","OAuth_Applications":"Aplicaciones OAuth","Objects":"Objetos","Off_the_record_conversation":"Off-the-record Conversación","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record conversación no está disponible para el navegador o dispositivo.","Offline_DM_Email":"[__site__] Se le ha contactado directamente por __user__","Offline_Mention_Email":"[__site__] Usted ha sido mencionado por __user__ en #__room__","Old_and_new_password_must_be_different":"La nueva contraseña debe ser diferente de la antigua contraseña.","Old_and_new_password_required":"Es necesario proporcionar tanto la contraseña anterior como la nueva para cambiar su contraseña","Online":"Conectado","Only_errors":"Solamente errores","Only_you_can_see_this_message":"Solo tu puedes ver este mensaje","Oops!":"Huy","Open":"Abierto","Opened":"Abierto","Opt_out_statistics":"No enviar mis estadísticas de uso a Rocket.Chat","Opt_out_statistics_warning":"Al enviar tus estadísticas de uso, nos estarás ayudando a identificar cuantas instancias de Rocket.Chat se han desplegado, así como a saber como se esta comportando el programa para poderlo mejorar todavía mas. No te preocupes, ninguna información de usuario es enviada y toda la información que recibimos es confidencial. Si deseas seguir enviándonos tus estadistas de uso, desactiva la casilla de verificación de arriba. Muchas Gracias!","optional":"opcional","Order":"Orden","OS_Arch":"Arquitectura de SO","OS_Cpus":"Conteo de CPU del SO","OS_Freemem":"Memoria Libre del SO","OS_Loadavg":"Promedio de Carga del SO","OS_Platform":"Plataforma del SO","OS_Release":"Versión del SO","OS_Totalmem":"Memoria Total del SO","OS_Type":"Tipo de SO","OS_Uptime":"Tiempo de funcionamiento del SO","others":"otros","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR sólo está disponible cuando los usuarios están en línea","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL de alteración a la que se cargan los archivos. Este sitio de Internet también se utiliza para las descargas a menos de un CDN es dado","Password":"Contraseña","Password_Change_Disabled":"Tu administrador de Rocket.Chat ha deshabilitado la opción para cambiar contraseñas.","Password_changed_successfully":"La contraseña fue cambiada con éxito","Payload":"Carga útil","People":"Gente","Permissions":"Permisos","Pin_Message":"Anclar Mensaje","Pinned_a_message":"Fijado un mensaje:","Pinned_Messages":"Mensajes Anclados","Placeholder_for_email_or_username_login_field":"Marcador de posición para el campo de correo electrónico o nombre de usuario de inicio de sesión","Placeholder_for_password_login_field":"Marcador de posición para el campo de la contraseña de inicio de sesión","Please_answer_survey":"Por favor tome un momento para responder una encuesta rápida sobre este chat","Please_enter_value_for_url":"Por favor introduzca un valor para la url de tu avatar.","Please_enter_your_new_password_below":"Por favor, introduzca a continuación su nueva contraseña:","Please_fill_a_label":"Por favor llene una etiqueta","Please_fill_a_name":"Por favor introduzca su nombre","Please_fill_a_username":"Por favor ingrese un nombre de usuario","Please_fill_name_and_email":"Por favor introduzca su usuario y correo electronico. ","Please_re_enter_your_password":"Por favor re ingrese su contraseña","Please_select_enabled_yes_or_no":"Por favor elija una opción para Habilitar","Please_wait":"Por favor espera","Please_wait_activation":"Por favor espere, esto puede tomar algún tiempo.","Please_wait_statistics":"Por favor espere, se están generando las estadísticas.","Please_wait_while_OTR_is_being_established":"Por favor espere mientras se está estableciendo OTR","Please_wait_while_your_account_is_being_deleted":"Por favor, espere mientras se elimina su cuenta ...","Please_wait_while_your_profile_is_being_saved":"Por favor, espere mientras que su perfil se guarda ...","Post_as":"Publicar como","Post_to_Channel":"Publicar al Canal","Post_to_s_as_s":"Publicar a <strong>%s</strong> como <strong>%s</strong>","Powered_by":"Desarrollado por","Preferences":"Preferencias","Preferences_saved":"Preferencias guardadas","Privacy":"Privacidad","Private_Group":"Grupo Privado","Private_Groups":"Grupos Privados","Private_Groups_list":"Lista de Grupos Privados","Profile":"Perfil","Profile_saved_successfully":"Perfil guardado correctamente","Proudly_developed":"Orgullosamente desarrollado con Meteor","Push":"empujar","Push_apn_cert":"Certificado de APN","Push_apn_dev_cert":"Certificado de APN de desarrollador","Push_apn_dev_key":"Llave de APN de desarrollador","Push_apn_dev_passphrase":"Frase de contraseña APN de desarrollador","Push_apn_key":"Llave de APN","Push_apn_passphrase":"Frase de contraseña APN","Push_debug":"Depurar","push_disabled":"empuje discapacitados","Push_enable":"Habilitar","Push_enable_gateway":"Habilitar Puerta de Enlace","Push_gateway":"Puerta de Enlace","Push_gcm_api_key":"Llave del API GCM","Push_gcm_project_number":"Numero de Projecto de GCM","Push_production":"Producción","Push_show_message":"Muestra el mensaje de notificación","Push_show_username_room":"Mostrar canal / grupo / nombre de usuario en la notificación","Push_test_push":"Prueba","Query":"Consulta","Query_description":"Condiciones adicionales para determinar a que usuarios enviar el correo electronico. Los usuarios que optaron por cancelar su suscripción serán eliminados de la consulta. Debe ser JSON valido. Ejemplo: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Búsqueda rápida","quote":"cita","Reactions":"reacciones","Recents":"Recientes","Record":"Grabar","Redirect_URI":"URI de redireccionamiento","Refresh_keys":"llaves de refresco","Refresh_your_page_after_install_to_enable_screen_sharing":"Refresque su pantalla después de la instalación para permitir compartir su pantalla","Register":"Registrar una nueva cuenta","Registration_Succeeded":"Registro Exitoso","Remember_me":"Recuérdame","Remove":"Borrar","Remove_Admin":"Eliminar Admin","Remove_as_moderator":"Retire como moderador","Remove_as_owner":"Retire como propietario","Remove_custom_oauth":"Eliminar oauth personalizado","Remove_from_room":"Eliminado de la sala","Remove_someone_from_room":"Eliminar a alguien de la sala","Removed":"Eliminado","Require_password_change":"Requerir el cambio de contraseña","Resend_verification_email":"Reenviar correo electrónico de verificación","Reset":"Reiniciar","Reset_password":"Reiniciar password","Restart":"Reiniciar","Restart_the_server":"Reiniciar el servidor","RocketBot_Enabled":"RocketBot ha sido Habilitado","RocketBot_Name":"Nombre de RocketBot","RocketBot_Name_Description":"El nombre asignado a RocketBot debe ser un nombre de usuario valido en su servidor","Role":"Rol","Role_Editing":"Ediciones de Roles","Role_removed":"Rol Eliminado","Room":"Sala","Room_archivation_state":"Estado","Room_archivation_state_false":"Activo","Room_archivation_state_true":"archivado","Room_archived":"sala de archivado","room_changed_privacy":"Tipo de sala cambiado a:  <em>__room_type__</em> por<em>__user_by__</em>","room_changed_topic":"Tema del la sala cambiado a:  <em>__room_topic__</em> por <em>__user_by__</em>","Room_has_been_deleted":"La Sala a sido eliminada","Room_Info":"Info de la Sala","Room_name_changed":"El nombre de la sala ha sido cambiado a: <em>__room_name__</em> por <em>__user_by__</em>","Room_name_changed_successfully":"El nombre de la sala fue cambiado con éxito","Room_not_found":"Sala no encontrada","Room_topic_changed_successfully":"tema habitación cambiado con éxito","Room_type_changed_successfully":"Tipo de habitación cambiado correctamente","Room_unarchived":"habitación no archivada","Room_uploaded_file_list":"Lista de Archivos","Room_uploaded_file_list_empty":"Ningún archivo disponible.","room_user_count":"%s usuarios","Rooms":"Salas","S_new_messages_since_s":"%s nuevos mensajes desde %s","SAML":"SAML","SAML_Custom_Cert":"Certificado Personalizado ","SAML_Custom_Entry_point":"Punto de Entrada Personalizado","SAML_Custom_Generate_Username":"Generar Nombre de Usuario","SAML_Custom_Issuer":"Emisor Personalizado","SAML_Custom_Provider":"Proveedor Personalizado","Save":"Guardar","Save_changes":"Guardar cambios","Save_Mobile_Bandwidth":"Ahorrar Ancho de Banda Movil","Save_to_enable_this_action":"Guardar para permitir esta acción","Saved":"Guardado","Saving":"Guardando","Scope":"Alcance","Screen_Share":"Compartir Pantalla","Script_Enabled":"Guión Habilitado","Search":"Buscar","Search_by_username":"Búsqueda por nombre de usuario","Search_Channels":"Canales de búsqueda","Search_Direct_Messages":"Buscar mensajes directos","Search_Messages":"Buscar Mensajes","Search_Private_Groups":"Grupos privados","Search_settings":"Configuración de búsqueda","seconds":"segundos","See_all":"Ver todos","See_only_online":"Sólo en línea","Select_a_department":"Seleccionar un departamento","Select_an_avatar":"Selecciona un avatar","Select_file":"Selecciona archivo","Select_service_to_login":"Selecciona un servicio para iniciar sesión y cargar tu imagen o sube una foto de tu computadora","Select_user":"Seleccionar usuario","Select_users":"Seleccione los usuarios","Selected_agents":"agentes seleccionados","Selected_users":"Miembros seleccionados","Send":"Enviar","Send_a_message":"Enviar mensaje","Send_a_test_mail_to_my_user":"Enviar un mensaje de prueba a mi usuario","Send_a_test_push_to_my_user":"Enviar un impulso de prueba para mi usuario","Send_confirmation_email":"Enviar email de confirmación","Send_data_into_RocketChat_in_realtime":"Enviar datos a Rocket.Chat en tiempo real.","Send_email":"Enviar Correo Electronico","Send_invitation_email":"Enviar invitación por correo electronico","Send_invitation_email_error":"No has proporcionado ninguna dirección de correo electrónico valida. ","Send_invitation_email_info":"Puede enviar múltiples invitaciones por correo electronico a la vez","Send_invitation_email_success":"Has enviado con éxito una invitación por correo electronico a las siguientes direcciones:","Send_invitation_email_warning":"Para poder enviar invitaciones por correo electronico, tiene que configurar los parametros de SMTP ","Send_Message":"Enviar Mensaje","Send_your_JSON_payloads_to_this_URL":"Envíe sus cargas útiles JSON a esta dirección URL.","Sending":"Enviando...","Set_as_moderator":"Establezca como moderador","Set_as_owner":"Establecer como propietario","Settings":"Configuración","Settings_updated":"Se han actualización las opciones ","Should_be_a_URL_of_an_image":"Debe de ser un URL de una imagen. ","Should_exists_a_user_with_this_username":"Ya debe existir el usuario.","Show_all":"Mostrar todo","Show_more":"Mostrar más","Show_only_online":"Mostrar sólo la línea","Show_preregistration_form":"Mostrar formulario de inscripción previa","Showing_archived_results":"<p> Mostrando resultados <b>archivados %s</b> </p>","Showing_online_users":"Mostrando <b>__total_showing__</b> de __total__ usuarios","Showing_results":"<p>Mostrando <b>%s</b> resultados</p>","Silence":"Silencio","since_creation":"desde %s","Site_Name":"Nombre del Sitio","Site_Url":"URL del Sitio","Site_Url_Description":"Ejemplo: https://chat.domain.com","Skip":"Saltar","Smileys_and_People":"Smileys e personas","SMTP":"SMTP","SMTP_Host":"Anfitrión SMTP","SMTP_Password":"Contraseña SMTP","SMTP_Port":"Puerto SMTP","SMTP_Test_Button":"Prueba de valores de SMTP","SMTP_Username":"Usuario SMTP","Sound":"Sonido","Star_Message":"Destacar un Mensaje","Starred_Messages":"Mensajes Destacados","Start_audio_call":"Iniciar llamada","Start_Chat":"Iniciar chat","Start_of_conversation":"Inicio de la conversación","Start_OTR":"Inicio OTR","Start_video_call":"Iniciar video llamada","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Inicia con <code class=\"inline\">%s</code> para un usuario o <code class=\"inline\">%s</code> para un canal. Ejem: <code class=\"inline\">%s</code> o <code class=\"inline\">%s</code>","Statistics":"Estadisticas","Stats_Active_Users":"Usuarios Activos","Stats_Avg_Channel_Users":"Promedio de Usuarios por Canal","Stats_Avg_Private_Group_Users":"Promedio de Usuarios por Grupo Privado","Stats_Away_Users":"Usuarios Ausentes","Stats_Max_Room_Users":"Maximo de Usuarios por Sala","Stats_Non_Active_Users":"Usuario Inactivos","Stats_Offline_Users":"Usuarios Desconectados","Stats_Online_Users":"Usuarios Conectados","Stats_Total_Channels":"Total de Canales","Stats_Total_Direct_Messages":"Total de Salas de Mensajes Directos","Stats_Total_Messages":"Total del Mensajes","Stats_Total_Private_Groups":"Total de Grupos Privados","Stats_Total_Rooms":"Total de Salas","Stats_Total_Users":"Total del Usuarios","Stop_Recording":"Detener Grabacion","strike":"strike","Subject":"Tema","Submit":"Enviar","Success":"Exito","Survey":"Encuesta","Survey_instructions":"Califique cada pregunta de acuerdo a su nivel de satisfacción, 1 para completamente insatisfecho y 5 para completamente satisfecho.","Symbols":"símbolos","Sync_success":"el éxito de sincronización","Sync_Users":"Los usuarios de sincronización","Test_Connection":"Conexión de prueba","Test_Desktop_Notifications":"Prueba las notificaciones de escritorio","Thank_you_for_your_feedback":"Gracias por su retroalimentación.","The_application_name_is_required":"Se requiere que el nombre de la aplicación","The_channel_name_is_required":"El nombre del canal es requerido","The_emails_are_being_sent":"Los correos electrónicos están siendo enviados","The_field_is_required":"El campo %s es obligatorio","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"El ajuste de tamaño de imágenes no funcionara porque no detectamos que estén instalados en su servidor ni  Imagemagick o GraphicsMagick.","The_redirectUri_is_required":"El Uri de redireccionamiento es requerido","The_server_will_restart_in_s_seconds":"El servidor se reiniciara en %s segundos","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"La <strong>configuración %s</strong> está configurado <strong>para %s</strong> y está accediendo <strong>desde %s!</strong>","The_user_will_be_removed_from_s":"El usuario sera eliminado de %s","The_user_wont_be_able_to_type_in_s":"El usuario no podra introducir datos en %s","Theme":"Tema","theme-color-action-buttons-color":"Acciones botones de colores","theme-color-active-channel-background-color":"Canal activo Color de fondo","theme-color-active-channel-font-color":"Canal activo Color de fuente","theme-color-blockquote-background":"Color del Fondo del Bloque de Citas","theme-color-clean-buttons-color":"Limpias botones de colores","theme-color-code-background":"Color del Fondo de Bloque de Codigo","theme-color-code-border":"Color del Borde del Bloque de Codigo","theme-color-code-color":"Codigo del Color","theme-color-content-background-color":"Color del Fondo del Contenido","theme-color-custom-scrollbar-color":"Barra de desplazamiento de color personalizado","theme-color-info-active-font-color":"Color de la Fuente de la Información Activa","theme-color-info-font-color":"Color de la Fuente de Informacion","theme-color-input-font-color":"Color de la Fuente de Entrada","theme-color-link-font-color":"Color de la Fuente de los Hipervinculos","theme-color-message-hover-background-color":"Mensaje Hover BG color","theme-color-primary-background-color":"Color Primario del Fondo ","theme-color-primary-font-color":"Color Primario de la Fuente","theme-color-quaternary-font-color":"Cuaternario Color de fuente","theme-color-secondary-background-color":"Color Secundario del Fondo","theme-color-secondary-font-color":"Color Secundario de la Fuente","theme-color-smallprint-font-color":"La letra pequeña fuente Color","theme-color-smallprint-hover-color":"La letra pequeña de la libración del color","theme-color-status-away":"Color del Estado Ausente","theme-color-status-busy":"Ocupado Color Estado","theme-color-status-offline":"Color del Estado Desconectado","theme-color-status-online":"Color del Estado Conectado","theme-color-tertiary-background-color":"Color de fondo terciaria","theme-color-tertiary-font-color":"Color de fuente terciaria","theme-color-unread-notification-color":"Sin leer Notificaciones color","theme-custom-css":"CSS personalizado","There_are_no_agents_added_to_this_department_yet":"Todavia no hay ningún agente agregado a este departamento.","There_are_no_integrations":"No hay integraciones","There_are_no_users_in_this_role":"No hay ningún usuario en este rol","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Este correo electrónico ya se ha utilizado y no se ha verificado. Por favor, cambie su contraseña.","This_is_a_desktop_notification":"Se trata de una notificación de escritorio","This_is_a_push_test_messsage":"Se trata de mensajes con la prueba de empuje","Time_in_seconds":"Tiempo en segundos","Title_bar_color":"Color de la Barra de Titulo","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Para instalar Rocket.Chat Livechat en su sitio web, copia y pega este código por encima de la última etiqueta <strong></ body></strong> en su sitio.","To_users":"para los usuarios","Topic":"Tema","Travel_and_Places":"Viajes y Lugares","Trigger_removed":"gatillo eliminado","Trigger_Words":"Las palabras de activación","Triggers":"disparadores","True":"Verdadero","Type":"Tipo","Type_your_new_password":"Escriba la nueva contraseña","Unarchive":"Desarchivar","Unmute_someone_in_room":"De-silenciar a alguien en la sala","Unmute_user":"De-silenciar Usuario","Unnamed":"Sin nombre","Unpin_Message":"Desanclar Mensaje","Unread_Rooms":"Salas sin leer","Unread_Rooms_Mode":"Modo Salas sin leer","Unstar_Message":"Eliminar Destacado","Upload_file_question":"Subir archivo?","Uploading_file":"Subiendo Archivo...","Use_account_preference":"Use cuenta la preferencia","Use_Emojis":"Usar Emojis","Use_initials_avatar":"Usar las iniciales de tu nombre de usuario","use_menu":"Usa el menú lateral para acceder a tus salas y chats","Use_service_avatar":"Usar %s avatar","Use_this_username":"Usar este nombre de usuario","Use_uploaded_avatar":"Utilizar avatar subido","Use_url_for_avatar":"Usa url para avatar","User__username__is_now_a_moderator_of__room_name_":"El usuario __username__ es ahora moderador de la sala  __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ usuario es ahora un titular de __room_name__","User__username__removed_from__room_name__moderators":"El Usuario __username__ a sido eliminado como moderador de la sala __room_name__ ","User__username__removed_from__room_name__owners":"__username__ eliminado al usuario de los propietarios __room_name__","User_added":"Usuario <em>__user_added__</em> añadido.","User_added_by":"El usuario <em>__user_added__</em> ha sido añadido por <em>__user_by__</em>.","User_added_successfully":"Usuario añadido correctamente","User_Channels":"Canales de Usuario","User_doesnt_exist":"Ningun usuario con el nombre `@%s` existe.","User_has_been_activated":"El usuario a sido activado","User_has_been_deactivated":"El usuario a sido desactivado","User_has_been_deleted":"El usuario a sido eliminado","User_has_been_muted_in_s":"El usuario a sido silenciado en %s","User_has_been_removed_from_s":"El usuario a sido eliminado en %s","User_has_disconnected":"El usuario ha desconectado","User_Info":"Info de Usuario","User_is_no_longer_an_admin":"El usuario ya no es un administrador","User_is_not_activated":"El usuario no ha sido activado","User_is_now_an_admin":"El usuario ahora es un administrador","User_joined_channel":"Se ha unido al canal.","User_joined_channel_female":"Se ha unido al canal","User_joined_channel_male":"Se ha unido al canal","User_left":"<em>__user_left__</em> ha salido del canal.","User_left_female":"Ha salido del canal","User_left_male":"Ha salido del canal","User_logged_out":"El usuario está desconectado","User_management":"Administracion de Usuarios","User_muted_by":"<em>__user_muted__</em> Usuario ha silenciado por <em>__user_by__.</em>","User_muted_in_room":"Usuario silenciado en la sala","User_not_found":"Usuario no encontrado","User_not_found_or_incorrect_password":"Usuario no encontrado o contraseña no valida","User_or_channel_name":"Nombre de usuario o canal","User_removed":"Usuario eliminado","User_removed_by":"El usuario <em>__user_removed__</em> ha sido eliminado por <em>__user_by__</em>.","User_removed_from_room":"El usuario a sido eliminado de la sala","User_Settings":"Opciones de usuario","User_unmuted_by":"<em>__user_unmuted__</em> Usuario desactivar el silencio <em>__user_by__.</em>","User_unmuted_in_room":"Usuario de-silenciado en la sala","User_updated_successfully":"Usuario actualizado exitosamente","Username":"Nombre de usuario","Username_and_message_must_not_be_empty":"Nombre de usuario y el mensaje no debe estar vacío.","Username_cant_be_empty":"El nombre de usuario no puede estar vacío","Username_Change_Disabled":"Su administrador de Rocket.Chat ha des habilitado el cambio de nombres de usuario","Username_denied_the_OTR_session":"__username__ negó la sesión OTR","Username_description":"El nombre de usuario se utiliza para permitir que otros te mencionen en los mensajes.","Username_doesnt_exist":"El usuario `%s` no existe.","Username_ended_the_OTR_session":"__username__ terminó la sesión OTR","Username_invalid":"<strong>%s</strong> no esu nombre de usuario válido,<br/> usa solo letras, números, puntos y guiones","Username_is_already_in_here":"`@%s` ya esta aqui.","Username_is_not_in_this_room":"El usuario `#%s` no se encuentra en esta sala","Username_not_found":"Nombre de usuario no encontrado","Username_title":"Registrar nombre de usuario\n","Username_unavaliable":"<strong>%s</strong> ya está en uso :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ quiere empezar OTR. ¿Quieres aceptar?","Users":"Usuarios","Users_in_role":"Usuarios en el rol","UTF8_Names_Slugify":"Slugify de Nombres UTF8","UTF8_Names_Validation":"Validación de Nombres UTF8","UTF8_Names_Validation_Description":"No se permiten caracteres especiales ni espacios. Puede user - _ y . pero no al final de un nombre.","Verification_email_sent":"Verificación de correo electrónico enviado","View_All":"Ver todo","View_Logs":"Ver Registros","Visibility":"Visibilidad","Visible":"Visible","Visitor":"Visitante","Visitor_page_URL":"URL de la pagina de Visitantes","Visitor_time_on_site":"Tiempo de visitantes en el sitio","Wait_activation_warning":"Antes de poder iniciar sesión, su cuenta debe ser activada manualmente por un administrador.","We_are_offline_Sorry_for_the_inconvenience":"Fuera de Linea. Disculpe las molestias.","We_have_sent_password_email":"Te hemos enviado un e-mail con las instrucciones para resetear la contraseña. Si no recibes un correo en breve, por favor regresa y vuelve a intentarlo.","We_have_sent_registration_email":"Te hemos enviado un e-mail para confirmar tu registro. Si no recibes un correo en breve, por favor regresa y vuelve a intentarlo.","WebRTC_Enable_Channel":"Habilitar para Canales Publicos","WebRTC_Enable_Direct":"Habilitar para Mensajes Directos","WebRTC_Enable_Private":"Habilitar para Canales Privados","WebRTC_Servers":"Servidores STUN / TURN","WebRTC_Servers_Description":"Una lista de servidores STUN y TURN separadas por comas. <br/> Nombre de usuario, contraseña y el puerto están permitidos en el formato 'nombre de usuario: contraseña @ paralizante: host: port` o `nombre de usuario: contraseña @ a su vez: host: port`.","Welcome":"Bienvenido <em>%s</em>.","Welcome_to_the":"Bienvenido a la","will_be_able_to":"será capaz de","With_whom":"Con quien","Yes":"Sí","Yes_clear_all":"Si, borrar todos!","Yes_delete_it":"¡Sí, eliminalo!","Yes_hide_it":"Sí, ocultarlo!","Yes_leave_it":"Sí, lo dejas!","Yes_mute_user":"Si, silenciar usuario!","Yes_remove_user":"Si, eliminar usuario!","you_are_in_preview_mode_of":"Estás en modo vista previa del canal #<strong>__room_name__</strong>","You_are_logged_in_as":"Has iniciado sesión como","You_are_not_authorized_to_view_this_page":"No está autorizado para ver esta página.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Usted es el último propietario. Por favor, establece nuevo propietario antes de salir de la habitación.","You_can_change_a_different_avatar_too":"Puede anular el avatar usado para publicar desde esta integración.","You_can_use_an_emoji_as_avatar":"También puede utilizar un emoji como avatar.","You_have_been_muted":"Has sido silenciado y no podrás hablar en esta sala","You_have_not_verified_your_email":"Aún no ha comprobado su correo electrónico.","You_have_successfully_unsubscribed":"Se ha dado de baja correctamente de nuestra lista de Distribución de Correos","You_informed_an_invalid_FROM_address":"Ha ingresado una dirección invalida en el campo De","You_must_provide_the_unsubscribe_link":"Debe proporcionar el enlace [darse de baja].","You_need_confirm_email":"¡Es necesario confirmar tu correo electrónico para poder identificarte!","You_need_install_an_extension_to_allow_screen_sharing":"Necesita instalar una extensión para permitir compartir su pantalla","You_need_to_change_your_password":"Es necesario cambiar la contraseña","You_need_to_type_in_your_password_in_order_to_do_this":"Usted tiene que escribir su contraseña con el fin de hacer esto!","You_need_to_type_in_your_username_in_order_to_do_this":"Es necesario que teclear su nombre de usuario con el fin de hacer esto!","You_need_to_verifiy_your_email_address_to_get_notications":"Es necesario haber comprobado su dirección de correo electrónico para recibir notificaciones","You_should_name_it_to_easily_manage_your_integrations":"Nombralo para poder administrar fácilmente sus integraciones","You_will_not_be_able_to_recover":"No podrás recuperar este mensaje!","You_will_not_be_able_to_recover_file":"Usted no será capaz de recuperar este archivo!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"No recibirá notificaciones por correo electrónico, ya que no ha comprobado su correo electrónico.","Your_email_has_been_queued_for_sending":"Su correo electrónico ha puesto en cola para enviar","Your_entry_has_been_deleted":"Tu entrada ha sido eliminada","Your_file_has_been_deleted":"Tu archivo ha sido eliminado.","Your_mail_was_sent_to_s":"Su correo electrónico fue enviado a %s","Your_Open_Source_solution":"Tu propia solución de chat de código abierto","Your_password_is_wrong":"Su contraseña es incorrecta!","Your_push_was_sent_to_s_devices":"Su impulso fue enviado a los dispositivos %s"});
TAPi18n._registerServerTranslator("es", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/fa.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["fa"] = ["Persian","فارسی"];                                                                   // 8
if(_.isUndefined(TAPi18n.translations["fa"])) {                                                                        // 9
  TAPi18n.translations["fa"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["fa"][namespace])) {                                                             // 13
  TAPi18n.translations["fa"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["fa"][namespace], {"500":"خطای داخلی سرور","0_Errors_Only":"0 - خطاها فقط","1_Errors_and_Information":"1 - خطاها و اطلاعات","2_Erros_Information_and_Debug":"2 - Erros، اطلاعات و اشکال زدایی","__username__was_set__role__by__user_by_":"_نام کاربری_ __role__ توسط __user_by__ تعیین شد","__username__is_no_longer__role__defined_by__user_by_":"_نام کاربری_ است که دیگر __role__، توسط __user_by__","Access_not_authorized":"دسترسی مجاز","Access_online_demo":"دسترسی به نسخه ی نمایشی آنلاین","Access_Online_Demo":"دسترسی به نسخه ی نمایشی آنلاین","Access_Token_URL":"URL دسترسی به رمز","Accounts":"حساب ها","Accounts_AllowDeleteOwnAccount":"اجازه به کاربران برای حذف حساب کاربری خود","Accounts_AllowedDomainsList":"فهرست دامنههای مجاز","Accounts_AllowedDomainsList_Description":"جدا شده با کاما از دامنه مجاز","Accounts_AllowEmailChange":"اجازه می دهد ایمیل تغییر","Accounts_AllowPasswordChange":"اجازه تغییر رمز ورود","Accounts_AllowUserAvatarChange":"کاربر اجازه می دهد آواتار تغییر","Accounts_AllowUsernameChange":"اجازه می دهد نام کاربری تغییر","Accounts_AllowUserProfileChange":"کاربر اجازه می دهد مشخصات تغییر","Accounts_AvatarResize":"تغییر اندازه آواتار ها","Accounts_AvatarSize":"آواتار حجم","Accounts_AvatarStorePath":"مسیر آواتار ذخیره سازی","Accounts_AvatarStoreType":"آواتار نوع ذخیره سازی","Accounts_BlockedDomainsList":"مسدود شده فهرست دامنه","Accounts_BlockedDomainsList_Description":"جدا شده با کاما از حوزه های مسدود شده","Accounts_denyUnverifiedEmail":"انکار ایمیل تأیید نشده","Accounts_EmailVerification":"تأیید پست الکترونیکی","Accounts_EmailVerification_Description":"اطمینان حاصل کنید که تنظیمات SMTP صحیح برای استفاده از این ویژگی","Accounts_Enrollment_Email":"ثبت نام پست الکترونیک","Accounts_Enrollment_Email_Description":"شما ممکن است [نام]، [fname] برای نام کامل کاربر، نام اول یا نام خانوادگی، به ترتیب استفاده کنید، [آنگاه]. <br /> ممکن است [ایمیل] برای ایمیل کاربر استفاده کنید.","Accounts_Iframe_api_method":"روش API","Accounts_Iframe_api_url":"URL API","Accounts_iframe_enabled":"فعال","Accounts_iframe_url":"از iframe آدرس","Accounts_LoginExpiration":"انقضا ورود در روز","Accounts_ManuallyApproveNewUsers":"تأیید دستی کاربران جدید","Accounts_OAuth_Custom_Token_Sent_Via":"رمز ارسال شده از طریق","Accounts_OAuth_Custom_Authorize_Path":"اجازه راه","Accounts_OAuth_Custom_Button_Color":"رنگ دکمه","Accounts_OAuth_Custom_Button_Label_Color":"رنگ دکمه متن","Accounts_OAuth_Custom_Button_Label_Text":"متن دکمه","Accounts_OAuth_Custom_Enable":"قادر ساختن","Accounts_OAuth_Custom_id":"شناسه","Accounts_OAuth_Custom_Identity_Path":"مسیر هویت","Accounts_OAuth_Custom_Login_Style":"سبک ورود","Accounts_OAuth_Custom_Secret":"راز","Accounts_OAuth_Custom_Token_Path":"مسیر نشانه رمز","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"ورود به فیس بوک","Accounts_OAuth_Facebook_callback_url":"URL فیس بوک مخاطبین","Accounts_OAuth_Facebook_id":"شناسه فیس بوک نرم افزار","Accounts_OAuth_Facebook_secret":"فیس بوک راز","Accounts_OAuth_Github":"OAuth فعال","Accounts_OAuth_Github_callback_url":"URL گیتهاب مخاطبین","Accounts_OAuth_GitHub_Enterprise":"OAuth فعال","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL گیتهاب شرکت نوع مخاطبین","Accounts_OAuth_GitHub_Enterprise_id":"شناسه مشتری","Accounts_OAuth_GitHub_Enterprise_secret":"مشتری راز","Accounts_OAuth_Github_id":"شناسه مشتری","Accounts_OAuth_Github_secret":"مشتری راز","Accounts_OAuth_Gitlab":"OAuth فعال","Accounts_OAuth_Gitlab_callback_url":"URL GitLab مخاطبین","Accounts_OAuth_Gitlab_id":"GitLab ها","Accounts_OAuth_Gitlab_secret":"مشتری راز","Accounts_OAuth_Google":"ورود به سیستم Google","Accounts_OAuth_Google_callback_url":"URL گوگل مخاطبین","Accounts_OAuth_Google_id":"گوگل ID","Accounts_OAuth_Google_secret":"گوگل راز","Accounts_OAuth_Linkedin":"لینک ورود","Accounts_OAuth_Linkedin_callback_url":"URL لینک مخاطبین","Accounts_OAuth_Linkedin_id":"لینک ها","Accounts_OAuth_Linkedin_secret":"ارتباط با راز","Accounts_OAuth_Meteor":"شهاب ورود","Accounts_OAuth_Meteor_callback_url":"URL شهاب مخاطبین","Accounts_OAuth_Meteor_id":"شهاب ها","Accounts_OAuth_Meteor_secret":"شهاب راز","Accounts_OAuth_Twitter":"توییتر ورود","Accounts_OAuth_Twitter_callback_url":"URL توییتر مخاطبین","Accounts_OAuth_Twitter_id":"توییتر ID","Accounts_OAuth_Twitter_secret":"توییتر راز","Accounts_OAuth_Wordpress":"وردپرس ورود","Accounts_OAuth_Wordpress_callback_url":"URL وردپرس مخاطبین","Accounts_OAuth_Wordpress_id":"کد وردپرس","Accounts_OAuth_Wordpress_secret":"وردپرس راز","Accounts_PasswordReset":"تنظیم مجدد رمز عبور","Accounts_Registration_AuthenticationServices_Enabled":"ثبت نام با خدمات احراز هویت","Accounts_RegistrationForm":"فرم ثبت نام","Accounts_RegistrationForm_Disabled":"معلول","Accounts_RegistrationForm_LinkReplacementText":"فرم ثبت نام لینک جایگزین متن","Accounts_RegistrationForm_Public":"عمومی","Accounts_RegistrationForm_Secret_URL":"URL راز","Accounts_RegistrationForm_SecretURL":"فرم ثبت نام راز URL","Accounts_RegistrationForm_SecretURL_Description":"شما باید یک رشته تصادفی است که به URL ثبت نام خود را اضافه فراهم می کند. به عنوان مثال: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"ثبت نام مورد نیاز","Accounts_RequireNameForSignUp":"نیاز به نام برای ثبت نام","Accounts_ShowFormLogin":"ورود مبتنی بر فرم نمایش","Accounts_UseDefaultBlockedDomainsList":"استفاده از پیش فرض مسدود شده فهرست دامنه","Accounts_UseDNSDomainCheck":"استفاده از چک DNS دامنه","Activate":"فعال کردن","Activity":"فعالیت","Add":"اضافه کردن","Add_agent":"اضافه کردن عامل","Add_custom_oauth":"اضافه کردن OAuth حفظ سفارشی","Add_manager":"اضافه کردن بدهید","Add_Members":"اضافه کردن کاربران","Add_User":"اضافه کردن کاربر","Add_user":"اضافه کردن کاربر","Add_users":"اضافه کردن کاربران","Additional_emails":"اضافی ایمیل","Additional_Feedback":"بازخورد اضافی","Administration":"مدیریت","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"پس از احراز هویت از OAuth2، کاربران خواهد شد به این URL هدایت","Agent_added":"عامل اضافه شده","Agent_removed":"عامل حذف","Alias":"نام مستعار","All":"همه","All_channels":"تمام کانال های","All_logs":"تمام سیاهههای","All_messages":"همه پیام","Allow_Invalid_SelfSigned_Certs":"اجازه می دهد نامعتبر خود امضا Certs ارسل","Allow_Invalid_SelfSigned_Certs_Description":"اجازه می دهد به گواهینامه SSL نامعتبر و خود امضا برای اعتبار سنجی لینک و پیش نمایش.","and":"و","And_more":"و __length بیشتر __...","Animals_and_Nature":"حیوانات و طبیعت","API":"API","API_Analytics":"تجزیه و تحلیل ترافیک","API_Embed":"قراردادن","API_EmbedDisabledFor":"قراردادن غیر فعال کردن برای کاربران","API_EmbedDisabledFor_Description":"فهرست کاما جدا از نام های کاربری","API_GitHub_Enterprise_URL":"URL سرور","API_GitHub_Enterprise_URL_Description":"به عنوان مثال: http://domain.com (به جز علامت)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"URL وردپرس","Appearance":"ظاهر","Application_added":"نرم افزار اضافه شده","Application_Name":"نام نرم افزار","Application_updated":"نرم افزار به روز","Apply_and_refresh_all_clients":"درخواست و تازه کردن تمام مشتریان","Archive":"بایگانی","Archive_Unarchive":"بایگانی / لغو بایگانی","are_also_typing":"همچنین تایپ","are_typing":"در حال تایپ کردن","Are_you_sure":"شما مطمئن هستید؟","Are_you_sure_you_want_to_delete_your_account":"آیا شما مطمئن هستید که میخواهید حساب خود را حذف کنید؟","Authorization_URL":"URL مجوز","Authorize":"اجازه دادن","AutoLinker_StripPrefix":"AutoLinker نوار پیشوند","AutoLinker_StripPrefix_Description":"نمایش کوتاه. به عنوان مثال https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL عبارت منظم","AutoLinker_Email":"AutoLinker ایمیل","AutoLinker_Phone":"AutoLinker تلفن","AutoLinker_Phone_Description":"به صورت خودکار برای شماره تلفن در ارتباط است. به عنوان مثال `(123) 456-7890`","Auto_Load_Images":"بار خودکار تصاویر","Available":"در دسترس","Available_agents":"عوامل موجود","Avatar":"آواتار","Avatar_changed_successfully":"آواتار موفقیت تغییر","Avatar_URL":"URL آواتار","Avatar_url_invalid_or_error":"URL ارائه نامعتبر است و یا در دسترس نیست. لطفا دوباره امتحان کنید، اما با یک آدرس متفاوت است.","away":"دور","Away":"دور","away_female":"دور","Away_female":"دور","away_male":"دور","Away_male":"دور","Back":"بازگشت","Back_to_applications":"بازگشت به برنامه های کاربردی","Back_to_integrations":"برگشت به یکپارچگی","Back_to_login":"بازگشت به صفحه ورود","Back_to_permissions":"برگشت به مجوز","Body":"بدن","bold":"جسور","busy":"مشغول","Busy":"مشغول","busy_female":"مشغول","Busy_female":"مشغول","busy_male":"مشغول","Busy_male":"مشغول","Cancel":"لغو کردن","Cannot_delete_a_protected_role":"می تواند نقش محافظت شده را حذف","Cannot_delete_role_because_its_in_use":"می توانید نقش را حذف کنید زیرا در حال استفاده است","Cannot_invite_users_to_direct_rooms":"می تواند کاربران را به طور مستقیم اتاق دعوت","CDN_PREFIX":"CDN پیشوند","Certificates_and_Keys":"گواهینامه ها و کلید","Channel":"کانال","Channel_doesnt_exist":"کانال `# %s` وجود ندارد.","Channels":"کانال","Channels_list":"لیست کانال های عمومی","Chat_Rooms":"اتاق های گفت و گو","Chatops_Enabled":"فعال کردن Chatops","Chatops_Title":"Chatops پنل","Chatops_Username":"Chatops نام کاربری","Choose_a_room":"انتخاب یک اتاق","Choose_messages":"انتخاب پیام","Choose_the_alias_that_will_appear_before_the_username_in_messages":"نام مستعار که قبل از نام کاربری در پیام ظاهر خواهد شد را انتخاب نمایید.","Choose_the_username_that_this_integration_will_post_as":"نام کاربری که این ادغام به عنوان پست را انتخاب کنید.","Clear_all_unreads_question":"پاک کردن تمام unreads؟","Client_ID":"شناسه مشتری","Client_Secret":"مشتری راز","Clients_will_refresh_in_a_few_seconds":"مشتریان در چند ثانیه تازه کردن","close":"بستن","Closed":"بسته","Collapse_Embedded_Media_By_Default":"سقوط رسانه های جاسازی شده به طور پیش فرض","coming_soon":"به زودی","Commands":"دستورات","Compact_View":"جمع و جور نمایش","Confirm_password":"تکرار رمز عبور خود را","Contact":"تماس","Conversation":"گفتگو","Convert_Ascii_Emojis":"تبدیل ASCII به از Emoji","Copied":"کپی","COPY_TO_CLIPBOARD":"کپی به کلیپ بورد","Copy_to_clipboard":"کپی به کلیپ بورد","Count":"شمردن","Create":"ايجاد كردن","Create_new":"ایجاد جدید","Created_at":"ایجاد شده در","Created_at_s_by_s":"ایجاد <strong>در %s</strong> <strong>توسط %s</strong>","Custom_Fields":"موضوعات سفارشی","Custom_oauth_helper":"هنگامی که راه اندازی ارائه دهنده OAuth حفظ خود را، شما باید به اطلاع یک URL مخاطبین. استفاده کنید <pre style=\";text-align:right;direction:rtl\"> %s را </pre> .","Custom_oauth_unique_name":"نام منحصر به فرد از OAuth سفارشی","Custom_Script_Logged_In":"سفارشی اسکریپت برای کاربران وارد شده","Custom_Script_Logged_Out":"سفارشی اسکریپت برای کاربران سیستم خارج","Dashboard":"داشبورد","days":"روزها","Deactivate":"از کار انداختن","Debug_Level":"سطح اشکال زدایی","Default":"به طور پیش فرض","Delete":"حذف کردن","Delete_my_account":"حذف حساب کاربری من","Delete_Room_Warning":"حذف یک اتاق تمام پیغام های ارسال شده در داخل اتاق را حذف کنید. این قابل بازگشت نیست.","Delete_User_Warning":"حذف یک کاربر تمام پیام ها از آن کاربران نیز حذف کنید. این قابل بازگشت نیست.","Deleted":"حذف شده!","Department_not_found":"وزارت یافت نشد","Department_removed":"وزارت حذف","Departments":"گروه ها","Description":"شرح","Desktop":"دسکتاپ","Desktop_Notification_Test":"تست هشدار از طریق دسکتاپ","Desktop_Notifications":"اعلان های دسک تاپ","Desktop_Notifications_Disabled":"اعلان های دسک تاپ غیر فعال هستند. تغییر تنظیمات مرورگر خود را اگر شما نیاز به اطلاعیه را فعال کنید.","Desktop_Notifications_Enabled":"اعلانهای دسکتاپ را فعال کنید","Direct_message_someone":"کسی پیام مستقیم","Direct_Messages":"پیام مستقیم","Direct_Messages_list":"پیام مستقیم","Disable_Favorite_Rooms":"مورد علاقه های غیر فعال کردن","Disable_New_Message_Notification":"غیر فعال کردن هشدار از طریق پیام جدید","Disable_New_Room_Notification":"غیر فعال کردن هشدار از طریق اتاق جدید","Displays_action_text":"نمایش متن عمل","Do_you_want_to_change_to_s_question":"آیا شما می خواهید به تغییر <strong>به %s؟</strong>","Drop_to_upload_file":"رها کردن برای آپلود فایل","Dry_run":"تمرین جنگی","Dry_run_description":"تنها ارسال یک ایمیل به آدرس همان است که در از. ایمیل باید به یک کاربر معتبر تعلق دارند.","Duplicate_archived_channel_name":"آرشیو کانال با نام » %s 'را وجود دارد","Duplicate_archived_private_group_name":"شخصی گروه بایگانی با نام » %s 'را وجود دارد","Duplicate_private_group_name":"یک گروه خصوصی با نام « %s 'را وجود دارد","E-mail":"پست الکترونیک","Edit":"ویرایش","Edit_Custom_Field":"ویرایش سفارشی درست","Edit_Department":"وزارت ویرایش","edited":"ویرایش شده","Email":"پست الکترونیک","Email_already_exists":"ایمیل وجود دارد","Email_body":"ایمیل بدن","Email_Change_Disabled":"مدیر Rocket.Chat خود را تغییر ایمیل را غیرفعال کرده است","Email_from":"از جانب","Email_Notification_Mode":"آگاه سازی ایمیل آفلاین","Email_Notification_Mode_All":"هر اشاره / DM","Email_Notification_Mode_Disabled":"معلول","Email_or_username":"ایمیل یا نام کاربری","Email_subject":"موضوع","Email_verified":"ایمیل تایید","Emoji":"از Emoji","Empty_title":"عنوان خالی","Enable":"قادر ساختن","Enable_Desktop_Notifications":"اعلانهای دسکتاپ را فعال","Enabled":"فعال","Encrypted_message":"پیام رمز شده","End_OTR":"پایان OTR","Enter_a_regex":"یک regex را وارد کنید","Enter_a_room_name":"نام اتاق را وارد کنید","Enter_a_username":"نام کاربری را وارد کنید","Enter_info":"اطلاعات خود را وارد کنید","Enter_name_here":"نام اینجا وارد کنید","Enter_to":"را وارد کنید به","Error":"خطا","error-cant-invite-for-direct-room":"می توانید کاربران را به اتاق دعوت مستقیم","error-duplicate-channel-name":"یک کانال با نام » %s 'را وجود دارد","error-invalid-custom-field":"زمینه های سفارشی نامعتبر","error-invalid-custom-field-name":"نام زمینه سفارشی نامعتبر است. استفاده از حروف تنها، اعداد، خط فاصله و زیرین.","error-invalid-password":"رمز عبور نامعتبر","error-invalid-room":"اتاق نامعتبر","error-invalid-room-name":"<strong> %s</strong> از نام اتاق معتبر نیست، <br/> استفاده از حروف تنها، اعداد، خط فاصله و زیرین","error-invalid-user":"کاربر نامعتبر","error-invalid-username":"نام کاربری نامعتبر","error-not-allowed":"ممنوع","error-not-authorized":"غیر مجاز","error-remove-last-owner":"این آخرین مالک است. لطفا یک مالک جدید قبل از حذف یک تنظیم شده است.","error-role-name-required":"نام نقش مورد نیاز است","error-user-not-in-room":"کاربر در این اتاق نیست","Error_changing_password":"تغییر پسورد","Error_sending_confirmation_email":"خطا در ارسال ایمیل تایید","Error_too_many_requests":"خطا، درخواست های زیادی. لطفا آرامتر. شما باید %s ثانیه قبل از تلاش دوباره صبر کنید","Esc_to":"Esc را برای","Example_s":"به عنوان مثال: <code class=\"inline\">%s</code>","False":"غلط","Favorites":"مورد علاقه های شما","Field":"رشته","Field_removed":"درست حذف","File_exceeds_allowed_size_of_bytes":"فایل بیشتر حجم مجاز بایت __size__","FileUpload":"آپلود فایل","FileUpload_Enabled":"ارسال فایل فعال","FileUpload_File_Empty":"فایل خالی","FileUpload_FileSystemPath":"مسیر سیستم","FileUpload_MaxFileSize":"حداکثر حجم آپلود فایل (در بایت)","FileUpload_MediaType_NotAccepted":"انواع رسانه پذیرفته نشده","FileUpload_MediaTypeWhiteList":"انواع رسانه های پذیرفته شده","FileUpload_MediaTypeWhiteListDescription":"کاما از هم جدا لیستی از انواع رسانه ها. ترک آن را خالی برای پذیرش انواع رسانه ها.","FileUpload_ProtectFiles":"حفاظت از فایل های آپلود شده","FileUpload_ProtectFilesDescription":"تنها کاربران تصدیق خواهد دسترسی دارند","FileUpload_S3_Acl":"لیگ قهرمانان آسیا آمازون S3","FileUpload_S3_AWSAccessKeyId":"آمازون S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"آمازون S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"آمازون S3 نام سطل","FileUpload_S3_BucketURL":"URL سطل","FileUpload_S3_CDN":"دامنه CDN برای دریافت","FileUpload_S3_Region":"منطقه","FileUpload_Storage_Type":"نوع ذخیره سازی","Flags":"پرچم","Follow_social_profiles":"دنبال پروفایل های اجتماعی ما، چنگال ما در github و به اشتراک گذاری افکار خود را در مورد برنامه rocket.chat در هیئت مدیره trello ما است.","Food_and_Drink":"غذا نوشیدنی","For_your_security_you_must_re_enter_your_password_to_continue":"برای امنیت شما، شما باید رمز عبور خود را دوباره وارد کنید به ادامه","Force_SSL":"استفاده از SSL","Force_SSL_Description":"* توجه * _Force SSL_ هرگز نباید با پروکسی معکوس استفاده می شود. اگر شما از یک پروکسی معکوس، شما باید تغییر مسیر وجود دارد انجام. این گزینه برای استقرار مانند Heroku، که پیکربندی تغییر مسیر در پروکسی معکوس اجازه نمی دهد وجود دارد.","Forgot_password":"رمز عبور خود را فراموش کرده","Fork_it_on_github":"چنگال آن را در github","Frequently_Used":"اغلب استفاده می شود","From":"از جانب","From_Email":"از ایمیل","From_email_is_required":"از ایمیل مورد نیاز است","From_email_warning":"<b>هشدار:</b> این زمینه <b>از</b> موضوع را به تنظیمات سرور پست الکترونیکی خود را است.","General":"عمومی","Get_to_know_the_team":"دریافت به دانستن Rocket.Team","github_no_public_email":"شما به هیچ عنوان ایمیل ایمیل عمومی در حساب github خود را نمی","Give_a_unique_name_for_the_custom_oauth":"یک نام منحصر به فرد برای OAuth حفظ سفارشی","Give_the_application_a_name_This_will_be_seen_by_your_users":"به نرم افزار یک نام. این خواهد بود که توسط کاربران شما دیده می شود.","Global":"جهانی","GoogleTagManager_id":"گوگل ID مدیر برچسب","Has_more":"بیشتر داشتن","Have_your_own_chat":"چت وب خود را. طراحی و توسعه با Meteor.com از Rocket.Chat یک راه حل عالی برای توسعه دهندگان به دنبال به جلو به ساخت و تکامل پلت فرم چت خود است.","Header":"سربرگ","Hidden":"پنهان","Hide_Group_Warning":"آیا مطمئن هستید که می خواهید برای مخفی گروه \" %s\" را؟","Hide_Private_Warning":"آیا شما مطمئن هستید که میخواهید برای مخفی کردن بحث با \" %s\" را؟","Hide_room":"مخفی کردن اتاق","Hide_Room_Warning":"آیا مطمئن هستید که می خواهید برای مخفی در اتاق \" %s\" را؟","Highlights":"های لایت","Highlights_How_To":"مطلع می شود وقتی کسی اشاره یک کلمه یا عبارت، آن را در اینجا اضافه کنید. شما می توانید کلمات یا عبارات با کاما از هم جدا کنید. واژه های برجسته حروف حساس نیست.","Highlights_List":"کلمات برجسته","History":"تاریخ","hours":"ساعت ها","How_friendly_was_the_chat_agent":"عامل چت چگونه دوستانه بود؟","How_knowledgeable_was_the_chat_agent":"عامل چت چگونه آگاه بود؟","How_responsive_was_the_chat_agent":"عامل چت چگونه پاسخگو بود؟","How_satisfied_were_you_with_this_chat":"چگونه رضایت شما را با این چت بود؟","If_you_are_sure_type_in_your_password":"اگر شما مطمئن نوع رمز عبور خود را عبارتند از:","If_you_are_sure_type_in_your_username":"اگر شما مطمئن نوع کاربری خود را عبارتند از:","Importer_Archived":"آرشیو","Importer_done":"واردات کامل!","Importer_finishing":"تا پایان واردات.","Importer_From_Description":"واردات __from داده __ را به Rocket.Chat.","Importer_import_cancelled":"واردات لغو شده است.","Importer_import_failed":"در حالی که در حال اجرا واردات خطایی رخ داد.","Importer_importing_channels":"واردات کانال.","Importer_importing_messages":"واردات پیام است.","Importer_importing_started":"شروع واردات.","Importer_importing_users":"واردات از کاربران است.","Importer_not_defined_properly":"وارد کننده درست تعریف نشده بود، آن را از دست رفته کلاس واردات.","Importer_not_in_progress":"وارد کننده در حال حاضر در حال اجرا نیست.","Importer_Prepare_Restart_Import":"راه اندازی مجدد واردات","Importer_Prepare_Start_Import":"شروع وارد","Importer_Prepare_Uncheck_Archived_Channels":"کانال های آرشیو شده لغو انتخاب","Importer_Prepare_Uncheck_Deleted_Users":"کاربران لغو انتخاب حذف","Importer_progress_error":"برای به دست آوردن پیشرفت برای واردات شکست خورده است.","Importer_setup_error":"در حالی که راه اندازی وارد خطایی رخ داد.","Incorrect_Password":"رمز ورود نادرست","inline_code":"inline_code","Install_Extension":"نصب برنامه افزودنی","Install_FxOs":"نصب Rocket.Chat در فایرفاکس خود را","Install_FxOs_done":"عالی! شما هم اکنون می توانید Rocket.Chat از طریق آیکون بر روی صفحه اصلی خود را. آن لذت ببرید با Rocket.Chat!","Install_FxOs_error":"با عرض پوزش، که کار نمی کند به عنوان در نظر گرفته شده! خطای زیر ظاهر می شود:","Install_FxOs_follow_instructions":"لطفا نصب و راه اندازی برنامه بر روی دستگاه را اعلام (مطبوعات \"نصب\" وقتی از شما خواسته).","Installation":"نصب و راه اندازی","Integration_added":"ادغام اضافه شده است","Integration_Incoming_WebHook":"ادغام WebHook ورودی","Integration_New":"یکپارچه سازی جدید","Integration_Outgoing_WebHook":"ادغام WebHook خروجی","Integration_updated":"ادغام به روز شده است","Integrations":"یکپارچگی","Invalid_asset":"دارایی نامعتبر","Invalid_confirm_pass":"تایید رمز عبور رمز عبور مطابقت ندارد","Invalid_email":"ایمیل وارد شده نامعتبر است","Invalid_Export_File":"فایل آپلود شده است٪ معتبر بازدید کنندگان فایل صادرات است.","Invalid_file_height":"ارتفاع فایل نامعتبر","Invalid_file_type":"نوع فایل نامعتبر","Invalid_file_width":"عرض فایل نامعتبر","Invalid_Import_File_Type":"نوع فایل واردات نامعتبر است.","Invalid_name":"نام نباید خالی باشد","Invalid_notification_setting_s":"تنظیمات اطلاع رسانی نامعتبر: %s","Invalid_pass":"رمز عبور نباید خالی باشد","Invalid_room_name":"<strong> %s</strong> از نام اتاق معتبر نیست، <br/> استفاده از حروف تنها، اعداد، خط فاصله و زیرین","Invalid_room_type":"<strong> %s</strong> از نوع اتاق معتبر نیست.","Invalid_Secret_URL":"URL راز نامعتبر","Invalid_secret_URL_message":"URL ارائه نامعتبر است.","invisible":"نامرئی","Invisible":"نامرئی","Invitation_HTML":"دعوت HTML","Invitation_Subject":"دعوت نامه تم","Invite_user_to_join_channel":"دعوت از یک کاربر برای پیوستن به این کانال","Invite_Users":"دعوت از کاربران","is_also_typing":"همچنین تایپ","is_also_typing_female":"همچنین تایپ","is_also_typing_male":"همچنین تایپ","is_typing":"در حال تایپ کردن","is_typing_female":"در حال تایپ کردن","is_typing_male":"در حال تایپ کردن","italics":"کج (ایتالیک)","join":"پیوستن","Join_audio_call":"اضافه کردن تماس های صوتی","Join_the_Community":"تاریخ جامعه","Join_the_given_channel":"اضافه کردن کانال داده","Join_video_call":"پیوستن به تماس ویدیویی","Joined":"پیوسته","Jump":"پرش","Jump_to_first_unread":"پرش به خوانده نشده اولین","Jump_to_message":"پرش به پیام","Jump_to_recent_messages":"پرش به پیام های اخیر","Katex_Enabled":"KAtex دارای فعال","Label":"برچسب","Language":"زبان","Language_Version":"نسخه انگلیسی","Last_login":"آخرین ورود به سیستم","Last_message":"آخرین","Last_seen":"آخرین فعالیت","Layout":"طرح","Layout_Home_Body":"صفحه اصلی بدن","Layout_Home_Title":"صفحه اصلی عنوان","Layout_Login_Terms":"ورود به شرایط","Layout_Privacy_Policy":"سیاست حفظ حریم خصوصی","Layout_Sidenav_Footer":"سمت ناوبری پاورقی","Layout_Sidenav_Footer_description":"اندازه بالا و پایین صفحه 260 X 70px","Layout_Terms_of_Service":"شرایط استفاده از خدمات","LDAP":"LDAP","LDAP_CA_Cert":"CA بزنید","LDAP_Custom_Domain_Search":"جستجو سفارشی دامنه","LDAP_Custom_Domain_Search_Description":"قطعه ای از JSON که بر اتصال و اتصال اطلاعات و فرم: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"به طور پیش فرض دامنه","LDAP_Description":"یک مرکز برای به اشتراک گذاری یک رمز عبور بین سایت و خدمات مختلف - LDAP یک پایگاه داده سلسله مراتبی است که بسیاری از شرکت ها برای ارائه یکبار ورود به سیستم است. https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication: برای کسب اطلاعات پیکربندی پیشرفته و نمونه، لطفا ویکی ما مشورت کنید.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"پایه دامنه","LDAP_Domain_Base_Description":"نام کامل برجسته (DN) از یک زیر درخت LDAP شما می خواهید به جستجو برای کاربران و گروه. شما می توانید به عنوان بسیاری از شما می خواهم اضافه کنید. با این حال، هر گروه باید در پایه دامنه به عنوان کاربران که متعلق به آن تعریف شود. اگر شما گروه های کاربری محدود مشخص، تنها کاربران که متعلق به آن گروه در دامنه باشد. ما توصیه می کنیم که شما در سطح بالا از LDAP درخت دایرکتوری خود را مشخص کنید به عنوان پایه دامنه خود و استفاده از فیلتر جستجو برای کنترل دسترسی.","LDAP_Domain_Search_Filter":"دامنه جستجو فیلتر","LDAP_Domain_Search_Filter_Description":"اگر مشخص، تنها کاربران که مطابقت دارند این فیلتر اجازه خواهد داشت به سیستم وارد شوید. اگر هیچ فیلتر مشخص است، تمام کاربران در محدوده پایه دامنه مشخص قادر خواهد بود به سیستم وارد شوید. <br/> به عنوان مثال برای اکتیو دایرکتوری `memberOf = CN = ROCKET_CHAT، OU = عمومی Groups`. <br/> به عنوان مثال برای اوپنالدپ (جستجو بازی های درب) `OU: DN: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"دامنه جستجو شی رده","LDAP_Domain_Search_Object_Category_Description":"* به objectCategory * که شناسایی کاربران خود را. <br/> خالی به * اوپنالدپ *. <br/> به عنوان مثال `person`، و غیره","LDAP_Domain_Search_Object_Class":"دامنه کلاس جستجو شی","LDAP_Domain_Search_Object_Class_Description":"* به objectclass * که شناسایی کاربران خود را. <br/> به عنوان مثال `organizationalPerson`،` user`، `inetOrgPerson`، و غیره","LDAP_Domain_Search_Password":"دامنه جستجو رمز عبور","LDAP_Domain_Search_Password_Description":"رمز عبور برای کاربر جستجوی دامنه.","LDAP_Domain_Search_User":"دامنه جستجو کاربر","LDAP_Domain_Search_User_Description":"کاربر LDAP که انجام جستجوها کاربران برای تأیید هویت کاربران دیگر زمانی که آنها وارد شوید. <br/> این یک حساب خدمات به طور خاص برای یکپارچگی شخص ثالث ایجاد شده است به طور معمول. استفاده از یک نام کاملا مناسب، مانند `CN = مدیر، CN = کاربران، DC = به عنوان مثال، DC = com`.","LDAP_Domain_Search_User_ID":"دامنه جستجو ID کاربر","LDAP_Domain_Search_User_ID_Description":"ویژگی LDAP LDAP که شناسایی کاربران که تلاش احراز هویت. در این زمینه باید `شود sAMAccountName` برای نصب فعال ترین دایرکتوری، اما ممکن است` uid` برای راه حل های دیگر LDAP، مانند OpenLDAP. شما می توانید `mail` برای شناسایی کاربران از طریق ایمیل و یا هر ویژگی شما می خواهید استفاده کنید. <br> شما می توانید چندین مقدار را جدا شده توسط کاما به کاربران اجازه ورود با استفاده از شناسههای متعدد مانند نام کاربری یا ایمیل استفاده کنید.","LDAP_Enable":"قادر ساختن","LDAP_Enable_Description":"تلاش برای استفاده از LDAP برای احراز هویت.","LDAP_Encryption":"رمزگذاری","LDAP_Encryption_Description":"روش رمزگذاری مورد استفاده برای تامین امنیت ارتباطات به سرور LDAP. مثالها عبارتند از `plain` (بدون رمزنگاری)،` SSL / LDAPS` (رمزگذاری از شروع)، و `StartTLS` (ارتقا به ارتباط رمزگذاری شده یک بار متصل).","LDAP_Host":"میزبان","LDAP_Host_Description":"میزبان LDAP، به عنوان مثال `` ldap.example.com` یا 10.0.0.30`.","LDAP_Port":"بندر","LDAP_Port_Description":"بندر برای دسترسی به LDAP. به عنوان مثال: `` 389` یا 636` برای LDAPS","LDAP_Reject_Unauthorized":"رد غیر مجاز","LDAP_Sync_User_Avatar":"همگام سازی کاربر آواتار ها","LDAP_Sync_User_Data":"همگام سازی داده ها","LDAP_Sync_User_Data_Description":"حفظ اطلاعات کاربران در همگام سازی با سرور در ورود (به عنوان مثال: نام، ایمیل).","LDAP_Sync_User_Data_FieldMap":"کاربر داده نقشه درست","LDAP_Sync_User_Data_FieldMap_Description":"پیکربندی زمینه حساب کاربری (مانند ایمیل) از یک رکورد در LDAP جمعیت (یک بار). <br/> به عنوان مثال، `{\" CN \":\" نام \"،\" ایمیل \":\" ایمیل \"}` خواهد نام یک شخص قابل خواندن توسط انسان از ویژگی CN، و ایمیل خود را از ویژگی های ایمیل را انتخاب نمایید. <br/> زمینه های موجود عبارتند از `name` و` email`.","LDAP_Sync_Users":"کاربران همگام سازی","LDAP_Test_Connection":"اتصال تست","LDAP_Unique_Identifier_Field":"شناسه منحصر به فرد درست","LDAP_Unique_Identifier_Field_Description":"که درست استفاده خواهد شد به لینک کاربران LDAP و کاربر Rocket.Chat است. شما می توانید چندین مقدار را جدا شده توسط کاما اطلاع به تلاش برای بدست آوردن مقدار از رکورد LDAP. <br/> مقدار پیش فرض است `objectGUID، آی بی ام-entryUUID، GUID، dominoUNID، nsuniqueId، uidNumber`","LDAP_Use_Custom_Domain_Search":"استفاده از جستجو سفارشی دامنه","LDAP_Use_Custom_Domain_Search_Description":"ارسال فیلتر خود را به کاربران جستجو در سرور LDAP.","LDAP_Username_Field":"نام کاربری درست","LDAP_Username_Field_Description":"که درست خواهد شد به عنوان * نام کاربری * برای کاربران جدید استفاده می شود. خالی بگذارید به استفاده از نام کاربری آگاهانه در صفحه ورود. <br/> شما می توانید تگ های قالب بیش از حد استفاده کنید، مانند `# {givenName} # {SN}`. <br/> مقدار پیش فرض است `sAMAccountName`.","Leave_Group_Warning":"آیا مطمئن هستید که می خواهید گروه \" %s\" را ترک کنند؟","Leave_Private_Warning":"مطمئنید که می خواهید بحث با \" %s\" را ترک کنند؟","Leave_room":"خروج از اتاق","Leave_Room_Warning":"آیا مطمئن هستید که می خواهید به ترک اتاق \" %s\" را؟","line":"خط","List_of_Direct_Messages":"فهرست پیام های مستقیم","Live_sessions":"جلسات زندگی می کنند","Livechat_agents":"عوامل livechat در","Livechat_Dashboard":"داشبورد livechat در","Livechat_enabled":"livechat در فعال","Livechat_Manager":"مدیر livechat در","Livechat_managers":"مدیران livechat در","Livechat_title":"عنوان livechat در","Livechat_title_color":"عنوان livechat در رنگ پس زمینه","Livechat_Users":"کاربران livechat در","Load_more":"بارگیری بیشتر","Loading...":"در حال بارگذاری ...","Loading_more_from_history":"بارگیری بیش از تاریخ","Loading_suggestion":"بارگذاری پیشنهادات ...","Localization":"بومی سازی","Log_File":"نمایش فایل ها و خط","Log_Level":"سطح ورود","Log_Package":"نمایش بسته بندی","Log_View_Limit":"ورود مشخصات محدود","Logged_out_of_other_clients_successfully":"از سیستم خارج از مشتریان دیگر موفقیت","Login":"ورود","Login_with":"ورود با %s","login_with":"و یا برای ورود مستقیم با","Logout":"خروج از سیستم","Logout_Others":"خروج از دیگر وارد شده در مکان های","Mail_Message_Invalid_emails":"شما ایمیل یک یا نامعتبر ارائه کرده اند: %s را","Mail_Message_Missing_to":"شما باید یک یا چند کاربر را انتخاب کنید و یا ارائه یک یا چند آدرس ایمیل، با کاما جدا شده.","Mail_Message_No_messages_selected_select_all":"هیچ پیامی برای شما انتخاب نشده. دوست دارید <a href='#' class='select-all'>را انتخاب کنید همه</a> پیام قابل مشاهده است؟","Mail_Messages":"پیام های پست الکترونیکی","Mail_Messages_Instructions":"را انتخاب کنید که پیام های شما می خواهید برای ارسال از طریق ایمیل را با کلیک کردن پیام","Mail_Messages_Subject":"در اینجا یک بخش انتخاب شده از %s پیام است","Mailer":"نامه رسان","Mailer_body_tags":"شما <b>باید</b> [لغو اشتراک] برای لینک لغو عضویت استفاده کنید. <br /> شما ممکن است [نام]، [fname] برای نام کامل کاربر، نام اول یا نام خانوادگی، به ترتیب استفاده کنید، [آنگاه]. <br /> ممکن است [ایمیل] برای ایمیل کاربر استفاده کنید.","Make_Admin":"ساختن مدیر","Manager_added":"مدیر اضافه","Manager_removed":"مدیر حذف","Mark_as_read":"به عنوان خوانده شده علامت بزن","Markdown_Headers":"مدل های نشانه گذاری سرصفحه","Markdown_SupportSchemesForLink":"طرح های پشتیبانی مدل های نشانه گذاری برای لینک","Markdown_SupportSchemesForLink_Description":"جدا شده با کاما از طرح اجازه","Members_List":"فهرست کاربران","Mentions":"اشاره","Mentions_default":"اشاره (پیش فرض)","Message":"پیام","Message_AllowDeleting":"اجازه می دهد پیام حذف","Message_AllowEditing":"اجازه می دهد پیام ویرایش","Message_AllowEditing_BlockEditInMinutes":"بلوک پیام ویرایش پس از (N) دقیقه","Message_AllowEditing_BlockEditInMinutesDescription":"را وارد کنید 0 برای غیر فعال کردن مسدود کردن.","Message_AllowPinning":"اجازه می دهد پیام سنجاق","Message_AllowPinning_Description":"اجازه می دهد پیام به به هر یک از کانال های دوخته شود.","Message_AllowStarring":"اجازه می دهد پیام بازیگران","Message_AudioRecorderEnabled":"ضبط صوتی را فعال کنید","Message_AudioRecorderEnabledDescription":"نیاز به 'صوتی / WAV، فایل ها را به یک نوع رسانه مورد قبول در تنظیمات، آپلود فایل.","Message_DateFormat":"فرمت تاریخ","Message_DateFormat_Description":"همچنین ببینید: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"پیام در حال حذف مجاز نیست","Message_editing_blocked":"این پیام می توانید دیگر ویرایش","Message_editing_not_allowed":"ویرایش پیام مجاز نیست","Message_GroupingPeriod":"گروه بندی دوره (در ثانیه)","Message_GroupingPeriodDescription":"پیام خواهد شد با پیام قبلی گروه بندی می شوند اگر هر دو از کاربران هستند و زمان سپری شده کمتر از زمان آگاهانه در ثانیه بود.","Message_KeepHistory":"حفظ تاریخچه پیام","Message_MaxAllowedSize":"حداکثر اندازه مجاز پیام","Message_MaxAll":"حداکثر اندازه کانال برای تمام پیام","Message_pinned":"پیام دوخته","Message_pinning_not_allowed":"پیام سنجاق مجاز نیست","Message_removed":"پیام حذف","Message_ShowDeletedStatus":"نمایش وضعیت حذف","Message_ShowEditedStatus":"نمایش وضعیت ویرایش","Message_ShowFormattingTips":"نمایش قالب گذاری","Message_TimeFormat":"قالب زمان","Message_TimeFormat_Description":"همچنین ببینید: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"پیام بسیار طولانی","Messages":"پیام","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"پیام هایی که به ورودی WebHook ارسال خواهد شد در اینجا نوشته شده است.","Meta":"متا","Meta_fb_app_id":"شناسه فیس بوک نرم افزار","Meta_google-site-verification":"تأیید سایت گوگل","Meta_language":"زبان","Meta_msvalidate01":"MSValidate.01","Meta_robots":"روبات","minutes":"دقایق","Mobile_push":"فشار های تلفن همراه","More_channels":"کانال های بیشتر","More_direct_messages":"پیام های مستقیم بیشتر","More_groups":"گروه بیشتر خصوصی","More_unreads":"unreads بیشتر","Msgs":"پیام های","multi":"چند","Mute_someone_in_room":"کسی بیصدا کردن در اتاق","Mute_user":"کاربران بیصدا","Muted":"خاموش","My_Account":"حساب من","n_messages":" %s پیام","N_new_messages":" %s پیام جدید","Name":"نام","Name_cant_be_empty":"نام نمی تواند خالی باشد","Name_of_agent":"نام عامل","Name_optional":"نام (اختیاری)","Navigation_History_20_last_pages":"تاریخچه ناوبری، ناوبری (20 صفحه آخر)","New_Application":"برنامه جدید","New_Custom_Field":"جدید درست سفارشی","New_Department":"وزارت جدید","New_integration":"یکپارچه سازی جدید","New_logs":"سیاهههای مربوط جدید","New_messages":"پیام های جدید","New_password":"رمز عبور جدید","New_role":"نقش جدید","No_channel_with_name_%s_was_found":"کانالی با نام <strong>\" %s\" را</strong> پیدا نشد!","No_channels_yet":"شما بخشی از هر کانال نکرده است.","No_direct_messages_yet":"شما هر گونه مکالمات آغاز نکرده است.","No_Encryption":"بدون رمزگذاری","No_favorites_yet":"شما هیچ علاقه مندی ها اضافه نکرده است.","No_group_with_name_%s_was_found":"هیچ گروهی خصوصی با نام <strong>\" %s\" را</strong> پیدا نشد!","No_groups_yet":"شما هیچ گروه های خصوصی است.","No_livechats":"شما هیچ livechats.","No_mentions_found":"بدون اشاره یافت","No_permission_to_view_room":"شما اجازه دسترسی به این اتاق نیست","No_pinned_messages":"هیچ پیام دوخته","No_results_found":"نتیجه ای پیدا نشد","No_starred_messages":"بدون پیام های ستاره دار","no_tokens_for_this_user":"هیچ نشانه برای این کاربر وجود دارد","No_user_with_username_%s_was_found":"هیچ کاربر با نام کاربری <strong>\" %s\" را</strong> پیدا نشد!","Not_allowed":"ممنوع","Not_authorized":"غیر مجاز","Not_Available":"در دسترس نیست","Not_found_or_not_allowed":"یافت نشد و یا مجاز نیست","Nothing":"هیچ چی","Nothing_found":"چیزی پیدا نشد","Notifications":"اطلاعیه","Notify_all_in_this_room":"به اطلاع همه در این اتاق","Num_Agents":"# نمایندگی","Number_of_messages":"تعداد پیام ها","OAuth_Application":"OAuth تأیید نرم افزار","OAuth_Applications":"نرم افزار OAuth تأیید","Objects":"اشیاء","Off_the_record_conversation":"خارج از رکورد مکالمات","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"خارج از ضبط مکالمات برای مرورگر یا دستگاه شما در دسترس نیست.","Offline_DM_Email":"[__site__] شما مستقیم توسط __user__ پیام ارسال شده است","Offline_Mention_Email":"[__site__] شما توسط __user__ در #__room__ ذکر شده است","Old_and_new_password_must_be_different":"رمز عبور جدید باید متفاوت از رمز عبور قدیمی است.","Old_and_new_password_required":"شما نیاز به ارائه هر دو رمز عبور قدیمی و جدید برای تغییر رمز عبور خود را.","Online":"آنلاین","Only_errors":"تنها خطاهای","Only_you_can_see_this_message":"فقط شما میتوانید به این پیام را مشاهده","Oops!":"اوه","Open":"باز کن","Opened":"باز","Opt_out_statistics":"آیا آمار به Rocket.Chat ارسال کنید","Opt_out_statistics_warning":"با ارسال آمار خود را، شما به ما کمک کند شناسایی که چگونه بسیاری از موارد از Rocket.Chat مستقر هستند، و همچنین چقدر خوب سیستم رفتار، بنابراین ما بیشتر می توانید آن را بهبود بخشد. نگران نباشید، به عنوان هیچ اطلاعات کاربر فرستاده می شود و تمام اطلاعات که دریافت می کنیم محرمانه نگه داشته. اگر می خواهید ادامه فرستادن آمار خود را، علامت را بردارید. متشکرم.","optional":"اختیاری","Order":"سفارش","OS_Arch":"سیستم عامل در قوس دار","OS_Cpus":"سیستم عامل تعداد CPU","OS_Freemem":"سیستم عامل حافظه رایگان","OS_Loadavg":"سیستم عامل میانگین بار","OS_Platform":"سیستم عامل بستر های نرم افزاری","OS_Release":"سیستم عامل انتشار","OS_Totalmem":"سیستم عامل ها حافظه","OS_Type":"نوع سیستم عامل","OS_Uptime":"سیستم عامل آپ تایم","others":"دیگران","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR تنها در دسترس است که هر دو کاربران آنلاین","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL نادیده گرفتن که فایل های آپلود شده است. این URL نیز برای دریافت مگر اینکه یک CDN استفاده شده است","Password":"کلمه عبور","Password_Change_Disabled":"مدیر Rocket.Chat خود را تغییر کلمه عبور را غیرفعال کرده است","Password_changed_successfully":"رمز عبور با موفقیت تغییر","Payload":"ظرفیت ترابری","People":"مردم","Permissions":"مجوز","Pin_Message":"پین پیام","Pinned_a_message":"دوخته یک پیام:","Pinned_Messages":"پیام دوخته","Placeholder_for_email_or_username_login_field":"نگهدارنده برای ایمیل و یا ورود نام کاربری درست","Placeholder_for_password_login_field":"نگهدارنده برای ورود نام کاربری رمز درست","Please_answer_survey":"لطفا یک لحظه به پاسخ به یک نظرسنجی در مورد این چت","Please_enter_value_for_url":"لطفا یک مقدار برای URL از نماد خود را وارد کنید.","Please_enter_your_new_password_below":"لطفا کلمه عبور جدید خود را در زیر وارد کنید:","Please_fill_a_label":"لطفا یک برچسب را پر کنید","Please_fill_a_name":"لطفا یک نام را پر کنید","Please_fill_a_username":"لطفا یک نام کاربری پر کردن","Please_fill_name_and_email":"لطفا نام و ایمیل را پر کنید","Please_re_enter_your_password":"لطفا رمز عبور خود را دوباره وارد کنید","Please_select_enabled_yes_or_no":"لطفا یک گزینه برای فعال را انتخاب کنید","Please_wait":"لطفا صبر کنید","Please_wait_activation":"لطفا صبر کنید، این می تواند برخی از زمان.","Please_wait_statistics":"لطفا صبر کنید، آمار حال تولید است.","Please_wait_while_OTR_is_being_established":"لطفا صبر کنید در حالی که OTR در حال استقرار","Please_wait_while_your_account_is_being_deleted":"لطفا صبر کنید در حالی که حساب شما در حال حذف ...","Please_wait_while_your_profile_is_being_saved":"لطفا صبر کنید در حالی که مشخصات خود را در حال ذخیره ...","Post_as":"ارسال به عنوان","Post_to_Channel":"ارسال به کانال","Post_to_s_as_s":"ارسال <strong>به %s</strong> <strong>به عنوان %s</strong>","Powered_by":"طراحی شده توسط","Preferences":"تنظیمات","Preferences_saved":"تنظیمات ذخیره شده","Privacy":"حریم خصوصی","Private_Group":"گروه خصوصی","Private_Groups":"گروه های خصوصی","Private_Groups_list":"فهرست گروه های خصوصی","Profile":"مشخصات","Profile_saved_successfully":"مشخصات موفقیت ذخیره","Proudly_developed":"با افتخار نیرو گرفته با شهاب توسعه","Push":"فشار دادن","Push_apn_cert":"APN بزنید","Push_apn_dev_cert":"APN نویس بزنید","Push_apn_dev_key":"APN برنامه نویس کلیدی","Push_apn_dev_passphrase":"APN نویس کلمه عبور","Push_apn_key":"APN کلیدی","Push_apn_passphrase":"APN کلمه عبور","Push_debug":"اشکال زدایی","push_disabled":"فشار غیر فعال","Push_enable":"قادر ساختن","Push_enable_gateway":"فعال کردن دروازه","Push_gateway":"دروازه","Push_gcm_api_key":"کلید GCM API","Push_gcm_project_number":"GCM پروژه شماره","Push_production":"تولید","Push_show_message":"نمایش پیام در اطلاع رسانی","Push_show_username_room":"نمایش کانال / گروه / نام کاربری در اطلاع رسانی","Push_test_push":"تست","Query":"پرس و جو","Query_description":"شرایط اضافی برای تعیین کاربران برای ارسال ایمیل به. کاربران لغو اشتراک به طور خودکار از پرس و جو برداشته شده است. این باید یک معتبر JSON باشد. به عنوان مثال: \"{\" createdAt \": {\" $ GT \": {\" تاریخ $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"جستجوی سریع","quote":"نقل قول","Reactions":"واکنش","Recents":"تازه ها","Record":"رکورد","Redirect_URI":"تغییر مسیر URI","Refresh_keys":"کلید تازه کردن","Refresh_your_page_after_install_to_enable_screen_sharing":"تازه کردن صفحه خود را پس از نصب برای فعال کردن اشتراک گذاری صفحه نمایش","Register":"ثبت نام کاربر جدید","Registration_Succeeded":"ثبت نام پیش","Remember_me":"مرا به خاطر بسپار","Remove":"برداشتن","Remove_Admin":"حذف محیط مدیریت","Remove_as_moderator":"حذف به عنوان مدیر","Remove_as_owner":"حذف عنوان مالک","Remove_custom_oauth":"حذف OAuth حفظ سفارشی","Remove_from_room":"حذف از اتاق","Remove_someone_from_room":"حذف فرد از اتاق","Removed":"حذف شده","Require_password_change":"نیاز به تغییر رمز عبور","Resend_verification_email":"ایمیل تایید را دوباره بفرست","Reset":"تنظیم مجدد","Reset_password":"تنظیم مجدد رمز عبور","Restart":"شروع دوباره","Restart_the_server":"راه اندازی مجدد سرور","RocketBot_Enabled":"RocketBot فعال","RocketBot_Name":"نام RocketBot","RocketBot_Name_Description":"نام RocketBot باید یک نام کاربری معتبر ثبت نام بر روی سرور خود باشد.","Role":"نقش","Role_Editing":"نقش در حال ویرایش","Role_removed":"نقش حذف","Room":"اتاق","Room_archivation_state":"دولت","Room_archivation_state_false":"فعال","Room_archivation_state_true":"آرشیو","Room_archived":"اتاق بایگانی","room_changed_privacy":"توسط <em>__user_by__</em> <em>__room_type__:</em> نوع اتاق به تغییر","room_changed_topic":"توسط <em>__user_by__</em> <em>__room_topic__:</em> موضوع اتاق به تغییر","Room_has_been_deleted":"اتاق حذف شده است","Room_Info":"اطلاعات اتاق","Room_name_changed":"توسط <em>__user_by__</em> <em>__room_name__:</em> نام اتاق به تغییر","Room_name_changed_successfully":"نام اتاق موفقیت تغییر","Room_not_found":"اتاق یافت نشد","Room_topic_changed_successfully":"موضوع اتاق موفقیت تغییر","Room_type_changed_successfully":"نوع اتاق موفقیت تغییر","Room_unarchived":"اتاق بایگانی خارج شد","Room_uploaded_file_list":"لیست فایل های","Room_uploaded_file_list_empty":"بدون فایل های موجود.","room_user_count":" %s کاربران","Rooms":"اتاق","S_new_messages_since_s":" %s پیام جدید از %s را","SAML":"SAML","SAML_Custom_Cert":"گواهی سفارشی","SAML_Custom_Entry_point":"نقطه ورود سفارشی","SAML_Custom_Generate_Username":"تولید نام کاربری","SAML_Custom_Issuer":"صادرکننده سفارشی","SAML_Custom_Provider":"ارائه دهنده سفارشی","Save":"صرفه جویی","Save_changes":"ذخیره تغییرات","Save_Mobile_Bandwidth":"صرفه جویی پهنای باند موبایل","Save_to_enable_this_action":"ذخیره برای فعال کردن این اقدام","Saved":"ذخیره","Saving":"صرفه جویی در","Scope":"محدوده","Screen_Share":"صفحه نمایش به اشتراک","Script_Enabled":"اسکریپت فعال","Search":"جستجو کردن","Search_by_username":"جستجو بر اساس نام کاربری","Search_Channels":"کانال های جستجو","Search_Direct_Messages":"جستجو پیام های مستقیم","Search_Messages":"پیام های جستجو","Search_Private_Groups":"جستجوی گروه ها شخصی","Search_settings":"تنظیمات جستجو","seconds":"ثانیه","See_all":"همه را ببین","See_only_online":"فقط آنلاین","Select_a_department":"انتخاب بخش","Select_an_avatar":"یک نماد را انتخاب کنید","Select_file":"فایل را انتخاب کنید","Select_service_to_login":"انتخاب یک سرویس به ورود به بارگذاری عکس خود و یا یکی به طور مستقیم از کامپیوتر خود را","Select_user":"انتخاب کاربر","Select_users":"کاربران انتخاب","Selected_agents":"عوامل انتخاب شده","Selected_users":"اعضای انتخاب شده","Send":"ارسال","Send_a_message":"ارسال یک پیام","Send_a_test_mail_to_my_user":"ارسال یک ایمیل به آزمون کاربر من","Send_a_test_push_to_my_user":"ارسال یک فشار آزمون به کاربر من","Send_confirmation_email":"ارسال ایمیل تایید","Send_data_into_RocketChat_in_realtime":"ارسال داده ها را به Rocket.Chat در زمان واقعی است.","Send_email":"ایمیل بفرست","Send_invitation_email":"ارسال ایمیل دعوت","Send_invitation_email_error":"شما هر آدرس ایمیل معتبری ارائه نشده است.","Send_invitation_email_info":"شما می توانید دعوت نامه ایمیل متعدد در یک بار ارسال کنید.","Send_invitation_email_success":"با موفقیت یک ایمیل دعوت به آدرس زیر ارسال:","Send_invitation_email_warning":"به منظور ارسال ایمیل دعوت، شما باید اول تنظیمات SMTP پیکربندی کنید.","Send_Message":"پیام فرستادن","Send_your_JSON_payloads_to_this_URL":"ارسال محموله های JSON خود را به این آدرس.","Sending":"در حال ارسال...","Set_as_moderator":"تنظیم به عنوان ناظر","Set_as_owner":"تنظیم به عنوان صاحب","Settings":"تنظیمات","Settings_updated":"تنظیمات به روز رسانی","Should_be_a_URL_of_an_image":"باید یک URL از یک تصویر.","Should_exists_a_user_with_this_username":"کاربر در حال حاضر باید وجود داشته باشد.","Show_all":"نمایش همه","Show_more":"بیشتر نشان بده، اطلاعات بیشتر","Show_only_online":"نمایش فقط آنلاین","Show_preregistration_form":"فرم پیش ثبت نام","Showing_archived_results":"<p style=\";text-align:right;direction:rtl\"> نمایش نتایج: از <b>آرشیو %s را</b> </p>","Showing_online_users":"نمایش <b>__total_showing__</b> از __total__ کاربران","Showing_results":"<p style=\";text-align:right;direction:rtl\"> نمایش نتایج: <b>از %s را</b> </p>","Silence":"سکوت","since_creation":"از %s را","Site_Name":"نام سایت","Site_Url":"آدرس سایت","Site_Url_Description":"به عنوان مثال: https://chat.domain.com/","Skip":"رفتن","Smileys_and_People":"شکلک ها و مردم","SMTP":"SMTP","SMTP_Host":"هاست SMTP","SMTP_Password":"SMTP رمز عبور","SMTP_Port":"SMTP پورت","SMTP_Test_Button":"تنظیمات SMTP آزمون","SMTP_Username":"SMTP نام کاربری","Sound":"صدا","Star_Message":"پیام ستاره","Starred_Messages":"پیام های ستاره دار","Start_audio_call":"شروع تماس صوتی","Start_Chat":"شروع چت","Start_of_conversation":"شروع مکالمه","Start_OTR":"شروع OTR","Start_video_call":"شروع تماس ویدیویی","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"شروع با <code class=\"inline\">%s</code> برای کاربر یا <code class=\"inline\">%s</code> برای کانال. به عنوان مثال: <code class=\"inline\">%s</code> یا <code class=\"inline\">%s</code>","Statistics":"آمار","Stats_Active_Users":"کاربران فعال","Stats_Avg_Channel_Users":"متوسط ​​کاربران کانال","Stats_Avg_Private_Group_Users":"متوسط ​​کاربران گروه خصوصی","Stats_Away_Users":"کاربران دور","Stats_Max_Room_Users":"حداکثر اتاق کاربران","Stats_Non_Active_Users":"کاربران غیر فعال","Stats_Offline_Users":"کاربر آفلاین","Stats_Online_Users":"کاربران آنلاین","Stats_Total_Channels":"تعداد کانال ها","Stats_Total_Direct_Messages":"مجموع پیام مستقیم اتاق","Stats_Total_Messages":"مجموع پیغام ها","Stats_Total_Private_Groups":"مجموع گروه های خصوصی","Stats_Total_Rooms":"کل اتاق","Stats_Total_Users":"تعداد اعضا","Stop_Recording":"توقف ضبط","strike":"ضربه","Subject":"موضوع","Submit":"ارسال","Success":"موفقیت","Survey":"نظرسنجی","Survey_instructions":"رای هر سوال با توجه به جلب رضایت شما، 1 معنی که شما ناراضی هستند به طور کامل و 5 این معنی که شما به طور کامل راضی هستند.","Symbols":"علامت","Sync_success":"موفقیت همگام سازی","Sync_Users":"کاربران همگام سازی","Test_Connection":"اتصال تست","Test_Desktop_Notifications":"آزمون های دسک تاپ","Thank_you_for_your_feedback":"با تشکر از شما برای نظرات شما","The_application_name_is_required":"نام نرم افزار مورد نیاز است","The_channel_name_is_required":"نام کانال مورد نیاز است","The_emails_are_being_sent":"ایمیل در حال ارسال.","The_field_is_required":"زمینه به %s مورد نیاز است.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"تغییر اندازه تصویر به کار نخواهد کرد زیرا ما نمی توانیم تشخیص ImageMagick را یا GraphicsMagick بر روی سرور خود نصب شده است.","The_redirectUri_is_required":"redirectUri مورد نیاز است","The_server_will_restart_in_s_seconds":"سرور در %s ثانیه راه اندازی مجدد خواهد","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>تنظیمات %s</strong> در <strong>به %s</strong> پیکربندی و شما <strong>از %s</strong> دسترسی!","The_user_will_be_removed_from_s":"کاربر خواهد شد از %s حذف","The_user_wont_be_able_to_type_in_s":"کاربر نمی خواهد قادر به تایپ در %s","Theme":"موضوع","theme-color-action-buttons-color":"عملیات دکمه های رنگی","theme-color-active-channel-background-color":"فعال کانال رنگ پس زمینه","theme-color-active-channel-font-color":"فعال کانال رنگ قلم","theme-color-blockquote-background":"نقل قول رنگ پس زمینه","theme-color-clean-buttons-color":"دکمه پاک رنگ","theme-color-code-background":"کد رنگ پس زمینه","theme-color-code-border":"کد رنگ قاب","theme-color-code-color":"کد رنگ","theme-color-content-background-color":"محتوای رنگ پس زمینه","theme-color-custom-scrollbar-color":"سفارشی نمایشمیلهلغزش رنگ","theme-color-info-active-font-color":"اطلاعات فعال رنگ قلم","theme-color-info-font-color":"اطلاعات رنگ قلم","theme-color-input-font-color":"ورودی رنگ قلم","theme-color-link-font-color":"لینک رنگ قلم","theme-color-message-hover-background-color":"پیام شناور BG رنگ","theme-color-primary-background-color":"اولیه رنگ پس زمینه","theme-color-primary-font-color":"اولیه رنگ قلم","theme-color-quaternary-font-color":"کواترنر رنگ قلم","theme-color-secondary-background-color":"ثانویه رنگ پس زمینه","theme-color-secondary-font-color":"ثانویه رنگ قلم","theme-color-smallprint-font-color":"کوچک نسخه قابل چاپ رنگ قلم","theme-color-smallprint-hover-color":"چاپ کوچک شناور رنگ","theme-color-status-away":"وضعیت دور رنگ","theme-color-status-busy":"وضعیت مشغول رنگ","theme-color-status-offline":"وضعیت: آفلاین رنگ","theme-color-status-online":"وضعیت رنگ","theme-color-tertiary-background-color":"دوران سوم رنگ پس زمینه","theme-color-tertiary-font-color":"دوران سوم رنگ قلم","theme-color-unread-notification-color":"خوانده نشده اطلاعیه رنگ","theme-custom-css":"CSS سفارشی","There_are_no_agents_added_to_this_department_yet":"هیچ عوامل اضافه شده به این بخش وجود ندارد.","There_are_no_integrations":"هیچ یکپارچگی وجود دارد","There_are_no_users_in_this_role":"هیچ کاربری در این نقش وجود دارد.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"این ایمیل قبلا استفاده شده است و تأیید نشده است. لطفا رمز عبور خود را تغییر دهید.","This_is_a_desktop_notification":"این اعلان دسکتاپ","This_is_a_push_test_messsage":"این messsage آزمون فشار است","Time_in_seconds":"زمان در ثانیه","Title_bar_color":"رنگ نوار عنوان","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"برای نصب Rocket.Chat livechat در در وب سایت خود کپی و پیست کنید و این کد بالا آخرین <strong></ BODY></strong> برچسب در سایت خود.","To_users":"به کاربران","Topic":"موضوع","Travel_and_Places":"سفر و اماکن","Trigger_removed":"ماشه حذف","Trigger_Words":"کلمات محرک","Triggers":"محرک های","True":"درست","Type":"نوع","Type_your_new_password":"رمز عبور جدید خود را تایپ کنید","Unarchive":"لغو بایگانی","Unmute_someone_in_room":"کسی باصدا کردن در اتاق","Unmute_user":"کاربران باصدا کردن","Unnamed":"که نامش ذکر نشده","Unpin_Message":"پیام لغو پین","Unread_Rooms":"اتاق خوانده نشده","Unread_Rooms_Mode":"حالت اتاق خوانده نشده","Unstar_Message":"حذف ستاره","Upload_file_question":"آپلود فایل؟","Uploading_file":"آپلود فایل ...","Use_account_preference":"استفاده از همه حساب","Use_Emojis":"استفاده از Emojis","Use_initials_avatar":"استفاده از حروف اول نام کاربری خود را","use_menu":"استفاده از منوی سمت برای دسترسی به اتاق و چت خود را","Use_service_avatar":"استفاده از %s آواتار ها","Use_this_username":"با استفاده از این نام کاربری","Use_uploaded_avatar":"استفاده از نماد های آپلود","Use_url_for_avatar":"استفاده از URL برای نماد","User__username__is_now_a_moderator_of__room_name_":"_نام کاربری_ کاربر در حال حاضر به ناظم از __room_name__","User__username__is_now_a_owner_of__room_name_":"_نام کاربری_ کاربر در حال حاضر صاحب __room_name__","User__username__removed_from__room_name__moderators":"_نام کاربری_ کاربر از مدیران __room_name__ حذف","User__username__removed_from__room_name__owners":"_نام کاربری_ کاربر از صاحبان __room_name__ حذف","User_added":"اضافه شده توسط کاربر","User_added_by":"<em>__user_added__</em> کاربر اضافه شده توسط <em>__user_by__.</em>","User_added_successfully":"کاربر با موفقیت اضافه شد","User_Channels":"کانال های کاربر","User_doesnt_exist":"کاربری با نام `@ %s` وجود دارد.","User_has_been_activated":"کاربر فعال شده است","User_has_been_deactivated":"کاربر غیر فعال شده است","User_has_been_deleted":"کاربر حذف شده است","User_has_been_muted_in_s":"کاربر شده است به در %s خاموش","User_has_been_removed_from_s":"کاربر از %s حذف شده است","User_has_disconnected":"کاربر قطع شده است","User_Info":"اطلاعات کاربر","User_is_no_longer_an_admin":"کاربر دیگر یک مدیر","User_is_not_activated":"کاربر فعال نیست","User_is_now_an_admin":"کاربر در حال حاضر به یک مدیر","User_joined_channel":"کانال پیوسته است.","User_joined_channel_female":"کانال پیوسته است.","User_joined_channel_male":"کانال پیوسته است.","User_left":"کانال را ترک کرده است.","User_left_female":"کانال را ترک کرده است.","User_left_male":"کانال را ترک کرده است.","User_logged_out":"کاربر وارد شده است را","User_management":"مدیریت کاربر","User_muted_by":"<em>__user_muted__</em> کاربر خاموش شده توسط <em>__user_by__.</em>","User_muted_in_room":"کاربر خاموش در اتاق","User_not_found":"کاربر یافت نشد","User_not_found_or_incorrect_password":"کاربر یافت نشد و یا رمز عبور اشتباه","User_or_channel_name":"کاربر یا کانال نام","User_removed":"کاربر حذف","User_removed_by":"<em>__user_removed__</em> کاربر حذف شده توسط <em>__user_by__.</em>","User_removed_from_room":"کاربر با از اتاق خارج شده است","User_Settings":"تنظیمات کاربر","User_unmuted_by":"<em>__user_unmuted__</em> کاربر لغو شد توسط <em>__user_by__.</em>","User_unmuted_in_room":"کاربر نادیده در اتاق","User_updated_successfully":"کاربر با موفقیت به روز","Username":"نام کاربری","Username_and_message_must_not_be_empty":"نام کاربری و پیام نباید خالی باشد.","Username_cant_be_empty":"نام کاربری نمی تواند خالی باشد","Username_Change_Disabled":"مدیر Rocket.Chat خود را تغییر نام های کاربری را غیرفعال کرده است","Username_denied_the_OTR_session":"_نام کاربری_ را تکذیب کرد جلسه OTR","Username_description":"نام کاربری استفاده شده است به دیگران اجازه می دهد به شما اشاره در پیام است.","Username_doesnt_exist":"نام کاربری ` %s` وجود ندارد.","Username_ended_the_OTR_session":"_نام کاربری_ به پایان رسید جلسه OTR","Username_invalid":"<strong> %s</strong> است یک نام کاربری معتبر نیست، <br/> استفاده از تنها حروف، اعداد، نقطه، خط فاصله و زیرین","Username_is_already_in_here":"`@ %s` در حال حاضر در اینجا.","Username_is_not_in_this_room":"کاربر `# %s` است در این اتاق نیست.","Username_not_found":"نام کاربری یافت نشد","Username_title":"ثبت نام نام کاربری","Username_unavaliable":"<strong> %s</strong> است در حال حاضر در استفاده :(","Username_wants_to_start_otr_Do_you_want_to_accept":"_نام کاربری_ می خواهد برای شروع OTR. آیا می خواهید به قبول می کنید؟","Users":"کاربران","Users_in_role":"کاربران در نقش","UTF8_Names_Slugify":"UTF8 نام slugify را","UTF8_Names_Validation":"UTF8 اسامی اعتبار سنجی","UTF8_Names_Validation_Description":"هنوز کاراکترهای خاص و فضاهای اجازه نمی دهد. و _ - شما می توانید استفاده کنید. اما نه در پایان نام","Verification_email_sent":"ایمیل تأیید","View_All":"مشاهده همه","View_Logs":"نمایش سیاهههای مربوط","Visibility":"دید","Visible":"قابل رویت","Visitor":"بازدید کننده","Visitor_page_URL":"URL صفحه های بازدید کننده","Visitor_time_on_site":"زمان بازدید کنندگان در سایت","Wait_activation_warning":"قبل از اینکه شما می توانید وارد شوید، حساب خود را باید به صورت دستی توسط مدیر فعال می شود.","We_are_offline_Sorry_for_the_inconvenience":"ما آنلاین نیست. با عرض پوزش برای ناراحتی.","We_have_sent_password_email":"ما به شما یک ایمیل با دستورالعمل تنظیم مجدد رمز عبور ارسال کرده اند. اگر شما یک ایمیل را دریافت نمی در مدت کوتاهی، لطفا دوباره و دوباره امتحان کنید.","We_have_sent_registration_email":"ما به شما یک ایمیل برای تایید ثبت نام خود را فرستاده اند. اگر شما یک ایمیل را دریافت نمی در مدت کوتاهی، لطفا دوباره و دوباره امتحان کنید.","WebRTC_Enable_Channel":"فعال کردن برای کانال های عمومی","WebRTC_Enable_Direct":"فعال کردن برای پیام های مستقیم","WebRTC_Enable_Private":"فعال کردن برای کانال خصوصی","WebRTC_Servers":"سرور بی حس کردن / روشن","WebRTC_Servers_Description":"یک لیست از بی حس کردن و روشن کردن سرور جداشده با کاما. <br/> رمز عبور @ بی حس کردن:: نام کاربری و رمز پورت در فرمت `نام کاربری اجازه میزبان: port` یا` نام کاربری: رمز عبور @ نوبه خود: میزبان: port`.","Welcome":"خوش آمدید <em>به %s.</em>","Welcome_to_the":"خوش آمدید به","will_be_able_to":"قادر خواهد بود تا","With_whom":"با آنها","Yes":"بله","Yes_clear_all":"بله، پاک کردن تمام!","Yes_delete_it":"بله، آن را حذف کنید!","Yes_hide_it":"بله، آن را پنهان!","Yes_leave_it":"بله، آن را ترک کنید!","Yes_mute_user":"بله، کاربر قطع!","Yes_remove_user":"بله، حذف کاربر!","you_are_in_preview_mode_of":"شما در حالت پیش نمایش از کانال # <strong>__room_name__</strong> هستند","You_are_logged_in_as":"شما وارد شدید با عنوان","You_are_not_authorized_to_view_this_page":"شما به این صفحه مجاز است.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"شما آخرین مالک هستند. لطفا مالک جدید قبل از خروج از اتاق تنظیم شده است.","You_can_change_a_different_avatar_too":"شما می توانید نماد مورد استفاده برای ارسال از این ادغام را لغو کنید.","You_can_use_an_emoji_as_avatar":"شما همچنین می توانید از Emoji به عنوان یک نماد استفاده کنید.","You_have_been_muted":"شما نادیده گرفته شده است و نمی تواند در این اتاق صحبت","You_have_not_verified_your_email":"شما ایمیل خود را تایید نمی کند.","You_have_successfully_unsubscribed":"شما با موفقیت از فهرست Mailling ما لغو شده است.","You_informed_an_invalid_FROM_address":"شما را از آدرس نامعتبر آگاه است.","You_must_provide_the_unsubscribe_link":"شما باید [لغو اشتراک] لینک فراهم می کند.","You_need_confirm_email":"شما نیاز به تایید ایمیل خود را برای ورود!","You_need_install_an_extension_to_allow_screen_sharing":"شما نیاز به نصب یک فرمت به اجازه به اشتراک گذاری صفحه نمایش","You_need_to_change_your_password":"شما نیاز به تغییر رمز عبور خود را","You_need_to_type_in_your_password_in_order_to_do_this":"شما نیاز به تایپ رمز عبور خود را به منظور انجام این کار!","You_need_to_type_in_your_username_in_order_to_do_this":"شما نیاز به تایپ در نام کاربری خود را به منظور انجام این کار!","You_need_to_verifiy_your_email_address_to_get_notications":"شما نیاز به تأیید آدرس ایمیل خود را برای دریافت اطلاعیه","You_should_name_it_to_easily_manage_your_integrations":"شما باید نام آن را به راحتی مدیریت یکپارچگی خود را.","You_will_not_be_able_to_recover":"شما نمی خواهد قادر به بازیابی این ارسال!","You_will_not_be_able_to_recover_file":"شما نمی خواهد قادر به بازیابی این فایل!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"شما اطلاعیه ایمیل دریافت نمی کند چرا که شما از پست الکترونیک خود را تایید نمی کند.","Your_email_has_been_queued_for_sending":"ایمیل شما برای ارسال صف","Your_entry_has_been_deleted":"ورود شما حذف شده است.","Your_file_has_been_deleted":"فایل شما حذف شده است.","Your_mail_was_sent_to_s":"پست الکترونیکی خود را به %s ارسال شد","Your_Open_Source_solution":"خود راه حل چت منبع باز خود را","Your_password_is_wrong":"رمز عبور خود را اشتباه است!","Your_push_was_sent_to_s_devices":"فشار خود را به دستگاه %s را ارسال شد"});
TAPi18n._registerServerTranslator("fa", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/fi.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["fi"] = ["Finnish","Suomi"];                                                                   // 8
if(_.isUndefined(TAPi18n.translations["fi"])) {                                                                        // 9
  TAPi18n.translations["fi"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["fi"][namespace])) {                                                             // 13
  TAPi18n.translations["fi"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["fi"][namespace], {"500":"Internal Server Error","0_Errors_Only":"0 - Vain virheet","1_Errors_and_Information":"1 - Virheet ja tiedot","2_Erros_Information_and_Debug":"2 - erros, Information ja Debug","__username__was_set__role__by__user_by_":"__username__ asetettiin __role__ by __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ ei enää __role__, jonka __user_by__","Access_not_authorized":"Pääsy estetty.","Access_online_demo":"Access the online demo","Access_Online_Demo":"Access the Online Demo","Access_Token_URL":"Access Token URL","Accounts":"Käyttäjätilit","Accounts_AllowDeleteOwnAccount":"Salli käyttäjien poistaa omaan","Accounts_AllowedDomainsList":"Pilkkueroteltu lista sallituista domaineista","Accounts_AllowedDomainsList_Description":"Pilkuilla eroteltu luettelo sallituista verkkotunnuksia","Accounts_AllowEmailChange":"Salli Sähköposti Change","Accounts_AllowPasswordChange":"Salli salasanan vaihto","Accounts_AllowUserAvatarChange":"Salli käyttäjän avatarin muutos","Accounts_AllowUsernameChange":"Salli käyttäjätunnuksen muuttaminen","Accounts_AllowUserProfileChange":"Salli käyttäjän profiilin muutos","Accounts_AvatarResize":"Muuta avatarien kokoa","Accounts_AvatarSize":"Avatarin koko","Accounts_AvatarStorePath":"Avatarin tallennuspolku","Accounts_AvatarStoreType":"Avatarien tallennusmuoto","Accounts_BlockedDomainsList":"Estettyjen Verkkotunnukset List","Accounts_BlockedDomainsList_Description":"Pilkuilla erotettu luettelo estettyjen verkkotunnusten","Accounts_denyUnverifiedEmail":"Estä vahvistamaton sähköpostiosoite","Accounts_EmailVerification":"Sähköpostiosoitteen varmistaminen","Accounts_EmailVerification_Description":"Varmista, että oikeat SMTP-asetukset käyttää tätä ominaisuutta","Accounts_Enrollment_Email":"Kirjautumissähköposti","Accounts_Enrollment_Email_Description":"Voit käyttää [name], [fname], [lname] käyttäjän koko nimen, etunimen tai sukunimen paikalla.<br />Voit käyttää [email] käyttäjän sähköpostin paikalla.","Accounts_Iframe_api_method":"sovellusliittymämenetelmä","Accounts_Iframe_api_url":"Api URL","Accounts_iframe_enabled":"käytössä","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"Kirjautumisen vanhentumisaika (päiviä)","Accounts_ManuallyApproveNewUsers":"Hyväksy uudet käyttäjät manuaalisesti","Accounts_OAuth_Custom_Token_Sent_Via":"Token lähetetään","Accounts_OAuth_Custom_Authorize_Path":"Auktorisointipolku","Accounts_OAuth_Custom_Button_Color":"Painikkeen väri","Accounts_OAuth_Custom_Button_Label_Color":"Painikkeen tekstin väri","Accounts_OAuth_Custom_Button_Label_Text":"Painikkeen teksti","Accounts_OAuth_Custom_Enable":"Kytke päälle","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity polku","Accounts_OAuth_Custom_Login_Style":"Kirjautumistyyli","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token polku","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook-tunnus","Accounts_OAuth_Facebook_callback_url":"Facebook Takaisinsoitto URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Käytössä","Accounts_OAuth_Github_callback_url":"Github Takaisinsoitto URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Käytössä","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise Takaisinsoitto URL","Accounts_OAuth_GitHub_Enterprise_id":"Client ID","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Client ID","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth käytössä","Accounts_OAuth_Gitlab_callback_url":"GitLab Takaisinsoitto URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google-tunnus","Accounts_OAuth_Google_callback_url":"Google Takaisinsoitto URL","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn-tunnus","Accounts_OAuth_Linkedin_callback_url":"Linkedin Takaisinsoitto URL","Accounts_OAuth_Linkedin_id":"LinkedIn ID","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor-tunnus","Accounts_OAuth_Meteor_callback_url":"Meteor Takaisinsoitto URL","Accounts_OAuth_Meteor_id":"Meteor ID","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter-tunnus","Accounts_OAuth_Twitter_callback_url":"Twitter Takaisinsoitto URL","Accounts_OAuth_Twitter_id":"Twitter ID","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress-kirjautuminen","Accounts_OAuth_Wordpress_callback_url":"Wordpress Takaisinsoitto URL","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"Wordpress Secret","Accounts_PasswordReset":"Salasanan nollaus","Accounts_Registration_AuthenticationServices_Enabled":"Rekisteröinti autentikointipalveluiden kautta","Accounts_RegistrationForm":"Rekisteröintilomake","Accounts_RegistrationForm_Disabled":"Pois päältä","Accounts_RegistrationForm_LinkReplacementText":"Ilmoittautumislomakkeen linkin korvaava teksti","Accounts_RegistrationForm_Public":"Julkinen","Accounts_RegistrationForm_Secret_URL":"Salainen URL","Accounts_RegistrationForm_SecretURL":"Ilmoittautumislomakkeen salainen URL","Accounts_RegistrationForm_SecretURL_Description":"Sinun on annettava satunnainen merkkijono, joka lisätään rekisteröitymis-URLiin. Esimerkiksi: https://chat.example.com/register/[secret_hash]","Accounts_RegistrationRequired":"Rekisteröinti vaaditaan","Accounts_RequireNameForSignUp":"Vaadi nimi rekisteröityessä","Accounts_ShowFormLogin":"Näytä lomakepohjainen kirjautuminen","Accounts_UseDefaultBlockedDomainsList":"Käytä Oletus Estettyjen Domains List","Accounts_UseDNSDomainCheck":"Käytä DNS Domain Check","Activate":"Aktivoi","Activity":"Toiminta","Add":"Lisää","Add_agent":"Lisää agentti","Add_custom_oauth":"Lisää mukautettu oauth","Add_manager":"Lisää manageri","Add_Members":"Lisää osallistujia","Add_User":"Lisää käyttäjä","Add_user":"Lisää käyttäjä","Add_users":"Lisää käyttäjiä","Additional_emails":"Lisäsähköpostit","Additional_Feedback":"Lisäpalaute","Administration":"Ylläpito","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2-todennuksen jälkeen käyttäjät ohjataan tähän URL-osoitteeseen","Agent_added":"Agentti lisätty","Agent_removed":"Agentti poistettu","Alias":"Alias","All":"Kaikki","All_channels":"Kaikki kanavat","All_logs":"Kaikki lokit","All_messages":"kaikki viestit","Allow_Invalid_SelfSigned_Certs":"Salli virheelliset ja itse allekirjoitetut SSL varmenteet linkin validointiin ja esikatseluihin","Allow_Invalid_SelfSigned_Certs_Description":"Hyväksy virheelliset ja itse allekirjoitetut SSL-varmenteet linkkien validoinnissa ja esikatselussa.","and":"ja","And_more":"Ja lisää __length __...","Animals_and_Nature":"Kasvit ja eläimet","API":"API","API_Analytics":"Analytics","API_Embed":"Upota","API_EmbedDisabledFor":"Poista upotustoiminto käyttäjiltä","API_EmbedDisabledFor_Description":"Pilkkueroteltu lista käyttäjätunnuksista","API_GitHub_Enterprise_URL":"Server URL","API_GitHub_Enterprise_URL_Description":"Esim: http://example.com (ei kauttaviivaa loppuun)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Ulkoasu","Application_added":"Sovellus lisätty","Application_Name":"Sovelluksen nimi","Application_updated":"Sovellus päivitetty","Apply_and_refresh_all_clients":"Levitä ja päivittää kaikki asiakkaat","Archive":"Arkistoi","Archive_Unarchive":"Arkistoi / palauta arkistosta","are_also_typing":"kirjoittavat myös","are_typing":"kirjoittavat","Are_you_sure":"Oletko varma?","Are_you_sure_you_want_to_delete_your_account":"Oletko varma, että haluat poistaa tilin?","Authorization_URL":"Valtuutus URL","Authorize":"Valtuuta","AutoLinker_StripPrefix":"AutoLinker Strip etuliite","AutoLinker_StripPrefix_Description":"Lyhyt esitys. esim https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Vakiolausekehaku","AutoLinker_Email":"AutoLinker Sähköposti","AutoLinker_Phone":"AutoLinker Puhelin","AutoLinker_Phone_Description":"Yhdistetään automaattisesti puhelinnumeroita. esim `(123) 456-7890`","Auto_Load_Images":"Lataa kuvat automaattisesti\n","Available":"saatavissa","Available_agents":"Vapaat agentit","Avatar":"Vaihda avatar","Avatar_changed_successfully":"Avatar vaihdettu onnistuneesti","Avatar_URL":"Avatarin URL","Avatar_url_invalid_or_error":"URL on virheellinen tai ei ole käytettävissä. Yritä uudestaan.","away":"poissa","Away":"Poissa","away_female":"poissa","Away_female":"Poissa","away_male":"poissa","Away_male":"Poissa","Back":"Takaisin","Back_to_applications":"Takaisin sovelluksiin","Back_to_integrations":"Takaisin integraatioihin","Back_to_login":"Takaisin kirjautumiseen","Back_to_permissions":"Takaisin käyttöoikeuksiin","Body":"Runko","bold":"lihavoitu","busy":"varattu","Busy":"Varattu","busy_female":"varattu","Busy_female":"Varattu","busy_male":"varattu","Busy_male":"Varattu","Cancel":"Peruuta","Cannot_delete_a_protected_role":"Et voi poistaa suojattua roolia","Cannot_delete_role_because_its_in_use":"Et voi poistaa roolia, koska se on käytössä","Cannot_invite_users_to_direct_rooms":"Ei voi kutsua käyttäjiä suoralle huonetta","CDN_PREFIX":"CDN etuliite","Certificates_and_Keys":"Sertifikaatit ja avaimet","Channel":"Kanava","Channel_doesnt_exist":"Kanavaa `#%s` ei ole olemassa.","Channels":"Kanavat","Channels_list":"Julkiset kanavat","Chat_Rooms":"Chathuoneet","Chatops_Enabled":"Ota käyttöön Chatops","Chatops_Title":"Chatops paneeli","Chatops_Username":"Chatops käyttäjätunnus","Choose_a_room":"Valitse huone","Choose_messages":"Valitse viestit","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Valitse alias, joka näkyy viesteissä ennen käyttäjätunnustasi","Choose_the_username_that_this_integration_will_post_as":"Valitse käyttäjänimi, jolla integraatio postaa keskusteluun","Clear_all_unreads_question":"Tyhjennä kaikki lukemattomat?","Client_ID":"Client ID","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Asiakkaat päivittyy muutaman sekunnin","close":"sulje","Closed":"Suljettu","Collapse_Embedded_Media_By_Default":"Romahtaa upotettu media oletuksena","coming_soon":"tulossa","Commands":"Komennot","Compact_View":"Suppea näkymä","Confirm_password":"Vahvista salasanasi","Contact":"Yhteys","Conversation":"Keskustelu","Convert_Ascii_Emojis":"Muunna ASCII-merkit Emojiksi","Copied":"kopioitu","COPY_TO_CLIPBOARD":"KOPIOI LEIKEPÖYDÄLLE","Copy_to_clipboard":"Kopioi leikepöydälle","Count":"Lukumäärä","Create":"Luoda","Create_new":"Luo uusi","Created_at":"Luotu","Created_at_s_by_s":"Luotu <strong>%s</strong> käyttäjän <strong>%s</strong> toimesta","Custom_Fields":"Erikoiskentät","Custom_oauth_helper":"Kun perustat OAuth Providerin, sinun täytyy ilmoittaa Callback URL. Käytä <pre>%s</pre>.","Custom_oauth_unique_name":"Mukautettu oauth yksilöllinen nimi","Custom_Script_Logged_In":"Custom Script kirjautuneille käyttäjille","Custom_Script_Logged_Out":"Custom Script for kirjautunut ulos käyttäjille","Dashboard":"Ohjauspaneeli","days":"päivää","Deactivate":"Deaktivoi","Debug_Level":"Debug-taso","Default":"oletusarvo","Delete":"Poista","Delete_my_account":"Poista tilini","Delete_Room_Warning":"Huomeen poistaminen poistaa kaikki huoneessa olevat viestit.\nToimintoa ei voi perua.","Delete_User_Warning":"Käyttäjän poistaminen poistaa myös käyttäjän kaikki viestit. Toimintoa ei voi perua.","Deleted":"Poistettu!","Department_not_found":"Osastoa ei löytynyt","Department_removed":"Osasto poistettu","Departments":"Osastot","Description":"Kuvaus","Desktop":"pöytä-","Desktop_Notification_Test":"Desktop ilmoitus Test","Desktop_Notifications":"Työpöytäilmoituksia","Desktop_Notifications_Disabled":"Työpöytäilmoitukset eivät ole käytössä. Muuta selaimen asetuksia mikäli haluat ilmoitukset käyttöön.","Desktop_Notifications_Enabled":"Työpöytäilmoitukset ovat käytössä.","Direct_message_someone":"Suora sanoma joku","Direct_Messages":"Yksityisviestit","Direct_Messages_list":"Suora viestit","Disable_Favorite_Rooms":"Poista Suosikit käytöstä","Disable_New_Message_Notification":"Poista uuden viestin ilmoitus käytöstä","Disable_New_Room_Notification":"Poista uuden huoneen ilmoitus käytöstä","Displays_action_text":"Näyttää toimintakehotustekstiä","Do_you_want_to_change_to_s_question":"Haluatko vaihtaa tämän arvoon <strong>%s</strong>?","Drop_to_upload_file":"Vedä ja pudota lähettääksesi tiedoston","Dry_run":"Kuivaharjoitus","Dry_run_description":"Lähettää vain yhden sähköpostin, lähettäjän osoitteeseen. Osoite tulee kuulua olemassaolevalle käyttäjälle.","Duplicate_archived_channel_name":"Arkistoitu kanava nimellä '%s' on olemassa","Duplicate_archived_private_group_name":"Arkistoitu privaattiryhmä '%s%' on olemassa","Duplicate_private_group_name":"Privaattiryhmä '%s' on olemassa jo","E-mail":"Sähköpostiosoite","Edit":"Muokkaa","Edit_Custom_Field":"Muokkaa omaa Field","Edit_Department":"Muokkaa osastoa","edited":"muokattu","Email":"Sähköposti","Email_already_exists":"Sähköpostiosoite on jo olemassa","Email_body":"Viestin runko","Email_Change_Disabled":"Your Rocket.Chat järjestelmänvalvoja on poistanut muuttaminen sähköpostin","Email_from":"Lähettäjä","Email_Notification_Mode":"Poissa Sähköposti-ilmoitukset","Email_Notification_Mode_All":"Jokainen Mainitse / DM","Email_Notification_Mode_Disabled":"Liikuntarajoitteinen","Email_or_username":"Sähköpostiosoite tai käyttäjänimi","Email_subject":"Aihe","Email_verified":"Sähköpostiosoite vahvistettu","Emoji":"Emoji","Empty_title":"Tyhjä otsikko","Enable":"Ota käyttöön","Enable_Desktop_Notifications":"Ota työpöytäilmoitukset käyttöön","Enabled":"Käytössä","Encrypted_message":"salattu viesti","End_OTR":"end OTR","Enter_a_regex":"Syötä säännöllinen lause (regex)","Enter_a_room_name":"Anna huone nimi","Enter_a_username":"Syötä käyttäjätunnus","Enter_info":"Syötä kirjautumistietosi","Enter_name_here":"Anna nimi tähän","Enter_to":"Astu sisään","Error":"Virhe","error-cant-invite-for-direct-room":"Ei voi kutsua käyttäjää suoraan huoneet","error-duplicate-channel-name":"Kanava nimeltä '%s' on olemassa jo","error-invalid-custom-field":"Virheellinen muokattu kenttä","error-invalid-custom-field-name":"Virheellinen muokatun kentän nimi. Käytä vain kirjaimia, numeroita, väliviivoja ja alaviivoja.","error-invalid-password":"Väärä salasana","error-invalid-room":"Virheellinen huone","error-invalid-room-name":"<strong> %s</strong> ei ole kelvollinen huone nimi, <br/> Käytä vain kirjaimia, numeroita, väliviivoja ja alaviivoja","error-invalid-user":"Virheellinen käyttäjä","error-invalid-username":"Virheellinen käyttäjätunnus","error-not-allowed":"Ei sallittu","error-not-authorized":"ei sallittu","error-remove-last-owner":"Tämä on viimeinen omistaja. Aseta uusi omistaja ennen sen poistamista tämän yhden.","error-role-name-required":"Rooli nimi on pakollinen","error-user-not-in-room":"Käyttäjä ei ole tässä huoneessa","Error_changing_password":"Virhe vaihtaessa salasanaa","Error_sending_confirmation_email":"Virhe lähetettäessä vahvistussähköpostia","Error_too_many_requests":"Virhe, liikaa pyyntöjä. Rauhoitu hieman.\nOdota %s sekuntia ennen uudelleenyritystä.","Esc_to":"Poistu","Example_s":"Esimerkiksi: <code class=\"inline\">%s</code>","False":"Ei","Favorites":"Suosikit","Field":"Ala","Field_removed":"kenttä poistettu","File_exceeds_allowed_size_of_bytes":"Tiedoston ylittää sallittu koko __size__ tavua","FileUpload":"Lähetä tiedosto","FileUpload_Enabled":"Tiedostojen lähetykset käytössä","FileUpload_File_Empty":"Tiedosto tyhjä","FileUpload_FileSystemPath":"System Path","FileUpload_MaxFileSize":"Suurin lähetettävän tiedoston koko (tavuina)","FileUpload_MediaType_NotAccepted":"Mediatyyppejä ei hyväksytä","FileUpload_MediaTypeWhiteList":"Hyväksytyt mediatyypit","FileUpload_MediaTypeWhiteListDescription":"Pilkkueroteltu lista mediatyypeistä","FileUpload_ProtectFiles":"Suojaa ladatut tiedostot","FileUpload_ProtectFilesDescription":"Vain kirjautuneilla käyttäjillä on pääsy tiedostoihin","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 ämpäri nimi","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN verkkotunnus lataukset","FileUpload_S3_Region":"alue","FileUpload_Storage_Type":"varastointi Tyyppi","Flags":"Liput","Follow_social_profiles":"Seuraa someamme, forkkaa Githubissa ja jaa ajatuksiasi rocket.chatista trellossa.","Food_and_Drink":"Ruoka juoma","For_your_security_you_must_re_enter_your_password_to_continue":"Turvallisuussyistä sinun täytyy palata salasana jatkaa","Force_SSL":"Force SSL","Force_SSL_Description":"* Varoitus! * _Force SSL_ pitäisi koskaan käyttää käänteisen välityspalvelimen. Jos sinulla on käänteinen proxy, sinun pitäisi tehdä uudelleenohjaus siellä. Tämä vaihtoehto on olemassa asennuksia kuten Heroku, joka ei salli uudelleenohjaus konfiguraatio käänteisen välityspalvelimen.","Forgot_password":"Unohditko salasanasi?","Fork_it_on_github":"Forkkaa GitHubissa","Frequently_Used":"Usein käytetyt","From":"Lähettäjä","From_Email":"Sähköpostin lähettäjä","From_email_is_required":"Lähettäjän sähköposti vaaditaan","From_email_warning":"<b>Varoitus</b>: Kenttä <b>Lähettäjä</b> tulee olla sähköpostipalvelimesi hyväksymä.","General":"Yleinen","Get_to_know_the_team":"Tutustu Rocket.Teamiin","github_no_public_email":"GitHub-tunnukseltasi ei löydy julkisia sähköpostiosoitetietoja","Give_a_unique_name_for_the_custom_oauth":"Anna yksilöllinen nimi mukautettua oauth varten","Give_the_application_a_name_This_will_be_seen_by_your_users":"Anna sovelluksen nimi. Käyttäjät näkevät tämän.","Global":"maailmanlaajuinen","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Löytyy lisää","Have_your_own_chat":"Have your own web chat. Developed with Meteor.com, the Rocket.Chat is a great solution for developers looking forward to build and evolve their own chat platform.","Header":"ylätunniste","Hidden":"kätketty","Hide_Group_Warning":"Oletko varma, että haluat piilottaa ryhmään \" %s\"?","Hide_Private_Warning":"Oletko varma, että haluat piilottaa keskustelun \" %s\"?","Hide_room":"Piilota kanava","Hide_Room_Warning":"Oletko varma, että haluat piilottaa huoneeseen \" %s\"?","Highlights":"Poimintoja","Highlights_How_To":"Ilmoituksen, kun joku mainitsee sanan tai lauseen, lisätä sen tässä. Voit erottaa sanoja tai lauseita pilkulla. Korosta Sanat ei ole merkitystä.","Highlights_List":"Korosta sanat","History":"Historia","hours":"tuntia","How_friendly_was_the_chat_agent":"Kuinka ystävällinen chat agentti oli?","How_knowledgeable_was_the_chat_agent":"Miten osaava chat agentti oli?","How_responsive_was_the_chat_agent":"Miten reagoiva chat agentti oli?","How_satisfied_were_you_with_this_chat":"Kuinka tyytyväinen olit tähän chattiin?","If_you_are_sure_type_in_your_password":"Jos olet varma, kirjoita salasana:","If_you_are_sure_type_in_your_username":"Jos olet varma, kirjoita käyttäjätunnus:","Importer_Archived":"arkistoitu","Importer_done":"Tuominen valmis!","Importer_finishing":"Lopettamassa tuonti.","Importer_From_Description":"Tuonti __from __ n tiedot Rocket.Chat.","Importer_import_cancelled":"Tuo peruutettu.","Importer_import_failed":"Virhe käynnissä tuonti.","Importer_importing_channels":"Tuominen kanavat.","Importer_importing_messages":"Tuominen viestit.","Importer_importing_started":"Tuonnin aloittamista.","Importer_importing_users":"Tuominen käyttäjille.","Importer_not_defined_properly":"Maahantuoja ei määritelty oikein, se puuttuu Tuo luokka.","Importer_not_in_progress":"Tuoja ei ole tällä hetkellä käynnissä.","Importer_Prepare_Restart_Import":"Käynnistä uudelleen Tuo","Importer_Prepare_Start_Import":"Aloita tuominen","Importer_Prepare_Uncheck_Archived_Channels":"Poista valinta Arkistoidut Kanavat","Importer_Prepare_Uncheck_Deleted_Users":"Poista valinta poistetut käyttäjät","Importer_progress_error":"Onnistunut saamaan edistystä tuontia.","Importer_setup_error":"Virhe perustamalla tuoja.","Incorrect_Password":"Väärä salasana","inline_code":"koodi","Install_Extension":"Asenna laajennus","Install_FxOs":"Asenna Rocket.Chat Firefoxiisi","Install_FxOs_done":"Hienoa! Voit käyttää nyt Rocket.Chatiä etusivulla olevan kuvakkeen kautta. Pidä kivaa!","Install_FxOs_error":"Pahoittelut, asennus ei onnistunut, seuraava virhe ilmeni:","Install_FxOs_follow_instructions":"Vahvista sovelluksen asennus laitteellasi (paina \"Install\" käskettäessä)","Installation":"Asennus","Integration_added":"Integraatio lisätty","Integration_Incoming_WebHook":"Sisääntuleva WebHook-integraatio","Integration_New":"Uusi integraatio","Integration_Outgoing_WebHook":"Lähtevä WebHook Integration","Integration_updated":"Integraatio päivitetty","Integrations":"Integraatiot","Invalid_asset":"Virheellinen resurssi","Invalid_confirm_pass":"Salasanat eivät täsmää","Invalid_email":"Annettu sähköpostiosoite ei ole oikea","Invalid_Export_File":"Tiedosto ladattu ei ole kelvollinen %s vienti tiedosto.","Invalid_file_height":"Virheellinen tiedoston korkeus","Invalid_file_type":"Virheellinen tiedostotyyppi","Invalid_file_width":"Virheellinen tiedoston leveys","Invalid_Import_File_Type":"Virheellinen Tuo tiedostotyyppi.","Invalid_name":"Nimi ei voi olla tyhjä","Invalid_notification_setting_s":"Virheellinen ilmoitusasetus: %s","Invalid_pass":"Salasana ei voi olla tyhjä","Invalid_room_name":"<strong>%s</strong> ei ole hyväksyttävä kanavan nimi,<br/> käytä vain kirjaimia, numeroita ja viivaa","Invalid_room_type":"<strong>%s</strong> ei ole sallittu huoneen tyyppi.","Invalid_Secret_URL":"Virheellinen salainen URL","Invalid_secret_URL_message":"URL on virheellinen.","invisible":"näkymätön","Invisible":"Näkymätön","Invitation_HTML":"Kutsu HTML","Invitation_Subject":"Kutsun aihe","Invite_user_to_join_channel":"Kutsu käyttäjä kanavalle","Invite_Users":"Kutsu käyttäjiä","is_also_typing":"kirjoittaa myös","is_also_typing_female":"kirjoittaa myös","is_also_typing_male":"kirjoittaa myös","is_typing":"kirjoittaa","is_typing_female":"kirjoittaa","is_typing_male":"kirjoittaa","italics":"kursivoitu","join":"Liity","Join_audio_call":"Liity äänipuheluun","Join_the_Community":"Liity yhteisöön","Join_the_given_channel":"Liity kanavalle","Join_video_call":"Liity videopuheluun","Joined":"yhdistetyt","Jump":"Hypätä","Jump_to_first_unread":"Siirry ensimmäiseen lukemattomaan","Jump_to_message":"Siirry viestiin","Jump_to_recent_messages":"Siirry viimeisimpiin viestiin","Katex_Enabled":"Katex Käytössä","Label":"etiketti","Language":"Kieli","Language_Version":"Suomi","Last_login":"Viimeisin kirjautuminen","Last_message":"Viimeinen viesti","Last_seen":"Viimeksi nähty","Layout":"Ulkoasu","Layout_Home_Body":"Etusivun runko","Layout_Home_Title":"Etusivun otsikko","Layout_Login_Terms":"Kirjautumisehdot","Layout_Privacy_Policy":"Tietosuojakäytäntö","Layout_Sidenav_Footer":"Sivunavigoinnin alatunniste","Layout_Sidenav_Footer_description":"Alatunnisteen koko on 260x70","Layout_Terms_of_Service":"Käyttöehdot","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Search","LDAP_Custom_Domain_Search_Description":"Pala JSON jotka säätelevät sitovat ja yhteys tiedot ja on muotoa: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"LDAP on laajasti käytössä oleva hierarkinen tietokantapalvelu, jolla organisaatioiden palveluille mahdollistetaan kertakirjautuminen (SSO).\nMääritystiedot ja esimerkit, katso wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Domain Base","LDAP_Domain_Base_Description":"Täysin pätevä Distinguished Name (DN) LDAP alipuun haluat etsiä käyttäjiä ja ryhmiä. Voit lisätä niin monta kuin haluat; kuitenkin, jokainen ryhmä on määritelty samalla toimialueen pohjalle kuin käyttäjät, jotka kuuluvat siihen. Jos määrittelet rajoitettua käyttäjäryhmiä, vain käyttäjät, jotka kuuluvat niihin ryhmiin, on laajuudeltaan. Suosittelemme määrittää ylätasolla LDAP hakemistopuun kuin verkkotunnuksen pohja ja käyttää hakusuodatin valvoa pääsyä.","LDAP_Domain_Search_Filter":"Domain Hakusuodin","LDAP_Domain_Search_Filter_Description":"Mikäli määritelty, vain käyttäjät, jotka vastaavat tätä suodatinta voivat kirjautua sisään. Jos suodatin on määritetty, kaikki käyttäjät puitteissa määritetyn toimialueen pohja voi kirjautua sisään. <br/> Esim Active Directory `MEMBEROF = cn = ROCKET_CHAT, ou = General Groups`. <br/> Esim OpenLDAP (Extensible ottelu haku) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Luokka","LDAP_Domain_Search_Object_Category_Description":"* ObjectCategory * joka tunnistaa käyttäjät. <br/> Jätä tyhjäksi * OpenLDAP *. <br/> Esim `henkilöllä`, jne.","LDAP_Domain_Search_Object_Class":"Domain Search Object Class","LDAP_Domain_Search_Object_Class_Description":"* Olioluokan * joka tunnistaa käyttäjät. <br/> Esim `organizationalPerson`,` user`, `inetOrgPerson`, jne.","LDAP_Domain_Search_Password":"Domain Search Salasana","LDAP_Domain_Search_Password_Description":"Salasana toimialueen haun käyttäjä.","LDAP_Domain_Search_User":"Domain Search User","LDAP_Domain_Search_User_Description":"LDAP käyttäjä, joka suorittaa käyttäjän haut todentaa muille käyttäjille, kun he kirjautuvat sisään. <br/> Tämä on tyypillisesti palvelun tili luotu nimenomaan kolmannen osapuolen integraatiot. Käytä täysin pätevä nimi, kuten `cn = Ylläpitäjä, cn = Users, dc = esimerkki, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search Käyttäjätunnus","LDAP_Domain_Search_User_ID_Description":"LDAP-määrite, joka yksilöi LDAP käyttäjä, joka yrittää todennus. Tämän kentän pitäisi olla `sAMAccountName` useimmille Active Directory laitoksia, mutta se voi olla` uid` muille LDAP ratkaisuja, kuten OpenLDAP. Voit `mail` tunnistaa käyttäjät sähköpostitse tai mitä attribuutti haluat. <br> Voit käyttää useita arvoja erotetaan pilkulla, jotta käyttäjät voivat kirjautua käyttämällä useita tunnisteita, kuten käyttäjätunnus tai sähköpostiosoite.","LDAP_Enable":"Kytke LDAP päälle","LDAP_Enable_Description":"Käytä LDAPia autentikointiin","LDAP_Encryption":"Salaus","LDAP_Encryption_Description":"Salaustavan turvata viestinnän LDAP-palvelimelle. Esimerkkejä ovat `plain` (ei salausta),` SSL / LDAPS` (salattu alusta), ja `StartTLS` (päivittää salatun viestinnän kerran kytkettynä).","LDAP_Host":"isäntä","LDAP_Host_Description":"LDAP isännän, esim `ldap.example.com` tai` 10.0.0.30`.","LDAP_Port":"LDAP portti","LDAP_Port_Description":"LDAP-portti (esim 389)","LDAP_Reject_Unauthorized":"Hylkää luvaton","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"Synkronoi käyttäjädata","LDAP_Sync_User_Data_Description":"Pidä käyttäjädata synkronoituna palvelimelta kirjautumishetkellä (esim nimi, sähköposti)","LDAP_Sync_User_Data_FieldMap":"Käyttäjätietojen kohdistus","LDAP_Sync_User_Data_FieldMap_Description":"Määrittää, miten käyttäjätietojen kentät tuodaan LDAP-palvelimelta.\nEsimerkiksi, {\"cn\":\"name\", \"mail\":\"email\"} -määritys tuo käyttäjän nimen cn-tiedosta ja sähköpostin email-tiedosta. Käytettävissä olevat kentät ovat \"name\" ja \"email\".","LDAP_Sync_Users":"Sync Käyttäjät","LDAP_Test_Connection":"Testaa yhteys","LDAP_Unique_Identifier_Field":"Unique Identifier Field","LDAP_Unique_Identifier_Field_Description":"Joka kenttää käytetään liittämään LDAP käyttäjä ja Rocket.Chat käyttäjä. Voit ilmoittaa useita arvoja erotetaan pilkuilla yrittää saada arvon LDAP ennätys. <br/> Oletusarvo on `objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Käytä Custom Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Kirjoita oma suodatin etsiä käyttäjien LDAP-palvelimelle.","LDAP_Username_Field":"Käyttäjätunnus Field","LDAP_Username_Field_Description":"Joka kenttä tullaan käyttämään * käyttäjätunnus * uusille käyttäjille. Jätä tyhjäksi käyttää käyttäjätunnusta tasalla kirjautumissivulla. <br/> Voit käyttää mallia tageja minäkin `# {givenName}. # {Sn}`. <br/> Oletusarvo on `sAMAccountName`.","Leave_Group_Warning":"Oletko varma, että haluat jättää ryhmän \" %s\"?","Leave_Private_Warning":"Oletko varma, että haluat lähteä keskustelua \" %s\"?","Leave_room":"Poistu kanavalta","Leave_Room_Warning":"Oletko varma, että haluat poistua huoneesta \" %s\"?","line":"riviä","List_of_Direct_Messages":"Luettelo suoria viestejä","Live_sessions":"Live-istunnot","Livechat_agents":"Livechat agentit","Livechat_Dashboard":"Livechat ohjauspaneeli","Livechat_enabled":"LiveChat käytössä","Livechat_Manager":"Livechat manageri","Livechat_managers":"Livechat managerit","Livechat_title":"Livechat otsikko","Livechat_title_color":"Livechat otsikon taustaväri","Livechat_Users":"Livechat käyttäjät","Load_more":"Lataa lisää","Loading...":"Ladataan...","Loading_more_from_history":"Ladataan lisää historiasta","Loading_suggestion":"Ladataan ehdotuksia...","Localization":"lokalisointi","Log_File":"Näytä Tiedostojen ja Line","Log_Level":"lokitaso","Log_Package":"Näytä pakkauksen","Log_View_Limit":"Lokinäkymässä Limit","Logged_out_of_other_clients_successfully":"Muut sessiot kirjattu ulos onnistuneesti","Login":"Kirjaudu","Login_with":"Kirjaudu käyttäen %s","login_with":"tai kirjaudu suoraan","Logout":"Kirjaudu ulos","Logout_Others":"Kirjaa ulos muut sessiot","Mail_Message_Invalid_emails":"Olet antanut virheellisiä sähköposteja: %s","Mail_Message_Missing_to":"Sinun tulee valita yksi tai useampi käyttäjä tai yksi tai useampi sähköpostiosoite, pilkuilla eroteltuna.","Mail_Message_No_messages_selected_select_all":"Et ole valinnut yhtään viestiä. Haluaisitko <a href='#' class='select-all'>valita kaikki</a> näkyvät viestit?","Mail_Messages":"Lähetä viestit sähköpostitse","Mail_Messages_Instructions":"Valitse, mitkä viestit haluat lähettää sähköpostitse klikkaamalla viestejä","Mail_Messages_Subject":"Tässä muutama viesti (%s viestiä)","Mailer":"Postittaja","Mailer_body_tags":"Sinun <b>tulee</b> käyttää [unsubscribe] postituslistalta poistumislinkkinä.<br />Voit käyttää [name], [fname], [lname] käyttäjän koko nimen, etunimen tai sukunimen paikalla.<br />Voit käyttää [email] käyttäjän sähköpostin paikalla.","Make_Admin":"Tee ylläpitäjäksi","Manager_added":"Manageri lisätty","Manager_removed":"Manageri poistettu","Mark_as_read":"Merkitse luetuksi","Markdown_Headers":"Markdown otsikot","Markdown_SupportSchemesForLink":"Markdown tukijärjestelmät Link","Markdown_SupportSchemesForLink_Description":"Pilkuilla erotettu lista sallittu järjestelmien","Members_List":"Jäsenlista","Mentions":"Maininnat","Mentions_default":"Mainitsee (oletus)","Message":"Viestit","Message_AllowDeleting":"Salli viestin poisto","Message_AllowEditing":"Salli viestin muokkaus","Message_AllowEditing_BlockEditInMinutes":"Estä viestin muokkaus (x) minuutin jälkeen","Message_AllowEditing_BlockEditInMinutesDescription":"Syötä 0 poistaaksesi muutoseston","Message_AllowPinning":"Salli viestien kiinnittäminen","Message_AllowPinning_Description":"Salli viestien kiinnitys kaikilla kanavilla.","Message_AllowStarring":"Salli viesteille tähti-merkki","Message_AudioRecorderEnabled":"Äänentallennin käytössä","Message_AudioRecorderEnabledDescription":"Jotta tämä toimisi, WAV-tiedostojen (mediatyyppi 'audio/wav') lähetys tulee olla sallittu","Message_DateFormat":"Päivämäärämuoto","Message_DateFormat_Description":"Katso myös: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Viestin poisto ei sallittu","Message_editing_blocked":"Tätä viestiä ei voi muokata enää.","Message_editing_not_allowed":"Viestin muokkaus ei sallittu","Message_GroupingPeriod":"Ryhmittelyaika (sekunneissa)","Message_GroupingPeriodDescription":"Viestit ryhmitellään edellisen viestin kanssa jos molemmat viestit ovat samalta käyttäjältä ja viestien välinen aika on pienempi kuin määritelty aika.","Message_KeepHistory":"Säilytä viestihistoria","Message_MaxAllowedSize":"Viestin suurin sallittu koko","Message_MaxAll":"Suurin kanavan koko ALL viesti","Message_pinned":"Viesti kiinnitetty","Message_pinning_not_allowed":"Viestien kiinnittäminen ei sallittu","Message_removed":"Viesti poistettu\n","Message_ShowDeletedStatus":"Näytä poistotila","Message_ShowEditedStatus":"Näytä muokkaustila","Message_ShowFormattingTips":"Näytä muotoiluvihjeet","Message_TimeFormat":"Aikamuoto","Message_TimeFormat_Description":"Katso myös: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Viesti liian pitkä","Messages":"Viestit","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Viestit, jotka lähetetään sisääntulevaan WebHookiin, postataan tänne","Meta":"Meta","Meta_fb_app_id":"Facebook APP ID","Meta_google-site-verification":"Google Site Verification","Meta_language":"Kieli","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Hakurobotit","minutes":"minuuttia","Mobile_push":"Mobile push","More_channels":"Lisää kanavia","More_direct_messages":"Enemmän suoria viestejä","More_groups":"Lisää privaattiryhmiä","More_unreads":"Lisää lukemattomia","Msgs":"Viestit","multi":"monta","Mute_someone_in_room":"Mykistä joku huoneessa","Mute_user":"Mykistä käyttäjä","Muted":"Mykistetty","My_Account":"Käyttäjätilini","n_messages":"%s viestiä","N_new_messages":" %s uutta viestiä","Name":"Nimi","Name_cant_be_empty":"Nimi ei voi olla tyhjä","Name_of_agent":"Agentin nimi","Name_optional":"Nimi (valinnainen)","Navigation_History_20_last_pages":"Navigointihistoria (viimeiset 20 sivua)","New_Application":"Uusi sovellus","New_Custom_Field":"Uusi oma Field","New_Department":"Uusi osasto","New_integration":"Uusi integraatio","New_logs":"Uudet lokit","New_messages":"Uusia viestejä","New_password":"Uusi salasana","New_role":"Uusi rooli","No_channel_with_name_%s_was_found":"Kanavaa nimeltä '%s' ei löytynyt!","No_channels_yet":"Et ole vielä millään kanavalla.","No_direct_messages_yet":"Et ole vielä aloittanut mitään keskustelua.","No_Encryption":"ei Encryption","No_favorites_yet":"Et ole vielä lisännyt suosikkeja.","No_group_with_name_%s_was_found":"Privaattiryhmää '%s' ei löytynyt!","No_groups_yet":"Sinulla ei ole vielä privaattiryhmiä.","No_livechats":"Sinulla ei ole livechatteja.","No_mentions_found":"Mainintoja ei löytynyt","No_permission_to_view_room":"Sinulla ei ole oikeutta katsella tätä","No_pinned_messages":"Ei kiinnitettyjä viestejä","No_results_found":"Ei tuloksia","No_starred_messages":"Ei tähdellä merkittyjä viestejä","no_tokens_for_this_user":"Valtuutusta käyttäjälle ei löydy","No_user_with_username_%s_was_found":"Käyttäjää nimeltä <strong>\"%s\"</strong> ei löytynyt!","Not_allowed":"Ei sallittu","Not_authorized":"Ei sallittu","Not_Available":"Ei saatavilla","Not_found_or_not_allowed":"Ei löydy tai ei sallittu","Nothing":"Ei mitään","Nothing_found":"Ei löytynyt","Notifications":"ilmoitukset","Notify_all_in_this_room":"Ilmoita kaikille kanavallaolijoille","Num_Agents":"# Agenttia","Number_of_messages":"Sanomien lukumäärä","OAuth_Application":"OAuth sovellus","OAuth_Applications":"OAuth sovellukset","Objects":"Esineet","Off_the_record_conversation":"Off-the-record Keskustelu","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record keskustelu ei ole käytettävissä selainta tai laitetta.","Offline_DM_Email":"[__site__] Sinut on suoraan viesteistä by __user__","Offline_Mention_Email":"[__site__] Olet mainitsi __user__ vuonna #__room__","Old_and_new_password_must_be_different":"Uuden salasanan on oltava erilainen kuin vanha salasana.","Old_and_new_password_required":"Sinun täytyy antaa sekä vanha että uusi salasana, että saat vaihdettua salasanasi.","Online":"Online","Only_errors":"Vain virheet","Only_you_can_see_this_message":"Vain sinä voit nähdä tämän viestin","Oops!":"Oho","Open":"Avata","Opened":"Avattu","Opt_out_statistics":"Älä lähetä anonyymejä tilastoja Rocket.Chatille","Opt_out_statistics_warning":"Lähettämällä anonyymit tilastot, autat meitä selvittämään, kuinka monta Rocket.Chat -ympäristöä on käynnistetty, kuten myös sen, miten hyvin järjestelmä toimii. Tätä tietoa käytetään Rocket.Chatin parantamiseen.\nJos haluat jatkaa anonyymien tilastojen lähettämistä, poista ylläoleva ruksi. Kiitos.","optional":"valinnainen","Order":"Järjestys","OS_Arch":"OS Arkkitehtuuri","OS_Cpus":"OS CPU määrä","OS_Freemem":"OS Vapaa muisti","OS_Loadavg":"OS Keskimääräinen kuorma","OS_Platform":"OS Alusta","OS_Release":"OS Julkaisu","OS_Totalmem":"OS Muisti yhteensä","OS_Type":"OS Tyyppi","OS_Uptime":"OS Päälläoloaika","others":"muut","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR on käytettävissä vain, kun molemmat käyttäjät ovat verkossa","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Ohitus URL johon tiedostot ladataan. Tämä url käytetään myös ladattavia ellei CDN annetaan","Password":"Salasana","Password_Change_Disabled":"Rocket.Chat ylläpitäjäsi on poistanut salasanan vaihtamismahdollisuuden","Password_changed_successfully":"Salasana vaihdettu","Payload":"hyötykuorma","People":"Ihmiset","Permissions":"Oikeudet","Pin_Message":"Kiinnitä viesti","Pinned_a_message":"Puristuksiin viesti:","Pinned_Messages":"Kiinnitetyt viestit","Placeholder_for_email_or_username_login_field":"Paikkamerkki sähköpostin tai käyttäjätunnus kirjautuminen kenttä","Placeholder_for_password_login_field":"Paikkamerkki sisäänkirjautumissalasanasi kentän","Please_answer_survey":"Käytä hetki vastataksesi pikakyselyyn tästä chatista","Please_enter_value_for_url":"Anna avatarisi URL","Please_enter_your_new_password_below":"Anna uusi salasana:","Please_fill_a_label":"Täytä etiketti","Please_fill_a_name":"Täytä nimi","Please_fill_a_username":"Täytä käyttäjätunnus","Please_fill_name_and_email":"Täytä nimi ja sähköpostiosoite","Please_re_enter_your_password":"Kirjautumista uudelleen salasana","Please_select_enabled_yes_or_no":"Valitse vaihtoehto Käytössä","Please_wait":"Odota hetki","Please_wait_activation":"Odota, tämä voi kestää jonkin aikaa.","Please_wait_statistics":"Odota, tilastoja generoidaan.","Please_wait_while_OTR_is_being_established":"Odota OTR ollaan perustamassa","Please_wait_while_your_account_is_being_deleted":"Odota tilin on poistettu ...","Please_wait_while_your_profile_is_being_saved":"Odota profiili tallennetaan ...","Post_as":"Postaa käyttäjänä","Post_to_Channel":"Postaa kanavalle","Post_to_s_as_s":"Postaa paikkaan <strong>%s</strong> käyttäjänä <strong>%s</strong>","Powered_by":"Powered by","Preferences":"Asetukset","Preferences_saved":"Asetukset tallennettu","Privacy":"Yksityisyys","Private_Group":"Privaattiryhmä","Private_Groups":"Privaattiryhmät","Private_Groups_list":"Privaattiryhmäluettelo","Profile":"Profiili","Profile_saved_successfully":"Profiili tallennettu onnistuneesti","Proudly_developed":"Proudly developed with Meteor","Push":"Push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Cert (kehitys)","Push_apn_dev_key":"APN Key (kehitys)","Push_apn_dev_passphrase":"APN Passphrase (kehitys)","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Debug","push_disabled":"Push pois päältä","Push_enable":"Kytke päälle","Push_enable_gateway":"Ota yhdyskäytävä käyttöön","Push_gateway":"Yhdyskäytävä","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Project Number","Push_production":"Tuotanto","Push_show_message":"Näytä viesti ilmoitus","Push_show_username_room":"Näytä kanava / ryhmä / käyttäjänimi ilmoituksessa","Push_test_push":"Testaa","Query":"Kysely","Query_description":"Lisämäärittelyt, joiden perusteella määritellään kenelle lähetetään sähköposteja. Postituslistalta poistuneita ei koskaan sisällytetä vastaanottajiin. Kyselymäärityksen tulee olla validia JSONia. Esimerkiksi:  \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Pikaetsintä","quote":"lainaus","Reactions":"reaktiot","Recents":"Viimeisimmät","Record":"Nauhoita","Redirect_URI":"Ohjaus URI","Refresh_keys":"Päivitä avaimet","Refresh_your_page_after_install_to_enable_screen_sharing":"Päivitä sivu asennuksen jälkeen ottaaksesi käyttöön näytön jakamisen","Register":"Rekisteröi uusi käyttäjätili","Registration_Succeeded":"Rekisteröinti onnistui","Remember_me":"Muista minut","Remove":"Poista","Remove_Admin":"Poista ylläpitäjyys","Remove_as_moderator":"Poista moderaattoristatus","Remove_as_owner":"Poista omistajuus","Remove_custom_oauth":"Poista mukautettu oauth","Remove_from_room":"Poista huoneesta","Remove_someone_from_room":"Poista joku huoneesta","Removed":"Poistettu","Require_password_change":"Vaadi salasanan vaihto","Resend_verification_email":"Lähetä Vahvistussähköposti Uudelleen","Reset":"Nollaa","Reset_password":"Nollaa salasana","Restart":"Käynnistä uudelleen","Restart_the_server":"Käynnistä palvelin uudelleen","RocketBot_Enabled":"RocketBot otettu käyttöön","RocketBot_Name":"RocketBot nimi","RocketBot_Name_Description":"RocketBot nimen on oltava kelvollinen käyttäjänimi rekisteröityneenä palvelimellasi.","Role":"Rooli","Role_Editing":"Roolin muokkaaminen","Role_removed":"Rooli poistettu","Room":"Huone","Room_archivation_state":"Osavaltio","Room_archivation_state_false":"aktiivinen","Room_archivation_state_true":"arkistoitu","Room_archived":"Huone arkistoitu","room_changed_privacy":"Huoneen tyyppi vaihdettu <em>__room_type__</em> käyttäjän <em>__user_by__</em> toimesta","room_changed_topic":"Huoneen aihe vaihdettu <em>__room_topic__</em> käyttäjän <em>__user_by__</em> toimesta","Room_has_been_deleted":"Huone poistettu","Room_Info":"Huoneen info","Room_name_changed":"Huoneen nimi vaihdettu <em>__room_name__</em> <em>__user_by__</em> toimesta","Room_name_changed_successfully":"Huoneen nimi vaihdettu","Room_not_found":"Huonetta ei löytynyt","Room_topic_changed_successfully":"Huoneen aihe vaihdettu","Room_type_changed_successfully":"Huoneen tyyppi vaihdettu","Room_unarchived":"Huone palautettu arkistosta","Room_uploaded_file_list":"Tiedostolista","Room_uploaded_file_list_empty":"Tiedostoja ei ole saatavilla.","room_user_count":"%s käyttäjää","Rooms":"Huoneet","S_new_messages_since_s":"%s uutta viestiä lähtien %s","SAML":"SAML","SAML_Custom_Cert":"Custom sertifikaatti","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Generoi käyttäjätunnus","SAML_Custom_Issuer":"Custom Issuer","SAML_Custom_Provider":"Custom Provider","Save":"Tallenna","Save_changes":"Tallenna muutokset","Save_Mobile_Bandwidth":"Säästä kaistaa mobiilissa","Save_to_enable_this_action":"Tallenna jotta tätä toimintaa","Saved":"Tallennettu","Saving":"Tallennetaan","Scope":"laajuus","Screen_Share":"Näytön jakaminen","Script_Enabled":"script Käytössä","Search":"Etsi","Search_by_username":"Etsi käyttäjätunnus","Search_Channels":"haku Kanavat","Search_Direct_Messages":"Hae suoria viestejä","Search_Messages":"Etsi viestejä","Search_Private_Groups":"Haku Yksityiset Ryhmät","Search_settings":"Etsi asetuksista","seconds":"sekuntia","See_all":"Katso kaikki","See_only_online":"Vain online-tila","Select_a_department":"Valitse osasto","Select_an_avatar":"Valitse avatar","Select_file":"Valitse tiedosto","Select_service_to_login":"Valitse kirjautumiseen käytettävä palvelu tai lataa kuvasi suoraan koneeltasi","Select_user":"Valitse käyttäjä","Select_users":"Valitse käyttäjät","Selected_agents":"Valitut agentit","Selected_users":"Valitut käyttäjät","Send":"Lähetä","Send_a_message":"Lähetä viesti","Send_a_test_mail_to_my_user":"Lähetä testisähköposti käyttäjälle","Send_a_test_push_to_my_user":"Lähetä testi-push käyttäjälle","Send_confirmation_email":"Lähetä vahvistussähköposti","Send_data_into_RocketChat_in_realtime":"Lähetä data Rocket.Chatiin reaaliajassa","Send_email":"Lähetä sähköposti","Send_invitation_email":"Lähetä kutsusähköposti","Send_invitation_email_error":"Et ole antanyt yhtään validia sähköpostiosoitetta.","Send_invitation_email_info":"Voit lähettää useita sähköpostikutsuja kerralla.","Send_invitation_email_success":"Olet onnistuneesti lähettänyt sähköpostikutsun seuraaviin osoitteisiin:","Send_invitation_email_warning":"Lähettääksesi sähköpostikutsuja, sinun täytyy ensin tehdä SMTP asetukset.","Send_Message":"Lähetä viesti","Send_your_JSON_payloads_to_this_URL":"Lähetä JSON payload tähän URL-osoitteeseen","Sending":"Lähetetään...","Set_as_moderator":"Aseta moderaattoriksi","Set_as_owner":"Aseta omistajaksi","Settings":"Asetukset","Settings_updated":"Asetukset päivitetty","Should_be_a_URL_of_an_image":"Kuvan URL-osoite","Should_exists_a_user_with_this_username":"Käyttäjä tällä käyttäjätunnuksella tulisi olla olemassa","Show_all":"Näytä kaikki","Show_more":"Näytä lisää","Show_only_online":"Näytä vain verkossa","Show_preregistration_form":"Näytä esirekisteröintilomake","Showing_archived_results":"<p>Näytetään <b>%s</b> arkistoitua tulosta</p>","Showing_online_users":"Näytetään <b>__total_showing__</b>/__total__ users","Showing_results":"<p>Näytetään <b>%s</b> tulosta</p>","Silence":"Hiljaisuus","since_creation":"%s saakka","Site_Name":"Sivuston nimi:","Site_Url":"Sivuston URL-osoite","Site_Url_Description":"Esimerkiksi: https://chat.domain.com/","Skip":"Ohita","Smileys_and_People":"Hymiöitä & Ihmiset","SMTP":"SMTP","SMTP_Host":"SMTP-palvelin","SMTP_Password":"SMTP Salasana","SMTP_Port":"SMTP-portti","SMTP_Test_Button":"Testaa SMTP-asetukset","SMTP_Username":"SMTP Käyttäjätunnus","Sound":"Ääni","Star_Message":"Merkkaa tähdellä","Starred_Messages":"Tähdellä merkityt viestit","Start_audio_call":"Aloita äänipuhelu","Start_Chat":"Aloita chat","Start_of_conversation":"Keskustelun alku","Start_OTR":"Start OTR","Start_video_call":"Aloita videopuhelu","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Aloita <code class=\"inline\">%s</code> käyttäjänä or <code class=\"inline\">%s</code> kanavana. Esim: <code class=\"inline\">%s</code> tai <code class=\"inline\">%s</code>","Statistics":"Tilastot","Stats_Active_Users":"Aktiivisia käyttäjiä","Stats_Avg_Channel_Users":"Keskimääräinen kanavan käyttäjämäärä","Stats_Avg_Private_Group_Users":"Keskimääräinen käyttäjämäärä","Stats_Away_Users":"Poissaolevat käyttäjät","Stats_Max_Room_Users":"Maksimi käyttäjämäärä","Stats_Non_Active_Users":"Passiivisia käyttäjiä","Stats_Offline_Users":"Offline-käyttäjiä","Stats_Online_Users":"Online-käyttäjiä","Stats_Total_Channels":"Kanavia yhteensä","Stats_Total_Direct_Messages":"Yksityisviestikeskustelujen määrä","Stats_Total_Messages":"Viestejä yhteensä","Stats_Total_Private_Groups":"Privaattiryhmien määrä","Stats_Total_Rooms":"Huoneiden määrä","Stats_Total_Users":"Käyttäjiä yhteensä","Stop_Recording":"Lopeta nauhoittaminen","strike":"yliviivaa","Subject":"Aihe","Submit":"Lähetä","Success":"Onnistui","Survey":"Tutkimus","Survey_instructions":"Arvioi jokainen kysymys sen mukaan miten tyytyväinen olet, 1 tarkoittaa että olet täysin tyytymätön ja 5 tarkoittaa että olet täysin tyytyväinen.","Symbols":"Symbolit","Sync_success":"Sync menestys","Sync_Users":"Sync Käyttäjät","Test_Connection":"Testaa yhteys","Test_Desktop_Notifications":"Test Työpöytäilmoitusten","Thank_you_for_your_feedback":"Kiitos palautteestasi","The_application_name_is_required":"Sovelluksen nimi on pakollinen","The_channel_name_is_required":"Kanavan nimi on määriteltävä","The_emails_are_being_sent":"Sähköposteja lähetetään.","The_field_is_required":"Kenttä %s vaaditaan.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Kuvien koon muuttaminen ei toimi koska ImageMagickia tai GraphicsMagickia ei havaittu asennettuna palvelimelle.","The_redirectUri_is_required":"Ohjaus URI on pakollinen","The_server_will_restart_in_s_seconds":"Palvelin käynnistyy %s sekunnin kuluttua","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Asetus <strong>%s</strong> on määritelty arvoon <strong>%s</strong> yrität käyttää tätä lähteenä <strong>%s</strong>!","The_user_will_be_removed_from_s":"Käyttäjä poistetaan %s","The_user_wont_be_able_to_type_in_s":"Käyttäjä ei pysty kirjoittamaan %s","Theme":"Ulkoasu","theme-color-action-buttons-color":"Toimintapainikkeiden väri","theme-color-active-channel-background-color":"Aktiivisen kanavan taustaväri","theme-color-active-channel-font-color":"Aktiivisen kanavan tekstin väri","theme-color-blockquote-background":"Lainauksen taustaväri","theme-color-clean-buttons-color":"Puhdista painikkeet Color","theme-color-code-background":"Koodin taustaväri","theme-color-code-border":"Koodin reunusväri","theme-color-code-color":"Koodin väri","theme-color-content-background-color":"Sisällön taustaväri","theme-color-custom-scrollbar-color":"Vierityspalkin väri (custom)","theme-color-info-active-font-color":"Aktiivisen infon fontin väri","theme-color-info-font-color":"Infon fontin väri","theme-color-input-font-color":"Syötteen fontin väri","theme-color-link-font-color":"Linkin fontin väri","theme-color-message-hover-background-color":"Message Hover BG Color","theme-color-primary-background-color":"Ensisijainen taustaväri","theme-color-primary-font-color":"Ensisijainen fontin väri","theme-color-quaternary-font-color":"Neljäs tekstin väri","theme-color-secondary-background-color":"Toissijainen taustaväri","theme-color-secondary-font-color":"Toissijainen fontin väri","theme-color-smallprint-font-color":"Pienen tekstin fontin väri","theme-color-smallprint-hover-color":"Pienen tekstin korostusväri","theme-color-status-away":"Poissa-tilan väri","theme-color-status-busy":"Varattu-tilan väri","theme-color-status-offline":"Offline-tilan väri","theme-color-status-online":"Online-tilan väri","theme-color-tertiary-background-color":"Tertiäärinen (se kolmas) taustaväri","theme-color-tertiary-font-color":"Tertiäärinen (se kolmas) fontin väri","theme-color-unread-notification-color":"Lukemattomat Ilmoitukset Color","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"Yhtään agenttia ei ole vielä lisätty tähän osastoon.","There_are_no_integrations":"Ei integraatioita","There_are_no_users_in_this_role":"Roolissa ei ole käyttäjiä","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Tämä sähköpostiosoite on jo käytetty ja ei ole vahvistettu. Vaihda salasana.","This_is_a_desktop_notification":"Tämä on työpöydän ilmoitus","This_is_a_push_test_messsage":"Tämä on testi-pushviesti","Time_in_seconds":"Aika sekunneissa","Title_bar_color":"Otsikkorivin väri","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Asentaaksesi Rocket.Chat Livechatin sivustollesi, kopioi ja liitä seuraava sivusi <strong>&lt;/body&gt;</strong> osion yläpuolelle.","To_users":"Käyttäjille","Topic":"Aihe","Travel_and_Places":"Travel & Places","Trigger_removed":"Laukaisija poistettu","Trigger_Words":"Käynnistyssanat","Triggers":"Laukaisijat","True":"Kyllä","Type":"Tyyppi","Type_your_new_password":"Anna uusi salasana","Unarchive":"Palauta arkistosta","Unmute_someone_in_room":"Poista jonkun mykistys huoneessa","Unmute_user":"Poista mykistys käyttäjältä","Unnamed":"Nimetön","Unpin_Message":"Poista kiinnitys","Unread_Rooms":"Lukemattomia","Unread_Rooms_Mode":"Lukemattomien tila","Unstar_Message":"Poista tähti","Upload_file_question":"Lähetä tiedosto?","Uploading_file":"Ladataan tiedostoa...","Use_account_preference":"Käytä tilin etusija","Use_Emojis":"Käytä Emojia","Use_initials_avatar":"Käytä käyttäjätunnuksen nimikirjaimia","use_menu":"Käytä sivuvalikkoa käyttääksesi huoneitasi ja chattejasi","Use_service_avatar":"Käytä %s avataria","Use_this_username":"Käytä tätä käyttäjänimieä","Use_uploaded_avatar":"Käytä ladattua avataria","Use_url_for_avatar":"Käytä avatar-URLia","User__username__is_now_a_moderator_of__room_name_":"Käyttäjä __username__ on nyt __room_name__ moderaattori","User__username__is_now_a_owner_of__room_name_":"Käyttäjä __username__ on nyt __room_name__ omistaja","User__username__removed_from__room_name__moderators":"Käyttäjän __username__ moderaattoristatus __room_name__  on poistettu","User__username__removed_from__room_name__owners":"Käyttäjä __username__ poistettu __room_name__ omistajista","User_added":"Käyttäjä <em>__user_added__</em> lisätty.","User_added_by":"Käyttäjä <em>__user_added__</em> lisätty <em>__user_by__</em> toimesta.","User_added_successfully":"Käyttäjän lisääminen onnistui","User_Channels":"Käyttäjän kanavat","User_doesnt_exist":"Yhtään käyttäjää ei ole olemassa nimellä `@%s`.","User_has_been_activated":"Käyttäjä on aktivoitu","User_has_been_deactivated":"Käyttäjä on deaktivoitu","User_has_been_deleted":"Käyttäjä on poistettu","User_has_been_muted_in_s":"Käyttäjä on mykistetty %s","User_has_been_removed_from_s":"Käyttäjä on poistettu %s","User_has_disconnected":"Käyttäjä on katkaistu","User_Info":"Käyttäjän tiedot","User_is_no_longer_an_admin":"Käyttäjä ei ole enää ylläpitäjä","User_is_not_activated":"Käyttäjää ei ole aktivoitu","User_is_now_an_admin":"Käyttäjä on nyt ylläpitäjä","User_joined_channel":"Liittyi kanavalle.","User_joined_channel_female":"Liittyi kanavalle.","User_joined_channel_male":"Liittyi kanavalle.","User_left":"Käyttäjä poistui kanavalta.","User_left_female":"Käyttäjä poistui kanavalta.","User_left_male":"Käyttäjä poistui kanavalta.","User_logged_out":"Käyttäjä on kirjautunut ulos","User_management":"Käyttäjähallinta","User_muted_by":"Käyttäjä <em>__user_muted__</em> mykistetty <em>__user_by__</em> toimesta.","User_muted_in_room":"Käyttäjä mykistetty huoneessa","User_not_found":"Käyttäjää ei löydy","User_not_found_or_incorrect_password":"Käyttäjää ei löydy tai väärä salasana","User_or_channel_name":"Käyttäjän tai kanavan nimi","User_removed":"Käyttäjä on poistettu","User_removed_by":"Käyttäjä <em>__user_removed__</em> poistettu <em>__user_by__</em> toimesta.","User_removed_from_room":"Käyttäjä on poistettu huoneesta","User_Settings":"Käyttäjän asetukset","User_unmuted_by":"Käyttäjän <em>__user_unmuted__</em> mykistys poistettu <em>__user_by__</em> toimesta.","User_unmuted_in_room":"Käyttäjän mykistys poistettu huoneessa","User_updated_successfully":"Käyttäjän tiedot päivitetty","Username":"Käyttäjänimi","Username_and_message_must_not_be_empty":"Käyttäjätunnus ja viesti ei saa olla tyhjä.","Username_cant_be_empty":"Käyttäjänimi ei voi olla tyhjä","Username_Change_Disabled":"Rocket.Chat ylläpitäjäsi on poistanut käyttäjätunnuksen vaihtamismahdollisuuden","Username_denied_the_OTR_session":"__username__ kiisti OTR istunto","Username_description":"Käyttäjänimeä käytetään sinun mainitsemiseen muiden viesteissä.","Username_doesnt_exist":"Käyttäjätunnusta  `# %s` ei ole olemassa.","Username_ended_the_OTR_session":"__username__ päättyi OTR istunto","Username_invalid":"<strong>%s</strong> ei ole kelvollinen käyttäjänimi,<br/> käytä vain kirjaimia, numeroita, pistettä ja viivaa","Username_is_already_in_here":"`@%s` on jo täällä.","Username_is_not_in_this_room":"Käyttäjä `# %s` ei ole tässä huoneessa.","Username_not_found":"Käyttäjätunnusta ei löydy","Username_title":"Rekisteröi käyttäjänimi","Username_unavaliable":"<strong>%s</strong> on jo käytössä :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ haluaa alkaa OTR. Haluatko hyväksyä?","Users":"Käyttäjät","Users_in_role":"Roolin käyttäjiä","UTF8_Names_Slugify":"Siisti UTF8-nimet","UTF8_Names_Validation":"UTF-nimien validointi","UTF8_Names_Validation_Description":"Älä anna erikoismerkkejä ja välilyöntejä. Voit käyttää - _ ja . mutta ei nimen lopussa","Verification_email_sent":"Vahvistusviesti lähetetty","View_All":"Katso kaikki","View_Logs":"Katso lokit","Visibility":"näkyvyys","Visible":"näkyvä","Visitor":"Vierailija","Visitor_page_URL":"Vierailijan sivun URL","Visitor_time_on_site":"Vierailijan aika sivustolla","Wait_activation_warning":"Ennen kuin voit kirjautua, tunnuksesi pitää aktivoida ylläpitäjän toimesta.","We_are_offline_Sorry_for_the_inconvenience":"Palvelu on offline-tilassa. Pahoittelut häiriöstä.","We_have_sent_password_email":"Lähetimme salasanan nollausohjeet sähköpostiisi. Mikäli et saanut sähköpostia, yritä uudelleen.","We_have_sent_registration_email":"Lähetimme rekisteröitymisvahvistuksen sähköpostiisi. Mikäli et saanut sähköpostia, yritä uudelleen.","WebRTC_Enable_Channel":"Ota käyttöön julkisilla kanavilla","WebRTC_Enable_Direct":"Ota käyttöön yksityisviesteissä","WebRTC_Enable_Private":"Ota käyttöön privaattiryhmissä","WebRTC_Servers":"STUN / TURN palvelimet","WebRTC_Servers_Description":"Luettelo STUN ja TURN palvelimia erotettu pilkulla. <br/> Käyttäjätunnus, salasana ja portti ovat sallittuja muodossa `käyttäjänimi: salasana @ stun: isäntä: satamalla tai` käyttäjänimi: salasana @ puolestaan: isäntä: satamalla.","Welcome":"Tervetuloa <em>%s</em>.","Welcome_to_the":"Tervetuloa","will_be_able_to":"mahdollistaa","With_whom":"kanssa","Yes":"Kyllä","Yes_clear_all":"Jep, tyhjennä kaikki!","Yes_delete_it":"Kyllä, poista!","Yes_hide_it":"Kyllä, piilottaa sen!","Yes_leave_it":"Kyllä, jätä se!","Yes_mute_user":"Kyllä, mykistä käyttäjä!","Yes_remove_user":"Kyllä, poista käyttäjä!","you_are_in_preview_mode_of":"Tämä on kanavan #<strong>__room_name__</strong> esikatselutila","You_are_logged_in_as":"Olet kirjautunut sisään käyttäjänä","You_are_not_authorized_to_view_this_page":"Sinulla ei ole oikeuksia tarkastella tätä sivua.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Olet viimeinen omistaja. Aseta uusi omistaja ennen lähtöä huone.","You_can_change_a_different_avatar_too":"Voit vaihtaa tähän eri avatarin tätä integraatiota varten","You_can_use_an_emoji_as_avatar":"Voit käyttää myös emojia avatarina.","You_have_been_muted":"Olet mykistetty, et voi puhua tässä huoneessa.","You_have_not_verified_your_email":"Et ole vahvistanut sähköpostisi.","You_have_successfully_unsubscribed":"Sinut on poistettu onnistuneesti postituslistaltamme.","You_informed_an_invalid_FROM_address":"Virheellinen lähettäjän osoite.","You_must_provide_the_unsubscribe_link":"Sinun on annettava [unsubscribe] -linkki.","You_need_confirm_email":"Sinun tulee vahvistaa sähköpostiosoitteesi!","You_need_install_an_extension_to_allow_screen_sharing":"Sinun tarvitsee asentaa laajennus mahdollistaaksesi näytön jakamisen","You_need_to_change_your_password":"Sinun täytyy vaihtaa salasana","You_need_to_type_in_your_password_in_order_to_do_this":"Sinun täytyy kirjoittaa salasana, jotta tehdä tätä!","You_need_to_type_in_your_username_in_order_to_do_this":"Sinun täytyy kirjoittaa käyttäjätunnus, jotta tehdä tätä!","You_need_to_verifiy_your_email_address_to_get_notications":"Sinun täytyy verifiy sähköpostiosoitteesi saada ilmoituksia","You_should_name_it_to_easily_manage_your_integrations":"Nimeä siten, että sinun on helppo hallita integraatioitasi","You_will_not_be_able_to_recover":"Viestin palauttaminen ei ole mahdollista!","You_will_not_be_able_to_recover_file":"Et voi palauttaa tätä tiedostoa!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Et saa sähköposti-ilmoituksia, koska et ole vahvistanut sähköpostisi.","Your_email_has_been_queued_for_sending":"Sähköpostisi on lähetysjonossa","Your_entry_has_been_deleted":"Your entry has been deleted.","Your_file_has_been_deleted":"Tiedosto on poistettu.","Your_mail_was_sent_to_s":"Sähköpostisi lähetettiin, vastaanottaja %s","Your_Open_Source_solution":"Your own Open Source chat solution","Your_password_is_wrong":"Salasana on väärä!","Your_push_was_sent_to_s_devices":"Push-viesti lähetettiin %s laitteeseen"});
TAPi18n._registerServerTranslator("fi", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/fr.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["fr"] = ["French (France)","Français"];                                                        // 8
if(_.isUndefined(TAPi18n.translations["fr"])) {                                                                        // 9
  TAPi18n.translations["fr"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["fr"][namespace])) {                                                             // 13
  TAPi18n.translations["fr"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["fr"][namespace], {"500":"Erreur interne au serveur","0_Errors_Only":"0 - Erreurs seulement","1_Errors_and_Information":"1 - Erreurs et Informations","2_Erros_Information_and_Debug":"2 - Erreurs, Informations et Debug","__username__was_set__role__by__user_by_":"__username__ a été fixé par __role__ __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ est plus __role__, par __user_by__","Access_not_authorized":"Accès non autorisé","Access_online_demo":"Accédez à la démo en ligne","Access_Online_Demo":"Accédez à la démo en ligne","Access_Token_URL":"URL de l'Access Token","Accounts":"Comptes","Accounts_AllowDeleteOwnAccount":"Autoriser les utilisateurs à supprimer leur propre compte","Accounts_AllowedDomainsList":"Liste des domaines autorisés","Accounts_AllowedDomainsList_Description":"Liste des domaines autorisés (séparés par des virgules)","Accounts_AllowEmailChange":"Autoriser le changement d'adresse e-mail","Accounts_AllowPasswordChange":"Autoriser le changement de mot de passe","Accounts_AllowUserAvatarChange":"Autoriser le changement d'avatar","Accounts_AllowUsernameChange":"Autoriser le changement de nom d'utilisateur","Accounts_AllowUserProfileChange":"Autoriser le changement de profil","Accounts_AvatarResize":"Redimensionner les avatars","Accounts_AvatarSize":"Taille des avatars","Accounts_AvatarStorePath":"Chemin de stockage des avatars","Accounts_AvatarStoreType":"Type de stockage des avatars","Accounts_BlockedDomainsList":"Liste des domaines bloqués","Accounts_BlockedDomainsList_Description":"Liste de domaines bloqués séparés par des virgules","Accounts_denyUnverifiedEmail":"Refuser les e-mails non vérifiés","Accounts_EmailVerification":"Vérification de l'adresse e-mail","Accounts_EmailVerification_Description":"Vous devez avoir des paramètres SMTP corrects pour utiliser cette fonctionnalité","Accounts_Enrollment_Email":"E-mail d'inscription","Accounts_Enrollment_Email_Description":"Vous pouvez utiliser [name], [fname], [lname] pour le nom complet de l'utilisateur, le prénom et le nom de famille respectivement.<br />Vous pouvez utiliser [email] pour l'adresse e-mail de l'utilisateur.","Accounts_Iframe_api_method":"Méthode de l'API","Accounts_Iframe_api_url":"URL de l'API","Accounts_iframe_enabled":"Activé","Accounts_iframe_url":"URL de l'Iframe","Accounts_LoginExpiration":"Expiration de la connexion (jours)","Accounts_ManuallyApproveNewUsers":"Approuver manuellement les nouveaux utilisateurs","Accounts_OAuth_Custom_Token_Sent_Via":"Token Via Sent","Accounts_OAuth_Custom_Authorize_Path":"URL d'autorisation","Accounts_OAuth_Custom_Button_Color":"Couleur du bouton","Accounts_OAuth_Custom_Button_Label_Color":"Couleur du texte du bouton","Accounts_OAuth_Custom_Button_Label_Text":"Texte du bouton","Accounts_OAuth_Custom_Enable":"Activer","Accounts_OAuth_Custom_id":"ID","Accounts_OAuth_Custom_Identity_Path":"URL d'identification","Accounts_OAuth_Custom_Login_Style":"Style de la page de connexion","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"URL de Token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Connexion avec Facebook","Accounts_OAuth_Facebook_callback_url":"Facebook URL de Callback","Accounts_OAuth_Facebook_id":"ID Facebook App ","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"Connexion avec GitHub","Accounts_OAuth_Github_callback_url":"GitHub URL de Callback","Accounts_OAuth_GitHub_Enterprise":"OAuth activé","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Entreprise URL de Callback","Accounts_OAuth_GitHub_Enterprise_id":"GitHub Entreprise ID","Accounts_OAuth_GitHub_Enterprise_secret":"GitHub Entreprise Secret","Accounts_OAuth_Github_id":"ID client","Accounts_OAuth_Github_secret":"GitHub Secret","Accounts_OAuth_Gitlab":"OAuth activé","Accounts_OAuth_Gitlab_callback_url":"GitLab URL de Callback","Accounts_OAuth_Gitlab_id":"ID GitLab","Accounts_OAuth_Gitlab_secret":"Mot de passe client","Accounts_OAuth_Google":"Connexion avec Google","Accounts_OAuth_Google_callback_url":"Google URL de Callback","Accounts_OAuth_Google_id":"ID Google ","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"Connexion avec LinkedIn","Accounts_OAuth_Linkedin_callback_url":"LinkedIn URL de Callback","Accounts_OAuth_Linkedin_id":"ID LinkedIn ","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Connexion avec Meteor","Accounts_OAuth_Meteor_callback_url":"Meteor URL de Callback","Accounts_OAuth_Meteor_id":"ID Meteor ","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Connexion avec Twitter","Accounts_OAuth_Twitter_callback_url":"Twitter URL de Callback","Accounts_OAuth_Twitter_id":"ID Twitter","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"WordPress URL de Callback","Accounts_OAuth_Wordpress_id":"WordPress ID ","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Mot de passe réinitialisé","Accounts_Registration_AuthenticationServices_Enabled":"Enregistrement des comptes avec les services d'authentification","Accounts_RegistrationForm":"Formulaire d'inscription","Accounts_RegistrationForm_Disabled":"Désactivé","Accounts_RegistrationForm_LinkReplacementText":"Texte de remplacement des liens dans le formulaire d'inscription","Accounts_RegistrationForm_Public":"Publique","Accounts_RegistrationForm_Secret_URL":"URL secrète","Accounts_RegistrationForm_SecretURL":"URL secrète du formulaire d'inscription","Accounts_RegistrationForm_SecretURL_Description":"Vous devez fournir une chaîne de caractères aléatoire qui sera ajoutée à votre URL d'inscription. Exemple: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Enregistrement nécessaire","Accounts_RequireNameForSignUp":"Exiger un nom pour s'inscrire","Accounts_ShowFormLogin":"Afficher le formulaire de connexion","Accounts_UseDefaultBlockedDomainsList":"Utiliser la liste par défaut de domaines bloqués","Accounts_UseDNSDomainCheck":"Utiliser la vérification de Domaine du DNS","Activate":"Activer","Activity":"Activité","Add":"Ajouter","Add_agent":"Ajouter un assistant","Add_custom_oauth":"Ajouter OAuth personnalisé","Add_manager":"Ajouter un manager","Add_Members":"Ajouter des membres","Add_User":"Ajouter un utilisateur","Add_user":"Ajouter un utilisateur","Add_users":"Ajouter des utilisateurs","Additional_emails":"Adresses e-mail additionnelles","Additional_Feedback":"Commentaires supplémentaires","Administration":"Administration","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Après l'authentification par OAuth2, les utilisateurs seront redirigés vers cette URL","Agent_added":"Assistant ajouté","Agent_removed":"Assistant retiré","Alias":"Alias","All":"Tous","All_channels":"Tous les canaux","All_logs":"Tous les journaux","All_messages":"Tous les messages","Allow_Invalid_SelfSigned_Certs":"Autoriser les certificats auto-signés invalides","Allow_Invalid_SelfSigned_Certs_Description":"Autoriser les certificats SSL invalides et auto-signés pour la validation des liens et extraits.","and":"et","And_more":"et plus de __lenght__...","Animals_and_Nature":"Faune & Flore","API":"API","API_Analytics":"Analytique","API_Embed":"Embed","API_EmbedDisabledFor":"Désactiver l'intégration externe pour les utilisateurs","API_EmbedDisabledFor_Description":"Liste de noms d'utilisateurs séparés par des virgules","API_GitHub_Enterprise_URL":"URL du serveur","API_GitHub_Enterprise_URL_Description":"Exemple: http://domain.com (sans slash final)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Apparence","Application_added":"Application ajoutée","Application_Name":"Nom de l'application","Application_updated":"Application mise à jour","Apply_and_refresh_all_clients":"Appliquer et rafraîchir tous les clients","Archive":"Archiver","Archive_Unarchive":"Archiver / Désarchiver","are_also_typing":"sont également en train d'écrire","are_typing":"sont en train d'écrire","Are_you_sure":"Êtes-vous sûr(e) ?","Are_you_sure_you_want_to_delete_your_account":"Êtes-vous sûr(e) de vouloir supprimer votre compte ?","Authorization_URL":"URL d’autorisation","Authorize":"Autoriser","AutoLinker_StripPrefix":"AutoLinker Strip Prefix","AutoLinker_StripPrefix_Description":"Affichage court. e.g. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Expression régulière","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker téléphone","AutoLinker_Phone_Description":"liée automatiquement les numéros de téléphone. par exemple `(123) 456-7890`","Auto_Load_Images":"Charger automatiquement les images","Available":"Disponible","Available_agents":"Assistants disponibles","Avatar":"Modifier l'avatar","Avatar_changed_successfully":"Avatar modifié avec succès","Avatar_URL":"URL de l'avatar","Avatar_url_invalid_or_error":"L'URL est invalide ou non accessible. Essayez de nouveau, mais avec une URL différente.","away":"absent","Away":"Absent","away_female":"absente","Away_female":"Absente","away_male":"absent","Away_male":"Absent","Back":"Retour","Back_to_applications":"Retour aux applications","Back_to_integrations":"Retour aux intégrations","Back_to_login":"Retourner à l'écran de connexion","Back_to_permissions":"Retour aux permissions","Body":"Corps","bold":"gras","busy":"occupé","Busy":"Occupé","busy_female":"occupée","Busy_female":"Occupée","busy_male":"occupé","Busy_male":"Occupé","Cancel":"Annuler","Cannot_delete_a_protected_role":"Impossible de supprimer un rôle protégé","Cannot_delete_role_because_its_in_use":"Impossible de supprimer le rôle car il est utilisé","Cannot_invite_users_to_direct_rooms":"Impossible d'inviter des utilisateurs dans les salons privés","CDN_PREFIX":"Préfixe CDN","Certificates_and_Keys":"Certificats et clés","Channel":"Canal","Channel_doesnt_exist":"Le canal `#%s` n'existe pas.","Channels":"Canaux","Channels_list":"Liste des canaux publics","Chat_Rooms":"Salons de discussion","Chatops_Enabled":"Activer Chatops","Chatops_Title":"Panneau de contrôle des Chatops","Chatops_Username":"Nom d'utilisateur Chatops","Choose_a_room":"Choisissez un salon","Choose_messages":"Choisissez des messages","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Choisissez l'alias qui apparaitra avant le nom d'utilisateur dans les messages.","Choose_the_username_that_this_integration_will_post_as":"Choisir le nom de domaine que cette intégration va utiliser pour publier.","Clear_all_unreads_question":"Marquer tout comme lu ?","Client_ID":"ID du client","Client_Secret":"Secret du client","Clients_will_refresh_in_a_few_seconds":"Les clients vont être rechargés dans quelques secondes","close":"fermer","Closed":"Fermé","Collapse_Embedded_Media_By_Default":"Réduire tous les médias intégrés par défaut","coming_soon":"prochainement","Commands":"Commandes","Compact_View":"Vue compacte","Confirm_password":"Confirmez votre mot de passe","Contact":"Contact","Conversation":"Conversation","Convert_Ascii_Emojis":"Convertir le code ASCII en Emoji","Copied":"Copié","COPY_TO_CLIPBOARD":"COPIER DANS LE PRESSE-PAPIER","Copy_to_clipboard":"Copier dans le presse-papier","Count":"Nombre","Create":"Créer","Create_new":"Créer nouveau","Created_at":"Créé le","Created_at_s_by_s":"Créé sur <strong>%s</strong> par <strong>%s>/strong>","Custom_Fields":"Champs Personnalisés","Custom_oauth_helper":"Lorsque vous configurez votre service OAuth, vous devez indiquer une URL pour le Callback. Utilisez <pre>%s</pre>","Custom_oauth_unique_name":"Nom unique OAuth personnalisé","Custom_Script_Logged_In":"Script personnalisé pour les utilisateurs connectés","Custom_Script_Logged_Out":"Script personnalisé pour les utilisateurs déconnectés","Dashboard":"Tableau de bord","days":"jours","Deactivate":"Désactiver","Debug_Level":"Niveau Debug","Default":"Défaut","Delete":"Supprimer","Delete_my_account":"Supprimer mon compte","Delete_Room_Warning":"Supprimer un salon supprimera également tous les messages postés dans le salon. Cela ne peut pas être annulé.","Delete_User_Warning":"Supprimer un utilisateur va également supprimer tous les messages de celui-ci. Cette action ne peut être annulée.","Deleted":"Supprimé !","Department_not_found":"Département introuvable","Department_removed":"Département supprimé","Departments":"Départements","Description":"Description","Desktop":"Bureau","Desktop_Notification_Test":"Test des notifications sur le bureau","Desktop_Notifications":"Notifications sur le bureau","Desktop_Notifications_Disabled":"Les notifications du bureau sont désactivées, Modifiez les préférences de votre navigateur si vous avez besoin de les activer.","Desktop_Notifications_Enabled":"Les notifications sur le bureau sont activées","Direct_message_someone":"Envoyer un message privé à quelqu'un","Direct_Messages":"Messages privés","Direct_Messages_list":"Messages Privés","Disable_Favorite_Rooms":"Désactiver les favoris","Disable_New_Message_Notification":"Désactiver la notification de nouveau message","Disable_New_Room_Notification":"Désactiver la notification de nouveau salon","Displays_action_text":"Texte d'affichage","Do_you_want_to_change_to_s_question":"Voulez-vous changer pour <strong>%s</strong> ?","Drop_to_upload_file":"Glissez-déposez pour transférer un fichier","Dry_run":"Essai à vide","Dry_run_description":"Envoi un unique e-mail, à l'adresse de l'expéditeur. L'adresse e-mail doit appartenir à un utilisateur valide.","Duplicate_archived_channel_name":"Un canal archivé avec le nom ' %s' existe","Duplicate_archived_private_group_name":"Un Groupe Privé archivé avec le nom '%s' existe","Duplicate_private_group_name":"Un groupe privé avec le nom ' %s' existe déjà","E-mail":"E-mail","Edit":"Modifier","Edit_Custom_Field":"Editer le Champ Personnalisé","Edit_Department":"Éditer le département","edited":"modifié","Email":"E-mail","Email_already_exists":"L'adresse email existe déjà","Email_body":"Corps du message","Email_Change_Disabled":"Votre administrateur de Rocket.Chat a désactivé le changement d'adresse e-mail","Email_from":"De","Email_Notification_Mode":"Notifications hors-ligne par e-mail","Email_Notification_Mode_All":"Toutes les Mentions/MP","Email_Notification_Mode_Disabled":"Désactivé","Email_or_username":"Adresse email ou nom d'utilisateur","Email_subject":"Sujet","Email_verified":"Adresse e-mail vérifiée","Emoji":"Emoji","Empty_title":"Titre vide","Enable":"Activer","Enable_Desktop_Notifications":"Activer les notifications sur le bureau","Enabled":"Activé","Encrypted_message":"Message chiffré","End_OTR":"Arrêter OTR","Enter_a_regex":"Entrez une expression rationnelle","Enter_a_room_name":"Saisissez un nom de salon","Enter_a_username":"Entrez un nom d'utilisateur","Enter_info":"Entrez vos identifiants de connexion","Enter_name_here":"Saisissez le nom ici","Enter_to":"Entrée pour","Error":"Erreur","error-cant-invite-for-direct-room":"Vous ne pouvez pas inviter d'utilisateur dans les discussions privées","error-duplicate-channel-name":"Un canal avec le nom ' %s' existe déjà","error-invalid-custom-field":"Champ personnalisé invalide","error-invalid-custom-field-name":"Invalid nom de champ personnalisé. Utilisez des lettres, des chiffres, des traits d'union et de soulignement.","error-invalid-password":"Mot de passe invalide","error-invalid-room":"Salon invalide","error-invalid-room-name":"<strong>%s</strong> n'est pas un nom de salon valide,<br/>vous ne pouvez utiliser que des lettres, des nombres et des tirets (milieu et bas).","error-invalid-user":"Utilisateur invalide","error-invalid-username":"Nom d'utilisateur invalide","error-not-allowed":"Interdit","error-not-authorized":"Non autorisé","error-remove-last-owner":"Cet utilisateur est le dernier propriétaire. Veuillez sélectionner un nouveau propriétaire avant de retirer celui-ci.","error-role-name-required":"Le nom du rôle est requis.","error-user-not-in-room":"L'utilisateur n'est pas dans ce salon.","Error_changing_password":"Erreur lors du changement de mot de passe","Error_sending_confirmation_email":"Erreur lors de l'envoi de l'e-mail de confirmation","Error_too_many_requests":"Erreur, trop de requêtes. Veuillez ralentir. Vous devez attendre %s secondes avant de réessayer.","Esc_to":"Échap pour","Example_s":"Exemple : <code class=\"inline\">%s</code>","False":"Non","Favorites":"Favoris","Field":"Champ","Field_removed":"Champ supprimé","File_exceeds_allowed_size_of_bytes":"Le fichier dépasse la taille maximale autorisée : __size__ octets","FileUpload":"Envoi de fichiers","FileUpload_Enabled":"Envois de fichiers activés","FileUpload_File_Empty":"Fichier vide","FileUpload_FileSystemPath":"Chemin d'accès","FileUpload_MaxFileSize":"Taille maximale pour l'envoi de fichier (en bits)","FileUpload_MediaType_NotAccepted":"Types de Fichiers Non Acceptés","FileUpload_MediaTypeWhiteList":"Types de média acceptés","FileUpload_MediaTypeWhiteListDescription":"Liste des types de média (séparés par des virgules). Laisser vide pour accepter tous les types de media.","FileUpload_ProtectFiles":"Protéger les fichiers uploadés","FileUpload_ProtectFilesDescription":"Seuls les utilisateurs authentifiés auront accès","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket name","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"Domaine CDN pour les téléchargements","FileUpload_S3_Region":"Région","FileUpload_Storage_Type":"Type de stockage","Flags":"Drapeaux","Follow_social_profiles":"Suivez-nous sur les réseaux sociaux, clonez le projet sur GitHub et partagez vos idées à propos de rocket.chat sur notre tableau Trello.","Food_and_Drink":"Nourriture & Boissons","For_your_security_you_must_re_enter_your_password_to_continue":"Pour votre sécurité, vous devez ré-entrer votre mot de passe pour continuer","Force_SSL":"Forcer l'utilisation de SSL","Force_SSL_Description":"*Attention !* _ForceSSL_ ne devrait jamais être utilisé avec un reverse proxy. Si vous utilisez un reverse proxy, vous devriez y gérer la redirection. Cette option existe pour des déploiements tels que Heroku, qui n'autorisent pas la configuration de redirection au niveau des reverse proxy.","Forgot_password":"Mot de passe oublié","Fork_it_on_github":"Cloner sur GitHub","Frequently_Used":"Fréquemment utilisé","From":"De","From_Email":"De","From_email_is_required":"Le champ \"Expéditeur\" est requis.","From_email_warning":"<b>Attention</b> : le champ <b>Expéditeur</b> est déterminé par les paramètres de votre serveur mail.","General":"Général","Get_to_know_the_team":"Venez rencontrer la Rocket.Team","github_no_public_email":"Vous n'avez pas d'adresse email public associé à votre compte GitHub","Give_a_unique_name_for_the_custom_oauth":"Indiquez un nom unique pour l'OAuth personnalisé","Give_the_application_a_name_This_will_be_seen_by_your_users":"Donnez un nom à l'application. Il sera visible par les utilisateurs.","Global":"Global","GoogleTagManager_id":"Google Tag Manager ID","Has_more":"a plus de","Have_your_own_chat":"Disposez de votre propre salon de discussion en ligne. Développé à l'aide de Meteor.com, Rocket.Chat est une solution pour les développeurs désirant mettre en place et faire évoluer leur propre plate-forme de discussion.","Header":"En-Tête","Hidden":"Caché","Hide_Group_Warning":"Êtes-vous sûr de vouloir cacher le groupe \"%s\" ?","Hide_Private_Warning":"Êtes-vous sûr de vouloir cacher la discussion avec \"%s\" ?","Hide_room":"Cacher le salon","Hide_Room_Warning":"Êtes-vous sûr de vouloir cacher le salon \"%s\" ?","Highlights":"Mises en avant","Highlights_How_To":"Pour être notifié(e) lorsque quelqu'un écrit un mot ou une phrase spécifique, ajoutez le/la ici. Vous pouvez les séparer par une virgule. Les termes surveillés ne sont pas sensibles à la casse.","Highlights_List":"Mots surveillés","History":"Historique","hours":"heures","How_friendly_was_the_chat_agent":"L'assistant du chat était-il amical ?","How_knowledgeable_was_the_chat_agent":"L'assistant du chat était-il clair ?","How_responsive_was_the_chat_agent":"L'assistant du chat avait-il des réponses adaptées ?","How_satisfied_were_you_with_this_chat":"Étiez-vous satisfait de ce chat?","If_you_are_sure_type_in_your_password":"Si vous êtes sûr(e), entrez votre mot de passe :","If_you_are_sure_type_in_your_username":"Si vous êtes certain(e), saisissez votre nom d'utilisateur :","Importer_Archived":"Archivé","Importer_done":"Importation réussie !","Importer_finishing":"Finalisation de l'import","Importer_From_Description":"Importer les données de __from__ dans Rocket.Chat.","Importer_import_cancelled":"Importation annulé","Importer_import_failed":"Un erreur est survenue pendant l'importation.","Importer_importing_channels":"Importation des canaux.","Importer_importing_messages":"Importation des messages.","Importer_importing_started":"Début de l'importation.","Importer_importing_users":"Importation des utilisateurs.","Importer_not_defined_properly":"L'importateur n'a pas été défini correctement, il manque la classe Import.","Importer_not_in_progress":"L'importateur n'est pas en cours d'exécution.","Importer_Prepare_Restart_Import":"Recommencer l’Importation","Importer_Prepare_Start_Import":"Commencer l'Importation","Importer_Prepare_Uncheck_Archived_Channels":"Désélectionner les Canaux Archivés","Importer_Prepare_Uncheck_Deleted_Users":"Désélectionner les Utilisateurs Supprimés","Importer_progress_error":"Impossible d'obtenir l'état de l'importation.","Importer_setup_error":"Une erreur est survenue lors du paramétrage de l'importateur.","Incorrect_Password":"Mot de passe incorrect","inline_code":"Ligne de code","Install_Extension":"Installer l'extension","Install_FxOs":"Installez Rocket.Chat dans votre Firefox","Install_FxOs_done":"Formidable ! Vous pouvez maintenant utiliser Rocket.Chat via l'icône sur votre écran d'accueil. Amusez-vous avec Rocket.Chat !","Install_FxOs_error":"Désolé, cela n'a pas fonctionné comme prévu! L'erreur suivante est apparue :","Install_FxOs_follow_instructions":"Veuillez confirmer l'installation de l'application sur votre appareil (appuyez sur \"Installer\" lorsque c'est demandé).","Installation":"Installation","Integration_added":"L'intégration a été ajoutée","Integration_Incoming_WebHook":"Intégration WebHook Entrant","Integration_New":"Nouvelle intégration","Integration_Outgoing_WebHook":"Intégration WebHook Sortant","Integration_updated":"L'intégration a été mise à jour","Integrations":"Intégrations","Invalid_asset":"Ressource invalide","Invalid_confirm_pass":"Les mots de passe renseignés ne sont pas les mêmes","Invalid_email":"L'adresse e-mail saisie est invalide","Invalid_Export_File":"Le fichier transmis n'est pas un fichier d'exportation valide de %s","Invalid_file_height":"Hauteur du fichier non valide","Invalid_file_type":"Type de fichier invalide","Invalid_file_width":"Largeur du fichier non valide","Invalid_Import_File_Type":"Format du fichier d'importation invalide.","Invalid_name":"Le nom doit être renseigné","Invalid_notification_setting_s":"Paramètre de notification invalide : %s","Invalid_pass":"Le mot de passe doit être renseigné","Invalid_room_name":"<strong>%s</strong> n'est pas un nom de canal valide.<br/>Utilisez uniquement des lettres, des chiffres et des tirets","Invalid_room_type":"<strong>%s</strong> n'est pas un type de salon valide.","Invalid_Secret_URL":"URL secrète invalide","Invalid_secret_URL_message":"L'URL fournie est invalide.","invisible":"invisible","Invisible":"Invisible","Invitation_HTML":"Contenu HTML de l'invitation","Invitation_Subject":"Sujet de l'invitation","Invite_user_to_join_channel":"Inviter un utilisateur à rejoindre le canal","Invite_Users":"Inviter des utilisateurs","is_also_typing":"est également en train d'écrire","is_also_typing_female":"est également en train d'écrire","is_also_typing_male":"est également en train d'écrire","is_typing":"est en train d'écrire","is_typing_female":"est en train d'écrire","is_typing_male":"est en train d'écrire","italics":"italique","join":"Rejoindre\n","Join_audio_call":"Rejoindre l'appel audio","Join_the_Community":"Rejoignez la communauté","Join_the_given_channel":"Rejoindre le canal choisi","Join_video_call":"Rejoindre l'appel vidéo","Joined":"A rejoint","Jump":"Sauter","Jump_to_first_unread":"Aller au premier non lu","Jump_to_message":"Aller au message","Jump_to_recent_messages":"Aller aux messages récents","Katex_Enabled":"Katex activé","Label":"Label","Language":"Langue","Language_Version":"Version Anglaise","Last_login":"Dernière connexion","Last_message":"Dernier message","Last_seen":"Vu pour la dernière fois","Layout":"Disposition","Layout_Home_Body":"Contenu de la page d'accueil","Layout_Home_Title":"Titre de la page d'accueil","Layout_Login_Terms":"Conditions de connexion","Layout_Privacy_Policy":"Politique de confidentialité","Layout_Sidenav_Footer":"Pied de page de la sidebar","Layout_Sidenav_Footer_description":"La taille du pied de page est de 260 × 70 pixels","Layout_Terms_of_Service":"Conditions de service","LDAP":"LDAP","LDAP_CA_Cert":"Certificat CA (Autorité de certification)","LDAP_Custom_Domain_Search":"Domaine de recherche personnalisé","LDAP_Custom_Domain_Search_Description":"Un bout de JSON qui contrôle la liaison et la connexion et qui a le format :<br/><code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domaine par défaut","LDAP_Description":"Un LDAP est une base de données hiérarchique que de nombreuses entreprises utilisent pour fournir une authentification unique à travers leurs services - l'utilisateur partage un mot de passe entre plusieurs sites et services. Pour avoir plus d'informations sur la configuration avancée et voir des exemples, consulter notre wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication .","LDAP_Dn":"DN LDAP","LDAP_Domain_Base":"Domaine de base","LDAP_Domain_Base_Description":"Le chemin complet du Distinguished Name (DN) d'un sous arbre LDAP dans lequel vous souhaitez chercher les utilisateurs et les groupes. Vous pouvez en ajouter autant que vous voulez ; cependant, chaque groupe doit être défini dans le même domaine de base que les utilisateurs qui le composent.Si vous spécifiez des restrictions sur des groupes d'utilisateurs, seuls les utilisateurs appartenant à ces groupes seront dans le périmètre de la recherche. Nous recommandons de spécifier le top level de votre arbre LDAP en tant que domaine de base et d'utiliser le filtre de recherche pour contrôler l'accès.","LDAP_Domain_Search_Filter":"Filtre de recherche dans le domaine","LDAP_Domain_Search_Filter_Description":"Si renseigné, seuls les utilisateurs qui correspondent à ce filtre seront autorisés à se connecter. Si aucun filtre n'est spécifié, tous les utilisateurs dans le spectre du domaine de base spécifié seront capable de se connecter.<br/>Exemple pour ActiveDirectory `memberOf=cn=ROCKET_CHAT,ou=General Groups`.<br/>Exemple pour OpenLDAP (recherche étendue de correspondance) `ou:dn:=ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Catégorie d'objet pour la recherche dans le domaine","LDAP_Domain_Search_Object_Category_Description":"L'*objectCategory* qui identifie vos utilisateurs.<br/>Laisser vide pour *OpenLDAP*.<br/>Par exemple : `personne`, etc.","LDAP_Domain_Search_Object_Class":"Classe d'objet pour la recherche dans le domaine","LDAP_Domain_Search_Object_Class_Description":"L'*objectClass* qui identifie vos utilisateurs.<br/>Par exemple : `organizationalPerson`, ``user`, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Mot de passe pour la recherche dans le domaine","LDAP_Domain_Search_Password_Description":"Le mot de passe pour l'utilisateur de la recherche dans le domaine.","LDAP_Domain_Search_User":"Utilisateur pour al recherche dans le domaine","LDAP_Domain_Search_User_Description":"L'utilisateur LDAP qui réalise les recherches d'utilisateur pour authentifier les autres utilisateurs quand ils se connectent.<br/>Il s'agit typiquement d'un compte de service créé spécialement pour l'intégration de tierces parties. Utilisez un nom complet, tel que `cn=Administrator,cn=Users,dc=Example,dc=com`.","LDAP_Domain_Search_User_ID":"ID de l'utilisateur pour el recherche dans le domaine","LDAP_Domain_Search_User_ID_Description":"L'attribut LDAP qui identifie l'utilisateur LDAP qui essaye de s'authentifier. Ce champ est `sAMAccountName` pour la plupart des installations Active Directory, mais cela peut être `uid` pour d'autres solutions de LDAP, comme OpenLDAP. Vous pouvez utiliser `mail` pour identifier les utilisateurs par leur adresse e-mail ou n'importe quel autre attribut que vous souhaitez.<br>Vous pouvez utiliser plusieurs valeurs séparées par des virgules pour permettre aux utilisateur de s'identifier en utilisant plusieurs identifiants comme le nom d'utilisateur ou l'adresse e-mail.","LDAP_Enable":"Activer LDAP","LDAP_Enable_Description":"Essayer d'utiliser LDAP pour l'authentification.","LDAP_Encryption":"Chiffrement","LDAP_Encryption_Description":"La méthode de chiffrement utilisée pour sécuriser les communications avec le serveur LDAP. Parmi les exemples on trouve `plain` (pas de chiffrement), `SSL/LDAPS` (chiffrement dès le début) et `StartTLS` (chiffrement une fois la connexion établie).","LDAP_Host":"Hôte","LDAP_Host_Description":"L'hôte LDAP, par exemple `ldap.exemple.com` ou `10.0.0.30`.","LDAP_Port":"Port LDAP","LDAP_Port_Description":"Port pour accéder au LDAP ( ex : 389 ou 636 pour LDAPS)","LDAP_Reject_Unauthorized":"Rejeter les personnes non autorisées","LDAP_Sync_User_Avatar":"Synchronisation Avatar Utilisateur","LDAP_Sync_User_Data":"Synchronisation des données","LDAP_Sync_User_Data_Description":"Garder les données de l'utilisateur synchronisées avec celles du serveur lors de la connexion (par exemple: nom, adresse e-mail).","LDAP_Sync_User_Data_FieldMap":"Liste des champs utilisateur","LDAP_Sync_User_Data_FieldMap_Description":"Configurer la façon dont les champs de compte utilisateur (comme l'adresse e-mail) sont remplis à partir d'un enregistrement dans l'annuaire LDAP (une fois trouvé). À titre d'exemple, {\"cn\": \"nom\", \"mail\": \"email\"} choisira le nom lisible d'une personne à partir de l'attribut cn, et son adresse e-mail à partir de l'attribut mail.<br/> Les champs disponibles comprennent le nom et l'adresse e-mail.","LDAP_Sync_Users":"Synchronisation Utilisateurs","LDAP_Test_Connection":"Tester la connexion","LDAP_Unique_Identifier_Field":"Champ de l'identifiant unique","LDAP_Unique_Identifier_Field_Description":"Le champ utilisé pour lier l'utilisateur LDAP à l'utilisateur Rocket.Chat. Vous pouvez renseigner plusieurs valeurs séparées par des virgules pour obtenir la valeur depuis l'enregistrement LDAP.<br/>La valeur par défaut est `objectGUID,ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber`","LDAP_Use_Custom_Domain_Search":"Utiliser la recherche personnalisée dans le domaine","LDAP_Use_Custom_Domain_Search_Description":"Écrivez vos propres filtres pour rechercher les utilisateurs dans le serveur LDAP.","LDAP_Username_Field":"Champs du nom d'utilisateur","LDAP_Username_Field_Description":"Le champ qui sera utilisé en tant que *nom d'utilisateur* pour les nouveaux utilisateurs. Laisser vide pour utiliser le nom d'utilisateur renseigné sur la page de connexion.<br/>La valeur par défaut est `sAMAccountName`.","Leave_Group_Warning":"Êtes-vous sûr de vouloir quitter le groupe \"%s\" ?","Leave_Private_Warning":"Êtes-vous sûr de vouloir quitter la discussion avec \"%s\" ?","Leave_room":"Quitter le salon","Leave_Room_Warning":"Êtes-vous sûr de vouloir quitter le salon \"%s\" ?","line":"ligne","List_of_Direct_Messages":"Liste des Messages Privés","Live_sessions":"Sessions en direct","Livechat_agents":"Assistants du chat en direct","Livechat_Dashboard":"Tableau de bord du chat en direct","Livechat_enabled":"Chat en direct activé","Livechat_Manager":"Manager du chat en direct","Livechat_managers":"Managers du chat en direct","Livechat_title":"Titre du chat en direct","Livechat_title_color":"Couleur d'arrière plan du titre du chat en direct","Livechat_Users":"Utilisateurs du chat en direct","Load_more":"Charger plus","Loading...":"Chargement...","Loading_more_from_history":"Charger plus d'historique","Loading_suggestion":"Chargement des suggestions ...","Localization":"Localisation","Log_File":"Afficher le fichier et la ligne","Log_Level":"Niveau de log","Log_Package":"Afficher le paquet","Log_View_Limit":"Limite de visibilité des log","Logged_out_of_other_clients_successfully":"Déconnexion des autres sessions réussie","Login":"Se connecter","Login_with":"Connectez-vous avec %s","login_with":"Ou connectez-vous avec","Logout":"Se déconnecter","Logout_Others":"Déconnecter les autres sessions ouvertes","Mail_Message_Invalid_emails":"Vous avez fourni une ou plusieurs adresses e-mails invalides : %s","Mail_Message_Missing_to":"Vous devez sélectionner un ou plusieurs utilisateurs ou fournir une ou plusieurs adresses e-mail, séparées par des virgules.","Mail_Message_No_messages_selected_select_all":"Vous n'avez sélectionné aucun message. Voulez-vous <a href='#' class='select-all'>sélectionner tous</a> les messages visibles ?","Mail_Messages":"Messages électroniques","Mail_Messages_Instructions":"Choisissez les messages que vous souhaitez envoyer par e-mail en cliquant dessus","Mail_Messages_Subject":"Voici une sélection de messages de \"%s\"","Mailer":"Envoi d'e-mail","Mailer_body_tags":"Vous <b>devez</b> utiliser [unsubscribe] pour le lien de désinscription.<br />Vous pouvez utiliser [name], [fname], [lname] pour le nom complet de l'utilisateur, le prénom et le nom de famille respectivement.<br />Vous pouvez utiliser [email] pour l'adresse e-mail de l'utilisateur.","Make_Admin":"Promouvoir administrateur","Manager_added":"Manager ajouté","Manager_removed":"Manager retiré","Mark_as_read":"Marquer comme lu","Markdown_Headers":"Titres Markdown","Markdown_SupportSchemesForLink":"Schéma de Markdown supportés pour les liens","Markdown_SupportSchemesForLink_Description":"Liste de schémas séparés par des virgules","Members_List":"Liste des membres","Mentions":"Mentions","Mentions_default":"Mentions (défaut)","Message":"Message","Message_AllowDeleting":"Autoriser la suppression de message","Message_AllowEditing":"Autoriser la modification de message","Message_AllowEditing_BlockEditInMinutes":"Bloquer la modification des messages après (n) minutes","Message_AllowEditing_BlockEditInMinutesDescription":"Entrez 0 pour désactiver le blocage.","Message_AllowPinning":"Autoriser l'épinglement de message","Message_AllowPinning_Description":"Autoriser les messages à être épinglés à n'importe quel canal.","Message_AllowStarring":"Autoriser les favoris pour les messages","Message_AudioRecorderEnabled":"Enregistrement audio activé","Message_AudioRecorderEnabledDescription":"Nécessite que les fichiers de type « audio/wav » soient acceptés en tant que média dans les réglages d'envoi de fichiers.","Message_DateFormat":"Format de Date","Message_deleting_not_allowed":"Suppression d'un message non autorisée","Message_editing_blocked":"Ce message ne peut plus être modifié","Message_editing_not_allowed":"Modification d'un message non autorisée","Message_GroupingPeriod":"Période de regroupement (en secondes)","Message_GroupingPeriodDescription":"Les messages seront regroupés avec les messages précédents si ils sont du même utilisateur et si le temps écoulé est inférieur au temps indiqué en secondes.","Message_KeepHistory":"Conserver l'historique des messages","Message_MaxAllowedSize":"Taille maximale d'un message","Message_MaxAll":"Taille de canal maximale pour le message ALL","Message_pinned":"Message épinglé","Message_pinning_not_allowed":"L'épinglement de message n'est pas autorisé","Message_removed":"Message supprimé","Message_ShowDeletedStatus":"Afficher le statut de suppression","Message_ShowEditedStatus":"Afficher le statut de modification","Message_ShowFormattingTips":"Afficher les astuces de mise en forme","Message_TimeFormat":"Format du Temps","Message_TimeFormat_Description":"Voir aussi: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Message trop long","Messages":"Messages","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Les messages envoyés au WebHook Entrant seront postés ici","Meta":"Meta","Meta_fb_app_id":"App ID Facebook","Meta_google-site-verification":"Google Site Verification","Meta_language":"Langue","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minutes","Mobile_push":"Notifications push sur mobile","More_channels":"Plus de canaux","More_direct_messages":"Plus de Messages Privés","More_groups":"Davantage de groupes","More_unreads":"Davantage de messages non lus","Msgs":"Messages","multi":"multiple","Mute_someone_in_room":"Rendre quelqu'un muet dans ce salon","Mute_user":"Rendre muet","Muted":"Rendu muet","My_Account":"Mon compte","n_messages":"%s messages","N_new_messages":"%s nouveaux messages","Name":"Nom","Name_cant_be_empty":"Le nom ne peut pas être vide","Name_of_agent":"Nom de l'assistant","Name_optional":"Nom (optionnel)","Navigation_History_20_last_pages":"Historique de navigation (20 dernières pages)","New_Application":"Nouvelle application","New_Custom_Field":"Nouveau Champ Personalisé","New_Department":"Nouveau département","New_integration":"Nouvelle intégration","New_logs":"Nouveaux journaux","New_messages":"Nouveaux messages","New_password":"Nouveau mot de passe","New_role":"Nouveau rôle","No_channel_with_name_%s_was_found":"Aucun canal nommé <strong>\"%s\"</strong> n'a été trouvé !","No_channels_yet":"Vous ne faites partie d’aucun canal pour le moment.","No_direct_messages_yet":"Vous n'avez pris part à aucune discussion privée pour le moment.","No_Encryption":"Pas de Chiffrement","No_favorites_yet":"Vous n'avez ajouté aucun favoris pour le moment.","No_group_with_name_%s_was_found":"Aucun groupe privé nommé <strong>\"%s\"</strong> n'a été trouvé !","No_groups_yet":"Vous n'avez pas encore de groupes privés.","No_livechats":"Vous n'avez pas de chat en direct.","No_mentions_found":"Aucune mention trouvée","No_permission_to_view_room":"Vous n'avez pas la permission de voir ce salon","No_pinned_messages":"Aucun message épinglé","No_results_found":"Aucun résultat trouvé","No_starred_messages":"Aucun message en favoris","no_tokens_for_this_user":"Il n'y a aucun jeton pour cet utilisateur","No_user_with_username_%s_was_found":"Aucun utilisateur nommé <strong>\"%s\"</strong> n'a été trouvé !","Not_allowed":"Non autorisé","Not_authorized":"Non autorisé","Not_Available":"Indisponible","Not_found_or_not_allowed":"Introuvable ou non autorisé","Nothing":"Rien","Nothing_found":"Aucun résultat","Notifications":"Notifications","Notify_all_in_this_room":"Notifiez tout le monde dans ce salon","Num_Agents":"# Assistants","Number_of_messages":"Nombre de messages","OAuth_Application":"Application OAuth","OAuth_Applications":"Applications OAuth","Objects":"Objets","Off_the_record_conversation":"Conversation Off-the-record (non enregistrée)","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"La conversation Off-the-record n'est pas disponible pour votre navigateur ou appareil.","Offline_DM_Email":"|__site__] Vous avez reçu des messages privés de __user__","Offline_Mention_Email":"[__site__] Vous avez été mentionné par __user__ dans le salon #__room__","Old_and_new_password_must_be_different":"Le nouveau mot de passe doit être différent de l'ancien mot de passe.","Old_and_new_password_required":"Vous devez renseigner votre ancien mot de passe et le nouveau afin de changer ce dernier.","Online":"Connecté","Only_errors":"Erreurs uniquement","Only_you_can_see_this_message":"Vous seul pouvez voir ce message","Oops!":"Oups","Open":"Ouvrir","Opened":"Ouvert","Opt_out_statistics":"Ne pas envoyer mes statistiques anonymes à Rocket.Chat","Opt_out_statistics_warning":"En envoyant vos statistiques anonymes, vous allez nous aider à identifier le nombre d'instances de Rocket.Chat déployées, ainsi que le bon comportement du système, afin que nous puissions l'améliorer encore plus. N'ayez aucune crainte car aucune information utilisateur n'est envoyée et toutes les informations reçues sont considérées confidentielles. Si vous souhaitez continuer à nous envoyer vos statistiques anonymes, décochez la case ci-dessus. Merci.","optional":"facultatif","Order":"Ordre","OS_Arch":"Architecture","OS_Cpus":"Nombre de CPU","OS_Freemem":"Mémoire disponible","OS_Loadavg":"Charge moyenne","OS_Platform":"Plate-forme","OS_Release":"Version","OS_Totalmem":"Mémoire totale","OS_Type":"Type","OS_Uptime":"Durée de fonctionnement","others":"autres","OTR":"Conversation Cryptée (OTR)","OTR_is_only_available_when_both_users_are_online":"OTR est disponible uniquement lorsque les deux utilisateurs sont connectés","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Modifier l'URL vers laquelle les fichiers sont téléversés. Cette URL est également utilisée pour les téléchargements sauf si un CDN a été configuré","Password":"Mot de passe","Password_Change_Disabled":"L'administrateur de votre Rocket.Chat a désactivé la possibilité de changer de mot de passe","Password_changed_successfully":"Mot de passe modifié avec succès","Payload":"Charge utile","People":"Personnes","Permissions":"Permissions","Pin_Message":"Épingler ce message","Pinned_a_message":"A épinglé un message :","Pinned_Messages":"Messages épinglés","Placeholder_for_email_or_username_login_field":"Texte de remplacement pour l'e-mail ou le nom d'utilisateur à la connexion","Placeholder_for_password_login_field":"Texte de remplacement pour le mot de passe","Please_answer_survey":"S'il vous plait , prenez un moment pour répondre à un court sondage à propos de ce chat ","Please_enter_value_for_url":"Veuillez entrer l'url de votre avatar.","Please_enter_your_new_password_below":"Veuillez écrire votre nouveau mot de passe ci-dessous :","Please_fill_a_label":"veuillez inscrire un Label","Please_fill_a_name":"Veuillez saisir un nom","Please_fill_a_username":"Veuillez enter un nom d'utilisateur","Please_fill_name_and_email":"Veuillez remplir le nom et l'adresse e-mail","Please_re_enter_your_password":"Veuillez ré-entrer votre mot de passe","Please_select_enabled_yes_or_no":"Veuillez choisir une option pour Activé","Please_wait":"Veuillez patienter","Please_wait_activation":"Veuillez patienter, cela peut prendre un peu de temps.","Please_wait_statistics":"Veuillez patienter, les statistiques sont en cours de génération.","Please_wait_while_OTR_is_being_established":"Veuillez patienter pendant l'établissement de l'OTR","Please_wait_while_your_account_is_being_deleted":"Veuillez patienter pendant que votre compte est supprimé...","Please_wait_while_your_profile_is_being_saved":"Veuillez patienter pendant que votre profil est enregistré ...","Post_as":"Publié en tant que","Post_to_Channel":"Publié sur le Canal","Post_to_s_as_s":"Publié sur <strong>%s</strong> en tant que <strong>%s</strong>","Powered_by":"Propulsé par","Preferences":"Préférences","Preferences_saved":"Préférences enregistrées","Privacy":"Vie privée","Private_Group":"Groupe privé","Private_Groups":"Groupes privés","Private_Groups_list":"Liste des groupes privés","Profile":"Profil","Profile_saved_successfully":"Profil enregistré avec succès","Proudly_developed":"Fièrement développé avec Meteor","Push":"Push","Push_apn_cert":"Certificat APN","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"Clef APN","Push_apn_passphrase":"APN Passphrase","Push_debug":"Débogage","push_disabled":"Notification push désactivée","Push_enable":"Activer","Push_enable_gateway":"Activer la passerelle","Push_gateway":"Passerelle","Push_gcm_api_key":"Clé API GCM","Push_gcm_project_number":"Numéro de projet GCM","Push_production":"Production","Push_show_message":"Afficher le message dans la notification","Push_show_username_room":"Afficher le canal/groupe/nom d'utilisateur dans la notification","Push_test_push":"Test","Query":"Requête","Query_description":"Conditions additionnelles pour déterminer à quels utilisateurs l'e-mail sera envoyé. Les utilisateurs désinscrits sont automatiquement retirés de la requête. La requête doit être au format JSON. Exemple : \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Recherche rapide","quote":"citation","Reactions":"Réactions","Recents":"Récents","Record":"Enregistrer","Redirect_URI":"URI de redirection","Refresh_keys":"Rafraîchir les clefs","Refresh_your_page_after_install_to_enable_screen_sharing":"Actualisez votre page après l'installation pour permettre le partage d'écran","Register":"Créer un nouveau compte","Registration_Succeeded":"Enregistrement réussi","Remember_me":"Se souvenir de moi","Remove":"Supprimer","Remove_Admin":"Supprimer administrateur","Remove_as_moderator":"Retirer de la modération","Remove_as_owner":"Retirer de la liste des propriétaires","Remove_custom_oauth":"Supprimer OAuth personnalisé ","Remove_from_room":"Éjecter du salon","Remove_someone_from_room":"Éjecter quelqu'un du salon","Removed":"Retiré","Require_password_change":"Changement de mot de passe requis","Resend_verification_email":"Renvoyer l'e-mail de vérification","Reset":"Réinitialiser","Reset_password":"Réinitialiser le mot de passe","Restart":"Redémarrer","Restart_the_server":"Redémarrer le serveur","RocketBot_Enabled":"RocketBot activé","RocketBot_Name":"Nom du RocketBot","RocketBot_Name_Description":"Le nom du RocketBot doit être un nom valide enregistré sur votre serveur.","Role":"Rôle","Role_Editing":"Édition des rôles","Role_removed":"Rôle retiré","Room":"Salon","Room_archivation_state":"État","Room_archivation_state_false":"Actif","Room_archivation_state_true":"Archivé","Room_archived":"Salon archivé","room_changed_privacy":"Type du salon changé pour : <em>__room_type__</em> par <em>__user_by__</em>","room_changed_topic":"Sujet du salon changé pour : <em>__room_topic__</em> by <em>__user_by__</em>","Room_has_been_deleted":"Le salon a été supprimé","Room_Info":"Informations sur le salon","Room_name_changed":"Nom du salon changé en : <em>__room_name__</em> par <em>__user_by__</em>","Room_name_changed_successfully":"Nom du salon modifié avec succès","Room_not_found":"Salon introuvable","Room_topic_changed_successfully":"Sujet du salon modifié avec succès","Room_type_changed_successfully":"Type du salon modifié avec succès","Room_unarchived":"Salon désarchivé","Room_uploaded_file_list":"Liste des fichiers","Room_uploaded_file_list_empty":"Aucun fichier disponible.","room_user_count":"%s utilisateurs","Rooms":"Salons","S_new_messages_since_s":"%s nouveaux messages depuis %s","SAML":"SAML","SAML_Custom_Cert":"Certificat personnalisé","SAML_Custom_Entry_point":"Point d'entrée personnalisée","SAML_Custom_Generate_Username":"Générer le nom d'utilisateur","SAML_Custom_Issuer":"Émetteur personnalisé","SAML_Custom_Provider":"Fournisseur personnalisé","Save":"Enregistrer","Save_changes":"Sauvegarder les modifications","Save_Mobile_Bandwidth":"Préserver la bande passante sur mobile","Save_to_enable_this_action":"Sauvegarder pour activer cette action","Saved":"Enregistré","Saving":"Enregistrement en cours","Scope":"Portée","Screen_Share":"Partage d'Écran","Script_Enabled":"Script activé","Search":"Recherche","Search_by_username":"Rechercher par nom d'utilisateur","Search_Channels":"Recherche de canaux","Search_Direct_Messages":"Rechercher dans les Messages Privés","Search_Messages":"Rechercher dans les messages","Search_Private_Groups":"Rechercher dans les Groupes Privés","Search_settings":"Paramètres de la recherche","seconds":"secondes","See_all":"Voir tous","See_only_online":"Connectés seulement","Select_a_department":"Sélectionner un département","Select_an_avatar":"Choisissez un avatar","Select_file":"Sélectionnez le fichier","Select_service_to_login":"Sélectionnez un service pour vous connecter et importer votre image ou importez directement une image à partir de votre ordinateur.","Select_user":"Sélectionner l'utilisateur","Select_users":"Sélectionner des utilisateurs","Selected_agents":"Assistants sélectionnés","Selected_users":"Membres sélectionnés","Send":"Envoyer","Send_a_message":"Envoyez un message","Send_a_test_mail_to_my_user":"Envoyer un e-mail de test à mon utilisateur","Send_a_test_push_to_my_user":"Envoyer une notification test aux utilisateurs","Send_confirmation_email":"Envoyer un email de confirmation","Send_data_into_RocketChat_in_realtime":"Envoyer des données dans Rocket.Chat en temps réel","Send_email":"Envoyer l'e-mail","Send_invitation_email":"Envoyer un e-mail d'invitation","Send_invitation_email_error":"Vous n'avez pas fourni d'adresse e-mail valide.","Send_invitation_email_info":"Vous pouvez envoyer plusieurs e-mails d'invitation à la fois.","Send_invitation_email_success":"Vous avez envoyé avec succès un e-mail d'invitation aux adresses suivantes :","Send_invitation_email_warning":"Pour pouvoir envoyer des e-mails d'invitation, vous devez configurer le SMTP.","Send_Message":"Envoyer un message","Send_your_JSON_payloads_to_this_URL":"Envoyer les messages JSON à cette URL","Sending":"Envoi en cours...","Set_as_moderator":"Définir comme modérateur","Set_as_owner":"Définir comme propriétaire","Settings":"Paramètres","Settings_updated":"Paramètres mis à jour","Should_be_a_URL_of_an_image":"Doit être l'URL d'une image.","Should_exists_a_user_with_this_username":"L'utilisateur doit déjà exister","Show_all":"Afficher tout","Show_more":"Afficher plus","Show_only_online":"Ne montrer que les utilisateurs connectés","Show_preregistration_form":"Afficher le formulaire de pré-inscription","Showing_archived_results":"<p>Affichage de <b>%s</b> résultats archivés</p>","Showing_online_users":"<b>__total_showing__</b> utilisateur(s) affichés sur un total de __total__","Showing_results":"<p><b>%s</b> résultat(s)</p>","Silence":"Silence","since_creation":"depuis %s","Site_Name":"Nom du site","Site_Url":"URL du site","Site_Url_Description":"Exemple : https://chat.domain.com/","Skip":"Passer","Smileys_and_People":"Émojis & Portraits","SMTP":"SMTP","SMTP_Host":"Hôte SMTP","SMTP_Password":"Mot de passe SMTP","SMTP_Port":"Port SMTP","SMTP_Test_Button":"Tester les paramètres SMTP","SMTP_Username":"Nom d'utilisateur SMTP","Sound":"Alertes sonores","Star_Message":"Mettre en favoris","Starred_Messages":"Messages favoris","Start_audio_call":"Démarrer l'appel audio","Start_Chat":"Démarrer un chat","Start_of_conversation":"Début de la conversation","Start_OTR":"Démarrer une conversation cryptée (OTR)","Start_video_call":"Démarrer l'appel vidéo","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Débuter avec <code class=\"inline\">%s</code> pour l'utilisateur ou <code class=\"inline\">%s</code> pour canal. Ex: <code class=\"inline\">%s</code> ou <code class=\"inline\">%s</code>","Statistics":"Statistiques","Stats_Active_Users":"Utilisateurs actifs","Stats_Avg_Channel_Users":"Nombre moyen d'utilisateurs dans les canaux","Stats_Avg_Private_Group_Users":"Nombre moyen d'utilisateurs dans les groupes privés","Stats_Away_Users":"Utilisateurs indisponibles","Stats_Max_Room_Users":"Nombre maximum d'utilisateurs dans un salon","Stats_Non_Active_Users":"Utilisateurs inactifs","Stats_Offline_Users":"Utilisateurs hors ligne","Stats_Online_Users":"Utilisateurs en ligne","Stats_Total_Channels":"Nombre total de canaux","Stats_Total_Direct_Messages":"Nombre total de discussions privées","Stats_Total_Messages":"Nombre total de messages","Stats_Total_Private_Groups":"Nombre total de groupes privés","Stats_Total_Rooms":"Nombre total de salons","Stats_Total_Users":"Nombre total d'utilisateurs","Stop_Recording":"Arrêter l'enregistrement","strike":"barré","Subject":"Sujet","Submit":"Envoyer","Success":"Réussi","Survey":"Sondage","Survey_instructions":"Notez chaque question en fonction de votre satisfaction, 1 signifiant que vous êtes très insatisfait et 5 que vous êtes entièrement satisfait.","Symbols":"Symboles","Sync_success":"Synchronisation réussie","Sync_Users":"Synchronisation Utilisateurs","Test_Connection":"Tester la connexion","Test_Desktop_Notifications":"Tester les notifications sur le bureau","Thank_you_for_your_feedback":"Merci pour votre retour","The_application_name_is_required":"Le nom de l'application est requis","The_channel_name_is_required":"Le canal doit être nommé","The_emails_are_being_sent":"Les e-mails sont en cours d'envoi.","The_field_is_required":"Le champ %s est requis.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Le redimensionnement d'image ne fonctionnera pas car nous ne pouvons pas détecter d'installation d'ImageMagick ou de GraphicsMagick sur votre serveur.","The_redirectUri_is_required":"L'URI de redirection est requise","The_server_will_restart_in_s_seconds":"Le serveur redémarrera dans %s secondes","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Le réglage <strong>%s</strong> est configuré pour <strong>%s</strong> et vous accédez à partir de <strong>%s</strong> !","The_user_will_be_removed_from_s":"L'utilisateur sera éjecté de %s","The_user_wont_be_able_to_type_in_s":"L'utilisateur ne pourra pas écrire dans %s","Theme":"Thème","theme-color-action-buttons-color":"Couleur des boutons d'action","theme-color-active-channel-background-color":"Couleur d'arrière plan du canal actif","theme-color-active-channel-font-color":"Couleur de police du canal actif","theme-color-blockquote-background":"Couleur d'arrière plan des citations","theme-color-clean-buttons-color":"Couleur des boutons neutres","theme-color-code-background":"Couleur d'arrière plan du code","theme-color-code-border":"Couleur des bordures du code","theme-color-code-color":"Couleur du code","theme-color-content-background-color":"Couleur d'arrière plan du contenu","theme-color-custom-scrollbar-color":"Couleur personnalisée de la barre de défilement","theme-color-info-active-font-color":"Couleur de la police des informations actives","theme-color-info-font-color":"Couleur de la police des informations","theme-color-input-font-color":"Couleur de la police du champ de saisie","theme-color-link-font-color":"Couleur de la police des liens","theme-color-message-hover-background-color":"Couleur d'arrière plan des messages au survol","theme-color-primary-background-color":"Couleur d'arrière plan principale","theme-color-primary-font-color":"Couleur de la police principale","theme-color-quaternary-font-color":"Quatrième couleur de police","theme-color-secondary-background-color":"Couleur d'arrière plan secondaire","theme-color-secondary-font-color":"Couleur de police secondaire","theme-color-smallprint-font-color":"Couleur de la police des petits messages","theme-color-smallprint-hover-color":"Couleur de survol des petits messages","theme-color-status-away":"Couleur du statut \"Absent\"","theme-color-status-busy":"Couleur du statut \"Occupé\"","theme-color-status-offline":"Couleur du statut \"Hors-ligne\"","theme-color-status-online":"Couleur du statut \"Connecté\"","theme-color-tertiary-background-color":"Couleur de fond tertiaire (contenu)","theme-color-tertiary-font-color":"Couleur de police tertiaire (contenu)","theme-color-unread-notification-color":"Couleur des notifications non-lues","theme-custom-css":"CSS personnalisé","There_are_no_agents_added_to_this_department_yet":"Il n'y a pas d'assistant ajouté à ce département pour le moment","There_are_no_integrations":"Il n'y a aucune intégration","There_are_no_users_in_this_role":"Il n'y a aucun utilisateur avec ce rôle.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Cette adresse e-mail a déjà été utilisée et n'a pas été vérifiée. Veuillez changer votre mot de passe.","This_is_a_desktop_notification":"Ceci est une notification sur le bureau.","This_is_a_push_test_messsage":"Ceci est une notification de test","Time_in_seconds":"Temps en secondes","Title_bar_color":"Couleur de la barre de titre","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Pour installer le chat en direct Rocket.Chat (Livechat) sur votre site web, copiez-collez ce code au dessus de la dernière balise <strong>&lt;/body&gt;</strong> du site.","To_users":"Pour les utilisateurs","Topic":"Sujet","Travel_and_Places":"Voyages & Lieux","Trigger_removed":"Déclencheur retiré","Trigger_Words":"Mots déclencheurs","Triggers":"Déclencheurs","True":"Oui","Type":"Type","Type_your_new_password":"Écrivez votre nouveau mot de passe","Unarchive":"Désarchiver","Unmute_someone_in_room":"Rendre la parole à quelqu'un dans ce salon","Unmute_user":"Rendre la parole","Unnamed":"Sans nom","Unpin_Message":"Détacher ce message","Unread_Rooms":"Salons contenant des messages non-lus","Unread_Rooms_Mode":"Mode des salons non-lus","Unstar_Message":"Supprimer des favoris","Upload_file_question":"Transférer le fichier ?","Uploading_file":"Envoi du fichier en cours...","Use_account_preference":"Préférence du compte utilisateur","Use_Emojis":"Utiliser les Emojis","Use_initials_avatar":"Utiliser les initiales de votre nom d'utilisateur","use_menu":"Utilisez le menu latéral pour accéder à vos salons et discussions.","Use_service_avatar":"Utiliser l'avatar %s","Use_this_username":"Utilisez ce nom d'utilisateur","Use_uploaded_avatar":"Utiliser l'avatar transmis","Use_url_for_avatar":"Utilisez l'URL pour l'avatar","User__username__is_now_a_moderator_of__room_name_":"L'utilisateur __username__ est désormais un modérateur du salon __room_name__.","User__username__is_now_a_owner_of__room_name_":"L'utilisateur __username__ est désormais un propriétaire du salon __room_name__.","User__username__removed_from__room_name__moderators":"L'utilisateur __username__ n'est plus modérateur du salon __room_name__.","User__username__removed_from__room_name__owners":"L'utilisateur __username__ n'est plus propriétaire du salon __room_name__.","User_added":"L'utilisateur <em>__user_added__</em> a été ajouté","User_added_by":"L'utilisateur <em>__user_added__</em> a été ajouté par <em>__user_by__</em>.","User_added_successfully":"Utilisateur ajouté avec succès","User_Channels":"Canaux d'utilisateur","User_doesnt_exist":"Aucun utilisateur nommé `@ %s`.","User_has_been_activated":"L'utilisateur a été activé","User_has_been_deactivated":"L'utilisateur a été désactivé","User_has_been_deleted":"L'utilisateur a été supprimé","User_has_been_muted_in_s":"L'utilisateur a été rendu muet dans %s","User_has_been_removed_from_s":"L'utilisateur a été éjecté de %s","User_has_disconnected":"L'utilisateur s'est déconnecté","User_Info":"Informations sur l'utilisateur","User_is_no_longer_an_admin":"L'utilisateur n'est plus un administrateur","User_is_not_activated":"L'utilisateur n'est pas activé","User_is_now_an_admin":"L'utilisateur est désormais un administrateur","User_joined_channel":"A rejoint le canal.","User_joined_channel_female":"A rejoint le canal.","User_joined_channel_male":"A rejoint le canal.","User_left":"A quitté le canal.","User_left_female":"A quitté le canal.","User_left_male":"A quitté le canal.","User_logged_out":"L'utilisateur est déconnecté","User_management":"Gestion des Utilisateurs","User_muted_by":"L'utilisateur <em>__user_muted__</em> a été rendu muet par <em>__user_by__</em>.","User_muted_in_room":"L'utilisateur a été rendu muet dans ce salon","User_not_found":"Utilisateur introuvable","User_not_found_or_incorrect_password":"Utilisateur introuvable ou mot de passe incorrect","User_or_channel_name":"Nom d'utilisateur ou de canal","User_removed":"Utilisateur retiré","User_removed_by":"L'utilisateur <em>__user_removed__</em> a été éjecté par <em>__user_by__</em>.","User_removed_from_room":"L'utilisateur a été éjecté du salon","User_Settings":"Paramètres utilisateur","User_unmuted_by":"L'utilisateur <em>__user_by__</em> a rendu la parole à <em>__user_unmuted__</em>.","User_unmuted_in_room":"L'utilisateur a retrouvé la parole dans ce salon","User_updated_successfully":"Utilisateur mis à jour avec succès","Username":"Nom d'utilisateur","Username_and_message_must_not_be_empty":"Le nom d'utilisateur et le message ne peuvent pas être vides.","Username_cant_be_empty":"Le nom d'utilisateur doit être renseigné","Username_Change_Disabled":"L'administrateur de votre Rocket.Chat a désactivé la possibilité de changer de nom d'utilisateur","Username_denied_the_OTR_session":"__username__ a refusé la session OTR","Username_description":"Le nom d'utilisateur est utilisé pour permettre à d'autres personnes de vous mentionner dans leurs messages.","Username_doesnt_exist":"L'utilisateur `#%s` n'existe pas.","Username_ended_the_OTR_session":"__username__ a rejoint la session OTR","Username_invalid":"<strong>%s</strong> n'est pas un nom d'utilisateur valide,<br/> utilisez uniquement des lettres, des chiffres, des points et des tirets (milieu et bas)","Username_is_already_in_here":"`@ %s` est déjà présent.","Username_is_not_in_this_room":"L'utilisateur `#%s` n'est pas dans ce salon.","Username_not_found":"Nom d'utilisateur introuvable","Username_title":"Enregistrer un nom d'utilisateur","Username_unavaliable":"<strong>%s</strong> est déjà utilisé :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ veut démarrer une conversation cryptée (OTR). Voulez-vous accepter ?","Users":"Utilisateurs","Users_in_role":"Utilisateurs ayant ce rôle","UTF8_Names_Slugify":"Utiliser un slug (texte court) pour les noms UTF-8","UTF8_Names_Validation":"Validation UTF8 des Noms","UTF8_Names_Validation_Description":"N’autorise pas les caractères spéciaux et les espaces. Vous pouvez utilisez - _ et . (tiret du milieu, tiret du bas et point) mais pas à la fin du nom","Verification_email_sent":"E-mail de vérification envoyé","View_All":"Voir tous","View_Logs":"Voir les logs","Visibility":"Visibilité","Visible":"Visible","Visitor":"Visiteur","Visitor_page_URL":"Page d'accueil du visiteur (URL)","Visitor_time_on_site":"Temps des visiteurs sur le site","Wait_activation_warning":"Avant de pouvoir vous connecter, votre compte doit être manuellement activé par un administrateur.","We_are_offline_Sorry_for_the_inconvenience":"Nous sommes hors ligne. Désolé pour le désagrément.","We_have_sent_password_email":"Nous vous avons envoyé un e-mail avec des instructions pour réinitialiser votre mot de passe. Si vous ne le recevez pas dans quelques minutes, veuillez réessayer.","We_have_sent_registration_email":"Nous vous avons envoyé un e-mail afin que vous confirmiez votre inscription. Si vous ne le recevez pas dans quelques minutes, veuillez réessayer.","WebRTC_Enable_Channel":"Activer pour les canaux publics","WebRTC_Enable_Direct":"Activer pour les messages privés","WebRTC_Enable_Private":"Activer pour les groupes privés","WebRTC_Servers":"Serveurs STUN/TURN","WebRTC_Servers_Description":"Une liste de serveurs STUN et TURN séparés par une virgule.<br/> Vous pouvez utiliser utilisateur, mot de passe et port selon le format `utilisateur:motdepasse@stun:hôte:port` ou `utilisateur:motdepasse@turn:hôte:port`.","Welcome":"Bienvenue <em>%s</em>.","Welcome_to_the":"Bienvenue sur","will_be_able_to":"sera capable de","With_whom":"Avec qui","Yes":"Oui","Yes_clear_all":"Oui, marquez tout comme lu !","Yes_delete_it":"Oui, je confirme la suppression !","Yes_hide_it":"Oui, je veux le cacher !","Yes_leave_it":"Oui, je veux partir !","Yes_mute_user":"Oui, rendre l'utilisateur muet !","Yes_remove_user":"Oui, éjecter l'utilisateur !","you_are_in_preview_mode_of":"Aperçu du salon #<strong>__room_name__</strong> ","You_are_logged_in_as":"Vous êtes connecté en tant que","You_are_not_authorized_to_view_this_page":"Vous n'avez pas l'autorisation de voir cette page.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Vous êtes le dernier propriétaire. Veuillez choisir un nouveau propriétaire avant de quitter le salon.","You_can_change_a_different_avatar_too":"Vous pouvez ignorer l'avatar utilisé pour publier depuis cette intégration.","You_can_use_an_emoji_as_avatar":"Vous pouvez également utiliser un emoji comme avatar.","You_have_been_muted":"Vous avez été rendu muet et ne pouvez donc pas parler dans ce salon","You_have_not_verified_your_email":"Vous n'avez pas vérifié votre adresse e-mail.","You_have_successfully_unsubscribed":"Vous êtes désabonné avec succès de notre liste de diffusion.","You_informed_an_invalid_FROM_address":"Vous avez entré un expéditeur invalide (champ De).","You_must_provide_the_unsubscribe_link":"Vous devez fournir le lien de désinscription [unsubscribe].","You_need_confirm_email":"Vous devez confirmer votre adresse email pour vous connecter !","You_need_install_an_extension_to_allow_screen_sharing":"Vous devez installer une extension pour permettre le partage d'écran","You_need_to_change_your_password":"Vous devez changer votre mot de passe.","You_need_to_type_in_your_password_in_order_to_do_this":"Vous devez entrer votre mot de passe pour faire ceci !","You_need_to_type_in_your_username_in_order_to_do_this":"Vous devez entrer votre nom d'utilisateur pour faire ceci !","You_need_to_verifiy_your_email_address_to_get_notications":"Vous devez vérifier votre adresse e-mail pour recevoir les notifications","You_should_name_it_to_easily_manage_your_integrations":"Vous devriez le nommer pour gérer facilement vos intégrations.","You_will_not_be_able_to_recover":"Vous ne serez pas en mesure de récupérer ce message !","You_will_not_be_able_to_recover_file":"Vous ne pourrez plus récupérer ce fichier !","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Vous ne recevrez pas les notifications par e-mail car vous n'avez pas vérifié votre adresse e-mail.","Your_email_has_been_queued_for_sending":"Votre e-mail a été placé dans la boîte d'envoi","Your_entry_has_been_deleted":"Ce message a été supprimé.","Your_file_has_been_deleted":"Votre fichier a été supprimé.","Your_mail_was_sent_to_s":"Votre e-mail a été envoyé à %s","Your_Open_Source_solution":"Votre propre solution de chat Open Source","Your_password_is_wrong":"Votre mot de passe est incorrect !","Your_push_was_sent_to_s_devices":"Votre notification a été envoyée à %s appareils"});
TAPi18n._registerServerTranslator("fr", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/he.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["he"] = ["Hebrew","עברית"];                                                                    // 8
if(_.isUndefined(TAPi18n.translations["he"])) {                                                                        // 9
  TAPi18n.translations["he"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["he"][namespace])) {                                                             // 13
  TAPi18n.translations["he"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["he"][namespace], {"500":"שגיאת שרת פנימית","0_Errors_Only":"0 - שגיאות רק","1_Errors_and_Information":"1 - טעויות ומידע","2_Erros_Information_and_Debug":"2 - erros, מידע Debug","__username__was_set__role__by__user_by_":"__שם משתמש__ נקבע __role__ ידי __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__שם משתמש__ הוא כבר לא __role__, על ידי __user_by__","Access_not_authorized":"הגישה אינה מורשית.","Access_online_demo":"צפייה בגרסת הדגמה","Access_Online_Demo":"צפייה בגרסת ההדגמה","Access_Token_URL":"URL אסימון גישה","Accounts":"חשבונות","Accounts_AllowDeleteOwnAccount":"אפשר למשתמשים למחוק את החשבון לבד","Accounts_AllowedDomainsList":"רשימת דומיינים מאופשרים","Accounts_AllowedDomainsList_Description":"רשימת הדומיינים המאושרים מופרדים בפסיק","Accounts_AllowEmailChange":"אפשר שינוי דואר אלקטרוני","Accounts_AllowPasswordChange":"אפשר שינוי סיסמה","Accounts_AllowUserAvatarChange":"אפשר למשתמש לשנות את תמונת הפרופיל","Accounts_AllowUsernameChange":"אפשר שינוי שם משתמש","Accounts_AllowUserProfileChange":"אפשר למשתמש לשנות את הפרופיל","Accounts_AvatarResize":"שנה את גודל תמונת הפרופיל","Accounts_AvatarSize":"גודל תמונת הפרופיל","Accounts_AvatarStorePath":"נתיב תמונת הפרופיל","Accounts_AvatarStoreType":"סוג אחסון תמונת פרופיל","Accounts_BlockedDomainsList":"רשימת דומיינים חסומים","Accounts_BlockedDomainsList_Description":"רשימה מופרדת בפסיקים של דומיינים חסומים","Accounts_denyUnverifiedEmail":"מנע מיילים לא מאומתים","Accounts_EmailVerification":"אימות דוא״ל","Accounts_EmailVerification_Description":"בדוק שיש לך הגדרות SMTP נכונות כדי להשתמש בתכונה זו","Accounts_Enrollment_Email":"אימייל הרשמה","Accounts_Enrollment_Email_Description":"אתה יכול להשתמש [שם], [fname], [lname] עבור השם המלא של המשתמש, שם פרטי או שם משפחה, בהתאמה. <br /> אתה יכול להשתמש [email] עבור הדוא\"ל של המשתמש.","Accounts_Iframe_api_method":"שיטת Api","Accounts_Iframe_api_url":"Url Api","Accounts_iframe_enabled":"מופעל","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"תפוגת כניסת ימים","Accounts_ManuallyApproveNewUsers":"אשר משתמשים חדשים ידנית","Accounts_OAuth_Custom_Token_Sent_Via":"Via אסימון שנשלח","Accounts_OAuth_Custom_Authorize_Path":"נתיב אימות","Accounts_OAuth_Custom_Button_Color":"צבע הכפתור","Accounts_OAuth_Custom_Button_Label_Color":"צבע טקסט הכפתור","Accounts_OAuth_Custom_Button_Label_Text":"טקסט הכפתור","Accounts_OAuth_Custom_Enable":"הפעלה","Accounts_OAuth_Custom_id":"מזהה ייחודי","Accounts_OAuth_Custom_Identity_Path":"נתיב הזהות","Accounts_OAuth_Custom_Login_Style":"סגנון כניסה","Accounts_OAuth_Custom_Secret":"סוד","Accounts_OAuth_Custom_Token_Path":"נתיב האסימון","Accounts_OAuth_Custom_URL":"כתובת","Accounts_OAuth_Facebook":"כניסה לפייסבוק","Accounts_OAuth_Facebook_callback_url":"כתובת אתר Callback פייסבוק","Accounts_OAuth_Facebook_id":"מזהה יישומון פייסבוק","Accounts_OAuth_Facebook_secret":"סוד פייסבוק","Accounts_OAuth_Github":"OAuth מופעל","Accounts_OAuth_Github_callback_url":"כתובת האתר Callback Github","Accounts_OAuth_GitHub_Enterprise":"OAuth משופעל","Accounts_OAuth_GitHub_Enterprise_callback_url":"כתובת האתר Callback Enterprise GitHub","Accounts_OAuth_GitHub_Enterprise_id":"מזהה קליינט","Accounts_OAuth_GitHub_Enterprise_secret":"סיסמת קליינט","Accounts_OAuth_Github_id":"מזהה לקוח","Accounts_OAuth_Github_secret":"סוד לקוח","Accounts_OAuth_Gitlab":"הזדהות OAuth משופעלת","Accounts_OAuth_Gitlab_callback_url":"כתובת האתר Callback GitLab","Accounts_OAuth_Gitlab_id":"מזהה GitLab","Accounts_OAuth_Gitlab_secret":"סיסמת קליינט","Accounts_OAuth_Google":"כניסה לגוגל","Accounts_OAuth_Google_callback_url":"כתובת האתר Callback Google","Accounts_OAuth_Google_id":"מזהה בגוגל","Accounts_OAuth_Google_secret":"סוד גוגל","Accounts_OAuth_Linkedin":"כניסה ל־LinkedIn","Accounts_OAuth_Linkedin_callback_url":"כתובת האתר Callback Linkedin","Accounts_OAuth_Linkedin_id":"מזהה LinkedIn","Accounts_OAuth_Linkedin_secret":"סוד LinkedIn","Accounts_OAuth_Meteor":"התחברות עם Meteor","Accounts_OAuth_Meteor_callback_url":"כתובת האתר Callback מטאור","Accounts_OAuth_Meteor_id":"מזהה Meteor","Accounts_OAuth_Meteor_secret":"סיסמת Meteor","Accounts_OAuth_Twitter":"התחברות באמצעות טוויטר","Accounts_OAuth_Twitter_callback_url":"כתובת האתר Callback Twitter","Accounts_OAuth_Twitter_id":"זיהוי טוויטר","Accounts_OAuth_Twitter_secret":"סיסמת Twitter","Accounts_OAuth_Wordpress":"התחברות WordPress","Accounts_OAuth_Wordpress_callback_url":"כתובת האתר Callback Wordpress","Accounts_OAuth_Wordpress_id":"מזהה WordPress","Accounts_OAuth_Wordpress_secret":"סיסמת WordPress","Accounts_PasswordReset":"איפוס ססמה","Accounts_Registration_AuthenticationServices_Enabled":"הרשמה עם שירותי הזדהות","Accounts_RegistrationForm":"טופס הרשמה","Accounts_RegistrationForm_Disabled":"מבוטל","Accounts_RegistrationForm_LinkReplacementText":"טקסט החלפה של לינק טופס הרישום","Accounts_RegistrationForm_Public":"ציבורי","Accounts_RegistrationForm_Secret_URL":"כתובת סודית","Accounts_RegistrationForm_SecretURL":"סיסמת כתובת טופס הרישום","Accounts_RegistrationForm_SecretURL_Description":"אתה חייב לספק מחרוזת אקראית שתתווסף לכתובת הרישום שלך. לדוגמה:https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"נדרשת הרשמה","Accounts_RequireNameForSignUp":"נדרש שם לרישום","Accounts_ShowFormLogin":"טופס מבוסס צג כניסה","Accounts_UseDefaultBlockedDomainsList":"השתמש בברירת מחדל רשימת Domains חסימה","Accounts_UseDNSDomainCheck":"הסימון השתמש דומיין DNS","Activate":"הפעל","Activity":"פְּעִילוּת","Add":"הוספה","Add_agent":"הוספת סוכן","Add_custom_oauth":"הוסף הזדהות OAuth מותאמת אישית","Add_manager":"הוספת מנהל","Add_Members":"הוספת חברים","Add_User":"הוסף משתמש","Add_user":"הוספת משתמש","Add_users":"הוספת משתמשים","Additional_emails":"דואר אלקטרוני נוסף","Additional_Feedback":"משוב נוסף","Administration":"ניהול","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"לאחר אימות OAuth2, משתמשים ינותבו אל כתובת האתר הזו","Agent_added":"נוסף סוכן","Agent_removed":"הוסר סוכן","Alias":"כינוי","All":"את כל","All_channels":"כל הערוצים","All_logs":"כל היומנים","All_messages":"כל ההודעות","Allow_Invalid_SelfSigned_Certs":"אפשר תעודות לא תקינות בחתימה עצמית","Allow_Invalid_SelfSigned_Certs_Description":"אפשר תעודות SSL שנחתמו לא ע\"י CA תקין עבור אימות לינקים ותצוגות מקדימות.","and":"ו","And_more":"ועוד __length __...","Animals_and_Nature":"בעלי חיים וטבע","API":"API","API_Analytics":"סטטיסטיקה","API_Embed":"הטמעה","API_EmbedDisabledFor":"בטל הטמעה עבור משתמשים","API_EmbedDisabledFor_Description":"רשימת משתמשים מופרדים בפסיק","API_GitHub_Enterprise_URL":"כתובת שרת","API_GitHub_Enterprise_URL_Description":"דוגמה: http://domain.com (ללא \"/\" בסוף הכתובת)","API_Gitlab_URL":"כתובת GitLab","API_Wordpress_URL":"כתובת WordPress","Appearance":"מראה","Application_added":"ליישום נוסף","Application_Name":"שם אפליקציה","Application_updated":"עודכן Application","Apply_and_refresh_all_clients":"החל ולרענן את כל הלקוחות","Archive":"ארכיון","Archive_Unarchive":"ארכיון / הוצאה מארכיון","are_also_typing":"גם מקלידים","are_typing":"מקלידים","Are_you_sure":"בוודאות?","Are_you_sure_you_want_to_delete_your_account":"האם אתה בטוח שאתה רוצה למחוק את החשבון שלך?","Authorization_URL":"כתובת אתר הרשאה","Authorize":"לְאַשֵׁר","AutoLinker_StripPrefix":"AutoLinker רצועת קידומת","AutoLinker_StripPrefix_Description":"תצוגה קצרה. למשל https://rocket.chat => rocket.chat","AutoLinker_Urls":"כתובת אתר AutoLinker","AutoLinker_UrlsRegExp":"ביטוי AutoLinker URL רגיל","AutoLinker_Email":"דוא\"ל AutoLinker","AutoLinker_Phone":"טלפון AutoLinker","AutoLinker_Phone_Description":"אוטומטית מקושר מספרי טלפון. למשל `(123) 456-7890`","Auto_Load_Images":"טעינת תמונות אוטומטית","Available":"זמין","Available_agents":"סוכני זמין","Avatar":"תמונת פרופיל","Avatar_changed_successfully":"התמונה הוחלפה בהצלחה","Avatar_URL":"כתובת אתר אישי","Avatar_url_invalid_or_error":"הכתובת שסופקה לא תקינה או לא נגישה. אנא נסה שנית עם כתובת אחרת.","away":"לא נמצא","Away":"לא נמצא","away_female":"לא נמצאת","Away_female":"לא נמצאת","away_male":"לא נמצא","Away_male":"לא נמצא","Back":"חזרה","Back_to_applications":"חזרה יישומים","Back_to_integrations":"חזרה ואינטגרציות","Back_to_login":"חזרה לכניסה","Back_to_permissions":"חזרה להרשאות","Body":"גוּף","bold":"מודגש","busy":"עסוק","Busy":"עסוק","busy_female":"עסוקה","Busy_female":"עסוקה","busy_male":"עסוק","Busy_male":"עסוק","Cancel":"ביטול","Cannot_delete_a_protected_role":"לא ניתן למחוק תפקיד מוגן.","Cannot_delete_role_because_its_in_use":"לא ניתן למחוק תפקיד כי הוא בשימוש","Cannot_invite_users_to_direct_rooms":"אין אפשרות להזמין משתמשים לכוון חדרים","CDN_PREFIX":"תחילית CDN","Certificates_and_Keys":"תעודות ומפתחות","Channel":"ערוץ","Channel_doesnt_exist":"הערוץ `#%s` לא קיים.","Channels":"ערוצים","Channels_list":"רשימת ערוצים ציבוריים","Chat_Rooms":"חדרי צ׳אט","Chatops_Enabled":"אפשר Chatops","Chatops_Title":"פאנל Chatops","Chatops_Username":"שם משתמש Chatops","Choose_a_room":"תוכלו לבחור בחדר","Choose_messages":"בחירת הודעות","Choose_the_alias_that_will_appear_before_the_username_in_messages":"בחר את הכינוי שיופיע לפני שם המשתמש בהודעות.","Choose_the_username_that_this_integration_will_post_as":"בחר את השם משתמש כי השילוב הזה יפרסם כמו.","Clear_all_unreads_question":"נקה את כל ההודעות שלא נקראו?","Client_ID":"זיהוי הלקוח","Client_Secret":"סוד הלקוח","Clients_will_refresh_in_a_few_seconds":"לקוחות ירעננו בעוד כמה שניות","close":"סגירה","Closed":"סָגוּר","Collapse_Embedded_Media_By_Default":"מכווץ תקשורת מוטבעת כברירת מחדל","coming_soon":"בקרוב","Commands":"פקודות","Compact_View":"תצוגה קומפקטית","Confirm_password":"אימות הססמה","Contact":"יצירת קשר","Conversation":"שיחה","Convert_Ascii_Emojis":"המרת ASCII לאימוג׳י","Copied":"מוּעֲתָק","COPY_TO_CLIPBOARD":"העתקה ללוח הגזירים","Copy_to_clipboard":"העתקה ללוח הגזירים","Count":"לִסְפּוֹר","Create":"לִיצוֹר","Create_new":"יצירת חדש","Created_at":"נוצר ב־","Created_at_s_by_s":"נוצר <strong>בתאריך %s</strong> על <strong>ידי %s</strong>","Custom_Fields":"שדות מותאמים אישית","Custom_oauth_helper":"כאשר אתה מגדיר ספק OAuth, תצטרך לספק כתובת Callback. השתמש ב-<pre>%s</pre>.","Custom_oauth_unique_name":"שם ייחודי ב-OAuth מותאם אישית","Custom_Script_Logged_In":"סקריפט המותאם אישית עבור משתמשים מחוברים","Custom_Script_Logged_Out":"סקריפט המותאם אישית למשתמשים מתנתקים","Dashboard":"לוּחַ מַחווָנִים","days":"ימים","Deactivate":"הושבת","Debug_Level":"רמת פירוט","Default":"בְּרִירַת מֶחדָל","Delete":"מחיקה","Delete_my_account":"מחק את חשבוני","Delete_Room_Warning":"מחיקת חדר יגרום למחיקת כל ההודעות שפורסמו בחדר. פעולה זו מוחלטת.","Delete_User_Warning":"מחיקת משתמש תמחק את כל הודעותיו, פעולה זו בלתי הפיכה.","Deleted":"נמחק!","Department_not_found":"המחלקה לא נמצאה","Department_removed":"מחלקת הוסר","Departments":"מחלקות","Description":"תיאור","Desktop":"שולחן","Desktop_Notification_Test":"מבחן הודעה Desktop","Desktop_Notifications":"התראות בשולחן העבודה","Desktop_Notifications_Disabled":"הודעות עבור שולחן עבודה אינן משופעלות. שנה את הגדרות הדפדפן שלך אם אתה רוצה לשפעל הודעות עבור שולחן עבודה.","Desktop_Notifications_Enabled":"הודעות עבור שולחן עבודה משופעלות","Direct_message_someone":"מישהו מסר ישיר","Direct_Messages":"הודעות ישירות","Direct_Messages_list":"הודעות ישירות","Disable_Favorite_Rooms":"בטל מועדפים","Disable_New_Message_Notification":"נטרול התרעת הודעה חדשה","Disable_New_Room_Notification":"נטרול התרעת חדר חדש","Displays_action_text":"טקסט פעולה מציגה","Do_you_want_to_change_to_s_question":"האם אתה רוצה לשנות <strong>את %s?</strong>","Drop_to_upload_file":"יש להשליך לכאן כדי להעלות קובץ","Dry_run":"ניסוי יבש","Dry_run_description":"המייל ישלח רק לכתובת האימייל שכתובה בשדה From. האימייל חייב להיות של משתמש תקין.","Duplicate_archived_channel_name":"עם שם ערוץ בארכיון ' %s' קיימת","Duplicate_archived_private_group_name":"קבוצה פרטית בארכיון עם השם ' %s' קיימת","Duplicate_private_group_name":"כבר קיימת קבוצה פרטית בשם ‚%s‘","E-mail":"דוא״ל","Edit":"עריכה","Edit_Custom_Field":"שדה מותאם אישית ערוך","Edit_Department":"מחלקת עריכה","edited":"נערך","Email":"אֶלֶקטרוֹנִי","Email_already_exists":"כתובת הדוא״ל כבר קיימת","Email_body":"תוכן ההודעה","Email_Change_Disabled":"מנהל Rocket.Chat שלך השבית את חילופי דוא\"ל","Email_from":"מאת","Email_Notification_Mode":"הודעות דוא\"ל מנותקות","Email_Notification_Mode_All":"כל אזכור / DM","Email_Notification_Mode_Disabled":"נָכֶה","Email_or_username":"כתובת דוא״ל או שם משתמש","Email_subject":"נושא","Email_verified":"כתובת הדוא״ל אומתה","Emoji":"אימוג'י","Empty_title":"כותרת ריקה","Enable":"לְאַפשֵׁר","Enable_Desktop_Notifications":"שפעל הודעות עבור שולחן עבודה","Enabled":"מופעל","Encrypted_message":"הודעה מוצפנת","End_OTR":"סוף OTR","Enter_a_regex":"נא להזין ביטוי רגולרי","Enter_a_room_name":"הזן שם חדר","Enter_a_username":"נא להזין שם משתמש","Enter_info":"נא להזין את הפרטים שלך","Enter_name_here":"הזן את השם כאן","Enter_to":"היכנס ל","Error":"שגיאה","error-cant-invite-for-direct-room":"לא ניתן להזמין את משתמש לחדרים ישירים","error-duplicate-channel-name":"כבר קיים ערוץ בשם ‚%s‘","error-invalid-custom-field":"שדה מותאם אישית לא חוקי","error-invalid-custom-field-name":"שם שדה מותאם אישית לא חוקי. השתמש רק אותיות, מספרים, מקפים וקווים תחתונים.","error-invalid-password":"סיסמה שגויה","error-invalid-room":"חדר לא חוקי","error-invalid-room-name":"<strong> %s</strong> אינו שם חדר חוקי, <br/> להשתמש אותיות, מספרים, מקפים וקווים תחתונים בלבד","error-invalid-user":"משתמש שגוי","error-invalid-username":"שם משתמש לא חוקי","error-not-allowed":"לא מורשה","error-not-authorized":"לא מורשה","error-remove-last-owner":"זהו הבעלים האחרונים. אנא קבע בעלים חדש לפני שתסיר את זו.","error-role-name-required":"שם התפקיד נדרש","error-user-not-in-room":"המשתמש אינו בחדר הזה","Error_changing_password":"הססמה הוחלפה","Error_sending_confirmation_email":"שגיאה בשליחת דואר אישור","Error_too_many_requests":"שגיאה, יותר מדי בקשות. בבקשה האט את הקצב. אתה חייב לחכות %s שניות לפני שתוכל לנסות שוב.","Esc_to":"צא ל","Example_s":"לדוגמה: <code class=\"inline\">%s</code>","False":"לא נכון","Favorites":"מועדפים","Field":"שדה","Field_removed":"שדה הוסר","File_exceeds_allowed_size_of_bytes":"קובץ עולה על גודל מוותר של בתי __size__","FileUpload":"העלאת קובץ","FileUpload_Enabled":"העלאת קבצים משופעלת","FileUpload_File_Empty":"קובץ ריק","FileUpload_FileSystemPath":"נתיב מערכת","FileUpload_MaxFileSize":"קובץ מקסימלי להעלאה (בבתים)","FileUpload_MediaType_NotAccepted":"סוג מדיה לא מאושר","FileUpload_MediaTypeWhiteList":"סוגי מדיה מאופשרים","FileUpload_MediaTypeWhiteListDescription":"רשימת סוגי מדיה מופרדים בפסיק. השאר ריק לקבל את כלל סוגי המדיה.","FileUpload_ProtectFiles":"הגנה על קבצים שהועלו","FileUpload_ProtectFilesDescription":"רק משתמשים מאומתים תהיה גישה","FileUpload_S3_Acl":"ACL Amazon S3","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"שם דלי Amazon S3","FileUpload_S3_BucketURL":"כתובת אתר דלי","FileUpload_S3_CDN":"תחום CDN עבור הורדות","FileUpload_S3_Region":"אזור","FileUpload_Storage_Type":"סוג האחסון","Flags":"דגלים","Follow_social_profiles":"ניתן לעקוב אחר הפרופילים שלנו ברשתות החברתיות, לעשות fork למיזם שלנו ב־github ושתף את המחשבות שלך על אפליקציית rocket.chat בלוח trello שלנו.","Food_and_Drink":"אוכל שתייה","For_your_security_you_must_re_enter_your_password_to_continue":"עבור האבטחה, עליך להכניס שוב את הסיסמא שלך על מנת להמשיך","Force_SSL":"חיל SSL","Force_SSL_Description":"* שימו לב! * _Force SSL_ אסור לחלוטין להשתמש עם פרוקסי הפוך. אם יש לך פרוקסי הפוך, אתה צריך לעשות את הפניה THERE. אפשרות זו קיימת עבור פריסות כמו Heroku, שאינו מאפשר את תצורת ההפניה בבית proxy ההפוכה.","Forgot_password":"שכחת את הססמה?","Fork_it_on_github":"fork ב־github","Frequently_Used":"בשימוש תכוף","From":"מ","From_Email":"כתובת מאת","From_email_is_required":"מייל \"מאת\" נדרש","From_email_warning":"<b>אזהרה:</b>: השדה <b>From</b> תלוי בהגדרות שרת המייל שלך.","General":"כללי","Get_to_know_the_team":"היכרות עם הצוות שמאחורי Rocket.Chat","github_no_public_email":"אין לך אף כתובת דוא״ל פומבית בחשבון ה־GitHub שלך","Give_a_unique_name_for_the_custom_oauth":"תן שם ייחודי ב-OAuth מותאם אישית","Give_the_application_a_name_This_will_be_seen_by_your_users":"תן היישום שם. זה ייראה על ידי המשתמשים שלך.","Global":"גלוֹבָּלִי","GoogleTagManager_id":"מנהל התגים של Google Id","Has_more":"יש עוד","Have_your_own_chat":"קח את העניינים לידיים. האפליקציה Rocket.Chat, ש","Header":"כּוֹתֶרֶת","Hidden":"מוּסתָר","Hide_Group_Warning":"האם אתה בטוח שאתה מעוניין להסתחר את הקבוצה \"%s\"?","Hide_Private_Warning":"האם אתה בטוח שאתה רוצה להסתיר את הדיון עם \" %s\"?","Hide_room":"להסתיר את החדר","Hide_Room_Warning":"האם אתה בטוח שאתה רוצה להסתיר בחדר \" %s\"?","Highlights":"עיקרי הדברים","Highlights_How_To":"כדי לקבל הודעה כאשר מישהו מזכיר את המילה או הביטוי, להוסיף אותו כאן. ניתן להפריד מילים או ביטויים עם פסיקים. מילות דגש אינן תלויות-רישיות.","Highlights_List":"מילות דגש","History":"היסטוריה","hours":"שעות","How_friendly_was_the_chat_agent":"איך ידידותי היה סוכן הצ'אט?","How_knowledgeable_was_the_chat_agent":"איך ידע היה סוכן הצ'אט?","How_responsive_was_the_chat_agent":"מידת ההיענות היה סוכן צ'אט?","How_satisfied_were_you_with_this_chat":"איך הייתם מרוצה הצ'אט הזה?","If_you_are_sure_type_in_your_password":"אם אתה סוג בטוח ב הסיסמה:","If_you_are_sure_type_in_your_username":"אם אתה סוג בטוח שם המשתמש שלך:","Importer_Archived":"לארכיון","Importer_done":"יבוא הושלם!","Importer_finishing":"מסיים את היבוא.","Importer_From_Description":"יבוא __from __ נתונים של 'אל Rocket.Chat.","Importer_import_cancelled":"היבוא בוטל.","Importer_import_failed":"ארעה שגיאה בזמן ריצה את הייבוא.","Importer_importing_channels":"יבוא הערוצים.","Importer_importing_messages":"ייבוא ​​הודעות.","Importer_importing_started":"תחילת הייבוא.","Importer_importing_users":"יבוא המשתמשים.","Importer_not_defined_properly":"היבואן לא הוגדר כהלכה, הוא חסר מעמד היבוא.","Importer_not_in_progress":"היבואן כרגע לא פועל.","Importer_Prepare_Restart_Import":"הפעל מחדש את יבוא","Importer_Prepare_Start_Import":"התחל יבוא","Importer_Prepare_Uncheck_Archived_Channels":"ערוצים בארכיון הסר את הסימון","Importer_Prepare_Uncheck_Deleted_Users":"משתמשים הסר את הסימון נמחק","Importer_progress_error":"נכשל בהשגת התקדמות ליבוא.","Importer_setup_error":"ארעה שגיאה בעת הגדרת היבואן.","Incorrect_Password":"סיסמה לא נכונה","inline_code":"קוד","Install_Extension":"התקנת הרחבה","Install_FxOs":"התקן Rocket.Chat ב-Firefox","Install_FxOs_done":"מעולה! עכשיו אתה יכול להשתמש ב-Rocket.Chat מהאייקון שבדף הבית שלך. תהנה עם Rocket.Chat!","Install_FxOs_error":"מצטערים, זה לא עבד כפי שצריך. השגיאה הבאה קרתה:","Install_FxOs_follow_instructions":"וודא שהאפליקציה מותקנת על המכשיר שלך (לחץ \"התקן\" כאשר נדרש).","Installation":"התקנה","Integration_added":"אינטגרציה נוספה","Integration_Incoming_WebHook":"אינטגרציה WebHook נכנסת","Integration_New":"שילוב חדש","Integration_Outgoing_WebHook":"אינטגרצית WebHook יוצאת","Integration_updated":"אינטגרציה עודכנה","Integrations":"ואינטגרציות","Invalid_asset":"Asset לא תקין","Invalid_confirm_pass":"אימות הססמה אינו זהה לססמה","Invalid_email":"כתובת הדוא״ל שהוזנה אינה תקינה","Invalid_Export_File":"הקובץ שהועלה אינו קובץ הייצוא של %s.","Invalid_file_height":"גובה הקובץ לא תקין","Invalid_file_type":"סוג קובץ לא תקין","Invalid_file_width":"רוחב הקובץ לא תקין","Invalid_Import_File_Type":"סוג קובץ יבוא לא חוקי.","Invalid_name":"יש להזין שם","Invalid_notification_setting_s":"הגדרת התראה לא חוקית: %s","Invalid_pass":"יש להזין ססמה","Invalid_room_name":"השם <strong>%s</strong> הוא לא שם תקין לחדר,<br/> יש להשתמש רק באותיות, מספרים ומקפים.","Invalid_room_type":"<strong> %s</strong> אינו סוג חדר חוקי.","Invalid_Secret_URL":"סיסמת URL לא תקינה","Invalid_secret_URL_message":"הכתובת שסופקה לא תקינה","invisible":"בלתי נראה","Invisible":"בלתי נראה","Invitation_HTML":"תבנית HTML להזמנה","Invitation_Subject":"נושא ההזמנה","Invite_user_to_join_channel":"הזמן משתמש להצטרף לחדר","Invite_Users":"הזמן משתמשים","is_also_typing":"גם מקליד/ה","is_also_typing_female":"גם מקלידה","is_also_typing_male":"גם מקליד","is_typing":"מקליד/ה","is_typing_female":"מקלידה","is_typing_male":"מקליד","italics":"נוטה","join":"הצטרפות","Join_audio_call":"הצטרף לשיחה אודיו","Join_the_Community":"הצטרפות לקהילה","Join_the_given_channel":"הצטרף לחדר","Join_video_call":"הצטרף לשיחת וידאו","Joined":"הצטרף","Jump":"קְפִיצָה","Jump_to_first_unread":"קפיצה אל הראשונה שלא נקראה","Jump_to_message":"מעבר להודעה","Jump_to_recent_messages":"מעבר להודעות האחרונות","Katex_Enabled":"Katex מופעל","Label":"תווית","Language":"שפה","Language_Version":"גרסה אנגלית","Last_login":"כניסה אחרונה","Last_message":"ההודעה האחרונה","Last_seen":"נצפה לאחרונה","Layout":"פריסה","Layout_Home_Body":"גוף עמוד הבית","Layout_Home_Title":"כותרת עמוד הבית","Layout_Login_Terms":"תנאי כניסה","Layout_Privacy_Policy":"מדיניות פרטיות","Layout_Sidenav_Footer":"חלק תחתון תפריט צד","Layout_Sidenav_Footer_description":"גודל חלק תחתון הוא 260 על 70 פיקסלים","Layout_Terms_of_Service":"תנאי השירות","LDAP":"LDAP","LDAP_CA_Cert":"Cert CA","LDAP_Custom_Domain_Search":"חיפוש הדומיין המותאם אישית","LDAP_Custom_Domain_Search_Description":"חתיכת JSON, השולטת מידע לאגד וחיבור והוא מהצורה: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"ברירת המחדל של תחום","LDAP_Description":"LDAP הוא מסד נתונים היררכיים כי חברות רבות להשתמש בו כדי לספק כניסה יחידה - מתקן לשיתוף סיסמא אחת בין אתרים ושירותים רבים. לקבלת מידע תצורה מתקדמת ודוגמאות, היועץ wiki שלנו: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"מאגר דומיין","LDAP_Domain_Base_Description":"השם הייחודי מלא (DN) של עץ משנה LDAP אתה רוצה לחפש משתמשים וקבוצות. אתה יכול להוסיף כמה שאתה רוצה; עם זאת, כל קבוצה חייבת להיות מוגדרת באותו הבסיס מושלם בתור המשתמשים ששייכים אליו. אם תציין קבוצות משתמש מוגבלות, רק משתמשים השייכים לקבוצות אלו יהיו בהיקפה. אנו ממליצים לציין את הרמה העליונה של ספריית עץ LDAP שלך כבסיס התחום שלך ולהשתמש במסנן חיפוש כדי לשלוט בגישה.","LDAP_Domain_Search_Filter":"סנן חיפוש דומיין","LDAP_Domain_Search_Filter_Description":"אם צויין, רק משתמשים התואמים מסנן זה יורשו להיכנס. אם אין מסנן מצוין, כל המשתמשים בתחולת בבסיס התחום שצוין יוכלו להיכנס. <br/> למשל עבור Active Directory `memberOf = cn = ROCKET_CHAT, ou = כללי Groups`. <br/> לדוגמא עבור OpenLDAP (חיפוש בהתאמה להרחבה) `ou: DN: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"קטגורית אובייקט חיפוש דומיין","LDAP_Domain_Search_Object_Category_Description":"הסימן * * objectCategory שמזהים המשתמשים שלך. <br/> השאר ריק עבור OpenLDAP * *. <br/> לדוגמא `person`, וכו '","LDAP_Domain_Search_Object_Class":"כיתת אובייקט חיפוש דומיין","LDAP_Domain_Search_Object_Class_Description":"הסימן * * objectClass שמזהים המשתמשים שלך. <br/> לדוגמא `organizationalPerson`,` user`, `inetOrgPerson`, וכו '","LDAP_Domain_Search_Password":"סיסמא חיפוש דומיין","LDAP_Domain_Search_Password_Description":"הסיסמה עבור משתמש תחום החיפוש.","LDAP_Domain_Search_User":"משתמש חיפוש דומיין","LDAP_Domain_Search_User_Description":"משתמש LDAP שמבצע חיפושי משתמש כדי לאמת משתמשים אחרים כאשר הם נכנסים. <br/> זה בדרך כלל חשבון שירות שנוצרו במיוחד עבור ואינטגרציות צד שלישי. השתמש בשם מלא, כגון `cn = מנהל, cn = Users, dc = דוגמא, dc = com`.","LDAP_Domain_Search_User_ID":"זיהוי משתמש חיפוש דומיין","LDAP_Domain_Search_User_ID_Description":"התכונה של LDAP המזהה את המשתמש LDAP שמנסה אימות. שדה זה צריך להיות `sAMAccountName` להתקנות של Active Directory ביותר, אבל זה עשוי להיות` uid` לפתרונות LDAP אחרים, כגון OpenLDAP. אתה יכול להשתמש `mail` לזהות משתמשים בדוא\"ל או כל תכונה שאתה רוצה. <br> תוכל להשתמש בערכים מרובים המופרדים בפסיק כדי לאפשר למשתמשים להתחבר באמצעות מזהים מרובים כמו שם משתמש או דוא\"ל.","LDAP_Enable":"אפשר","LDAP_Enable_Description":"מנסה לאתחל LDAP עבור הזדהות.","LDAP_Encryption":"הצף","LDAP_Encryption_Description":"שיטת ההצפנה שאנו משתמשים כדי לאבטח את התקשורת לשרת LDAP. דוגמאות כוללות `plain` (ללא הצפנה),` SSL / LDAPS` (מוצפן מההתחלה), ו 'StartTLS` (לשדרג תקשורת מוצפנת פעם מחוברת).","LDAP_Host":"מארח","LDAP_Host_Description":"המארח LDAP, למשל `ldap.example.com` או` 10.0.0.30`.","LDAP_Port":"פתחת LDAP","LDAP_Port_Description":"פורט לגישת LDAP. לדוגמה: `389` או `636` עבור LDAPS.","LDAP_Reject_Unauthorized":"דחית מורשה","LDAP_Sync_User_Avatar":"Sync משתמש אישי","LDAP_Sync_User_Data":"סנכרן מידע","LDAP_Sync_User_Data_Description":"דאג למידע מסונכרן על המשתמש בהתחברות לשרת (שם, אימייל).","LDAP_Sync_User_Data_FieldMap":"מיפוי שדה User Data","LDAP_Sync_User_Data_FieldMap_Description":"הגדר כיצד שדות חשבון המשתמש (כגון אימייל) ישלפו מרשומת ה-LDAP (כאשר נמצאה).<br/> לדוגמה, `{\"cn\":\"name\", \"mail\":\"email\"}` יבחרו את השם הקריא של המשתמש מהשדה cn והאימייל שלהם מהשדה mail.<br/> השדות האפשריים כוללים  `name`, ו-`email`.","LDAP_Sync_Users":"משתמשים Sync","LDAP_Test_Connection":"בדיקת חיבור","LDAP_Unique_Identifier_Field":"ייחודיות מזהים שדה","LDAP_Unique_Identifier_Field_Description":"איזה שדה ישמש לקשר משתמש LDAP ומשתמש Rocket.Chat. אתה יכול להודיע ​​ערכים המופרדים באמצעות פסיק כדי לנסות להשיג את הערך מרשום LDAP. <br/> ערך ברירת המחדל הוא `objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"השתמש חיפוש דומיין מותאם אישית","LDAP_Use_Custom_Domain_Search_Description":"כתוב מסנן משלך לחפש משתמשים בשרת LDAP.","LDAP_Username_Field":"שדה שם המשתמש","LDAP_Username_Field_Description":"איזה שדה ישמש * שם משתמש * עבור משתמשים חדשים. השאר ריק להשתמש בשם המשתמש הודיע ​​על דף הכניסה. <br/> אתה יכול להשתמש בתגי תבנית מדי, כמו '# {givenName}. # {SN} `. <br/> ערך ברירת המחדל הוא `sAMAccountName`.","Leave_Group_Warning":"האם אתה בטוח שאתה רוצה לעזוב את הקבוצה \" %s\"?","Leave_Private_Warning":"האם אתה בטוח שאתה רוצה לעזוב את הדיון עם \" %s\"?","Leave_room":"לעזוב את החדר","Leave_Room_Warning":"אתה בטוח שאתה מעוניין לעזוב את החדר \"%s\"","line":"שורה","List_of_Direct_Messages":"רשימת הודעות ישירות","Live_sessions":"הפעלות חיות","Livechat_agents":"סוכני Livechat","Livechat_Dashboard":"לוח המחוונים LiveChat","Livechat_enabled":"Livechat enabled","Livechat_Manager":"מנהל Livechat","Livechat_managers":"מנהלי Livechat","Livechat_title":"כותרת Livechat","Livechat_title_color":"צבע רקע של כותרת Livechat","Livechat_Users":"משתמשים LiveChat","Load_more":"טעינת נוספים","Loading...":"בטעינה…","Loading_more_from_history":"הודעות נוספות נטענות מההיסטוריה","Loading_suggestion":"ההצעות נטענות…","Localization":"לוקליזציה","Log_File":"צג קבצי קו","Log_Level":"רמה התחבר","Log_Package":"חבילת הצג","Log_View_Limit":"התחבר צפו הגבל","Logged_out_of_other_clients_successfully":"הביקור האחרון מתוך לקוחות אחרים בהצלחה","Login":"התחברות","Login_with":"כניסה עם %s","login_with":"או להיכנס ישירות עם","Logout":"יציאה","Logout_Others":"התנתקות מ נרשם אחר במקומות","Mail_Message_Invalid_emails":"אתה ספקת מיילים חוקיים אחד או יותר: %s","Mail_Message_Missing_to":"עליך לבחור משתמש אחד או יותר או לספק אחד או יותר כתובות דואר אלקטרוני, מופרדות בפסיקים.","Mail_Message_No_messages_selected_select_all":"לא בחרת שום הודעות. האם אתה רוצה <a href='#' class='select-all'>לבחור את כל</a> ההודעות הגלויות?","Mail_Messages":"הודעות דואר אלקטרוניות","Mail_Messages_Instructions":"בחר אילו הודעות אתה רוצה לשלוח בדוא\"ל, על ידי לחיצה על ההודעות","Mail_Messages_Subject":"הנה חלק נבחר של %s הודעות","Mailer":"שולח","Mailer_body_tags":"אתה <b>חייב</b> להשתמש ב-[unsubscribe] עבור לינק ההסרה מרשימת התפוצה.<br />אתה יכול להשתמש ב-[name], [fname], [lname] בשביל השם המלא של המשתמש, השם הפרטי או שם המשפחה בהתאמה.<br />אתה יכול להשתמש ב-[email] עבור כתובת המייל של המשתמש.","Make_Admin":"הפוך לאדמין","Manager_added":"נוסף מנהל","Manager_removed":"הוסר מנהל","Mark_as_read":"סימון כנקרא","Markdown_Headers":"כותרות Markdown","Markdown_SupportSchemesForLink":"תוכניות תמיכה Markdown עבור קישור","Markdown_SupportSchemesForLink_Description":"רשימה מופרדת בפסיקים של תוכניות מותרות","Members_List":"רשימת חברים","Mentions":"אזכורים","Mentions_default":"אזכורים (ברירת מחדל)","Message":"הודעה","Message_AllowDeleting":"לאפשר מחיקת הודעות","Message_AllowEditing":"לאפשר עריכת הודעות","Message_AllowEditing_BlockEditInMinutes":"נעל עריכת הודעה לאחר (n) דקות","Message_AllowEditing_BlockEditInMinutesDescription":"הזן 0 לביטול נעילה.","Message_AllowPinning":"אפשר הודעות נעוצות","Message_AllowPinning_Description":"אפשר להודעות להיות נעוצות לכל הערוצים.","Message_AllowStarring":"אפשר הודעות מועדפות","Message_AudioRecorderEnabled":"מקליט אודיו משופעל","Message_AudioRecorderEnabledDescription":"דורש שקבצי 'audio/wav' יתקבלו בסוגי מדיה בהגדרות 'File Upload'.  ","Message_DateFormat":"פורמט תאריך","Message_DateFormat_Description":"ראו גם: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"לא ניתן למחוק הודעה","Message_editing_blocked":"לא ניתן לערוך את הודעה יותר","Message_editing_not_allowed":"לא ניתן לערוך הודעה","Message_GroupingPeriod":"הקבצה תקופה (בשניות)","Message_GroupingPeriodDescription":"הודעות תקובצנה עם הודעה קודמת אם שניהם מאותו משתמש ואת הזמן שהחלף היה פחות הזמן המושכל בשניות.","Message_KeepHistory":"שמירה על היסטוריית הודעות","Message_MaxAllowedSize":"גודל ההודעה המרבי המותר","Message_MaxAll":"ALL גודל ערוץ מקסימאלי עבור הודעה","Message_pinned":"ההודעה ננעצה","Message_pinning_not_allowed":"נעיצת הודעות לא מאופשרת","Message_removed":"ההודעה הוסרה","Message_ShowDeletedStatus":"הצגת מצב מחיקה","Message_ShowEditedStatus":"הצגת מצב ערוך","Message_ShowFormattingTips":"הצג טיפים לעריכה","Message_TimeFormat":"פורמט זמן","Message_TimeFormat_Description":"ראו גם: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"הודעה יותר מדי זמן","Messages":"הודעות","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"הודעות נשלחות אל נכנס WebHook תפורסמנה כאן.","Meta":"Meta","Meta_fb_app_id":"זיהוי אפליקציית פייסבוק","Meta_google-site-verification":"אימות Google Site","Meta_language":"שפה","Meta_msvalidate01":"MSValidate.01","Meta_robots":"רובוטים","minutes":"דקות","Mobile_push":"דחיפה ניידת","More_channels":"עוד ערוצים","More_direct_messages":"עוד הודעות ישירות","More_groups":"קבוצות פרטיות נוספות","More_unreads":"עוד שלא נקראו","Msgs":"הודעות","multi":"הרבה","Mute_someone_in_room":"מישהו השתק בחדר","Mute_user":"השתקת משתמש","Muted":"מושתק","My_Account":"החשבון שלי","n_messages":"%s הודעות","N_new_messages":"הודעות חדשות %s","Name":"שם","Name_cant_be_empty":"השם לא יכול להיות ריק","Name_of_agent":"שם הסוכן","Name_optional":"שם (אופציונאלי)","Navigation_History_20_last_pages":"ניווט ההיסטוריה (20 עמודים אחרונים)","New_Application":"יישום חדש","New_Custom_Field":"חדש בשדה מותאם אישית","New_Department":"חדש מחלקת","New_integration":"שילוב חדש","New_logs":"יומנים חדשים","New_messages":"הודעות חדשות","New_password":"ססמה חדשה","New_role":"תפקיד חדש","No_channel_with_name_%s_was_found":"לא נמצא ערוץ עם השם <strong>\"%s\"</strong>!","No_channels_yet":"אינך חבר באף ערוץ עד כה.","No_direct_messages_yet":"לא התחלת אף שיחה עד כה.","No_Encryption":"ללא הצפנה","No_favorites_yet":"אין לך מועדפים.","No_group_with_name_%s_was_found":"לא נמצאה קבוצה פרטית עם השם <strong>\"%s\"</strong>!","No_groups_yet":"לא קיימות לך קבוצות פרטיות.","No_livechats":"אין לך אף Livechats.","No_mentions_found":"לא נמצאו אזכורים","No_permission_to_view_room":"אין לך הרשאות לצפות בחדר זה","No_pinned_messages":"אין הודעות מוצמדות","No_results_found":"לא נמצאו תוצאות","No_starred_messages":"אין הודעות מועדפות","no_tokens_for_this_user":"אין אסימונים למשתמש זה","No_user_with_username_%s_was_found":"לא נמצא המשתמש <strong>\"%s\"</strong>!","Not_allowed":"לא מורשה","Not_authorized":"לא מאומת","Not_Available":"לא זמין","Not_found_or_not_allowed":"לא נמצא או שאין לך הרשאה","Nothing":"שום דבר","Nothing_found":"אין תוצאות","Notifications":"התראות","Notify_all_in_this_room":"להודיע לכל מי שבחדר","Num_Agents":"סוכני #","Number_of_messages":"מספר הודעות","OAuth_Application":"יישום OAuth","OAuth_Applications":"יישומי OAuth","Objects":"אובייקטים","Off_the_record_conversation":"Off-the-שיא השיחה","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-שיא השיחה אינה זמינה בדפדפן או במכשיר שלך.","Offline_DM_Email":"[__site__] קבלת הודעות במשך ישיר על ידי __user__","Offline_Mention_Email":"[__site__] אתה הוזכרת על ידי __user__ ב #__room__","Old_and_new_password_must_be_different":"הסיסמה החדשה חייבת להיות שונה הסיסמה הישנה.","Old_and_new_password_required":"תצטרך לספק את הסיסמה הישנה והחדשה על מנת לשנות את הסיסמה שלך.","Online":"מחובר","Only_errors":"שגיאות בלבד","Only_you_can_see_this_message":"רק אתה יכול לראות הודעה זו","Oops!":"אופס","Open":"לִפְתוֹחַ","Opened":"נפתח","Opt_out_statistics":"לא לשלוח את הסטטיסטיקה שלי ל־Rocket.Chat","Opt_out_statistics_warning":"על ידי שליחה של הסטטיסטיקות שלך, תוכל תעזור לנו לזהות כמה מופעים של Rocket.Chat הקמת, כמו כן כיצד המערכת מתנהגת, על מנת שנוכל לשפר אותה. אל תדאג, מידע על המשתמשים לא ישלח וכל האינפורמציה נשמרת בצורה סודית. אם אתה רוצה להמשיך לשלוח לנו סטטיסטיקות, בטל את הסימון בתיבה למעלה. תודה.","optional":"אופציונאלי","Order":"סדר","OS_Arch":"ארכטיקטורת מערכת הפעלה","OS_Cpus":"מספר מעבדים","OS_Freemem":"זיכרון פנוי","OS_Loadavg":"עומס ממוצע","OS_Platform":"פלטפורמת מערכת הפעלה","OS_Release":"הפצת מערכת הפעלה","OS_Totalmem":"זיכרון כללי","OS_Type":"סוג מערכת הפעלה","OS_Uptime":"זמן פעילות","others":"אחרים","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR זמינה רק כאשר המשתמשים הוא במצב מקוון","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"כתובת אתר דרוס שאליו קבצים מועלים. url זה משמש גם עבור הורדות אלא אם CDN ניתן","Password":"ססמה","Password_Change_Disabled":"מנהל המערכת שלך ביטל את האפשרות לשנות סיסמאות","Password_changed_successfully":"הססמה הוחלפה בהצלחה","Payload":"מטען","People":"אנשים","Permissions":"הרשאות","Pin_Message":"הצמדת הודעה","Pinned_a_message":"צמיד הודעה:","Pinned_Messages":"הודעות מוצמדות","Placeholder_for_email_or_username_login_field":"שומר מקום בשדה Login דוא\"ל או שם משתמש","Placeholder_for_password_login_field":"שומר מקום בשדה Login סיסמא","Please_answer_survey":"קדש דק כדי לענות על סקר קצר על הצ'אט הזה","Please_enter_value_for_url":"הכנס ערך עבור הכתובת של תמונת הפרופיל שלך.","Please_enter_your_new_password_below":"נא להזין את הסיסמה החדשה שלך למטה:","Please_fill_a_label":"נא למלא תווית","Please_fill_a_name":"נא למלא שם","Please_fill_a_username":"נא למלא שם משתמש","Please_fill_name_and_email":"נא למלא את השם ואת הדוא\"ל","Please_re_enter_your_password":"הזן מחדש את הסיסמה שלך","Please_select_enabled_yes_or_no":"אנא בחר אופציה מופעל","Please_wait":"נא להמתין","Please_wait_activation":"בבקשה המתן, זה עשוי לקחת מעט זמן.","Please_wait_statistics":"בבקשה המתן, המערכת מחוללת סטטיסטיקות. ","Please_wait_while_OTR_is_being_established":"אנא המתן בזמן OTR ומוקם","Please_wait_while_your_account_is_being_deleted":"אנא המתן בזמן חשבונך מתבצע מחיקה ...","Please_wait_while_your_profile_is_being_saved":"אנא המתן כאשר הפרופיל שלך חוזר לקדמותו ...","Post_as":"Post כמו","Post_to_Channel":"פרסום לערוץ","Post_to_s_as_s":"<strong>פרסם% <strong>s%</strong></strong> <strong>s</strong>","Powered_by":"מופעל על גבי","Preferences":"העדפות","Preferences_saved":"ההעדפות נשמרו","Privacy":"פרטיות","Private_Group":"קבוצה פרטית","Private_Groups":"קבוצות פרטיות","Private_Groups_list":"הצגת הקבוצות הפרטיות","Profile":"פרופיל","Profile_saved_successfully":"הפרופיל נשמר בהצלחה","Proudly_developed":"פותח בגאווה עם Meteor","Push":"דחיפה","Push_apn_cert":"תעודת APN","Push_apn_dev_cert":"תעודת סביבת פיתוח של APN","Push_apn_dev_key":"מפתח סביבת פיתוח של APN","Push_apn_dev_passphrase":"סיסמת סביבת פיתוח של APN","Push_apn_key":"מפתח ל-APN","Push_apn_passphrase":"סיסמה ל-APN","Push_debug":"ניפוי שגיאות","push_disabled":"Push מבוטל","Push_enable":"אפשר","Push_enable_gateway":"הפעלת שער גישה","Push_gateway":"שער גישה","Push_gcm_api_key":"מפתח API של GCM","Push_gcm_project_number":"מספר פרויקט ב-GCM","Push_production":"סביבת ייצור","Push_show_message":"הצג הודעה בהודעה","Push_show_username_room":"ערוץ הצג / קבוצה / username בהודעה","Push_test_push":"בדיקה","Query":"שאילתה","Query_description":"תנאים נוספים לקביעה אשר למשתמשים לשלוח את הודעת הדוא\"ל. למשתמשים לא רשומים יוסרו באופן אוטומטי את השאילתה. זה חייב להיות JSON תקף. דוגמה: \"{\" createdAt \": {\" $ gt \": {\" תאריך $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"חיפוש מהיר","quote":"ציטוט","Reactions":"תגובות","Recents":"אחרונים/אחרונות","Record":"הקלט","Redirect_URI":"הפניה URI","Refresh_keys":"מפתחות רעננים","Refresh_your_page_after_install_to_enable_screen_sharing":"רענן את הדף לאחר להתקין כדי לאפשר שיתוף מסך","Register":"הרשמה עם חשבון חדש","Registration_Succeeded":"הרשמה הצליחה","Remember_me":"שמירת הפרטים שלי","Remove":"מחיקה","Remove_Admin":"הסר אדמין","Remove_as_moderator":"הסר כמו מנחה","Remove_as_owner":"הסר כבעלים","Remove_custom_oauth":"הסר הזדהות OAuth מותאם אישית","Remove_from_room":"הסר מחדר","Remove_someone_from_room":"הסר מישהו מהחדר","Removed":"הוסר","Require_password_change":"דרוש שינוי סיסמה","Resend_verification_email":"לשלוח דוא\"ל לאימות","Reset":"איפוס","Reset_password":"איפוס ססמה","Restart":"הפעלה מחדש","Restart_the_server":"איפוס השרת","RocketBot_Enabled":"RocketBot משופעל","RocketBot_Name":"שם RocketBot","RocketBot_Name_Description":"שם RocketBot חייב להיות שם משתמש תקין שרשום בשרת שלך.","Role":"תפקיד","Role_Editing":"עריכת תפקידים","Role_removed":"התפקיד הוסר","Room":"חדר","Room_archivation_state":"מְדִינָה","Room_archivation_state_false":"פָּעִיל","Room_archivation_state_true":"לארכיון","Room_archived":"חדר בארכיון","room_changed_privacy":"סוג החדר השנה ל:<em>__room_type__</em> ע\"י <em>__user_by__</em>","room_changed_topic":"נושא החדר שונה ל:<em>__room_topic__</em> ע\"י <em>__user_by__</em>","Room_has_been_deleted":"חדר נמחק","Room_Info":"פרטי החדר","Room_name_changed":"שם החדר שונה ל: <em>__room_name__</em> על ידי המשתמש <em>__user_by__</em>","Room_name_changed_successfully":"שם החדר שונה בהצלחה","Room_not_found":"החדר לא נמצא","Room_topic_changed_successfully":"נושא החדר שונה בהצלחה","Room_type_changed_successfully":"סוג החדר שונה בהצלחה","Room_unarchived":"חדר מהארכיון","Room_uploaded_file_list":"רשימת קבצים","Room_uploaded_file_list_empty":"אין קבצים זמינים.","room_user_count":"משתמשי %s","Rooms":"חדרים","S_new_messages_since_s":"%s הודעות חדשות מאז %s","SAML":"SAML","SAML_Custom_Cert":"תעודה מותאמת אישית","SAML_Custom_Entry_point":"Entry Point מותאם אישית","SAML_Custom_Generate_Username":"חולל שם משתמש","SAML_Custom_Issuer":"Issuer מותאם אישית","SAML_Custom_Provider":"Provider מותאם אישית","Save":"שמירה","Save_changes":"שמירת השינויים","Save_Mobile_Bandwidth":"חסכון בתעבורה סלולרית","Save_to_enable_this_action":"שמור כדי להפעיל את הפעולה הזו","Saved":"נשמר","Saving":"בשמירה","Scope":"תְחוּם","Screen_Share":"שיתוף מסך","Script_Enabled":"מאופשר סקריפט","Search":"חיפוש","Search_by_username":"חיפוש לפי שם","Search_Channels":"ערוצי חיפוש","Search_Direct_Messages":"חפש בהודעות ישירות","Search_Messages":"חיפוש בהודעות","Search_Private_Groups":"חיפוש קבוצות פרטיות","Search_settings":"הגדרות חיפוש","seconds":"שניות","See_all":"צפייה בהכול","See_only_online":"רק מחוברים","Select_a_department":"בחר מחלקה","Select_an_avatar":"בחירת תמונה","Select_file":"בחירת קובץ","Select_service_to_login":"יש לבחור בשירות להתחבר דרכו לטעינת התמונה שלך או להעלות אחת ישירות מהמחשב שלך","Select_user":"נא לבחור משתמש","Select_users":"משתמשים בחרו","Selected_agents":"סוכנים נבחרים","Selected_users":"חברים נבחרים","Send":"שליחה","Send_a_message":"שליחת הודעה","Send_a_test_mail_to_my_user":"שלח מבחן אלקטרוני למשתמש שלי","Send_a_test_push_to_my_user":"שלח בדיקת push למשתמש שלי","Send_confirmation_email":"שליחת דוא״ל אימות","Send_data_into_RocketChat_in_realtime":"שליחת נתונים לתוך Rocket.Chat בזמן אמת.","Send_email":"שלח אימייל","Send_invitation_email":"שלח הזמנה באמצעות אי מייל","Send_invitation_email_error":"לא סיפקת אימייל תקף","Send_invitation_email_info":"ניתן לשלוח הזמנות מרובות באימייל בפעם אחת","Send_invitation_email_success":"שלחת בהצלחה הזמנה באמצעות אימייל לכתובות הבאות:","Send_invitation_email_warning":"על מנת לשלוח הזמנות באימייל, עליך להגדיר ראשית את הגדרות ה-SMTP.","Send_Message":"שליחת הודעה","Send_your_JSON_payloads_to_this_URL":"שלח מטעני JSON שלך לכתובת אתר זו.","Sending":"שְׁלִיחָה...","Set_as_moderator":"Set as מנחה","Set_as_owner":"גדר כבעלים","Settings":"הגדרות","Settings_updated":"ההגדרות עודכנו","Should_be_a_URL_of_an_image":"צריך להיות כתובת אתר של תמונה.","Should_exists_a_user_with_this_username":"המשתמש חייב להיות קיים.","Show_all":"הצג הכול","Show_more":"הראה עוד","Show_only_online":"הצג רק באינטרנט","Show_preregistration_form":"צג טופס הרשמה מראש","Showing_archived_results":"<p style=\";text-align:right;direction:rtl\"> מציג תוצאות <b>בארכיון %s</b> </p>","Showing_online_users":"מציג <b>__total_showing__</b> מתוך __total__ משתמשים","Showing_results":"<p>מוצגות <b>%s</b> תוצאות</p>","Silence":"השתקה","since_creation":"מאז %s","Site_Name":"שם האתר","Site_Url":"כתובת אתר","Site_Url_Description":"דוגמה: https://chat.domain.com","Skip":"לדלג","Smileys_and_People":"סמיילים & אנשים","SMTP":"SMTP","SMTP_Host":"מארח ","SMTP_Password":"ססמה ל־","SMTP_Port":"פתחת SMTP","SMTP_Test_Button":"הגדרות SMTP מבחן","SMTP_Username":"שם משתמש ב־SMTP","Sound":"שמע","Star_Message":"הוסף הודעה למועדפים","Starred_Messages":"הודעות מועדפות","Start_audio_call":"התחל שיחת אודיו","Start_Chat":"התחל צ'אט","Start_of_conversation":"התחלת השיחה","Start_OTR":"התחל OTR","Start_video_call":"התחל שיחת וידאו","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"התחל עם <code class=\"inline\">%s</code> עבור משתמש או <code class=\"inline\">%s</code> עבור הערוץ. לדוגמא: <code class=\"inline\">%s</code> או <code class=\"inline\">%s</code>","Statistics":"סטטיסטיקה","Stats_Active_Users":"משתמשים פעילים","Stats_Avg_Channel_Users":"ממוצע המשתמשים לערוץ","Stats_Avg_Private_Group_Users":"ממוצע המשתמשים לקבוצה פרטית","Stats_Away_Users":"משתמשים שאינם נמצאים","Stats_Max_Room_Users":"מקסימום משתמשים לחדר","Stats_Non_Active_Users":"משתמשים לא פעילים","Stats_Offline_Users":"משתמשים לא מקוונים","Stats_Online_Users":"משתמשים מקוונים","Stats_Total_Channels":"סך כל הערוצים","Stats_Total_Direct_Messages":"כמות הודעות ישירות כללית","Stats_Total_Messages":"סך כל ההודעות","Stats_Total_Private_Groups":"סך כל הקבוצות הפרטיות","Stats_Total_Rooms":"סך כל החדרים","Stats_Total_Users":"סך כל המשתמשים","Stop_Recording":"הפסק להקליט","strike":"מחוק","Subject":"הנדון","Submit":"שליחה","Success":"הצליח","Survey":"סקר","Survey_instructions":"דרג כל שאלה על פי לשביעות רצונך, כש -1 פירושו אתה לא מרוצה לחלוטין ו -5 כלומר אתה מרוצה לגמרי.","Symbols":"סמלים","Sync_success":"הצלחת Sync","Sync_Users":"משתמשים Sync","Test_Connection":"בדיקת חיבור","Test_Desktop_Notifications":"הודעות בשולחן העבודה מבחן","Thank_you_for_your_feedback":"תודה לך על המשוב","The_application_name_is_required":"שם האפליקציה נדרש","The_channel_name_is_required":"שם הערוץ נדרש","The_emails_are_being_sent":"האימיילים נשלחים.","The_field_is_required":"השדה %s הוא חובה.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"שינוי גודל התמונה לא יעבוד כי אנחנו לא יכולים לזהות ImageMagick או GraphicsMagick מותקן על השרת שלך.","The_redirectUri_is_required":"RedirectUri נדרש","The_server_will_restart_in_s_seconds":"השרת יפעיל את עצמו מחדש בעוד ","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"ה- <strong>S הגדרת%</strong> <strong>מוגדר %s</strong> ואתה ניגש <strong>מ %s!</strong>","The_user_will_be_removed_from_s":"המשתמש יוסר %s","The_user_wont_be_able_to_type_in_s":"המשתמש לא יוכל להקליד %s","Theme":"נושא","theme-color-action-buttons-color":"לחצני פעולות צבע","theme-color-active-channel-background-color":"צבע הרקע של הערוץ Active","theme-color-active-channel-font-color":"צבע גופן ערוץ Active","theme-color-blockquote-background":"צבע רקע של ציטוט","theme-color-clean-buttons-color":"צבע לחצנים נקיים","theme-color-code-background":"קוד הצבע של הרקע","theme-color-code-border":"קוד הצבע של המסגרת","theme-color-code-color":"קוד צבע","theme-color-content-background-color":"צבע הרקע של התוכן","theme-color-custom-scrollbar-color":"צבע מותאם אישית פס גלילה","theme-color-info-active-font-color":"צבע פונט של ה-Info הפעיל","theme-color-info-font-color":"צבע של פונט Info","theme-color-input-font-color":"צבע פונט של קלט","theme-color-link-font-color":"צבע פונט של לינק","theme-color-message-hover-background-color":"צבע הודעת רחף BG","theme-color-primary-background-color":"צבע רקע ראשי","theme-color-primary-font-color":"צבע פונט ראשי","theme-color-quaternary-font-color":"הרביעון צבע הגופן","theme-color-secondary-background-color":"צבע רקע משני","theme-color-secondary-font-color":"צבע פונט משני","theme-color-smallprint-font-color":"צבע פונט Small Print","theme-color-smallprint-hover-color":"צבע מעבר Small Print","theme-color-status-away":"צבע סטטוס לא נמצא","theme-color-status-busy":"צבע סטטוס עסוק","theme-color-status-offline":"צבע סטטוס לא מחובר","theme-color-status-online":"צבע סטטוס זמין","theme-color-tertiary-background-color":"צבע סטטוס ","theme-color-tertiary-font-color":"צבע פונט שלישי","theme-color-unread-notification-color":"צבע הודעות שלא נקראו","theme-custom-css":"CSS מותאם אישית","There_are_no_agents_added_to_this_department_yet":"אין סוכנים הוסיף למחלקה זו עדיין.","There_are_no_integrations":"אין ואינטגרציות","There_are_no_users_in_this_role":"אין משתמשים בתפקיד זה.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"דוא\"ל זה כבר נעשה שימוש ולא אומת. שנה את הסיסמה שלך.","This_is_a_desktop_notification":"זוהי הודעת שולחן עבודה","This_is_a_push_test_messsage":"זוהי הודעת בדיקה של ה-push","Time_in_seconds":"זמן בשניות","Title_bar_color":"צבע בר הכותרת","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"כדי להתקין Rocket.Chat LiveChat באתר האינטרנט שלך, העתק והדבק את הקוד הזה מעל <strong></ body></strong> האחרון באתר שלך.","To_users":"למשתמשים","Topic":"נושא","Travel_and_Places":"Travel & מקומות","Trigger_removed":"טריגר הוסר","Trigger_Words":"מילות טריגר","Triggers":"מפעילים","True":"נכון","Type":"סוג","Type_your_new_password":"הקלד את הסיסמה החדשה","Unarchive":"הוצא מארכיון","Unmute_someone_in_room":"מישהו לבטל את ההשתקה בחדר","Unmute_user":"המשתמש לבטל את ההשתקה","Unnamed":"ללא שם","Unpin_Message":"שחרור הודעה","Unread_Rooms":"חדרים שלא נקראו","Unread_Rooms_Mode":"מצב חדרים שלא נקראו","Unstar_Message":"הסר ממועדפים","Upload_file_question":"להעלות קובץ?","Uploading_file":"מעלה קובץ...","Use_account_preference":"השתמש העדפת חשבון","Use_Emojis":"שימוש באימוג׳י","Use_initials_avatar":"שימוש בראשי התיבות של שם המשתמש שלך","use_menu":"ניתן להשתמש בתפריט הצד כדי לגשת לחדרים ולצ׳אטים שלך.","Use_service_avatar":"שימוש בתמונה מ־%s","Use_this_username":"יש להשתמש בשם המשתמש הזה","Use_uploaded_avatar":"שימוש בתמונה שהועלתה","Use_url_for_avatar":"השתמש ב-url עבור תמונת הפרופיל","User__username__is_now_a_moderator_of__room_name_":"__שם משתמש__ המשתמש עכשיו מנחה של __room_name__","User__username__is_now_a_owner_of__room_name_":"__שם משתמש__ המשתמש עכשיו בעלים של __room_name__","User__username__removed_from__room_name__moderators":"__שם משתמש__ המשתמש הוסר ממפקחי __room_name__","User__username__removed_from__room_name__owners":"__שם משתמש__ המשתמש הוסר מבעלי __room_name__","User_added":"המשתמש נוסף.","User_added_by":"המשתמש <em>__user_added__</em> נוסף על ידי <em>__user_by__</em>","User_added_successfully":"משתמש נוסף בהצלחה","User_Channels":"ערוצי משתמש","User_doesnt_exist":"אף משתמש לא קיים בשם `@%s`.","User_has_been_activated":"המשתמש הופעל","User_has_been_deactivated":"המשתמש נוטרל","User_has_been_deleted":"המשתמש הוסר","User_has_been_muted_in_s":"משתמש הושתק ב %s","User_has_been_removed_from_s":"משתמש הוסר %s","User_has_disconnected":"משתמש נותק","User_Info":"פרטי משתמש","User_is_no_longer_an_admin":"המשתמש אינו משמש יותר כאדמין","User_is_not_activated":"המשתמש אינו פעיל","User_is_now_an_admin":"המשתמש כרגע משמש כאדמין","User_joined_channel":"הצטרף לערוץ.","User_joined_channel_female":"הצטרפה לערוץ.","User_joined_channel_male":"הצטרף לערוץ.","User_left":"המשתמש עזב את השיחה.","User_left_female":"עזבה את הערוץ.","User_left_male":"עזב את הערוץ.","User_logged_out":"המשתמש לא מחובר","User_management":"ניהול משתמשים","User_muted_by":"משתמש <em>__user_muted__</em> מושתק על ידי <em>__user_by__.</em>","User_muted_in_room":"משתמש מושתק בחדר","User_not_found":"המשתמש לא נמצא","User_not_found_or_incorrect_password":"המשתמש לא נמצא או הסיסמה לא נכונה","User_or_channel_name":"כינוי או ערוץ","User_removed":"המשתמש הוסר","User_removed_by":"המשתמש <em>__user_removed__</em> הוסר על ידי <em>__user_by__</em>","User_removed_from_room":"המשתמש הוסר מן החדר","User_Settings":"הגדרות המשתמש","User_unmuted_by":"<em>__user_unmuted__</em> משתמש בוטל השתקה ידי <em>__user_by__.</em>","User_unmuted_in_room":"משתמש ההשתקה בחדר","User_updated_successfully":"המשתמש עודכן בהצלחה","Username":"שם משתמש","Username_and_message_must_not_be_empty":"שם משתמש הודעה לא יכולים להיות ריקים.","Username_cant_be_empty":"יש להזין שם משתמש","Username_Change_Disabled":"מנהל המערכת שלך ביטל את האפשרות לשנות שמות משתמשים","Username_denied_the_OTR_session":"__שם משתמש__ הכחיש את הפגישה OTR","Username_description":"שם המשתמש שלך משמש עבור אזכורים שלך בהודעות של משתמשים אחרים. שים לב! שם משתמש ללא רווחים (לדוגמא גיא.ישראלי)","Username_doesnt_exist":"שם המשתמש ' %s` אינו קיים.","Username_ended_the_OTR_session":"__שם משתמש__ הסתיימה פגישת OTR","Username_invalid":"השם <strong>%s</strong> אינו שם משתמש תקין,<br/> יש להשתמש רק באותיות, מספרים נקודות ומקפים. חשוב! שם משתמש ללא רווחים (לדוגמא גיא.ישראלי)","Username_is_already_in_here":"`@%s` כבר נמצא כאן.","Username_is_not_in_this_room":"S` המשתמשים `#% הוא לא בחדר הזה.","Username_not_found":"שם המשתמש לא נמצא","Username_title":"רישום שם משתמש","Username_unavaliable":"השם <strong>%s</strong> תפוס :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__שם משתמש__ רוצה להתחיל OTR. האם אתה רוצה לקבל?","Users":"משתמשים","Users_in_role":"משתמשים בתפקיד","UTF8_Names_Slugify":"UTF8 שמות Slugify","UTF8_Names_Validation":"UTF8 שמות אימות","UTF8_Names_Validation_Description":"אל תאפשרו תווים וחללים מיוחדים. אתה יכול להשתמש - _ ו. אבל לא בסוף השם","Verification_email_sent":"נשלחה הודעת אישור בדוא\"ל","View_All":"הצגת הכול","View_Logs":"יומנים","Visibility":"רְאוּת","Visible":"נִרְאֶה","Visitor":"אוֹרֵחַ","Visitor_page_URL":"כתובת אתר של דף הגולש","Visitor_time_on_site":"זמן גולש באתר","Wait_activation_warning":"לפני שתוכל להתחבר, החשבון שלך חייב לעבור אישור על ידי האדמין.","We_are_offline_Sorry_for_the_inconvenience":"אנחנו במצב לא מקוון. מצטער על אי הנוחות.","We_have_sent_password_email":"בדקות הקרובות אמורה להגיע אליך הודעה בדוא״ל עם הוראות לאיפוס הססמה. אם ההודעה לא מגיעה אליך, נא לנסות שוב.","We_have_sent_registration_email":"שלחנו לך הודעת דוא״ל לאישור ההרשמה. אם ההודעה לא מגיעה אליך בדקות הקרובות, נא לחזור לכאן ולנסות שוב.","WebRTC_Enable_Channel":"אפשר ערוצים ציבוריים","WebRTC_Enable_Direct":"אפשר הודעות ישירות","WebRTC_Enable_Private":"אפשר ערוצים פרטיים","WebRTC_Servers":"שרתי STUN / TURN","WebRTC_Servers_Description":"רשימת שרתי STUN ולהפוך מופרדות בפסיקים. <br/> שם משתמש, סיסמא יציאה מותרת במתכונת `שם משתמש: ההלם @ סיסמא: מארח: port` או` שם משתמש: בתורו @ סיסמא: מארח: port`.","Welcome":"ברוך בואך <em>%s</em>.","Welcome_to_the":"ברוך בואך ל־","will_be_able_to":"תוכל","With_whom":"עם מי","Yes":"כן","Yes_clear_all":"כן, הכל נוקה!","Yes_delete_it":"כן, למחוק אותה!","Yes_hide_it":"כן, להסתיר את זה!","Yes_leave_it":"כן, להשאיר אותו!","Yes_mute_user":"כן, המשתמש אילם!","Yes_remove_user":"כן, להסיר את המשתמש!","you_are_in_preview_mode_of":"You are in preview mode of channel #<strong>__room_name__</strong>","You_are_logged_in_as":"אתה מחובר בשם","You_are_not_authorized_to_view_this_page":"אין לך הרשאה לצפות בדף זה","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"אתה הבעלים האחרון. אנא הגדר בעלים חדשים לפני שעזבתי את החדר.","You_can_change_a_different_avatar_too":"באפשרותך לעקוף את הגלגול נהג לפרסם מאינטגרציה זה.","You_can_use_an_emoji_as_avatar":"אתה יכול גם להשתמש אמוג'י כתמונה אישית.","You_have_been_muted":"אתה הושתקת ולא יכול לדבר בחדר הזה","You_have_not_verified_your_email":"לא אימת הדוא\"ל שלך.","You_have_successfully_unsubscribed":"הוסרת מרשימת התפוצה בהצלחה.","You_informed_an_invalid_FROM_address":"הזנת כתובת לא תקינה ב-FROM.","You_must_provide_the_unsubscribe_link":"חובה לספק את הלינק [unsubscribe].","You_need_confirm_email":"עליך לאמת את כתובת הדוא״ל על מנת להתחבר!","You_need_install_an_extension_to_allow_screen_sharing":"צריך להתקין הרחבה כדי לאפשר שיתוף מסך","You_need_to_change_your_password":"אתה צריך לשנות את הסיסמא שלך","You_need_to_type_in_your_password_in_order_to_do_this":"אתה צריך להקליד את הסיסמה שלך על מנת לעשות זאת!","You_need_to_type_in_your_username_in_order_to_do_this":"אתה צריך להקליד את שם המשתמש שלך כדי לעשות את זה!","You_need_to_verifiy_your_email_address_to_get_notications":"אתה צריך verifiy כתובת הדוא\"ל שלך כדי לקבל הודעות","You_should_name_it_to_easily_manage_your_integrations":"אתה צריך שם את זה כדי לנהל ואינטגרציות שלך בקלות.","You_will_not_be_able_to_recover":"לא תהיה לך אפשרות לשחזר את ההודעה הזו!","You_will_not_be_able_to_recover_file":"אתה לא תוכל לשחזר קובץ זה!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"לא תקבל הודעות דוא\"ל, כי אתה לא מאומת הדוא\"ל שלך.","Your_email_has_been_queued_for_sending":"הדוא\"ל שלך נוסף לתור לשליחה","Your_entry_has_been_deleted":"הרשומה שלך נמחקה","Your_file_has_been_deleted":"הקובץ שלך נמחק.","Your_mail_was_sent_to_s":"הדואר שלך נשלח אל %s","Your_Open_Source_solution":"הפתרון ","Your_password_is_wrong":"הסיסמה שלך היא לא בסדר!","Your_push_was_sent_to_s_devices":"הודעת ה-push נשלח בהצלחה ל-%s מכשירים"});
TAPi18n._registerServerTranslator("he", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/hr.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["hr"] = ["Croatian","Hrvatski"];                                                               // 8
if(_.isUndefined(TAPi18n.translations["hr"])) {                                                                        // 9
  TAPi18n.translations["hr"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["hr"][namespace])) {                                                             // 13
  TAPi18n.translations["hr"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["hr"][namespace], {"500":"Interna pogreška poslužitelja","0_Errors_Only":"0 - Pogreške Samo","1_Errors_and_Information":"1 - Pogreške i informacije","2_Erros_Information_and_Debug":"2 - erros, informacije i ispravak pogrešaka","__username__was_set__role__by__user_by_":"__korisničko ime__ bio postavljen __role__ strane __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__korisničko ime__ više nije __role__ po __user_by__","Access_not_authorized":"Pristup nije ovlašten","Access_online_demo":"Pristupi online demonstraciji","Access_Online_Demo":"Pristupi Online demonstraciji","Access_Token_URL":"URL Access Token","Accounts":"Računi","Accounts_AllowDeleteOwnAccount":"Dopusti korisnicima izbrisati svoj račun","Accounts_AllowedDomainsList":"Dopušteno Popis domena","Accounts_AllowedDomainsList_Description":"Odvojenih zarezom popis dopuštenih domena","Accounts_AllowEmailChange":"Dopusti e-mail promjene","Accounts_AllowPasswordChange":"Dopusti promjenu lozinke","Accounts_AllowUserAvatarChange":"Dopusti korisnika Change avatar","Accounts_AllowUsernameChange":"Dopusti promjenu korisničkog imena","Accounts_AllowUserProfileChange":"Dopusti Korisnik Promjena profila","Accounts_AvatarResize":"Promjeni veličinu Avatara","Accounts_AvatarSize":"Veličina Avatara","Accounts_AvatarStorePath":"Put Avatar Storage","Accounts_AvatarStoreType":"Avatar Tip Storage","Accounts_BlockedDomainsList":"Popis blokiranih domena","Accounts_BlockedDomainsList_Description":"Odvojenih zarezom popis blokiranih domena","Accounts_denyUnverifiedEmail":"Odbij neprovjereni e-mail","Accounts_EmailVerification":"E-mail Verifikacija","Accounts_EmailVerification_Description":"Provjerite imate li ispravne postavke SMTP bi koristili ovu mogućnost","Accounts_Enrollment_Email":"Upis E-mail","Accounts_Enrollment_Email_Description":"Možete koristiti [name], [fname], [lname] za korisnikovo ime i prezime, ime i prezime, odnosno. <br /> Možete koristiti [EMAIL] za e-poštu korisnika.","Accounts_Iframe_api_method":"API metoda","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"Omogućeno","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Prijava isteka na Danima","Accounts_ManuallyApproveNewUsers":"Ručno odobri nove korisnike","Accounts_OAuth_Custom_Token_Sent_Via":"Token poslani putem","Accounts_OAuth_Custom_Authorize_Path":"Autorizacija put","Accounts_OAuth_Custom_Button_Color":"Boja Gumba","Accounts_OAuth_Custom_Button_Label_Color":"Button Boja teksta","Accounts_OAuth_Custom_Button_Label_Text":"Tekst Gumba","Accounts_OAuth_Custom_Enable":"Omogući","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Put identiteta","Accounts_OAuth_Custom_Login_Style":"Prijava Style","Accounts_OAuth_Custom_Secret":"Tajno","Accounts_OAuth_Custom_Token_Path":"token Put","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook prijava","Accounts_OAuth_Facebook_callback_url":"URL povratnog poziva Facebook","Accounts_OAuth_Facebook_id":"ID aplikacije Facebook","Accounts_OAuth_Facebook_secret":"Facebook tajna","Accounts_OAuth_Github":"GitHub Prijava","Accounts_OAuth_Github_callback_url":"URL povratnog poziva Github","Accounts_OAuth_GitHub_Enterprise":"OAuth Omogućeno","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise povratnog poziva","Accounts_OAuth_GitHub_Enterprise_id":"Id klijenta","Accounts_OAuth_Github_id":"Id klijenta","Accounts_OAuth_Gitlab":"OAuth Omogućeno","Accounts_OAuth_Gitlab_callback_url":"URL povratnog poziva GitLab","Accounts_OAuth_Gitlab_id":"Id GitLab","Accounts_OAuth_Gitlab_secret":"Klijent tajna","Accounts_OAuth_Google":"Google Prijava","Accounts_OAuth_Google_callback_url":"Google URL povratnog poziva","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google Tajna","Accounts_OAuth_Linkedin":"LinkedIn Prijava","Accounts_OAuth_Linkedin_callback_url":"URL povratnog poziva Linkedin","Accounts_OAuth_Linkedin_id":"Id LinkedIn","Accounts_OAuth_Linkedin_secret":"LinkedIn tajna","Accounts_OAuth_Meteor":"Meteor Prijava","Accounts_OAuth_Meteor_callback_url":"URL povratnog poziva Meteor","Accounts_OAuth_Meteor_id":"Id Meteor","Accounts_OAuth_Meteor_secret":"Meteor tajna","Accounts_OAuth_Twitter":"Twitter Prijava","Accounts_OAuth_Twitter_callback_url":"URL povratnog poziva Twitter","Accounts_OAuth_Twitter_id":"Id Twitter","Accounts_OAuth_Twitter_secret":"Twitter Tajna","Accounts_OAuth_Wordpress":"WordPress Prijava","Accounts_OAuth_Wordpress_callback_url":"URL povratnog poziva Wordpress","Accounts_OAuth_Wordpress_id":"Id WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Tajna","Accounts_PasswordReset":"Resetiraj lozinku","Accounts_Registration_AuthenticationServices_Enabled":"Registracija s uslugama provjere autentičnosti","Accounts_RegistrationForm":"Upisnica","Accounts_RegistrationForm_Disabled":"onesposobljen","Accounts_RegistrationForm_LinkReplacementText":"Prijavnica Zamjena Link Text","Accounts_RegistrationForm_Public":"Javnost","Accounts_RegistrationForm_Secret_URL":"Tajna URL","Accounts_RegistrationForm_SecretURL":"Obrazac za registraciju Tajna URL","Accounts_RegistrationForm_SecretURL_Description":"Morate navesti slučajni niz koji će biti dodan u vašu registraciju URL. Primjer: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Potrebna je registracija","Accounts_RequireNameForSignUp":"Zahtijevaju ime za prijavu kojima","Accounts_ShowFormLogin":"Prikaži oblik-based Prijava","Accounts_UseDefaultBlockedDomainsList":"Koristi zadano blokiranih domena listu","Accounts_UseDNSDomainCheck":"Koristi provjeru DNS Domain","Activate":"Aktiviraj","Activity":"Aktivnost","Add":"Dodaj","Add_agent":"dodati sredstvo za","Add_custom_oauth":"Dodaj prilagođenu OAuth","Add_manager":"Dodaj upravitelja","Add_Members":"Dodaj Članove","Add_User":"Dodaj korisnika","Add_user":"Dodaj korisnika","Add_users":"Dodaj korisnike","Additional_emails":"Dodatni E-mailovi","Additional_Feedback":"dodatni komentar","Administration":"Administracija","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Nakon protokola OAuth2 autentifikacije, korisnici će biti preusmjeren na ovaj URL","Agent_added":"Agent je dodao","Agent_removed":"Agent uklonjen","Alias":"pseudonim","All":"svi","All_channels":"Svi kanali","All_logs":"Sve evidencije","All_messages":"Sve poruke","Allow_Invalid_SelfSigned_Certs":"Dopusti Pogrešna samopotpisan Certifikati","Allow_Invalid_SelfSigned_Certs_Description":"Dopusti nevažeće i samopotpisane SSL certifikata za vezu validaciju i pregledima.","and":"i","And_more":"I više __length __...","Animals_and_Nature":"Životinje i priroda","API":"API","API_Analytics":"Analitika","API_Embed":"Ugraditi","API_EmbedDisabledFor":"Onemogući Postavi za korisnike","API_EmbedDisabledFor_Description":"Odvojenih zarezom popis korisničkih imena","API_GitHub_Enterprise_URL":"GitHub Enterprise","API_GitHub_Enterprise_URL_Description":"Primjer: http://domain.com (isključujući kosu crticu na kraju)","API_Gitlab_URL":"GitLab link","API_Wordpress_URL":"WordPress link","Appearance":"Izgled","Application_added":"dodao Prijava","Application_Name":"Naziv aplikacije","Application_updated":"Primjena ažurirana","Apply_and_refresh_all_clients":"Primjena i osvježiti sve klijente","Archive":"Arhiva","Archive_Unarchive":"Arhiviraj / Dearhiviraj","are_also_typing":"isto tipkaju","are_typing":"tipkaju","Are_you_sure":"Jesi li siguran?","Are_you_sure_you_want_to_delete_your_account":"Jeste li sigurni da želite izbrisati svoj račun?","Authorization_URL":"URL za autorizaciju","Authorize":"Odobriti","AutoLinker_StripPrefix":"AutoLinker Strip Prefiks","AutoLinker_StripPrefix_Description":"Kratki prikaz. npr https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"Automatski vezan za brojeve telefona. npr: '(123) 456-7890`","Auto_Load_Images":"Automatski učitaj slike","Available":"Dostupno","Available_agents":"Dostupni agenti","Avatar":"Promijeni avatar","Avatar_changed_successfully":"Avatar je uspješno promijenjen","Avatar_URL":"URL Avatar","Avatar_url_invalid_or_error":"Navedeni URL nije valjan ili nije dostupan. Pokušajte ponovno, ali s različitim URL.","away":"odsutan","Away":"Odsutan","away_female":"odsutna","Away_female":"Odsutna","away_male":"odsutan","Away_male":"Odsutan","Back":"Natrag","Back_to_applications":"Povratak na aplikacije","Back_to_integrations":"Povratak na integracijama","Back_to_login":"Natrag na prijavu","Back_to_permissions":"Povratak na dozvole","Body":"Tijelo","bold":"podebljaj","busy":"zaposlen","Busy":"Zaposlen","busy_female":"zauzeta","Busy_female":"Zauzeta","busy_male":"zauzet","Busy_male":"Zauzet","Cancel":"Otkaži","Cannot_delete_a_protected_role":"Ne možete izbrisati zaštićenu ulogu","Cannot_delete_role_because_its_in_use":"Ne možete izbrisati ulogu jer je u upotrebi","Cannot_invite_users_to_direct_rooms":"Ne mogu pozvati korisnike da usmjeravaju sobe","CDN_PREFIX":"CDN Prefiks","Certificates_and_Keys":"Certifikati i ključevi","Channel":"Kanal","Channel_doesnt_exist":"Kanal `# %s` ne postoji.","Channels":"Kanali","Channels_list":"Lista javnih kanala","Chat_Rooms":"Chat Sobe","Chatops_Enabled":"Omogući Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Korisničko ime","Choose_a_room":"Odaberite sobu","Choose_messages":"Odaberite poruke","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Odaberite alias koji će se pojaviti pred korisničko ime u porukama.","Choose_the_username_that_this_integration_will_post_as":"Odaberite korisničko ime koje ta integracija će objaviti kao.","Clear_all_unreads_question":"Makni sve nepročitane?","Client_ID":"ID klijenta","Client_Secret":"Klijent tajna","Clients_will_refresh_in_a_few_seconds":"Klijenti će osvježiti u nekoliko sekundi","close":"zatvori","Closed":"Zatvoreno","Collapse_Embedded_Media_By_Default":"Sažmi ugrađenog medija prema zadanom","coming_soon":"dolazi uskoro","Commands":"Naredbe","Compact_View":"Kompaktni Pogledaj","Confirm_password":"Potvrdi svoju lozinku","Contact":"Kontakt","Conversation":"Razgovor","Convert_Ascii_Emojis":"Pretvori ASCII u Emoji","Copied":"Kopirano","COPY_TO_CLIPBOARD":"KOPIRATI U MEĐUSPREMNIK","Copy_to_clipboard":"Kopiraj u međuspremnik","Count":"Računati","Create":"Stvoriti","Create_new":"Stvori novi","Created_at":"Stvoreno u","Created_at_s_by_s":"Stvoren <strong>na %s</strong> <strong>od %s</strong>","Custom_Fields":"Custom Fields","Custom_oauth_helper":"Prilikom postavljanja OAuth Provider, morate obavijestiti URL povratnog poziva. Koristiti <pre> %s </pre> ,","Custom_oauth_unique_name":"Prilagođena OAutha jedinstveno ime","Custom_Script_Logged_In":"Prilagođena skripta za prijavljeni korisnici","Custom_Script_Logged_Out":"Prilagođena skripta za odjavljenih korisnika","Dashboard":"kontrolna ploča","days":"dana","Deactivate":"Isključi","Debug_Level":"Debug Razina","Default":"Zadano","Delete":"Obriši","Delete_my_account":"Izbriši moj račun","Delete_Room_Warning":"Brisanje sobe će obrisati sve poruke u toj sobi. Ovo se ne može poništiti.","Delete_User_Warning":"Brisanje korisnika će izbrisati i sve poruke od tog korisnika. Ovo se ne može poništiti.","Deleted":"Obrisano!","Department_not_found":"Odjel nije pronađen","Department_removed":"Odjel uklonjen","Departments":"Odjeli","Description":"Opis","Desktop":"Desktop","Desktop_Notification_Test":"Test Obavijest Desktop","Desktop_Notifications":"Desktop Obavijesti","Desktop_Notifications_Disabled":"Desktop Obavijesti su onemogućene. Promjena postavki preglednika, ako je potrebno omogućene Obavijesti.","Desktop_Notifications_Enabled":"Desktop Obavijesti su omogućene","Direct_message_someone":"Izravno je netko poruku","Direct_Messages":"Izravne Poruke","Direct_Messages_list":"izravne poruke","Disable_Favorite_Rooms":"Onemogući favorite","Disable_New_Message_Notification":"Onemogući obavijesti o novim porukama","Disable_New_Room_Notification":"Onemogući obavijesti o novim sobama","Displays_action_text":"Prikazuje akcija tekst","Do_you_want_to_change_to_s_question":"Želite li <strong>promijeniti %s?</strong>","Drop_to_upload_file":"Ispusti datoteku da se uploada.","Dry_run":"Suha trčanje","Dry_run_description":"Hoće li samo poslati jedan e-mail, na istoj adresi kao u Iz. E-mail mora pripadati valjanom korisniku.","Duplicate_archived_channel_name":"Arhivirana kanal s nazivom ' %s' ne postoji","Duplicate_archived_private_group_name":"Arhivirana Privatna grupa s nazivom ' %s' ne postoji","Duplicate_private_group_name":"Privatna Grupa s nazivom ' %s' postoji","E-mail":"E-mail","Edit":"Uredi","Edit_Custom_Field":"Edit Custom Field","Edit_Department":"Uredi Odjel","edited":"uređeno","Email":"E-mail","Email_already_exists":"Email već postoji","Email_body":"Tijelo E-mail","Email_Change_Disabled":"Vaš Rocket.Chat Administrator je onemogućio mijenjanje e-mail","Email_from":"Od","Email_Notification_Mode":"Offline Obavijesti e-pošte","Email_Notification_Mode_All":"Svako spominjanje / DM","Email_Notification_Mode_Disabled":"onesposobljen","Email_or_username":"Email or username","Email_subject":"subjekt","Email_verified":"Email provjeren","Emoji":"Emoji","Empty_title":"prazna naslova","Enable":"Omogućiti","Enable_Desktop_Notifications":"Omogući obavijesti na radnoj površini","Enabled":"Omogućeno","Encrypted_message":"šifrirana poruka","End_OTR":"Kraj SP","Enter_a_regex":"Unesite regex","Enter_a_room_name":"Unesite naziv sobe","Enter_a_username":"Unesite korisničko ime","Enter_info":"Unesi svoje informacije za prijavu","Enter_name_here":"Unesite ime ovdje","Enter_to":"Uđi u ","Error":"Pogreška","error-cant-invite-for-direct-room":"Ne može pozvati korisnika na neposrednim soba","error-duplicate-channel-name":"Kanal s nazivom ' %s' postoji","error-invalid-custom-field":"Nevažeći prilagođeni polje","error-invalid-custom-field-name":"Neispravan naziv prilagođeno polje. Koristite samo slova, brojeve, crtice i podvlake.","error-invalid-password":"Netočna zaporka","error-invalid-room":"Pogrešna soba","error-invalid-room-name":"<strong> %s</strong> nije valjan naziv boravak, <br/> koristiti samo slova, brojeve, crtice i podvlake","error-invalid-user":"Nevažeće korisničko","error-invalid-username":"Nevažeće korisničko ime","error-not-allowed":"Nije dozvoljeno","error-not-authorized":"Niste ovlašteni","error-remove-last-owner":"Ovo je posljednji vlasnik. Postavite novog vlasnika prije uklanjanja ovog.","error-role-name-required":"Naziv uloge potrebna je","error-user-not-in-room":"Korisnik nije u ovoj sobi","Error_changing_password":"Lozinka je izmijenjena","Error_sending_confirmation_email":"Pogreška prilikom slanja e-poštu potvrde","Error_too_many_requests":"Greška, previše zahtjeva. Molimo usporiti. Morate čekati %s sekundi prije ponovnog pokušaja","Esc_to":"Pobjegni iz","Example_s":"Primjer: <code class=\"inline\">%s</code>","False":"Ne","Favorites":"Omiljeni","Field":"Polje","Field_removed":"Područje uklonjen","File_exceeds_allowed_size_of_bytes":"Datoteka premašuje dopuštenu veličinu __size__ bajtova","FileUpload":"Prijenos datoteke","FileUpload_Enabled":"File Prijenosi Omogućeno","FileUpload_File_Empty":"File prazna","FileUpload_FileSystemPath":"Put sustav","FileUpload_MaxFileSize":"Maksimalna File Upload Veličina (u bajtovima)","FileUpload_MediaType_NotAccepted":"Vrste medija nije prihvaćen","FileUpload_MediaTypeWhiteList":"Prihvaćeni Vrste medija","FileUpload_MediaTypeWhiteListDescription":"Odvojenih zarezom popis vrsta medija. Ostavite prazno za prihvat svih vrsta medija.","FileUpload_ProtectFiles":"Zaštitite uploadane datoteke","FileUpload_ProtectFilesDescription":"Samo autoriziranim korisnicima će imati pristup","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 ime kanta","FileUpload_S3_BucketURL":"URL Bucket","FileUpload_S3_CDN":"CDN domena za download","FileUpload_S3_Region":"Regija","FileUpload_Storage_Type":"Tip Storage","Flags":"zastavice","Follow_social_profiles":"Slijedi naše socijalne profile, forkaj chat na githubu i podijeli svoje misli o rocket.chat aplikaciji na našoj trello ploči.","Food_and_Drink":"Hrana i piće","For_your_security_you_must_re_enter_your_password_to_continue":"Zbog svoje sigurnosti, morate ponovno unijeti svoju lozinku za nastavak","Force_SSL":"Force SSL","Force_SSL_Description":"* Oprez! * _Force SSL_ nikada ne treba koristiti s obrnutim proxy. Ako imate obrnuti proxy, što bi trebalo učiniti preusmjeravanje tamo. Ova opcija postoji za implementaciju kao Heroku, koja ne dopušta konfiguraciju za preusmjeravanje na naličju proxy.","Forgot_password":"Zaboravih lozinku","Fork_it_on_github":"Forkaj na githubu","Frequently_Used":"Često se koristi","From":"Od","From_Email":"Sa e-maila","From_email_is_required":"Od potreban e-mail","From_email_warning":"<b>Upozorenje:</b> Polje <b>Od</b> podliježe postavke poslužitelja e-pošte.","General":"General","Get_to_know_the_team":"Upoznajte Rocket.Team","github_no_public_email":"Nemaš ni1 javni email u svom GitHub računu","Give_a_unique_name_for_the_custom_oauth":"Dati jedinstveno ime za prilagođeni OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Dajte primjeni ime. To će se vidjeti od strane svojih korisnika.","Global":"Globalno","GoogleTagManager_id":"Id Google upravitelj oznaka","Has_more":"Ima više","Have_your_own_chat":"Imaj svoj vlastiti web chat. Razvijen sa Meteor.com, Rocket.Chat je sjajno rješenje za developere koji žele sagraditi i dalje razvijati svoju vlastitu chat platformu.","Header":"Zaglavlje","Hidden":"Skriven","Hide_Group_Warning":"Jeste li sigurni da želite sakriti grupu \" %s\"?","Hide_Private_Warning":"Jeste li sigurni da želite sakriti raspravu s \" %s\"?","Hide_room":"Sakrij sobu","Hide_Room_Warning":"Jeste li sigurni da želite sakriti u sobu \" %s\"?","Highlights":"pramenovi","Highlights_How_To":"Biti obaviješteni kada netko spomene riječ ili izraz, dodati ga ovdje. Možete odvojiti riječi ili fraze zarezima. Isticanje riječi nisu velika i mala slova.","Highlights_List":"Označite riječi","History":"Povijest","hours":"sati","How_friendly_was_the_chat_agent":"Kako friendly bio chat agent?","How_knowledgeable_was_the_chat_agent":"Kako obrazovan bio chat agent?","How_responsive_was_the_chat_agent":"Kako reagiraju bio chat agent?","How_satisfied_were_you_with_this_chat":"Koliko ste zadovoljni ovom chatu?","If_you_are_sure_type_in_your_password":"Ako ste sigurni upišite svoju lozinku:","If_you_are_sure_type_in_your_username":"Ako ste sigurni da tip u svoje korisničko ime:","Importer_Archived":"Arhivirano","Importer_done":"Uvoz dovršen!","Importer_finishing":"Završavanje uvoz.","Importer_From_Description":"Uvoz __from __ 's podataka u Rocket.Chat.","Importer_import_cancelled":"Uvoz otkazan.","Importer_import_failed":"Došlo je do pogreške pri izvršavanju uvoz.","Importer_importing_channels":"Prebacivanje kanala.","Importer_importing_messages":"Uvoz poruka.","Importer_importing_started":"Pokretanje uvoz.","Importer_importing_users":"Uvoz korisnicima.","Importer_not_defined_properly":"Uvoznik nije ispravno definirani, to je nestalo Import klase.","Importer_not_in_progress":"Uvoznik trenutno ne radi.","Importer_Prepare_Restart_Import":"Restart uvoz","Importer_Prepare_Start_Import":"Započnite uvoz","Importer_Prepare_Uncheck_Archived_Channels":"Poništite okvir Arhivirani kanali","Importer_Prepare_Uncheck_Deleted_Users":"Isključite ovo Izbrisano korisnika","Importer_progress_error":"Nije uspio dobiti napredak za uvoz.","Importer_setup_error":"Došlo je do pogreške pri postavljanju uvoznika.","Incorrect_Password":"Netočna lozinka","inline_code":"jednolinijski kôd","Install_Extension":"Instalirajte proširenje","Install_FxOs":"Instalirajte Rocket.Chat na svoj Firefox","Install_FxOs_done":"Izvrsno! Sada možete koristiti Rocket.Chat putem ikona na početnom zaslonu. Zabavite se s Rocket.Chat!","Install_FxOs_error":"Nažalost, to nije uspjelo onako kako smo zamislili! Pojavila se sljedeća greška:","Install_FxOs_follow_instructions":"Molimo Vas da potvrdite instalaciju aplikacija na uređaju (pritisnite \"Install\" kada se to zatraži).","Installation":"Instalacija","Integration_added":"Integracija je dodana","Integration_Incoming_WebHook":"Dolazni WebHook integracija","Integration_New":"Novi integracija","Integration_Outgoing_WebHook":"Odlazni WebHook integracija","Integration_updated":"Integracija je ažuriran","Integrations":"integracije","Invalid_asset":"Pogrešna imovine","Invalid_confirm_pass":"Potvrda lozinke se ne slaže sa lozinkom","Invalid_email":"Uneseni e-mail nije valjan","Invalid_Export_File":"Prenesena datoteka nije valjana %s datoteke za izvoz.","Invalid_file_height":"Visina nije valjana datoteka","Invalid_file_type":"Pogrešna vrsta datoteke","Invalid_file_width":"Pogrešna širina datoteka","Invalid_Import_File_Type":"Pogrešna vrsta Uvoz datoteke.","Invalid_name":"Ime ne smije biti prazno","Invalid_notification_setting_s":"Pogrešna postavka Obavijest: %s","Invalid_pass":"Lozinka ne smije biti prazna","Invalid_room_name":"<strong>%s</strong> nije valjano ime sobe,<br/> koristi samo slova, brojeve i crtice","Invalid_room_type":"<strong> %s</strong> nije valjani tip sobe.","Invalid_Secret_URL":"Pogrešna Tajna URL","Invalid_secret_URL_message":"Navedeni URL nije valjan.","invisible":"nevidljiv","Invisible":"Nevidljiv","Invitation_HTML":"Poziv HTML","Invitation_Subject":"Poziv Predmet","Invite_user_to_join_channel":"Pozovi jednog korisnika da se pridruži ovom kanalu","Invite_Users":"Pozovite korisnike","is_also_typing":"isto tipka","is_also_typing_female":"isto tipka","is_also_typing_male":"isto tipka","is_typing":"tipka","is_typing_female":"piše","is_typing_male":"piše","italics":"ukosi","join":"Pridruži se","Join_audio_call":"Pridružite audiopoziv","Join_the_Community":"Pridruži se zajednici","Join_the_given_channel":"Pridružite se na određeni kanal","Join_video_call":"Pridružite videopoziva","Joined":"Član od","Jump":"Skok","Jump_to_first_unread":"Jump to first nepročitano","Jump_to_message":"Skoči na poruku","Jump_to_recent_messages":"Skoči na nedavne poruke","Katex_Enabled":"Katex Omogućeno","Label":"Označiti","Language":"Jezik","Language_Version":"Engleska Verzija","Last_login":"Zadnja prijava","Last_message":"Posljednja poruka","Last_seen":"Zadnje viđeno","Layout":"raspored","Layout_Home_Body":"Početna tijelo","Layout_Home_Title":"Početna Naslov","Layout_Login_Terms":"Uvjeti Prijava","Layout_Privacy_Policy":"Izjava o privatnosti","Layout_Sidenav_Footer":"Strana Navigation Footer","Layout_Sidenav_Footer_description":"Veličina footera je 260x70","Layout_Terms_of_Service":"Uvjeti pružanja usluge","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Traži Custom Domain","LDAP_Custom_Domain_Search_Description":"Komad JSON koje upravlja vezati i veze info i ima oblik: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"zadana domene","LDAP_Description":"LDAP je hijerarhijska baza podataka koja mnoge tvrtke koriste za pružanje jedan znak na - postrojenje za dijeljenje jednu lozinku između više web-mjesta i usluga. Za napredne Podatke o konfiguraciji i primjere, obratite se našem wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Baza domena","LDAP_Domain_Base_Description":"Potpuno kvalificirana Distinguished Name (DN) u LDAP podstablo koje želite pretražiti za korisnike i grupe. Možete dodati koliko god želite; Međutim, svaka grupa mora biti definirana u istoj bazi domeni kao korisnici koji pripadaju njemu. Ako navedete ograničene grupe korisnika, samo korisnici koji pripadaju tim skupinama će biti u opsegu. Preporučujemo da odredite gornju razinu svoje LDAP direktorija stablo kao svoju bazu domene i korištenje filtra za pretraživanje za kontrolu pristupa.","LDAP_Domain_Search_Filter":"Domena Search Filter","LDAP_Domain_Search_Filter_Description":"Ako je naveden, samo korisnici koji odgovaraju filtar će biti dopušteno da se prijavite. Ako nijedan filtar nije navedeno, svi korisnici u okviru zadanog baze domene moći će se prijaviti. <br/> Npr za Active Directory `memberOf = CN = ROCKET_CHAT, ou = Općenito Groups`. <br/> Npr za OpenLDAP (proširiva utakmici pretraživanje) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domena traži objekt Kategorija","LDAP_Domain_Search_Object_Category_Description":"Znak * objectCategory * da identificiraju svoje korisnike. <br/> Ostavite prazno za * OpenLDAP *. <br/> Npr `person` itd","LDAP_Domain_Search_Object_Class":"Domena Klasa traži objekt","LDAP_Domain_Search_Object_Class_Description":"Znak * klasa objekta * da identificiraju svoje korisnike. <br/> Npr `organizationalPerson` 'user`' inetOrgPerson` itd","LDAP_Domain_Search_Password":"Domena Search Lozinka","LDAP_Domain_Search_Password_Description":"Lozinka za korisnika za pretraživanje domene.","LDAP_Domain_Search_User":"Domain Traži korisnike","LDAP_Domain_Search_User_Description":"LDAP korisnički koja obavlja korisničke dohvate za autentifikaciju drugih korisnika prilikom prijave. <br/> To je obično račun za uslugu izrađen posebno za treće strane integracijama. Koristite potpuno kvalificirani naziv, kao što je `cn = Administrator, Cn = korisnicima, dc = primjer, DC = com`.","LDAP_Domain_Search_User_ID":"Domena Search ID korisnika","LDAP_Domain_Search_User_ID_Description":"LDAP atribut koji identificira LDAP korisnika koji pokušava provjeru autentičnosti. Ovo polje mora biti `sAMAccountName` za većinu Active Directory instalacija, ali to može biti` uid` za druge LDAP rješenjima, kao što su OpenLDAP. Možete koristiti `mail` identificiraju korisnike putem e-maila ili bilo atribut želite. <br> Možete koristiti više vrijednosti odvojene zarezom kako bi se omogućilo korisnicima da se prijavite koristeći višestruke identifikatore kao što su korisničko ime ili e-mail.","LDAP_Enable":"Omogućiti","LDAP_Enable_Description":"Pokušaj koristiti LDAP za provjeru autentičnosti.","LDAP_Encryption":"Šifriranje","LDAP_Encryption_Description":"Način šifriranja koristi za sigurnu komunikaciju s LDAP poslužiteljem. Primjeri uključuju `plain` (bez enkripcije),` SSL / LDAPS` (šifriranu od početka), i `StartTLS` (nadogradite na šifrirani komunikacije nekad povezano).","LDAP_Host":"Domaćin","LDAP_Host_Description":"LDAP domaćin, npr `ldap.example.com` ili` 10.0.0.30`.","LDAP_Port":"Luka","LDAP_Port_Description":"Port za pristup LDAP. npr: `389` ili` 636` za LDAPS","LDAP_Reject_Unauthorized":"Odbaci Neovlašteno","LDAP_Sync_User_Avatar":"Sinkronizacija User Avatar","LDAP_Sync_User_Data":"Sinkronizacija podataka","LDAP_Sync_User_Data_Description":"Imajte korisničkih podataka u sync sa servera na prijavu (npr: ime i prezime, e-mail).","LDAP_Sync_User_Data_FieldMap":"Korisnički podaci Polje Karta","LDAP_Sync_User_Data_FieldMap_Description":"Konfiguriranje načina polja korisničkih računa (kao što su e-mail) su naseljeni iz zapisa u LDAP (jednom našao). <br/> Kao primjer, `{\" cn \":\" Ime \",\" mail \":\" e \"}` odabrat će osobe ljudskih čitljiv ime iz cn atribut, a njihove e-mail iz mail atributa. <br/> Dostupna polja su `name` i` email`.","LDAP_Sync_Users":"Sinkronizacija korisnika","LDAP_Test_Connection":"Test Connection","LDAP_Unique_Identifier_Field":"Jedinstveni identifikator polja","LDAP_Unique_Identifier_Field_Description":"Koji polje će se koristiti za povezivanje LDAP korisnika i korisnika Rocket.Chat. Možete obavijestiti višestruke vrijednosti odvojene zarezom pokušati dobiti vrijednost iz LDAP rekord. <br/> Zadana vrijednost je `objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Koristite Search Custom Domain","LDAP_Use_Custom_Domain_Search_Description":"Napišite vlastiti filtar za pretraživanje korisnika u LDAP poslužitelju.","LDAP_Username_Field":"Korisničko ime polje","LDAP_Username_Field_Description":"Koji polje će se koristiti kao * korisničko ime * za nove korisnike. Ostavite prazno za korištenje korisničko ime informirani na naslovnici. <br/> Možete koristiti predložak oznake previše, poput '# {GivenName}. # {Sn} `. <br/> Zadana vrijednost je `sAMAccountName`.","Leave_Group_Warning":"Jeste li sigurni da želite napustiti grupu \" %s\"?","Leave_Private_Warning":"Jeste li sigurni da želite napustiti razgovor s \" %s\"?","Leave_room":"Izađi iz sobe","Leave_Room_Warning":"Jeste li sigurni da želite izaći iz sobe \" %s\"?","line":"linija","List_of_Direct_Messages":"Popis izravne poruke","Live_sessions":"sjednice uživo","Livechat_agents":"LiveChat agenti","Livechat_Dashboard":"LiveChat ploča","Livechat_enabled":"LiveChat omogućeno","Livechat_Manager":"LiveChat Manager","Livechat_managers":"menadžeri LiveChat","Livechat_title":"LiveChat Naslov","Livechat_title_color":"LiveChat Naslov Boja pozadine","Livechat_Users":"LiveChat korisnika","Load_more":"Učitaj više","Loading...":"Učitavanje ...","Loading_more_from_history":"Učitavanje više iz povijesti","Loading_suggestion":"Učitavam sugestije...","Localization":"lokalizacija","Log_File":"Prikaži datoteka i Line","Log_Level":"Prijava na razini","Log_Package":"Show Package","Log_View_Limit":"Prijava View Granica","Logged_out_of_other_clients_successfully":"Evidentirano iz drugih klijenata uspješno","Login":"Prijava","Login_with":"Prijavi se sa %s","login_with":"Ili se prijavi izravno sa","Logout":"Odjava","Logout_Others":"Odjava iz drugih prijavljeni lokacijama","Mail_Message_Invalid_emails":"Ti su dali jedan ili više nevažećih e-pošte: %s","Mail_Message_Missing_to":"Morate odabrati jednu ili više korisnika ili dati jednu ili više adresa e-pošte, odvojene zarezima.","Mail_Message_No_messages_selected_select_all":"Niste odabrali nikakve poruke. Želite li <a href='#' class='select-all'>odabrati sve</a> vidljive poruke?","Mail_Messages":"pošte","Mail_Messages_Instructions":"Odaberite koje poruke želite poslati putem e-maila klikom poruke","Mail_Messages_Subject":"Evo odabrani dio %s porukama","Mailer":"Mailer","Mailer_body_tags":"<b>Morate</b> koristiti [odjaviti] za otkazivanje pretplate link. <br /> Možete koristiti [name], [fname], [lname] za korisnikovo ime i prezime, ime i prezime, odnosno. <br /> Možete koristiti [EMAIL] za e-poštu korisnika.","Make_Admin":"Učini Administratorom","Manager_added":"dodao Manager","Manager_removed":"Manager uklonjen","Mark_as_read":"Označi kao pročitano","Markdown_Headers":"smanjenje zaglavlja","Markdown_SupportSchemesForLink":"Smanjenje potpore za link","Markdown_SupportSchemesForLink_Description":"Odvojenih zarezom popis dopuštenih programa","Members_List":"Lista Članova","Mentions":"spomene","Mentions_default":"Spominje (zadano)","Message":"Poruka","Message_AllowDeleting":"Dopusti Brisanje Poruka","Message_AllowEditing":"Dopusti Uređivanje Poruka","Message_AllowEditing_BlockEditInMinutes":"Blokirajte uređivanje poruka nakon (u minutama - 0 kako bi onemogučili)","Message_AllowEditing_BlockEditInMinutesDescription":"Ulaz 0 onemogućiti blokadu.","Message_AllowPinning":"Dopusti pribadanje poruka ","Message_AllowPinning_Description":"Dopusti poruke biti zabodena na bilo koji od kanala.","Message_AllowStarring":"Dopusti poruke Glumi","Message_AudioRecorderEnabled":"Audio Recorder Omogućeno","Message_AudioRecorderEnabledDescription":"Zahtijeva 'audio / WAV \"datoteke biti prihvaćena vrsta medija u\" File Upload' postavkama.","Message_DateFormat":"Format datuma","Message_DateFormat_Description":"Vidi također: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Brisanje poruka nije dopušteno","Message_editing_blocked":"Ova poruka se više ne može uređivati ","Message_editing_not_allowed":"Uređivanje poruka nije dopušteno","Message_GroupingPeriod":"Grupiranje razdoblju (u sekundama)","Message_GroupingPeriodDescription":"Poruke će biti grupirani u prethodnoj poruci ako su oba od istog korisnika, a proteklo vrijeme bio manji od informiranog puta u sekundi.","Message_KeepHistory":"Zadrži Povijest Poruka","Message_MaxAllowedSize":"Maksimalna dopuštena veličina poruke","Message_MaxAll":"Maximális csatorna mérete ALL üzenet","Message_pinned":"Poruka je pribodena","Message_pinning_not_allowed":"Pribadanje poruka nije dopušteno","Message_removed":"Poruka je maknuta","Message_ShowDeletedStatus":"Pokaži Izbrisan status","Message_ShowEditedStatus":"Prikaži uređeni status","Message_ShowFormattingTips":"Prikaži Savjeti za oblikovanje","Message_TimeFormat":"Format vremena","Message_TimeFormat_Description":"Vidi također: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Poruka je predugačka","Messages":"Poruke","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Poruke koje se šalju na dolazeći WebHook će biti objavljena ovdje.","Meta":"Meta","Meta_fb_app_id":"Facebook App-ID","Meta_google-site-verification":"Provjera Google Site","Meta_language":"Jezik","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Roboti","minutes":"minuta","Mobile_push":"Mobilni guranje","More_channels":"Više kanala","More_direct_messages":"Više izravnih poruka","More_groups":"Više privatnih grupa","More_unreads":"Više nepročitanih","Msgs":"Poruke","multi":"više","Mute_someone_in_room":"Mute je netko u sobi","Mute_user":"Isključivanje korisnika","Muted":"Prigušen","My_Account":"Moj Račun","n_messages":"%s poruka","N_new_messages":" %s novih poruka","Name":"Ime","Name_cant_be_empty":"Ime ne može biti prazno","Name_of_agent":"Naziv agenta","Name_optional":"Ime (obavezno)","Navigation_History_20_last_pages":"Navigacija Povijest (20 posljednjih stranica)","New_Application":"Nova aplikacija","New_Custom_Field":"Novo prilagođeno polje","New_Department":"Novi odjel","New_integration":"Novi integracija","New_logs":"Novi dnevnici","New_messages":"Nove Poruke","New_password":"Nova lozinka","New_role":"Nova uloga","No_channel_with_name_%s_was_found":"Kanal s tim imenom nije nađen","No_channels_yet":"Još nisi dio nijednog kanala.","No_direct_messages_yet":"Još nisi započeo ni1 razgovor.","No_Encryption":"Ne Encryption","No_favorites_yet":"Još nisi dodao omiljene.","No_group_with_name_%s_was_found":"Privatna grupa s tim imenom nije nađena","No_groups_yet":"Još nemaš privatnih grupa.","No_livechats":"Nemate livechats.","No_mentions_found":"Ne spominje pronađeno","No_permission_to_view_room":"Nemaš dopuštenje da vidiš ovu sobu","No_pinned_messages":"Nema zabodena poruka","No_results_found":"Rezultati nisu nađeni","No_starred_messages":"Nema poruka sa zvjezdicom","no_tokens_for_this_user":"Nema tokena za ovog korisnika","No_user_with_username_%s_was_found":"Korisnik sa korisničkim imenom <strong>\"%s\"</strong> nije nađen!","Not_allowed":"Nije dozvoljeno","Not_authorized":"Niste ovlašteni","Not_Available":"Nije dostupno","Not_found_or_not_allowed":"Nije Nađeno ili Nije Dozvoljeno","Nothing":"Ništa","Nothing_found":"Ništa nije nađeno","Notifications":"Obavijesti","Notify_all_in_this_room":"Obavijesti sve u ovoj sobi","Num_Agents":"# agenti","Number_of_messages":"Broj poruka","OAuth_Application":"OAuth Primjena","OAuth_Applications":"OAuth Aplikacije","Objects":"objekti","Off_the_record_conversation":"Off-the-zabilježenih razgovora","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record razgovor nije dostupno za vaš preglednik ili uređaj.","Offline_DM_Email":"[__site__] Vi ste bili izravni messaged strane __user__","Offline_Mention_Email":"[__site__] Dobili ste spomenuli __user__ u #__room__","Old_and_new_password_must_be_different":"Nova lozinka mora biti različita od stare lozinke.","Old_and_new_password_required":"Morate pružiti i staru i novu lozinku za promjenu lozinke.","Online":"Online","Only_errors":"samo pogreške","Only_you_can_see_this_message":"Samo ti možeš vidjeti ovu poruku","Oops!":"Ups","Open":"Otvoren","Opened":"Otvoreno","Opt_out_statistics":"Ne šalji moje anonimne statistike Rocket.Chatu","Opt_out_statistics_warning":"Slanjem statistiku, da ćete nam pomoći identificirati kako mnogi slučajevi Rocket.Chat su razmještene, kao i koliko je dobar sustav se ponaša, tako da i dalje mogu poboljšati. Ne brinite, jer nema informacija korisniku se šalje i sve informacije primamo se drži u tajnosti. Ako želite nastaviti slati nam svoje statistike, isključite iznad okvira. Hvala ti.","optional":"neobavezan","Order":"Narudžba","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Točka","OS_Freemem":"OS Slobodna Memorija","OS_Loadavg":"OS Prosječno opterećenje","OS_Platform":"OS platforma","OS_Release":"OS Izdanje","OS_Totalmem":"OS Ukupno memorije","OS_Type":"Vrsta OS-a","OS_Uptime":"OS Uptime","others":"drugi","OTR":"SP","OTR_is_only_available_when_both_users_are_online":"OTR je dostupna samo ako oba korisnika je online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Odbaci URL na koji su postavljene datoteke. Ovaj url također se koristi za preuzimanje, osim ako CDN je dano","Password":"Lozinka","Password_Change_Disabled":"Vaš Rocket.Chat Administrator je onemogućio izmjenu lozinke","Password_changed_successfully":"Lozinka je uspješno promijenjena","Payload":"korisna nosivost","People":"Ljudi","Permissions":"Dopuštenja","Pin_Message":"Pin Poruka","Pinned_a_message":"Zabodena poruku:","Pinned_Messages":"Prikvačene Poruke","Placeholder_for_email_or_username_login_field":"Rezervirano za e-mail ili korisničko ime za prijavu polju","Placeholder_for_password_login_field":"Rezervirano za polje zaporke za prijavu","Please_answer_survey":"Odvojite trenutak kako bi odgovorili na anketu o ovom chatu","Please_enter_value_for_url":"Molimo unesite vrijednost za URL Vaše avatar.","Please_enter_your_new_password_below":"Molimo unesite novu lozinku u nastavku:","Please_fill_a_label":"Molimo Vas da ispunite oznaku","Please_fill_a_name":"Molimo ispunite ime","Please_fill_a_username":"Molimo Vas da ispunite korisničko ime","Please_fill_name_and_email":"Molimo Vas da ispunite ime i e-mail","Please_re_enter_your_password":"Ponovno unesite zaporku","Please_select_enabled_yes_or_no":"Odaberite opciju za Omogućeno","Please_wait":"Pričekaj","Please_wait_activation":"Molimo pričekajte, ovo bi moglo potrajati neko vrijeme.","Please_wait_statistics":"Molimo pričekajte, statistike se generiraju.","Please_wait_while_OTR_is_being_established":"Molimo pričekajte dok se uspostavlja SP","Please_wait_while_your_account_is_being_deleted":"Molimo pričekajte dok se vaš račun biti izbrisan ...","Please_wait_while_your_profile_is_being_saved":"Pričekajte dok vam je profil koji se spremaju ...","Post_as":"Pošalji kao","Post_to_Channel":"Post na kanalu","Post_to_s_as_s":"Objavi <strong>na %s</strong> <strong>kao %s</strong>","Powered_by":"Powered by","Preferences":"Postavke","Preferences_saved":"Postavke sačuvane","Privacy":"Privatnost","Private_Group":"Privatna Grupa","Private_Groups":"Privatne Grupe","Private_Groups_list":"Lista privatnih grupa","Profile":"Profil","Profile_saved_successfully":"Profil je uspješno sačuvan","Proudly_developed":"Proudly developed by Meteor","Push":"Gurnuti","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Ključ","Push_apn_dev_passphrase":"APN Dev zaporka","Push_apn_key":"APN Ključ","Push_apn_passphrase":"APN zaporka","Push_debug":"otkloniti neispravnost","push_disabled":"Push onemogućeni","Push_enable":"Omogući","Push_enable_gateway":"Omogući Gateway","Push_gateway":"prolaz","Push_gcm_api_key":"GCM API ključ","Push_gcm_project_number":"GCM Broj projekta","Push_production":"Produkcija","Push_show_message":"Prikaži poruke u obavijesti","Push_show_username_room":"Prikaži kanala / grupa / korisničko ime na obavijesti","Push_test_push":"Test","Query":"pitanje","Query_description":"Dodatni uvjeti za određivanje koji korisnici poslati e-mail. Otkazane korisnik se automatski uklanjaju iz upita. To mora biti valjana JSON. Primjer: \"{\" createdAt \": {\" $ gt \": {\" Datum $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Brza Pretraga","quote":"c","Reactions":"reakcije","Recents":"Nedavni","Record":"Snimaj","Redirect_URI":"Preusmjeravanje URI","Refresh_keys":"Osvježi ključevi","Refresh_your_page_after_install_to_enable_screen_sharing":"Osvježi stranicu nakon instalacije kako bi se omogućilo dijeljenje zaslona","Register":"Registriraj novi račun","Registration_Succeeded":"Registracija je uspjela ","Remember_me":"Zapamti me","Remove":"Makni","Remove_Admin":"Makni Administratora","Remove_as_moderator":"Uklonite što moderator","Remove_as_owner":"Uklonite kao vlasnik","Remove_custom_oauth":"Ukloni prilagođenu OAuth","Remove_from_room":"Uklonite iz sobe","Remove_someone_from_room":"Uklonite nekoga iz sobe","Removed":"Uklonjeno","Require_password_change":"Zahtijevaju promjenu lozinke","Resend_verification_email":"Ponovno pošalji e-mail potvrdu","Reset":"Reset","Reset_password":"Resetiraj lozinku","Restart":"Restart","Restart_the_server":"Ponovno pokretanje poslužitelj","RocketBot_Enabled":"RocketBot Omogućeno","RocketBot_Name":"Naziv RocketBot","RocketBot_Name_Description":"Naziv RocketBot mora biti valjano korisničko ime registriran na poslužitelju.","Role":"Uloga","Role_Editing":"Uloga Uređivanje","Role_removed":"Uloga uklonjen","Room":"Soba","Room_archivation_state":"država","Room_archivation_state_false":"Aktivan","Room_archivation_state_true":"Arhivirano","Room_archived":"Soba je arhivirana","room_changed_privacy":"Tip sobe mijenja u: <em>__room_type__</em> po <em>__user_by__</em>","room_changed_topic":"Soba tema mijenja u: <em>__room_topic__</em> po <em>__user_by__</em>","Room_has_been_deleted":"Soba je obrisana","Room_Info":"Soba Info","Room_name_changed":"Ime sobe promijenjeno u: <em>__room_name__</em> od <em>__user_by__</em>","Room_name_changed_successfully":"Ime sobe je uspješno izmijenjeno","Room_not_found":"Soba nije nađena","Room_topic_changed_successfully":"Soba tema je uspješno promijenjena","Room_type_changed_successfully":"Vrsta sobe je uspješno promijenjena","Room_unarchived":"Soba Dearhivirano","Room_uploaded_file_list":"Popis datoteka","Room_uploaded_file_list_empty":"Nijedna datoteka nije dostupna","room_user_count":"% korisnika","Rooms":"Sobe","S_new_messages_since_s":"novih poruka od","SAML":"SAML","SAML_Custom_Cert":"Prilagođeni Certifikat","SAML_Custom_Entry_point":"Prilagođena ulazna točka","SAML_Custom_Generate_Username":"Izradi korisničko ime","SAML_Custom_Issuer":"Prilagođena Izdavatelj","SAML_Custom_Provider":"Prilagođena Provider","Save":"Sačuvaj","Save_changes":"Spremi promjene","Save_Mobile_Bandwidth":"Spremi Mobile Bandwidth","Save_to_enable_this_action":"Spremi da biste omogućili ovu akciju","Saved":"Spremljeno","Saving":"Spremanje","Scope":"djelokrug","Screen_Share":"Zaslon Podijeli","Script_Enabled":"Skripta Omogućeno","Search":"Traži","Search_by_username":"Pretraživanje po korisničkom imenu","Search_Channels":"Pretraga kanali","Search_Direct_Messages":"Traži izravne poruke","Search_Messages":"Pretraži poruke","Search_Private_Groups":"Traži privatne grupe","Search_settings":"Postavke pretraživanja","seconds":"se","See_all":"Vidi sve","See_only_online":"Samo online","Select_a_department":"Odaberite odjel","Select_an_avatar":"Odaberi avatar","Select_file":"Odaberi fajl","Select_service_to_login":"Odaberi servis kako bi se prijavio/la da učitaš svoju sliku ili ju uploadaj izravno sa svog računala","Select_user":"Odaberite korisnika","Select_users":"Odabir korisnika","Selected_agents":"Odabrana sredstva","Selected_users":"Odabrani članovi","Send":"Pošalji","Send_a_message":"Pošalji Poruku","Send_a_test_mail_to_my_user":"Pošaljite probnu mail na moju korisnika","Send_a_test_push_to_my_user":"Pošaljite probnu gurati u moju korisnika","Send_confirmation_email":"Pošalji potvrdni email","Send_data_into_RocketChat_in_realtime":"Slanje podataka u Rocket.Chat u realnom vremenu.","Send_email":"Pošalji e-mail","Send_invitation_email":"Pošaljite e-mail pozivnicu.","Send_invitation_email_error":"Niste upisali nijednu valjanu e-mail adresu.","Send_invitation_email_info":"Možete poslati više e-mail pozivnica odjednom.","Send_invitation_email_success":"Uspješno ste poslali e-mail pozivnicu na sljedeće adrese:","Send_invitation_email_warning":"Da bi poslali e-poruke pozivnica, najprije morate konfigurirati SMTP postavke.","Send_Message":"Pošalji Poruku","Send_your_JSON_payloads_to_this_URL":"Pošaljite svoje JSON nosivosti na taj URL.","Sending":"Slanje ...","Set_as_moderator":"Postavi kao moderator","Set_as_owner":"Postavi kao vlasnik","Settings":"Postavke","Settings_updated":"Postavke su ažurirane","Should_be_a_URL_of_an_image":"Treba biti URL slike.","Should_exists_a_user_with_this_username":"Korisnik mora već postojati.","Show_all":"Pokaži sve","Show_more":"Prikaži više","Show_only_online":"Prikaži samo online","Show_preregistration_form":"Prikaži obrazac za pre-registraciju","Showing_archived_results":"<p> <b>Prikazivanje %s</b> arhivirane rezultate </p>","Showing_online_users":"Prikazujem <b>__total_showing__</b> od __total__ korisnika","Showing_results":"<p>Prikazujem <b>%s</b> rezultata</p>","Silence":"Tišina","since_creation":"%s","Site_Name":"Ime Stranice:","Site_Url":"Link web stranice","Site_Url_Description":"Primjer: https://chat.domain.com/","Skip":"Preskočiti","Smileys_and_People":"Smajlići & ljudi","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP lozinka","SMTP_Port":"SMTP port","SMTP_Test_Button":"Test SMTP postavke","SMTP_Username":"SMTP korisničko ime","Sound":"Zvuk","Star_Message":"Star Poruka","Starred_Messages":"Poruke sa zvjezdicom","Start_audio_call":"Početak audiopoziv","Start_Chat":"Početak Chat","Start_of_conversation":"Početak razgovora","Start_OTR":"Početak SP","Start_video_call":"Započni videopoziv","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Počnite s <code class=\"inline\">%s</code> za korisnika ili <code class=\"inline\">%s</code> za kanal. Npr: <code class=\"inline\">%s</code> ili <code class=\"inline\">%s</code>","Statistics":"Statistike","Stats_Active_Users":"Aktivni korisnici","Stats_Avg_Channel_Users":"Prosječan broj korisnika kanala","Stats_Avg_Private_Group_Users":"Prosječne privatnim korisnicima grupe","Stats_Away_Users":"Odsutni Korisnici","Stats_Max_Room_Users":"Maksimalno Korisnika Sobe","Stats_Non_Active_Users":"Neaktivni korisnici","Stats_Offline_Users":"Offline Korisnici","Stats_Online_Users":"Online Korisnici","Stats_Total_Channels":"Ukupno kanala","Stats_Total_Direct_Messages":"Ukupno Izravni Sobe poruka","Stats_Total_Messages":"Ukupno poruka","Stats_Total_Private_Groups":"Ukupno Privatnih Grupa","Stats_Total_Rooms":"Ukupno soba","Stats_Total_Users":"Ukupno korisnika","Stop_Recording":"Prestani sa snimanjem","strike":"precrtaj","Subject":"Naslov","Submit":"Pošalji","Success":"Uspjeh","Survey":"Pregled","Survey_instructions":"Ocijenite svako pitanje u skladu s Vaše zadovoljstvo, 1 što znači da su potpuno nezadovoljni i 5 što znači da su u potpunosti zadovoljni.","Symbols":"Simboli","Sync_success":"Sinkronizacija uspjeh","Sync_Users":"Sinkronizacija korisnika","Test_Connection":"Test Connection","Test_Desktop_Notifications":"Test Desktop Obavijesti","Thank_you_for_your_feedback":"Hvala vam na povratnim informacijama","The_application_name_is_required":"Naziv aplikacije je potrebno","The_channel_name_is_required":"Ime kanala je potrebno","The_emails_are_being_sent":"E-mailovi su poslani.","The_field_is_required":"Polje %s je traženo.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Da biste promijenili veličinu slike neće raditi, jer ne možemo otkriti ImageMagick ili GraphicsMagick instaliran na vašem poslužitelju.","The_redirectUri_is_required":"RedirectUri je potrebno","The_server_will_restart_in_s_seconds":"Poslužitelj će se ponovno pokrenuti u %s sekundi","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Postavka %s</strong> konfiguriran <strong>za %s</strong> i <strong>pristupate %s!</strong>","The_user_will_be_removed_from_s":"Korisnik će biti uklonjena iz %s","The_user_wont_be_able_to_type_in_s":"Korisnik neće moći upisati u %s","Theme":"Tema","theme-color-action-buttons-color":"Akcije Tipke u boji","theme-color-active-channel-background-color":"Aktivno Channel Boja pozadine","theme-color-active-channel-font-color":"Aktivni kanal boje slova","theme-color-blockquote-background":"Blockquote Boja pozadine","theme-color-clean-buttons-color":"Čiste tipke u boji","theme-color-code-background":"Kod Boja pozadine","theme-color-code-border":"Kod Boja obruba","theme-color-code-color":"kod boja","theme-color-content-background-color":"Boja pozadine sadržaja","theme-color-custom-scrollbar-color":"Prilagođena klizač boji","theme-color-info-active-font-color":"Aktivno Info boje slova","theme-color-info-font-color":"Informacije boje slova","theme-color-input-font-color":"Ulaz boje slova","theme-color-link-font-color":"Link boje slova","theme-color-message-hover-background-color":"Poruka Hover BG Color","theme-color-primary-background-color":"Primarni Boja pozadine","theme-color-primary-font-color":"Primarni boje slova","theme-color-quaternary-font-color":"Kvartara boje slova","theme-color-secondary-background-color":"Sekundarna boja pozadine","theme-color-secondary-font-color":"Sekundarna boje slova","theme-color-smallprint-font-color":"Sitnog tiska boje slova","theme-color-smallprint-hover-color":"Sitnog tiska Hover boji","theme-color-status-away":"Daleko Boja Status","theme-color-status-busy":"Zauzet Boja Status","theme-color-status-offline":"Offline Boja Status","theme-color-status-online":"Online Boja status","theme-color-tertiary-background-color":"Tercijarna Boja pozadine","theme-color-tertiary-font-color":"Tercijarna boje slova","theme-color-unread-notification-color":"Nepročitana Obavijesti Color","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"Nema agenti dodao da ovaj odjel još.","There_are_no_integrations":"Nema integracije","There_are_no_users_in_this_role":"Nema korisnika u toj ulozi.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ova e-mail već korišten i nije potvrđena. Molimo promijeniti lozinku.","This_is_a_desktop_notification":"To je desktop obavijest","This_is_a_push_test_messsage":"To je guranje Test poruku korisniku","Time_in_seconds":"Vrijeme u sekundama","Title_bar_color":"Naslov bar u boji","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Za instaliranje Rocket.Chat LiveChat u vaše web stranice, kopirajte i zalijepite ovaj kod iznad zadnjeg <strong></ body></strong> taga na svoje stranice.","To_users":"Za korisnike","Topic":"Tema","Travel_and_Places":"Travel & Places","Trigger_removed":"Okidač uklonjen","Trigger_Words":"Riječi koje pokreću oglase","Triggers":"Okidači","True":"Da","Type":"Vrsta","Type_your_new_password":"Upišite novu lozinku","Unarchive":"Dearhiviraj","Unmute_someone_in_room":"Mikrofon uključen je netko u sobi","Unmute_user":"Uključi mikrofon korisnika","Unnamed":"Neimenovan","Unpin_Message":"Odvoji Poruka","Unread_Rooms":"nepročitane Sobe","Unread_Rooms_Mode":"Nepročitane Sobe mod","Unstar_Message":"Ukloni zvjezdicu","Upload_file_question":"Postavi datoteku?","Uploading_file":"Prijenos datoteke ...","Use_account_preference":"Koristite postavke računa","Use_Emojis":"Koristi Emoji Smajliće","Use_initials_avatar":"Koristi inicijale svog korisničkog imena","use_menu":"Koristite izbornik kako bi pristupili svojim sobama i chatovima","Use_service_avatar":"Koristi %s avatar","Use_this_username":"Koristi ovo korisničko ime","Use_uploaded_avatar":"Koristi uploadani avatar","Use_url_for_avatar":"Koristite URL za avatar","User__username__is_now_a_moderator_of__room_name_":"Korisnik __korisničko ime__ je sada moderator __room_name__","User__username__is_now_a_owner_of__room_name_":"Korisnik __korisničko ime__ je sada vlasnik __room_name__","User__username__removed_from__room_name__moderators":"Korisnik __korisničko ime__ uklonjen iz moderatori __room_name__","User__username__removed_from__room_name__owners":"Korisnik __korisničko ime__ uklonjen iz __room_name__ vlasnika","User_added":"Korisnik <em>__user_added__</em> je dodan.","User_added_by":"Korisnik <em>__user_added__</em> dodan od <em>__user_by__</em>.","User_added_successfully":"Korisnik uspješno dodan","User_Channels":"Korisnički kanali","User_doesnt_exist":"Ne postoji korisnik pod imenom `@ %s`.","User_has_been_activated":"Korisnik je aktiviran","User_has_been_deactivated":"Korisnik je deaktiviran","User_has_been_deleted":"Korisnik je obrisan","User_has_been_muted_in_s":"Korisnik je isključen u %s","User_has_been_removed_from_s":"Korisnik je uklonjen sa %s","User_has_disconnected":"Korisnik je isključen","User_Info":"Podaci o korisniku","User_is_no_longer_an_admin":"Korisnik nije više admin","User_is_not_activated":"Korisnik nije aktiviran","User_is_now_an_admin":"Korisnik je sada admin","User_joined_channel":"se pridružio kanalu.","User_joined_channel_female":"se pridružila kanalu.","User_joined_channel_male":"se pridružio kanalu.","User_left":"Korisnik <em>__user_left__</em> je otišao.","User_left_female":"Korisnica <em>__user_left__</em> je otišla.","User_left_male":"Korisnik <em>__user_left__</em> je otišao.","User_logged_out":"Korisnik je odjavljen","User_management":"Upute za upravljanje","User_muted_by":"Korisnik <em>__user_muted__</em> prigušen <em>__user_by__.</em>","User_muted_in_room":"Korisnik je isključen zvuk u sobi","User_not_found":"Korisnik nije pronađen","User_not_found_or_incorrect_password":"Korisnik nije pronađen ili pogrešna lozinka","User_or_channel_name":"Korisnik ili naziv kanala","User_removed":"Korisnik je uklonjen","User_removed_by":"Korisnik <em>__user_removed__</em> maknut od <em>__user_by__</em>.","User_removed_from_room":"Korisnik je uklonjen iz sobe","User_Settings":"Korisničke postavke","User_unmuted_by":"Korisnik <em>__user_unmuted__</em> uključio by <em>__user_by__.</em>","User_unmuted_in_room":"Korisnik ne zanemaruje u sobi","User_updated_successfully":"Korisnik je uspješno ažuriran","Username":"Korisničko ime","Username_and_message_must_not_be_empty":"Korisničko ime i poruka ne smije biti prazan.","Username_cant_be_empty":"Korisničko ime ne može ostati prazno.","Username_Change_Disabled":"Vaš Rocket.Chat Administrator je onemogućio izmjenu korisničkih imena","Username_denied_the_OTR_session":"__korisničko ime__ negirao OTR sjednicu","Username_description":"Korisničko ime se koristi kako bi te drugi mogli spomenuti u porukama.","Username_doesnt_exist":"Korisničko ime '# %s` ne postoji.","Username_ended_the_OTR_session":"__korisničko ime__ završio OTR sjednicu","Username_invalid":"<strong>%s</strong> nije valjano korisničko ime,<br/> koristi samo slova, brojeve, točke i crtice","Username_is_already_in_here":"`@ %s` je već ovdje.","Username_is_not_in_this_room":"Korisnik `# %s` nije u ovoj sobi.","Username_not_found":"Korisničko ime nije pronađeno","Username_title":"Registriraj korisničko ime","Username_unavaliable":"<strong>%s</strong> je već zauzeto :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__korisničko ime__ želi započeti SP. Želite li prihvatiti?","Users":"Korisnici","Users_in_role":"Korisnici u ulozi","UTF8_Names_Slugify":"UTF8 Imena Slugify","UTF8_Names_Validation":"UTF8 Imena valjanosti","UTF8_Names_Validation_Description":"Nemojte dopustiti posebnih znakova i razmaka. Možete koristiti - _ i. ali ne i na kraju imena","Verification_email_sent":"Provjera e-mail poslan","View_All":"Prikaži Sve","View_Logs":"Pogledaj izvještaje","Visibility":"Vidljivost","Visible":"vidljiv","Visitor":"posjetilac","Visitor_page_URL":"URL stranice posjetitelja","Visitor_time_on_site":"Vrijeme posjetitelja na licu mjesta","Wait_activation_warning":"Prije nego što se prijavite, vaš račun mora ručno aktivirati administrator.","We_are_offline_Sorry_for_the_inconvenience":"Mi smo izvan mreže. Oprostite na neugodnosti.","We_have_sent_password_email":"Poslan ti je e-mail sa uputama za resetiranje lozinke. Provjeri i spam folder! Ako ga ne primiš uskoro, molimo te vrati se i pokušaj opet.","We_have_sent_registration_email":"Poslan ti je e-mail kako bi potvrdio svoju registraciju. Provjeri i spam folder! Ako ga ne primiš uskoro, molimo te vrati se i pokušaj opet.","WebRTC_Enable_Channel":"Omogući za javne kanale","WebRTC_Enable_Direct":"Omogući za izravne poruke","WebRTC_Enable_Private":"Omogući za privatne kanale","WebRTC_Servers":"STUN / Uključite poslužitelji","WebRTC_Servers_Description":"Popis STUN i okrenuti servere odvojenih zarezom. <br/> Korisničko ime, lozinku i luka dopušten ulazak u formatu 'Korisničko ime: Lozinka @ omamljivanje: Domaćin: port` ili `korisničko ime: lozinka @ red: Domaćin: port`.","Welcome":"Dobro došao/la<em>%s</em>.","Welcome_to_the":"Dobro došli »","will_be_able_to":"će moći","With_whom":"Sa kim","Yes":"Da","Yes_clear_all":"Da, makni sve!","Yes_delete_it":"Da, obriši!","Yes_hide_it":"Da, to sakriti!","Yes_leave_it":"Da, ostavi ga!","Yes_mute_user":"Da, nijemi korisnik!","Yes_remove_user":"Da, ukloni korisnika!","you_are_in_preview_mode_of":"Ti si u preglednom načinu kanala # <strong>__room_name__</strong>","You_are_logged_in_as":"Prijavljeni ste kao","You_are_not_authorized_to_view_this_page":"Nemate dopuštenje za pregled ove stranice.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Vi ste zadnji vlasnik. Postavite novi vlasnik prije izlaska iz sobe.","You_can_change_a_different_avatar_too":"Možete nadjačati avatar koristi na post iz ove integracije.","You_can_use_an_emoji_as_avatar":"Također možete koristiti i emotikon kao avatar.","You_have_been_muted":"Ti su zanemarene i ne može govoriti u ovoj sobi","You_have_not_verified_your_email":"Niste potvrdili svoju adresu e-pošte.","You_have_successfully_unsubscribed":"Uspješno ste pretplatu od našeg mailling List.","You_informed_an_invalid_FROM_address":"upozorio je invalid OD adresu.","You_must_provide_the_unsubscribe_link":"Morate navesti na link [odjaviti].","You_need_confirm_email":"Trebaš potvrditi svoj email kako bi se prijavio!","You_need_install_an_extension_to_allow_screen_sharing":"Morate instalirati proširenje kako bi se omogućilo dijeljenje zaslona","You_need_to_change_your_password":"Morate promijeniti svoju lozinku","You_need_to_type_in_your_password_in_order_to_do_this":"Morate upisati svoju lozinku kako bi se to učiniti!","You_need_to_type_in_your_username_in_order_to_do_this":"Morate upisati svoje korisničko ime kako bi se to učiniti!","You_need_to_verifiy_your_email_address_to_get_notications":"Morate provjerimo vašu e-mail adresu kako bi dobili obavijesti","You_should_name_it_to_easily_manage_your_integrations":"Te bi trebao imenovati lako upravljati svojim integracije.","You_will_not_be_able_to_recover":"Ovo nećeš moći promijeniti!","You_will_not_be_able_to_recover_file":"Nećete biti u mogućnosti da se oporavim ovu sliku!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Nećete primati e-mail obavijesti jer niste potvrdili svoju adresu e-pošte.","Your_email_has_been_queued_for_sending":"Vaš e-mail je na čekanju za slanje","Your_entry_has_been_deleted":"Tvoj unos je obrisan.","Your_file_has_been_deleted":"Vaša datoteka je izbrisana.","Your_mail_was_sent_to_s":"Vaš e-pošte je poslana na %s","Your_Open_Source_solution":"Vaše vlastito Open Source chat rješenje","Your_password_is_wrong":"Vaša lozinka je pogrešno!","Your_push_was_sent_to_s_devices":"Pritisni je poslana na %s uređajima"});
TAPi18n._registerServerTranslator("hr", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/hu.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["hu"] = ["Hungarian","Magyar"];                                                                // 8
if(_.isUndefined(TAPi18n.translations["hu"])) {                                                                        // 9
  TAPi18n.translations["hu"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["hu"][namespace])) {                                                             // 13
  TAPi18n.translations["hu"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["hu"][namespace], {"500":"Belső Szerverhiba","0_Errors_Only":"0 - Csak hibák","1_Errors_and_Information":"1 - Hibák és Információs","2_Erros_Information_and_Debug":"2 - azokat a hibákat, Információs és Debug","__username__was_set__role__by__user_by_":"__username__ állították __role__ által __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ már nem __role__, által __user_by__","Access_not_authorized":"A hozzáférés nem engedélyezett","Access_online_demo":"Hozzáférés az online demóhoz","Access_Online_Demo":"Hozzáférés az Online Demóhoz","Access_Token_URL":"Access Token URL","Accounts":"Fiókok","Accounts_AllowDeleteOwnAccount":"Lehetővé teszi a felhasználóknak, hogy törölni saját számlára","Accounts_AllowedDomainsList":"Engedélyezett domainek listája","Accounts_AllowedDomainsList_Description":"Vesszővel elválasztott listája az engedélyezett domainek","Accounts_AllowEmailChange":"Hagyjuk E-mail Change","Accounts_AllowPasswordChange":"Hagyjuk jelszó módosítása","Accounts_AllowUserAvatarChange":"Lehetővé teszi a felhasználó Avatar Change","Accounts_AllowUsernameChange":"Hagyjuk Felhasználónév Change","Accounts_AllowUserProfileChange":"Hagyjuk Felhasználói profil Change","Accounts_AvatarResize":"átméretezése karakterekkel","Accounts_AvatarSize":"Avatar méret","Accounts_AvatarStorePath":"Avatar Storage Path","Accounts_AvatarStoreType":"Avatar Tároló típusa","Accounts_BlockedDomainsList":"Blokkolt domainek listája","Accounts_BlockedDomainsList_Description":"Vesszővel elválasztott listája blokkolt domainek","Accounts_denyUnverifiedEmail":"Deny igazolatlan e-mail","Accounts_EmailVerification":"Email megerősítés","Accounts_EmailVerification_Description":"Győződjön meg róla, hogy a megfelelő SMTP beállításait használja ezt a funkciót","Accounts_Enrollment_Email":"Beiratkozás E-mail","Accounts_Enrollment_Email_Description":"Lehet használni [nevet], [fname], [lname] a felhasználó teljes nevét, keresztnevét vagy vezetéknevét, ill. <br /> Lehet használni [email] A felhasználó e-mail.","Accounts_Iframe_api_method":"Api módszer","Accounts_Iframe_api_url":"API URL","Accounts_iframe_enabled":"Engedélyezett","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"Bejelentkezés lejárata Days","Accounts_ManuallyApproveNewUsers":"Kézzel jóváhagyása Új felhasználók","Accounts_OAuth_Custom_Token_Sent_Via":"Token keresztül küldött","Accounts_OAuth_Custom_Authorize_Path":"engedélyezheti Path","Accounts_OAuth_Custom_Button_Color":"gomb színe","Accounts_OAuth_Custom_Button_Label_Color":"Gomb szövegének színe","Accounts_OAuth_Custom_Button_Label_Text":"Gombfelirat","Accounts_OAuth_Custom_Enable":"Engedélyezze","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"identity Path","Accounts_OAuth_Custom_Login_Style":"Bejelentkezés stílus","Accounts_OAuth_Custom_Secret":"Titok","Accounts_OAuth_Custom_Token_Path":"token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook bejelentkezés","Accounts_OAuth_Facebook_callback_url":"Facebook visszahívás URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Enabled","Accounts_OAuth_Github_callback_url":"Github visszahívás URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise visszahívás URL","Accounts_OAuth_GitHub_Enterprise_id":"Az ügyfél-azonosító","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Az ügyfél-azonosító","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab visszahívás URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google Bejelentkezés","Accounts_OAuth_Google_callback_url":"Google visszahívás URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn bejelentkezés","Accounts_OAuth_Linkedin_callback_url":"Iwiw visszahívás URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Bejelentkezés","Accounts_OAuth_Meteor_callback_url":"Meteor visszahívás URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Bejelentkezés","Accounts_OAuth_Twitter_callback_url":"Twitter visszahívás URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter titkos","Accounts_OAuth_Wordpress":"WordPress Bejelentkezés","Accounts_OAuth_Wordpress_callback_url":"Wordpress visszahívás URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Jelszó visszaállítása","Accounts_Registration_AuthenticationServices_Enabled":"Bejegyzés az Authentication Services","Accounts_RegistrationForm":"Regisztrációs űrlap","Accounts_RegistrationForm_Disabled":"Tiltva","Accounts_RegistrationForm_LinkReplacementText":"Regisztrációs űrlap link csere szöveg","Accounts_RegistrationForm_Public":"Nyilvános","Accounts_RegistrationForm_Secret_URL":"titkos URL","Accounts_RegistrationForm_SecretURL":"Regisztrációs űrlap titkos URL","Accounts_RegistrationForm_SecretURL_Description":"Meg kell adnia egy véletlenszerű karaktersorozat, amely hozzáadódik a regisztrációs URL-t. Példa: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Regisztráció szükséges","Accounts_RequireNameForSignUp":"Igényel elnevezése Regisztráció","Accounts_ShowFormLogin":"Megmutatása űrlap alapú bejelentkezés","Accounts_UseDefaultBlockedDomainsList":"Use Default blokkolt domainek listája","Accounts_UseDNSDomainCheck":"DNS használata Domain ellenőrzése","Activate":"Aktiválja","Activity":"Tevékenység","Add":"hozzáad","Add_agent":"Add ügynök","Add_custom_oauth":"Add egyéni OAuth","Add_manager":"Add menedzser","Add_Members":"Új tagok","Add_User":"Felhasználó hozzáadása","Add_user":"Add felhasználó","Add_users":"Felhasználók hozzáadása","Additional_emails":"További E-mail","Additional_Feedback":"további Visszajelzés","Administration":"Adminisztráció","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Miután OAuth2 hitelesítésre, a felhasználók lesz irányítva erre az URL","Agent_added":"Agent hozzáadott","Agent_removed":"Agent eltávolított","Alias":"Álnév","All":"Minden","All_channels":"minden csatorna","All_logs":"minden rönk","All_messages":"Az összes üzenet","Allow_Invalid_SelfSigned_Certs":"Az érvénytelen Önaláíró Certs","Allow_Invalid_SelfSigned_Certs_Description":"Az érvénytelen és önaláíró SSL tanúsítvány a kapcsolatot a hitelesítésre és előzetesek.","and":"és","And_more":"És még __length __...","Animals_and_Nature":"Állatok és Természet","API":"API","API_Analytics":"Analitika","API_Embed":"Beágyaz","API_EmbedDisabledFor":"Letiltása beágyazása felhasználóknak","API_EmbedDisabledFor_Description":"Vesszővel elválasztott listája felhasználónevek","API_GitHub_Enterprise_URL":"szerver URL","API_GitHub_Enterprise_URL_Description":"Példa: http://domain.com (kivéve záró perjel)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Kinézet","Application_added":"alkalmazás hozzáadott","Application_Name":"alkalmazás neve","Application_updated":"Az alkalmazás frissítése","Apply_and_refresh_all_clients":"Alkalmazni, és frissítse az összes kliens","Archive":"Archív","Archive_Unarchive":"Archive / Archiválás megszüntetése","are_also_typing":"is ír","are_typing":"éppen ír","Are_you_sure":"Biztos vagy benne?","Are_you_sure_you_want_to_delete_your_account":"Biztos, hogy törli a fiókot?","Authorization_URL":"engedélyezési URL","Authorize":"engedélyez","AutoLinker_StripPrefix":"AutoLinker Strip előtag","AutoLinker_StripPrefix_Description":"Rövid kijelzőn. pl https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL reguláris kifejezés","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Automatikusan kapcsolódik a telefonszámot. Pl: `(123) 456-7890`","Auto_Load_Images":"Auto Load Images","Available":"Elérhető","Available_agents":"elérhető szerek","Avatar":"Kép megváltoztatása","Avatar_changed_successfully":"Avatar sikeresen módosítva","Avatar_URL":"Avatar URL","Avatar_url_invalid_or_error":"A megadott URL érvénytelen, vagy nem érhető el. Kérjük, próbálja újra, de egy másik URL-t.","away":"távol","Away":"Távol","away_female":"el","Away_female":"El","away_male":"el","Away_male":"El","Back":"Hát","Back_to_applications":"Vissza az alkalmazások","Back_to_integrations":"Vissza az integrációk","Back_to_login":"Vissza a bejelentkezéshez","Back_to_permissions":"Vissza az engedélyeket","Body":"Test","bold":"bátor","busy":"elfoglalt","Busy":"Elfoglalt","busy_female":"elfoglalt","Busy_female":"Elfoglalt","busy_male":"elfoglalt","Busy_male":"Elfoglalt","Cancel":"Mégse","Cannot_delete_a_protected_role":"Nem lehet törölni a védett szerepe","Cannot_delete_role_because_its_in_use":"Nem lehet törölni a szerepet, mert használatban van","Cannot_invite_users_to_direct_rooms":"Nem lehet meghívni a felhasználók közvetlen szobák","CDN_PREFIX":"CDN előtag","Certificates_and_Keys":"Bizonyítványok és kulcsok","Channel":"Csatorna","Channel_doesnt_exist":"A csatorna `# %s` nem létezik.","Channels":"Csatornák","Channels_list":"Nyilvános csatornák listája","Chat_Rooms":"Társalgók","Chatops_Enabled":"engedélyezze Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Felhasználónév","Choose_a_room":"Válasszon egy szobát","Choose_messages":"üzenetek kiválasztása","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Válassza Alias ​​előtt jelenik meg a felhasználónevét üzeneteket.","Choose_the_username_that_this_integration_will_post_as":"Válassza ki a felhasználónevét, hogy ez az integráció utáni mint.","Clear_all_unreads_question":"Törölje az összes unreads?","Client_ID":"ügyfél-azonosító","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Az ügyfelek frissíteni néhány másodperc","close":"bezár","Closed":"Zárva","Collapse_Embedded_Media_By_Default":"Összecsukása beágyazott média alapértelmezés","coming_soon":"hamarosan","Commands":"parancsok","Compact_View":"kompakt nézet","Confirm_password":"Ellenőrizd a jelszavad","Contact":"Kapcsolat","Conversation":"Beszélgetés","Convert_Ascii_Emojis":"Átalakítás ASCII Emoji","Copied":"másolt","COPY_TO_CLIPBOARD":"MÁSOLJA A VÁGÓLAPRA","Copy_to_clipboard":"Másolja a vágólapra","Count":"számol","Create":"Teremt","Create_new":"Újat készíteni","Created_at":"Készült","Created_at_s_by_s":"<strong>Alkotó:% <strong>s%</strong></strong> <strong>s</strong>","Custom_Fields":"egyéni mezők","Custom_oauth_helper":"Amikor beállítja OAuth Szolgáltató, akkor tájékoztatni visszahívás URL. Használat <pre> %s </pre> .","Custom_oauth_unique_name":"Egyedi OAuth egyedi nevet","Custom_Script_Logged_In":"Egyedi szkript bejelentkezett felhasználóknak","Custom_Script_Logged_Out":"Egyedi szkript kijelentkezett felhasználó","Dashboard":"Műszerfal","days":"napok","Deactivate":"deaktiválása","Debug_Level":"Debug szint","Default":"Alapértelmezett","Delete":"Töröl","Delete_my_account":"A fiókom törlése","Delete_Room_Warning":"Törlése szoba törli az összes üzenetet küldte a szobában. Ezt nem lehet visszacsinálni.","Delete_User_Warning":"Törlése felhasználó összes üzenetet törölni, hogy a felhasználó is. Ezt nem lehet visszacsinálni.","Deleted":"Törölve!","Department_not_found":"Osztály nem talált","Department_removed":"Department eltávolított","Departments":"Osztályok","Description":"Leírás","Desktop":"Desktop","Desktop_Notification_Test":"Asztali értesítés teszt","Desktop_Notifications":"Asztali értesítések","Desktop_Notifications_Disabled":"Asztali értesítések le vannak tiltva. Módosítania kell a böngésző beállításait, ha szüksége Értesítések engedélyezve.","Desktop_Notifications_Enabled":"Asztali értesítések engedélyezve vannak","Direct_message_someone":"Közvetlen üzenet valaki","Direct_Messages":"Közvetlen üzenet","Direct_Messages_list":"Közvetlen üzenet","Disable_Favorite_Rooms":"letiltása Kedvencek","Disable_New_Message_Notification":"Kikapcsolja új üzenet értesítést","Disable_New_Room_Notification":"Kikapcsolja az új terem Notification","Displays_action_text":"Kijelzők akció szöveg","Do_you_want_to_change_to_s_question":"Szeretné <strong>megváltoztatni %s?</strong>","Drop_to_upload_file":"Dobd lehet feltölteni a fájlt","Dry_run":"Szárazon futás","Dry_run_description":"Csak akkor küldünk egy e-mailt, hogy ugyanaz a cím, mint a From. Az e-mail kell tartozniuk felhasználó érvényes.","Duplicate_archived_channel_name":"Archivált Channel névvel ' %s' létezik","Duplicate_archived_private_group_name":"Archivált Private csoport név ' %s' létezik","Duplicate_private_group_name":"A Private csoport neve ' %s' létezik","E-mail":"Email","Edit":"szerkesztése","Edit_Custom_Field":"Szerkesztés egyéni mező","Edit_Department":"szerkesztés Tanszék","edited":"szerkesztve","Email":"Email","Email_already_exists":"Az e-mail cím már létezik","Email_body":"E-mail test","Email_Change_Disabled":"Az Rocket.Chat rendszergazda letiltotta a változó e-mail","Email_from":"Ból ből","Email_Notification_Mode":"Offline-mail értesítések","Email_Notification_Mode_All":"Minden Említés / DM","Email_Notification_Mode_Disabled":"Tiltva","Email_or_username":"Email or username","Email_subject":"Tantárgy","Email_verified":"Email hitelesítve","Emoji":"Emoji","Empty_title":"üres címet","Enable":"Engedélyezze","Enable_Desktop_Notifications":"Asztali értesítések engedélyezése","Enabled":"Engedélyezett","Encrypted_message":"titkosított üzenet","End_OTR":"vége OTR","Enter_a_regex":"Adjon meg egy regex","Enter_a_room_name":"Írja be a szoba nevét","Enter_a_username":"Adjon meg egy felhasználónevet","Enter_info":"Írd be a bejelentkezéshez szükséges adatokat","Enter_name_here":"Írd be a nevet","Enter_to":"az Enter","Error":"Hiba","error-cant-invite-for-direct-room":"Nem lehet meghívni a felhasználó közvetlen szobák","error-duplicate-channel-name":"A csatorna névvel ' %s' létezik","error-invalid-custom-field":"Érvénytelen egyéni mező","error-invalid-custom-field-name":"Érvénytelen egyéni mező nevét. Csak betűk, számok, kötőjel és aláhúzás.","error-invalid-password":"Érvénytelen jelszó","error-invalid-room":"érvénytelen szoba","error-invalid-room-name":"<strong> %s</strong> nem érvényes helyiség nevét, <br/> Csak betűket, számokat, kötőjelet és aláhúzást","error-invalid-user":"Érvénytelen felhasználó","error-invalid-username":"Érvénytelen felhasználónév","error-not-allowed":"Nem megengedett","error-not-authorized":"nem engedélyezett","error-remove-last-owner":"Ez az utolsó tulajdonos. Kérjük, állítsa be az új tulajdonos, mielőtt ezt eltávolítaná.","error-role-name-required":"Szerep neve szükséges","error-user-not-in-room":"A felhasználó nem ebben a szobában","Error_changing_password":"Jelszó megváltoztatva","Error_sending_confirmation_email":"Nem sikerült elküldeni a megerősítő e-mailt","Error_too_many_requests":"Hiba, túl sok kérés. Kérlek lassíts le. Meg kell várni, %s másodperc, mielőtt újra próbálkozna","Esc_to":"Esc, hogy","Example_s":"Példa: <code class=\"inline\">%s</code>","False":"Hamis","Favorites":"Kedvencek","Field":"Mező","Field_removed":"Field eltávolított","File_exceeds_allowed_size_of_bytes":"Fájl mérete meghaladja a megengedett méretet a __size__ bájt","FileUpload":"Fájlfeltöltés","FileUpload_Enabled":"Fájlfeltöltések Enabled","FileUpload_File_Empty":"Fájl üres","FileUpload_FileSystemPath":"rendszer Path","FileUpload_MaxFileSize":"Feltölthető legnagyobb fájlméret (bájtban)","FileUpload_MediaType_NotAccepted":"Média típusok Nem Elfogadva","FileUpload_MediaTypeWhiteList":"Elfogadott média típusok","FileUpload_MediaTypeWhiteListDescription":"Vesszővel elválasztott listája média típusok. Hagyja üresen elfogadó minden média típus.","FileUpload_ProtectFiles":"Protect feltöltött fájlok","FileUpload_ProtectFilesDescription":"Csak regisztrált felhasználók férhetnek","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket neve","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN domain letöltések","FileUpload_S3_Region":"Vidék","FileUpload_Storage_Type":"tároló típusa","Flags":"Zászlók","Follow_social_profiles":"Kövess minket a közösségi oldalainkon, forkold a github projektünk és oszd meg az ötleted a rocket.chat alkalmazás trello oldalán.","Food_and_Drink":"Étel ital","For_your_security_you_must_re_enter_your_password_to_continue":"Az Ön biztonsága érdekében, meg kell adja meg újra a jelszót, hogy továbbra is","Force_SSL":"Force SSL","Force_SSL_Description":"* Figyelem! * _Force SSL_ soha nem lehet fordított proxy. Ha van egy fordított proxy, meg kell tennie az átirányítást OTT. Ez a lehetőség fennáll telepítések mint Heroku, amely nem teszi lehetővé az átirányítás konfiguráció a fordított proxy.","Forgot_password":"Elfelejtetted a jelszavad?","Fork_it_on_github":"Forkold github-on","Frequently_Used":"gyakran használt","From":"Ból ből","From_Email":"az e-mailben","From_email_is_required":"Tól email szükséges","From_email_warning":"<b>Figyelmeztetés:</b> A <b>mező</b> van kitéve az e-mail szerver beállításait.","General":"Általános","Get_to_know_the_team":"Ismerd meg a Rocket.Team","github_no_public_email":"Nincs egy email címed se publikusként megadva a GitHub fiókodban","Give_a_unique_name_for_the_custom_oauth":"Adj egy egyedi nevet az egyéni OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Adjon az alkalmazás nevét. Ez látható lesz az Ön számára.","Global":"Globális","GoogleTagManager_id":"Google Címkekezelő Id","Has_more":"több","Have_your_own_chat":"Legyen saját webes chat-ed. A Meteor.com alapokra épített Rocket.Chat remek megoldás azoknak a fejlesztőknek akik szívesen építenének vagy fejlesztenének saját alkalmazást.","Header":"Fejléc","Hidden":"Rejtett","Hide_Group_Warning":"Biztosan el szeretné rejteni a csoport \" %s\"?","Hide_Private_Warning":"Biztosan el szeretné rejteni a beszélgetés \" %s\"?","Hide_room":"Szoba elrejtése","Hide_Room_Warning":"Biztosan el szeretné rejteni a szobában \" %s\"?","Highlights":"Főbb","Highlights_How_To":"Értesítést, ha valaki megemlíti a szót vagy kifejezést, add ide. Akkor külön szavak és kifejezések vesszővel. Kiemelés szavak nem érzékenyek.","Highlights_List":"Kiemelés szavak","History":"Előzmények","hours":"órák","How_friendly_was_the_chat_agent":"Hogyan barátságos volt a chat ügynök?","How_knowledgeable_was_the_chat_agent":"Mennyire értett a chat ügynök?","How_responsive_was_the_chat_agent":"Hogyan reagálnak volt a chat ügynök?","How_satisfied_were_you_with_this_chat":"Mennyire volt elégedett ezzel a beszélgetés?","If_you_are_sure_type_in_your_password":"Ha biztos abban, írja be a jelszót:","If_you_are_sure_type_in_your_username":"Ha biztos abban, írja be a felhasználónevét:","Importer_Archived":"archivált","Importer_done":"Importálása befejeződött!","Importer_finishing":"Utolsó simítások az import.","Importer_From_Description":"Behozatal __from __ 's adatok Rocket.Chat.","Importer_import_cancelled":"Import törölték.","Importer_import_failed":"Hiba történt a futás az import.","Importer_importing_channels":"Importálása a csatornákat.","Importer_importing_messages":"Importálása az üzeneteket.","Importer_importing_started":"Kezdve az import.","Importer_importing_users":"Importálása a felhasználók számára.","Importer_not_defined_properly":"Az importőr nem helyesen meghatározva, ez hiányzik az Import osztály.","Importer_not_in_progress":"Az importőr jelenleg nem aktív.","Importer_Prepare_Restart_Import":"Újraindítás Import","Importer_Prepare_Start_Import":"Kezdés importálása","Importer_Prepare_Uncheck_Archived_Channels":"Szüntesse archivált csatornák","Importer_Prepare_Uncheck_Deleted_Users":"Szüntesse törölt felhasználók","Importer_progress_error":"Nem sikerült lekérni az előrehaladás az import.","Importer_setup_error":"Hiba történt a felállítása az importőr.","Incorrect_Password":"Hibás jelszó","inline_code":"inline_code","Install_Extension":"Install Extension","Install_FxOs":"Telepítse Rocket.Chat a Firefox","Install_FxOs_done":"Nagy! Most már használhatja Rocket.Chat keresztül az ikont a kezdőképernyőn. Jó szórakozást Rocket.Chat!","Install_FxOs_error":"Sajnos ez nem működik rendeltetésszerűen! A következő hiba jelent meg:","Install_FxOs_follow_instructions":"Kérjük, erősítse meg az alkalmazás telepítése a készülék (nyomja meg a \"telepítés\").","Installation":"Telepítés","Integration_added":"Integráció került","Integration_Incoming_WebHook":"Bejövő WebHook integráció","Integration_New":"új integráció","Integration_Outgoing_WebHook":"Kimenő WebHook integráció","Integration_updated":"Integration frissült","Integrations":"Integráció","Invalid_asset":"érvénytelen eszköz","Invalid_confirm_pass":"A két jelszó nem eggyezik","Invalid_email":"Érvénytelen email cím","Invalid_Export_File":"A feltöltött fájl nem érvényes %s export fájlt.","Invalid_file_height":"Érvénytelen fájl magassága","Invalid_file_type":"Érvénytelen fájltípus","Invalid_file_width":"Érvénytelen fájl szélessége","Invalid_Import_File_Type":"Érvénytelen Import fájltípus.","Invalid_name":"A név nem lehet üres","Invalid_notification_setting_s":"Érvénytelen bejelentés beállítás: %s","Invalid_pass":"A jelszó nem lehet üres","Invalid_room_name":"<strong>%s</strong> szobanév nem érvényes,<br/> kérlek csak betűket, számokat és kötőjeleket használj","Invalid_room_type":"<strong> %s</strong> nem érvényes szobatípusban.","Invalid_Secret_URL":"Érvénytelen a titkos URL","Invalid_secret_URL_message":"A megadott URL érvénytelen.","invisible":"láthatatlan","Invisible":"Láthatatlan","Invitation_HTML":"Meghívó HTML","Invitation_Subject":"Meghívó Tárgy","Invite_user_to_join_channel":"Kérj meg egy felhasználó számára, hogy csatlakozzon ehhez a csatornához","Invite_Users":"felhasználók meghívása","is_also_typing":"is ír","is_also_typing_female":"is beírni","is_also_typing_male":"is beírni","is_typing":"éppen ír","is_typing_female":"gépel","is_typing_male":"gépel","italics":"dőlt betűk","join":"Csatlakozik","Join_audio_call":"Csatlakozás audio hívást","Join_the_Community":"Csatlakozz a közösséghez","Join_the_given_channel":"Csatlakozz az adott csatorna","Join_video_call":"Csatlakozz videohívás","Joined":"csatlakozott","Jump":"Ugrás","Jump_to_first_unread":"Ugrás az első olvasatlan","Jump_to_message":"Ugrás az üzenethez","Jump_to_recent_messages":"Ugrás a legutóbbi üzeneteket","Katex_Enabled":"KATEX Enabled","Label":"Címke","Language":"Nyelv","Language_Version":"Angol nyelvű verzió","Last_login":"Utolsó bejelentkezés","Last_message":"Utolsó üzenet","Last_seen":"Utoljára látva","Layout":"Elrendezés","Layout_Home_Body":"Főoldal Body","Layout_Home_Title":"Otthoni cím","Layout_Login_Terms":"bejelentkezési feltételek","Layout_Privacy_Policy":"Adatvédelmi irányelvek","Layout_Sidenav_Footer":"Oldalsó navigáció lábléc","Layout_Sidenav_Footer_description":"Footer mérete 260 x 70 képpont","Layout_Terms_of_Service":"Szolgáltatás feltételei","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Egyéni Domain Search","LDAP_Custom_Domain_Search_Description":"Egy darab JSON, amely szabályozza kötődnek és a kapcsolat adatainak és a forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"Az LDAP hierarchikus adatbázis sok cég használja, hogy single sign on - a létesítmény megosztása egy jelszót a több oldalak és szolgáltatások. Speciális konfigurációs információkat és példákat, kérjük forduljon a wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Domain Base","LDAP_Domain_Base_Description":"A teljesen minősített elkülönítő neve (DN) LDAP részfa szeretne keresni felhasználókat és csoportokat. Akkor adjunk hozzá annyi, amennyit akar; azonban minden csoport kell meghatározni ugyanabban a tartományban bázis a felhasználók számára, hogy tartozik hozzá. Ha megadod korlátozott felhasználói csoportok, csak azok a felhasználók, hogy tartoznak azok a csoportok lesznek hatálya alá. Javasoljuk, hogy adja meg a felső szint a LDAP fa, mint a domain bázis és használja keresési szűrő a hozzáférés szabályozására.","LDAP_Domain_Search_Filter":"Domain Search Filter","LDAP_Domain_Search_Filter_Description":"Ha meg van adva, csak azok a felhasználók, amelyek megfelelnek a szűrőt tenni, hogy jelentkezzen be. Ha nincs szűrő megadva, az összes felhasználó körén belül a megadott tartomány bázis lesz képes bejelentkezni. <br/> Pl Active Directory `MemberOf = cn = ROCKET_CHAT, ou = Általános Groups`. <br/> Pl OpenLDAP (bővíthető találat keresés) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Kategória","LDAP_Domain_Search_Object_Category_Description":"A * objectCategory * hogy azonosítsa a felhasználókat. <br/> Hagyja üresen * OpenLDAP *. <br/> Pl: `Person, stb","LDAP_Domain_Search_Object_Class":"Domain Search Objektumosztály","LDAP_Domain_Search_Object_Class_Description":"A * objectlass * hogy azonosítsa a felhasználókat. <br/> Pl: `organizationalPerson`,`-használó, `inetOrgPerson` stb","LDAP_Domain_Search_Password":"Domain Search jelszó","LDAP_Domain_Search_Password_Description":"A jelszó a domain kereső felhasználó.","LDAP_Domain_Search_User":"Domain Felhasználó keresése","LDAP_Domain_Search_User_Description":"Az LDAP felhasználó, amely végrehajtja a felhasználó kereséseket hitelesítésére felhasználók, amikor bejelentkeznek. <br/> Ez általában egy szolgáltatási fiókot létre kifejezetten a harmadik fél integrációk. Használjon teljes nevét, például `cn = Administrator, cn = Users, dc = példa, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search felhasználói azonosító","LDAP_Domain_Search_User_ID_Description":"Az LDAP-attribútum, amely azonosítja az LDAP felhasználó, aki megkísérel hitelesítést. Ezt a mezőt kell `sAMAccountName` legtöbb Active Directory telepítés, de lehet, hogy` uid` más LDAP megoldások, mint például az OpenLDAP. A `mail` azonosítani felhasználókat e-mailben, vagy bármi kívánt attribútum. <br> A többszörös értékeket vesszővel elválasztva, hogy a felhasználó bejelentkezési segítségével több azonosítók, mint a felhasználónév vagy e-mailben.","LDAP_Enable":"Engedélyezze","LDAP_Enable_Description":"Kísérlet, hogy kihasználja az LDAP hitelesítés.","LDAP_Encryption":"Titkosítás","LDAP_Encryption_Description":"A kódolás, hogy biztosítsa a kommunikáció az LDAP szerver. Példák `plain` (nincs titkosítás),` SSL / LDAPS` (titkosított a kezdetektől), és `StartTLS` (upgrade titkosított kommunikációs egyszer csatlakoztatva).","LDAP_Host":"Házigazda","LDAP_Host_Description":"Az LDAP gazda, például `` ldap.example.com` vagy 10.0.0.30`.","LDAP_Port":"Kikötő","LDAP_Port_Description":"Port eléréséhez LDAP. pl: `` 389` vagy 636` az LDAPS","LDAP_Reject_Unauthorized":"Elutasítás jogosulatlan","LDAP_Sync_User_Avatar":"Szinkronizálás Avatar","LDAP_Sync_User_Data":"adatok szinkronizálása","LDAP_Sync_User_Data_Description":"Tartsa a felhasználói adatok szinkronban szerver login (pl: név, e-mail).","LDAP_Sync_User_Data_FieldMap":"Felhasználói adatok Field Térkép","LDAP_Sync_User_Data_FieldMap_Description":"Állítsd be, hogyan felhasználói fiók területeken (például e-mail) lakott egy rekordot LDAP (egyszer találtak). <br/> Példaként `{\" cn \":\" name \",\" mail \":\" email \"}` fog választani egy személy olvasható név a cn attribútumot, és az e-mail a mail attribútumot. <br/> Elérhető mezők közé `name` és` email`.","LDAP_Sync_Users":"Szinkronizálás felhasználók","LDAP_Test_Connection":"kapcsolat tesztelése","LDAP_Unique_Identifier_Field":"Egyedi azonosító mező","LDAP_Unique_Identifier_Field_Description":"Mely területen fogják használni, hogy összekapcsolja a LDAP felhasználó és a felhasználói Rocket.Chat. Közölhetitek több értéket vesszővel elválasztva meg kell kérni az érték LDAP rekordot. <br/> Az alapértelmezett érték a `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Használja Egyéni Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Írja meg saját szűrő keresni a felhasználókat az LDAP kiszolgálón.","LDAP_Username_Field":"felhasználónév mező","LDAP_Username_Field_Description":"Mely területen kerül felhasználásra * felhasználónév * az új felhasználók számára. Hagyja üresen használni a felhasználónevét tájékoztatni bejelentkezési oldalon. <br/> Használhatja sablon címkéket is, mint a `# {} givenName. # {Sn}`. <br/> Az alapértelmezett érték `sAMAccountName`.","Leave_Group_Warning":"Biztos benne, hogy szeretné elhagyni a csoportot \" %s\"?","Leave_Private_Warning":"Biztosan el szeretné hagyni a beszélgetést: \" %s\"?","Leave_room":"Szoba elhagyása","Leave_Room_Warning":"Biztos benne, hogy szeretné elhagyni a szobát \" %s\"?","line":"vonal","List_of_Direct_Messages":"Listája közvetlen üzenetek","Live_sessions":"élő ülés","Livechat_agents":"GYIK szerek","Livechat_Dashboard":"GYIK Portál","Livechat_enabled":"LiveChat engedélyezve","Livechat_Manager":"GYIK menedzser","Livechat_managers":"GYIK vezetők","Livechat_title":"GYIK Cím","Livechat_title_color":"GYIK cím háttérszíne","Livechat_Users":"GYIK felhasználók","Load_more":"Korábbiak betöltése","Loading...":"Tölt...","Loading_more_from_history":"Továbbiak betöltése a történelemből","Loading_suggestion":"Javaslatok betöltése...","Localization":"Honosítás","Log_File":"Mutasd neve és a sor","Log_Level":"Log Level","Log_Package":"Show Package","Log_View_Limit":"Naplónézetben Limit","Logged_out_of_other_clients_successfully":"Kijelentkezett a más ügyfelek sikeresen","Login":"Bejelentkezés","Login_with":"Bejelentkezés %s segítségével","login_with":"Vagy jelentkezz be a következőkkel","Logout":"Kijelentkezés","Logout_Others":"Kijelentkezel Egyéb bejelentkezve Locations","Mail_Message_Invalid_emails":"Megadta egy vagy több érvénytelen e-mail: %s","Mail_Message_Missing_to":"Ki kell választania egy vagy több felhasználót, vagy egy, vagy több e-mail címet, vesszővel elválasztva.","Mail_Message_No_messages_selected_select_all":"Nem választott ki semmilyen üzenetet. Szeretné <a href='#' class='select-all'>válassza ki az összes</a> látható üzeneteket?","Mail_Messages":"e-mail üzenetek","Mail_Messages_Instructions":"Válassza ki, melyik üzenetet szeretne küldeni e-mailben rákattint az üzeneteket","Mail_Messages_Subject":"Itt egy kiválasztott részét %s üzeneteket","Mailer":"Postázó","Mailer_body_tags":"Ki <b>kell</b> használni [leiratkozás] a leiratkozás linkre. <br /> Lehet használni [nevet], [fname], [lname] a felhasználó teljes nevét, keresztnevét vagy vezetéknevét, ill. <br /> Lehet használni [email] A felhasználó e-mail.","Make_Admin":"Tedd Admin","Manager_added":"A menedzser hozzátette","Manager_removed":"menedzser eltávolított","Mark_as_read":"Jelöld olvasottként","Markdown_Headers":"árleszállítás fejlécek","Markdown_SupportSchemesForLink":"Árleszállítás támogatási rendszereket link","Markdown_SupportSchemesForLink_Description":"Vesszővel elválasztott listája az engedélyezett programok","Members_List":"Tag lista","Mentions":"megemlíti","Mentions_default":"Szerint (alapértelmezett)","Message":"Üzenet","Message_AllowDeleting":"Engedélyezés Message törlése","Message_AllowEditing":"Engedélyezés Message szerkesztése","Message_AllowEditing_BlockEditInMinutes":"Blokk Üzenet szerkesztése után (n) a jegyzőkönyvet","Message_AllowEditing_BlockEditInMinutesDescription":"Írja 0 letiltja blokkoló.","Message_AllowPinning":"Engedélyezés Message rögzítéssel","Message_AllowPinning_Description":"Az üzenetek tűzve bármelyik csatornán.","Message_AllowStarring":"Engedélyezés Message Szereplők","Message_AudioRecorderEnabled":"Audio Recorder Enabled","Message_AudioRecorderEnabledDescription":"\"Megköveteli hang / wav\" fájlokat, hogy egy elfogadott média típusa szerint \"Fájl feltöltése\" beállításokat.","Message_DateFormat":"Dátum formátum","Message_DateFormat_Description":"Lásd még: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Üzenet törlése folyamatban nem engedélyezett","Message_editing_blocked":"Ez az üzenet nem lehet szerkeszteni többé","Message_editing_not_allowed":"Üzenet szerkesztése nem engedélyezett","Message_GroupingPeriod":"Csoportosítása idő (másodperc)","Message_GroupingPeriodDescription":"Üzenetek lesznek csoportosítva a korábbi üzenetet, ha mindkettő ugyanannak a felhasználónak és az eltelt idő kevesebb volt, mint a tájékozott időt másodpercben.","Message_KeepHistory":"Az üzenet legyen története","Message_MaxAllowedSize":"Maximális megengedett Üzenetméret","Message_MaxAll":"Maximális csatorna mérete az ÖSSZES üzenet","Message_pinned":"üzenet tűzött","Message_pinning_not_allowed":"Üzenet lábkiosztás nem engedélyezett","Message_removed":"üzenet eltávolított","Message_ShowDeletedStatus":"Törölt állapota","Message_ShowEditedStatus":"Mutasd Szerkesztette állapota","Message_ShowFormattingTips":"Itt található Formázási tippek","Message_TimeFormat":"Idő formátum","Message_TimeFormat_Description":"Lásd még: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Az üzenet túl hosszú","Messages":"Üzenetek","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Küldött üzenetek a Bejövő WebHook felteszik itt.","Meta":"meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Webhelyellenőrző","Meta_language":"Nyelv","Meta_msvalidate01":"MSValidate.01","Meta_robots":"robotok","minutes":"percek","Mobile_push":"Mobile push-","More_channels":"Még több csatorna","More_direct_messages":"Több közvetlen üzenetek","More_groups":"Több privát csoport","More_unreads":"több unreads","Msgs":"Üzik","multi":"több","Mute_someone_in_room":"Mute valaki a szobában","Mute_user":"Mute felhasználó","Muted":"Tompított","My_Account":"A fiókom","n_messages":"s% üzenetek","N_new_messages":" %s új üzenet","Name":"Név","Name_cant_be_empty":"A név nem lehet üres","Name_of_agent":"Az anyag neve","Name_optional":"Név (kötelező)","Navigation_History_20_last_pages":"Navigáció történelem (20 Utolsó oldal)","New_Application":"új alkalmazás","New_Custom_Field":"Új egyéni mező","New_Department":"új Osztály","New_integration":"új integráció","New_logs":"új naplók","New_messages":"Új üzenet","New_password":"Új jelszó","New_role":"új szerep","No_channel_with_name_%s_was_found":"Nem található csatorna neve <strong>\" %s\"</strong> találtak!","No_channels_yet":"Még nem vagy tagja egy csatornának sem.","No_direct_messages_yet":"Még nem kezdeményeztél beszélgetést","No_Encryption":"nincs titkosítás","No_favorites_yet":"Még nincsenek kedvenceid.","No_group_with_name_%s_was_found":"Nem privát csoport neve <strong>\" %s\"</strong> találtak!","No_groups_yet":"Még nincsenek privát csoportjaid","No_livechats":"Nincsenek livechats.","No_mentions_found":"Nincs említés talált","No_permission_to_view_room":"Ezt a szobát nem tekintheted meg","No_pinned_messages":"Nem rögzített üzenetek","No_results_found":"Nincs találat","No_starred_messages":"Nincsenek csillagozott üzenetek","no_tokens_for_this_user":"Nincsenek zsetonok felhasználó","No_user_with_username_%s_was_found":"Nincs felhasználó <strong>felhasználónév: \" %s\"</strong> találtak!","Not_allowed":"Nem megengedett","Not_authorized":"nem engedélyezett","Not_Available":"Nem elérhető","Not_found_or_not_allowed":"Nem található vagy Nem engedett","Nothing":"Semmi","Nothing_found":"Nem találtam semmit","Notifications":"Értesítések","Notify_all_in_this_room":"Értesíti az összes ebben a szobában","Num_Agents":"# minőségben","Number_of_messages":"Üzenetek száma","OAuth_Application":"OAuth Application","OAuth_Applications":"OAuth alkalmazások","Objects":"tárgyak","Off_the_record_conversation":"Off-the-record beszélgetés","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record beszélgetés nem érhető el a böngésző vagy az eszköz.","Offline_DM_Email":"[__site__] Te már közvetlen üzenetben által __user__","Offline_Mention_Email":"[__site__] Meg kellett volna említeni a __user__ a #__room__","Old_and_new_password_must_be_different":"Az új jelszó nem lehet azonos a régi jelszót.","Old_and_new_password_required":"Meg kell adnia a régi és az új jelszót a jelszó megváltoztatása.","Online":"Elérhető","Only_errors":"csak hibák","Only_you_can_see_this_message":"Csak akkor látni ezt az üzenetet","Oops!":"Hoppá","Open":"Nyisd ki","Opened":"Nyitott","Opt_out_statistics":"Ne küldje statisztikák Rocket.Chat","Opt_out_statistics_warning":"Elküldi a statisztikát, akkor segítenek azonosítani, hogy hány példányban Rocket.Chat telepítettek, valamint, hogy milyen jó a rendszer úgy viselkedik, így tudjuk tovább javítani. Ne aggódj, a felhasználói információ nem küldött, és az összes információt kapunk bizalmasan kezeljük. Ha azt szeretnénk, hogy továbbra is küldjön nekünk statisztikák, törölje a fenti jelölőnégyzetet. Köszönöm.","optional":"választható","Order":"Rendelés","OS_Arch":"OS Arch","OS_Cpus":"Operációs rendszer CPU Count","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Average","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Összes memória","OS_Type":"OS Type","OS_Uptime":"OS üzemidő","others":"mások","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR csak ha mindkét online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Felülírása URL, amelyre fájlok feltöltése. Ez az URL is használható letöltések hacsak CDN kap","Password":"Jelszó","Password_Change_Disabled":"Az Rocket.Chat rendszergazda letiltotta a változó jelszavakat","Password_changed_successfully":"Jelszó sikeresen módosítva","Payload":"Hasznos teher","People":"Emberek","Permissions":"Engedélyek","Pin_Message":"pIN-üzenet","Pinned_a_message":"Rögzítette egy üzenetet:","Pinned_Messages":"Rögzítette üzenetek","Placeholder_for_email_or_username_login_field":"Helyőrzőjére email vagy felhasználónév bejelentkezési mező","Placeholder_for_password_login_field":"Placeholder jelszó bejelentkezési mező","Please_answer_survey":"Kérjük, szánjon egy kis választ egy gyors felmérést erről csevegés","Please_enter_value_for_url":"Kérjük, adjon meg egy értéket az url az avatar.","Please_enter_your_new_password_below":"Kérjük, adja meg az új jelszót:","Please_fill_a_label":"Kérjük, töltse ki a címkét","Please_fill_a_name":"Kérjük, töltse ki a név","Please_fill_a_username":"Kérjük, töltse ki a felhasználónév","Please_fill_name_and_email":"Kérjük, töltse ki nevét és email","Please_re_enter_your_password":"Kérjük adja meg újra a jelszavát","Please_select_enabled_yes_or_no":"Kérjük, válasszon ki egy lehetőséget az Enabled","Please_wait":"Várj egy kicsit","Please_wait_activation":"Kérjük, várjon, ez eltarthat egy ideig.","Please_wait_statistics":"Kérjük, várjon, statisztikák kerülnek keletkezik.","Please_wait_while_OTR_is_being_established":"Kérem várjon, amíg OTR létrehozásakor","Please_wait_while_your_account_is_being_deleted":"Kérem várjon, amíg a fiók törlésre kerül ...","Please_wait_while_your_profile_is_being_saved":"Kérem várjon, amíg a profil mentése folyamatban ...","Post_as":"Post","Post_to_Channel":"Hozzászólás Channel","Post_to_s_as_s":"<strong>Hozzászólás:% <strong>s%</strong></strong> <strong>s</strong>","Powered_by":"a szolgáltatás motorja","Preferences":"preferenciák","Preferences_saved":"A beállítások elmentve","Privacy":"Adatvédelem","Private_Group":"Private Csoport","Private_Groups":"Privát csoportok","Private_Groups_list":"List of Private Groups","Profile":"Profil","Profile_saved_successfully":"Profil sikeresen mentve","Proudly_developed":"Meteor-al büszkén fejlesztve","Push":"Nyom","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Jelszó","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Jelszó","Push_debug":"Debug","push_disabled":"tolja a fogyatékkal","Push_enable":"Engedélyezze","Push_enable_gateway":"engedélyezze Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API kulcs","Push_gcm_project_number":"GCM projekt száma","Push_production":"Termelés","Push_show_message":"Itt található az üzenet az értesítési","Push_show_username_room":"-Es csatorna / csoport / felhasználónév az értesítési","Push_test_push":"Teszt","Query":"kérdés","Query_description":"További feltételek meghatározására, hogy mely felhasználók küldeni a levelet. Feliratkozott felhasználók automatikusan eltávolításra kerülnek a lekérdezés. Meg kell egy érvényes JSON. Példa: \"{\" CreatedAt \": {\" $ gt \": {\" $ date \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Gyors keresés","quote":"idézet","Reactions":"reakciók","Recents":"Legújabb","Record":"Rekord","Redirect_URI":"Átirányítás URI","Refresh_keys":"Frissítés kulcsok","Refresh_your_page_after_install_to_enable_screen_sharing":"Frissítse az oldalt, telepítés után, hogy a képernyő megosztásának","Register":"Új fiók regisztálása","Registration_Succeeded":"Regisztráció Sikeres","Remember_me":"Emlékezz rám","Remove":"Eltávolít","Remove_Admin":"Távolítsuk Admin","Remove_as_moderator":"Távolítsuk el a moderátor","Remove_as_owner":"Távolítsuk el a tulajdonos","Remove_custom_oauth":"Távolítsa el az egyéni OAuth","Remove_from_room":"Vegyük le a szoba","Remove_someone_from_room":"Távolítsuk el valaki a szobában","Removed":"eltávolított","Require_password_change":"Igényel jelszócsere","Resend_verification_email":"Igazoló e-mail újraküldése","Reset":"visszaállítása","Reset_password":"Jelszó visszaállítása","Restart":"Újrakezd","Restart_the_server":"Indítsa újra a kiszolgálót","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"RocketBot neve","RocketBot_Name_Description":"RocketBot nevet kell érvényes felhasználónévvel regisztrálva a szerveren.","Role":"Szerep","Role_Editing":"szerep szerkesztése","Role_removed":"Role eltávolított","Room":"Szoba","Room_archivation_state":"Állami","Room_archivation_state_false":"Aktív","Room_archivation_state_true":"archivált","Room_archived":"szoba archivált","room_changed_privacy":"Szoba típusa változott: <em>__room_type__</em> által <em>__user_by__</em>","room_changed_topic":"Szoba téma változott: <em>__room_topic__</em> által <em>__user_by__</em>","Room_has_been_deleted":"Szoba törölve lett","Room_Info":"szoba információk","Room_name_changed":"A szoba neve megváltozott: <em>__room_name__</em>, megváltoztatta <em>__user_by__</em>","Room_name_changed_successfully":"A szoba neve sikeresen megváltozott","Room_not_found":"Szoba nem talált","Room_topic_changed_successfully":"Szoba téma sikeresen módosítva","Room_type_changed_successfully":"Szoba típusa megváltozott sikeresen","Room_unarchived":"szoba archivált","Room_uploaded_file_list":"fájlok","Room_uploaded_file_list_empty":"Nincs fájl is elérhető.","room_user_count":" %s felhasználó","Rooms":"szobák","S_new_messages_since_s":" %s új üzenet óta %s","SAML":"SAML","SAML_Custom_Cert":"Egyedi tanúsítvány","SAML_Custom_Entry_point":"Egyedi Entry Point","SAML_Custom_Generate_Username":"generálása Felhasználónév","SAML_Custom_Issuer":"Egyedi Kibocsátó","SAML_Custom_Provider":"Egyedi Szolgáltató","Save":"Mentés","Save_changes":"Változtatások mentése","Save_Mobile_Bandwidth":"Save Mobile sávszélesség","Save_to_enable_this_action":"Mentse, hogy ezt a műveletet","Saved":"Mentett","Saving":"Megtakarítás","Scope":"Alkalmazási kör","Screen_Share":"képernyő megosztása","Script_Enabled":"Script engedélyezve","Search":"Keresés","Search_by_username":"Keresés felhasználónév","Search_Channels":"Keresés Csatornák","Search_Direct_Messages":"Keresés közvetlen üzenetek","Search_Messages":"Üzenetek keresése","Search_Private_Groups":"Keresés Privát Csoportok","Search_settings":"Keresési beállítások","seconds":"másodperc","See_all":"Összes megtekintése","See_only_online":"Csak online","Select_a_department":"Válasszon egy osztály","Select_an_avatar":"Válassz képet","Select_file":"File kiválasztása","Select_service_to_login":"Válasszon ki egy szolgáltatást, hogy jelentkezzen be, hogy töltse be a képet, vagy feltölteni egy közvetlenül a számítógépről","Select_user":"Válasszon felhasználó","Select_users":"felhasználók kiválasztása","Selected_agents":"Válogatott szerek","Selected_users":"Kiválasztott tagok","Send":"Elküld","Send_a_message":"Üzenetet küldeni","Send_a_test_mail_to_my_user":"Küldj egy teszt mailt a használati","Send_a_test_push_to_my_user":"Küldj egy teszt push a használati","Send_confirmation_email":"Megerősítő email elküldése","Send_data_into_RocketChat_in_realtime":"Adatok küldése a Rocket.Chat valós időben.","Send_email":"Küldjön e-mailt","Send_invitation_email":"Meghívás küldése e-mailben","Send_invitation_email_error":"Nem adtál meg e-mail címre.","Send_invitation_email_info":"Küldhet több e-mail meghívók egyszerre.","Send_invitation_email_success":"Sikeresen küldött meghívó e-mailt az alábbi címre:","Send_invitation_email_warning":"Annak érdekében, hogy küldjön meghívót e-maileket, akkor először be kell állítania az SMTP beállításokat.","Send_Message":"Üzenet küldése","Send_your_JSON_payloads_to_this_URL":"Küldje el JSON rakományának erre az URL.","Sending":"Küldés ...","Set_as_moderator":"Beállítás moderátor","Set_as_owner":"Beállítás tulajdonos","Settings":"Beállítások","Settings_updated":"beállítások frissítve","Should_be_a_URL_of_an_image":"Kell egy kép URL-je.","Should_exists_a_user_with_this_username":"A felhasználó már léteznie kell.","Show_all":"Mutasd az összeset","Show_more":"Mutass többet","Show_only_online":"Csak online","Show_preregistration_form":"Itt található az előzetes regisztrációs űrlapot","Showing_archived_results":"<p> A <b>következő %s</b> archivált eredmények </p>","Showing_online_users":"<b>__total_showing__</b> online a __total___ felhasználóból","Showing_results":"<p><b>%s</b> eredmény megjelenítve</p>","Silence":"Némítás","since_creation":"%s óta","Site_Name":"webhely neve","Site_Url":"Az oldal URL","Site_Url_Description":"Példa: https://chat.domain.com/","Skip":"Skip","Smileys_and_People":"Hangulatjelek és emberek","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP jelszó","SMTP_Port":"SMTP Port","SMTP_Test_Button":"Test SMTP beállítások","SMTP_Username":"SMTP felhasználónév","Sound":"Hang","Star_Message":"Csillagok Message","Starred_Messages":"Csillaggal megjelölt üzenetek","Start_audio_call":"Kezdés audio hívást","Start_Chat":"Start Chat","Start_of_conversation":"Beszélgetés kezdete","Start_OTR":"Indítás OTR","Start_video_call":"Videohívás indítása","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Kezdje <code class=\"inline\">%s</code> felhasználó vagy <code class=\"inline\">%s</code> csatorna. Pl: <code class=\"inline\">%s</code> vagy <code class=\"inline\">%s</code>","Statistics":"Statisztika","Stats_Active_Users":"aktív felhasználók","Stats_Avg_Channel_Users":"Átlagos Channel Felhasználók","Stats_Avg_Private_Group_Users":"Átlagos Private Csoport Felhasználók","Stats_Away_Users":"Idegenben felhasználók","Stats_Max_Room_Users":"Max szobák Felhasználók","Stats_Non_Active_Users":"inaktív felhasználók","Stats_Offline_Users":"Offline felhasználók","Stats_Online_Users":"Online felhasználók","Stats_Total_Channels":"Összesen csatornák","Stats_Total_Direct_Messages":"Összesen Direct Message szobák","Stats_Total_Messages":"Összes üzenet","Stats_Total_Private_Groups":"Összesen Private Groups","Stats_Total_Rooms":"Összesen szobák","Stats_Total_Users":"felhasználók","Stop_Recording":"Felvétel leállítása","strike":"sztrájk","Subject":"Tantárgy","Submit":"Elküldés","Success":"Siker","Survey":"Felmérés","Survey_instructions":"Szavazz minden kérdésre az Ön elégedettsége, 1 ami azt jelenti, teljesen elégedetlen, és 5 ami azt jelenti, hogy teljesen elégedett.","Symbols":"szimbólumok","Sync_success":"Szinkronizálás siker","Sync_Users":"Szinkronizálás felhasználók","Test_Connection":"kapcsolat tesztelése","Test_Desktop_Notifications":"Test Asztali értesítések","Thank_you_for_your_feedback":"Köszönjük a visszajelzést","The_application_name_is_required":"Az alkalmazás neve szükséges","The_channel_name_is_required":"A csatorna neve szükséges","The_emails_are_being_sent":"Az e-mailek küldésére is.","The_field_is_required":"A %s mezőben van szükség.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"A kép átméretezés nem fog működni, mert nem tudjuk észlelni ImageMagick vagy GraphicsMagick szerveren telepítve.","The_redirectUri_is_required":"A redirectUri szükséges","The_server_will_restart_in_s_seconds":"A szerver újraindul %s másodperc","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"A <strong>beállítás %s</strong> van beállítva, <strong>hogy %s</strong> és akkor férnek <strong>hozzá: %s!</strong>","The_user_will_be_removed_from_s":"A felhasználó eltávolításra kerül %s","The_user_wont_be_able_to_type_in_s":"A felhasználó nem lesz képes, hogy írja be a %s","Theme":"Téma","theme-color-action-buttons-color":"Hozzászólások gombok színe","theme-color-active-channel-background-color":"Aktív csatorna háttérszíne","theme-color-active-channel-font-color":"Aktív csatorna Betűszín","theme-color-blockquote-background":"Idézetblokk háttérszíne","theme-color-clean-buttons-color":"Tiszta gombok színe","theme-color-code-background":"Kód háttérszíne","theme-color-code-border":"Kód Szegélyszín","theme-color-code-color":"Code Color","theme-color-content-background-color":"Tartalom háttérszíne","theme-color-custom-scrollbar-color":"Egyedi Scrollbar Color","theme-color-info-active-font-color":"Aktív Info Betűszín","theme-color-info-font-color":"Info Betűszín","theme-color-input-font-color":"Input Betűszín","theme-color-link-font-color":"Link Betűszín","theme-color-message-hover-background-color":"Üzenet Hover BG Color","theme-color-primary-background-color":"Elsődleges háttérszíne","theme-color-primary-font-color":"Elsődleges Betűszín","theme-color-quaternary-font-color":"Negyedidőszaki Betűszín","theme-color-secondary-background-color":"Másodlagos háttérszíne","theme-color-secondary-font-color":"Másodlagos Betűszín","theme-color-smallprint-font-color":"Kis Print Betűszín","theme-color-smallprint-hover-color":"Kis Print Hover Color","theme-color-status-away":"Idegenben állapot Szín","theme-color-status-busy":"Foglalt állapot Szín","theme-color-status-offline":"Offline állapot Szín","theme-color-status-online":"Online állapot Szín","theme-color-tertiary-background-color":"Harmadlagos háttérszíne","theme-color-tertiary-font-color":"Harmadlagos Betűszín","theme-color-unread-notification-color":"Olvasatlan értesítés Color","theme-custom-css":"egyéni CSS","There_are_no_agents_added_to_this_department_yet":"Nincsenek ügynökök hozzá ezen az osztályon még.","There_are_no_integrations":"Nincsenek integrációk","There_are_no_users_in_this_role":"Nincsenek felhasználók ebben a szerepben.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ez az e-mail már felhasználták, és még nem igazolták. Kérjük, változtassa meg a jelszavát.","This_is_a_desktop_notification":"Ez egy asztali értesítés","This_is_a_push_test_messsage":"Ez egy push teszt messsage","Time_in_seconds":"Az az idő másodpercben","Title_bar_color":"Cím sáv színe","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Telepíteni Rocket.Chat GYIK a honlapon, másolja be ezt a kódot a fenti utolsó <strong></ body></strong> tag a webhelyen.","To_users":"Ahhoz, hogy a felhasználók","Topic":"Téma","Travel_and_Places":"Utazás és helyek","Trigger_removed":"Trigger eltávolított","Trigger_Words":"parancsszavakat","Triggers":"triggerek","True":"Igaz","Type":"típus","Type_your_new_password":"Írja be az új jelszót","Unarchive":"Archiválás megszüntetése","Unmute_someone_in_room":"Unmute valaki a szobában","Unmute_user":"Unmute felhasználó","Unnamed":"megnevezetlen","Unpin_Message":"Unpin Message","Unread_Rooms":"olvasatlan szobák","Unread_Rooms_Mode":"Olvasatlan szobák Mode","Unstar_Message":"csillag eltávolítása","Upload_file_question":"Fájl feltöltés?","Uploading_file":"Fájl feltöltése ...","Use_account_preference":"Használja számla preferencia","Use_Emojis":"Felhasználási hangulatjelek","Use_initials_avatar":"Használd a felhasználónév kezdőbetűi","use_menu":"Használd az oldalsó menüt hogy elérd a beszélgetéseidet és a szobákat","Use_service_avatar":"%s használata","Use_this_username":"Használd ezt a felhasználónevet","Use_uploaded_avatar":"Feltöltött kép használata","Use_url_for_avatar":"Használja url avatar","User__username__is_now_a_moderator_of__room_name_":"Felhasználó __username__ most egy moderátor __room_name__","User__username__is_now_a_owner_of__room_name_":"Felhasználó __username__ most tulajdonosa __room_name__","User__username__removed_from__room_name__moderators":"Felhasználó __username__ távolítani __room_name__ moderátorok","User__username__removed_from__room_name__owners":"Felhasználó __username__ távolítani __room_name__ tulajdonosok","User_added":"<em>__user_added__</em> hozzáadva.","User_added_by":"<em>__user_added__</em> felhasználót hozzáadta <em>__user_by__</em>.","User_added_successfully":"Felhasználó sikeresen hozzáadva","User_Channels":"felhasználói csatornák","User_doesnt_exist":"Nincs felhasználó létezik, a neve `@ %s`.","User_has_been_activated":"Felhasználó aktiválva lett","User_has_been_deactivated":"Felhasználói deaktivált","User_has_been_deleted":"Felhasználó törölve","User_has_been_muted_in_s":"Felhasználói némítva lett a %s","User_has_been_removed_from_s":"Felhasználói eltávolították %s","User_has_disconnected":"Felhasználói lekapcsolódott","User_Info":"User Info","User_is_no_longer_an_admin":"A felhasználó már nem egy admin","User_is_not_activated":"Felhasználó nem aktív","User_is_now_an_admin":"Felhasználó most egy admin","User_joined_channel":"Csatlakozott a csatorna.","User_joined_channel_female":"Csatlakozott a csatorna.","User_joined_channel_male":"Csatlakozott a csatorna.","User_left":"<em>__user_left__</em> kilépett.","User_left_female":"Elhagyta a csatornát.","User_left_male":"Elhagyta a csatornát.","User_logged_out":"Nem elérhető","User_management":"User Management","User_muted_by":"Felhasználói <em>__user_muted__</em> elnémítva <em>__user_by__.</em>","User_muted_in_room":"Felhasználói némítva a szobában","User_not_found":"Felhasználó nem található","User_not_found_or_incorrect_password":"Felhasználó nem található vagy hibás jelszó","User_or_channel_name":"Felhasználó vagy csatorna neve","User_removed":"A felhasználó eltávolította","User_removed_by":"<em>__user_removed__</em> felhasználót eltávolította <em>__user_by__</em>","User_removed_from_room":"A felhasználó el lett távolítva a szoba","User_Settings":"felhasználói beállítások","User_unmuted_by":"Felhasználói <em>__user_unmuted__</em> hangjának újbóli által <em>__user_by__.</em>","User_unmuted_in_room":"A felhasználó elnémítása megszüntetve a szobában","User_updated_successfully":"Felhasználó sikeresen frissítve","Username":"Felhasználónév","Username_and_message_must_not_be_empty":"A felhasználónév és az üzenetet nem lehet üres.","Username_cant_be_empty":"A felhasználónév nem lehet üres","Username_Change_Disabled":"Az Rocket.Chat rendszergazda letiltotta a változó felhasználói nevek","Username_denied_the_OTR_session":"__username__ tagadta a OTR ülés","Username_description":"A felhasználónév arra kel hogy meg tudjanak említeni beszélgetésekben.","Username_doesnt_exist":"A felhasználónév ` %s` nem létezik.","Username_ended_the_OTR_session":"__username__ véget ért az OTR ülés","Username_invalid":"<strong>%s</strong> felhasználónév nem érvényes,<br/> kérlek csak betűket, számokat, pontokat vagy kötőjeleket használj","Username_is_already_in_here":"`@ %s` már itt.","Username_is_not_in_this_room":"A felhasználó `# %s` nem ebben a szobában.","Username_not_found":"A felhasználónév nem található","Username_title":"Felhasználónév regisztrálása","Username_unavaliable":"<strong>%s</strong>  név már használatban van :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ akar kezdeni OTR. Szeretné, hogy elfogadja?","Users":"felhasználók","Users_in_role":"Felhasználók szerepe","UTF8_Names_Slugify":"UTF8 nevek Slugify","UTF8_Names_Validation":"UTF8 nevek Validation","UTF8_Names_Validation_Description":"Ne hagyja, hogy speciális karaktereket és szóközt. Használhatja - _ és. de nem a végén a név","Verification_email_sent":"E-mailt elküldtük","View_All":"Összes megtekintése","View_Logs":"Naplók megtekintése","Visibility":"Láthatóság","Visible":"Látható","Visitor":"Látogató","Visitor_page_URL":"Látogatói oldal URL","Visitor_time_on_site":"Látogató az oldalon eltöltött idő","Wait_activation_warning":"Mielőtt bejelentkezés fiókját manuálisan kell aktiválni a rendszergazda.","We_are_offline_Sorry_for_the_inconvenience":"Mi vagyunk az offline. Elnézést a kellemetlenségért.","We_have_sent_password_email":"Elküldtünk egy email-t a jelszó visszaállítás lépéseiről. Ha hamarosan nem érkezne meg, akkor gyere vissza és próbáld újra.","We_have_sent_registration_email":"Küldtünk egy email-t hogy megerősíthessük a regisztrációt. Ha nem kapnál hamarosan levelet akkor gyere vissza később és próbáld újra.","WebRTC_Enable_Channel":"Engedélyezze a közszolgálati csatornákon","WebRTC_Enable_Direct":"Engedélyezze a közvetlen üzenetek","WebRTC_Enable_Private":"Engedélyezze Private Csatornák","WebRTC_Servers":"STUN / TURN Szerverek","WebRTC_Servers_Description":"A listát a STUN és TURN szerverek vesszővel elválasztva. <br/> Felhasználónév, jelszó és a port engedélyezett a formában `felhasználónév: jelszó @ stun: host: port` vagy` felhasználónév: jelszó @ fordulat: host: port`.","Welcome":"Üdvözöllek <em>%s</em>","Welcome_to_the":"Üdvözöllek a","will_be_able_to":"képes lesz","With_whom":"Kivel","Yes":"Igen","Yes_clear_all":"Igen, tiszta minden!","Yes_delete_it":"Igen, töröld!","Yes_hide_it":"Igen, elrejteni!","Yes_leave_it":"Igen, hagyjuk!","Yes_mute_user":"Igen, néma felhasználó!","Yes_remove_user":"Igen, távolítsa el a felhasználó!","you_are_in_preview_mode_of":"Ön előnézeti módban a csatorna # <strong>__room_name__</strong>","You_are_logged_in_as":"Be van jelentkezve a","You_are_not_authorized_to_view_this_page":"Ön nem jogosult az oldal megtekintésére.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Te vagy az utolsó tulajdonosa. Kérjük, állítsa be az új tulajdonos, mielőtt elhagyja a szobát.","You_can_change_a_different_avatar_too":"Ön felülbírálhatja az avatar közzétevő ebből integráció.","You_can_use_an_emoji_as_avatar":"Ön is használja a hangulatjel, mint egy avatar.","You_have_been_muted":"Akkor került lezárásra, és nem tud beszélni ebben a szobában","You_have_not_verified_your_email":"Ön még nem igazolta az e-mail.","You_have_successfully_unsubscribed":"Sikeresen leiratkozott a Mailling List.","You_informed_an_invalid_FROM_address":"Informálják érvénytelen feladó címét.","You_must_provide_the_unsubscribe_link":"Meg kell adnia a [leiratkozás] linkre.","You_need_confirm_email":"Kérlek hitelesítsd az email címed a bejelntkezéshez","You_need_install_an_extension_to_allow_screen_sharing":"Be kell telepíteni kiterjesztése a képernyő megosztás","You_need_to_change_your_password":"Meg kell változtatni a jelszót","You_need_to_type_in_your_password_in_order_to_do_this":"Be kell, hogy írja be a jelszót, hogy ezt tegye!","You_need_to_type_in_your_username_in_order_to_do_this":"Be kell, hogy írja be a felhasználónevét annak érdekében, hogy ezt tegye!","You_need_to_verifiy_your_email_address_to_get_notications":"Meg kell verifiy e-mail címét, hogy értesítést","You_should_name_it_to_easily_manage_your_integrations":"Meg kell neveznie azt könnyedén kezelheti a integrációk.","You_will_not_be_able_to_recover":"Ön nem lesz képes visszaállítani ezt az üzenetet!","You_will_not_be_able_to_recover_file":"Ön nem lesz képes visszaállítani a fájlt!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Nem fog kapni e-mailben értesítést, mert nem ellenőrizte az e-mail.","Your_email_has_been_queued_for_sending":"Az e-mail várólistára került küldő","Your_entry_has_been_deleted":"A bejegyzés törölve lett.","Your_file_has_been_deleted":"A fájl törölve lett.","Your_mail_was_sent_to_s":"A mail-ben küldött %s","Your_Open_Source_solution":"A saját Nyílt Forrású chat-ed","Your_password_is_wrong":"A jelszó rossz!","Your_push_was_sent_to_s_devices":"Push küldték %s eszközök"});
TAPi18n._registerServerTranslator("hu", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/it.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["it"] = ["Italian","Italiano"];                                                                // 8
if(_.isUndefined(TAPi18n.translations["it"])) {                                                                        // 9
  TAPi18n.translations["it"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["it"][namespace])) {                                                             // 13
  TAPi18n.translations["it"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["it"][namespace], {"500":"Errore interno del server","0_Errors_Only":"Solo errori - 0","1_Errors_and_Information":"1 - Errori e informazioni","2_Erros_Information_and_Debug":"2 - Erros, informazione e di debug","__username__was_set__role__by__user_by_":"__username__ è stato fissato __role__ da __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ non è più __role__, da __user_by__","Access_not_authorized":"L'accesso non autorizzato","Access_online_demo":"Accedi la demo online","Access_Online_Demo":"Accedi la Demo Online","Access_Token_URL":"Token di accesso URL","Accounts":"conti","Accounts_AllowDeleteOwnAccount":"Consentire agli utenti di eliminare conto proprio","Accounts_AllowedDomainsList":"Lista Domini ammessi","Accounts_AllowedDomainsList_Description":"elenco separato da virgole di domini consentiti","Accounts_AllowEmailChange":"Consentire e-mail Change","Accounts_AllowPasswordChange":"Consentire Password Change","Accounts_AllowUserAvatarChange":"Consentire L'avatar Change","Accounts_AllowUsernameChange":"Consentire Nome utente Change","Accounts_AllowUserProfileChange":"Consentire Profilo utente Change","Accounts_AvatarResize":"Ridimensiona Avatars","Accounts_AvatarSize":"Avatar Size","Accounts_AvatarStorePath":"Percorso Avatar bagagli","Accounts_AvatarStoreType":"Avatar tipo di archiviazione","Accounts_BlockedDomainsList":"Elenco domini bloccati","Accounts_BlockedDomainsList_Description":"elenco separato da virgole dei domini bloccati","Accounts_denyUnverifiedEmail":"Nega email non verificato","Accounts_EmailVerification":"Verifica email","Accounts_EmailVerification_Description":"Assicurati di avere impostazioni SMTP corrette per utilizzare questa funzione","Accounts_Enrollment_Email":"L'iscrizione e-mail","Accounts_Enrollment_Email_Description":"È possibile utilizzare [nome], [fname], [lname] per il nome completo dell'utente, nome o cognome, rispettivamente. <br /> È possibile utilizzare [email] per e-mail dell'utente.","Accounts_Iframe_api_method":"metodo API","Accounts_Iframe_api_url":"Api URL","Accounts_iframe_enabled":"Abilitato","Accounts_iframe_url":"Iframe URL","Accounts_LoginExpiration":"Scadenza Accesso a giorni","Accounts_ManuallyApproveNewUsers":"Approvare manualmente nuovi utenti","Accounts_OAuth_Custom_Token_Sent_Via":"Token Inviato via","Accounts_OAuth_Custom_Authorize_Path":"Autorizza Path","Accounts_OAuth_Custom_Button_Color":"Colore pulsante","Accounts_OAuth_Custom_Button_Label_Color":"Pulsante Colore testo","Accounts_OAuth_Custom_Button_Label_Text":"Testo pulsante","Accounts_OAuth_Custom_Enable":"consentire","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Percorso identità","Accounts_OAuth_Custom_Login_Style":"Stile Accesso","Accounts_OAuth_Custom_Secret":"Segreto","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Accesso a Facebook","Accounts_OAuth_Facebook_callback_url":"URL Facebook richiamata","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Segreto","Accounts_OAuth_Github":"OAuth Abilitato","Accounts_OAuth_Github_callback_url":"URL Github richiamata","Accounts_OAuth_GitHub_Enterprise":"OAuth Abilitato","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise richiamata","Accounts_OAuth_GitHub_Enterprise_id":"Identificativo cliente","Accounts_OAuth_GitHub_Enterprise_secret":"client Segreto","Accounts_OAuth_Github_id":"Identificativo cliente","Accounts_OAuth_Github_secret":"client Segreto","Accounts_OAuth_Gitlab":"OAuth Abilitato","Accounts_OAuth_Gitlab_callback_url":"URL GitLab richiamata","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"client Segreto","Accounts_OAuth_Google":"Google Accesso","Accounts_OAuth_Google_callback_url":"URL di Google Callback","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Segreto","Accounts_OAuth_Linkedin":"LinkedIn Accesso","Accounts_OAuth_Linkedin_callback_url":"URL Linkedin richiamata","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Segreto","Accounts_OAuth_Meteor":"Meteor Accesso","Accounts_OAuth_Meteor_callback_url":"URL Meteor richiamata","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Segreto","Accounts_OAuth_Twitter":"Twitter login","Accounts_OAuth_Twitter_callback_url":"URL Twitter Callback","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Segreto","Accounts_OAuth_Wordpress":"WordPress Accesso","Accounts_OAuth_Wordpress_callback_url":"URL Wordpress richiamata","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Segreto","Accounts_PasswordReset":"Reimpostazione della password","Accounts_Registration_AuthenticationServices_Enabled":"Registrazione presso Authentication Services","Accounts_RegistrationForm":"Formulario di registrazione","Accounts_RegistrationForm_Disabled":"Disabilitato","Accounts_RegistrationForm_LinkReplacementText":"Testo Modulo di registrazione link Sostituzione","Accounts_RegistrationForm_Public":"Pubblico","Accounts_RegistrationForm_Secret_URL":"URL Segreto","Accounts_RegistrationForm_SecretURL":"Modulo di registrazione segreto URL","Accounts_RegistrationForm_SecretURL_Description":"È necessario fornire una stringa casuale che verrà aggiunto al vostro URL di registrazione. Esempio: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"registrazione Richiesto","Accounts_RequireNameForSignUp":"Richiede nome per iscrizione","Accounts_ShowFormLogin":"Accesso a base di modulo Visualizza","Accounts_UseDefaultBlockedDomainsList":"Utilizza default bloccati Lista Domini","Accounts_UseDNSDomainCheck":"Utilizzare dominio DNS Controllare","Activate":"Attivare","Activity":"Attività","Add":"Aggiungere","Add_agent":"Aggiungere agente","Add_custom_oauth":"Aggiungere OAuth personalizzato","Add_manager":"Aggiungere direttore","Add_Members":"Aggiungi membri","Add_User":"Aggiungi utente","Add_user":"Aggiungi utente","Add_users":"Aggiungere utenti","Additional_emails":"Ulteriori e-mail","Additional_Feedback":"Commenti aggiuntivi","Administration":"Amministrazione","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Dopo l'autenticazione OAuth2, gli utenti saranno reindirizzati a questo URL","Agent_added":"Agente aggiunto","Agent_removed":"Agente rimosso","Alias":"Alias","All":"Tutti","All_channels":"tutti i canali","All_logs":"tutti i registri","All_messages":"tutti i messaggi","Allow_Invalid_SelfSigned_Certs":"Consentire valido autofirmato Certs","Allow_Invalid_SelfSigned_Certs_Description":"Consentire di certificati SSL non validi e auto-firmato per la validazione di collegamento e anteprime.","and":"e","And_more":"E più __length __...","Animals_and_Nature":"Animali & Natura","API":"API","API_Analytics":"analitica","API_Embed":"Incorporare","API_EmbedDisabledFor":"Incorpora Disabilita per gli utenti","API_EmbedDisabledFor_Description":"elenco separato da virgole di nomi utente","API_GitHub_Enterprise_URL":"URL del server","API_GitHub_Enterprise_URL_Description":"Esempio: http://domain.com (escluso slash)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"URL WordPress","Appearance":"Aspetto","Application_added":"Applicazione aggiunto","Application_Name":"Nome dell'applicazione","Application_updated":"applicazione aggiornata","Apply_and_refresh_all_clients":"Applicare e aggiornare tutti i clienti","Archive":"archivio","Archive_Unarchive":"Archivio / Annulla archiviazione","are_also_typing":"sta digitando anche","are_typing":"sta digitando","Are_you_sure":"Sei sicuro?","Are_you_sure_you_want_to_delete_your_account":"Sei sicuro di voler eliminare il tuo account?","Authorization_URL":"URL Authorization","Authorize":"Autorizzare","AutoLinker_StripPrefix":"AutoLinker Striscia prefisso","AutoLinker_StripPrefix_Description":"visualizzazione breve. ad esempio https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"collegato automaticamente i numeri di telefono. ad esempio, `(123) 456-7890`","Auto_Load_Images":"Immagini Auto Load","Available":"A disposizione","Available_agents":"agenti disponibili","Avatar":"Cambia l'avatar","Avatar_changed_successfully":"Avatar ha cambiato con successo","Avatar_URL":"URL Avatar","Avatar_url_invalid_or_error":"L'URL fornito non è valido o non è accessibile. Riprova, ma con un URL diverso.","away":"via","Away":"Via","away_female":"lontano","Away_female":"Lontano","away_male":"lontano","Away_male":"Lontano","Back":"Indietro","Back_to_applications":"Torna alle applicazioni","Back_to_integrations":"Torna integrazioni","Back_to_login":"Torna al login","Back_to_permissions":"Torna ai permessi","Body":"Corpo","bold":"grassetto","busy":"occupato","Busy":"Occupato","busy_female":"occupato","Busy_female":"Occupato","busy_male":"occupato","Busy_male":"Occupato","Cancel":"Cancellare","Cannot_delete_a_protected_role":"Non è possibile eliminare un ruolo protetta","Cannot_delete_role_because_its_in_use":"Impossibile eliminare il ruolo, perché è in uso","Cannot_invite_users_to_direct_rooms":"Non è possibile invitare gli utenti a dirigere camere","CDN_PREFIX":"CDN Prefisso","Certificates_and_Keys":"Certificati e chiavi","Channel":"Canale","Channel_doesnt_exist":"Il canale `# %s` non esiste.","Channels":"Canali","Channels_list":"Elenco dei canali pubblici","Chat_Rooms":"Stanza di chat","Chatops_Enabled":"Abilita Chatops","Chatops_Title":"Pannello Chatops","Chatops_Username":"Chatops Nome utente","Choose_a_room":"Scegli una stanza","Choose_messages":"Scegli i messaggi","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Scegliere l'alias che verrà visualizzato prima il nome utente nei messaggi.","Choose_the_username_that_this_integration_will_post_as":"Scegliere il nome utente che questa integrazione sarà inviare come.","Clear_all_unreads_question":"Cancellare tutti i unreads?","Client_ID":"Identificativo cliente","Client_Secret":"client Segreto","Clients_will_refresh_in_a_few_seconds":"I clienti potranno aggiornare in pochi secondi","close":"chiudere","Closed":"Chiuso","Collapse_Embedded_Media_By_Default":"Riduci multimediale incorporato per default","coming_soon":"in arrivo","Commands":"comandi","Compact_View":"Vista compatta","Confirm_password":"Conferma la password","Contact":"Contatto","Conversation":"Conversazione","Convert_Ascii_Emojis":"Convertire ASCII a Emoji","Copied":"Copiato","COPY_TO_CLIPBOARD":"COPIA NEGLI APPUNTI","Copy_to_clipboard":"Copia negli appunti","Count":"Contare","Create":"Creare","Create_new":"Creare nuovo","Created_at":"Creato a","Created_at_s_by_s":"Creato <strong>a %s</strong> <strong>da %s</strong>","Custom_Fields":"Campi personalizzati","Custom_oauth_helper":"Quando si imposta il provider di OAuth, dovrete informare un URL di richiamata. Uso <pre> %S </pre> .","Custom_oauth_unique_name":"nome univoco personalizzato oauth","Custom_Script_Logged_In":"Script personalizzato per gli utenti registrati","Custom_Script_Logged_Out":"Script personalizzato per gli utenti registrati fuori","Dashboard":"scrivania","days":"giorni","Deactivate":"Disattivare","Debug_Level":"Livello di debug","Default":"Predefinito","Delete":"cancellare","Delete_my_account":"Cancella il mio account","Delete_Room_Warning":"L'eliminazione di una stanza cancellerà tutti i messaggi inseriti all'interno della stanza. Questo non può essere annullata.","Delete_User_Warning":"L'eliminazione di un utente verranno eliminati tutti i messaggi da quell'utente pure. Questo non può essere annullata.","Deleted":"Eliminata!","Department_not_found":"Dipartimento non trovato","Department_removed":"Dipartimento rimosso","Departments":"dipartimenti","Description":"Descrizione","Desktop":"Desktop","Desktop_Notification_Test":"Desktop test di notifica","Desktop_Notifications":"Notifiche desktop","Desktop_Notifications_Disabled":"Desktop le notifiche sono disattivate. Modificare le preferenze del browser se avete bisogno di notifiche attivate.","Desktop_Notifications_Enabled":"Notifiche desktop sono abilitati","Direct_message_someone":"messaggio qualcuno diretta","Direct_Messages":"Messaggi diretti","Direct_Messages_list":"Messaggi diretti","Disable_Favorite_Rooms":"Disattiva Preferiti","Disable_New_Message_Notification":"Disabilita la notifica nuovo messaggio","Disable_New_Room_Notification":"Disabilita la notifica New Room","Displays_action_text":"testo visualizza azione","Do_you_want_to_change_to_s_question":"Vuoi cambiare <strong>a %s?</strong>","Drop_to_upload_file":"Goccia caricare il file","Dry_run":"Funzionamento a secco","Dry_run_description":"Sarà solo inviare una e-mail, per lo stesso indirizzo a partire. L'e-mail deve appartenere a un utente valido.","Duplicate_archived_channel_name":"Un archiviato canale con il nome ' %s' esiste","Duplicate_archived_private_group_name":"Un gruppo privato archiviato con esiste il nome ' %s'","Duplicate_private_group_name":"Un gruppo privato con nome esiste ' %s'","E-mail":"E-mail","Edit":"Modifica","Edit_Custom_Field":"Modifica campo personalizzato","Edit_Department":"Modifica Dipartimento","edited":"modificato","Email":"E-mail","Email_already_exists":"Email già esistente","Email_body":"corpo e-mail","Email_Change_Disabled":"L'amministratore Rocket.Chat ha disattivato il cambio di e-mail","Email_from":"Da parte di","Email_Notification_Mode":"Offline notifiche e-mail","Email_Notification_Mode_All":"Ogni Menzione / DM","Email_Notification_Mode_Disabled":"Disabilitato","Email_or_username":"Email o nome di utente","Email_subject":"Soggetto","Email_verified":"Email verificata","Emoji":"emoji","Empty_title":"titolo vuoto","Enable":"consentire","Enable_Desktop_Notifications":"Attiva notifiche per il desktop","Enabled":"Abilitato","Encrypted_message":"messaggio cifrato","End_OTR":"fine OTR","Enter_a_regex":"Inserisci una regex","Enter_a_room_name":"Inserire un nome stanza","Enter_a_username":"Inserisci un nome utente","Enter_info":"Digita le tue informazione di login","Enter_name_here":"Inserire il nome qui","Enter_to":"Invio per","Error":"Errore","error-cant-invite-for-direct-room":"Non può invitare all'utente di camere diretti","error-duplicate-channel-name":"Un canale con il nome ' %s' esiste","error-invalid-custom-field":"campo personalizzato non valido","error-invalid-custom-field-name":"Valido nome del campo personalizzato. Utilizzare solo lettere, numeri, trattini e underscore.","error-invalid-password":"Password Invalida","error-invalid-room":"stanza non valido","error-invalid-room-name":"<strong> %s</strong> non è un nome stanza valida, <br/> utilizzare solo lettere, numeri, trattini e underscore","error-invalid-user":"Utente non valido","error-invalid-username":"Nome utente non valido","error-not-allowed":"Non autorizzato","error-not-authorized":"Non autorizzato","error-remove-last-owner":"Questo è l'ultimo proprietario. Si prega di impostare un nuovo proprietario prima di rimuovere questo.","error-role-name-required":"è necessario nome di ruolo","error-user-not-in-room":"L'utente non è in questa stanza","Error_changing_password":"Password cambiata","Error_sending_confirmation_email":"Errore durante l'invio e-mail di conferma","Error_too_many_requests":"Errore, troppe richieste. Per favore rallenta. È necessario attendere %s secondi prima di riprovare","Esc_to":"Esc per","Example_s":"Esempio: <code class=\"inline\">%s</code>","False":"falso","Favorites":"Favorite","Field":"Campo","Field_removed":"campo rimosso","File_exceeds_allowed_size_of_bytes":"File supera la dimensione consentita di byte __size__","FileUpload":"Upload di file","FileUpload_Enabled":"Upload di file Abilitato","FileUpload_File_Empty":"file vuoto","FileUpload_FileSystemPath":"percorso di sistema","FileUpload_MaxFileSize":"Massima Carica file Dimensioni (in byte)","FileUpload_MediaType_NotAccepted":"Tipi di carta non accettati","FileUpload_MediaTypeWhiteList":"Tipi di supporto accettati","FileUpload_MediaTypeWhiteListDescription":"elenco dei tipi di supporto separato da virgole. Lasciare in bianco per accettare tutti i tipi di media.","FileUpload_ProtectFiles":"Proteggere i file caricati","FileUpload_ProtectFilesDescription":"Solo gli utenti autenticati avranno accesso","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 nome bucket","FileUpload_S3_BucketURL":"URL benna","FileUpload_S3_CDN":"dominio CDN per i download","FileUpload_S3_Region":"Regione","FileUpload_Storage_Type":"Tipo di archiviazione","Flags":"bandiere","Follow_social_profiles":"Segui i nostri profili sociali, fai un fork su github e condivide i tuoi pensieri circa l'app rocket.chat nella nostra bacheca Trello.","Food_and_Drink":"Cibo bevanda","For_your_security_you_must_re_enter_your_password_to_continue":"Per motivi di sicurezza, è necessario reinserire la password per continuare","Force_SSL":"forza SSL","Force_SSL_Description":"* Attenzione * _Force SSL_ non dovrebbe mai essere usato con proxy inverso. Se si dispone di un proxy inverso, si dovrebbe fare il redirect CI. Questa opzione esiste per le implementazioni come Heroku, che non permette la configurazione di reindirizzamento al proxy inverso.","Forgot_password":"Ho dimenticato mia password","Fork_it_on_github":"Fai un fork su Github","Frequently_Used":"Usato frequentemente","From":"Da parte di","From_Email":"Dall'email","From_email_is_required":"Dalla e-mail è necessario","From_email_warning":"<b>Attenzione:</b> Il campo <b>Da</b> è soggetto alle impostazioni del server di posta.","General":"Generale","Get_to_know_the_team":"Venite a conoscere la Rocket.Team","github_no_public_email":"Non havi un email publico sul tuo GitHub account","Give_a_unique_name_for_the_custom_oauth":"Dare un nome univoco per il OAuth personalizzato","Give_the_application_a_name_This_will_be_seen_by_your_users":"Dare l'applicazione di un nome. Questo sarà visto dagli utenti.","Global":"Globale","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Ha di più","Have_your_own_chat":"Avere il proprio web chat. Sviluppato con Meteor.com, il Rocket.Chat è una grande soluzione per gli sviluppatori in attesa di costruire ed evolvere la propria piattaforma di chat.","Header":"Intestazione","Hidden":"Nascosto","Hide_Group_Warning":"Sei sicuro di voler nascondere il gruppo \" %s\"?","Hide_Private_Warning":"Sei sicuro che si desidera nascondere la discussione con \" %s\"?","Hide_room":"Nascondi la stanza","Hide_Room_Warning":"Sei sicuro che si desidera nascondere la stanza \" %s\"?","Highlights":"Mette in risalto","Highlights_How_To":"Per ricevere una notifica quando qualcuno parla di una parola o frase, inserirlo qui. È possibile separare parole o frasi con le virgole. Evidenziare le parole non sono case sensitive.","Highlights_List":"Evidenziare le parole","History":"Storico","hours":"ore","How_friendly_was_the_chat_agent":"Come amichevole è stato l'agente chat?","How_knowledgeable_was_the_chat_agent":"Come esperto era l'agente chat?","How_responsive_was_the_chat_agent":"Come reattivo è stato l'agente chat?","How_satisfied_were_you_with_this_chat":"Quanto è soddisfatto eri con questa chat?","If_you_are_sure_type_in_your_password":"Se sei sicuro tipo la password:","If_you_are_sure_type_in_your_username":"Se sei sicuro digitare il proprio nome utente:","Importer_Archived":"Archiviati","Importer_done":"Importazione completa!","Importer_finishing":"Finendo l'importazione.","Importer_From_Description":"Le importazioni __from __ 's dati in Rocket.Chat.","Importer_import_cancelled":"Importazione annullata.","Importer_import_failed":"È verificato un errore durante l'esecuzione l'importazione.","Importer_importing_channels":"Importare i canali.","Importer_importing_messages":"Importazione dei messaggi.","Importer_importing_started":"A partire l'importazione.","Importer_importing_users":"Importazione gli utenti.","Importer_not_defined_properly":"L'importatore non è stato definito in modo corretto, manca la classe di importazione.","Importer_not_in_progress":"L'importatore non è in esecuzione.","Importer_Prepare_Restart_Import":"restart Import","Importer_Prepare_Start_Import":"avviare l'importazione","Importer_Prepare_Uncheck_Archived_Channels":"Canali archiviati deselezionare","Importer_Prepare_Uncheck_Deleted_Users":"Deselezionare Utenti eliminati","Importer_progress_error":"Impossibile ottenere lo stato di avanzamento per l'importazione.","Importer_setup_error":"È verificato un errore durante l'impostazione l'importatore.","Incorrect_Password":"Password errata","inline_code":"inline_code","Install_Extension":"Installa estensione","Install_FxOs":"Installare Rocket.Chat sul tuo Firefox","Install_FxOs_done":"Grande! È ora possibile utilizzare Rocket.Chat tramite l'icona sul vostro homescreen. Buon divertimento con Rocket.Chat!","Install_FxOs_error":"Siamo spiacenti, che non ha funzionato come previsto! Il seguente errore è apparso:","Install_FxOs_follow_instructions":"Si prega di confermare l'installazione applicazione sul proprio dispositivo (premere \"Installa\" quando richiesto).","Installation":"Installazione","Integration_added":"L'integrazione è stata aggiunta","Integration_Incoming_WebHook":"Integrazione WebHook Incoming","Integration_New":"nuova integrazione","Integration_Outgoing_WebHook":"Integrazione WebHook in uscita","Integration_updated":"L'integrazione è stata aggiornata","Integrations":"integrazioni","Invalid_asset":"risorsa non valido","Invalid_confirm_pass":"La password di conferma non corrisponde con la password","Invalid_email":"L'email inserito è invalida","Invalid_Export_File":"Il file caricato non è una valida %s file di esportazione.","Invalid_file_height":"altezza di file non valido","Invalid_file_type":"tipo di file non valido","Invalid_file_width":"larghezza file non valido","Invalid_Import_File_Type":"Importa tipo di file non valido.","Invalid_name":"Il nome non può essere vuoto","Invalid_notification_setting_s":"impostazione di notifica non valida: %s","Invalid_pass":"La password non deve essere vuoto","Invalid_room_name":"<strong>%s</strong il nome della stanza nnon è corretto,<br/> usare solo lettere, numeri o linee","Invalid_room_type":"<strong> %s</strong> non è un tipo di camera valida.","Invalid_Secret_URL":"URL non valido Segreto","Invalid_secret_URL_message":"L'URL fornito non è valido.","invisible":"invisibile","Invisible":"Invisibile","Invitation_HTML":"invito HTML","Invitation_Subject":"invito Soggetto","Invite_user_to_join_channel":"Invitare un utente ad entrare questo canale","Invite_Users":"Invita utenti","is_also_typing":"sta digitando anche","is_also_typing_female":"è anche digitando","is_also_typing_male":"è anche digitando","is_typing":"sta digitando","is_typing_female":"sta scrivendo","is_typing_male":"sta scrivendo","italics":"corsivo","join":"Aderire","Join_audio_call":"Partecipa chiamata audio","Join_the_Community":"Entra nella Comunità","Join_the_given_channel":"Entrare nel canale data","Join_video_call":"Partecipa videochiamata","Joined":"congiunto","Jump":"Saltare","Jump_to_first_unread":"Vai al primo messaggio non letto","Jump_to_message":"Vai a messaggio","Jump_to_recent_messages":"Vai a messaggi recenti","Katex_Enabled":"Katex Abilitato","Label":"Etichetta","Language":"Lingua","Language_Version":"Versione Italiana","Last_login":"Ultimo accesso","Last_message":"Ultimo messaggio","Last_seen":"Ultima visualizzazione","Layout":"disposizione","Layout_Home_Body":"corpo a casa","Layout_Home_Title":"Inizio Titolo","Layout_Login_Terms":"login Condizioni","Layout_Privacy_Policy":"politica sulla riservatezza","Layout_Sidenav_Footer":"Side Navigation Footer","Layout_Sidenav_Footer_description":"dimensione piè di pagina è di 260 x 70 px","Layout_Terms_of_Service":"Termini di servizio","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Ricerca dominio personalizzato","LDAP_Custom_Domain_Search_Description":"Un pezzo di JSON che governa legano e collegamento informazioni e ha la forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"default Domain","LDAP_Description":"LDAP è un database gerarchico che molte aziende utilizzano per fornire single sign on - un impianto per la condivisione di una sola password tra più siti e servizi. Per informazioni sulla configurazione avanzata ed esempi, si prega di consultare il nostro wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Base dominio","LDAP_Domain_Base_Description":"Il nome completo distinto (DN) di una sottostruttura LDAP che si desidera cercare utenti e gruppi. È possibile aggiungere come molti come si desidera; Tuttavia, ogni gruppo deve essere definito nella stessa base dominio degli utenti che ne fanno parte. Se si specifica gruppi di utenti con restrizioni, solo gli utenti che appartengono a questi gruppi saranno di portata. Si consiglia di specificare il livello superiore della directory LDAP albero come base di dominio e utilizzare il filtro di ricerca per controllare l'accesso.","LDAP_Domain_Search_Filter":"Ricerca nel dominio Filtro","LDAP_Domain_Search_Filter_Description":"Se specificato, solo gli utenti che corrispondono a questo filtro sarà consentito effettuare il login. Se non viene specificato alcun filtro, tutti gli utenti che rientrano nel campo della base di dominio specificato saranno in grado di accedere. <br/> Ad esempio, per Active Directory `memberOf = CN = ROCKET_CHAT, ou = Generale Groups`. <br/> Ad esempio per OpenLDAP (extensible ricerca match) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Ricerca nel dominio Categoria dell'oggetto","LDAP_Domain_Search_Object_Category_Description":"Il * * objectCategory che identificano gli utenti. <br/> Lascia vuoto per * * OpenLDAP. <br/> Ad esempio `Person`, etc.","LDAP_Domain_Search_Object_Class":"Dominio classe di ricerca di oggetti","LDAP_Domain_Search_Object_Class_Description":"Il * * objectclass che identificano gli utenti. <br/> Ad esempio `organizationalPerson`,` user`, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Ricerca nel dominio password","LDAP_Domain_Search_Password_Description":"La password per l'utente del dominio di ricerca.","LDAP_Domain_Search_User":"Ricerca nel dominio dell'utente","LDAP_Domain_Search_User_Description":"L'utente che esegue ricerche LDAP per l'autenticazione degli utenti altri utenti quando accedono. <br/> Questo è in genere un account di servizio creato appositamente per le integrazioni di terze parti. Utilizzare un nome completo, come `cn = Administrator, CN = Users, dc = example, dc = com`.","LDAP_Domain_Search_User_ID":"Ricerca nel dominio User ID","LDAP_Domain_Search_User_ID_Description":"L'attributo LDAP che identifica l'utente LDAP che i tentativi di autenticazione. Questo campo deve essere `sAMAccountName` per installazioni più di Active Directory, ma può essere` uid` per altre soluzioni LDAP, come OpenLDAP. È possibile utilizzare `mail` per identificare gli utenti via e-mail o quello che volete attributo. <br> È possibile utilizzare più valori separati da virgola per consentire agli utenti di accedere con più identificatori, come nome utente o e-mail.","LDAP_Enable":"consentire","LDAP_Enable_Description":"Tentare di utilizzare LDAP per l'autenticazione.","LDAP_Encryption":"crittografia","LDAP_Encryption_Description":"Il metodo di cifratura utilizzato per proteggere le comunicazioni con il server LDAP. Gli esempi includono `plain` (senza crittografia),` SSL / LDAPS` (criptato dall'inizio), e `StartTLS` (aggiornamento a comunicazione criptata una volta collegato).","LDAP_Host":"Ospite","LDAP_Host_Description":"L'host LDAP, ad esempio `ldap.example.com` o` 10.0.0.30`.","LDAP_Port":"porto","LDAP_Port_Description":"Porta di accesso LDAP. ad esempio: `389` o` 636` per LDAPS","LDAP_Reject_Unauthorized":"Rifiuta non autorizzato","LDAP_Sync_User_Avatar":"Sync Avatar utente","LDAP_Sync_User_Data":"Data Sync","LDAP_Sync_User_Data_Description":"Conservare i dati degli utenti in sincronia con server di login (ad esempio: nome, e-mail).","LDAP_Sync_User_Data_FieldMap":"User Data Campo Mappa","LDAP_Sync_User_Data_FieldMap_Description":"Configurare come i campi account utente (come e-mail) sono popolate da un record in LDAP (una volta trovato). <br/> A titolo di esempio, `{\" cn \":\" nome \",\" mail \":\" e-mail \"}` sceglierà il nome di una persona umana leggibile dall'attributo CN, e la loro e-mail dal attributo di posta elettronica. <br/> I campi disponibili includono `name` e` email`.","LDAP_Sync_Users":"Gli utenti di sincronizzazione","LDAP_Test_Connection":"Connessione di prova","LDAP_Unique_Identifier_Field":"Unique Identifier Campo","LDAP_Unique_Identifier_Field_Description":"Quale campo verrà utilizzato per collegare l'utente LDAP e l'utente Rocket.Chat. È possibile comunicare più valori separati da virgola per cercare di ottenere il valore dal record di LDAP. <br/> Il valore predefinito è `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Utilizzare Ricerca dominio personalizzato","LDAP_Use_Custom_Domain_Search_Description":"Scrivere il proprio filtro per cercare gli utenti nel server LDAP.","LDAP_Username_Field":"Nome utente campo","LDAP_Username_Field_Description":"Quale campo verrà utilizzato come nome utente * * per i nuovi utenti. Lasciare vuoto per usare il nome utente informato sulla pagina di login. <br/> È possibile utilizzare i tag modello di troppo, come `# {} givenName. # {Sn}`. <br/> Il valore predefinito è `sAMAccountName`.","Leave_Group_Warning":"Sei sicuro di voler lasciare il gruppo \" %s\"?","Leave_Private_Warning":"Sei sicuro di volere lasciare la discussione con \" %s\"?","Leave_room":"Lasciare la stanza","Leave_Room_Warning":"Sei sicuro di voler lasciare la stanza \" %s\"?","line":"linea","List_of_Direct_Messages":"Elenco dei messaggi diretti","Live_sessions":"sessioni live","Livechat_agents":"agenti livechat","Livechat_Dashboard":"Dashboard livechat","Livechat_enabled":"Livechat abilitato","Livechat_Manager":"livechat Responsabile","Livechat_managers":"manager livechat","Livechat_title":"livechat Titolo","Livechat_title_color":"Livechat Titolo colore di sfondo","Livechat_Users":"Gli utenti livechat","Load_more":"Carica di più","Loading...":"Caricamento in corso...","Loading_more_from_history":"Caricamento di più dalla storia","Loading_suggestion":"Caricando suggestioni...","Localization":"Localizzazione","Log_File":"Mostra file e Linea","Log_Level":"Livello di log","Log_Package":"Visualizza Package","Log_View_Limit":"Log View Limite","Logged_out_of_other_clients_successfully":"Disconnesso da altri clienti con successo","Login":"Login","Login_with":"Fai login con %s","login_with":"O fai il login diretto con","Logout":"Uscire","Logout_Others":"Disconnetti Da Altre connessi Sedi","Mail_Message_Invalid_emails":"Lei ha fornito e-mail uno o più validi: %s","Mail_Message_Missing_to":"È necessario selezionare uno o più utenti o fornire uno o più indirizzi email, separati da virgole.","Mail_Message_No_messages_selected_select_all":"Non hai selezionato alcun messaggio. Volete <a href='#' class='select-all'>selezionare tutti</a> i messaggi visibili?","Mail_Messages":"I messaggi di posta","Mail_Messages_Instructions":"Scegliere quali messaggi si desidera inviare via e-mail cliccando i messaggi","Mail_Messages_Subject":"Ecco una porzione selezionata di messaggi %s","Mailer":"Mailer","Mailer_body_tags":"È <b>necessario</b> utilizzare [cancellati] per il collegamento cancellazione. <br /> È possibile utilizzare [nome], [fname], [lname] per il nome completo dell'utente, nome o cognome, rispettivamente. <br /> È possibile utilizzare [email] per e-mail dell'utente.","Make_Admin":"Rendere amministratore","Manager_added":"direttore aggiunto","Manager_removed":"Responsabile rimosso","Mark_as_read":"segna come letto","Markdown_Headers":"Markdown intestazioni","Markdown_SupportSchemesForLink":"Schemi di supporto Markdown per il link","Markdown_SupportSchemesForLink_Description":"elenco separato da virgole di programmi consentiti","Members_List":"Lista dei membri","Mentions":"menzioni","Mentions_default":"Menzioni (default)","Message":"Messaggio","Message_AllowDeleting":"Permetti messaggi Eliminazione","Message_AllowEditing":"Permetti messaggi Editing","Message_AllowEditing_BlockEditInMinutes":"Message Block Modifica Dopo (n) Minuti","Message_AllowEditing_BlockEditInMinutesDescription":"Inserisci 0 per disattivare il blocco.","Message_AllowPinning":"Permetti messaggi Pinning","Message_AllowPinning_Description":"Consenti messaggi da appuntato a uno qualsiasi dei canali.","Message_AllowStarring":"Consentire Protagonisti Messaggio","Message_AudioRecorderEnabled":"Audio Recorder Abilitato","Message_AudioRecorderEnabledDescription":"Richiede 'wav audio /' i file di essere un tipo di supporto accettato all'interno di 'File Upload' impostazioni.","Message_DateFormat":"Formato data","Message_DateFormat_Description":"Vedi anche: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Messaggio eliminazione dei non ammessi","Message_editing_blocked":"Questo messaggio non può essere modificato più","Message_editing_not_allowed":"editing messaggio non consentito","Message_GroupingPeriod":"Raggruppamento periodo (in secondi)","Message_GroupingPeriodDescription":"I messaggi saranno raggruppati con il messaggio precedente, se entrambi sono dallo stesso utente e il tempo trascorso è stato inferiore al tempo informata in secondi.","Message_KeepHistory":"Mantenere Cronologia messaggi","Message_MaxAllowedSize":"Massima Messaggio ammessi Size","Message_MaxAll":"La dimensione massima del canale per TUTTI messaggio","Message_pinned":"Messaggio appuntato","Message_pinning_not_allowed":"Messaggio pinning non ammessi","Message_removed":"Messaggio rimosso","Message_ShowDeletedStatus":"Mostra stato eliminato","Message_ShowEditedStatus":"Mostra a cura di stato","Message_ShowFormattingTips":"Mostra suggerimenti di formattazione","Message_TimeFormat":"Formato orario","Message_TimeFormat_Description":"Vedi anche: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Messaggio troppo lungo","Messages":"messaggi","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"I messaggi inviati al Incoming WebHook verranno pubblicati qui.","Meta":"Meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google verifica del sito","Meta_language":"Lingua","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robot","minutes":"minuti","Mobile_push":"spinta mobile","More_channels":"Piu canali","More_direct_messages":"Altri messaggi diretti","More_groups":"Altri gruppi privati","More_unreads":"Più unreads","Msgs":"Msgs","multi":"Multi","Mute_someone_in_room":"qualcuno Muto nella stanza","Mute_user":"utente Muto","Muted":"smorzato","My_Account":"Il mio account","n_messages":"% messaggi","N_new_messages":" %s nuovi messaggi","Name":"Nome","Name_cant_be_empty":"Il nome non può essere vuoto","Name_of_agent":"Nome dell'agente","Name_optional":"Nome (opzionale)","Navigation_History_20_last_pages":"Storia di navigazione (20 ultime pagine)","New_Application":"Nuova applicazione","New_Custom_Field":"Nuovo campo personalizzato","New_Department":"Nuovo Dipartimento","New_integration":"nuova integrazione","New_logs":"nuovi registri","New_messages":"Nuovi messaggi","New_password":"Nuova password","New_role":"Nuovo ruolo","No_channel_with_name_%s_was_found":"Nessun canale con il nome <strong>\" %s\"</strong> è stato trovato!","No_channels_yet":"Non fai parte di nessun canale ancora.","No_direct_messages_yet":"Non ha iniziato nessuna conversazione ancora.","No_Encryption":"senza crittografia","No_favorites_yet":"Non hai aggiunto qualche favoriti ancora.","No_group_with_name_%s_was_found":"Nessun gruppo privato con nome <strong>\" %s\"</strong> è stato trovato!","No_groups_yet":"Non hai gruppi privati ancora.","No_livechats":"Non hai livechats.","No_mentions_found":"Nessun menzioni trovato","No_permission_to_view_room":"Non hai permissione per guardare questa stanza","No_pinned_messages":"Nessun messaggio appuntato","No_results_found":"nessun risultato trovato","No_starred_messages":"Nessun messaggio stellati","no_tokens_for_this_user":"Non ci sono gettoni per questo utente","No_user_with_username_%s_was_found":"Nessun utente con nome utente <strong>\" %s\"</strong> è stato trovato!","Not_allowed":"Non autorizzato","Not_authorized":"Non autorizzato","Not_Available":"Non disponibile","Not_found_or_not_allowed":"Non trovato o Non Amesso","Nothing":"Niente","Nothing_found":"Non abbiamo trovato nulla","Notifications":"notifiche","Notify_all_in_this_room":"Notifica tutti in questa stanza","Num_Agents":"# Agents","Number_of_messages":"Numero di messaggi","OAuth_Application":"OAuth Application","OAuth_Applications":"Applicazioni OAuth","Objects":"Oggetti","Off_the_record_conversation":"Off-the-record di conversazione","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record di conversazione non è disponibile per il browser o dispositivo.","Offline_DM_Email":"[__site__] Sei stato diretto da messaged __user__","Offline_Mention_Email":"[__site__] Sei stato citato da __user__ in #__room__","Old_and_new_password_must_be_different":"La nuova password deve essere diversa dalla vecchia password.","Old_and_new_password_required":"È necessario fornire vecchi e nuova password per la modifica della password.","Online":"Online","Only_errors":"solo errori","Only_you_can_see_this_message":"Solo tu puoi vedere questo messaggio","Oops!":"Spiacenti","Open":"aperto","Opened":"Ha aperto","Opt_out_statistics":"Non inviare le mie statistiche Rocket.Chat","Opt_out_statistics_warning":"Inviando le statistiche, ci aiuterai a identificare come vengono distribuiti molti casi di Rocket.Chat, così come quanto è buono il sistema si comporta, in modo che possiamo ulteriormente migliorare. Non ti preoccupare, in quanto non le informazioni dell'utente vengono inviate e tutte le informazioni che riceviamo sono mantenute riservate. Se si desidera continuare a inviarci le vostre statistiche, deselezionare la casella di controllo di cui sopra. Grazie.","optional":"facoltativo","Order":"Ordine","OS_Arch":"OS Arch","OS_Cpus":"Conte CPU OS","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Carico medio","OS_Platform":"OS Platform","OS_Release":"OS di uscita","OS_Totalmem":"Memoria totale OS","OS_Type":"Tipo OS","OS_Uptime":"OS Uptime","others":"altri","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR è disponibile solo se entrambi gli utenti sono on-line","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL di sostituzione a cui vengono caricati i file. Questo URL utilizzato anche per i download a meno che un CDN è dato","Password":"Password","Password_Change_Disabled":"L'amministratore Rocket.Chat ha disattivato il cambio della password","Password_changed_successfully":"password cambiata con successo","Payload":"Carico utile","People":"Persone","Permissions":"Permessi","Pin_Message":"Pin Messaggio","Pinned_a_message":"Pinned un messaggio:","Pinned_Messages":"Messaggi Pinned","Placeholder_for_email_or_username_login_field":"Segnaposto per e-mail o il nome utente login campo","Placeholder_for_password_login_field":"Segnaposto per il campo Login Password","Please_answer_survey":"Si prega di prendere un momento per rispondere a un rapido sondaggio su questa chat","Please_enter_value_for_url":"Inserisci un valore per l'URL del tuo avatar.","Please_enter_your_new_password_below":"Per favore digita la nuova password sotto:","Please_fill_a_label":"Si prega di compilare una etichetta","Please_fill_a_name":"Si prega di compilare un nome","Please_fill_a_username":"Si prega di compilare un nome utente","Please_fill_name_and_email":"Si prega di compilare il nome ed e-mail","Please_re_enter_your_password":"per favore reinserisci la tua password","Please_select_enabled_yes_or_no":"Seleziona un'opzione per Abilitato","Please_wait":"Attendere prego","Please_wait_activation":"Attendere prego, questo può richiedere un certo tempo.","Please_wait_statistics":"Attendere, le statistiche vengono generati.","Please_wait_while_OTR_is_being_established":"Per favore attendi che OTR viene stabilita","Please_wait_while_your_account_is_being_deleted":"Per favore attendi che il tuo account è stato cancellato ...","Please_wait_while_your_profile_is_being_saved":"Per favore attendi che il tuo profilo viene salvato ...","Post_as":"post come","Post_to_Channel":"Posta a Canale","Post_to_s_as_s":"<strong>Pubblica %s</strong> <strong>in %s</strong>","Powered_by":"Powered by","Preferences":"Preferenze","Preferences_saved":"Preferenze salvate","Privacy":"Privacy","Private_Group":"Gruppo privato","Private_Groups":"Gruppi Privati","Private_Groups_list":"Elenco dei gruppi privati","Profile":"Profilo","Profile_saved_successfully":"Profilo salvato con successo","Proudly_developed":"Orgogliosamente sviluppato con Meteor","Push":"Spingi","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev chiave","Push_apn_dev_passphrase":"APN Dev passphrase","Push_apn_key":"APN chiave","Push_apn_passphrase":"APN passphrase","Push_debug":"mettere a punto","push_disabled":"spingere disattivato","Push_enable":"consentire","Push_enable_gateway":"Abilita Gateway","Push_gateway":"porta","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Numero Progetto","Push_production":"Produzione","Push_show_message":"Mostra messaggio di notifica","Push_show_username_room":"Mostra canale / gruppo / nome utente nel notifica","Push_test_push":"Test","Query":"domanda","Query_description":"Condizioni supplementari per determinare quali utenti di inviare l'e-mail a. gli utenti non iscritti vengono automaticamente rimossi dalla query. Deve essere un JSON valido. Esempio: \"{\" createdAt \": {\" $ gt \": {\" $ data \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Ricerca rapida","quote":"citazione","Reactions":"reazioni","Recents":"Recenti","Record":"Disco","Redirect_URI":"Redirect URI","Refresh_keys":"chiavi Aggiorna","Refresh_your_page_after_install_to_enable_screen_sharing":"Aggiornare la pagina dopo l'installazione per consentire la condivisione dello schermo","Register":"Registra una nuovo account","Registration_Succeeded":"registrazione Succeeded","Remember_me":"Ricordare di me","Remove":"Rimuovi","Remove_Admin":"rimuovere Admin","Remove_as_moderator":"Rimuovere in qualità di moderatore","Remove_as_owner":"Rimuovere come proprietario","Remove_custom_oauth":"Rimuovere OAuth personalizzato","Remove_from_room":"Rimuovi da camera","Remove_someone_from_room":"Rimuovere qualcuno dalla stanza","Removed":"Rimosso","Require_password_change":"Richiede la modifica della password","Resend_verification_email":"Invia nuovamente email di verifica","Reset":"Reset","Reset_password":"Resettare la tua password","Restart":"Ricomincia","Restart_the_server":"Riavviare il server","RocketBot_Enabled":"RocketBot Abilitato","RocketBot_Name":"Nome RocketBot","RocketBot_Name_Description":"Nome RocketBot deve essere un nome utente valido registrato nel vostro server.","Role":"Ruolo","Role_Editing":"ruolo Editing","Role_removed":"ruolo rimosso","Room":"Stanza","Room_archivation_state":"Stato","Room_archivation_state_false":"Attivo","Room_archivation_state_true":"Archiviati","Room_archived":"camera archiviata","room_changed_privacy":"Tipo di camera cambiato in: <em>__room_type__</em> da <em>__user_by__</em>","room_changed_topic":"Argomento camera cambiato in: <em>__room_topic__</em> da <em>__user_by__</em>","Room_has_been_deleted":"Camera è stato eliminato","Room_Info":"Info camera","Room_name_changed":"Il nome della stanza è cambiato per: <em>__room_name__</em> da <em>__user_by__</em>","Room_name_changed_successfully":"Nome della stanza cambiato con successo","Room_not_found":"Camera non trovato","Room_topic_changed_successfully":"argomento camera cambiata con successo","Room_type_changed_successfully":"Tipo di camera cambiata con successo","Room_unarchived":"camera non archiviata","Room_uploaded_file_list":"Elenco dei file","Room_uploaded_file_list_empty":"Nessun file disponibile.","room_user_count":" %s utenti","Rooms":"Camere","S_new_messages_since_s":" %s nuovi messaggi da %s","SAML":"SAML","SAML_Custom_Cert":"certificato personalizzato","SAML_Custom_Entry_point":"Point voce personalizzata","SAML_Custom_Generate_Username":"genera Nome utente","SAML_Custom_Issuer":"Emittente personalizzato","SAML_Custom_Provider":"provider personalizzato","Save":"Salva","Save_changes":"Salva I Cambiamenti","Save_Mobile_Bandwidth":"Salva mobile della larghezza di banda","Save_to_enable_this_action":"Salva per abilitare questa azione","Saved":"Salvato","Saving":"Risparmio","Scope":"portata","Screen_Share":"schermo Condividi","Script_Enabled":"script Abilitato","Search":"Ricerca","Search_by_username":"Ricerca per nome utente","Search_Channels":"ricerca Canali","Search_Direct_Messages":"Cerca messaggi diretti","Search_Messages":"Cerca Messaggi","Search_Private_Groups":"Gruppi di ricerca privati","Search_settings":"impostazioni di ricerca","seconds":"secondi","See_all":"Guarda tuttto","See_only_online":"Solo online","Select_a_department":"Selezionare un reparto","Select_an_avatar":"Seleziona l'avatar","Select_file":"Seleziona l'archivio","Select_service_to_login":"Selezionare un servizio per effettuare il login per caricare la tua foto o caricare uno direttamente dal proprio computer","Select_user":"Selezionare l'utente","Select_users":"selezionare gli utenti","Selected_agents":"agenti selezionati","Selected_users":"Membri selezionati","Send":"Inviare","Send_a_message":"Mandare un messaggio","Send_a_test_mail_to_my_user":"Send a mail di prova per il mio utente","Send_a_test_push_to_my_user":"Invia una spinta di prova per il mio utente","Send_confirmation_email":"Invia email di conferma","Send_data_into_RocketChat_in_realtime":"Invia i dati in Rocket.Chat in tempo reale.","Send_email":"Invia una email","Send_invitation_email":"Invia e-mail di invito","Send_invitation_email_error":"Non hai fornito un indirizzo email valido.","Send_invitation_email_info":"È possibile inviare più inviti e-mail in una sola volta.","Send_invitation_email_success":"Hai inviato con successo una e-mail di invito ai seguenti indirizzi:","Send_invitation_email_warning":"Al fine di inviare e-mail di invito, è necessario configurare le impostazioni SMTP.","Send_Message":"Invia il messaggio","Send_your_JSON_payloads_to_this_URL":"Invia i tuoi carichi JSON a questo URL.","Sending":"Invio ...","Set_as_moderator":"Imposta come moderatore","Set_as_owner":"Imposta come proprietario","Settings":"Impostazioni","Settings_updated":"Impostazioni aggiornate","Should_be_a_URL_of_an_image":"Dovrebbe essere un URL di un'immagine.","Should_exists_a_user_with_this_username":"L'utente deve già esistere.","Show_all":"Mostra tutto","Show_more":"Mostra di più","Show_only_online":"Mostra solo on-line","Show_preregistration_form":"Mostra modulo di pre-registrazione","Showing_archived_results":"<p> <b>Visualizzazione %s</b> risultati archiviati </p>","Showing_online_users":"Mostra <b>__total_showing__</b> di __total__users","Showing_results":"<p>Mostra <b>%s</b> resultati</p>","Silence":"Silenzio","since_creation":"da %s","Site_Name":"Nome del sito","Site_Url":"indirizzo del sito","Site_Url_Description":"Esempio: https://chat.domain.com/","Skip":"Salta","Smileys_and_People":"Smileys & Persone","SMTP":"SMTP","SMTP_Host":"Host SMTP","SMTP_Password":"password SMTP","SMTP_Port":"porta SMTP","SMTP_Test_Button":"Impostazioni di prova SMTP","SMTP_Username":"Nome utente SMTP","Sound":"Suono","Star_Message":"stella Messaggio","Starred_Messages":"messaggi speciali","Start_audio_call":"Inizia chiamata audio","Start_Chat":"Avvia chat","Start_of_conversation":"Inizia una conversazione","Start_OTR":"Inizio OTR","Start_video_call":"Inizia videochiamata","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Inizia con <code class=\"inline\">%s</code> per l'utente o il <code class=\"inline\">%s</code> per il canale. Ad esempio: <code class=\"inline\">%s</code> oppure <code class=\"inline\">%s</code>","Statistics":"statistica","Stats_Active_Users":"utenti attivi","Stats_Avg_Channel_Users":"Gli utenti medi di canale","Stats_Avg_Private_Group_Users":"Media privati ​​Users Group","Stats_Away_Users":"gli utenti lontano","Stats_Max_Room_Users":"Max Camere utenti","Stats_Non_Active_Users":"Gli utenti inattivi","Stats_Offline_Users":"Gli utenti non in linea","Stats_Online_Users":"utenti online","Stats_Total_Channels":"Canali totali","Stats_Total_Direct_Messages":"Totale dei messaggi diretti Camere","Stats_Total_Messages":"Messaggi totali","Stats_Total_Private_Groups":"Totale gruppi privati","Stats_Total_Rooms":"Totale camere","Stats_Total_Users":"Totale utenti","Stop_Recording":"Interrompi registrazione","strike":"sciopero","Subject":"Soggetto","Submit":"Invia","Success":"Successo","Survey":"Indagine","Survey_instructions":"Vota ogni domanda secondo la vostra soddisfazione, 1 significa che sono completamente insoddisfatto e 5 significa che sono completamente soddisfatti.","Symbols":"Simboli","Sync_success":"successo Sync","Sync_Users":"Gli utenti di sincronizzazione","Test_Connection":"Connessione di prova","Test_Desktop_Notifications":"Prova Notifiche desktop","Thank_you_for_your_feedback":"Grazie per il tuo feedback","The_application_name_is_required":"È richiesto il nome dell'applicazione","The_channel_name_is_required":"È richiesto il nome del canale","The_emails_are_being_sent":"I messaggi di posta elettronica vengono inviati.","The_field_is_required":"È necessario il campo %s.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Il ridimensionamento dell'immagine non funzionerà perché non siamo in grado di rilevare ImageMagick o GraphicsMagick installati sul server.","The_redirectUri_is_required":"Il redirectUri è richiesto","The_server_will_restart_in_s_seconds":"Il server viene riavviato in %s secondi","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>L'impostazione %s</strong> è configurato <strong>per %s</strong> e si accede <strong>da %s!</strong>","The_user_will_be_removed_from_s":"L'utente sarà rimosso da %s","The_user_wont_be_able_to_type_in_s":"L'utente non sarà in grado di digitare %s","Theme":"Tema","theme-color-action-buttons-color":"Azioni tasti di colore","theme-color-active-channel-background-color":"Attivo Canale colore di sfondo","theme-color-active-channel-font-color":"Attivo Canale colore dei caratteri","theme-color-blockquote-background":"Sfondo Blockquote Colore","theme-color-clean-buttons-color":"Pulsanti Clean Color","theme-color-code-background":"Codice colore di sfondo","theme-color-code-border":"Codice del colore del bordo","theme-color-code-color":"Codice del colore","theme-color-content-background-color":"Sfondo contenuto a colori","theme-color-custom-scrollbar-color":"Colore personalizzato Scrollbar","theme-color-info-active-font-color":"Info Attivo Colore carattere","theme-color-info-font-color":"Info Colore carattere","theme-color-input-font-color":"Ingresso Colore carattere","theme-color-link-font-color":"Colore collegamento Font","theme-color-message-hover-background-color":"Messaggio al passaggio del mouse il colore di sfondo","theme-color-primary-background-color":"Sfondo Colore primario","theme-color-primary-font-color":"Colore primario Font","theme-color-quaternary-font-color":"Quaternario colore dei caratteri","theme-color-secondary-background-color":"Sfondo secondario Colore","theme-color-secondary-font-color":"Font Secondario Colore","theme-color-smallprint-font-color":"Piccolo Stampa Colore carattere","theme-color-smallprint-hover-color":"Piccolo Stampa Hover colori","theme-color-status-away":"Lontano Colore Stato","theme-color-status-busy":"Occupato Colore Stato","theme-color-status-offline":"Offline Colore Stato","theme-color-status-online":"Linea Colore Stato","theme-color-tertiary-background-color":"Sfondo terziario Colore","theme-color-tertiary-font-color":"Terziario Colore carattere","theme-color-unread-notification-color":"Non letto Notifiche colori","theme-custom-css":"CSS personalizzato","There_are_no_agents_added_to_this_department_yet":"Non ci sono agenti aggiunti a questo reparto ancora.","There_are_no_integrations":"Non esistono integrazioni","There_are_no_users_in_this_role":"Non ci sono utenti in questo ruolo.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Questa email è già stato utilizzato e non è stato verificato. Si prega di cambiare la password.","This_is_a_desktop_notification":"Si tratta di un messaggio sul desktop","This_is_a_push_test_messsage":"Questa è una prova di spinta messsage","Time_in_seconds":"Tempo in secondi","Title_bar_color":"colore Barra del titolo","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Per installare Rocket.Chat Livechat nel vostro sito web, copia e incolla questo codice sopra l'ultima <strong></ body></strong> tag sul tuo sito.","To_users":"per gli utenti","Topic":"Argomento","Travel_and_Places":"Travel & Places","Trigger_removed":"trigger rimosso","Trigger_Words":"trigger Parole","Triggers":"trigger","True":"Vero","Type":"Digitare","Type_your_new_password":"Digitare la nuova password","Unarchive":"unarchive","Unmute_someone_in_room":"qualcuno Attiva nella stanza","Unmute_user":"utente Attiva","Unnamed":"Senza nome","Unpin_Message":"Messaggio Sblocca","Unread_Rooms":"Camere non letti","Unread_Rooms_Mode":"Modalità non letti Camere","Unstar_Message":"rimuovere stella","Upload_file_question":"Caricare un file?","Uploading_file":"Caricamento di file ...","Use_account_preference":"Utilizzare conto preferenza","Use_Emojis":"Utilizzare Emojis","Use_initials_avatar":"Usa le iniziali del tuo nome id utente","use_menu":"Usi il menu accanto per accedere alle stanze e i chat","Use_service_avatar":"Usa l'avatar %s","Use_this_username":"Usa questo nome di utente","Use_uploaded_avatar":"Usare l'avatar caricato","Use_url_for_avatar":"Utilizzare URL per avatar","User__username__is_now_a_moderator_of__room_name_":"__username__ utente è un moderatore di __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ utente è ora un proprietario di __room_name__","User__username__removed_from__room_name__moderators":"__username__ utente rimosso da moderatori __room_name__","User__username__removed_from__room_name__owners":"__username__ utente rimosso dai proprietari __room_name__","User_added":"Utente <em>__user_added__</em> aggiunto.","User_added_by":"Utente <em>__user_added__</em> aggiunto da <em>__user_by__</em>.","User_added_successfully":"Utente aggiunto correttamente","User_Channels":"canali utente","User_doesnt_exist":"Nessun utente esiste con il nome di ` %s` @.","User_has_been_activated":"Utente è stato attivato","User_has_been_deactivated":"Utente non è attivato","User_has_been_deleted":"L'utente è stato cancellato","User_has_been_muted_in_s":"Utente è stato disattivato in %s","User_has_been_removed_from_s":"Utente è stato rimosso da %s","User_has_disconnected":"Utente è disconnesso","User_Info":"Info utente","User_is_no_longer_an_admin":"Utente non è più un amministratore","User_is_not_activated":"L'utente non viene attivato","User_is_now_an_admin":"L'utente è ora un amministratore","User_joined_channel":"Ha aderito al canale.","User_joined_channel_female":"Ha aderito al canale.","User_joined_channel_male":"Ha aderito al canale.","User_left":"Utente <em>__user_left__</em> ha lasciato.","User_left_female":"Ha lasciato il canale.","User_left_male":"Ha lasciato il canale.","User_logged_out":"L'utente è disconnesso ","User_management":"Gestione utenti","User_muted_by":"<em>__user_muted__</em> Utente disattivato da <em>__user_by__.</em>","User_muted_in_room":"Utente disattivato in camera","User_not_found":"Utente non trovato","User_not_found_or_incorrect_password":"Utente non trovato o password non corretta","User_or_channel_name":"Nome utente o del canale","User_removed":"rimosso utente","User_removed_by":"Utente <em>__user_removed__</em> rimosso da <em>__user_by__</em>. ","User_removed_from_room":"L'utente è stato rimosso dalla camera","User_Settings":"Impostazioni utente","User_unmuted_by":"<em>__user_unmuted__</em> Utente riattivato da <em>__user_by__.</em>","User_unmuted_in_room":"Utente riattivato in camera","User_updated_successfully":"Utente aggiornato con successo","Username":"Nome di utente","Username_and_message_must_not_be_empty":"Nome utente e il messaggio non deve essere vuoto.","Username_cant_be_empty":"Il nome di utente non deve essere vuoto","Username_Change_Disabled":"L'amministratore Rocket.Chat ha disattivato il cambio di username","Username_denied_the_OTR_session":"__username__ negato la sessione OTR","Username_description":"Il nome di utente viene utilizzato per permetter agli altri di inviarti dei messaggi.","Username_doesnt_exist":"Il nome utente ` %s` non esiste.","Username_ended_the_OTR_session":"__username__ concluso la sessione OTR","Username_invalid":"<strong>%s</strong> nome di utente non corretto,<br/> utilizzare solo lettere, numeri, punti e linee","Username_is_already_in_here":"`@ %s` è già qui.","Username_is_not_in_this_room":"L'utente `# %s` non è in questa stanza.","Username_not_found":"Nome utente non trovato","Username_title":"Registra nome di utente","Username_unavaliable":"<strong>%s</strong> è già in uso :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ vuole iniziare OTR. Vuoi accettare?","Users":"utenti","Users_in_role":"Utenti in ruolo","UTF8_Names_Slugify":"UTF8 nomi slugify","UTF8_Names_Validation":"UTF8 nomi di convalida","UTF8_Names_Validation_Description":"Non permettere che i caratteri speciali e spazi. È possibile utilizzare - _ e. ma non al fine del nome","Verification_email_sent":"Email di verifica inviata","View_All":"Vedi tutto","View_Logs":"Visualizza registri","Visibility":"Visibilità","Visible":"Visibile","Visitor":"Visitatore","Visitor_page_URL":"Pagina Visitor URL","Visitor_time_on_site":"tempo Visitor sul posto","Wait_activation_warning":"Prima di poter effettuare il login, il tuo account deve essere attivato manualmente da un amministratore.","We_are_offline_Sorry_for_the_inconvenience":"Noi siamo in linea. Ci dispiace per l'inconvenienza.","We_have_sent_password_email":"Abbiamo inviato una email con le istruzioni di reimpostazione della password. Se non si riceve una email a breve tempo, torna e prova di nuovo.","We_have_sent_registration_email":"Abbiamo inviato una email per confermare la registrazione. Se non ricevi una email a breve tempo, torna e prova di nuovo.","WebRTC_Enable_Channel":"Attiva per canali pubblici","WebRTC_Enable_Direct":"Abilitazione per i messaggi diretti","WebRTC_Enable_Private":"Attiva per canali privati","WebRTC_Servers":"I server STUN / giro","WebRTC_Servers_Description":"Un elenco di server STUN e DIREZIONE separate da una virgola. <br/> Nome utente, la password e la porta sono ammessi in formato `username: password @ stordire: host: port` o` username: password @ turno: host: port`.","Welcome":"Benvenuto <em>%s</em>.","Welcome_to_the":"Benvenuto a","will_be_able_to":"potranno","With_whom":"Con chi","Yes":"sì","Yes_clear_all":"Sì, chiaro tutti!","Yes_delete_it":"Sì, eliminarlo!","Yes_hide_it":"Sì, nasconderlo!","Yes_leave_it":"Sì, lasciare!","Yes_mute_user":"Sì, l'utente muto!","Yes_remove_user":"Sì, rimuovere l'utente!","you_are_in_preview_mode_of":"Sei in modalità di anteprima del canale # <strong>__room_name__</strong>","You_are_logged_in_as":"Sei stato registrato come","You_are_not_authorized_to_view_this_page":"Non sei autorizzato a visualizzare questa pagina.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Tu sei l'ultimo proprietario. Impostare nuovo proprietario prima di lasciare la stanza.","You_can_change_a_different_avatar_too":"È possibile ignorare l'avatar utilizzato per inviare da questa integrazione.","You_can_use_an_emoji_as_avatar":"È inoltre possibile utilizzare un emoji come avatar.","You_have_been_muted":"Lei è stato disattivato e non può parlare in questa stanza","You_have_not_verified_your_email":"Non hai verificato la tua email.","You_have_successfully_unsubscribed":"Hai annullato l'iscrizione con successo dalla nostra lista Mailling.","You_informed_an_invalid_FROM_address":"È informato un invalido DA indirizzo.","You_must_provide_the_unsubscribe_link":"È necessario fornire il link [cancellati].","You_need_confirm_email":"Hai bisogno di confermare il tuo email per accedere!","You_need_install_an_extension_to_allow_screen_sharing":"È necessario installare un'estensione per consentire la condivisione dello schermo","You_need_to_change_your_password":"È necessario cambiare la password","You_need_to_type_in_your_password_in_order_to_do_this":"È necessario digitare la password per poter fare questo!","You_need_to_type_in_your_username_in_order_to_do_this":"È necessario digitare il nome utente al fine di fare questo!","You_need_to_verifiy_your_email_address_to_get_notications":"È necessario verifiy tuo indirizzo email per ricevere le notifiche","You_should_name_it_to_easily_manage_your_integrations":"Si dovrebbe chiamare di gestire facilmente le integrazioni.","You_will_not_be_able_to_recover":"Non sarà in grado di recuperare questo messaggio!","You_will_not_be_able_to_recover_file":"Non sarà in grado di recuperare questo file!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Non riceverai notifiche e-mail, perché non hai verificato la tua email.","Your_email_has_been_queued_for_sending":"L'email è stata in coda per l'invio","Your_entry_has_been_deleted":"La vostra voce è stata cancellata.","Your_file_has_been_deleted":"Il file è stato eliminato.","Your_mail_was_sent_to_s":"La tua mail è stata inviata a %s","Your_Open_Source_solution":"La tua soluzione per chat Open Source","Your_password_is_wrong":"La password è sbagliata!","Your_push_was_sent_to_s_devices":"La vostra spinta è stato inviato a dispositivi %s"});
TAPi18n._registerServerTranslator("it", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ja.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ja"] = ["Japanese","日本語"];                                                                    // 8
if(_.isUndefined(TAPi18n.translations["ja"])) {                                                                        // 9
  TAPi18n.translations["ja"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ja"][namespace])) {                                                             // 13
  TAPi18n.translations["ja"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ja"][namespace], {"500":"内部サーバーエラー","0_Errors_Only":"0 - エラーのみ","1_Errors_and_Information":"1 - エラーと情報","2_Erros_Information_and_Debug":"2 - エラー, 情報とデバッグ","__username__was_set__role__by__user_by_":"__username__は__user_by__によって__role__設定されました","__username__is_no_longer__role__defined_by__user_by_":"__username__は__user_by__により、__role__はなくなりました","Access_not_authorized":"アクセスする権限がありません","Access_online_demo":"オンラインデモにアクセス","Access_Online_Demo":"オンラインデモにアクセス","Access_Token_URL":"アクセストークン URL","Accounts":"アカウント","Accounts_AllowDeleteOwnAccount":"マイアカウントの削除を許可する","Accounts_AllowedDomainsList":"許可されたドメイン一覧","Accounts_AllowedDomainsList_Description":"カンマ区切りの許可されたドメイン一覧","Accounts_AllowEmailChange":"メールアドレスの変更を許可する","Accounts_AllowPasswordChange":"パスワードの変更を許可する","Accounts_AllowUserAvatarChange":"アバターの変更を許可する","Accounts_AllowUsernameChange":"ユーザー名の変更を許可する","Accounts_AllowUserProfileChange":"プロフィールの変更を許可する","Accounts_AvatarResize":"アバターの大きさを変更する","Accounts_AvatarSize":"アバターの大きさ","Accounts_AvatarStorePath":"アバターの保存先","Accounts_AvatarStoreType":"アバターの保存先ストレージ種類","Accounts_BlockedDomainsList":"ブロックされたドメイン一覧","Accounts_BlockedDomainsList_Description":"カンマ区切りのブロックされたドメイン一覧","Accounts_denyUnverifiedEmail":"認証されていないメールアドレスを拒否する","Accounts_EmailVerification":"メール認証をする","Accounts_EmailVerification_Description":"この機能を使う前に、SMTP が正しく設定されているか確認してください","Accounts_Enrollment_Email":"登録メール","Accounts_Enrollment_Email_Description":"ユーザーのフルネームに [name], [fname], [lname] を使用できます。姓 または 名 にも対応しています。<br />メールアドレスには、 [email] を使用できます。","Accounts_Iframe_api_method":"API メソッド","Accounts_Iframe_api_url":"API URL","Accounts_iframe_enabled":"Iframe を有効にする","Accounts_iframe_url":"Iframe URL","Accounts_LoginExpiration":"ログイン期限までの日数","Accounts_ManuallyApproveNewUsers":"新しいユーザーを手動で承認する","Accounts_OAuth_Custom_Token_Sent_Via":"介して送信されるトークン","Accounts_OAuth_Custom_Authorize_Path":"認証パス","Accounts_OAuth_Custom_Button_Color":"ボタン背景色","Accounts_OAuth_Custom_Button_Label_Color":"ボタン文字色","Accounts_OAuth_Custom_Button_Label_Text":"ボタンテキスト","Accounts_OAuth_Custom_Enable":"有効にする","Accounts_OAuth_Custom_id":"ID","Accounts_OAuth_Custom_Identity_Path":"個人情報パス","Accounts_OAuth_Custom_Login_Style":"ログイン方法","Accounts_OAuth_Custom_Secret":"シークレットキー","Accounts_OAuth_Custom_Token_Path":"トークンパス","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook によるログインを有効にする","Accounts_OAuth_Facebook_callback_url":"Facebook コールバック URL","Accounts_OAuth_Facebook_id":"Facebook アプリケーション ID","Accounts_OAuth_Facebook_secret":"Facebook シークレットキー","Accounts_OAuth_Github":"OAuth によるログインを有効する","Accounts_OAuth_Github_callback_url":"Github コールバック URL","Accounts_OAuth_GitHub_Enterprise":"OAuth によるログインを有効にする","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise コールバック URL","Accounts_OAuth_GitHub_Enterprise_id":"クライアント ID","Accounts_OAuth_GitHub_Enterprise_secret":"クライアント シークレットキー","Accounts_OAuth_Github_id":"クライアント ID","Accounts_OAuth_Github_secret":"クライアント シークレットキー","Accounts_OAuth_Gitlab":"OAuth によるログインを有効する","Accounts_OAuth_Gitlab_callback_url":"GitLab コールバック URL","Accounts_OAuth_Gitlab_id":"GitLab ID","Accounts_OAuth_Gitlab_secret":"クライアント シークレットキー","Accounts_OAuth_Google":"Google によるログインを有効にする","Accounts_OAuth_Google_callback_url":"Google コールバック URL","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google シークレットキー","Accounts_OAuth_Linkedin":"LinkedIn によるログインを有効にする","Accounts_OAuth_Linkedin_callback_url":"Linkedin コールバック URL","Accounts_OAuth_Linkedin_id":"LinkedIn ID","Accounts_OAuth_Linkedin_secret":"LinkedIn シークレットキー","Accounts_OAuth_Meteor":"Meteor によるログインを有効にする","Accounts_OAuth_Meteor_callback_url":"Meteor コールバック URL","Accounts_OAuth_Meteor_id":"Meteor ID","Accounts_OAuth_Meteor_secret":"Meteor シークレットキー","Accounts_OAuth_Twitter":"Twitter によるログインを有効にする","Accounts_OAuth_Twitter_callback_url":"Twitter コールバック URL","Accounts_OAuth_Twitter_id":"Twitter ID","Accounts_OAuth_Twitter_secret":"Twitter シークレットキー","Accounts_OAuth_Wordpress":"WordPress によるログインを有効にする","Accounts_OAuth_Wordpress_callback_url":"Wordpress コールバック URL","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"WordPress シークレットキー","Accounts_PasswordReset":"パスワードを再設定する","Accounts_Registration_AuthenticationServices_Enabled":"認証サービスで登録を受け付ける","Accounts_RegistrationForm":"登録フォームへのアクセス","Accounts_RegistrationForm_Disabled":"無効","Accounts_RegistrationForm_LinkReplacementText":"リンクによる登録フォームの代替テキスト","Accounts_RegistrationForm_Public":"公開","Accounts_RegistrationForm_Secret_URL":"非公開 URL","Accounts_RegistrationForm_SecretURL":"登録フォームの非公開 URL","Accounts_RegistrationForm_SecretURL_Description":"ランダムな文字列を入力してください。この文字列は、登録フォームの URL に使用されます。 例: https://demo.rocket.chat/register/[入力した文字列]","Accounts_RegistrationRequired":"登録が必要です","Accounts_RequireNameForSignUp":"登録時にユーザー名を必須にする","Accounts_ShowFormLogin":"ログインフォームを表示する","Accounts_UseDefaultBlockedDomainsList":"既定のブロックされたドメイン一覧を利用する","Accounts_UseDNSDomainCheck":"DNS ドメイン検証を利用する","Activate":"有効化","Activity":"運動","Add":"追加","Add_agent":"担当者を追加","Add_custom_oauth":"カスタム OAuth を追加","Add_manager":"管理者を追加","Add_Members":"メンバーを追加","Add_User":"ユーザーを追加","Add_user":"ユーザーを追加","Add_users":"ユーザーを追加","Additional_emails":"追加のメールアドレス","Additional_Feedback":"さらにご意見などございましたら、お願いたします。","Administration":"管理","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2 認証から、ユーザーはこの URL へリダイレクトされます","Agent_added":"担当者を追加しました","Agent_removed":"担当者を削除しました","Alias":"エイリアス","All":"すべて","All_channels":"すべてのチャンネル","All_logs":"すべてのログ","All_messages":"すべてのメッセージ","Allow_Invalid_SelfSigned_Certs":"無効な自己署名証明書を許可する","Allow_Invalid_SelfSigned_Certs_Description":"リンク検証とプレビューに不正な自己署名証明書を許可する。","and":"と","And_more":"さらに __length__...","Animals_and_Nature":"動物と自然","API":"API","API_Analytics":"アナリティクス","API_Embed":"埋め込み機能を有効にする","API_EmbedDisabledFor":"埋め込み機能を無効にするユーザー","API_EmbedDisabledFor_Description":"カンマ区切りのユーザー名一覧","API_GitHub_Enterprise_URL":"サーバー URL","API_GitHub_Enterprise_URL_Description":"例: http://domain.com (末尾のスラッシュを除く)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"表示設定","Application_added":"アプリケーションを追加しました","Application_Name":"アプリケーション名","Application_updated":"アプリケーションを更新しました","Apply_and_refresh_all_clients":"すべてのクライアントを適用し、リフレッシュ","Archive":"アーカイブ","Archive_Unarchive":"アーカイブ / アーカイブ解除","are_also_typing":"誰かがまた入力しています","are_typing":"誰かが入力しています","Are_you_sure":"本当にいいですか?","Are_you_sure_you_want_to_delete_your_account":"本当にアカウントを削除しますか?","Authorization_URL":"認証 URL","Authorize":"承認","AutoLinker_StripPrefix":"AutoLinker 先頭部分を表示しない","AutoLinker_StripPrefix_Description":"短い表示。例: https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL 正規表現","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker 電話番号","AutoLinker_Phone_Description":"電話番号をリンクにする。例: `(123)456-7890`","Auto_Load_Images":"画像自動読み込み","Available":"利用できます","Available_agents":"割り当てられる担当者","Avatar":"アバター","Avatar_changed_successfully":"アバターが正常に変更されました","Avatar_URL":"アバター URL","Avatar_url_invalid_or_error":"入力された URL は間違っているかアクセスできません。もう一度違う URL でお試しください。","away":"離席中","Away":"離席中","away_female":"離席中","Away_female":"離席中","away_male":"離席中","Away_male":"離席中","Back":"戻る","Back_to_applications":"アプリケーションへ戻る","Back_to_integrations":"サービス連携へ戻る","Back_to_login":"ログインへ戻る","Back_to_permissions":"権限へ戻る","Body":"体","bold":"太字","busy":"取り込み中","Busy":"取り込み中","busy_female":"取り込み中","Busy_female":"取り込み中","busy_male":"取り込み中","Busy_male":"取り込み中","Cancel":"キャンセル","Cannot_delete_a_protected_role":"保護されているロールは、削除できません","Cannot_delete_role_because_its_in_use":"ロールを使用中のため、削除できません","Cannot_invite_users_to_direct_rooms":"ダイレクトメッセージにユーザーを招待できません","CDN_PREFIX":"CDN プレフィックス","Certificates_and_Keys":"証明書と認証キー","Channel":"チャンネル","Channel_doesnt_exist":"`#%s` というチャンネルは、登録されていません。","Channels":"チャンネル","Channels_list":"パブリックチャンネルリスト","Chat_Rooms":"チャットルーム","Chatops_Enabled":"Chatops を有効にする","Chatops_Title":"Chatops パネル","Chatops_Username":"Chatops ユーザー名","Choose_a_room":"部屋を選択してください","Choose_messages":"メッセージを選択","Choose_the_alias_that_will_appear_before_the_username_in_messages":"メッセージでユーザー名の前に表示されるエイリアスを選択してください。","Choose_the_username_that_this_integration_will_post_as":"この連携が投稿者として使用するユーザー名を選択してください。","Clear_all_unreads_question":"すべての未読をクリアしますか?","Client_ID":"クライアント ID","Client_Secret":"クライアント シークレットキー","Clients_will_refresh_in_a_few_seconds":"クライアントは数秒で更新されます","close":"閉じる","Closed":"閉じた状態","Collapse_Embedded_Media_By_Default":"デフォルトでは、埋め込まれたメディアを折りたたみます","coming_soon":"近日公開","Commands":"コマンド","Compact_View":"コンパクト表示","Confirm_password":"パスワードの確認","Contact":"コンタクト","Conversation":"会話","Convert_Ascii_Emojis":"ASCIIを絵文字に変換する","Copied":"コピー","COPY_TO_CLIPBOARD":"クリップボードへコピー","Copy_to_clipboard":"クリップボードへコピー","Count":"カウント","Create":"作ります","Create_new":"新しく作成","Created_at":"作成日時","Created_at_s_by_s":"作成日時 <strong>%s</strong> by <strong>%s</strong>","Custom_Fields":"カスタムフィールド","Custom_oauth_helper":"OAuth プロバイダーを構築する場合、コールバック URL として <pre>%s</pre> を提供してください。","Custom_oauth_unique_name":"カスタム OAuth の一意な名前","Custom_Script_Logged_In":"ログインしたユーザーに対するカスタムスクリプト","Custom_Script_Logged_Out":"ログアウトしたユーザーに対するカスタムスクリプト","Dashboard":"ダッシュボード","days":"日","Deactivate":"停止","Debug_Level":"デバッグ レベル","Default":"デフォルト","Delete":"削除","Delete_my_account":"マイアカウントを削除","Delete_Room_Warning":"ルームを削除すると、このルームで投稿されたすべてのメッセージは削除されます。削除すると、元に戻せません。","Delete_User_Warning":"ユーザーを削除すると、このユーザーのすべてのメッセージは削除されます。削除すると、元に戻せません。","Deleted":"削除しました!","Department_not_found":"部門が見つかりませんでした","Department_removed":"部門を削除しました","Departments":"部門","Description":"概要","Desktop":"デスクトップ","Desktop_Notification_Test":"デスクトップ通知のテスト","Desktop_Notifications":"デスクトップ通知","Desktop_Notifications_Disabled":"デスクトップ通知が無効なっています。通知を有効にする場合、ブラウザの設定を変更してください。","Desktop_Notifications_Enabled":"デスクトップ通知は有効になりました","Direct_message_someone":"誰かへダイレクトメッセージ","Direct_Messages":"ダイレクトメッセージ","Direct_Messages_list":"ダイレクトメッセージ","Disable_Favorite_Rooms":"お気に入りを無効にする","Disable_New_Message_Notification":"新しいメッセージの通知を無効にする","Disable_New_Room_Notification":"新しいルームの通知を無効にする","Displays_action_text":"操作テキストを表示","Do_you_want_to_change_to_s_question":"<strong>%s</strong> へ変更したいですか?","Drop_to_upload_file":"アップロードするファイルをドロップしてください","Dry_run":"予行練習","Dry_run_description":"送信元のアドレスへ1通のメールを送信します。アドレスは、登録されているユーザーのものでなければなりません。","Duplicate_archived_channel_name":"'%s' は、すでにアーカイブされたチャンネルで登録されています","Duplicate_archived_private_group_name":"'%s' は、すでにアーカイブされたプライベートグループで登録されています","Duplicate_private_group_name":"'%s' は、すでにチャンネル/プライベートグループで登録されています","E-mail":"メール","Edit":"編集","Edit_Custom_Field":"編集カスタムフィールド","Edit_Department":"部門を編集","edited":"編集","Email":"メール","Email_already_exists":"メールアドレスは、すでに登録されています","Email_body":"メール本文","Email_Change_Disabled":"Rocket.Chat 管理者は、メールアドレスの変更を無効にしています","Email_from":"送信元","Email_Notification_Mode":"オフライン時のメール通知","Email_Notification_Mode_All":"すべての メンション / ダイレクトメッセージ","Email_Notification_Mode_Disabled":"無効","Email_or_username":"メールアドレスまたはユーザー名","Email_subject":"件名","Email_verified":"メールアドレスを検証しました","Emoji":"絵文字","Empty_title":"タイトルなし","Enable":"有効","Enable_Desktop_Notifications":"デスクトップ通知を有効にする","Enabled":"有効","Encrypted_message":"暗号化されたメッセージ","End_OTR":"オフレコ会話を終了","Enter_a_regex":"正規表現を入力","Enter_a_room_name":"ルーム名を入力します。","Enter_a_username":"ユーザー名を入力","Enter_info":"ログイン情報を入力してください","Enter_name_here":"ここに名前を入力します。","Enter_to":"Enter キーで","Error":"エラーが発生しました","error-cant-invite-for-direct-room":"直接お部屋へのユーザーを招待することはできません。","error-duplicate-channel-name":"'%s' は、すでにチャンネル/プライベートグループで登録されています","error-invalid-custom-field":"無効なカスタムフィールド","error-invalid-custom-field-name":"無効なカスタムフィールド名。文字、数字、ハイフンとアンダースコアのみを使用してください。","error-invalid-password":"無効なパスワード","error-invalid-room":"無効な部屋","error-invalid-room-name":"<strong>％sは</strong>有効なルーム名ではありません、 <br/>文字、数字、ハイフンとアンダースコアのみを使用","error-invalid-user":"無効なユーザー","error-invalid-username":"無効なユーザー名","error-not-allowed":"許可されていません","error-not-authorized":"承認されません","error-remove-last-owner":"これが最後の所有者です。この1を削除する前に、新しい所有者を設定してください。","error-role-name-required":"ロール名が必要です","error-user-not-in-room":"ユーザーはこの部屋ではありません","Error_changing_password":"パスワード変更","Error_sending_confirmation_email":"確認メールの送信中にエラーが発生しました","Error_too_many_requests":"エラーが発生しました、リクエストが多すぎます。 もう少しゆっくり操作してください。もう一度試す前に、 %s 秒待ってください","Esc_to":"Esc キーで","Example_s":"例: <code class=\"inline\">%s</code>","False":"いいえ","Favorites":"お気に入り","Field":"フィールド","Field_removed":"フィールド削除","File_exceeds_allowed_size_of_bytes":"ファイルが許可されているサイズ __size__ バイトを超過しています。","FileUpload":"ファイルアップロード","FileUpload_Enabled":"ファイルアップロードを有効にする","FileUpload_File_Empty":"ファイルが空です","FileUpload_FileSystemPath":"システム内パス","FileUpload_MaxFileSize":"アップロードできる最大ファイルサイズ (バイト数)","FileUpload_MediaType_NotAccepted":"メディア種類は、受け付けられません","FileUpload_MediaTypeWhiteList":"受け付けるメディア種類","FileUpload_MediaTypeWhiteListDescription":"カンマ区切りのメディア種類一覧。すべての受け付ける場合は、空に設定","FileUpload_ProtectFiles":"アップロードされたファイルを保護する","FileUpload_ProtectFilesDescription":"認証されたユーザーのみアクセスできます","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 バケット名","FileUpload_S3_BucketURL":"バケット URL","FileUpload_S3_CDN":"ダウンロード用のCDNドメイン","FileUpload_S3_Region":"リージョン","FileUpload_Storage_Type":"保存先ストレージ種類","Flags":"国旗","Follow_social_profiles":"私たちのソーシャルプロファイルをフォローしたり、GitHub上でのフォークしたり、私たちのTrelloのボード上でRocket.Chatアプリについてのあなたの考えを共有しましょう。","Food_and_Drink":"食べ物と飲み物","For_your_security_you_must_re_enter_your_password_to_continue":"セキュリティーの為、続けるにはもう一度パスワードを入力してください","Force_SSL":"SSLを強制する","Force_SSL_Description":"*ご注意！* _Force SSL_は、リバースプロキシで使用すべきではありません。あなたがリバースプロキシを使用している場合、あなたはそこにリダイレクトを行う必要があります。このオプションは、リバースプロキシでのリダイレクト設定を許可していませんHerokuの、のような展開のために存在します。","Forgot_password":"パスワードをお忘れですか？","Fork_it_on_github":"GitHub上でフォーク","Frequently_Used":"よく使うもの","From":"送信元","From_Email":"送信元メールアドレス","From_email_is_required":"送信元メールアドレスは必須です","From_email_warning":"<b>注意</b>: <b>送信元</b> 項目は、メールサーバーの設定の対象になります。","General":"全般","Get_to_know_the_team":"Rocket.Team について情報を得る","github_no_public_email":"あなたのGitHubアカウントはパブリックメールなどの任意のメールアドレスを持っていません","Give_a_unique_name_for_the_custom_oauth":"カスタム OAuth の一意な名前を入力してください","Give_the_application_a_name_This_will_be_seen_by_your_users":"アプリケーション名を入力してください。この名前はユーザーに表示されます。","Global":"グローバル","GoogleTagManager_id":"Google タグマネージャー ID","Has_more":"さらにあります","Have_your_own_chat":"あなたは独自のWebチャットを得ました。Rocket.Chatは、Meteor.comで開発され、開発者たちが楽しく構築し、独自のチャットのプラットフォームを進化させることのできるすばらしいソリューションです。","Header":"ヘッダ","Hidden":"非表示中","Hide_Group_Warning":"本当にグループ \"%s\" を隠しますか?","Hide_Private_Warning":"本当に \"%s\" との会話を隠しますか?","Hide_room":"ルームを隠す","Hide_Room_Warning":"本当にルーム \"%s\" を隠しますか?","Highlights":"ハイライト","Highlights_How_To":"こちらに入力した単語や連語を誰かがコメントした時に、通知されます。単語や連語は、カンマで区切ってください。ハイライトする言葉は、大文字と小文字を区別されません。","Highlights_List":"ハイライトする言葉","History":"履歴","hours":"時間","How_friendly_was_the_chat_agent":"チャット担当者の親しみやすさは、いかがでしたか?","How_knowledgeable_was_the_chat_agent":"チャット担当者の知識は、いかがでしたか?","How_responsive_was_the_chat_agent":"チャット担当者の対応は、いかがでしたか?","How_satisfied_were_you_with_this_chat":"このチャットのご満足度は、いかがでしたか?","If_you_are_sure_type_in_your_password":"お間違いなければ、パスワードを入力してください:","If_you_are_sure_type_in_your_username":"あなたのユーザー名に必ずタイプである場合：","Importer_Archived":"アーカイブ済み","Importer_done":"インポートが完了しました!","Importer_finishing":"インポートを終了しています","Importer_From_Description":"__from__ のデータを Rocket.Chat へインポート","Importer_import_cancelled":"インポートをキャンセルしました。","Importer_import_failed":"インポート中にエラーが発生しました。","Importer_importing_channels":"チャンネルをインポートしています","Importer_importing_messages":"メッセージをインポートしています","Importer_importing_started":"インポートを開始しています","Importer_importing_users":"ユーザーをインポートしています","Importer_not_defined_properly":"インポート処理が正しく定義されていません。Import クラスが見つかりません。","Importer_not_in_progress":"インポート処理は、現在停止しています","Importer_Prepare_Restart_Import":"インポートを再実行する","Importer_Prepare_Start_Import":"インポートを開始","Importer_Prepare_Uncheck_Archived_Channels":"アーカイブされたチャンネルを外す","Importer_Prepare_Uncheck_Deleted_Users":"削除されたユーザーを外す","Importer_progress_error":"インポートの進行状況を取得するのに失敗しました。","Importer_setup_error":"インポート処理の設定中にエラーが発生しました","Incorrect_Password":"パスワードが間違っています","inline_code":"インライン","Install_Extension":"拡張機能をインストール","Install_FxOs":"Firefox に Rocket.Chat をインストール","Install_FxOs_done":"やりました! ホーム画面の Rocket.Chat アイコンから利用できるようになりました。 Rocket.Chat をお楽しみください!","Install_FxOs_error":"すみません, 期待した通りに動作しませんでした! 以下のエラーが発生しました:","Install_FxOs_follow_instructions":"デバイスにアプリがインストールされることを確認してください ( \"インストール\" を押すと表示されます) 。","Installation":"インストール方法","Integration_added":"サービス連携を追加しました","Integration_Incoming_WebHook":"Incoming WebHook サービス連携","Integration_New":"新しいサービス連携","Integration_Outgoing_WebHook":"Outgoing WebHook サービス連携","Integration_updated":"サービス連携を更新しました","Integrations":"サービス連携","Invalid_asset":"アセットファイルは、有効ではありません","Invalid_confirm_pass":"入力されたパスワードとパスワードの確認が一致していません","Invalid_email":"入力されたメールアドレスが無効です","Invalid_Export_File":"アップロードされたファイルは、有効な％sのエクスポート・ファイルではありません。","Invalid_file_height":"ファイルの高さは、有効ではありません","Invalid_file_type":"ファイルの種類は、有効ではありません","Invalid_file_width":"ファイルの横幅は、有効ではありません","Invalid_Import_File_Type":"無効な取り込みファイル種類です。","Invalid_name":"名前は空にできません","Invalid_notification_setting_s":"無効な通知設定: %s","Invalid_pass":"パスワードは空にすることはできません","Invalid_room_name":"<strong>%s</strong> は有効なルーム名ではありません。<br/> 利用できるのは、半角文字(英数字・マイナス)だけです。","Invalid_room_type":"<strong>%s</strong> は有効なルーム種類ではありません。","Invalid_Secret_URL":"非公開 URL は、有効ではありません","Invalid_secret_URL_message":"入力された URL は、有効ではありません。","invisible":"状態を隠す","Invisible":"状態を隠す","Invitation_HTML":"招待メールのHTML本文","Invitation_Subject":"招待メールの件名","Invite_user_to_join_channel":"ユーザーをこのチャンネルへ招待します","Invite_Users":"ユーザーを招待","is_also_typing":"がまた入力しています","is_also_typing_female":"がまた入力しています","is_also_typing_male":"がまた入力しています","is_typing":"が入力しています","is_typing_female":"が入力しています","is_typing_male":"が入力しています","italics":"斜体","join":"参加","Join_audio_call":"音声通話に参加","Join_the_Community":"コミュニティに参加","Join_the_given_channel":"チャンネルへ参加する","Join_video_call":"ビデオ通話に参加","Joined":"参加中","Jump":"移動","Jump_to_first_unread":"最初の未読へ移動","Jump_to_message":"メッセージへ移動","Jump_to_recent_messages":"最近のメッセージへ移動","Katex_Enabled":"Katex を有効にする","Label":"ラベル","Language":"言語","Language_Version":"日本語バージョン","Last_login":"最終ログイン","Last_message":"最後のメッセージ","Last_seen":"最近見たもの","Layout":"レイアウト","Layout_Home_Body":"ホーム画面の本文","Layout_Home_Title":"ホーム画面のタイトル","Layout_Login_Terms":"ログイン画面の規約","Layout_Privacy_Policy":"プライバシーポリシー","Layout_Sidenav_Footer":"サイドナビゲーションのフッター","Layout_Sidenav_Footer_description":"フッターのサイズは 260 × 70px です","Layout_Terms_of_Service":"サービス利用規約","LDAP":"LDAP","LDAP_CA_Cert":"CA 証明書","LDAP_Custom_Domain_Search":"カスタムドメイン検索","LDAP_Custom_Domain_Search_Description":"バインドと接続情報を管理し、フォームのあるJSONの作品： <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"既定ドメイン","LDAP_Description":"LDAP は、多くの企業でシングルサインオンを提供する為に使用している階層構造データベースで、 1 つのパスワードを複数サイトやサービスで共有できる手法です。高度な設定情報や例示は、私達の wiki で相談してください: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"ドメインベース","LDAP_Domain_Base_Description":"検索したいユーザーやグループが LDAP サブツリーとして属す完全修飾の Distinguished Name (DN) 。 それぞれのグループは、そこに属すユーザーと同じドメインベースに定義されていなければなりません。特定のユーザーグループを制限した場合、そのグループに属したユーザーのみ対象になります。LDAP ディレクトリーのトップレベルドメインをドメインベースとし、アクセス制御には検索フィルターを使用することを推奨します。","LDAP_Domain_Search_Filter":"ドメイン検索フィルター","LDAP_Domain_Search_Filter_Description":"指定すると、このフィルターにマッチしたユーザーのみログインできます。何も指定しないと、指定したドメインベースの範囲にいるすべてのユーザーログインできるようになります。<br/>例えば Active Directory では `memberOf=cn=ROCKET_CHAT,ou=General Groups` など。<br/>例えば OpenLDAP ( 拡張可能な検索 ) では `ou:dn:=ROCKET_CHAT` など。","LDAP_Domain_Search_Object_Category":"ドメイン検索の objectCategory","LDAP_Domain_Search_Object_Category_Description":"ユーザーを識別する *objectCategory* 。<br/>空値は *OpenLDAP* のために、除いてください。<br/>例例えば、 `person` など。","LDAP_Domain_Search_Object_Class":"ドメイン検索の objectclass","LDAP_Domain_Search_Object_Class_Description":"ユーザーを識別する *objectclass* 。<br/>例えば、 `organizationalPerson` 、 `user` 、 `inetOrgPerson` など。","LDAP_Domain_Search_Password":"ドメイン検索のパスワード","LDAP_Domain_Search_Password_Description":"ドメイン検索ユーザーのパスワード。","LDAP_Domain_Search_User":"ドメイン検索ユーザー","LDAP_Domain_Search_User_Description":"ユーザーがログインするためにユーザーを検索する時に使用する LDAP ユーザー。<br/>これは多くの場合、 3rd パーティー連携の為に特別に作成されたサービスアカウントです。 `cn=Administrator,cn=Users,dc=Example,dc=com` といった完全修飾名を使用してください。","LDAP_Domain_Search_User_ID":"ドメイン検索ユーザー ID","LDAP_Domain_Search_User_ID_Description":"認証を試みるユーザーの LDAP 属性。 このフィールドは、ほとんどの Active Directory インストールで `sAMAccountName` とすることを推奨されていますが、ほかの OpenLDAP などの LDAP システムでは `uid` かもしれません。 `mail` をメールアドレスとしてユーザーを識別であれば使用できますし、この他にも識別できればどんな属性でも構いません。<br>複数の値をカンマ区切りで指定すれば、メールアドレスとユーザー名といったように複数のIDでログインできるようになります。","LDAP_Enable":"有効にする","LDAP_Enable_Description":"LDAP による認証を試行するようになります。","LDAP_Encryption":"暗号化","LDAP_Encryption_Description":"LDAP サーバーとセキュアに通信するため、暗号化機能を使用します。例えば `plain` (暗号化なし) 、 `SSL/LDAPS` (開始から暗号化) や `StartTLS` (一度接続したら暗号化通信へアップグレード) を使用できます。","LDAP_Host":"ホスト","LDAP_Host_Description":"LDAP ホスト。例: `ldap.example.com` や `10.0.0.30`。","LDAP_Port":"ポート","LDAP_Port_Description":"LDAP アクセスするポート番号。例: `389` や `636` ( LDAPS 用 )","LDAP_Reject_Unauthorized":"認証できなければ拒否する","LDAP_Sync_User_Avatar":"ユーザーのアバターを同期する","LDAP_Sync_User_Data":"データを同期する","LDAP_Sync_User_Data_Description":"ログインする時に、ユーザーデータを同期します (例: 名前, メールアドレス)","LDAP_Sync_User_Data_FieldMap":"ユーザーデータのフィールドマップ","LDAP_Sync_User_Data_FieldMap_Description":"どのようにユーザーアカウントのフィールド (メールアドレスなど) を LDAP にあるレコードから調整するか。 <br/>例えば、 `{\"cn\":\"name\", \"mail\":\"email\"}` では、人間が読める名前を cn 属性とし、メールアドレスを mail 属性から取得します。<br/> 使用できるは、 `名前` と `メールアドレス` を含むものです。","LDAP_Sync_Users":"ユーザーを同期する","LDAP_Test_Connection":"接続テスト","LDAP_Unique_Identifier_Field":"一意性を識別するフィールド","LDAP_Unique_Identifier_Field_Description":"どのフィールドで LDAP ユーザーと Rocket.Chat ユーザーをリンクするか。複数の値をカンマ区切りで指定すると LDAP レコードからそれぞれ取得することを試みます。<br/>既定値は、 `objectGUID,ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber` です","LDAP_Use_Custom_Domain_Search":"カスタムドメイン検索を使用する","LDAP_Use_Custom_Domain_Search_Description":"LDAP サーバー上で検索する際の独自フィルターを記述する場合に指定します。","LDAP_Username_Field":"ユーザー名フィールド","LDAP_Username_Field_Description":"どのフィールドを新しいユーザーの *ユーザー名* として使用するのか。ログインページのユーザー名を利用する場合は、空にしてください。<br/>テンプレートタグとして `#{givenName}.#{sn}` といった記述も使用できます。<br/>既定値は、 `sAMAccountName` です","Leave_Group_Warning":"本当にグループ \"%s\" から退出しますか?","Leave_Private_Warning":"本当に \"%s\" との会話から退出しますか?","Leave_room":"ルームを出る","Leave_Room_Warning":"本当にルーム \"%s\" から退出しますか?","line":"ライン","List_of_Direct_Messages":"ダイレクトメッセージ一覧","Live_sessions":"ライブセッション","Livechat_agents":"ライブチャット 担当者","Livechat_Dashboard":"ライブチャット ダッシュボード","Livechat_enabled":"ライブチャットを有効にする","Livechat_Manager":"ライブチャット 管理者","Livechat_managers":"ライブチャット 管理者","Livechat_title":"ライブチャットのタイトル","Livechat_title_color":"ライブチャットのタイトル背景色","Livechat_Users":"ライブチャット 担当者","Load_more":"さらに読み込み","Loading...":"読み込み中...","Loading_more_from_history":"さらに履歴を読み込み中","Loading_suggestion":"候補を読み込み中...","Localization":"地域化","Log_File":"ファイルと罫線を表示する","Log_Level":"ログレベル","Log_Package":"パッケージを表示する","Log_View_Limit":"ログ表示数","Logged_out_of_other_clients_successfully":"他のクライアントを正常にログアウトさせました","Login":"ログイン","Login_with":"%s でログイン","login_with":"または直接ログイン","Logout":"ログアウト","Logout_Others":"ログインしている他のクライアントをログアウトする","Mail_Message_Invalid_emails":"ひとつ、またはいくつかの無効なメールアドレスが入力されました: %s","Mail_Message_Missing_to":"ひとつ、またはさらにユーザーを選択するか、メールアドレスをカンマ区切りで入力してください。","Mail_Message_No_messages_selected_select_all":"何もメッセージを選択しませんでした。表示されているメッセージの <a href='#' class='select-all'>すべてを選択</a> しますか?","Mail_Messages":"メッセージをメール","Mail_Messages_Instructions":"メールで送信したいメッセージをクリックして選択してください","Mail_Messages_Subject":"こちらは %s から選択されたメッセージです","Mailer":"メーラー","Mailer_body_tags":"[unsubscribe] を購読解除のリンクとして<b>使わなければなりません</b>。<br />ユーザーのフルネームに [name], [fname], [lname] を使用できます。姓 または 名 にも対応しています。<br />メールアドレスには、 [email] を使用できます。","Make_Admin":"管理者に設定","Manager_added":"管理者を追加しました","Manager_removed":"管理者を削除しました","Mark_as_read":"既読にする","Markdown_Headers":"Markdown ヘッダー","Markdown_SupportSchemesForLink":"Markdown リンクでサポートするスキーマ","Markdown_SupportSchemesForLink_Description":"許可するスキーマをカンマ区切りで記述してください。","Members_List":"メンバーリスト","Mentions":"メンション","Mentions_default":"メンション (デフォルト)","Message":"メッセージ","Message_AllowDeleting":"メッセージの削除を許可する","Message_AllowEditing":"メッセージの編集を許可する","Message_AllowEditing_BlockEditInMinutes":"メッセージの編集を (n) 分ブロックする","Message_AllowEditing_BlockEditInMinutesDescription":"ブロックしない場合は、 0 を入力。","Message_AllowPinning":"メッセージのピン留めを許可する","Message_AllowPinning_Description":"どのチャンネルでもメッセージのピン留めを許可します。","Message_AllowStarring":"メッセージへのスターを許可する","Message_AudioRecorderEnabled":"音声録音を有効にする","Message_AudioRecorderEnabledDescription":"'audio/wav' が 'ファイルアップロード' 設定のメディア種類で許可されていなければなりません","Message_DateFormat":"日付のフォーマット","Message_DateFormat_Description":"参考: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"メッセージを削除する権限がありません","Message_editing_blocked":"このメッセージを編集できません","Message_editing_not_allowed":"メッセージを編集する権限がありません","Message_GroupingPeriod":"グループ化する期限 (秒数)","Message_GroupingPeriodDescription":"指定した秒数の間で、同じユーザーが投稿した以前のメッセージをグループ化します。","Message_KeepHistory":"メッセージ履歴を保持","Message_MaxAllowedSize":"メッセージの最大文字数","Message_MaxAll":"ALL のメッセージの最大チャネルサイズ","Message_pinned":"メッセージをピン留めしました","Message_pinning_not_allowed":"メッセージをピン留めする権限がありません","Message_removed":"メッセージを削除しました","Message_ShowDeletedStatus":"削除した状態を表示する","Message_ShowEditedStatus":"編集した状態を表示する","Message_ShowFormattingTips":"書式のヒントを表示する","Message_TimeFormat":"時刻のフォーマット","Message_TimeFormat_Description":"参考: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"メッセージが長すぎです","Messages":"メッセージ","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Incoming WebHook へ送信されたメッセージは、こちらへ投稿されます。","Meta":"メタ情報","Meta_fb_app_id":"Facebook アプリケーション ID","Meta_google-site-verification":"Google Site Verification","Meta_language":"言語","Meta_msvalidate01":"MSValidate.01","Meta_robots":"robots属性","minutes":"分","Mobile_push":"モバイルプッシュ通知","More_channels":"その他のチャンネル","More_direct_messages":"その他のダイレクトメッセージ","More_groups":"その他のプライベートグループ","More_unreads":"その他の未読","Msgs":"メッセージ","multi":"マルチ","Mute_someone_in_room":"誰かをルームでミュートにする","Mute_user":"ミュート","Muted":"ミュートにしました","My_Account":"マイアカウント","n_messages":"%s メッセージ","N_new_messages":"%s 件の新しいメッセージ","Name":"名前","Name_cant_be_empty":"名前は空にできません","Name_of_agent":"担当者の名前","Name_optional":"名前 (オプション)","Navigation_History_20_last_pages":"案内の履歴 ( 最近 20 ページ )","New_Application":"新しいアプリケーション","New_Custom_Field":"新しいカスタムフィールド","New_Department":"新しい部門","New_integration":"新しいサービス連携","New_logs":"新しい履歴","New_messages":"新しいメッセージ","New_password":"新しいパスワード","New_role":"新しいロール","No_channel_with_name_%s_was_found":"<strong>\"%s\"</strong> というチャンネルは、見つかりませんでした!","No_channels_yet":"まだチャンネルに参加していません。","No_direct_messages_yet":"まだ会話を開始していません。","No_Encryption":"暗号化なし","No_favorites_yet":"あなたはまだお気に入りに追加していません。","No_group_with_name_%s_was_found":"<strong>\"%s\"</strong> というプライベートグループは、見つかりませんでした!","No_groups_yet":"まだプライベートグループを持っていません。","No_livechats":"ライブチャットがありません。","No_mentions_found":"メンションが見つかりませんでした","No_permission_to_view_room":"このルームを表示する権限がありません","No_pinned_messages":"ピン留めされたメッセージはありません","No_results_found":"メッセージは、見つかりませんでした","No_starred_messages":"スターをつけたメッセージはありません","no_tokens_for_this_user":"このユーザーにトークンがありません","No_user_with_username_%s_was_found":"<strong>\"%s\"</strong> というユーザーは、見つかりませんでした!","Not_allowed":"権限がありません","Not_authorized":"権限がありません","Not_Available":"利用不可","Not_found_or_not_allowed":"見つからないか、権限がありません","Nothing":"なし","Nothing_found":"何も見つかりませんでした","Notifications":"通知","Notify_all_in_this_room":"このルームの全員に通知","Num_Agents":"# 担当者","Number_of_messages":"メッセージ数","OAuth_Application":"OAuth アプリケーション","OAuth_Applications":"OAuth アプリケーション","Objects":"オブジェクト","Off_the_record_conversation":"オフレコ会話","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"ご利用のブラウザーやデバイスでは、オフレコ会話を利用できません","Offline_DM_Email":"[__site__] ダイレクトメッセージが届いています by __user__","Offline_Mention_Email":"[__site__] あなたについて #__room__ でコメントされています by __user__","Old_and_new_password_must_be_different":"新しいパスワードは、古いパスワードと同じにできません。","Old_and_new_password_required":"パスワードを変更するには、古いパスワードと新しいパスワードの両方を入力してください。","Online":"オンライン","Only_errors":"エラーのみ","Only_you_can_see_this_message":"あなただけが、このメッセージを見られます","Oops!":"おっと","Open":"開いた","Opened":"開いた状態","Opt_out_statistics":"使用状況の統計を Rocket.Chat へ送信しない","Opt_out_statistics_warning":"使用状況の統計を送信すると、 私たちがどのくらいのRocket.Chatが公開しているかやシステムが正常に稼働しているか把握する手助けになり、改善へと活かすことができます。心配しないでください。ユーザー情報は送信されませんし、私たちが受け取ったすべての情報は機密として扱われます。使用状況の統計を送ってもよければ、上記チェックボックスのチェックを外してください。","optional":"オプション","Order":"注文","OS_Arch":"OS アーキテクチャー","OS_Cpus":"OS CPU 数","OS_Freemem":"OS 空きメモリー","OS_Loadavg":"OS ロードアベレージ","OS_Platform":"OS プラットフォーム","OS_Release":"OS リリースバージョン","OS_Totalmem":"OS 総メモリー","OS_Type":"OS 種類","OS_Uptime":"OS 稼働時間","others":"その他","OTR":"オフレコ会話","OTR_is_only_available_when_both_users_are_online":"オフレコ会話は、ユーザーがお互いにオンラインの場合に利用できます","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"アップロードされたファイルの URL を上書きします。この URL は、 CDN から提供された URL の代わりにダウンロードで使われます","Password":"パスワード","Password_Change_Disabled":"Rocket.Chat 管理者は、パスワードの変更を無効にしています","Password_changed_successfully":"パスワードが正常に変更されました","Payload":"ペイロード","People":"メンバー","Permissions":"権限","Pin_Message":"ピン留めする","Pinned_a_message":"メッセージをピン留めしました :","Pinned_Messages":"ピン留めされたメッセージ","Placeholder_for_email_or_username_login_field":"ログインフォームのメールアドレスやユーザー名に表示するプレースホルダー","Placeholder_for_password_login_field":"ログインフォームのパスワードに表示するプレースホルダー","Please_answer_survey":"このチャットに関する簡単なアンケートに、少々お時間を頂けますでしょうか?","Please_enter_value_for_url":"アバターの URL を入力してください。","Please_enter_your_new_password_below":"以下に、新しいパスワードを入力してください :","Please_fill_a_label":"ラベルを記入してください","Please_fill_a_name":"名前を入力してください","Please_fill_a_username":"ユーザー名を入力してください","Please_fill_name_and_email":"名前とメールアドレスを入力してください","Please_re_enter_your_password":"パスワードをもう一度入力してください","Please_select_enabled_yes_or_no":"有効の設定オプションを選択してください","Please_wait":"お待ちください","Please_wait_activation":"少し時間がかかるので、お待ちください。","Please_wait_statistics":"統計を生成しているので、お待ちください。","Please_wait_while_OTR_is_being_established":"オフレコ会話を確立するまで、お待ちください","Please_wait_while_your_account_is_being_deleted":"アカウントが削除されるまで、お待ちください...","Please_wait_while_your_profile_is_being_saved":"プロフィールが保存されるまで、お待ちください...","Post_as":"投稿ユーザー","Post_to_Channel":"投稿先チャンネル","Post_to_s_as_s":"<strong>%s</strong> へ <strong>%s</strong> として投稿","Powered_by":"Powered by","Preferences":"設定","Preferences_saved":"設定を保存しました","Privacy":"プライバシー","Private_Group":"プライベートグループ","Private_Groups":"プライベートグループ","Private_Groups_list":"プライベートグループ一覧","Profile":"プロフィール","Profile_saved_successfully":"プロフィールが正常に保存されました。","Proudly_developed":"Meteorで誇りを持って開発","Push":"プッシュ通知","Push_apn_cert":"APN 証明書","Push_apn_dev_cert":"APN 開発者 証明書","Push_apn_dev_key":"APN 開発者 キー","Push_apn_dev_passphrase":"APN 開発者 パスフレーズ","Push_apn_key":"APN キー","Push_apn_passphrase":"APN パスフレーズ","Push_debug":"デバッグ","push_disabled":"プッシュ通知を無効にする","Push_enable":"有効にする","Push_enable_gateway":"ゲートウェイを有効にする","Push_gateway":"ゲートウェイ","Push_gcm_api_key":"GCM API キー","Push_gcm_project_number":"GCM プロジェクトナンバー","Push_production":"本番環境","Push_show_message":"通知でメッセージを表示する","Push_show_username_room":"通知でチャンネル/グループ/ユーザー名を表示する","Push_test_push":"テスト","Query":"条件クエリー","Query_description":"メール送信先のユーザーを決める追加条件。購読解除されたユーザーは、自動的に条件から除外されます。条件は、有効なJSON形式でなければなりません。例:  \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"クイック検索","quote":"引用","Reactions":"リアクション","Recents":"最近","Record":"記録","Redirect_URI":"リダイレクト先 URI","Refresh_keys":"接続鍵を更新","Refresh_your_page_after_install_to_enable_screen_sharing":"画面共有に必要なインストールしたら、ページを更新してください","Register":"新しいアカウントを登録","Registration_Succeeded":"登録が成功しました","Remember_me":"ログイン情報を保存","Remove":"削除","Remove_Admin":"管理者から削除","Remove_as_moderator":"モデレーターから削除","Remove_as_owner":"オーナーから削除","Remove_custom_oauth":"カスタム OAuth を削除","Remove_from_room":"ルームから削除","Remove_someone_from_room":"誰かをルームから削除","Removed":"削除しました","Require_password_change":"パスワードの変更を要求","Resend_verification_email":"認証メールを再送信","Reset":"リセット","Reset_password":"パスワードリセット","Restart":"再起動","Restart_the_server":"サーバーを再起動","RocketBot_Enabled":"RocketBot を有効にする","RocketBot_Name":"RocketBot の名前","RocketBot_Name_Description":"RocketBot の名前は、登録されている有効なユーザー名でなければなりません。","Role":"ロール","Role_Editing":"ロール編集","Role_removed":"ロールを削除しました","Room":"ルーム","Room_archivation_state":"状態","Room_archivation_state_false":"アクティブ","Room_archivation_state_true":"アーカイブ","Room_archived":"ルームをアーカイブしました","room_changed_privacy":"ルームの種類を <em>__room_type__</em> へ変更しました。 by <em>__user_by__</em>","room_changed_topic":"ルームのトピックを <em>__room_topic__</em> へ変更しました。 by <em>__user_by__</em>","Room_has_been_deleted":"ルームは削除されました","Room_Info":"ルーム情報","Room_name_changed":"ルーム名を <em>__room_name__</em> へ変更しました。 by <em>__user_by__</em>","Room_name_changed_successfully":"ルーム名が正常に変更されました","Room_not_found":"ルームが見つかりませんでした","Room_topic_changed_successfully":"ルームのトピックは正常に変更されました","Room_type_changed_successfully":"ルームの種類は正常に変更されました","Room_unarchived":"ルームのアーカイブを解除しました","Room_uploaded_file_list":"ファイル一覧","Room_uploaded_file_list_empty":"ファイルがありません。","room_user_count":"%s 人","Rooms":"ルーム","S_new_messages_since_s":"%s 件の新しいメッセージが %s 以降に投稿されています","SAML":"SAML","SAML_Custom_Cert":"カスタム 証明書","SAML_Custom_Entry_point":"カスタム エントリーポイント","SAML_Custom_Generate_Username":"ユーザー名を生成する","SAML_Custom_Issuer":"カスタム 照会者 (Issuer)","SAML_Custom_Provider":"カスタム プロバイダー","Save":"保存","Save_changes":"変更を保存","Save_Mobile_Bandwidth":"モバイルデータ通信量を節約する","Save_to_enable_this_action":"この操作をする前に、保存してください","Saved":"保存しました","Saving":"保存しています","Scope":"範囲","Screen_Share":"画面共有","Script_Enabled":"スクリプトを有効にする","Search":"検索","Search_by_username":"ユーザー名で検索","Search_Channels":"チャンネルを検索","Search_Direct_Messages":"ダイレクトメッセージを検索","Search_Messages":"メッセージを検索","Search_Private_Groups":"プライベートグループを検索","Search_settings":"検索設定","seconds":"秒","See_all":"すべて見る","See_only_online":"オンラインのみ","Select_a_department":"部門を選択","Select_an_avatar":"アバターを選択","Select_file":"ファイルを選択","Select_service_to_login":"サービスにログインしてアバターを読み込むか、もしくは画像を直接アップロードしてください","Select_user":"選択したユーザ","Select_users":"ユーザーを選択","Selected_agents":"選択された担当者","Selected_users":"メンバーを選択","Send":"送信","Send_a_message":"メッセージを送信","Send_a_test_mail_to_my_user":"メールのテストをマイユーザーへ送信","Send_a_test_push_to_my_user":"プッシュ通知のテストをマイユーザーへ送信","Send_confirmation_email":"確認メールを送信","Send_data_into_RocketChat_in_realtime":"リアルタイムに Rocket.Chat へデータを送信します。","Send_email":"メール送信","Send_invitation_email":"招待メールを送信","Send_invitation_email_error":"正しい書式のメールアドレスが入力されていません。","Send_invitation_email_info":"一度に複数の招待メールを送信できます。","Send_invitation_email_success":"以下のアドレスへ招待メールを送信しました:","Send_invitation_email_warning":"招待メールを送信するには、はじめに SMTP 設定を調整してください。","Send_Message":"メッセージを送信","Send_your_JSON_payloads_to_this_URL":"この URL へ JSON ペイロードを送信してください。","Sending":"送信しています...","Set_as_moderator":"モデレーターに設定","Set_as_owner":"オーナーに設定","Settings":"設定","Settings_updated":"設定を更新しました","Should_be_a_URL_of_an_image":"URL で指定する先は、画像でなければなりません。","Should_exists_a_user_with_this_username":"ユーザーは登録されていなければなりません。","Show_all":"すべて表示","Show_more":"さらに表示","Show_only_online":"オンラインのみ表示","Show_preregistration_form":"事前登録フォームを表示する","Showing_archived_results":"<p><b>%s</b> 件のアーカイブされた結果を表示</p>","Showing_online_users":"__total__ ユーザー中 <b>__total_showing__</b> ユーザーが見ています","Showing_results":"<p><b>%s</b> 件の結果を表示</p>","Silence":"サイレンス","since_creation":"%s から","Site_Name":"サイト名","Site_Url":"サイトURL","Site_Url_Description":"例: https://chat.domain.com/","Skip":"スキップ","Smileys_and_People":"顔文字と人々","SMTP":"SMTP","SMTP_Host":"SMTP ホスト","SMTP_Password":"SMTP パスワード","SMTP_Port":"SMTP ポート","SMTP_Test_Button":"SMTP 設定をテスト","SMTP_Username":"SMTP ユーザー名","Sound":"サウンド","Star_Message":"スターをつける","Starred_Messages":"スターをつけたメッセージ","Start_audio_call":"音声通話を開始","Start_Chat":"チャットを開始","Start_of_conversation":"会話を開始","Start_OTR":"オフレコ会話を開始","Start_video_call":"ビデオ通話を開始","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"ユーザーは <code class=\"inline\">%s</code> 、チャンネルは <code class=\"inline\">%s</code> から始めてください。 例: <code class=\"inline\">%s</code> または <code class=\"inline\">%s</code>","Statistics":"統計","Stats_Active_Users":"アクティブなユーザー","Stats_Avg_Channel_Users":"チャンネルの平均ユーザー","Stats_Avg_Private_Group_Users":"プライベートグループの平均ユーザー","Stats_Away_Users":"離席中のユーザー","Stats_Max_Room_Users":"ルームの最多ユーザー","Stats_Non_Active_Users":"アクティブでないユーザー","Stats_Offline_Users":"オフラインのユーザー","Stats_Online_Users":"オンラインのユーザー","Stats_Total_Channels":"すべてのチャンネル","Stats_Total_Direct_Messages":"すべてのダイレクトメッセージ","Stats_Total_Messages":"すべてのメッセージ","Stats_Total_Private_Groups":"すべてのプライベートグループ","Stats_Total_Rooms":"すべてのチャットルーム","Stats_Total_Users":"すべてのユーザー","Stop_Recording":"記録を停止","strike":"取り消し線","Subject":"件名","Submit":"送信","Success":"成功","Survey":"アンケート","Survey_instructions":"それぞれの設問にご満足度を、全く不満 1 〜 大変満足5 で評価してください。","Symbols":"シンボル","Sync_success":"同期に成功しました","Sync_Users":"ユーザーを同期","Test_Connection":"接続をテスト","Test_Desktop_Notifications":"デスクトップ通知をテスト","Thank_you_for_your_feedback":"ご意見をありがとうございます","The_application_name_is_required":"アプリケーション名は必須です","The_channel_name_is_required":"チャンネル名は必須です","The_emails_are_being_sent":"メールは送信されました","The_field_is_required":"%s 項目は、必須です。","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"画像のリサイズは、機能していません。インストールされているサーバーで ImageMagick や GraphicsMagick を検出できません。","The_redirectUri_is_required":"リダイレクト先 URI は必須です","The_server_will_restart_in_s_seconds":"%s 秒後にサーバーを再起動します","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>%s</strong> 設定は、 <strong>%s</strong> に設定されていて、 <strong>%s</strong> からアクセスしています!","The_user_will_be_removed_from_s":"そのユーザーは、 %s から削除されます","The_user_wont_be_able_to_type_in_s":"そのユーザーは、 %s で入力できなくなります","Theme":"テーマ","theme-color-action-buttons-color":"アクション ボタン色","theme-color-active-channel-background-color":"アクティブなチャンネル 背景色","theme-color-active-channel-font-color":"アクティブなチャンネル 文字色","theme-color-blockquote-background":"引用 背景色","theme-color-clean-buttons-color":"操作 ボタン色","theme-color-code-background":"コード 背景色","theme-color-code-border":"コード 枠色","theme-color-code-color":"コード色","theme-color-content-background-color":"コンテンツ 背景色","theme-color-custom-scrollbar-color":"カスタム スクロールバー色","theme-color-info-active-font-color":"アクティブな情報 文字色","theme-color-info-font-color":"情報 文字色","theme-color-input-font-color":"入力 文字色","theme-color-link-font-color":"リンク 文字色","theme-color-message-hover-background-color":"メッセージ ホバー 背景色","theme-color-primary-background-color":"基本 背景色","theme-color-primary-font-color":"基本 文字色","theme-color-quaternary-font-color":"四次 文字色","theme-color-secondary-background-color":"二次 背景色","theme-color-secondary-font-color":"二次 文字色","theme-color-smallprint-font-color":"小さい表示 文字色","theme-color-smallprint-hover-color":"小さい表示 ホバー 文字色","theme-color-status-away":"離席中 ステータス色","theme-color-status-busy":"取り込み中 ステータス色","theme-color-status-offline":"状態を隠す ステータス色","theme-color-status-online":"オンライン ステータス色","theme-color-tertiary-background-color":"三次 背景色","theme-color-tertiary-font-color":"三次 文字色","theme-color-unread-notification-color":"未読 通知色","theme-custom-css":"カスタム CSS","There_are_no_agents_added_to_this_department_yet":"この部門には、まだ担当者がいません。","There_are_no_integrations":"連携しているサービスはありません","There_are_no_users_in_this_role":"このロールを割り当てられたユーザーはいません。","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"このメールアドレスは、すでに登録されていますが、認証手続きの途中です。パスワードを変更してください。","This_is_a_desktop_notification":"これはデスクトップ通知です","This_is_a_push_test_messsage":"これはプッシュ通知のテストメッセージです","Time_in_seconds":"時間を秒数で指定","Title_bar_color":"タイトルバー色","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Webサイトへ Rocket.Chat ライブチャットを導入するには、あなたのサイトの <strong>&lt;/body&gt;</strong> タグの前に、このコードをコピー &amp; ペーストしてください。","To_users":"宛先ユーザー","Topic":"トピック","Travel_and_Places":"旅行と名所","Trigger_removed":"トリガーを削除しました","Trigger_Words":"トリガーになる言葉","Triggers":"トリガー","True":"はい","Type":"種類","Type_your_new_password":"新しいパスワードを入力","Unarchive":"アーカイブを解除","Unmute_someone_in_room":"誰かをルームでミュートを解除されました","Unmute_user":"ミュートを解除","Unnamed":"無名","Unpin_Message":"ピン留めを外す","Unread_Rooms":"未読のあるルーム","Unread_Rooms_Mode":"未読ルーム表示モード","Unstar_Message":"スターを外す","Upload_file_question":"アップロードしますか?","Uploading_file":"ファイルをアップロード中...","Use_account_preference":"アカウント設定を使用する","Use_Emojis":"絵文字を使う","Use_initials_avatar":"ユーザー名の頭文字を使用","use_menu":"ルームやチャットにアクセスするには、サイドメニューを使用します","Use_service_avatar":"%s のアバターを使用","Use_this_username":"ユーザー名を使用","Use_uploaded_avatar":"アップロードしたアバターを使用","Use_url_for_avatar":"URL をアバターに使用","User__username__is_now_a_moderator_of__room_name_":"ユーザー __username__ は、これより __room_name__ のモデレーターです","User__username__is_now_a_owner_of__room_name_":"ユーザー __username__ は、これより __room_name__ のオーナーです","User__username__removed_from__room_name__moderators":"ユーザー __username__ を __room_name__ のモデレーターから削除しました","User__username__removed_from__room_name__owners":"ユーザー __username__ を __room_name__ のオーナーから削除しました","User_added":"ユーザーを追加しました","User_added_by":"ユーザー <em>__user_added__</em> を追加しました。 by <em>__user_by__</em>","User_added_successfully":"ユーザーが正常に追加されました","User_Channels":"ユーザーのチャンネル","User_doesnt_exist":"`@%s` という名前のユーザーは、登録されていません。","User_has_been_activated":"ユーザーが有効にされました","User_has_been_deactivated":"ユーザーが停止されました","User_has_been_deleted":"ユーザーは削除されました","User_has_been_muted_in_s":"ユーザーは %s でミュートにされました","User_has_been_removed_from_s":"ユーザーは %s から削除されました","User_has_disconnected":"ユーザーは切断されました","User_Info":"ユーザー情報","User_is_no_longer_an_admin":"ユーザーはもう管理者ではありません","User_is_not_activated":"ユーザーは有効ではありません","User_is_now_an_admin":"ユーザーはこれより管理者です","User_joined_channel":"チャンネルへ参加しました。","User_joined_channel_female":"チャンネルへ参加しました。","User_joined_channel_male":"チャンネルへ参加しました。","User_left":"ユーザー <em>__user_left__</em> は退出しました。","User_left_female":"チャンネルから退出しました。","User_left_male":"チャンネルから退出しました。","User_logged_out":"ユーザーはログアウトしました","User_management":"ユーザー管理","User_muted_by":"ユーザー <em>__user_muted__</em> をミュートにしました。 by <em>__user_by__</em>","User_muted_in_room":"ユーザーはルームでミュートにされました","User_not_found":"ユーザーが見つからないか、パスワードが間違っています","User_not_found_or_incorrect_password":"ユーザーが見付からないか、パスワードが間違っています","User_or_channel_name":"ユーザー名 または チャンネル名","User_removed":"ユーザーを削除しました","User_removed_by":"ユーザー <em>__user_removed__</em> を削除しました。 by <em>__user_by__</em>","User_removed_from_room":"ユーザーはルームから削除されました","User_Settings":"ユーザー設定","User_unmuted_by":"ユーザー <em>__user_unmuted__</em> は、ミュートを解除されました。 by <em>__user_by__</em>","User_unmuted_in_room":"ユーザーはルームでミュートを解除されました","User_updated_successfully":"ユーザーは正常に更新されました","Username":"ユーザー名","Username_and_message_must_not_be_empty":"ユーザー名とメッセージは空にできません。","Username_cant_be_empty":"ユーザー名は空にすることはできません","Username_Change_Disabled":"Rocket.Chat 管理者は、ユーザー名の変更を無効にしています","Username_denied_the_OTR_session":"__username__ は、オフレコ会話を断りました","Username_description":"ユーザー名は、ほかの人がメッセージの中であなたについて言及するために利用します。","Username_doesnt_exist":"ユーザー名 `%s` は存在しません。","Username_ended_the_OTR_session":"__username__ は、オフレコ会話を終了しました","Username_invalid":"<strong>%s</strong> は、有効なユーザー名ではありません。<br/> 利用できるのは、半角文字(英数字・ドット・マイナス)だけです","Username_is_already_in_here":"`@%s` は、すでにここにいます。","Username_is_not_in_this_room":"ユーザー `#%s` は、このルームにいません。","Username_not_found":"ユーザー名が見つかりません","Username_title":"ユーザー名を登録","Username_unavaliable":"<strong>%s</strong> は、すでに利用されています :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ は、オフレコ会話を開始したいようです。受け入れますか?","Users":"ユーザー","Users_in_role":"ロールを割り当て中のユーザー","UTF8_Names_Slugify":"UTF8形式名をスラグ化する","UTF8_Names_Validation":"UTF8形式名の検証パターン","UTF8_Names_Validation_Description":"特殊文字と空はを許可しないでください。半角記号(マイナス・アンダーバー・ドット)を使えますが、名前の最後には使えません","Verification_email_sent":"認証メールを送信しました","View_All":"すべて表示","View_Logs":"ログ表示","Visibility":"可視性","Visible":"目に見えます","Visitor":"ビジター","Visitor_page_URL":"訪問者のページ URL","Visitor_time_on_site":"サイトの滞在時間","Wait_activation_warning":"ログインするには、管理者によるアカウントの有効化が必要です。","We_are_offline_Sorry_for_the_inconvenience":"ただいまオフラインです。ご不便をお掛けし、申し訳ありません。","We_have_sent_password_email":"パスワードのリセット手順を記載したメールを送信しました。すぐにメールが届かない場合は、再度お試しください。","We_have_sent_registration_email":"登録を確認するメールを送信しました。すぐにメールが届かない場合は、再度お試しください。","WebRTC_Enable_Channel":"パブリックチャンネルで有効にする","WebRTC_Enable_Direct":"ダイレクトメッセージで有効にする","WebRTC_Enable_Private":"プライベートチャンネルで有効にする","WebRTC_Servers":"STUN/TURN サーバー","WebRTC_Servers_Description":"カンマ区切りの STUN と TRUN サーバー一覧。<br/>ユーザー名、パスワードとポートは、`ユーザー名:パスワード@stun:ホスト:ポート` または `ユーザー名:パスワード@turn:ホスト:ポート` の形式で指定してください。","Welcome":"ようこそ <em>%s</em>.","Welcome_to_the":"ようこそ","will_be_able_to":"は、以下ができるようになります","With_whom":"宛先","Yes":"はい","Yes_clear_all":"はい、すべてクリアします!","Yes_delete_it":"はい、削除します!","Yes_hide_it":"はい、隠します!","Yes_leave_it":"はい、退出します!","Yes_mute_user":"はい、ユーザーをミュートにします!","Yes_remove_user":"はい、ユーザーを削除します!","you_are_in_preview_mode_of":"プレビューモードでチャンネル #<strong>__room_name__</strong> を表示しています","You_are_logged_in_as":"次のユーザーとしてログインしています","You_are_not_authorized_to_view_this_page":"このページを閲覧する権限がありません","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"あなたが最後の所有者です。部屋を出る前に、新しい所有者を設定してください。","You_can_change_a_different_avatar_too":"この連携の投稿で使用されるアバターを上書きできます。","You_can_use_an_emoji_as_avatar":"アバターとして絵文字を使用できます。","You_have_been_muted":"ミュートにされているため、このルームで発言できません","You_have_not_verified_your_email":"メールアドレスが認証されていません","You_have_successfully_unsubscribed":"メーリングリストから正常に購読解除されました。","You_informed_an_invalid_FROM_address":"入力された送信元アドレスは、正しい書式ではありません。","You_must_provide_the_unsubscribe_link":"[unsubscribe] リンクを入力してください。 ","You_need_confirm_email":"ログインするためにはメールを確認する必要があります！","You_need_install_an_extension_to_allow_screen_sharing":"画面共有をするには、拡張機能をインストールする必要があります","You_need_to_change_your_password":"パスワードを変更してください","You_need_to_type_in_your_password_in_order_to_do_this":"この操作には、パスワードを入力する必要があります!","You_need_to_type_in_your_username_in_order_to_do_this":"あなたはこれを行うためにユーザー名を入力する必要があります！","You_need_to_verifiy_your_email_address_to_get_notications":"通知を受信するには、メールアドレスの認証を行なってください","You_should_name_it_to_easily_manage_your_integrations":"連携を管理しやすい名前にすることを推奨します。","You_will_not_be_able_to_recover":"このメッセージを復元できなくなります!","You_will_not_be_able_to_recover_file":"このファイルを復元できなくなります!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"メールアドレスが認証されていないため、メール通知を受信できません","Your_email_has_been_queued_for_sending":"メールは送信待ちキューへ登録されました","Your_entry_has_been_deleted":"メッセージは削除されました。","Your_file_has_been_deleted":"ファイルは削除されました。","Your_mail_was_sent_to_s":"メールは %s へを送信されました","Your_Open_Source_solution":"独自のオープンソースチャットソリューション","Your_password_is_wrong":"パスワードが間違っています!","Your_push_was_sent_to_s_devices":"プッシュ通知が %s 台のデバイスへ送信されました"});
TAPi18n._registerServerTranslator("ja", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/km.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["km"] = ["Khmer","ភាសាខ្មែរ"];                                                                 // 8
if(_.isUndefined(TAPi18n.translations["km"])) {                                                                        // 9
  TAPi18n.translations["km"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["km"][namespace])) {                                                             // 13
  TAPi18n.translations["km"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["km"][namespace], {"500":"កំហុសក្នុងការម៉ាស៊ីនបម្រើផ្ទៃក្នុង","0_Errors_Only":"តែកំហុស - 0","1_Errors_and_Information":"1 - កំហុសនិងការជូនដំណឹង","2_Erros_Information_and_Debug":"2 - Erros, ពនិងបំបាត់កំហុស","__username__was_set__role__by__user_by_":"__username__ ត្រូវបានកំណត់ __role__ ដោយ __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ គឺមិនយូរទៀត __role__ ដោយ __user_by__","Access_not_authorized":"ការភ្ជាប់ចូលមិនបានផ្ទៀងផ្ទាត់","Access_online_demo":"ចូល​ទៅ​សាក​ល្បងវា​លើ​អ៊ីនធើណិត​ជា​មុន​សិន","Access_Online_Demo":"ចូល​ទៅ​សាក​ល្បងវា​លើ​អ៊ីនធើណិត​ជា​មុន​សិន","Access_Token_URL":"URL ចូល Token","Accounts":"គណនី","Accounts_AllowDeleteOwnAccount":"អនុញ្ញាតឱ្យអ្នកប្រើដើម្បីលុបគណនីផ្ទាល់ខ្លួន","Accounts_AllowedDomainsList":"ប្រើសញ្ញា ក្បៀស(,) ដើម្បីបែងចែង Domain ដែលអនុញ្ញាតិក្នុងបញ្ជី","Accounts_AllowedDomainsList_Description":"ប្រើប្រាស់សញ្ញាក្បៀស ',' ក្នុងបញ្ជីដែនអនុញ្ញាតិ","Accounts_AllowEmailChange":"អនុញ្ញាតឱ្យមានការផ្លាស់ប្តូរអ៊ីម៉ែល","Accounts_AllowPasswordChange":"អនុញ្ញាត​ឱ្យ​ផ្លាស់​ប្តូ​រ​ពាក្យ​សម្ងាត់","Accounts_AllowUserAvatarChange":"អនុញ្ញាតិអ្នកប្រើប្រាស់ប្តូររូប","Accounts_AllowUsernameChange":"អនុញ្ញាត​ឱ្យ​ផ្លាស់​ប្តូ​រ​ឈ្មោះ​អ្នក​ប្រើ","Accounts_AllowUserProfileChange":"អនុញ្ញាតិអ្នកប្រើប្រាស់ប្តូរព័ត៌មានផ្ទាល់ខ្លួន","Accounts_AvatarResize":"ប្តូ​រ​ទំហំ Avatar","Accounts_AvatarSize":"ទំហំ Avatar","Accounts_AvatarStorePath":"ទីតាំងផ្ទុក Avatar","Accounts_AvatarStoreType":"ប្រភេទបន្ទុក Avatar","Accounts_BlockedDomainsList":"បញ្ជីដែន","Accounts_BlockedDomainsList_Description":"បញ្ជីបំបែកដោយសញ្ញាក្បៀសនៃដែនបានបិទ","Accounts_denyUnverifiedEmail":"រាំងខ្ទប់អ្នកមិនបានផ្ទៀតផ្ទាត់អ៊ីមែល","Accounts_EmailVerification":"ការ​ផ្ទៀងផ្ទាត់​តាម​​អ៊ី​ម៉ែ​ល","Accounts_EmailVerification_Description":"សូមប្រាកដថាអ្នកមានការកំណត់របស់ SMTP ត្រឹមត្រូវដើម្បីប្រើលក្ខណៈពិសេសនេះ","Accounts_Enrollment_Email":"ការចូលអ៊ីមែល","Accounts_Enrollment_Email_Description":"អ្នកប្រហែលប្រើ [name], [fname], [lname] ពីឈ្មោះពេញរបស់អ្នកប្រើប្រាស់ គោត្តនាម ឬនាមខ្លួន។ <br /> អ្នកប្រហែលប្រើប្រាស់ [email] ពីអ៊ីមែលរបស់អញនកប្រើប្រាស់។","Accounts_Iframe_api_method":"វិធីសាស្រ្ត API","Accounts_Iframe_api_url":"Url API","Accounts_iframe_enabled":"បានបើក","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"នៅថ្ងៃផុតកំណត់ចូល","Accounts_ManuallyApproveNewUsers":"ទទួល​អ្នក​ប្រើប្រាស់​ថ្មី​ដោយ​ផ្ទាល់","Accounts_OAuth_Custom_Token_Sent_Via":"សញ្ញាសម្ងាត់បានផ្ញើតាមរយៈ","Accounts_OAuth_Custom_Authorize_Path":"ទីតាំងផ្ទៀតផ្ទាត់","Accounts_OAuth_Custom_Button_Color":"ពណ៌ប៊ូតុង","Accounts_OAuth_Custom_Button_Label_Color":"ពណ៌អត្ថបទប៊ូតុង","Accounts_OAuth_Custom_Button_Label_Text":"អត្ថបទ​ប៊ូតុង","Accounts_OAuth_Custom_Enable":"អនុញ្ញាត","Accounts_OAuth_Custom_id":"លេខសម្គាល់","Accounts_OAuth_Custom_Identity_Path":"ទីទាំងអត្តសញ្ញាណ","Accounts_OAuth_Custom_Login_Style":"រចនាប័ទ្មចូល","Accounts_OAuth_Custom_Secret":"ការ​សម្ងាត់","Accounts_OAuth_Custom_Token_Path":"ទីទាំង Token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"ចូល​តាម​ហ្វេសប៊ូក","Accounts_OAuth_Facebook_callback_url":"URL របស់ហ្វេសប៊ុកហៅទៅវិញ","Accounts_OAuth_Facebook_id":"លេខ​សម្គាល់​កម្មវិធី​ហ្វេសប៊ូក","Accounts_OAuth_Facebook_secret":"ហ្វេ​ស​ប៊ុ​ក​សម្ងាត់","Accounts_OAuth_Github":"ចូល​តាម Github","Accounts_OAuth_Github_callback_url":"URL ដែល Github ហៅទៅវិញ","Accounts_OAuth_GitHub_Enterprise":"OAuth បានអនុញ្ញាតិ","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL ដែលបាន GitHub សហគ្រាសហៅទៅវិញ","Accounts_OAuth_GitHub_Enterprise_id":"លេខសម្គាល់ Client","Accounts_OAuth_GitHub_Enterprise_secret":"Client សម្ងាត់","Accounts_OAuth_Github_id":"លេខ​សម្គាល់ GitHub","Accounts_OAuth_Github_secret":"GitHub សម្ងាត់","Accounts_OAuth_Gitlab":"OAuth បានអនុញ្ញាតិ","Accounts_OAuth_Gitlab_callback_url":"URL ដែល GitLab ហៅទៅវិញ","Accounts_OAuth_Gitlab_id":"លេខសម្គាល់ GitLab","Accounts_OAuth_Gitlab_secret":"Client សម្ងាត់","Accounts_OAuth_Google":"ចូល​តាម Google","Accounts_OAuth_Google_callback_url":"URL ដែលក្រុមហ៊ុន Google បានហៅទៅវិញ","Accounts_OAuth_Google_id":"លេខ​សម្គាល់ Google","Accounts_OAuth_Google_secret":"Google សម្ងាត់","Accounts_OAuth_Linkedin":"ចូល​តាម​ LinkedIn","Accounts_OAuth_Linkedin_callback_url":"URL ដែល LinkedIn ហៅទៅវិញ","Accounts_OAuth_Linkedin_id":"លេខ​សម្គាល់​ LinkedIn","Accounts_OAuth_Linkedin_secret":"LinkedIn សម្ងាត់","Accounts_OAuth_Meteor":"ចូល​តាម Meteor","Accounts_OAuth_Meteor_callback_url":"URL ដែល Meteor ហៅទៅវិញ","Accounts_OAuth_Meteor_id":"លេខ​សម្គាល់ Meteor ","Accounts_OAuth_Meteor_secret":"Meteor សម្ងាត់","Accounts_OAuth_Twitter":"ចូលតាម Twitter","Accounts_OAuth_Twitter_callback_url":"URL ដែល Twitter បានហៅទៅវិញ","Accounts_OAuth_Twitter_id":"លេខសម្គាល់ Twitter","Accounts_OAuth_Twitter_secret":"Twitter សម្ងាត់","Accounts_OAuth_Wordpress":"ការឡុកចូល Wordpress","Accounts_OAuth_Wordpress_callback_url":"URL ដែលប្លកហៅទៅវិញ","Accounts_OAuth_Wordpress_id":"លេខសម្គាល់ WordPress","Accounts_OAuth_Wordpress_secret":"WordPress សម្ងាត់","Accounts_PasswordReset":"កំណត់ពាក្យសម្ងាត់ឡើងវិញ","Accounts_Registration_AuthenticationServices_Enabled":"ការផ្ទៀងផ្ទាត់ភាពត្រឹមត្រូវការចុះឈ្មោះជាមួយនឹងសេវា","Accounts_RegistrationForm":"សំណុំបែបបទការចុះឈ្មោះ","Accounts_RegistrationForm_Disabled":"ជនពិការ","Accounts_RegistrationForm_LinkReplacementText":"អត្ថបទតំណជំនួសសំណុំបែបបទការចុះឈ្មោះ","Accounts_RegistrationForm_Public":"សាធារណៈ","Accounts_RegistrationForm_Secret_URL":"URL ដែលជាការសម្ងាត់","Accounts_RegistrationForm_SecretURL":"ទម្រង់បែបបទចុះឈ្មោះរបស់ URL សម្ងាត់","Accounts_RegistrationForm_SecretURL_Description":"អ្នកត្រូវតែផ្ដល់ខ្សែអក្សរចៃដន្យដែលនឹងត្រូវបានបន្ថែមទៅ URL ចុះឈ្មោះរបស់អ្នក។ ឧទាហរណ៍: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"ត្រូវ​ចុះ​ឈ្មោះ","Accounts_RequireNameForSignUp":"ត្រូវការ Name សម្រាប់ការចុះឈ្មោះ","Accounts_ShowFormLogin":"ការចូលជាទម្រង់ដែលមានមូលដ្ឋានបង្ហាញ","Accounts_UseDefaultBlockedDomainsList":"បញ្ជីដែនប្រើលំនាំដើម","Accounts_UseDNSDomainCheck":"ប្រើដែនឈ្មោះ DNS ពិនិត្យ","Activate":"ធ្វើ​ឱ្យ​សកម្ម","Activity":"សកម្មភាព","Add":"បន្ថែម","Add_agent":"បន្ថែមភ្នាក់ងារ","Add_custom_oauth":"បន្ថែម oauth ផ្ទាល់​ខ្លួន","Add_manager":"បន្ថែមអ្នកចាត់ការទូទៅ","Add_Members":"ថែម​សមាជិក","Add_User":"បន្ថែមអ្នកប្រើ","Add_user":"បន្ថែមអ្នកប្រើ","Add_users":"ថែម​អ្នក​ប្រើប្រាស់","Additional_emails":"បន្ថែមអ៊ីមែល","Additional_Feedback":"មតិបន្ថែម","Administration":"រដ្ឋបាល","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"បន្ទាប់ពីការផ្ទៀងផ្ទាត់ភាពត្រឹមត្រូវ OAuth2, អ្នកប្រើនឹងត្រូវបានបញ្ជូនបន្តទៅ URL នេះ","Agent_added":"ភ្នាក់ងារបានបន្ថែម","Agent_removed":"ភ្នាក់ងារបានយកចេញ","Alias":"ឈ្មោះក្លែងក្លាយ","All":"ទាំងអស់","All_channels":"គ្រប់​ប៉ិស្តិ៍","All_logs":"កំណត់ហេតុទាំងអស់","All_messages":"សារទាំងអស់","Allow_Invalid_SelfSigned_Certs":"អនុញ្ញាតិឲ្យវិញ្ញាបនប័ត្រមិនត្រឹមត្រូវ និងចុះហត្ថលេខាខ្លួនឯង សម្រាប់តំណភ្ជាប់ត្រួតពិនិត្យ និងមើលជាមុន","Allow_Invalid_SelfSigned_Certs_Description":"អនុញ្ញាតឱ្យរបស់វិញ្ញាបនបត្រ SSL សុពលភាពនិងបានចុះហត្ថលេខាដោយខ្លួនឯងសម្រាប់តំណនិងការមើលជាមុនសុពលភាព។","and":"និង","And_more":"និង __length ច្រើនទៀត __...","Animals_and_Nature":"សត្វនិងធម្មជាតិ","API":"ប្រើ API","API_Analytics":"វិភាគ","API_Embed":"បញ្ចូល","API_EmbedDisabledFor":"មិនអនុញ្ញាតិ Embed សម្រាប់អ្នកប្រើប្រាស់","API_EmbedDisabledFor_Description":"ប្រើសញ្ញា ក្បៀស(,) ដើម្បីបែងចែងអ្នកប្រើប្រាស់ក្នុងបញ្ជី","API_GitHub_Enterprise_URL":"GitHub Enterprise","API_GitHub_Enterprise_URL_Description":"ចំណាំ: សូមដកចេញនូវ trailing slash","API_Gitlab_URL":"URL របស់ GitLab","API_Wordpress_URL":"តំណភ្ជាប់ URL របស់ WordPress","Appearance":"រូបរាង","Application_added":"ពាក្យស្នើសុំបន្ថែមទៀត","Application_Name":"ឈ្មោះកម្មវិធី","Application_updated":"កម្មវិធីដែលបានធ្វើបច្ចុប្បន្នភាព","Apply_and_refresh_all_clients":"អនុវត្តនិងធ្វើឱ្យអតិថិជនទាំងអស់","Archive":"បណ្ណសារ","Archive_Unarchive":"បណ្ណសារ / ទុកក្នុងប័ណ្ណសារ","are_also_typing":"គឺ​កំពុង​ព្យាយាម​ផង​ដែរ","are_typing":"កំពុង​វាយ","Are_you_sure":"តើ​អ្នក​ច្បាស់​ហើយ​ឬ?","Are_you_sure_you_want_to_delete_your_account":"តើអ្នកពិតជាចង់លុបគណនីរបស់អ្នក?","Authorization_URL":"URL ដែលបានការអនុញ្ញាត","Authorize":"ផ្តល់សិទ្ធិ","AutoLinker_StripPrefix":"AutoLinker ស្ទ្រីបុព្វបទ","AutoLinker_StripPrefix_Description":"បង្ហាញខ្លី។ ឧ https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL ដែល AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker កន្សោមធម្មតា URL ដែល","AutoLinker_Email":"AutoLinker អ៊ីមែល","AutoLinker_Phone":"ទូរស័ព្ទ AutoLinker","AutoLinker_Phone_Description":"ភ្ជាប់ដោយស្វ័យប្រវត្តិសម្រាប់លេខទូរស័ព្ទ។ ឧទាហរណ៍: (123) 456-7890`","Auto_Load_Images":"ផ្ទុក​រូបភាព​ដោយ​ស្វ័យប្រវត្តិ","Available":"ដែលអាចប្រើបាន","Available_agents":"ភ្នាក់ងារដែលអាចប្រើបាន","Avatar":"ប្តូរ​រូប","Avatar_changed_successfully":"ផ្លាស់​ប្តូ​រ​រូប​តំ​នាង​ដោយ​ជោគជ័យ","Avatar_URL":"URL ដែល Avatar","Avatar_url_invalid_or_error":"តំណភ្ជាប់ដែលបានមិនត្រឹមត្រូវ ដូចនេះសូមព្យាយាមម្តងទៀត ប៉ុន្តែជាមួយតំណភ្ជាប់ផ្សេងទៀត។","away":"ឆ្ងាយ","Away":"ឆ្ងាយ","away_female":"ឆ្ងាយ","Away_female":"ឆ្ងាយ","away_male":"ឆ្ងាយ","Away_male":"ឆ្ងាយ","Back":"ត្រលប់ក្រោយ","Back_to_applications":"ត្រឡប់ទៅកម្មវិធី","Back_to_integrations":"ត្រឡប់មកវិញធ្វើសមាហរណកម្ម","Back_to_login":"ត្រឡប់​មក​ឡុក​ចូល","Back_to_permissions":"ត្រឡប់ទៅសិទ្ធិ","Body":"តួ","bold":"ក្រាស់","busy":"រវល់","Busy":"រវល់","busy_female":"រវល់","Busy_female":"រវល់","busy_male":"រវល់","Busy_male":"រវល់","Cancel":"បញ្ឈប់","Cannot_delete_a_protected_role":"មិនអាចលុបតួនាទីការពារ","Cannot_delete_role_because_its_in_use":"មិនអាចលុបតួនាទីពីព្រោះវាជានៅក្នុងការប្រើប្រាស់","Cannot_invite_users_to_direct_rooms":"មិនអាចអញ្ជើញអ្នកប្រើប្រាស់ដើម្បីដឹកនាំបន្ទប់","CDN_PREFIX":"CDN បុព្វបទ","Certificates_and_Keys":"វិញ្ញាបនប័ត្រនិងគ្រាប់ចុច","Channel":"ប៉ុស្តិ៍","Channel_doesnt_exist":"ប៉ុស្តិ៍៖ `# %s` មិនមានទេ។","Channels":"ប៉ុស្តិ៍","Channels_list":"បណ្តាប៉ុស្តិ៍​សាធារណៈ","Chat_Rooms":"បន្ទប់​ពិភាក្សា","Chatops_Enabled":"អនុញ្ញាតិ Chatops","Chatops_Title":"ផ្ទាំង Chatops","Chatops_Username":"ឈ្មោះអ្នកប្រើប្រាស់ Chatops","Choose_a_room":"ជ្រើសយកបន្ទប់មួយ","Choose_messages":"ជ្រើសសារ","Choose_the_alias_that_will_appear_before_the_username_in_messages":"ជ្រើសឈ្មោះក្លែងក្លាយដែលនឹងលេចឡើងនៅក្នុងសារមុនពេលដែលឈ្មោះអ្នកប្រើនេះ។","Choose_the_username_that_this_integration_will_post_as":"ជ្រើសឈ្មោះអ្នកប្រើថាការធ្វើសមាហរណកម្មនេះនឹងប្រកាសជា។","Clear_all_unreads_question":"ចង់ជម្រះចោលគ្រប់សារមិនបានអានឬ?","Client_ID":"លេខសម្គាល់អតិថិជន","Client_Secret":"អតិថិជនសម្ងាត់","Clients_will_refresh_in_a_few_seconds":"អតិថិជននឹងបានស្ងប់ក្នុងពីរបីវិនាទី","close":"បិទ","Closed":"បិទ","Collapse_Embedded_Media_By_Default":"វេញប្រព័ន្ធផ្សព្វផ្សាយដែលបានបង្កប់ដោយលំនាំដើម","coming_soon":"មក​ដល់​ឆាប់ៗ","Commands":"ឃ្លាបញ្ជា","Compact_View":"មើលជាតារាង","Confirm_password":"បញ្ជាក់​ពាក្យ​សម្ងាត់","Contact":"ទំនាក់ទំនង","Conversation":"កិច្ច​ពិភាក្សា","Convert_Ascii_Emojis":"បម្លែង ASCII នេះ​ទៅ Emoji","Copied":"ចម្លង","COPY_TO_CLIPBOARD":"ចម្លងទៅក្ដារតម្បៀតខ្ទាស់","Copy_to_clipboard":"ចម្លងទៅក្ដារតម្បៀតខ្ទាស់","Count":"រាប់ចំនួន","Create":"បង្កើត","Create_new":"បង្កើត​ថ្មី","Created_at":"បាន​បង្កើត​កាល​ពី","Created_at_s_by_s":"<strong>បង្កើតឡើងនៅក្នុង% <strong>s%</strong></strong> <strong>s បាន</strong>","Custom_Fields":"វាលផ្ទាល់ខ្លួន","Custom_oauth_helper":"ពេលអ្នកកំពុងកំណត់ OAuth Provider នោះអ្នកនឹងទទួល URL បញ្ជាក់មួយត្រឡប់មកវិញ, ដែលប្រើ <pre>%s</pre>","Custom_oauth_unique_name":"កំណត់ oauth ឲ្យមានឈ្មោះតែមួយគត់","Custom_Script_Logged_In":"ស្គ្រីបផ្ទាល់ខ្លួនសម្រាប់ចូលរបស់អ្នកប្រើ","Custom_Script_Logged_Out":"ស្គ្រីបផ្ទាល់ខ្លួនសម្រាប់អ្នកប្រើចេញ","Dashboard":"ផ្ទាំងគ្រប់គ្រង","days":"ថ្ងៃ","Deactivate":"ធ្វើឲ្យមិនសកម្ម","Debug_Level":"កម្រិតបំបាត់កំហុស","Default":"លំនាំដើម","Delete":"លុប","Delete_my_account":"លុបគណនីរបស់ខ្ញុំ","Delete_Room_Warning":"ការលប់បន្ទប់មួយនឹងត្រូវលប់ចោលទាំងអស់នូវរាល់សារដែលបានប្រកាសនៅក្នុងបន្ទប់នេះ, ដំណើរការនេះមិនទាន់បានបញ្ចប់ទេ","Delete_User_Warning":"ការ​លប់​អ្នក​ប្រើប្រាស់ នឹង​ត្រូវ​លប់​​គ្រប់​សារ​​របស់​​គាត់​ផង​ដែរ។ ដូច​នេះ​មិន​អាច​ធ្វើ​បាន​ទេ ។","Deleted":"បាន​លប់!","Department_not_found":"រកមិនឃើញនាយកដ្ឋាន","Department_removed":"នាយកដ្ឋានបានយកចេញ","Departments":"មន្ទីរ","Description":"សង្ខេប","Desktop":"ផ្ទៃតុ","Desktop_Notification_Test":"ការធ្វើតេស្តការជូនដំណឹងផ្ទៃតុ","Desktop_Notifications":"ជំនូនដំណឹងលើ Desktop","Desktop_Notifications_Disabled":"ជំនូនដំណឹងលើ Desktop មិនបានអនុញ្ញាតិ, សូមផ្លាស់ប្តូរការកំណត់នៅលើ Browser របស់អ្នកប្រសិនបើចង់អនុញ្ញតិវា","Desktop_Notifications_Enabled":"ជំនូនដំណឹងលើ Desktop ត្រូវបានអនុញ្ញាតិ","Direct_message_someone":"មាននរណាម្នាក់បានផ្ញើសារដោយផ្ទាល់","Direct_Messages":"សារ​ផ្ទាល់","Direct_Messages_list":"ផ្ញើសារដោយផ្ទាល់","Disable_Favorite_Rooms":"បិទការពេញចិត្ត","Disable_New_Message_Notification":"បិទ​ការ​ជូន​ដំណឹង​សារ​ថ្មី","Disable_New_Room_Notification":"បិទ​ការ​ជូន​ដំណឹង​បន្ទប់​ថ្មី","Displays_action_text":"អត្ថបទសកម្មភាពបង្ហាញ","Do_you_want_to_change_to_s_question":"<strong>តើអ្នកចង់ផ្លាស់ប្តូរទៅ %s?</strong>","Drop_to_upload_file":"ទម្លាក់​ឯកសារ​ដើម្បី​ផ្ទុក​ឡើង","Dry_run":"ការរត់ស្ងួត","Dry_run_description":"តែនឹងផ្ញើអ៊ីម៉ែលមួយទៅអាសយដ្ឋានដូចគ្នានេះដែរដូចជានៅក្នុងពី។ អ៊ីមែលត្រូវតែជាកម្មសិទ្ធិរបស់អ្នកប្រើត្រឹមត្រូវ។","Duplicate_archived_channel_name":"ឆានែលមួយដែលបានដាក់ក្នុងប័ណ្ណសារដែលមានឈ្មោះ ' %s' មាន","Duplicate_archived_private_group_name":"ក្រុមឯកជនដែលមានឈ្មោះប័ណ្ណសារ ' %s' មាន","Duplicate_private_group_name":"ក្រុម​ឯក​ជន​ដែល​មាន​ឈ្មោះ​, '%s', មាន​ហើយ","E-mail":"អ៊ីមែល","Edit":"កែ​សម្រួល","Edit_Custom_Field":"កែសម្រួលវាលផ្ទាល់ខ្លួន","Edit_Department":"កែសម្រួលនាយកដ្ឋាន","edited":"បានកែសម្រួល","Email":"អ៊ីម៉ែល","Email_already_exists":"អ៊ី​ម៉ែ​ល​ដែល​មាន​រួច​ហើយ","Email_body":"រាងកាយអ៊ីមែល","Email_Change_Disabled":"អ្នកគ្រប់គ្រង Rocket.Chat របស់អ្នកបានបិទការផ្លាស់ប្តូរអ៊ីម៉ែល","Email_from":"ពី","Email_Notification_Mode":"ការជូនដំណឹងអ៊ីម៉ែលក្រៅបណ្តាញ","Email_Notification_Mode_All":"ជារៀងរាល់រៀបរាប់ / ទឹកនោមផ្អែម","Email_Notification_Mode_Disabled":"ជនពិការ","Email_or_username":"អ៊ីមែល ឬឈ្មោះ​សម្ងាត់","Email_subject":"ប្រធានបទ","Email_verified":"អ៊ីម៉ែល​បញ្ជាក់","Emoji":"សញ្ញា​អារម្មណ៍","Empty_title":"ពានរង្វាន់ទទេ","Enable":"អនុញ្ញាត","Enable_Desktop_Notifications":"អនុញ្ញាតិជំនូនដំណឹងលើ Desktop","Enabled":"បានបើក","Encrypted_message":"សារដែលបានអ៊ិនគ្រីប","End_OTR":"បញ្ចប់ប្រវត្តិ","Enter_a_regex":"បញ្ចូល regex ​​មួយ","Enter_a_room_name":"បញ្ចូលឈ្មោះក្នុងបន្ទប់មួយ","Enter_a_username":"បញ្ចូលឈ្មោះអ្នកប្រើ","Enter_info":"បញ្ចូល​ព័ត៌មាន​របស់​អ្នក","Enter_name_here":"បញ្ចូលឈ្មោះនៅទីនេះ","Enter_to":"បញ្ចូល","Error":"កំហុសក្នុងការ","error-cant-invite-for-direct-room":"មិនអាចអញ្ជើញអ្នកប្រើប្រាស់ទៅកាន់បន្ទប់ផ្ទាល់","error-duplicate-channel-name":"ប៉ុស្តិ៍​ដែល​មាន​ឈ្មោះ​, '%s', មាន​ហើយ","error-invalid-custom-field":"វាលតាមតំរូវការមិនត្រឹមត្រូវ","error-invalid-custom-field-name":"ឈ្មោះវាលផ្ទាល់ខ្លួនមិនត្រឹមត្រូវ។ ប្រើតែតួអក្សរលេខសហសញ្ញានិងសញ្ញា។","error-invalid-password":"ពាក្យសម្ងាត់មិនត្រឹមត្រូវ","error-invalid-room":"បន្ទប់មិនត្រឹមត្រូវ","error-invalid-room-name":"<strong> %s</strong> គឺមិនមែនជាឈ្មោះបន្ទប់មួយត្រឹមត្រូវ <br/> ប្រើតែតួអក្សរលេខសហសញ្ញានិងសញ្ញា","error-invalid-user":"អ្នកប្រើមិនត្រឹមត្រូវ","error-invalid-username":"ឈ្មោះ​អ្នកប្រើប្រាស់​មិន​ត្រឹមត្រូវ","error-not-allowed":"មិន​អនុញ្ញាត","error-not-authorized":"មិនត្រូវបានអនុញ្ញាត","error-remove-last-owner":"នេះគឺជាម្ចាស់ចុងក្រោយ។ សូមកំណត់ម្ចាស់ថ្មីមុនពេលយកចេញមួយនេះ។","error-role-name-required":"ឈ្មោះតួនាទីគឺត្រូវបានទាមទារ","error-user-not-in-room":"អ្នកប្រើគឺមិននៅក្នុងបន្ទប់នេះ","Error_changing_password":"ពាក្យ​សម្ងាត់​បាន​ប្តូរ","Error_sending_confirmation_email":"កំហុសក្នុងការផ្ញើអ៊ីម៉ែលបញ្ជាក់","Error_too_many_requests":"កំហុស, មានសំណើរច្រើន ដូចនេះសូមកាត់បន្ថយវា ព្រោះអ្នកត្រូវរង់ចាំ %s វិនាទីមុនព្យាយាមម្តងទៀត","Esc_to":"Esc ដើម្បី","Example_s":"ឧទាហរណ៍: <code class=\"inline\">%s</code>","False":"មិន​ពិត","Favorites":"ពេញ​ចិត្ត","Field":"វាល","Field_removed":"វាលបានយកចេញ","File_exceeds_allowed_size_of_bytes":"ឯកសារលើសពីទំហំបៃ __size__ បាន​​អនុញ្ញាត","FileUpload":"ផ្ទុក​ឯកសារ​ឡើង","FileUpload_Enabled":"អនុញ្ញាត​ឱ្យ​ផ្ទុក​ឡើង​ឯកសារ","FileUpload_File_Empty":"ឯកសារទទេ","FileUpload_FileSystemPath":"ផ្លូវប្រព័ន្ធ","FileUpload_MaxFileSize":"ទំហំអតិបរិមាកំណត់សម្រាប់ការផ្ទុកឡើយឯកសារ(គឹតជាបៃ)","FileUpload_MediaType_NotAccepted":"ប្រភេទប្រព័ន្ធផ្សព្វផ្សាយមិនបានទទួលយក","FileUpload_MediaTypeWhiteList":"ប្រើសញ្ញា ក្បៀស(,) ដើម្បីបែងចែកបញ្ជីប្រភេទមេឌៀ","FileUpload_MediaTypeWhiteListDescription":"ប្រើសញ្ញា ក្បៀស(,) ដើម្បីបែងចែងប្រភេទ Media ក្នុងបញ្ជី","FileUpload_ProtectFiles":"ការពារឯកសារដែលបានផ្ទុកឡើង","FileUpload_ProtectFilesDescription":"មានតែអ្នកប្រើនឹងត្រូវបានចូលដំណើរការផ្ទៀងផ្ទាត់ភាពត្រឹមត្រូវ","FileUpload_S3_Acl":"ក្រុមហ៊ុន Amazon ជា S3 A​​CL","FileUpload_S3_AWSAccessKeyId":"ក្រុមហ៊ុន Amazon ជា S3 A​​WSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"ក្រុមហ៊ុន Amazon ជា S3 A​​WSSecretAccessKey","FileUpload_S3_Bucket":"ក្រុមហ៊ុន Amazon S3 របស់ឈ្មោះដាក់ធុង","FileUpload_S3_BucketURL":"ដាក់​​ធុង URL ដែល","FileUpload_S3_CDN":"CDN សម្រាប់ការទាញយកដែន","FileUpload_S3_Region":"តំបន់","FileUpload_Storage_Type":"ប្រភេទឧបករណ៍ផ្ទុក","Flags":"ទង់","Follow_social_profiles":"តាម​ដាន​​​បណ្តា​គណនីបណ្តាញ​សង្គម​របស់​យើង​, មើល​យើង​លើ​ github និង​ចែក​រំលែក​បទពិសោធន៍​របស់​អ្នក​ជាមួយ​ rocket.chat app នៅ​លើ​ក្តារឃៀន​របស់​យើង","Food_and_Drink":"អាហារនិងភេសជ្ជៈ","For_your_security_you_must_re_enter_your_password_to_continue":"ដើម្បីសុវត្ថិភាពរបស់អ្នក, អ្នកត្រូវតែបញ្ចូលពាក្យសម្ងាត់ឡើងវិញរបស់អ្នកដើម្បីបន្ត","Force_SSL":"កម្លាំង SSL ដែលបាន","Force_SSL_Description":"* ប្រយ័ត្ន! * _Force SSL_ មិនគួរត្រូវបានប្រើជាមួយប្រូកស៊ីបញ្ច្រាស។ ប្រសិនបើអ្នកមានប្រូកស៊ីបញ្ច្រាស, អ្នកគួរតែធ្វើការប្តូរទិសនៅទីនោះ។ ជម្រើសនេះមានសម្រាប់ការដាក់ពង្រាយដូច Heroku, ដែលមិនអនុញ្ញាតឱ្យមានការប្តូរទិសនៅក្នុងការកំណត់រចនាសម្ព័ន្ធប្រូកស៊ីបញ្ច្រាស។","Forgot_password":"ភ្លេច​ពាក្យ​សម្ងាត់","Fork_it_on_github":"ទៅ​មើល​វា​លើ github","Frequently_Used":"ត្រូវបានប្រើជាញឹកញាប់","From":"ពី","From_Email":"ពី​អ៊ី​ម៉ែ​ល","From_email_is_required":"From អ៊ីមែលគឺត្រូវបំពេញ","From_email_warning":"<b>ព្រមាន៖</b>ចន្លោះ<b>FROM</b> គឺជាចំណងជើងទៅម៉ាស៊ីនមេអ៊ីមែលរបស់អ្នកកំណត់។","General":"ទូទៅ","Get_to_know_the_team":"ទៅ​ស្គាល់ Rocket.Team","github_no_public_email":"អ្នក​មិន​មាន​អ៊ីមែល​សាធារណៈ​ក្នុង​ GitHub នៅ​ឡើយ​ទេ","Give_a_unique_name_for_the_custom_oauth":"ផ្តល់​ឱ្យ​ឈ្មោះ​តែ​មួយ​គត់​សម្រាប់ oauth ផ្ទាល់​ខ្លួន","Give_the_application_a_name_This_will_be_seen_by_your_users":"ផ្តល់ឱ្យកម្មវិធីនេះមានឈ្មោះមួយ។ នេះនឹងត្រូវបានគេមើលឃើញដោយអ្នកប្រើរបស់អ្នក។","Global":"សកល","GoogleTagManager_id":"ការគ្រប់គ្រងស្លាកលេខសម្គាល់របស់ Google","Has_more":"សញ្ញា Has ច្រើនទៀត","Have_your_own_chat":"អ្នក​មាន Web Chat ផ្ទាល់​ខ្លួនហើ​យឬ។ អភិវឌ្ឃន៍​ជាមួយ​ Meteor.com, Rocket.Chat គឺ​ជា​ដំណោះ​ស្រាយ​ដ៏​ល្អ​បំផុត​សម្រាប់អ្នក​អភិវឌ្ឍន៍ ក្នុង​ការ​បង្កើត Web Chat Plateform។","Header":"បឋមកថា","Hidden":"លាក់","Hide_Group_Warning":"តើអ្នកពិតជាចង់លាក់ក្រុម \" %s\" ទេ?","Hide_Private_Warning":"តើអ្នកប្រាកដថាអ្នកចង់លាក់ការពិភាក្សាជាមួយ \" %s\" ទេ?","Hide_room":"លាក់​បន្ទប់","Hide_Room_Warning":"តើអ្នកពិតជាចង់លាក់បន្ទប់ \" %s\"?","Highlights":"ការរំលេច","Highlights_How_To":"នឹងត្រូវបានជូនដំណឹងនៅពេលនរណាម្នាក់និយាយអំពីពាក្យឬឃ្លាបន្ថែមវានៅទីនេះ។ អ្នកអាចបំបែកពាក្យឬឃ្លាជាមួយសញ្ញាក្បៀស។ ការបន្លិចពាក្យមិនត្រូវបានប្រកាន់តួអក្សរតូចធំ។","Highlights_List":"ពាក្យដែលបានបន្លិច","History":"ប្រវត្តិ","hours":"ម៉ោង","How_friendly_was_the_chat_agent":"តើធ្វើដូចម្តេចមិត្តភាពភ្នាក់ងារជជែកកំសាន្តនោះ?","How_knowledgeable_was_the_chat_agent":"តើចំណេះភ្នាក់ងារជជែកកំសាន្តនោះ?","How_responsive_was_the_chat_agent":"តើធ្វើដូចម្តេចឆ្លើយតបភ្នាក់ងារជជែកកំសាន្តនោះ?","How_satisfied_were_you_with_this_chat":"តើអ្នកពេញចិត្តនាក់អ្នកជាមួយនឹងការជជែកនេះ?","If_you_are_sure_type_in_your_password":"ប្រសិនបើអ្នកមានប្រភេទប្រាកដថាពាក​​្យសម្ងាត់របស់អ្នក:","If_you_are_sure_type_in_your_username":"ប្រសិនបើអ្នកមានប្រភេទប្រាកដថានៅក្នុងឈ្មោះអ្នកប្រើប្រាស់របស់អ្នក:","Importer_Archived":"ទុកជាឯកសារ","Importer_done":"ការនាំចូលបានបញ្ចប់!","Importer_finishing":"បញ្ចប់ការនាំចូល។","Importer_From_Description":"ការនាំចូល __from ទិន្នន័យ __ 's បានចូលទៅក្នុង Rocket.Chat ។","Importer_import_cancelled":"នាំចូលលុបចោល។","Importer_import_failed":"កំហុសមួយបានកើតឡើងខណៈពេលកំពុងរត់ការនាំចូល។","Importer_importing_channels":"ការនាំចូលបណ្តាញនេះ។","Importer_importing_messages":"ការនាំចូលសារ។","Importer_importing_started":"ការចាប់ផ្តើមនាំចូល។","Importer_importing_users":"ការនាំចូលអ្នកប្រើ។","Importer_not_defined_properly":"ការនាំចូលមិនត្រូវបានកំណត់ត្រឹមត្រូវ, វាត្រូវបានបាត់ខ្លួនថ្នាក់នាំចូល។","Importer_not_in_progress":"សំខាន់គឺបច្ចុប្បន្នមិនកំពុងរត់ទេ។","Importer_Prepare_Restart_Import":"ចាប់ផ្ដើមនាំចូល","Importer_Prepare_Start_Import":"ចាប់ផ្តើមនាំចូល","Importer_Prepare_Uncheck_Archived_Channels":"ឆានែលទុកជាឯកសារដោះធីក","Importer_Prepare_Uncheck_Deleted_Users":"ដោះធីកលុបអ្នកប្រើ","Importer_progress_error":"បានបរាជ័យក្នុងការទទួលបានការរីកចម្រើនសម្រាប់ការនាំចូល។","Importer_setup_error":"កំហុសមួយបានកើតឡើងខណៈពេលរៀបចំការកំណត់ការនាំចូល។","Incorrect_Password":"ឃ្លាសំងាត់មិនត្រឹមត្រូវ","inline_code":"inline_code","Install_Extension":"ដំឡើងផ្នែកបន្ថែម","Install_FxOs":"ដំឡើង Rocket.Chat នៅ​លើ Firefox របស់​អ្នក","Install_FxOs_done":"អស្ចារ្យណាស់ឥឡូវអ្នកអាចប្រើប្រាស់ Rocket.Chat តាមរយៈ Icon នៅលើ Homescreen។ សូមរីករាយជាមួយ Rocket.Chat!","Install_FxOs_error":"សុំទោស ដែលវាមិនដំណើរការខណៈមានបញ្ហាលេចឡើងដូចខាងក្រោម","Install_FxOs_follow_instructions":"សូមបញ្ជាក់ការដំឡើងកម្មវិធីនេះនៅលើឧបករណ៍របស់អ្នក(ចុច \"Install\" ពេលបញ្ចាក់)","Installation":"ការដំឡើង","Integration_added":"បានបន្ថែមសមាហរណកម្ម","Integration_Incoming_WebHook":"សមាហរណកម្ម WebHook មកដល់","Integration_New":"ការរួមបញ្ចូលថ្មី","Integration_Outgoing_WebHook":"សមាហរណកម្ម WebHook ចេញ","Integration_updated":"ត្រូវបានធ្វើឱ្យទាន់សម័យធ្វើសមាហរណកម្ម","Integrations":"ការរួមបញ្ចូល","Invalid_asset":"ទ្រព្យសកម្មមិនត្រឹមត្រូវ","Invalid_confirm_pass":"ពាក្យ​សម្ងាត់​បញ្ជាក់​មិន​ដូច​ពាក្យ​សម្ងាត់​បាន​បញ្ចូល​","Invalid_email":"អ៊ី​មែល​ដែល​បញ្ចូល​មិន​ត្រឹម​ត្រូវ","Invalid_Export_File":"ឯកសារដែលបានផ្ទុកឡើងមិនមែនជាឯកសារនាំចេញជា %s បានត្រឹមត្រូវ។","Invalid_file_height":"កម្ពស់ឯកសារមិនត្រឹមត្រូវ","Invalid_file_type":"ប្រភេទឯកសារមិនត្រឹមត្រូវ","Invalid_file_width":"ទទឹងឯកសារមិនត្រឹមត្រូវ","Invalid_Import_File_Type":"ប្រភេទឯកសារនាំចូលមិនត្រឹមត្រូវ។","Invalid_name":"ឈ្មោះ​មិន​​អាច​ទំនេរ","Invalid_notification_setting_s":"ការកំណត់ការជូនដំណឹងមិនត្រឹមត្រូវ: %s","Invalid_pass":"ពាក្យ​សម្ងាត់​មិន​ត្រូវ​ទំនេរ","Invalid_room_name":"<strong>%s</strong> គឺ​ជា​ឈ្មោះ​បន្ទប់​មិន​ត្រឹម​ត្រូវ,<br/> ត្រូវ​ប្រើប្រាស់​​ត្រឹម​តែ​តួរ​អក្សរ, លេខ និង​ សញ្ញាចុច","Invalid_room_type":"<strong> %s</strong> គឺមិនមែនជាប្រភេទបន្ទប់ត្រឹមត្រូវ។","Invalid_Secret_URL":"URL ដែលសម្ងាត់មិនត្រឹមត្រូវ","Invalid_secret_URL_message":"URL ដែលបានផ្ដល់គឺមិនត្រឹមត្រូវ។","invisible":"មិន​បង្ហាញ","Invisible":"មិន​បង្ហាញ","Invitation_HTML":"ការអញ្ជើញទម្រង់ HTML","Invitation_Subject":"ប្រធានបទការអញ្ជើញ","Invite_user_to_join_channel":"អញ្ចើញអ្នកប្រើប្រាស់ម្នាក់ដើម្បីចូលរួមប៉ុស្តិ៍នេះ","Invite_Users":"អញ្ជើញអ្នកប្រើប្រាស់","is_also_typing":"គឺ​កំពុង​វាយ","is_also_typing_female":"គឺ​កំពុង​វាយ","is_also_typing_male":"គឺ​កំពុង​វាយ","is_typing":"គឺ​កំពុង​វាយ","is_typing_female":"គឺ​កំពុង​វាយ","is_typing_male":"គឺ​កំពុង​វាយ","italics":"ទ្រេត","join":"ចូល​រួម","Join_audio_call":"ចូលរួមជាមួយការហៅជាសំឡេង","Join_the_Community":"ចូល​រួម​សហគមន៍","Join_the_given_channel":"ចូលរួមប៉ុស្តិ៍ដែលបានផ្តល់ឲ្យ","Join_video_call":"ចូលរួមក្នុងការហៅវីដេអូ","Joined":"ចូលបម្រើការងារ","Jump":"លោត","Jump_to_first_unread":"លោតទៅមិនទាន់អាន​​ដំបូង","Jump_to_message":"លោតទៅសារ","Jump_to_recent_messages":"លោតទៅសារថ្មី","Katex_Enabled":"Katex បើក","Label":"ស្លាក","Language":"ភាសា","Language_Version":"ជំនាន់​អង់គ្លេស","Last_login":"ចូល​លើក​មុន","Last_message":"សារ​ចុង​ក្រោយ","Last_seen":"គេមើលឃើញចុងក្រោយនេះ","Layout":"ប្លង់","Layout_Home_Body":"តួរសេចក្តីទំព័រដើម","Layout_Home_Title":"ចំណងជើងទំព័រដើម","Layout_Login_Terms":"លក្ខ័ណចូល","Layout_Privacy_Policy":"គោលការណ៍ឯកជនភាព","Layout_Sidenav_Footer":"ចំហៀង​របស់​កម្មវិធី​រុករក​បាតកថា","Layout_Sidenav_Footer_description":"​ទំហំ​បាន​គឺ 260x70","Layout_Terms_of_Service":"ល័ក្ខខ័ណ្ឌ​នៃ​សេវាកម្ម","LDAP":"ប្រើ LDAP","LDAP_CA_Cert":"CA បានវិញ្ញាបនបត្រ","LDAP_Custom_Domain_Search":"ស្វែងរកដែនផ្ទាល់ខ្លួន","LDAP_Custom_Domain_Search_Description":"បំណែកមួយនៃ JSON ប៉ុណ្ណោះដែលគ្រប់គ្រង info ចងនិងការតភ្ជាប់និងជានៃសំណុំបែបបទនេះ: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"ដែនលំនាំដើម","LDAP_Description":"LDAP គឺជាលំដាប់ក្នុងទូផ្ទុកទិន្នន័យដែលផ្ទុកព័ត៌មានក្រុមហ៊ុនជាច្រើនដែលប្រើប្រាស់ដើម្បីធ្វើការ Authentication ដោយប្រើប្រាស់ Username និង Password រវាង Site ជាច្រើន និងសេវាកម្មផ្សេងៗ។ ព័ត៌មានអំពីការកំណត់កម្រិតខ្ពស់ និងឧទាហរណ៍សូមចូលទៅកាន់វីគី https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":" LDAP DN","LDAP_Domain_Base":"មូលដ្ឋានដែន","LDAP_Domain_Base_Description":"ឈ្មោះដែលមានសមត្ថភាពយ៉ាងពេញលេញកិត្តិយស (DN) នៃមែកធាងរបស់ LDAP មួយដែលអ្នកចង់បានដើម្បីស្វែងរកអ្នកប្រើនិងក្រុម។ អ្នកអាចបន្ថែមជាច្រើនដូចជាអ្នកចង់; ទោះជាយ៉ាងណា, ក្រុមនីមួយត្រូវតែត្រូវបានកំណត់នៅក្នុងមូលដ្ឋានដែនដូចគ្នាជាអ្នកប្រើប្រាស់ដែលជាកម្មសិទ្ធិរបស់វា។ ប្រសិនបើអ្នកបញ្ជាក់ក្រុមអ្នកប្រើបានដាក់មានតែអ្នកប្រើដែលជារបស់ក្រុមទាំងនោះនឹងមាននៅក្នុងវិសាលភាព។ យើងផ្ដល់អនុសាសន៍ថាអ្នកបញ្ជាក់ក្នុងកម្រិតកំពូលរបស់ថត LDAP របស់អ្នកដើមឈើជាមូលដ្ឋានដែនរបស់អ្នកហើយប្រើតម្រងស្វែងរកដើម្បីគ្រប់គ្រងការចូលប្រើ។","LDAP_Domain_Search_Filter":"តម្រងស្វែងរកដែន","LDAP_Domain_Search_Filter_Description":"ប្រសិនបើបានបញ្ជាក់នោះមានតែអ្នកប្រើដែលផ្គូផ្គងនឹងតម្រងនេះនឹងត្រូវបានអនុញ្ញាតឱ្យចូល។ ប្រសិនបើមិនមានតម្រងត្រូវបានបញ្ជាក់, អ្នកប្រើប្រាស់ទាំងអស់នៅក្នុងវិសាលភាពនៃមូលដ្ឋានដែនដែលបានបញ្ជាក់នឹងអាចចូល។ <br/> ឧសម្រាប់ថតសកម្ម `memberOf = CN = ROCKET_CHAT, ou = ទូទៅ Groups` ។ <br/> ឧសម្រាប់ OpenLDAP (ស្វែងរកការប្រកួតពង្រីក) `OU: DN: = ROCKET_CHAT` ។","LDAP_Domain_Search_Object_Category":"ដែនស្វែងរកវត្ថុ","LDAP_Domain_Search_Object_Category_Description":"នេះ * objectCategory * ដែលសម្គាល់អ្នកប្រើរបស់អ្នក។ <br/> ទុកឱ្យនៅទទេចំពោះ * របស់ OpenLDAP * ។ <br/> ឧ `person` ល","LDAP_Domain_Search_Object_Class":"ស្វែងរកវត្ថុដែនថ្នាក់","LDAP_Domain_Search_Object_Class_Description":"នេះ * objectClass * ដែលសម្គាល់អ្នកប្រើរបស់អ្នក។ <br/> ឧ `organizationalPerson`: user`: inetOrgPerson` ល","LDAP_Domain_Search_Password":"ស្វែងរកពាក្យសម្ងាត់ដែន","LDAP_Domain_Search_Password_Description":"ពាក្យសម្ងាត់សម្រាប់អ្នកប្រើស្វែងរកដែន។","LDAP_Domain_Search_User":"ដែនស្វែងរករបស់អ្នកប្រើ","LDAP_Domain_Search_User_Description":"អ្នកប្រើ LDAP ដែលដំណើរការរកមើលអ្នកប្រើដើម្បីផ្ទៀងផ្ទាត់ភាពត្រឹមត្រូវអ្នកប្រើផ្សេងទៀតនៅពេលពួកគេចូល។ <br/> នេះគឺជាការជាធម្មតាគណនីសេវាកម្មមួយដែលបានបង្កើតឡើងជាពិសេសសម្រាប់ការធ្វើសមាហរណកម្មភាគីទីបី។ ប្រើឈ្មោះដែលមានសមត្ថភាពយ៉ាងពេញលេញជាមួយដូចជា `CN = គ្រប់គ្រង CN = អ្នកប្រើ, DC = ឧទាហរណ៍ dc = com` ។","LDAP_Domain_Search_User_ID":"លេខសម្គាល់អ្នកដែនស្វែងរក","LDAP_Domain_Search_User_ID_Description":"គុណលក្ខណៈ LDAP ដែលបានកំណត់អ្នកប្រើ LDAP ដែលប៉ុនប៉ងផ្ទៀងផ្ទាត់ភាពត្រឹមត្រូវ។ វាលនេះគួរតែជា `sAMAccountName` សម្រាប់ការដំឡើងថតសកម្មច្រើនបំផុតប៉ុន្តែវាអាចជាដំណោះស្រាយ` uid` ផ្សេងទៀតរបស់ LDAP ដូចជារបស់ OpenLDAP ។ អ្នកអាចប្រើ `mail` អត្តសញ្ញាណអ្នកប្រើដោយអ៊ីម៉ែលឬគុណលក្ខណៈដែលអ្នកចង់បាន។ <br> អ្នកអាចប្រើតម្លៃជាច្រើនត្រូវបានបំបែកដោយសញ្ញាក្បៀសដើម្បីអនុញ្ញាតឱ្យអ្នកប្រើដើម្បីចូលទៅប្រើប្រាស់ជាច្រើនដូចឈ្មោះអ្នកប្រើអត្តសញ្ញាឬអ៊ីម៉ែល។","LDAP_Enable":"អនុញ្ញាតិ LDAP","LDAP_Enable_Description":"ព្យាយាមប្រើប្រាស់ LDAP ក្នុងការផ្ទៀងផ្ទាត់គណនី","LDAP_Encryption":"ការអ៊ីនគ្រីប","LDAP_Encryption_Description":"វិធីសាស្រ្តក្នុងការអ៊ិនគ្រីបបានប្រើដើម្បីទទួលបានទំនាក់ទំនងទៅកាន់ម៉ាស៊ីនបម្រើ LDAP ។ ឧទហរណ៍រួមបញ្ចូលទាំងការ `plain` (ការអ៊ិនគ្រីបទេ): SSL / LDAPS` (ដែលបានអ៊ិនគ្រីបពីចាប់ផ្តើម) និង` StartTLS` (ធ្វើឱ្យប្រសើរឡើងទំនាក់ទំនងដែលបានអ៊ិនគ្រីបបានភ្ជាប់ម្តង) ។","LDAP_Host":"ម៉ាស៊ីន","LDAP_Host_Description":"ម៉ាស៊ីនបម្រើ LDAP ឧទាហរណ៍ ldap.example.com` `ឬ` 10.0.0.30` ។","LDAP_Port":"ច្រក LDAP","LDAP_Port_Description":"ផែដើម្បីចូលទៅកាន់ LDAP ត្រង់លេខ; ឧទាហរណ៍៖ 389 ","LDAP_Reject_Unauthorized":"បដិសេធចោលដោយគ្មានការអនុញ្ញាត","LDAP_Sync_User_Avatar":"ធ្វើសមកាលកម្ម Avatar របស់អ្នកប្រើប្រាស់","LDAP_Sync_User_Data":"រក្សាទិន្នន័យ User ដោយ Sync ជាមួយ Server","LDAP_Sync_User_Data_Description":"រក្សាទិន្នន័យអ្នកប្រើប្រាស់ក្នុងការ Sync ជាមួយម៉ាស៊ីនមេក្នុងការ Login (eg: name, email)។","LDAP_Sync_User_Data_FieldMap":"ចំណុចចងភ្ជាប់ទិន្នន័យអ្នកប្រើប្រាស់","LDAP_Sync_User_Data_FieldMap_Description":"ការកំណត់ចន្លោះគណនីអ្នកប្រើប្រាស់ (ដូចជាអ៊ីមែល) គឺត្រូវបានទាញទិន្នន័យចេញពី LDAP (ពេលដែលរកឃើញ)។ <br/> ឧទាហរណ៍៖ `{\"cn\":\"ឈ្មោះ\", \"mail\":\"អ៊ីមែល\"}` នឹងត្រូវបានជ្រើសយកឈ្មោះមនុស្សពីធាតុ cn ហើយអ៊ីមែលរបស់ពួកគេទាញចេញពីធាតុ email។<br/> ចន្លោះទំនេររាប់បញ្ចូលទាំង `ឈ្មោះ` និង `អ៊ីមែល`។","LDAP_Sync_Users":"អ្នកប្រើសមកាលកម្ម","LDAP_Test_Connection":"សាកល្បងការតភ្ជាប់","LDAP_Unique_Identifier_Field":"មានតែមួយគត់សម្គាល់វាល","LDAP_Unique_Identifier_Field_Description":"វាលនេះដែលនឹងត្រូវបានប្រើដើម្បីភ្ជាប់អ្នកប្រើ LDAP និងអ្នកប្រើ Rocket.Chat នេះ។ អ្នកអាចជូនដំណឹងដល់តម្លៃជាច្រើនត្រូវបានបំបែកដោយសញ្ញាក្បៀសដើម្បីព្យាយាមដើម្បីទទួលបានតម្លៃពីកំណត់ត្រា LDAP ។ <br/> តម្លៃលំនាំដើមគឺ `objectGUID, ក្រុមហ៊ុន IBM-entryUUID, ណែនាំ, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"ប្រើ Search ដែនផ្ទាល់ខ្លួន","LDAP_Use_Custom_Domain_Search_Description":"ការសរសេរតម្រងផ្ទាល់ខ្លួនរបស់អ្នកដើម្បីស្វែងរកអ្នកប្រើនៅក្នុងម៉ាស៊ីនបម្រើ LDAP ។","LDAP_Username_Field":"ឈ្មោះអ្នកប្រើវាល","LDAP_Username_Field_Description":"វាលនេះដែលនឹងត្រូវបានប្រើជា * សម្រាប់អ្នកប្រើឈ្មោះអ្នកប្រើ * ថ្មី។ ទុកឱ្យទទេដើម្បីប្រើឈ្មោះអ្នកប្រើដែលបានជូនដំណឹងនៅលើទំព័រចូល។ <br/> អ្នកអាចប្រើស្លាកពុម្ពផងដែរ, ដូចជា `# {givenName} ។ # {SN}` ។ <br/> តម្លៃលំនាំដើមគឺ `sAMAccountName` ។","Leave_Group_Warning":"តើអ្នកពិតជាចង់ចាកចេញពីក្រុម \" %s\" ទេ?","Leave_Private_Warning":"តើអ្នកពិតជាចង់ទុកការពិភាក្សាជាមួយ \" %s\" ទេ?","Leave_room":"ចេញ​ពីបន្ទប់","Leave_Room_Warning":"តើអ្នកពិតជាចង់ចាកចេញពីបន្ទប់ \" %s\"?","line":"ជួរ","List_of_Direct_Messages":"បញ្ជីនៃការផ្ញើសារដោយផ្ទាល់","Live_sessions":"វគ្គបន្តផ្ទាល់","Livechat_agents":"ភ្នាក់ងារ Livechat","Livechat_Dashboard":"ផ្ទាំងគ្រប់គ្រង Livechat","Livechat_enabled":"Livechat បានអនុញ្ញាត","Livechat_Manager":"កម្មវិធីគ្រប់គ្រង Livechat","Livechat_managers":"អ្នកចាត់ការទូទៅ Livechat","Livechat_title":"ចំណង​ជើង LiveChat","Livechat_title_color":"ពណ៌ផ្ទៃខាងក្រោយចំណងជើង LiveChat","Livechat_Users":"អ្នកប្រើ Livechat","Load_more":"មើល​ទៀត","Loading...":"កំពុង​ដំណើរការ...","Loading_more_from_history":"លោតច្រើនទៀតពីប្រវត្តិ","Loading_suggestion":"កំពុង​មើល​ការ​សម្រេច​ចិត្ត...","Localization":"មូលដ្ឋានីយកម្ម","Log_File":"បង្ហាញឯកសារនិងបន្ទាត់","Log_Level":"កម្រិតកំណត់ហេតុ","Log_Package":"បង្ហាញកញ្ចប់","Log_View_Limit":"ចូលមើលដែនកំណត់","Logged_out_of_other_clients_successfully":"បានចេញនៃអតិថិជនផ្សេងទៀតដោយជោគជ័យ","Login":"ឡុក​ចូល","Login_with":"ឡុក​ចូល​ជាមួយ %s","login_with":"ឬ ឡុក​ចូល​ដោយ​ផ្ទាល់​ជាមួយ","Logout":"ចាក​ចេញ","Logout_Others":"ចេញពីអ្នកផ្សេងទៀតនៅក្នុងទីតាំង","Mail_Message_Invalid_emails":"អ្នកបានផ្តល់អ៊ីម៉ែលមួយឬច្រើនជាងនេះមិនត្រឹមត្រូវ: %s បាន","Mail_Message_Missing_to":"អ្នកត្រូវតែជ្រើសអ្នកប្រើមួយឬច្រើនឬផ្ដល់នូវអាសយដ្ឋានអ៊ីម៉ែលមួយឬច្រើនដែលបំបែកដោយសញ្ញាក្បៀស។","Mail_Message_No_messages_selected_select_all":"អ្នកមិនបានជ្រើសសារណាមួយឡើយ។ តើអ្នកចង់ <a href='#' class='select-all'>ជ្រើសទាំងអស់</a> សារដែលអាចមើលឃើញ?","Mail_Messages":"សារសំបុត្រ","Mail_Messages_Instructions":"ជ្រើសសារដែលអ្នកចង់ផ្ញើតាមរយៈអ៊ីម៉ែលដោយចុចលើសារ","Mail_Messages_Subject":"នៅទីនេះជាមួយផ្នែកដែលបានជ្រើសរបស់ %s ដែលសារ","Mailer":"ផ្ញើសំបុត្រ","Mailer_body_tags":"អ្នក<b>ត្រូវ</b>ប្រើប្រាស់ [unsubcribe] សម្រាប់ដកដំណភ្ជាប់ជាវជាប្រចាំ។<br/> អ្នកប្រហែលជាត្រូវប្រើប្រាស់ [name], [fname], [lname] ធ្វើជាឈ្មោះពេញរបស់អ្នកប្រើប្រាស់។<br/> អ្នកប្រហែលជាប្រើ [email] ធ្វើជាអ៊ីមែលរបស់អ្នកប្រើប្រាស់។","Make_Admin":"ឲ្យ​ធ្វើ​អ្នក​គ្រប់​គ្រង","Manager_added":"កម្មវិធីគ្រប់គ្រងបន្ថែមទៀត","Manager_removed":"អ្នកចាត់ការទូទៅបានយកចេញ","Mark_as_read":"សម្គាល់​ថា​បាន​អាន","Markdown_Headers":"បឋមកថា Markdown","Markdown_SupportSchemesForLink":"គម្រោងគាំទ្រ Markdown សម្រាប់តំណ","Markdown_SupportSchemesForLink_Description":"បញ្ជីបំបែកដោយសញ្ញាក្បៀសនៃគម្រោងដែលបានអនុញ្ញាត","Members_List":"បញ្ជី​សមាជិក","Mentions":"លើកឡើង","Mentions_default":"បានលើកឡើង (លំនាំដើម)","Message":"សារ","Message_AllowDeleting":"អនុញ្ញាត​ឱ្យ​មាន​ការ​លុប​សារ","Message_AllowEditing":"អនុញ្ញាត​ឱ្យ​មាន​ការ​កែ​សម្រួល​សារ","Message_AllowEditing_BlockEditInMinutes":"បិទការកែស្រួលសារបន្ទាប់ (ជាចំនួននាទី ឬ0ដើម្បីបិទចោល)","Message_AllowEditing_BlockEditInMinutesDescription":"បញ្ចូលលេខ 0 ដើម្បីបិទការ Block","Message_AllowPinning":"អនុញ្ញតិ​ខ្ទស់សារ​","Message_AllowPinning_Description":"អនុញ្ញាតឱ្យសារត្រូវបានខ្ទាស់ទៅច្រើនប៉ុស្តិ៍។","Message_AllowStarring":"អនុញ្ញាតិការសម្គាល់ផ្កាយលើសារ","Message_AudioRecorderEnabled":"ការថតសម្លេងបានអនុញ្ញាតិ","Message_AudioRecorderEnabledDescription":"ត្រូវការឯកសារប្រភេទ 'audio/wav' ក្នុងការកំណត់ 'File Upload' ","Message_DateFormat":"ទ្រង់ទ្រាយកាលបរិច្ឆេទ","Message_DateFormat_Description":"សូមមើលផងដែរ: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"ការ​លប់សារ​មិន​ត្រូវ​បាន​អនុញ្ញាតិ","Message_editing_blocked":"សារ​នេះ​មិន​អាច​ត្រូវ​បាន​កែប្រែ​ទៀត​ទេ","Message_editing_not_allowed":"ការ​កែ​សម្រួល​សារ​មិន​ត្រូវ​បាន​អនុញ្ញាតិ","Message_GroupingPeriod":"ក្រុមរយៈពេល (គិតជាវិនាទី)","Message_GroupingPeriodDescription":"សារនឹងត្រូវបានដាក់ជាក្រុមជាមួយនឹងសារមុនប្រសិនបើអ្នកទាំងពីរគឺបានមកពីអ្នកប្រើដូចគ្នានិងពេលវេលាកន្លងទៅនេះគឺតិចជាងការពេលវេលាជាវិនាទីដំណឹង។","Message_KeepHistory":"រក្សា​​ប្រវត្តិ​សារ","Message_MaxAllowedSize":"ទំហំអតិបរមាដែលត្រូវបានអនុញ្ញាតសារ","Message_MaxAll":"ទំហំអតិបរមាសម្រាប់ឆានែល ALL សារ","Message_pinned":"សារ\n","Message_pinning_not_allowed":"ការខ្ទាស់​សារ​មិន​អនុញ្ញាតិ​","Message_removed":"សារ​បាន​លប់","Message_ShowDeletedStatus":"បង្ហាញ​ស្ថានភាព​ដែល​បាន​លុប","Message_ShowEditedStatus":"បង្ហាញ​ស្ថានភាព​អត្ថបទ​​ដែល​បាន​កែ​សម្រួល","Message_ShowFormattingTips":"បង្ហាញទ្រង់ទ្រាយដំបូន្មាន","Message_TimeFormat":"ទ្រង់ទ្រាយពេលវេលា","Message_TimeFormat_Description":"សូមមើលផងដែរ: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"សារយូរពេក","Messages":"សារ","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"សារដែលត្រូវបានបញ្ជូនទៅចូល WebHook នឹងត្រូវបានបង្ហោះនៅទីនេះ។","Meta":"មេតា","Meta_fb_app_id":"លេខ​សម្គាល់ កម្មវិធី​ហ្វេស​ប៊ូក","Meta_google-site-verification":"ការ​ផ្ទៀង​ផ្ទាត់​ជាមួយ Google Site","Meta_language":"ភាសា","Meta_msvalidate01":"កូដ MSValidate.01","Meta_robots":"មនុស្ស​យន្ត","minutes":"នាទី","Mobile_push":"ការជំរុញទូរស័ព្ទដៃ","More_channels":"ប៉ុស្តិ៍​ច្រើន​ទៀត","More_direct_messages":"សារដោយផ្ទាល់","More_groups":"ក្រុមឯកជនច្រើនទៀត","More_unreads":"មិនទាន់អានច្រើនទៀត","Msgs":"សារ","multi":"ច្រើន","Mute_someone_in_room":"នរណាម្នាក់នៅក្នុងបន្ទប់នេះមនុស្សគ","Mute_user":"អ្នកប្រើដែលបានបិទ","Muted":"ស្ងាត់","My_Account":"គណនី​របស់ខ្ញុំ","n_messages":"%s សារ","N_new_messages":"សារថ្មី %s បាន","Name":"Name","Name_cant_be_empty":"ឈ្មោះ​មិន​អាច​ទទេ","Name_of_agent":"ឈ្មោះរបស់ភ្នាក់ងារ","Name_optional":"ឈ្មោះ (ស្រេច​ចិត្ត​)","Navigation_History_20_last_pages":"ប្រវត្តិសាស្រ្តរុករក (20 ទំព័រចុងក្រោយ)","New_Application":"កម្មវិធីថ្មី","New_Custom_Field":"វាលផ្ទាល់ខ្លួនថ្មី","New_Department":"នាយកដ្ឋានថ្មី","New_integration":"ការរួមបញ្ចូលថ្មី","New_logs":"កំណត់ហេតុថ្មី","New_messages":"សារ​ថ្មី","New_password":"ពាក្យ​សម្ងាត់​ថ្មី","New_role":"តួនាទីថ្មី","No_channel_with_name_%s_was_found":"មិន​មាន​ប៉ុស្តិ៍​ឈ្មោះ <strong>\"%s\"</strong> ឡើយ​","No_channels_yet":"អ្នក​មិន​មែន​ជា​សមាជិក​នៃ​ប៉ុស្តិ៍​ណា​មួយ​ឡើយ","No_direct_messages_yet":"អ្នក​មិន​ធ្លាប់​បាន​ធ្វើ​ការ​ពិភាក្សា​នៅ​ឡើយ","No_Encryption":"គ្មានការអ៊ិនគ្រីប","No_favorites_yet":"អ្នក​មិន​ធ្លាប់​បាន​កំណត់​ត្រា​ពេញ​ចិត្ត​ណាមួយ​ឡើយ","No_group_with_name_%s_was_found":"មិន​មាន​ក្រុម​ឯក​ជន​​ឈ្មោះ <strong>\"%s\"</strong> ឡើយ","No_groups_yet":"អ្នក​មិន​ទាន់​មាន​ក្រុម​ឯកជន​នៅឡើយ","No_livechats":"អ្នកមាន livechats ទេ។","No_mentions_found":"គ្មានការលើកឡើងរកឃើញ","No_permission_to_view_room":"អ្នក​មិន​មាន​សិទ្ធ​មើល​បន្ទប់​នេះ​ឡើយ","No_pinned_messages":"មិនមានសារបានខ្ទាស់","No_results_found":"គ្មានរកឃើញលទ្ធផល","No_starred_messages":"សារមិនមានផ្កាយ","no_tokens_for_this_user":"មានថូខឹនសម្រាប់អ្នកប្រើនេះទេ","No_user_with_username_%s_was_found":"មិន​មាន​អ្នក​ប្រើប្រាស់​ឈ្មោះ <strong>\"%s\"</strong> ឡើយ","Not_allowed":"មិន​បាន​អនុញ្ញាត្តិ","Not_authorized":"មិនត្រូវបានអនុញ្ញាត","Not_Available":"មិនអាច","Not_found_or_not_allowed":"មិន​ប្រទះ ឬ​មិន​អនុញ្ញាតិ","Nothing":"គ្មានអ្វី","Nothing_found":"គ្មាន​អ្វី​ប្រទះ","Notifications":"ការជូនដំណឹង","Notify_all_in_this_room":"ជូន​ដំណឹង​ទាំង​អស់​នៅ​ក្នុង​បន្ទប់​នេះ","Num_Agents":"ភ្នាក់ងារ #","Number_of_messages":"ចំនួននៃសារដែលបាន","OAuth_Application":"កម្មវិធី OAuth","OAuth_Applications":"កម្មវិធី OAuth","Objects":"វត្ថុ","Off_the_record_conversation":"បិទការកត់ត្រាការសន្ទនា","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"បិទការកត់ត្រាការសន្ទនាគឺជាការមិនអាចរកបានសម្រាប់កម្មវិធីរុករកឬឧបករណ៍របស់អ្នក។","Offline_DM_Email":"[__site__] អ្នកត្រូវបាន messaged ដោយផ្ទាល់ដោយ __user__","Offline_Mention_Email":"[__site__] អ្នកត្រូវបានលើកឡើងដោយ __user__ ក្នុង #__room__","Old_and_new_password_must_be_different":"ពាក្យសម្ងាត់ថ្មីត្រូវតែមានការខុសគ្នាពីពាក្យសម្ងាត់ចាស់។","Old_and_new_password_required":"អ្នកត្រូវតែផ្តល់ទាំងពាក្យសម្ងាត់ចាស់ និងថ្មី ដើម្បីប្តូរពាក្យសម្ងាត់។","Online":"លើបណ្តាញ","Only_errors":"មានតែកំហុស","Only_you_can_see_this_message":"មានតែអ្នកដែលអាចឃើញសារនេះ","Oops!":"អូ!","Open":"បើកទូលាយ","Opened":"បានបើក","Opt_out_statistics":"កុំផ្ញើស្ថិតិអនាមិករបស់អ្នកទៅ Rocket.Chat","Opt_out_statistics_warning":"តាមការផ្ញើរស្ថិតិអនាមិនរបស់អ្នក, អ្នកនឹងជួយយើងដើម្បីសម្គាល់ចំនួនករណីនៃ Rocket.Chat ដែលត្រូវបានដាក់ប្រើ ដូចជាករណីចំនួនប្រព័ន្ធ ល្អកំពុងប្រើប្រាស់ ដូចនេះយើងអាចពង្រឹងវាបន្ថែមទៀត។ ប្រសិនបើអ្នកចង់បន្តការផ្ញើរស្ថិតិអនាមិនរបស់អ្នក សូមកុំធិចក្នុងប្រអប់ខាងលើ សូមអរគុណ!","optional":"ស្រេចចិត្ត","Order":"លំដាប់","OS_Arch":"ប្រព័ន្ធប្រតិបត្តិការសំខាន់បំផុត","OS_Cpus":"រាប់ CPU ប្រព័ន្ធប្រតិបត្តិការ","OS_Freemem":"អង្គចងចាំប្រព័ន្ធប្រតិបត្តិការដែលនៅទំនេរ","OS_Loadavg":"ប្រព័ន្ធប្រតិបត្តិការធ្វើការមធ្យម","OS_Platform":"ទម្រង់ប្រព័ន្ធប្រតិបត្តិការ","OS_Release":"ជំនាន់ប្រព័ន្ធប្រតិបត្តិការ","OS_Totalmem":"ប្រព័ន្ធប្រតិបត្តិការប្រើអង្គចងចាំសរុប","OS_Type":"ប្រភេទ​ប្រព័ន្ធ​ប្រតិបត្តិការ","OS_Uptime":"ប្រព័ន្ធ​ប្រតិបត្តិការ​អស់​ពេល","others":"ផ្សេងៗ","OTR":"ប្រវត្តិ","OTR_is_only_available_when_both_users_are_online":"ប្រវត្តិគឺអាចប្រើបានតែនៅពេលដែលអ្នកប្រើប្រាស់ទាំងពីរគឺមាននៅលើបណ្ដាញ","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL ដែលបានបដិសេធទៅនឹងឯកសារដែលបានផ្ទុកឡើង។ URL នេះបានប្រើផងដែរសម្រាប់ការទាញយកបានទេលុះត្រាតែ CDN មួយត្រូវបានផ្ដល់","Password":"ពាក្យ​សម្ងាត់","Password_Change_Disabled":"សិទ្ធជាអ្នកគ្រប់គ្រង Rocket.Chat ត្រូវបានបិទមិនឲ្យប្តូរពាក្យសម្ងាត់ឡើយ","Password_changed_successfully":"ពាក្យ​សម្ងាត់​បាន​ប្តូរ​ជោគជ័យ","Payload":"payload","People":"មនុស្ស","Permissions":"សិទ្ធិ","Pin_Message":"ខ្ទាស់សារ","Pinned_a_message":"ខ្ទាស់សារមួយ:","Pinned_Messages":"មិនខ្ទាស់សារ","Placeholder_for_email_or_username_login_field":"កន្លែងដាក់សម្រាប់អ៊ីម៉ែលឬចូលឈ្មោះអ្នកប្រើវាល","Placeholder_for_password_login_field":"កន្លែងដាក់សម្រាប់វាលចូលពាក្យសម្ងាត់","Please_answer_survey":"សូមចំណាយពេលបន្តិចដើម្បីឆ្លើយតបការស្ទង់មតិរហ័សអំពីការជជែកនេះ","Please_enter_value_for_url":"សូមបញ្ចូលតម្លៃរបស់ URL នៃ Avatar របស់អ្នក","Please_enter_your_new_password_below":"សូមបញ្ចូលពាក្យសម្ងាត់ថ្មីរបស់អ្នកនៅខាងក្រោម:","Please_fill_a_label":"សូមបំពេញស្លាក","Please_fill_a_name":"សូមបំពេញឈ្មោះមួយ","Please_fill_a_username":"សូមបំពេញឈ្មោះអ្នកប្រើ","Please_fill_name_and_email":"សូមបំពេញឈ្មោះនិងអ៊ីម៉ែល","Please_re_enter_your_password":"សូមបញ្ចូលពាក្យសម្ងាត់របស់អ្នក","Please_select_enabled_yes_or_no":"សូមជ្រើសជម្រើសមួយសម្រាប់ការបើក","Please_wait":"សូម​មេត្តារង់​ចាំ","Please_wait_activation":"សូម​មេត្តារង់​ចាំ ការងារ​នេះ​ត្រូវ​ចំណាយ​ពេល​បន្តិច","Please_wait_statistics":"សូម​មេត្តារង់ចាំ ស្ថិតិ​គឺ​កំពុង​គណនា","Please_wait_while_OTR_is_being_established":"សូមរង់ចាំខណៈពេលដែលត្រូវបានបង្កើតឡើងប្រវត្តិ","Please_wait_while_your_account_is_being_deleted":"សូមរង់ចាំខណៈពេលដែលគណនីរបស់អ្នកត្រូវបានលុប ...","Please_wait_while_your_profile_is_being_saved":"សូមរង់ចាំខណៈពេលដែលទម្រង់របស់អ្នកកំពុងត្រូវបានរក្សាទុក ...","Post_as":"ប៉ុស្តិ៍","Post_to_Channel":"ប្រកាសទៅឆានែល","Post_to_s_as_s":"<strong>ភ្នំពេញប៉ុស្តិ៍ទៅ %s</strong> <strong>ជា %s</strong>","Powered_by":"រក្សាសិទ្ធិ​ដោយ","Preferences":"ចំណង់​ចំណូល​ចិត្ត","Preferences_saved":"ចំណង់​ចំណូល​ចិត្ត​ដែល​បាន​រក្សាទុក","Privacy":"ឯកជនភាព","Private_Group":"ក្រុម​ឯកជន","Private_Groups":"ក្រុម​ឯកជន","Private_Groups_list":"បញ្ជី​នៃ​ក្រុម​ឯកជន","Profile":"ព​ត៌​មាន​ផ្ទាល់​ខ្លួន","Profile_saved_successfully":"ព​ត៌​មាន​ផ្ទាល់​ខ្លួន​​បាន​រក្សា​ទុក​ដោយ​ជោគជ័យ","Proudly_developed":"បាន​អភិវឌ្ឍ​ដោយ​មោ​ទ​នៈ​ដោយ​មាន​រឿង Meteor","Push":"រុញ","Push_apn_cert":"វិញ្ញាបនប័ត្រ APN","Push_apn_dev_cert":"វិញ្ញាបនប័ត្រអ្នក​អភិវឌ្ឍន៍ APN","Push_apn_dev_key":"សោរអ្នក​អភិវឌ្ឍន៍ APN","Push_apn_dev_passphrase":"ឃ្លា​សម្ងាត់​អ្នក​អភិវឌ្ឍន៍ APN","Push_apn_key":"សោរ APN","Push_apn_passphrase":"ឃ្លា​សម្ងាត់ APN","Push_debug":"ត្រួត​ពិនិត្យ​​កំហុស","push_disabled":"ជំរុញឱ្យជនពិការ","Push_enable":"អនុញ្ញាត","Push_enable_gateway":"អនុញ្ញាតឱ្យមានផ្លូវចេញចូល","Push_gateway":"ផ្លូវចេញចូល","Push_gcm_api_key":"GCM កូនសោ API","Push_gcm_project_number":"លេខគម្រោង GCM","Push_production":"ផលិតកម្ម","Push_show_message":"បង្ហាញសារក្នុងការជូនដំណឹង","Push_show_username_room":"បង្ហាញឆានែល / ក្រុម / ឈ្មោះអ្នកប្រើនៅក្នុងការជូនដំណឹង","Push_test_push":"ការធ្វើតេស្ត","Query":"សំណួរ","Query_description":"លក្ខខណ្ឌបន្ថែមសម្រាប់អ្នកប្រើប្រាស់ដែលមានដើម្បីកំណត់ផ្ញើអ៊ីម៉ែលទៅ។ អ្នកប្រើប្រាស់មិនបានជាវត្រូវបានយកចេញដោយស្វ័យប្រវត្តិពីសំណួរ។ វាត្រូវតែជា JSON ត្រឹមត្រូវ។ ឧទាហរណ៍: \"{\" createdAt \": {\" $ GT \": {\" $ កាលបរិច្ឆេទ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"ស្វែង​រក​រហ័ស","quote":"សំណៅ","Reactions":"ប្រតិកម្ម","Recents":"ថ្មីៗ","Record":"កំណត់​ត្រា","Redirect_URI":"ប្តូរទិស URI","Refresh_keys":"គ្រាប់ចុចធ្វើឱ្យស្រស់","Refresh_your_page_after_install_to_enable_screen_sharing":"ធ្វើឱ្យស្រស់ទំព័ររបស់អ្នកបន្ទាប់ពីការដំឡើងដើម្បីអនុញ្ញាតការចែករំលែកអេក្រង់","Register":"ចុះ​ឈ្មោះ​គណនី​ថ្មី","Registration_Succeeded":"ការ​ចុះឈ្មោះ​ជោគជ័យ","Remember_me":"ចងចាំ​ខ្ញុំ","Remove":"ដកចេញ","Remove_Admin":"ដក​សិទ្ធ​អ្នក​គ្រប់គ្រង","Remove_as_moderator":"យកជាអ្នកសម្របសម្រួល","Remove_as_owner":"យកជាម្ចាស់","Remove_custom_oauth":"លប់ចោល oauth ផ្ទាល់ខ្លួន","Remove_from_room":"យកចេញពីបន្ទប់","Remove_someone_from_room":"យកនរណាម្នាក់ពីបន្ទប់","Removed":"បានយកចេញ","Require_password_change":"តម្រូវឱ្យមានការផ្លាស់ប្តូរពាក្យសម្ងាត់","Resend_verification_email":"ផ្ញើអ៊ីមែលផ្ទៀងផ្ទាត់","Reset":"កំណត់ឡើងវិញ","Reset_password":"កំណត់​ពាក្យ​សម្ងាត់​ឡើងវិញ","Restart":"ចាប់ផ្ដើមឡើងវិញ","Restart_the_server":"ចាប់ផ្ដើមម៉ាស៊ីនបម្រើបាន","RocketBot_Enabled":"RocketBot បានអនុញ្ញាតិ","RocketBot_Name":"ឈ្មោះ RocketBot","RocketBot_Name_Description":"ឈ្មោះ RocketBot ត្រូវតែជាឈ្មោះដែលបានចុះត្រឹមត្រូវនៅលើ Server ។","Role":"តួនាទី","Role_Editing":"តួនាទីការកែសម្រួល","Role_removed":"តួនាទីបានយកចេញ","Room":"បន្ទប់","Room_archivation_state":"រដ្ឋ","Room_archivation_state_false":"ដែលសកម្ម","Room_archivation_state_true":"ទុកជាឯកសារ","Room_archived":"បន្ទប់ទុក​​ក្នុងប័ណ្ណសារ","room_changed_privacy":"ប្រភេទបន្ទប់បានផ្លាស់ប្តូរទៅជា: <em>__room_type__</em> ដោយ <em>__user_by__</em>","room_changed_topic":"អត្ថបទបន្ទប់បានផ្លាស់ប្តូរទៅជា: <em>__room_topic__</em> ដោយ <em>__user_by__</em>","Room_has_been_deleted":"បន្ទប់ត្រូវបានលុបចោល","Room_Info":"ព័តមានបន្ទប់","Room_name_changed":"ឈ្មោះ​បន្ទប់​បាន​ប្តូរ​ទៅ​ជា: <em>__room_name__</em> ដោយ <em>__user_by__</em>","Room_name_changed_successfully":"ឈ្មោះ​បន្ទប់​បាន​ប្តូរ​ជោគជ័យ","Room_not_found":"រក​មិន​ឃើញ​បន្ទប់","Room_topic_changed_successfully":"បន្ទប់ផ្លាស់ប្តូរដោយជោគជ័យប្រធានបទ","Room_type_changed_successfully":"ប្រភេទបន្ទប់ផ្លាស់ប្តូរដោយជោគជ័យ","Room_unarchived":"បន្ទប់ទុក​​ក្នុងប័ណ្ណសារ","Room_uploaded_file_list":"បញ្ជី​ឯកសារ","Room_uploaded_file_list_empty":"ពុំមានឯកសារដែលអាចប្រើបាន។","room_user_count":"%s អ្នក​ប្រើប្រាស់","Rooms":"បន្ទប់","S_new_messages_since_s":"%s សារថ្មីចាប់តាំងពី %s","SAML":"ប្រើ SAML","SAML_Custom_Cert":"វិញ្ញាបនបត្រ​ផ្ទាល់ខ្លួន","SAML_Custom_Entry_point":"ចំណុចធាតុផ្ទាល់ខ្លួន","SAML_Custom_Generate_Username":"គណនាឈ្មោះអ្នកប្រើប្រាស់","SAML_Custom_Issuer":"អ្នកចេញផ្សាយផ្ទាល់ខ្លួន","SAML_Custom_Provider":"ក្រុមហ៊ុនផ្ដល់ផ្ទាល់ខ្លួន","Save":"រក្សាទុក","Save_changes":"រក្សា​ទុក​ការ​ផ្លាស់​ប្តូ​រ","Save_Mobile_Bandwidth":"រក្សាទុកកម្រិតបញ្ជូនតាមទូរស័ព្ទដៃ","Save_to_enable_this_action":"រក្សាទុកដើម្បីបើកសកម្មភាពនេះ","Saved":"ដែលបានរក្សាទុក","Saving":"កំពុងរក្សាទុក","Scope":"វិសាលភាព","Screen_Share":"អេក្រង់ចែករំលែក","Script_Enabled":"ស្គ្រីបបានអនុញ្ញាត","Search":"ស្វែង​រក","Search_by_username":"ការស្វែងរកដោយប្រើឈ្មោះអ្នកប្រើ","Search_Channels":"ស្វែងរកឆានែល","Search_Direct_Messages":"ស្វែងរកសារដោយផ្ទាល់","Search_Messages":"ស្វែងរក​សារ","Search_Private_Groups":"ស្វែងរកឯកជនក្រុម","Search_settings":"កំណត់​ការស្វែង​រក","seconds":"វិនាទ","See_all":"មើលទាំងអស់","See_only_online":"ត្រឹម​តែ​លើ​បណ្តាញ","Select_a_department":"ជ្រើសផ្នែកណាមួយ","Select_an_avatar":"ជ្រើស​រូប","Select_file":"ជ្រើស​ ឯកសារ","Select_service_to_login":"ជ្រើស​សេវាកម្ម​ដើម្បីឡុក​ចូល ទាញ​រូប​របស់​អ្នក ឬ​ផ្ទុកឡើង​ផ្ទាល់​ពីកុំព្យូទ័រ","Select_user":"ជ្រើសអ្នកប្រើ","Select_users":"ជ្រើសអ្នកប្រើ","Selected_agents":"ភ្នាក់ងារដែលបានជ្រើស","Selected_users":"ជ្រើស​សមាជិក","Send":"ផ្ញើ","Send_a_message":"ផ្ញើ​សារ​មួយ","Send_a_test_mail_to_my_user":"ការធ្វើតេស្តផ្ញើសំបុត្រទៅអ្នកប្រើរបស់ខ្ញុំ","Send_a_test_push_to_my_user":"ផ្ញើការជំរុញការធ្វើតេស្តទៅអ្នកប្រើរបស់ខ្ញុំ","Send_confirmation_email":"ផ្ញើរអ៊ីម៉ែល​បញ្ជាក់","Send_data_into_RocketChat_in_realtime":"ផ្ញើទិន្នន័យទៅក្នុង Rocket.Chat ពេលវេលាពិតប្រាកដក្នុងការ។","Send_email":"ផ្ញើ​រ​អ៊ី​ម៉ែ​ល","Send_invitation_email":"ផ្ញើ​ការ​អញ្ជើញ​អ៊ីមែល","Send_invitation_email_error":"អ្នកមិនបានផ្តល់អាស័យដ្ឋានអ៊ីមែលត្រឹមត្រូវទេ","Send_invitation_email_info":"អ្នកអាចផ្ញើរច្រើនការអញ្ជើញអ៊ីមែលក្នុងពេលតែមួយ","Send_invitation_email_success":"អ្នកបានផ្ញើរអ៊ីមែលការអញ្ជើញដោយជោគជ័យតាមរយៈអាស័យដ្ឋានដូចជា៖","Send_invitation_email_warning":"លំដាប់នៃការរៀបចំផ្ញើរអ៊ីមែលអញ្ជើញ គឺជាដំបូងអ្នកត្រូវកំណត់ពិធីការ SMTP ជាមុនសិន។","Send_Message":"ផ្ញើរសារ","Send_your_JSON_payloads_to_this_URL":"ការបញ្ជូនទិន្នន័យ JSON របស់អ្នកបានផ្ញើទៅ URL នេះ។","Sending":"កំពុងផ្ញើ ...","Set_as_moderator":"ដែលបានកំណត់ជាអ្នកសម្របសម្រួល","Set_as_owner":"ដែលបានកំណត់ជាម្ចាស់","Settings":"ការកំណត់","Settings_updated":"ការ​កំណត់​ការ​ធ្វើ​ឱ្យ​ទាន់​សម័យ","Should_be_a_URL_of_an_image":"គួរជា URL របស់រូបភាពមួយ។","Should_exists_a_user_with_this_username":"អ្នកប្រើត្រូវតែមានរួចទៅហើយ។","Show_all":"បង្ហាញ​ទាំងអស់","Show_more":"បង្ហាញបន្ថែមទៀត","Show_only_online":"បង្ហាញតែលើបណ្តាញ","Show_preregistration_form":"បង្ហាញសំណុំបែបបទការចុះឈ្មោះជាមុន","Showing_archived_results":"<p> <b>បង្ហាញពីលទ្ធផលទុកក្នុងប័ណ្ណសារ %s បាន</b> </p>","Showing_online_users":"កំពុង​បង្ហាញ <b>__total_showing__</b> នៃ __total__ users","Showing_results":"<p>កំពុង​បង្ហាញ <b>%s</b> លទ្ធផល</p>","Silence":"ស្ងាត់","since_creation":"តាំងពី %s","Site_Name":"គេហទំព័រ​ឈ្មោះ","Site_Url":"តំបន់ URL","Site_Url_Description":"ឧទាហរណ៍៖ https://chat.domain.com/","Skip":"រំលង","Smileys_and_People":"ញញឹមនិងប្រជាជន","SMTP":"ពិធីការ SMTP","SMTP_Host":"ម៉ាស៊ីន SMTP","SMTP_Password":"ឃ្លា​សម្ងាត់ SMTP","SMTP_Port":"ផែ SMTP","SMTP_Test_Button":"ការកំណត់ការធ្វើតេស្តរបស់ SMTP","SMTP_Username":"ឈ្មោះ​សម្ងាត់ SMTP","Sound":"សំឡេង","Star_Message":"សារសម្គាល់ផ្កាយ","Starred_Messages":"សារដែលមានផ្កាយ","Start_audio_call":"ចាប់ផ្តើមការហៅជាសំឡេង","Start_Chat":"ចាប់ផ្ដើម​ជជែក​កំសាន្ត","Start_of_conversation":"ចំនាប់​ផ្តើ​ការ​ពិភាក្សា","Start_OTR":"ចាប់ផ្តើមប្រវត្តិ","Start_video_call":"ចាប់ផ្តើមការហៅវីដេអូ","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"ការចាប់ផ្តើមជាមួយនឹង <code class=\"inline\">%s</code> សម្រាប់អ្នកប្រើឬ <code class=\"inline\">%s</code> សម្រាប់ឆានែល។ ឧទា: <code class=\"inline\">%s</code> ឬ <code class=\"inline\">%s</code>","Statistics":"ស្ថិតិ","Stats_Active_Users":"អ្នក​ប្រើ​ប្រាស់​សកម្ម","Stats_Avg_Channel_Users":"ចំនួន​អ្នក​ប្រើប្រាស់​ជា​មធ្យម​ក្នុង​ប៉ុស្តិ៍","Stats_Avg_Private_Group_Users":"ចំនួន​អ្នក​ប្រើប្រាស់​ជា​មធ្យម​ក្នុងក្រុម​ឯកជន","Stats_Away_Users":"អ្នក​ប្រើ​ដែល​បាន​ចាក​ឆ្ងាយ","Stats_Max_Room_Users":"អតិបរិមា​អ្នក​ប្រើប្រាស់​ក្នុង​បន្ទប់","Stats_Non_Active_Users":"អ្នក​ប្រើ​អសកម្ម","Stats_Offline_Users":"អ្នក​ប្រើ​ក្រៅ​ប​ណ្តា​ញ","Stats_Online_Users":"អ្នក​ប្រើ​លើ​បណ្ដាញ","Stats_Total_Channels":"ប៉ុស្តិ៍សរុប","Stats_Total_Direct_Messages":"បន្ទប់សារដោយផ្ទាល់សរុប","Stats_Total_Messages":"សារ​សរុប","Stats_Total_Private_Groups":"ក្រុម​ឯកជន​សរុប","Stats_Total_Rooms":"បន្ទប់​សរុប","Stats_Total_Users":"អ្នក​ប្រើ​ប្រាស់​សរុប","Stop_Recording":"បញ្ឈប់​ការ​កត់​ត្រា","strike":"strike","Subject":"ប្រធានបទ","Submit":"បញ្ចូល","Success":"ភាពជោគជ័យ","Survey":"ការស្ទង់មតិ","Survey_instructions":"អត្រាសំណួរគ្នាយោងទៅតាមការពេញចិត្តរបស់អ្នក, 1 មានន័យថាអ្នកគឺជាអ្នកមិនទាន់បានដោះស្រាយទាំងស្រុងនិង 5 មានន័យថាអ្នកគឺជាអ្នកពេញចិត្តទាំងស្រុង។","Symbols":"និមិត្តសញ្ញា","Sync_success":"ការទទួលបានជោគជ័យធ្វើសមកាលកម្ម","Sync_Users":"អ្នកប្រើសមកាលកម្ម","Test_Connection":"សាកល្បងការតភ្ជាប់","Test_Desktop_Notifications":"ការជូនដំណឹងផ្ទៃតុសាកល្បង","Thank_you_for_your_feedback":"សូមអរគុណសម្រាប់មតិរបស់អ្នក","The_application_name_is_required":"ឈ្មោះកម្មវិធីនេះគឺត្រូវបានទាមទារ","The_channel_name_is_required":"ឈ្មោះឆានែលនេះគឺត្រូវបានទាមទារ","The_emails_are_being_sent":"នេះ​អ៊ីមែល​ត្រូវ​បាន​បញ្ជូន​។","The_field_is_required":"ចន្លោះ %s ត្រូវ​បំពេញ","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"ប្ដូរទំហំរូបភាពនឹងមិនធ្វើការដោយសារតែយើងមិនអាចរកឃើញ ImageMagick ឬ GraphicsMagick ដែលបានដំឡើងនៅលើម៉ាស៊ីនបម្រើរបស់អ្នក។","The_redirectUri_is_required":"redirectUri នេះគឺត្រូវបានទាមទារ","The_server_will_restart_in_s_seconds":"ម៉ាស៊ីនបម្រើនេះនឹងចាប់ផ្ដើមឡើងវិញនៅក្នុង %s វិនាទី","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>ការកំណត់ %s</strong> <strong>ត្រូវបានកំណត់រចនាសម្ព័ន្ធដើម្បី %s</strong> <strong>និងអ្នកត្រូវបានចូលដំណើរការពី %s!</strong>","The_user_will_be_removed_from_s":"អ្នកប្រើនឹងត្រូវបានយកចេញពី %s","The_user_wont_be_able_to_type_in_s":"អ្នកប្រើនឹងមិនអាចវាយនៅក្នុង %s","Theme":"ស្បែក","theme-color-action-buttons-color":"ប៊ូតុងសកម្មភាពល័រ","theme-color-active-channel-background-color":"ឆានែលសកម្មផ្ទៃខាងក្រោយ","theme-color-active-channel-font-color":"ឆានែលល័រពុម្ពអក្សរសកម្ម","theme-color-blockquote-background":"ពណ៌ផ្ទៃខាងក្រោយនៃ Blockquote","theme-color-clean-buttons-color":"ប៊ូតុងលាងសមាតល័រ","theme-color-code-background":"កូដពណ៌ផ្ទៃខាងក្រោម","theme-color-code-border":"កូដពណ៌ជាយ","theme-color-code-color":"កូដពណ៌","theme-color-content-background-color":"ពណ៌ផ្ទៃខាងក្រោយអត្ថបទ","theme-color-custom-scrollbar-color":"របាររមូរផ្ទាល់ខ្លួន Color","theme-color-info-active-font-color":"ពណ៌ពុម្ពអក្សររបស់ Active Info","theme-color-info-font-color":"ពណ៌ពុម្ពអក្សររបស់ Info","theme-color-input-font-color":"ពណ៌ពុម្ពអក្សរបញ្ចូល","theme-color-link-font-color":"ពណ៌ពុម្ពអក្សរតំណភ្ជាប់","theme-color-message-hover-background-color":"សារសំកាំងល័ BG","theme-color-primary-background-color":"ពណ៌អាទិភាពផ្ទៃខាងក្រោយ","theme-color-primary-font-color":"ពណ៌អាទិភាពពុម្ពអក្សរ","theme-color-quaternary-font-color":"Quaternary ល័ពុម្ពអក្សរ","theme-color-secondary-background-color":"ពណ៌បន្ទាប់បន្សំផ្ទៃខាងក្រោយ","theme-color-secondary-font-color":"ពណ៌បន្ទាប់បន្សំពុម្ពអក្សរ","theme-color-smallprint-font-color":"បោះពុម្ពខ្នាតតូចល័រពុម្ពអក្សរ","theme-color-smallprint-hover-color":"បោះពុម្ពខ្នាតតូចល័សំកាំង","theme-color-status-away":"ពណ៌ស្ថានភាពនៅឆ្ងាយ","theme-color-status-busy":"ពណ៌ស្ថានភាពរវល់","theme-color-status-offline":"ពណ៌ស្ថានភាពក្រៅបណ្តាញ","theme-color-status-online":"ពណ៌ស្ថានភាពលើបណ្តាញ","theme-color-tertiary-background-color":"ផ្ទៃខាងក្រោយឧត្តមសិក្សា","theme-color-tertiary-font-color":"ឧត្តមសិក្សាល័ពុម្ពអក្សរ","theme-color-unread-notification-color":"មិនទាន់អាន​​ Color ជូនដំណឹង","theme-custom-css":"CSS ផ្ទាល់ខ្លួន","There_are_no_agents_added_to_this_department_yet":"មានភ្នាក់ងារបានបន្ថែមទៅនាយកដ្ឋាននេះនៅឡើយទេ។","There_are_no_integrations":"មានរួមបញ្ចូលទេ","There_are_no_users_in_this_role":"មានអ្នកប្រើប្រាស់នៅក្នុងតួនាទីនេះទេ។","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"អ៊ីមែលនេះត្រូវបានប្រើរួចទៅហើយហើយមិនត្រូវបានផ្ទៀងផ្ទាត់។ សូមផ្លាស់ប្តូរពាក្យសម្ងាត់របស់អ្នក។","This_is_a_desktop_notification":"នេះគឺជាការជូនដំណឹងផ្ទៃតុ","This_is_a_push_test_messsage":"នេះគឺជាការធ្វើតេស្តការជំរុញ messsage","Time_in_seconds":"ពេលវេលានៅក្នុងវិនាទី","Title_bar_color":"ប៍នរបារចំណងជើង","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"ដើម្បីដំឡើង Rocket.Chat Livechat នៅក្នុងគេហទំព័ររបស់អ្នក, ចម្លងនិងបិទភ្ជាប់កូដខាងលើ <strong></ body></strong> tag ចុងក្រោយនៅលើតំបន់បណ្ដាញរបស់អ្នកនេះ។","To_users":"ដល់អ្នកប្រើ","Topic":"ប្រធានបទ","Travel_and_Places":"ទេសចរណ៍និងកន្លែង","Trigger_removed":"គន្លឹះយកចេញ","Trigger_Words":"ពាក្យគន្លឹះ","Triggers":"ដែលបង្កឱ្យកើត","True":"ពិត","Type":"ប្រភេទ","Type_your_new_password":"បញ្ចូលពាក្យសម្ងាត់ថ្មីរបស់អ្នក","Unarchive":"ទុកក្នុងប័ណ្ណសារ","Unmute_someone_in_room":"នរណាម្នាក់បើកសំឡេងនៅក្នុងបន្ទប់នេះ","Unmute_user":"អ្នកប្រើបើកសំឡេង","Unnamed":"គ្មាន​ឈ្មោះ","Unpin_Message":"សារមិនខ្ទាស់","Unread_Rooms":"បន្ទប់​ដែល​មិនទាន់​អាន","Unread_Rooms_Mode":"របៀប​បន្ទប់​ដែល​មិនទាន់​អាន","Unstar_Message":"ដាកផ្កាយចេញ","Upload_file_question":"ផ្ទុក​ឯកសារ​ឡើង​ឬ?","Uploading_file":"ផ្ទុកឯកសារ ...","Use_account_preference":"ប្រើចំណង់ចំណូលចិត្តគណនី","Use_Emojis":"ប្រើ Emoji","Use_initials_avatar":"ប្រើឈ្មោះ​អ្នក​ជា​ពិសេស","use_menu":"ប្រើប្រាស់​ផ្ទាំង​នៅ​សង​ខាង​ដើម្បី​ចូល​ទៅ​កាន់បន្ទប់ និង​ពិភាក្សា","Use_service_avatar":"ប្រើ %s រូប","Use_this_username":"ប្រើ​ឈ្មោះ​នេះ","Use_uploaded_avatar":"ប្រើ​រូប​បាន​ផ្ទុក​ឡើង","Use_url_for_avatar":"ប្រើប្រាស់ URL សម្រាប់ Avatar","User__username__is_now_a_moderator_of__room_name_":"__username__ ឥឡូវនេះគឺជាអ្នកសម្របសម្រួលរបស់អ្នកប្រើការ __room_name__ មួយ","User__username__is_now_a_owner_of__room_name_":"__username__ ឥឡូវនេះគឺជាម្ចាស់របស់អ្នកប្រើការ __room_name__ មួយ","User__username__removed_from__room_name__moderators":"__username__ អ្នកប្រើយកចេញពីល្មម __room_name__","User__username__removed_from__room_name__owners":"__username__ អ្នកប្រើយកចេញពីម្ចាស់ __room_name__","User_added":"អ្នក​ប្រើ <em>__user_added__</em> បាន​បន្ថែម","User_added_by":"អ្នក​ប្រើ <em>__user_added__</em> បាន​ថែម​ដោយ <em>__user_by__</em>.","User_added_successfully":"អ្នកប្រើដែលបានបន្ថែមដោយជោគជ័យ","User_Channels":"ប៉ុស្តិ៍អ្នកប្រើប្រាស់","User_doesnt_exist":"គ្មានអ្នកប្រើដែលមានឈ្មោះរបស់ `@ %s` ឡើយ។","User_has_been_activated":"អ្នក​ប្រើ​ដែល​បាន​ធ្វើ​ឱ្យ​សកម្ម","User_has_been_deactivated":"អ្នក​ប្រើ​ដែល​ត្រូវ​បាន​ធ្វើ​ឱ្យ​អសកម្ម","User_has_been_deleted":"អ្នក​ប្រើប្រាស់​ដែល​បាន​លប់","User_has_been_muted_in_s":"អ្នកប្រើត្រូវបានស្ងាត់នៅក្នុង %s","User_has_been_removed_from_s":"អ្នកប្រើត្រូវបានយកចេញពី %s","User_has_disconnected":"អ្នកប្រើបានផ្ដាច់","User_Info":"ព័ត​មាន​របស់​អ្នក​ប្រើ","User_is_no_longer_an_admin":"អ្នក​ប្រើប្រាស់​​គឺ​មិន​មែន​ជា​អ្នក​គ្រប់គ្រង​ទៀត​ទេ","User_is_not_activated":"អ្នក​ប្រើ​ដែល​មិន​ត្រូវ​បាន​ធ្វើ​ឱ្យ​សកម្ម","User_is_now_an_admin":"បច្ចុប្បន្ន​អ្នក​ប្រើប្រាស់​គឺ​ជា​អ្នក​គ្រប់គ្រង","User_joined_channel":"បាន​ចូល​រួម​ប៉ុស្តិ៍","User_joined_channel_female":"បាន​ចូល​រួម​ប៉ុស្តិ៍","User_joined_channel_male":"បាន​ចូល​រួម​ប៉ុស្តិ៍","User_left":"អ្នក​ប្រើ <em>__user_left__</em> បានចេញ","User_left_female":"អ្នក​ប្រើ <em>__user_left__</em> បាន​ចេញ","User_left_male":"អ្នក​ប្រើ <em>__user_left__</em> បាន​ចេញ","User_logged_out":"អ្នក​ប្រើបាន​ចាកចេញ","User_management":"គ្រប់គ្រងអ្នកប្រើ","User_muted_by":"<em>__user_muted__</em> អ្នកប្រើស្ងាត់ដោយ <em>__user_by__</em> ។","User_muted_in_room":"ស្ងាត់នៅក្នុងបន្ទប់របស់អ្នកប្រើ","User_not_found":"រកមិនឃើញអ្នកប្រើ","User_not_found_or_incorrect_password":"អ្នកប្រើប្រាស់ឬពាក្យសម្ងាត់មិនត្រឹមត្រូវ","User_or_channel_name":"ឈ្មោះអ្នកប្រើឬឆានែល","User_removed":"អ្នកប្រើដែលបានយកចេញ","User_removed_by":"អ្នក​ប្រើ <em>__user_removed__</em> បាន​ដក​ចេញ​ដោយ <em>__user_by__</em>.","User_removed_from_room":"អ្នកប្រើត្រូវបានយកចេញពីបន្ទប់","User_Settings":"ការ​កំណត់​របស់​អ្នក​ប្រើ","User_unmuted_by":"<em>__user_unmuted__</em> អ្នកប្រើដំណឹងដោយ <em>__user_by__</em> ។","User_unmuted_in_room":"បើកសំឡេងនៅក្នុងបន្ទប់របស់អ្នកប្រើ","User_updated_successfully":"អ្នក​ប្រើប្រាស់​បាន​កែ​សម្រួល​ដោយ​ជោគជ័យ","Username":"ឈ្មោះ​សម្ងាត់","Username_and_message_must_not_be_empty":"ឈ្មោះអ្នកប្រើនិងសារត្រូវតែមិនទទេ។","Username_cant_be_empty":"ឈ្មោះ​សម្ងាត់​មិនអាចទទេ","Username_Change_Disabled":"សិទ្ធជាអ្នកគ្រប់គ្រង Rocket.Chat ត្រូវបានបិទមិនឲ្យប្តូរឈ្មោះអ្នកប្រើប្រាស់ឡើយ","Username_denied_the_OTR_session":"__username__ បដិសេធសម័យប្រវត្តិ","Username_description":"ឈ្មោះ​សម្ងាត់​បាន​អនុញ្ញាត់​ឲ្យ​អ្នក​ផ្សេង​ដាក់​ស្លាក​ឈ្មោះ​អ្នក​","Username_doesnt_exist":"ឈ្មោះអ្នកប្រើ ` %s` មិនមានទេ។","Username_ended_the_OTR_session":"__username__ បាន​​បញ្ចប់សម័យប្រជុំប្រវត្តិ","Username_invalid":"<strong>%s</strong> គឺ​ជា​ឈ្មោះ​សម្ងាត់​មិន​ត្រឹម​ត្រូវ,<br/> ព្រោះ​អ្នក​អាច​ប្រើបាន​តែ​តួរ​អក្សរ, លេខ, ចុច និង ដក","Username_is_already_in_here":"`@ %s` គឺមាននៅទីនេះរួចទៅហើយ។","Username_is_not_in_this_room":"អ្នកប្រើ `# %s` គឺមិននៅក្នុងបន្ទប់នេះ។","Username_not_found":"រកមិនឃើញឈ្មោះអ្នកប្រើ","Username_title":"ចុះ​ឈ្មោះ​សម្ងាត់","Username_unavaliable":"<strong>%s</strong> គឺ​បាន​ប្រើហើយ :(","Username_wants_to_start_otr_Do_you_want_to_accept":"ការចាប់ផ្តើមចង់ធ្វើឱ្យ __username__ ប្រវត្តិ។ តើអ្នកចង់ទទួលយក?","Users":"អ្នក​ប្រើ​ប្រាស់","Users_in_role":"អ្នកប្រើនៅក្នុងតួនាទី","UTF8_Names_Slugify":"ឈ្មោះក្រៅ UTF8 Slugify","UTF8_Names_Validation":"ឈ្មោះក្រៅ UTF8 សុពលភាព","UTF8_Names_Validation_Description":"មិនអនុញ្ញាតឱ្យតួអក្សរពិសេសនិងចន្លោះ។ អ្នកអាចប្រើ - _ និង។ ប៉ុន្តែមិននៅចុងបញ្ចប់នៃឈ្មោះនេះ","Verification_email_sent":"ការផ្ទៀងផ្ទាត់អ៊ីមែលផ្ញើ","View_All":"មើល​ទាំង​អស់","View_Logs":"មើលកំណត់ហេតុ","Visibility":"ភាពមើលឃើញ","Visible":"ដែលអាចមើលឃើញ","Visitor":"ចំនួនអ្នកទស្សនា","Visitor_page_URL":"URL របស់ទំព័រអ្នកទស្សនា","Visitor_time_on_site":"ពេលដែលអ្នកទស្សនានៅលើគេហទំព័រ","Wait_activation_warning":"មុន​ពេល​ចូល​ប្រើប្រាស់​គណនី​អ្នក​ត្រូវ​តែ​ទទួល​បាន​ការ​អនុញ្ញាតិ​ពី​អ្នក​គ្រប់​គ្រង​ជាមុន​សិន​","We_are_offline_Sorry_for_the_inconvenience":"យើងមាននៅក្រៅបណ្ដាញ។ សូមអភ័យទោសចំពោះការរំខាននេះ។","We_have_sent_password_email":"យើងបាន​ផ្ញើរ​អ៊ីមែល​ជាមួយ​លំណែនាំ​ក្នុង​ការ​ប្តូរ​ឃ្លា​សម្ងាត់។ ប្រសិន​បើ​អ្នក​មិន​បាន​ទទួល​អ៊ី​មែល​ទេ​សូម​រួស​រាន់​មក​ទីនេះ​ ដើម្បី​ធ្វើ​វា​ម្តង​ទៀត​។","We_have_sent_registration_email":"យើង​បាន​ផ្ញើរ​អ៊ីមែល​មួយ​ទៅ​អ្នក​ដើម្បី​បញ្ជាក់​ការ​បាន​ចុះ​ឈ្មោះ​។ ប្រសិន​បើ​អ្នក​មិន​បាន​ទទួល​អ៊ី​មែល​ទេ​សូម​រួស​រាន់​មក​ទីនេះ​ ដើម្បី​ធ្វើ​វា​ម្តង​ទៀត​។","WebRTC_Enable_Channel":"អនុញ្ញាតិគ្រប់ប៉ុស្តិ៍សាធារណ","WebRTC_Enable_Direct":"អនុញ្ញតិសារផ្ទាល់","WebRTC_Enable_Private":"អនុញ្ញាតិគ្រប់ប៉ុស្តិ៍ឯកជន","WebRTC_Servers":"ម៉ាស៊ីនបម្រើ STUN / TURN","WebRTC_Servers_Description":"បញ្ជីនៃម៉ាស៊ីនបម្រើ STUN និងបើកបំបែកដោយសញ្ញាក្បៀស។ <br/> ឈ្មោះអ្នកប្រើពាក្យសម្ងាត់និងកំពង់ផែត្រូវបានអនុញ្ញាតនៅក្នុងទ្រង់ទ្រាយ `ឈ្មោះអ្នកប្រើ: ពាក្យសម្ងាត់ @ STUN: ម៉ាស៊ីន: port` ឬ` ឈ្មោះអ្នកប្រើ: ពាក្យសម្ងាត់ @ វេន: ម៉ាស៊ីន: port` ។","Welcome":"ស្វាគមន៍ <em>%s</em>.","Welcome_to_the":"ស្វាគមន៍​មក​កាន់","will_be_able_to":"នឹងអាច","With_whom":"ជា​មួយ​នរណា","Yes":"បាទ","Yes_clear_all":"បាទ, សម្អាតចោលទាំងអស់","Yes_delete_it":"បាទ លប់​វា!","Yes_hide_it":"បាទ, លាក់វា!","Yes_leave_it":"បាទទុកវា!","Yes_mute_user":"បាទ, អ្នកប្រើគ!","Yes_remove_user":"បាទ, យកអ្នកប្រើ!","you_are_in_preview_mode_of":"អ្នក​ស្ថិត​ក្នុង​ទម្រង់​មើល​ជា​មុន​នៃ​ប៉ុស្តិ៍ #<strong>__room_name__</strong>","You_are_logged_in_as":"អ្នកត្រូវបានចូលជា","You_are_not_authorized_to_view_this_page":"អ្នក​មិន​ត្រូវ​បាន​អនុញ្ញាត​ឱ្យ​មើល​ទំព័រ​នេះ​។","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"អ្នកគឺជាម្ចាស់ចុងក្រោយ។ សូមកំណត់ម្ចាស់ថ្មីមុនពេលចាកចេញពីបន្ទប់។","You_can_change_a_different_avatar_too":"អ្នកអាចបដិសេធរូបតំនាងដែលត្រូវបានប្រើដើម្បីប្រកាសពីការធ្វើសមាហរណកម្មនេះ។","You_can_use_an_emoji_as_avatar":"អ្នកអាចប្រើរូបអារម្មណ៍មួយដែលជារូបតំនាងមួយ។","You_have_been_muted":"អ្នកត្រូវបានស្ងាត់និងមិនអាចនិយាយក្នុងបន្ទប់នេះ","You_have_not_verified_your_email":"អ្នកមិនបានផ្ទៀងផ្ទាត់អ៊ីមែលរបស់អ្នក។","You_have_successfully_unsubscribed":"អ្នក​បាន unsubscribed ដោយ​ជោគជ័យ​ពី​បញ្ជី Mailling របស់​យើង​។","You_informed_an_invalid_FROM_address":"អ្នកបានបំពេញមិនត្រឹមត្រូវក្នុងចន្លោះ FROM អាស័យដ្ឋាន","You_must_provide_the_unsubscribe_link":"អ្នកត្រូវតែផ្ដល់តំណភ្ជាប់ [unsubscribe] ។","You_need_confirm_email":"អ្នក​ត្រូវ​បញ្ជាក់អ៊ីមែល​ដើម្បី​ឡុកចូល!","You_need_install_an_extension_to_allow_screen_sharing":"អ្នកត្រូវការដំឡើងផ្នែកបន្ថែមមួយដើម្បីអនុញ្ញាតឱ្យចែករំលែកអេក្រង់","You_need_to_change_your_password":"អ្នកត្រូវការដើម្បីផ្លាស់ប្តូរពាក្យសម្ងាត់របស់អ្នក","You_need_to_type_in_your_password_in_order_to_do_this":"អ្នកត្រូវវាយពាក្យសម្ងាត់របស់អ្នកដើម្បីធ្វើការនេះ!","You_need_to_type_in_your_username_in_order_to_do_this":"អ្នកត្រូវវាយនៅក្នុងឈ្មោះអ្នកប្រើរបស់អ្នកដើម្បីធ្វើការនេះ!","You_need_to_verifiy_your_email_address_to_get_notications":"អ្នកត្រូវការដើម្បី verifiy អាសយដ្ឋានអ៊ីមែលរបស់អ្នកដើម្បីទទួលបានការជូនដំណឹង","You_should_name_it_to_easily_manage_your_integrations":"អ្នកគួរតែដាក់ឈ្មោះវាដើម្បីគ្រប់គ្រងការរួមបញ្ចូលរបស់អ្នកបានយ៉ាងងាយស្រួល។","You_will_not_be_able_to_recover":"អ្នក​នឹង​មិនអាច​ទាញ​មក​វិញ!","You_will_not_be_able_to_recover_file":"អ្នកនឹងមិនអាចងើបឡើងវិញឯកសារនេះ!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"អ្នកនឹងមិនទទួលបានការជូនដំណឹងតាមអ៊ីមែលទេព្រោះអ្នកមិនបានផ្ទៀងផ្ទាត់អ៊ីមែលរបស់អ្នក។","Your_email_has_been_queued_for_sending":"អ៊ីម៉ែលរបស់អ្នកត្រូវបានដាក់ជាជួរសម្រាប់ផ្ញើ","Your_entry_has_been_deleted":"ការ​បញ្ចូល​អ្នក​បាន​លប់","Your_file_has_been_deleted":"ឯកសាររបស់អ្នកត្រូវបានលុបចោល។","Your_mail_was_sent_to_s":"សំបុត្ររបស់អ្នកត្រូវបានបញ្ជូនទៅកាន់ %s","Your_Open_Source_solution":"ដំណោះ​ស្រាយ​ពិភាក្សាកូដ​ចំហរ​របស់​អ្នក","Your_password_is_wrong":"ពាក្យសម្ងាត់របស់អ្នកគឺខុស!","Your_push_was_sent_to_s_devices":"ការជំរុញរបស់អ្នកត្រូវបានបញ្ជូនទៅកាន់ឧបករណ៍ %s បាន"});
TAPi18n._registerServerTranslator("km", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ko.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ko"] = ["Korean","한국어"];                                                                      // 8
if(_.isUndefined(TAPi18n.translations["ko"])) {                                                                        // 9
  TAPi18n.translations["ko"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ko"][namespace])) {                                                             // 13
  TAPi18n.translations["ko"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ko"][namespace], {"500":"인터넷 서버 오류","0_Errors_Only":"0 - 오류 만","1_Errors_and_Information":"1 - 오류 및 정보","2_Erros_Information_and_Debug":"2 - Erros, 정보 및 디버그","__username__was_set__role__by__user_by_":"__ 사용자 이름 __은 __user_by__에 의해 __role__ 설정했다","__username__is_no_longer__role__defined_by__user_by_":"__ 사용자 이름 __는 __user_by__에 의해, __role__ 더 이상 없다","Access_not_authorized":"액세스 권한이 없습니다","Access_online_demo":"온라인 데모 접속","Access_Online_Demo":"온라인 데모 접속","Access_Token_URL":"액세스 토큰 URL","Accounts":"계정","Accounts_AllowDeleteOwnAccount":"사용자가 자신의 계정을 삭제할 수","Accounts_AllowedDomainsList":"허용 가능한 도메인 목록","Accounts_AllowedDomainsList_Description":"허용 도메인의 쉼표로 구분 된 목록","Accounts_AllowEmailChange":"E 메일 변경을 허용","Accounts_AllowPasswordChange":"암호 변경 허용","Accounts_AllowUserAvatarChange":"사용자 아바타 변경을 허용","Accounts_AllowUsernameChange":"사용자 이름 변경 허용","Accounts_AllowUserProfileChange":"사용자 프로필 변경을 허용","Accounts_AvatarResize":"아바타 크기 조정","Accounts_AvatarSize":"아바타 크기","Accounts_AvatarStorePath":"아바타 저장 경로","Accounts_AvatarStoreType":"아바파 저장 타입","Accounts_BlockedDomainsList":"차단 된 도메인 목록","Accounts_BlockedDomainsList_Description":"차단 된 도메인의 쉼표로 구분 된 목록","Accounts_denyUnverifiedEmail":"확인되지 않은 이메일 거부","Accounts_EmailVerification":"이메일 확인","Accounts_EmailVerification_Description":"당신이이 기능을 사용하려면 올바른 SMTP 설정이 있는지 확인","Accounts_Enrollment_Email":"등록한 이메일","Accounts_Enrollment_Email_Description":"당신은 각각 사용자의 전체 이름, 이름 또는 성을 위해 [LNAME], [이름], [FNAME]을 사용할 수 있습니다. <br /> 당신은 사용자의 이메일을 [메일]을 사용할 수 있습니다.","Accounts_Iframe_api_method":"API 메소드","Accounts_Iframe_api_url":"API를 URL","Accounts_iframe_enabled":"사용","Accounts_iframe_url":"iframe이 URL","Accounts_LoginExpiration":"일에 로그인 만료","Accounts_ManuallyApproveNewUsers":"수동으로 새로운 사용자 승인","Accounts_OAuth_Custom_Token_Sent_Via":"토큰 보낸 비아","Accounts_OAuth_Custom_Authorize_Path":"Authorize 경로","Accounts_OAuth_Custom_Button_Color":"버튼 색","Accounts_OAuth_Custom_Button_Label_Color":"버튼 텍스트 색","Accounts_OAuth_Custom_Button_Label_Text":"버튼 텍스트","Accounts_OAuth_Custom_Enable":"사용 가능","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity 경로","Accounts_OAuth_Custom_Login_Style":"로그인 스타일","Accounts_OAuth_Custom_Secret":"비밀","Accounts_OAuth_Custom_Token_Path":"Token 경로","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook 로그인","Accounts_OAuth_Facebook_callback_url":"페이스 북 콜백 URL","Accounts_OAuth_Facebook_id":"Facebook 앱 ID","Accounts_OAuth_Facebook_secret":"Facebook 암호","Accounts_OAuth_Github":"Github 로그인","Accounts_OAuth_Github_callback_url":"GitHub의 콜백 URL","Accounts_OAuth_GitHub_Enterprise":"OAuth 활성화","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub의 기업 콜백 URL","Accounts_OAuth_GitHub_Enterprise_id":"Client ID","Accounts_OAuth_GitHub_Enterprise_secret":"Client 암호","Accounts_OAuth_Github_id":"Github ID","Accounts_OAuth_Github_secret":"Github 암호","Accounts_OAuth_Gitlab":"OAuth 활성화","Accounts_OAuth_Gitlab_callback_url":"GitLab 콜백 URL","Accounts_OAuth_Gitlab_id":"GitLab ID","Accounts_OAuth_Gitlab_secret":"Client 암호","Accounts_OAuth_Google":"구글 로그인","Accounts_OAuth_Google_callback_url":"구글 콜백 URL","Accounts_OAuth_Google_id":"구글 ID","Accounts_OAuth_Google_secret":"구글 암호","Accounts_OAuth_Linkedin":"LinkedIn 로그인","Accounts_OAuth_Linkedin_callback_url":"링크드 인 콜백 URL","Accounts_OAuth_Linkedin_id":"LinkedIn ID","Accounts_OAuth_Linkedin_secret":"LinkedIn 암호","Accounts_OAuth_Meteor":"Meteor 로그인","Accounts_OAuth_Meteor_callback_url":"유성 콜백 URL","Accounts_OAuth_Meteor_id":"Meteor ID","Accounts_OAuth_Meteor_secret":"Meteor 암호","Accounts_OAuth_Twitter":"트위터 로그인","Accounts_OAuth_Twitter_callback_url":"트위터 콜백 URL","Accounts_OAuth_Twitter_id":"트위터 ID","Accounts_OAuth_Twitter_secret":"트위터 암호","Accounts_OAuth_Wordpress":"WordPress 로그인","Accounts_OAuth_Wordpress_callback_url":"워드 프레스 콜백 URL","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"WordPress 암호","Accounts_PasswordReset":"암호 재설정","Accounts_Registration_AuthenticationServices_Enabled":"인증 서비스에 등록","Accounts_RegistrationForm":"등록 양식","Accounts_RegistrationForm_Disabled":"비활성화","Accounts_RegistrationForm_LinkReplacementText":"등록 양식 링크 대체 텍스트","Accounts_RegistrationForm_Public":"공개","Accounts_RegistrationForm_Secret_URL":"비밀 URL","Accounts_RegistrationForm_SecretURL":"등록 양식 비밀 URL","Accounts_RegistrationForm_SecretURL_Description":"당신은 당신의 등록 URL에 추가됩니다 임의의 문자열을 제공해야합니다. 예 : https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"등록시 필수","Accounts_RequireNameForSignUp":"회원 가입은 이름 필요","Accounts_ShowFormLogin":"보기 양식 기반 로그인","Accounts_UseDefaultBlockedDomainsList":"기본값 사용 차단 된 도메인 목록","Accounts_UseDNSDomainCheck":"DNS 도메인 확인을 사용하여","Activate":"활성화","Activity":"활동","Add":"추가","Add_agent":"에이전트를 추가","Add_custom_oauth":"사용자 정의 OAuth 추가","Add_manager":"관리자 추가","Add_Members":"멤버 추가","Add_User":"사용자 추가","Add_user":"사용자 추가","Add_users":"사용자 추가","Additional_emails":"추가 E - 메일","Additional_Feedback":"추가 의견","Administration":"관리","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2를 인증 한 후, 사용자는이 URL로 리디렉션됩니다","Agent_added":"에이전트는 추가","Agent_removed":"에이전트 제거","Alias":"별명","All":"모든","All_channels":"모든 채널","All_logs":"모든 로그","All_messages":"모든 메시지","Allow_Invalid_SelfSigned_Certs":"잘못된 Self-Signed Certs 허용","Allow_Invalid_SelfSigned_Certs_Description":"링크 확인 및 미리보기 무효 및 자체 서명 된 SSL 인증서의 허용.","and":"그리고","And_more":"그리고 더 __length __...","Animals_and_Nature":"동물과 자연","API":"API","API_Analytics":"분석","API_Embed":"포함","API_EmbedDisabledFor":"사용자에대한 Embed 비활성화","API_EmbedDisabledFor_Description":"쉼표로 구분된 사용자 이름 목록","API_GitHub_Enterprise_URL":"Server URL","API_GitHub_Enterprise_URL_Description":"예: http://domain.com (마지막 슬래시 제외)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"외관","Application_added":"응용 프로그램 추가","Application_Name":"응용 프로그램 이름","Application_updated":"응용 프로그램 업데이트","Apply_and_refresh_all_clients":"적용하고 모든 클라이언트를 새로 고침","Archive":"아카이브","Archive_Unarchive":"보관 / 보관 취소","are_also_typing":"또한 입력중","are_typing":"입력 중","Are_you_sure":"괜찮아요?","Are_you_sure_you_want_to_delete_your_account":"당신은 당신의 계정을 삭제 하시겠습니까?","Authorization_URL":"인증 URL","Authorize":"권한 부여","AutoLinker_StripPrefix":"AutoLinker 스트립 접두사","AutoLinker_StripPrefix_Description":"짧은 표시됩니다. 예를 들어 https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker의 URL","AutoLinker_UrlsRegExp":"AutoLinker URL 정규 표현식","AutoLinker_Email":"AutoLinker 이메일","AutoLinker_Phone":"AutoLinker 전화","AutoLinker_Phone_Description":"자동으로 전화 번호를 연결. 예를 들어`(123) 456-7890`","Auto_Load_Images":"이미지 자동 로드","Available":"유효한","Available_agents":"사용 가능한 에이전트","Avatar":"아바타 변경","Avatar_changed_successfully":"아바타를 성공적으로 변경하였습니다","Avatar_URL":"아바타 URL","Avatar_url_invalid_or_error":"지정된 URL이 잘못되었거나 접근할 수 없습니다. 다른 URL로 다시 시도하세요.","away":"자리비움","Away":"자리비움","away_female":"자리비움","Away_female":"자리비움","away_male":"자리비움","Away_male":"자리비움","Back":"뒤로","Back_to_applications":"다시 응용 프로그램","Back_to_integrations":"위로 통합에","Back_to_login":"로그인으로 돌아가기","Back_to_permissions":"돌아 가기 권한","Body":"신체","bold":"굵게","busy":"바쁨","Busy":"바쁨","busy_female":"바쁨","Busy_female":"바쁨","busy_male":"바쁨","Busy_male":"바쁨","Cancel":"취소","Cannot_delete_a_protected_role":"보호 역할을 삭제할 수 없습니다","Cannot_delete_role_because_its_in_use":"그것이 사용 때문에 역할을 삭제할 수 없습니다","Cannot_invite_users_to_direct_rooms":"객실을 지시하는 사용자를 초대 할 수 없습니다","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"인증서와 키","Channel":"채널","Channel_doesnt_exist":"`#%s` 채널이 존재하지 않습니다.","Channels":"채널","Channels_list":"공개 채널 리스트","Chat_Rooms":"채팅방","Chatops_Enabled":"Cahtops 사용","Chatops_Title":"Chatops 패널","Chatops_Username":"Chatops 사용자 이름","Choose_a_room":"방을 선택","Choose_messages":"메시지를 선택","Choose_the_alias_that_will_appear_before_the_username_in_messages":"메시지에 사용자 이름 앞에 나타납니다 별칭을 선택합니다.","Choose_the_username_that_this_integration_will_post_as":"이 통합으로 게시 할 예정 사용자 이름을 선택합니다.","Clear_all_unreads_question":"읽지 않은 메시지를 삭제합니까?","Client_ID":"클라이언트 ID","Client_Secret":"클라이언트 비밀","Clients_will_refresh_in_a_few_seconds":"클라이언트는 몇 초에 새로 고쳐집니다","close":"닫기","Closed":"닫은","Collapse_Embedded_Media_By_Default":"기본적으로 포함 된 미디어 축소","coming_soon":"곧","Commands":"명령","Compact_View":"축소해 보기","Confirm_password":"암호를 확인하세요","Contact":"접속","Conversation":"대화","Convert_Ascii_Emojis":"이모지를 ASCII로 변환","Copied":"복사","COPY_TO_CLIPBOARD":"클립 보드에 복사","Copy_to_clipboard":"클립 보드에 복사","Count":"카운트","Create":"몹시 떠들어 대다","Create_new":"새로 만들기","Created_at":"제작","Created_at_s_by_s":"<strong> %s에</strong> 의해 <strong> %s로</strong> 만든","Custom_Fields":"사용자 정의 필드","Custom_oauth_helper":"OAuth Provider를 설정할때, 콜백 URL을 알려줘야합니다. <pre>%s</pre>를 사용.","Custom_oauth_unique_name":"사용자 정의 OAuth 고유한 이름","Custom_Script_Logged_In":"사용자 정의 스크립트 로그인 한 사용자를 위해","Custom_Script_Logged_Out":"사용자 정의 스크립트 로그 아웃 사용자를위한","Dashboard":"계기반","days":"일","Deactivate":"비활성화","Debug_Level":"디버그 수준","Default":"태만","Delete":"삭제","Delete_my_account":"내 계정 삭제","Delete_Room_Warning":"방을 삭제하면 모든 메시지가 삭제됩니다. 이 작업은 취소할 수 없습니다.","Delete_User_Warning":"사용자 삭제시 사용자의 모든 메시지를 삭제합니다. 취소할 수 없습니다.","Deleted":"삭제!","Department_not_found":"부서를 찾을 수 없습니다","Department_removed":"학과 제거","Departments":"부서","Description":"설명","Desktop":"바탕 화면","Desktop_Notification_Test":"바탕 화면 알림 테스트","Desktop_Notifications":"바탕화면 알림","Desktop_Notifications_Disabled":"바탕화면 알림이 비활성화 되었습니다. 활성화 하려면 설정을 변경하세요.","Desktop_Notifications_Enabled":"바탕화면 알림 활성화","Direct_message_someone":"직접 메시지 사람","Direct_Messages":"귓속말","Direct_Messages_list":"직접 메시지","Disable_Favorite_Rooms":"즐겨찾기 사용안함","Disable_New_Message_Notification":"새 메시지 알림 비활성화","Disable_New_Room_Notification":"새 방 알림 비활성화","Displays_action_text":"표시 액션 텍스트","Do_you_want_to_change_to_s_question":"<strong>%s</strong>으로 변경합니까?","Drop_to_upload_file":"업로드할 파일 드롭","Dry_run":"드라","Dry_run_description":"단지에서와 같은 주소로 하나의 이메일을 보내드립니다. 이메일은 유효한 사용자에 속해야합니다.","Duplicate_archived_channel_name":"보관 된 채널 이름 ' %s'이 (가) 존재","Duplicate_archived_private_group_name":"이름 ' %s는'존재로 보관 된 개인 그룹","Duplicate_private_group_name":"'%s'는 이미 존재하는 비밀 그룹입니다.","E-mail":"이메일","Edit":"수정","Edit_Custom_Field":"편집 사용자 정의 필드","Edit_Department":"편집 부서","edited":"수정됨","Email":"이메일","Email_already_exists":"이메일이 이미 존재합니다","Email_body":"이메일 본문","Email_Change_Disabled":"당신의 Rocket.Chat 관리자는 이메일의 변화를 사용할 수있다","Email_from":"보내는 이","Email_Notification_Mode":"오프라인 전자 메일 알림","Email_Notification_Mode_All":"모든 언급 / DM","Email_Notification_Mode_Disabled":"장애인","Email_or_username":"이메일 또는 사용자 이름","Email_subject":"제목","Email_verified":"Email 확인","Emoji":"Emoji","Empty_title":"빈 제목","Enable":"사용","Enable_Desktop_Notifications":"바탕화면 알림 활성화","Enabled":"사용","Encrypted_message":"암호화 된 메시지","End_OTR":"최종 OTR","Enter_a_regex":"정규식을 입력","Enter_a_room_name":"방 이름을 입력합니다","Enter_a_username":"사용자 이름 입력","Enter_info":"로그인 정보를 입력하세요","Enter_name_here":"여기에 이​​름을 입력합니다","Enter_to":"Enter to","Error":"오류","error-cant-invite-for-direct-room":"직접 객실에 대한 사용자를 초대 할 수 없습니다","error-duplicate-channel-name":"'%s' 채널 이름은 이미 존재합니다.","error-invalid-custom-field":"잘못된 사용자 정의 필드","error-invalid-custom-field-name":"잘못된 사용자 정의 필드 이름입니다. 문자, 숫자, 하이픈 및 밑줄을 사용합니다.","error-invalid-password":"유효하지 않은 비밀번호","error-invalid-room":"잘못된 방","error-invalid-room-name":"<strong> %s은 (는)</strong> 유효한 방 이름이 아닙니다, <br/> 문자, 숫자, 하이픈 및 밑줄을 사용하여","error-invalid-user":"잘못된 사용자","error-invalid-username":"잘못된 사용자 이름","error-not-allowed":"허용되지 않음","error-not-authorized":"권한이 없습니다","error-remove-last-owner":"이 마지막 소유자입니다. 이 중 하나를 제거하기 전에 새 소유자를 설정하십시오.","error-role-name-required":"역할 이름이 필요합니다","error-user-not-in-room":"사용자는이 방에없는","Error_changing_password":"암호 변경 중 오류 발생","Error_sending_confirmation_email":"오류 확인 이메일을 보내","Error_too_many_requests":"너무 많은 요청으로 에러발생. 천천히 하세요. %s 초 이후 입력할 수 있습니다","Esc_to":"Esc to","Example_s":"예 : <code class=\"inline\">%s</code>","False":"False","Favorites":"즐겨찾기","Field":"들","Field_removed":"이 필드를 제거","File_exceeds_allowed_size_of_bytes":"파일 __size__ 바이트의 허용 크기를 초과","FileUpload":"파일 업로드","FileUpload_Enabled":"파일 업로드 활성화","FileUpload_File_Empty":"빈 파일","FileUpload_FileSystemPath":"시스템 경로","FileUpload_MaxFileSize":"파일 업로드 최대 크기 (바이트 단위)","FileUpload_MediaType_NotAccepted":"미디어 유형은 허용되지 않음","FileUpload_MediaTypeWhiteList":"허용 가능한 미디어 타입","FileUpload_MediaTypeWhiteListDescription":"쉼표로 구분된 미디어 타입 목록","FileUpload_ProtectFiles":"업로드 된 파일을 보호","FileUpload_ProtectFilesDescription":"인증 된 사용자 만 액세스 할 수 있습니다","FileUpload_S3_Acl":"아마존 S3의 ACL","FileUpload_S3_AWSAccessKeyId":"아마존 S3 A​​WSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"아마존 S3 A​​WSSecretAccessKey","FileUpload_S3_Bucket":"아마존 S3 버킷 이름","FileUpload_S3_BucketURL":"버킷 URL","FileUpload_S3_CDN":"다운로드 CDN 도메인","FileUpload_S3_Region":"부위","FileUpload_Storage_Type":"저장 유형","Flags":"플래그","Follow_social_profiles":"소셜 프로파일에 따라주십시오. Github에서 포크하고, 우리의 trello 보드에서 rocket.chat app에대한 의견을 공유합니다.","Food_and_Drink":"음식 및 음료","For_your_security_you_must_re_enter_your_password_to_continue":"보안을 위해, 당신은 계속하려면 암호를 다시 입력해야합니다","Force_SSL":"포스 SSL","Force_SSL_Description":"*주의 * _Force SSL_가 역방향 프록시로 사용해서는 안됩니다. 당신이 리버스 프록시가있는 경우, 당신은 거기 리디렉션을 수행해야합니다. 이 옵션은 역방향 프록시에서 리디렉션 구성을 허용하지 않습니다 Heroku를 같은 배치를 위해 존재한다.","Forgot_password":"암호를 잊었습니다","Fork_it_on_github":"Github에서 포크","Frequently_Used":"자주 사용하는","From":"에서","From_Email":"이메일에서","From_email_is_required":"이메일이 필요합니다","From_email_warning":"<b>경고</b> <b>:에서</b> 필드가 메일 서버 설정이 적용됩니다.","General":"일반","Get_to_know_the_team":"Rocket.Team 알아보기","github_no_public_email":"Github 계정에 공개된 이메일이 없습니다.","Give_a_unique_name_for_the_custom_oauth":"사용자 정의 OAuth에 대한 고유 이름 지정","Give_the_application_a_name_This_will_be_seen_by_your_users":"응용 프로그램 이름을 지정합니다. 이렇게하면 사용자가 볼 수 있습니다.","Global":"글로벌","GoogleTagManager_id":"Google 태그 관리자 아이디","Has_more":"더 많이","Have_your_own_chat":"당신만의 웹 채팅을 만드세요. Meteor.com으로 개발한 Rocket.Chat은 자신만의 채팅 플랫폼을 만들고 개선해 나아갈 개발자들을 위한 훌륭한 솔루션입니다.","Header":"머리글","Hidden":"숨겨진","Hide_Group_Warning":"당신은 당신이 그룹 \" %s을 (를)\"숨기시겠습니까?","Hide_Private_Warning":"당신은 ' %s'에 함께 토론을 숨길 하시겠습니까?","Hide_room":"방 숨김","Hide_Room_Warning":"당신은 당신이 방 \" %s을 (를)\"숨기시겠습니까?","Highlights":"하이라이트","Highlights_How_To":"누군가가 여기에 추가, 단어 나 문구를 언급 할 때 통지합니다. 쉼표로 단어 나 구를 분리 할 수​​ 있습니다. 강조 단어는 대소 문자를 구분하지 않습니다.","Highlights_List":"강조 단어","History":"이력","hours":"시간","How_friendly_was_the_chat_agent":"채팅 에이전트는 어떻게 친했다?","How_knowledgeable_was_the_chat_agent":"채팅 에이전트는 어떻게 지식인가?","How_responsive_was_the_chat_agent":"채팅 에이전트는 어떻게 반응이었다?","How_satisfied_were_you_with_this_chat":"이 채팅에 당신을 어떻게 만족?","If_you_are_sure_type_in_your_password":"당신은 당신의 암호를 확인 유형의 경우 :","If_you_are_sure_type_in_your_username":"당신은 당신의 이름에 확인 유형의 경우 :","Importer_Archived":"보관","Importer_done":"전체 가져 오기!","Importer_finishing":"가져 오기를 마무리.","Importer_From_Description":"수입은 Rocket.Chat에 __의 데이터를 __from.","Importer_import_cancelled":"가져 오기가 취소되었습니다.","Importer_import_failed":"가져 오기를 실행하는 동안 오류가 발생했습니다.","Importer_importing_channels":"채널을 가져 오기.","Importer_importing_messages":"메시지를 가져 오기.","Importer_importing_started":"가져 오기를 시작.","Importer_importing_users":"사용자를 가져 오기.","Importer_not_defined_properly":"수입업자는 가져 오기 클래스를 누락 올바르게 정의되지 않았습니다.","Importer_not_in_progress":"수입은 현재 실행되고 있지 않습니다.","Importer_Prepare_Restart_Import":"다시 가져 오기","Importer_Prepare_Start_Import":"가져 오기 시작","Importer_Prepare_Uncheck_Archived_Channels":"선택을 취소 보관 채널","Importer_Prepare_Uncheck_Deleted_Users":"선택을 취소 삭제 된 사용자","Importer_progress_error":"가져 오기에 대한 진전을 가져 오지 못했습니다.","Importer_setup_error":"수입을 설정하는 동안 오류가 발생했습니다.","Incorrect_Password":"잘못된 암호","inline_code":"inline_code","Install_Extension":"확장 설치","Install_FxOs":"파이어폭스에 Rocket.Chat 설치","Install_FxOs_done":"좋습니다! 홈 스크린의 아이콘을 통해 Rock.Chat을 사용할 수 있습니다. Rock.Chat과 즐거운 시간을 보내십시오.","Install_FxOs_error":"미안, 의도한대로 작동하지 않았습니다. 에러가 발생했습니다:","Install_FxOs_follow_instructions":"장치에 응용 프로그램 설치를 확인하십시오 ( \"설치\" 메시지가 뜨면).","Installation":"설치","Integration_added":"통합이 추가되었습니다","Integration_Incoming_WebHook":"수신은 webhook 통합","Integration_New":"새로운 통합","Integration_Outgoing_WebHook":"발신은 webhook 통합","Integration_updated":"통합이 업데이트되었습니다","Integrations":"통합","Invalid_asset":"잘못된 자산","Invalid_confirm_pass":"암호가 일치하지 않습니다","Invalid_email":"입력한 이메일이 잘못되었습니다","Invalid_Export_File":"업로드 한 파일은 유효한 %의 수출 파일이 아닙니다.","Invalid_file_height":"잘못된 파일 높이","Invalid_file_type":"잘못된 파일 형식","Invalid_file_width":"잘못된 파일 너비","Invalid_Import_File_Type":"잘못된 가져 오기 파일 형식.","Invalid_name":"이름을 비워 둘 수 없습니다","Invalid_notification_setting_s":"잘못된 알림 설정 : %의","Invalid_pass":"암호를 비워 둘 수 없습니다","Invalid_room_name":"<strong>%s</strong>은 사용 가능한 방 이름이 아닙니다.<br/>소문자, 숫자, 대시만 사용할 수 있습니다","Invalid_room_type":"<strong> %s는</strong> 올바른 유형의 객실이 아니다.","Invalid_Secret_URL":"잘못된 비밀 URL","Invalid_secret_URL_message":"제공되는 URL이 잘못되었습니다.","invisible":"보지 않음","Invisible":"보지 않음","Invitation_HTML":"HTML 초대 페이지","Invitation_Subject":"초대 제목","Invite_user_to_join_channel":"이 채널로 초대한 사용자 참여","Invite_Users":"사용자 초대","is_also_typing":"또한 입력중","is_also_typing_female":"또한 입력중","is_also_typing_male":"또한 입력중","is_typing":"입력중","is_typing_female":"입력중","is_typing_male":"입력중","italics":"기울기","join":"참여","Join_audio_call":"음성 통화에 참여","Join_the_Community":"커뮤니티 가입","Join_the_given_channel":"지정한 채널에 참여","Join_video_call":"화상 통화에 참여","Joined":"가입","Jump":"도약","Jump_to_first_unread":"첫 번째 읽지로 이동","Jump_to_message":"메시지로 이동","Jump_to_recent_messages":"최근 메시지에 점프","Katex_Enabled":"Katex 사용","Label":"상표","Language":"언어","Language_Version":"한국어 버전","Last_login":"마지막 로그인","Last_message":"마지막 메시지","Last_seen":"마지막으로 본","Layout":"레이아웃","Layout_Home_Body":"홈 본문 내용","Layout_Home_Title":"홈 제목","Layout_Login_Terms":"로그인 약관","Layout_Privacy_Policy":"개인정보취급방침","Layout_Sidenav_Footer":"옆 네비 바닥글","Layout_Sidenav_Footer_description":"바닥글 크기는 260x70입니다.","Layout_Terms_of_Service":"이용약관","LDAP":"LDAP","LDAP_CA_Cert":"CA 쿠폰","LDAP_Custom_Domain_Search":"맞춤 도메인 검색","LDAP_Custom_Domain_Search_Description":"바인딩 및 연결 정보를 지배하고 양식입니다 JSON의 조각 : <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"기본 도메인","LDAP_Description":"LDAP는 많은 기업들이 통합 인증을 제공하기 위해 사용하는 계층적인 데이터베이스입니다. 여러 사이트와 서비스 간에 하나의 암호를 공유하기 위한 기능으로, 자세한 정보는 위키를 참고하세요: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"도메인 자료","LDAP_Domain_Base_Description":"사용자와 그룹을 검색하려는 LDAP 하위 트리의 완전한 고유 이름 (DN). 당신은 당신이 원하는만큼 추가 할 수 있습니다; 그러나, 각각의 그룹은 그것이 속하는 사용자와 동일한 도메인베이스에 정의되어야한다. 당신이 제한된 사용자 그룹을 지정하면 해당 그룹에 속한 사용자 만 범위에있을 것입니다. 우리는 당신이 도메인베이스로 LDAP 디렉토리 트리의 최상위 레벨을 지정하고 액세스를 제어하는​​ 검색 필터를 사용하는 것이 좋습니다.","LDAP_Domain_Search_Filter":"도메인 검색 필터","LDAP_Domain_Search_Filter_Description":"이 필터와 일치하는 지정된 사용자 만이 로그인 할 수 할 경우에는 필터가 지정되지 않은 경우. 지정된 도메인베이스의 범위 내에서 모든 사용자가 로그인 할 수 있습니다. <br/> Active Directory에 대한 예`의 memberOf = CN = ROCKET_CHAT, OU = 일반 Groups`. <br/> OpenLDAP를위한 예 (확장 일치 검색)`OU : DN = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"도메인 검색 개체 카테고리","LDAP_Domain_Search_Object_Category_Description":"사용자를 식별 *의 수 objectcategory의 *. <br/> *의 OpenLDAP를 * 빈 둡니다. <br/> 예를 들어`person` 등","LDAP_Domain_Search_Object_Class":"도메인 검색 객체 클래스","LDAP_Domain_Search_Object_Class_Description":"사용자를 식별 * 객체 클래스의 *. <br/> 예를 들어`organizationalPerson`,`user`,`inetOrgPerson` 등","LDAP_Domain_Search_Password":"도메인 검색 비밀","LDAP_Domain_Search_Password_Description":"도메인 검색 사용자의 암호입니다.","LDAP_Domain_Search_User":"도메인 검색 사용","LDAP_Domain_Search_User_Description":"가 로그인 할 때 다른 사용자를 인증하는 사용자 조회를 수행하는 LDAP 사용자입니다. <br/> 이것은 일반적으로 타사 통합을 위해 특별히 만든 서비스 계정입니다. 정규화 된 이름을 사용, 같은 CN = 관리자 '로, CN 사용자, DC = 예, DC = com`을 =.","LDAP_Domain_Search_User_ID":"도메인 검색 사용자 ID","LDAP_Domain_Search_User_ID_Description":"인증을 시도하는 LDAP 사용자를 식별하는 LDAP 속성입니다. 이 필드는`대부분의 Active Directory 설치를위한 sAMAccountName`해야하지만, 그러한 OpenLDAP를 다른 LDAP 솔루션에 대한`uid` 수있다. 당신은 이메일이나 어떤 속성 당신이 원하는하여 사용자를 식별하기 위해`mail`를 사용할 수 있습니다. <br> 당신은 사용자가 사용자 이름 또는 이메일 등 여러 ID를 사용하여 로그인 할 수 있도록 쉼표로 구분하여 여러 값을 사용할 수 있습니다.","LDAP_Enable":"LDAP 사용","LDAP_Enable_Description":"인증을 위해 LDAP를 사용하려고합니다.","LDAP_Encryption":"암호화","LDAP_Encryption_Description":"LDAP 서버에 통신을 보호하는 데 사용되는 암호화 방법. 예를 들면`plain` (암호화), (처음부터 암호화 된)`SSL / LDAPS`, 그리고`StartTLS` (암호화 통신에 한 번 연결 업그레이드)를 포함하지 않습니다.","LDAP_Host":"주인","LDAP_Host_Description":"LDAP 호스트, 예를 들어`ldap.example.com` 또는`10.0.0.30`.","LDAP_Port":"LDAP 포트","LDAP_Port_Description":"포트는 LDAP에 액세스 할 수 있습니다. LDAPS에 대한`389` 또는`636` : 예","LDAP_Reject_Unauthorized":"무단 거부","LDAP_Sync_User_Avatar":"동기화 사용자 아바타","LDAP_Sync_User_Data":"데이터 동기화","LDAP_Sync_User_Data_Description":"서버에 로그인할 때 사용자 데이터의 동기화를 유지하세요(예: 이름, 이메일).","LDAP_Sync_User_Data_FieldMap":"사용자 데이터 필드 맵","LDAP_Sync_User_Data_FieldMap_Description":"사용자 계정 필드 (이메일 등) LDAP의 레코드에서 채워집니다 방법을 구성 (한 번 발견). <br/> 예를 들어,`{ \"CN은\": \"이름\", \"메일\": \"이메일\"}`cn 속성에서 사람의 사람이 읽을 수있는 이름, 메일 속성에서 이메일을 선택합니다. <br/> 사용 가능한 필드는 name`, 그리고`email``등이 있습니다.","LDAP_Sync_Users":"동기화 사용자","LDAP_Test_Connection":"연결 테스트","LDAP_Unique_Identifier_Field":"고유 식별자 필드","LDAP_Unique_Identifier_Field_Description":"어떤 필드는 LDAP 사용자와 Rocket.Chat 사용자를 연결하는 데 사용됩니다. 당신은 LDAP 레코드에서 값을 얻기 위해 시도하는 쉼표로 구분하여 여러 값을 알릴 수 있습니다. <br/> 기본값은 '의 objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueid도, uidNumber`입니다","LDAP_Use_Custom_Domain_Search":"맞춤 도메인 검색을 사용하여","LDAP_Use_Custom_Domain_Search_Description":"LDAP 서버에서 사용자를 검색 할 자신의 필터를 작성합니다.","LDAP_Username_Field":"사용자 이름 필드","LDAP_Username_Field_Description":"어떤 분야는 새로운 사용자를위한 * 사용자 이름 *으로 사용됩니다. 로그인 페이지에서 정보를 사용자 이름을 사용하는 빈 둡니다. <br/> 당신은 # {givenName으로}`처럼, 너무 템플릿 태그를 사용할 수 있습니다. # {SN}`. <br/> 기본값은`sAMAccountName`입니다.","Leave_Group_Warning":"당신은 당신이 그룹 \" %s을 (를)\"에서 탈퇴 하시겠습니까?","Leave_Private_Warning":"당신은 ' %s'에 함께 토론을 남겨 하시겠습니까?","Leave_room":"방 나가기","Leave_Room_Warning":"당신은 당신이 방 \" %s을 (를)\"에서 탈퇴 하시겠습니까?","line":"밑줄","List_of_Direct_Messages":"직접 메시지 목록","Live_sessions":"라이브 세션","Livechat_agents":"LIVECHAT 에이전트","Livechat_Dashboard":"LIVECHAT 대시 보드","Livechat_enabled":"LIVECHAT 활성화","Livechat_Manager":"LIVECHAT 관리자","Livechat_managers":"LIVECHAT 관리자","Livechat_title":"Livechat 제목","Livechat_title_color":"Livechat 제목 배경색","Livechat_Users":"LIVECHAT 사용자","Load_more":"더 보기","Loading...":"로딩 중 ...","Loading_more_from_history":"이전 내용에서 가져오기","Loading_suggestion":"제안 로딩중...","Localization":"현지화","Log_File":"파일 및 라인보기","Log_Level":"로그 수준","Log_Package":"쇼 패키지","Log_View_Limit":"보기 제한 로그","Logged_out_of_other_clients_successfully":"성공적으로 다른 클라이언트에서 로그 아웃","Login":"로그인","Login_with":"%s으로 로그인","login_with":"아니면 직접 로그인","Logout":"로그아웃","Logout_Others":"위치에서 다른 기록 된에서 로그 아웃","Mail_Message_Invalid_emails":"하나 이상의 유효하지 않은 이메일을 제공하고 있습니다 : %의","Mail_Message_Missing_to":"하나 이상의 사용자를 선택하거나 하나 이상의 이메일 주소를 쉼표로 구분하여 제공해야합니다.","Mail_Message_No_messages_selected_select_all":"당신은 어떤 메시지를 선택하지 않았습니다. 당신이하고 싶은 <a href='#' class='select-all'>모든 선택</a> 보이는 메시지를?","Mail_Messages":"메일 메시지","Mail_Messages_Instructions":"메시지를 클릭하여 이메일을 통해 전송하고자하는 메시지 선택","Mail_Messages_Subject":"여기 %의 메시지의 선택된 부분이다","Mailer":"우편 발신인","Mailer_body_tags":"당신은 탈퇴 링크 [수신 거부]를 <b>사용합니다.</b> <br /> 당신은 각각 사용자의 전체 이름, 이름 또는 성을 위해 [LNAME], [이름], [FNAME]을 사용할 수 있습니다. <br /> 당신은 사용자의 이메일을 [메일]을 사용할 수 있습니다.","Make_Admin":"관리자 권한 생성","Manager_added":"관리자 추가","Manager_removed":"관리자 제거","Mark_as_read":"읽었음","Markdown_Headers":"마크다운 해더","Markdown_SupportSchemesForLink":"링크에 대한 마크 다운 지원 제도","Markdown_SupportSchemesForLink_Description":"허용 방식의 쉼표로 구분 된 목록","Members_List":"멤버 리스트","Mentions":"언급","Mentions_default":"언급 (기본값)","Message":"메시지","Message_AllowDeleting":"메시지 삭제 허용","Message_AllowEditing":"메시지 수정 허용","Message_AllowEditing_BlockEditInMinutes":"(n) 분 이후로 수정할 수 없습니다","Message_AllowEditing_BlockEditInMinutesDescription":"0을 입력하면 블로킹 비활성화","Message_AllowPinning":"허용 메시지 고정","Message_AllowPinning_Description":"허용 메시지는 임의의 채널에 고정한다.","Message_AllowStarring":"메시지 별표 허용","Message_AudioRecorderEnabled":"음성 녹음 활성화","Message_AudioRecorderEnabledDescription":"'audio/wav' 파일은 '파일 업로드' 설정에서 허용한 미디어 타입이어야 합니다.","Message_DateFormat":"날짜 형식","Message_DateFormat_Description":"참조 : <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js을</a>","Message_deleting_not_allowed":"메시지 삭제를 할 수 없습니다.","Message_editing_blocked":"메시지를 더 이상 수정할 수 없습니다.","Message_editing_not_allowed":"메시지 수정을 할 수 없습니다.","Message_GroupingPeriod":"(초) 기간을 그룹화","Message_GroupingPeriodDescription":"이 동일한 사용자로부터하며, 경과 시간 (초) 정보를 시간보다 작은 경우, 메시지는 이전 메시지로 분류한다.","Message_KeepHistory":"메시지 기록을 유지","Message_MaxAllowedSize":"메시지 최대 허용 크기","Message_MaxAll":"ALL 메시지의 최대 채널 크기","Message_pinned":"메시지가 고정되었습니다.","Message_pinning_not_allowed":"메시지를 고정할 수 없습니다.","Message_removed":"메시지 제거","Message_ShowDeletedStatus":"삭제된 상태 확인","Message_ShowEditedStatus":"수정 상태 확인","Message_ShowFormattingTips":"포멧 팁 보기","Message_TimeFormat":"시간 형식","Message_TimeFormat_Description":"참조 : <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js을</a>","Message_too_long":"너무 오래 메시지","Messages":"메시지","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"받는으로 webhook로 전송되는 메시지는 여기에 게시됩니다.","Meta":"메타","Meta_fb_app_id":"페이스북 APP ID","Meta_google-site-verification":"Google 사이트 확인","Meta_language":"언어","Meta_msvalidate01":"MSValidate.01","Meta_robots":"로봇","minutes":"분","Mobile_push":"모바일 푸시","More_channels":"추가 채널","More_direct_messages":"보다 직접적인 메시지","More_groups":"비밀 그룹 더보기","More_unreads":"읽지 않은 메시지 더보기","Msgs":"Msgs","multi":"다중 밑줄","Mute_someone_in_room":"방에 음소거 사람","Mute_user":"음소거 사용자","Muted":"음소거","My_Account":"내 계정","n_messages":"%s 메시지","N_new_messages":"%의 새로운 메시지","Name":"이름","Name_cant_be_empty":"이름을 비워 둘 수 없습니다","Name_of_agent":"에이전트의 이름","Name_optional":"이름 (선택 사항)","Navigation_History_20_last_pages":"네비게이션 역사 (20 마지막 페이지)","New_Application":"새 응용 프로그램","New_Custom_Field":"새 사용자 정의 필드","New_Department":"새로운 부서","New_integration":"새로운 통합","New_logs":"새로운 로그","New_messages":"새로운 메시지","New_password":"새로운 암호","New_role":"새로운 역할","No_channel_with_name_%s_was_found":"<strong>\"%s\"</strong> 채널 이름을 찾을 수 없습니다!","No_channels_yet":"어떠한 채널에도 가입하지 않았습니다.","No_direct_messages_yet":"어떤 귓속말도 하지 않았습니다.","No_Encryption":"어떤 암호화 없음","No_favorites_yet":"아직 즐겨찾기를 추가하지 않았습니다.","No_group_with_name_%s_was_found":"<strong>\"%s\"</strong> 비밀 그룹 이름을 찾을 수 없습니다!","No_groups_yet":"비밀 그룹을 만들지 않았습니다.","No_livechats":"당신은 더 livechats이 없습니다.","No_mentions_found":"아무도 찾을 수 없습니다 언급하는","No_permission_to_view_room":"이 방을 볼 수 있는 권한이 없습니다","No_pinned_messages":"보관된 메시지가 없습니다","No_results_found":"검색 결과가 없습니다","No_starred_messages":"별표된 메시지가 없습니다","no_tokens_for_this_user":"이 사용자에 대한 토큰이 없습니다","No_user_with_username_%s_was_found":"<strong>\"%s\"</strong> 사용자 이름을 가진 사용자를 찾을 수 없습니다!","Not_allowed":"허용되지 않음","Not_authorized":"권한이 없습니다","Not_Available":"사용 불가","Not_found_or_not_allowed":"찾을 수 없거나 허용되지 않았습니다","Nothing":"아무것도","Nothing_found":"찾을 수 없습니다","Notifications":"알림","Notify_all_in_this_room":"이 방에 있는 모든이에게 알림","Num_Agents":"# 에이전트","Number_of_messages":"메시지 수","OAuth_Application":"OAuth를 응용 프로그램","OAuth_Applications":"OAuth를 응용 프로그램","Objects":"사물","Off_the_record_conversation":"오프 - 더 - 레코드 대화","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"오프 - 더 - 레코드 대화는 브라우저 나 장치를 사용할 수 없습니다.","Offline_DM_Email":"[__site__] 당신이 직접 __user__에 의해 메세지되었습니다","Offline_Mention_Email":"[__site__] 당신은 #__room__에 __user__ 언급 한","Old_and_new_password_must_be_different":"새 암호는 이전 암호와 달라야합니다.","Old_and_new_password_required":"암호를 변경하기 위해서는 기존 암호와 새로 사용할 암호를 입력해야합니다.","Online":"온라인","Only_errors":"오류 만","Only_you_can_see_this_message":"이 메시지는 당신만 볼 수 있습니다","Oops!":"아차","Open":"열다","Opened":"개설","Opt_out_statistics":"나의 어떤 무기명 통계도 Rocket.chat으로 보내지 마십시오.","Opt_out_statistics_warning":"배포된 Rocket.Chat에대한 여럿 인스턴스들을 확인하여 통계를 전송하게되면 우리는 문제점을 확인하고 더 좋은 시스템을 만들 수 있습니다. 사용자 정보를 보내지 않으며, 우리가 받은 정보는 모두 비밀유지가 됩니다. 만약 계속해서 통계를 보내고 싶다면 체크박스를 해제하시면 됩니다. 감사합니다.","optional":"선택 과목","Order":"주문","OS_Arch":"OS Arch","OS_Cpus":"OS CPU 갯수","OS_Freemem":"OS 빈 메모리","OS_Loadavg":"OS 부하 평균","OS_Platform":"OS 플랫폼","OS_Release":"OS 릴리즈","OS_Totalmem":"OS 전체 메모리","OS_Type":"OS 유형","OS_Uptime":"OS 사용 시간","others":"다른 사람","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"두 사용자가 온라인 상태 일 때 OTR에만 사용할 수 있습니다","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"파일이 업로드되는 재정의 URL. 또한 CDN하지 않는 다운로드에 사용이 URL이 제공됩니다","Password":"암호","Password_Change_Disabled":"Rock.Chat 관리자는 암호 변경을 할 수 없습니다.","Password_changed_successfully":"암호를 성공적으로 변경하였습니다.","Payload":"유효 탑재량","People":"사람들","Permissions":"권한","Pin_Message":"메시지 보관하기","Pinned_a_message":"메시지 핀드 :","Pinned_Messages":"보관된 메시지","Placeholder_for_email_or_username_login_field":"이메일 또는 사용자 이름 로그인 필드에 대한 자리 표시 자","Placeholder_for_password_login_field":"비밀번호 로그인 필드에 대한 자리 표시 자","Please_answer_survey":"이 채팅에 대한 간단한 설문 조사에 응답하기 위해 잠시 시간을내어 주시기 바랍니다","Please_enter_value_for_url":"아바타 URL을 입력하십시오.","Please_enter_your_new_password_below":"아래에 새 암호를 입력하십시오 :","Please_fill_a_label":"라벨을 기입하십시오","Please_fill_a_name":"이름을 기입하십시오","Please_fill_a_username":"사용자 이름을 기입하십시오","Please_fill_name_and_email":"이름과 이메일을 입력하세요","Please_re_enter_your_password":"비밀번호를 다시 입력하세요","Please_select_enabled_yes_or_no":"사용에 대한 옵션을 선택하세요","Please_wait":"잠시만 기다려 주세요.","Please_wait_activation":"시간이 좀 걸릴 수 있습니다. 잠시만 기다려주십시오.","Please_wait_statistics":"통계를 생성 중입니다. 잠시만 기다려주십시오.","Please_wait_while_OTR_is_being_established":"OTR이 설립되는 동안 잠시 기다려주십시오","Please_wait_while_your_account_is_being_deleted":"당신의 계정이 삭제되는 동안 잠시 기다려주십시오 ...","Please_wait_while_your_profile_is_being_saved":"프로필이 저장되는 동안 잠시 기다려주십시오 ...","Post_as":"포스트 등","Post_to_Channel":"채널에 게시","Post_to_s_as_s":"게시물 <strong>%의</strong> <strong>% 정도의</strong>","Powered_by":"Powered by","Preferences":"설정","Preferences_saved":"설정 저장함.","Privacy":"프라이버시","Private_Group":"비밀 그룹","Private_Groups":"비밀 그룹","Private_Groups_list":"비밀 그룹 목록","Profile":"프로필","Profile_saved_successfully":"프로필을 성공적으로 저장","Proudly_developed":"Meteor로 개발됨","Push":"푸시","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN 개발 Cert","Push_apn_dev_key":"APN 개발 키","Push_apn_dev_passphrase":"APN 개발 암호","Push_apn_key":"APN 키","Push_apn_passphrase":"APN 암호","Push_debug":"Debug","push_disabled":"장애인 눌러","Push_enable":"사용 가능","Push_enable_gateway":"게이트웨이 사용","Push_gateway":"게이트웨이","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM 프로젝트 번호","Push_production":"Production","Push_show_message":"통지에 메시지 표시","Push_show_username_room":"알림에 표시 채널 / 그룹 / 사용자 이름","Push_test_push":"테스트","Query":"질문","Query_description":"에 이메일을 보낼 수있는 사용자를 결정하기위한 추가 조건. 구독 사용자는 자동으로 쿼리에서 제거됩니다. 그것은 유효한 JSON해야합니다. 예 : \"{\"createdAt \": {\"$에있다 \": {\"$ 날짜 \":\"2015-01-01T00 : 00 : 00.000Z \"}}}\"","Quick_Search":"빠른 찾기","quote":"인용","Reactions":"반응","Recents":"최근","Record":"기록","Redirect_URI":"URI 리디렉션","Refresh_keys":"새로 고침 키","Refresh_your_page_after_install_to_enable_screen_sharing":"화면 공유를 가능하게 설치 한 후 페이지를 새로 고침","Register":"새로운 계정 등록","Registration_Succeeded":"등록 성공","Remember_me":"자동 로그인","Remove":"삭제","Remove_Admin":"관리자 권한 제거","Remove_as_moderator":"사회자로 제거","Remove_as_owner":"소유자로 제거","Remove_custom_oauth":"사용자 정의 OAuth 제거","Remove_from_room":"방에서 제거","Remove_someone_from_room":"방에서 사람을 제거","Removed":"제거됨","Require_password_change":"비밀번호 변경 필요","Resend_verification_email":"확인 이메일을 다시 보내","Reset":"다시 놓기","Reset_password":"암호 재설정","Restart":"재시작","Restart_the_server":"서버를 다시 시작","RocketBot_Enabled":"RockBot 사용","RocketBot_Name":"RocketBot 이름","RocketBot_Name_Description":"RocketBot 이름은 서버에 등록된 사용자 이름이여야 합니다.","Role":"역할","Role_Editing":"역할 편집","Role_removed":"역할 제거","Room":"방","Room_archivation_state":"상태","Room_archivation_state_false":"유효한","Room_archivation_state_true":"보관","Room_archived":"룸 보관","room_changed_privacy":"방 종류가 <em>__user_by__</em>에서 <em>__room_type__</em>로 변경되었습니다.","room_changed_topic":"방 주제가 <em>__user_by__</em>에서 <em>__room_topic__</em>로 변경되었습니다.","Room_has_been_deleted":"방이 삭제되었습니다","Room_Info":"객실 안내","Room_name_changed":"방 이름 변경: <em>__user_by__</em>에서 <em>__room_name__</em>로.","Room_name_changed_successfully":"방 이름 변경 완료","Room_not_found":"방을 찾을 수 없습니다.","Room_topic_changed_successfully":"룸 항목이 성공적으로 변경","Room_type_changed_successfully":"객실 타입은 성공적으로 변경","Room_unarchived":"언 아카이브 룸","Room_uploaded_file_list":"파일 목록","Room_uploaded_file_list_empty":"파일을 사용할 수 없습니다.","room_user_count":"%s 사용자","Rooms":"방","S_new_messages_since_s":"%s 새로운 메시지 %s 이후로","SAML":"SAML","SAML_Custom_Cert":"커스텀 인증","SAML_Custom_Entry_point":"커스텀 접근 포인트","SAML_Custom_Generate_Username":"사용자 이름 생성","SAML_Custom_Issuer":"커스텀 발급자","SAML_Custom_Provider":"커스텀 제공자","Save":"저장","Save_changes":"변경사항 저장","Save_Mobile_Bandwidth":"모바일 대역폭 저장","Save_to_enable_this_action":"이 작업을 가능하게 저장","Saved":"저장됨","Saving":"저장 중","Scope":"범위","Screen_Share":"화면 공유","Script_Enabled":"스크립트 사용","Search":"검색","Search_by_username":"이름으로 검색","Search_Channels":"검색 채널","Search_Direct_Messages":"직접 메시지를 검색","Search_Messages":"메시지 찾기","Search_Private_Groups":"개인 그룹 검색","Search_settings":"검색 설정","seconds":"초","See_all":"모두 보기","See_only_online":"온라인에서만","Select_a_department":"부서를 선택","Select_an_avatar":"아바타 선택","Select_file":"파일 선택","Select_service_to_login":"서비스 로그인시 불러온 사진이나 컴퓨터에서 직접 올린 사진을 선택합니다.","Select_user":"선택 사용자","Select_users":"사용자 선택","Selected_agents":"선택한 에이전트","Selected_users":"선택된 멤버","Send":"보내기","Send_a_message":"메시지 보내기","Send_a_test_mail_to_my_user":"내 사용자에게 테스트 메일 보내기","Send_a_test_push_to_my_user":"내 사용자에게 테스트 푸시 보내기","Send_confirmation_email":"확인 메일 보냄","Send_data_into_RocketChat_in_realtime":"실시간으로 Rocket.Chat로 데이터를 전송합니다.","Send_email":"이메일 보내기","Send_invitation_email":"초대 메일 보내기","Send_invitation_email_error":"유효한 이메일 주소가 입력되지 않았습니다.","Send_invitation_email_info":"한번에 여러 사람에게 초대 이메일을 보낼 수 있습니다.","Send_invitation_email_success":"다음 주소로 초대 이메일을 발송하였습니다:","Send_invitation_email_warning":"초대 이메일을 보내려면, 먼저 SMTP 설정을 구성해야 합니다.","Send_Message":"메시지 보내기","Send_your_JSON_payloads_to_this_URL":"이 URL에 JSON 페이로드를 보냅니다.","Sending":"배상...","Set_as_moderator":"사회자로 설정","Set_as_owner":"소유자로 설정","Settings":"설정","Settings_updated":"설정 업데이트","Should_be_a_URL_of_an_image":"이미지의 URL이어야합니다.","Should_exists_a_user_with_this_username":"사용자가 이미 존재해야합니다.","Show_all":"모두 보이기","Show_more":"자세히보기","Show_only_online":"온라인으로 만보기","Show_preregistration_form":"사전 등록 양식을보기","Showing_archived_results":"<p> <b> %s에</b> 보관 된 결과를 표시 </p>","Showing_online_users":"__total__ 사용자의 <b>__total_showing__</b> 표시","Showing_results":"<p><b>%s</b> 결과 확인</p>","Silence":"소리끄기","since_creation":"%s 이후","Site_Name":"사이트 이름","Site_Url":"사이트 URL","Site_Url_Description":"예: https://chat.domain.com/","Skip":"버킷","Smileys_and_People":"스마일 & 사람들","SMTP":"SMTP","SMTP_Host":"SMTP 호스트","SMTP_Password":"SMTP 암호","SMTP_Port":"SMTP 포트","SMTP_Test_Button":"테스트 SMTP 설정","SMTP_Username":"SMTP 사용자 이름","Sound":"소리","Star_Message":"별표 메시지","Starred_Messages":"별표된 메시지","Start_audio_call":"음성 통화를 시작합니다","Start_Chat":"채팅 시작","Start_of_conversation":"대화 시작","Start_OTR":"시작 OTR","Start_video_call":"화상 통화 시작","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"시작 <code class=\"inline\">%s</code> 사용자 나에 대한 <code class=\"inline\">%s</code> 채널. 예 : <code class=\"inline\">%s</code> 또는 <code class=\"inline\">%s</code>","Statistics":"통계","Stats_Active_Users":"활성 사용자","Stats_Avg_Channel_Users":"채널 사용자 평균","Stats_Avg_Private_Group_Users":"비밀 그룹 사용자 평균","Stats_Away_Users":"사용자 자리비움","Stats_Max_Room_Users":"최대 방 사용자","Stats_Non_Active_Users":"비활성 사용자","Stats_Offline_Users":"오프라인 사용자","Stats_Online_Users":"온라인 사용자","Stats_Total_Channels":"전체 채널","Stats_Total_Direct_Messages":"전체 귓속말","Stats_Total_Messages":"전체 메시지","Stats_Total_Private_Groups":"전체 비밀 그룹","Stats_Total_Rooms":"전체 방","Stats_Total_Users":"총 사용자","Stop_Recording":"기록 중지","strike":"취소선","Subject":"제목","Submit":"제출","Success":"성공","Survey":"측량","Survey_instructions":"당신이 완전히 만족하는 의미를 완전히 만족하지 의미에 대한 만족도에 따라 1 각 질문에 평가 5.","Symbols":"기호","Sync_success":"동기화 성공","Sync_Users":"동기화 사용자","Test_Connection":"연결 테스트","Test_Desktop_Notifications":"시험 바탕 화면 알림","Thank_you_for_your_feedback":"의견을 보내 주셔서 감사합니다","The_application_name_is_required":"응용 프로그램 이름이 필요합니다","The_channel_name_is_required":"채널 이름이 필요합니다","The_emails_are_being_sent":"이메일을 전송 중입니다.","The_field_is_required":"필드 %s는 필요합니다.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"당신의 서버에 ImageMagick 또는 GraphicMagick이 설치되어 있지 않아 이미지 크기를 재조정할 수 없습니다.","The_redirectUri_is_required":"redirectUri이 필요합니다","The_server_will_restart_in_s_seconds":"서버가 %s 초 후 재시작합니다.","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"설정 <strong> %s 님이</strong> <strong> %s의</strong> 구성되고 당신은 <strong> %s의에서</strong> 액세스!","The_user_will_be_removed_from_s":"사용자는 %의에서 제거됩니다","The_user_wont_be_able_to_type_in_s":"사용자는 %s에 입력 할 수 없습니다","Theme":"테마","theme-color-action-buttons-color":"액션 버튼 색상","theme-color-active-channel-background-color":"활성 채널 배경 색상","theme-color-active-channel-font-color":"활성 채널 글꼴 색상","theme-color-blockquote-background":"인용구 배경색","theme-color-clean-buttons-color":"청소 버튼 색상","theme-color-code-background":"코드 배경색","theme-color-code-border":"코드 테두리 색상","theme-color-code-color":"코드 색상","theme-color-content-background-color":"콘텐츠 배경색","theme-color-custom-scrollbar-color":"사용자 지정 스크롤 막대 색상","theme-color-info-active-font-color":"활성 정보 글꼴 색상","theme-color-info-font-color":"글자 색상 정보","theme-color-input-font-color":"입력 글꼴 색상","theme-color-link-font-color":"링크 글꼴 색상","theme-color-message-hover-background-color":"메시지 호버 배경색","theme-color-primary-background-color":"기본 배경색","theme-color-primary-font-color":"기본 글자 색상","theme-color-quaternary-font-color":"사기 글꼴 색상","theme-color-secondary-background-color":"보조 배경색","theme-color-secondary-font-color":"보조 글자 색상","theme-color-smallprint-font-color":"작은 인쇄 글꼴 색상","theme-color-smallprint-hover-color":"작은 인쇄 호버 색상","theme-color-status-away":"자리비움 상태 색상","theme-color-status-busy":"바쁨 상태 색상","theme-color-status-offline":"보지않음 상태 색상","theme-color-status-online":"온라인 상태 색상","theme-color-tertiary-background-color":"차 배경 색상","theme-color-tertiary-font-color":"차 글꼴 색상","theme-color-unread-notification-color":"읽지 않은 알림 색상","theme-custom-css":"사용자 정의 CSS","There_are_no_agents_added_to_this_department_yet":"아직이 부서에 추가에는 에이전트가 없습니다.","There_are_no_integrations":"더 통합이 없습니다","There_are_no_users_in_this_role":"이 역할의 사용자가 없습니다.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"이 이메일은 이미 사용하고 확인되지 않았습니다. 비밀번호를 변경하십시오.","This_is_a_desktop_notification":"이것은 데스크톱 알려","This_is_a_push_test_messsage":"이 푸시 테스트 님에게 메일입니다","Time_in_seconds":"시간 (초)","Title_bar_color":"제목 표시 줄 색상","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"귀하의 웹 사이트에 Rocket.Chat LIVECHAT를 설치하려면 복사 및 사이트의 마지막 <strong></ BODY></strong> 태그 위에이 코드를 붙여 넣습니다.","To_users":"사용자에","Topic":"이야기","Travel_and_Places":"여행 및 지역 정보","Trigger_removed":"트리거 제거","Trigger_Words":"트리거 단어","Triggers":"트리거","True":"True","Type":"유형","Type_your_new_password":"새 암호를 입력","Unarchive":"보관 취소","Unmute_someone_in_room":"방에 음소거 해제 사람","Unmute_user":"음소거 해제 사용자","Unnamed":"이름이없는","Unpin_Message":"메시지 보관하지 않기","Unread_Rooms":"읽지 않은 방","Unread_Rooms_Mode":"읽지 않은 객실 모드","Unstar_Message":"별표 삭제","Upload_file_question":"파일을 업로드하시겠습니까?","Uploading_file":"파일 업로드 중...","Use_account_preference":"계정 환경 설정을 사용","Use_Emojis":"이모지 사용","Use_initials_avatar":"사용자 이름을 이니셜로 사용합니다","use_menu":"사이드 메뉴를 이용하여 방과 채팅에 참여할 수 있습니다","Use_service_avatar":"아바타 %s 사용","Use_this_username":"이 사용자 이름 사용","Use_uploaded_avatar":"업로드된 아바타 사용","Use_url_for_avatar":"아바타 URL 사용","User__username__is_now_a_moderator_of__room_name_":"사용자 __ 사용자 이름 __ 이제 __room_name__의 운영자입니다","User__username__is_now_a_owner_of__room_name_":"사용자 __ 사용자 이름 __ 이제 __room_name__의 소유자","User__username__removed_from__room_name__moderators":"사용자 __ 사용자 이름 __은 __room_name__ 운영자에서 제거","User__username__removed_from__room_name__owners":"사용자 __ 사용자 이름 __은 __room_name__ 소유자에서 제거","User_added":"사용자 추가함.","User_added_by":"사용자 <em>__user_added__</em>을/를 <em>__user_by__</em>에 추가합니다.","User_added_successfully":"사용자가 성공적으로 추가","User_Channels":"사용자 채널","User_doesnt_exist":"`@%s` 사용자가 존재하지 않습니다.","User_has_been_activated":"사용자가 활성화되었습니다","User_has_been_deactivated":"사용자가 비활성화되었습니다","User_has_been_deleted":"사용자 삭제되었습니다","User_has_been_muted_in_s":"사용자 %s의에서 음소거되었습니다","User_has_been_removed_from_s":"사용자 %s의 삭제되었습니다","User_has_disconnected":"사용자의 연결이 끊어있다","User_Info":"사용자 정보","User_is_no_longer_an_admin":"사용자는 더 이상 관리자가 아닙니다","User_is_not_activated":"사용자는 더 이상 활동하지 않습니다.","User_is_now_an_admin":"사용자는 관리자입니다.","User_joined_channel":"채널에 참여했습니다.","User_joined_channel_female":"채널에 참여했습니다.","User_joined_channel_male":"채널에 참여했습니다.","User_left":"채널을 떠났습니다.","User_left_female":"채널을 떠났습니다.","User_left_male":"채널을 떠났습니다.","User_logged_out":"사용자를 로그아웃합니다","User_management":"사용자 관리","User_muted_by":"사용자 <em>__user_muted__는</em> <em>__user_by__</em> 음소거.","User_muted_in_room":"사용자는 방에서 음소거","User_not_found":"사용자를 찾을 수 없음","User_not_found_or_incorrect_password":"사용자를 찾을 수 없거나 잘못된 암호입니다","User_or_channel_name":"사용자 또는 채널 이름","User_removed":"사용자 제거됨","User_removed_by":"사용자 <em>__user_removed__</em>을/를 <em>__user_by__</em>에서 삭제하였습니다.","User_removed_from_room":"사용자는 방에서 제거되었습니다","User_Settings":"사용자 설정","User_unmuted_by":"사용자 <em>__user_unmuted__는</em> <em>__user_by__으로</em> 음소거를 해제했습니다.","User_unmuted_in_room":"방에서 음소거 해제 사용자","User_updated_successfully":"사용자를 성공적으로 업데이트 하였습니다.","Username":"사용자 이름","Username_and_message_must_not_be_empty":"사용자 이름과 메시지는 비워 둘 수 없습니다.","Username_cant_be_empty":"사용자 이름을 비워둘 수 없습니다","Username_Change_Disabled":"Rocket.Chat 관리자는 사용자 이름 변경을 할 수 없습니다.","Username_denied_the_OTR_session":"OTR __ 사용자가 세션을 거절","Username_description":"사용자 이름은 다른 사람이 메시지에서 언급할 수 있도록 하는데 사용됩니다.","Username_doesnt_exist":"사용자 이름 '%의 s`가 존재하지 않습니다.","Username_ended_the_OTR_session":"__ 사용자 이름 __은 OTR 세션을 종료","Username_invalid":"<strong>&s</strong>는 알맞은 사용자명이 아닙니다,<br/> 문자, 숫자, 마침표와 밑줄을 사용하십시오.","Username_is_already_in_here":"`@%s` 사용자가 이미 있습니다.","Username_is_not_in_this_room":"사용자`#의 %의 s`이 방에 있지 않습니다.","Username_not_found":"사용자 이름을 찾을 수 없습니다","Username_title":"사용자 이름 등록","Username_unavaliable":"<strong>%s</strong> 는 사용중입니다. :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__ 사용자 이름 __은 OTR을 시작하려고합니다. 수락 하시겠습니까?","Users":"사용자","Users_in_role":"역할의 사용자","UTF8_Names_Slugify":"UTF8 이름 Slugify","UTF8_Names_Validation":"UTF8 이름 확인","UTF8_Names_Validation_Description":"특수 문자와 공백을 허용하지 않습니다. _와 - 당신은 사용할 수 있습니다. 아니라 이름 끝에","Verification_email_sent":"확인 이메일이 전송","View_All":"모두 보기","View_Logs":"로그보기","Visibility":"시계","Visible":"명백한","Visitor":"방문객","Visitor_page_URL":"방문자 페이지 URL","Visitor_time_on_site":"사이트 방문자 시간","Wait_activation_warning":"로그인하기 전에 관리자가 계정을 수동으로 활성화시켜야합니다.","We_are_offline_Sorry_for_the_inconvenience":"우리는 오프라인 상태입니다. 불편을 드려 죄송합니다.","We_have_sent_password_email":"암호 재설정 요청 이메일을 보냈습니다. 이메일을 받지 못한 경우, 다시 시도하세요.","We_have_sent_registration_email":"등록확인 이메일을 보냈습니다. 이메일을 받지 못한 경우, 다시 시도하세요.","WebRTC_Enable_Channel":"공개 채널 사용","WebRTC_Enable_Direct":"귓속말 사용","WebRTC_Enable_Private":"비밀 그룹 사용","WebRTC_Servers":"STUN / TURN 서버","WebRTC_Servers_Description":"쉼표로 구분하여 STUN 및 TURN 서버의 목록입니다. <br/> 암호 @ 스턴 : 사용자 이름, 암호 및 포트는 형식으로`사용자 이름을 사용할 수 있습니다 호스트 : port` 또는 '사용자 이름 : 암호 @ 턴 : 호스트 : port`합니다.","Welcome":"환영합니다, <em>%s</em>.","Welcome_to_the":"오신것을 환영합니다","will_be_able_to":"수있을 것입니다","With_whom":"누구랑?","Yes":"예","Yes_clear_all":"예, 전부 지웁니다!","Yes_delete_it":"예, 삭제합니다!","Yes_hide_it":"예, 그것을 숨길!","Yes_leave_it":"예, 맡겨!","Yes_mute_user":"네, 음소거 사용자!","Yes_remove_user":"예, 사용자를 제거!","you_are_in_preview_mode_of":"#<strong>__room_name__</strong> 채널 미리보기 모드","You_are_logged_in_as":"당신은로 로그인","You_are_not_authorized_to_view_this_page":"당신은 이 페이지를 볼 수 있는 권한이 없습니다.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"당신은 마지막 소유자입니다. 방을 떠나기 전에 새 소유자를 설정하십시오.","You_can_change_a_different_avatar_too":"이 통합을 게시하는 데 사용되는 아바타를 대체 할 수 있습니다.","You_can_use_an_emoji_as_avatar":"또한 아바타로 이모티콘을 사용할 수 있습니다.","You_have_been_muted":"당신은 이제 이 방에서 듣지도 말하지도 못합니다","You_have_not_verified_your_email":"당신은 이메일을 확인하지 않았습니다.","You_have_successfully_unsubscribed":"지금부터 당신은 메일링 리스트를 수신하지 않습니다.","You_informed_an_invalid_FROM_address":"당신은 주소에서 잘못을 알렸다.","You_must_provide_the_unsubscribe_link":"당신은 [수신 거부] 링크를 제공해야합니다.","You_need_confirm_email":"로그인하려면 이메일 확인이 필요합니다!","You_need_install_an_extension_to_allow_screen_sharing":"당신은 화면 공유를 허용하는 확장을 설치해야합니다","You_need_to_change_your_password":"당신은 당신의 암호를 변경해야","You_need_to_type_in_your_password_in_order_to_do_this":"이 작업을 수행하기 위해 사용자의 암호를 입력해야합니다!","You_need_to_type_in_your_username_in_order_to_do_this":"이 작업을 수행하기 위해 사용자 이름을 입력해야합니다!","You_need_to_verifiy_your_email_address_to_get_notications":"당신은 알림을받을 이메일 주소를 verifiy 필요","You_should_name_it_to_easily_manage_your_integrations":"당신은 쉽게 통합을 관리하기 위해 이름을해야합니다.","You_will_not_be_able_to_recover":"이 메시지는 복구할 수 없습니다!","You_will_not_be_able_to_recover_file":"이 파일을 복구 할 수 없습니다!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"당신이 당신의 이메일을 확인하지 않았기 때문에 당신은 전자 메일 알림을받을 수 없습니다.","Your_email_has_been_queued_for_sending":"당신의 이메일이 전송을 위해 대기하고있다","Your_entry_has_been_deleted":"항목이 삭제되었습니다.","Your_file_has_been_deleted":"파일이 삭제되었습니다.","Your_mail_was_sent_to_s":"메일은 %s의 전송되었습니다","Your_Open_Source_solution":"당신만의 오픈소스 채팅 솔루션","Your_password_is_wrong":"암호가 잘못되었습니다!","Your_push_was_sent_to_s_devices":"귀하의 푸시는 %의 기기에 전송"});
TAPi18n._registerServerTranslator("ko", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ku.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ku"] = ["ku","ku"];                                                                           // 8
if(_.isUndefined(TAPi18n.translations["ku"])) {                                                                        // 9
  TAPi18n.translations["ku"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ku"][namespace])) {                                                             // 13
  TAPi18n.translations["ku"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ku"][namespace], {"500":"Xeletiya Pêşkêşkara Herêmî","0_Errors_Only":"0 - Errors Tenê","1_Errors_and_Information":"1 - Errors û Information","2_Erros_Information_and_Debug":"2 - Erros, Information û Debug","__username__was_set__role__by__user_by_":"__username__ __role__ destê __user_by__ hat avakirin","__username__is_no_longer__role__defined_by__user_by_":"__username__ e êdî __role__, ji aliyê __user_by__","Access_not_authorized":"Têketinê destûr ne","Access_online_demo":"سەیری دێمۆی سەرهێڵ بکە","Access_Online_Demo":"سەیری دێمۆی سەرهێڵ بکە","Access_Token_URL":"URL Têketinê Token","Accounts":"bikarhênerên","Accounts_AllowDeleteOwnAccount":"Rê bide bikarhênerên bibî account xwe","Accounts_AllowedDomainsList":"Lîsteya Domain ji destûr","Accounts_AllowedDomainsList_Description":"lîsteya bêhnok-cuda ji qada destûr","Accounts_AllowEmailChange":"Destûrê bide E-mail Change","Accounts_AllowPasswordChange":"Destûrê bide Password Change","Accounts_AllowUserAvatarChange":"Destûrê bide User Avatar Change","Accounts_AllowUsernameChange":"Destûrê bide Username Change","Accounts_AllowUserProfileChange":"Destûrê bide User Profile Change","Accounts_AvatarResize":"resize Avatars","Accounts_AvatarSize":"Avatar Size","Accounts_AvatarStorePath":"Path Avatar Storage","Accounts_AvatarStoreType":"Avatar Type Storage","Accounts_BlockedDomainsList":"Astengkirin Lîsteya Domain","Accounts_BlockedDomainsList_Description":"lîsteya bêhnok-cuda ji qada astengkirin","Accounts_denyUnverifiedEmail":"Înkar email nepiştrastkirî","Accounts_EmailVerification":"Verification E-mail","Accounts_EmailVerification_Description":"Piştrast tu settings SMTP correct ji bo bikaranîna vê funksîyonê","Accounts_Enrollment_Email":"Kînge E-mail","Accounts_Enrollment_Email_Description":"Dibe ku tu [name], [fname] ji bo navê bikarhêner, nav an paşnav, bi rêzê ve bi kar tînin, [lname]. <br /> Dibe ku tu [email] ji bo email bikarhêner bi kar tînin.","Accounts_Iframe_api_method":"Method Api","Accounts_Iframe_api_url":"Url Api","Accounts_iframe_enabled":"çalake","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Expiration Login li Rojan","Accounts_ManuallyApproveNewUsers":"Bi destan Approve Users New","Accounts_OAuth_Custom_Token_Sent_Via":"Token Sent Via","Accounts_OAuth_Custom_Authorize_Path":"authorize Path","Accounts_OAuth_Custom_Button_Color":"rengê bişkoka","Accounts_OAuth_Custom_Button_Label_Color":"Rengê bişkoka Nivîsar di","Accounts_OAuth_Custom_Button_Label_Text":"Button Nivîsar di","Accounts_OAuth_Custom_Enable":"Bikêrkirin","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Path nasnameya","Accounts_OAuth_Custom_Login_Style":"Style Login","Accounts_OAuth_Custom_Secret":"Dizî","Accounts_OAuth_Custom_Token_Path":"Path token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"facebook Login","Accounts_OAuth_Facebook_callback_url":"URL Facebook Callback","Accounts_OAuth_Facebook_id":"Id Facebook App","Accounts_OAuth_Facebook_secret":"facebook Secret","Accounts_OAuth_Github":"OAuth çalake","Accounts_OAuth_Github_callback_url":"URL Github Callback","Accounts_OAuth_GitHub_Enterprise":"OAuth çalake","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise Callback","Accounts_OAuth_GitHub_Enterprise_id":"Id Client","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Id Client","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth çalake","Accounts_OAuth_Gitlab_callback_url":"URL GitLab Callback","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google Login","Accounts_OAuth_Google_callback_url":"URL Google Callback","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Login","Accounts_OAuth_Linkedin_callback_url":"URL Linkedin Callback","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"meteor Login","Accounts_OAuth_Meteor_callback_url":"URL Meteor Callback","Accounts_OAuth_Meteor_id":"meteor Id","Accounts_OAuth_Meteor_secret":"meteor Secret","Accounts_OAuth_Twitter":"Twitter Login","Accounts_OAuth_Twitter_callback_url":"URL Twitter Callback","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"URL Wordpress Callback","Accounts_OAuth_Wordpress_id":"Id WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Şîfreyê nû bike","Accounts_Registration_AuthenticationServices_Enabled":"Registration bi Services Têketin","Accounts_RegistrationForm":"Formê qeydkirina","Accounts_RegistrationForm_Disabled":"Bêmecel","Accounts_RegistrationForm_LinkReplacementText":"Formê Qeydkirina Link Replacement Nivîsar di","Accounts_RegistrationForm_Public":"Alenî","Accounts_RegistrationForm_Secret_URL":"URL Secret","Accounts_RegistrationForm_SecretURL":"Formê Qeydkirina Secret URL","Accounts_RegistrationForm_SecretURL_Description":"Divê tu string random ku wê bê URL xwe qeyd added ne. Mînak: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Registration pêwîst","Accounts_RequireNameForSignUp":"Hewce Name Ji bo Signup","Accounts_ShowFormLogin":"Login-bingeha forma nîşan","Accounts_UseDefaultBlockedDomainsList":"Use Default astengkirin Lîsteya Domain","Accounts_UseDNSDomainCheck":"Bi kar bîne Check DNS Domain","Activate":"de çalak bike","Activity":"Çalakî","Add":"Lêzêdekirin","Add_agent":"lê zêde bike agent","Add_custom_oauth":"Lê zêde bike OAuth custom","Add_manager":"lê zêde bike manager","Add_Members":"lê zêde bike Endam","Add_User":"lê zêde bike Bikarhêner","Add_user":"lê zêde bike user","Add_users":"بەکارهێنەر زیادبکە","Additional_emails":"Additional E-mailên","Additional_Feedback":"Feedback Additional","Administration":"Birêvebirî","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Piştî Erêkirina OAuth2, bikarhênerên wê ji bo vê URL redirected","Agent_added":"Agent added","Agent_removed":"Agent rakirin","Alias":"Navê dizî","All":"Gişt","All_channels":"Hemû kanalên","All_logs":"Hemû têketin","All_messages":"Hemû peyamên","Allow_Invalid_SelfSigned_Certs":"Destûrê bide Invalid Self-Îmze Certs","Allow_Invalid_SelfSigned_Certs_Description":"Destûrê ya sertîfîkayê SSL invalid û-bixwe hatiye îmzekirin ji bo mabesta link û previews.","and":"و","And_more":"Û __length zêdetir __...","Animals_and_Nature":"Animals & Nature","API":"API","API_Analytics":"analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Embed Disable bo Users","API_EmbedDisabledFor_Description":"lîsteya-bêhnok ji hev cuda yên bikarhêneran","API_GitHub_Enterprise_URL":"URL Server","API_GitHub_Enterprise_URL_Description":"Mînak: http://domain.com (ji bîlî slash qaşo)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"URL WordPress","Appearance":"Xuyabûnî","Application_added":"application added","Application_Name":"Navê application","Application_updated":"sepanê ve","Apply_and_refresh_all_clients":"Apply û refresh hemû mişterîyên","Archive":"Archive","Archive_Unarchive":"Archive / Unarchive","are_also_typing":"ئەوانیش ئەنوسن","are_typing":"ئەنوسن","Are_you_sure":"Piştrastin?","Are_you_sure_you_want_to_delete_your_account":"Ma tu dizanî, tu dixwazî ​​hesabê te jê bibî?","Authorization_URL":"URL Authorization","Authorize":"Ercdan","AutoLinker_StripPrefix":"AutoLinker Strip pêşbendik","AutoLinker_StripPrefix_Description":"display Short. eg https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL Bîr û Regular","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Otomatîk ji bo hejmara Phone ve girêdayî ye. wek nimûne `(123) 456-7890`","Auto_Load_Images":"Load Auto Images","Available":"Berdeste","Available_agents":"ajanên tune","Avatar":"Avatar","Avatar_changed_successfully":"Avatar bi serkeftî hate guhertin","Avatar_URL":"URL Avatar","Avatar_url_invalid_or_error":"The url provided nederbasdar an gihîştina wan ne e. Ji kerema xwe re dîsa biceribîne, lê bi a url cuda.","away":"serve","Away":"Serve","away_female":"serve","Away_female":"Serve","away_male":"serve","Away_male":"Serve","Back":"Paş","Back_to_applications":"Back ji bo sepanên ji","Back_to_integrations":"گەڕانەوە بۆ تێهەڵکێشان","Back_to_login":"Back to login","Back_to_permissions":"Back to destûrên","Body":"Beden","bold":"hesabî","busy":"bikar","Busy":"Bikar","busy_female":"bikar","Busy_female":"Bikar","busy_male":"bikar","Busy_male":"Bikar","Cancel":"پوچکردنەوە","Cannot_delete_a_protected_role":"Dikarin roleke parastî jêbirin ne","Cannot_delete_role_because_its_in_use":"Dikarin roleke jêbirin, ji ber ku ew di bikaranîna ye","Cannot_invite_users_to_direct_rooms":"Dikarin bikarhêneran ji bo derhênana odeyên gazî ne","CDN_PREFIX":"CDN pêşbendik","Certificates_and_Keys":"Wesîqe û Keys","Channel":"Qenal","Channel_doesnt_exist":"Kanala `# %s` tune.","Channels":"کەناڵەکان","Channels_list":"لیستی کەناڵه گشتیەکان","Chat_Rooms":"ژوورەکانی چات","Chatops_Enabled":"çalak Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Username","Choose_a_room":"Choose a room","Choose_messages":"Hilbijartina messages","Choose_the_alias_that_will_appear_before_the_username_in_messages":"li alê ku li ber navê bikarhêner li messages wê derkevin, wê hilbijêrî.","Choose_the_username_that_this_integration_will_post_as":"ناوی بەکارهێنەرێ هەڵبژێرە کە ئەم تێهەڵکێشانە بڵاوکرێتەوە بە ناویەوە.","Clear_all_unreads_question":"Paqijkirina hemû unreads?","Client_ID":"ID Client","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Clients di çend deqeyan de refresh wê","close":"داخستن","Closed":"Girtî","Collapse_Embedded_Media_By_Default":"Hilnaweşe, medya bicîbûyî by default","coming_soon":"ji nêzda","Commands":"emrên","Compact_View":"Compact View","Confirm_password":"تێپەڕەوشەکەت پشتڕاستکەوە","Contact":"پەیوەندیەکان","Conversation":"گفتوگۆ","Convert_Ascii_Emojis":"Convert ASCII ji bo Emoji","Copied":"Kopiyek ji","COPY_TO_CLIPBOARD":"کۆپی بکە","Copy_to_clipboard":"Kopî panoyê dike","Count":"Jimartin","Create":"Xûliqandin","Create_new":"nû biafirîne","Created_at":"دروستکرا لە","Created_at_s_by_s":"Tên <strong>li %s</strong> ji <strong>aliyê %s</strong>","Custom_Fields":"Fields Custom","Custom_oauth_helper":"Dema ku avakirina Provider OAuth te, tu ê bi xwe agahdar bike a URL Callback. Bikaranîn <pre style=\";text-align:right;direction:rtl\"> %s </pre> .","Custom_oauth_unique_name":"Navê yekane OAuth Custom","Custom_Script_Logged_In":"Custom Script ji bo Bikarhênerên qeydkirî","Custom_Script_Logged_Out":"Custom Script ji bo bikarhênerên (logged out)","Dashboard":"Rojhan","days":"rojan","Deactivate":"neçalak bikî","Debug_Level":"Level Debug","Default":"Destçûnî","Delete":"Vemirandina","Delete_my_account":"Vemirandina account min","Delete_Room_Warning":"Jêbirina odeyeke dê hemû mesaj nivîsandin di nava odeya jêbirin. Ev nayê vegerandin.","Delete_User_Warning":"Jêbirina user dê hemû peyamên ji ku user wek baş bibe. Ev nayê vegerandin.","Deleted":"Deleted!","Department_not_found":"Wezareta dîtin ne","Department_removed":"Wezareta rakirin","Departments":"Bingeha Zanist","Description":"Terîf","Desktop":"Desktop","Desktop_Notification_Test":"Test agahdar bike Desktop","Desktop_Notifications":"Desktop Notifications","Desktop_Notifications_Disabled":"Desktop Notifications nivîşkan in. Tercîhên browser'î xwe eger ku we pêdivî Notifications vekirî be.","Desktop_Notifications_Enabled":"Desktop Notifications çalake bi","Direct_message_someone":"message yekî Direct","Direct_Messages":"نامەی ڕاستەوخۆ","Direct_Messages_list":"Messages direct","Disable_Favorite_Rooms":"Favorites Disable","Disable_New_Message_Notification":"Disable agahdar bike New Message","Disable_New_Room_Notification":"Disable agahdar bike Room New","Displays_action_text":"text Displays action","Do_you_want_to_change_to_s_question":"Ma tu dixwazî ​​ji bo guhertina ji <strong>bo %s?</strong>","Drop_to_upload_file":"Anima barbike","Dry_run":"بۆ خۆشی","Dry_run_description":"تەنها یەک ئیمەیڵ ئەنێرم، بۆ هەمان ئیمەیڵی ناو فۆرمەکە. ئیمەیڵەکە ئەبێ دروست بێت.","Duplicate_archived_channel_name":"An arşîvkirin Channel bi navê ' %s' de heye","Duplicate_archived_private_group_name":"An Private Pol trendê bi navê ' %s' de heye","Duplicate_private_group_name":"A Pol taybet bi navê ' %s' de heye","E-mail":"E-mail","Edit":"Weşandin","Edit_Custom_Field":"Edit Custom Field","Edit_Department":"Wezareta biguherîne","edited":"دەستکاریکرا","Email":"Email","Email_already_exists":"Email jixwe heye","Email_body":"bedena E-mail","Email_Change_Disabled":"birêveberê Rocket.Chat xwe jî guherîna email deaktîv kiriye.","Email_from":"Ji","Email_Notification_Mode":"Notifications Email is offline","Email_Notification_Mode_All":"Her qala / DM","Email_Notification_Mode_Disabled":"Bêmecel","Email_or_username":"ئیمەیڵ یان ناوی بەکارهێنەر","Email_subject":"Mijar","Email_verified":"ئیمەیڵ پشتڕاستکرایەوە","Emoji":"emoji","Empty_title":"title vala","Enable":"Bikêrkirin","Enable_Desktop_Notifications":"Sermaseya Notifications","Enabled":"çalake","Encrypted_message":"message şîfrekirin","End_OTR":"End OTR","Enter_a_regex":"a regex binivîse","Enter_a_room_name":"a bi navê odeya binivîse","Enter_a_username":"a navê bikarhêner binivîse","Enter_info":"زانیاریەکانت تێ بکە","Enter_name_here":"name li vir binivîse","Enter_to":"binivîse","Error":"Şaşî","error-cant-invite-for-direct-room":"Can user ji bo odeyên direct gazî ne","error-duplicate-channel-name":"A Channel bi navê ' %s' de heye","error-invalid-custom-field":"warê custom Invalid","error-invalid-custom-field-name":"navê qadê custom Invalid. Bikaranîna tîpên tenê, hejmar, cîwan û xêzikên.","error-invalid-password":"şîfreya çewt","error-invalid-room":"room Invalid","error-invalid-room-name":"<strong> %s</strong> e bi navê odeya ne derbasdar e, <br/> bikaranîna tîpên tenê, hejmar, cîwan û xêzikên","error-invalid-user":"user Invalid","error-invalid-username":"navê bikarhêner ê nederbasdar","error-not-allowed":"destûr ne","error-not-authorized":"destûr ne","error-remove-last-owner":"Ev cara dawî weşanê e. Ji kerema xwe re, mafî billawkrdineweyî nû li ber rakirin ev yek danîn.","error-role-name-required":"Navê rola pêwîst e","error-user-not-in-room":"Bikarhêner li vê odeyê ne","Error_changing_password":"هەڵە ڕوویدا لە گۆڕینی تێپەڕەوشە","Error_sending_confirmation_email":"Error şandina email bo piştrastkirina","Error_too_many_requests":"Error, gelek daxwazên. Ji kerema xwe ve vebin. Tu divê %s seconds berî hewl dîsa sekandin","Esc_to":"Esc to","Example_s":"Mînak: <code class=\"inline\">%s</code>","False":"şaş","Favorites":"دڵخوازەکان","Field":"Erd","Field_removed":"meydanê","File_exceeds_allowed_size_of_bytes":"Wêne dibuhure size destûr ji bytes __size__","FileUpload":"Wêne Upload","FileUpload_Enabled":"Uploads File çalake","FileUpload_File_Empty":"File vala","FileUpload_FileSystemPath":"Path System","FileUpload_MaxFileSize":"Maximum File Upload Size (in bytes)","FileUpload_MediaType_NotAccepted":"جۆری میدیا ڕێ پێدراو نیە","FileUpload_MediaTypeWhiteList":"Types Media Qebûlkirin","FileUpload_MediaTypeWhiteListDescription":"De bêhnok-cuda lîsteya cureyên medyayê. Bihêle vala ji bo qebûlkirina hemû cureyên medyayê.","FileUpload_ProtectFiles":"Parastina wêneyên barkirî","FileUpload_ProtectFilesDescription":"Tenê bikarhênerên naskirin dê bikaribin","FileUpload_S3_Acl":"acl Amazon S3","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 name list","FileUpload_S3_BucketURL":"URL List","FileUpload_S3_CDN":"domain CDN bo downloads","FileUpload_S3_Region":"Herêm","FileUpload_Storage_Type":"Type Storage","Flags":"alên","Follow_social_profiles":"لە پرۆفایلە کۆمەڵایەتیەکانمان شوێنمان کەوە، فۆرکمان بکە لە گیتهەب و بۆچوونەکانت بەش بکە دەربارەی ڕۆکێت.چات لەسەر بۆردی ترێلۆ'کەمان","Food_and_Drink":"Food & Drink","For_your_security_you_must_re_enter_your_password_to_continue":"Ji bo ewlekariya te, tu divê nasnavê xwe ji nû ve bikeve berdewam","Force_SSL":"Force SSL","Force_SSL_Description":"* Caution! * _Force SSL_ divê tu caran bê bi proxy berevajî tê bikaranîn. Eger te wêneyek proxy berevajî, divê tu beralîkirina hene do. Ev bijare ji bo êrîşên wek Heroku, ku nayê mîhengên beralîkirina li proxy berevajî destûrê ne heye.","Forgot_password":"تێپەڕەوشەت بیرچوە","Fork_it_on_github":"فۆرکی بکە لە گیتهەب","Frequently_Used":"gelek caran dihat bikaranîn","From":"Ji","From_Email":"ji Email","From_email_is_required":"Ji email pêwîst e","From_email_warning":"<b>Hişyarî:</b> Li qadê <b>From</b> mijarê ji bo mîhengên pêşkêşkara mail te ye.","General":"Giştî","Get_to_know_the_team":"Get to nas Rocket.Team","github_no_public_email":"لە هەژماری گیتهەبەکەت هیچ ئیمەیڵێکی کراوەی گشتیت نیە","Give_a_unique_name_for_the_custom_oauth":"Give a bi navê yekta ji bo OAuth custom li","Give_the_application_a_name_This_will_be_seen_by_your_users":"Bide ku sepan a name. Ev jî dê ji aliyê bikarhênerên xwe dît.","Global":"Cîhane","GoogleTagManager_id":"Google Id Manager Tag","Has_more":"bêtir","Have_your_own_chat":"تۆڕی چاتکردنی خۆتت هەبێت. پەرەپێدراو بە Meteor.com، ڕۆکێت چات بژاردەیەکی زۆر چاکە بۆ پەرەپێدەرانێک بەدوای دروستکردن و گەشەپێدانی پلاتفۆرمی چاتی خۆیاندا بگەڕێن.","Header":"header","Hidden":"veşartî","Hide_Group_Warning":"Ma tu dizanî, tu dixwazî ​​ji bo veşartina koma \" %s\"?","Hide_Private_Warning":"Ma tu dizanî, tu dixwazî ​​ji bo veşartina gotûbêjeke bi \" %s\"?","Hide_room":"شاردنەوەی ژوور","Hide_Room_Warning":"Ma tu dizanî, tu dixwazî ​​ji bo veşartina room \" %s\"?","Highlights":"Highlights","Highlights_How_To":"To hên bê dema ku yekî behsa peyv an jî komepeyva, li vir wergeran lê zêde bike. Hûn dikarin gotinên an komepeyvên me yên bi cureyên cuda cuda. Words highlight bi nusinyan ne.","Highlights_List":"peyvên highlight","History":"مێژوو","hours":"saetan","How_friendly_was_the_chat_agent":"agent chat çawa dostane bû?","How_knowledgeable_was_the_chat_agent":"agent chat çawa zana bû?","How_responsive_was_the_chat_agent":"agent chat çawa bersîva bû?","How_satisfied_were_you_with_this_chat":"Çiqas memnûn we bi vê axaftinê de bûn?","If_you_are_sure_type_in_your_password":"Eger tu bi xwe ewle type li şîfreya xwe:","If_you_are_sure_type_in_your_username":"Eger tu bi xwe ewle type li navê te in:","Importer_Archived":"arşîvkirin","Importer_done":"Importing temam!","Importer_finishing":"Despêk xwe import.","Importer_From_Description":"Imports __from welat __ 's nav Rocket.Chat.","Importer_import_cancelled":"Import betalkirin.","Importer_import_failed":"dema ku li import An error teqîn pêk hat.","Importer_importing_channels":"Importing kanalên.","Importer_importing_messages":"Importing ji mesajên.","Importer_importing_started":"Dest bi import.","Importer_importing_users":"Importing bikarhêneran.","Importer_not_defined_properly":"The împort kardike danasîn ne bû, ku wenda çîna Import.","Importer_not_in_progress":"The împort niha dixebite ne.","Importer_Prepare_Restart_Import":"Restart Import","Importer_Prepare_Start_Import":"Destpêk Importing","Importer_Prepare_Uncheck_Archived_Channels":"Channels Archived menuya","Importer_Prepare_Uncheck_Deleted_Users":"Bikarhêner li ser menuya Deleted","Importer_progress_error":"ji bo pêşketina ji bo import bi ser neket.","Importer_setup_error":"sazkirina ji împort An error teqîn pêk hat.","Incorrect_Password":"Şîfre şaştî ye","inline_code":"inline_code","Install_Extension":"Install Extension","Install_FxOs":"Install Rocket.Chat li ser Firefox te","Install_FxOs_done":"Ecêb! Tu niha dikarin bi kar Rocket.Chat di rêya icon li ser homescreen xwe. Kêfa xwe bi Rocket.Chat!","Install_FxOs_error":"Mixabin, ku ew ne dixebitin, ne wek ye, lewma! Ev çewtî re xuya bû:","Install_FxOs_follow_instructions":"Ji kerema xwe re sazkirina app ji ser amûrê xwe piştrast bike (press \"Saz Bike\" dema ku li himberî).","Installation":"Lêkirinî","Integration_added":"Integration hatiye zêdekirin","Integration_Incoming_WebHook":"تێهەڵکێشانی هاتوو لە WebHook","Integration_New":"تێهەڵکێشانی تازە","Integration_Outgoing_WebHook":"Integration WebHook nikarbe","Integration_updated":"Integration cara ghurrînikarî bi serda","Integrations":"تێهەڵکێشان","Invalid_asset":"ekîpman Invalid","Invalid_confirm_pass":"دووبارەکراوەی تێپەڕەوشە یەکناگرێتەوە لەگەڵ تێپەڕەوشە","Invalid_email":"ئیمەیڵی نوسراو هەڵەیە.","Invalid_Export_File":"The file uploaded e a% derbasdar s pela derxistinê ne.","Invalid_file_height":"height Invalid file","Invalid_file_type":"cureyê pelê Invalid","Invalid_file_width":"width Invalid file","Invalid_Import_File_Type":"cureyê pelê Import Invalid.","Invalid_name":"ناو نابێ بەتاڵ بێت","Invalid_notification_setting_s":"mîhengê notification nederbasdar: %s","Invalid_pass":"تێپەڕەوشە نابێ بەتاڵ بێت","Invalid_room_name":"<strong>%s</strong> ناوێکی دروست نیە بۆ ژوور، <br/> تەنها پیت، ژمارە و داش بەکاربهێنە","Invalid_room_type":"<strong> %s</strong> e a type odeya ne derbasdar e.","Invalid_Secret_URL":"URL Secret Invalid","Invalid_secret_URL_message":"The URL provided ne derbasdar e.","invisible":"nedît","Invisible":"Nedît","Invitation_HTML":"Dawetname HTML","Invitation_Subject":"Dawetname Subject","Invite_user_to_join_channel":"Vexwendina user yek ji bo tevlî vê kanalê","Invite_Users":"vexwendina Users","is_also_typing":"یش ئەنوسێ","is_also_typing_female":"e jî Wêrek","is_also_typing_male":"e jî Wêrek","is_typing":"ئەنوسێ","is_typing_female":"e Wêrek","is_typing_male":"e Wêrek","italics":"fer-","join":"Bihevgirêdan","Join_audio_call":"Join deng","Join_the_Community":"پەیوەندی بکە بە کۆمەڵگاکەوە","Join_the_given_channel":"Join kanala dayîn","Join_video_call":"Join banga video","Joined":"Xeydkirinê","Jump":"Helperkîn","Jump_to_first_unread":"Here cem nexwendî yekem","Jump_to_message":"Here cem message","Jump_to_recent_messages":"Here cem mesajên vê dawiyê","Katex_Enabled":"Katex çalake","Label":"Awanasî","Language":"Ziman","Language_Version":"وەشانی ئینگلیزی","Last_login":"login Last","Last_message":"دوا نامە","Last_seen":"Last dîtin","Layout":"Rêz","Layout_Home_Body":"Home Body","Layout_Home_Title":"Home Title","Layout_Login_Terms":"Login Mercên","Layout_Privacy_Policy":"Privacy Policy","Layout_Sidenav_Footer":"Side Navigation Rêza","Layout_Sidenav_Footer_description":"size footer e 260 x 70px","Layout_Terms_of_Service":"Terms of Service","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Search Custom Domain","LDAP_Custom_Domain_Search_Description":"A perçek ji JSON ku rê bind û girêdana info e û yên ku forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"hesanîyekî ji bo parvekirina yek nasnavê di navbera sites û xizmetên piralî - LDAP a nav HTMLê da heye hiyerarşîk ku gelek kompaniyên bi kar ji bo ne yek nîşanek li ser e. https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication: Ji bo agahiyên Mîhengên pêşketî û wergerandî, ji kerema xwe ve wiki me bişêwirin.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Base Domain","LDAP_Domain_Base_Description":"The Name bi temamî bi kalîte Hêja (DN) ya subtree LDAP hûn jî dixwazin ku ji bo lêgerîna bikarhênerên û komên. Hûn dikarin wek gelek wek ku hûn dixwazin lê zêde bike; Lê belê, her kom, divê li ser bingeha domain eynî wek ku bikarhênerên ku ji bo ev were terîf kirin. Ger tu komên user dibî diyar bike, tenê bikarhênerên ku endamên wan koman dê di çarçoveya be. Em tewsiye dikin ku tu di asta herî bilind de ji LDAP dara pêristeke xwe diyar bike, wek bingeha Domaina xwe û bi kar tînin Parzûna lêgerîn ji bo kontrolkirina access.","LDAP_Domain_Search_Filter":"Domain Search Filter","LDAP_Domain_Search_Filter_Description":"Ger diyarkirin, tenê bikarhênerên ku lihevhatina bi vî Parzûna bê destûr dê têkevim. Heke tu Parzûna dîyarkirin, hemû bikarhêneran di çarçoveya bingeha domain xwe bişinî dê karibin bi îmza li bin. <br/> Mînak: ji bo Active Directory `memberOf = cn = ROCKET_CHAT, ou = Giştî Groups`. <br/> Mînak: ji bo OpenLDAP (search match Extensible) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Kategorî","LDAP_Domain_Search_Object_Category_Description":"The * objectCategory * ku bikarhênerên xwe. <br/> Vala bihêlin ji bo * OpenLDAP *. <br/> Eg `person`, û hwd.","LDAP_Domain_Search_Object_Class":"Domain Class Search Object","LDAP_Domain_Search_Object_Class_Description":"The * objectclass * ku bikarhênerên xwe. <br/> Eg `organizationalPerson`,` user`, `inetOrgPerson`, û hwd.","LDAP_Domain_Search_Password":"Domain Search Password","LDAP_Domain_Search_Password_Description":"The şîfreya bikarhêner ji bo search domain.","LDAP_Domain_Search_User":"Domain Search Bikarhêner","LDAP_Domain_Search_User_Description":"The user LDAP ku performs Lookups user piştrastkirin bikarhênerên din, gava ku ew sign in. <br/> Ev account xizmeta bi taybetî ji bo integrations third-party tên afirandin e, bêhtirê. Bi kar tînin a name bi temamî bi kalîte, wek `cn = Administrator, cn = Bikarhêner, dc = mînak, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search ID'ya bikarhêner","LDAP_Domain_Search_User_ID_Description":"Çawaniya LDAP ku tê nasîn user LDAP ku hewldanên di naskirinê. Vî warî de divê `be sAMAccountName` ji bo avahîyên herî çalak Directory, lê dibe ku` uid` bo din çareseriyên LDAP, wek OpenLDAP. Tu dikarî `mail` ji bo diyarkirina by email an jî her tiştê ku wesf û tu dixwazî ​​bi kar tînin. <br> Tu dikarî nirxên multiple ji hev veqetîne de bêhnok bête bi rê bikarhênerên têkevim bikaranîna identifiers multiple wek bikarhêner an jî email bi kar tînin.","LDAP_Enable":"Bikêrkirin","LDAP_Enable_Description":"Hewldana ji bo dozeke LDAP bo piştrastkirinê.","LDAP_Encryption":"Şîfrekirin,","LDAP_Encryption_Description":"Rêbaza şîfrekirinê ji bo misogerkirina ragihandinê de ji bo server LDAP de. Bi dehan `plain` (no encryption),` SSL / LDAPS` (bi şîfre ji destpêkê), û `StartTLS` (upgrade ji bo danûstendina bi şîfre carekê ve girêdayî ye).","LDAP_Host":"Mazûban","LDAP_Host_Description":"Mêvandar LDAP, wek nimûne `ldap.example.com` an` 10.0.0.30`.","LDAP_Port":"Bender","LDAP_Port_Description":"Port bo têketina LDAP. wek nimûne: `389` an` 636` bo LDAPS","LDAP_Reject_Unauthorized":"red dikin ji boy","LDAP_Sync_User_Avatar":"Syncê User Avatar","LDAP_Sync_User_Data":"Syncê Data","LDAP_Sync_User_Data_Description":"Keep welat user di synchê bi server li ser login (wek nimûne: name, email).","LDAP_Sync_User_Data_FieldMap":"Bikarhêner Data Map Field","LDAP_Sync_User_Data_FieldMap_Description":"Mîheng bikî ka zeviyên Hesabê bikarhêner (wek email) bi ji qeyda li LDAP dijîn (cih). <br/> Wek nimûne, `{\" cn \":\" name \",\" mail \":\" email \"}` ê bi navê mirovekî mirovan xwendin ji bikarbar cn, û email xwe ji taybetiyê mail hilbijêre. <br/> zeviyên Available de `name`, û` email`.","LDAP_Sync_Users":"Bikarhêner li ser Syncê","LDAP_Test_Connection":"Connection test","LDAP_Unique_Identifier_Field":"Krom Field","LDAP_Unique_Identifier_Field_Description":"Ku qada wê were bikaranîn berve bikarhênerê LDAP û user Rocket.Chat de. Tu dikarî nirxên multiple ji hev veqetîne de bêhnok agahdar to try to get nirxa ku ji qeyda LDAP. <br/> nirxa standard e `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Bi kar tînin Custom Search Domain","LDAP_Use_Custom_Domain_Search_Description":"Hewe Parzûna xwe bi xwe ji bo bikarhênerên lêgerîn li server LDAP de.","LDAP_Username_Field":"Username Field","LDAP_Username_Field_Description":"Ku qada wê bên * username * ji bo bikarhênerên nû de tê bikaranîn. Dev ji vala bi kar username agahdar li ser rûpela têketinê. <br/> Tu dikarî tags şablonê pêk hatiye jî bi kar tînin, wek `# {givenName}. # {Sn}`. <br/> nirxa standard e `sAMAccountName`.","Leave_Group_Warning":"Ma tu dizanî, tu dixwazî ​​ji koma \" %s\" ku herin?","Leave_Private_Warning":"Ma tu dizanî, tu dixwazî ​​li gotûbêjeke bi \" %s\" ku herin?","Leave_room":"جێهێشتنی ژوور","Leave_Room_Warning":"Ma tu bawer î ku dixwazî ​​ji odê derkevin \" %s\"?","line":"xet","List_of_Direct_Messages":"List of Messages Direct","Live_sessions":"danişînên Live","Livechat_agents":"ajanên livechat","Livechat_Dashboard":"Rojhan livechat","Livechat_enabled":"livechat enabled","Livechat_Manager":"Manager livechat","Livechat_managers":"rêveberan livechat","Livechat_title":"Title livechat","Livechat_title_color":"Title livechat Background Color","Livechat_Users":"Bikarhêner li ser livechat","Load_more":"زیاتر بارکە","Loading...":"Loading ...","Loading_more_from_history":"Loading zêdetir ji dîroka","Loading_suggestion":"بژاردەکان بارئەکرێن...","Localization":"Localization","Log_File":"Nîşan bide File û Line","Log_Level":"Level bike Têkeve Têkeve","Log_Package":"Show Package","Log_View_Limit":"Têkeve View Sînora","Logged_out_of_other_clients_successfully":"Logged out of din ji mişterî bi serkeftî","Login":"چوونەژوور","Login_with":"Login bi %s","login_with":"یان بچۆ ژوورەوە بە","Logout":"Derkeve","Logout_Others":"Guftugoyê From din têketî Locations","Mail_Message_Invalid_emails":"Tu emails yek an invalid zêdetir hatine: %s","Mail_Message_Missing_to":"Divê tu yek an jî zêdetir bikarhênerên hilbijêre yan ne yek an jî zêdetir navnîşanên email, ji hev biqetîne.","Mail_Message_No_messages_selected_select_all":"Tu peyam hatine hilbijartin ne. Gelo hûn dixwazin <a href='#' class='select-all'>hilbijêrin hemû</a> mesajên xuya?","Mail_Messages":"Messages mail","Mail_Messages_Instructions":"Hilbijartina ku mesajên ku tu dixwazî ​​bişîne via email bi tikandina messages","Mail_Messages_Subject":"Here rêjeyek hilbijartî yên %s mesajên ye","Mailer":"نامەبەر","Mailer_body_tags":"Tu <b>divê</b> [derketin] ji bo link unsubscription bi kar tînin. <br /> Dibe ku tu [name], [fname] ji bo navê bikarhêner, nav an paşnav, bi rêzê ve bi kar tînin, [lname]. <br /> Dibe ku tu [email] ji bo email bikarhêner bi kar tînin.","Make_Admin":"Make Admin","Manager_added":"Manager added","Manager_removed":"Manager rakirin","Mark_as_read":"Mark wek xwendin","Markdown_Headers":"Markdown Headers","Markdown_SupportSchemesForLink":"Schemes Support Markdown bo Link","Markdown_SupportSchemesForLink_Description":"lîsteya bêhnok-cuda yên schemes destûr","Members_List":"لیستی ئەندامان","Mentions":"behsa","Mentions_default":"Behsa (default)","Message":"Agah","Message_AllowDeleting":"Destûrê bide Message Deleting","Message_AllowEditing":"Destûrê bide Message Editing","Message_AllowEditing_BlockEditInMinutes":"Block Message Editing Piştî (n) Minutes","Message_AllowEditing_BlockEditInMinutesDescription":"Enter 0 neçalak astengkirinên.","Message_AllowPinning":"Destûrê bide Message Pinning","Message_AllowPinning_Description":"Destûrê bide mesajên ku ji bo yek ji kanalên asê kirin.","Message_AllowStarring":"Destûrê bide Message Starring","Message_AudioRecorderEnabled":"Recorder Audio çalake","Message_AudioRecorderEnabledDescription":"Pêwîstî bi 'audio / wav' files to be an type medya pejirandin di nava settings 'File Upload'.","Message_DateFormat":"Date Format","Message_DateFormat_Description":"Binêre herwiha: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Message Jêbirina destûr ne","Message_editing_blocked":"Vê peyamê ne dikarin naherikin di dahatûyê de were","Message_editing_not_allowed":"guherandinê Message destûr ne","Message_GroupingPeriod":"Enîyan Period (li seconds)","Message_GroupingPeriodDescription":"Messages dê bi message berê kom eger hem ji user heman in û dema derbas kêmtir ji wê demê de agahdar in seconds bû.","Message_KeepHistory":"Keep Dîroka Message","Message_MaxAllowedSize":"Maximum Message Yorumlar Size","Message_MaxAll":"Mezinahiya herî zêde kanala ji bo HEMÛ message","Message_pinned":"Message asê","Message_pinning_not_allowed":"Message Pinning destûr ne","Message_removed":"Message rakirin","Message_ShowDeletedStatus":"Show Status Deleted","Message_ShowEditedStatus":"Nîşan Status Edited","Message_ShowFormattingTips":"Nîşan Tips Meriv","Message_TimeFormat":"Format Time","Message_TimeFormat_Description":"Binêre herwiha: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Peyam zêde dirêj","Messages":"Messages","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"ئەو نامانەی ئەنێردرێن بۆ WebHookە هاتوەکان لێرە دا ئەنرێت","Meta":"Meta","Meta_fb_app_id":"Id Facebook App","Meta_google-site-verification":"Verification Site Google","Meta_language":"Ziman","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Qûna","minutes":"minutes","Mobile_push":"push Mobile","More_channels":"کەناڵی تر","More_direct_messages":"mesajên direct More","More_groups":"komên More taybet","More_unreads":"unreads More","Msgs":"نامەکان","multi":"pir","Mute_someone_in_room":"yekî Mute di odeyê de","Mute_user":"user Mute","Muted":"devgirtî","My_Account":"My Account","n_messages":"%s نامە","N_new_messages":" %s new messages","Name":"ناو","Name_cant_be_empty":"Name ne vala be","Name_of_agent":"Name ji agent","Name_optional":"Name (ne mecbûrî ye)","Navigation_History_20_last_pages":"Dîroka Navigation (20 rûpel cara)","New_Application":"Application New","New_Custom_Field":"New Field Custom","New_Department":"Wezareta New","New_integration":"تێهەڵکێشانی تازە","New_logs":"têketinên New","New_messages":"نامە تازەکان","New_password":"تێپەڕەوشەی نوێ","New_role":"rola New","No_channel_with_name_%s_was_found":"No kanalê bi navê <strong>\" %s\"</strong> hate dîtin!","No_channels_yet":"تۆ هێشتا لە هیچ کەناڵێک نیت.","No_direct_messages_yet":"تۆ هێشتا هیچ گفتوگۆیەکت دەست پێنەکردوە.","No_Encryption":"No şîfrekirinê","No_favorites_yet":"هێشتا هیچ شتێکت دڵخواز نەکردوە.","No_group_with_name_%s_was_found":"No komeke taybet bi navê <strong>\" %s\"</strong> hate dîtin!","No_groups_yet":"هێشتا گروپی تایبەتت نیە.","No_livechats":"We tune livechats.","No_mentions_found":"No behsa dîtin","No_permission_to_view_room":"مۆڵەتت پێنەدراوە ئەم ژوورە ببینیت","No_pinned_messages":"No mesajên asê","No_results_found":"No encam hate dîtin","No_starred_messages":"No mesajên stellati","no_tokens_for_this_user":"are no geşedana bo this user hene","No_user_with_username_%s_was_found":"No user bi navê <strong>\" %s\"</strong> hate dîtin!","Not_allowed":"destûr ne","Not_authorized":"destûr ne","Not_Available":"Amade ne","Not_found_or_not_allowed":"Not Found an, nehiştin ne","Nothing":"Netişt","Nothing_found":"هیچ نەدۆزرایەوە","Notifications":"notifications","Notify_all_in_this_room":"Notify hemû di vê odeyê","Num_Agents":"# Agents","Number_of_messages":"Hejmara peyamên","OAuth_Application":"OAuth Application","OAuth_Applications":"Applications OAuth","Objects":"Objekt","Off_the_record_conversation":"Off-the-record Conversation","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record hevpeyvînekê de ye ji bo browser an amûrê xwe ne amade ne.","Offline_DM_Email":"[__site__] Te direct by __user__ messaged dîtin","Offline_Mention_Email":"[__site__] Te by __user__ li #__room__ bêşê","Old_and_new_password_must_be_different":"Di şîfreya nû de divê cuda ji şîfreya xwe yê kevin be.","Old_and_new_password_required":"Ji we re lazim ne hem şîfreya xwe yê kevin û nû ji bo guhertina şîfreya xwe.","Online":"bike","Only_errors":"tenê de çewtî","Only_you_can_see_this_message":"Tenê hûn dikarin vê peyamê bibînin","Oops!":"Oops","Open":"Vekirî","Opened":"vekirin,","Opt_out_statistics":"Ma statistics min ji bo Rocket.Chat bişîne ne","Opt_out_statistics_warning":"By şandina statîstîkên te, tu ê alîkariya me çawa gelek rewşan de ji Rocket.Chat hatine bicihkirin, bi, û herweha ka baş ji sîstema tevdigere, da em bêtir dikanin wê çêtir. Xem neke, ku tu agahî user şandin û hemû agahiyên ku em bistînin nehênî tê hilanîn. Heke tu dixwazî ​​bidomînî me statîstîkên te, check'a qutika li jor. Spas dikim.","optional":"بژاردەییە","Order":"Emir","OS_Arch":"OS Arch","OS_Cpus":"OS View CPU","OS_Freemem":"OS Memory Free","OS_Loadavg":"OS Average Load","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Teviya Bîra","OS_Type":"Type OS","OS_Uptime":"OS Uptime","others":"yên din","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR bi tenê dikarî de derbasdar e ku her du users are bike","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL Redkirin ji bo ku wêneyên barkirî bi. Ev url jî ji bo downloads eger CDN bikaranîn dayîn","Password":"تێپەڕەوشە","Password_Change_Disabled":"birêveberê Rocket.Chat xwe jî guherîna şîfreyên deaktîv kiriye.","Password_changed_successfully":"Şîfre bi serkeftî hate guhertin","Payload":"Barkêşiya","People":"Gel","Permissions":"Permissions","Pin_Message":"Pin Message","Pinned_a_message":"Pinned a message:","Pinned_Messages":"Messages Pinned","Placeholder_for_email_or_username_login_field":"Placeholder bo email an login Username warê","Placeholder_for_password_login_field":"Placeholder bo warê nasnavê xwe yê têketinê","Please_answer_survey":"Ji kerema xwe, niha bigire ku tu bersiva anketê bi lez li ser vê chat","Please_enter_value_for_url":"Ji kerema xwe re nirx ji bo url of avatar xwe binivîse.","Please_enter_your_new_password_below":"Ji kerema xwe re şîfreya xwe ya nû li jêr binivisîne:","Please_fill_a_label":"Ji kerema xwe re label tijî","Please_fill_a_name":"Xêra xwe navekî tijî","Please_fill_a_username":"Ji kerema xwe navê bikarhêner tijî","Please_fill_name_and_email":"Ji kerema xwe ve name û email tijî","Please_re_enter_your_password":"Ji kerema xwe şîfreya xwe ji nû binivîse","Please_select_enabled_yes_or_no":"Ji kerema xwe re bijare ji bo çalake hilbijêre","Please_wait":"تکایە چاوەڕێ بە","Please_wait_activation":"Tikaye kemêk çawerê bike, ev dikarin hinek dem bigire.","Please_wait_statistics":"Hêvîye pîçekê, statistics tên bipêşxistin.","Please_wait_while_OTR_is_being_established":"Hêvîye pîçekê dema OTR tê avakirin","Please_wait_while_your_account_is_being_deleted":"Hêvîye pîçekê dema hesabê te hatiye jêbirin ...","Please_wait_while_your_profile_is_being_saved":"Hêvîye pîçekê dema profîla te tê tomarkirin ...","Post_as":"بڵاویکەوە بەناوی","Post_to_Channel":"بینێر بۆ کەناڵ","Post_to_s_as_s":"Post ji <strong>bo %s</strong> <strong>wekî %s</strong>","Powered_by":"پشتبەستوو بە","Preferences":"Hemû gotar","Preferences_saved":"Preferences xilas","Privacy":"Taybetî","Private_Group":"taybet Group","Private_Groups":"گروپی تایبەت","Private_Groups_list":"List of komên taybet","Profile":"Tengal","Profile_saved_successfully":"Profîl bi serkeftin hat tomarkirin","Proudly_developed":"بە شانازیەوە گەشەی پێدراوە بە میتیۆ","Push":"Lêqellibînî","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev nasnavê","Push_apn_key":"APN Key","Push_apn_passphrase":"APN nasnavê","Push_debug":"Debug","push_disabled":"Push seqet","Push_enable":"Bikêrkirin","Push_enable_gateway":"çalak Gateway","Push_gateway":"Derî","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Hejmara Project","Push_production":"Çêkerî","Push_show_message":"Nîşan message in notification","Push_show_username_room":"Show channel / group / navê bikarhêner li notification","Push_test_push":"Îmtîhan","Query":"داواکاری","Query_description":"şert û mercên ji bo tespîtkirina ku bikarhênerên bişînin email to. bikarhênerên Unsubscribed bi xweber ji query rakirin. Ev, divê JSON derbasdar be. Mînak: \"{\" createdAt \": {\" $ gt \": {\" date $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"گەڕانی خێرا","quote":"pêşnîyarîya bedelê","Reactions":"reaksiyonên","Recents":"تازەکان","Record":"Rekor","Redirect_URI":"Beralîkirina URI","Refresh_keys":"keys Refresh","Refresh_your_page_after_install_to_enable_screen_sharing":"Wêneyê rûpel te piştî sazkirina bo çalakkirina parvekirina screen","Register":"بۆ هەژماری نوێ خۆت تۆمارکە","Registration_Succeeded":"Registration Succeeded","Remember_me":"منت بیر بێ","Remove":"لایبە","Remove_Admin":"jê Admin","Remove_as_moderator":"Jê wek moderator","Remove_as_owner":"Jê wekî ku xwediyê","Remove_custom_oauth":"Jê OAuth custom","Remove_from_room":"Jê ji odeya","Remove_someone_from_room":"Jê yek ji odeya","Removed":"rakirin","Require_password_change":"Pêwîstî bi guhertina şîfreya","Resend_verification_email":"Ji nûve email piştrastkirin","Reset":"reset bike","Reset_password":"تێپەڕەوشە دابنێرەوە","Restart":"هەڵکردنەوە","Restart_the_server":"ڕاژەکارەکە هەڵکەرەوە","RocketBot_Enabled":"RocketBot çalake","RocketBot_Name":"Navê RocketBot","RocketBot_Name_Description":"Navê RocketBot, divê navê bikarhêner derbasdar qeydkirî li ser server te re be.","Role":"Role","Role_Editing":"Role Editing","Role_removed":"Role rakirin","Room":"ژوور","Room_archivation_state":"Rewş","Room_archivation_state_false":"Jîr","Room_archivation_state_true":"arşîvkirin","Room_archived":"room arşîvkirin","room_changed_privacy":"Destê <em>__user_by__</em> <em>__room_type__:</em> type Room guherî","room_changed_topic":"Destê <em>__user_by__</em> <em>__room_topic__:</em> topic Room guherî","Room_has_been_deleted":"Room hatiye jêbirin","Room_Info":"Info room","Room_name_changed":"ناوی ژوور گۆڕدرا بۆ: <em>__room_name__</em> لەلایەن <em>__user_by__</em>","Room_name_changed_successfully":"ناوی ژوور بەسەرکەوتوویی گۆڕدرا","Room_not_found":"Room dîtin ne","Room_topic_changed_successfully":"topic odeyê de bi serkeftî hate guhertin","Room_type_changed_successfully":"type odeyê de bi serkeftî hate guhertin","Room_unarchived":"room unarchived","Room_uploaded_file_list":"Lîsteya files","Room_uploaded_file_list_empty":"No files tune.","room_user_count":" %s bikarhêneran","Rooms":"odeyên","S_new_messages_since_s":" %s mesajên nû ji ber ku %s","SAML":"SAML","SAML_Custom_Cert":"Certificate Custom","SAML_Custom_Entry_point":"Peyam Point Custom","SAML_Custom_Generate_Username":"Çêneke Username","SAML_Custom_Issuer":"belavkar Custom","SAML_Custom_Provider":"Provider Custom","Save":"پاشەکەوت","Save_changes":"save Guherandinên","Save_Mobile_Bandwidth":"Save Mobile Bandwidth","Save_to_enable_this_action":"Xilas bike ji bo çalak vê çalakiyê de","Saved":"xilas","Saving":"Saving","Scope":"di çarçoveya","Screen_Share":"screen Share","Script_Enabled":"script çalake","Search":"گەڕان","Search_by_username":"Search ji aliyê bikarhêner","Search_Channels":"Channels Search","Search_Direct_Messages":"Search Messages Direct","Search_Messages":"Messages Search","Search_Private_Groups":"Search komên taybet","Search_settings":"settings Search","seconds":"seconds","See_all":"هەموو ببینە","See_only_online":"تەنها سەرهێڵ","Select_a_department":"Select a beşa","Select_an_avatar":"avatarê Select","Select_file":"Hilbijêre file","Select_service_to_login":"Select a xizmetê ji bo têketinê Barkirina picture xwe an jî barkirina yek rasterast ji we re dibe","Select_user":"Hilbijêre user","Select_users":"bikarhênerên Hilbijêre","Selected_agents":"ajanên hilbijartî","Selected_users":"ئەندامانی هەڵبژێردراو","Send":"Şandin","Send_a_message":"Ku peyam bişînin","Send_a_test_mail_to_my_user":"Send a mail test to user min","Send_a_test_push_to_my_user":"Send a push test to user min","Send_confirmation_email":"ئیمەیڵی پشتڕاستکردنەوە بنێرە","Send_data_into_RocketChat_in_realtime":"داتا بنێر بۆ ڕۆکێت.چات بە لەهەمان کاتدا","Send_email":"Send E-mail","Send_invitation_email":"Send email vexwendina","Send_invitation_email_error":"Hûn ti email address derbas nabe.","Send_invitation_email_info":"Tu daxwaznameyê email multiple bi şûn de bişîne.","Send_invitation_email_success":"Tu bi serkeftin an email vexwendinê ji navnîşanên jêr re şandin:","Send_invitation_email_warning":"Ji bo ku bişîne emails vexwendina, divê pêşî settings SMTP mîheng bikî.","Send_Message":"نامەی نوێ","Send_your_JSON_payloads_to_this_URL":"پەیلۆدە جەیسنەکانت بنێرە بۆ ئەم URL","Sending":"Şandin ...","Set_as_moderator":"Set wek moderator","Set_as_owner":"Set wekî ku xwediyê","Settings":"Mîhengên","Settings_updated":"Settings ve","Should_be_a_URL_of_an_image":"Divê bibe URL of an image.","Should_exists_a_user_with_this_username":"ئەبێ بەکارهێنەرێ بەم ناوە هەبێت","Show_all":"nîşan bide hemû","Show_more":"Hê nîşan bide","Show_only_online":"Nîşan tenê bike","Show_preregistration_form":"Nîşan form pre-qeyda","Showing_archived_results":"<p style=\";text-align:right;direction:rtl\"> Rûpela results <b>trendê %s</b> </p>","Showing_online_users":"<b>__total_showing__</b> لە __total__ users نیشاندراوە","Showing_results":"<p>نیشاندانی <b>%s</b> ئەنجام</p>","Silence":"Bêdengî","since_creation":"لە %s ـەوە","Site_Name":"Navê Site","Site_Url":"URL Site","Site_Url_Description":"Mînak: https://chat.domain.com/","Skip":"Hilperkîn","Smileys_and_People":"Pêkenok & People","SMTP":"SMTP","SMTP_Host":"Host SMTP","SMTP_Password":"SMTP Password","SMTP_Port":"SMTP Port","SMTP_Test_Button":"Settings SMTP Test","SMTP_Username":"SMTP Username","Sound":"Rengdan","Star_Message":"Message Star","Starred_Messages":"Messages Starred","Start_audio_call":"Destpêk bi deng","Start_Chat":"Start Chat","Start_of_conversation":"سەرەتای گفتوگۆ","Start_OTR":"Serî OTR","Start_video_call":"Destpêk banga video","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Destpêk bi <code class=\"inline\">%s</code> ji bo bikarhêner an jî <code class=\"inline\">%s</code> ji bo kanala. Eg: <code class=\"inline\">%s</code> an <code class=\"inline\">%s</code>","Statistics":"Jimare","Stats_Active_Users":"Active Users","Stats_Avg_Channel_Users":"Average Users Channel","Stats_Avg_Private_Group_Users":"Average Users Group Private","Stats_Away_Users":"Bikarhêner li Away","Stats_Max_Room_Users":"Max Rooms Users","Stats_Non_Active_Users":"Bikarhêner li ser neçalak e","Stats_Offline_Users":"Bikarhêner is offline","Stats_Online_Users":"Users Online","Stats_Total_Channels":"Total Channels","Stats_Total_Direct_Messages":"Total Message Direct Rooms","Stats_Total_Messages":"Total Messages","Stats_Total_Private_Groups":"Bi tevahî komên taybet","Stats_Total_Rooms":"Total Rooms","Stats_Total_Users":"Total Users","Stop_Recording":"Stop Recording","strike":"karberdan","Subject":"Mijar","Submit":"ناردن","Success":"Serketinî","Survey":"Lêkolîn","Survey_instructions":"Pûan hev pirs li gor dilê we, 1 wateya we ne razî ne bi temamî û 5 wateya ku tu bi temamî razî ne.","Symbols":"sembol","Sync_success":"serkeftina Syncê","Sync_Users":"Bikarhêner li ser Syncê","Test_Connection":"Connection test","Test_Desktop_Notifications":"Test Desktop Notifications","Thank_you_for_your_feedback":"Spas ji bo we Deng xwe","The_application_name_is_required":"Navê sepanê pêwîst e","The_channel_name_is_required":"The name kanala pêwîst e","The_emails_are_being_sent":"Mailan têne şandin.","The_field_is_required":"Li qadê %s tê xwestin.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Mezinahiyê image xebata wê ne ji ber ku em nikarin bi durustî .Pêşîn an GraphicsMagick li ser server te sazkirin.","The_redirectUri_is_required":"The redirectUri pêwîst e","The_server_will_restart_in_s_seconds":"ڕاژەکارەکە هەڵ ئەبێتەوە لە %s چرکەدا","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Mîhengên <strong>ji %s</strong> ji <strong>bo %s</strong> mîhengkirin û hûn bi <strong>ji %s</strong> negihîne!","The_user_will_be_removed_from_s":"The user dê ji %s rakirin","The_user_wont_be_able_to_type_in_s":"The user bi wê bikaribin kes li %s","Theme":"Mijad","theme-color-action-buttons-color":"Actions bişkokan Color","theme-color-active-channel-background-color":"Active Channel Background Color","theme-color-active-channel-font-color":"Active Channel Font Color","theme-color-blockquote-background":"Blockquote Color Background","theme-color-clean-buttons-color":"Bişkokan Clean Color","theme-color-code-background":"Code Background Color","theme-color-code-border":"Code Border Color","theme-color-code-color":"Code Color","theme-color-content-background-color":"Content Color Background","theme-color-custom-scrollbar-color":"Custom scrollbar Color","theme-color-info-active-font-color":"Info çalak Font Color","theme-color-info-font-color":"Info Font Color","theme-color-input-font-color":"Input Font Color","theme-color-link-font-color":"Link Font Color","theme-color-message-hover-background-color":"Message Hover BG Color","theme-color-primary-background-color":"Primary Color Background","theme-color-primary-font-color":"Primary Font Color","theme-color-quaternary-font-color":"چار Font Color","theme-color-secondary-background-color":"Navîn Color Background","theme-color-secondary-font-color":"Navîn Font Color","theme-color-smallprint-font-color":"Biçûk Print Font Color","theme-color-smallprint-hover-color":"Biçûk Print Hover Color","theme-color-status-away":"Rewş Away Color","theme-color-status-busy":"Rewş Mijûl Color","theme-color-status-offline":"Rewş is Color","theme-color-status-online":"Bike Status Color","theme-color-tertiary-background-color":"Kirmashan Color Background","theme-color-tertiary-font-color":"Kirmashan Font Color","theme-color-unread-notification-color":"Unread Notifications Color","theme-custom-css":"CSS Custom","There_are_no_agents_added_to_this_department_yet":"are no ajanên added ji bo vê beşê yet hene.","There_are_no_integrations":"are no integrations hene","There_are_no_users_in_this_role":"ne ti bikarhêner di vê rola hene.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ev email ji niha ve hatiye bikaranîn û hatiye piştrastkirin dîtin. Ji kerema xwe şîfreya xwe biguherînê.","This_is_a_desktop_notification":"Ev notification desktop e","This_is_a_push_test_messsage":"Ev messsage test push e","Time_in_seconds":"Time in seconds","Title_bar_color":"color bar Title","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Ji bo sazkirina Rocket.Chat livechat di malpera xwe, copy & paste ev Koda jor dawî <strong></ body></strong> tag li ser malpera te.","To_users":"Bikarhêner li","Topic":"Mijar","Travel_and_Places":"Travel & Places","Trigger_removed":"Trigger rakirin","Trigger_Words":"Words Trigger","Triggers":"destpêker","True":"rast","Type":"Awa","Type_your_new_password":"Şîfreya nû xwe binivîsin","Unarchive":"Unarchive","Unmute_someone_in_room":"yekî Unmute di odeyê de","Unmute_user":"user Unmute","Unnamed":"Unnamed","Unpin_Message":"Message Unpin","Unread_Rooms":"Rooms Unread","Unread_Rooms_Mode":"Mode Rooms Unread","Unstar_Message":"jê Star","Upload_file_question":"Pelê bar bike?","Uploading_file":"Cîhek file ...","Use_account_preference":"Bi kar tînin tercîh account","Use_Emojis":"bikaranîna Emojis","Use_initials_avatar":"Bi kar tînin herfên navê te","use_menu":"مێنوی لاتەنیشت بەکاربهێنە بۆ چوونە ناو ژوور و چاتەکانت","Use_service_avatar":"Bi kar tînin %s avatar","Use_this_username":"Bi kar tînin, ev bikarhêner","Use_uploaded_avatar":"Bi kar tînin avatar barkirî","Use_url_for_avatar":"Bi kar tînin url bo avatar","User__username__is_now_a_moderator_of__room_name_":"__username__ User is now a moderator ji __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ User is now a xwediyê __room_name__","User__username__removed_from__room_name__moderators":"__username__ User ji moderator __room_name__ rakirin","User__username__removed_from__room_name__owners":"__username__ User ji xwediyên __room_name__ rakirin","User_added":"بەکارهێنەر زیادکرا","User_added_by":"بەکارهێنەر <em>__user_added__</em> زیادکرا لەلایەن <em>__user_by__</em>.\n","User_added_successfully":"Bikarhêner added bi serkeftî","User_Channels":"Channels Bikarhêner","User_doesnt_exist":"No user bi navê `@ %s` heye.","User_has_been_activated":"Bikarhêner hat çalakirin","User_has_been_deactivated":"Bikarhêner neçalakirinComment","User_has_been_deleted":"Bikarhêner hatiye jêbirin","User_has_been_muted_in_s":"Bikarhêner hatiye dîtin li %s devgirtî","User_has_been_removed_from_s":"Bikarhêner hatiye ji %s rakirin","User_has_disconnected":"Bikarhêner negirêdayî","User_Info":"User Info","User_is_no_longer_an_admin":"Bikarhêner e êdî ji admin","User_is_not_activated":"User is çalak ne","User_is_now_an_admin":"User is now an admin","User_joined_channel":"kanala bûye.","User_joined_channel_female":"kanala bûye.","User_joined_channel_male":"kanala bûye.","User_left":"کەناڵی جێهێشت.","User_left_female":"kanala derket.","User_left_male":"kanala derket.","User_logged_out":"بەکارهێنەر چوە دەرەوە","User_management":"Management Bikarhêner","User_muted_by":"<em>__user_muted__</em> User devgirtî destê <em>__user_by__.</em>","User_muted_in_room":"Bikarhêner devgirtî di odeya","User_not_found":"Bikarhêner nehat dîtin","User_not_found_or_incorrect_password":"Bikarhêner nehat dîtin an şîfreya xwe rast nenivîsandiye","User_or_channel_name":"User an kanala name","User_removed":"Bikarhêner rakirin","User_removed_by":"بەکارهێنەر <em>__user_removed__</em> لابرا لەلایەن <em>__user_by__</em>.","User_removed_from_room":"The user hatiye ji odeyê de rakirin","User_Settings":"Settings Bikarhêner","User_unmuted_by":"<em>__user_unmuted__</em> User unmuted destê <em>__user_by__.</em>","User_unmuted_in_room":"Bikarhêner unmuted di odeya","User_updated_successfully":"User bi serkeftî ve","Username":"ناوی بەکارهێنەر","Username_and_message_must_not_be_empty":"Username û message divê ne vala.","Username_cant_be_empty":"The username ne vala be","Username_Change_Disabled":"birêveberê Rocket.Chat xwe jî guherîna bikarhêneran neçalak hatiye","Username_denied_the_OTR_session":"__username__ înkar rûniştina OTR","Username_description":"The username tê bikaranîn ji bo bihêlin ku kesên din ji bo we behs li messages.","Username_doesnt_exist":"The username ` %s` tune.","Username_ended_the_OTR_session":"__username__ dawî rûniştina OTR","Username_invalid":"<strong> %s</strong> e a navê bikarhêner ne derbasdar e, <br/> bi kar tînin tenê tîp, hejmar, zanyarîyan de, cîwan û xêzikên","Username_is_already_in_here":"`@ %s` e, jixwe li vê derê.","Username_is_not_in_this_room":"The user `# %s` e di vê odeyê ne.","Username_not_found":"Bikarhêner nehate dîtin","Username_title":"Register navê bikarhêner","Username_unavaliable":"<strong> %s</strong> e already in use :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ dixwaze dest bi OTR. Ma tu dixwazî ​​ku qebûl bike?","Users":"Bikarhêner li","Users_in_role":"Bikarhêner li rola","UTF8_Names_Slugify":"نازناو بۆ ناوی UTF8","UTF8_Names_Validation":"پشتڕاستکردنەوەی ناوی UTF8","UTF8_Names_Validation_Description":"Ma characters taybet û qadên destûrê ne. û _ - Tu dikarî bi kar tînin. lê ne li dawiya navê","Verification_email_sent":"email Verification şandin","View_All":"هەموو ببینە","View_Logs":"View Têketin","Visibility":"Dîtinî","Visible":"Têdîtinî","Visitor":"Serda","Visitor_page_URL":"URL rûpel Mêvan","Visitor_time_on_site":"dem Mêvan li ser malpera","Wait_activation_warning":"Berî ku hun nikarim têkevim, hesabê xwe divê bi destan an administrator aktîfkirin.","We_are_offline_Sorry_for_the_inconvenience":"Em ne offline. Mixabin ji ber nerihetîya.","We_have_sent_password_email":"ئێمە ئیمەیڵێکمان بۆ ناردی بۆ ئەوەی تێپەڕەوشەکەت دانێیتەوە. ەگەر ئیمەیڵەکە بەم زوانە نەهات، تکایە وەرەوە و دووبارە هەوڵ بدەرەوە.","We_have_sent_registration_email":"ئێمە ئیمەیڵێکمان بۆ ناردی بۆ دڵنیاکردنەوە لە تۆمارکردنەکەت. ئەگەر ئیمەیڵەکە بەم زوانە نەهات، تکایە وەرەوە و دووبارە هەوڵ بدەرەوە.","WebRTC_Enable_Channel":"Çalak ji bo Channels Public","WebRTC_Enable_Direct":"Çalak ji bo Messages Direct","WebRTC_Enable_Private":"Çalak ji bo Channels Private","WebRTC_Servers":"Server stûn / TURN","WebRTC_Servers_Description":"A list of stûn û TURN server'î ji hev veqetîne de bêhnok. <br/> şîfreya @ Hurriyet:: Navê bikarhêner, şîfre û port bi di formata `navê bikarhêner destûr host: port` an` Username: Password @ dora: host: port`.","Welcome":"خێرهاتی <em>%s</em>.","Welcome_to_the":"خێرهاتی بۆ","will_be_able_to":"ku wê bikaribin","With_whom":"bi kê re","Yes":"Erê","Yes_clear_all":"Erê, zelal hemû!","Yes_delete_it":"Erê, wê jêbibê!","Yes_hide_it":"Erê, ew veşêrin!","Yes_leave_it":"Erê, wê bihêle!","Yes_mute_user":"Erê, user lal!","Yes_remove_user":"Erê, jê user!","you_are_in_preview_mode_of":"Tu di moda preview ya kanala # <strong>__room_name__</strong> in","You_are_logged_in_as":"Tu li ku têkevî","You_are_not_authorized_to_view_this_page":"Tu ji bo dîtina vê rûpelê destûr ne.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Tu cara xwediyê in. Ji kerema xwe, mafî billawkrdineweyî nû, berî derketina ji odeya danîn.","You_can_change_a_different_avatar_too":"Hûn dikarin ji avatar bikaranîn to post ji vê întegrasyonê override.","You_can_use_an_emoji_as_avatar":"Tu dikarî an emoji wek avatar bi kar tînin.","You_have_been_muted":"Te devgirtî û ne dikarin li vê odeyê diaxivin","You_have_not_verified_your_email":"Tu email te hatine piştrastkirin.","You_have_successfully_unsubscribed":"Tu bi serkeftin ji Lîsteya Mailling me unsubscribed.","You_informed_an_invalid_FROM_address":"Tu ji adresa an invalid agahdarkirin.","You_must_provide_the_unsubscribe_link":"Divê hûn li ser [derketin] link ne.","You_need_confirm_email":"ئەبێ ئیمەیڵەکەت پشتڕاستکەیتەوە تا بچیتە ژوور.","You_need_install_an_extension_to_allow_screen_sharing":"Divê tu ji bo sazkirina pêveka bi rê parvekirina screen","You_need_to_change_your_password":"Tu divê nasnavê xwe biguherînî","You_need_to_type_in_your_password_in_order_to_do_this":"Divê ji bo kes li şîfreya xwe ji bo vê yekê!","You_need_to_type_in_your_username_in_order_to_do_this":"Divê ji bo kes li navê te, ji bo vê yekê!","You_need_to_verifiy_your_email_address_to_get_notications":"Ji we re lazim verifiy your email address to get notifications","You_should_name_it_to_easily_manage_your_integrations":"Tu divê Navê ew bi hêsanî bi rêve integrations xwe.","You_will_not_be_able_to_recover":"Hûn ê nikaribin ji bo rêgirtina li vê peyamê!","You_will_not_be_able_to_recover_file":"Hûn ê nikaribin ji bo rêgirtina li vî wêneyî!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Tu dê bi rekûpêk bistînin ne ji ber ku we email te hatine piştrastkirin.","Your_email_has_been_queued_for_sending":"email te hatiye dîtin ji bo şandina rêz","Your_entry_has_been_deleted":"entry xwe hatiye jêbirin.","Your_file_has_been_deleted":"file te hatiye jêbirin.","Your_mail_was_sent_to_s":"nameya te ji bo %s hate şandin","Your_Open_Source_solution":"چاتی سەرچاوە کراوەی خۆت","Your_password_is_wrong":"Te şîfreya xwe ji xelet e!","Your_push_was_sent_to_s_devices":"push xwe ji bo cîhazên %s hate şandin"});
TAPi18n._registerServerTranslator("ku", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/lo.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["lo"] = ["Lao","ພາສາລາວ"];                                                                     // 8
if(_.isUndefined(TAPi18n.translations["lo"])) {                                                                        // 9
  TAPi18n.translations["lo"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["lo"][namespace])) {                                                             // 13
  TAPi18n.translations["lo"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["lo"][namespace], {"500":"Error Server ພາຍໃນ","0_Errors_Only":"0 - ຄວາມຜິດພາດພຽງແຕ່","1_Errors_and_Information":"1 - ຄວາມຜິດພາດແລະຂໍ້ມູນຂ່າວສານ","2_Erros_Information_and_Debug":"2 - ຜິດພະລາດ, ຂໍ້ມູນຂ່າວສານແລະແກ້ໄຂບັນຫາ","__username__was_set__role__by__user_by_":"__username__ ໄດ້ກໍານົດໄວ້ __role__ ໂດຍ __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ ແມ່ນບໍ່ມີຕໍ່ໄປອ​​ີກແລ້ວ __role__, ໂດຍ __user_by__","Access_not_authorized":"ການເຂົ້າເຖິງບໍ່ອະນຸຍາດ","Access_online_demo":"ການເຂົ້າເຖິງການສາທິດອອນໄລນ໌","Access_Online_Demo":"ເຂົ້າ Demo ອອນໄລນ໌","Access_Token_URL":"URL ເຂົ້າ Token","Accounts":"ບັນຊີ","Accounts_AllowDeleteOwnAccount":"ອະນຸຍາດໃຫ້ຜູ້ໃຊ້ສາມາດລຶບບັນຊີຂອງຕົນເອງ","Accounts_AllowedDomainsList":"ອະນຸຍາດໃຫ້ບັນຊີ Domains","Accounts_AllowedDomainsList_Description":"ບັນຊີລາຍຊື່ຈຸດ, ແຍກຂອງໂດເມນອະນຸຍາດໃຫ້","Accounts_AllowEmailChange":"ອະນຸຍາດໃຫ້ປ່ຽນແປງອີເມລ໌","Accounts_AllowPasswordChange":"ອະນຸຍາດໃຫ້ການປ່ຽນແປງລະຫັດຜ່ານ","Accounts_AllowUserAvatarChange":"ອະນຸຍາດໃຫ້ຜູ້ໃຊ້ Avatar ການປ່ຽນແປງ","Accounts_AllowUsernameChange":"ອະນຸຍາດໃຫ້ຊື່ຜູ້ໃຊ້ການປ່ຽນແປງ","Accounts_AllowUserProfileChange":"ອະນຸຍາດໃຫ້ການປ່ຽນແປງຂໍ້ມູນຂອງຜູ້ໃຊ້","Accounts_AvatarResize":"ປັບຂະຫນາດນົດ","Accounts_AvatarSize":"Avatar ຂະຫນາດ","Accounts_AvatarStorePath":"ເສັ້ນທາງກ້າວສູ່ຮູບສ່ວນຕົວການເກັບຮັກສາ","Accounts_AvatarStoreType":"Avatar ປະເພດການເກັບຮັກສາ","Accounts_BlockedDomainsList":"ສະກັດຊີ Domains","Accounts_BlockedDomainsList_Description":"ບັນຊີລາຍຊື່ຈຸດ, ແຍກຂອງໂດເມນກັດ","Accounts_denyUnverifiedEmail":"ປະຕິເສດອີເມວ unverified","Accounts_EmailVerification":"ການກວດສອບອີເມລ໌","Accounts_EmailVerification_Description":"ເຮັດໃຫ້ແນ່ໃຈວ່າທ່ານມີການຕັ້ງຄ່າ SMTP ທີ່ຖືກຕ້ອງທີ່ຈະນໍາໃຊ້ຄຸນນະສົມບັດນີ້","Accounts_Enrollment_Email":"ການລົງທະບຽນ E-mail","Accounts_Enrollment_Email_Description":"ທ່ານອາດຈະນໍາໃຊ້ [name], [fname], [lname] ສໍາລັບຊື່ເຕັມຂອງຜູ້ໃຊ້ໄດ້, ຊື່ທໍາອິດຫຼືຊື່ສຸດທ້າຍ, ຕາມລໍາດັບ. <br /> ທ່ານອາດຈະນໍາໃຊ້ [email] ສໍາລັບອີເມລຂອງຜູ້ໃຊ້ໄດ້.","Accounts_Iframe_api_method":"ວິທີການ Api","Accounts_Iframe_api_url":"Url Api","Accounts_iframe_enabled":"ເປີດການໃຊ້ງານ","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"ຫມົດອາຍຸເຂົ້າສູ່ລະບົບໃນວັນ","Accounts_ManuallyApproveNewUsers":"ອະນຸມັດການສະມາຊິກໃຫມ່ດ້ວຍຕົນເອງ","Accounts_OAuth_Custom_Token_Sent_Via":"Token ສົ່ງຜ່ານ","Accounts_OAuth_Custom_Authorize_Path":"ອະນຸຍາດໃຫ້ເສັ້ນທາງກ້າວສູ່","Accounts_OAuth_Custom_Button_Color":"ປຸ່ມສີ","Accounts_OAuth_Custom_Button_Label_Color":"ປຸ່ມສີຂໍ້ຄວາມ","Accounts_OAuth_Custom_Button_Label_Text":"ປຸ່ມຂໍ້ຄວາມ","Accounts_OAuth_Custom_Enable":"ເຮັດໃຫ້ສາມາດ","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"ເສັ້ນທາງກ້າວສູ່ເອກະລັກ","Accounts_OAuth_Custom_Login_Style":"ເຂົ້າສູ່ລະບົບແບບ","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"ເສັ້ນທາງກ້າວສູ່ token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"ເຟສບຸກເຂົ້າສູ່ລະບົບ","Accounts_OAuth_Facebook_callback_url":"URL ເຟສບຸກຕິດຕໍ່ກັບ","Accounts_OAuth_Facebook_id":"Id App ເຟສບຸກ","Accounts_OAuth_Facebook_secret":"ເຟສບຸກລັບ","Accounts_OAuth_Github":"OAuth ເປີດໃຊ້ວຽກ","Accounts_OAuth_Github_callback_url":"URL GitHub ໂທກັບ","Accounts_OAuth_GitHub_Enterprise":"OAuth ເປີດໃຊ້ວຽກ","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise ໂທກັບ","Accounts_OAuth_GitHub_Enterprise_id":"Id ລູກຄ້າ","Accounts_OAuth_GitHub_Enterprise_secret":"ລັບລູກຄ້າ","Accounts_OAuth_Github_id":"Id ລູກຄ້າ","Accounts_OAuth_Github_secret":"ລັບລູກຄ້າ","Accounts_OAuth_Gitlab":"OAuth ເປີດໃຊ້ວຽກ","Accounts_OAuth_Gitlab_callback_url":"URL GitLab ໂທກັບ","Accounts_OAuth_Gitlab_id":"Id GitLab","Accounts_OAuth_Gitlab_secret":"ລັບລູກຄ້າ","Accounts_OAuth_Google":"ກູໂກລະບົບ","Accounts_OAuth_Google_callback_url":"URL ກູໂກໂທກັບ","Accounts_OAuth_Google_id":"Id ກູໂກ","Accounts_OAuth_Google_secret":"ກູໂກ Secret","Accounts_OAuth_Linkedin":"LinkedIn ເຂົ້າສູ່ລະບົບ","Accounts_OAuth_Linkedin_callback_url":"URL Linkedin ໂທກັບ","Accounts_OAuth_Linkedin_id":"Id LinkedIn","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor ເຂົ້າສູ່ລະບົບ","Accounts_OAuth_Meteor_callback_url":"URL Meteor ໂທກັບ","Accounts_OAuth_Meteor_id":"Id Meteor","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter ເຂົ້າສູ່ລະບົບ","Accounts_OAuth_Twitter_callback_url":"URL Twitter ໂທກັບ","Accounts_OAuth_Twitter_id":"Id Twitter","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress ເຂົ້າສູ່ລະບົບ","Accounts_OAuth_Wordpress_callback_url":"URL Wordpress ໂທກັບ","Accounts_OAuth_Wordpress_id":"Id WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"ຕັ້ງຄ່າລະຫັດຜ່ານ","Accounts_Registration_AuthenticationServices_Enabled":"ການຈົດທະບຽນມີການບໍລິການກວດສອບ","Accounts_RegistrationForm":"ແບບ​ຟອມ​ການ​ຈົດ​ທະ​ບຽນ","Accounts_RegistrationForm_Disabled":"ຄົນພິການ","Accounts_RegistrationForm_LinkReplacementText":"ຂໍ້ຄວາມການຈົດທະບຽນແບບຟອມ Link ທົດແທນ","Accounts_RegistrationForm_Public":"ສາທາລະນະ","Accounts_RegistrationForm_Secret_URL":"URL Secret","Accounts_RegistrationForm_SecretURL":"ການລົງທະບຽນແບບຟອມ URL Secret","Accounts_RegistrationForm_SecretURL_Description":"ທ່ານຕ້ອງໄດ້ສະຫນອງການຊ່ອຍແນ່ໄປທີ່ຈະໄດ້ຮັບການເພີ່ມ URL ລົງທະບຽນຂອງທ່ານ. ຍົກຕົວຢ່າງ: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"ການຈົດທະບຽນທີ່ກໍານົດໄວ້","Accounts_RequireNameForSignUp":"ຮຽກຮ້ອງໃຫ້ຊື່ສໍາລັບສະຫມັກ","Accounts_ShowFormLogin":"ສະແດງໃຫ້ເຫັນຮູບແບບທີ່ເຂົ້າສູ່ລະບົບ","Accounts_UseDefaultBlockedDomainsList":"ການນໍາໃຊ້ມາດຕະຖານສະກັດຊີ Domains","Accounts_UseDNSDomainCheck":"ການນໍາໃຊ້ Check DNS ໂດເມນ","Activate":"ກະຕຸ້ນ","Activity":"ກິດຈະກໍາ","Add":"ຕື່ມ","Add_agent":"ຕື່ມການຕົວແທນ","Add_custom_oauth":"ເພີ່ມ OAuth custom","Add_manager":"ຕື່ມການຜູ້ຈັດການ","Add_Members":"ເພີ່ມສະມາຊິກ","Add_User":"ເພີ່ມຜູ້ໃຊ້","Add_user":"ເພີ່ມສະມາຊິກ","Add_users":"ເພີ່ມຜູ້ຊົມໃຊ້","Additional_emails":"ອີເມລເພີ່ມເຕີມ","Additional_Feedback":"ຜົນຕອບຮັບເພີ່ມເຕີມ","Administration":"ການບໍລິຫານ","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"ຫຼັງຈາກການກວດສອບ OAuth2, ຜູ້ໃຊ້ຈະໄດ້ຮັບການ redirected ກັບ URL ນີ້","Agent_added":"ຕົວແທນເຂົ້າມາ","Agent_removed":"ຕົວແທນການໂຍກຍ້າຍອອກ","Alias":"Alias","All":"ທັງຫມົດ","All_channels":"ຊ່ອງທາງການທັງຫມົດ","All_logs":"ບັນທຶກທັງຫມົດ","All_messages":"ຂໍ້ຄວາມທັງຫມົດ","Allow_Invalid_SelfSigned_Certs":"ອະນຸຍາດໃຫ້ຖືກຕ້ອງດ້ວຍຕົນເອງໄດ້ເຊັນໃບຮັບຮອງ","Allow_Invalid_SelfSigned_Certs_Description":"ອະນຸຍາດໃຫ້ບໍ່ຖືກຕ້ອງແລະຕົນເອງລົງນາມຂອງໃບຢັ້ງຢືນການ SSL ສໍາລັບການກວດສອບການເຊື່ອມຕໍ່ແລະຕົວຢ່າງ.","and":"ແລະ","And_more":"ແລະ __length ຫຼາຍ __...","Animals_and_Nature":"ສັດແລະທໍາມະຊາດ","API":"API","API_Analytics":"ການວິເຄາະ","API_Embed":"Embed","API_EmbedDisabledFor":"Embed ປິດການໃຊ້ງານສໍາລັບຜູ້ໃຊ້","API_EmbedDisabledFor_Description":"ບັນຊີລາຍຊື່ຈຸດ, ແຍກຊື່ຜູ້ໃຊ້","API_GitHub_Enterprise_URL":"URL Server","API_GitHub_Enterprise_URL_Description":"ຍົກຕົວຢ່າງ: http://domain.com (ບໍ່ລວມ trailing slash)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"URL WordPress","Appearance":"ຮູບລັກສະນະ","Application_added":"ຄໍາຮ້ອງສະຫມັກເຂົ້າມາ","Application_Name":"ຄໍາຮ້ອງສະຫມັກຊື່","Application_updated":"ຄໍາຮ້ອງສະຫມັກສະບັບປັບປຸງ","Apply_and_refresh_all_clients":"ສະຫມັກຕໍາແລະໂຫຼດຫນ້າຈໍຄືນລູກຄ້າທັງຫມົດ","Archive":"Archive","Archive_Unarchive":"Archive / Unarchive","are_also_typing":"ຍັງມີການພິມ","are_typing":"ມີການພິມ","Are_you_sure":"ເຈົ້າ​ແນ່​ໃຈ​ບໍ່?","Are_you_sure_you_want_to_delete_your_account":"ທ່ານວ່າທ່ານແມ່ນແນ່ໃຈວ່າຕ້ອງການທີ່ຈະລຶບບັນຊີຂອງທ່ານ?","Authorization_URL":"URL ການອະນຸຍາດ","Authorize":"ອະນຸຍາດ","AutoLinker_StripPrefix":"Autolink Strip Prefix","AutoLinker_StripPrefix_Description":"ສະແດງສັ້ນ. ຕົວຢ່າງ https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL Autolink","AutoLinker_UrlsRegExp":"Autolink URL ພົດປະກະຕິ","AutoLinker_Email":"Autolink Email","AutoLinker_Phone":"ໂທລະສັບ Autolink","AutoLinker_Phone_Description":"ການເຊື່ອມຕໍ່ສໍາລັບການຈໍານວນໂທລະສັບອັດຕະໂນມັດ. ຕົວຢ່າງ: `(123) 456-7890`","Auto_Load_Images":"ອັດຕະໂນມັດກໍາລັງໂຫລດຮູບ","Available":"ມີ","Available_agents":"ຕົວແທນທີ່ມີຢູ່","Avatar":"Avatar","Avatar_changed_successfully":"Avatar ການປ່ຽນແປງສົບຜົນສໍາເລັດ","Avatar_URL":"URL Avatar","Avatar_url_invalid_or_error":"url ສະຫນອງໃຫ້ແມ່ນບໍ່ຖືກຕ້ອງຫຼືບໍ່ສາມາດເຂົ້າເຖິງ. ກະລຸນາພະຍາຍາມອີກເທື່ອຫນຶ່ງ, ແຕ່ວ່າມີ url ທີ່ແຕກຕ່າງກັນ.","away":"ທັນທີ","Away":"ທັນທີ","away_female":"ທັນທີ","Away_female":"ທັນທີ","away_male":"ທັນທີ","Away_male":"ທັນທີ","Back":"ກັບຄືນໄປບ່ອນ","Back_to_applications":"ກັບຄືນໄປບ່ອນຄໍາຮ້ອງສະຫມັກ","Back_to_integrations":"ກັບຄືນໄປບ່ອນການເຊື່ອມໂຍງ","Back_to_login":"ກັບຄືນໄປບ່ອນເຂົ້າສູ່ລະບົບ","Back_to_permissions":"ກັບຄືນໄປບ່ອນການອະນຸຍາດ","Body":"ຮ່າງກາຍ","bold":"ກ້າຫານ","busy":"ຄາ​ວຽກ","Busy":"ຄາ​ວຽກ","busy_female":"ຄາ​ວຽກ","Busy_female":"ຄາ​ວຽກ","busy_male":"ຄາ​ວຽກ","Busy_male":"ຄາ​ວຽກ","Cancel":"ຍົກເລີກການ","Cannot_delete_a_protected_role":"ບໍ່ສາມາດລຶບພາລະບົດບາດປ້ອງກັນ","Cannot_delete_role_because_its_in_use":"ບໍ່ສາມາດລຶບພາລະບົດບາດເນື່ອງຈາກວ່າມັນເປັນໃນການນໍາໃຊ້","Cannot_invite_users_to_direct_rooms":"ບໍ່ສາມາດເຊີນຜູ້ໃຊ້ຫ້ອງພັກ","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"ໃບຢັ້ງຢືນການແລະຫຼັກ","Channel":"Channel","Channel_doesnt_exist":"ຊ່ອງທາງການ `# %s` ບໍ່ມີ.","Channels":"ຊ່ອງ​ທາງ​ການ","Channels_list":"ບັນຊີລາຍຊື່ຂອງຊ່ອງທາງສາທາລະນະ","Chat_Rooms":"ຫ້ອງສົນທະນາ","Chatops_Enabled":"ເຮັດໃຫ້ Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Username","Choose_a_room":"ເລືອກຫ້ອງ","Choose_messages":"ເລືອກຂໍ້ຄວາມ","Choose_the_alias_that_will_appear_before_the_username_in_messages":"ເລືອກ alias ທີ່ຈະໄປປາກົດກ່ອນທີ່ຈະຊື່ຜູ້ໃຊ້ໃນຂໍ້ຄວາມໄດ້.","Choose_the_username_that_this_integration_will_post_as":"ເລືອກຊື່ຜູ້ໃຊ້ໄດ້ວ່າການເຊື່ອມໂຍງນີ້ຈະຕອບເປັນ.","Clear_all_unreads_question":"ອະນາໄມທີ່ຍັງບໍ່ໄດ້ທັງຫມົດ?","Client_ID":"ID ລູກຄ້າ","Client_Secret":"ລັບລູກຄ້າ","Clients_will_refresh_in_a_few_seconds":"ລູກຄ້າຈະໄດ້ໂຫຼດຫນ້າຈໍຄືນໃນບໍ່ພໍເທົ່າໃດວິນາທີ","close":"ໃກ້","Closed":"ປິດ","Collapse_Embedded_Media_By_Default":"ຍຸບສື່ມວນຊົນຝັງໂດຍໃນຕອນຕົ້ນ","coming_soon":"ມາທັນທີ","Commands":"ຄໍາສັ່ງ","Compact_View":"ເບິ່ງກະທັດລັດ","Confirm_password":"ຢືນຢັນລະຫັດຜ່ານຂອງທ່ານ","Contact":"ການຕິດຕໍ່","Conversation":"ການສົນທະນາ","Convert_Ascii_Emojis":"ແປງ ASCII ກັບ Emoji","Copied":"ຄັດລອກ","COPY_TO_CLIPBOARD":"COPY ໄປທີ່ຄລິບບອດ","Copy_to_clipboard":"ສໍາເນົາເພື່ອ clipboard","Count":"ນັບ","Create":"ສ້າງ","Create_new":"ສ້າງໃຫມ່","Created_at":"ສ້າງຕັ້ງຂື້ນໃນ","Created_at_s_by_s":"<strong>ສ້າງຕັ້ງຂື້ນໃນ %s</strong> <strong>ໂດຍ %s</strong>","Custom_Fields":"ຊຸດກໍານົດຄ່າ","Custom_oauth_helper":"ໃນເວລາທີ່ການສ້າງຕັ້ງໃຫ້ບໍລິການ OAuth ຂອງທ່ານ, ທ່ານຈະຕ້ອງໄດ້ແຈ້ງ URL ໂທໄດ້. ການນໍາໃຊ້ <pre> %s </pre> .","Custom_oauth_unique_name":"ຊື່ເປັນເອກະລັກ OAuth Custom","Custom_Script_Logged_In":"Script Custom ສໍາລັບການເຂົ້າສູ່ລະບົບຜູ້ໃຊ້","Custom_Script_Logged_Out":"Script ລູກຄ້າສໍາລັບຜູ້ໃຊ້ອອກຈາກລະບົບ","Dashboard":"dashboard","days":"ວັນ","Deactivate":"ຍົກເລີກ","Debug_Level":"ລະດັບການແກ້ບັນຫາ","Default":"ມາດຕະຖານ","Delete":"ລົບ","Delete_my_account":"ລຶບບັນຊີຂອງຂ້າພະເຈົ້າ","Delete_Room_Warning":"ລົບຫ້ອງຈະລຶບຂໍ້ຄວາມທັງຫມົດຈັດພີມມາພາຍໃນຫ້ອງການ. ນີ້​ບໍ່​ສາ​ມາດ​ຍົກ​ເລີກ​ໄດ້.","Delete_User_Warning":"ລົບຜູ້ໃຊ້ຈະລຶບຂໍ້ຄວາມທັງຫມົດຈາກຜູ້ໃຊ້ທີ່ເຊັ່ນດຽວກັນ. ນີ້​ບໍ່​ສາ​ມາດ​ຍົກ​ເລີກ​ໄດ້.","Deleted":"ລົບ!","Department_not_found":"ບໍ່ໄດ້ພົບເຫັນພະແນກ","Department_removed":"ພະແນກການໂຍກຍ້າຍອອກ","Departments":"ພະແນກການ","Description":"ລາຍລະອຽດ","Desktop":"desktop","Desktop_Notification_Test":"ການທົດສອບແຈ້ງ Desktop","Desktop_Notifications":"ການແຈ້ງເຕືອນ desktop","Desktop_Notifications_Disabled":"ການແຈ້ງເຕືອນ Desktop ທີ່ປິດໃຊ້. ປ່ຽນການຕັ້ງຄ່າຂອງຕົວທ່ອງເວັບຂອງທ່ານຖ້າຫາກວ່າທ່ານຕ້ອງການແຈ້ງເປີດການໃຊ້ງານ.","Desktop_Notifications_Enabled":"ການແຈ້ງເຕືອນ Desktop ຈະເປີດໃຊ້ວຽກ","Direct_message_someone":"ຜູ້ໃດຜູ້ຫນຶ່ງຂໍ້ຄວາມໂດຍກົງ","Direct_Messages":"ຂໍ້ຄວາມໂດຍກົງ","Direct_Messages_list":"ຂໍ້ຄວາມໂດຍກົງ","Disable_Favorite_Rooms":"ປິດການໃຊ້ງານ Favorites","Disable_New_Message_Notification":"ປິດການທໍາງານໃຫມ່ຂໍ້ຄວາມແຈ້ງເຕືອນ","Disable_New_Room_Notification":"ປິດການແຈ້ງເຕືອນຫ້ອງໃຫມ່","Displays_action_text":"ຂໍ້ຄວາມສະແດງການປະຕິບັດ","Do_you_want_to_change_to_s_question":"<strong>ທ່ານຕ້ອງການທີ່ຈະມີການປ່ຽນແປງການ %s?</strong>","Drop_to_upload_file":"ການຫຼຸດລົງຂອງການອັບໂຫລດເອກະສານ","Dry_run":"ໄລຍະແຫ້ງ","Dry_run_description":"ພຽງແຕ່ຈະສົ່ງອີເມວ, ທີ່ຢູ່ເຊັ່ນດຽວກັນກັບໃນຈາກ. ອີເມວຕ້ອງຂຶ້ນກັບຜູ້ໃຊ້ທີ່ຖືກຕ້ອງ.","Duplicate_archived_channel_name":"ການເກັບ Channel ທີ່ມີຊື່ ' %s' ຢູ່","Duplicate_archived_private_group_name":"ການເກັບ Group ເອກກະຊົນທີ່ມີຊື່ ' %s' ຢູ່","Duplicate_private_group_name":"A ກຸ່ມເອກກະຊົນທີ່ມີຊື່ ' %s' ຢູ່","E-mail":"ອີເມລ໌","Edit":"ດັດແກ້","Edit_Custom_Field":"ແກ້ໄຂພາກສະຫນາມ Custom","Edit_Department":"ດັດແກ້ Department","edited":"ແກ້​ໄຂ","Email":"Email","Email_already_exists":"Email ຢູ່ແລ້ວ","Email_body":"ຮ່າງກາຍອີເມລ໌","Email_Change_Disabled":"administrator Rocket.Chat ຂອງທ່ານໄດ້ປິດການນໍາໃຊ້ການປ່ຽນແປງຂອງອີເມວ","Email_from":"ຈາກ","Email_Notification_Mode":"ການແຈ້ງເຕືອນ Email ອອຟໄລ","Email_Notification_Mode_All":"ທຸກ Mention / DM","Email_Notification_Mode_Disabled":"ຄົນພິການ","Email_or_username":"ອີ​ເມລ​ຫຼື​ຊື່​ຜູ້​ໃຊ້","Email_subject":"Subject","Email_verified":"Email ກວດສອບ","Emoji":"Emoji","Empty_title":"ຫົວຂໍ້ເປົ່າຫວ່າງ","Enable":"ເຮັດໃຫ້ສາມາດ","Enable_Desktop_Notifications":"ເຮັດໃຫ້ການແຈ້ງເຕືອນ Desktop","Enabled":"ເປີດການໃຊ້ງານ","Encrypted_message":"ຂໍ້ຄວາມທີ່ເຂົ້າລະຫັດ","End_OTR":"End OTR","Enter_a_regex":"ກະລຸນາໃສ່ regex ​​ເປັນ","Enter_a_room_name":"ກະລຸນາໃສ່ຊື່ຫ້ອງ","Enter_a_username":"ກະລຸນາໃສ່ຊື່ຜູ້ໃຊ້","Enter_info":"ກະລຸນາໃສ່ຂໍ້ມູນຂອງທ່ານ","Enter_name_here":"ກະລຸນາໃສ່ຊື່ນີ້","Enter_to":"ກະລຸນາໃສ່ທີ່","Error":"Error","error-cant-invite-for-direct-room":"ບໍ່ສາມາດເຊີນຜູ້ໃຊ້ຫ້ອງໂດຍກົງ","error-duplicate-channel-name":"A ຊ່ອງທີ່ມີຊື່ ' %s' ຢູ່","error-invalid-custom-field":"ພາກສະຫນາມທີ່ກໍາຫນົດເອງບໍ່ຖືກຕ້ອງ","error-invalid-custom-field-name":"ຊື່ພາກສະຫນາມ custom ທີ່ບໍ່ຖືກຕ້ອງ. ການນໍາໃຊ້ຕົວອັກສອນເທົ່ານັ້ນ, ຈໍານວນ, hyphens ແລະຂີດ.","error-invalid-password":"ລະຫັດຜ່ານບໍ່ຖືກຕ້ອງ","error-invalid-room":"ຫ້ອງທີ່ບໍ່ຖືກຕ້ອງ","error-invalid-room-name":"<strong> %s</strong> ບໍ່ແມ່ນຊື່ຫ້ອງທີ່ຖືກຕ້ອງ, <br/> ການນໍາໃຊ້ຕົວອັກສອນເທົ່ານັ້ນ, ຈໍານວນ, hyphens ແລະຂີດ","error-invalid-user":"ຜູ້ໃຊ້ທີ່ບໍ່ຖືກຕ້ອງ","error-invalid-username":"ຊື່​ຜູ້​ໃຊ້​ທີ່​ບໍ່​ຖືກ​ຕ້ອງ","error-not-allowed":"ບໍ່​ອະ​ນຸ​ຍາດ","error-not-authorized":"ບໍ່ອະນຸຍາດ","error-remove-last-owner":"ນີ້ເປັນເຈົ້າຂອງທີ່ຜ່ານມາ. ກະລຸນາທີ່ກໍານົດໄວ້ເປັນເຈົ້າຂອງໃຫມ່ກ່ອນທີ່ຈະຖອນຫນຶ່ງໃນນີ້.","error-role-name-required":"ຊື່ພາລະບົດບາດຈໍາເປັນຕ້ອງມີ","error-user-not-in-room":"ຜູ້ໃຊ້, ບໍ່ແມ່ນການຢູ່ໃນຫ້ອງນີ້","Error_changing_password":"Error ລະຫັດຜ່ານການປ່ຽນແປງ","Error_sending_confirmation_email":"ຄວາມຜິດພາດການສົ່ງອີເມວການຢືນຢັນ","Error_too_many_requests":"ຄວາມຜິດພາດ, ການຮ້ອງຂໍຫຼາຍເກີນໄປ. ກະລຸນາຊ້າລົງ. ທ່ານຕ້ອງລໍຖ້ານາທີ %s ກ່ອນຄວາມພະຍາຍາມອີກເທື່ອຫນຶ່ງ","Esc_to":"Esc ກັບ","Example_s":"ຍົກຕົວຢ່າງ: <code class=\"inline\">%s</code>","False":"ທີ່ບໍ່ຖືກຕ້ອງ","Favorites":"Favorites","Field":"ພາກສະຫນາມ","Field_removed":"ພາກສະຫນາມອອກ","File_exceeds_allowed_size_of_bytes":"ເອກະສານເກີນກວ່າຂະຫນາດທີ່ອະນຸຍາດ bytes __size__","FileUpload":"Upload file","FileUpload_Enabled":"ອັບໂຫຼດໄຟລ໌ທີ່ເປີດໃຊ້ວຽກ","FileUpload_File_Empty":"ເອກະສານຫວ່າງເປົ່າ","FileUpload_FileSystemPath":"ເສັ້ນທາງກ້າວສູ່ລະບົບ","FileUpload_MaxFileSize":"Upload File ສູງສຸດ Size (in bytes)","FileUpload_MediaType_NotAccepted":"ປະເພດສື່ມວນຊົນບໍ່ຍອມຮັບ","FileUpload_MediaTypeWhiteList":"ປະເພດຂອງສື່ທີ່ໄດ້ຮັບການ","FileUpload_MediaTypeWhiteListDescription":"ບັນຊີລາຍຊື່ຂອງປະເພດສື່ມວນຊົນ Comma, ແຍກອອກ. ອອກຈາກມັນເປົ່າສໍາລັບການຮັບເອົາສື່ມວນຊົນທຸກປະເພດ.","FileUpload_ProtectFiles":"ປົກປັກຮັກສາໄຟລ໌ທີ່ອັບໂຫຼດ","FileUpload_ProtectFilesDescription":"ພຽງແຕ່ຜູ້ໃຊ້ສິດຈະມີການເຂົ້າເຖິງ","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 A​​WSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 A​​WSSecretAccessKey","FileUpload_S3_Bucket":"ຊື່ bucket Amazon S3","FileUpload_S3_BucketURL":"URL Bucket","FileUpload_S3_CDN":"ໂດເມນ CDN ສໍາລັບດາວໂຫລດ","FileUpload_S3_Region":"ພູມິພາກ","FileUpload_Storage_Type":"ປະເພດການເກັບຮັກສາ","Flags":"ທຸງ","Follow_social_profiles":"ປະຕິບັດຕາມຂໍ້ມູນສັງຄົມຂອງພວກເຮົາ, ຄວາມຍາວຂອງສ້ອມພວກເຮົາກ່ຽວກັບ GitHub ແລະແບ່ງປັນຄວາມຄິດຂອງທ່ານກ່ຽວກັບ app rocket.chat ກ່ຽວກັບຄະນະ trello ຂອງພວກເຮົາ.","Food_and_Drink":"ອາຫານແລະເຄື່ອງດື່ມ","For_your_security_you_must_re_enter_your_password_to_continue":"ສໍາລັບຄວາມປອດໄພຂອງທ່ານ, ທ່ານຕ້ອງໃສ່ລະຫັດຜ່ານຂອງທ່ານທີ່ຈະສືບຕໍ່","Force_SSL":"ຜົນບັງຄັບໃຊ້ SSL","Force_SSL_Description":"* ຂໍ້ຄວນລະວັງ! _Force SSL_ ບໍ່ຄວນຈະຖືກນໍາໃຊ້ກັບຕົວແທນໄດ້ຢ່າງສິ້ນເຊີງ. ຖ້າຫາກວ່າທ່ານມີຕົວແທນໄດ້ຢ່າງສິ້ນເຊີງ, ທ່ານຄວນເຮັດແນວໃດຕົວຊີ້ທິດທາງມີ. ຕົວເລືອກນີ້ແລ້ວສໍາລັບການປະຕິບັດຄື Heroku, ວ່າບໍ່ໄດ້ອະນຸຍາດໃຫ້ການຕັ້ງຄ່າຕົວຊີ້ທິດທາງທີ່ຕົວແທນໄດ້ຢ່າງສິ້ນເຊີງ.","Forgot_password":"ລືມ​ລະ​ຫັດ​ຜ່ານ​","Fork_it_on_github":"ຄວາມຍາວຂອງສ້ອມມັນ GitHub","Frequently_Used":"ທີ່ໃຊ້ເລື້ອຍ","From":"ຈາກ","From_Email":"ຈາກ Email","From_email_is_required":"ຈາກອີເມວທີ່ຕ້ອງການ","From_email_warning":"<b>ການເຕືອນໄພ:</b> <b>ພາກສະຫນາມຈາກແມ່ນຂຶ້ນກັບການຕັ້ງຄ່າເຄື່ອງແມ່ຂ່າຍເມລຂອງທ່ານ.</b>","General":"ໂດຍທົ່ວໄປ","Get_to_know_the_team":"ໄດ້ຮັບຮູ້ໄດ້ Rocket.Team","github_no_public_email":"ທ່ານບໍ່ມີອີເມລອີເມລສາທາລະນະຢູ່ໃນບັນຊີ GitHub ຂອງທ່ານ","Give_a_unique_name_for_the_custom_oauth":"ໃຫ້ຊື່ເປັນເອກະລັກສໍາລັບການ OAuth ທີ່ກໍາຫນົດເອງ","Give_the_application_a_name_This_will_be_seen_by_your_users":"ໃຫ້ຄໍາຮ້ອງສະຫມັກຂອງຊື່. ນີ້ຈະໄດ້ຮັບການເຫັນໂດຍຜູ້ໃຊ້ຂອງທ່ານ.","Global":"Global","GoogleTagManager_id":"Id Tag Manager ກູໂກ","Has_more":"ມີຫຼາຍ","Have_your_own_chat":"ມີເວັບແຄມຂອງທ່ານເອງ. ການພັດທະນາທີ່ມີ Meteor.com, Rocket.Chat ແມ່ນເປັນການແກ້ໄຂທີ່ຍິ່ງໃຫຍ່ສໍາລັບການພັດທະນາຊອກຫາຕໍ່ກັບການກໍ່ສ້າງແລະພັດທະນາເວທີການສົນທະນາຂອງເຂົາເຈົ້າເອງ.","Header":"Header","Hidden":"ເຊື່ອງໄວ້","Hide_Group_Warning":"ທ່ານແນ່ໃຈວ່າທ່ານຕ້ອງການເພື່ອຊ່ອນກຸ່ມ \" %s\"?","Hide_Private_Warning":"ທ່ານວ່າທ່ານແມ່ນແນ່ໃຈວ່າຕ້ອງການບໍ່ໄດ້ສົນທະນາກັບ \" %s\"?","Hide_room":"hide ຫ້ອງ","Hide_Room_Warning":"ທ່ານແນ່ໃຈວ່າທ່ານຕ້ອງການເພື່ອຊ່ອນຫ້ອງ \" %s\"?","Highlights":"Highlights","Highlights_How_To":"ຮັບການແຈ້ງການໃນເວລາທີ່ຜູ້ໃດຜູ້ຫນຶ່ງໄດ້ກ່າວເຖິງເປັນຄໍາຫຼືປະໂຫຍກ, ເພີ່ມມັນທີ່ນີ້. ທ່ານສາມາດແຍກຄໍາຫຼືປະໂຫຍກດ້ວຍຈຸລະພາກ. Highlight ຄໍາສັບຕ່າງໆຍັງບໍ່ໄດ້ກໍລະນີທີ່ລະອຽດອ່ອນ.","Highlights_List":"ຄໍາ Highlight","History":"ປະຫວັດສາດ","hours":"ຊົ່ວໂມງ","How_friendly_was_the_chat_agent":"ວິທີການທີ່ເປັນຕົວແທນການສົນທະນາ?","How_knowledgeable_was_the_chat_agent":"ວິທີການມີຄວາມຮູ້ນີ້ແມ່ນຕົວແທນການສົນທະນາ?","How_responsive_was_the_chat_agent":"ວິທີການຕອບສະຫນອງນີ້ແມ່ນຕົວແທນການສົນທະນາ?","How_satisfied_were_you_with_this_chat":"ວິທີການພໍໃຈທີ່ທ່ານໄດ້ມີການສົນທະນານີ້?","If_you_are_sure_type_in_your_password":"ຖ້າຫາກວ່າທ່ານແນ່ໃຈວ່າຢູ່ໃນປະເພດລະຫັດຜ່ານຂອງທ່ານ:","If_you_are_sure_type_in_your_username":"ຖ້າຫາກວ່າທ່ານແນ່ໃຈວ່າຢູ່ໃນປະເພດຊື່ຜູ້ໃຊ້ຂອງທ່ານ:","Importer_Archived":"ທີ່ຜ່ານມາ","Importer_done":"ການນໍາເຂົ້າທີ່ສົມບູນ!","Importer_finishing":"ສໍາເລັດເຖິງການນໍາເຂົ້າ.","Importer_From_Description":"ການນໍາເຂົ້າ __from ຂໍ້ມູນ __ 's ເຂົ້າໄປໃນ Rocket.Chat.","Importer_import_cancelled":"ການນໍາເຂົ້າຍົກເລີກ.","Importer_import_failed":"ເກີດຄວາມຜິດພາດໃນຂະນະທີ່ເຮັດວຽກການນໍາເຂົ້າ.","Importer_importing_channels":"ການນໍາເຂົ້າຊ່ອງທາງການ.","Importer_importing_messages":"ການນໍາເຂົ້າຂໍ້ຄວາມໄດ້.","Importer_importing_started":"ເລີ່ມຕົ້ນການນໍາເຂົ້າ.","Importer_importing_users":"ການນໍາເຂົ້າຜູ້ຊົມໃຊ້.","Importer_not_defined_properly":"ການນໍາເຂົ້າບໍ່ໄດ້ກໍານົດຢ່າງຖືກຕ້ອງ, ມັນກໍຫາຍໄປລະດັບທີ່ສໍາຄັນ.","Importer_not_in_progress":"ທີ່ສໍາຄັນແມ່ນປັດຈຸບັນບໍ່ໄດ້ເຮັດວຽກ.","Importer_Prepare_Restart_Import":"Restart ນໍາເຂົ້າ","Importer_Prepare_Start_Import":"ເລີ່ມຕົ້ນການນໍາເຂົ້າ","Importer_Prepare_Uncheck_Archived_Channels":"Channels ປະກາດຍົກເລີກການເລືອກ","Importer_Prepare_Uncheck_Deleted_Users":"ຜູ້ໃຊ້ຍົກເລີກການເລືອກທີ່ຖືກລົບ","Importer_progress_error":"ສົບຜົນສໍາເລັດເພື່ອໃຫ້ໄດ້ຮັບຄວາມຄືບຫນ້າສໍາລັບການນໍາເຂົ້າ.","Importer_setup_error":"ເກີດຄວາມຜິດພາດໃນຂະນະທີ່ການສ້າງຕັ້ງຂຶ້ນຜູ້ນໍາເຂົ້າ.","Incorrect_Password":"ລະຫັດຜ່ານບໍ່ຖືກຕ້ອງ","inline_code":"inline_code","Install_Extension":"ການຕິດຕັ້ງ Extension","Install_FxOs":"ຕິດຕັ້ງ Rocket.Chat ໃນ Firefox ຂອງທ່ານ","Install_FxOs_done":"ທີ່ຍິ່ງໃຫຍ່! ປັດຈຸບັນທ່ານສາມາດນໍາໃຊ້ Rocket.Chat ຜ່ານ icon ໃນຫນ້າຈໍຂອງທ່ານ. ມີຄວາມມ່ວນກັບ Rocket.Chat!","Install_FxOs_error":"ຂໍອະໄພ, ບໍ່ໄດ້ເຮັດວຽກຕາມຈຸດປະສົງ! ຄວາມຜິດພາດດັ່ງຕໍ່ໄປນີ້ປາກົດວ່າ:","Install_FxOs_follow_instructions":"ກະລຸນາຢືນຢັນການຕິດຕັ້ງ app ໃນອຸປະກອນຂອງທ່ານ (ຫນັງສືພິມ \"ການຕິດຕັ້ງ\" ໃນເວລາທີ່ກະຕຸ້ນ).","Installation":"ການຕິດຕັ້ງ","Integration_added":"ການເຊື່ອມໂຍງໄດ້ຮັບການເພີ່ມ","Integration_Incoming_WebHook":"Integration WebHook ມາ","Integration_New":"ການເຊື່ອມໂຍງໃຫມ່","Integration_Outgoing_WebHook":"Integration WebHook ລາຍຈ່າຍ","Integration_updated":"ການເຊື່ອມໂຍງໄດ້ຮັບການປັບປຸງ","Integrations":"Integrations","Invalid_asset":"ຊັບສິນທີ່ບໍ່ຖືກຕ້ອງ","Invalid_confirm_pass":"ການຢືນຢັນລະຫັດຜ່ານບໍ່ກົງກັບລະຫັດຜ່ານ","Invalid_email":"ອີເມວນັ້ນບໍ່ຖືກຕ້ອງ","Invalid_Export_File":"ເອກະສານທີ່ອັບໂຫລດບໍ່ແມ່ນເອກະສານການສົ່ງອອກເປັນ% ຖືກຕ້ອງ s.","Invalid_file_height":"ລະດັບຄວາມສູງເອກະສານທີ່ບໍ່ຖືກຕ້ອງ","Invalid_file_type":"ປະເພດເອກະສານທີ່ບໍ່ຖືກຕ້ອງ","Invalid_file_width":"width ເອກະສານທີ່ບໍ່ຖືກຕ້ອງ","Invalid_Import_File_Type":"ປະເພດນໍາເຂົ້າເອກະສານທີ່ບໍ່ຖືກຕ້ອງ.","Invalid_name":"ຊື່ຕ້ອງບໍ່ເປົ່າຫວ່າງ","Invalid_notification_setting_s":"ການຕັ້ງຄ່າການແຈ້ງການບໍ່ຖືກຕ້ອງ: %s","Invalid_pass":"ລະຫັດຜ່ານຈະຕ້ອງບໍ່ເປົ່າຫວ່າງ","Invalid_room_name":"<strong> %s</strong> ບໍ່ແມ່ນຊື່ຫ້ອງທີ່ຖືກຕ້ອງ, <br/> ການນໍາໃຊ້ຕົວອັກສອນເທົ່ານັ້ນ, ຈໍານວນ, hyphens ແລະຂີດ","Invalid_room_type":"<strong> %s</strong> ບໍ່ແມ່ນປະເພດຫ້ອງພັກທີ່ຖືກຕ້ອງ.","Invalid_Secret_URL":"URL ລັບທີ່ບໍ່ຖືກຕ້ອງ","Invalid_secret_URL_message":"URL ທີ່ໃຫ້ບໍ່ຖືກຕ້ອງ.","invisible":"ທີ່ເບິ່ງບໍ່ເຫັນ","Invisible":"ທີ່ເບິ່ງບໍ່ເຫັນ","Invitation_HTML":"ການເຊື້ອເຊີນ HTML","Invitation_Subject":"ການເຊື້ອເຊີນ Subject","Invite_user_to_join_channel":"ເຊີນຜູ້ໃຊ້ຄົນຫນຶ່ງເພື່ອເຂົ້າຮ່ວມຊ່ອງທາງນີ້","Invite_Users":"ເຊີນຜູ້ໃຊ້","is_also_typing":"ນອກຈາກນີ້ຍັງພິມ","is_also_typing_female":"ນອກຈາກນີ້ຍັງພິມ","is_also_typing_male":"ນອກຈາກນີ້ຍັງພິມ","is_typing":"ເປັນການພິມ","is_typing_female":"ເປັນການພິມ","is_typing_male":"ເປັນການພິມ","italics":"italics","join":"ເຂົ້າຮ່ວມ","Join_audio_call":"ເຂົ້າຮ່ວມການໂທສຽງ","Join_the_Community":"ເຂົ້າຮ່ວມປະຊາຄົມ","Join_the_given_channel":"ເຂົ້າຮ່ວມຊ່ອງໄດ້ຮັບການ","Join_video_call":"ເຂົ້າຮ່ວມການໂທວິດີໂອ","Joined":"ເຂົ້າຮ່ວມ","Jump":"ໄປ","Jump_to_first_unread":"ໄປຫາຂໍ້ຄວາມທໍາອິດ","Jump_to_message":"ໄປຫາຂໍ້ຄວາມ","Jump_to_recent_messages":"ໄປຫາຂໍ້ຄວາມທີ່ຜ່ານມາ","Katex_Enabled":"Katex ເປີດໃຊ້ວຽກ","Label":"Label","Language":"ພາສາ","Language_Version":"ພາສາອັງກິດ Version","Last_login":"ເຂົ້າສູ່ລະບົບຫຼ້າສຸດ","Last_message":"ຂໍ້ຄວາມຫຼ້າສຸດ","Last_seen":"ເຫັນຫຼ້າສຸດ","Layout":"ຮູບແບບ","Layout_Home_Body":"Body Home","Layout_Home_Title":"ຫນ້າທໍາອິດຫົວຂໍ້","Layout_Login_Terms":"ເຂົ້າສູ່ລະບົບເງື່ອນໄຂ","Layout_Privacy_Policy":"ນະໂຍບາຍຄວາມເປັນສ່ວນຕົວ","Layout_Sidenav_Footer":"Side Navigation Footer","Layout_Sidenav_Footer_description":"ຂະຫນາດ Footer ແມ່ນ 260 x 70px","Layout_Terms_of_Service":"ເງື່ອນໄຂການໃຫ້ບໍລິການ","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"ຄົ້ນຫາ Domain Custom","LDAP_Custom_Domain_Search_Description":"A ສິ້ນຂອງ JSON ທີ່ຄວບຄຸມຂໍ້ມູນຕິດແລະການເຊື່ອມຕໍ່ແລະເປັນຮູບແບບ: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domain ມາດຕະຖານ","LDAP_Description":"LDAP ເປັນຖານຂໍ້ມູນລໍາດັບຊັ້ນທີ່ຫຼາຍບໍລິສັດນໍາໃຊ້ເພື່ອສະຫນອງການເຂົ້າສູ່ລະບົບໃນ - ສະຖານທີ່ສໍາລັບການແລກປ່ຽນລະຫັດຜ່ານຫນຶ່ງລະຫວ່າງສະຖານທີ່ແລະບໍລິການທີ່ຫຼາກຫຼາຍ. ສໍາລັບຂໍ້ມູນການຕັ້ງຄ່າຂັ້ນສູງແລະຕົວຢ່າງ, ກະລຸນາປືກສາຫາລື wiki ຂອງພວກເຮົາ: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Base ໂດເມນ","LDAP_Domain_Base_Description":"ຄຸນສົມບັດຢ່າງເຕັມສ່ວນຊື່ເພາະ (DN) ຂອງຍ່ອຍ LDAP ທ່ານຕ້ອງການຄົ້ນຫາສໍາລັບຜູ້ໃຊ້ແລະກຸ່ມ. ທ່ານສາມາດເພີ່ມເປັນຈໍານວນຫຼາຍຕາມທີ່ທ່ານຕ້ອງການ; ຢ່າງໃດກໍຕາມ, ໃນແຕ່ລະກຸ່ມຈະຕ້ອງໄດ້ຮັບການກໍານົດໄວ້ໃນຖານໂດເມນດຽວກັນຜູ້ຊົມໃຊ້ທີ່ເປັນຂອງມັນ. ຖ້າຫາກວ່າທ່ານລະບຸກຸ່ມຜູ້ໃຊ້ຈໍາກັດ, ມີພຽງແຕ່ຜູ້ໃຊ້ທີ່ຂຶ້ນກັບກຸ່ມຄົນເຫຼົ່ານັ້ນຈະຢູ່ໃນຂອບເຂດ. ພວກເຮົາແນະນໍາໃຫ້ທ່ານກໍານົດລະດັບເທິງຂອງຕົ້ນໄມ້ directory LDAP ຂອງທ່ານເປັນພື້ນຖານໂດເມນຂອງທ່ານແລະການນໍາໃຊ້ການກັ່ນຕອງການຊອກຫາທີ່ຈະຄວບຄຸມການເຂົ້າເຖິງ.","LDAP_Domain_Search_Filter":"ໂດເມນຜົນການຄົ້ນຫາ","LDAP_Domain_Search_Filter_Description":"ຖ້າກໍານົດໄວ້, ຜູ້ໃຊ້ພຽງແຕ່ຄໍາວ່າການກັ່ນຕອງນີ້ຈະໄດ້ຮັບການອະນຸຍາດໃຫ້ເຂົ້າສູ່ລະບົບ. ຖ້າຫາກວ່າບໍ່ມີການກັ່ນຕອງແມ່ນກໍານົດໄວ້, ຜູ້ຊົມໃຊ້ທັງຫມົດພາຍໃນຂອບເຂດຂອງພື້ນຖານໂດເມນທີ່ລະບຸຈະສາມາດເຂົ້າສູ່ລະບົບ. <br/> ຕົວຢ່າງ: ສໍາລັບການ Active Directory `memberOf = cn = ROCKET_CHAT, ou = General Groups`. <br/> ຕົວຢ່າງ: ສໍາລັບການ OpenLDAP (ການຊອກຫາຄໍາວ່າຂະຫຍາຍ) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"ໂດເມນຄົ້ນຫາວັດຖຸປະເພດ","LDAP_Domain_Search_Object_Category_Description":"The * * objectCategory ທີ່ລະບຸຜູ້ໃຊ້ຂອງທ່ານ. <br/> ອອກຈາກເປົ່າຫວ່າງສໍາລັບ OpenLDAP * *. <br/> ຕົວຢ່າງ: `person`, ແລະອື່ນໆ","LDAP_Domain_Search_Object_Class":"ໂດເມນ Class ຄົ້ນຫາວັດຖຸ","LDAP_Domain_Search_Object_Class_Description":"The * * objectClass ທີ່ລະບຸຜູ້ໃຊ້ຂອງທ່ານ. <br/> ຕົວຢ່າງ: `organizationalPerson`,` user`, `inetOrgPerson`, ແລະອື່ນໆ","LDAP_Domain_Search_Password":"ຄົ້ນຫາໂດເມນລະຫັດຜ່ານ","LDAP_Domain_Search_Password_Description":"ລະຫັດຜ່ານສໍາລັບຜູ້ໃຊ້ຄົ້ນຫາໂດເມນທີ່.","LDAP_Domain_Search_User":"ໂດເມນຄົ້ນຫາຜູ້ໃຊ້","LDAP_Domain_Search_User_Description":"ຜູ້ໃຊ້ LDAP ທີ່ດໍາເນີນການຄົ້ນຫາຜູ້ໃຊ້ໃນການກວດສອບຜູ້ຊົມໃຊ້ອື່ນໆໃນເວລາທີ່ພວກເຂົາເຈົ້າເຂົ້າສູ່ລະບົບ. <br/> ນີ້ແມ່ນປົກກະຕິບັນຊີການບໍລິການສ້າງໂດຍສະເພາະສໍາລັບການເຊື່ອມໂຍງພາກສ່ວນທີສາມ. ການນໍາໃຊ້ຊື່ຄົບຖ້ວນ, ເຊັ່ນດຽວກັນ, cn = Administrator, cn = ຜູ້ໃຊ້ dc = ຕົວຢ່າງ, dc = com`.","LDAP_Domain_Search_User_ID":"ຄົ້ນຫາ Domain User ID","LDAP_Domain_Search_User_ID_Description":"ການໃຫ້ເຫດຜົນ LDAP ທີ່ລະບຸຜູ້ໃຊ້ LDAP ຜູ້ທີ່ພະຍາຍາມກວດສອບ. ພາກສະຫນາມນີ້ຄວນຈະເປັນ `sAMAccountName` ສໍາລັບການຕິດຕັ້ງໃຊ້ວຽກຫຼາຍທີ່ສຸດລະບົບ, ແຕ່ວ່າມັນອາດຈະ` uid` ສໍາລັບການແກ້ໄຂບັນຫາ LDAP ອື່ນໆ, ເຊັ່ນ: OpenLDAP. ທ່ານສາມາດນໍາໃຊ້ `mail` ເພື່ອກໍານົດຜູ້ໃຊ້ອີເມລຫຼືໃດກໍ່ຕາມເຫດຜົນທີ່ທ່ານຕ້ອງການ. <br> ທ່ານສາມາດນໍາໃຊ້ຄຸນຄ່າຫລາຍຂັ້ນດ້ວຍຈໍ້າຈຸດທີ່ຈະອະນຸຍາດໃຫ້ຜູ້ໃຊ້ສາມາດເຂົ້າສູ່ລະບົບໂດຍໃຊ້ຕົວລະບຸຫຼາຍເຊັ່ນຊື່ຜູ້ໃຊ້ຫລືອີເມລ໌.","LDAP_Enable":"ເຮັດໃຫ້ສາມາດ","LDAP_Enable_Description":"ພະຍາຍາມທີ່ຈະນໍາໃຊ້ LDAP ສໍາລັບການກວດສອບ.","LDAP_Encryption":"ການເຂົ້າລະຫັດ","LDAP_Encryption_Description":"ວິທີການເຂົ້າລະຫັດທີ່ໃຊ້ໃນການຮັບປະກັນການສື່ສານກັບເຄື່ອງແມ່ຂ່າຍຂອງ LDAP. ຕົວຢ່າງລວມມີ `plain` (ບໍ່ມີການເຂົ້າລະຫັດ),` SSL / LDAPS` (ການເຂົ້າລະຫັດຈາກການເລີ່ມຕົ້ນ), ແລະ `StartTLS` (ຍົກລະດັບການສື່ສານເຂົ້າລະຫັດເຊື່ອມຕໍ່ດຽວ).","LDAP_Host":"ການເປັນເຈົ້າພາບ","LDAP_Host_Description":"ການເປັນເຈົ້າພາບ LDAP, ຕົວຢ່າງ: `ldap.example.com` ຫຼື` 10.0.0.30`.","LDAP_Port":"Port","LDAP_Port_Description":"Port ໃນການເຂົ້າເຖິງ LDAP. ຕົວຢ່າງ: `389` ຫຼື` 636` ສໍາລັບ LDAP","LDAP_Reject_Unauthorized":"ປະຕິເສດຮັບອະນຸຍາດ","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"Sync ຂໍ້ມູນ","LDAP_Sync_User_Data_Description":"ໃຫ້ເກັບຮັກສາຂໍ້ມູນຜູ້ໃຊ້ໃນ sync ກັບເຄື່ອງແມ່ຂ່າຍຂອງກ່ຽວກັບການເຂົ້າສູ່ລະບົບ (ເຊັ່ນ: ຊື່, ອີເມວ).","LDAP_Sync_User_Data_FieldMap":"ຜູ້ໃຊ້ຂໍ້ມູນພາກສະຫນາມແຜນທີ່","LDAP_Sync_User_Data_FieldMap_Description":"ກໍາຫນົດຄ່າວິທີຂົງເຂດບັນຊີຜູ້ໃຊ້ (ເຊັ່ນ: ອີ) ມີປະຊາກອນຈາກການບັນທຶກໃນ LDAP ເປັນ (ພົບເທື່ອດຽວ). <br/> ໃນຖານະເປັນຕົວຢ່າງ, `{\" cn \":\" ຊື່ \",\" ຈົດຫມາຍ \":\" ອີເມລ໌ \"}` ຈະເລືອກເອົາຊື່ຂອງບຸກຄົນມະນຸດສາມາດອ່ານໄດ້ຈາກ cn ເຫດຜົນ, ແລະອີເມລຂອງເຂົາເຈົ້າຈາກເຫດຜົນ mail ໄດ້. <br/> ທົ່ງນາທີ່ມີປະກອບມີ `name`, ແລະ` email`.","LDAP_Sync_Users":"ຜູ້ໃຊ້ Sync","LDAP_Test_Connection":"ການເຊື່ອມຕໍ່ການທົດສອບ","LDAP_Unique_Identifier_Field":"ເປັນເອກະລັກ Identifier ພາກສະຫນາມ","LDAP_Unique_Identifier_Field_Description":"ພາກສະຫນາມທີ່ຈະໄດ້ຮັບການນໍາໃຊ້ເພື່ອເຊື່ອມຕໍ່ຜູ້ໃຊ້ LDAP ແລະຜູ້ໃຊ້ Rocket.Chat ໄດ້. ທ່ານສາມາດແຈ້ງຄ່າຫລາຍຂັ້ນດ້ວຍຈໍ້າຈຸດທີ່ຈະພະຍາຍາມເພື່ອໃຫ້ໄດ້ຮັບມູນຄ່າຈາກການບັນທຶກຂອງ LDAP. <br/> ຄ່າເລີ່ມຕົ້ນຄື `objectGUID, IBM, entryUUID, ຄູ່ມື, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"ການນໍາໃຊ້ຄົ້ນຫາ Domain Custom","LDAP_Use_Custom_Domain_Search_Description":"ຂຽນກັ່ນຕອງຂອງທ່ານເອງເພື່ອຄົ້ນຫາຜູ້ໃຊ້ໃນເຄື່ອງແມ່ຂ່າຍຂອງ LDAP.","LDAP_Username_Field":"ຊື່ຜູ້ໃຊ້ພາກສະຫນາມ","LDAP_Username_Field_Description":"ພາກສະຫນາມທີ່ຈະໄດ້ຮັບການນໍາໃຊ້ເປັນຊື່ຜູ້ໃຊ້ * ສໍາລັບຜູ້ໃຊ້ໃຫມ່ *. ປ່ອຍໃຫ້ເປົ່າການນໍາໃຊ້ຊື່ຜູ້ໃຊ້ຂໍ້ມູນໃນຫນ້າເຂົ້າສູ່ລະບົບ. <br/> ທ່ານສາມາດນໍາໃຊ້ tags ແມ່ແບບເກີນໄປເຊັ່ນ: `# {givenName}. # {sn}`. <br/> ຄ່າເລີ່ມຕົ້ນຄື `sAMAccountName`.","Leave_Group_Warning":"ທ່ານແນ່ໃຈວ່າທ່ານຕ້ອງການທີ່ຈະອອກຈາກກຸ່ມ \" %s\"?","Leave_Private_Warning":"ທ່ານວ່າທ່ານແມ່ນແນ່ໃຈວ່າຕ້ອງການທີ່ຈະອອກຈາກການສົນທະນາທີ່ມີ \" %s\"?","Leave_room":"ຫ້ອງໃບ","Leave_Room_Warning":"ທ່ານແນ່ໃຈວ່າທ່ານຕ້ອງການທີ່ຈະອອກຈາກຫ້ອງ \" %s\"?","line":"ອອນໄລນ໌","List_of_Direct_Messages":"ບັນຊີລາຍຊື່ຂອງຂໍ້ຄວາມໂດຍກົງ","Live_sessions":"ກອງປະຊຸມດໍາລົງຊີວິດ","Livechat_agents":"ຕົວແທນ Livechat","Livechat_Dashboard":"Dashboard Livechat","Livechat_enabled":"Livechat ເປີດ​ໃຫ້​ໃຊ້​ງານ","Livechat_Manager":"Manager Livechat","Livechat_managers":"ຜູ້ຈັດການ Livechat","Livechat_title":"Title Livechat","Livechat_title_color":"Livechat Title ສີຄວາມເປັນມາ","Livechat_Users":"ຜູ້ໃຊ້ Livechat","Load_more":"ການໂຫຼດຫຼາຍຂຶ້ນ","Loading...":"Loading ...","Loading_more_from_history":"Loading ຫຼາຍຈາກປະຫວັດສາດ","Loading_suggestion":"ກໍາລັງໂຫລດຄໍາແນະນໍາ ...","Localization":"ທ້ອງຖິ່ນ","Log_File":"ສະແດງໃຫ້ເຫັນເອກະສານແລະ Line","Log_Level":"Level ເຂົ້າສູ່ລະບົບ","Log_Package":"ສະແດງໃຫ້ເຫັນ Package","Log_View_Limit":"ເຂົ້າສູ່ລະບົບເບິ່ງຈໍາກັດ","Logged_out_of_other_clients_successfully":"ອອກຈາກລະບົບຂອງລູກຄ້າອື່ນໆຢ່າງສໍາເລັດຜົນ","Login":"ເຂົ້າ​ສູ່​ລະ​ບົບ","Login_with":"ເຂົ້າສູ່ລະບົບ %s","login_with":"ຫລືເຂົ້າສູ່ລະບົບໂດຍກົງກັບ","Logout":"ອອກ​ຈາກ​ລະ​ບົບ","Logout_Others":"ອອກຈາກລະບົບຈາກ Logged ອື່ນ ໆ ໃນສະຖານທີ່","Mail_Message_Invalid_emails":"ທ່ານໄດ້ສະຫນອງອີຫນຶ່ງຫລືບໍ່ຖືກຕ້ອງຫຼາຍ: %s","Mail_Message_Missing_to":"ທ່ານຕ້ອງໄດ້ເລືອກເອົາຫນຶ່ງຫຼືຫຼາຍກວ່າຜູ້ໃຊ້ຫຼືສະຫນອງການຫນຶ່ງຫຼືຫຼາຍກວ່າທີ່ຢູ່ອີເມວ, ຂັ້ນດ້ວຍຈໍ້າຈຸດ.","Mail_Message_No_messages_selected_select_all":"ທ່ານຍັງບໍ່ໄດ້ເລືອກຂໍ້ຄວາມ. ທ່ານຕ້ອງການທີ່ຈະ <a href='#' class='select-all'>ເລືອກເອົາທັງຫມົດ</a> ຂໍ້ຄວາມສັງເກດເຫັນ?","Mail_Messages":"ຂໍ້ຄວາມອີເມວ","Mail_Messages_Instructions":"ເລືອກຂໍ້ຄວາມທີ່ທ່ານຕ້ອງການທີ່ຈະສົ່ງຜ່ານທາງອີເມລໂດຍການຄລິກຂໍ້ຄວາມ","Mail_Messages_Subject":"ຕໍ່ໄປນີ້ແມ່ນເປັນສ່ວນການຄັດເລືອກຂອງຂໍ້ %s","Mailer":"Mailer","Mailer_body_tags":"<b>ທ່ານຕ້ອງການນໍາໃຊ້</b> [ຍົກເລີກ] ສໍາລັບການເຊື່ອມຕໍ່ unsubscription. <br /> ທ່ານອາດຈະນໍາໃຊ້ [name], [fname], [lname] ສໍາລັບຊື່ເຕັມຂອງຜູ້ໃຊ້ໄດ້, ຊື່ທໍາອິດຫຼືຊື່ສຸດທ້າຍ, ຕາມລໍາດັບ. <br /> ທ່ານອາດຈະນໍາໃຊ້ [email] ສໍາລັບອີເມລຂອງຜູ້ໃຊ້ໄດ້.","Make_Admin":"ເຮັດໃຫ້ Admin","Manager_added":"ຜູ້ຈັດການເຂົ້າມາ","Manager_removed":"ຜູ້ຈັດການໂຍກຍ້າຍອອກ","Mark_as_read":"Mark ເປັນອ່ານ","Markdown_Headers":"markdown Headers","Markdown_SupportSchemesForLink":"ໂຄງການສະຫນັບສະຫນູນ markdown ສໍາລັບການເຊື່ອມຕໍ່","Markdown_SupportSchemesForLink_Description":"ບັນຊີລາຍຊື່ຈຸດ, ແຍກອອກຂອງໂຄງການອະນຸຍາດ","Members_List":"ບັນຊີສະມາຊິກ","Mentions":"ກ່າວເຖິງ","Mentions_default":"ກ່າວ (ມາດຕະຖານ)","Message":"ຂໍ້ຄວາມ","Message_AllowDeleting":"ອະນຸຍາດໃຫ້ຂໍ້ຄວາມລຶບ","Message_AllowEditing":"ອະນຸຍາດໃຫ້ແກ້ໄຂຂໍ້ຄວາມ","Message_AllowEditing_BlockEditInMinutes":"Block ຂໍ້ຄວາມແກ້ໄຂຫລັງຈາກ (n) ນາທີ","Message_AllowEditing_BlockEditInMinutesDescription":"ກະລຸນາໃສ່ 0 ທີ່ຈະປິດຕັນ.","Message_AllowPinning":"ອະນຸຍາດໃຫ້ຂໍ້ຄວາມ pinning","Message_AllowPinning_Description":"ອະນຸຍາດໃຫ້ຂໍ້ຄວາມທີ່ຈະໄດ້ຮັບການ pinned ກັບການໃດໆຂອງຊ່ອງທາງການ.","Message_AllowStarring":"ອະນຸຍາດໃຫ້ຂໍ້ຄວາມສະແດງ","Message_AudioRecorderEnabled":"ບັນທຶກສຽງເປີດໃຊ້ວຽກ","Message_AudioRecorderEnabledDescription":"ຮຽກຮ້ອງໃຫ້ມີ '/ wav ສຽງ' ໄຟລ໌ໄປຫາຈະເປັນປະເພດສື່ມວນຊົນຍອມຮັບພາຍໃນການຕັ້ງຄ່າ 'File Upload'.","Message_DateFormat":"ຮູບແບບວັນທີ່","Message_DateFormat_Description":"See also: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"ຂໍ້ຄວາມລົບບໍ່ອະນຸຍາດໃຫ້","Message_editing_blocked":"ຂໍ້ຄວາມນີ້ບໍ່ສາມາດໄດ້ຮັບການແກ້ໄຂອີກຕໍ່ໄປ","Message_editing_not_allowed":"ການແກ້ໄຂຂໍ້ຄວາມບໍ່ອະນຸຍາດໃຫ້","Message_GroupingPeriod":"ການຈັດກຸ່ມໄລຍະເວລາ (ວິນາທີ)","Message_GroupingPeriodDescription":"ຂໍ້ຄວາມຈະຖືກຈັດທີ່ມີຂໍ້ຄວາມທີ່ຜ່ານມາຖ້າຫາກວ່າທັງສອງແມ່ນໄດ້ມາຈາກຜູ້ໃຊ້ດຽວກັນແລະໃຊ້ເວລາ elapsed ແມ່ນຫນ້ອຍກ່ວາທີ່ໃຊ້ເວລາຂໍ້ມູນຂ່າວສານໃນວິນາທີ.","Message_KeepHistory":"ໃຫ້ເກັບຮັກສາປະຫວັດຂໍ້ຄວາມ","Message_MaxAllowedSize":"ສູງສຸດຂະຫນາດຂໍ້ຄວາມອະນຸຍາດ","Message_MaxAll":"ຂະຫນາດຊ່ອງສູງສຸດສໍາລັບຂໍ້ຄວາມທັງຫມົດ","Message_pinned":"ຂໍ້ຄວາມຕຶງ","Message_pinning_not_allowed":"ຂໍ້ຄວາມ pinning ບໍ່ອະນຸຍາດໃຫ້","Message_removed":"ຂໍ້ຄວາມການໂຍກຍ້າຍອອກ","Message_ShowDeletedStatus":"ສະແດງໃຫ້ເຫັນສະຖານະທີ່ຖືກລົບ","Message_ShowEditedStatus":"ສະແດງໃຫ້ເຫັນສະຖານະ Edited","Message_ShowFormattingTips":"ສະແດງໃຫ້ເຫັນສິ່ງທີ່ຄວນຮູ້ການຈັດຮູບແບບ","Message_TimeFormat":"ຮູບແບບທີ່ໃຊ້ເວລາ","Message_TimeFormat_Description":"See also: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"ຂໍ້ຄວາມຍາວເກີນໄປ","Messages":"ຂໍ້ຄວາມ","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"ຂໍ້ຄວາມທີ່ຖືກສົ່ງໄປທີ່ເຂົ້າມາ WebHook ຈະໄດ້ຮັບການຈັດພີມມາທີ່ນີ້.","Meta":"Meta","Meta_fb_app_id":"Id App ເຟສບຸກ","Meta_google-site-verification":"ກວດສອບເວັບໄຊກູໂກ","Meta_language":"ພາສາ","Meta_msvalidate01":"MSValidate.01","Meta_robots":"ຫຸ່ນຍົນ","minutes":"ນາທີ","Mobile_push":"ຊຸກຍູ້ການໂທລະສັບມືຖື","More_channels":"ຊ່ອງທາງເພີ່ມເຕີມ","More_direct_messages":"ຂໍ້ຄວາມໂດຍກົງ","More_groups":"ກຸ່ມເອກະຊົນຫຼາຍ","More_unreads":"ບໍ່ສາມາດອ່ານເພີ່ມເຕີມ","Msgs":"msgs","multi":"ຫຼາຍ","Mute_someone_in_room":"ຜູ້ໃດຜູ້ຫນຶ່ງ Mute ຢູ່ໃນຫ້ອງການ","Mute_user":"ຜູ້ໃຊ້ mute","Muted":"ອອກສຽງ","My_Account":"ບັນ​ຊີ​ຂອງ​ຂ້ອຍ","n_messages":"ຂໍ້ %s","N_new_messages":" %s ຂໍ້ຄວາມໃຫມ່","Name":"ຊື່","Name_cant_be_empty":"ຊື່ບໍ່ສາມາດຈະເປົ່າ","Name_of_agent":"ຊື່ຂອງຕົວແທນ","Name_optional":"ຊື່ (ທາງເລືອກອື່ນ)","Navigation_History_20_last_pages":"ປະຫວັດການນໍາທິດ (20 ຫນ້າສຸດທ້າຍ)","New_Application":"ຄໍາຮ້ອງສະຫມັກໃຫມ່","New_Custom_Field":"ມືພາກສະຫນາມ Custom ໃຫມ່","New_Department":"ພະແນກການໃຫມ່","New_integration":"ການເຊື່ອມໂຍງໃຫມ່","New_logs":"ຂໍ້ມູນບັນທຶກໃຫມ່","New_messages":"ຂໍ້ຄວາມໃຫມ່","New_password":"ລະ​ຫັດ​ຜ່ານ​ໃຫມ່","New_role":"ພາລະບົດບາດໃຫມ່","No_channel_with_name_%s_was_found":"ບໍ່ມີຊ່ອງທາງທີ່ມີຊື່ <strong>\" %s\"</strong> ໄດ້ຖືກພົບເຫັນ!","No_channels_yet":"ທ່ານບໍ່ແມ່ນສ່ວນຫນຶ່ງຂອງຊ່ອງທາງໃດ ໆ .","No_direct_messages_yet":"ທ່ານບໍ່ໄດ້ເລີ່ມຕົ້ນການສົນທະນາໃດ ໆ .","No_Encryption":"ບໍ່ມີການເຂົ້າລະຫັດ","No_favorites_yet":"ທ່ານຍັງບໍ່ໄດ້ເພີ່ມຫຼິ້ນໃດ ໆ .","No_group_with_name_%s_was_found":"ຍັງບໍ່ມີກຸ່ມເອກະຊົນທີ່ມີຊື່ <strong>\" %s\"</strong> ໄດ້ຖືກພົບເຫັນ!","No_groups_yet":"ທ່ານມີບໍ່ມີກຸ່ມເອກະຊົນບໍ່ມີ.","No_livechats":"ທ່ານມີບໍ່ມີ Livechat.","No_mentions_found":"ບໍ່ມີກ່າວເຖິງພົບ","No_permission_to_view_room":"ທ່ານບໍ່ມີສິດໃນການເບິ່ງຫ້ອງນີ້","No_pinned_messages":"ບໍ່ມີຂໍ້ຄວາມຕຶງ","No_results_found":"ບໍ່ມີຂໍ້ມູນທີ່ພົບ","No_starred_messages":"ບໍ່ມີຂໍ້ຄວາມທີ່ຕິດດາວ","no_tokens_for_this_user":"ມີ tokens ສໍາລັບຜູ້ໃຊ້ນີ້ບໍ່ມີ","No_user_with_username_%s_was_found":"ຜູ້ໃຊ້ທີ່ມີຊື່ຜູ້ໃຊ້ <strong>\" %s\"</strong> ບໍ່ໄດ້ພົບເຫັນ!","Not_allowed":"ບໍ່​ອະ​ນຸ​ຍາດ","Not_authorized":"ບໍ່ອະນຸຍາດ","Not_Available":"ບໍ່​ສາ​ມາດ​ໃຊ້​ໄດ້","Not_found_or_not_allowed":"ບໍ່ພົບຫຼືບໍ່ອະນຸຍາດ","Nothing":"ບໍ່ມີຫຍັງ","Nothing_found":"ບໍ່ມີພົບ","Notifications":"ການແຈ້ງເຕືອນ","Notify_all_in_this_room":"ແຈ້ງໃຫ້ທຸກຢູ່ໃນຫ້ອງນີ້","Num_Agents":"ຕົວແທນ #","Number_of_messages":"ຈໍານວນຂອງຂໍ້ຄວາມ","OAuth_Application":"ການນໍາໃຊ້ OAuth","OAuth_Applications":"ຄໍາຮ້ອງສະຫມັກ OAuth","Objects":"ຈຸດປະສົງ","Off_the_record_conversation":"ໄປໄດ້, ການບັນທຶກການສົນທະນາ","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"ໄປໄດ້, ການບັນທຶກການສົນທະນາແມ່ນບໍ່ສາມາດໃຊ້ສໍາລັບຕົວທ່ອງເວັບຫຼືອຸປະກອນຂອງທ່ານ.","Offline_DM_Email":"[__site__] ທ່ານໄດ້ຮັບການ messaged ໂດຍກົງໂດຍ __user__","Offline_Mention_Email":"[__site__] ທ່ານໄດ້ຮັບການທີ່ໄດ້ກ່າວມາໂດຍ __user__ ໃນ #__room__","Old_and_new_password_must_be_different":"ລະຫັດຜ່ານໃຫມ່ຕ້ອງແຕກຕ່າງຈາກລະຫັດຜ່ານອາຍຸ.","Old_and_new_password_required":"ທ່ານຈໍາເປັນຕ້ອງໃຫ້ທັງສອງລະຫັດຜ່ານເກົ່າແລະໃຫມ່ສໍາລັບການປ່ຽນແປງລະຫັດຜ່ານຂອງທ່ານ.","Online":"ອອນໄລນ໌","Only_errors":"ຄວາມຜິດພາດພຽງແຕ່","Only_you_can_see_this_message":"ພຽງແຕ່ທ່ານສາມາດເຫັນຂໍ້ຄວາມນີ້","Oops!":"Oops","Open":"ເປີດ","Opened":"ເປີດ","Opt_out_statistics":"ບໍ່ໄດ້ສົ່ງສະຖິຕິຂອງຂ້າພະເຈົ້າກັບ Rocket.Chat","Opt_out_statistics_warning":"ໂດຍການສົ່ງສະຖິຕິຂອງທ່ານ, ທ່ານຈະຊ່ວຍພວກເຮົາກໍານົດວິທີການຈໍານວນຫຼາຍກໍລະນີຂອງ Rocket.Chat ໄດ້ຖືກ deployed, ເຊັ່ນດຽວກັນກັບວິທີການທີ່ດີລະບົບການແມ່ນການປະພຶດຕົນ, ດັ່ງນັ້ນພວກເຮົາຍັງສາມາດປັບປຸງມັນ. ບໍ່ກັງວົນ, ເປັນຂໍ້ມູນຜູ້ໃຊ້ບໍ່ຖືກສົ່ງແລະຂໍ້ມູນທັງຫມົດທີ່ພວກເຮົາໄດ້ຮັບການເກັບຮັກສາໄວ້ເປັນຄວາມລັບ. ຖ້າຫາກວ່າທ່ານຕ້ອງການທີ່ຈະສືບຕໍ່ການສົ່ງພວກເຮົາສະຖິຕິຂອງທ່ານ, ຍົກເລີກການເລືອກ checkbox ຂ້າງເທິງ. ຂອບ​ໃຈ.","optional":"ທາງເລືອກ","Order":"ຄໍາສັ່ງ","OS_Arch":"OS Arch","OS_Cpus":"OS Count CPU","OS_Freemem":"OS ຫນ່ວຍຄວາມຈໍາ","OS_Loadavg":"OS Load ສະເລ່ຍ","OS_Platform":"ເວທີ OS","OS_Release":"OS Release","OS_Totalmem":"OS Memory ທັງຫມົດ","OS_Type":"ປະເພດ OS","OS_Uptime":"OS Uptime","others":"ຄົນອື່ນ","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR ແມ່ນມີພຽງແຕ່ໃນເວລາທີ່ຜູ້ໃຊ້ທັງສອງອອນໄລນ໌","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL ແທນທີ່ໄຟລ໌ໄດ້ຖືກອັບໂຫລດ. url ນີ້ຍັງສາມາດໃຊ້ສໍາລັບການດາວໂຫລດເວັ້ນເສຍແຕ່ວ່າແຄນາດາຈະໄດ້ຮັບ","Password":"ລະຫັດຜ່ານ","Password_Change_Disabled":"administrator Rocket.Chat ຂອງທ່ານໄດ້ປິດການນໍາໃຊ້ການປ່ຽນແປງຂອງລະຫັດຜ່ານ","Password_changed_successfully":"ປ່ຽນລະຫັດຜ່ານສົບຜົນສໍາເລັດ","Payload":"ອັດ","People":"ປະຊາຊົນ","Permissions":"ການອະນຸຍາດ","Pin_Message":"Pin ຂໍ້ຄວາມ","Pinned_a_message":"pinned ຂໍ້ຄວາມ:","Pinned_Messages":"ຂໍ້ຄວາມຕຶງ","Placeholder_for_email_or_username_login_field":"Placeholder ສໍາລັບອີເມລ໌ຫຼືເຂົ້າສູ່ລະບົບຊື່ຜູ້ໃຊ້ພາກສະຫນາມ","Placeholder_for_password_login_field":"Placeholder ສໍາລັບພາກສະຫນາມເຂົ້າສູ່ລະບົບລະຫັດຜ່ານ","Please_answer_survey":"ກະລຸນາໃຊ້ເວລາປັດຈຸບັນເປັນທີ່ຈະຕອບການສໍາຫຼວດໄວກ່ຽວກັບການສົນທະນານີ້","Please_enter_value_for_url":"ກະລຸນາໃສ່ຄຸນຄ່າສໍາລັບ url ຂອງນົດຂອງທ່ານ.","Please_enter_your_new_password_below":"ກະລຸນາໃສ່ລະຫັດຜ່ານໃຫມ່ຂອງທ່ານຂ້າງລຸ່ມນີ້:","Please_fill_a_label":"ກະລຸນາຕື່ມຂໍ້ມູນໃສ່ປ້າຍ","Please_fill_a_name":"ກະລຸນາຕື່ມຂໍ້ມູນໃສ່ຊື່","Please_fill_a_username":"ກະລຸນາຕື່ມຂໍ້ມູນໃສ່ຊື່ຜູ້ໃຊ້","Please_fill_name_and_email":"ກະລຸນາຕື່ມຂໍ້ມູນໃສ່ຊື່ແລະອີເມລ","Please_re_enter_your_password":"ກະລຸນາໃສ່ລະຫັດຜ່ານຂອງທ່ານ","Please_select_enabled_yes_or_no":"ກະລຸນາເລືອກເອົາທາງເລືອກສໍາລັບການເປີດໃຊ້ວຽກ","Please_wait":"ກະ​ລຸ​ນາ​ລໍ​ຖ້າ","Please_wait_activation":"ກະລຸນາລໍຖ້າ, ນີ້ສາມາດໃຊ້ເວລາທີ່ໃຊ້ເວລາບາງ.","Please_wait_statistics":"ກະລຸນາລໍຖ້າ, ສະຖິຕິແມ່ນໄດ້ຖືກສ້າງຂຶ້ນ.","Please_wait_while_OTR_is_being_established":"ກະລຸນາລໍຖ້າໃນຂະນະທີ່ OTR ຈະຖືກສ້າງຕັ້ງຂຶ້ນ","Please_wait_while_your_account_is_being_deleted":"ກະລຸນາລໍຖ້າໃນຂະນະທີ່ບັນຊີຂອງທ່ານຈະຖືກລຶບ ...","Please_wait_while_your_profile_is_being_saved":"ກະລຸນາລໍຖ້າໃນຂະນະທີ່ຂໍ້ມູນຂອງທ່ານຈະຖືກບັນທືກ ...","Post_as":"Post ເປັນ","Post_to_Channel":"ຕອບກັບ Channel","Post_to_s_as_s":"Post <strong>ການ %s</strong> <strong>ເປັນ %s</strong>","Powered_by":"ສະ​ຫນັບ​ສະ​ຫນູນ​ໂດຍ","Preferences":"ຕາມທີ່ໃຈມັກ","Preferences_saved":"ຕາມທີ່ໃຈມັກລອດ","Privacy":"ຄວາມເປັນສ່ວນຕົວ","Private_Group":"ກຸ່ມເອກະຊົນ","Private_Groups":"ກຸ່ມສົນທະນາພາກເອກະຊົນ","Private_Groups_list":"ບັນຊີລາຍຊື່ຂອງກຸ່ມເອກກະຊົນ","Profile":"ຂໍ້ມູນສ່ວນຕົວ","Profile_saved_successfully":"ຂໍ້ມູນບັນທຶກຮຽບຮ້ອຍ","Proudly_developed":"ການພັດທະນາໄຟຟ້າພູມມີ Meteor","Push":"ການຊຸກຍູ້","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"debug","push_disabled":"ຊຸກຍູ້ຄົນພິການ","Push_enable":"ເຮັດໃຫ້ສາມາດ","Push_enable_gateway":"ເຮັດໃຫ້ທາງເລືອກໃຫມ່","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"ຈໍານວນໂຄງການ GCM","Push_production":"ການຜະລິດ","Push_show_message":"ສະແດງໃຫ້ເຫັນຂໍ້ຄວາມໃນແຈ້ງການ","Push_show_username_room":"ສະແດງໃຫ້ເຫັນຊ່ອງ / ກຸ່ມ / ຊື່ຜູ້ໃຊ້ໃນການແຈ້ງເຕືອນ","Push_test_push":"ການທົດສອບ","Query":"ການສອບຖາມ","Query_description":"ເງື່ອນໄຂເພີ່ມເຕີມສໍາລັບການກໍານົດທີ່ຜູ້ໃຊ້ສາມາດສົ່ງອີເມວການ. ຜູ້ໃຊ້ຍົກເລີກຖືກໂຍກຍ້າຍອອກອັດຕະໂນມັດຈາກການສອບຖາມ. ມັນຈະຕ້ອງເປັນ JSON ຖືກຕ້ອງ. ຍົກຕົວຢ່າງ: \"{\" createdAt \": {\" $ gt \": {\" $ ວັນ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"ຄົ້ນຫາດ່ວນ","quote":"quote","Reactions":"ຕິກິລິຍາ","Recents":"ກະທູ້ຫຼ້າ","Record":"ການບັນທຶກ","Redirect_URI":"ປ່ຽນເສັ້ນທາງ URI","Refresh_keys":"ຕົວທີ່ໃຊ້ໃນການຟື້ນຟູ","Refresh_your_page_after_install_to_enable_screen_sharing":"ໂຫຼດຫນ້າຈໍຄືນຫນ້າຂອງທ່ານຫຼັງຈາກການຕິດຕັ້ງເພື່ອໃຫ້ສາມາດແລກປ່ຽນຫນ້າຈໍ","Register":"ລົງທະບຽນບັນຊີໃຫມ່","Registration_Succeeded":"ການລົງທະບຽນສົບຄວາມສໍາເລັດ","Remember_me":"ຈື່​ຂ້ອຍ","Remove":"ເອົາ","Remove_Admin":"ເອົາ Admin","Remove_as_moderator":"ເອົາເປັນ moderator","Remove_as_owner":"ເອົາເປັນເຈົ້າຂອງ","Remove_custom_oauth":"ເອົາ OAuth custom","Remove_from_room":"ອອກຈາກຫ້ອງ","Remove_someone_from_room":"ເອົາຜູ້ໃດຜູ້ຫນຶ່ງຈາກຫ້ອງການ","Removed":"ການໂຍກຍ້າຍອອກ","Require_password_change":"ຮຽກຮ້ອງໃຫ້ມີການປ່ຽນແປງລະຫັດຜ່ານ","Resend_verification_email":"ສົ່ງອີເມວການຢືນຢັນ","Reset":"ປັບ","Reset_password":"ປັບລະຫັດຜ່ານ","Restart":"ເລີ່ມ​ຕົ້ນ​ໃຫມ່","Restart_the_server":"ເລີ່ມການເຮັດວຽກຂອງເຄື່ອງແມ່ຂ່າຍ","RocketBot_Enabled":"RocketBot ເປີດໃຊ້ວຽກ","RocketBot_Name":"ຊື່ RocketBot","RocketBot_Name_Description":"ຊື່ RocketBot ຈະຕ້ອງເປັນຊື່ຜູ້ໃຊ້ທີ່ຖືກຕ້ອງລົງທະບຽນໃນເຄື່ອງແມ່ຂ່າຍຂອງທ່ານ.","Role":"ພາລະບົດບາດ","Role_Editing":"ການແກ້ໄຂພາລະບົດບາດ","Role_removed":"ພາລະບົດບາດການໂຍກຍ້າຍອອກ","Room":"ຫ້ອງ","Room_archivation_state":"State","Room_archivation_state_false":"ການເຄື່ອນໄຫວ","Room_archivation_state_true":"ທີ່ຜ່ານມາ","Room_archived":"ຫ້ອງເກັບ","room_changed_privacy":"ປະເພດຫ້ອງການປ່ຽນແປງກັບ: <em>__room_type__</em> ໂດຍ <em>__user_by__</em>","room_changed_topic":"ຫົວຂໍ້ຫ້ອງການປ່ຽນແປງກັບ: <em>__room_topic__</em> ໂດຍ <em>__user_by__</em>","Room_has_been_deleted":"ຫ້ອງໄດ້ຖືກລຶບອອກແລ້ວ","Room_Info":"ຂໍ້ມູນຫ້ອງ","Room_name_changed":"ຊື່ຫ້ອງການປ່ຽນແປງກັບ: <em>__room_name__</em> ໂດຍ <em>__user_by__</em>","Room_name_changed_successfully":"ຊື່ຫ້ອງການປ່ຽນແປງສົບຜົນສໍາເລັດ","Room_not_found":"ບໍ່ໄດ້ພົບເຫັນຫ້ອງ","Room_topic_changed_successfully":"ຫົວຂໍ້ຫ້ອງການປ່ຽນແປງສົບຜົນສໍາເລັດ","Room_type_changed_successfully":"ປະເພດຫ້ອງການປ່ຽນແປງສົບຜົນສໍາເລັດ","Room_unarchived":"ຫ້ອງຈໍານວນຫຼາຍ","Room_uploaded_file_list":"ບັນຊີໄຟລ໌","Room_uploaded_file_list_empty":"ບໍ່ມີໄຟລ໌ທີ່ມີ.","room_user_count":"ຜູ້ໃຊ້ %s","Rooms":"ຫ້ອງ","S_new_messages_since_s":" %s ຂໍ້ຄວາມໃຫມ່ນັບຕັ້ງແ​​ຕ່ %s","SAML":"SAML","SAML_Custom_Cert":"ໃບຢັ້ງຢືນທີ່ກໍາຫນົດເອງ","SAML_Custom_Entry_point":"ຈຸດ Entry Custom","SAML_Custom_Generate_Username":"ສ້າງຊື່ຜູ້ໃຊ້","SAML_Custom_Issuer":"ຜູ້ອອກ Custom","SAML_Custom_Provider":"ຜູ້ໃຫ້ບໍລິການລູກຄ້າ","Save":"ບັນທຶກ","Save_changes":"ບັນ​ທຶກ​ການ​ປ່ຽນ​ແປງ","Save_Mobile_Bandwidth":"ບັນທຶກໂທລະສັບມືຖື Bandwidth","Save_to_enable_this_action":"ຊ່ວຍປະຢັດທີ່ຈະເຮັດໃຫ້ການປະຕິບັດນີ້","Saved":"ບັນທຶກໄວ້","Saving":"ຝາກປະຢັດ","Scope":"ຂອບເຂດ","Screen_Share":"ຫນ້າຈໍ Share","Script_Enabled":"script ເປີດໃຊ້ວຽກ","Search":"ຄົ້ນຫາ","Search_by_username":"ຄົ້ນຫາໂດຍຊື່ຜູ້ໃຊ້","Search_Channels":"ຊ່ອງຄົ້ນຫາ","Search_Direct_Messages":"ຄົ້ນຫາຂໍ້ຄວາມໂດຍກົງ","Search_Messages":"ການຄົ້ນຫາ","Search_Private_Groups":"ຄົ້ນຫາກຸ່ມເອກກະຊົນ","Search_settings":"ການຕັ້ງຄ່າການຄົ້ນຫາ","seconds":"ວິນາທີ","See_all":"ເບິ່ງທັງຫມົດ","See_only_online":"ອອນໄລນ໌ພຽງແຕ່","Select_a_department":"ເລືອກຂອງພະແນກ","Select_an_avatar":"ຄັດເລືອກເອົານົດ","Select_file":"ເລືອກໄຟລ໌","Select_service_to_login":"ເລືອກການບໍລິການເຂົ້າສູ່ລະບົບເພື່ອການໂຫຼດຮູບພາບຂອງທ່ານຫລືອັບໂຫລດຫນຶ່ງໂດຍກົງຈາກຄອມພິວເຕີຂອງທ່ານ","Select_user":"ເລືອກຜູ້ໃຊ້","Select_users":"ເລືອກຜູ້ໃຊ້","Selected_agents":"ຕົວແທນທີ່ເລືອກ","Selected_users":"ສະມາຊິກທີ່ເລືອກ","Send":"ສົ່ງ","Send_a_message":"ສົ່ງຂໍ້ຄວາມ","Send_a_test_mail_to_my_user":"ສົ່ງອີເມວການທົດສອບໃຫ້ກັບຜູ້ໃຊ້ຂອງຂ້າພະເຈົ້າ","Send_a_test_push_to_my_user":"ສົ່ງເປັນການຊຸກຍູ້ການທົດສອບກັບຜູ້ໃຊ້ຂອງຂ້າພະເຈົ້າ","Send_confirmation_email":"ສົ່ງອີເມວການຢືນຢັນ","Send_data_into_RocketChat_in_realtime":"ສົ່ງຂໍ້ມູນເຂົ້າໄປໃນ Rocket.Chat ໃນທີ່ແທ້ຈິງທີ່ໃຊ້ເວລາ.","Send_email":"ສົ່ງອີເມລ໌","Send_invitation_email":"ສົ່ງອີເມວການເຊື້ອເຊີນ","Send_invitation_email_error":"ທ່ານຍັງບໍ່ໄດ້ສະຫນອງໃຫ້ທີ່ຢູ່ອີເມວທີ່ຖືກຕ້ອງ.","Send_invitation_email_info":"ທ່ານສາມາດສົ່ງການເຊື້ອເຊີນອີເມວໃນເວລາດຽວ.","Send_invitation_email_success":"ທ່ານໄດ້ຖືກສົ່ງສົບຜົນສໍາເລັດອີເມວເຊີນຊວນໄປຫາທີ່ຢູ່ດັ່ງຕໍ່ໄປນີ້:","Send_invitation_email_warning":"ໃນຄໍາສັ່ງທີ່ຈະສົ່ງອີເມວການເຊື້ອເຊີນ, ທ່ານທໍາອິດທີ່ຈະຕ້ອງ configure ປັບຄ່າ SMTP.","Send_Message":"ສົ່ງ​ຂໍ້​ຄວາມ","Send_your_JSON_payloads_to_this_URL":"ສົ່ງອັດ JSON ຂອງທ່ານກັບ URL ນີ້.","Sending":"ການສົ່ງ ...","Set_as_moderator":"ກໍານົດເປັນ moderator","Set_as_owner":"ກໍານົດເປັນເຈົ້າຂອງ","Settings":"ການຕັ້ງຄ່າ","Settings_updated":"ການຕັ້ງຄ່າສະບັບປັບປຸງ","Should_be_a_URL_of_an_image":"ຄວນຈະ URL ຂອງຮູບພາບທີ່ເປັນ.","Should_exists_a_user_with_this_username":"ຜູ້ໃຊ້ຕ້ອງມີຢູ່ແລ້ວ.","Show_all":"ສະແດງໃຫ້ເຫັນທັງຫມົດ","Show_more":"ສະແດງໃຫ້ເຫັນຫຼາຍ","Show_only_online":"ສະແດງໃຫ້ເຫັນພຽງແຕ່ອອນໄລນ໌","Show_preregistration_form":"ສະແດງໃຫ້ເຫັນຮູບແບບທາງສ່ວນຫນ້າຂອງການຈົດທະບຽນ","Showing_archived_results":"<p> <b>ສະແດງໃຫ້ເຫັນຜົນໄດ້ຮັບທີ່ເກັບ %s</b> </p>","Showing_online_users":"ສະແດງໃຫ້ເຫັນ <b>__total_showing__</b> ຂອງຜູ້ຊົມໃຊ້ __total__","Showing_results":"<p> <b>ສະແດງໃຫ້ເຫັນຜົນໄດ້ຮັບ %s</b> </p>","Silence":"silence","since_creation":"ນັບຕັ້ງແ​​ຕ່ %s","Site_Name":"ຊື່ເວັບໄຊ","Site_Url":"URL ຂອງເວັບໄຊ","Site_Url_Description":"ຍົກຕົວຢ່າງ: https://chat.domain.com/","Skip":"ຂ້າມ","Smileys_and_People":"ຮອຍຍິ້ມແລະປະຊາຊົນ","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"ລະຫັດຜ່ານ SMTP","SMTP_Port":"SMTP Port","SMTP_Test_Button":"ການຕັ້ງຄ່າການທົດສອບ SMTP","SMTP_Username":"SMTP Username","Sound":"ສຽງ","Star_Message":"Star ຂໍ້ຄວາມ","Starred_Messages":"ຂໍ້ຄວາມສະແດງ","Start_audio_call":"ເລີ່ມຕົ້ນການໂທສຽງ","Start_Chat":"ການ​ເລີ່ມ​ຕົ້ນ​ສົນ​ທະ​ນາ","Start_of_conversation":"ການເລີ່ມຕົ້ນຂອງການສົນທະນາ","Start_OTR":"ການເລີ່ມຕົ້ນ OTR","Start_video_call":"ເລີ່ມຕົ້ນວິດີໂອ","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"ເລີ່ມຕົ້ນດ້ວຍການ <code class=\"inline\">%s</code> ສໍາລັບຜູ້ໃຊ້ຫລື <code class=\"inline\">%s</code> ສໍາລັບຊ່ອງທາງການ. ຕົວຢ່າງ: <code class=\"inline\">%s</code> ຫລື <code class=\"inline\">%s</code>","Statistics":"ສະຖິຕິ","Stats_Active_Users":"ຜູ້ໃຊ້","Stats_Avg_Channel_Users":"ຜູ້ໃຊ້ Channel ສະເລ່ຍປະຈໍາ","Stats_Avg_Private_Group_Users":"ສະເລ່ຍປະຈໍາ Users Group ເອກກະຊົນ","Stats_Away_Users":"ຜູ້ໃຊ້ທັນທີ","Stats_Max_Room_Users":"Max ຜູ້ໃຊ້ຫ້ອງ","Stats_Non_Active_Users":"ຜູ້ໃຊ້ບໍ່ໄດ້ໃຊ້ວຽກ","Stats_Offline_Users":"ຜູ້ໃຊ້ອອຟໄລ","Stats_Online_Users":"ຜູ້ໃຊ້ອອນໄລນ໌","Stats_Total_Channels":"Channels ທັງຫມົດ","Stats_Total_Direct_Messages":"ທັງຫມົດຫ້ອງຂໍ້ຄວາມໂດຍກົງ","Stats_Total_Messages":"ຂໍ້ຄວາມທັງຫມົດ","Stats_Total_Private_Groups":"ທັງຫມົດກຸ່ມເອກກະຊົນ","Stats_Total_Rooms":"ນວນຫ້ອງທັງຫມົດ","Stats_Total_Users":"ຜູ້ໃຊ້ທັງຫມົດ","Stop_Recording":"ຢຸດການບັນທຶກ","strike":"ປະທ້ວງ","Subject":"Subject","Submit":"ຍື່ນສະເຫນີ","Success":"ຄວາມສໍາເລັດ","Survey":"ການສໍາຫຼວດ","Survey_instructions":"ອັດຕາຄໍາຖາມແຕ່ລະຄົນຕາມຄວາມເພິ່ງພໍໃຈຂອງທ່ານ, 1 ຊຶ່ງຫມາຍຄວາມວ່າທ່ານບໍ່ພໍໃຈຢ່າງສົມບູນແລະ 5 ຊຶ່ງຫມາຍຄວາມວ່າທ່ານພໍໃຈຫມົດ.","Symbols":"ສັນຍາລັກ","Sync_success":"ຜົນສໍາເລັດ Sync","Sync_Users":"ຜູ້ໃຊ້ Sync","Test_Connection":"ການເຊື່ອມຕໍ່ການທົດສອບ","Test_Desktop_Notifications":"ການທົດສອບການແຈ້ງເຕືອນ Desktop","Thank_you_for_your_feedback":"ຂໍ​ຂອບ​ໃຈ​ທ່ານ​ສໍາ​ລັບ​ການ​ຕໍາ​ນິ​ຕິ​ຊົມ​ຂອງ​ທ່ານ​","The_application_name_is_required":"ຊື່ຄໍາຮ້ອງສະຫມັກແມ່ນຈໍາເປັນຕ້ອງ","The_channel_name_is_required":"ຊື່ຊ່ອງທາງການຈໍາເປັນຕ້ອງ","The_emails_are_being_sent":"ອີເມວໄດ້ຖືກສົ່ງໄປແລ້ວ.","The_field_is_required":"ພາກສະຫນາມ %s ແມ່ນຕ້ອງການ.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"ການ resize ຮູບພາບຈະບໍ່ເຮັດວຽກເພາະວ່າພວກເຮົາບໍ່ສາມາດກວດພົບ ImageMagick ຫຼື GraphicsMagick ການຕິດຕັ້ງໃນເຄື່ອງແມ່ຂ່າຍຂອງທ່ານ.","The_redirectUri_is_required":"The redirectUri ຈໍາເປັນຕ້ອງມີ","The_server_will_restart_in_s_seconds":"ເຄື່ອງແມ່ຂ່າຍຂອງຈະເລີ່ມການເຮັດວຽກໃນ %s ວິນາທີ","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>ການຕັ້ງຄ່າ %s</strong> <strong>ຖືກຕັ້ງຄ່າການ %s</strong> <strong>ແລະທ່ານມີການເຂົ້າເຖິງຈາກ %s!</strong>","The_user_will_be_removed_from_s":"ຜູ້ໃຊ້ຈະໄດ້ຮັບການໂຍກຍ້າຍອອກຈາກ %s","The_user_wont_be_able_to_type_in_s":"ຜູ້ໃຊ້ຈະບໍ່ສາມາດຢູ່ໃນປະເພດ %s","Theme":"Theme","theme-color-action-buttons-color":"ປຸ່ມ Color ການກະທໍາ","theme-color-active-channel-background-color":"ການເຄື່ອນໄຫວ Channel ສີຄວາມເປັນມາ","theme-color-active-channel-font-color":"ການເຄື່ອນໄຫວ Channel ສີຕົວອັກສອນ","theme-color-blockquote-background":"Blockquote ສີຄວາມເປັນມາ","theme-color-clean-buttons-color":"ປຸ່ມສະອາດສີ","theme-color-code-background":"ລະຫັດສີຄວາມເປັນມາ","theme-color-code-border":"ລະຫັດສີຊາຍແດນ","theme-color-code-color":"ສີລະຫັດ","theme-color-content-background-color":"ເນື້ອໃນສີຄວາມເປັນມາ","theme-color-custom-scrollbar-color":"Custom ເລື່ອນສີ","theme-color-info-active-font-color":"ການເຄື່ອນໄຫວລະອຽດ Font ສີ","theme-color-info-font-color":"ຂໍ້ມູນ Font ສີ","theme-color-input-font-color":"Input ສີຕົວອັກສອນ","theme-color-link-font-color":"ການເຊື່ອມຕໍ່ສີຕົວອັກສອນ","theme-color-message-hover-background-color":"ຂໍ້ຄວາມ Hover BG ສີ","theme-color-primary-background-color":"ປະຖົມສີຄວາມເປັນມາ","theme-color-primary-font-color":"ປະຖົມສີຕົວອັກສອນ","theme-color-quaternary-font-color":"Quaternary ສີຕົວອັກສອນ","theme-color-secondary-background-color":"ມັດທະຍົມສີຄວາມເປັນມາ","theme-color-secondary-font-color":"ມັດທະຍົມສີຕົວອັກສອນ","theme-color-smallprint-font-color":"Print ຂະຫນາດນ້ອຍສີຕົວອັກສອນ","theme-color-smallprint-hover-color":"Print ຂະຫນາດນ້ອຍສີ Hover","theme-color-status-away":"ໄປສີສະຖານະ","theme-color-status-busy":"ທຸລະກິດສີສະຖານະ","theme-color-status-offline":"ອອຟໄລສີສະຖານະ","theme-color-status-online":"ອອນໄລນ໌ສີສະຖານະ","theme-color-tertiary-background-color":"ສາມສີຄວາມເປັນມາ","theme-color-tertiary-font-color":"ສາມສີຕົວອັກສອນ","theme-color-unread-notification-color":"ຍັງບໍ່ໄດ້ອ່ານສີການແຈ້ງເຕືອນ","theme-custom-css":"CSS Custom","There_are_no_agents_added_to_this_department_yet":"ມີຕົວແທນເພີ່ມບໍ່ມີການພະແນກນີ້ຍັງ.","There_are_no_integrations":"ບໍ່ມີການເຊື່ອມໂຍງແມ່ນ","There_are_no_users_in_this_role":"ມີຜູ້ຊົມໃຊ້ຢູ່ໃນບົດບາດນີ້.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"ອີເມວນີ້ໄດ້ຖືກນໍາມາໃຊ້ແລະຍັງບໍ່ທັນໄດ້ຮັບການຢັ້ງຢືນ. ກະລຸນາມີການປ່ຽນແປງລະຫັດຜ່ານຂອງທ່ານ.","This_is_a_desktop_notification":"ນີ້ແມ່ນການແຈ້ງການ desktop ເປັນ","This_is_a_push_test_messsage":"ນີ້ເປັນ messsage ການທົດສອບການຊຸກຍູ້","Time_in_seconds":"ທີ່ໃຊ້ເວລາໃນວິນາທີ","Title_bar_color":"ສີ Title bar","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"ການຕິດຕັ້ງ Rocket.Chat Livechat ໃນເວັບໄຊທ໌ຂອງທ່ານ, ສໍາເນົາແລະການວາງຂໍ້ກໍານົດຂ້າງເທິງນີ້ໄດ້ <strong></ body></strong> tag ສຸດທ້າຍຢູ່ໃນເວັບໄຊຂອງທ່ານ.","To_users":"ກັບຜູ້ໃຊ້","Topic":"ກະທູ້","Travel_and_Places":"ການເດີນທາງແລະສະຖານທີ່","Trigger_removed":"ຜົນກະທົບຕໍ່ການໂຍກຍ້າຍອອກ","Trigger_Words":"ຜົນກະທົບຕໍ່ຄໍາສັບຕ່າງໆ","Triggers":"ຜົນກະທົບຕໍ່","True":"ທີ່ແທ້ຈິງ","Type":"ປະເພດ","Type_your_new_password":"ພິມລະຫັດຜ່ານໃຫມ່ຂອງທ່ານ","Unarchive":"Unarchive","Unmute_someone_in_room":"ຜູ້ໃດຜູ້ຫນຶ່ງເປດສຽງຢູ່ໃນຫ້ອງການ","Unmute_user":"ຜູ້ໃຊ້ເປດສຽງ","Unnamed":"ທີ່ບໍ່ມີຊື່","Unpin_Message":"ຂໍ້ຄວາມ Unpin","Unread_Rooms":"ຫ້ອງຍັງບໍ່ໄດ້ອ່ານ","Unread_Rooms_Mode":"Mode ຍັງບໍ່ໄດ້ອ່ານຫ້ອງ","Unstar_Message":"ເອົາ Star","Upload_file_question":"ອັບໂຫລດເອກະສານ?","Uploading_file":"ອັບໂຫລດໄຟລ໌ ...","Use_account_preference":"ການນໍາໃຊ້ຄວາມຕ້ອງການບັນຊີ","Use_Emojis":"ການນໍາໃຊ້ສັນຍາລັກຕ່າງໆ","Use_initials_avatar":"ການນໍາໃຊ້ອັກສອນຫຍໍ້ຊື່ຜູ້ໃຊ້ຂອງທ່ານ","use_menu":"ການນໍາໃຊ້ເມນູດ້ານຂ້າງເຂົ້າຫ້ອງແລະການສົນທະນາຂອງທ່ານ","Use_service_avatar":"ການນໍາໃຊ້ %s avatar","Use_this_username":"ການນໍາໃຊ້ຊື່ຜູ້ໃຊ້ນີ້","Use_uploaded_avatar":"ການນໍາໃຊ້ avatar ອັບໂຫຼດ","Use_url_for_avatar":"ການນໍາໃຊ້ url ສໍາລັບ avatar","User__username__is_now_a_moderator_of__room_name_":"__username__ ຜູ້ໃຊ້ໃນປັດຈຸບັນເປັນຜູ້ເບິ່ງແລຂອງ __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ ຜູ້ໃຊ້ໃນປັດຈຸບັນເປັນເຈົ້າຂອງ __room_name__ ເປັນ","User__username__removed_from__room_name__moderators":"__username__ ຜູ້ໃຊ້ໂຍກຍ້າຍອອກຈາກປະດິດ __room_name__","User__username__removed_from__room_name__owners":"__username__ ຜູ້ໃຊ້ໂຍກຍ້າຍອອກຈາກເຈົ້າຂອງ __room_name__","User_added":"ຜູ້ໃຊ້ເຂົ້າມາ","User_added_by":"<em>__user_added__</em> ຜູ້ໃຊ້ທີ່ເພີ່ມຂຶ້ນໂດຍ <em>__user_by__.</em>","User_added_successfully":"ຜູ້ໃຊ້ເຂົ້າມາສົບຜົນສໍາເລັດ","User_Channels":"Channels ຜູ້ໃຊ້","User_doesnt_exist":"ຜູ້ໃຊ້ບໍ່ມີລາຄາໂດຍຊື່ຂອງ `@ %s` ໄດ້.","User_has_been_activated":"ຜູ້ໃຊ້ໄດ້ຮັບການ activated","User_has_been_deactivated":"ຜູ້ໃຊ້ນີ້ໄດ້ຖືກປິດການໃຊ້","User_has_been_deleted":"ຜູ້ໃຊ້ນີ້ໄດ້ຖືກລຶບອອກແລ້ວ","User_has_been_muted_in_s":"ຜູ້ໃຊ້ໄດ້ຮັບການ muted ໃນ %s","User_has_been_removed_from_s":"ຜູ້ໃຊ້ໄດ້ຮັບການໂຍກຍ້າຍອອກຈາກ %s","User_has_disconnected":"ຜູ້ໃຊ້ທີ່ມີການເຊື່ອມຕໍ່","User_Info":"ຂໍ້ມູນຜູ້ໃຊ້","User_is_no_longer_an_admin":"ຜູ້ໃຊ້ທີ່ບໍ່ມີຕໍ່ໄປອ​​ີກແລ້ວການ admin","User_is_not_activated":"ຜູ້ໃຊ້ບໍ່ໄດ້ເປີດໃຊ້","User_is_now_an_admin":"ຜູ້ໃຊ້ໃນປັດຈຸບັນເປັນ admin","User_joined_channel":"ໄດ້ເຂົ້າຮ່ວມຊ່ອງທາງການ.","User_joined_channel_female":"ໄດ້ເຂົ້າຮ່ວມຊ່ອງທາງການ.","User_joined_channel_male":"ໄດ້ເຂົ້າຮ່ວມຊ່ອງທາງການ.","User_left":"ໄດ້​ປະ​ໄວ້​ຊ່ອງ​ທາງ​ການ​.","User_left_female":"ໄດ້ປະໄວ້ຊ່ອງທາງການ.","User_left_male":"ໄດ້ປະໄວ້ຊ່ອງທາງການ.","User_logged_out":"ຜູ້ໃຊ້ເຂົ້າສູ່ລະບົບອອກ","User_management":"ການຄຸ້ມຄອງຜູ້ໃຊ້","User_muted_by":"<em>__user_muted__</em> User muted ໂດຍ <em>__user_by__.</em>","User_muted_in_room":"User muted ຢູ່ໃນຫ້ອງ","User_not_found":"ບໍ່ໄດ້ພົບເຫັນຜູ້ໃຊ້","User_not_found_or_incorrect_password":"ຜູ້ໃຊ້ບໍ່ໄດ້ພົບເຫັນຫລືລະຫັດຜ່ານບໍ່ຖືກຕ້ອງ","User_or_channel_name":"ສະມາຊິກຫຼືຊື່ຂອງຊ່ອງ","User_removed":"ຜູ້ໃຊ້ການໂຍກຍ້າຍອອກ","User_removed_by":"<em>__user_removed__</em> ຜູ້ໃຊ້ໂຍກຍ້າຍອອກໂດຍ <em>__user_by__.</em>","User_removed_from_room":"ຜູ້ໃຊ້ໄດ້ຮັບການໂຍກຍ້າຍອອກຈາກຫ້ອງການ","User_Settings":"ການຕັ້ງຄ່າຂອງຜູ້ໃຊ້","User_unmuted_by":"<em>__user_unmuted__</em> User unmuted ໂດຍ <em>__user_by__.</em>","User_unmuted_in_room":"User ເປດສຽງຢູ່ໃນຫ້ອງ","User_updated_successfully":"ຜູ້ໃຊ້ອັບເດດຮຽບຮ້ອຍ","Username":"ຊື່ຜູ້ໃຊ້","Username_and_message_must_not_be_empty":"ຊື່ຜູ້ໃຊ້ແລະຂໍ້ຄວາມຈະຕ້ອງບໍ່ເປົ່າຫວ່າງ.","Username_cant_be_empty":"ຊື່ຜູ້ໃຊ້ບໍ່ສາມາດປ່ອຍຫວ່າງ","Username_Change_Disabled":"administrator Rocket.Chat ຂອງທ່ານໄດ້ປິດການນໍາໃຊ້ການປ່ຽນແປງຊື່ຜູ້ໃຊ້ໄດ້","Username_denied_the_OTR_session":"__username__ ປະຕິເສດການປະຊຸມ OTR","Username_description":"ຊື່ຜູ້ໃຊ້ຖືກນໍາໃຊ້ເພື່ອອະນຸຍາດໃຫ້ຄົນອື່ນເວົ້າເຖິງຄຸນໃນຂໍ້ຄວາມ.","Username_doesnt_exist":"ຊື່ຜູ້ໃຊ້ ` %s` ບໍ່ມີ.","Username_ended_the_OTR_session":"__username__ ສິ້ນສຸດລົງໃນກອງປະຊຸມ OTR","Username_invalid":"<strong> %s</strong> ບໍ່ແມ່ນຊື່ຜູ້ໃຊ້ທີ່ຖືກຕ້ອງ, <br/> ນໍາໃຊ້ພຽງແຕ່ຕົວອັກສອນ, ຈໍານວນ, ຈຸດ, ເຄື່ອງຫມາຍແລະຂີດ","Username_is_already_in_here":"`@ %s` ແມ່ນແລ້ວໃນທີ່ນີ້.","Username_is_not_in_this_room":"ຜູ້ໃຊ້ `# %s` ບໍ່ແມ່ນໃນຫ້ອງນີ້.","Username_not_found":"ຊື່ຜູ້ໃຊ້ບໍ່ໄດ້ພົບເຫັນ","Username_title":"ລົງທະບຽນຊື່ຜູ້ໃຊ້","Username_unavaliable":"<strong> %s</strong> ແມ່ນຢູ່ໃນການນໍາໃຊ້ :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ ຕ້ອງການເພື່ອເລີ່ມຕົ້ນການ OTR. ທ່ານຕ້ອງການທີ່ຈະຍອມຮັບ?","Users":"ຜູ້ຊົມໃຊ້","Users_in_role":"ຜູ້ຊົມໃຊ້ໃນພາລະບົດບາດ","UTF8_Names_Slugify":"UTF8 Names Slugify","UTF8_Names_Validation":"UTF8 ຊື່ທີ່ຖືກຕ້ອງ","UTF8_Names_Validation_Description":"ບໍ່ອະນຸຍາດໃຫ້ລັກສະນະພິເສດແລະສະຖານທີ່. ທ່ານສາມາດນໍາໃຊ້ - _ ແລະ. ແຕ່ບໍ່ໄດ້ຢູ່ໃນຕອນທ້າຍຂອງຊື່ໄດ້","Verification_email_sent":"ອີເມວຢືນຢັນສົ່ງ","View_All":"ເບິ່ງ​ທັງ​ຫມົດ","View_Logs":"ເບິ່ງຂໍ້ມູນບັນທຶກ","Visibility":"ສັງເກດເຫັນ","Visible":"ສັງເກດເຫັນ","Visitor":"ຈໍານວນຜູ້ເຂົ້າ","Visitor_page_URL":"URL ຫນ້າຈໍານວນຜູ້ເຂົ້າ","Visitor_time_on_site":"ທີ່ໃຊ້ເວລາຈໍານວນຜູ້ເຂົ້າຢູ່ໃນເວັບໄຊ","Wait_activation_warning":"ກ່ອນທີ່ທ່ານຈະສາມາດເຂົ້າສູ່ລະບົບ, ບັນຊີຂອງທ່ານຕ້ອງໄດ້ຮັບການເປີດໃຊ້ວຽກດ້ວຍຕົນເອງໂດຍຜູ້ບໍລິຫານ.","We_are_offline_Sorry_for_the_inconvenience":"ພວກເຮົາມີຄວາມອອຟໄລ. ຂໍ​ອະ​ໄພ​ໃນ​ຄວາມ​ບໍ່​ສະ​ດວກ.","We_have_sent_password_email":"ພວກເຮົາໄດ້ສົ່ງໃຫ້ທ່ານທາງອີເມລ໌ທີ່ມີຄໍາແນະນໍາປ່ຽນລະຫັດຜ່ານ. ຖ້າຫາກວ່າທ່ານບໍ່ໄດ້ຮັບອີເມວບໍ່ດົນ, ກະລຸນາກັບຄືນມາແລະພະຍາຍາມອີກເທື່ອຫນຶ່ງ.","We_have_sent_registration_email":"ພວກເຮົາໄດ້ສົ່ງອີເມວເພື່ອຢືນຢັນການລົງທະບຽນຂອງທ່ານທ່ານ. ຖ້າຫາກວ່າທ່ານບໍ່ໄດ້ຮັບອີເມວບໍ່ດົນ, ກະລຸນາກັບຄືນມາແລະພະຍາຍາມອີກເທື່ອຫນຶ່ງ.","WebRTC_Enable_Channel":"ເຮັດໃຫ້ສໍາລັບຊ່ອງທາງສາທາລະນະ","WebRTC_Enable_Direct":"ເຮັດໃຫ້ສາມາດສໍາລັບຂໍ້ຄວາມໂດຍກົງ","WebRTC_Enable_Private":"ເຮັດໃຫ້ສໍາລັບຊ່ອງທາງສ່ວນຕົວ","WebRTC_Servers":"ເຄື່ອງແມ່ຂ່າຍ ST​​UN / ເຮັດໃຫ້","WebRTC_Servers_Description":"ບັນຊີລາຍຊື່ຂອງ STUN ແລະເຮັດໃຫ້ເຄື່ອງແມ່ຂ່າຍແຍກອອກໂດຍຈຸດ A. <br/> ຊື່ຜູ້ໃຊ້, ລະຫັດຜ່ານແລະທີ່ Port ແມ່ນອະນຸຍາດໃຫ້ຢູ່ໃນຮູບແບບ `ຊື່ຜູ້ໃຊ້: ລະຫັດຜ່ານ @ stun: ເຈົ້າພາບ: port` ຫຼື` ຊື່ຜູ້ໃຊ້: ລະຫັດຜ່ານ @ ເຮັດ: ເຈົ້າພາບ: port`.","Welcome":"<em>ຍິນດີຕ້ອນຮັບ %s.</em>","Welcome_to_the":"ຍິນດີຕ້ອນຮັບ","will_be_able_to":"ຈະສາມາດ","With_whom":"ກັບ​ໃຜ","Yes":"Yes","Yes_clear_all":"ແມ່ນແລ້ວ, ຈະແຈ້ງທັງຫມົດ!","Yes_delete_it":"Yes, ລຶບມັນ!","Yes_hide_it":"ແມ່ນແລ້ວ, ມັນບໍ່!","Yes_leave_it":"Yes, ອອກຈາກມັນ!","Yes_mute_user":"ແມ່ນແລ້ວ, ຜູ້ໃຊ້ mute!","Yes_remove_user":"ແມ່ນແລ້ວ, ເອົາຜູ້ໃຊ້!","you_are_in_preview_mode_of":"ທ່ານຢູ່ໃນຮູບແບບສະແດງຂອງຊ່ອງ # <strong>__room_name__</strong>","You_are_logged_in_as":"ເຈົ້າຍັງບໍ່ໄດ້ເຂົ້າສູ່ລະບົບໃນຖານະ","You_are_not_authorized_to_view_this_page":"ເຈົ້າຍັງບໍ່ໄດ້ອະນຸຍາດໃຫ້ເບິ່ງຫນ້ານີ້.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"ທ່ານແມ່ນເຈົ້າຂອງທີ່ຜ່ານມາ. ກະລຸນາຕັ້ງເຈົ້າຂອງໃຫມ່ກ່ອນທີ່ຈະອອກຫ້ອງການ.","You_can_change_a_different_avatar_too":"ທ່ານສາມາດແທນ avatar ນໍາໃຊ້ເພື່ອສະຈາກການເຊື່ອມໂຍງນີ້.","You_can_use_an_emoji_as_avatar":"ນອກນັ້ນທ່ານຍັງສາມາດນໍາໃຊ້ສັນຍາລັກຕ່າງໆເປັນ avatar.","You_have_been_muted":"ທ່ານໄດ້ຮັບການ muted ແລະບໍ່ສາມາດເວົ້າຢູ່ໃນຫ້ອງນີ້","You_have_not_verified_your_email":"ທ່ານຍັງບໍ່ໄດ້ກວດສອບອີເມວຂອງທ່ານ.","You_have_successfully_unsubscribed":"ທ່ານໄດ້ unsubscribed ສົບຜົນສໍາເລັດຈາກບັນຊີ maill ຂອງພວກເຮົາ.","You_informed_an_invalid_FROM_address":"ທ່ານແຈ້ງໃຫ້ຊາບເປັນທີ່ບໍ່ຖືກຕ້ອງຈາກທີ່ຢູ່.","You_must_provide_the_unsubscribe_link":"ທ່ານຕ້ອງໄດ້ສະຫນອງການເຊື່ອມຕໍ່ [ຍົກເລີກ].","You_need_confirm_email":"ທ່ານຈໍາເປັນຕ້ອງຢືນຢັນອີເມວຂອງທ່ານທີ່ຈະເຂົ້າສູ່ລະບົບ!","You_need_install_an_extension_to_allow_screen_sharing":"ທ່ານຕ້ອງການຕິດຕັ້ງການສົ່ງເສີມການອະນຸຍາດໃຫ້ການແບ່ງປັນຫນ້າຈໍ","You_need_to_change_your_password":"ທ່ານຈໍາເປັນຕ້ອງມີການປ່ຽນແປງລະຫັດຜ່ານຂອງທ່ານ","You_need_to_type_in_your_password_in_order_to_do_this":"ທ່ານຈໍາເປັນຕ້ອງຢູ່ໃນປະເພດລະຫັດຜ່ານຂອງທ່ານເພື່ອເຮັດແນວໃດນີ້!","You_need_to_type_in_your_username_in_order_to_do_this":"ທ່ານຕ້ອງການພິມໃນຊື່ຜູ້ໃຊ້ຂອງທ່ານຢູ່ໃນຄໍາສັ່ງທີ່ຈະເຮັດແນວໃດນີ້!","You_need_to_verifiy_your_email_address_to_get_notications":"ທ່ານຈໍາເປັນຕ້ອງ verifiy ທີ່ຢູ່ອີເມວຂອງທ່ານເພື່ອໃຫ້ໄດ້ຮັບການແຈ້ງເຕືອນ","You_should_name_it_to_easily_manage_your_integrations":"ທ່ານຄວນມັນໄດ້ຢ່າງງ່າຍດາຍໃນການຄຸ້ມຄອງການເຊື່ອມໂຍງຂອງທ່ານ.","You_will_not_be_able_to_recover":"ທ່ານຈະບໍ່ສາມາດຟື້ນຕົວຂໍ້ຄວາມນີ້!","You_will_not_be_able_to_recover_file":"ທ່ານຈະບໍ່ສາມາດຟື້ນຕົວເອກະສານນີ້!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"ທ່ານຈະບໍ່ໄດ້ຮັບການແຈ້ງການອີເມລເພາະວ່າທ່ານຍັງບໍ່ທັນໄດ້ກວດສອບອີເມວຂອງທ່ານ.","Your_email_has_been_queued_for_sending":"ອີເມວຂອງທ່ານໄດ້ຮັບການເຂົ້າຄິວສໍາລັບການສົ່ງ","Your_entry_has_been_deleted":"ເຂົ້າຂອງທ່ານໄດ້ຖືກລຶບແລ້ວ.","Your_file_has_been_deleted":"ເອກະສານຂອງທ່ານໄດ້ຖືກລຶບແລ້ວ.","Your_mail_was_sent_to_s":"ອີເມລຂອງທ່ານໄດ້ຖືກສົ່ງໄປ %s","Your_Open_Source_solution":"ຂອງຕົນເອງມາເປີດການແກ້ໄຂການສົນທະນາຂອງທ່ານ","Your_password_is_wrong":"ລະຫັດຜ່ານຂອງທ່ານແມ່ນຜິດພາດ!","Your_push_was_sent_to_s_devices":"ການຊຸກຍູ້ຂອງທ່ານໄດ້ຖືກສົ່ງໄປອຸປະກອນ %s"});
TAPi18n._registerServerTranslator("lo", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ms-MY.i18n.json                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ms-MY"] = ["ms-MY","ms-MY"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["ms-MY"])) {                                                                     // 9
  TAPi18n.translations["ms-MY"] = {};                                                                                  // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ms-MY"][namespace])) {                                                          // 13
  TAPi18n.translations["ms-MY"][namespace] = {};                                                                       // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ms-MY"][namespace], {"500":"Ralat Pelayan Dalaman","0_Errors_Only":"0 - Kesilapan Hanya","1_Errors_and_Information":"1 - Kesilapan dan Maklumat","2_Erros_Information_and_Debug":"2 - Erros, Maklumat dan Debug","__username__was_set__role__by__user_by_":"__nama pengguna__ ditubuhkan __role__ oleh __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__nama pengguna__ tidak lagi __role__, dengan __user_by__","Access_not_authorized":"Akses tidak dibenarkan","Access_online_demo":"Akses demo atas talian","Access_Online_Demo":"Akses Demo Atas talian","Access_Token_URL":"URL Access Token","Accounts":"Akaun","Accounts_AllowDeleteOwnAccount":"Membenarkan pengguna untuk memadam akaun sendiri","Accounts_AllowedDomainsList":"Senarai Domain dibenarkan","Accounts_AllowedDomainsList_Description":"Senarai diasingkan koma bagi domain dibenarkan","Accounts_AllowEmailChange":"Benarkan E-mel Tukar","Accounts_AllowPasswordChange":"Benarkan Tukar Kata Laluan","Accounts_AllowUserAvatarChange":"Benarkan pengguna Avatar Tukar","Accounts_AllowUsernameChange":"Benarkan pengguna Tukar","Accounts_AllowUserProfileChange":"Benarkan Profil Pengguna Tukar","Accounts_AvatarResize":"Saiz semula Avatars","Accounts_AvatarSize":"avatar Saiz","Accounts_AvatarStorePath":"Avatar Storage Path","Accounts_AvatarStoreType":"Avatar Storage Jenis","Accounts_BlockedDomainsList":"Senarai Domain Disekat","Accounts_BlockedDomainsList_Description":"Senarai diasingkan koma bagi domain disekat","Accounts_denyUnverifiedEmail":"Menafikan e-mel yang tidak sah","Accounts_EmailVerification":"Pengesahan E-mel","Accounts_EmailVerification_Description":"Pastikan anda mempunyai tetapan SMTP betul untuk menggunakan ciri-ciri ini","Accounts_Enrollment_Email":"Pendaftaran E-mel","Accounts_Enrollment_Email_Description":"Anda boleh menggunakan [nama], [fname], [lname] bagi nama penuh pengguna, nama pertama atau nama akhir, masing-masing. <br /> Anda boleh menggunakan [email] untuk e-mel pengguna.","Accounts_Iframe_api_method":"Kaedah Api","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"didayakan","Accounts_iframe_url":"Iframe Url","Accounts_LoginExpiration":"Tamat Tempoh Masuk dalam Days","Accounts_ManuallyApproveNewUsers":"Secara manual meluluskan pengguna baru","Accounts_OAuth_Custom_Token_Sent_Via":"Token Dihantar Via","Accounts_OAuth_Custom_Authorize_Path":"Authorize Path","Accounts_OAuth_Custom_Button_Color":"Butang Warna","Accounts_OAuth_Custom_Button_Label_Color":"Butang Teks Berwarna","Accounts_OAuth_Custom_Button_Label_Text":"Butang Teks","Accounts_OAuth_Custom_Enable":"Aktifkan","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity Path","Accounts_OAuth_Custom_Login_Style":"Style login","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Daftar masuk Facebook","Accounts_OAuth_Facebook_callback_url":"URL Facebook Callback","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Diaktifkan","Accounts_OAuth_Github_callback_url":"URL github Callback","Accounts_OAuth_GitHub_Enterprise":"OAuth Didayakan","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise Callback","Accounts_OAuth_GitHub_Enterprise_id":"Id Pelanggan","Accounts_OAuth_Github_id":"ID Klien","Accounts_OAuth_Github_secret":"Rahsia Klien","Accounts_OAuth_Gitlab":"OAuth Didayakan","Accounts_OAuth_Gitlab_callback_url":"URL GitLab Callback","Accounts_OAuth_Gitlab_id":"Id GitLab","Accounts_OAuth_Gitlab_secret":"Secret Pelanggan","Accounts_OAuth_Google":"Daftar masuk Google","Accounts_OAuth_Google_callback_url":"URL Google Callback","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"Daftar masuk LinkedIn","Accounts_OAuth_Linkedin_callback_url":"URL LinkedIn Callback","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Daftar masuk Meteor","Accounts_OAuth_Meteor_callback_url":"URL Meteor Callback","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Daftar masuk Twitter","Accounts_OAuth_Twitter_callback_url":"URL Twitter Callback","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"Daftar masuk WordPress","Accounts_OAuth_Wordpress_callback_url":"URL Wordpress Callback","Accounts_OAuth_Wordpress_id":" ID WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Password Reset","Accounts_Registration_AuthenticationServices_Enabled":"Pendaftaran dengan Pengesahan Perkhidmatan","Accounts_RegistrationForm":"Borang pendaftaran","Accounts_RegistrationForm_Disabled":"Orang kurang Upaya","Accounts_RegistrationForm_LinkReplacementText":"Borang Pendaftaran Link penggantian teks","Accounts_RegistrationForm_Public":"awam","Accounts_RegistrationForm_Secret_URL":"URL Secret","Accounts_RegistrationForm_SecretURL":"Borang Pendaftaran URL Secret","Accounts_RegistrationForm_SecretURL_Description":"Anda mesti menyediakan rentetan rawak yang akan ditambah ke URL pendaftaran anda. Contoh: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Pendaftaran diperlukan","Accounts_RequireNameForSignUp":"Memerlukan Nama Untuk Daftar","Accounts_ShowFormLogin":"berasaskan Tunjukkan bentuk Login","Accounts_UseDefaultBlockedDomainsList":"Penggunaan Lalai Disekat Senarai Domain","Accounts_UseDNSDomainCheck":"Gunakan DNS Domain Daftar","Activate":"Aktifkan","Activity":"aktiviti","Add":"Tambah","Add_agent":"menambah ejen","Add_custom_oauth":"Tambahkan OAuth adat","Add_manager":"Tambah pengurus","Add_Members":"Tambah Ahli","Add_User":"Tambah Pengguna","Add_user":"Tambah pengguna","Add_users":"Tambah pengguna","Additional_emails":"Tambahan E-mel","Additional_Feedback":"Maklum balas tambahan","Administration":"Pentadbiran","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Selepas pengesahan OAuth2, pengguna akan diarahkan ke URL ini","Agent_added":"Agent ditambah","Agent_removed":"Agent dikeluarkan","Alias":"Alias","All":"Semua","All_channels":"Semua saluran","All_logs":"semua log","All_messages":"semua mesej","Allow_Invalid_SelfSigned_Certs":"Benarkan sah sendiri Ditandatangani CERT","Allow_Invalid_SelfSigned_Certs_Description":"Benarkan sijil SSL tidak sah dan ditandatangani sendiri untuk pengesahan link dan tinjauan.","and":"dan","And_more":"Dan lebih __length __...","Animals_and_Nature":"Animals & Nature","API":"API","API_Analytics":"Analisis","API_Embed":"Benam","API_EmbedDisabledFor":"Disable Benamkan untuk Pengguna","API_EmbedDisabledFor_Description":"senarai-dipisah-koma nama pengguna","API_GitHub_Enterprise_URL":"URL Server","API_GitHub_Enterprise_URL_Description":"Contoh: http://domain.com (tidak termasuk trailing slash)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":" URL WordPress","Appearance":"rupa","Application_added":"permohonan tambah","Application_Name":"Nama permohonan","Application_updated":"permohonan dikemaskini","Apply_and_refresh_all_clients":"Dikenakan dan menyegarkan semua pelanggan","Archive":"Mencapai","Archive_Unarchive":"Archive / Nyaharkibkan","are_also_typing":"juga menaip","are_typing":"yang menaip","Are_you_sure":"Adakah anda pasti?","Are_you_sure_you_want_to_delete_your_account":"Adakah anda pasti anda mahu memadam akaun anda?","Authorization_URL":"URL kebenaran","Authorize":"oleh tiada","AutoLinker_StripPrefix":"AutoLinker Strip Awalan","AutoLinker_StripPrefix_Description":"paparan pendek. contohnya https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL Ungkapan Biasa","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"dikaitkan secara automatik untuk nombor telefon. contohnya `(123) 456-7890`","Auto_Load_Images":"Automatik Memuat Gambar","Available":"Terdapat","Available_agents":"ejen tersedia","Avatar":"Tukar avatar","Avatar_changed_successfully":"Avatar berjaya ditukar","Avatar_URL":"URL avatar","Avatar_url_invalid_or_error":"Url yang diberikan adalah tidak sah atau tidak boleh diakses. Sila cuba sekali lagi, tetapi dengan url yang berbeza.","away":"keluar","Away":"Keluar","away_female":"keluar","Away_female":"Keluar","away_male":"keluar","Away_male":"Keluar","Back":"Kembali","Back_to_applications":"Kembali kepada aplikasi","Back_to_integrations":"Kembali ke integrasi","Back_to_login":"Kembali ke log masuk","Back_to_permissions":"Kembali ke kebenaran","Body":"badan","bold":"berani","busy":"sibuk","Busy":"Sibuk","busy_female":"sibuk","Busy_female":"Sibuk","busy_male":"sibuk","Busy_male":"Sibuk","Cancel":"Batal","Cannot_delete_a_protected_role":"Tidak dapat memadam peranan yang dilindungi","Cannot_delete_role_because_its_in_use":"Tidak dapat memadam peranan kerana ia digunakan","Cannot_invite_users_to_direct_rooms":"Tidak boleh menjemput pengguna ke bilik mengarahkan","CDN_PREFIX":"CDN Awalan","Certificates_and_Keys":"Sijil dan Keys","Channel":"Channel","Channel_doesnt_exist":"Saluran `# %s` tidak wujud.","Channels":"Saluran","Channels_list":"Senarai daripada saluran awam","Chat_Rooms":"Bilik Sembang","Chatops_Enabled":"membolehkan Chatops","Chatops_Title":"Panel Chatops","Chatops_Username":"Chatops Nama pengguna","Choose_a_room":"Pilih bilik","Choose_messages":"pilih mesej","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Pilih alias yang akan muncul sebelum nama pengguna dalam mesej.","Choose_the_username_that_this_integration_will_post_as":"Pilih nama pengguna yang integrasi ini akan menghantar seberapa.","Clear_all_unreads_question":"Kosongkan semua unreads?","Client_ID":"ID Pelanggan","Client_Secret":"Secret Pelanggan","Clients_will_refresh_in_a_few_seconds":"Pelanggan akan menyegarkan dalam beberapa saat","close":"tutup","Closed":"ditutup","Collapse_Embedded_Media_By_Default":"Runtuh media tertanam secara lalai","coming_soon":"akan datang","Commands":"Arahan","Compact_View":"Paparan Kompak","Confirm_password":"Sahkan kata laluan anda","Contact":"Hubungi","Conversation":"Perbualan","Convert_Ascii_Emojis":"Menukar ASCII ke Emoji","Copied":"disalin","COPY_TO_CLIPBOARD":"Salinan ke clipboard","Copy_to_clipboard":"Salin ke clipboard","Count":"Count","Create":"Buat","Create_new":"Buat baru","Created_at":"Dibuat pada","Created_at_s_by_s":"Dicipta <strong>pada %s</strong> <strong>oleh %s</strong>","Custom_Fields":"Fields Custom","Custom_oauth_helper":"Apabila menyediakan Pembekal OAuth anda, anda akan mempunyai untuk memberitahu URL Callback. Penggunaan <pre> %s </pre> .","Custom_oauth_unique_name":"nama unik Custom OAuth","Custom_Script_Logged_In":"Custom Script untuk log masuk pengguna","Custom_Script_Logged_Out":"Custom Script untuk pengguna log keluar","Dashboard":"Dashboard","days":"hari","Deactivate":"Nyahaktifkan","Debug_Level":"debug Level","Default":"lalai","Delete":"Padam","Delete_my_account":"Padam akaun saya","Delete_Room_Warning":"Memadam bilik akan memadam semua mesej yang dihantar di dalam bilik. Perkara ini tidak boleh diubah.","Delete_User_Warning":"Memadam pengguna akan memadam semua mesej dari pengguna itu juga. Ini tidak boleh kembalikan asal.","Deleted":"Dipadamkan!","Department_not_found":"Jabatan tidak dijumpai","Department_removed":"Jabatan dikeluarkan","Departments":"Jabatan","Description":"Penerangan","Desktop":"desktop","Desktop_Notification_Test":"Test Pemberitahuan Desktop","Desktop_Notifications":"Notifikasi Desktop","Desktop_Notifications_Disabled":"Notifikasi Desktop dinyahaktifkan. Tukar tetapan pelayar web jika anda mahukan notifikasi diaktifkan.","Desktop_Notifications_Enabled":"Notifikasi Desktop Diaktifkan","Direct_message_someone":"mesej seseorang Direct","Direct_Messages":"Mesej Secara Langsung","Direct_Messages_list":"Mesej langsung","Disable_Favorite_Rooms":"Nyahaktifkan Kegemaran","Disable_New_Message_Notification":"Lumpuhkan Notifikasi Mesej Baru","Disable_New_Room_Notification":"Lumpuhkan Notifikasi Bilik Baru","Displays_action_text":"teks memaparkan tindakan","Do_you_want_to_change_to_s_question":"Adakah anda mahu menukar <strong>kepada %s?</strong>","Drop_to_upload_file":"Gugurkan untuk memuat naik fail","Dry_run":"raptai","Dry_run_description":"hanya akan menghantar satu e-mel, alamat yang sama seperti dalam Dari. e-mel mesti milik pengguna yang sah.","Duplicate_archived_channel_name":"An diarkibkan Channel dengan nama ' %s' wujud","Duplicate_archived_private_group_name":"Satu Kumpulan Swasta diarkibkan dengan nama ' %s' wujud","Duplicate_private_group_name":"Kumpulan Persendirian dengan nama '%s' telah wujud","E-mail":"E-mel","Edit":"Sunting","Edit_Custom_Field":"Edit Field Custom","Edit_Department":"Edit Jabatan","edited":"disunting","Email":"e-mel","Email_already_exists":"E-mel telah wujud","Email_body":"badan E-mel","Email_Change_Disabled":"pentadbir Rocket.Chat anda telah melumpuhkan perubahan e-mel","Email_from":"dari","Email_Notification_Mode":"Pemberitahuan E-mel Offline","Email_Notification_Mode_All":"Setiap Mention / DM","Email_Notification_Mode_Disabled":"Orang kurang Upaya","Email_or_username":"E-mel atau nama pengguna","Email_subject":"subjek","Email_verified":"E-mel disahkan","Emoji":"Emoji","Empty_title":"tajuk kosong","Enable":"membolehkan","Enable_Desktop_Notifications":"Mengaktifkan Notifikasi Desktop","Enabled":"didayakan","Encrypted_message":"mesej disulitkan","End_OTR":"akhir OTR","Enter_a_regex":"Masukkan regex yang","Enter_a_room_name":"Masukkan nama bilik","Enter_a_username":"Masukkan nama pengguna","Enter_info":"Masukkan maklumat anda","Enter_name_here":"Masukkan nama di sini","Enter_to":"Masuk ke","Error":"ralat","error-cant-invite-for-direct-room":"tidak boleh menjemput pengguna ke bilik terus","error-duplicate-channel-name":"Saluran dengan nama '%s' telah wujud","error-invalid-custom-field":"bidang adat yang tidak sah","error-invalid-custom-field-name":"nama medan tersuai tidak sah. Gunakan hanya huruf, nombor, sengkang dan garis bawah.","error-invalid-password":"Kata laluan tidak sah","error-invalid-room":"bilik tidak sah","error-invalid-room-name":"<strong> %s</strong> bukan nama bilik yang sah, <br/> menggunakan hanya huruf, nombor, sengkang dan garis bawah","error-invalid-user":"pengguna tidak sah","error-invalid-username":"Nama pengguna tidak sah","error-not-allowed":"Tidak dibenarkan","error-not-authorized":"tidak dibenarkan","error-remove-last-owner":"Ini adalah pemilik terakhir. Sila menetapkan pemilik baru sebelum mengeluarkan ini.","error-role-name-required":"nama peranan diperlukan","error-user-not-in-room":"Pengguna tidak ada di dalam bilik ini","Error_changing_password":"Ralat menukar kata laluan","Error_sending_confirmation_email":"Ralat menghantar e-mel pengesahan","Error_too_many_requests":"Ralat, terlalu banyak permintaan. Sila melambatkan. Anda perlu menunggu %s saat sebelum mencuba semula","Esc_to":"Esc untuk","Example_s":"Contoh: <code class=\"inline\">%s</code>","False":"Lumpuhkan","Favorites":"Kegemaran","Field":"Field","Field_removed":"Field dikeluarkan","File_exceeds_allowed_size_of_bytes":"Fail melebihi saiz dibenarkan bait __size__","FileUpload":"Muat Naik Fail","FileUpload_Enabled":"Naik Fail Diaktifkan","FileUpload_File_Empty":"Fail kosong","FileUpload_FileSystemPath":"sistem jalan","FileUpload_MaxFileSize":"Fail muat naik saiz Maksimum (dalam bytes)","FileUpload_MediaType_NotAccepted":"Jenis Media Tidak Diterima","FileUpload_MediaTypeWhiteList":"Diterima Jenis Media","FileUpload_MediaTypeWhiteListDescription":"senarai jenis media yang dipisahkan dengan koma. Biarkan kosong untuk menerima semua jenis media.","FileUpload_ProtectFiles":"Melindungi fail yang dimuat naik","FileUpload_ProtectFilesDescription":"Hanya pengguna yang disahkan mempunyai akses","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 nama baldi","FileUpload_S3_BucketURL":"URL Bucket","FileUpload_S3_CDN":"domain CDN untuk muat turun","FileUpload_S3_Region":"rantau","FileUpload_Storage_Type":"Jenis Storage","Flags":"Flags","Follow_social_profiles":"Ikut profil sosial kami, mengeluarkan kami di github dan berkongsi pendapat anda mengenai aplikasi rocket.chat di atas kapal Trello kami.","Food_and_Drink":"Makanan & Minuman","For_your_security_you_must_re_enter_your_password_to_continue":"Untuk keselamatan anda, anda perlu masukkan semula kata laluan anda untuk terus","Force_SSL":"Tentera SSL","Force_SSL_Description":"* Awas! * _Force SSL_ tidak boleh digunakan dengan proksi terbalik. Jika anda mempunyai proksi terbalik, anda perlu melakukan peralihan ADA. Pilihan ini wujud untuk pergerakan seperti Heroku, yang tidak membenarkan konfigurasi redirect di proksi terbalik.","Forgot_password":"Lupa kata laluan anda","Fork_it_on_github":"Mencabang pada github","Frequently_Used":"sering Digunakan","From":"dari","From_Email":"Daripada E-mel","From_email_is_required":"Dari e-mel diperlukan","From_email_warning":"<b>Amaran:</b> Medan <b>Dari</b> tertakluk kepada tetapan pelayan mel anda.","General":"Umum","Get_to_know_the_team":"Kenali Rocket.Team","github_no_public_email":"Anda tidak mempunyai sebarang e-mel umum pada akaun GitHub anda","Give_a_unique_name_for_the_custom_oauth":"Beri nama unik untuk OAuth adat","Give_the_application_a_name_This_will_be_seen_by_your_users":"Beri permohonan itu nama. Ini akan dapat dilihat oleh pengguna-pengguna anda.","Global":"global","GoogleTagManager_id":"Id Pengurus Teg Google","Has_more":"Ada lagi","Have_your_own_chat":"Mempunyai chat web anda sendiri. Dibangunkan dengan Meteor.com, Rocket.Chat adalah satu penyelesaian yang bagus untuk pemaju sabar untuk membina dan mengembangkan platform chat mereka sendiri.","Header":"Kepala","Hidden":"tersembunyi","Hide_Group_Warning":"Adakah anda pasti anda mahu menyembunyikan kumpulan \" %s\"?","Hide_Private_Warning":"Adakah anda pasti anda mahu menyembunyikan perbincangan dengan \" %s\"?","Hide_room":"Menyembunyikan bilik","Hide_Room_Warning":"Adakah anda pasti anda mahu menyembunyikan bilik \" %s\"?","Highlights":"Sorotan","Highlights_How_To":"Untuk diberitahu apabila seseorang menyebut perkataan atau frasa, tambah di sini. Anda boleh memisahkan perkataan atau frasa dengan koma. Highlight Perkataan tidak sensitif.","Highlights_List":"kata-kata Highlight","History":"Sejarah","hours":"jam","How_friendly_was_the_chat_agent":"Bagaimana mesra adalah ejen chat?","How_knowledgeable_was_the_chat_agent":"Sejauh manakah ejen chat?","How_responsive_was_the_chat_agent":"Bagaimana responsif adalah ejen chat?","How_satisfied_were_you_with_this_chat":"Apakah tahap kepuasan hadir di sisi sembang ini?","If_you_are_sure_type_in_your_password":"Jika anda adalah jenis memastikan kata laluan anda:","If_you_are_sure_type_in_your_username":"Jika anda adalah jenis pasti dalam nama pengguna anda:","Importer_Archived":"diarkibkan","Importer_done":"Mengimport lengkap!","Importer_finishing":"Hampir selesai import.","Importer_From_Description":"Import __from data __ 's ke dalam Rocket.Chat.","Importer_import_cancelled":"Import dibatalkan.","Importer_import_failed":"Ralat berlaku semasa berjalan import.","Importer_importing_channels":"Mengimport saluran.","Importer_importing_messages":"Mengimport mesej.","Importer_importing_started":"Bermula import.","Importer_importing_users":"Mengimport pengguna.","Importer_not_defined_properly":"pengimport tidak ditakrifkan dengan betul, ia hilang kelas Import.","Importer_not_in_progress":"pengimport itu kini tidak berjalan.","Importer_Prepare_Restart_Import":"Mulakan semula Import","Importer_Prepare_Start_Import":"mula Mengimport","Importer_Prepare_Uncheck_Archived_Channels":"Saluran Diarkibkan nyahtandakan","Importer_Prepare_Uncheck_Deleted_Users":"Pengguna nyahtandakan Deleted","Importer_progress_error":"Gagal untuk mendapatkan kemajuan untuk import.","Importer_setup_error":"Ralat berlaku semasa menyediakan pengimport.","Incorrect_Password":"Kata Laluan salah","inline_code":"inline_code","Install_Extension":"Pasang Extension","Install_FxOs":"Pasang Rocket.Chat pada Firefox anda","Install_FxOs_done":"Great! Anda kini boleh menggunakan Rocket.Chat melalui ikon pada skrin utama anda. Bersenang-senang dengan Rocket.Chat!","Install_FxOs_error":"Maaf, itu tidak berfungsi seperti yang sepatutnya! Ralat berikut muncul:","Install_FxOs_follow_instructions":"Sila sahkan pemasangan aplikasi pada peranti anda (tekan \"Pasang\" apabila diminta).","Installation":"pemasangan","Integration_added":"Integrasi telah ditambah","Integration_Incoming_WebHook":"Integrasi WebHook masuk","Integration_New":"Integrasi New","Integration_Outgoing_WebHook":"Integrasi WebHook keluar","Integration_updated":"Integrasi telah dikemaskini","Integrations":"Integrations","Invalid_asset":"aset tidak sah","Invalid_confirm_pass":"Pengesahan kata laluan tidak sepadan dengan kata laluan","Invalid_email":"E-mel yang dimasukkan tidak sah","Invalid_Export_File":"Fail yang dimuat naik tidak %s yang sah fail eksport.","Invalid_file_height":"ketinggian fail yang tidak sah","Invalid_file_type":"Jenis fail tidak sah","Invalid_file_width":"lebar fail yang tidak sah","Invalid_Import_File_Type":"jenis fail Import tidak sah.","Invalid_name":"Nama mesti tidak dikosongkan","Invalid_notification_setting_s":"tetapan pemberitahuan tidak sah: %s","Invalid_pass":"Kata Laluan mesti tidak dikosongkan","Invalid_room_name":"<strong> %s</strong> bukan nama bilik yang sah, <br/> menggunakan hanya huruf, nombor, sengkang dan garis bawah","Invalid_room_type":"<strong> %s</strong> bukan jenis bilik yang sah.","Invalid_Secret_URL":"URL Secret sah","Invalid_secret_URL_message":"URL yang diberikan adalah tidak sah.","invisible":"tidak dalam dilihat","Invisible":"Tidak dapat dilihat","Invitation_HTML":" HTML Jemputan","Invitation_Subject":"Subjek Jemputan","Invite_user_to_join_channel":"Jemput satu pengguna untuk menyertai saluran ini","Invite_Users":"Jemput Pengguna","is_also_typing":"turut menaip","is_also_typing_female":"turut menaip","is_also_typing_male":"turut menaip","is_typing":"sedang menaip","is_typing_female":"sedang menaip","is_typing_male":"sedang menaip","italics":"condong","join":"Sertai","Join_audio_call":"Sertai panggilan audio","Join_the_Community":"Sertai Komuniti","Join_the_given_channel":"Sertai saluran yang dinyatakan","Join_video_call":"Menyertai panggilan video","Joined":"menyertai","Jump":"Jump","Jump_to_first_unread":"Lompat ke belum dibaca pertama","Jump_to_message":"Lompat ke mesej","Jump_to_recent_messages":"Lompat ke mesej terbaru","Katex_Enabled":"Katex Didayakan","Label":"label","Language":"Bahasa","Language_Version":"Versi Bahasa Inggeris","Last_login":"Log masuk terakhir","Last_message":"Mesej terakhir","Last_seen":"Kali terakhir dilihat","Layout":"Tata atur","Layout_Home_Body":"Badan Laman","Layout_Home_Title":"Tajuk Halaman Utama","Layout_Login_Terms":"Terma Log masuk","Layout_Privacy_Policy":"Dasar Privasi","Layout_Sidenav_Footer":"Navigasi Belah Tepi Footer","Layout_Sidenav_Footer_description":"Saiz footer ialah 260x70","Layout_Terms_of_Service":"Terma Perkhidmatan","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Search","LDAP_Custom_Domain_Search_Description":"Sekeping JSON yang mentadbir maklumat mengikat dan sambungan dan dalam bentuk: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domain lalai","LDAP_Description":"LDAP adalah pangkalan data hierarki bahawa banyak syarikat gunakan untuk menyediakan single sign on - kemudahan untuk berkongsi satu kata laluan antara beberapa tapak dan perkhidmatan. Untuk maklumat konfigurasi lanjutan dan contoh, sila rujuk wiki kami: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Base domain","LDAP_Domain_Base_Description":"Nama pertama layak sepenuhnya Cemerlang (DN) seorang anak pohon LDAP anda ingin mencari pengguna-pengguna dan kumpulan. Anda boleh menambah seberapa banyak yang anda suka; Walau bagaimanapun, setiap kumpulan mesti ditakrifkan dalam asas domain yang sama dengan pengguna yang menjadi miliknya. Jika anda menentukan kumpulan pengguna terhad, hanya pengguna yang di dalam kumpulan-kumpulan akan berada dalam skop. Kami mengesyorkan bahawa anda menentukan tahap bahagian atas pokok direktori LDAP anda sebagai asas domain anda dan menggunakan penapis carian untuk mengawal akses.","LDAP_Domain_Search_Filter":"Domain Search Filter","LDAP_Domain_Search_Filter_Description":"Jika dinyatakan, hanya pengguna yang sepadan dengan penapis ini akan dibenarkan untuk log masuk. Jika tiada penapis yang dinyatakan, semua pengguna dalam skop asas domain yang dinyatakan akan dapat untuk mendaftar masuk. <br/> Contohnya untuk Active Directory `memberOf = cn = ROCKET_CHAT, ou = General Groups`. <br/> Contohnya untuk OpenLDAP (search Perlawanan extensible) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Cari Objek Kategori","LDAP_Domain_Search_Object_Category_Description":"The * objectCategory * yang mengenal pasti pengguna anda. <br/> Tinggalkan kosong untuk * OpenLDAP *. <br/> Eg `person`, dan lain-lain","LDAP_Domain_Search_Object_Class":"Domain Kelas Cari Objek","LDAP_Domain_Search_Object_Class_Description":"The * kelas objek * yang mengenal pasti pengguna anda. <br/> Eg `organizationalPerson`,` user`, `inetOrgPerson`, dan lain-lain","LDAP_Domain_Search_Password":"Domain Cari Kata laluan","LDAP_Domain_Search_Password_Description":"Kata laluan untuk pengguna carian domain.","LDAP_Domain_Search_User":"Domain Search Pengguna","LDAP_Domain_Search_User_Description":"The LDAP pengguna yang melaksanakan pencarian pengguna untuk mengesahkan pengguna lain apabila mereka log masuk. <br/> Ini biasanya satu akaun perkhidmatan dicipta khusus untuk integrasi pihak ketiga. Gunakan nama yang memenuhi syarat, seperti `cn = Administrator, cn = Pengguna, dc = Contoh, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search ID Pengguna","LDAP_Domain_Search_User_ID_Description":"The LDAP atribut yang mengenal pasti pengguna LDAP yang cuba pengesahan. medan ini sepatutnya menjadi `sAMAccountName` untuk pemasangan paling Active Directory, tetapi ia boleh menjadi` uid` penyelesaian LDAP yang lain, seperti OpenLDAP. Anda boleh menggunakan `mail` untuk mengenal pasti pengguna melalui e-mel atau apa sahaja atribut yang anda mahu. <br> Anda boleh menggunakan pelbagai nilai dipisahkan oleh koma untuk membolehkan pengguna untuk log masuk menggunakan berbilang pengecam seperti nama pengguna atau e-mel.","LDAP_Enable":"membolehkan","LDAP_Enable_Description":"Cuba untuk menggunakan LDAP untuk pengesahan.","LDAP_Encryption":"penyulitan","LDAP_Encryption_Description":"Kaedah penyulitan digunakan untuk menjamin komunikasi ke pelayan LDAP. Contohnya termasuk `plain` (tiada penyulitan),` SSL / LDAPS` (disulitkan dari awal), dan `StartTLS` (naik taraf kepada komunikasi disulitkan sekali berkaitan).","LDAP_Host":"Host","LDAP_Host_Description":"The LDAP tuan rumah, contohnya `ldap.example.com` atau` 10.0.0.30`.","LDAP_Port":"Port LDAP","LDAP_Port_Description":"Port untuk mengakses LDAP. eg: `389` atau` 636` untuk LDAPS","LDAP_Reject_Unauthorized":"Tolak yang tidak dibenarkan","LDAP_Sync_User_Avatar":"Sync Pengguna Avatar","LDAP_Sync_User_Data":"Sync Data","LDAP_Sync_User_Data_Description":"Menyimpan data pengguna dalam penyegerakan dengan pelayan pada login (contohnya: nama, e-mel).","LDAP_Sync_User_Data_FieldMap":"Pengguna Data Field Peta","LDAP_Sync_User_Data_FieldMap_Description":"Konfigur berapa bidang akaun pengguna (seperti e-mel) adalah penduduk dari satu rekod dalam LDAP (sekali dijumpai). <br/> Sebagai contoh, `{\" cn \":\" nama \",\" mel \":\" e-mel \"}` akan memilih nama seseorang manusia boleh dibaca dari atribut cn, dan e-mel mereka dari sifat mel. <br/> bidang termasuk `name`, dan` email`.","LDAP_Sync_Users":"Pengguna Sync","LDAP_Test_Connection":"Test Connection","LDAP_Unique_Identifier_Field":"Pengecam Unik Field","LDAP_Unique_Identifier_Field_Description":"Yang bidang akan digunakan untuk menghubungkan pengguna LDAP dan pengguna Rocket.Chat itu. Anda boleh memaklumkan pelbagai nilai dipisahkan oleh koma untuk cuba untuk mendapatkan nilai daripada rekod LDAP. <br/> Nilai lalai adalah `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Gunakan Custom Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Tulis penapis anda sendiri untuk mencari pengguna dalam pelayan LDAP.","LDAP_Username_Field":"Nama pengguna Field","LDAP_Username_Field_Description":"Yang bidang akan digunakan sebagai * nama pengguna * bagi pengguna baru. Biarkan kosong untuk menggunakan nama pengguna yang dimaklumkan pada halaman login. <br/> Anda boleh menggunakan tag template juga, seperti `# {givenName}. {# Sn}`. <br/> Nilai lalai adalah `sAMAccountName`.","Leave_Group_Warning":"Adakah anda pasti anda mahu meninggalkan kumpulan \" %s\"?","Leave_Private_Warning":"Adakah anda pasti anda mahu meninggalkan perbincangan dengan \" %s\"?","Leave_room":"Meninggalkan bilik","Leave_Room_Warning":"Adakah anda pasti anda mahu meninggalkan bilik \" %s\"?","line":"garis","List_of_Direct_Messages":"Senarai Mesej Langsung","Live_sessions":"sesi live","Livechat_agents":"ejen LiveChat","Livechat_Dashboard":"Dashboard LiveChat","Livechat_enabled":"LiveChat membolehkan","Livechat_Manager":"Pengurus LiveChat","Livechat_managers":"pengurus LiveChat","Livechat_title":"Tajuk Livechat","Livechat_title_color":"Warna latar belakang tajuk Livechat","Livechat_Users":"Pengguna LiveChat","Load_more":"Memuat lagi","Loading...":"Memuatkan...","Loading_more_from_history":"Memuatkan lagi dari sejarah","Loading_suggestion":"Memuatkan cadangan...","Localization":"penyetempatan","Log_File":"Tunjukkan fail dan Talian","Log_Level":"Log Level","Log_Package":"Show Pakej","Log_View_Limit":"Log Lihat Had","Logged_out_of_other_clients_successfully":"Log keluar daripada pelanggan lain berjaya","Login":"Log masuk","Login_with":"Log masuk dengan %s","login_with":"Atau log masuk secara terus dengan","Logout":"Log keluar","Logout_Others":"Log keluar Dari Logged Lain Di Lokasi","Mail_Message_Invalid_emails":"Anda telah menyediakan e-mel satu atau lebih tidak sah: %s","Mail_Message_Missing_to":"Anda mesti memilih satu atau lebih pengguna atau menyediakan satu atau lebih alamat e-mel, dipisahkan dengan tanda koma.","Mail_Message_No_messages_selected_select_all":"Anda belum memilih sebarang mesej. Adakah anda ingin <a href='#' class='select-all'>memilih semua</a> mesej yang dapat dilihat?","Mail_Messages":"Mesej mail","Mail_Messages_Instructions":"Pilih mesej yang anda ingin menghantar melalui e-mel dengan mengklik mesej","Mail_Messages_Subject":"Berikut adalah bahagian terpilih mesej %s","Mailer":"Mailer","Mailer_body_tags":"Anda <b>mesti</b> menggunakan [unsubscribe] untuk pautan langganan. <br /> Anda boleh menggunakan [nama], [fname], [lname] bagi nama penuh pengguna, nama pertama atau nama akhir, masing-masing. <br /> Anda boleh menggunakan [email] untuk e-mel pengguna.","Make_Admin":"Lantik Pentadbir","Manager_added":"pengurus ditambah","Manager_removed":"pengurus dikeluarkan","Mark_as_read":"Tanda sebagai telah dibaca","Markdown_Headers":"turun harga Pengepala","Markdown_SupportSchemesForLink":"Skim Sokongan turun harga untuk Link","Markdown_SupportSchemesForLink_Description":"Senarai diasingkan koma bagi skim dibenarkan","Members_List":"Senarai Ahli","Mentions":"menyebut","Mentions_default":"Menyebut (default)","Message":"Mesej","Message_AllowDeleting":"Benarkan Pemadaman Mesej","Message_AllowEditing":"Benarkan Penyuntingan Mesej","Message_AllowEditing_BlockEditInMinutes":"Sekat penyuntingan mesej selepas (dalam minit - 0 hingga melumpuhkan)","Message_AllowEditing_BlockEditInMinutesDescription":"Masukkan 0 untuk melumpuhkan menyekat.","Message_AllowPinning":"Benarkan Mesej Pelekatan","Message_AllowPinning_Description":"Benarkan mesej disematkan ke mana-mana saluran.","Message_AllowStarring":"Benarkan Mesej Dibintangi","Message_AudioRecorderEnabled":"Perakam Audio Diaktifkan","Message_AudioRecorderEnabledDescription":"Memerlukan '/ audio wav' fail untuk jenis media diterima dalam masa tetapan 'File Upload'.","Message_DateFormat":"Format tarikh","Message_DateFormat_Description":"Lihat juga: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Pemadaman mesej tidak dibenarkan","Message_editing_blocked":"Mesej ini tidak boleh lagi disunting","Message_editing_not_allowed":"Penyuntingan mesej tidak dibenarkan","Message_GroupingPeriod":"Mengumpulkan Tempoh (dalam saat)","Message_GroupingPeriodDescription":"Mesej akan dikumpulkan dengan mesej sebelumnya jika kedua-duanya dari pengguna yang sama dan masa yang berlalu adalah kurang daripada masa yang bijak di saat.","Message_KeepHistory":"Simpan Sejarah Mesej","Message_MaxAllowedSize":"Saiz mesej maksimum yang dibenarkan","Message_MaxAll":"saiz saluran maksimum untuk ALL mesej","Message_pinned":"Mesej dipinkan","Message_pinning_not_allowed":"Mesej menyematkan tidak dibenarkan","Message_removed":"Mesej dipadam","Message_ShowDeletedStatus":"Tunjuk Status Pemadaman","Message_ShowEditedStatus":"Tunjuk Status Penyuntingan","Message_ShowFormattingTips":"Tunjuk Tip Pemformatan","Message_TimeFormat":"masa Format","Message_TimeFormat_Description":"Lihat juga: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Mesej terlalu lama","Messages":"Mesej","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Mesej-mesej yang dihantar ke masuk WebHook akan disiarkan di sini.","Meta":"Meta","Meta_fb_app_id":"Facebook APP ID","Meta_google-site-verification":"Pengesahan Laman Google","Meta_language":"Bahasa","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robot","minutes":"minit","Mobile_push":"Mobile push","More_channels":"Lagi saluran","More_direct_messages":"Lebih mesej langsung","More_groups":"Lagi kumpulan persendirian","More_unreads":"Lagi belum dibaca","Msgs":"Mesej","multi":"pelbagai","Mute_someone_in_room":"seseorang bisu di dalam bilik","Mute_user":"pengguna bisu","Muted":"disenyapkan","My_Account":"Akaun Saya","n_messages":"%s mesej","N_new_messages":" %s mesej baru","Name":"Nama","Name_cant_be_empty":"Nama tidak boleh dibiarkan kosong","Name_of_agent":"Nama ejen","Name_optional":"Nama (pilihan)","Navigation_History_20_last_pages":"Navigation Sejarah (20 muka surat terakhir)","New_Application":"Permohonan baru","New_Custom_Field":"New Field Custom","New_Department":"Jabatan baru","New_integration":"integrasi baru","New_logs":"balak baru","New_messages":"Mesej baru","New_password":"Kata Laluan baru","New_role":"peranan baru","No_channel_with_name_%s_was_found":"Tiada saluran dengan nama <strong>\"%s\"</strong> dijumpai!","No_channels_yet":"Anda bukan daripada mana-mana saluran lagi.","No_direct_messages_yet":"Anda tidak memulakan sebarang perbualan lagi.","No_Encryption":"Tiada penyulitan","No_favorites_yet":"Anda belum menambah sebarang kegemaran lagi.","No_group_with_name_%s_was_found":"Tiada kumpulan persendirian dengan nama <strong>\"%s\"</strong> dijumpai!","No_groups_yet":"Anda tidak mempunyai kumpulan persendirian lagi.","No_livechats":"Anda tidak mempunyai livechats.","No_mentions_found":"No menyebut mendapati","No_permission_to_view_room":"Anda tidak mempunyai kebenaran untuk melihat bilik ini","No_pinned_messages":"Tiada mesej yang disematkan","No_results_found":"Tiada keputusan dijumpai","No_starred_messages":"Tiada mesej berbintang","no_tokens_for_this_user":"Tiada token untuk pengguna ini","No_user_with_username_%s_was_found":"Tiada pengguna dengan nama pengguna <strong>\"%s\"</strong> dijumpai!","Not_allowed":"Tidak dibenarkan","Not_authorized":"tidak dibenarkan","Not_Available":"tidak Sesuai","Not_found_or_not_allowed":"Tidak Ditemui atau Tidak Dibenarkan","Nothing":"Tiada apa-apa","Nothing_found":"Tiada apa Dijumpai","Notifications":"Pemberitahuan","Notify_all_in_this_room":"Memberitahu semua di dalam bilik ini","Num_Agents":"# Agents","Number_of_messages":"Bilangan mesej","OAuth_Application":"OAuth Permohonan","OAuth_Applications":"Aplikasi OAuth","Objects":"objek","Off_the_record_conversation":"Off-the-rekod Perbualan","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-rekod perbualan tidak tersedia untuk pelayar atau peranti anda.","Offline_DM_Email":"[__site__] Anda telah menghantar mesej langsung oleh __user__","Offline_Mention_Email":"[__site__] Anda telah disebut oleh __user__ dalam #__room__","Old_and_new_password_must_be_different":"Kata laluan baru mesti berbeza daripada kata laluan lama.","Old_and_new_password_required":"Anda perlu memberikan kedua-dua kata laluan lama dan baru untuk menukar kata laluan anda.","Online":"Dalam talian","Only_errors":"hanya kesilapan","Only_you_can_see_this_message":"Hanya anda yang boleh melihat mesej ini","Oops!":"Oops","Open":"Dibuka","Opened":"dibuka","Opt_out_statistics":"Jangan hantar statistik saya ke Rocket.Chat","Opt_out_statistics_warning":"Dengan menghantar statistik anda, ada akan membantu kami mengenalpasti berapa banyak","optional":"pilihan","Order":"Order","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Count","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Average","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Total Memory","OS_Type":"OS Type","OS_Uptime":"OS Uptime","others":"lain-lain","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR hanya tersedia apabila kedua-dua pengguna sedang online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL Override untuk fail yang dimuat naik. url ini juga digunakan untuk muat turun melainkan CDN diberikan","Password":"Kata Laluan","Password_Change_Disabled":"pentadbir Rocket.Chat anda telah melumpuhkan perubahan kata laluan","Password_changed_successfully":"Kata Laluan berjaya ditukar","Payload":"muatan","People":"Orang","Permissions":"kebenaran","Pin_Message":"pin Mesej","Pinned_a_message":"Disematkan mesej:","Pinned_Messages":"Mesej disematkan","Placeholder_for_email_or_username_login_field":"Pemegang tempat untuk e-mel atau nama pengguna log masuk bidang","Placeholder_for_password_login_field":"Pemegang tempat untuk medan login kata laluan","Please_answer_survey":"Sila luangkan sedikit masa untuk menjawab kaji selidik yang cepat mengenai sembang ini","Please_enter_value_for_url":"Sila masukkan sesuatu dalam url avatar anda.","Please_enter_your_new_password_below":"Sila masukkan kata laluan baru anda di bawah:","Please_fill_a_label":"Sila isikan label","Please_fill_a_name":"Sila isikan nama","Please_fill_a_username":"Sila isi nama pengguna","Please_fill_name_and_email":"Sila isikan nama dan e-mel","Please_re_enter_your_password":"Sila masukkan semula kata laluan anda","Please_select_enabled_yes_or_no":"Sila buat pilihan Didayakan","Please_wait":"Sila tunggu","Please_wait_activation":"Sila tunggu, ini boleh mengambil beberapa masa.","Please_wait_statistics":"Sila tunggu, statistik sedang dijana.","Please_wait_while_OTR_is_being_established":"Sila tunggu sementara OTR sedang diwujudkan","Please_wait_while_your_account_is_being_deleted":"Sila tunggu sementara akaun anda dipadamkan ...","Please_wait_while_your_profile_is_being_saved":"Sila tunggu sementara profil anda sedang disimpan ...","Post_as":"Post sebagai","Post_to_Channel":"Hantar ke Saluran","Post_to_s_as_s":"Pos <strong>kepada %s</strong> <strong>sebagai %s</strong>","Powered_by":"Dikuasakan oleh","Preferences":"Keutamaan","Preferences_saved":"Keutamaan disimpan","Privacy":"Privasi","Private_Group":"Kumpulan swasta","Private_Groups":"Kumpulan Persendirian","Private_Groups_list":"Senarai daripada Kumpulan Persendirian","Profile":"Profil","Profile_saved_successfully":"Profil berjaya disimpan","Proudly_developed":"Dengan bangganya dibangunkan dengan Meteor","Push":"push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"Frasa Laluan APN","Push_debug":"Debug","push_disabled":"tolak kurang upaya","Push_enable":"Aktifkan","Push_enable_gateway":"membolehkan Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Nombor Projek","Push_production":"Penerbitan","Push_show_message":"Menunjukkan mesej dalam pemberitahuan","Push_show_username_room":"Show saluran / kumpulan / nama pengguna dalam pemberitahuan","Push_test_push":"ujian","Query":"pertanyaan","Query_description":"Syarat tambahan untuk menentukan pengguna untuk menghantar e-mel kepada. pengguna tidak dilanggan secara automatik dikeluarkan daripada pertanyaan. Ia mesti JSON yang sah. Contoh: \"{\" createdAt \": {\" $ gt \": {\" tarikh $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Carian Pantas","quote":"quote","Reactions":"reaksi","Recents":"baru-baru ini","Record":"Rakam","Redirect_URI":"redirect URI","Refresh_keys":"kunci Refresh","Refresh_your_page_after_install_to_enable_screen_sharing":"Muat semula halaman anda selepas memasang untuk membolehkan perkongsian skrin","Register":"Mendaftar akaun baru","Registration_Succeeded":"Pendaftaran Berjaya","Remember_me":"Ingatkan saya","Remove":"Padam","Remove_Admin":"Padam Pentadbir","Remove_as_moderator":"Keluarkan sebagai moderator","Remove_as_owner":"Buang sebagai pemilik","Remove_custom_oauth":"Buang OAuth adat","Remove_from_room":"Alih Keluar dari bilik","Remove_someone_from_room":"Mengeluarkan seseorang dari bilik","Removed":"dikeluarkan","Require_password_change":"Memerlukan perubahan kata laluan","Resend_verification_email":"Menghantar semula e-mel pengesahan","Reset":"Reset","Reset_password":"Menetapkan semula kata laluan","Restart":"Mula semula","Restart_the_server":"Memulakan semula pelayan","RocketBot_Enabled":"RocketBot Diaktifkan","RocketBot_Name":"Nama RocketBot","RocketBot_Name_Description":"Nama RocketBot mesti mengandungi nama pengguna yang sah berdaftar pada pelayan anda.","Role":"peranan","Role_Editing":"peranan Editing","Role_removed":"peranan dikeluarkan","Room":"Bilik","Room_archivation_state":"Negeri","Room_archivation_state_false":"aktif","Room_archivation_state_true":"diarkibkan","Room_archived":"bilik diarkibkan","room_changed_privacy":"Jenis bilik diubah kepada: <em>__room_type__</em> oleh <em>__user_by__</em>","room_changed_topic":"Topik Bilik diubah kepada: <em>__room_topic__</em> oleh <em>__user_by__</em>","Room_has_been_deleted":"Bilik telah dipadam","Room_Info":"Maklumat bilik","Room_name_changed":"Nama bilik ditukar kepada: <em>__room_name__</em> daripada <em>__user_by__</em>","Room_name_changed_successfully":"Nama bilik berjaya ditukar","Room_not_found":"Bilik tidak dijumpai","Room_topic_changed_successfully":"topik Bilik berjaya ditukar","Room_type_changed_successfully":"Jenis bilik ditukar dengan jayanya","Room_unarchived":"bilik dinyaharkibkan","Room_uploaded_file_list":"Senarai fail","Room_uploaded_file_list_empty":"Tiada fail yang ada.","room_user_count":"Pengguna %s","Rooms":"Bilik","S_new_messages_since_s":"%s mesej baru sejak %s","SAML":"SAML","SAML_Custom_Cert":"Sijil Custom","SAML_Custom_Entry_point":"Entry Point Custom","SAML_Custom_Generate_Username":"menjana Nama pengguna","SAML_Custom_Issuer":"Custom Penerbit","SAML_Custom_Provider":"Pembekal Custom","Save":"Simpan","Save_changes":"Simpan perubahan","Save_Mobile_Bandwidth":"Simpan Jalur lebar mudah alih","Save_to_enable_this_action":"Jimat untuk membolehkan tindakan ini","Saved":"disimpan","Saving":"Menyelamatkan","Scope":"Skop","Screen_Share":"skrin Kongsi","Script_Enabled":"Script Didayakan","Search":"Cari","Search_by_username":"Cari dengan nama pengguna","Search_Channels":"Cari Saluran","Search_Direct_Messages":"Mencari Mesej Langsung","Search_Messages":"Cari Mesej","Search_Private_Groups":"Cari Kumpulan Swasta","Search_settings":"Tetapan carian","seconds":"saat","See_all":"Lihat semua","See_only_online":"Hanya Dalam talian","Select_a_department":"Pilih jabatan","Select_an_avatar":"Pilih avatar","Select_file":"Pilih fail","Select_service_to_login":"Pilih perkhidmatan untuk log masuk untuk memuat gambar anda atau muat naik terus satu daripada komputer anda","Select_user":"Pilih pengguna","Select_users":"Pilih pengguna","Selected_agents":"ejen terpilih","Selected_users":"Ahli yang terpilih","Send":"Hantar","Send_a_message":"Hantar satu mesej","Send_a_test_mail_to_my_user":"Hantar mel ujian untuk pengguna saya","Send_a_test_push_to_my_user":"Menghantar dorongan ujian untuk pengguna saya","Send_confirmation_email":"Hantar e-mel pengesahan","Send_data_into_RocketChat_in_realtime":"Menghantar data ke Rocket.Chat dalam masa nyata.","Send_email":"Menghantar e-mel","Send_invitation_email":"Hantar jemputan e-mel","Send_invitation_email_error":"Anda belum memberikan mana-mana alamat e-mel yang sah.","Send_invitation_email_info":"Anda boleh menghantar beberapa e-mel jemputan sekaligus.","Send_invitation_email_success":"Anda telah berjaya menghantar e-mel jemputan ke alamat berikut:","Send_invitation_email_warning":"Untuk menghantar e-mel jemputan, anda mesti mengkonfigurasi tetapan SMTP","Send_Message":"Hantar mesej","Send_your_JSON_payloads_to_this_URL":"Menghantar muatan JSON anda ke URL ini.","Sending":"Dikirim ...","Set_as_moderator":"Ditetapkan sebagai moderator","Set_as_owner":"Ditetapkan sebagai pemilik","Settings":"Tetapan","Settings_updated":"Tetapan dikemaskini","Should_be_a_URL_of_an_image":"Sekiranya menjadi URL imej.","Should_exists_a_user_with_this_username":"Pengguna mesti sudah wujud.","Show_all":"Tunjukkan semua","Show_more":"Papar semua","Show_only_online":"Paparkan hanya talian","Show_preregistration_form":"Tunjukkan Borang pra-pendaftaran","Showing_archived_results":"<p> Menunjukkan hasil yang <b>diarkibkan %s</b> </p>","Showing_online_users":"Menunjukkan <b>__total_showing__</b> dari  __total__ pengguna","Showing_results":"<p>Menunjukan <b>%s</b> keputusan</p>","Silence":"Senyap","since_creation":"sejak %s","Site_Name":"Nama Laman:","Site_Url":"URL laman","Site_Url_Description":"Contoh: https://chat.domain.com/","Skip":"Langkau","Smileys_and_People":"Senyuman & Rakyat","SMTP":"SMTP","SMTP_Host":"Hos SMTP","SMTP_Password":"Kata Laluan SMTP","SMTP_Port":"Port SMTP","SMTP_Test_Button":"Tetapan Test SMTP","SMTP_Username":"Nama Pengguna SMTP","Sound":"Bunyi","Star_Message":"Bintangkan Mesej ","Starred_Messages":"Mesej Berbintang","Start_audio_call":"Mulakan panggilan audio","Start_Chat":"Mula Chat","Start_of_conversation":"Permulaan perbualan","Start_OTR":"Mula OTR","Start_video_call":"Mulakan panggilan video","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Mulakan dengan <code class=\"inline\">%s</code> untuk pengguna atau <code class=\"inline\">%s</code> untuk saluran. Contoh: <code class=\"inline\">%s</code> atau <code class=\"inline\">%s</code>","Statistics":"Statistik","Stats_Active_Users":"Pengguna Aktif","Stats_Avg_Channel_Users":"Purata Pengguna Saluran","Stats_Avg_Private_Group_Users":"Purata Pengguna Kumpulan Persendirian","Stats_Away_Users":"Pengguna Keluar","Stats_Max_Room_Users":"Maksimum Pengguna Bilik","Stats_Non_Active_Users":"Pengguna Tidak Aktif","Stats_Offline_Users":"Pengguna Luar talian","Stats_Online_Users":"Pengguna Dalam talian","Stats_Total_Channels":"Jumlah Saluran","Stats_Total_Direct_Messages":"Jumlah Bilik Mesej Langsung","Stats_Total_Messages":"Jumlah Mesej","Stats_Total_Private_Groups":"Jumlah Kumpulan Persendirian","Stats_Total_Rooms":"Jumlah Bilik","Stats_Total_Users":"Jumlah Pengguna","Stop_Recording":"Berhenti Merakam","strike":"mogok","Subject":"subjek","Submit":"Hantar","Success":"kejayaan","Survey":"Survey","Survey_instructions":"Menilai setiap soalan menurut kepuasan anda, 1 bermakna anda benar-benar berpuas hati dan 5 yang bermaksud anda benar-benar berpuas hati.","Symbols":"simbol","Sync_success":"kejayaan Sync","Sync_Users":"Pengguna Sync","Test_Connection":"Test Connection","Test_Desktop_Notifications":"Test Desktop Pemberitahuan","Thank_you_for_your_feedback":"Terima kasih atas maklum balas anda","The_application_name_is_required":"Nama permohonan diperlukan","The_channel_name_is_required":"Nama saluran diperlukan","The_emails_are_being_sent":"E-mel yang sedang dihantar.","The_field_is_required":"Medan ini %s diperlukan","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"The saiz semula imej tidak akan berfungsi kerana kita tidak dapat mengesan ImageMagick atau GraphicsMagick dipasang pada pelayan anda.","The_redirectUri_is_required":"The redirectUri diperlukan","The_server_will_restart_in_s_seconds":"Server akan memulakan semula dalam %s saat","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Penubuhan %s</strong> dikonfigurasi <strong>untuk %s</strong> dan anda mengakses <strong>dari %s!</strong>","The_user_will_be_removed_from_s":"Pengguna akan dikeluarkan daripada %s","The_user_wont_be_able_to_type_in_s":"Pengguna tidak akan dapat untuk menaip dalam %s","Theme":"tema","theme-color-action-buttons-color":"Tindakan Butang Warna","theme-color-active-channel-background-color":"Active Channel Warna Latar Belakang","theme-color-active-channel-font-color":"Active Channel Font Warna","theme-color-blockquote-background":"Warna Latar Belakang Blockquote","theme-color-clean-buttons-color":"Butang Bersih Warna","theme-color-code-background":"Kod Warna Latar Belakang","theme-color-code-border":"Kod Warna Sempadan","theme-color-code-color":"kod Warna","theme-color-content-background-color":"Warna Latar Belakang kandungan","theme-color-custom-scrollbar-color":"Custom Scrollbar Color","theme-color-info-active-font-color":"Maklumat Active Font Warna","theme-color-info-font-color":"Maklumat Font Warna","theme-color-input-font-color":"Input Font Warna","theme-color-link-font-color":"Link Font Warna","theme-color-message-hover-background-color":"Mesej Hover BG Warna","theme-color-primary-background-color":"Warna Latar Belakang Utama","theme-color-primary-font-color":"Primary Font Warna","theme-color-quaternary-font-color":"Kuarter Font Warna","theme-color-secondary-background-color":"Warna Latar Belakang Menengah","theme-color-secondary-font-color":"Menengah Font Warna","theme-color-smallprint-font-color":"Cetak Kecil Font Warna","theme-color-smallprint-hover-color":"Cetak Kecil Hover Warna","theme-color-status-away":"Status Away Warna","theme-color-status-busy":"Status Busy Warna","theme-color-status-offline":"Status Offline Warna","theme-color-status-online":"Online Status Warna","theme-color-tertiary-background-color":"Warna Latar Belakang Tertiary","theme-color-tertiary-font-color":"Tertiary Font Warna","theme-color-unread-notification-color":"Belum Baca Pemberitahuan Warna","theme-custom-css":"CSS Custom","There_are_no_agents_added_to_this_department_yet":"Tiada ejen ditambah kepada jabatan ini.","There_are_no_integrations":"Tiada integrasi","There_are_no_users_in_this_role":"Tiada pengguna dalam peranan ini.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"E-mel ini telah digunakan dan tidak disahkan. Sila tukar kata laluan anda.","This_is_a_desktop_notification":"Ini adalah pemberitahuan desktop","This_is_a_push_test_messsage":"Ini adalah mesej supaya ujian push","Time_in_seconds":"Masa dalam saat","Title_bar_color":"warna bar tajuk","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Untuk memasang Rocket.Chat LiveChat di laman web anda, copy & paste kod ini di atas terakhir <strong></ body></strong> tag pada laman anda.","To_users":"kepada Pengguna","Topic":"Topic","Travel_and_Places":"Travel & Places","Trigger_removed":"Trigger dikeluarkan","Trigger_Words":"Trigger Perkataan","Triggers":"Pencetus","True":"Dayakan","Type":"Jenis","Type_your_new_password":"Taipkan kata laluan baru anda","Unarchive":"Nyaharkibkan","Unmute_someone_in_room":"seseorang Nyahsenyap di dalam bilik","Unmute_user":"pengguna Nyahsenyap","Unnamed":"Tidak dinamakan","Unpin_Message":"Mesej buka pin","Unread_Rooms":"Bilik yang belum dibaca","Unread_Rooms_Mode":"Mod belum dibaca Bilik","Unstar_Message":"Padam Bintang","Upload_file_question":"Muat naik fail?","Uploading_file":"Memuat naik fail ...","Use_account_preference":"Gunakan keutamaan akaun","Use_Emojis":"Guna Emoji","Use_initials_avatar":"Guna singkatan nama pengguna anda","use_menu":"Gunakan menu sebelah untuk mengakses bilik dan sembang anda","Use_service_avatar":"Guna %s avatar","Use_this_username":"Guna nama pengguna ini","Use_uploaded_avatar":"Guna avatar yang dimuat naik","Use_url_for_avatar":"Guna url untuk avatar","User__username__is_now_a_moderator_of__room_name_":"__nama pengguna__ pengguna kini merupakan moderator __room_name__","User__username__is_now_a_owner_of__room_name_":"__nama pengguna__ pengguna kini merupakan pemilik __room_name__","User__username__removed_from__room_name__moderators":"__nama pengguna__ Pengguna dikeluarkan dari moderator __room_name__","User__username__removed_from__room_name__owners":"__nama pengguna__ Pengguna dikeluarkan daripada pemilik __room_name__","User_added":"Pengguna <em>__user_added__</em> ditambah.","User_added_by":"Pengguna <em>__user_added__</em> ditambah oleh <em>__user_by__</em>.","User_added_successfully":"Pengguna berjaya diletakkan","User_Channels":"Saluran Pengguna","User_doesnt_exist":"Tiada pengguna wujud dengan nama `@%s`.","User_has_been_activated":"Pengguna telah diaktifkan","User_has_been_deactivated":"Pengguna telah dinyahaktifkan","User_has_been_deleted":"Pengguna telah dipadam","User_has_been_muted_in_s":"Pengguna telah disenyapkan dalam %s","User_has_been_removed_from_s":"Pengguna telah dikeluarkan daripada %s","User_has_disconnected":"Pengguna yang terputus","User_Info":"Maklumat Pengguna","User_is_no_longer_an_admin":"Pengguna tidak lagi seorang pentadbir","User_is_not_activated":"Pengguna tidak diaktifkan","User_is_now_an_admin":"Pengguna sekarang adalah pentadbir","User_joined_channel":"Telah menyertai saluran.","User_joined_channel_female":"Telah menyertai saluran.","User_joined_channel_male":"Telah menyertai saluran.","User_left":"Pengguna <em>__user_left__</em> meninggalkan.","User_left_female":"User <em>__user_left__</em> meninggalkan.","User_left_male":"Pengguna <em>__user_left__</em> meninggalkan.","User_logged_out":"Pengguna melog keluar","User_management":"Pengurusan pengguna","User_muted_by":"<em>__user_muted__</em> Pengguna disenyapkan oleh <em>__user_by__.</em>","User_muted_in_room":"Pengguna disenyapkan di dalam bilik","User_not_found":"Pengguna tidak dijumpai","User_not_found_or_incorrect_password":"Pengguna tidak dijumpai atau kata laluan salah","User_or_channel_name":"Pengguna atau saluran nama","User_removed":"pengguna dikeluarkan","User_removed_by":"Pengguna <em>__user_removed__</em> dibuang oleh <em>__user_by__</em>.","User_removed_from_room":"Pengguna ini telah dikeluarkan dari bilik","User_Settings":"Tetapan Pengguna","User_unmuted_by":"<em>__user_unmuted__</em> Pengguna menyahsenyapkan oleh <em>__user_by__.</em>","User_unmuted_in_room":"Pengguna dinyahredam dalam bilik","User_updated_successfully":"Pengguna berjaya dikemaskini","Username":"Nama Pengguna","Username_and_message_must_not_be_empty":"Nama pengguna dan mesej tidak perlu menjadi kosong.","Username_cant_be_empty":"Nama Pengguna tidak boleh dibiarkan kosong","Username_Change_Disabled":"pentadbir Rocket.Chat anda telah melumpuhkan perubahan nama pengguna","Username_denied_the_OTR_session":"__nama pengguna__ menafikan sesi OTR yang","Username_description":"Nama Pengguna adalah digunakan untuk membolehkan pengguna lain menyebut anda di mesej.","Username_doesnt_exist":"Nama pengguna ' %s` tidak wujud.","Username_ended_the_OTR_session":"__nama pengguna__ mengakhiri sesi OTR yang","Username_invalid":"<strong>%s</strong> bukan nama pengguna yang sah,<br/> guna hanya huruf, nombor, titik dan pemisah","Username_is_already_in_here":"`@%s` sudah berada di sini.","Username_is_not_in_this_room":"Pengguna `# %s` tidak ada di dalam bilik ini.","Username_not_found":"Nama pengguna tidak dijumpai","Username_title":"Daftar nama pengguna","Username_unavaliable":"<strong>%s</strong> sudah digunakan :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__nama pengguna__ ingin memulakan OTR. Adakah anda mahu terima?","Users":"Pengguna","Users_in_role":"Pengguna dalam peranan","UTF8_Names_Slugify":"UTF8 Nama Slugify","UTF8_Names_Validation":"UTF8 Nama Pengesahan","UTF8_Names_Validation_Description":"Tidak membenarkan aksara khas dan ruang. Anda boleh menggunakan - _ dan. tetapi tidak pada akhir nama","Verification_email_sent":"e-mel pengesahan yang dihantar","View_All":"Lihat Semua","View_Logs":"Lihat Balak","Visibility":"kebolehlihatan","Visible":"yang boleh dilihat","Visitor":"Pelawat","Visitor_page_URL":"URL halaman Pelawat","Visitor_time_on_site":"kali pengunjung di laman web","Wait_activation_warning":"Sebelum anda boleh log masuk, akaun anda mesti diaktifkan secara manual oleh pentadbiran.","We_are_offline_Sorry_for_the_inconvenience":"Kami berada di luar talian. Maaf atas kesulitan.","We_have_sent_password_email":"Kami telah menghantar e-mel dengan arahan reset password. Jika anda tidak menerima e-mel tidak lama lagi, sila lawat sekali dan cuba lagi.","We_have_sent_registration_email":"Kami telah menghantar kepada anda e-mel untuk mengesahkan pendaftaran anda. Jika anda tidak menerima e-mel berikut dalam masa terdekat. sila datang kembali dan cuba lagi.","WebRTC_Enable_Channel":"Dayakan untuk Saluran Awam","WebRTC_Enable_Direct":"Dayakan untuk Mesej Langsung","WebRTC_Enable_Private":"Dayakan untuk Saluran Swasta","WebRTC_Servers":"STUN / TURN Server","WebRTC_Servers_Description":"Senarai STUN dan TURN pelayan dipisahkan oleh koma. <br/> Nama pengguna, kata laluan dan pelabuhan yang dibenarkan dalam format `nama pengguna: Kata laluan @ membisingkan: host: port` atau` nama pengguna: Kata laluan @ seterusnya: host: port`.","Welcome":"Selamat datang <em>%s</em>.","Welcome_to_the":"Selamat datang ke","will_be_able_to":"akan dapat","With_whom":"Dengan siapa","Yes":"Ya","Yes_clear_all":"Ya, jelas semua!","Yes_delete_it":"Ya, padam ia!","Yes_hide_it":"Ya, menyembunyikannya!","Yes_leave_it":"Ya, biarkan!","Yes_mute_user":"Ya, bisu pengguna!","Yes_remove_user":"Ya, keluarkan pengguna!","you_are_in_preview_mode_of":"Anda berapa di dalam mod pralihat saluran #<strong>__room_name__</strong>","You_are_logged_in_as":"Anda log masuk sebagai","You_are_not_authorized_to_view_this_page":"Anda tiada kebenaran untuk melihat halaman ini.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Anda pemilik terakhir. Sila menetapkan pemilik baru sebelum meninggalkan bilik.","You_can_change_a_different_avatar_too":"Anda boleh mengatasi avatar yang digunakan untuk hantar daripada integrasi ini.","You_can_use_an_emoji_as_avatar":"Anda juga boleh menggunakan emoji sebagai avatar.","You_have_been_muted":"Anda telah disenyapkan dan tidak boleh bercakap di dalam bilik ini","You_have_not_verified_your_email":"Anda belum mengesahkan e-mel anda.","You_have_successfully_unsubscribed":"Anda telah berjaya menghentikan langganan Senarai bil penghantaran kami.","You_informed_an_invalid_FROM_address":"Anda dimaklumkan yang tidak sah DARI alamat.","You_must_provide_the_unsubscribe_link":"Anda mesti menyediakan [unsubscribe] link.","You_need_confirm_email":"Anda perlu mengesahkan e-mel anda untuk melog masuk!","You_need_install_an_extension_to_allow_screen_sharing":"Anda perlu memasang lanjutan untuk membolehkan perkongsian skrin","You_need_to_change_your_password":"Anda perlu mengubah kata laluan anda","You_need_to_type_in_your_password_in_order_to_do_this":"Anda perlu menaip kata laluan anda untuk melakukan ini!","You_need_to_type_in_your_username_in_order_to_do_this":"Anda perlu menaip nama pengguna anda untuk melakukan ini!","You_need_to_verifiy_your_email_address_to_get_notications":"Anda perlu mengesahkan sama alamat e-mel anda untuk mendapatkan pemberitahuan","You_should_name_it_to_easily_manage_your_integrations":"Anda perlu menamakan ia dengan mudah menguruskan integrasi anda.","You_will_not_be_able_to_recover":"Anda tidak boleh membaik pulih.","You_will_not_be_able_to_recover_file":"Anda tidak akan dapat untuk mendapatkan semula fail ini!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Anda tidak akan menerima pemberitahuan e-mel kerana anda belum mengesahkan e-mel anda.","Your_email_has_been_queued_for_sending":"e-mel anda telah beratur untuk menghantar","Your_entry_has_been_deleted":"Entri anda telah dipadam.","Your_file_has_been_deleted":"Fail anda telah dipadam.","Your_mail_was_sent_to_s":"mel anda telah dihantar ke %s","Your_Open_Source_solution":"penyelesaian chat Sumber Terbuka anda sendiri","Your_password_is_wrong":"Kata laluan anda adalah salah!","Your_push_was_sent_to_s_devices":"push anda telah dihantar ke peranti %s"});
TAPi18n._registerServerTranslator("ms-MY", namespace);                                                                 // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/nl.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["nl"] = ["Dutch","Nederlands"];                                                                // 8
if(_.isUndefined(TAPi18n.translations["nl"])) {                                                                        // 9
  TAPi18n.translations["nl"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["nl"][namespace])) {                                                             // 13
  TAPi18n.translations["nl"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["nl"][namespace], {"500":"Interne Server Fout","0_Errors_Only":"0 - Alleen fouten","1_Errors_and_Information":"1 - Fouten en infomatie","2_Erros_Information_and_Debug":"2 - Fouten, informatie en debuginformatie","__username__was_set__role__by__user_by_":"__username__ werd __role__ instellen door __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ is niet langer __role__, door __user_by__","Access_not_authorized":"Toegang niet geautoriseerd","Access_online_demo":"Toegang tot de online demo","Access_Online_Demo":"Toegang tot de online demo","Access_Token_URL":"Access Token URL","Accounts":"Accounts","Accounts_AllowDeleteOwnAccount":"Sta gebruikers toe om eigen account te verwijderen","Accounts_AllowedDomainsList":"Toegestaan ​​Domeinen Lijst","Accounts_AllowedDomainsList_Description":"Komma-gescheiden lijst van toegestande domeinen","Accounts_AllowEmailChange":"Sta e-mail wijzigen toe","Accounts_AllowPasswordChange":"Toestaan wachtwoord wijzigen","Accounts_AllowUserAvatarChange":"Sta wijzigen van gebruikers Avatar toe","Accounts_AllowUsernameChange":"Toestaan wijzigen gebruikersnaam","Accounts_AllowUserProfileChange":"Sta wijzen van gebruikers profiel toe","Accounts_AvatarResize":"Wijzig Avatar grootte","Accounts_AvatarSize":"Avatar grootte","Accounts_AvatarStorePath":"Avatar opslag pad","Accounts_AvatarStoreType":"Avatar opslag type","Accounts_BlockedDomainsList":"Geblokkeerde domeinen List","Accounts_BlockedDomainsList_Description":"Door komma's gescheiden lijst van geblokkeerde domeinen","Accounts_denyUnverifiedEmail":"Weiger ongeverifieerde e-mail","Accounts_EmailVerification":"E-mail verificatie","Accounts_EmailVerification_Description":"Zorg ervoor dat u de juiste SMTP-instellingen om deze functie te gebruiken","Accounts_Enrollment_Email":"Registratie E-mail","Accounts_Enrollment_Email_Description":"You may use [name], [fname], [lname] for the user's full name, first name or last name, respectively.<br />You may use [email] for the user's e-mail.","Accounts_Iframe_api_method":"API-methode","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"Ingeschakeld","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Login Vervaltermijn in Dagen","Accounts_ManuallyApproveNewUsers":"Handmatig goedkeuren Nieuwe Gebruikers","Accounts_OAuth_Custom_Token_Sent_Via":"Token Sent Via","Accounts_OAuth_Custom_Authorize_Path":"Machtigen Path","Accounts_OAuth_Custom_Button_Color":"Knop Color","Accounts_OAuth_Custom_Button_Label_Color":"Knop Tekst Kleur","Accounts_OAuth_Custom_Button_Label_Text":"Knop Tekst","Accounts_OAuth_Custom_Enable":"Inschakelen","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identiteit Path","Accounts_OAuth_Custom_Login_Style":"Login Stijl","Accounts_OAuth_Custom_Secret":"Geheim","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Inloggen","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Ingeschakeld","Accounts_OAuth_Github_callback_url":"Github Callback URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Ingeschakeld","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise Callback URL","Accounts_OAuth_GitHub_Enterprise_id":"Client Id","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Client Id","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab Callback URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google Inloggen","Accounts_OAuth_Google_callback_url":"Google Callback URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Inloggen","Accounts_OAuth_Linkedin_callback_url":"Linkedin Callback URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Inloggen","Accounts_OAuth_Meteor_callback_url":"Meteor Callback URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Inloggen","Accounts_OAuth_Twitter_callback_url":"Twitter Callback URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Inloggen","Accounts_OAuth_Wordpress_callback_url":"Wordpress Callback URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Geheim (secret)","Accounts_PasswordReset":"Wachtwoord reset","Accounts_Registration_AuthenticationServices_Enabled":"Registration with Authentication Services","Accounts_RegistrationForm":"Registratieformulier","Accounts_RegistrationForm_Disabled":"Uitgeschakeld","Accounts_RegistrationForm_LinkReplacementText":"Registration Form Link Replacement Text","Accounts_RegistrationForm_Public":"Openbaar","Accounts_RegistrationForm_Secret_URL":"Geheime URL","Accounts_RegistrationForm_SecretURL":"Registration Form Secret URL","Accounts_RegistrationForm_SecretURL_Description":"You must provide a random string that will be added to your registration URL. Example: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Registratie vereist","Accounts_RequireNameForSignUp":"Vereis naam tijdens registratie","Accounts_ShowFormLogin":"Laat formulier-gebaseerd loginscherm zien","Accounts_UseDefaultBlockedDomainsList":"Gebruik Default geblokkeerde domeinen List","Accounts_UseDNSDomainCheck":"Gebruik DNS-domein controleren","Activate":"Activeren","Activity":"Activiteit","Add":"Toevoegen","Add_agent":"Voeg agent toe","Add_custom_oauth":"Voeg aangepaste OAuth toe","Add_manager":"Manager toevoegen","Add_Members":"Voeg leden toe","Add_User":"Voeg gebruiker toe","Add_user":"Gebruikers toevoegen","Add_users":"Gebruikers toevoegen","Additional_emails":"Extra e-mails","Additional_Feedback":"Extra feedback","Administration":"Administratie","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"After OAuth2 authentication, users will be redirected to this URL","Agent_added":"Agent toegevoegd","Agent_removed":"Agent verwijderd","Alias":"Alias","All":"Alle","All_channels":"Alle kanalen","All_logs":"Alle logs","All_messages":"alle berichten","Allow_Invalid_SelfSigned_Certs":"Sta Ongeldige Self-Signed Certs toe","Allow_Invalid_SelfSigned_Certs_Description":"Allow invalid and self-signed SSL certificate's for link validation and previews.","and":"en","And_more":"En meer __length __...","Animals_and_Nature":"Planten en dieren","API":"API","API_Analytics":"Analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Embed voor gebruikers uitschakelen","API_EmbedDisabledFor_Description":"Komma's gescheiden lijst van gebruikersnamen","API_GitHub_Enterprise_URL":"Server URL","API_GitHub_Enterprise_URL_Description":"Voorbeeld: http://domain.com (exclusief slash)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Uiterlijk","Application_added":"Applicatie toegevoegd","Application_Name":"Naam van de toepassing","Application_updated":"Applicatie bijgewerkt","Apply_and_refresh_all_clients":"Toe te passen en te vernieuwen alle cliënten","Archive":"Archiveren","Archive_Unarchive":"Archief / Uit archief","are_also_typing":"zijn ook aan het typen","are_typing":"zijn aan het typen","Are_you_sure":"Weet u het zeker?","Are_you_sure_you_want_to_delete_your_account":"Weet je zeker dat je je account wilt verwijderen?","Authorization_URL":"Authorization URL","Authorize":"Authorizeren","AutoLinker_StripPrefix":"AutoLinker Strip voorvoegsel","AutoLinker_StripPrefix_Description":"Beknopte weergave. bv https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL reguliere expressie","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Automatisch gekoppeld voor telefoonnummers. bijvoorbeeld `(123) 456-7890`","Auto_Load_Images":"Automatisch afbeeldingen laden","Available":"Beschikbaar","Available_agents":"Beschikbare agenten","Avatar":"Verander uw foto","Avatar_changed_successfully":"Afbeelding is gewijzigd","Avatar_URL":"Afbeelding URL","Avatar_url_invalid_or_error":"De gegeven URL us ongeldig of niet bereikbaar. Probeer het opnieuw met een andere URL.","away":"Afwezig","Away":"Afwezig","away_female":"afwezig","Away_female":"Afwezig","away_male":"afwezig","Away_male":"Afwezig","Back":"Terug","Back_to_applications":"Terug naar toepassingen","Back_to_integrations":"Terug naar integraties","Back_to_login":"Terug naar Inloggen","Back_to_permissions":"Terug naar machtigingen","Body":"Body","bold":"vetgedrukt","busy":"Bezet","Busy":"Bezet","busy_female":"bezet","Busy_female":"Bezet","busy_male":"bezet","Busy_male":"Bezet","Cancel":"Annuleren","Cannot_delete_a_protected_role":"Kan een beschermde rol niet verwijderen","Cannot_delete_role_because_its_in_use":"Kan rol niet verwijderen omdat het in gebruik is","Cannot_invite_users_to_direct_rooms":"Kan niet-gebruikers aan direct kamers nodigen","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certificaten en sleutels","Channel":"Kanaal","Channel_doesnt_exist":"Het kanaal `#%s` bestaat niet.","Channels":"Kanalen","Channels_list":"Lijst van de openbare kanalen","Chat_Rooms":"Kanalen","Chatops_Enabled":"Chatops Inschakelen","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Gebruikersnaam","Choose_a_room":"Kies een kamer","Choose_messages":"Kies berichten","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Kies de alias die zal verschijnen voor de gebruikersnaam in berichten.","Choose_the_username_that_this_integration_will_post_as":"Kies de gebruikersnaam als welke deze integratie zal posten.","Clear_all_unreads_question":"Wis alle ongelezen?","Client_ID":"Client ID","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Klanten zullen vernieuwen in een paar seconden","close":"Sluiten","Closed":"Gesloten","Collapse_Embedded_Media_By_Default":"Collapse ingebedde media standaard","coming_soon":"binnenkort beschikbaar","Commands":"Commando's","Compact_View":"Compacte weergave","Confirm_password":"Bevestig uw wachtwoord","Contact":"Contact","Conversation":"Gesprek","Convert_Ascii_Emojis":"ASCII naar Emoji Converteren ","Copied":"gekopieerde","COPY_TO_CLIPBOARD":"KOPIEER NAAR KLEMBOARD","Copy_to_clipboard":"Kopieer naar klembord","Count":"Aantal","Create":"creëren","Create_new":"Maak nieuw","Created_at":"Gemaakt op","Created_at_s_by_s":"Gemaakt op <strong>%s</strong> door <strong>%s</strong>","Custom_Fields":"Aangepaste velden","Custom_oauth_helper":"Bij het instellen van uw OAuth Provider, moet u een Callback URL geven. Gebruik <pre>%s</pre> .","Custom_oauth_unique_name":"Aangepaste OAuth unieke naam","Custom_Script_Logged_In":"Aangepaste Script voor gebruikers die ingelogd","Custom_Script_Logged_Out":"Aangepaste Script voor uitgelogd gebruikers","Dashboard":"Dashboard","days":"dagen","Deactivate":"Deactiveren","Debug_Level":"Debug Nivo","Default":"Standaard","Delete":"Verwijder","Delete_my_account":"Verwijder mijn account","Delete_Room_Warning":"Het verwijderen van een kamer verwijdert ook alle in deze kamer geplaatste berichten. Dat kan niet ongedaan gemaakt worden!","Delete_User_Warning":"Een gebruiker verwijderen betekent dat alle berichten van die gebruiker ook verwijderd worden. Dit kan niet ongedaan gemaakt worden.","Deleted":"Verwijderd!","Department_not_found":"Afdeling niet gevonden","Department_removed":"Afdeling verwijderd","Departments":"Afdelingen","Description":"Beschrijving","Desktop":"Desktop","Desktop_Notification_Test":"Desktop Kennisgeving Test","Desktop_Notifications":"Desktop Meldingen","Desktop_Notifications_Disabled":"Desktop Meldingen zijn uitgeschakeld. Wijzig uw browser voorkeuren als u Meldingen ingeschakeld wil hebben.","Desktop_Notifications_Enabled":"Desktop Meldingen zijn ingeschakeld","Direct_message_someone":"Stuur iemand een direct bericht","Direct_Messages":"Directe berichten","Direct_Messages_list":"Directe berichten","Disable_Favorite_Rooms":"Favorieten Uitschakelen","Disable_New_Message_Notification":"Notificatie voor nieuwe berichten uitzetten","Disable_New_Room_Notification":"Notificatie voor nieuwe kamer/room uitzetten","Displays_action_text":"Displays actie tekst","Do_you_want_to_change_to_s_question":"Wilt u <strong>%s</strong> veranderen?","Drop_to_upload_file":"Sleep hierheen om een bestand te uploaden","Dry_run":"Testrun","Dry_run_description":"Zal slechts één e-mail sturen naar hetzelfde adres als in afzenderveld. De e-mail moet horen bij een geldige gebruiker.","Duplicate_archived_channel_name":"An gearchiveerd kanaal met naam '%s' bestaat al","Duplicate_archived_private_group_name":"An gearchiveerde privé-group met naam '%s' bestaat al","Duplicate_private_group_name":"Een privé-groep met de naam '%s' bestaat reeds","E-mail":"E-mail","Edit":"Wijzig","Edit_Custom_Field":"Bewerken Aangepast veld","Edit_Department":"Afdeling bewerken","edited":"bewerkt","Email":"E-mail","Email_already_exists":"Emailadres bestaat al","Email_body":"E-mail tekst","Email_Change_Disabled":"Je Rocket.Chat administrator heeft het wijzigen van e-mail adressen uitgezet","Email_from":"Afzender","Email_Notification_Mode":"Offline E-mail Meldingen","Email_Notification_Mode_All":"Elke Mention / DM","Email_Notification_Mode_Disabled":"invalide","Email_or_username":"E-mail of gebruikersnaam","Email_subject":"Onderwerp","Email_verified":"E-mail geverifiëerd","Emoji":"Emoji","Empty_title":"Lege titel","Enable":"Inschakelen","Enable_Desktop_Notifications":"Zet Desktop Meldingen aan","Enabled":"Ingeschakeld","Encrypted_message":"gecodeerd bericht","End_OTR":"end OTR","Enter_a_regex":"Voer een reguliere expressie in","Enter_a_room_name":"Voer een naam in kamer","Enter_a_username":"Voer een gebruikersnaam in","Enter_info":"Voer uw gegevens in","Enter_name_here":"Voer naam hier","Enter_to":"Ga binnen bij","Error":"Fout","error-cant-invite-for-direct-room":"Kan niet door de gebruiker om direct kamers nodigen","error-duplicate-channel-name":"Een kanaal met de naam '%s' bestaat reeds","error-invalid-custom-field":"Ongeldige aangepaste veld","error-invalid-custom-field-name":"Ongeldige aangepaste veldnaam. Gebruik alleen letters, cijfers, koppeltekens en underscores.","error-invalid-password":"Ongeldig wachtwoord","error-invalid-room":"ongeldige kamer","error-invalid-room-name":"<strong> %s</strong> is geen geldige naam van de kamer, <br/> Gebruik alleen letters, cijfers, koppeltekens en underscores","error-invalid-user":"Ongeldige gebruiker","error-invalid-username":"Ongeldige gebruikersnaam","error-not-allowed":"Niet toegestaan","error-not-authorized":"niet toegestaan","error-remove-last-owner":"Dit is de laatste eigenaar. Stel een nieuwe eigenaar voordat u deze.","error-role-name-required":"Rol naam is verplicht","error-user-not-in-room":"Gebruiker is niet in deze kamer","Error_changing_password":"Fout bij het veranderen van het wachtwoord","Error_sending_confirmation_email":"Fout bij het verzenden bevestigingsmail","Error_too_many_requests":"Fout, te veel verzoeken. Gelieve vertragen. U moet %s seconden wachten alvorens opnieuw te proberen","Esc_to":"Esc om","Example_s":"Voorbeeld: <code class=\"inline\">%s</code>","False":"False","Favorites":"Favorieten","Field":"Veld","Field_removed":"Het gebied verwijderd","File_exceeds_allowed_size_of_bytes":"File overschrijdt toegestane grootte van __size__ bytes","FileUpload":"Bestand uploaden","FileUpload_Enabled":"File uploaden ingeschakeld","FileUpload_File_Empty":"Bestand leeg","FileUpload_FileSystemPath":"System Path","FileUpload_MaxFileSize":"Maximale bestandgsgrootte voor uploads (in bytes)","FileUpload_MediaType_NotAccepted":"Mediatypen niet geaccepteerd","FileUpload_MediaTypeWhiteList":"Geaccepteerde Media Types","FileUpload_MediaTypeWhiteListDescription":"Komma-gescheiden lijst van media types. Laat het leeg om alle media types te accepteren.","FileUpload_ProtectFiles":"Bescherm geüploade bestanden","FileUpload_ProtectFilesDescription":"Alleen geverifieerde gebruikers hebben toegang","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket naam","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN domein voor downloads","FileUpload_S3_Region":"Regio","FileUpload_Storage_Type":"Storage Type","Flags":"vlaggen","Follow_social_profiles":"Volg ons via de sociale netwerken, kopieer ons op GitHub en deel uw mening over de rocket.chat app op onze Trello pagina.","Food_and_Drink":"Eten drinken","For_your_security_you_must_re_enter_your_password_to_continue":"Voor uw eigen veiligheid, dient u deze opnieuw voer uw wachtwoord in om door te gaan","Force_SSL":"Dwing SSL af","Force_SSL_Description":"* Let op! * _Force SSL_ mag nooit worden gebruikt in combinatie met reverse proxy. Als u een reverse proxy, moet u de omleiding daar te doen. Deze optie bestaat voor implementaties zoals Heroku, die niet de omleiding configuratie aan de reverse proxy niet toestaat.","Forgot_password":"Wachtwoord vergeten","Fork_it_on_github":"Kopieer ons op GitHub","Frequently_Used":"Vaak gebruikt","From":"Afzender","From_Email":"Afzender e-mail","From_email_is_required":"Afzender e-mailadres is verplicht","From_email_warning":"<b>Waarschuwing</b>: Het veld <b>Afzender</b> is afhankelijk van je mail mail server instellingen.","General":"Algemeen","Get_to_know_the_team":"Maak kennis met het Rocket.Team","github_no_public_email":"U heeft geen openbaar e-mail adres in uw GitHub toegang","Give_a_unique_name_for_the_custom_oauth":"Geef een unieke naam voor de aangepaste OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Geef de toepassing een naam. Dit zal worden gezien door de gebruiker.","Global":"Globaal","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Heeft meer","Have_your_own_chat":"Gebruik uw eigen webchat. Ontwikkeld met Meteor.com, Rocket.Chat is een goede oplossing voor ontwikkelaars om een eigen chat-platform in te richten en te verder te ontwikkelen.","Header":"hoofd","Hidden":"Verborgen","Hide_Group_Warning":"Weet je zeker dat je groep \"%s\" wil verbergen?","Hide_Private_Warning":"Weet je zeker dat je de discussie met \"%s\" wil verbergen?","Hide_room":"Kamer verbergen","Hide_Room_Warning":"Weet je zeker dat je kamer \"%s\" wil verbergen?","Highlights":"highlights","Highlights_How_To":"Worden gewaarschuwd wanneer iemand een woord of zin noemt, hier toevoegen. U kunt woorden of zinnen te scheiden met komma's. Highlight Woorden zijn niet hoofdlettergevoelig.","Highlights_List":"highlight woorden","History":"Geschiedenis","hours":"uur","How_friendly_was_the_chat_agent":"Hoe vriendelijk was de chat-agent?","How_knowledgeable_was_the_chat_agent":"Hoe deskundig was de chat-agent?","How_responsive_was_the_chat_agent":"Hoe goed reageert de chat-agent?","How_satisfied_were_you_with_this_chat":"Hoe tevreden bent u met deze chat?","If_you_are_sure_type_in_your_password":"Als u zeker weet typ uw wachtwoord:","If_you_are_sure_type_in_your_username":"Als u zeker weet typ uw gebruikersnaam:","Importer_Archived":"gearchiveerd","Importer_done":"Importeren compleet!","Importer_finishing":"Afwerking van de import.","Importer_From_Description":"Invoer __from __ 's gegevens in Rocket.Chat.","Importer_import_cancelled":"Importeren geannuleerd.","Importer_import_failed":"Er is een fout opgetreden tijdens het uitvoeren van de import.","Importer_importing_channels":"Het importeren van de kanalen.","Importer_importing_messages":"Het importeren van de berichten.","Importer_importing_started":"Starten van de import.","Importer_importing_users":"Het importeren van de gebruikers.","Importer_not_defined_properly":"De importeur is niet goed gedefinieerd, is het missen van de klasse importeren.","Importer_not_in_progress":"De importeur is momenteel niet actief.","Importer_Prepare_Restart_Import":"Restart Import","Importer_Prepare_Start_Import":"start importeren","Importer_Prepare_Uncheck_Archived_Channels":"Haal het vinkje weg Gearchiveerd Channels","Importer_Prepare_Uncheck_Deleted_Users":"Haal het vinkje weg Verwijderde Gebruikers","Importer_progress_error":"Kan de vooruitgang van de import te krijgen.","Importer_setup_error":"Er is een fout opgetreden tijdens het instellen van de importeur.","Incorrect_Password":"Verkeerd paswoord","inline_code":"inline_code","Install_Extension":"Installeer Uitbreiding","Install_FxOs":"Rocket.Chat installeren op uw Firefox-","Install_FxOs_done":"Super! Je kunt Rocket.Chat gebruiker d.m.v. het ikoon op je beginscherm. Veel plezier met Rocket.Chat!","Install_FxOs_error":"Sorry, dat werkte niet zoals de bedoeling! De volgende fout is verschenen:","Install_FxOs_follow_instructions":"S.v.p. de app installatie op uw apparaten bevestigen (druk op \"Installeer\" wanneer daar om gevraagd wordt).","Installation":"Installatie","Integration_added":"Integratie is toegevoegd","Integration_Incoming_WebHook":"Binnenkomende WebHook Integratie","Integration_New":"Nieuwe Integratie","Integration_Outgoing_WebHook":"Uitgaande webhook Integration","Integration_updated":"Integratie is bijgewerkt","Integrations":"Integraties","Invalid_asset":"Invalid asset","Invalid_confirm_pass":"De wachtwoorden zijn verschillend","Invalid_email":"Ongeldig e-mail adres","Invalid_Export_File":"Het bestand geüpload is geen geldig %s exportbestand.","Invalid_file_height":"Ongeldige hoogte","Invalid_file_type":"Ongeldig bestandstype","Invalid_file_width":"Ongeldige breedte","Invalid_Import_File_Type":"Ongeldig bestandstype importeren.","Invalid_name":"De naam mag niet leeg zijn","Invalid_notification_setting_s":"Ongeldige melding-instelling: %s","Invalid_pass":"Het wachtwoord mag niet leeg zijn","Invalid_room_name":"<strong>%s</strong> is geen geldige naam,<br/> gebruik alleen letters, cijfers en streepjes","Invalid_room_type":"<strong>%s</strong> is geen geldig kamer type","Invalid_Secret_URL":"Ongeldige geheime URL","Invalid_secret_URL_message":"De gegeven URL is ongeldig.","invisible":"onzichtbaar","Invisible":"Onzichtbaar","Invitation_HTML":"Uitnodiging HTML","Invitation_Subject":"Uitnodiging Onderwerp","Invite_user_to_join_channel":"Nodig een gebruiker uit voor om dit kanaal","Invite_Users":"Gebruikers Uitnodigen","is_also_typing":"is ook aan het typen","is_also_typing_female":"is ook aan het typen","is_also_typing_male":"is ook aan het typen","is_typing":"is aan het typen","is_typing_female":"is aan het typen","is_typing_male":"is aan het typen","italics":"cursief","join":"Toetreden","Join_audio_call":"Voeg me toe aan audio gesprek","Join_the_Community":"Word lid","Join_the_given_channel":"Word lid van de gegeven kanaal","Join_video_call":"Voeg me toe aan video gesprek","Joined":"Geregistreerd","Jump":"Springen","Jump_to_first_unread":"Naar eerste ongelezen","Jump_to_message":"Ga naar bericht","Jump_to_recent_messages":"Ga naar recente berichten","Katex_Enabled":"Katex Ingeschakeld","Label":"Etiket","Language":"Taal","Language_Version":"Nederlandse versie","Last_login":"Laatste aanmelding","Last_message":"Laatste bericht","Last_seen":"Laatst gezien","Layout":"Lay-out","Layout_Home_Body":"Home Body","Layout_Home_Title":"Home Titel","Layout_Login_Terms":"Login voorwaarden","Layout_Privacy_Policy":"Privacybeleid","Layout_Sidenav_Footer":"Side Navigation Footer","Layout_Sidenav_Footer_description":"Footer afmetingen is 260 x 70px","Layout_Terms_of_Service":"Algemene Voorwaarden","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Search","LDAP_Custom_Domain_Search_Description":"Een stuk van JSON die regeert binden en de aansluiting info en is van de vorm: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"LDAP is a hierarchical database that many companies use to provide single sign on - a facility for sharing one password between multiple sites and services. For advanced configuration information and examples, please consult our wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Domain Base","LDAP_Domain_Base_Description":"De volledig gekwalificeerde Distinguished Name (DN) van een LDAP subtree u wilt zoeken voor gebruikers en groepen. U kunt zoveel als je wilt toevoegen; echter, moet elke groep worden gedefinieerd in hetzelfde domein basis als de gebruikers die behoren. Als u beperkte gebruikersgroepen geven, zullen alleen gebruikers die behoren tot die groepen in scope. Wij raden u aan het hoogste niveau van de LDAP-directory tree opgeven als uw domein basis en gebruiken zoekfilter om toegang te controleren.","LDAP_Domain_Search_Filter":"Domain Zoek Filter","LDAP_Domain_Search_Filter_Description":"Indien gespecificeerd, alleen gebruikers die overeenkomen met dit filter zal worden toegestaan ​​om in te loggen. Als er geen filter is aangegeven, zijn alle gebruikers in het kader van het opgegeven domein basis zal in staat zijn om in te loggen. <br/> Bijvoorbeeld voor Active Directory `memberOf = cn = ROCKET_CHAT, ou = General Groups`. <br/> Bijvoorbeeld voor OpenLDAP (extensible match zoeken) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Categorie","LDAP_Domain_Search_Object_Category_Description":"De * objectCategory * dat uw gebruikers te identificeren. <br/> Laat leeg voor OpenLDAP * *. <br/> Bijvoorbeeld `person`, etc.","LDAP_Domain_Search_Object_Class":"Domain Search Object Class","LDAP_Domain_Search_Object_Class_Description":"De * objectclass * dat uw gebruikers te identificeren. <br/> Bijvoorbeeld `organizationalPerson`,` netgebruiker, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Domain Search Password","LDAP_Domain_Search_Password_Description":"Het wachtwoord voor het domein zoeken gebruiker.","LDAP_Domain_Search_User":"Domain Search Gebruiker","LDAP_Domain_Search_User_Description":"De LDAP-gebruiker die gebruiker lookups uitvoert om andere gebruikers te verifiëren wanneer ze zich aanmelden. <br/> Dit is typisch een service-account speciaal gemaakt voor derden integraties. Gebruik een volledig gekwalificeerde naam, zoals `cn = Administrator, cn = Users, dc = voorbeeld, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search User ID","LDAP_Domain_Search_User_ID_Description":"De LDAP-kenmerk dat de LDAP-gebruiker die verificatie probeert identificeert. Dit veld moet `sAMAccountName` voor de meeste Active Directory-installaties, maar het kan` uid` andere LDAP-oplossingen, zoals OpenLDAP zijn. U kunt `mail` gebruiken om gebruikers te identificeren via e-mail of wat kenmerk dat u wilt. <br> U kunt meerdere waarden gescheiden door een komma te gebruiken om gebruikers in staat om in te loggen met behulp van meerdere identifiers zoals gebruikersnaam of e-mail.","LDAP_Enable":"Aanzetten","LDAP_Enable_Description":"Probeer LDAP te gebruiken voor authenticatie.","LDAP_Encryption":"encryptie","LDAP_Encryption_Description":"De encryptie methode die wordt gebruikt om de communicatie te beveiligen met de LDAP-server. Voorbeelden zijn `plain` (geen encryptie),` SSL / LDAPS` (versleutelde vanaf het begin), en `StartTLS` (upgraden naar versleutelde communicatie eenmaal aangesloten).","LDAP_Host":"gastheer","LDAP_Host_Description":"De LDAP-host, bijvoorbeeld `ldap.example.com` of` 10.0.0.30`.","LDAP_Port":"LDAP Port","LDAP_Port_Description":"Poort om LDAP te benaderen. bijv. 389 of 636 voor LDAPS","LDAP_Reject_Unauthorized":"Reject Unauthorized","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"gegevens synchroniseren","LDAP_Sync_User_Data_Description":"Houd gebruikersdata synchroon met de server tijdens login (bijv. naam en email).","LDAP_Sync_User_Data_FieldMap":"User Data Field Map","LDAP_Sync_User_Data_FieldMap_Description":"Configure how user account fields (like email) are populated from a record in LDAP (once found). As an example, {\"cn\":\"name\", \"mail\":\"email\"} will choose a person's human readable name from the cn attribute, and their email from the mail attribute. Available fields include name, and email.","LDAP_Sync_Users":"Sync Gebruikers","LDAP_Test_Connection":"Test verbinding","LDAP_Unique_Identifier_Field":"Unique Identifier Field","LDAP_Unique_Identifier_Field_Description":"Welk veld zal worden gebruikt om de LDAP-gebruiker en de Rocket.Chat gebruiker te koppelen. U kunt meerdere waarden gescheiden door een komma te informeren om te proberen om de waarde van LDAP plaat te krijgen. <br/> Standaard waarde is `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Gebruik Custom Domain Search","LDAP_Use_Custom_Domain_Search_Description":"Schrijf uw eigen filter te zoeken gebruikers in de LDAP-server.","LDAP_Username_Field":"gebruikersnaam Field","LDAP_Username_Field_Description":"Welk veld zal gebruikt worden als gebruikersnaam * * voor nieuwe gebruikers. Laat leeg om de gebruikersnaam op de hoogte inlogpagina te gebruiken. <br/> U kunt template-tags te gebruiken, zoals `# {} givenName. # {Sn}`. <br/> Standaard waarde is `sAMAccountName`.","Leave_Group_Warning":"Weet je zeker dat je groep \"%s\" wil verlaten?","Leave_Private_Warning":"Weet je zeker dat je de discussie met \"%s\" wil verlaten?","Leave_room":"Kamer verlaten","Leave_Room_Warning":"Weet je zeker dat je kamer \"%s\" wil verlaten?","line":"lijn","List_of_Direct_Messages":"Lijst van Direct Messages","Live_sessions":"Live sessies","Livechat_agents":"Livechat agenten","Livechat_Dashboard":"Livechat Dashboard","Livechat_enabled":"Livechat beschikbaar","Livechat_Manager":"Livechat Manager","Livechat_managers":"Livechat managers","Livechat_title":"Livechat Titel","Livechat_title_color":"Livechat Titel Achtergrond Kleur","Livechat_Users":"Livechat Gebruikers","Load_more":"Meer laden","Loading...":"Laden ...","Loading_more_from_history":"Meer oude berichten laden","Loading_suggestion":"Suggesties laden...","Localization":"Localization","Log_File":"Laat bestand en regelnummer zien","Log_Level":"Log level","Log_Package":"Laat package zien","Log_View_Limit":"Log limiet","Logged_out_of_other_clients_successfully":"Uitgeloggen van andere plekken was succevol","Login":"Log In","Login_with":"Login met %s","login_with":"Of log in met","Logout":"Uitloggen","Logout_Others":"Uitloggen van andere plekken","Mail_Message_Invalid_emails":"Je hebt één of meer ongeldige e-mails gegeven: %s","Mail_Message_Missing_to":"U moet een of meer gebruikers selecteren of één of meer e-mailadressen invullen, gescheiden door komma's.","Mail_Message_No_messages_selected_select_all":"Je hebt geen bericten geslecteerd. Zou je <a href='#' class='select-all'>alle zichtbare berichten</a> willen selecteren?","Mail_Messages":"Mailberichten","Mail_Messages_Instructions":"Kies welke berichten je wil versturen via e-mail door te klikken op de berichten","Mail_Messages_Subject":"Hier is een geselecteerd deel van %s berichten","Mailer":"Mailer","Mailer_body_tags":"Je <b>moet</b> [unsubscribe] gebruiken voor een unsubscribe link.<br />Je kunt [name], [fname], [lname] gebruiken voor een gebruikers volledige naam, voorname of achtername.<br />Je kunt [email] gebruiken voor het email adres van de gebruiker.","Make_Admin":"Maak Admin","Manager_added":"Manager toegevoegd","Manager_removed":"Manager verwijderd","Mark_as_read":"Markeer als gelezen","Markdown_Headers":"Markdown kopteksten","Markdown_SupportSchemesForLink":"Markdown steunregelingen voor Link","Markdown_SupportSchemesForLink_Description":"Komma's gescheiden lijst met toegestane regelingen","Members_List":"Ledenlijst","Mentions":"Vermeldingen","Mentions_default":"Vermeldingen (standaard)","Message":"Bericht","Message_AllowDeleting":"Bericht verwijderen toestaan","Message_AllowEditing":"Bericht bewerken toestaan","Message_AllowEditing_BlockEditInMinutes":"Blokkeer berichtbewerkingen na (n) minuten","Message_AllowEditing_BlockEditInMinutesDescription":"Vul 0 in om blokkeren uit te schakelen.","Message_AllowPinning":"Bericht vastzetten toestaan","Message_AllowPinning_Description":"Sta berichten vastzetten toe op elk kanaal.","Message_AllowStarring":"Sta markeren toe","Message_AudioRecorderEnabled":"Audio Recorder Ingeschakeld","Message_AudioRecorderEnabledDescription":"Vereist 'audio/wav' bestanden als geaccepteerd mediatype binnen de 'File Upload' instellingen.","Message_DateFormat":"Datumnotatie","Message_DateFormat_Description":"Zie ook: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Bericht verwijderen niet toegestaan","Message_editing_blocked":"Dit bericht kan niet meer worden bewerkt","Message_editing_not_allowed":"Bericht bewerken niet toegestaan","Message_GroupingPeriod":"Groeperen periode (in seconden)","Message_GroupingPeriodDescription":"Berichten worden gegroepeerd met het vorige bericht als beide van dezelfde gebruiker zijn.","Message_KeepHistory":"Bewaar berichten geschiedenis","Message_MaxAllowedSize":"Maximaal toegestane berichtgrootte","Message_MaxAll":"Maximale grootte kanaal voor ALL boodschap","Message_pinned":"Bericht is vastgezet","Message_pinning_not_allowed":"Bericht vastzetten niet toegestaan","Message_removed":"Bericht verwijderd","Message_ShowDeletedStatus":"Toon Verwijderde Status","Message_ShowEditedStatus":"Toon Gewijzigde Status","Message_ShowFormattingTips":"Toon opmaaktips","Message_TimeFormat":"Tijd formaat","Message_TimeFormat_Description":"Zie ook: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Bericht te lang","Messages":"Berichten","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Berichten die worden verstuurd naar de binnenkomende WebHook zullen hier gepost worden.","Meta":"Meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Site Verification","Meta_language":"Taal","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minuten","Mobile_push":"Mobile push","More_channels":"Meer kanalen","More_direct_messages":"Meer directe berichten","More_groups":"Meer privé-berichten","More_unreads":"Meer ongelezen","Msgs":"Berichten","multi":"multi","Mute_someone_in_room":"Maak iemand in de kamer stil","Mute_user":"Maak gebruiker stil","Muted":"Mond Snoeren","My_Account":"Mijn account","n_messages":"%s berichten","N_new_messages":" %s nieuwe berichten","Name":"Naam","Name_cant_be_empty":"De naam mag niet leeg zijn","Name_of_agent":"Naam agent","Name_optional":"Naam (optioneel)","Navigation_History_20_last_pages":"Navigatie Geschiedenis (20 laatste pagina's)","New_Application":"Nieuwe toepassing","New_Custom_Field":"Nieuw Aangepast veld","New_Department":"Nieuwe afdeling","New_integration":"Nieuwe intergratie","New_logs":"nieuwe logs","New_messages":"Nieuwe berichten","New_password":"Nieuw Wachtwoord","New_role":"Nieuwe rol","No_channel_with_name_%s_was_found":"Geen kanaal met de naam  <strong>\"%s\"</strong> gevonden","No_channels_yet":"U maakt nog geen deel uit van een kanaal.","No_direct_messages_yet":"U bent nog geen gesprekken begonnen.","No_Encryption":"geen codering","No_favorites_yet":"U heeft nog geen favorieten toegevoegd.","No_group_with_name_%s_was_found":"Geen privé-groep met de naam  <strong>\"%s\"</strong> gevonden","No_groups_yet":"U heeft nog geen privé-groepen.","No_livechats":"Je hebt geen livechats.","No_mentions_found":"Geen vermeldingen gevonden","No_permission_to_view_room":"U heeft geen toestemming dit kanaal te bekijken","No_pinned_messages":"Geen vastgezette berichten","No_results_found":"Geen resultaten gevonden","No_starred_messages":"Geen gemarkeerde berichten","no_tokens_for_this_user":"Er zijn geen tokens voor deze gebruiker","No_user_with_username_%s_was_found":"Geen gebruiker met de naam  <strong>\"%s\"</strong> gevonden","Not_allowed":"Niet toegestaan","Not_authorized":"Geen bevoegdheid","Not_Available":"Niet beschikbaar","Not_found_or_not_allowed":"Niet gevonden of niet toegestaan","Nothing":"Niks","Nothing_found":"Niets gevonden","Notifications":"meldingen","Notify_all_in_this_room":"Meld aan iederen in deze kamer","Num_Agents":"# Agenten","Number_of_messages":"Aantal berichten","OAuth_Application":"OAuth Application","OAuth_Applications":"OAuth Applications","Objects":"Voorwerpen","Off_the_record_conversation":"Off-the-opname Conversation","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-opname gesprek is niet beschikbaar voor uw browser of apparaat.","Offline_DM_Email":"[__site__] Je hebt direct zijn messaged door __user__","Offline_Mention_Email":"[__site__] Je bent genoemd door __user__ in #__room__","Old_and_new_password_must_be_different":"Het oude en nieuwe paswoord moeten verschillen.","Old_and_new_password_required":"Je moet zowel je oude als nieuwe wachtwoord geven om uw wachtwoord te wijzigen.","Online":"Online","Only_errors":"Alleen fouten","Only_you_can_see_this_message":"Alleen jij kunt dit bericht lezen","Oops!":"Oeps","Open":"Open","Opened":"Geopend","Opt_out_statistics":"Stuur mijn statistieken niet naar Rocket.Chat","Opt_out_statistics_warning":"Door het verzenden van uw statistieken, zult u ons helpen om te bepalen hoe veel gevallen van Rocket.Chat worden ingezet, evenals hoe goed het systeem zich gedraagd, zodat we verder kunnen verbeteren. Maak je geen zorgen, omdat er geen informatie over de gebruiker wordt gestuurd en alle informatie die wij ontvangen wordt vertrouwelijk behandeld. Als u wilt doorgaan met het sturen van uw statistieken, schakelt de bovenstaande checkbox. Dank je.","optional":"optioneel","Order":"Bestelling","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Count","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Gemiddeld","OS_Platform":"OS Platform","OS_Release":"OS Versie","OS_Totalmem":"OS Totaal geheugen","OS_Type":"OS Type","OS_Uptime":"OS Uptime","others":"anderen","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR is alleen beschikbaar als zowel gebruikers online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Override URL waarop bestanden worden geüpload. Deze url ook gebruikt voor downloads, tenzij een CDN wordt gegeven","Password":"Wachtwoord","Password_Change_Disabled":"Uw Rocket.Chat beheerder heeft het veranderen van wachtwoorden uitgeschakeld","Password_changed_successfully":"Wachtwoord succesvol gewijzigd","Payload":"payload","People":"Mensen","Permissions":"Machtigingen","Pin_Message":"Zet bericht vast","Pinned_a_message":"Speldde een bericht:","Pinned_Messages":"Vastgezette berichten","Placeholder_for_email_or_username_login_field":"Aanduiding voor e-mail of gebruikersnaam login veld","Placeholder_for_password_login_field":"Tijdelijke aanduiding voor het wachtwoord veld","Please_answer_survey":"Heeft u een moment om een korte enquête over deze chat te beantwoorden","Please_enter_value_for_url":"Vul s.v.p. een URL voor uw Avatar in.","Please_enter_your_new_password_below":"Vul hieronder uw nieuwe wachtwoord in:","Please_fill_a_label":"Vul een label","Please_fill_a_name":"Vul een naam in","Please_fill_a_username":"Vul een gebruikersnaam in","Please_fill_name_and_email":"Vul naam en e-mail in","Please_re_enter_your_password":"Vul alstublieft uw wachtwoord opnieuw in","Please_select_enabled_yes_or_no":"Selecteer een optie voor Ingeschakeld","Please_wait":"Wacht alstublieft","Please_wait_activation":"Even geduld, dit kan enige tijd duren.","Please_wait_statistics":"Even geduld, er worden statistieken gegenereerd.","Please_wait_while_OTR_is_being_established":"Een moment geduld aub OTR tot stand wordt gebracht","Please_wait_while_your_account_is_being_deleted":"Een moment geduld aub uw account wordt verwijderd ...","Please_wait_while_your_profile_is_being_saved":"Een ogenblik geduld terwijl uw profiel wordt opgeslagen ...","Post_as":"Stuur als","Post_to_Channel":"Posten in kanaal","Post_to_s_as_s":"Posten in <strong>%s</strong> als <strong>%s</strong>","Powered_by":"Mede mogelijk gemaakt door","Preferences":"Voorkeuren","Preferences_saved":"Voorkeuren opgeslagen","Privacy":"Privacy","Private_Group":"Privé-groep","Private_Groups":"Privé groepen","Private_Groups_list":"Lijst van privé-groepen","Profile":"Profiel","Profile_saved_successfully":"Profiel succesvol opgeslagen","Proudly_developed":"Ontwikkeld met Meteor","Push":"Push","Push_apn_cert":"APN Certificaat","Push_apn_dev_cert":"APN Ontwikkelaars Certificaat","Push_apn_dev_key":"APN Ontwikkelaars Sleutel","Push_apn_dev_passphrase":"APN Ontwikkelaars Wachtwoord","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Wachtwoord","Push_debug":"Debug","push_disabled":"Push notificaties uitgeschakeld","Push_enable":"Enable","Push_enable_gateway":"Enable Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API Sleutel","Push_gcm_project_number":"GCM Projektnummer","Push_production":"Productie","Push_show_message":"Toon bericht notificatie","Push_show_username_room":"Show kanaal / groep / gebruikersnaam in de kennisgeving","Push_test_push":"Test","Query":"Query/vraag","Query_description":"Additional conditions for determining which users to send the e-mail to. Unsubscribed users are automatically removed from the query. It must be a valid JSON. Example: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Snelzoeken","quote":"citaat","Reactions":"reacties","Recents":"Recente","Record":"Opnemen","Redirect_URI":"Redirect URI","Refresh_keys":"Vernieuwen sleutels","Refresh_your_page_after_install_to_enable_screen_sharing":"Ververs uw pagina na installeren om het delen van het scherm mogelijk te maken","Register":"Registreer een nieuwe gebruiker","Registration_Succeeded":"Registratie Geslaagd","Remember_me":"Onthou me","Remove":"Verwijderen","Remove_Admin":"Verwijder Admin","Remove_as_moderator":"Verwijder als moderator","Remove_as_owner":"Verwijder als eigenaar","Remove_custom_oauth":"Verwijder aangepaste OAuth","Remove_from_room":"Verwijderen uit de kamer","Remove_someone_from_room":"Verwijder iemand uit de kamer","Removed":"Verwijderd","Require_password_change":"Vereis paswoord wijziging","Resend_verification_email":"Opnieuw verzenden verificatie e-mail","Reset":"Reset","Reset_password":"Reset Wachtwoord","Restart":"Herstart","Restart_the_server":"Herstart de server","RocketBot_Enabled":"RocketBot Ingeschakeld","RocketBot_Name":"RocketBot Naam","RocketBot_Name_Description":"RocketBot naam moet een geldige gebruikersnaam zijn op uw server.","Role":"Rol","Role_Editing":"Rol bewerken","Role_removed":"Rol verwijderd","Room":"Kamer","Room_archivation_state":"State","Room_archivation_state_false":"Aktief","Room_archivation_state_true":"Gearchiveerd","Room_archived":"Kamer gearchiveerd","room_changed_privacy":"Room type changed to: <em>__room_type__</em> by <em>__user_by__</em>","room_changed_topic":"Room topic changed to: <em>__room_topic__</em> by <em>__user_by__</em>","Room_has_been_deleted":"Kamer is verwijderd","Room_Info":"Kamer info","Room_name_changed":"Naam van de kamer veranderd in: <em>__room_name__</em> door <em>__user_by__</em>","Room_name_changed_successfully":"Naam van het kanaal is aangepast","Room_not_found":"Kamer niet gevonden","Room_topic_changed_successfully":"Kamer onderwerp succesvol gewijzigd","Room_type_changed_successfully":"Kamertype met succes gewijzigd","Room_unarchived":"Kamer uit meer gearchiveerd","Room_uploaded_file_list":"Bestandslijst","Room_uploaded_file_list_empty":"Geen bestanden beschikbaar.","room_user_count":"%s gebruikers","Rooms":"Kamers","S_new_messages_since_s":"%s nieuwe berichten sinds %s","SAML":"SAML","SAML_Custom_Cert":"Custom Certificate","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Generate Username","SAML_Custom_Issuer":"Custom Issuer","SAML_Custom_Provider":"Custom Provider","Save":"Bewaren","Save_changes":"Wijzigingen opslaan","Save_Mobile_Bandwidth":"Bespaar op mobile bandbreedte","Save_to_enable_this_action":"Bewaar deze actie mogelijk te maken","Saved":"Opgeslagen","Saving":"Opslaan","Scope":"strekking","Screen_Share":"Scherm delen","Script_Enabled":"script Ingeschakeld","Search":"Zoeken","Search_by_username":"Zoek op gebruikersnaam","Search_Channels":"Zoek kanalen","Search_Direct_Messages":"Zoeken Direct Messages","Search_Messages":"Berichten zoeken","Search_Private_Groups":"Zoeken Private Groepen","Search_settings":"Zoekinstellingen","seconds":"seconden","See_all":"Alles zien","See_only_online":"Alleen online","Select_a_department":"Selecteer een afdeling","Select_an_avatar":"Selecteer een afbeelding","Select_file":"Selecteer bestand","Select_service_to_login":"Selecteer een dienst in te loggen om uw foto op te halen of  upload er één van uw computer","Select_user":"Kies een gebruiker","Select_users":"Selecteer gebruikers","Selected_agents":"Geselecteerde agenten","Selected_users":"Geselecteerde leden","Send":"Verstuur","Send_a_message":"Stuur een bericht","Send_a_test_mail_to_my_user":"Stuur een test email naar mijn gebruiker","Send_a_test_push_to_my_user":"Stuur een test push notificatie naar mijn gebruiker","Send_confirmation_email":"Bevestigings e-mail sturen","Send_data_into_RocketChat_in_realtime":"Stuur gegevens in Rocket.Chat in real-time.","Send_email":"Verstuur e-mail","Send_invitation_email":"Stuur uitnodiging e-mail","Send_invitation_email_error":"Je hebt geen geldig e-mailadres gegeven.","Send_invitation_email_info":"Je kunt meerdere e-mail uitnodigingen verzenden per keer sturen.","Send_invitation_email_success":"U hebt een uitnodiging e-mail gestuurd naar de volgende adressen:","Send_invitation_email_warning":"Om de uitnodiging e-mails te versturen, moet u eerst de SMTP-instellingen configureren.","Send_Message":"Bericht verzenden","Send_your_JSON_payloads_to_this_URL":"Verstuur je JSON payload naar deze URL.","Sending":"Verzenden ...","Set_as_moderator":"Stel in als moderator","Set_as_owner":"Maak eigenaar","Settings":"Instellingen","Settings_updated":"Instellingen bijgewerkt","Should_be_a_URL_of_an_image":"Dit moet een URL van een afbeelding zijn.","Should_exists_a_user_with_this_username":"De gebruiker moet al bestaan.","Show_all":"Toon alles","Show_more":"Laat meer zien","Show_only_online":"Alleen online","Show_preregistration_form":"<p>Showing <b>%s</b> archived results</p>","Showing_archived_results":"<p>Zichtbaar: <b>%s</b> gearchiveerde resultaten</p>","Showing_online_users":"Toont <b>__total_showing__</b> van de __total__ gebruikers","Showing_results":"<p>Toon <b>%s</b> resultaten</p>","Silence":"Stilte","since_creation":"sinds %s","Site_Name":"Site naam","Site_Url":"URL van de site","Site_Url_Description":"Voorbeeld: https://chat.domain.com/","Skip":"Overslaan","Smileys_and_People":"Smileys & People","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP-wachtwoord","SMTP_Port":"SMTP Poort","SMTP_Test_Button":"Test SMTP Instellingen","SMTP_Username":"SMTP Gebruikersnaam","Sound":"Geluid","Star_Message":"Markeer bericht","Starred_Messages":"Gemarkeerde berichten","Start_audio_call":"Begin audio gesprek","Start_Chat":"Start Chat","Start_of_conversation":"Begin van het gesprek","Start_OTR":"Start OTR","Start_video_call":"Begin video gesprek","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Begin met <code class=\"inline\">%s</code> voor gebruiker of <code class=\"inline\">%s</code> voor kanaal. Bijv.: <code class=\"inline\">%s</code> of <code class=\"inline\">%s</code>","Statistics":"Statistieken","Stats_Active_Users":"Actieve gebruikers","Stats_Avg_Channel_Users":"Gemiddeld aantal Kanaal Gebruikers","Stats_Avg_Private_Group_Users":"Gemiddeld aantal Privé Groep Gebruikers","Stats_Away_Users":"Afwezige gebruikers","Stats_Max_Room_Users":"Maximaal aantal Kamer Gebruikers","Stats_Non_Active_Users":"Inactieve Gebruikers","Stats_Offline_Users":"Offline Gebruikers","Stats_Online_Users":"Online Gebruikers","Stats_Total_Channels":"Totaal Kanalen","Stats_Total_Direct_Messages":"Totaal Directe Berichten Kamers","Stats_Total_Messages":"Totaal aantal berichten","Stats_Total_Private_Groups":"Totaal Privé Groepen","Stats_Total_Rooms":"Totaal aantal Kamers","Stats_Total_Users":"Totaal aantal leden","Stop_Recording":"Stop opname","strike":"doorhalen","Subject":"Onderwerp","Submit":"Verzenden","Success":"Succes","Survey":"Enquête","Survey_instructions":"Beoordeel elke vraag naar mate uw tevredenheid, 1 betekent dat u helemaal ontevreden  bent en 5 betekent volledig tevreden.","Symbols":"Symbolen","Sync_success":"Sync succes","Sync_Users":"Sync Gebruikers","Test_Connection":"Test verbinding","Test_Desktop_Notifications":"Test Desktop Meldingen","Thank_you_for_your_feedback":"Hartelijk dank voor uw feedback","The_application_name_is_required":"Th _application name is required","The_channel_name_is_required":"De naam van het kanaal is vereist","The_emails_are_being_sent":"De e-mails worden verzonden.","The_field_is_required":"Het veld %s is vereist.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Het beeld zal niet van grootte worden veranderd omdat we niet kunnen zien of Imagemagick of GraphicsMagick geïnstalleerd zijn op uw server.","The_redirectUri_is_required":"The redirectUri is required","The_server_will_restart_in_s_seconds":"De server wordt herstart in %s seconden","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"De configuratie <strong>%s</strong> is ingesteld op  <strong>%s</strong> en u gebruikt toegang vanaf <strong>%s</strong>!","The_user_will_be_removed_from_s":"De gebruiker zal worden verwijderd van %s","The_user_wont_be_able_to_type_in_s":"De gebruiker kan niet typen in %s","Theme":"Thema","theme-color-action-buttons-color":"Aktie knoppen kleur","theme-color-active-channel-background-color":"Actieve Kanaal Achtergrondkleur","theme-color-active-channel-font-color":"Actieve Kanaal Tekstkleur","theme-color-blockquote-background":"Blockquote Achtergrondkleur","theme-color-clean-buttons-color":"Clean Buttons Color","theme-color-code-background":"Code Achtergrondkleur","theme-color-code-border":"Code Randkleur","theme-color-code-color":"Code Kleur","theme-color-content-background-color":"Inhoud Achtergrondkleur","theme-color-custom-scrollbar-color":"Handmatige Scrollbarkleur","theme-color-info-active-font-color":"Aktieve Info Tekstkleur","theme-color-info-font-color":"Info Tekstkleur","theme-color-input-font-color":"Input Tekstkleur","theme-color-link-font-color":"Link Tekstkleur","theme-color-message-hover-background-color":"Achtergrondkleur als muis er boven is","theme-color-primary-background-color":"Primaire Achtergrondkleur","theme-color-primary-font-color":"Primaire Tekstkleur","theme-color-quaternary-font-color":"Quaternary Font Color","theme-color-secondary-background-color":"Secondaire Achtergrondkleur","theme-color-secondary-font-color":"Secondaire Tekstkleur","theme-color-smallprint-font-color":"Kleine-tekst Tekstkleur","theme-color-smallprint-hover-color":"Small Print Hover Color","theme-color-status-away":"Afwezig Statuskleur","theme-color-status-busy":"Bezet Statuskleur","theme-color-status-offline":"Offline Statuskleur","theme-color-status-online":"Online Statuskleur","theme-color-tertiary-background-color":"Tertiaire Achtergronkleur","theme-color-tertiary-font-color":"Tertiaire Tekstkleur ","theme-color-unread-notification-color":"Ongelezen Notificaties Kleur","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"Er zijn nog geen agenten aan deze afdeling toegevoegd.","There_are_no_integrations":"Er zijn geen integraties","There_are_no_users_in_this_role":"Er zijn geen gebruikers met deze rol.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Deze e-mail is al gebruikt en niet is geverifieerd. Gelieve uw wachtwoord wijzigen.","This_is_a_desktop_notification":"Dit is een desktop kennisgeving","This_is_a_push_test_messsage":"Dit is een push-test messsage","Time_in_seconds":"Tijd in seconden","Title_bar_color":"Titelbalk kleur","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Om Rocket.Chat Livechat te installeren op uw website, kopiëert u de volgende code boven de laatste <strong>&lt;/body&gt;</strong> html tag op uw web pagina's.","To_users":"Aan Gebruikers","Topic":"Onderwerp","Travel_and_Places":"Travel & Places","Trigger_removed":"Trigger verwijderd","Trigger_Words":"Trigger woorden","Triggers":"Triggers","True":"True","Type":"Type","Type_your_new_password":"Typ uw nieuwe wachtwoord","Unarchive":"Uit archief halen","Unmute_someone_in_room":"Laat iemand weer in de kamer praten","Unmute_user":"Laat iemand weer praten","Unnamed":"Naamloos","Unpin_Message":"Bericht niet meer vastzetten","Unread_Rooms":"Ongelezen Kamers","Unread_Rooms_Mode":"Ongelezen Kamers Mode","Unstar_Message":"Verwijder markering","Upload_file_question":"Bestand uploaden?","Uploading_file":"Bestand uploaden...","Use_account_preference":"Gebruik rekening voorkeur","Use_Emojis":"Gebruik Emojis","Use_initials_avatar":"Gebruik de initialen van uw gebruikersnaam","use_menu":"Gebruik het menu aan de zijkant om toegang te krijgen tot de kanalen en privé gesprekken","Use_service_avatar":"Gebruik %s afbeelding","Use_this_username":"Gebruik deze gebruikersnaam","Use_uploaded_avatar":"Gebruik geüploade afbeelding","Use_url_for_avatar":"Gebruik url voor avatar","User__username__is_now_a_moderator_of__room_name_":"User __username__ is now a moderator of __room_name__","User__username__is_now_a_owner_of__room_name_":"User __username__ is now a owner of __room_name__","User__username__removed_from__room_name__moderators":"User __username__ removed from __room_name__ moderators","User__username__removed_from__room_name__owners":"User __username__ removed from __room_name__ owners","User_added":"Gebruiker toegevoegd","User_added_by":"Gebruiker <em>__user_added__</em> toegevoegd door <em>__user_by__</em>","User_added_successfully":"Nieuwe gebruiker succesvol toegevoegd","User_Channels":"Gebruikers Kanalen","User_doesnt_exist":"Geen gebruiker bestaat met de naam `@%s`.","User_has_been_activated":"Gebruiker is geactiveerd","User_has_been_deactivated":"Gebruiker is gedeactiveerd","User_has_been_deleted":"Gebruiker is verwijderd","User_has_been_muted_in_s":"Gebruiker is de mond gesnoerd in %s","User_has_been_removed_from_s":"Gebruiker is verwijderd van %s","User_has_disconnected":"Gebruiker heeft verbroken","User_Info":"Gebruikers informatie","User_is_no_longer_an_admin":"Gebruiker is niet langer een admin","User_is_not_activated":"Gebruiker is niet geactiveerd","User_is_now_an_admin":"Gebruiker is nu een admin","User_joined_channel":"Heeft zich aangesloten bij het kanaal.","User_joined_channel_female":"Heeft zich aangesloten bij het kanaal.","User_joined_channel_male":"Heeft zich aangesloten bij het kanaal.","User_left":"Heeft het kanaal verlaten.","User_left_female":"Heeft het kanaal verlaten.","User_left_male":"Heeft het kanaal verlaten.","User_logged_out":"Gebruiker is uitgelogd","User_management":"Gebruikersbeheer","User_muted_by":"Gebruiker <em>__user_muted__</em> tot zwijgen gebracht door <em>__user_by__</em>.","User_muted_in_room":"Gebruiker stil gemaakt in de kamer","User_not_found":"Gebruiker niet gevonden","User_not_found_or_incorrect_password":"Gebruiker niet gevonden of onjuist wachtwoord","User_or_channel_name":"Gebruiker of kanaal ","User_removed":"Gebruiker verwijderd","User_removed_by":"Gebruiker <em>__user_removed__</em> verwijderd door  <em>__user_by__</em>.","User_removed_from_room":"De gebruiker is verwijderd uit de kamer","User_Settings":"Gebruikersinstellingen","User_unmuted_by":"Gebruiker <em>__user_muted__</em> weer tot spreken in staat gebracht door <em>__user_by__</em>.\n","User_unmuted_in_room":"Gebruiker kan weer spreken in de kamer","User_updated_successfully":"Gebruiker succesvol bijgewerkt","Username":"Gebruikersnaam","Username_and_message_must_not_be_empty":"Gebruikersnaam en bericht moeten ingevuld zijn.","Username_cant_be_empty":"De gebruikersnaam mag niet leeg zijn","Username_Change_Disabled":"Uw Rocket.Chat beheerder heeft het wijzigen van gebruikersnamen uitgeschakeld","Username_denied_the_OTR_session":"__username__ ontkende de OTR-sessie","Username_description":"De gebruikersnaam kan door anderen gebruikt worden om aan u te refereren.","Username_doesnt_exist":"De gebruikersnaam `%s` bestaat niet.","Username_ended_the_OTR_session":"__username__ eindigde de OTR-sessie","Username_invalid":"<strong>%s</strong> is geen geldige gebruikersnaam,<br/> gebruik uitsluitend letters, cijfers, punten en streepjes","Username_is_already_in_here":"`@%s` is al hier.","Username_is_not_in_this_room":"De gebruiker `#%s` is niet in deze kamer.","Username_not_found":"Gebruikersnaam niet gevonden","Username_title":"Registreer Gebruikersnaam","Username_unavaliable":"<strong>%s</strong> is al in gebruik :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ wil OTR starten. Heeft u wilt accepteren?","Users":"Gebruikers","Users_in_role":"Gebruikers met rol","UTF8_Names_Slugify":"UTF8 Names Slugify","UTF8_Names_Validation":"UTF8 Names Validation","UTF8_Names_Validation_Description":"Geen speciale tekens en spaties toestaan. U kunt - _ en. gebruiken maar niet aan het einde van de naam","Verification_email_sent":"Verificatie e-mail verzonden","View_All":"Bekijk alles","View_Logs":"Bekijk Logs","Visibility":"Zichtbaarheid","Visible":"Zichtbaar","Visitor":"Bezoeker","Visitor_page_URL":"Bezoeker URL","Visitor_time_on_site":"Bezoeker tijd aanwezig op de site","Wait_activation_warning":"Voordat u kunt inloggen, moet uw account handmatig worden geactiveerd door een beheerder.","We_are_offline_Sorry_for_the_inconvenience":"We zijn offline. Excuses voor het ongemak.","We_have_sent_password_email":"Wij hebben u een e-mail gestuurd met herstel instructies voor uw wachtwoord. Als u deze e-mail niet snel ontvangt, ook niet in uw spam-folder, kom dan terug en probeer het opnieuw.","We_have_sent_registration_email":"Wij hebben een e-mail gestuurd om uw registratie te bevestigen. Als u deze e-mail niet snel ontvangt, ook niet in uw spam-folder, kom dan terug en probeer het opnieuw.","WebRTC_Enable_Channel":"Toestaan voor openbare kanalen","WebRTC_Enable_Direct":"Toestaan directe berichten","WebRTC_Enable_Private":"Toestaan voor privé-berichten","WebRTC_Servers":"STUN / TURN Servers","WebRTC_Servers_Description":"Een lijst van STUN en TURN servers gescheiden door een komma. <br/> Gebruikersnaam, wachtwoord en de haven zijn toegestaan ​​in het formaat `gebruikersnaam: wachtwoord @ stun: host: port` of` gebruikersnaam: wachtwoord @ beurt: host: port`.","Welcome":"Welkom <em>%s</em>.","Welcome_to_the":"Welkom bij de","will_be_able_to":"zal in staat zijn om","With_whom":"Met wie","Yes":"Ja","Yes_clear_all":"Ja, alles wissen!","Yes_delete_it":"Ja, verwijder het!","Yes_hide_it":"Ja, verberg het!","Yes_leave_it":"Ja, verlaat het!","Yes_mute_user":"Ja, snoer gebruiker de mond!","Yes_remove_user":"Ja, verwijder gebruiker!","you_are_in_preview_mode_of":"U kijkt naar de voorbeschouwing van kanaal #<strong>__room_name__</strong>","You_are_logged_in_as":"Je bent ingelogd als","You_are_not_authorized_to_view_this_page":"U bent niet bevoegd om deze pagina te bekijken.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Jij bent de laatste eigenaar. Stel nieuwe eigenaar voor het verlaten van de kamer.","You_can_change_a_different_avatar_too":"U kunt de afbeelding die bij berichten gebruikt wordt vervangen.","You_can_use_an_emoji_as_avatar":"U kunt ook een emoji gebruiken als een afbeelding.","You_have_been_muted":"Je bent tot zwijgen gebracht in deze kamer.","You_have_not_verified_your_email":"Je hebt niet geverifieerd uw e-mail.","You_have_successfully_unsubscribed":"U bent uitgeschreven van onze mailinglijst.","You_informed_an_invalid_FROM_address":"You informed an invalid FROM address.","You_must_provide_the_unsubscribe_link":"Je moet een [unsubscribe] link toevoegen.","You_need_confirm_email":"U dient uw e-mail te bevestigen on in te kunnen loggen!","You_need_install_an_extension_to_allow_screen_sharing":"U moet een uitbreiding op uw browser installeren om het delen van het scherm mogelijk te maken","You_need_to_change_your_password":"Je moet je paswoord wijzigen","You_need_to_type_in_your_password_in_order_to_do_this":"Je nodig hebt om te typen in uw wachtwoord in om dit te doen!","You_need_to_type_in_your_username_in_order_to_do_this":"Je nodig hebt om te typen in uw gebruikersnaam in om dit te doen!","You_need_to_verifiy_your_email_address_to_get_notications":"U moet uw e-mailadres verifiy meldingen ontvangen","You_should_name_it_to_easily_manage_your_integrations":"Je moet het een naam geven om je integraties eenvoudig te kunnen beheren.","You_will_not_be_able_to_recover":"Dit bericht zal niet meer te herstellen zijn!","You_will_not_be_able_to_recover_file":"Je kunt dit bestand niet terughalen!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"U zult geen e-mail notificaties ontvangen omdat u niet uw e-mail hebt geverifieerd.","Your_email_has_been_queued_for_sending":"Uw e-mail staat in de wachtrij voor het verzenden","Your_entry_has_been_deleted":"Uw bericht is verwijderd.","Your_file_has_been_deleted":"Je bestand is verwijderd.","Your_mail_was_sent_to_s":"Uw e-mail werd verzonden naar %s","Your_Open_Source_solution":"Uw eigen Open Source chat-oplossing","Your_password_is_wrong":"Je wachtwoord is verkeerd!","Your_push_was_sent_to_s_devices":"Je push werd verzonden naar %s apparaten"});
TAPi18n._registerServerTranslator("nl", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/pl.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["pl"] = ["Polish","Polski"];                                                                   // 8
if(_.isUndefined(TAPi18n.translations["pl"])) {                                                                        // 9
  TAPi18n.translations["pl"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["pl"][namespace])) {                                                             // 13
  TAPi18n.translations["pl"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["pl"][namespace], {"500":"Wewnętrzny Błąd Serwera","0_Errors_Only":"Tylko błędy - 0","1_Errors_and_Information":"1 - Błędy i informacje","2_Erros_Information_and_Debug":"2 - erros, Informacja i debugowania","__username__was_set__role__by__user_by_":"__username__ ustalono __role__ przez __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ nie jest już __role__ przez __user_by__","Access_not_authorized":"Dostęp zabroniony","Access_online_demo":"Uzyskaj dostęp do demo online","Access_Online_Demo":"Uzyskaj dostęp do demo online","Access_Token_URL":"Dostęp Reklamowe URL","Accounts":"Konta","Accounts_AllowDeleteOwnAccount":"Zezwalaj użytkownikom na usunięcie własnego konta","Accounts_AllowedDomainsList":"Lista dozwolonych domen","Accounts_AllowedDomainsList_Description":"Lista dozwolonych domen oddzielona przecinkami","Accounts_AllowEmailChange":"Pozwól E-mail Zmień","Accounts_AllowPasswordChange":"Pozwól na zmianę hasła","Accounts_AllowUserAvatarChange":"Pozwól na zmienianie avatarów","Accounts_AllowUsernameChange":"Pozwól na zmianę nazwy użytkownika","Accounts_AllowUserProfileChange":"Pozwól na zmienianie profilów użytkowników","Accounts_AvatarResize":"Zmiana rozmiaru avatarów","Accounts_AvatarSize":"Rozmiar avataru","Accounts_AvatarStorePath":"Ścieżka przechowywania avatarów","Accounts_AvatarStoreType":"Rodzaj magazynu avatarów","Accounts_BlockedDomainsList":"Lista zablokowanych domen","Accounts_BlockedDomainsList_Description":"Oddzielonych przecinkami lista zablokowanych domen","Accounts_denyUnverifiedEmail":"Odrzucaj niezweryfikowane adresy email","Accounts_EmailVerification":"Weryfikacja adresu email","Accounts_EmailVerification_Description":"Upewnij się, że masz odpowiednie ustawienia SMTP do korzystania z tej funkcji","Accounts_Enrollment_Email":"Adres email do rekrutacji","Accounts_Enrollment_Email_Description":"Możesz użyć znaczników [name], [fname], [lname] by wstawić odpowiednio pełną nazwę użytkownika, jego imię, nazwisko.<br />\nMożesz użyć znacznika [email] by wstawić adres email użytkownika.","Accounts_Iframe_api_method":"Metoda Api","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"Włączone","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Logowanie ważności w dniach","Accounts_ManuallyApproveNewUsers":"Ręczne zatwierdzanie nowych użytkowników","Accounts_OAuth_Custom_Token_Sent_Via":"Reklamowe wysyłane za pośrednictwem","Accounts_OAuth_Custom_Authorize_Path":"Authorize Path","Accounts_OAuth_Custom_Button_Color":"Kolor przycisku","Accounts_OAuth_Custom_Button_Label_Color":"Kolor etykiety przycisku","Accounts_OAuth_Custom_Button_Label_Text":"Etykieta przycisku","Accounts_OAuth_Custom_Enable":"Włącz","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity Path","Accounts_OAuth_Custom_Login_Style":"logowanie Style","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"Adres URL","Accounts_OAuth_Facebook":"Facebook Login","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"GitHub Login","Accounts_OAuth_Github_callback_url":"Github Callback URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Włączone","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise Callback URL","Accounts_OAuth_GitHub_Enterprise_id":"Client Id","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"GitHub Id","Accounts_OAuth_Github_secret":"GitHub Secret","Accounts_OAuth_Gitlab":"OAuth Włączone","Accounts_OAuth_Gitlab_callback_url":"GitLab Callback URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google Login","Accounts_OAuth_Google_callback_url":"Google Callback URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Login","Accounts_OAuth_Linkedin_callback_url":"Linkedin Callback URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Login","Accounts_OAuth_Meteor_callback_url":"Meteor Callback URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Login","Accounts_OAuth_Twitter_callback_url":"Twitter Callback URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"Wordpress Callback URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Zresetuj hasło","Accounts_Registration_AuthenticationServices_Enabled":"Rejestracja przy użyciu serwisów zewnętrznych","Accounts_RegistrationForm":"Formularz rejestracyjny","Accounts_RegistrationForm_Disabled":"Wyłączony","Accounts_RegistrationForm_LinkReplacementText":"Treść tekstu zamiennego w formularzu rejestracyjnym","Accounts_RegistrationForm_Public":"Publiczny","Accounts_RegistrationForm_Secret_URL":"Sekretny adres URL","Accounts_RegistrationForm_SecretURL":"Sekretny adres URL formularza rejestracyjnego","Accounts_RegistrationForm_SecretURL_Description":"Musisz podać losowy ciąg znaków, który zostanie dodany do adresu URL rejestracji. Przykład: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Musisz się zarejestrować","Accounts_RequireNameForSignUp":"Wymagaj podana nazwy podczas rejestracji","Accounts_ShowFormLogin":"Pokaż formularz logowania","Accounts_UseDefaultBlockedDomainsList":"Użyj domyślnego Lista zablokowanych domen","Accounts_UseDNSDomainCheck":"Użyj DNS domeny Check","Activate":"Aktywuj","Activity":"Czynność","Add":"Dodaj","Add_agent":"Dodaj agenta","Add_custom_oauth":"Dodaj własne OAuth","Add_manager":"Dodaj menedżera","Add_Members":"Dodaj członków","Add_User":"Dodaj użytkownika","Add_user":"Dodaj użytkownika","Add_users":"Dodaj użytkowników","Additional_emails":"Dodatkowe e-maile","Additional_Feedback":"dodatkowy komentarz","Administration":"Administracja","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Po uwierzytelnieniu OAuth2, użytkownik zostanie przekierowany na ten adres URL","Agent_added":"Brokerzy dodany","Agent_removed":"Środek usunięta","Alias":"Alias","All":"Wszystko","All_channels":"Wszystkie kanały","All_logs":"Wszystkie dzienniki","All_messages":"Wszystkie wiadomości","Allow_Invalid_SelfSigned_Certs":"Pozwól na nieprawidłowe certyfikaty","Allow_Invalid_SelfSigned_Certs_Description":"Pozwól na nieprawidłowe i samodzielnie podpisane certyfikaty SSL podczas walidacji linków i podglądów","and":"i","And_more":"I więcej __length __...","Animals_and_Nature":"Fauna & Flora","API":"API","API_Analytics":"Analytics","API_Embed":"Osadź","API_EmbedDisabledFor":"Wyłącz osadzanie dla użytkowników","API_EmbedDisabledFor_Description":"Lista użytkowników oddzielonych przecinkami","API_GitHub_Enterprise_URL":"Adres serwera","API_GitHub_Enterprise_URL_Description":"Przykład: http://domain.com (bez końcowego ukośnika)","API_Gitlab_URL":"Adres GitLab","API_Wordpress_URL":"WordPress URL","Appearance":"Wygląd","Application_added":"aplikacja dodaje","Application_Name":"Nazwa aplikacji","Application_updated":"zaktualizowana aplikacja","Apply_and_refresh_all_clients":"Zastosuj i odświeżenia wszystkich klientów","Archive":"Archiwizuj","Archive_Unarchive":"Przeniesienie do archiwum","are_also_typing":"również piszą","are_typing":"piszą","Are_you_sure":"Jesteś pewny?","Are_you_sure_you_want_to_delete_your_account":"Czy na pewno chcesz usunąć swoje konto?","Authorization_URL":"Autoryzacja URL","Authorize":"Autoryzować","AutoLinker_StripPrefix":"AutoLinker Strip Prefiks","AutoLinker_StripPrefix_Description":"Krótki wyświetlacz. np https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker email","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"Automatycznie połączone dla numerów telefonów. np `(123) 456-7890`","Auto_Load_Images":"Automatycznie ładuj zdjęcia","Available":"Dostępny","Available_agents":"dostępne środki","Avatar":"Zmień avatar","Avatar_changed_successfully":"Twój avatar został zapisany","Avatar_URL":"Avatar URL","Avatar_url_invalid_or_error":"Podany adres URL jest nieprawidłowy. Popraw go i spróbuj ponownie.","away":"zaraz wracam","Away":"Zaraz wracam","away_female":"zaraz wracam","Away_female":"Zaraz wracam","away_male":"zaraz wracam","Away_male":"Zaraz wracam","Back":"Plecy","Back_to_applications":"Powrót do aplikacji","Back_to_integrations":"Powrót do integracji","Back_to_login":"Wróć do strony logowania","Back_to_permissions":"Powrót do uprawnień","Body":"Ciało","bold":"pogrubienie","busy":"zajęty","Busy":"Zajęty","busy_female":"zajęta","Busy_female":"Zajęta","busy_male":"zajęty","Busy_male":"Zajęty","Cancel":"Anuluj","Cannot_delete_a_protected_role":"Nie można usunąć zabezpieczonego rolę","Cannot_delete_role_because_its_in_use":"Nie można usunąć rolę, ponieważ jest w użyciu","Cannot_invite_users_to_direct_rooms":"Nie można zaprosić użytkowników do kierujących pokoje","CDN_PREFIX":"Prefiks CDN","Certificates_and_Keys":"Certyfikaty i klucze","Channel":"Kanał","Channel_doesnt_exist":"Kanał `#%s` nie istnieje.","Channels":"Kanały","Channels_list":"Lista kanałów publicznych","Chat_Rooms":"Pokoje","Chatops_Enabled":"Włącz opów w pokojach","Chatops_Title":"Panel operatora","Chatops_Username":"Nazwa użytkownika operatora","Choose_a_room":"Wybierz pokój","Choose_messages":"Wybierz wiadomości","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Wybierz alias, który pojawi się przed nazwą użytkownika w wiadomościach.","Choose_the_username_that_this_integration_will_post_as":"Wybierz nazwę użytkownika, że ​​integracja ta będzie posadę.","Clear_all_unreads_question":"Wyczyścić wszystkie nieprzeczytane?","Client_ID":"Identyfikator klienta","Client_Secret":"Tajny klient","Clients_will_refresh_in_a_few_seconds":"Klienci będą odświeżyć w ciągu kilku sekund","close":"zamknij","Closed":"Zamknięte","Collapse_Embedded_Media_By_Default":"Zwiń wbudowanego nośnika domyślnie","coming_soon":"wkrótce","Commands":"Polecenia","Compact_View":"Widok kompaktowy","Confirm_password":"Potwierdź hasło","Contact":"Kontakt","Conversation":"Rozmowa","Convert_Ascii_Emojis":"Konwertuj ASCII do Emoji","Copied":"skopiowane","COPY_TO_CLIPBOARD":"SKOPIUJ DO SCHOWKA","Copy_to_clipboard":"Skopiuj do schowka","Count":"Liczyć","Create":"Stwórz","Create_new":"Utwórz","Created_at":"Utworzono","Created_at_s_by_s":"Utworzono <strong>przez% <strong>s%</strong></strong> <strong>s</strong>","Custom_Fields":"Pola niestandardowe","Custom_oauth_helper":"Przy konfiguracji dostawcy OAuth będziesz musiał podać zwrotny adres URL (Callback). Użyj adresu <pre>%s</pre>.","Custom_oauth_unique_name":"Nazwa własnego serwisu OAuth","Custom_Script_Logged_In":"Script zwyczaj zalogowanych użytkowników","Custom_Script_Logged_Out":"Niestandardowy skrypt dla zalogowanych użytkowników z","Dashboard":"Deska rozdzielcza","days":"dni","Deactivate":"Deaktywuj","Debug_Level":"Debug Level","Default":"Domyślne","Delete":"Usuń","Delete_my_account":"Usuń moje konto","Delete_Room_Warning":"Usunięcie pokoju wiąże się z usunięciem wszystkich wiadomości wysłanych do niego. Tej operacji nie można cofnąć.","Delete_User_Warning":"Usunięcie użytkownika wiąże się z usunięciem wszystkich jego wiadomości. Tej czynności nie można cofnąć.","Deleted":"Usunięte!","Department_not_found":"Zakład nie został znaleziony","Department_removed":"Departament usunięta","Departments":"wydziały","Description":"Opis","Desktop":"Pulpit","Desktop_Notification_Test":"Pulpit test Powiadamianie","Desktop_Notifications":"Powiadomienia na pulpicie","Desktop_Notifications_Disabled":"Powiadomienia na pulpicie są wyłączone. Zmień ustawienia swojej przeglądarki jeżeli chcesz włączyć powiadomienia.","Desktop_Notifications_Enabled":"Powiadomienia na pulpicie są włączone","Direct_message_someone":"Bezpośredni komunikat ktoś","Direct_Messages":"Prywatne wiadomości","Direct_Messages_list":"Bezpośrednie wiadomości","Disable_Favorite_Rooms":"Wyłącz ulubione","Disable_New_Message_Notification":"Wyłącz powiadomienia dla nowych wiadomości","Disable_New_Room_Notification":"Wyłącz powiadomienia dla nowych kanałów","Displays_action_text":"Wyświetla tekst działania","Do_you_want_to_change_to_s_question":"Chcesz zmienić <strong>na %s?</strong>","Drop_to_upload_file":"Przeciągnij, aby przesłać plik","Dry_run":"Próba","Dry_run_description":"Wyśle tylko jedną wiadomość e-mail, na ten sam adres, jak w Od. Wiadomość e-mail musi należeć do ważnego użytkownika.","Duplicate_archived_channel_name":"Zarchiwizowanej Kanał o nazwie ' %s' nie istnieje","Duplicate_archived_private_group_name":"Zarchiwizowany Grupa Prywatna ze istnieje Nazwa ' %s'","Duplicate_private_group_name":"Grupa Prywatna o nazwie '%s' istnieje","E-mail":"Email","Edit":"Edycja","Edit_Custom_Field":"Edycja klienta Pole","Edit_Department":"Edycja Departament","edited":"zmieniono","Email":"E-mail","Email_already_exists":"Ten email jest zajęty","Email_body":"Treść wiadomości","Email_Change_Disabled":"Twój Rocket.Chat Administrator wyłączył wymianę e-mail","Email_from":"Od","Email_Notification_Mode":"Powiadomienia e-mail w trybie offline","Email_Notification_Mode_All":"Każdy Wzmianka / DM","Email_Notification_Mode_Disabled":"Niepełnosprawny","Email_or_username":"Email lub nazwa użytkownika","Email_subject":"Temat","Email_verified":"E-mail zweryfikowany","Emoji":"Emoji","Empty_title":"Pusty tytuł","Enable":"Włącz","Enable_Desktop_Notifications":"Włącz powiadomienia na pulpicie","Enabled":"Włączone","Encrypted_message":"zaszyfrowaną wiadomość","End_OTR":"koniec OTR","Enter_a_regex":"Wprowadź regex","Enter_a_room_name":"Wpisz nazwę pomieszczenia","Enter_a_username":"Nazwa użytkownika","Enter_info":"Podaj swoje dane","Enter_name_here":"Wpisz nazwę tutaj","Enter_to":"Naciśnij Enter: ","Error":"Błąd","error-cant-invite-for-direct-room":"Nie można zaprosić użytkownika do bezpośrednich pokoi","error-duplicate-channel-name":"Kanał o nazwie \"%s\" już istnieje","error-invalid-custom-field":"Nieprawidłowa pola","error-invalid-custom-field-name":"Nieprawidłowa nazwa pole niestandardowe. Używaj tylko litery, cyfry, łączniki i podkreślenia.","error-invalid-password":"Nieprawidłowe hasło","error-invalid-room":"Nieprawidłowy pokoju","error-invalid-room-name":"<strong> %s</strong> nie jest prawidłową nazwą pokój, <br/> używać tylko litery, cyfry, łączniki i podkreślenia","error-invalid-user":"Nieprawidłowy użytkownik","error-invalid-username":"Zła nazwa użytkownika","error-not-allowed":"Niedozwolone","error-not-authorized":"Nieautoryzowany","error-remove-last-owner":"Jest to ostatni właściciel. Proszę ustawić nowego właściciela przed usunięciem tego.","error-role-name-required":"wymagana jest nazwa roli","error-user-not-in-room":"Użytkownik nie jest w tym pokoju","Error_changing_password":"Błąd zmiany hasła","Error_sending_confirmation_email":"Błąd wysyłania wiadomości e-mail z potwierdzeniem","Error_too_many_requests":"Błąd, zbyt wiele żądań. Proszę zwolnij. Musisz poczekać %s sekund zanim spróbujesz ponownie","Esc_to":"Naciśnij Esc: ","Example_s":"Przykład: <code class=\"inline\">%s</code>","False":"Nie","Favorites":"Ulubione","Field":"Pole","Field_removed":"Pole usunięte","File_exceeds_allowed_size_of_bytes":"Plik przekracza dozwoloną wielkość __size__ bajtów","FileUpload":"Przesyłanie plików","FileUpload_Enabled":"Przesyłanie plików włączone","FileUpload_File_Empty":"Plik jest pusty","FileUpload_FileSystemPath":"Ścieżka System","FileUpload_MaxFileSize":"Maksymalny rozmiar przesłanego pliku (w bajtach)","FileUpload_MediaType_NotAccepted":"Typy mediów nie są akceptowane","FileUpload_MediaTypeWhiteList":"Dozwolone typy plików","FileUpload_MediaTypeWhiteListDescription":"Typy plików, oddzielone przecinkami","FileUpload_ProtectFiles":"Chronić przesłane pliki","FileUpload_ProtectFilesDescription":"Tylko uwierzytelnione użytkownicy będą mieli dostęp","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 Nazwa wiadro","FileUpload_S3_BucketURL":"URL Bucket","FileUpload_S3_CDN":"CDN domeny pobrania","FileUpload_S3_Region":"Region","FileUpload_Storage_Type":"Rodzaj bagażu","Flags":"flagi","Follow_social_profiles":"Śledź nas w portalach społecznościowych, forkuj projekt na githubie lub powiedz nam co myślisz o rocket.chat na naszym trello.","Food_and_Drink":"Jedzenie picie","For_your_security_you_must_re_enter_your_password_to_continue":"Dla własnego bezpieczeństwa, należy ponownie wprowadzić hasło, aby kontynuować","Force_SSL":"siła SSL","Force_SSL_Description":"* Uwaga! * _Force SSL_ nigdy nie powinien być stosowany z reverse proxy. Jeśli masz reverse proxy, należy zrobić przekierowanie tam. Opcja ta istnieje dla wdrożeń jak Heroku, który nie pozwala na konfigurację przekierowania na reverse proxy.","Forgot_password":"Zapomniałeś hasła","Fork_it_on_github":"Forkuj projekt na GitHubie","Frequently_Used":"Często używany","From":"Od","From_Email":"Adres nadawcy","From_email_is_required":"Adres nadawcy jest wymagany","From_email_warning":"<b>Uwaga</b>: Pole <b>Od</b> może być uzależnione od ustawień serwera.","General":"Ogólne","Get_to_know_the_team":"Poznaj Rocket.Team","github_no_public_email":"Nie posiadasz publicznego konta e-mail przypisanego do swojego profilu GitHub.","Give_a_unique_name_for_the_custom_oauth":"Podaj unikalną nazwę dla własnego serwisu OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Daj aplikację nazwę. Będzie to widoczne dla użytkowników.","Global":"Światowy","GoogleTagManager_id":"Menedżer tagów Google Id","Has_more":"Jest więcej","Have_your_own_chat":"Załóż swój własny czat. Dzięki Meteor.com, Rocket.Chat jest idealnym rozwiązaniem dla wszystkich chcących budować i rozwijać swoją własną platformę do rozmów.","Header":"nagłówek","Hidden":"Ukryty","Hide_Group_Warning":"Czy na pewno chcesz ukryć grupę \" %s\"?","Hide_Private_Warning":"Czy na pewno chcesz ukryć dyskusję z \" %s\"?","Hide_room":"Ukryj pokój","Hide_Room_Warning":"Czy na pewno chcesz ukryć pokój \" %s\"?","Highlights":"Pasemka","Highlights_How_To":"Aby otrzymywać powiadomienia, gdy ktoś wspomina słowo lub frazę, dodaj go tutaj. Można oddzielić słowa lub wyrażenia przecinkami. Podświetlane Słowa nie są wrażliwe na wielkość liter.","Highlights_List":"podświetlane słowa","History":"Historia","hours":"godzin","How_friendly_was_the_chat_agent":"Jak przyjazny był agentem czat?","How_knowledgeable_was_the_chat_agent":"Jak wiedzę był agentem czat?","How_responsive_was_the_chat_agent":"Jak reaguje był agentem czat?","How_satisfied_were_you_with_this_chat":"Jak byłeś zadowolony z tej rozmowy?","If_you_are_sure_type_in_your_password":"Jeżeli jesteś pewien, wpisz swoje hasło:","If_you_are_sure_type_in_your_username":"Jeżeli jesteś pewien, wpisz swoją nazwę użytkownika:","Importer_Archived":"zarchiwizowane","Importer_done":"Importowanie zakończone!","Importer_finishing":"Kończąc się na import.","Importer_From_Description":"Import __from __ 's dane do Rocket.Chat.","Importer_import_cancelled":"Importowanie anulowane.","Importer_import_failed":"Wystąpił błąd podczas wykonywania importu.","Importer_importing_channels":"Importowanie kanałów.","Importer_importing_messages":"Importowanie wiadomości.","Importer_importing_started":"Począwszy od importu.","Importer_importing_users":"Importowanie użytkowników.","Importer_not_defined_properly":"Importer nie została określona prawidłowo, to brakuje klasy Import.","Importer_not_in_progress":"Importer nie jest obecnie uruchomiony.","Importer_Prepare_Restart_Import":"restart importu","Importer_Prepare_Start_Import":"Zacznij Importowanie","Importer_Prepare_Uncheck_Archived_Channels":"Odznacz kanały archiwalne","Importer_Prepare_Uncheck_Deleted_Users":"Odznacz usuniętych użytkowników","Importer_progress_error":"Nie udało się uzyskać postęp dla importu.","Importer_setup_error":"Wystąpił błąd podczas konfigurowania importera wystąpił.","Incorrect_Password":"Hasło jest nieprawidłowe","inline_code":"kod","Install_Extension":"Zainstaluj rozszerzenie","Install_FxOs":"Zainstaluj Rocket.Chat w Firefoksie","Install_FxOs_done":"Świetnie! Możesz teraz włączać Rocket.Chat poprzez ikonę na ekranie głównym. Życzymy miłego korzystania z Rocket.Chat!","Install_FxOs_error":"Niestety, coś nie zadziałało! Wystąpił następujący błąd:","Install_FxOs_follow_instructions":"Potwierdź instalowanie aplikacji na twoim urządzeniu (gdy wyskoczy pytanie naciśnij przycisk \"Zainstaluj\").","Installation":"Instalacja","Integration_added":"Integracja został dodany","Integration_Incoming_WebHook":"Przychodzące WebHook Integracja","Integration_New":"Nowy Integracja","Integration_Outgoing_WebHook":"Wychodzące WebHook Integracja","Integration_updated":"Integracja została zaktualizowana","Integrations":"Integracje","Invalid_asset":"Nieprawidłowy aktywów","Invalid_confirm_pass":"Podane hasła nie są jednakowe","Invalid_email":"E-mail jest nieprawidłowy","Invalid_Export_File":"Przesłany plik nie jest prawidłowym %s plik eksportu.","Invalid_file_height":"Nieprawidłowa wysokość pliku","Invalid_file_type":"Nieprawidłowy typ pliku","Invalid_file_width":"Nieprawidłowa szerokość pliku","Invalid_Import_File_Type":"Nieprawidłowy typ pliku importu.","Invalid_name":"Nazwa nie może być pusta","Invalid_notification_setting_s":"Nieprawidłowe ustawienie powiadamiania: %s","Invalid_pass":"Hasło nie może być puste","Invalid_room_name":"<strong>%s</strong> nie jest poprawną nazwą pokoju, <br / >użyj tylko liter, cyfr i myślników","Invalid_room_type":"<strong> %s</strong> nie jest prawidłowy typ pokoju.","Invalid_Secret_URL":"Nieprawidłowy Tajny URL","Invalid_secret_URL_message":"Podany adres URL jest nieprawidłowy.","invisible":"niewidoczny","Invisible":"Niewidoczny","Invitation_HTML":"Kod HTML zaproszenia","Invitation_Subject":"Temat zaproszenia","Invite_user_to_join_channel":"Zaproś użytkownika by dołączył do kanału","Invite_Users":"Zaproś użytkowników","is_also_typing":"również pisze","is_also_typing_female":"pisze","is_also_typing_male":"również pisze","is_typing":"pisze","is_typing_female":"pisze","is_typing_male":"pisze","italics":"kursywa","join":"Dołącz","Join_audio_call":"Dołącz do połączenia dźwięku","Join_the_Community":"Dołącz do społeczności","Join_the_given_channel":"Dołącz do tego kanału","Join_video_call":"Dołącz do połączenia wideo","Joined":"Dołączył","Jump":"Skok","Jump_to_first_unread":"Przejdź do pierwszej nieprzeczytanej","Jump_to_message":"Skocz do wiadomości","Jump_to_recent_messages":"Przejdź do ostatnich wiadomości","Katex_Enabled":"KATEX Włączone","Label":"Etykieta","Language":"Język","Language_Version":"Wersja angielska","Last_login":"Ostatnie logowanie","Last_message":"Ostatnia wiadomość","Last_seen":"Ostatnio widziany","Layout":"Wygląd i treść","Layout_Home_Body":"Treść strony głównej","Layout_Home_Title":"Tytuł strony głównej","Layout_Login_Terms":"Regulamin rejestacji","Layout_Privacy_Policy":"Polityka Prywatności","Layout_Sidenav_Footer":"Stopka panelu nawigacyjnego","Layout_Sidenav_Footer_description":"Stopka ma rozmiar 260 x 70 pikseli","Layout_Terms_of_Service":"Regulamin","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Szukaj Domena niestandardowa","LDAP_Custom_Domain_Search_Description":"Kawałek JSON, który reguluje powiązania i połączenia informacji i ma postać: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Default Domain","LDAP_Description":"LDAP to hierarchiczna baza danych wykorzystywana przez wiele firm w celu udostępniania pojedynczej usługi autoryzacji użytkowników pomiędzy wieloma serwisami. Aby uzyskać dodatkowe informacje i przykłady konfiguracji, odwiedź nasze wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Baza domeny","LDAP_Domain_Base_Description":"W pełni kwalifikowana nazwa wyróżniająca (DN) w poddrzewie LDAP chcesz wyszukać użytkowników i grup. Możesz dodać tyle, ile zechcesz; Jednakże, każda grupa musi być określona w ten sam bazie domeny jako użytkowników należących do niego. Jeśli podasz niewielkich grup użytkowników, tylko użytkownicy należący do tych grup będzie w zasięgu. Zaleca się, aby określić górny poziom drzewa katalogów LDAP jako baza domeny i użyć filtru wyszukiwania w celu kontroli dostępu.","LDAP_Domain_Search_Filter":"Domeny Filtr wyszukiwania","LDAP_Domain_Search_Filter_Description":"Jeśli określony, tylko użytkownicy pasujących ten filtr będzie mógł zalogować. Jeśli filtr nie jest określony, wszyscy użytkownicy w zakresie określonym bazie domeny będą mogli się zalogować. <br/> Np Active Directory `memberOf = cn = ROCKET_CHAT, ou = Ogólne Groups`. <br/> Np OpenLDAP (rozszerzalny wyszukiwania match) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Kategoria","LDAP_Domain_Search_Object_Category_Description":"* Przy objectCategory *, które identyfikują użytkowników. <br/> Zostaw pusty * OpenLDAP *. <br/> Np `osoba prowadząca, etc.","LDAP_Domain_Search_Object_Class":"Domain Search Object Class","LDAP_Domain_Search_Object_Class_Description":"Gwiazdka * * objectclass które identyfikują użytkowników. <br/> Np `organizationalPerson`,` użytkownik portu, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Domain Search Hasło","LDAP_Domain_Search_Password_Description":"Hasło dla użytkownika wyszukiwarki domeny.","LDAP_Domain_Search_User":"Domeny Szukaj użytkownika","LDAP_Domain_Search_User_Description":"Użytkownik LDAP, który wykonuje wyszukiwań użytkowników do uwierzytelnienia innych użytkowników podczas logowania się. <br/> Jest to zazwyczaj konto usługi stworzony specjalnie dla integracji osób trzecich. Użyj pełnej nazwy, takie jak `cn = Administrator, CN = Users, DC = example, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search ID użytkownika","LDAP_Domain_Search_User_ID_Description":"Atrybut LDAP, która identyfikuje użytkownika LDAP, który próbuje uwierzytelnienia. To pole powinno być `sAMAccountName` dla instalacji najbardziej Active Directory, ale może to być` uid` innych rozwiązań, takich jak LDAP OpenLDAP. Można użyć `mail` celu identyfikacji użytkowników przez e-mail lub cokolwiek atrybut chcesz. <br> Można użyć wielu wartości oddzielonych przecinkiem, aby umożliwić użytkownikom, aby zalogować się za pomocą wielu identyfikatorów, takich jak nazwa użytkownika lub adres e-mail.","LDAP_Enable":"Włącz LDAP","LDAP_Enable_Description":"Włącza LDAP podczas uwierzytelniania.","LDAP_Encryption":"Szyfrowanie","LDAP_Encryption_Description":"Metoda szyfrowania wykorzystywany do zabezpieczenia komunikacji z serwerem LDAP. Przykłady obejmują `plain` (bez szyfrowania),` SSL / LDAPS` (zaszyfrowany od początku) i `StartTLS` (upgrade do szyfrowanej komunikacji po podłączeniu).","LDAP_Host":"Gospodarz","LDAP_Host_Description":"Gospodarz LDAP, np `ldap.example.com` lub` 10.0.0.30`.","LDAP_Port":"Port LDAP","LDAP_Port_Description":"Port dostępowy dla LDAP; np: 389","LDAP_Reject_Unauthorized":"Odrzuć Nieuprawnione","LDAP_Sync_User_Avatar":"Synchronizacja User Avatar","LDAP_Sync_User_Data":"Synchronizuj dane","LDAP_Sync_User_Data_Description":"Utrzymuj dane (np: nazwa, email) w synchronizacji z serwerem podczas logowania","LDAP_Sync_User_Data_FieldMap":"Mapa pól użytkownika","LDAP_Sync_User_Data_FieldMap_Description":"Konfigurowanie sposobu w jaki pola kont (np. email) są uzupełniane z rekordów LDAP (gdy takowe zostaną znalezione). Na przykład podając {\"cn\":\"name\", \"mail\":\"email\"} system wybierze wyświetlaną nazwę użytkownika z pola cn i jego adres email z pola email. Dostępne pola to: name, email.","LDAP_Sync_Users":"Użytkownicy Sync","LDAP_Test_Connection":"Test połączenia","LDAP_Unique_Identifier_Field":"Unikalny Identyfikator Pole","LDAP_Unique_Identifier_Field_Description":"To które będą stosowane do łączenia użytkownika LDAP i użytkownika Rocket.Chat. Możesz poinformować wiele wartości oddzielonych przecinkiem, aby postarać się o wartość z rejestru LDAP. <br/> Domyślną wartością jest `objectGUID IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Użyj wyszukiwarki Domena niestandardowa","LDAP_Use_Custom_Domain_Search_Description":"Wpisz swój własny filtr do wyszukiwania użytkowników na serwerze LDAP.","LDAP_Username_Field":"Nazwa pola","LDAP_Username_Field_Description":"Które pole będzie używany jako nazwa użytkownika * * Dla nowych użytkowników. Zostaw puste, aby użyć nazwy użytkownika informować na stronie logowania. <br/> Można używać znaczników szablonów też, podobnie jak `# {givenName}. # {sn}`. <br/> Domyślną wartością jest `sAMAccountName`.","Leave_Group_Warning":"Czy na pewno chcesz opuścić grupę \" %s\"?","Leave_Private_Warning":"Czy na pewno chcesz opuścić dyskusji z \" %s\"?","Leave_room":"Opuść pokój","Leave_Room_Warning":"Czy na pewno chcesz opuścić pokój \" %s\"?","line":"linia","List_of_Direct_Messages":"Lista wiadomości bezpośrednich","Live_sessions":"Sesje na żywo","Livechat_agents":"środki LiveChat","Livechat_Dashboard":"Livechat Dashboard","Livechat_enabled":"Livechat włączony","Livechat_Manager":"Livechat menadżera","Livechat_managers":"Zarządzający LiveChat","Livechat_title":"Tytuł Livechatu","Livechat_title_color":"Kolor tła nagłówka Livechat","Livechat_Users":"Livechat Użytkownicy","Load_more":"Załaduj więcej","Loading...":"Ładowanie ...","Loading_more_from_history":"Ładowanie więcej z historii","Loading_suggestion":"Ładowanie sugestii...","Localization":"Lokalizacja","Log_File":"Pokaż plików i linię","Log_Level":"Log Level","Log_Package":"Pokaż Pakiet","Log_View_Limit":"Zaloguj Zobacz Limit","Logged_out_of_other_clients_successfully":"Wylogowanie z innymi klientami z powodzeniem","Login":"Login","Login_with":"Zaloguj się z %s","login_with":"lub zaloguj bezpośrednio z","Logout":"Wyloguj","Logout_Others":"Rozłączenie z innych zalogowany Lokalizacje","Mail_Message_Invalid_emails":"Podałeś jeden lub więcej nieprawidłowych maile: %s","Mail_Message_Missing_to":"Musisz wybrać jeden lub więcej użytkowników lub dostarczyć jeden lub więcej adresów e-mail, rozdzielając je przecinkami.","Mail_Message_No_messages_selected_select_all":"Nie wybrałeś żadnych wiadomości. Chcesz <a href='#' class='select-all'>wybrać wszystkie</a> widoczne wiadomości?","Mail_Messages":"Wysyłanie wiadomości przez email","Mail_Messages_Instructions":"Wybierz wiadomości, które chcesz wysłać za pośrednictwem poczty elektronicznej za pomocą wiadomości","Mail_Messages_Subject":"Oto wybrana część wiadomości %s","Mailer":"Wyślij email użytkownikom","Mailer_body_tags":"<b>Musisz</b> użyć znacznika [unsubscribe] aby zawrzeć w treści odnośnik do rezygnacji z subskrypcji.<br />Możesz użyć znaczników [name], [fname], [lname] by wstawić odpowiednio pełną nazwę użytkownika, jego imię, nazwisko.<br />\nMożesz użyć znacznika [email] by wstawić adres email użytkownika.","Make_Admin":"Przydziel Admina","Manager_added":"Menedżer dodał","Manager_removed":"Menedżer usunięte","Mark_as_read":"Oznacz jako przeczytane","Markdown_Headers":"Nagłówki Markdown","Markdown_SupportSchemesForLink":"Przecena systemy wsparcia dla Łącze","Markdown_SupportSchemesForLink_Description":"Oddzielonych przecinkami lista dozwolonych programów","Members_List":"Lista użytkowników","Mentions":"Wzmianki o tobie","Mentions_default":"Wzmianki (domyślnie)","Message":"Wiadomość","Message_AllowDeleting":"Pozwól usuwać wiadomości","Message_AllowEditing":"Pozwól edytować wiadomości","Message_AllowEditing_BlockEditInMinutes":"Blokuj edytowanie wiadomości po (n) minutach","Message_AllowEditing_BlockEditInMinutesDescription":"Wpisz 0, aby wyłączyć blokowanie.","Message_AllowPinning":"Pozwól na przypinanie wiadomości","Message_AllowPinning_Description":"Pozwól na przypinanie wiadomości we wszystkich kanałach.","Message_AllowStarring":"Pozwól oznaczać wiadomości gwiazdką","Message_AudioRecorderEnabled":"Wysyłanie nagrań audio włączone","Message_AudioRecorderEnabledDescription":"Wymagane jest akceptowanie plików 'audio/wav' w panelu ustawień 'Przesyłanie plików'","Message_DateFormat":"Format daty","Message_DateFormat_Description":"Zobacz także: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Usuwanie wiadomości jest niedozwolone","Message_editing_blocked":"Nie można już edytować tej wiadomości","Message_editing_not_allowed":"Edycja wiadomości jest niedozwolona","Message_GroupingPeriod":"Grupowanie okres (w sekundach)","Message_GroupingPeriodDescription":"Komunikaty będą grupowane z poprzedniego komunikatu, jeżeli oba są z tego samego użytkownika i czas, jaki upłynął mniej od podanej czas w sekundach.","Message_KeepHistory":"Zachowaj historię wiadomości","Message_MaxAllowedSize":"Maksymalna dozwolona długość wiadomości","Message_MaxAll":"Maksymalny rozmiar kanałem wiadomości ALL","Message_pinned":"Wiadomość przypięta","Message_pinning_not_allowed":"Przypinanie wiadomości jest niedozwolone","Message_removed":"Wiadomość usunięta","Message_ShowDeletedStatus":"Pokaż informację o usunięciu","Message_ShowEditedStatus":"Pokaż informację o edycji","Message_ShowFormattingTips":"Pokaż porady formatowania wiadomości","Message_TimeFormat":"Format czasu","Message_TimeFormat_Description":"Zobacz także: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Wiadomość za długa","Messages":"Wiadomości","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Wiadomości, które są wysyłane do przychodzącej WebHook zostaną zamieszczone tutaj.","Meta":"meta","Meta_fb_app_id":"Facebook APP ID","Meta_google-site-verification":"Weryfikacja Google","Meta_language":"Język","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Roboty","minutes":"minut","Mobile_push":"Komórka Push","More_channels":"Więcej kanałów","More_direct_messages":"Więcej wiadomości bezpośrednie","More_groups":"Więcej grup prywatnych","More_unreads":"Więcej nieprzeczytanych","Msgs":"Wiadomości","multi":"multi","Mute_someone_in_room":"Wycisz ktoś w pokoju","Mute_user":"Wycisz użytkownika","Muted":"wyciszony","My_Account":"Moje konto","n_messages":"%s wiadomości","N_new_messages":" %s nowych wiadomości","Name":"Nazwa","Name_cant_be_empty":"Nazwa nie może być pusta","Name_of_agent":"Nazwa środka","Name_optional":"Nazwa (opcjonalnie)","Navigation_History_20_last_pages":"Historia nawigacji (20 ostatnich stron)","New_Application":"Nowa aplikacja","New_Custom_Field":"Nowe niestandardowe pole","New_Department":"Nowy Zakład","New_integration":"Nowa integracja","New_logs":"Nowe dzienniki","New_messages":"Nowe wiadomości","New_password":"Nowe hasło","New_role":"Nowa rola","No_channel_with_name_%s_was_found":"Nie odnaleziono kanału o nazwie <strong>\"%s\"</strong>!","No_channels_yet":"Nie jesteś członkiem żadnego kanału.","No_direct_messages_yet":"Nie rozpocząłeś jeszcze żadnej rozmowy.","No_Encryption":"Bez szyfrowania","No_favorites_yet":"Nie masz żadnych ulubionych.","No_group_with_name_%s_was_found":"Nie odnaleziono grupy o nazwie <strong>\"%s\"</strong>!","No_groups_yet":"Nie masz prywatnych grup.","No_livechats":"Nie masz żadnych livechatów.","No_mentions_found":"Nie znaleziono wzmianek o tobie","No_permission_to_view_room":"Nie masz dostępu do tego pokoju","No_pinned_messages":"Brak przypiętych wiadomości","No_results_found":"Nie znaleziono wyników","No_starred_messages":"Brak ulubionych wiadomości","no_tokens_for_this_user":"Brak tokeny dla tego użytkownika","No_user_with_username_%s_was_found":"Nie odnaleziono użytkownika o nazwie <strong>\"%s\"</strong>!","Not_allowed":"Niedozwolone","Not_authorized":"Brak autoryzacji","Not_Available":"Niedostępne","Not_found_or_not_allowed":"Nie znaleziono lub niedozwolone","Nothing":"Nic","Nothing_found":"Nic nie znaleziono","Notifications":"Powiadomienia","Notify_all_in_this_room":"Powiadom wszystkich w pokoju","Num_Agents":"# Agents","Number_of_messages":"Ilość wiadomości","OAuth_Application":"Zastosowanie OAuth","OAuth_Applications":"Aplikacje OAuth","Objects":"Przedmioty","Off_the_record_conversation":"Off-the-record Conversation","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record rozmowa nie jest dostępna dla przeglądarki lub urządzenia.","Offline_DM_Email":"[__site__] Zostałaś bezpośrednim messaged przez __user__","Offline_Mention_Email":"[__site__] Nie zostały wymienione przez __user__ w #__room__","Old_and_new_password_must_be_different":"Nowe hasło musi różnić się od starego hasła.","Old_and_new_password_required":"Aby zmienić hasło musisz podać zarówno stare jak i nowe hasło.","Online":"Online","Only_errors":"Tylko błędy","Only_you_can_see_this_message":"Tylko Ty widzisz tę wiadomość","Oops!":"Ups","Open":"otwarty","Opened":"Otwierany","Opt_out_statistics":"Nie wysyłaj statystyk do autorów Rocket.Chat","Opt_out_statistics_warning":"Przesyłając swoje statystyki pomagasz nam określić jak instalacji Rocket.Chat jest w użyciu i jak dobrze sprawuje się nasza aplikacja, co pozwala nam ją wciąż ulepszać. Nie przesyłamy żadnych informacji o użytkownikach, a wszystkie otrzymane informacje są traktowane jako poufne. Jeśli chcesz nadal przesyłać nam statystyki, odznacz powyższe pole. Dziękujemy.","optional":"opcjonalne","Order":"Zamówienie","OS_Arch":"Architektura systemu","OS_Cpus":"Ilość procesorów","OS_Freemem":"Ilość wolnej pamięci","OS_Loadavg":"Średnie obciążenie systemu","OS_Platform":"Platforma systemu","OS_Release":"Wydanie systemu","OS_Totalmem":"Całkowita ilość pamięci systemu","OS_Type":"Typ systemu ","OS_Uptime":"Czas pracy systemu","others":"inni","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR jest dostępna tylko wtedy, gdy oba użytkowników online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Zastąp adres URL, do którego są przesyłane pliki. Ten url również wykorzystywane do pobrania, chyba że podano CDN","Password":"Hasło","Password_Change_Disabled":"Administrator czatu wyłączył możliwość zmiany haseł","Password_changed_successfully":"Hasło zostało zmienione","Payload":"ładowność","People":"Ludzie","Permissions":"Uprawnienia","Pin_Message":"Przypnij wiadomość","Pinned_a_message":"Przypięte wiadomość:","Pinned_Messages":"Przypięte wiadomości","Placeholder_for_email_or_username_login_field":"Zastępczy e-mail lub nazwa użytkownika logowania dziedzinie","Placeholder_for_password_login_field":"Zastępczym dla hasła polu logowania","Please_answer_survey":"Proszę poświęć chwilę, aby odpowiedzieć na krótką ankietę na temat tej rozmowy","Please_enter_value_for_url":"Wprowadź poprawny adres URL dla swojego awatara.","Please_enter_your_new_password_below":"Wpisz poniżej swoje hasło:","Please_fill_a_label":"Proszę wypełnić etykietę","Please_fill_a_name":"Proszę wypełnić nazwę","Please_fill_a_username":"Proszę wypełnić nazwę użytkownika","Please_fill_name_and_email":"Proszę wypełnić nazwisko i e-mail","Please_re_enter_your_password":"Wprowadź ponownie swoje hasło","Please_select_enabled_yes_or_no":"Proszę wybrać opcję Włączone","Please_wait":"Proszę czekaj","Please_wait_activation":"To może chwilę potrwać, proszę czekaj.","Please_wait_statistics":"Generuję statystyki, proszę czekaj.","Please_wait_while_OTR_is_being_established":"Poczekaj OTR jest ustanawiana","Please_wait_while_your_account_is_being_deleted":"Poczekaj konto jest usuwane ...","Please_wait_while_your_profile_is_being_saved":"Poczekaj Twój profil jest zapisywany ...","Post_as":"Opublikuj jako","Post_to_Channel":"Pisać do kanału","Post_to_s_as_s":"Post <strong>jako% <strong>s%</strong></strong> <strong>s</strong>","Powered_by":"Technologię dostarcza ","Preferences":"Preferencje","Preferences_saved":"Preferencje zapisane","Privacy":"Prywatność","Private_Group":"Grupa Prywatna","Private_Groups":"Prywatne grupy","Private_Groups_list":"Lista prywatnych grup","Profile":"Profil","Profile_saved_successfully":"Dane zostały zapisane","Proudly_developed":"Stworzone na platformie Meteor","Push":"Powiadomienia","Push_apn_cert":"Certyfikat APN","Push_apn_dev_cert":"Certyfikat Dev APN","Push_apn_dev_key":"Klucz Dev APN","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"Klucz APN","Push_apn_passphrase":"APN Passphrase","Push_debug":"Debugowanie","push_disabled":"Wciśnij niepełnosprawnych","Push_enable":"Włącz","Push_enable_gateway":"Włącz bramę","Push_gateway":"Brama","Push_gcm_api_key":"Klucz API GCM","Push_gcm_project_number":"Identyfikator projektu GCM","Push_production":"Serwer produkcyjny","Push_show_message":"Pokaż post w powiadomieniu","Push_show_username_room":"Pokaż kanał / grupa / nazwa_użytkownika w powiadomieniu","Push_test_push":"Test","Query":"Zapytanie","Query_description":"Dodatkowe warunki ustalania użytkowników, aby wysłać e-mail do. Bez subskrypcji użytkowników są automatycznie usuwane z zapytania. To musi być prawidłowy JSON. Przykład: \"{\" createdAt \": {\" $ gt \": {\" $ data \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Szybkie wyszukiwanie","quote":"cytat","Reactions":"reakcje","Recents":"Najnowsze","Record":"Nagrywaj","Redirect_URI":"Przekierowanie URI","Refresh_keys":"klucze Odśwież","Refresh_your_page_after_install_to_enable_screen_sharing":"Odśwież stronę po instalacji, aby umożliwić dzielenie ekranu","Register":"Zarejestruj nowe konto","Registration_Succeeded":"Rejestracja zakończona","Remember_me":"Zapamiętaj mnie","Remove":"Usuń","Remove_Admin":"Zabierz Admina","Remove_as_moderator":"Usuń jako moderator","Remove_as_owner":"Usuń jak właściciel","Remove_custom_oauth":"Usuń własne OAuth","Remove_from_room":"Usuń z pokoju","Remove_someone_from_room":"Usunąć kogoś z pokoju","Removed":"Usunięto","Require_password_change":"Wymagaj zmiany hasła","Resend_verification_email":"Ponownie wysłać e-mail weryfikacyjny","Reset":"Nastawić","Reset_password":"Zresetuj hasło","Restart":"Uruchom ponownie","Restart_the_server":"Uruchom serwer ponownie","RocketBot_Enabled":"Włącz RocketBot","RocketBot_Name":"Nazwa RocketBota","RocketBot_Name_Description":"Nazwa RocketBota musi być poprawną nazwą zarejestrowanego użytkownika.","Role":"Rola","Role_Editing":"Edycja ról","Role_removed":"Rola usunięta","Room":"Pokój","Room_archivation_state":"Stan","Room_archivation_state_false":"Aktywny","Room_archivation_state_true":"zarchiwizowane","Room_archived":"Pokój zarchiwizowany","room_changed_privacy":"<em>__user_by__</em> zmienił(a) rodzaj pokoju na: <em>__room_type__</em>","room_changed_topic":"<em>__user_by__</em> zmienił(a) temat pokoju na: <em>__room_topic__</em>","Room_has_been_deleted":"Pokój został usunięty","Room_Info":"Ustawienia pokoju","Room_name_changed":"Nazwa pokoju zmieniona na: <em>__room_name__</em>przez <em>__user_by__</em>","Room_name_changed_successfully":"Nazwa pokoju zmieniona","Room_not_found":"Nie odnaleziono pokoju","Room_topic_changed_successfully":"Temat pokoju został zmieniony","Room_type_changed_successfully":"Rodzaj pokoju pomyślnie zmieniony","Room_unarchived":"Pokój niezarchiwizowane","Room_uploaded_file_list":"Lista plików","Room_uploaded_file_list_empty":"Brak dostępnych plików","room_user_count":"%s użytkowników","Rooms":"Pokoje","S_new_messages_since_s":"%s nowych wiadomości od %s","SAML":"SAML","SAML_Custom_Cert":"Własny certyfikat","SAML_Custom_Entry_point":"Niestandardowy punkt wejścia","SAML_Custom_Generate_Username":"Generowanie nazwy użytkownika","SAML_Custom_Issuer":"Własny wydawca (issuer)","SAML_Custom_Provider":"Własny dostawca (provider)","Save":"Zapisz","Save_changes":"Zapisz zmiany","Save_Mobile_Bandwidth":"Oszczędzaj przepustowość","Save_to_enable_this_action":"Zapisz, aby włączyć tę akcję","Saved":"Zapisano","Saving":"Zapisywanie","Scope":"Zakres","Screen_Share":"Współdzielenie ekranu","Script_Enabled":"script Włączone","Search":"Szukaj","Search_by_username":"Szukaj według nazwy użytkownika","Search_Channels":"Szukaj kanały","Search_Direct_Messages":"Bezpośrednie wyszukiwanie wiadomości","Search_Messages":"Przeszukaj wiadomości","Search_Private_Groups":"Szukaj prywatnych grup","Search_settings":"Przeszukaj ustawienia","seconds":"sekund","See_all":"Zobacz wszystko","See_only_online":"Wyłącznie w trybie online","Select_a_department":"Wybierz dział","Select_an_avatar":"Wybierz awatar","Select_file":"Wybierz plik","Select_service_to_login":"Wybierz usługę, aby zalogować się, celem dodania zdjęcia lub prześlij je bezpośrednio z komputera","Select_user":"Wybierz użytkownika","Select_users":"Wybierz użytkowników","Selected_agents":"Wybrane czynniki","Selected_users":"Wybrani członkowie","Send":"Wyślij","Send_a_message":"Wyślij wiadomość","Send_a_test_mail_to_my_user":"Wyślij wiadomość testową do mojego użytkownik","Send_a_test_push_to_my_user":"Wyślij impuls testowy do mojego użytkownik","Send_confirmation_email":"Wyślij e-mail z potwierdzeniem","Send_data_into_RocketChat_in_realtime":"Wysyłanie danych do Rocket.Chat w czasie rzeczywistym.","Send_email":"Wyślij wiadomość","Send_invitation_email":"Wyślij email z zaproszeniem","Send_invitation_email_error":"Nie wprowadziłeś poprawnego adresu email.","Send_invitation_email_info":"Możesz wysłać kilka zaproszeń na raz.","Send_invitation_email_success":"Zaproszenia zostały wysłane na następujące adresy email:","Send_invitation_email_warning":"Aby wysłać zaproszenie, skonfiguruj najpierw ustawienia serwera SMTP.","Send_Message":"Wyślij wiadomość","Send_your_JSON_payloads_to_this_URL":"Wyślij swoje ładunki JSON do tego adresu URL.","Sending":"Wysyłanie...","Set_as_moderator":"Ustaw jako moderatora","Set_as_owner":"Ustaw jako właściciela","Settings":"Ustawienia","Settings_updated":"Ustawienia zapisane","Should_be_a_URL_of_an_image":"Powinien być adres URL obrazu.","Should_exists_a_user_with_this_username":"Użytkownik musi już istnieć.","Show_all":"Pokaż wszystko","Show_more":"Pokaż więcej","Show_only_online":"Pokaż wyłącznie w trybie online","Show_preregistration_form":"Pokaż formularz rejestracji wstępnej","Showing_archived_results":"<p> <b>Pokazuje %s</b> zarchiwizowanych wyników </p>","Showing_online_users":"Widocznych <b>__total_showing__</b> z __total__users","Showing_results":"<p>Wyświetlono <b>%s</b> wyników</p>","Silence":"Cisza","since_creation":"od %s","Site_Name":"Nazwa strony","Site_Url":"Adres strony","Site_Url_Description":"Przykład: https://chat.domain.com/","Skip":"Pomiń","Smileys_and_People":"Buźki & Ludzie","SMTP":"SMTP","SMTP_Host":"Nazwa hosta SMTP","SMTP_Password":"Hasło SMTP","SMTP_Port":"Port SMTP","SMTP_Test_Button":"Ustawienia SMTP test","SMTP_Username":"Nazwa użytkownika SMTP","Sound":"Dźwięk","Star_Message":"Oznacz wiadomość","Starred_Messages":"Ulubione wiadomości","Start_audio_call":"Zacznij rozmowę dźwięku","Start_Chat":"Rozpocznij czat","Start_of_conversation":"Rozpocznij rozmowę","Start_OTR":"Rozpocznij OTR","Start_video_call":"Rozpocznij połączenie wideo","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Start z <code class=\"inline\">%s</code> do użytkownika lub <code class=\"inline\">%s</code> dla kanału. Np: <code class=\"inline\">%s</code> lub <code class=\"inline\">%s</code>","Statistics":"Statystyki","Stats_Active_Users":"Aktywni użytkownicy","Stats_Avg_Channel_Users":"Średnio użytkowników w kanałach","Stats_Avg_Private_Group_Users":"Średnio użytkowników w grupach","Stats_Away_Users":"Nieobecni użytkownicy","Stats_Max_Room_Users":"Maksymalnie użytkowników w kanałach","Stats_Non_Active_Users":"Nieaktywni użytkownicy","Stats_Offline_Users":"Niepodłączeni użytkownicy","Stats_Online_Users":"Podłączeni użytkownicy","Stats_Total_Channels":"Liczba kanałów","Stats_Total_Direct_Messages":"Liczba sesji prywatnych","Stats_Total_Messages":"Liczba wiadomości","Stats_Total_Private_Groups":"Liczba grup prywatnych","Stats_Total_Rooms":"Liczba wszystkich pokoi","Stats_Total_Users":"Liczba użytkowników","Stop_Recording":"Zatrzymaj nagrywanie","strike":"przekreślenie","Subject":"Przedmiot","Submit":"Prześlij","Success":"Sukces","Survey":"Ankieta","Survey_instructions":"Oceń każde pytanie zgodnie z zadowolenia, 1 co oznacza, że ​​są całkowicie niedosyt i 5 co oznacza, że ​​są w pełni zadowoleni.","Symbols":"Symbolika","Sync_success":"Synchronizacja sukces","Sync_Users":"Użytkownicy Sync","Test_Connection":"Test połączenia","Test_Desktop_Notifications":"Badane pulpitu Powiadomienia","Thank_you_for_your_feedback":"Dziękujemy za twoją opinię","The_application_name_is_required":"Wymagana jest nazwa aplikacji","The_channel_name_is_required":"Wymagana jest nazwa kanału","The_emails_are_being_sent":"Wiadomości e-mail są wysyłane.","The_field_is_required":"Pole %s jest wymagane.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Zmiany rozmiaru obrazu nie będzie działać, ponieważ nie możemy wykryć ImageMagick lub GraphicsMagick zainstalowany na serwerze.","The_redirectUri_is_required":"RedirectUri jest wymagane","The_server_will_restart_in_s_seconds":"Serwer zostanie ponownie uruchomiony za %s sekund","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Ustawienie %s</strong> jest skonfigurowany <strong>do %s</strong> i łączysz się <strong>z %s!</strong>","The_user_will_be_removed_from_s":"Użytkownik zostanie usunięty z %s","The_user_wont_be_able_to_type_in_s":"Użytkownik nie będzie mógł wpisać w %s","Theme":"Motyw","theme-color-action-buttons-color":"Operacje Przyciski Kolor","theme-color-active-channel-background-color":"Aktywny kanał koloru tła","theme-color-active-channel-font-color":"Aktywny kanał koloru czcionki","theme-color-blockquote-background":"Kolor tła bloku cytatu","theme-color-clean-buttons-color":"Czyste Przyciski Kolor","theme-color-code-background":"Kolor tła bloku kodu","theme-color-code-border":"Kolor ramki bloku kodu","theme-color-code-color":"Kolor czcionki bloku kodu","theme-color-content-background-color":"Kolor tła zawartości","theme-color-custom-scrollbar-color":"Niestandardowe Scrollbar Kolor","theme-color-info-active-font-color":"Kolor czcionki aktywnej informacji","theme-color-info-font-color":"Kolor czcionki informacji","theme-color-input-font-color":"Kolor czcionki w polach tekstowych","theme-color-link-font-color":"Kolor czcionki odnośników","theme-color-message-hover-background-color":"Wiadomość Hover BG Kolor","theme-color-primary-background-color":"Podstawowy kolor tła","theme-color-primary-font-color":"Podstawowy kolor czcionki","theme-color-quaternary-font-color":"Czwartorzędu Kolor czcionki","theme-color-secondary-background-color":"Dodatkowy kolor tła","theme-color-secondary-font-color":"Dodatkowy kolor czcionki","theme-color-smallprint-font-color":"Kolor czcionki drobnego druku","theme-color-smallprint-hover-color":"Kolor aktywny drobnego druku","theme-color-status-away":"Kolor statusu Zaraz wracam","theme-color-status-busy":"Kolor statusu Zajęty","theme-color-status-offline":"Kolor statusu Niedostępny","theme-color-status-online":"Kolor statusu Online","theme-color-tertiary-background-color":"Trzeciorzędny kolor tła","theme-color-tertiary-font-color":"Trzeciorzędny kolor czcionki","theme-color-unread-notification-color":"Nieczytany Powiadomienia Kolor","theme-custom-css":"niestandardowe CSS","There_are_no_agents_added_to_this_department_yet":"Brak środki dodawane do tego działu jeszcze.","There_are_no_integrations":"Brak integracje","There_are_no_users_in_this_role":"Ta rola nie ma przypisanych użytkowników.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ten e-mail został już użyty i nie został zweryfikowany. Proszę zmienić swoje hasło.","This_is_a_desktop_notification":"To jest powiadomienie pulpit","This_is_a_push_test_messsage":"Jest to messsage Test Push","Time_in_seconds":"Czas w sekundach","Title_bar_color":"Tytuł pasek koloru","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Aby zainstalować Rocket.Chat LiveChat na swojej stronie, skopiuj i wklej ten kod powyżej ostatniego <strong></ body></strong> na swojej stronie.","To_users":"dla użytkowników","Topic":"Temat","Travel_and_Places":"Podróże & Miejsca","Trigger_removed":"Wyzwalanie usunięte","Trigger_Words":"Słowa spustowe","Triggers":"Wyzwalacze","True":"Tak","Type":"Rodzaj","Type_your_new_password":"Wprowadź nowe hasło","Unarchive":"Zdezarchiwizuj","Unmute_someone_in_room":"Włącz mikrofon ktoś w pokoju","Unmute_user":"Włącz mikrofon użytkownika","Unnamed":"Anonimowy","Unpin_Message":"Odepnij wiadomość","Unread_Rooms":"Nieprzeczytane pokoje","Unread_Rooms_Mode":"Tryb nieprzeczytanych pokoi","Unstar_Message":"Usuń oznaczenie","Upload_file_question":"Przesłać plik?","Uploading_file":"Przesyłanie pliku ...","Use_account_preference":"Użyj preferencje konta","Use_Emojis":"Użyj Emoji","Use_initials_avatar":"Użyj inicjałów","use_menu":"Otwórz menu boczne by uzyskać dostęp do twoich pokoi i rozmów","Use_service_avatar":"Użyj avatar z %s","Use_this_username":"Użyj tej nazwy użytkownika","Use_uploaded_avatar":"Użyj dodany awatar","Use_url_for_avatar":"Użyj adresu URL","User__username__is_now_a_moderator_of__room_name_":"__username__ Użytkownik jest teraz moderatorem __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ Użytkownik jest teraz właścicielem __room_name__","User__username__removed_from__room_name__moderators":"__username__ Użytkownik usunięty z moderatorów __room_name__","User__username__removed_from__room_name__owners":"__username__ Użytkownik usunięty przez właściciela __room_name__","User_added":"Użytkownik <em>__user_added__</em> dodany.","User_added_by":"Użytkownik <em>__user_added__</em>dodany przez <em>__user_by__</em>.","User_added_successfully":"Użytkownik został dodany","User_Channels":"Kanały użytkowników","User_doesnt_exist":"Nie istnieje użytkownik o nazwie `@%s`.","User_has_been_activated":"Użytkownik został aktywowany","User_has_been_deactivated":"Użytkownik został deaktywowany","User_has_been_deleted":"Użytkownik został usunięty","User_has_been_muted_in_s":"Użytkownik został wyciszony w %s","User_has_been_removed_from_s":"Użytkownik został usunięty z %s","User_has_disconnected":"Użytkownik rozłączył","User_Info":"Informacje o użytkowniku","User_is_no_longer_an_admin":"Użytkownik nie jest już adminem","User_is_not_activated":"Użytkownik nie jest aktywny","User_is_now_an_admin":"Użytkownik jest teraz adminem","User_joined_channel":"Dołączył do kanału","User_joined_channel_female":"Dołączyła do kanału","User_joined_channel_male":"Dołączył do kanału","User_left":"Użytkownik <em>__user_left__</em> wyszedł.","User_left_female":"Użytkowniczka <em>__user_left__</em> wyszła.","User_left_male":"Użytkownik <em>__user_left__</em> wyszedł.","User_logged_out":"Użytkownik jest wylogowany","User_management":"Zarządzanie użytkownikami","User_muted_by":"<em>__user_muted__</em> Użytkownika wyciszone <em>__user_by__.</em>","User_muted_in_room":"Użytkownik wyciszony w pokoju","User_not_found":"Użytkownik nie znaleziony","User_not_found_or_incorrect_password":"Nie znaleziono użytkownika lub nieprawidłowe hasło","User_or_channel_name":"Użytkownik lub kanał nazwę","User_removed":"Użytkownik usunięty","User_removed_by":"Użytkownik <em>__user_removed__</em> został usunięty przez <em>__user_by__</em>.","User_removed_from_room":"Użytkownik został usunięty z pomieszczenia","User_Settings":"Ustawienia użytkownika","User_unmuted_by":"<em>__user_unmuted__</em> Użytkownik wyłączył wyciszenie przez <em>__user_by__.</em>","User_unmuted_in_room":"Użytkownik wyciszone w pokoju","User_updated_successfully":"Zaktualizowano dane użytkownika","Username":"Nazwa użytkownika","Username_and_message_must_not_be_empty":"Nazwa użytkownika i wiadomości nie może być pusta.","Username_cant_be_empty":"Nazwa użytkownika nie może być pusta","Username_Change_Disabled":"Administrator czatu nie zezwolił na zmianę nazw użytkownika","Username_denied_the_OTR_session":"__username__ zaprzeczył sesję OTR","Username_description":"Nazwa użytkownika jest używana, by inni mogli Cię wspomnieć w swoich wiadomościach.","Username_doesnt_exist":"Nazwa użytkownika ` %s` nie istnieje.","Username_ended_the_OTR_session":"__username__ zakończył sesję OTR","Username_invalid":"<strong>%s</strong> nie jest prawidłową nazwą użytkownika, <br / >użyj jedynie liter, cyfr, kropek i kresek","Username_is_already_in_here":"`@%s` już tutaj jest.","Username_is_not_in_this_room":"Użytkownik `# %s` nie jest w tym pokoju.","Username_not_found":"Użytkownik nie został znaleziony","Username_title":"Utwórz nazwę użytkownika","Username_unavaliable":"Nazwa <strong>%s</strong> jest zajęta :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ chce rozpocząć OTR. Czy chcesz zaakceptować?","Users":"Użytkownicy","Users_in_role":"Użytkownicy w roli","UTF8_Names_Slugify":"Nazwy UTF8 Slugify","UTF8_Names_Validation":"Nazwy UTF8 Validation","UTF8_Names_Validation_Description":"Nie dopuścić znaków specjalnych i spacji. Można użyć - _ i. ale nie na końcu opisu","Verification_email_sent":"e-mail weryfikacyjny został wysłany","View_All":"Pokaż wszystko","View_Logs":"Zobacz rejestry","Visibility":"Widoczność","Visible":"Widoczny","Visitor":"Gość","Visitor_page_URL":"Strona Visitor URL","Visitor_time_on_site":"Czas gościem na stronie","Wait_activation_warning":"Zanim się zalogujesz, twoje konto musi być aktywowane przez administratora.","We_are_offline_Sorry_for_the_inconvenience":"Jesteśmy offline. Przepraszam za niedogodności.","We_have_sent_password_email":"Wysłaliśmy Ci e-mail z instrukcjami resetowania hasła. Jeśli nie dostaniesz wiadomości, prosimy spróbować ponownie.","We_have_sent_registration_email":"Wysłaliśmy e-mail w celu potwierdzenie Twojej rejestracji. Jeśli nie dostaniesz wiadomości, prosimy spróbować ponownie.","WebRTC_Enable_Channel":"Włącz dla kanałów publicznych","WebRTC_Enable_Direct":"Włącz dla prywatnych wiadomości","WebRTC_Enable_Private":"Włącz dla grup prywatnych","WebRTC_Servers":"Serwery STUN / TURN","WebRTC_Servers_Description":"Lista serwerów STUN i skręcić oddzielonych przecinkami. <br/> Nazwa użytkownika, hasło i port są dozwolone w formacie `nazwa_użytkownika: hasło @ ogłuszenie: host: port morski lub` nazwa_użytkownika: hasło @ kolej: host: port morski.","Welcome":"Witamy <em>%s</em>.","Welcome_to_the":"Witaj w","will_be_able_to":"będzie zdolny do","With_whom":"Z kim","Yes":"Tak","Yes_clear_all":"Tak, wyczyść!","Yes_delete_it":"Tak, usuń to!","Yes_hide_it":"Tak, ukryć!","Yes_leave_it":"Tak, zostaw go!","Yes_mute_user":"Tak, wyciszenie użytkownika!","Yes_remove_user":"Tak, usuń użytkownika!","you_are_in_preview_mode_of":"Jesteś w trybie podglądu kanału # <strong>__room_name__</strong>","You_are_logged_in_as":"Jesteś zalogowany jako","You_are_not_authorized_to_view_this_page":"Nie masz uprawnień, aby zobaczyć tę stronę.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Jesteś ostatnim właścicielem. Proszę ustawić nowego właściciela przed opuszczeniem pokoju.","You_can_change_a_different_avatar_too":"Można zastąpić awatar używany do wysyłania z tej integracji.","You_can_use_an_emoji_as_avatar":"Można również używać emotikony jako awatar.","You_have_been_muted":"Zostałaś wyciszony i nie można mówić w tym pokoju","You_have_not_verified_your_email":"Nie sprawdzili swój email.","You_have_successfully_unsubscribed":"Twój email został usunięty z naszej listy powiadomień.","You_informed_an_invalid_FROM_address":"Adres nadawcy jest nieprawidłowy","You_must_provide_the_unsubscribe_link":"Musisz wstawić w treści znacznik [unsubscribe].","You_need_confirm_email":"Aby się zalogować musisz potwierdzić swój adres e-mail!","You_need_install_an_extension_to_allow_screen_sharing":"Musisz zainstalować rozszerzenie, aby umożliwić dzielenie ekranu","You_need_to_change_your_password":"Musisz zmienić swoje hasło","You_need_to_type_in_your_password_in_order_to_do_this":"Musisz wpisać swoje hasło, aby to zrobić!","You_need_to_type_in_your_username_in_order_to_do_this":"Należy wpisać nazwę użytkownika, aby to zrobić!","You_need_to_verifiy_your_email_address_to_get_notications":"Trzeba sprawdzenia zgodności swój adres e-mail aby otrzymywać powiadomienia","You_should_name_it_to_easily_manage_your_integrations":"Należy wymienić go na łatwe zarządzanie integracji.","You_will_not_be_able_to_recover":"Nie będziesz w stanie odzyskać tej wiadomości!","You_will_not_be_able_to_recover_file":"Nie będzie w stanie odzyskać ten plik!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Nie będziesz otrzymywać powiadomienia e-mail, ponieważ nie sprawdzili swój email.","Your_email_has_been_queued_for_sending":"Twój e-mail został w kolejce do wysyłania","Your_entry_has_been_deleted":"Twój wpis został usunięty.","Your_file_has_been_deleted":"Twój plik został usunięty.","Your_mail_was_sent_to_s":"Twoja wiadomość została wysłana do użytkownika %s","Your_Open_Source_solution":"Twój własny czat Open Source","Your_password_is_wrong":"Twoje hasło jest błędne!","Your_push_was_sent_to_s_devices":"Twój Push została wysłana do urządzeń %s"});
TAPi18n._registerServerTranslator("pl", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/pt.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["pt"] = ["Portuguese (Portugal)","Português"];                                                 // 8
if(_.isUndefined(TAPi18n.translations["pt"])) {                                                                        // 9
  TAPi18n.translations["pt"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["pt"][namespace])) {                                                             // 13
  TAPi18n.translations["pt"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["pt"][namespace], {"500":"Erro Interno do Servidor","0_Errors_Only":"0 - Apenas erros","1_Errors_and_Information":"1 - Erros e Informações","2_Erros_Information_and_Debug":"2 - Erros, Informação e Debug","__username__was_set__role__by__user_by_":"__username__ foi definido como __role__ por __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ não é mais __role__, por __user_by__","Access_not_authorized":"Acesso não autorizado","Access_online_demo":"Acesse o demo online","Access_Online_Demo":"Acesse o Demo Online","Access_Token_URL":"URL do Token de Acesso","Accounts":"Contas","Accounts_AllowDeleteOwnAccount":"Permitir que usuários apaguem a própria conta","Accounts_AllowedDomainsList":"Lista de domínios permitidos","Accounts_AllowedDomainsList_Description":"Lista de domínios permitidos, separados por vírgula","Accounts_AllowEmailChange":"Permitir Alterar E-mail","Accounts_AllowPasswordChange":"Permitir Alteração de Senha","Accounts_AllowUserAvatarChange":"Permitir que o usuário troque o avatar","Accounts_AllowUsernameChange":"Permitir alterar nome de usuário","Accounts_AllowUserProfileChange":"Permitir que o usuário altere o perfil","Accounts_AvatarResize":"Redimensionar Avatares","Accounts_AvatarSize":"Tamanho do Avatar","Accounts_AvatarStorePath":"Caminho para armazenar Avatares","Accounts_AvatarStoreType":"Tipo de armazenamento de Avatares","Accounts_BlockedDomainsList":"Lista de Domínios Bloqueados","Accounts_BlockedDomainsList_Description":"Lista de domínios bloqueados, separados por vírgulas ","Accounts_denyUnverifiedEmail":"Proibir e-mail não verificado","Accounts_EmailVerification":"Verificação de E-mail","Accounts_EmailVerification_Description":"Certifique-se de que as configurações de SMTP estão corretas para usar este recurso","Accounts_Enrollment_Email":"E-mail de inscrição","Accounts_Enrollment_Email_Description":"Você pode usar [name], [fname], [lname] para o nome completo, primeiro nome ou último nome do usuário, respectivamente.<br />Você pode usar [email] para o email do usuário.","Accounts_Iframe_api_method":"Método Api","Accounts_Iframe_api_url":"Url Api","Accounts_iframe_enabled":"Habilitado","Accounts_iframe_url":"Url do Iframe","Accounts_LoginExpiration":"Validade do Login em Dias","Accounts_ManuallyApproveNewUsers":"Aprovar manualmente novos usuários","Accounts_OAuth_Custom_Token_Sent_Via":"Token Enviado Por","Accounts_OAuth_Custom_Authorize_Path":"Authorize Path","Accounts_OAuth_Custom_Button_Color":"Cor do botão","Accounts_OAuth_Custom_Button_Label_Color":"Cor do texto do botão","Accounts_OAuth_Custom_Button_Label_Text":"Texto do botão","Accounts_OAuth_Custom_Enable":"Enable","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"Identity Path","Accounts_OAuth_Custom_Login_Style":"Estilo de Login","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Login do Facebook","Accounts_OAuth_Facebook_callback_url":"URL de Callback do Facebook","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"Login do GitHub","Accounts_OAuth_Github_callback_url":"URL de Callback do Github","Accounts_OAuth_GitHub_Enterprise":"OAuth Ativado","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL de Callback do GitHub Enterprise","Accounts_OAuth_GitHub_Enterprise_id":"GitHub Id","Accounts_OAuth_GitHub_Enterprise_secret":"Segredo","Accounts_OAuth_Github_id":"GitHub Id","Accounts_OAuth_Github_secret":"GitHub Secret","Accounts_OAuth_Gitlab":"OAuth Ativado","Accounts_OAuth_Gitlab_callback_url":"URL de Callback do GitLab","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Segredo","Accounts_OAuth_Google":"Login do Google","Accounts_OAuth_Google_callback_url":"URL de Callback do Google","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"Login do LinkedIn","Accounts_OAuth_Linkedin_callback_url":"URL de Callback do Linkedin","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Login do Meteor","Accounts_OAuth_Meteor_callback_url":"URL de Callback do Meteor","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Login do Twitter","Accounts_OAuth_Twitter_callback_url":"URL de Callback do Twitter","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"Login WordPress","Accounts_OAuth_Wordpress_callback_url":"URL de Callback do Wordpress","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Resetar senha","Accounts_Registration_AuthenticationServices_Enabled":"Registro com os Serviços de Autenticação","Accounts_RegistrationForm":"Formulário de Registro","Accounts_RegistrationForm_Disabled":"Desativado","Accounts_RegistrationForm_LinkReplacementText":"Text de Substituição do Link do Formulário de Registro","Accounts_RegistrationForm_Public":"Público","Accounts_RegistrationForm_Secret_URL":"URL Secreta","Accounts_RegistrationForm_SecretURL":"URL Secreta para o Formulário de Registro","Accounts_RegistrationForm_SecretURL_Description":"Você deve fornecer uma seqüência aleatória que será adicionada à sua URL de registro. Exemplo: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Registro Obrigatório","Accounts_RequireNameForSignUp":"Nome é obrigatório para cadastro","Accounts_ShowFormLogin":"Mostrar formulário de login","Accounts_UseDefaultBlockedDomainsList":"Use Lista Padrão de Domínios Bloqueados","Accounts_UseDNSDomainCheck":"Use verificação de Domínio DNS","Activate":"Ativar","Activity":"Atividade","Add":"Adicionar","Add_agent":"Adicionar agente","Add_custom_oauth":"Adicionar oauth customizado","Add_manager":"Adicionar gerente","Add_Members":"Adicionar membros","Add_User":"Adicionar Usuário","Add_user":"Adicionar usuário","Add_users":"Adicionar usuários","Additional_emails":"E-mails adicionais","Additional_Feedback":"Comentários Adicionais","Administration":"Administração","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Após a autenticação OAuth2, os usuários serão redirecionados para esta URL","Agent_added":"Agente adicionado","Agent_removed":"Agente removido","Alias":"Alias","All":"Todos","All_channels":"Todos os canais","All_logs":"Todos os logs","All_messages":"Todas as mensagens","Allow_Invalid_SelfSigned_Certs":"Permitir certificados inválidos e auto-assinados para validação de links e previews","Allow_Invalid_SelfSigned_Certs_Description":"Permitir certificado SSL inválidos e auto-assinados para validação de link e previews.","and":"e","And_more":"E mais __length __...","Animals_and_Nature":"Animais e Natureza","API":"API","API_Analytics":"Analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Desabilitar embed para os usuários","API_EmbedDisabledFor_Description":"Lista de nomes de usuário separados por vírgula","API_GitHub_Enterprise_URL":"URL do servidor","API_GitHub_Enterprise_URL_Description":"Nota: excluir barra final","API_Gitlab_URL":"URL do GitLab","API_Wordpress_URL":"URL do WordPress","Appearance":"Aparência","Application_added":"Aplicativo adicionado","Application_Name":"Nome da Aplicação","Application_updated":"Aplicativo atualizado","Apply_and_refresh_all_clients":"Aplicar e atualizar todos os clientes","Archive":"Arquivar","Archive_Unarchive":"Arquivar / Desarquivar","are_also_typing":"também estão digitando","are_typing":"estão digitando","Are_you_sure":"Você tem certeza?","Are_you_sure_you_want_to_delete_your_account":"Tem certeza de que deseja excluir a sua conta?","Authorization_URL":"URL de Autorização","Authorize":"Autorizar","AutoLinker_StripPrefix":"Remover Prefixo","AutoLinker_StripPrefix_Description":"Exibição curta. Por exemplo https://rocket.chat => rocket.chat","AutoLinker_Urls":"Aplicar em URLs","AutoLinker_UrlsRegExp":"Expressão Regular para URL","AutoLinker_Email":"Aplicar para Email","AutoLinker_Phone":"Aplicar para Telefone","AutoLinker_Phone_Description":"Links automáticos para para números de telefone. Por exemplo, `(123) 456-7890`","Auto_Load_Images":"Auto Carregar Imagens","Available":"Disponível","Available_agents":"Agentes disponíveis","Avatar":"Avatar","Avatar_changed_successfully":"Avatar alterado com sucesso","Avatar_URL":"URL do Avatar","Avatar_url_invalid_or_error":"A URL fornecida é inválida ou não acessível. Por favor tente novamente, mas com uma url diferente.","away":"ausente","Away":"Ausente","away_female":"ausente","Away_female":"Ausente","away_male":"ausente","Away_male":"ausente","Back":"Voltar","Back_to_applications":"Voltar para aplicações","Back_to_integrations":"Voltar para integrações","Back_to_login":"Voltar para o login","Back_to_permissions":"Voltar para permissões","Body":"Corpo","bold":"negrito","busy":"ocupado","Busy":"Ocupado","busy_female":"ocupado","Busy_female":"Ocupado","busy_male":"ocupado","Busy_male":"Ocupado","Cancel":"Cancelar","Cannot_delete_a_protected_role":"Não é possível remover um papel protegido","Cannot_delete_role_because_its_in_use":"Não é possível remover o papel pois ele está em uso","Cannot_invite_users_to_direct_rooms":"Não é possível convidar pessoas para salas diretas","CDN_PREFIX":"Prefixo CDN","Certificates_and_Keys":"Certificados e Chaves","Channel":"Canal","Channel_doesnt_exist":"O canal `#%s` não existe.","Channels":"Canais","Channels_list":"Lista de canais públicos","Chat_Rooms":"Salas de Chat","Chatops_Enabled":"Ativar Chatops","Chatops_Title":"Painel Chatops","Chatops_Username":"Ops do chat","Choose_a_room":"Escolha uma sala","Choose_messages":"Escolha mensagens","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Escolha o alias que aparecerá antes do nome de usuário nas mensagens.","Choose_the_username_that_this_integration_will_post_as":"Escolha o nome do usuário que esta integração utilizará.","Clear_all_unreads_question":"Limpar todas não lidas?","Client_ID":"ID do Cliente","Client_Secret":"Segredo do Cliente","Clients_will_refresh_in_a_few_seconds":"Os clientes irão atualizar em poucos segundos","close":"fechar","Closed":"Fechado","Collapse_Embedded_Media_By_Default":"Esconder mídia por padrão","coming_soon":"em breve","Commands":"Comandos","Compact_View":"Visão Compacta","Confirm_password":"Confirmar a senha","Contact":"Contato","Conversation":"Conversa","Convert_Ascii_Emojis":"Converter ASCII para Emoji","Copied":"Copiado","COPY_TO_CLIPBOARD":"COPIAR PARA ÁREA DE TRANSFERÊNCIA","Copy_to_clipboard":"Copiar para área de transferência","Count":"Total","Create":"Criar","Create_new":"Criar um novo","Created_at":"Data criação","Created_at_s_by_s":"Criado em <strong>%s</strong> por <strong>%s</strong>","Custom_Fields":"Campos Personalizados","Custom_oauth_helper":"Ao configurar o seu Provedor de OAuth, você terá que informar uma URL de retorno de chamada. Use <pre>%s</pre>.","Custom_oauth_unique_name":"Nome exclusivo para oauth customizado","Custom_Script_Logged_In":"Script Personalizado para usuários logados","Custom_Script_Logged_Out":"Script Personalizado para usuários não logados","Dashboard":"Dashboard","days":"dias","Deactivate":"Desativar","Debug_Level":"Nível de Depuração","Default":"Padrão","Delete":"Deletar","Delete_my_account":"Excluir minha conta","Delete_Room_Warning":"A exclusão de uma sala irá apagar todas as mensagens postadas na sala. Isso não pode ser desfeito.","Delete_User_Warning":"Excluir um usuário irá apagar todas as mensagens desse usuário também. Isso não poderá ser desfeito.","Deleted":"Deletado!","Department_not_found":"Departamento não encontrado","Department_removed":"Departamento removido","Departments":"Departamentos","Description":"Descrição","Desktop":"Área de Trabalho","Desktop_Notification_Test":"Teste de Notificação de Desktop","Desktop_Notifications":"Notificações Desktop","Desktop_Notifications_Disabled":"Notificações Desktop estão Desativadas. Mude as preferências do seu navegador se quiser habilitar as notificações.","Desktop_Notifications_Enabled":"Notificações Desktop estão Habilitadas","Direct_message_someone":"Enviar mensagem direta para alguém","Direct_Messages":"Mensagens Diretas","Direct_Messages_list":"Mensagens Diretas","Disable_Favorite_Rooms":"Desabilitar Favoritos","Disable_New_Message_Notification":"Desativar notificações de nova mensagem","Disable_New_Room_Notification":"Desativar notificações de nova sala","Displays_action_text":"Exibe texto da ação","Do_you_want_to_change_to_s_question":"Você quer mudar para <strong>%s</strong>?","Drop_to_upload_file":"Largue para enviar arquivos","Dry_run":"Simulação","Dry_run_description":"Enviará apenas um e-mail, para o mesmo endereço definido em 'De'. O e-mail deve pertencer a um usuário válido.","Duplicate_archived_channel_name":"Já existe um canal, arquivado, com o nome '%s'","Duplicate_archived_private_group_name":"Já existe um Grupo Privado, arquivado, com o nome '%s'","Duplicate_private_group_name":"Já existe um Grupo Privado com nome '%s'","E-mail":"E-mail","Edit":"Editar","Edit_Custom_Field":"Editar Campo Personalizado","Edit_Department":"Editar Departamento","edited":"editado","Email":"Email","Email_already_exists":"Email já cadastrado","Email_body":"Corpo do E-mail","Email_Change_Disabled":"O administrador do Rocket.Chat desativou a mudança de e-mail","Email_from":"De","Email_Notification_Mode":"Notificações de E-mail Offline","Email_Notification_Mode_All":"Cada Menção / Mensagem Direta","Email_Notification_Mode_Disabled":"Desativado","Email_or_username":"Email ou nome de usuário","Email_subject":"Assunto","Email_verified":"Email verificado","Emoji":"Emoji","Empty_title":"Título vazio","Enable":"Habilitar","Enable_Desktop_Notifications":"Habilitar Notificações Desktop","Enabled":"Ativado","Encrypted_message":"Mensagem criptografada","End_OTR":"Finalizar OTR","Enter_a_regex":"Introduza um regex","Enter_a_room_name":"Digite um nome de sala","Enter_a_username":"Nome de usuário","Enter_info":"Entre com seus dados de login","Enter_name_here":"Insira o nome aqui","Enter_to":"Enter para","Error":"Erro","error-cant-invite-for-direct-room":"Não é possível convidar usuários para salas diretas","error-duplicate-channel-name":"Já existe um Canal com nome '%s'","error-invalid-custom-field":"Campo personalizado inválido","error-invalid-custom-field-name":"Nome inválido para o campo personalizado. Use apenas letras, números, hífens e underscores.","error-invalid-password":"Senha inválida","error-invalid-room":"Sala inválida","error-invalid-room-name":"<strong> %s</strong> não é um nome de sala válido, <br/> utilizar apenas letras, números, hífens e underscores","error-invalid-user":"Usuário inválido","error-invalid-username":"Nome de usuário Inválido","error-not-allowed":"Não permitido","error-not-authorized":"Não autorizado","error-remove-last-owner":"Este é o último proprietário. Por favor, defina um novo proprietário antes de remover este.","error-role-name-required":"Nome do papel é obrigatório","error-user-not-in-room":"O usuário não está nesta sala","Error_changing_password":"Erro ao alterar senha","Error_sending_confirmation_email":"Erro ao enviar e-mail de confirmação","Error_too_many_requests":"Erro, foram realizadas muitas solicitações. Por favor, diminua a velocidade. Você deve esperar %s segundos antes de tentar novamente","Esc_to":"Esc para","Example_s":"Exemplo: <code class=\"inline\">%s</code>","False":"Não","Favorites":"Favoritos","Field":"Campo","Field_removed":"Campo removido","File_exceeds_allowed_size_of_bytes":"O arquivo excede o tamanho permitido de __size__ bytes","FileUpload":"Upload de Arquivos","FileUpload_Enabled":"Habilitar upload de arquivos","FileUpload_File_Empty":"Arquivo vazio","FileUpload_FileSystemPath":"Caminho do Sistema","FileUpload_MaxFileSize":"Tamanho máximo dos arquivos (em bytes)","FileUpload_MediaType_NotAccepted":"Tipos de Arquivos Não Aceitos","FileUpload_MediaTypeWhiteList":"Lista de tipos de mídia","FileUpload_MediaTypeWhiteListDescription":"Tipos separados por vírgula. Deixe em branco para aceitar todos os tipos de arquivo.","FileUpload_ProtectFiles":"Proteger arquivos enviados","FileUpload_ProtectFilesDescription":"Somente usuários autenticados terão acesso","FileUpload_S3_Acl":"Amazon S3 ACL ","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Nome do bucket do Amazon S3","FileUpload_S3_BucketURL":"URL do Bucket","FileUpload_S3_CDN":"Domínio CDN para downloads","FileUpload_S3_Region":"Região","FileUpload_Storage_Type":"Tipo de Armazenamento","Flags":"Bandeiras","Follow_social_profiles":"Siga-nos nas redes sociais, faça fork no github e compartilhe suas ideias sobre o app rocket.chat em nosso trello.","Food_and_Drink":"Comida & Bebida","For_your_security_you_must_re_enter_your_password_to_continue":"Para sua segurança, você deve re-digitar sua senha para continuar","Force_SSL":"Forçar SSL","Force_SSL_Description":"*Cuidado!* _Forçar SSL_ nunca deve ser usado com proxy reverso. Se você tem um proxy reverso, você deve fazer o redirecionamento LÁ. Esta opção existe para implantações como Heroku, que não permite a configuração de redirecionamento de proxy reverso.","Forgot_password":"Esqueceu sua senha","Fork_it_on_github":"Fork it on github","Frequently_Used":"Usados frequentemente","From":"De","From_Email":"Email De","From_email_is_required":"'De' é obrigatório","From_email_warning":"<b>Aviso</b>: O campo <b>De</b> está sujeito às configurações do seu servidor de emails.","General":"Geral","Get_to_know_the_team":"Conheça o Rocket.Team","github_no_public_email":"Você não possui um e-mail público em sua conta do GitHub","Give_a_unique_name_for_the_custom_oauth":"Dê um nome exclusivo para o oauth customizado","Give_the_application_a_name_This_will_be_seen_by_your_users":"Dê um nome à aplicação. Isso será visto por seus usuários.","Global":"Global","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Há mais","Have_your_own_chat":"Tenha seu próprio web chat. Desenvolvido com Meteor.com, o Rocket.Chat é uma excelente solução para desenvolvedores que querem construir e desenvolver sua própria plataforma de chat.","Header":"Cabeçalho","Hidden":"Escondido","Hide_Group_Warning":"Tem certeza de que deseja ocultar o grupo \"%s\"?","Hide_Private_Warning":"Tem certeza de que deseja ocultar a discussão com \"%s\"?","Hide_room":"Esconder sala","Hide_Room_Warning":"Tem certeza de que deseja ocultar a sala \"%s\"?","Highlights":"Destaques","Highlights_How_To":"Para ser notificado quando alguém menciona uma palavra ou frase, adicione-as aqui. Você pode separar palavras ou frases com vírgulas. Não há diferenciação de maiúsculas e minúsculas ao destacar palavras.","Highlights_List":"Destacar palavras","History":"Histórico","hours":"horas","How_friendly_was_the_chat_agent":"Quão amigável foi o agente de bate-papo?","How_knowledgeable_was_the_chat_agent":"O agente bate-papo possuía conhecimentos suficientes?","How_responsive_was_the_chat_agent":"Quão responsivo foi o agente de bate-papo?","How_satisfied_were_you_with_this_chat":"Ficou satisfeito com este bate-papo?","If_you_are_sure_type_in_your_password":"Se você tem certeza, digite sua senha:","If_you_are_sure_type_in_your_username":"Se você tem certeza, digite seu nome de usuário:","Importer_Archived":"Arquivado","Importer_done":"Importação concluída!","Importer_finishing":"Terminando a importação.","Importer_From_Description":"Importa dados de __from__  para o Rocket.Chat.","Importer_import_cancelled":"Importação cancelada.","Importer_import_failed":"Ocorreu um erro durante a execução da importação.","Importer_importing_channels":"Importando os canais.","Importer_importing_messages":"Importando as mensagens.","Importer_importing_started":"Iniciando a importação.","Importer_importing_users":"Importando os usuários.","Importer_not_defined_properly":"O importador não foi definido corretamente;  está faltando a classe Import.","Importer_not_in_progress":"O importador não está em execução.","Importer_Prepare_Restart_Import":"Reiniciar Importação","Importer_Prepare_Start_Import":"Começar a importar","Importer_Prepare_Uncheck_Archived_Channels":"Desmarque Canais Arquivados","Importer_Prepare_Uncheck_Deleted_Users":"Desmarque Usuários Excluídos","Importer_progress_error":"Falha ao obter o progresso da importação.","Importer_setup_error":"Ocorreu um erro durante a configuração do importador.","Incorrect_Password":"Senha incorreta","inline_code":"código","Install_Extension":"Instalar Extensão","Install_FxOs":"Instale o Rocket.Chat em seu Firefox","Install_FxOs_done":"Ótimo! Agora você pode usar o Rocket.Chat através do ícone na sua tela inicial. Aproveite o Rocket.Chat!","Install_FxOs_error":"Desculpe, isso não funcionou conforme planejado! Ocorreu o seguinte erro:","Install_FxOs_follow_instructions":"Por favor confirme a instalação do app no seu dispositivo (pressione \"instalar\" quando solicitado).","Installation":"Instalação","Integration_added":"A integração foi adicionada","Integration_Incoming_WebHook":"Integração com WebHook de Entrada","Integration_New":"Nova Integração","Integration_Outgoing_WebHook":"Integração de WebHook de Saída","Integration_updated":"A integração foi atualizada","Integrations":"Integrações","Invalid_asset":"Arquivo Inválido","Invalid_confirm_pass":"A confirmação de senha não é igual à senha","Invalid_email":"O e-mail informado é inválido","Invalid_Export_File":"O arquivo enviado não é um arquivo de exportação %s válido.","Invalid_file_height":"Altura de arquivo inválida","Invalid_file_type":"Tipo de arquivo inválido","Invalid_file_width":"Altura de arquivo inválida","Invalid_Import_File_Type":"Tipo de Arquivo de Importação Inválido.","Invalid_name":"O nome não pode ser vazio","Invalid_notification_setting_s":"Configuração de notificação inválida: %s","Invalid_pass":"A senha não pode ser vazia","Invalid_room_name":"<strong>%s</strong> não é um nome válido,<br/> utilizar apenas letras, números e hífens","Invalid_room_type":"<strong>%s</strong> não é um tipo de sala válido.","Invalid_Secret_URL":"URL Secreta inválida","Invalid_secret_URL_message":"A URL fornecida é inválida.","invisible":"invisível","Invisible":"Invisível","Invitation_HTML":"HTML do Convite","Invitation_Subject":"Assunto do Convite","Invite_user_to_join_channel":"Convidar um usuário para este canal","Invite_Users":"Convidar Usuários","is_also_typing":"também está digitando","is_also_typing_female":"também está digitando","is_also_typing_male":"também está digitando","is_typing":"está digitando","is_typing_female":"está digitando","is_typing_male":"está digitando","italics":"itálico","join":"Entrar","Join_audio_call":"Entrar na chamada de áudio","Join_the_Community":"Junte-se à Comunidade","Join_the_given_channel":"Entrar no canal informado","Join_video_call":"Entrar na chamada de vídeo","Joined":"Entrou","Jump":"Saltar","Jump_to_first_unread":"Ir para primeira mensagem não lida","Jump_to_message":"Ir para mensagem","Jump_to_recent_messages":"Ir para mensagens recentes","Katex_Enabled":"Katex Ativado","Label":"Rótulo","Language":"Idioma","Language_Version":"Versão em Português","Last_login":"Último login","Last_message":"Última mensagem","Last_seen":"Visto por último","Layout":"Layout","Layout_Home_Body":"Corpo da Home","Layout_Home_Title":"Título da Home","Layout_Login_Terms":"Termos de Login","Layout_Privacy_Policy":"Política de Privacidade","Layout_Sidenav_Footer":"Rodapé da Navegação Lateral","Layout_Sidenav_Footer_description":"Tamanho do rodapé é 260x70","Layout_Terms_of_Service":"Termos de Serviço","LDAP":"LDAP","LDAP_CA_Cert":"Certificado CA","LDAP_Custom_Domain_Search":"Pesquisa de Domínio Personalizado","LDAP_Custom_Domain_Search_Description":"Um pedaço de JSON que governa informações de conexão e ligação e é da forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domínio Padrão","LDAP_Description":"LDAP é um banco de dados hierárquico que muitas empresas usam para fornecer single sign on - uma facilidade para compartilhar uma senha entre múltiplos sites e serviços. Para exemplos e informações de configurações avançadas, por favor consulte nosso wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":"DN LDAP","LDAP_Domain_Base":"Base de Domínio","LDAP_Domain_Base_Description":"O nome distinto (DN) de uma sub-árvore LDAP em que você deseja procurar por usuários e grupos. Você pode adicionar tantos quantos quiser; no entanto, cada grupo deve ser definido na mesma base de domínio que os usuários que pertencem a ele. Se você especificar grupos de usuários restritos, somente os usuários que pertencem a esses grupos estarão no escopo. Recomendamos que você especifique o nível mais alto de seu diretório LDAP como a sua base de domínio e use o filtro de pesquisa para controlar o acesso.","LDAP_Domain_Search_Filter":"Filtro da Pesquisa de Domínio","LDAP_Domain_Search_Filter_Description":"Se especificado, somente os usuários que correspondem a este filtro serão autorizados a entrar. Se nenhum filtro for especificado, todos os usuários dentro do âmbito da base de domínio especificado serão capazes de entrar. <br/> Por exemplo, para Active Directory `memberOf = cn = ROCKET_CHAT, ou = Geral Groups`. <br/> Por exemplo, para OpenLDAP (extensible match search) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Categoria de Objeto de Pesquisa de Domínio","LDAP_Domain_Search_Object_Category_Description":"O *objectCategory* que identifica seus usuários. <br/> Deixe em branco para *OpenLDAP*. <br/> Por exemplo, `person`, etc.","LDAP_Domain_Search_Object_Class":"Classe de Objeto de Pesquisa de Domínio","LDAP_Domain_Search_Object_Class_Description":"O *objectclass* que identifica seus usuários. <br/> Por exemplo, `organizationalPerson`,` user`, `inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Senha da Pesquisa de Domínio","LDAP_Domain_Search_Password_Description":"A senha para o usuário de pesquisa de domínio.","LDAP_Domain_Search_User":"Usuário da Pesquisa de Domínio","LDAP_Domain_Search_User_Description":"O usuário LDAP que realiza pesquisas de usuário para autenticar outros usuários quando eles entram. <br/> Isto é tipicamente uma conta de serviço criado especificamente para integrações de terceiros. Usar um nome qualificado, como `cn = administrador, cn = usuários, dc = exemplo, dc = com`.","LDAP_Domain_Search_User_ID":"ID de Usuário de Pesquisa de Domínio","LDAP_Domain_Search_User_ID_Description":"O atributo LDAP que identifica o usuário LDAP que tenta autenticar. Este campo deve ser `sAMAccountName` para a maioria das instalações de Active Directory, mas pode ser` uid` para outras soluções LDAP, como o OpenLDAP. Você pode usar `mail` para identificar usuários por e-mail ou qualquer atributo que você desejar. <br> Você pode usar vários valores separados por vírgula para permitir que os usuários façam login usando vários identificadores, como nome de usuário ou e-mail.","LDAP_Enable":"Ativar","LDAP_Enable_Description":"Tente utilizar LDAP para autenticação","LDAP_Encryption":"Criptografia","LDAP_Encryption_Description":"O método de criptografia usado para proteger as comunicações com o servidor LDAP. Exemplos incluem `plain` (sem criptografia),` SSL / LDAPS` (criptografados desde o início), e `StartTLS` (upgrade para comunicação criptografada uma vez conectado).","LDAP_Host":"Host","LDAP_Host_Description":"O host LDAP, por exemplo, `ldap.example.com` ou` 10.0.0.30`.","LDAP_Port":"Porta","LDAP_Port_Description":"Porta para acessar o LDAP. Ex.: `389` ou `636` para LDAPS","LDAP_Reject_Unauthorized":"Rejeitar Não Autorizados","LDAP_Sync_User_Avatar":"Sincronizar Avatar dos Usuários","LDAP_Sync_User_Data":"Manter dados dos usuários sincronizados","LDAP_Sync_User_Data_Description":"Mantenha seus dados de usuário em sincronia logando no servidor (ex.: nome, email).","LDAP_Sync_User_Data_FieldMap":"Mapeamento de campos do usuário","LDAP_Sync_User_Data_FieldMap_Description":"Configure como os campos da conta de usuário (tipo email) serão populados no LDAP (quando encontrados). <br />Por exemplo, `{\"cn\":\"name\", \"mail\":\"email\"}` irá selecionar o nome do usuário do atributo cn, e o seu e-mail do atributo mail. <br/>Os campos disponíveis incluem `name` e `email`.","LDAP_Sync_Users":"Sincronizar Usuários","LDAP_Test_Connection":"Testar Conexão","LDAP_Unique_Identifier_Field":"Campo Identificador Único","LDAP_Unique_Identifier_Field_Description":"O campo que será usado para vincular o usuário LDAP ao usuário Rocket.Chat. Você pode informar vários valores separados por vírgula para tentar obter o valor do registro LDAP. <br/> O valor padrão é `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueid, uidNumber`","LDAP_Use_Custom_Domain_Search":"Use Pesquisa de Domínio Personalizado","LDAP_Use_Custom_Domain_Search_Description":"Escreva seu próprio filtro para procurar usuários no servidor LDAP.","LDAP_Username_Field":"Campo do Nome de Usuário","LDAP_Username_Field_Description":"O campo que será usado como nome de usuário (*username*) para novos usuários. Deixe em branco para usar o nome de usuário informado na página de login. <br/> Você pode usar tags de template também, como `# {givenName}. # {Sn}`. <br/> O valor padrão é `sAMAccountName`.","Leave_Group_Warning":"Tem certeza de que quer sair do grupo \"%s\"?","Leave_Private_Warning":"Tem certeza de que quer sair da discussão com \"%s\"?","Leave_room":"Sair da sala","Leave_Room_Warning":"Tem certeza de que deseja sair da sala \"%s\"?","line":"linha","List_of_Direct_Messages":"Lista de Mensagens Diretas","Live_sessions":"Sessões ativas","Livechat_agents":"Agentes do Livechat","Livechat_Dashboard":"Painel Livechat","Livechat_enabled":"Livechat habilitado","Livechat_Manager":"Administração Livechat","Livechat_managers":"Gerentes do Livechat","Livechat_title":"Título Livechat","Livechat_title_color":"Cor de fundo do título do Livechat","Livechat_Users":"Usuários Livechat","Load_more":"Carregar mais","Loading...":"Carregando...","Loading_more_from_history":"Carregando mais a partir do histórico","Loading_suggestion":"Buscando sugestões...","Localization":"Localização","Log_File":"Mostrar Arquivo e Linha","Log_Level":"Nível de Log","Log_Package":"Mostrar Pacote","Log_View_Limit":"Limite de Visualização de Log","Logged_out_of_other_clients_successfully":"Desconectado de outros clientes com sucesso","Login":"Entrar","Login_with":"Login com %s","login_with":"Ou faça seu login com","Logout":"Sair","Logout_Others":"Sair de outros locais logados","Mail_Message_Invalid_emails":"Você forneceu um ou mais e-mails inválidos: %s","Mail_Message_Missing_to":"Você deve selecionar um ou mais usuários ou fornecer um ou mais endereços de e-mail, separados por vírgulas.","Mail_Message_No_messages_selected_select_all":"Você não selecionou nenhuma mensagem. Gostaria de <a href='#' class='select-all'>selecionar todas</a> as mensagens visíveis?","Mail_Messages":"Mensagens de E-mail","Mail_Messages_Instructions":"Escolher as mensagens que deseja enviar via e-mail, clicando nas mensagens","Mail_Messages_Subject":"Aqui está uma parte selecionada de %s mensagens","Mailer":"Mailer","Mailer_body_tags":"Você <b>deve</b> usar [unsubscribe] como link para desinscrever-se.<br/> Você pode usar [name], [fname], [lname] para utilizar o nome completo, primeiro nome ou último nome, respectivamente. <br/>Você pode usar [email] para o email do usuário.","Make_Admin":"Tornar Administrador","Manager_added":"Gerente adicionado","Manager_removed":"Gerente removido","Mark_as_read":"Marcar como lido","Markdown_Headers":"Cabeçalhos","Markdown_SupportSchemesForLink":"Protocolos Suportados para Markdown de Links","Markdown_SupportSchemesForLink_Description":"Lista de protocolos separados por vírgulas","Members_List":"Lista de Membros","Mentions":"Menções","Mentions_default":"Menções (padrão)","Message":"Mensagem","Message_AllowDeleting":"Permitir Exclusão de Mensagem","Message_AllowEditing":"Permitir Edição de Mensagem","Message_AllowEditing_BlockEditInMinutes":"Bloquear edição de mensagens após (em minutos - 0 para desabilitar)","Message_AllowEditing_BlockEditInMinutesDescription":"Insira 0 para desabilitar o bloqueio.","Message_AllowPinning":"Permitir Fixar Mensagem","Message_AllowPinning_Description":"Permitir que mensagens sejam fixadas em qualquer canal.","Message_AllowStarring":"Permitir Mensagens Favoritas","Message_AudioRecorderEnabled":"Gravação de Áudio Habilitada","Message_AudioRecorderEnabledDescription":"Requer que 'audio/wav' seja aceito nas configurações de 'Upload de Arquivos'","Message_DateFormat":"Formato de Data","Message_DateFormat_Description":"Veja também: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Exclusão de mensagem não permitido","Message_editing_blocked":"Esta mensagem não pode mais ser editada","Message_editing_not_allowed":"Edição de mensagem não permitido","Message_GroupingPeriod":"Período de Agrupamento (em segundos)","Message_GroupingPeriodDescription":"As mensagens serão agrupadas com as anteriores se pertencerem ao mesmo usuário e o tempo decorrido for menor do que o tempo em segundos informado.","Message_KeepHistory":"Manter Histórico de Mensagens","Message_MaxAllowedSize":"Tamanho máximo de mensagem permitido ","Message_MaxAll":"Tamanho máximo de canais para a mensagem ALL","Message_pinned":"Mensagem fixada","Message_pinning_not_allowed":"Não Permitir Fixar Mensagem","Message_removed":"Mensagem removida","Message_ShowDeletedStatus":"Mostrar Status Excluído","Message_ShowEditedStatus":"Mostrar Status Editado","Message_ShowFormattingTips":"Exibir dicas de formatação","Message_TimeFormat":"Formato de Hora","Message_TimeFormat_Description":"Veja também: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Mensagem muito longa","Messages":"Mensagens","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"As mensagens que são enviadas para o WebHook de Entrada serão publicadas aqui.","Meta":"Meta","Meta_fb_app_id":"Facebook APP ID","Meta_google-site-verification":"Verificação de Site do Google","Meta_language":"Idioma","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minutos","Mobile_push":"Notificação por celular","More_channels":"Mais canais","More_direct_messages":"Mais mensagens diretas","More_groups":"Mais grupos privados","More_unreads":"Mais não lidos","Msgs":"Msgs","multi":"multi","Mute_someone_in_room":"Silenciar alguém na sala","Mute_user":"Silenciar usuário","Muted":"Silenciado","My_Account":"Minha Conta","n_messages":"%s mensagens","N_new_messages":"%s novas mensagens","Name":"Nome","Name_cant_be_empty":"Nome não pode ser vazio","Name_of_agent":"Nome do agente","Name_optional":"Nome (opcional)","Navigation_History_20_last_pages":"Histórico de Navegação (20 últimas páginas)","New_Application":"Nova aplicação","New_Custom_Field":"Novo Campo Personalizado","New_Department":"Novo Departamento","New_integration":"Nova integração","New_logs":"Novos logs","New_messages":"Novas mensagens","New_password":"Nova senha","New_role":"Novo papel","No_channel_with_name_%s_was_found":"Nenhum canal com nome <strong>\"%s\"</strong> foi encontrado!","No_channels_yet":"Você não faz parte de nenhum canal ainda.","No_direct_messages_yet":"Você não iniciou nenhuma conversa ainda.","No_Encryption":"Sem Criptografia","No_favorites_yet":"Nenhum favorito ainda.","No_group_with_name_%s_was_found":"Nenhum grupo privado com nome <strong>\"%s\"</strong> foi encontrado!","No_groups_yet":"Nenhum grupo privado ainda.","No_livechats":"Nenhum atendimento.","No_mentions_found":"Menções não encontradas","No_permission_to_view_room":"Sem permissões para ver a sala","No_pinned_messages":"Não há mensagens fixadas","No_results_found":"Nenhum resultado encontrado","No_starred_messages":"Não há mensagens favoritas","no_tokens_for_this_user":"Não existem tokens para este usuário","No_user_with_username_%s_was_found":"Nenhum usuário com nome de usuário <strong>\"%s\"</strong> foi encontrado!","Not_allowed":"Não permitido","Not_authorized":"Não autorizado","Not_Available":"Não Disponível","Not_found_or_not_allowed":"Não encontrado ou não permitido","Nothing":"Nada","Nothing_found":"Nada encontrado","Notifications":"Notificações","Notify_all_in_this_room":"Notificar todos nesta sala","Num_Agents":"# Agentes","Number_of_messages":"Número de mensagens","OAuth_Application":"Aplicação OAuth","OAuth_Applications":"Aplicações OAuth","Objects":"Objetos","Off_the_record_conversation":"Conversa Off-the-record","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Conversa Off-the-record não está disponível para o seu navegador ou dispositivo.","Offline_DM_Email":"[__site__] Você recebeu uma mensagem direta de __user__","Offline_Mention_Email":"[__site__] Você foi mencionado por __user__ em #__room__","Old_and_new_password_must_be_different":"A nova senha deve ser diferente da senha antiga.","Old_and_new_password_required":"Você precisa fornecer a senha antiga e a nova senha para alterar sua senha.","Online":"Online","Only_errors":"Apenas erros","Only_you_can_see_this_message":"Apenas você pode ver esta mensagem","Oops!":"Ops","Open":"Aberto","Opened":"Aberto","Opt_out_statistics":"Não envie as minhas estatísticas anonimamente para Rocket.Chat","Opt_out_statistics_warning":"Enviando suas estatísticas anonimamente você nos ajudará a identificar quantas instâncias do Rocket.Chat são implantadas, bem como o quão bom o sistema está se comportando, para que nós possamos melhorar ainda mais. Se você quiser continuar nos enviando suas estatísticas anonimamente, desmarque a caixa de seleção acima. Obrigado","optional":"opcional","Order":"Ordem","OS_Arch":"Arquitetura","OS_Cpus":"Número de CPUs","OS_Freemem":"Memória Disponível","OS_Loadavg":"Carga Média","OS_Platform":"Plataforma","OS_Release":"Release","OS_Totalmem":"Memória Total","OS_Type":"Tipo de Sistema Operacional","OS_Uptime":"Tempo ligado","others":"outros","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR só está disponível quando os usuários estão online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Substituir URL para a qual os arquivos são carregados. Esta url também será usada para downloads, a menos que um CDN seja fornecido","Password":"Senha","Password_Change_Disabled":"O administrador do Rocket.Chat desativou a mudança de senhas","Password_changed_successfully":"Senha alterada com sucesso","Payload":"Payload","People":"Pessoas","Permissions":"Permissões","Pin_Message":"Fixar Mensagem","Pinned_a_message":"Fixou uma mensagem:","Pinned_Messages":"Mensagens Fixadas","Placeholder_for_email_or_username_login_field":"Espaço reservado para campo de e-mail ou nome de usuário","Placeholder_for_password_login_field":"Espaço reservado para campo de senha","Please_answer_survey":"Por favor, dedique um momento para responder a uma pesquisa rápida sobre o bate-papo","Please_enter_value_for_url":"Por favor insira um valor para a URL do seu avatar.","Please_enter_your_new_password_below":"Por favor digite sua nova senha abaixo:","Please_fill_a_label":"Por favor, preencha um rótulo","Please_fill_a_name":"Por favor, preencha um nome","Please_fill_a_username":"Por favor preencha um nome de usuário","Please_fill_name_and_email":"Por favor, preencha nome e e-mail","Please_re_enter_your_password":"Por favor, digite sua senha novamente","Please_select_enabled_yes_or_no":"Por favor, selecione uma opção para Ativado","Please_wait":"Aguarde","Please_wait_activation":"Por favor aguarde, isso pode levar algum tempo.","Please_wait_statistics":"Por favor aguarde, as estatísticas estão sendo geradas.","Please_wait_while_OTR_is_being_established":"Por favor aguarde enquanto a conversa OTR está sendo estabelecida","Please_wait_while_your_account_is_being_deleted":"Por favor aguarde enquanto a sua conta está sendo excluída...","Please_wait_while_your_profile_is_being_saved":"Aguarde enquanto o seu perfil está sendo salvo...","Post_as":"Postar como","Post_to_Channel":"Postar no Canal","Post_to_s_as_s":"Postar em <strong>%s</strong> como <strong>%s</strong>","Powered_by":"Powered by","Preferences":"Preferências","Preferences_saved":"Preferências salvas","Privacy":"Privacidade","Private_Group":"Grupo Privado","Private_Groups":"Grupos Privados","Private_Groups_list":"Lista de Grupos Privados","Profile":"Perfil","Profile_saved_successfully":"Perfil salvo com sucesso","Proudly_developed":"Orgulhosamente desenvolvido com Meteor","Push":"Push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Debug","push_disabled":"Push desativado","Push_enable":"Habilitar","Push_enable_gateway":"Ativar Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"Chave da API GCM","Push_gcm_project_number":"Número do Projeto GCM","Push_production":"Produção","Push_show_message":"Mostrar mensagem na notificação","Push_show_username_room":"Mostrar canal / grupo / nome de usuário na notificação","Push_test_push":"Teste","Query":"Query","Query_description":"Condições adicionais para determinar para quais usuários enviar e-mail. Usuários não inscritos são automaticamente removidos a partir da consulta. Deve ser um JSON válido. Exemplo: `{\"createdAt\": {\"$gt\": {\"$date\": \"2015-01-01T00: 00: 00.000Z\"}}}`","Quick_Search":"Pesquisa Rápida","quote":"citação","Reactions":"Reações","Recents":"Recentes","Record":"Gravar","Redirect_URI":"URI de redirecionamento","Refresh_keys":"Atualizar chaves","Refresh_your_page_after_install_to_enable_screen_sharing":"Atualize sua página após a instalação para permitir o compartilhamento de tela","Register":"Registrar-se","Registration_Succeeded":"Registrado com Sucesso","Remember_me":"Lembrar-me","Remove":"Remover","Remove_Admin":"Remover Administrador","Remove_as_moderator":"Remover como moderador","Remove_as_owner":"Remover de proprietário","Remove_custom_oauth":"Remover oauth customizado","Remove_from_room":"Retire da sala","Remove_someone_from_room":"Retirar alguém da sala","Removed":"Removido","Require_password_change":"Exigir alteração de senha","Resend_verification_email":"Reenviar email de verificação","Reset":"Resetar","Reset_password":"Resetar senha","Restart":"Reiniciar","Restart_the_server":"Reiniciar o servidor","RocketBot_Enabled":"RocketBot Habilitado","RocketBot_Name":"Nome do RocketBot","RocketBot_Name_Description":"O nome deve ser um username registrado.","Role":"Papel","Role_Editing":"Edição de Papel","Role_removed":"Papel Removido","Room":"Sala","Room_archivation_state":"Estado","Room_archivation_state_false":"Ativo","Room_archivation_state_true":"Arquivado","Room_archived":"Sala arquivada","room_changed_privacy":"Tipo da sala mudou para: <em>__room_type__</em> por <em>__user_by__</em>","room_changed_topic":"Tópico da sala mudou para: <em>__room_topic__</em> por <em>__user_by__</em>","Room_has_been_deleted":"A sala foi excluída","Room_Info":"Informações da Sala","Room_name_changed":"Nome da sala alterado para: <em>__room_name__</em> por <em>__user_by__</em>","Room_name_changed_successfully":"Nome da sala alterado com sucesso","Room_not_found":"Sala não encontrada","Room_topic_changed_successfully":"Tópico da sala alterado com sucesso","Room_type_changed_successfully":"Tipo de sala alterado com sucesso","Room_unarchived":"Sala desarquivada","Room_uploaded_file_list":"Lista de arquivos","Room_uploaded_file_list_empty":"Nenhum arquivo disponível","room_user_count":"%s usuários","Rooms":"Salas","S_new_messages_since_s":"%s novas mensagens desde %s","SAML":"SAML","SAML_Custom_Cert":"Certificado personalizado","SAML_Custom_Entry_point":"Entry Point personalizado","SAML_Custom_Generate_Username":"Gerar nome de usuário","SAML_Custom_Issuer":"Emissor Personalizado","SAML_Custom_Provider":"Provedor Personalizado","Save":"Salvar","Save_changes":"Salvar alterações","Save_Mobile_Bandwidth":"Economizar Banda Móvel","Save_to_enable_this_action":"Salvar para habilitar esta ação","Saved":"Salvo","Saving":"Salvando","Scope":"Escopo","Screen_Share":"Compartilhamento de Tela","Script_Enabled":"Script Ativado","Search":"Pesquisar","Search_by_username":"Busca por nome de usuário","Search_Channels":"Pesquisar Canais","Search_Direct_Messages":"Pesquisar Mensagens Diretas","Search_Messages":"Pesquisar Mensagens","Search_Private_Groups":"Pesquisar Grupos Privados","Search_settings":"Pesquisar configurações","seconds":"segundos","See_all":"Ver todos","See_only_online":"Apenas online","Select_a_department":"Selecione um departamento","Select_an_avatar":"Selecione um avatar","Select_file":"Selecione um arquivo","Select_service_to_login":"Selecione um serviço para iniciar sessão e carregar sua imagem ou faça upload de um arquivo de seu computador","Select_user":"Escolha um usuário","Select_users":"Selecione usuários","Selected_agents":"Agentes seleccionados","Selected_users":"Membros selecionados","Send":"Enviar","Send_a_message":"Envie uma mensagem","Send_a_test_mail_to_my_user":"Enviar um e-mail de teste para o meu usuário","Send_a_test_push_to_my_user":"Enviar um Push de teste para o meu usuário","Send_confirmation_email":"Enviar email de confirmação","Send_data_into_RocketChat_in_realtime":"Enviar dados para Rocket.Chat em tempo real.","Send_email":"Enviar E-mail","Send_invitation_email":"Enviar convite por e-mail","Send_invitation_email_error":"Você não forneceu um e-mail válido.","Send_invitation_email_info":"Você pode enviar vários convites por e-mail de uma vez.","Send_invitation_email_success":"Você enviou com sucesso um convite por e-mail para os seguintes endereços:","Send_invitation_email_warning":"Para enviar convites por e-mails, você deve primeiro definir as configurações de SMTP.","Send_Message":"Enviar Mensagem","Send_your_JSON_payloads_to_this_URL":"Envie seu payload  JSON para esta URL.","Sending":"Enviando ...","Set_as_moderator":"Definir como moderador","Set_as_owner":"Definir como proprietário","Settings":"Configurações","Settings_updated":"Configurações atualizadas","Should_be_a_URL_of_an_image":"Deve ser uma URL de uma imagem.","Should_exists_a_user_with_this_username":"O usuário já deve existir.","Show_all":"Mostrar tudo","Show_more":"Mostrar mais","Show_only_online":"Mostrar apenas online","Show_preregistration_form":"Mostrar formulário de pré-registro","Showing_archived_results":"<p>Exibindo <b>%s</b> resultados arquivados</p>","Showing_online_users":"Mostrando <b>__total_showing__</b> de __total__ usuários","Showing_results":"<p>Exibindo <b>%s</b> resultados</p>","Silence":"Silenciar","since_creation":"desde %s","Site_Name":"Nome do Site","Site_Url":"URL do Site","Site_Url_Description":"Exemplo: https://chat.dominio.com.br/","Skip":"Pular","Smileys_and_People":"Smileys & Pessoas","SMTP":"SMTP","SMTP_Host":"Host SMTP","SMTP_Password":"Senha SMTP","SMTP_Port":"Porta SMTP","SMTP_Test_Button":"Testar Configurações SMTP","SMTP_Username":"Nome de usuário SMTP","Sound":"Som","Star_Message":"Favoritar Message","Starred_Messages":"Mensagens Favoritas","Start_audio_call":"Iniciar chamada de áudio","Start_Chat":"Iniciar bate-papo","Start_of_conversation":"Início da conversa","Start_OTR":"Iniciar OTR","Start_video_call":"Iniciar chamada de vídeo","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Comece com <code class=\"inline\">%s</code> para o usuário ou <code class=\"inline\">%s</code> para o canal. Por exemplo: <code class=\"inline\">%s</code> ou <code class=\"inline\">%s</code>","Statistics":"Estatísticas","Stats_Active_Users":"Usuários Ativos","Stats_Avg_Channel_Users":"Média de Usuários por Canal","Stats_Avg_Private_Group_Users":"Média de Usuários por Grupo Privado","Stats_Away_Users":"Usuários ausentes","Stats_Max_Room_Users":"Número Máximo de Usuários em um Sala","Stats_Non_Active_Users":"Usuários Inativos","Stats_Offline_Users":"Usuários Offline","Stats_Online_Users":"Usuários Online","Stats_Total_Channels":"Quantidade de Canais","Stats_Total_Direct_Messages":"Total de Salas de Mensagem Direta","Stats_Total_Messages":"Quantidade de Mensagens","Stats_Total_Private_Groups":"Quantidade de Grupos Privados","Stats_Total_Rooms":"Quantidade de Salas","Stats_Total_Users":"Quantidade de Usuários","Stop_Recording":"Parar Gravação","strike":"tachado","Subject":"Assunto","Submit":"Enviar","Success":"Sucesso","Survey":"Pesquisa","Survey_instructions":"Classifique cada questão de acordo com a sua satisfação, 1 significa que você está completamente insatisfeito e 5 significa que você está completamente satisfeito.","Symbols":"Símbolos","Sync_success":"Sincronizado com sucesso","Sync_Users":"Sincronizar Usuários","Test_Connection":"Testar Conexão","Test_Desktop_Notifications":"Testar Notificações de Desktop","Thank_you_for_your_feedback":"Obrigado pelo seu feedback","The_application_name_is_required":"O nome da aplicação é obrigatório","The_channel_name_is_required":"O nome do canal é obrigatório","The_emails_are_being_sent":"Os emails estão sendo enviados.","The_field_is_required":"O campo %s é obrigatório.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"O redimensionamento da imagem não vai funcionar porque não conseguimos detectar ImageMagick ou GraphicsMagick instalado no seu servidor.","The_redirectUri_is_required":"O redirectUri é necessário","The_server_will_restart_in_s_seconds":"O servidor será reiniciado em %s segundos","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"A configuração <strong>%s</strong> está definida como <strong>%s</strong> e você está acessando a partir de <strong>%s</strong>!","The_user_will_be_removed_from_s":"O usuário será removido de %s","The_user_wont_be_able_to_type_in_s":"O usuário não será capaz de escrever em %s","Theme":"Tema","theme-color-action-buttons-color":"Cor dos Botões de Ação","theme-color-active-channel-background-color":"Cor do Fundo de Canal Ativo","theme-color-active-channel-font-color":"Cor de Fonte de Canal Ativo","theme-color-blockquote-background":"Cor de fundo de bloco de citação","theme-color-clean-buttons-color":"Cor dos Botões Claros","theme-color-code-background":"Cor de fundo de código","theme-color-code-border":"Cor da borda de código","theme-color-code-color":"Cor de código","theme-color-content-background-color":"Cor de fundo do conteúdo principal","theme-color-custom-scrollbar-color":"Cor da Barra de Rolagem Customizada","theme-color-info-active-font-color":"Cor da fonte de informação ativa","theme-color-info-font-color":"Cor da fonte de informação","theme-color-input-font-color":"Cor da fonte de entrada","theme-color-link-font-color":"Cor da fonte de link","theme-color-message-hover-background-color":"Cor de Fundo de Hover da Mensagem","theme-color-primary-background-color":"Cor de fundo primária","theme-color-primary-font-color":"Cor de fonte primária","theme-color-quaternary-font-color":"Cor de Fonte Quaternária","theme-color-secondary-background-color":"Cor de fundo secundária","theme-color-secondary-font-color":"Cor de fonte secundária","theme-color-smallprint-font-color":"Cor de fonte de small print","theme-color-smallprint-hover-color":"Cor de hover de small print","theme-color-status-away":"Cor da situação ausente","theme-color-status-busy":"Cor da situação ocupado","theme-color-status-offline":"Cor da situação offline","theme-color-status-online":"Cor da situação online","theme-color-tertiary-background-color":"Cor de fundo terciária","theme-color-tertiary-font-color":"Cor de fonte terciária","theme-color-unread-notification-color":"Cor das Notificações Não Lidas","theme-custom-css":"CSS Customizado","There_are_no_agents_added_to_this_department_yet":"Não há agentes adicionados a este departamento ainda.","There_are_no_integrations":"Não há integrações","There_are_no_users_in_this_role":"Não há usuários neste papel.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Este e-mail já foi utilizado e não foi verificado. Por favor, altere sua senha.","This_is_a_desktop_notification":"Esta é uma notificação de desktop","This_is_a_push_test_messsage":"Este é uma mensagem de teste de push notification","Time_in_seconds":"Tempo em segundos","Title_bar_color":"Cor da barra de título","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Para instalar Rocket.Chat Livechat no seu website, copie e cole este código acima da última tag <strong>&lt;/ body&gt;</strong> em seu site.","To_users":"Para Usuários","Topic":"Tópico","Travel_and_Places":"Viagem & Locais","Trigger_removed":"Gatilho removido","Trigger_Words":"Palavras Gatilho","Triggers":"Gatilhos","True":"Sim","Type":"Tipo","Type_your_new_password":"Digite sua nova senha","Unarchive":"Desarquivar","Unmute_someone_in_room":"Permitir que alguém fale na sala","Unmute_user":"Permitir que o usuário fale","Unnamed":"Sem nome","Unpin_Message":"Desafixar Mensagem ","Unread_Rooms":"Não Lidas","Unread_Rooms_Mode":"Agrupar Salas Não Lidas","Unstar_Message":"Remover Favorito","Upload_file_question":"Enviar arquivo?","Uploading_file":"Subindo arquivo...","Use_account_preference":"Use preferências da conta","Use_Emojis":"Usar Emojis","Use_initials_avatar":"Usar as iniciais do seu nome de usuário","use_menu":"Utilize o menu à esquerda para acessar suas salas","Use_service_avatar":"Use o avatar de %s","Use_this_username":"Usar este nome de usuário","Use_uploaded_avatar":"Use o avatar de upload","Use_url_for_avatar":"Use url para o avatar","User__username__is_now_a_moderator_of__room_name_":"Usuário __username__ agora é um moderador de __room_name__","User__username__is_now_a_owner_of__room_name_":"Usuário __username__ agora é proprietário de __room_name__","User__username__removed_from__room_name__moderators":"Usuário __username__ removido dos moderadores de __room_name__","User__username__removed_from__room_name__owners":"Usuário __username__ removido dos proprietários de __room_name__","User_added":"Usuário adicionado","User_added_by":"Usuário <em>__user_added__</em> adicionado à conversa por <em>__user_by__</em>.","User_added_successfully":"Usuário adicionado com sucesso","User_Channels":"Canais do Usuário","User_doesnt_exist":"O usuário `@%s` não existe.","User_has_been_activated":"Usuário foi ativado","User_has_been_deactivated":"Usuário foi desativado","User_has_been_deleted":"O usuário foi excluído","User_has_been_muted_in_s":"Usuário foi silenciado em %s","User_has_been_removed_from_s":"Usuário foi removido de %s","User_has_disconnected":"Usuário foi desconectado","User_Info":"Informações do usuário","User_is_no_longer_an_admin":"O usuário já não é um administrador","User_is_not_activated":"O usuário não está ativo","User_is_now_an_admin":"O usuário tornou-se um administrador","User_joined_channel":"Entrou no canal.","User_joined_channel_female":"Entrou no canal.","User_joined_channel_male":"Entrou no canal.","User_left":"Usuário <em>__user_left__</em> deixou a conversa.","User_left_female":"Usuário <em>__user_left__</em> deixou a conversa.","User_left_male":"Usuário <em>__user_left__</em> deixou a conversa.","User_logged_out":"Usuário não logado","User_management":"Gerenciamento de usuários","User_muted_by":"Usuário <em>__user_muted__</em> silenciado por <em>__user_by__</em>.","User_muted_in_room":"Usuário silenciado na sala","User_not_found":"Usuário não encontrado","User_not_found_or_incorrect_password":"Usuário não encontrado ou senha incorreta","User_or_channel_name":"Usuário ou nome de canal","User_removed":"Usuário removido","User_removed_by":"Usuário <em>__user_removed__</em> removido da conversa por <em>__user_by__</em>.","User_removed_from_room":"O usuário foi removido da sala","User_Settings":"Configurações do Usuário","User_unmuted_by":"<em>__user_by__</em> permitiu que <em>__user_unmuted__</em> fale na sala.","User_unmuted_in_room":"Usuário pode falar na sala","User_updated_successfully":"Usuário atualizado com sucesso","Username":"Nome de usuário","Username_and_message_must_not_be_empty":"Usuário e mensagem não devem estar vazios.","Username_cant_be_empty":"O nome de usuário não pode ser vazio","Username_Change_Disabled":"O administrador do Rocket.Chat desabilitou a mudança de nome de usuário","Username_denied_the_OTR_session":"__username__ negou a sessão OTR","Username_description":"O nome de usuário serve para que outras pessoas possam mencionar você em mensagens","Username_doesnt_exist":"O nome de usuário `%s` não existe.","Username_ended_the_OTR_session":"__username__ terminou a sessão OTR","Username_invalid":"<strong>%s</strong> não é um nome de usuário válido, <br/> usar somente letras, números, pontos, hífens e underscores","Username_is_already_in_here":"`@%s` já está aqui.","Username_is_not_in_this_room":"O usuário `%s` não está nesta sala.","Username_not_found":"Nome de usuário não encontrado","Username_title":"Cadastre um nome de usuário","Username_unavaliable":"<strong>%s</strong> já está sendo usado :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ quer começar OTR. Você aceita?","Users":"Usuários","Users_in_role":"Usuários no papel","UTF8_Names_Slugify":"Slugify Nomes UTF8 ","UTF8_Names_Validation":"Validação de Nomes UTF8","UTF8_Names_Validation_Description":"Não permitir caracteres especiais e espaços. Você pode usar - _ e. mas não no final do nome","Verification_email_sent":"E-mail de verificação enviado","View_All":"Ver Todos","View_Logs":"Ver Logs","Visibility":"Visibilidade","Visible":"Visível","Visitor":"Visitante","Visitor_page_URL":"URL da página de visitante","Visitor_time_on_site":"Tempo do visitante no site","Wait_activation_warning":"Antes que você possa fazer o login, sua conta deve ser manualmente ativada por um administrador.","We_are_offline_Sorry_for_the_inconvenience":"Estamos offline. Desculpe pela inconveniência.","We_have_sent_password_email":"Nós lhe enviamos um e-mail com instruções para redefinir sua senha. Se você não receber um e-mail em breve, por favor retorne e tente novamente.","We_have_sent_registration_email":"Nós lhe enviamos um e-mail para confirmar o seu registro. Se você não receber um e-mail em breve, por favor retorne e tente novamente.","WebRTC_Enable_Channel":"Habilitar para canais públicos","WebRTC_Enable_Direct":"Ativar Mensagens Diretas","WebRTC_Enable_Private":"Habilitar para canais privados","WebRTC_Servers":"Servidores STUN/TURN","WebRTC_Servers_Description":"Uma lista de servidores STUN e TURN separados por vírgula. <br/> Nome de usuário, senha e porta são permitidos no formato `username:password @stun:host:port` ou` username:password@turn:host:port`.","Welcome":"Seja bem-vindo <em>%s</em>.","Welcome_to_the":"Bem-vindo ao","will_be_able_to":"poderá","With_whom":"Com quem","Yes":"Sim","Yes_clear_all":"Sim, limpar tudo!","Yes_delete_it":"Sim, exclua!","Yes_hide_it":"Sim, esconder!","Yes_leave_it":"Sim, sair!","Yes_mute_user":"Sim, silenciar o usuário!","Yes_remove_user":"Sim, remover usuário!","you_are_in_preview_mode_of":"Esta é uma prévia do canal #<strong>__room_name__</strong>","You_are_logged_in_as":"Vocês está logado como","You_are_not_authorized_to_view_this_page":"Você não possui permissão para visualizar esta página.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Você é o último proprietário da sala. Por favor defina um novo proprietário antes de sair.","You_can_change_a_different_avatar_too":"Você pode substituir o avatar usado para enviar a partir desta integração.","You_can_use_an_emoji_as_avatar":"Você também pode usar um emoji como um avatar.","You_have_been_muted":"Você foi silenciado e não pode falar nesta sala","You_have_not_verified_your_email":"Você ainda não verificou o seu e-mail.","You_have_successfully_unsubscribed":"A partir de agora você não está mais cadastrado em nossa lista de e-mails.","You_informed_an_invalid_FROM_address":"Você informou um e-mail DE inválido.","You_must_provide_the_unsubscribe_link":"Você deve fornecer o link para desinscrever-se: [unsubscribe].","You_need_confirm_email":"Você precisa confirmar seu email para logar!","You_need_install_an_extension_to_allow_screen_sharing":"Você precisa instalar uma extensão para permitir o compartilhamento de tela","You_need_to_change_your_password":"Você precisa alterar sua senha","You_need_to_type_in_your_password_in_order_to_do_this":"Você precisa digitar sua senha, a fim de fazer isso!","You_need_to_type_in_your_username_in_order_to_do_this":"Você precisa digitar seu nome de usuário, a fim de fazer isso!","You_need_to_verifiy_your_email_address_to_get_notications":"Você precisa comprovar o seu endereço de e-mail para obter notificações","You_should_name_it_to_easily_manage_your_integrations":"Você deve nomeá-lo para gerenciar facilmente as suas integrações.","You_will_not_be_able_to_recover":"Você não será capaz de desfazer!","You_will_not_be_able_to_recover_file":"Não será possível recuperar esse arquivo!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Você não receberá notificações de e-mail, porque você não confirmou seu e-mail.","Your_email_has_been_queued_for_sending":"Seu email está na fila para envio","Your_entry_has_been_deleted":"Sua mensagem foi excluída.","Your_file_has_been_deleted":"Seu arquivo foi apagado.","Your_mail_was_sent_to_s":"O seu e-mail foi enviado para %s","Your_Open_Source_solution":"Sua própria solução Open Source","Your_password_is_wrong":"Sua senha está errada!","Your_push_was_sent_to_s_devices":"Sua natificação foi enviada para %s dispositivos"});
TAPi18n._registerServerTranslator("pt", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ro.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ro"] = ["Romanian","Română"];                                                                 // 8
if(_.isUndefined(TAPi18n.translations["ro"])) {                                                                        // 9
  TAPi18n.translations["ro"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ro"][namespace])) {                                                             // 13
  TAPi18n.translations["ro"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ro"][namespace], {"500":"eroare interna a serverului","0_Errors_Only":"0 - Doar erori.","1_Errors_and_Information":"1 - Erori și informații","2_Erros_Information_and_Debug":"2- Erori, informații și debug","__username__was_set__role__by__user_by_":"__username__ a fost stabilită __role__ de __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ nu mai este __role__, prin __user_by__","Access_not_authorized":"Acces neautorizat","Access_online_demo":"Accesați demo on-line","Access_Online_Demo":"Accesati Demo Online","Access_Token_URL":"Acces Token URL","Accounts":"Conturi","Accounts_AllowDeleteOwnAccount":"Permiteți utilizatorilor să-și șteargă contul","Accounts_AllowedDomainsList":"Listă domenii permise","Accounts_AllowedDomainsList_Description":"Lista separată cu virgule a domeniilor acceptate","Accounts_AllowEmailChange":"Permite schimbare e-mail","Accounts_AllowPasswordChange":"Permiteți schimbare parolă","Accounts_AllowUserAvatarChange":"Permite schimbarea avatar-ului utilzatorilor","Accounts_AllowUsernameChange":"Permiteți schimbarea numelui de utilizator","Accounts_AllowUserProfileChange":"Permite schimbarea profilului utilzatorilor","Accounts_AvatarResize":"Redimensionarea Avatare","Accounts_AvatarSize":"Dimensiune Avatar","Accounts_AvatarStorePath":"Calea de stocare Avatar","Accounts_AvatarStoreType":"Tip stocare Avatar","Accounts_BlockedDomainsList":"Blocate List Domenii","Accounts_BlockedDomainsList_Description":"Lista de elemente separate prin virgulă de domenii blocate","Accounts_denyUnverifiedEmail":"Nu accepta e-mail neverificat","Accounts_EmailVerification":"Verificarea email-ului","Accounts_EmailVerification_Description":"Asigurați-vă că aveți setările SMT corecte pentru a utiliza această funcționalitate","Accounts_Enrollment_Email":"E-mail de înscriere ","Accounts_Enrollment_Email_Description":"Puteți utiliza [name], [fname], [lname] pentru numele complet al utilizatorului, prenumele respectiv numele de familie.<br/>Puteți folosi [email] pentru e-mailul utilizatorului.","Accounts_Iframe_api_method":"Metodă API","Accounts_Iframe_api_url":"API URL","Accounts_iframe_enabled":"Activat","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Autentificarea expiră (în zile)","Accounts_ManuallyApproveNewUsers":"Aprobarea manuală a noilor utilizatori","Accounts_OAuth_Custom_Token_Sent_Via":"Jeton Trimis Via","Accounts_OAuth_Custom_Authorize_Path":"Authorize Path","Accounts_OAuth_Custom_Button_Color":"Culoare buton","Accounts_OAuth_Custom_Button_Label_Color":"Culoare buton text","Accounts_OAuth_Custom_Button_Label_Text":"Text buton","Accounts_OAuth_Custom_Enable":"Activează","Accounts_OAuth_Custom_id":"Id-ul","Accounts_OAuth_Custom_Identity_Path":"Identity Path","Accounts_OAuth_Custom_Login_Style":"Stil Autentificare","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Logare cu Facebook","Accounts_OAuth_Facebook_callback_url":"Facebook URL de apelare inversă","Accounts_OAuth_Facebook_id":"Facebook App ID","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Activat","Accounts_OAuth_Github_callback_url":"Github URL de apelare inversă","Accounts_OAuth_GitHub_Enterprise":"OAuth Activat","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise URL de apelare inversă","Accounts_OAuth_GitHub_Enterprise_id":"Client ID","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Client Id","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth Activat","Accounts_OAuth_Gitlab_callback_url":"GitLab URL de apelare inversă","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Login cu Google","Accounts_OAuth_Google_callback_url":"Google URL de apelare inversă","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"Logare cu LinkedIn","Accounts_OAuth_Linkedin_callback_url":"LinkedIn URL de apelare inversă","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Logare cu Meteor","Accounts_OAuth_Meteor_callback_url":"Meteor URL de apelare inversă","Accounts_OAuth_Meteor_id":"Meteor ID","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Logare cu Twitter","Accounts_OAuth_Twitter_callback_url":"Stare de nervozitate URL de apelare inversă","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"Autentificare WordPress","Accounts_OAuth_Wordpress_callback_url":"Wordpress URL de apelare inversă","Accounts_OAuth_Wordpress_id":" Id WordPress","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Resetează parola","Accounts_Registration_AuthenticationServices_Enabled":"Înregistrare cu servicii de autentificare","Accounts_RegistrationForm":"Formular de înregistrare","Accounts_RegistrationForm_Disabled":"Dezactivat","Accounts_RegistrationForm_LinkReplacementText":"Înlocuire link din formularul de înregistrare","Accounts_RegistrationForm_Public":"Public","Accounts_RegistrationForm_Secret_URL":"URL secret","Accounts_RegistrationForm_SecretURL":"URL secret din formularul de înregistrare","Accounts_RegistrationForm_SecretURL_Description":"Trebuie să furnizați un șir aleatoriu care va fi adăugat la URL-ul dvs. de înregistrare. Exemplu: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Înregistrare necesară","Accounts_RequireNameForSignUp":"Cere nume pentru înregistrare","Accounts_ShowFormLogin":"Arată formularul pentru autentificare","Accounts_UseDefaultBlockedDomainsList":"Implicit utilizare blocate Listă Domenii","Accounts_UseDNSDomainCheck":"DNS Verificați domeniu utilizați","Activate":"Activează","Activity":"Activitate","Add":"Adăugă","Add_agent":"Adaugă agent","Add_custom_oauth":"Adaugă OAuth personalizat","Add_manager":"Adauga manager","Add_Members":"Adaugă membri","Add_User":"Adaugă utilizator","Add_user":"Adaugă utilizator","Add_users":"Adaugă utilizatori","Additional_emails":"E-mail-uri suplimentare","Additional_Feedback":"Feedback suplimentar","Administration":"Administrare","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"După autentificare OAuth2, utilizatorii vor fi redirecționat către această adresă URL","Agent_added":"Agent adăugat","Agent_removed":"Agent eliminat","Alias":"Alias","All":"Tot","All_channels":"Toate canalele","All_logs":"Toate înregistrările","All_messages":"Toate mesajele","Allow_Invalid_SelfSigned_Certs":"Permiteți Certificate Self-Signed Certs","Allow_Invalid_SelfSigned_Certs_Description":"Permiteți certificat SSL invalid și auto-semnat pentru validarea link-urilor și previzualizări.","and":"și","And_more":"Și mai mult __length __...","Animals_and_Nature":"Animale și natură","API":"API","API_Analytics":"Analytics","API_Embed":"Embed","API_EmbedDisabledFor":"Dezactivați Embed pentru utilizatori","API_EmbedDisabledFor_Description":"Lista separată cu virgule a numelor de utilizator","API_GitHub_Enterprise_URL":"URL-ul serverului","API_GitHub_Enterprise_URL_Description":"Exemplu: http://domain.com (fără '/' la final)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"URL WordPress","Appearance":"Aspect","Application_added":"Aplicație adăugată","Application_Name":"Nume aplicație","Application_updated":"Aplicație actualizată","Apply_and_refresh_all_clients":"Se aplică și actualizați toți clienții","Archive":"Arhivează","Archive_Unarchive":"Arhivează / Dezarhivează","are_also_typing":"tastează","are_typing":"tastează","Are_you_sure":"Sigur doriți asta?","Are_you_sure_you_want_to_delete_your_account":"Sunteți sigur că doriți să ștergeți contul?","Authorization_URL":"URL de autorizare","Authorize":"Autorizează","AutoLinker_StripPrefix":"AutoLinker Strip Prefixul","AutoLinker_StripPrefix_Description":"Afișaj scurt. de exemplu, https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL-ul","AutoLinker_UrlsRegExp":"AutoLinker URL Expresie regulată","AutoLinker_Email":"AutoLinker E-mail","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"legate automat de numere de telefon. de exemplu, `(123) 456-7890`","Auto_Load_Images":"Auto-încarcă imagini","Available":"Disponibil","Available_agents":"Agenți disponibili","Avatar":"Schimbare avatar","Avatar_changed_successfully":"Avatar schimbat cu succes","Avatar_URL":"URL Avatar ","Avatar_url_invalid_or_error":"URL-ul furnizat este invalid sau nu este accesibil. Vă rugăm să încercați din nou, dar cu o altă adresă URL.","away":"departe","Away":"Departe","away_female":"departe","Away_female":"Departe","away_male":"departe","Away_male":"Departe","Back":"Înapoi","Back_to_applications":"Înapoi la aplicații","Back_to_integrations":"Înapoi la integrări","Back_to_login":"Înapoi la autentificare","Back_to_permissions":"Înapoi la permisiuni","Body":"Corp","bold":"îngroșat","busy":"ocupat","Busy":"Ocupat","busy_female":"ocupat","Busy_female":"Ocupat","busy_male":"ocupat","Busy_male":"Ocupat","Cancel":"Anulează","Cannot_delete_a_protected_role":"Nu se poate șterge un rol protejat","Cannot_delete_role_because_its_in_use":"Nu se poate șterge rol, deoarece este în uz","Cannot_invite_users_to_direct_rooms":"Nu pot invita utilizatorii să direcționeze camere","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certificate și chei","Channel":"Canal","Channel_doesnt_exist":"Canalul `#%s` nu există.","Channels":"Canale","Channels_list":"Listă de canale publice","Chat_Rooms":"Camere de chat","Chatops_Enabled":"Activați Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Nume de ultilizator Chatops","Choose_a_room":"Alegeți o cameră","Choose_messages":"Alege mesaje","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Alege alias care va apărea în fața numelui de utilizator în mesaje.","Choose_the_username_that_this_integration_will_post_as":"Alege numele de utilizator cu care va posta această integrare.","Clear_all_unreads_question":"Ștergeți toate necitite?","Client_ID":"ID Client","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Clienții se va actualiza în câteva secunde","close":"închide","Closed":"Închis","Collapse_Embedded_Media_By_Default":"Colaps mass-media încorporate în mod implicit","coming_soon":"în curând","Commands":"Comenzi","Compact_View":"Vizualizare compactă","Confirm_password":"Confirmați parola","Contact":"Contact","Conversation":"Conversaţie","Convert_Ascii_Emojis":"Conversie ASCII în Emoji","Copied":"copiata","COPY_TO_CLIPBOARD":"COPIAȚI ÎN CLIPBOARD","Copy_to_clipboard":"Copiați în clipboard","Count":"Număr","Create":"Crea","Create_new":"Crează nou","Created_at":"Creat la","Created_at_s_by_s":"Creat la <strong>%s</strong> by <strong>%s</strong>","Custom_Fields":"câmpuri customizate","Custom_oauth_helper":"La configurarea furnizorul de OAuth, va trebui să apelați un URL de apel invers. Utilizați <pre>%s</pre>.","Custom_oauth_unique_name":"Nume unic OAuth personalizat","Custom_Script_Logged_In":"Script-ul personalizat pentru utilizatorii autentificați","Custom_Script_Logged_Out":"Script-ul personalizat pentru utilizatorii delogat","Dashboard":"Tablou de comandă","days":"zile","Deactivate":"Dezactivează","Debug_Level":"Debug Level","Default":"Implicit","Delete":"Șterge","Delete_my_account":"Șterge contul","Delete_Room_Warning":"Ștergerea unei camere va șterge toate mesajele postate în cameră. Acest lucru nu poate fi anulat.","Delete_User_Warning":"Ștergerea unui utilizator va șterge și toate mesajele acelui utilizator. Acest lucru nu poate fi anulat.","Deleted":"Șters!","Department_not_found":"Departamentul nu a fost găsit","Department_removed":"Departament eliminat","Departments":"Departamente","Description":"Descriere","Desktop":"Spațiul de lucru","Desktop_Notification_Test":"Test notificări desktop","Desktop_Notifications":"Notificări pe desktop","Desktop_Notifications_Disabled":"Notificările desktop sunt dezactivate. Schimbați preferințele browser-ului dacă aveți nevoie de notificări activate.","Desktop_Notifications_Enabled":"Notificări pe desktop sunt activate","Direct_message_someone":"Trimite un mesaj direct","Direct_Messages":"Mesaje directe","Direct_Messages_list":"Mesaje directe","Disable_Favorite_Rooms":"Dezactivați Favorite","Disable_New_Message_Notification":"Dezactivează notificările privind mesajele noi","Disable_New_Room_Notification":"Dezactivează notificările privind camere noi","Displays_action_text":"text Afișează acțiune","Do_you_want_to_change_to_s_question":"Doriți să modificați în <strong>%s</strong>?","Drop_to_upload_file":"Trageți fișierul aici pentru încărcare","Dry_run":"Dry run","Dry_run_description":"Va trimite un singur e-mail, la adresa specificată în CĂTRE. E-mail-ul trebuie să aparțină unui utilizator valid.","Duplicate_archived_channel_name":"Există în arhivă un canalul cu numele \"%s\"","Duplicate_archived_private_group_name":"Există în arhivă un grup privat cu numele ' %s' ","Duplicate_private_group_name":"Un grup privat cu numele ' %s' există deja","E-mail":"E-mail","Edit":"Editează","Edit_Custom_Field":"Edita Câmp personalizat","Edit_Department":"Editează departament","edited":"editat","Email":"E-mail","Email_already_exists":"Adresa de e-mail există deja","Email_body":"Corp E-mail","Email_Change_Disabled":"Administratorul Rocket.Chat a dezactivat schimbarea email-ului","Email_from":"De la","Email_Notification_Mode":"Notificări prin e-mail offline","Email_Notification_Mode_All":"Toate mențiunile/Mesajele directe","Email_Notification_Mode_Disabled":"Dezactivat","Email_or_username":"Adresă de e-mail sau nume de utilizator","Email_subject":"Subiect","Email_verified":"Email verificat","Emoji":"Emoji","Empty_title":"Titlu gol","Enable":"Activează","Enable_Desktop_Notifications":"Activați notificări pe desktop","Enabled":"Activat","Encrypted_message":"mesajul criptata","End_OTR":"Sfârșitul OTR","Enter_a_regex":"Introduceți un regex","Enter_a_room_name":"Introduceți un nume de cameră","Enter_a_username":"Introduceți un nume de utilizator","Enter_info":"Introduceți informațiile dumneavoastră","Enter_name_here":"Introdu numele aici","Enter_to":"Enter pentru a","Error":"Eroare","error-cant-invite-for-direct-room":"Nu poate fi invitat la camere directe","error-duplicate-channel-name":"Un canal cu numele \" %s\" există deja","error-invalid-custom-field":"câmp personalizat nevalid","error-invalid-custom-field-name":"Nume câmp personalizat nevalid. Utilizați numai litere, cifre, cratime și subliniere.","error-invalid-password":"Parolă Invalidă","error-invalid-room":"cameră nevalid","error-invalid-room-name":"<strong> %s</strong> nu este un nume de cameră valid, <br/> folosiți litere numai, numere, cratime și subliniere","error-invalid-user":"Utilizator incorect","error-invalid-username":"Nume de utilizator invalid","error-not-allowed":"Nepermis","error-not-authorized":"Neautorizat","error-remove-last-owner":"Acesta este ultimul proprietar. Vă rugăm să setați un nou proprietar înainte de a elimina pe aceasta.","error-role-name-required":"Este necesar numele rol","error-user-not-in-room":"Utilizator nu este în această cameră","Error_changing_password":"Eroare la schimbarea parolei","Error_sending_confirmation_email":"Eroare la trimiterea de e-mail de confirmare","Error_too_many_requests":"Eroare, prea multe cereri. Vă rugăm să încetinți. Trebuie să așteptați %s secunde înainte de a încerca din nou","Esc_to":"Esc pentru a","Example_s":"Exemplu: <code class=\"inline\">%s</code>","False":"Fals","Favorites":"Favorite","Field":"Camp","Field_removed":"câmp îndepărtat","File_exceeds_allowed_size_of_bytes":"Fișier depășește dimensiunea permis de bytes __size__","FileUpload":"Încărcare fișier","FileUpload_Enabled":"Încărcarea de fișiere activată","FileUpload_File_Empty":"Fișier gol","FileUpload_FileSystemPath":"Cale sistem","FileUpload_MaxFileSize":"Dimensiune maximă a fișierului (în bytes)","FileUpload_MediaType_NotAccepted":"Tipuri de media ne-acceptate","FileUpload_MediaTypeWhiteList":"Tipuri de media acceptate","FileUpload_MediaTypeWhiteListDescription":"Lista separată cu virgule a tipuri de media. Lăsați necompletat pentru a accepta toate tipurile de media.","FileUpload_ProtectFiles":"Protejare fișiere încărcate","FileUpload_ProtectFilesDescription":"Doar utilizatorii autentificați vor avea acces","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"numele cupă pentru excavat Amazon S3","FileUpload_S3_BucketURL":"URL-cupă pentru excavat","FileUpload_S3_CDN":"Domeniul CDN pentru descărcări","FileUpload_S3_Region":"Regiune","FileUpload_Storage_Type":"Tip de stocare","Flags":"Steaguri","Follow_social_profiles":"Urmăriți conturile noastre sociale, \"fork\" proiectul pe GitHub și împărtășiți părerile despre rocket.chat pe board-ul nostru de trello.","Food_and_Drink":"Mâncare & băutură","For_your_security_you_must_re_enter_your_password_to_continue":"Pentru siguranța dumneavoastră, e necesar să reintroduceți parola","Force_SSL":"Forțează SSL","Force_SSL_Description":"* Atenție! * _Force SSL_ nu ar trebui să fie utilizat cu proxy invers. Dacă aveți un proxy invers, ar trebui să faceți redirecționării acolo. există această opțiune pentru implementări cum ar fi Heroku, care nu permite configurarea redirectare la proxy inversă.","Forgot_password":"Parolă uitată","Fork_it_on_github":"\"Fork\" proiectul pe GitHub","Frequently_Used":"Frecvent folosite","From":"De la","From_Email":"E-mail de la","From_email_is_required":"E nevoie de adresa de email \"De la\"","From_email_warning":"b>Atenție</b>:Câmpul <b>De la</b> depinde de setările serverului dumneavoastră de email.","General":"General","Get_to_know_the_team":"Faceți cunoștință cu Rocket.Team","github_no_public_email":"Nu aveți nici un e-mail setat ca e-mail public în contul dumneavoastră GitHub","Give_a_unique_name_for_the_custom_oauth":"Alegeți un nume unic pentru OAuth personalizat","Give_the_application_a_name_This_will_be_seen_by_your_users":"Da aplicației un nume. Acest lucru va fi văzut de utilizatori.","Global":"Global","GoogleTagManager_id":"ID Google Manager de etichete","Has_more":"Are mai multe","Have_your_own_chat":"Avea propriul dumneavoastră web chat. Scris folosind Meteor.com, Rocket.Chat este o soluție excelentă pentru developerii care vor să construiască și să dezvolte platforma lor de chat.","Header":"Antet","Hidden":"Ascuns","Hide_Group_Warning":"Sunetți sigur că vreți să ascundeți grupul?","Hide_Private_Warning":"Sunteți sigur că vreți să ascundeți discuția?","Hide_room":"Ascunde camera","Hide_Room_Warning":"Sunteți sigur că vreți să ascundeți camera?","Highlights":"Repere","Highlights_How_To":"Pentru a fi notificat atunci când cineva menționează un cuvânt sau o expresie, adăugați-l aici. Puteți separa cuvinte sau fraze cu virgulă. Cuvintele de evidențiere nu sunt sensibile la majuscule.","Highlights_List":"cuvinte de evidențiere","History":"Istoric","hours":"ore","How_friendly_was_the_chat_agent":"Cât de prietenos  a fost agentul de chat?","How_knowledgeable_was_the_chat_agent":"Cât de informat a fost agentul de chat?","How_responsive_was_the_chat_agent":"Cât de rapid a fost agentul de chat?","How_satisfied_were_you_with_this_chat":"Cât de mulțumit sunteți de acest chat?","If_you_are_sure_type_in_your_password":"Dacă sunteți sigur că tipul în parola:","If_you_are_sure_type_in_your_username":"Dacă sunteți sigur că tipul numele de utilizator:","Importer_Archived":"Arhivat","Importer_done":"Import complet!","Importer_finishing":"Se finalizează import.","Importer_From_Description":"Importuri __from __ 's date în Rocket.Chat.","Importer_import_cancelled":"Import anulat.","Importer_import_failed":"A Apărut o eroare în timpul importului.","Importer_importing_channels":"Se importă canalele.","Importer_importing_messages":"Se imoprtă mesajele.","Importer_importing_started":"Începe importarea.","Importer_importing_users":"Importarea utilizatorilor.","Importer_not_defined_properly":"Importatorul nu a fost definit corect, acesta lipseste din clasa de import.","Importer_not_in_progress":"Importatorul este în prezent nu rulează.","Importer_Prepare_Restart_Import":"Reîncepe import","Importer_Prepare_Start_Import":"Începe import","Importer_Prepare_Uncheck_Archived_Channels":"Canale debifează arhivate","Importer_Prepare_Uncheck_Deleted_Users":"Utilizatorii debifează au fost șterse","Importer_progress_error":"Nu a reușit pentru a obține progresul pentru import.","Importer_setup_error":"A apărut o eroare la înființarea importatorului.","Incorrect_Password":"Parolă incorectă","inline_code":"inline_code","Install_Extension":"Instalați extensie","Install_FxOs":"Instalați Rocket.Chat pe Firefox","Install_FxOs_done":"Grozav! Acum puteți folosi Rocket.Chat atingând pictograma de pe ecranul de start. Distrează-te cu Rocket.Chat!","Install_FxOs_error":"Ne pare rău, lucrurile n-au mers bine! Următoarea eroare a apărut:","Install_FxOs_follow_instructions":"Vă rugăm să confirmați instalarea aplicației pe dispozitiv (apăsați \"Install\" când vi se solicită).","Installation":"Instalare","Integration_added":"Integrarea a fost adăugată","Integration_Incoming_WebHook":"Integrare Intrare WebHook","Integration_New":"Integrare nouă","Integration_Outgoing_WebHook":"Integrarea WebHook de ieșire","Integration_updated":"Integrarea a fost actualizată","Integrations":"Integrări","Invalid_asset":"Resursă invalidă","Invalid_confirm_pass":"Confirmarea parolei nu se potrivește cu parola introdusă","Invalid_email":"Adresa de email folosită este invalidă","Invalid_Export_File":"Fișierul încărcat nu este un fișier valid de export.","Invalid_file_height":"Înălțime fișier invalidă.","Invalid_file_type":"Tip de fișier invalid","Invalid_file_width":"Lățime fișier invalidă","Invalid_Import_File_Type":"Tip fișier de date invalid.","Invalid_name":"Câmpul nume de utilizator nu poate fi gol","Invalid_notification_setting_s":"Setare notificare nevalidă: %s","Invalid_pass":"Câmpul de parolă nu poate fi gol","Invalid_room_name":"<strong>%s</strong> nu este un nume de cameră valid,<br/> folosiți doar litere, cifre și cratimă","Invalid_room_type":"<strong>%s</strong> nu e un nume de cameră valid.","Invalid_Secret_URL":"URL secret invalid","Invalid_secret_URL_message":"URL-ul furnizat este invalid.","invisible":"invizibil","Invisible":"Invizibil","Invitation_HTML":" HTML Invitație","Invitation_Subject":"Subiect Invitație ","Invite_user_to_join_channel":"Invitați un utilizator să se alăture acestui canal","Invite_Users":"Invitați utilizatori","is_also_typing":"tastează","is_also_typing_female":"tastează","is_also_typing_male":"tastează","is_typing":"tastează","is_typing_female":"tastează","is_typing_male":"tastează","italics":"cursive","join":"Alăturați-vă","Join_audio_call":"Intră în apel audio","Join_the_Community":"Intrați în comunitate","Join_the_given_channel":"Intrați pe canalul specificat","Join_video_call":"Intră în apel video","Joined":"Inregistrat pe","Jump":"A sari","Jump_to_first_unread":"Salt la primul mesaj necitit","Jump_to_message":"Salt la mesaj","Jump_to_recent_messages":"Salt la mesajele recente","Katex_Enabled":"Katex activat","Label":"Eticheta","Language":"Limba","Language_Version":"Versiunea în limba Română","Last_login":"Ultima autentificare","Last_message":"Ultimul mesaj","Last_seen":"Ultima dată online","Layout":"Layout","Layout_Home_Body":"Corp pagină 'Acasă'","Layout_Home_Title":"Titlu pagină 'Acasă'","Layout_Login_Terms":"Termeni Autentificare","Layout_Privacy_Policy":"Politica de confidențialitate","Layout_Sidenav_Footer":"Footer meniu lateral","Layout_Sidenav_Footer_description":"Dimensiunea footer-ului este de 260 x 70px","Layout_Terms_of_Service":"Condții de utilizare","LDAP":"LDAP","LDAP_CA_Cert":"Certificat CA","LDAP_Custom_Domain_Search":"Căutare în domeniu personalizat","LDAP_Custom_Domain_Search_Description":"O bucată de JSON care guvernează leagă și conexiunea info și este de forma: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domeniu implicit","LDAP_Description":"LDAP este o bază de date ierarhică pe care multe companii o folosesc pentru a oferi osingură  parolă pe mai multe site-uri și servicii. Pentru informații și exemple de configurare avansate, vă rugăm să consultați wiki nostru: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Baza domeniului","LDAP_Domain_Base_Description":"Numele complet calificat distinctiv (DN) al unui subramificație LDAP pe care doriți să căutați utilizatori și grupuri. Puteți adăuga oricât de multe doriți; cu toate acestea, fiecare grup trebuie să fie definite în același domeniu de bază ca și utilizatorii care îi aparțin. Dacă precizați grupurile de utilizatori sunt restricționate, numai utilizatorii care fac parte din aceste grupuri vor fi în domeniul de aplicare. Vă recomandăm să specificați nivelul superior al arborelui dvs. de director LDAP ca baza domeniului dvs. și utilizați filtrul de căutare pentru a controla accesul.","LDAP_Domain_Search_Filter":"Filtru Căutare Domeniu","LDAP_Domain_Search_Filter_Description":"Dacă se specifică, numai utilizatorii care se potrivesc cu acest filtru va fi permis să te loghezi. Dacă nu este specificat nici un filtru, toți utilizatorii din domeniul de aplicare al bazei domeniului specificat va fi capabil să se conecteze. <br/> De exemplu, pentru Active Directory `memberOf = cn = ROCKET_CHAT, ou = generalul Groups`. <br/> De exemplu, pentru OpenLDAP (căutare meci extensibil) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domeniul Cautare Obiect Categorie","LDAP_Domain_Search_Object_Category_Description":"* De * objectCategory care identifica utilizatorii. <br/> Lasă un gol pentru * OpenLDAP *. <br/> De exemplu, `person` etc.","LDAP_Domain_Search_Object_Class":"Domeniul de clasă căutare Obiect","LDAP_Domain_Search_Object_Class_Description":"* De * objectclass care identifica utilizatorii. <br/> De exemplu, `organizationalPerson`,` utilizator al, `inetOrgPerson` etc.","LDAP_Domain_Search_Password":"Parolă căutare domeniu","LDAP_Domain_Search_Password_Description":"Parola pentru utilizatorul căutării domeniu","LDAP_Domain_Search_User":"Utilizator căutare domeniu","LDAP_Domain_Search_User_Description":"Utilizatorul LDAP care efectuează căutări de utilizator pentru autentificarea altor utilizatori atunci când se conectează. <br/> Aceasta este de obicei un cont de serviciu special creat pentru integrările terțe părți. Utilizați un nume complet calificat, cum ar fi `cn = Administrator, cn = Users, dc = Exemplu, dc = com`.","LDAP_Domain_Search_User_ID":"Domeniul de căutare ID utilizator","LDAP_Domain_Search_User_ID_Description":"Acest atribut LDAP care identifică utilizatorul LDAP care încearcă autentificarea. Acest câmp ar trebui să fie `sAMAccountName` pentru instalații de cele mai multe Active Directory, dar poate fi` uid` pentru alte soluții LDAP, cum ar fi OpenLDAP. Aveți posibilitatea să utilizați `mail` pentru a identifica utilizatorii prin e-mail sau orice atribut pe care doriți. <br> Puteți utiliza valori multiple, separate prin virgula pentru a permite utilizatorilor să te autentifici folosind mai mulți identificatori, cum ar fi numele de utilizator sau e-mail.","LDAP_Enable":"Activați","LDAP_Enable_Description":"Încearcă să utilizezi LDAP pentru autentificare.","LDAP_Encryption":"Encriptare","LDAP_Encryption_Description":"Metoda de criptare utilizată pentru a securiza comunicațiile către serverul LDAP. Exemplele includ `plain` (fără criptare),` SSL / LDAPS` (criptat de la început), iar `StartTLS` (upgrade la comunicații criptate o dată conectat).","LDAP_Host":"Gazdă","LDAP_Host_Description":"Gazda LDAP  e.g. `ldap.example.com` sau `10.0.0.30`.","LDAP_Port":"Port","LDAP_Port_Description":"Port pentru a accesa LDAP. De exemplu: '389' sau '636' pentru LDAPS","LDAP_Reject_Unauthorized":"Respinge neautorizat","LDAP_Sync_User_Avatar":"Sincronizare Avatar utilizator","LDAP_Sync_User_Data":"Sync Data","LDAP_Sync_User_Data_Description":"Păstrați datele utilizatorului în sincron cu serverul de autentificare (de exemplu: nume, e-mail).","LDAP_Sync_User_Data_FieldMap":"User Data Field Map","LDAP_Sync_User_Data_FieldMap_Description":"Configurați modul în care detalii ale contului de utilizator (cum ar fi e-mail-ul) sunt populate de o înregistrare LDAP (odată găsită).<br/> De exemplu, {\"cn\": \"Numele\", \"e-mail\": \"e-mail\"} va alege numele unei persoane ce poate fi citit de la atributul cn, și e-mail lor de atributul e-mail. <br/>Detaliile disponibile includ numele și e-mail.","LDAP_Sync_Users":"Sincronizează utilizatori","LDAP_Test_Connection":"Test conexiune","LDAP_Unique_Identifier_Field":"Identificator unic câmp","LDAP_Unique_Identifier_Field_Description":"Care câmp va fi folosit pentru a lega utilizatorul LDAP și utilizatorul Rocket.Chat. Vă poate informa cu valori multiple, separate prin virgula pentru a încerca pentru a obține valoarea de înregistrare LDAP. <br/> Valoarea implicită este `objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Folosește Căutare Domeniu Specific","LDAP_Use_Custom_Domain_Search_Description":"Scrie propriul filtru pentru utilizatorii caută în serverul LDAP.","LDAP_Username_Field":"Câmp utilizator","LDAP_Username_Field_Description":"Care câmp va fi folosit ca nume de utilizator * * pentru noii utilizatori. Lasă un gol pentru a utiliza numele de utilizator informat pe pagina de conectare. <br/> Aveți posibilitatea să utilizați etichete șablon prea, cum ar fi `# {} givenName. # {Sn}`. <br/> Valoarea implicită este `sAMAccountName`.","Leave_Group_Warning":"Sunteți sigur că vreți să părăsiți grupul?","Leave_Private_Warning":"Sunteți sigur că vreți să părăsiți discuția?","Leave_room":"Părăsește camera","Leave_Room_Warning":"Sunteți sigur că vreți să părăsiți camera?","line":"linie","List_of_Direct_Messages":"Listă mesaje directe","Live_sessions":"Sesiuni live","Livechat_agents":"Agenți Livechat","Livechat_Dashboard":"Tabloul de bord Livechat","Livechat_enabled":"Livechat activat","Livechat_Manager":"Manager Livechat","Livechat_managers":"Manageri Livechat","Livechat_title":"Titlu Livechat","Livechat_title_color":"Culoare de fundal titlu Livechat ","Livechat_Users":"Utilizatorii Livechat","Load_more":"Încarcă mai multe","Loading...":"Se încarcă...","Loading_more_from_history":"Se încarcă mai multe din istoric","Loading_suggestion":"Se încarcă sugestii...","Localization":"Localizare","Log_File":"Arată Fișier și Linie","Log_Level":"Nivel Log","Log_Package":"Arată pachet","Log_View_Limit":"Limită vizualizare log-uri","Logged_out_of_other_clients_successfully":"Delogat cu succes din alți clienți","Login":"Autentificare","Login_with":"Autentifică-te cu %s","login_with":"Sau conectare direct cu","Logout":"Ieșire","Logout_Others":"Delogare din celelalte locații","Mail_Message_Invalid_emails":"Ați furnizat unul sau mai multe e-mailuri invalide: %s","Mail_Message_Missing_to":"Trebuie să furnizați una sau mai multe adrese de e-mail pentru 'Către', separate prin virgulă.","Mail_Message_No_messages_selected_select_all":"Nu ați selectat niciun mesaj. Aţi dori să <a href='#' class='select-all'>selctați toate</a> mesajele vizibile?","Mail_Messages":"Mesaje Email","Mail_Messages_Instructions":"Alegeți ce mesaje doriți să trimiteți prin e-mail făcând clic pe ele","Mail_Messages_Subject":"Iată o parte din %s mesaje","Mailer":"Mailer","Mailer_body_tags":"<b>Trebuie</b> să folosiți [unsubscribe] pentru link-ul de unsuscribe.<br />Puteți utiliza [name], [fname], [lname] pentru numele întreg, prenume respectiv nume.<br />Puteți folosi [email] pentru e-mailul utilizatorului.","Make_Admin":"Fă utilizator de tip Admin","Manager_added":"Manager adăugat","Manager_removed":"Manager eliminat","Mark_as_read":"Marchează ca citit","Markdown_Headers":"Markdown Headers","Markdown_SupportSchemesForLink":"Scheme de sprijin pentru Markdown Link","Markdown_SupportSchemesForLink_Description":"Lista de elemente separate prin virgulă de scheme permise","Members_List":"Lista de membri","Mentions":"Mențiuni","Mentions_default":"Mențiuni (implicit","Message":"Mesaj","Message_AllowDeleting":"Permiteți ștergerea mesajului","Message_AllowEditing":"Permiteți editarea mesajului","Message_AllowEditing_BlockEditInMinutes":"Blocare editare mesaje după (n) minute","Message_AllowEditing_BlockEditInMinutesDescription":"Introduceți 0 pentru a dezactiva blocarea.","Message_AllowPinning":"Permiteți fixarea mesajului","Message_AllowPinning_Description":"Permite fixarea mesajelor în oricare canal.","Message_AllowStarring":"Permiteți însemnarea cu steluță a mesajelor","Message_AudioRecorderEnabled":"Audio Recorder Activat","Message_AudioRecorderEnabledDescription":"Necesită \"/ WAV audio\" să fie un tip de media acceptat în setările \"upload\".","Message_DateFormat":"Formatul datei","Message_deleting_not_allowed":"Nu e permisă ștergerea de mesaje","Message_editing_blocked":"Acest mesaj nu mai poate fi editat","Message_editing_not_allowed":"Nu e permisă editarea de mesaje","Message_GroupingPeriod":"Perioadă pentru grupare (în secunde)","Message_GroupingPeriodDescription":"Mesajele vor fi grupate cu mesajul anterior dacă sunt de la același utilizator și timpul scurs a fost mai mic decât perioada pentru grupare în secunde.","Message_KeepHistory":"Păstrează istoricul mesajelor","Message_MaxAllowedSize":"Dimensiunea maximă admisă Mesaj","Message_MaxAll":"Dimensiunea maximă a canalului pentru mesajul ALL","Message_pinned":"Mesaj fixat","Message_pinning_not_allowed":"Nu e permisă fixarea de mesaje","Message_removed":"Mesaj eliminat","Message_ShowDeletedStatus":"Afișare starea de ștergere","Message_ShowEditedStatus":"Afișează starea de editare","Message_ShowFormattingTips":"Arată sugestii de formatare","Message_TimeFormat":"Format oră","Message_TimeFormat_Description":"A se vedea , de asemenea: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Mesaj prea lung","Messages":"Mesaje","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Mesajele care sunt trimise prin WebHook vor fi postate aici.","Meta":"Meta","Meta_fb_app_id":"Facebook App ID","Meta_google-site-verification":"Google Site Verification","Meta_language":"Limba","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Roboți","minutes":"minute","Mobile_push":"împinge mobil","More_channels":"Mai multe canale","More_direct_messages":"Mai multe mesaje directe","More_groups":"Mai multe grupuri private","More_unreads":"Mai multe necitite","Msgs":"Mesaje","multi":"multi","Mute_someone_in_room":"Blocați noi mesaje ale cuiva în cameră","Mute_user":"Blochează mesajele utilizatorului","Muted":"Silențios","My_Account":"Contul meu","n_messages":"%s mesaje","N_new_messages":" %s noi mesaje","Name":"Nume","Name_cant_be_empty":"Numele nu poate fi gol","Name_of_agent":"Numele agentului","Name_optional":"Nume (opțional)","Navigation_History_20_last_pages":"Istoria de navigare (ultimele 20 de pagini)","New_Application":"Aplicație nouă","New_Custom_Field":"Câmp personalizat nou","New_Department":"Departament nou","New_integration":"Integrare nouă","New_logs":"busteni noi","New_messages":"Mesaje noi","New_password":"Parolă nouă","New_role":"Rol nou","No_channel_with_name_%s_was_found":"Niciun canal găsit cu numele <strong>\"%s\"</strong>!","No_channels_yet":"Încă nu faceți parte din niciun canal.","No_direct_messages_yet":"Încă nu ați inițiat nicio conversație.","No_Encryption":"Nicio encriptare","No_favorites_yet":"Încă nu ați adăugat niciun canal favorit.","No_group_with_name_%s_was_found":"Niciun grup privat găsit cu numele <strong>\"%s\"</strong>!","No_groups_yet":"Încă nu aveți niciun grup privat.","No_livechats":"Nu aveți livechats.","No_mentions_found":"Nicio mențiune găsită","No_permission_to_view_room":"Nu aveți permisiunea de a vedea această cameră","No_pinned_messages":"Nu sunt mesaje fixate","No_results_found":"Niciun rezultat găsit","No_starred_messages":"Niciun mesaj cu stea","no_tokens_for_this_user":"Nu există tokens pentru acest utilizator.","No_user_with_username_%s_was_found":"Niciun utilizator găsit cu numele de utilizator <strong>\"%s\"</strong>!","Not_allowed":"Nepermis","Not_authorized":"Neautorizat","Not_Available":"Nu e disponibil","Not_found_or_not_allowed":"Nu a fost găsit sau nu e permis","Nothing":"Nimic","Nothing_found":"Nu s-a găsit nimic","Notifications":"notificările","Notify_all_in_this_room":"Notifică toți utilizatorii din această cameră","Num_Agents":"# Agenți","Number_of_messages":"Numărul de mesaje","OAuth_Application":"Aplicație OAuth","OAuth_Applications":"Aplicații OAuth","Objects":"Obiecte","Off_the_record_conversation":"Off-the-record conversație","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record de conversație nu este disponibilă pentru browser-ul sau dispozitivul.","Offline_DM_Email":"[__site__] Ai fost messaged directe de __user__","Offline_Mention_Email":"[__site__] Ați fost menționat de către __user__ în #__room__","Old_and_new_password_must_be_different":"Noua parolă trebuie să fie diferită de cea veche","Old_and_new_password_required":"Trebuie să introduceți și parola veche și cea nouă pentru a schimba parola.","Online":"Activ","Only_errors":"Doar erori","Only_you_can_see_this_message":"Doar dumneavoastră puteți vedea acest mesaj","Oops!":"Oops","Open":"Deschis","Opened":"Deschis","Opt_out_statistics":"Nu trimiteți statisticile mele la Rocket.Chat","Opt_out_statistics_warning":"Prin trimiterea statisticilor, veți ajuta să identificăm modul în care e utilizat Rocket.Chat, precum și cât de bine se comportă sistemul, astfel încât să putem îmbunătăți în continuare aplicația. Nu vă faceți griji, nu se trimit informații despre utilizatori și toate informațiile pe care le primim sunt păstrate în mod confidențial. Dacă doriți să continuați a ne trimite statisticile, debifați caseta de selectare de mai sus. Mulțumim.","optional":"facultativ","Order":"Sortare","OS_Arch":"OS Arch","OS_Cpus":"OS număr CPU ","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Media","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Total Memory","OS_Type":"Tip sistem de operare","OS_Uptime":"OS Uptime","others":"alți","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR este disponibilă numai atunci când ambii utilizatori sunt online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"URL-ul supracontrol la care sunt încărcate fișiere. Această adresă URL, de asemenea, utilizat pentru download-uri decât dacă o CDN este dată","Password":"Parolă","Password_Change_Disabled":"Administratorul a dezactivat schimbarea de parole","Password_changed_successfully":"Parola a fost schimbată cu succes","Payload":"Încărcătură utilă","People":"Oameni","Permissions":"Permisiuni","Pin_Message":"Fixează mesaj","Pinned_a_message":"Pinned un mesaj:","Pinned_Messages":"Mesaje fixate","Placeholder_for_email_or_username_login_field":"Substituent pentru câmpul de e-mail sau numele de utilizator de conectare","Placeholder_for_password_login_field":"Substituent pentru câmpul de autentificare a parolei","Please_answer_survey":"Vă rugăm să acordați un moment pentru a răspunde la un sondaj rapid despre acest chat","Please_enter_value_for_url":"Vă rugăm să introduceți o valoare pentru adresa URL a avatarului.","Please_enter_your_new_password_below":"Vă rugăm să introduceți noua parolă mai jos:","Please_fill_a_label":"Vă rugăm să completați o etichetă","Please_fill_a_name":"Vă rugăm să completați un nume","Please_fill_a_username":"Vă rugăm să completați un nume de utilizator","Please_fill_name_and_email":"Vă rugăm să completați numele și e-mail","Please_re_enter_your_password":"Vă rugăm re-introduceți parola","Please_select_enabled_yes_or_no":"Vă rugăm să selectați o opțiune pentru Enabled","Please_wait":"Vă rugăm așteptați","Please_wait_activation":"Vă rugăm să așteptați, acest lucru poate dura ceva timp.","Please_wait_statistics":"Vă rugăm să așteptați, statisticile sunt generate.","Please_wait_while_OTR_is_being_established":"Vă rugăm să așteptați în timp ce OTR este stabilită","Please_wait_while_your_account_is_being_deleted":"Vă rugăm să așteptați în timp ce contul dvs. este șters ...","Please_wait_while_your_profile_is_being_saved":"Vă rugăm așteptați până ce profilul dumneavoastră se slavează...","Post_as":"Publică drept","Post_to_Channel":"Publică pe canal","Post_to_s_as_s":"Publică în <strong>%s</strong> as <strong>%s</strong>","Powered_by":"Oferit de","Preferences":"Preferințe","Preferences_saved":"Preferințe salvate","Privacy":"Confidențialitate","Private_Group":"Grup privat","Private_Groups":"Grupuri private","Private_Groups_list":"Lista grupurilor private","Profile":"Profil","Profile_saved_successfully":"Profil salvat cu succes","Proudly_developed":"Scris cu mândrie folosind Meteor","Push":"Notificări Push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Depanare","push_disabled":"Push dezactivat","Push_enable":"Activează","Push_enable_gateway":"Activați Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Project Number","Push_production":"Producție","Push_show_message":"Afișați mesajul în notificare","Push_show_username_room":"Afișează canalul / grup / nume de utilizator în notificare","Push_test_push":"Test","Query":"Interogare","Query_description":"Condiții suplimentare pentru a determina către ce utilizatori se trimite e-mail. Utilizatorii dezabonați sunt eliminați automat din interogare. Trebuie să fie un JSON valid. Exemplu: \"{\" createdAt \": {\" $ GT \": {\" $ data \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Cautare rapida","quote":"citat","Reactions":"Reacții","Recents":"Recente","Record":"Înregistrează","Redirect_URI":"Redirecționare URI","Refresh_keys":"tastele de reîmprospătare","Refresh_your_page_after_install_to_enable_screen_sharing":"Reîncarcă pagina după instalare pentru a permite partajarea de ecran","Register":"Înregistrează un cont nou","Registration_Succeeded":"Înregistrarea a reușit","Remember_me":"Ține-mă minte","Remove":"Elimină","Remove_Admin":"Eliminați utilizator de tip Admin","Remove_as_moderator":"Eliminați ca moderator","Remove_as_owner":"Eliminați ca proprietar","Remove_custom_oauth":"Eliminați OAuth personalizat","Remove_from_room":"Eliminați din cameră","Remove_someone_from_room":"Scoateți pe cineva din camera","Removed":"Eliminat","Require_password_change":"Cere schimbarea parolei","Resend_verification_email":"Retrimite email-ul de verificare","Reset":"Reset","Reset_password":"Resetează parola","Restart":"Repornire","Restart_the_server":"Reporniți serverul","RocketBot_Enabled":"RocketBot Activat","RocketBot_Name":"Nume RocketBot","RocketBot_Name_Description":"Numele RocketBot trebuie să fie un nume de utilizator valid înregistrat pe server.","Role":"Rol","Role_Editing":"Editare rol","Role_removed":"Rol eliminat","Room":"Cameră","Room_archivation_state":"Stare","Room_archivation_state_false":"Activă","Room_archivation_state_true":"Arhivată","Room_archived":"Cameră arhivată","room_changed_privacy":"Tipul camerei schimbat în: <em>__room_type__</em> de către <em>__user_by__</em>","room_changed_topic":"Subiectul camerei schimbat în: <em>__room_topic__</em> de către <em>__user_by__</em>","Room_has_been_deleted":"Camera a fost ștearsă","Room_Info":"Info cameră","Room_name_changed":"Numele camerei a fost schimbat în: <em>__room_name__</em> de către <em>__user_by__</em>","Room_name_changed_successfully":"Numele camerei a fost schimbat cu succes.","Room_not_found":"Camera nu a fost găsită","Room_topic_changed_successfully":"Subiectul camerei a fost schimbat cu succes.","Room_type_changed_successfully":"Tipul de cameră a fost schimbat cu succes","Room_unarchived":"Cameră dezarhivată","Room_uploaded_file_list":"Lista de fișiere","Room_uploaded_file_list_empty":"Niciun fișier disponibil.","room_user_count":"%s utilizatorii","Rooms":"Camere","S_new_messages_since_s":"%s mesaje noi de la %s","SAML":"SAML","SAML_Custom_Cert":"Custom Certificate","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Generate Username","SAML_Custom_Issuer":"Custom Issuer","SAML_Custom_Provider":"Custom Provider","Save":"Salvează","Save_changes":"Salvează modificările","Save_Mobile_Bandwidth":"Economisește lățime de bandă în modul Mobile","Save_to_enable_this_action":"Salvați pentru a activa această acțiune","Saved":"Salvat","Saving":"Salvare...","Scope":"domeniu","Screen_Share":"Partajare ecran","Script_Enabled":"script-ul activat","Search":"Căutare","Search_by_username":"Căutare după nume de utilizator","Search_Channels":"canale de căutare","Search_Direct_Messages":"Căutare mesaje directe","Search_Messages":"Căutare mesaje","Search_Private_Groups":"Căutare Grupuri private","Search_settings":"Setări de căutare","seconds":"secunde","See_all":"Vedeți tot","See_only_online":"Doar online","Select_a_department":"Selectați un departament","Select_an_avatar":"Selectați un avatar","Select_file":"Selectați fișierul","Select_service_to_login":"Selectați un serviciu pentru a vă conecta pentru a încărca fotografia dumneavoastră de profil sau încărcați una direct de pe computer","Select_user":"Selectați utilizator","Select_users":"selectaţi utilizatori","Selected_agents":"Agenți selectați","Selected_users":"Membri selectați","Send":"Trimite","Send_a_message":"Trimite un mesaj","Send_a_test_mail_to_my_user":"Trimite un e-mail de test pentru utilizator meu","Send_a_test_push_to_my_user":"Trimite Push de test pentru utilizator meu","Send_confirmation_email":"Trimite email de confirmare","Send_data_into_RocketChat_in_realtime":"Trimite datele înspre Rocket.Chat în timp real.","Send_email":"Trimite email","Send_invitation_email":"Trimite e-mail de invitație","Send_invitation_email_error":"Nu ați furnizat nici o adresă de e-mail validă.","Send_invitation_email_info":"Puteți trimite mai multe invitații de e-mail odată.","Send_invitation_email_success":"Ați trimis cu succes o invitație de e-mail la următoarele adrese:","Send_invitation_email_warning":"Pentru a trimite invitații e-mail, trebuie să configurați mai întâi setările SMTP.","Send_Message":"Trimite mesaj","Send_your_JSON_payloads_to_this_URL":"Trimiteți JSON către această adresă URL.","Sending":"Se trimite ...","Set_as_moderator":"Setați ca moderator","Set_as_owner":"Setați ca proprietar","Settings":"Setări","Settings_updated":"Setări actualizare","Should_be_a_URL_of_an_image":"Ar trebui să fie o adresă URL a unei imagini.","Should_exists_a_user_with_this_username":"Trebuie să existe deja un utilizator cu acest nume de utilizator.","Show_all":"Arată tot","Show_more":"Arată mai mult","Show_only_online":"Arată doar online","Show_preregistration_form":"Arată formularul de pre-înregistrare","Showing_archived_results":"<p>Se arată <b>%s</b> rezultate arhivate</p>","Showing_online_users":"Se afișează <b>__total_showing__</b> din __total__ users","Showing_results":"<p>Se afișează <b>%s</b> rezultate</p>","Silence":"Tăcere","since_creation":"de la %s","Site_Name":"Numele site-ului","Site_Url":"URL-ul site-ului","Site_Url_Description":"Exemplu: https://chat.domain.com/","Skip":"Sari peste asta","Smileys_and_People":"Zâmbete & oameni","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP Password","SMTP_Port":"Port SMTP","SMTP_Test_Button":"Setări SMTP de testare","SMTP_Username":"Nume de utilizator SMTP ","Sound":"Sunet","Star_Message":"Marchează cu stea mesajul","Starred_Messages":"Mesaje cu stea","Start_audio_call":"Pornește apel audio","Start_Chat":"Start chat","Start_of_conversation":"Începutul conversației","Start_OTR":"OTR start","Start_video_call":"Pornește apel video","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Începe cu <code class=\"inline\">%s</code> pentru utilizator sau <code class=\"inline\">%s</code> pentru canal. Ex: <code class=\"inline\">%s</code> sau <code class=\"inline\">%s</code>","Statistics":"Statistici","Stats_Active_Users":"Utilizatori activi","Stats_Avg_Channel_Users":"Medii utilizatori canal","Stats_Avg_Private_Group_Users":"Medie utilizatori grup privat","Stats_Away_Users":"Utilizatori Away","Stats_Max_Room_Users":"Maximum număr de utilizatori în cameră","Stats_Non_Active_Users":"Utilizatori inactivi","Stats_Offline_Users":"Utilizatori offline","Stats_Online_Users":"Utilizatori Activi","Stats_Total_Channels":"Total Canale","Stats_Total_Direct_Messages":"Total camere mesaje directe","Stats_Total_Messages":"Numărul total de mesaje","Stats_Total_Private_Groups":"Total grupuri private","Stats_Total_Rooms":"Total camere","Stats_Total_Users":"Utilizatori","Stop_Recording":"Oprește înregistrare","strike":"tăiat","Subject":"Subiect","Submit":"Trimite","Success":"Succes","Survey":"Sondaj de opinie","Survey_instructions":"Da o nota fiecărei întrebări în funcție de gradul de satisfacție, 1 înseamnă că sunt complet nemulțumit și 5 înseamnă că sunt complet mulțumiți.","Symbols":"Simboluri","Sync_success":"succesul de sincronizare","Sync_Users":"Sincronizează utilizatori","Test_Connection":"Testare conexiune","Test_Desktop_Notifications":"Testare notificări desktop","Thank_you_for_your_feedback":"Vă mulțumim pentru feedback","The_application_name_is_required":"Este nevoie de numele aplicației","The_channel_name_is_required":"Este nevoie de numele canalului","The_emails_are_being_sent":"E-mail-urile sunt trimise.","The_field_is_required":"Este nevoie de câmpul %s.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Redimensionarea imaginii nu va funcționa, deoarece nu putem detecta ImageMagick sau GraphicsMagick instalat pe server.","The_redirectUri_is_required":"URI de redirectare este necesar","The_server_will_restart_in_s_seconds":"Serverul va reporni în %s secunde","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Setarea <strong>%s</strong> e configurată să <strong>%s</strong> iar dumneavoastră accesați din <strong>%s</strong>!","The_user_will_be_removed_from_s":"Utilizatorul va fi eliminat din %s","The_user_wont_be_able_to_type_in_s":"Utilizatorul nu va putea să introducă text în %s","Theme":"Temă","theme-color-action-buttons-color":"Culoare butoane acțiuni","theme-color-active-channel-background-color":"Culoare de fundal canal activ","theme-color-active-channel-font-color":"Culoare text canal activ","theme-color-blockquote-background":"Culoare de fundal Blockquote ","theme-color-clean-buttons-color":"Culoare butoane curate","theme-color-code-background":"Culoare de fundal cod","theme-color-code-border":"Culoare chenar cod","theme-color-code-color":"Culoare cod","theme-color-content-background-color":"Culoare de fundal conținut","theme-color-custom-scrollbar-color":"Culoare Scrollbar personalizat","theme-color-info-active-font-color":"Culoare text informații activ","theme-color-info-font-color":"Culoare text info","theme-color-input-font-color":"Culoare text input","theme-color-link-font-color":"Culoare text link","theme-color-message-hover-background-color":"Culoare fundal mesaj la 'hover'","theme-color-primary-background-color":"Culoare de fundal primară","theme-color-primary-font-color":"Culoare text primară","theme-color-quaternary-font-color":"Culoare font cuaternar","theme-color-secondary-background-color":"Culoare de fundal secundară","theme-color-secondary-font-color":"Culoare text secundară","theme-color-smallprint-font-color":"Culoare text mic","theme-color-smallprint-hover-color":"Culoare text mic la 'hover'","theme-color-status-away":"Culoare status 'Away'","theme-color-status-busy":"Culoare status 'Ocupat'","theme-color-status-offline":"Culoare status 'Offline'","theme-color-status-online":"Culoare status 'Activ'","theme-color-tertiary-background-color":"Culoare de fundal terțiară","theme-color-tertiary-font-color":"Culoare text terțiară","theme-color-unread-notification-color":"Culoare notificări mesaje necitite","theme-custom-css":"CSS personalizat","There_are_no_agents_added_to_this_department_yet":"Încă există agenți adăugați la acest departament.","There_are_no_integrations":"Nu sunt integrări","There_are_no_users_in_this_role":"Nu există utilizatori în acest rol.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Acest e-mail a fost deja utilizat și nu a fost verificată. Vă rugăm să schimbați parola.","This_is_a_desktop_notification":"Aceasta este o notificare desktop","This_is_a_push_test_messsage":"Acesta este un test de notificare Push","Time_in_seconds":"Timpul în secunde","Title_bar_color":"Culoare bară de titlu","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Pentru a instala Rocket.Chat Livechat în site-ul dvs., copiați & lipiți acest cod chiar înaintea ultimului tag <strong>&lt;/body&gt;</strong> din pagină.","To_users":"Către utilizatori","Topic":"Subiect","Travel_and_Places":"Călătorii & locuri","Trigger_removed":"Declanșator eliminat","Trigger_Words":"Cuvinte de declanșare","Triggers":"Declanșatori","True":"Adevărat","Type":"Tip","Type_your_new_password":"Introduceți noua parolă","Unarchive":"Dezarhivați","Unmute_someone_in_room":"Deblocați mesajele noi ale unui utilizator în cameră","Unmute_user":"Deblochează mesajele utilizatorului","Unnamed":"Anonim","Unpin_Message":"Anulați fixarea mesajului","Unread_Rooms":"Camere necitite","Unread_Rooms_Mode":"Mod camere necitite","Unstar_Message":"Eliminați marcajul cu stea","Upload_file_question":"Încarcă fișier?","Uploading_file":"Încărcare de fișiere ...","Use_account_preference":"Utilizați preferința cont","Use_Emojis":"Folosiți Emoji","Use_initials_avatar":"Folosiți inițialele numelui de utilizator","use_menu":"Folosiți meniul lateral pentru a vă accesa camerele și chat-urile","Use_service_avatar":"Utilizați avatarul %s","Use_this_username":"Folosiți acest nume de utilizator","Use_uploaded_avatar":"Utilizați avatar încărcat","Use_url_for_avatar":"Utilizați URL pentru avatar","User__username__is_now_a_moderator_of__room_name_":"Utilizator __username__  este acum un moderator al __room_name__","User__username__is_now_a_owner_of__room_name_":"Utilizatorul __username__ este acum proprietar al  __room_name__","User__username__removed_from__room_name__moderators":"Utilizatorul __username__ a fost eliminat din moderatorii  __room_name__","User__username__removed_from__room_name__owners":"Utilizatorul __username__ scos din proprietarii __room_name__","User_added":"Utilizator adăugat","User_added_by":"Utilizator <em>__user_added__</em> adăugat de către <em>__user_by__</em>.","User_added_successfully":"Utilizator adăugat cu succes","User_Channels":"Canale utilizator","User_doesnt_exist":"Nu există nici un utilizator cu numele de `@%s`.","User_has_been_activated":"Utilizatorul a fost activat","User_has_been_deactivated":"Utilizator a fost dezactivat","User_has_been_deleted":"Utilizatorul a fost șters","User_has_been_muted_in_s":"Utilizator a fost oprit în %s","User_has_been_removed_from_s":"Utilizator a fost eliminat din %s","User_has_disconnected":"Utilizatorul s-a deconectat","User_Info":"Info utilizator","User_is_no_longer_an_admin":"Utilizatorul nu mai este Admin","User_is_not_activated":"Utilizatorul nu este activat","User_is_now_an_admin":"Utilizatorul este acum Admin","User_joined_channel":"A intrat pe canal.","User_joined_channel_female":"A intrat pe canal.","User_joined_channel_male":"A intrat pe canal.","User_left":"A părăsit canalul.","User_left_female":"A părăsit canalul.","User_left_male":"A părăsit canalul.","User_logged_out":"Utilizatorul este deconectat","User_management":"Managementul utilizatorilor","User_muted_by":"Utilizatorul <em>__user_muted__</em> a fost blocat de către  <em>__user_by__</em>.","User_muted_in_room":"Utilizator blocat în cameră","User_not_found":"Utilizatorul nu a fost găsit","User_not_found_or_incorrect_password":"Utilizator nu a fost găsit sau parolă incorectă","User_or_channel_name":"Nume de utilizator sau de canal ","User_removed":"Utilizator eliminat","User_removed_by":"Utilizator <em>__user_removed__</em> șters de către <em>__user_by__</em>.","User_removed_from_room":"Utilizatorul a fost scos din cameră","User_Settings":"Setări utilizator","User_unmuted_by":"Utilizatorul <em>__user_muted__</em> a fost deblocat de către  <em>__user_by__</em>.","User_unmuted_in_room":"Utilizator deblocat în cameră","User_updated_successfully":"Utilizator actualizat cu succes","Username":"Nume de ultilizator","Username_and_message_must_not_be_empty":"Câmpurile \"utilizator\" și \"mesaj\" nu pot fi goale","Username_cant_be_empty":"Numele de utilizator nu poate fi gol","Username_Change_Disabled":"Administratorul a dezactivat schimbarea de nume de utilizator","Username_denied_the_OTR_session":"__username__ a negat sesiunea OTR","Username_description":"Numele de utilizator este folosit pentru a permite altora să vă menționeze în mesaje.","Username_doesnt_exist":"Numele de utilizator ` %s` nu există.","Username_ended_the_OTR_session":"__username__ a incheiat sesiunea OTR","Username_invalid":"<strong>%s</strong>nu e un nume de utilizator valid,<br/> folosiți doar litere, cifre și cratime","Username_is_already_in_here":"`@ %s` este deja aici.","Username_is_not_in_this_room":"Utilizatorul `# %s` nu este în această cameră.","Username_not_found":"Numele de utilizator nu a fost găsit","Username_title":"Înregistrează nume de utilizator","Username_unavaliable":"<strong>%s</strong> e deja folosit :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ vrea să înceapă OTR. Doriți să acceptați?","Users":"Utilizatori","Users_in_role":"Utilizatorii în rol","UTF8_Names_Slugify":"UTF8 Names Slugify","UTF8_Names_Validation":"Validare UTF8 Names ","UTF8_Names_Validation_Description":"Nu permite caractere și spații speciale. Puteți folosi '-',  '_' și '.' dar nu la sfârșitul numelui","Verification_email_sent":"e-mail de verificare trimis","View_All":"Vezi toți","View_Logs":"Vezi log-uri","Visibility":"Vizibilitate","Visible":"Vizibil","Visitor":"Vizitator","Visitor_page_URL":"Pagina  URL a vizitatorului","Visitor_time_on_site":"Timpul vizitatorului pe site","Wait_activation_warning":"Ca să vă puteți autentifica, contul dumneavoastră trebuie să fie activat manual de către un administrator.","We_are_offline_Sorry_for_the_inconvenience":"Suntem offline. Scuze pentru neplăcerile provocate.","We_have_sent_password_email":"V-am trimis un e-mail cu instrucțiuni de resetare a parolei. Dacă nu primiți un e-mail în scurt timp, va rugăm să reveniti și să încercați din nou.","We_have_sent_registration_email":"V-am trimis un e-mail pentru a confirma înregistrarea dumneavoastră. Dacă nu primiți un e-mail în scurt timp, vă rugăm să reveniți și să încercați din nou.","WebRTC_Enable_Channel":"Activați pentru canale publice","WebRTC_Enable_Direct":"Activați pentru mesaje directe","WebRTC_Enable_Private":"Activați pentru canale private","WebRTC_Servers":"Servere STUN / TURN","WebRTC_Servers_Description":"O listă de servere STUN și Nap separate prin virgula. <br/> Nume de utilizator, parola și portul sunt permise în format `utilizator: parola @ asomarea: gazdă: port` sau` nume de utilizator: parola @ rândul său: gazdă: port`.","Welcome":"Bun venit <em>%s</em>.","Welcome_to_the":"Bun venit în","will_be_able_to":"va putea","With_whom":"Cu cine","Yes":"Da","Yes_clear_all":"Da, șterge toate!","Yes_delete_it":"Da, șterge-l!","Yes_hide_it":"Da, ascundeți.","Yes_leave_it":"Da, părăsiți.","Yes_mute_user":"Da, blochează mesajele utilizatorului","Yes_remove_user":"Da, eliminați utilizatorul!","you_are_in_preview_mode_of":"Vă aflați în modul de previzualizare a canalului #","You_are_logged_in_as":"Sunteți autentificat ca ","You_are_not_authorized_to_view_this_page":"Nu sunteți autorizat pentru a vizualiza această pagină.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Dacă sunteți ultimul proprietar. Vă rugăm să setați noul proprietar înainte de a părăsi camera.","You_can_change_a_different_avatar_too":"Puteți înlocui avatarul folosit pentru a posta din această integrare.","You_can_use_an_emoji_as_avatar":"Puteți utiliza un emoji ca avatar","You_have_been_muted":"Ați fost blocat și nu puteți vorbi în această cameră","You_have_not_verified_your_email":"Nu ati verificat un e-mail.","You_have_successfully_unsubscribed":"V-ați dezabonat cu succes din lista noastră de email.","You_informed_an_invalid_FROM_address":"Ați utilizat o adresă DE LA invalidă.","You_must_provide_the_unsubscribe_link":"Trebuie să furnizați link-ul de [unsubscribe].","You_need_confirm_email":"Confirmați adresa de email pentru a vă înregistra!","You_need_install_an_extension_to_allow_screen_sharing":"Aveți nevoie de a instala o extensie pentru a permite partajarea ecranului","You_need_to_change_your_password":"Trebui să vă schimbați parola","You_need_to_type_in_your_password_in_order_to_do_this":"Trebuie să tastați parola, în scopul de a face acest lucru!","You_need_to_type_in_your_username_in_order_to_do_this":"Trebuie să tastați numele de utilizator, în scopul de a face acest lucru!","You_need_to_verifiy_your_email_address_to_get_notications":"Aveți nevoie pentru a verifiy adresa de e-mail pentru a primi notificări","You_should_name_it_to_easily_manage_your_integrations":"Ar trebui să o numiți pentru a vă gestiona cu ușurință integrările.","You_will_not_be_able_to_recover":"Nu veți putea recupera acest mesaj!","You_will_not_be_able_to_recover_file":"Nu veți putea recupera acest fișier.","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Nu veți primi notificări prin e-mail, deoarece nu ați verificat un e-mail.","Your_email_has_been_queued_for_sending":"Emailul dumneavoastră a fost pus pe lista de trimis","Your_entry_has_been_deleted":"Mesajul dumneavoastră a fost șters.","Your_file_has_been_deleted":"Fișierul a fost șters.","Your_mail_was_sent_to_s":"E-mail-ul a fost trimis la %s","Your_Open_Source_solution":"Propria soluție de chat Open Source","Your_password_is_wrong":"Parola dvs. este greșită!","Your_push_was_sent_to_s_devices":"Mesajul Push a fost trimis la %s dispozitive"});
TAPi18n._registerServerTranslator("ro", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ru.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ru"] = ["Russian","Русский"];                                                                 // 8
if(_.isUndefined(TAPi18n.translations["ru"])) {                                                                        // 9
  TAPi18n.translations["ru"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ru"][namespace])) {                                                             // 13
  TAPi18n.translations["ru"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ru"][namespace], {"500":"Внутренняя ошибка сервера","0_Errors_Only":"0 - Только ошибки","1_Errors_and_Information":"1 - Ошибки и информация","2_Erros_Information_and_Debug":"2 - Ошибки, информация и отладка","__username__was_set__role__by__user_by_":"__username__ был установлен __role__ по __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ больше не __role__, по __user_by__","Access_not_authorized":"Доступ запрещён","Access_online_demo":"Попробовать демо-версию","Access_Online_Demo":"Попробовать демо-версию","Access_Token_URL":"Маркер доступа URL-адреса","Accounts":"Аккаунты","Accounts_AllowDeleteOwnAccount":"Разрешить пользователям удалять собственный аккаунт","Accounts_AllowedDomainsList":"Список разрешенных доменов","Accounts_AllowedDomainsList_Description":"Разделенный запятыми список разрешенных доменов","Accounts_AllowEmailChange":"Разрешить изменение E-mail-адреса","Accounts_AllowPasswordChange":"Разрешить смену пароля","Accounts_AllowUserAvatarChange":"Разрешить пользователю изменять Аватар","Accounts_AllowUsernameChange":"Разрешить изменять имя пользователя","Accounts_AllowUserProfileChange":"Разрешить пользователю изменять настройки профиля","Accounts_AvatarResize":"Изменение размера аватара","Accounts_AvatarSize":"Размер аватара","Accounts_AvatarStorePath":"Путь к аватарам","Accounts_AvatarStoreType":"Тип хранилища аватаров","Accounts_BlockedDomainsList":"Список запрещённых доменов","Accounts_BlockedDomainsList_Description":"Запрещённые домены через запятую","Accounts_denyUnverifiedEmail":"Запретить неподтверждённые e-mail","Accounts_EmailVerification":"Подтверждение e-mail","Accounts_EmailVerification_Description":"Убедитесь, что у Вас верные настройки SMTP для использования этой функции","Accounts_Enrollment_Email":"Запись электронной почты","Accounts_Enrollment_Email_Description":"Вы можете использовать [имя], [фамилию] и [отчество] в качестве полного имени пользователя.<br />Вы можете использовать [email] в качестве электронной почты пользователя.","Accounts_Iframe_api_method":"Метод API","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"Включено","Accounts_iframe_url":"Iframe Url","Accounts_LoginExpiration":"Истечение срока авторизации в днях","Accounts_ManuallyApproveNewUsers":"Утверждать вручную новых пользователей","Accounts_OAuth_Custom_Token_Sent_Via":"Токен посланными через","Accounts_OAuth_Custom_Authorize_Path":"Путь к авторизации","Accounts_OAuth_Custom_Button_Color":"Цвет кнопки","Accounts_OAuth_Custom_Button_Label_Color":"Цвет текста кнопки","Accounts_OAuth_Custom_Button_Label_Text":"Текст кнопки","Accounts_OAuth_Custom_Enable":"Включить","Accounts_OAuth_Custom_id":"Идентификатор","Accounts_OAuth_Custom_Identity_Path":"Единичный путь","Accounts_OAuth_Custom_Login_Style":"Вид логина","Accounts_OAuth_Custom_Secret":"Ключ","Accounts_OAuth_Custom_Token_Path":"Token Path","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook логин","Accounts_OAuth_Facebook_callback_url":"Обратный URL-адрес Facebook","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth разрешён","Accounts_OAuth_Github_callback_url":"Обратный URL-адрес Github","Accounts_OAuth_GitHub_Enterprise":"OAuth включен","Accounts_OAuth_GitHub_Enterprise_callback_url":"Обратный URL-адрес GitHub Enterprise","Accounts_OAuth_GitHub_Enterprise_id":"Client Id","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"Client Id","Accounts_OAuth_Github_secret":"Client Secret","Accounts_OAuth_Gitlab":"OAuth включен","Accounts_OAuth_Gitlab_callback_url":"Обратный URL-адрес GitLab","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google логин","Accounts_OAuth_Google_callback_url":"Обратный URL-адрес Google","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google пароль","Accounts_OAuth_Linkedin":"Логин LinkedIn","Accounts_OAuth_Linkedin_callback_url":"Обратный URL-адрес Linkedin","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Логин Meteor","Accounts_OAuth_Meteor_callback_url":"Обратный URL-адрес Meteor","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Логин Twitter","Accounts_OAuth_Twitter_callback_url":"Обратный URL-адрес Twitter","Accounts_OAuth_Twitter_id":"Twitter ID","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress логин","Accounts_OAuth_Wordpress_callback_url":"Обратный URL-адрес Wordpress","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"Пароль WordPress","Accounts_PasswordReset":"Восстановить пароль","Accounts_Registration_AuthenticationServices_Enabled":"Регистрация со службами проверки подлинности","Accounts_RegistrationForm":"Регистрационная форма","Accounts_RegistrationForm_Disabled":"Отключено","Accounts_RegistrationForm_LinkReplacementText":"Текст замены ссылки регистрационной формы","Accounts_RegistrationForm_Public":"Публичный","Accounts_RegistrationForm_Secret_URL":"Тайный URL-адрес","Accounts_RegistrationForm_SecretURL":"Тайный URL-адрес регистрационной формы","Accounts_RegistrationForm_SecretURL_Description":"Вы должны предоставить случайную строку, которая будет добавлена к Вашему регистрационному URL-адресу. Например: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Требуется регистрация","Accounts_RequireNameForSignUp":"Требуется имя для регистрации","Accounts_ShowFormLogin":"Показать логин на основе формы","Accounts_UseDefaultBlockedDomainsList":"Использовать список заблокированных доменов по умолчанию","Accounts_UseDNSDomainCheck":"Использовать DNS проверку доменов","Activate":"Активировать","Activity":"Активность","Add":"Добавить","Add_agent":"Добавить сотрудника","Add_custom_oauth":"Добавить пользовательский OAuth","Add_manager":"Добавить менеджера","Add_Members":"Добавить Пользователей","Add_User":"Добавить пользователя","Add_user":"Добавить пользователя","Add_users":"Добавить пользователей","Additional_emails":"Дополнительные электронные адреса","Additional_Feedback":"Дополнительная обратная связь","Administration":"Администрирование","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"После аутентификации OAuth2, пользователи будут перенаправляться на этот URL-адрес","Agent_added":"Сотрудник добавлен","Agent_removed":"Сотрудник удален","Alias":"Алиас","All":"Все","All_channels":"Все Чаты","All_logs":"Все записи","All_messages":"Все сообщения","Allow_Invalid_SelfSigned_Certs":"Разрешить недействительные самоподписанные сертификаты","Allow_Invalid_SelfSigned_Certs_Description":"Разрешить некорректные и само подписанные SSL сертификаты.","and":"и","And_more":"И еще __length__...","Animals_and_Nature":"Животные и природа","API":"Интерфейс приложения","API_Analytics":"Аналитика","API_Embed":"Вставить","API_EmbedDisabledFor":"Запретить доступ для пользователей","API_EmbedDisabledFor_Description":"Разделенный запятыми список имен пользователей","API_GitHub_Enterprise_URL":"URL-адрес сервера","API_GitHub_Enterprise_URL_Description":"Пример: http://domain.com (без завершающего слеша)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Внешний вид","Application_added":"Приложение добавлено","Application_Name":"Наименование приложения","Application_updated":"Приложение обновлено","Apply_and_refresh_all_clients":"Применить и обновить все клиенты","Archive":"Удалить","Archive_Unarchive":"Удалить / Восстановить","are_also_typing":"тоже печатает...","are_typing":"печатает...","Are_you_sure":"Вы уверены?","Are_you_sure_you_want_to_delete_your_account":"Вы уверены, что хотите удалить свой аккаунт?","Authorization_URL":"Авторизация URL-адреса","Authorize":"Разрешить","AutoLinker_StripPrefix":"Удалять префиксы","AutoLinker_StripPrefix_Description":"Сокращать формат, например: https://rocket.chat => rocket.chat","AutoLinker_Urls":"Сокращать URL","AutoLinker_UrlsRegExp":"Сокращать URL через регулярное выражение","AutoLinker_Email":"Подсвечивать Email","AutoLinker_Phone":"Подсвечивать телефоны","AutoLinker_Phone_Description":"Автоматически выделять телефонные номера, например `(123)456-7890`","Auto_Load_Images":"Автозагрузка изображений","Available":"Доступен","Available_agents":"Свободные сотрудники","Avatar":"Изменить аватар","Avatar_changed_successfully":"Аватар успешно изменен","Avatar_URL":"URL-адрес Аватара","Avatar_url_invalid_or_error":"Предоставленный URL-адрес недействителен или недоступен. Повторите попытку с другим URL-адресом.","away":"отошёл","Away":"Отошёл","away_female":"отошла","Away_female":"Отошла","away_male":"отошёл","Away_male":"Отошёл","Back":"Назад","Back_to_applications":"Вернуться к приложениям","Back_to_integrations":"Назад к интеграциям","Back_to_login":"На страницу авторизации","Back_to_permissions":"Назад к настройкам прав","Body":"Основная часть","bold":"жирный","busy":"занят","Busy":"Занят","busy_female":"занята","Busy_female":"Занята","busy_male":"занят","Busy_male":"Занят","Cancel":"Отмена","Cannot_delete_a_protected_role":"Нельзя удалить защищённую позицию","Cannot_delete_role_because_its_in_use":"Нельзя удалить позицию, потому что она используется","Cannot_invite_users_to_direct_rooms":"Нельзя приглашать пользователей в приватные чаты","CDN_PREFIX":"CDN префикс","Certificates_and_Keys":"Ключи и сертификаты","Channel":"Публичный чат","Channel_doesnt_exist":"Чат `#%s` не существует.","Channels":"Чаты","Channels_list":"Список общих чатов","Chat_Rooms":"Чаты","Chatops_Enabled":"Включить Chatops","Chatops_Title":"Панель Chatops","Chatops_Username":"Имя пользователя Chatops","Choose_a_room":"Выберите чат","Choose_messages":"Выбрать сообщения","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Выберите псевдоним, который появится перед именем пользователя в сообщениях.","Choose_the_username_that_this_integration_will_post_as":"Выберите имя пользователя, которое опубликует эта интеграция.","Clear_all_unreads_question":"Удалить все \"непрочитанные\"?","Client_ID":"Client ID","Client_Secret":"Client Secret","Clients_will_refresh_in_a_few_seconds":"Клиенты обновятся через пару секунд","close":"закрыть","Closed":"Закрыто","Collapse_Embedded_Media_By_Default":"Сворачивать вложенные медиа по умолчанию","coming_soon":"в разработке","Commands":"Команды","Compact_View":"Компактный вид","Confirm_password":"Подтвердить пароль","Contact":"Контакт","Conversation":"Диалог","Convert_Ascii_Emojis":"Конвертировать ASCII в Emoji","Copied":"Скопировано","COPY_TO_CLIPBOARD":"Скопировать в буфер обмена","Copy_to_clipboard":"Копировать в буфер обмена","Count":"Количество","Create":"Создать","Create_new":"Создать чат","Created_at":"Создано в","Created_at_s_by_s":"Создать на <strong>%s</strong> при помощи <strong>%s</strong>","Custom_Fields":"Пользовательские поля","Custom_oauth_helper":"Настраивая Вашего поставщика OAuth, Вам необходимо сообщить обратный URL-адрес. Используйте <pre>%s</pre> .","Custom_oauth_unique_name":"Уникальное имя пользовательского OAuth","Custom_Script_Logged_In":"Пользовательский сценарий для зарегистрированных пользователей","Custom_Script_Logged_Out":"Пользовательский сценарий для незарегистрированных пользователей","Dashboard":"Панель","days":"дней","Deactivate":"Деактивировать","Debug_Level":"Уровень отладки","Default":"По умолчанию","Delete":"Удалить","Delete_my_account":"Удалить мой аккаунт","Delete_Room_Warning":"Удаление чата так же удалит все сообщения в нем. Это действие невозможно отменить.","Delete_User_Warning":"Удаление пользователя удалит все сообщения от этого пользователя. Это действие невозможно отменить.","Deleted":"Удалено!","Department_not_found":"Раздел не найден","Department_removed":"Раздел удален","Departments":"Разделы","Description":"Описание","Desktop":"Рабочий стол","Desktop_Notification_Test":"Проверка уведомлений рабочего стола","Desktop_Notifications":"Уведомления на рабочем столе","Desktop_Notifications_Disabled":"Уведомления на рабочем столе отключены. Измените настройки браузера, если вам нужно включить уведомления.","Desktop_Notifications_Enabled":"Уведомления для рабочего стола включены","Direct_message_someone":"Личное сообщение кому-либо","Direct_Messages":"Личные сообщения","Direct_Messages_list":"Личные сообщения","Disable_Favorite_Rooms":"Отключить избранное","Disable_New_Message_Notification":"Отключить уведомления о новых сообщениях","Disable_New_Room_Notification":"Отключить уведомления о новых чатах","Displays_action_text":"Отображать текст действия","Do_you_want_to_change_to_s_question":"Хотите изменить на <strong>%s</strong>?","Drop_to_upload_file":"Переместите сюда для загрузки файла","Dry_run":"Пробный запуск","Dry_run_description":"Мы отправим только один e-mail на адрес, указанный в поле \"От\". E-mail адрес должен принадлежать действительному пользователю.","Duplicate_archived_channel_name":"Удалённый канал с именем '%s' существует","Duplicate_archived_private_group_name":"Удалённый приватный чат с именем '%s' существует","Duplicate_private_group_name":"Приватный чат с именем '%s' уже существует","E-mail":"Электронная почта","Edit":"Редактировать","Edit_Custom_Field":"Редактировать поле","Edit_Department":"Редактировать раздел","edited":"отредактировано","Email":"Email","Email_already_exists":"Email уже зарегистрирован","Email_body":"Тело сообщения","Email_Change_Disabled":"Администратор Вашего Rocket.Chat запретил изменение email","Email_from":"От","Email_Notification_Mode":"Офлайн уведомления по электронной почте","Email_Notification_Mode_All":"Каждое упоминание","Email_Notification_Mode_Disabled":"Отключено","Email_or_username":"Почтовый ящик или логин","Email_subject":"Тема","Email_verified":"Email подтверждён","Emoji":"Emoji","Empty_title":"Пустой заголовок","Enable":"Включить","Enable_Desktop_Notifications":"Включить уведомления для рабочего стола","Enabled":"Включено","Encrypted_message":"Зашифрованное сообщение","End_OTR":"Завершить конфиденциальную беседу","Enter_a_regex":"Введите regex","Enter_a_room_name":"Введите название чата","Enter_a_username":"Введите имя пользователя","Enter_info":"Введите свои данные","Enter_name_here":"Введите имя","Enter_to":"Войти в","Error":"Ошибка","error-cant-invite-for-direct-room":"Нельзя приглашать пользователей в личные сообщения","error-duplicate-channel-name":"Чат '%s' уже существует","error-invalid-custom-field":"Неверное поле","error-invalid-custom-field-name":"Неверное имя для поля. Используйте тельно буквы, цифры, дефисы и подчеркивания.","error-invalid-password":"Неверный пароль","error-invalid-room":"Несуществующий чат","error-invalid-room-name":"<strong>%s</strong> is not a valid room name,<br/> use only letters, numbers, hyphens and underscores","error-invalid-user":"Неверный пользователь","error-invalid-username":"Неверное имя пользователя","error-not-allowed":"Не разрешено","error-not-authorized":"Не допускается","error-remove-last-owner":"Это последний владелец. Пожалуйста, назначьте нового владельца до удаления этого.","error-role-name-required":"Необходимо название роли","error-user-not-in-room":"Пользователь не в этом чате","Error_changing_password":"Ошибка при изменении пароля","Error_sending_confirmation_email":"Ошибка отправки подтверждающего email","Error_too_many_requests":"Ошибка, слишком много запросов. Пожалуйста, помедленнее. Вы должны подождать%s секунд, прежде чем попробовать снова","Esc_to":"Выйти из","Example_s":"Пример: <code class=\"inline\">%s</code>","False":"Нет","Favorites":"Избранные чаты","Field":"Поле","Field_removed":"Полу удалено","File_exceeds_allowed_size_of_bytes":"Превышен допустимый размер файла на __size__ байт","FileUpload":"Загрузка файла","FileUpload_Enabled":"Загрузка файлов включена","FileUpload_File_Empty":"Пустой файл","FileUpload_FileSystemPath":"Системный путь","FileUpload_MaxFileSize":"Максимальный размер загружаемых файлов (в байтах)","FileUpload_MediaType_NotAccepted":"Медиа-файлы не приняты","FileUpload_MediaTypeWhiteList":"Принятые медиа файлы","FileUpload_MediaTypeWhiteListDescription":"Список медиа файлов, разделённый запятой. Оставьте его пустым, чтобы принять все типы медиа файлов.","FileUpload_ProtectFiles":"Защитить загруженные файлы","FileUpload_ProtectFilesDescription":"Только авторизованные пользователи будут иметь доступ","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"Домен CDN для загрузок","FileUpload_S3_Region":"Регион","FileUpload_Storage_Type":"Тип хранения","Flags":"Флаги","Follow_social_profiles":"Добавляйте нас в друзья в социальных сетях, форкайте на github и пишите свои отзывы о нашем приложении у нас в trello.","Food_and_Drink":"Еда и питьё","For_your_security_you_must_re_enter_your_password_to_continue":"Чтобы продолжить, Вы должны повторно ввести свой пароль для Вашей безопасности","Force_SSL":"Принудительный SSL","Force_SSL_Description":"*ВНИМАНИЕ!* Ни в коем случае не используйте _Force SSL_ в установках с обратным прокси (например, nginx). В таком случае вы должны делать redirect на нем, а не в Rocket.Chat.","Forgot_password":"Забыли пароль?","Fork_it_on_github":"Форкайте на github","Frequently_Used":"Часто используемые","From":"От","From_Email":"Email отправителя","From_email_is_required":"Требуется адрес отправителя","From_email_warning":"<b>Внимание</b>: Поле <b>От</b> зависит от настроек Вашего почтового сервера.","General":"Общие настройки","Get_to_know_the_team":"Познакомьтесь с Rocket.Team","github_no_public_email":"В настройках GitHub отсутствует публично доступный e-mail","Give_a_unique_name_for_the_custom_oauth":"Задайте уникальное имя для пользовательского OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Задайте приложению имя. Оно будет видно всем пользователям.","Global":"Общие","GoogleTagManager_id":"Google Tag Manager Id","Has_more":"Еще","Have_your_own_chat":"Rocket.Chat, разработанный на основе Meteor.com, - это отличное решение для разработчиков, которые хотят создать свою собственную платформу для общения.","Header":"Заголовок","Hidden":"Скрытый","Hide_Group_Warning":"Вы уверены, что хотите спрятать групповой чат \"%s\"?","Hide_Private_Warning":"Вы уверены, что хотите спрятать беседу с \"%s\"?","Hide_room":"Скрыть чат","Hide_Room_Warning":"Вы уверены, что хотите спрятать чат \"%s\"?","Highlights":"Главное","Highlights_How_To":"Чтобы получать уведомления, когда кто-то упоминает слово или фразу, добавьте здесь. Вы можете разделять слова или фразы запятыми. Выделенные слова не чувствительны к регистру.","Highlights_List":"Выделенные слова","History":"История","hours":"час(ы)","How_friendly_was_the_chat_agent":"Насколько дружелюбен был сотрудник чата?","How_knowledgeable_was_the_chat_agent":"Насколько информирован был сотрудник чата?","How_responsive_was_the_chat_agent":"Насколько отзывчив был сотрудник чата?","How_satisfied_were_you_with_this_chat":"Насколько Вы удовлетворены использованием этого чата?","If_you_are_sure_type_in_your_password":"Если Вы уверены, введите пароль:","If_you_are_sure_type_in_your_username":"Если Вы уверены, введите имя:","Importer_Archived":"Удаленные","Importer_done":"Импорт данных завершен!","Importer_finishing":"Завершить импорт данных.","Importer_From_Description":"Импортировать данные из __from__ в Rocket.Chat.","Importer_import_cancelled":"Импорт данных отменен.","Importer_import_failed":"Во время импорта данных возникла ошибка.","Importer_importing_channels":"Импортировать каналы.","Importer_importing_messages":"Импортировать сообщения.","Importer_importing_started":"Начать импорт данных.","Importer_importing_users":"Импортировать пользователей.","Importer_not_defined_properly":"Импортер не был определен правильно, не хватает классификации импорта.","Importer_not_in_progress":"Импортер на данный момент не в сети.","Importer_Prepare_Restart_Import":"Перезапустить импорт данных.","Importer_Prepare_Start_Import":"Начать импорт данных.","Importer_Prepare_Uncheck_Archived_Channels":"Снимите флажок с удаленных каналов","Importer_Prepare_Uncheck_Deleted_Users":"Снимите флажок с удаленных пользователей","Importer_progress_error":"Произошла ошибка при выполнении импорта данных.","Importer_setup_error":"При настройке импортера возникла ошибка.","Incorrect_Password":"Неверный пароль","inline_code":"внутренний код","Install_Extension":"Установить расширение","Install_FxOs":"Установить Rocket.Chat на Firefox","Install_FxOs_done":"Отлично! Теперь Вы можете использовать Rocket.Chat через иконку на Вашем рабочем столе. Развлекайтесь вместе с Rocket.Chat!","Install_FxOs_error":"Извините, что-то пошло не так! Появилась следующая ошибка:","Install_FxOs_follow_instructions":"Подтвердите установку приложения на Ваше устройство (при запросе нажмите \"Установить\").","Installation":"Установка","Integration_added":"Интеграция была добавлена","Integration_Incoming_WebHook":"Входящая интеграция WebHook","Integration_New":"Новая интеграция","Integration_Outgoing_WebHook":"Исходящая интеграция WebHook","Integration_updated":"Интеграция была загружена","Integrations":"Интеграции","Invalid_asset":"Недействительный актив","Invalid_confirm_pass":"Пароли не совпадают","Invalid_email":"Неверный e-mail","Invalid_Export_File":"Загруженный файл не является действительным экспортным файлом %s.","Invalid_file_height":"Недопустимая высота файла","Invalid_file_type":"Неверный тип файла","Invalid_file_width":"Недопустимая ширина файла","Invalid_Import_File_Type":"Недействительный тип импортируемого файла.","Invalid_name":"Имя не может быть пустым","Invalid_notification_setting_s":"Неверная настройка уведомлений: %s","Invalid_pass":"Пароль не может быть пустым","Invalid_room_name":"<strong>%s</strong> недопустимое имя чата, <br/> допустимые символы: цифры, подчеркивание и буквы.","Invalid_room_type":"<strong>%s</strong> недопустимый тип чата.","Invalid_Secret_URL":"Недействительный Secret URL","Invalid_secret_URL_message":"Предоставленный URL-адрес недействителен.","invisible":"невидимый","Invisible":"Невидимый","Invitation_HTML":"Приглашение в формате HTML","Invitation_Subject":"Предмет приглашения","Invite_user_to_join_channel":"Пригласить пользователя присоединиться к этому публичному чату","Invite_Users":"Пригласить пользователей","is_also_typing":"все ещё печатает","is_also_typing_female":"все ещё печатает","is_also_typing_male":"все ещё печатает","is_typing":"печатает","is_typing_female":"печатает","is_typing_male":"печатает","italics":"курсив","join":"Присоединиться","Join_audio_call":"Присоединиться к разговору","Join_the_Community":"Присоединиться к сообществу","Join_the_given_channel":"Присоединиться к этому публичному чату","Join_video_call":"Присоединиться к видеозвонку","Joined":"Участвую","Jump":"Перейти","Jump_to_first_unread":"Перейти к первому непрочитанному","Jump_to_message":"Перейти к сообщению","Jump_to_recent_messages":"Перейти к последнему сообщению","Katex_Enabled":"Katex включен","Label":"Подпись","Language":"Язык","Language_Version":"Русская версия","Last_login":"Последний визит","Last_message":"Последнее сообщение","Last_seen":"Последняя активность","Layout":"План","Layout_Home_Body":"Контент главной","Layout_Home_Title":"Название главной","Layout_Login_Terms":"Правила составления логина","Layout_Privacy_Policy":"Политика конфиденциальности","Layout_Sidenav_Footer":"Футер навигационной панели","Layout_Sidenav_Footer_description":"Размер футера 260 на 70 пикселей","Layout_Terms_of_Service":"Условия использования","LDAP":"Протокол LDAP","LDAP_CA_Cert":"Сертификат CA","LDAP_Custom_Domain_Search":"Пользовательский домен поиска","LDAP_Custom_Domain_Search_Description":"Часть протокола JSON, которая регулирует привязку и подключение информации, имеет форму: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Домен по умолчанию","LDAP_Description":"Протокол LDAP - это иерархическая база данных, которую используют многие компании для обеспечения единой регистрации - средство для совместного использования одного пароля для разных сайтов и сервисов. Для подробной информации по конфигурации читайте нашу wiki-страницу: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP домен","LDAP_Domain_Base":"Доменная база","LDAP_Domain_Base_Description":"Полностью соответствующее Отличительное Имя (ОМ) поддерева протокола LDAP, которое Вы хотите найти для пользователей и групп. Вы можете добавлять столько, сколько желаете; однако, каждая группа должна быть определена в одной и той же доменной базе, как и пользователи, относящиеся к ней. Если Вы укажете ограниченные группы пользователей, в пределах этих групп будут лишь те пользователи, относящиеся к ним. Вы рекомендуем Вам указать верхний уровень дерева каталогов LDAP в качестве доменной базы и использовать фильтр поиска для контроля доступа.","LDAP_Domain_Search_Filter":"Фильтр доменного поиска","LDAP_Domain_Search_Filter_Description":"Если определено, только пользователям, которые соответствуют этому фильтру, разрешат авторизоваться. Если никакой фильтр не будет определен, то все пользователи в рамках указанной доменной базы будут в состоянии регистрироваться. <br/>Например для Активной Директории `memberOf=cn=ROCKET_CHAT,ou=General Groups`.<br/>Например для OpenLDAP (расширяемый соответствующий поиск) `ou:dn:=ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Категория объекта доменного поиска","LDAP_Domain_Search_Object_Category_Description":"*objectCategory* определяет Ваших пользователей.<br/>Оставить пустым для *OpenLDAP*.<br/>Например `person`, и так далее.","LDAP_Domain_Search_Object_Class":"Класс объекта доменного поиска","LDAP_Domain_Search_Object_Class_Description":"*objectclass* определяет Ваших пользователей. <br/>Например `organizationalPerson`, `user`, `inetOrgPerson`, и так далее.","LDAP_Domain_Search_Password":"Пароль к доменному поиску","LDAP_Domain_Search_Password_Description":"Пароль для пользователя доменного поиска","LDAP_Domain_Search_User":"Пользователь доменного поиска","LDAP_Domain_Search_User_Description":"Пользователь LDAP, который выполняет пользовательские поиски, чтобы подтвердить подлинность других пользователей, когда они регистрируются. <br/>Это, как правило - сервисный аккаунт, созданный определенно для сторонней интеграции. Используйте полностью составное имя, например `cn=Administrator,cn=Users,dc=Example,dc=com`.","LDAP_Domain_Search_User_ID":"Идентификатор пользователя доменного поиска","LDAP_Domain_Search_User_ID_Description":"Признак LDAP, который опознает пользователя LDAP, делающего попытку идентификации. Эта область должна быть `sAMAccountName` для большинства Активных Директивных установок, но она может быть `uid` для других LDAP решений, таких как OpenLDAP. Вы можете использовать `mail` для указания пользователей по электронной почте или любой признак, какой пожелаете. <br>Вы можете использовать несколько значений, разделенных запятой, чтобы разрешить пользователям войти, используя множественные идентификаторы, такие как имя пользователя или электронная почта.","LDAP_Enable":"Включить LDAP","LDAP_Enable_Description":"Попытка использовать LDAP для аутентификации.","LDAP_Encryption":"Шифрование","LDAP_Encryption_Description":"Метод шифрования раньше обеспечивал безопасность коммуникаций с сервером LDAP. Примеры содержат `plain` (без шифрования), `SSL/LDAPS`(зашифрованный с начала), а также `StartTLS`(модернизируйте до зашифрованной коммуникации после подключения).","LDAP_Host":"Хост","LDAP_Host_Description":"Хост LDAP, например `ldap.example.com` или `10.0.0.30`.","LDAP_Port":"LDAP порт","LDAP_Port_Description":"Порт для доступа LDAP. Пример: `389` или `636` для LDAPS","LDAP_Reject_Unauthorized":"Отклонить запрещённых","LDAP_Sync_User_Avatar":"Синхронизация пользовательских аватаров","LDAP_Sync_User_Data":"Синхронизация данных","LDAP_Sync_User_Data_Description":"Хранить пользовательские данные в синхронизации с сервером на логине (например: имя, электронная почта).","LDAP_Sync_User_Data_FieldMap":"Карта пользовательских данных","LDAP_Sync_User_Data_FieldMap_Description":"Настраивайте то, как будут заполняться поля аккаунта пользователя (email) из записи в LDAP (как только будет найден). <br/>Например, при настройке `{\"cn\":\"name\", \"mail\":\"email\"}` имя человека будет выбираться из параметра \"cn\", а email – из параметра \"mail\". <br/>Доступны поля `name` и `email`.","LDAP_Sync_Users":"Синхронизация пользователей","LDAP_Test_Connection":"Протестировать соединение","LDAP_Unique_Identifier_Field":"Поле уникального идентификатора","LDAP_Unique_Identifier_Field_Description":"Какая область будет использоваться, чтобы связать пользователя LDAP и Rocket.Chat. Вы можете сообщать многократные значения, отделенные запятой, чтобы попытаться получить значение из отчета LDAP.<br/>Значение по умолчанию `objectGUID, ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber`","LDAP_Use_Custom_Domain_Search":"Использовать пользовательский домен поиска","LDAP_Use_Custom_Domain_Search_Description":"Напишите свой собственный фильтр, чтобы искать пользователей в сервере LDAP.","LDAP_Username_Field":"Поле \"Имя пользователя\"","LDAP_Username_Field_Description":"Какая область будет использоваться в качестве *username* для новых пользователей. Оставьте поле пустым, чтобы использовать имя пользователя, имеющееся на странице входа.<br/>Вы также можете использовать теги шаблонов, как `#{givenName}.#{sn}`.<br/>Значение по умолчанию `sAMAccountName`.","Leave_Group_Warning":"Вы уверены, что хотите покинуть групповой чат \"%s\"?","Leave_Private_Warning":"Вы уверены, что хотите покинуть беседу с \"%s\"?","Leave_room":"Покинуть чат","Leave_Room_Warning":"Вы уверены, что хотите покинуть чат \"%s\"?","line":"линия","List_of_Direct_Messages":"Список личных сообщений","Live_sessions":"Живые сессии","Livechat_agents":"Сотрудники Livechat","Livechat_Dashboard":"Информационная панель Livechat","Livechat_enabled":"Livechat включен","Livechat_Manager":"Менеджер Livechat","Livechat_managers":"Менеджеры Livechat","Livechat_title":"Название чата","Livechat_title_color":"Цвет фона заголовка Livechat","Livechat_Users":"Пользователи Livechat","Load_more":"Загрузить еще","Loading...":"Загрузка...","Loading_more_from_history":"Идёт загрузка из истории","Loading_suggestion":"Загрузка предпочтений...","Localization":"Определение местонахождения","Log_File":"Показать файл и строки","Log_Level":"Уровень журнала регистрации","Log_Package":"Показать комплект","Log_View_Limit":"Предел просмотра журнала","Logged_out_of_other_clients_successfully":"Сеансы в других клиентах успешно завершены","Login":"Войти","Login_with":"Авторизация через %s","login_with":"Авторизация через","Logout":"Выйти","Logout_Others":"Выйти из других разделов","Mail_Message_Invalid_emails":"Вы предоставили один или более недействительных адресов электронной почты: %s","Mail_Message_Missing_to":"Вы должны выбрать одного или нескольких пользователей или указать один или несколько адресов электронной почты, разделенных запятыми.","Mail_Message_No_messages_selected_select_all":"Вы не выбрали ни одного сообщения. Хотели бы Вы сделать <a href='#' class='select-all'>select all</a> сообщения видимыми?","Mail_Messages":"Сообщения электронной почты","Mail_Messages_Instructions":"Нажимая на сообщения, выберите, какие из них Вы хотите отправить по электронной почте","Mail_Messages_Subject":"Это выделенная часть %s сообщений.","Mailer":"Отправитель","Mailer_body_tags":"Для того, чтобы отписаться, Вам <b>необходимо</b> перейти [по ссылке]. <br />Вы можете использовать [имя], [фамилию] и [отчество] в качестве полного имени пользователя.<br />Вы можете использовать [email] в качестве электронной почты пользователя.","Make_Admin":"Сделать администратором","Manager_added":"Менеджер добавлен","Manager_removed":"Менеджер удален","Mark_as_read":"Пометить как \"прочитанное\"","Markdown_Headers":"Пометить заголовки","Markdown_SupportSchemesForLink":"Поддерживать Markdown систему ссылок","Markdown_SupportSchemesForLink_Description":"Разрешённые Markdown системы через запятую","Members_List":"Пользователи","Mentions":"Упоминания","Mentions_default":"Упоминания (по умолчанию)","Message":"Сообщение","Message_AllowDeleting":"Разрешить удаление сообщений","Message_AllowEditing":"Разрешить редактирование сообщений","Message_AllowEditing_BlockEditInMinutes":"Запретить редактирование сообщений через (n) минут","Message_AllowEditing_BlockEditInMinutesDescription":"Введите 0, чтобы отключить блокировку.","Message_AllowPinning":"Разрешить прикреплять сообщения","Message_AllowPinning_Description":"Разрешить прикреплять сообщения к любому из каналов","Message_AllowStarring":"Разрешить отмечать сообщения","Message_AudioRecorderEnabled":"Запись аудио включена","Message_AudioRecorderEnabledDescription":"Необходимо подтвердить принятие  'audio/wav' файлов в настройках \"Загрузка файла\".","Message_DateFormat":"Формат даты","Message_deleting_not_allowed":"Удаление сообщений запрещено","Message_editing_blocked":"Это сообщение больше не может быть отредактировано","Message_editing_not_allowed":"Редактирование сообщений запрещено","Message_GroupingPeriod":"Период объединения (в секундах)","Message_GroupingPeriodDescription":"Сообщения будут сгруппированы вместе с предыдущим сообщением, если они оба от одного пользователя и затраченное время было меньше, чем установленное в секундах.","Message_KeepHistory":"Хранить историю сообщений","Message_MaxAllowedSize":"Максимально допустимый размер сообщения","Message_MaxAll":"Максимальный размер канала для сообщения ALL","Message_pinned":"Сообщение прикреплено","Message_pinning_not_allowed":"Прикрепление сообщений запрещено","Message_removed":"Сообщение удалено","Message_ShowDeletedStatus":"Отображать статус \"Удалено\"","Message_ShowEditedStatus":"Отображать статус \"Отредактировано\"","Message_ShowFormattingTips":"Показывать советы по форматированию","Message_TimeFormat":"Формат времени","Message_TimeFormat_Description":"Смотрите также: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Сообщение слишком длинное","Messages":"Сообщения","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Сообщения, отосланные на Входящие WebHook, будут публиковаться здесь.","Meta":"Мета","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Site Verification","Meta_language":"Язык","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Боты","minutes":"минут(ы)","Mobile_push":"Мобильные пуши","More_channels":"Другие чаты","More_direct_messages":"Больше личных сообщений","More_groups":"Больше приватных чатов","More_unreads":"Еще \"непрочитанные\"","Msgs":"Сообщения","multi":"много","Mute_someone_in_room":"Заблокировать кого-нибудь в чате","Mute_user":"Заблокировать пользователя","Muted":"Заблокировано","My_Account":"Мой аккаунт","n_messages":"%s сообщений","N_new_messages":"%s новых сообщений","Name":"Имя","Name_cant_be_empty":"Имя не может быть пустым","Name_of_agent":"Имя сотрудника","Name_optional":"Имя (необязательно)","Navigation_History_20_last_pages":"Журнал переходов (20 последних страниц)","New_Application":"Новое приложение","New_Custom_Field":"Новое пользовательское поле","New_Department":"Новый раздел","New_integration":"Новая интеграция","New_logs":"Новые регистрации","New_messages":"Новые сообщения","New_password":"Новый пароль","New_role":"Новая роль","No_channel_with_name_%s_was_found":"Чат с названием <strong>\"%s\"</strong> не найден!","No_channels_yet":"Вы не состоите в публичных чатах.","No_direct_messages_yet":"Можно писать пользователям приватные сообщения.","No_Encryption":"Без шифрования","No_favorites_yet":"В избранном пусто. Попробуй добавить сюда что-нибудь.","No_group_with_name_%s_was_found":"Приватный чат с названием <strong>\"%s\"</strong> не найден!","No_groups_yet":"Вы не состоите ни в одном приватном чате.","No_livechats":"У Вас нет livechats.","No_mentions_found":"Упоминания не найдены","No_permission_to_view_room":"У вас нет прав для просмотра этого чата.","No_pinned_messages":"Нет прикрепленных сообщений","No_results_found":"Результатов не найдено","No_starred_messages":"Сообщения без оценки","no_tokens_for_this_user":"Для этого пользователя нет символов","No_user_with_username_%s_was_found":"Пользователь с логином  <strong>\"%s\"</strong> не найден!","Not_allowed":"Не допускается","Not_authorized":"Запрещено","Not_Available":"Не доступен","Not_found_or_not_allowed":"Чат не существует или владелец ограничил доступ","Nothing":"Пусто","Nothing_found":"Ничего не найдено","Notifications":"Уведомления","Notify_all_in_this_room":"Уведомить всех в данном чате","Num_Agents":"# Сотрудники","Number_of_messages":"Количество сообщений","OAuth_Application":"Приложение OAuth","OAuth_Applications":"Приложения OAuth","Objects":"Объекты","Off_the_record_conversation":"Конфиденциальная беседа","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Конфиденциальная беседа недоступна в Вашем браузере или на Вашем устройстве.","Offline_DM_Email":"[__site__]  Вам было отправлено сообщение пользователем __user__","Offline_Mention_Email":"[__site__]  Вас упомянул(и) __user__ в #__room__","Old_and_new_password_must_be_different":"Новый пароль должен отличаться от предыдущего.","Old_and_new_password_required":"Вы должны предоставить как старый, так и новый пароль для изменения пароля.","Online":"В сети","Only_errors":"Только ошибки","Only_you_can_see_this_message":"Только Вы можете видеть это сообщение","Oops!":"Ой","Open":"Открыть","Opened":"Открыто","Opt_out_statistics":"Не отправлять мою статистику в Rocket.Chat","Opt_out_statistics_warning":"Отправляя статистику, Вы помогаете нам подсчитать количество установок Rocket.Chat, а также узнать, насколько система хорошо работает для дальнейшей ее модернизации и улучшения. Не беспокойтесь, информация о ваших чатах и пользователях конфиденциальна и не отправляется нам. Если Вы хотите отправлять нам свою статистику, уберите галочку выше. Спасибо.","optional":"дополнительно","Order":"Последовательность","OS_Arch":"Архитектура ОС","OS_Cpus":"Количество процессоров в ОС","OS_Freemem":"Свободное кол-во памяти","OS_Loadavg":"Загрузка ОС","OS_Platform":"Платформа ОС","OS_Release":"Версия ОС","OS_Totalmem":"Общее кол-во памяти в ОС","OS_Type":"Тип ОС","OS_Uptime":"Uptime системы","others":"другие","OTR":"Конфиденциальность","OTR_is_only_available_when_both_users_are_online":"Конфиденциальная беседа доступна, когда оба пользователя online.","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Отклонить URL-адрес, на который загружены файлы. Этот URL-адрес также используется для загрузок в том случае, если указан CDN.","Password":"Пароль","Password_Change_Disabled":"Администратор отключил возможность изменения паролей","Password_changed_successfully":"Пароль успешно изменен","Payload":"Тело запроса","People":"Люди","Permissions":"Настройка прав","Pin_Message":"Прикрепить сообщение","Pinned_a_message":"Прикрепленное сообщение:","Pinned_Messages":"Прикрепленные сообщения","Placeholder_for_email_or_username_login_field":"Поля для заполнения электронного адреса или имени пользователя","Placeholder_for_password_login_field":"Поле для заполнения пароля","Please_answer_survey":"Пожалуйста, уделите минуту для того, чтобы ответить на несколько вопросов об этом чате","Please_enter_value_for_url":"Пожалуйста, введите значение для URL-адреса Вашего аватара.","Please_enter_your_new_password_below":"Введите Ваш новый пароль ниже:","Please_fill_a_label":"Заполните подпись","Please_fill_a_name":"Введите имя","Please_fill_a_username":"Заполните имя пользователя","Please_fill_name_and_email":"Введите имя и электронный адрес","Please_re_enter_your_password":"Повторно введите свой пароль","Please_select_enabled_yes_or_no":"Выберите вариант \"Разрешено\"","Please_wait":"Минуточку","Please_wait_activation":"Пожалуйста, подождите, это может занять некоторое время.","Please_wait_statistics":"Пожалуйста, подождите, статистика генерируется.","Please_wait_while_OTR_is_being_established":"Подождите, пока Ваша конфиденциальная беседа устанавливается","Please_wait_while_your_account_is_being_deleted":"Подождите, Ваш аккаунт удаляется...","Please_wait_while_your_profile_is_being_saved":"Подождите, пока Ваш профиль сохраняется...","Post_as":"Опубликовать как","Post_to_Channel":"Опубликовать на канал","Post_to_s_as_s":"Опубликовать на <strong>%s</strong> как <strong>%s</strong>","Powered_by":"Реализовано на","Preferences":"Настройки","Preferences_saved":"Настройки сохранены","Privacy":"Приватность","Private_Group":"Приватный чат","Private_Groups":"Приватные чаты","Private_Groups_list":"Список приватных чатов","Profile":"Профиль","Profile_saved_successfully":"Профиль успешно сохранен","Proudly_developed":"Разработано с Meteor","Push":"Push-уведомления","Push_apn_cert":"APN сертификат","Push_apn_dev_cert":"APN сертификат разработчика","Push_apn_dev_key":"APN ключ разработчика","Push_apn_dev_passphrase":"APN кодовая фраза разработчика","Push_apn_key":"APN ключ","Push_apn_passphrase":"APN кодовая фраза","Push_debug":"Отладка","push_disabled":"Push-уведомления отключены","Push_enable":"Включить","Push_enable_gateway":"Разрешить доступ","Push_gateway":"Доступ","Push_gcm_api_key":"GCM API-ключ","Push_gcm_project_number":"GCM номер проекта","Push_production":"Производство","Push_show_message":"Показать сообщение в уведомлении","Push_show_username_room":"Показать канал/группу/имя пользователя в уведомлении","Push_test_push":"Тест","Query":"Запрос","Query_description":"Дополнительные условия для определения того, каким пользователям отправлять электронную почту. Пользователи, не получающие рассылку, автоматически удалены из запроса. Формат JSON должен быть действителен. Например: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Быстрый поиск","quote":"цитата","Reactions":"Реакции","Recents":"Недавние","Record":"Запись","Redirect_URI":"Перенаправить URL-адрес","Refresh_keys":"Обновить клавиши","Refresh_your_page_after_install_to_enable_screen_sharing":"Чтобы включить демонстрацию экрана, обновите страницу после установки","Register":"Зарегистрироваться","Registration_Succeeded":"Успешная регистрация","Remember_me":"Запомните меня","Remove":"Удалить","Remove_Admin":"Разжаловать администратора","Remove_as_moderator":"Удалить в качестве модератора","Remove_as_owner":"Удалить как владелец","Remove_custom_oauth":"Удалить пользовательский OAuth","Remove_from_room":"Удалить из чата","Remove_someone_from_room":"Удалить кого-то из чата","Removed":"Удаленные","Require_password_change":"Требуется смена пароля","Resend_verification_email":"Отправить проверочный email ещё раз","Reset":"Сбросить","Reset_password":"Сбросить пароль","Restart":"Перезапустить","Restart_the_server":"Перезапустить сервер","RocketBot_Enabled":"Чат-бот включен","RocketBot_Name":"Имя чат-бота","RocketBot_Name_Description":"Имя чат-бота должно быть действительным именем пользователя зарегистрированным на вашем сервере.","Role":"Роль","Role_Editing":"Редактировать роль","Role_removed":"Роль удалена","Room":"Чат","Room_archivation_state":"Статус","Room_archivation_state_false":"В сети","Room_archivation_state_true":"Удалено","Room_archived":"Чат удалён","room_changed_privacy":"Тип чата изменен  <em>__user_by__</em> на: <em>__room_type__</em>","room_changed_topic":"Тема чата сменена <em>__user_by__</em> на: <em>__room_topic__</em>","Room_has_been_deleted":"Чат был удалён","Room_Info":"Информация чата","Room_name_changed":"Название чата изменено: <em>__room_name__</em> пользователем <em>__user_by__</em>","Room_name_changed_successfully":"Название чата успешно изменено","Room_not_found":"Чат не найден","Room_topic_changed_successfully":"Тема чата успешно изменена","Room_type_changed_successfully":"Тип чата успешно изменен","Room_unarchived":"Чат в архиве","Room_uploaded_file_list":"Список файлов","Room_uploaded_file_list_empty":"Нет доступных файлов","room_user_count":"%s пользователей","Rooms":"Чаты","S_new_messages_since_s":"%s новых сообщений с %s","SAML":"SAML разметка","SAML_Custom_Cert":"Пользовательский сертификат","SAML_Custom_Entry_point":"Пользовательская точка входа","SAML_Custom_Generate_Username":"Сгенерировать имя пользователя","SAML_Custom_Issuer":"Пользовательская организация","SAML_Custom_Provider":"Пользовательский поставщик","Save":"Сохранить","Save_changes":"Сохранить изменения","Save_Mobile_Bandwidth":"Включить режим экономии трафика","Save_to_enable_this_action":"Сохранить, чтобы активировать это действие","Saved":"Сохранено","Saving":"Сохранение","Scope":"Область","Screen_Share":"Демонстрация экрана","Script_Enabled":"Сценарий включен","Search":"Поиск","Search_by_username":"Поиск по имени пользователя","Search_Channels":"Поиск каналов","Search_Direct_Messages":"Поиск личных сообщений","Search_Messages":"Поиск сообщений","Search_Private_Groups":"Поиск приватных чатов","Search_settings":"Настройки поиска","seconds":"секунд(ы)","See_all":"К общему списку","See_only_online":"Только в сети","Select_a_department":"Выберите раздел","Select_an_avatar":"Выберите аватар","Select_file":"Выберите файл","Select_service_to_login":"Выберите сервис для входа или загрузите изображение с компьютера","Select_user":"Выберите пользователя","Select_users":"Выберите пользователей","Selected_agents":"Выбранные сотрудники","Selected_users":"Выбранные участники","Send":"Отправить","Send_a_message":"Отправить сообщение","Send_a_test_mail_to_my_user":"Отправить тестовое сообщение моему пользователю","Send_a_test_push_to_my_user":"Отправить тестовое push-уведомление моему пользователю","Send_confirmation_email":"Отправить письмо с подтверждением","Send_data_into_RocketChat_in_realtime":"Отправить данные на Rocket.Chat в режиме реального времени.","Send_email":"Отправить письмо","Send_invitation_email":"Отправить приглашение по электронной почте","Send_invitation_email_error":"Вы не предоставили корректный e-mail адрес.","Send_invitation_email_info":"Вы можете отправить несколько e-mail приглашений за раз.","Send_invitation_email_success":"Вы успешно отправили приглашения на следующие адреса:","Send_invitation_email_warning":"Для отправки приглашения по электронной почте, Вы должны настроить параметры SMTP.","Send_Message":"Отправить сообщение","Send_your_JSON_payloads_to_this_URL":"Отправить Ваши полезные данные формата JSON на этот URL-адрес.","Sending":"Отправка...","Set_as_moderator":"Назначить в качестве модератора","Set_as_owner":"Назначить в качестве владельца","Settings":"Настройки","Settings_updated":"Настройки обновлены","Should_be_a_URL_of_an_image":"Это должен быть URL-адрес или изображение.","Should_exists_a_user_with_this_username":"Пользователь уже должен существовать.","Show_all":"Показать все","Show_more":"Показать больше","Show_only_online":"Показать только online","Show_preregistration_form":"Показать предварительную регистрационную форму","Showing_archived_results":"<p>Демонстрация <b>%s</b> архивных результатов</p>","Showing_online_users":"Показано <b>__total_showing__</b> из __total__ пользователей","Showing_results":"<p>Отображено <b>%s</b> результатов</p>","Silence":"Тишина","since_creation":"с %s","Site_Name":"Название сайта","Site_Url":"URL-адрес сайта","Site_Url_Description":"Пример: https://chat.domain.com/","Skip":"Пропустить","Smileys_and_People":"Смайлики и люди","SMTP":"Протокол SMTP","SMTP_Host":"SMTP хост","SMTP_Password":"SMTP Пароль","SMTP_Port":"SMTP Порт","SMTP_Test_Button":"Настройка тестового протокола SMTP","SMTP_Username":"SMTP пользователь","Sound":"Звук","Star_Message":"Оценить сообщение","Starred_Messages":"Сообщения с оценкой","Start_audio_call":"Начать голосовой вызов","Start_Chat":"Начать чат","Start_of_conversation":"Начать диалог","Start_OTR":"Начать конфиденциальную беседу","Start_video_call":"Начать видеозвонок","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Начните с <code class=\"inline\">%s</code> для пользователя или <code class=\"inline\">%s</code> для канала. Например: <code class=\"inline\">%s</code> или <code class=\"inline\">%s</code>","Statistics":"Статистика","Stats_Active_Users":"Активные пользователи","Stats_Avg_Channel_Users":"Количество пользователей в публичных чатах","Stats_Avg_Private_Group_Users":"Количество пользователей в приватных чатах","Stats_Away_Users":"Отошедших пользователей","Stats_Max_Room_Users":"Максимальное количество пользователей в чате","Stats_Non_Active_Users":"Неактивные пользователи","Stats_Offline_Users":"Пользователи не в сети","Stats_Online_Users":"Пользователи в сети","Stats_Total_Channels":"Всего публичных чатов","Stats_Total_Direct_Messages":"Общее количество сообщений в личных чатах","Stats_Total_Messages":"Всего сообщений","Stats_Total_Private_Groups":"Всего приватных чатов","Stats_Total_Rooms":"Всего чатов","Stats_Total_Users":"Всего пользователей","Stop_Recording":"Остановить запись","strike":"зачеркнутый","Subject":"Тема","Submit":"Отправить","Success":"Выполнено","Survey":"Опрос","Survey_instructions":"Оценивайте каждый вопрос по 5-балльной шкале, где 1 означает, что Вы совсем недовольны, и 5 - полностью довольны.","Symbols":"Символы","Sync_success":"Синхронизация прошла успешно","Sync_Users":"Синхронизация пользователей","Test_Connection":"Проверка соединения","Test_Desktop_Notifications":"Проверить уведомления рабочего стола","Thank_you_for_your_feedback":"Спасибо за Ваш отзыв","The_application_name_is_required":"Требуется наименование приложения","The_channel_name_is_required":"Имя канала обязательно","The_emails_are_being_sent":"Письма отправляются.","The_field_is_required":"Поле %s обязательно.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Изменить размер изображения не получится, потому что мы не можем обнаружить установленные на Вашем сервере ImageMagick или GraphicsMagick.","The_redirectUri_is_required":"Требуется перенаправление URL-адреса","The_server_will_restart_in_s_seconds":"Сервер перезапустится через % секунд","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Параметр <strong>%s</strong> настраивается на <strong>%s</strong> и Вы получаете доступ из <strong>%s</strong>!","The_user_will_be_removed_from_s":"Пользователь будет удален из %s","The_user_wont_be_able_to_type_in_s":"Пользователь не сможет ввести в %s","Theme":"Тема","theme-color-action-buttons-color":"Цвет кнопок действий","theme-color-active-channel-background-color":"Цвет фона активного канала","theme-color-active-channel-font-color":"Цвет шрифта активного канала","theme-color-blockquote-background":"Цвет фона цитат","theme-color-clean-buttons-color":"Цвет кнопок \"удалить\"","theme-color-code-background":"Код цвета фона","theme-color-code-border":"Код цвета рамки","theme-color-code-color":"Код цвета","theme-color-content-background-color":"Цвет фона содержимого","theme-color-custom-scrollbar-color":"Пользовательский цвет полосы прокрутки","theme-color-info-active-font-color":"Цвет шрифта актуальной информации","theme-color-info-font-color":"Цвет шрифта информации","theme-color-input-font-color":"Цвет шрифта ввода","theme-color-link-font-color":"Цвет шрифта ссылки","theme-color-message-hover-background-color":"Цвет фона сообщения при наведении","theme-color-primary-background-color":"Основной цвет фона","theme-color-primary-font-color":"Основной цвет шрифта","theme-color-quaternary-font-color":"Четвёртый цвет шрифта","theme-color-secondary-background-color":"Второй цвет фона","theme-color-secondary-font-color":"Второй цвет шрифта","theme-color-smallprint-font-color":"Цвет мелкого шрифта","theme-color-smallprint-hover-color":"Цвет мелкого шрифта при наведении","theme-color-status-away":"Цвет статуса \"Нет на месте\"","theme-color-status-busy":"Цвет статуса \"Занят\"","theme-color-status-offline":"Цвет статуса \"Не в сети\"","theme-color-status-online":"Цвет статуса \"В сети\"","theme-color-tertiary-background-color":"Третий цвет фона","theme-color-tertiary-font-color":"Третий цвет шрифта","theme-color-unread-notification-color":"Цвет непрочитанных уведомлений","theme-custom-css":"Пользовательский CSS","There_are_no_agents_added_to_this_department_yet":"Сотрудников, добавленных в этот раздел, не найдено.","There_are_no_integrations":"Интеграций нет","There_are_no_users_in_this_role":"Пользователей в этой должности не найдено.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Такой email уже использовался и не был подтверждён. Измените Ваш пароль.","This_is_a_desktop_notification":"Это уведомление рабочего стола","This_is_a_push_test_messsage":"Это тестовое push-уведомление","Time_in_seconds":"Время в секундах","Title_bar_color":"Цвет строки заголовка","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Для того, чтобы установить Rocket.Chat Livechat на Вашем сайте, скопируйте &amp; и вставьте этот код выше последнего <strong>&lt;/body&gt;</strong> тега на Вашем сайте.","To_users":"Пользователям","Topic":"Тема","Travel_and_Places":"Путешествия и места","Trigger_removed":"Триггер удален","Trigger_Words":"Слова запуска","Triggers":"Триггер","True":"Да","Type":"Тип","Type_your_new_password":"Введите новый пароль","Unarchive":"Восстановить","Unmute_someone_in_room":"Разблокировать кого-нибудь в чате","Unmute_user":"Разблокировать пользователя","Unnamed":"Без названия","Unpin_Message":"Открепить сообщение","Unread_Rooms":"Непрочитанные чаты","Unread_Rooms_Mode":"Режим \"непрочитанные чаты\"","Unstar_Message":"Убрать оценку","Upload_file_question":"Загрузить файл?","Uploading_file":"Загрузка файла...","Use_account_preference":"Использовать параметры аккаунта","Use_Emojis":"Использовать Emojis","Use_initials_avatar":"Использовать стандартный аватар","use_menu":"Используйте боковое меню для доступа к вашим сообщениям и чатам","Use_service_avatar":"Использовать %s аватар","Use_this_username":"Использовать это имя пользователя","Use_uploaded_avatar":"Использовать загруженную аватарку","Use_url_for_avatar":"Использовать аватар по URL","User__username__is_now_a_moderator_of__room_name_":"Пользователь  __username__ сейчас является модератором __room_name__","User__username__is_now_a_owner_of__room_name_":"Пользователь __username__ является владельцем __room_name__","User__username__removed_from__room_name__moderators":"Пользователь __username__ удален из __room_name__ модераторов","User__username__removed_from__room_name__owners":"Пользователь __username__ удален из __room_name__ владельцев","User_added":"Пользователь <em>__user_added__</em> добавлен.","User_added_by":"Пользователь <em>__user_added__</em> добавлен <em>__user_by__</em>.","User_added_successfully":"Пользователь успешно добавлен","User_Channels":"Чаты пользователя","User_doesnt_exist":"Пользователя с логином `@%s` не существует.","User_has_been_activated":"Пользователь активирован","User_has_been_deactivated":"Пользователь деактивирован","User_has_been_deleted":"Пользователь был удален","User_has_been_muted_in_s":"Пользователь заблокирован в %s","User_has_been_removed_from_s":"Пользователь удален из %s","User_has_disconnected":"Пользователь отключился","User_Info":"Информация о пользователе","User_is_no_longer_an_admin":"Пользователь больше не администратор","User_is_not_activated":"Пользователь не активирован","User_is_now_an_admin":"Пользователь теперь администратор","User_joined_channel":"Присоединился к чату.","User_joined_channel_female":"Присоединилась к чату.","User_joined_channel_male":"Присоединился к чату.","User_left":"<em>__user_left__</em> покинул чат.","User_left_female":"<em>__user_left__</em> покинула чат.","User_left_male":"<em>__user_left__</em> покинул чат.","User_logged_out":"Пользователь не в сети","User_management":"Управление пользователями","User_muted_by":"Пользователь <em>__user_muted__</em> заблокирован пользователем <em>__user_by__</em>.","User_muted_in_room":"Пользователь заблокирован в чате","User_not_found":"Пользователь не найден","User_not_found_or_incorrect_password":"Пользователь не найден, или введен неправильный пароль","User_or_channel_name":"Имя пользователя или канала","User_removed":"Пользователь удален","User_removed_by":"Пользователь <em>__user_removed__</em> удален <em>__user_by__</em>.","User_removed_from_room":"Пользователь был удалён из чата","User_Settings":"Пользовательские настройки","User_unmuted_by":"Пользователь <em>__user_unmuted__</em> разблокирован пользователем <em>__user_by__</em>.","User_unmuted_in_room":"Пользователь разблокирован в чате","User_updated_successfully":"Пользователь успешно обновлен","Username":"Имя пользователя","Username_and_message_must_not_be_empty":"Имя пользователя или сообщение не должны быть пустыми","Username_cant_be_empty":"Имя пользователя не может быть пустым","Username_Change_Disabled":"Администратор отключил возможность изменения имен пользователей","Username_denied_the_OTR_session":"__username__ отклонил конфиденциальную беседу","Username_description":"Имя пользователя используется для обращения других участников к вам.","Username_doesnt_exist":"Имя пользователя `%s` не существует.","Username_ended_the_OTR_session":"__username__ завершил конфиденциальную беседу","Username_invalid":"<strong>%s</strong> &mdash; некорректное имя пользователя, <br/> можно использовать только цифры, точки, подчеркивания и латинские буквы","Username_is_already_in_here":"`@%s` уже здесь.","Username_is_not_in_this_room":"Пользователь `#%s` не в этом чате.","Username_not_found":"Пользователь не найден","Username_title":"Зарегистрировать логин","Username_unavaliable":"<strong>%s</strong> уже используется :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ хочет начать конфиденциальную беседу. Принять?","Users":"Пользователи","Users_in_role":"Пользователи с ролью","UTF8_Names_Slugify":"UTF8 Имена","UTF8_Names_Validation":"UTF8 подтверждение имен","UTF8_Names_Validation_Description":"Специальные символы запрещены. Вы можете использовать - _ и . но только не в конце имени","Verification_email_sent":"Проверочный email отправлен","View_All":"Посмотреть всех","View_Logs":"Просмотреть журнал","Visibility":"Видимость","Visible":"Показывать","Visitor":"Посетитель","Visitor_page_URL":"URL-адрес страницы посетителя","Visitor_time_on_site":"Время посетителя, проведённое на сайте","Wait_activation_warning":"Прежде чем Вы сможете войти в ваш аккаунт, он должен быть активирован администратором.","We_are_offline_Sorry_for_the_inconvenience":"Мы не в сети. Извините за доставленные неудобства.","We_have_sent_password_email":"На вашу почту было отправлено письмо с инструкциями. Если по каким-то причинам письмо не пришло, попробуйте еще раз и/или напишите нам.","We_have_sent_registration_email":"Все отлично. Осталось только подтвердить регистрацию - письмо выслано на почту. Если что-то пошло не так, попробуйте еще раз и/или напишите нам.","WebRTC_Enable_Channel":"Включить для публичных чатов","WebRTC_Enable_Direct":"Включить для личных сообщений","WebRTC_Enable_Private":"Включить для приватных чатов","WebRTC_Servers":"Серверы STUN/TURN","WebRTC_Servers_Description":"Список STUN/TURN серверов разделен запятой.<br/>Имя пользователя, пароль и порт разрешены в формате `username:password@stun:host:port` или `username:password@turn:host:port`.","Welcome":"Добро пожаловать, <em>%s</em>.","Welcome_to_the":"Добро пожаловать в","will_be_able_to":"в состоянии","With_whom":"C кем","Yes":"Да","Yes_clear_all":"Да, удалить все!","Yes_delete_it":"Да, удалить его!","Yes_hide_it":"Да, спрятать!","Yes_leave_it":"Да, покинуть!","Yes_mute_user":"Да, заблокировать пользователя!","Yes_remove_user":"Да, удалить пользователя!","you_are_in_preview_mode_of":"Вы находитесь в режиме предварительного просмотра # <strong>__room_name__</strong>","You_are_logged_in_as":"Вы вошли как","You_are_not_authorized_to_view_this_page":"Недостаточно прав для просмотра страницы.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Вы последний владелец чата. Пожалуйста, назначьте нового владельца до выхода из этого чата.","You_can_change_a_different_avatar_too":"Вы можете не принимать аватар, используемый для публикации из интеграции.","You_can_use_an_emoji_as_avatar":"Вы также можете использовать emoji в качестве аватара.","You_have_been_muted":"Вы были заблокированы и не можете говорить в этом чате","You_have_not_verified_your_email":"Вы не подтвердили email.","You_have_successfully_unsubscribed":"Вы успешно отписаны от нашей почтовой рассылки.","You_informed_an_invalid_FROM_address":"Вы сообщили неверный адрес отправителя.","You_must_provide_the_unsubscribe_link":"Для того, чтобы [отписаться], Вы должны предоставить эту ссылку.","You_need_confirm_email":"Необходимо подтвердить email для входа!","You_need_install_an_extension_to_allow_screen_sharing":"Для демонстрации экрана Вам необходимо установить расширение","You_need_to_change_your_password":"Вам необходимо сменить пароль","You_need_to_type_in_your_password_in_order_to_do_this":"Для этого действия необходимо ввести пароль!","You_need_to_type_in_your_username_in_order_to_do_this":"Для этого действия необходимо ввести имя пользователя!","You_need_to_verifiy_your_email_address_to_get_notications":"Вам необходимо подтвердить свой email для получения уведомлений","You_should_name_it_to_easily_manage_your_integrations":"Для того, чтобы легко управлять Вашими интеграциями, Вы должны это обозначить","You_will_not_be_able_to_recover":"Вы не сможете восстановить это сообщение!","You_will_not_be_able_to_recover_file":"Восстановить этот файл будет невозможно!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Вы не можете получать уведомления по email, потому что не подтвердили его.","Your_email_has_been_queued_for_sending":"Ваш email был поставлен в очередь на отправку","Your_entry_has_been_deleted":"Ваша запись была удалена.","Your_file_has_been_deleted":"Ваш файл был удалён.","Your_mail_was_sent_to_s":"Ваше сообщение было отправлено на %s","Your_Open_Source_solution":"Ваш собственный чат на базе Open Source-технологий","Your_password_is_wrong":"Неверный пароль!","Your_push_was_sent_to_s_devices":"Ваше push-уведомление было отправлено на % устройств."});
TAPi18n._registerServerTranslator("ru", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/sq.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["sq"] = ["Albanian","Shqip"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["sq"])) {                                                                        // 9
  TAPi18n.translations["sq"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["sq"][namespace])) {                                                             // 13
  TAPi18n.translations["sq"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["sq"][namespace], {"500":"Server Error brendshme","0_Errors_Only":"0 - Gabimet Vetëm","1_Errors_and_Information":"1 - Gabimet dhe Informacione","2_Erros_Information_and_Debug":"2 - Erros, Informacion dhe Debug","__username__was_set__role__by__user_by_":"__username__ u __role__ nga __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ nuk është më __role__, duke __user_by__","Access_not_authorized":"Qasja jo e autorizuar","Access_online_demo":"Hyni demo internet","Access_Online_Demo":"Qasja Online Demo","Access_Token_URL":"Qasja Token URL","Accounts":"llogaritë","Accounts_AllowDeleteOwnAccount":"Lejo përdoruesit të fshini llogarinë e","Accounts_AllowedDomainsList":"Lejohet Lista Domains","Accounts_AllowedDomainsList_Description":"lista të ndara me presje të fushave të lejuara","Accounts_AllowEmailChange":"Lejo E-mail Change","Accounts_AllowPasswordChange":"Lejo Password Change","Accounts_AllowUserAvatarChange":"Lejo User Avatar Change","Accounts_AllowUsernameChange":"Lejo përdoruesit Ndryshimi","Accounts_AllowUserProfileChange":"Lejo përdoruesit Profilin Change","Accounts_AvatarResize":"resize Avatars","Accounts_AvatarSize":"Avatar Size","Accounts_AvatarStorePath":"Avatari Storage Path","Accounts_AvatarStoreType":"Avatari Storage Lloji","Accounts_BlockedDomainsList":"Blocked Lista Domains","Accounts_BlockedDomainsList_Description":"lista të ndara me presje të fushave të bllokuara","Accounts_denyUnverifiedEmail":"Deny email paverifikuar","Accounts_EmailVerification":"E-mail Verifikimi","Accounts_EmailVerification_Description":"Sigurohuni që keni cilësimet e duhura SMTP për të përdorur këtë funksion","Accounts_Enrollment_Email":"Regjistrimi E-mail","Accounts_Enrollment_Email_Description":"Ju mund të përdorni [emri], [EMRI], [MBIEMRI] për emrin e plotë të përdoruesit, emrin e parë ose emrin e fundit, respektivisht. <br /> Ju mund të përdorni [email] për email të përdoruesit.","Accounts_Iframe_api_method":"Metoda api","Accounts_Iframe_api_url":"api Url","Accounts_iframe_enabled":"enabled","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Përfundimi Login në Ditët","Accounts_ManuallyApproveNewUsers":"Dorë Miratimi Përdoruesit reja","Accounts_OAuth_Custom_Token_Sent_Via":"Token Sent Via","Accounts_OAuth_Custom_Authorize_Path":"autorizojë Path","Accounts_OAuth_Custom_Button_Color":"Button Color","Accounts_OAuth_Custom_Button_Label_Color":"Button Text Color","Accounts_OAuth_Custom_Button_Label_Text":"Button Text","Accounts_OAuth_Custom_Enable":"mundësoj","Accounts_OAuth_Custom_id":"id","Accounts_OAuth_Custom_Identity_Path":"Path Identity","Accounts_OAuth_Custom_Login_Style":"Style Login","Accounts_OAuth_Custom_Secret":"sekret","Accounts_OAuth_Custom_Token_Path":"Path Token","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Login","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Enabled","Accounts_OAuth_Github_callback_url":"Github Callback URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise Callback URL","Accounts_OAuth_GitHub_Enterprise_id":"klienti Id","Accounts_OAuth_GitHub_Enterprise_secret":"klienti Secret","Accounts_OAuth_Github_id":"klienti Id","Accounts_OAuth_Github_secret":"klienti Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab Callback URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"klienti Secret","Accounts_OAuth_Google":"Google Login","Accounts_OAuth_Google_callback_url":"Google Callback URL","Accounts_OAuth_Google_id":"Google Id","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn Login","Accounts_OAuth_Linkedin_callback_url":"Linkedin Callback URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor Login","Accounts_OAuth_Meteor_callback_url":"Meteor Callback URL","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter Login","Accounts_OAuth_Twitter_callback_url":"Twitter Callback URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"Wordpress Callback URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"Password Reset","Accounts_Registration_AuthenticationServices_Enabled":"Regjistrimi me Authentication Shërbimet","Accounts_RegistrationForm":"Forma e Regjistrimit","Accounts_RegistrationForm_Disabled":"i paaftë","Accounts_RegistrationForm_LinkReplacementText":"Regjistrimi Form Link Text Replacement","Accounts_RegistrationForm_Public":"publik","Accounts_RegistrationForm_Secret_URL":"URL Secret","Accounts_RegistrationForm_SecretURL":"Regjistrimi Form Secret URL","Accounts_RegistrationForm_SecretURL_Description":"Ju duhet të sigurojë një varg të rastit që do të shtohet në URL tuaj e regjistrimit. Shembull: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Regjistrimi kërkuar","Accounts_RequireNameForSignUp":"Kërkojnë Emri For Regjistrohu","Accounts_ShowFormLogin":"Tregojnë formë të bazuar Login","Accounts_UseDefaultBlockedDomainsList":"Përdorimi Default Blocked Lista Domains","Accounts_UseDNSDomainCheck":"Përdorni DNS Domain Kontrollo","Activate":"aktivizoj","Activity":"aktivitet","Add":"shtoj","Add_agent":"Shto agjent","Add_custom_oauth":"Shto OAuth porosi","Add_manager":"Shto menaxher","Add_Members":"Shto Anëtarët","Add_User":"Shto përdoruesin","Add_user":"Shto përdorues","Add_users":"Shtoni përdoruesit","Additional_emails":"Shtesë E-mail","Additional_Feedback":"Feedback shtesë","Administration":"administratë","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Pas vërtetimit OAuth2, përdoruesit do të ridrejtuar në këtë URL","Agent_added":"Agent shtuar","Agent_removed":"Agent hequr","Alias":"pseudonim","All":"të gjithë","All_channels":"Të gjitha kanalet","All_logs":"Të gjitha shkrimet","All_messages":"Të gjitha mesazhet","Allow_Invalid_SelfSigned_Certs":"Lejo Invalid Self-Signed Certs","Allow_Invalid_SelfSigned_Certs_Description":"Lejo të pavlefshme dhe të vetë-nënshkruar-së certifikatë SSL për vlefshmërinë Lidhje dhe previews.","and":"dhe","And_more":"Dhe më shumë __length __...","Animals_and_Nature":"Animals & Natyra","API":"API","API_Analytics":"Analitikë","API_Embed":"Mbjell","API_EmbedDisabledFor":"Mbjell Disable për Përdoruesit","API_EmbedDisabledFor_Description":"Të ndara me presje lista e përdoruesve","API_GitHub_Enterprise_URL":"server URL","API_GitHub_Enterprise_URL_Description":"Shembull: http://domain.com (përjashtuar zvarritës slash)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"shfaqje","Application_added":"aplikimi shtuar","Application_Name":"aplikimi Emri","Application_updated":"aplikimi updated","Apply_and_refresh_all_clients":"Aplikoni dhe rifreskoni të gjithë klientët","Archive":"Arkivi","Archive_Unarchive":"Arkiva / Hiq nga arkivi","are_also_typing":"janë gjithashtu shtypja","are_typing":"janë shtypur","Are_you_sure":"Jeni te sigurte qe?","Are_you_sure_you_want_to_delete_your_account":"Jeni te sigurte qe doni te fshini llogarinë tuaj?","Authorization_URL":"URL autorizimi","Authorize":"Autorizoj","AutoLinker_StripPrefix":"AutoLinker Strip Prefix","AutoLinker_StripPrefix_Description":"shfaqje të shkurtër. p.sh. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL rregullt Expression","AutoLinker_Email":"AutoLinker Email","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"të lidhura automatikisht për numrat e telefonit. p.sh. `(123) 456-7890`","Auto_Load_Images":"Images Auto Load","Available":"në dispozicion","Available_agents":"agjentët në dispozicion","Avatar":"Ndrysho avatarin","Avatar_changed_successfully":"Avatari i ndryshuar me sukses","Avatar_URL":"Avatari URL","Avatar_url_invalid_or_error":"Url dhënë është e pavlefshme ose jo të arritshme. Ju lutemi të provoni përsëri, por me një url ndryshme.","away":"larg","Away":"Larg","away_female":"larg","Away_female":"Larg","away_male":"larg","Away_male":"Larg","Back":"prapa","Back_to_applications":"Mbrapsht në aplikimet","Back_to_integrations":"Mbrapsht në integrimet","Back_to_login":"Kthehu tek login","Back_to_permissions":"Mbrapsht në lejet","Body":"trup","bold":"guximshme","busy":"i zënë","Busy":"I zënë","busy_female":"i zënë","Busy_female":"I zënë","busy_male":"i zënë","Busy_male":"I zënë","Cancel":"Anuloj","Cannot_delete_a_protected_role":"nuk mund të fshini një rol të mbrojtur","Cannot_delete_role_because_its_in_use":"nuk mund të fshini rol, sepse kjo është në përdorim","Cannot_invite_users_to_direct_rooms":"Nuk mund të ftojë përdoruesit për të drejtuar dhoma","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certifikatat dhe Keys","Channel":"kanal","Channel_doesnt_exist":"Kanali `# %s` nuk ekziston.","Channels":"Kanalet","Channels_list":"Lista e kanaleve publike","Chat_Rooms":"Chat dhoma","Chatops_Enabled":"Aktivizo Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Emri i përdoruesit","Choose_a_room":"Zgjidhni një dhomë","Choose_messages":"zgjidhni mesazhe","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Zgjidhni pseudonim që do të shfaqet para emrin e përdoruesit në mesazhe.","Choose_the_username_that_this_integration_will_post_as":"Zgjidhni emrin se ky integrim do të postoni si.","Clear_all_unreads_question":"Qartë të gjitha unreads?","Client_ID":"ID klienti","Client_Secret":"klienti Secret","Clients_will_refresh_in_a_few_seconds":"Klientët do të rifreskoni në pak sekonda","close":"Mbyll","Closed":"Mbyllur","Collapse_Embedded_Media_By_Default":"Collapse media ngulitur by default","coming_soon":"se shpejti","Commands":"komandat","Compact_View":"Compact View","Confirm_password":"Konfirmoni fjalëkalimin tuaj","Contact":"Kontakt","Conversation":"Bisedë","Convert_Ascii_Emojis":"Convert ASCII të Emoji","Copied":"kopjuar","COPY_TO_CLIPBOARD":"Copy to clipboard","Copy_to_clipboard":"Kopjo në clipboard","Count":"akuzë","Create":"krijoj","Create_new":"Krijo  te ri","Created_at":"Krijuar në","Created_at_s_by_s":"Krijuar <strong>në %s</strong> <strong>nga %s</strong>","Custom_Fields":"Fushat Custom","Custom_oauth_helper":"Kur ngritjen Provider tuaj OAuth, ju do të keni për të informuar një URL callback. përdorim <pre> %s </pre> .","Custom_oauth_unique_name":"Emri Custom OAuth unike","Custom_Script_Logged_In":"Custom Script për përdoruesit e regjistruar në","Custom_Script_Logged_Out":"Custom Script për përdoruesit e regjistruar jashtë","Dashboard":"baltëpritëse","days":"ditë","Deactivate":"transferoj në rezervë","Debug_Level":"debug Niveli","Default":"Default","Delete":"fshij","Delete_my_account":"Fshij llogarinë time","Delete_Room_Warning":"Fshirja e një dhomë të fshirë të gjitha mesazhet e postuara në dhomë. Kjo nuk mund të zhbëhet.","Delete_User_Warning":"Fshirja e një përdorues do të fshirë të gjitha mesazhet nga këtë përdorues, si dhe. Kjo nuk mund të zhbëhet.","Deleted":"Fshihet!","Department_not_found":"Departamenti nuk u gjet","Department_removed":"Departamenti hequr","Departments":"departamentet","Description":"Përshkrim","Desktop":"Desktop","Desktop_Notification_Test":"Desktop Njoftimi Test","Desktop_Notifications":"desktop Njoftime","Desktop_Notifications_Disabled":"Desktop Notifications janë me aftësi të kufizuara. Ndrysho preferencat e shfletuesit tuaj nëse keni nevojë Njoftimet aktivizuar.","Desktop_Notifications_Enabled":"Desktop Notifications janë Enabled","Direct_message_someone":"Mesazhi Direct dikush","Direct_Messages":"Mesazhe Private","Direct_Messages_list":"Mesazhet direkte","Disable_Favorite_Rooms":"Favoritet Çaktivizo","Disable_New_Message_Notification":"Disable New Message Njoftim","Disable_New_Room_Notification":"Disable New Room Njoftim","Displays_action_text":"Teksti tregon veprim","Do_you_want_to_change_to_s_question":"A doni të ndryshojë <strong>për %s?</strong>","Drop_to_upload_file":"Drop të ngarkoni fotografi","Dry_run":"drejtuar të thatë","Dry_run_description":"Do të dërgojë vetëm një email, të njëjtën adresë me atë nga. E-mail duhet t'i përkasë një përdorues të vlefshme.","Duplicate_archived_channel_name":"Një arkivuar Channel me emrin ' %s' ekziston","Duplicate_archived_private_group_name":"Një Group arkivuar Private me emrin ' %s' ekziston","Duplicate_private_group_name":"Një grup privat me emrin ekziston ' %s'","E-mail":"E-mail","Edit":"redaktoj","Edit_Custom_Field":"Edit Custom Field","Edit_Department":"Edit Department","edited":"edited","Email":"Email","Email_already_exists":"Emaili ekziston","Email_body":"Trupi E-mail","Email_Change_Disabled":"Administratori juaj Rocket.Chat ka pezulluar ndryshimin e-mail","Email_from":"nga","Email_Notification_Mode":"Njoftimet Offline Email","Email_Notification_Mode_All":"Çdo Mention / DM","Email_Notification_Mode_Disabled":"i paaftë","Email_or_username":"Email ose emrin e përdoruesit","Email_subject":"subjekt","Email_verified":"Email verifikuar","Emoji":"Emoji","Empty_title":"Titulli Empty","Enable":"mundësoj","Enable_Desktop_Notifications":"Aktivizo Desktop Notifications","Enabled":"enabled","Encrypted_message":"mesazhi i koduar","End_OTR":"End OTR","Enter_a_regex":"Shkruani një regex","Enter_a_room_name":"Futni një emër dhomë","Enter_a_username":"Futni një emër përdoruesi","Enter_info":"Shkruani të dhënat tuaja","Enter_name_here":"Shkruani emrin këtu","Enter_to":"Shkruani për","Error":"gabim","error-cant-invite-for-direct-room":"Nuk mund të ftojë përdorues në dhoma të drejtpërdrejta","error-duplicate-channel-name":"Ekziston një Channel me emrin ' %s'","error-invalid-custom-field":"Fusha e pavlefshme porosi","error-invalid-custom-field-name":"Invalid Emri fushë me porosi. Përdorni shkronja, numra, vetëm hyphens dhe nënvizon.","error-invalid-password":"Fjalëkalim i pavlefshëm","error-invalid-room":"dhomë të pavlefshme","error-invalid-room-name":"<strong> %s</strong> nuk është një emër i vlefshëm dhomë, <br/> përdorin shkronja, numra, vetëm hyphens dhe nënvizon","error-invalid-user":"përdoruesi i pavlefshëm","error-invalid-username":"Emri i përdoruesit pavlefshëm","error-not-allowed":"Nuk lejohet","error-not-authorized":"nuk është i autorizuar","error-remove-last-owner":"Kjo është pronari i fundit. Ju lutemi të vendosur një pronar të ri para se të hiqni këtë.","error-role-name-required":"Emri roli është e nevojshme","error-user-not-in-room":"Përdoruesi nuk është në këtë dhomë","Error_changing_password":"Gabim ndryshuar fjalëkalimin","Error_sending_confirmation_email":"Gabim duke dërguar email konfirmimi","Error_too_many_requests":"Gabim, shumë kërkesa. Ju lutemi të ngadalësohet. Ju duhet të prisni %s sekonda përpara se të provoni përsëri","Esc_to":"Esc për të","Example_s":"Shembull: <code class=\"inline\">%s</code>","False":"I rremë","Favorites":"Favoritet","Field":"fushë","Field_removed":"Field hequr","File_exceeds_allowed_size_of_bytes":"File tejkalon madhësinë e lejuar të bytes __size__","FileUpload":"File Ngarko","FileUpload_Enabled":"Ngarkimet fotografi Enabled","FileUpload_File_Empty":"paraqesë bosh","FileUpload_FileSystemPath":"Path sistemi","FileUpload_MaxFileSize":"Maximum dokumentit Ngarko Size (në bytes)","FileUpload_MediaType_NotAccepted":"Lloji i materialit Jo Pranuar","FileUpload_MediaTypeWhiteList":"Llojet e pranuara Media","FileUpload_MediaTypeWhiteListDescription":"listën e llojeve të mediave të ndara me presje. Lëreni bosh për pranimin e të gjitha llojet e mediave.","FileUpload_ProtectFiles":"Mbroni skedarët e ngarkuar","FileUpload_ProtectFilesDescription":"Vetëm përdoruesit e vërtetuara do të kenë qasje","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Emri Amazon S3 kovë","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"CDN domain për shkarkime","FileUpload_S3_Region":"Rajon","FileUpload_Storage_Type":"Storage Lloji","Flags":"flamujt","Follow_social_profiles":"Ndiqni profilet tona sociale, na paguaj në Github dhe të ndajnë mendimet tuaja në lidhje me app rocket.chat në bord tonë Trello.","Food_and_Drink":"Food & Drink","For_your_security_you_must_re_enter_your_password_to_continue":"Për sigurinë tuaj, ju duhet të ri-shkruani fjalëkalimin tuaj për të vazhduar","Force_SSL":"Force SSL","Force_SSL_Description":"* Kujdes! * _Force SSL_ nuk duhet të përdoret me prokurë të kundërt. Nëse ju keni një prokurë të kundërt, ju duhet të bëni të përcjellim atje. Ky opsion ekziston për vendosjen e trupave si Heroku, që nuk lejon konfigurimin përcjellëse në prokurë të kundërt.","Forgot_password":"Keni harruar fjalëkalimin tuaj","Fork_it_on_github":"Paguaj atë në Github","Frequently_Used":"Përdorur shpesh","From":"nga","From_Email":"nga Email","From_email_is_required":"Nga mail-i është e nevojshme","From_email_warning":"<b>Warning:</b> Fusha <b>Nga</b> i nënshtrohet parametrat tuaj server postës.","General":"i përgjithshëm","Get_to_know_the_team":"Get të dini Rocket.Team","github_no_public_email":"Ju nuk keni ndonjë email si email publik në llogarinë tuaj GitHub","Give_a_unique_name_for_the_custom_oauth":"Jepni një emër të veçantë për OAuth porosi","Give_the_application_a_name_This_will_be_seen_by_your_users":"Jepni aplikacionin një emër. Kjo do të shihet nga përdoruesit e juaj.","Global":"global","GoogleTagManager_id":"Google Tag Menaxheri Id","Has_more":"ka më shumë","Have_your_own_chat":"Ketë web chat tuaj. Zhvilluar me Meteor.com, The Rocket.Chat është një zgjidhje e madhe për zhvilluesit në kërkim përpara për të ndërtuar dhe të zhvillohet vetë platformën e tyre chat.","Header":"arkitra","Hidden":"I fshehur","Hide_Group_Warning":"Jeni te sigurte qe doni te fshehur grupin \" %s\"?","Hide_Private_Warning":"A jeni i sigurt që ju doni të fshehur diskutimin me \" %s\"?","Hide_room":"Dhomë Fshih","Hide_Room_Warning":"Jeni te sigurte qe doni te fshehur në dhomë \" %s\"?","Highlights":"Pikat kryesore","Highlights_How_To":"Që të njoftohet kur dikush përmend një fjalë apo fraza, shtoni atë këtu. Ju mund të veçanta fjalët ose frazat me presje. Fjalët Highlight nuk janë çështje të ndjeshme.","Highlights_List":"fjalët Highlight","History":"Historiku","hours":"orë","How_friendly_was_the_chat_agent":"Si friendly ishte agjenti chat?","How_knowledgeable_was_the_chat_agent":"Si i ditur ishte agjenti chat?","How_responsive_was_the_chat_agent":"Si përgjegjshme ishte agjenti chat?","How_satisfied_were_you_with_this_chat":"Si të kënaqur të ishin me kete chat?","If_you_are_sure_type_in_your_password":"Nëse ju jeni të sigurt shkruani fjalëkalimin tuaj:","If_you_are_sure_type_in_your_username":"Nëse ju jeni të sigurt shkruani emrin tuaj:","Importer_Archived":"arkivuar","Importer_done":"Importimi i plotë!","Importer_finishing":"Përfunduar importin.","Importer_From_Description":"Importet __from dhënat __ 's në Rocket.Chat.","Importer_import_cancelled":"Import anuluar.","Importer_import_failed":"Ndodhi një gabim gjatë drejtimin e importit.","Importer_importing_channels":"Importimin e kanaleve.","Importer_importing_messages":"Importimi mesazhet.","Importer_importing_started":"Duke filluar importin.","Importer_importing_users":"Importimin e përdoruesit.","Importer_not_defined_properly":"Importuesi nuk është përcaktuar në mënyrë korrekte, ajo i mungon klasës Import.","Importer_not_in_progress":"Importuesi aktualisht nuk kandidon.","Importer_Prepare_Restart_Import":"Restart Import","Importer_Prepare_Start_Import":"Filloni Importimi","Importer_Prepare_Uncheck_Archived_Channels":"Kanalet Uncheck arkivuara","Importer_Prepare_Uncheck_Deleted_Users":"Përdoruesit Uncheck Deleted","Importer_progress_error":"Nuk arriti të marrë e progresit për import.","Importer_setup_error":"Ndodhi një gabim gjatë ngritjen e miqve.","Incorrect_Password":"Fjalëkalim i pasaktë","inline_code":"inline_code","Install_Extension":"Install Extension","Install_FxOs":"Install Rocket.Chat në Firefox tuaj","Install_FxOs_done":"Great! Ju tani mund të përdorni Rocket.Chat nëpërmjet ikonën në homescreen tuaj. Have fun me Rocket.Chat!","Install_FxOs_error":"Na vjen keq, se nuk ka punuar si qëllim! Gabimi më poshtë shfaq:","Install_FxOs_follow_instructions":"Ju lutem konfirmoni instalimin app në pajisjen tuaj (shtypni \"Install\" kur e bëri).","Installation":"instalim","Integration_added":"Integrimi është shtuar","Integration_Incoming_WebHook":"Integrimi Incoming WebHook","Integration_New":"Integrimi i ri","Integration_Outgoing_WebHook":"Integrimi WebHook po largohet","Integration_updated":"Integrimi është përditësuar","Integrations":"integrimet","Invalid_asset":"pasuri të pavlefshme","Invalid_confirm_pass":"Konfirmimi Fjalëkalimi nuk përputhet me fjalëkalimin","Invalid_email":"E-mail dhënë është i pavlefshëm","Invalid_Export_File":"Skedari i ngarkuar së fundi nuk është një% të vlefshme s fotografi eksportit.","Invalid_file_height":"lartësia e pavlefshme fotografi","Invalid_file_type":"Lloji i pavlefshëm fotografi","Invalid_file_width":"Gjerësia e pavlefshme fotografi","Invalid_Import_File_Type":"Invalid lloj skedari Import.","Invalid_name":"Emri nuk duhet të jetë bosh","Invalid_notification_setting_s":"vendosjen e pavlefshme njoftimit: %s","Invalid_pass":"Fjalëkalimi nuk duhet të jetë bosh","Invalid_room_name":"<strong> %s</strong> nuk është një emër i vlefshëm dhomë, <br/> përdorin shkronja, numra, vetëm hyphens dhe nënvizon","Invalid_room_type":"<strong> %s</strong> nuk është një lloj i vlefshëm dhomë.","Invalid_Secret_URL":"Invalid URL Secret","Invalid_secret_URL_message":"URL dhënë është e pavlefshme.","invisible":"i padukshëm","Invisible":"I padukshëm","Invitation_HTML":"ftesë HTML","Invitation_Subject":"ftesë Subject","Invite_user_to_join_channel":"Fto një përdorues për t'u bashkuar me këtë kanal","Invite_Users":"Fto Përdoruesit","is_also_typing":"janë gjithashtu shtypja","is_also_typing_female":"është shtypja","is_also_typing_male":"është edhe shtypja","is_typing":"është shtypja","is_typing_female":"është shtypja","is_typing_male":"është shtypja","italics":"italics","join":"Bashkohuni","Join_audio_call":"Join thirrje audio","Join_the_Community":"Join Komuniteti","Join_the_given_channel":"Join kanalin e dhënë","Join_video_call":"Join thirrje video","Joined":"Regjistruar më","Jump":"Jump","Jump_to_first_unread":"Kërce tek palexuara parë","Jump_to_message":"Kërce tek mesazhi","Jump_to_recent_messages":"Kërce tek mesazhet e fundit","Katex_Enabled":"Katex Enabled","Label":"etiketë","Language":"Gjuhë","Language_Version":"Versioni anglisht","Last_login":"Last login","Last_message":"Mesazhi i fundit","Last_seen":"pa e kaluar","Layout":"plan urbanistik","Layout_Home_Body":"Body shtëpi","Layout_Home_Title":"Faqja Titulli","Layout_Login_Terms":"Identifikohu Marrveshje","Layout_Privacy_Policy":"Politika e privatësisë","Layout_Sidenav_Footer":"Side Navigation Footer","Layout_Sidenav_Footer_description":"Madhësia Footer është 260 x 70px","Layout_Terms_of_Service":"Kushtet e Shërbimit","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Custom Domain Kërko","LDAP_Custom_Domain_Search_Description":"Një pjesë e JSON që rregullon lidh dhe lidhje info dhe është i formës: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Domain Default","LDAP_Description":"LDAP është një bazë të dhënash hierarkike se shumë kompani përdorin për të dhënë shenjë të vetme në - një strukturë për të ndarë një fjalëkalim në mes të vendeve të shumta dhe të shërbimeve. Për informacion të avancuara konfigurimi dhe shembuj, ju lutem konsultoni wiki tonë: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"domain Base","LDAP_Domain_Base_Description":"Plotësisht të kualifikuar nderuar Emri (DN) e një subtree LDAP që ju doni të kërkoni për përdoruesit dhe grupet. Ju mund të shtoni sa më shumë që ju pëlqen; Megjithatë, secili grup duhet të përcaktohen në të njëjtën bazë domain si përdoruesit që i përket. Nëse ju specifikoni grupet e kufizuara të përdoruesve, vetëm përdoruesit që i përkasin këtyre grupeve do të jetë në fushë. Ne ju rekomandojmë që të përcaktojë nivelin e lartë të LDAP pemë tuaj directory si bazë domain dhe përdorimin e kërkimit filtër për të kontrolluar hyrje.","LDAP_Domain_Search_Filter":"Domain Kërko Filter","LDAP_Domain_Search_Filter_Description":"Nëse specifikuara, vetëm përdoruesit që përputhen me këtë filtër do të lejohet të hyni. Nëse nuk është specifikuar filter, të gjithë përdoruesit brenda objektit të bazës së të caktuar domain do të jetë në gjendje të nënshkruajë në. <br/> P.sh. për Active Directory `memberOf = cn = ROCKET_CHAT, ou = General Groups`. <br/> P.sh. për t'OpenLdap (zgjeruar Kërkimi ndeshje) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search Object Category","LDAP_Domain_Search_Object_Category_Description":"* I * objectCategory që identifikojnë përdoruesit tuaj. <br/> Lini bosh për * t'OpenLdap *. <br/> P.sh. `person`, etj","LDAP_Domain_Search_Object_Class":"Domain Class kerko objekti","LDAP_Domain_Search_Object_Class_Description":"* I * objectclass që identifikojnë përdoruesit tuaj. <br/> P.sh. `organizationalPerson`,` user`, `inetOrgPerson`, etj","LDAP_Domain_Search_Password":"Domain Kërko Password","LDAP_Domain_Search_Password_Description":"Fjalëkalimi për përdoruesin e kërkimit domain.","LDAP_Domain_Search_User":"Domain Kërko User","LDAP_Domain_Search_User_Description":"Përdoruesi LDAP që kryen Lookups përdoruesit për të vërtetuar përdoruesit e tjerë, kur ata nënshkruajnë në. <br/> Kjo është zakonisht një llogari të shërbimit krijuar posaçërisht për integrime palë të treta. Përdorni një emër plotësisht të kualifikuar, të tilla si 'cn = Administrator, cn = Përdoruesit, dc = Shembull, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Kërko ID User","LDAP_Domain_Search_User_ID_Description":"LDAP atribut që identifikon përdoruesit LDAP që tenton të legalizuara. Kjo fushë duhet të jetë `sAMAccountName` për instalime më të Active Directory, por ajo mund të jetë` uid` për zgjidhje të tjera LDAP, të tilla si t'OpenLdap. Ju mund të përdorni `mail` për të identifikuar përdoruesit me email ose çfarëdo atribut që ju dëshironi. <br> Ju mund të përdorni vlerat e shumta të ndara me presje për të lejuar përdoruesit të identifikoheni duke përdorur identifikuesit të shumta si emrin e përdoruesit ose e-mail.","LDAP_Enable":"mundësoj","LDAP_Enable_Description":"Përpjekje për të shfrytëzuar LDAP për autentikim.","LDAP_Encryption":"encryption","LDAP_Encryption_Description":"Metoda encryption përdorur për të siguruar komunikimet në server LDAP. Shembujt përfshijnë `plain` (nuk ka encryption),` SSL / LDAPS` (koduar nga fillimi), dhe `StartTLS` (të përmirësuar në komunikim të koduar një herë e lidhur).","LDAP_Host":"mikpritës","LDAP_Host_Description":"LDAP host, p.sh. `ldap.example.com` ose` 10.0.0.30`.","LDAP_Port":"LDAP Port","LDAP_Port_Description":"Port për të hyrë LDAP. për shembull: `389` ose` 636` për LDAPS","LDAP_Reject_Unauthorized":"Refuzo paautorizuar","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"Sync Të dhënat","LDAP_Sync_User_Data_Description":"Të mbajtur të dhënat e përdoruesit në sync me server në hyrje (p.sh: emri, email).","LDAP_Sync_User_Data_FieldMap":"User Data Map Field","LDAP_Sync_User_Data_FieldMap_Description":"Konfiguro si fusha e llogarisë përdoruesit (si email) janë të populluar nga një rekord në LDAP (sapo gjetur). <br/> Si një shembull, `{\" cn \":\" Emri \",\" postë \":\" email \"} 'do të zgjedhë emrin e një personi njerëzor lexueshëm nga atribut cn dhe adresën e tyre nga postës atribut. <br/> Fushat e vlefshme përfshijnë `name`, dhe` email`.","LDAP_Sync_Users":"Përdoruesit Sync","LDAP_Test_Connection":"Test Connection","LDAP_Unique_Identifier_Field":"Unique Identifier Field","LDAP_Unique_Identifier_Field_Description":"Cilën fushë do të përdoret për të lidhur përdoruesit LDAP dhe përdoruesit Rocket.Chat. Ju mund të informojë vlerat e shumta të ndara me presje për të përpiqen për të marrë vlerën prej rekord LDAP. <br/> Vlera e parazgjedhur është 'objectGUID, ibm-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Përdorni Custom Domain Kërko","LDAP_Use_Custom_Domain_Search_Description":"Shkruar vetë filtrin tuaj për të kërkuar përdoruesit në server LDAP.","LDAP_Username_Field":"Username Field","LDAP_Username_Field_Description":"Cilën fushë do të përdoret si * emrin e përdoruesit * për përdoruesit e rinj. Lini bosh për të përdorur emrin e përdoruesit të informuar në faqen e identifikimit. <br/> Ju mund të përdorni tags template shumë, si `# {givenName}. {# Sn}`. <br/> Vlera e parazgjedhur është `sAMAccountName`.","Leave_Group_Warning":"Jeni te sigurte qe doni te largohet nga grupi \" %s\"?","Leave_Private_Warning":"Jeni te sigurte qe doni te largohet diskutimin me \" %s\"?","Leave_room":"Dhomë Leave","Leave_Room_Warning":"Jeni te sigurte qe doni te largohen nga dhoma \" %s\"?","line":"linjë","List_of_Direct_Messages":"Lista e mesazhe të drejtpërdrejta","Live_sessions":"Sesionet e gjalla","Livechat_agents":"agjentët LiveChat","Livechat_Dashboard":"Dashboard LiveChat","Livechat_enabled":"LiveChat aktivizuar","Livechat_Manager":"Menaxheri LiveChat","Livechat_managers":"menaxherët LiveChat","Livechat_title":"LiveChat Titulli","Livechat_title_color":"LiveChat Titulli Background Color","Livechat_Users":"Përdoruesit LiveChat","Load_more":"Lexo më shumë","Loading...":"Duke u ngarkuar ...","Loading_more_from_history":"Loading shumë nga historia","Loading_suggestion":"Sugjerimet Duke u ngarkuar ...","Localization":"Localization","Log_File":"Trego File dhe Line","Log_Level":"log Niveli","Log_Package":"Trego Paketa","Log_View_Limit":"Identifikohu Shiko Limit","Logged_out_of_other_clients_successfully":"Identifikuar nga klientë të tjerë me sukses","Login":"Hyrje","Login_with":"Identifikohuni me %s","login_with":"Ose login direkt me","Logout":"Largohu","Logout_Others":"Logout Nga Identifikuar tjera në vende të","Mail_Message_Invalid_emails":"Ju keni dhënë email një ose më shumë të pavlefshme: %s","Mail_Message_Missing_to":"Ju duhet të zgjidhni një ose më shumë përdorues, ose të sigurojë një ose më shumë adresa email, të ndara me presje.","Mail_Message_No_messages_selected_select_all":"Ju nuk keni zgjedhur ndonjë porosi. Dëshironi të <a href='#' class='select-all'>zgjidhni të gjitha</a> mesazhet e dukshme?","Mail_Messages":"Mesazhet Mail","Mail_Messages_Instructions":"Zgjidhni cilat mesazhe ju dëshironi të dërgoni përmes emailit duke klikuar mesazhet","Mail_Messages_Subject":"Këtu është një pjesë e zgjedhur e mesazheve %s","Mailer":"postues","Mailer_body_tags":"Ju <b>duhet të</b> përdorni [unsubscribe] për lidhjen Çabonimi. <br /> Ju mund të përdorni [emri], [EMRI], [MBIEMRI] për emrin e plotë të përdoruesit, emrin e parë ose emrin e fundit, respektivisht. <br /> Ju mund të përdorni [email] për email të përdoruesit.","Make_Admin":"bëni Admin","Manager_added":"menaxheri shtuar","Manager_removed":"menaxheri hequr","Mark_as_read":"Mark si të lexuar","Markdown_Headers":"markdown Headers","Markdown_SupportSchemesForLink":"Skemat mbështetëse markdown për Link","Markdown_SupportSchemesForLink_Description":"lista të ndara me presje i skemave të lejuara","Members_List":"Lista e Anëtarëve","Mentions":"përmend","Mentions_default":"Përmend (default)","Message":"Mesazh","Message_AllowDeleting":"Lejo Mesazh Fshirja","Message_AllowEditing":"Lejo Mesazh Editing","Message_AllowEditing_BlockEditInMinutes":"Block mesazh Editing Pas (n) minuta","Message_AllowEditing_BlockEditInMinutesDescription":"Shkruani 0 të çaktivizuar bllokimin.","Message_AllowPinning":"Lejo mesazh pinning","Message_AllowPinning_Description":"Lejojnë mesazhet për t'u mbërthyer me ndonjë nga kanale.","Message_AllowStarring":"Lejo mesazh Starring","Message_AudioRecorderEnabled":"Audio Recorder aktivizuar","Message_AudioRecorderEnabledDescription":"Kërkon 'audio / wav files' të jetë një lloj i pranuar media brenda settings 'Ngarkim fotografish'.","Message_DateFormat":"Formatii datës","Message_DateFormat_Description":"Shih gjithashtu: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Mesazhi nuk fshirjes lejohet","Message_editing_blocked":"Ky mesazh nuk mund të redaktohen më","Message_editing_not_allowed":"Mesazhi editing nuk lejohet","Message_GroupingPeriod":"Grupim Periudha (në sekonda)","Message_GroupingPeriodDescription":"Mesazhet do të grupohen me mesazhin e mëparshëm qoftë se të dy janë nga i njëjti përdorues dhe kaluar kohë ishte më pak se sa koha të informuar në sekonda.","Message_KeepHistory":"Mbani Mesazh Historia","Message_MaxAllowedSize":"Maksimumi i lejuar mesazh Size","Message_MaxAll":"Madhësia maksimale kanal për lekë mesazh","Message_pinned":"mesazhi mbështetën","Message_pinning_not_allowed":"Mesazhi nuk pinning lejohet","Message_removed":"mesazhi hequr","Message_ShowDeletedStatus":"Trego Statusi Deleted","Message_ShowEditedStatus":"Trego Statusi Edited","Message_ShowFormattingTips":"Trego Këshilla formatimit","Message_TimeFormat":"Koha Format","Message_TimeFormat_Description":"Shih gjithashtu: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Mesazhi shumë e gjatë","Messages":"mesazhet","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Mesazhet që janë dërguar tek hyrëse WebHook do të postohen këtu.","Meta":"Meta","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Site Verifikimi","Meta_language":"Gjuhë","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minuta","Mobile_push":"shtytje Mobile","More_channels":"Më shumë kanale","More_direct_messages":"Më shumë mesazhe të drejtpërdrejta","More_groups":"më shumë grupe private","More_unreads":"më shumë unreads","Msgs":"msgs","multi":"multi","Mute_someone_in_room":"dikush memec në dhomë","Mute_user":"përdorues Mute","Muted":"i mbytur","My_Account":"Llogaria ime","n_messages":" %s Mesazhet","N_new_messages":" %s mesazhe të reja","Name":"Emër","Name_cant_be_empty":"Emri nuk mund të jetë bosh","Name_of_agent":"Emri i agjentit","Name_optional":"Emri (jo i detyrueshëm)","Navigation_History_20_last_pages":"Navigation Histori (20 faqe e fundit)","New_Application":"Aplikimi i ri","New_Custom_Field":"New Custom Field","New_Department":"Departamenti i ri","New_integration":"integrimi i ri","New_logs":"shkrimet e reja","New_messages":"Mesazhe të reja","New_password":"Fjalëkalimi i ri","New_role":"roli i ri","No_channel_with_name_%s_was_found":"No channel me emrin <strong>\" %s\"</strong> u gjet!","No_channels_yet":"Ju nuk jeni pjesë e ndonjë kanali ende.","No_direct_messages_yet":"Ju nuk kanë filluar asnjë biseda ende.","No_Encryption":"No Encryption","No_favorites_yet":"Ju nuk keni shtuar asnjë preferuarat ende.","No_group_with_name_%s_was_found":"Asnjë grup private me emrin <strong>\" %s\"</strong> u gjet!","No_groups_yet":"Nuk keni asnjë faqe grupe private ende.","No_livechats":"Ju nuk keni livechats.","No_mentions_found":"Nuk ka përmend gjetur","No_permission_to_view_room":"Ju nuk keni leje për të parë këtë dhomë","No_pinned_messages":"Nuk ka mesazhe mbështetën","No_results_found":"Nuk u gjetën rezultate","No_starred_messages":"Nuk ka mesazhe me yll","no_tokens_for_this_user":"Nuk ka argumentet për këtë përdorues","No_user_with_username_%s_was_found":"Asnjë përdorues me emrin <strong>\" %s\"</strong> u gjet!","Not_allowed":"Nuk lejohet","Not_authorized":"nuk është i autorizuar","Not_Available":"I padisponueshem","Not_found_or_not_allowed":"Not Found ose jo Lejohet","Nothing":"asgjë","Nothing_found":"Asgjë për të gjetur","Notifications":"Njoftime","Notify_all_in_this_room":"Të njoftojë të gjithë në këtë dhomë","Num_Agents":"# Agents","Number_of_messages":"Numri i mesazheve","OAuth_Application":"OAuth Aplikimi","OAuth_Applications":"Aplikime OAuth","Objects":"objektet","Off_the_record_conversation":"Off-the-rekord bisedë","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-rekord biseda nuk është në dispozicion për shfletuesit tuaj ose pajisje.","Offline_DM_Email":"[__site__] Ju keni qenë mesazhi direkt nga __user__","Offline_Mention_Email":"[__site__] Ju keni përmendur nga __user__ në #__room__","Old_and_new_password_must_be_different":"Fjalëkalimi i ri duhet të jetë i ndryshëm nga fjalëkalimin e vjetër.","Old_and_new_password_required":"Ju duhet të sigurojë dy fjalëkalimin e vjetra dhe të reja për ndryshimin e fjalëkalimin tuaj.","Online":"Online","Only_errors":"vetëm gabime","Only_you_can_see_this_message":"Vetëm ju mund të shihni këtë mesazh","Oops!":"Oops","Open":"hapur","Opened":"Hapur","Opt_out_statistics":"Mos dërgoni statistikat e mia të Rocket.Chat","Opt_out_statistics_warning":"Duke dërguar statistikat tuaja, ju do të na ndihmojë të identifikuar se si shumë raste të Rocket.Chat janë vendosur, si dhe sa i mirë sistemi sillet, kështu që ne mund të përmirësojë më tej atë. Mos u shqetësoni, pasi asnjë informacion përdorues është dërguar dhe të gjitha informatat që marrim është mbajtur sekret. Nëse ju doni të vazhdoni të na dërguar statistikat tuaja, zgjidhni kutinë e mësipërme. Faleminderit.","optional":"fakultativ","Order":"urdhër","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Count","OS_Freemem":"OS pagesë Memory","OS_Loadavg":"OS Load mesatare","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Memory Total","OS_Type":"OS Lloji","OS_Uptime":"OS Uptime","others":"të tjerët","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR është në dispozicion vetëm kur të dy përdoruesit janë në internet","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Override URL të cilat fotografi janë ngarkuar. Kjo url përdorur edhe për shkarkime, përveç nëse një CDN është dhënë","Password":"Fjalëkalim","Password_Change_Disabled":"Administratori juaj Rocket.Chat ka pezulluar ndryshimin e fjalëkalimeve","Password_changed_successfully":"Fjalëkalimi ndryshuar me sukses","Payload":"payload","People":"njerëz","Permissions":"Permissions","Pin_Message":"Pin mesazh","Pinned_a_message":"Mbështetën një mesazh:","Pinned_Messages":"Mesazhet mbështetën","Placeholder_for_email_or_username_login_field":"Placeholder për email ose Përdoruesi identifikimit fushë","Placeholder_for_password_login_field":"Placeholder për fushën e identifikimit fjalëkalimin","Please_answer_survey":"Ju lutem, ndalo një moment për t'iu përgjigjur një anketë të shpejtë në lidhje me këtë bisedë","Please_enter_value_for_url":"Ju lutem fusni nje vlere per url e avatar tuaj.","Please_enter_your_new_password_below":"Ju lutemi shkruani fjalëkalimin tuaj të ri poshtë:","Please_fill_a_label":"Ju lutemi plotësoni një etiketë","Please_fill_a_name":"Ju lutemi plotësoni emrin","Please_fill_a_username":"Ju lutemi plotësoni emrin e përdoruesit","Please_fill_name_and_email":"Ju lutemi plotësoni emrin dhe email","Please_re_enter_your_password":"Ju lutem ri-shkruani fjalëkalimin tuaj","Please_select_enabled_yes_or_no":"Ju lutem, përzgjidhni një opsion për të aktivizuar","Please_wait":"Te lutem prisni","Please_wait_activation":"Ju lutemi të prisni, kjo mund të marrë disa kohë.","Please_wait_statistics":"Ju lutemi të prisni, statistikat janë të krijuara.","Please_wait_while_OTR_is_being_established":"Ju lutem prisni derisa OTR është duke u krijuar","Please_wait_while_your_account_is_being_deleted":"Ju lutem prisni ndërkohë që llogaria juaj është duke u fshirë ...","Please_wait_while_your_profile_is_being_saved":"Ju lutem prisni ndërkohë që profili juaj është duke u ruajtur ...","Post_as":"Post si","Post_to_Channel":"Posto në Channel","Post_to_s_as_s":"Post <strong>to %s</strong> <strong>si %s</strong>","Powered_by":"Mundësuar nga","Preferences":"preferencat","Preferences_saved":"preferencat ruajtur","Privacy":"Intimitet","Private_Group":"Group private","Private_Groups":"Grupet Private","Private_Groups_list":"Lista e Grupeve private","Profile":"Profil","Profile_saved_successfully":"Profili ruajtur me sukses","Proudly_developed":"Zhvilluar me krenari me Meteor","Push":"shtytje","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev parafrazën","Push_apn_key":"APN Key","Push_apn_passphrase":"APN parafrazën","Push_debug":"rregulloj","push_disabled":"Push me aftësi të kufizuara","Push_enable":"mundësoj","Push_enable_gateway":"Aktivizo Gateway","Push_gateway":"portë","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Numri i Projektit","Push_production":"prodhim","Push_show_message":"Trego mesazh në njoftimin","Push_show_username_room":"Trego channel / grupi / përdorues në njoftimin","Push_test_push":"provë","Query":"pyetje","Query_description":"Kushtet shtesë për përcaktimin e të cilat përdoruesit për të dërguar një email tek. përdoruesit papajtuara janë hequr automatikisht nga pyetje. Ajo duhet të jetë një JSON vlefshme. Shembull: \"{\" createdAt \": {\" $ gt \": {\" data $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Kërko Shpejt","quote":"citoj","Reactions":"reagimet","Recents":"Recents","Record":"rekord","Redirect_URI":"Redirect URI","Refresh_keys":"çelësat Refresh","Refresh_your_page_after_install_to_enable_screen_sharing":"Rifreskoni faqen tuaj, pasi të instaluar për të mundësuar ndarjen e ekranit","Register":"Regjistrohu një llogari të re","Registration_Succeeded":"Regjistrimi Sukses","Remember_me":"Më kujton mua","Remove":"Hiq","Remove_Admin":"Hiq Admin","Remove_as_moderator":"Hiq si moderator","Remove_as_owner":"Hiq si pronar","Remove_custom_oauth":"Hiq OAuth porosi","Remove_from_room":"Hiq nga dhoma","Remove_someone_from_room":"Hiq dikush nga dhoma","Removed":"Removed","Require_password_change":"Kërkojnë ndryshimin e fjalëkalimin","Resend_verification_email":"Ridërgo email verifikim","Reset":"Reset","Reset_password":"Fjalëkalimi i ri","Restart":"Rifillo, fillo përsëri","Restart_the_server":"Restart server","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"Emri RocketBot","RocketBot_Name_Description":"Emri RocketBot duhet të jetë një emër përdoruesi të vlefshme të regjistruar në serverin tuaj.","Role":"rol","Role_Editing":"roli Editing","Role_removed":"roli hequr","Room":"Dhomë","Room_archivation_state":"shtet","Room_archivation_state_false":"aktiv","Room_archivation_state_true":"arkivuar","Room_archived":"Room arkivuar","room_changed_privacy":"Lloji Room ndryshuar për: <em>__room_type__</em> nga <em>__user_by__</em>","room_changed_topic":"Tema Room ndryshuar për: <em>__room_topic__</em> nga <em>__user_by__</em>","Room_has_been_deleted":"Dhoma është fshirë","Room_Info":"Room Info","Room_name_changed":"Emri dhomë ndryshuar për:","Room_name_changed_successfully":"Emri dhomës  është ndryshuar me sukses","Room_not_found":"Dhoma nuk u gjet","Room_topic_changed_successfully":"Tema Room ndryshuar me sukses","Room_type_changed_successfully":"Lloji Room ndryshuar me sukses","Room_unarchived":"Room paarkivuar","Room_uploaded_file_list":"Lista Files","Room_uploaded_file_list_empty":"Nuk ka fotografi në dispozicion.","room_user_count":" %s përdorues","Rooms":"dhoma","S_new_messages_since_s":" %s mesazhe të reja që nga %s","SAML":"SAML","SAML_Custom_Cert":"Custom Certificate","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Generate Emri","SAML_Custom_Issuer":"Custom Lëshuesi","SAML_Custom_Provider":"Custom Provider","Save":"Ruaj","Save_changes":"Ruaj ndryshimet","Save_Mobile_Bandwidth":"Save Mobile Bandwidth","Save_to_enable_this_action":"Ruaj për të mundësuar këtë aksion","Saved":"Saved","Saving":"kursim","Scope":"fushë","Screen_Share":"Screen Share","Script_Enabled":"script aktivizuar","Search":"Kërko","Search_by_username":"Kërko sipas emrin","Search_Channels":"Kërko Kanalet","Search_Direct_Messages":"Kërko mesazhe të drejtpërdrejta","Search_Messages":"Kërko Mesazhet","Search_Private_Groups":"Kërko Grupe private","Search_settings":"Cilësimet","seconds":"sekonda","See_all":"Shih të gjithë","See_only_online":"Vetëm online","Select_a_department":"Zgjidh një departament","Select_an_avatar":"Zgjidh një avatar","Select_file":"Zgjidh skedar","Select_service_to_login":"Zgjidh një shërbim të identifikoheni për të ngarkuar foton tuaj ose ngarkoni një direkt nga kompjuteri juaj","Select_user":"Zgjidh përdorues","Select_users":"Zgjidh përdoruesit","Selected_agents":"agjentët e zgjedhur","Selected_users":"Anëtarë të zgjedhur","Send":"dërgoj","Send_a_message":"Dergo nje mesazh","Send_a_test_mail_to_my_user":"Dërgo një email provë për përdoruesit e mia","Send_a_test_push_to_my_user":"Dërgo një shtytje provë për përdoruesit e mia","Send_confirmation_email":"Dërgo email konfirmimi","Send_data_into_RocketChat_in_realtime":"Dërgoni të dhëna në Rocket.Chat në kohë reale.","Send_email":"Dërgoni një email","Send_invitation_email":"Dërgo email ftesë","Send_invitation_email_error":"Ju nuk keni dhënë asnjë adresë e vlefshme e-mail.","Send_invitation_email_info":"Ju mund të dërgoni ftesa të shumta e-mail në të njëjtën kohë.","Send_invitation_email_success":"Ju keni dërguar me sukses një email ftesë për adresat e mëposhtme:","Send_invitation_email_warning":"Për të dërguar email ftesë, ju duhet së pari të konfiguroni parametrat SMTP.","Send_Message":"Dërgoni mesazh","Send_your_JSON_payloads_to_this_URL":"Dërgo payloads tuaja JSON në këtë URL.","Sending":"Dërgimi ...","Set_as_moderator":"Vendosur si moderator","Set_as_owner":"Vendosur si pronar","Settings":"Cilësimet","Settings_updated":"Cilësimet updated","Should_be_a_URL_of_an_image":"Duhet të jetë një URL të një imazhi.","Should_exists_a_user_with_this_username":"Përdoruesi duhet të ekzistojnë.","Show_all":"Trego te gjitha","Show_more":"Trego më shumë","Show_only_online":"Trego vetëm online","Show_preregistration_form":"Tregojnë formën e para-regjistrimit","Showing_archived_results":"<p> Duke <b>treguar %s</b> rezultatet arkivuar </p>","Showing_online_users":"Duke treguar","Showing_results":"<p> Duke shfaqur <b>rezultatet %s</b> </p>","Silence":"Heshtje","since_creation":"që nga %s","Site_Name":"Site Emri","Site_Url":"Site URL","Site_Url_Description":"Shembull: https://chat.domain.com/","Skip":"Kalo","Smileys_and_People":"Smileys & People","SMTP":"SMTP","SMTP_Host":"SMTP Host","SMTP_Password":"SMTP Password","SMTP_Port":"SMTP Port","SMTP_Test_Button":"Cilësimet Test SMTP","SMTP_Username":"SMTP Username","Sound":"tingull","Star_Message":"Star mesazh","Starred_Messages":"Mesazhet luajti","Start_audio_call":"Filloni thirrje audio","Start_Chat":"Fillo bisedën","Start_of_conversation":"Fillimi i bisedës","Start_OTR":"fillimi OTR","Start_video_call":"Filloni thirrje video","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Filloni me <code class=\"inline\">%s</code> për përdoruesit ose <code class=\"inline\">%s</code> për kanal. Eg: <code class=\"inline\">%s</code> ose <code class=\"inline\">%s</code>","Statistics":"të dhëna statistikore","Stats_Active_Users":"salla","Stats_Avg_Channel_Users":"Përdoruesit mesatare Channel","Stats_Avg_Private_Group_Users":"Mesatarja Përdoruesit Private Group","Stats_Away_Users":"Përdoruesit Away","Stats_Max_Room_Users":"Max Dhoma Përdoruesit","Stats_Non_Active_Users":"Përdoruesit jo aktive","Stats_Offline_Users":"Përdoruesit offline","Stats_Online_Users":"Users Online","Stats_Total_Channels":"gjithsej Kanalet","Stats_Total_Direct_Messages":"Gjithsej Mesazh Dhoma direkte","Stats_Total_Messages":"gjithsej Messages","Stats_Total_Private_Groups":"Gjithsej Grupet Private","Stats_Total_Rooms":"total i Dhomave","Stats_Total_Users":"Antare","Stop_Recording":"Stop Recording","strike":"grevë","Subject":"subjekt","Submit":"Paraqes","Success":"Sukses","Survey":"studim","Survey_instructions":"Vlerësoni çdo pyetje në përputhje me kënaqësinë tuaj, 1 të thotë që ju jeni plotësisht të pakënaqur dhe 5 të thotë që ju jeni të kënaqur plotësisht.","Symbols":"simbole","Sync_success":"suksesi Sync","Sync_Users":"Përdoruesit Sync","Test_Connection":"Test Connection","Test_Desktop_Notifications":"Test Desktop Notifications","Thank_you_for_your_feedback":"Faleminderit për komentin tuaj","The_application_name_is_required":"Emri i aplikimit është e nevojshme","The_channel_name_is_required":"Emri kanal është e nevojshme","The_emails_are_being_sent":"Email janë duke u dërguar.","The_field_is_required":"Fusha %s është e nevojshme.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Imazhi resize nuk do të funksionojë, sepse ne nuk mund të zbulojë ImageMagick ose GraphicsMagick instaluar në serverin tuaj.","The_redirectUri_is_required":"RedirectUri është e nevojshme","The_server_will_restart_in_s_seconds":"Serveri do të rifillojë në %s sekonda","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Vendosjen %s</strong> është konfiguruar <strong>për %s</strong> dhe ju jeni të hyrë <strong>nga %s!</strong>","The_user_will_be_removed_from_s":"Përdorues do të hiqet nga %s","The_user_wont_be_able_to_type_in_s":"Ky përdorues nuk do të jetë në gjendje të shkruani në %s","Theme":"temë","theme-color-action-buttons-color":"Veprimet Buttons Color","theme-color-active-channel-background-color":"Active Channel Background Color","theme-color-active-channel-font-color":"Active Channel Font Color","theme-color-blockquote-background":"Blockquote Background Color","theme-color-clean-buttons-color":"Buttons pastër Color","theme-color-code-background":"Kodi Background Color","theme-color-code-border":"Kodi Color Border","theme-color-code-color":"Kodi Color","theme-color-content-background-color":"Përmbajtja Background Color","theme-color-custom-scrollbar-color":"Custom Scrollbar Color","theme-color-info-active-font-color":"Active Info Font Color","theme-color-info-font-color":"Info Font Color","theme-color-input-font-color":"Input Font Color","theme-color-link-font-color":"Link Font Color","theme-color-message-hover-background-color":"Mesazhi Hover BG Color","theme-color-primary-background-color":"Primar Background Color","theme-color-primary-font-color":"Primar Font Color","theme-color-quaternary-font-color":"Kuaternarit Font Color","theme-color-secondary-background-color":"Mesme Background Color","theme-color-secondary-font-color":"Mesme Font Color","theme-color-smallprint-font-color":"Small Print Font Color","theme-color-smallprint-hover-color":"Small Print Hover Color","theme-color-status-away":"Away Status Color","theme-color-status-busy":"Busy Status Color","theme-color-status-offline":"Offline Status Color","theme-color-status-online":"Online Status Color","theme-color-tertiary-background-color":"Terciar Background Color","theme-color-tertiary-font-color":"Terciar Font Color","theme-color-unread-notification-color":"Palexuar Njoftimet Color","theme-custom-css":"Custom CSS","There_are_no_agents_added_to_this_department_yet":"Nuk ka agjentë të shtuar në këtë departament ende.","There_are_no_integrations":"Nuk ka integrimet","There_are_no_users_in_this_role":"Nuk ka asnjë përdorues në këtë rol.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ky email është përdorur tashmë dhe nuk është verifikuar. Ju lutem ndryshoni fjalëkalimin tuaj.","This_is_a_desktop_notification":"Ky është një njoftim desktop","This_is_a_push_test_messsage":"Ky është një test i messsage shtytje","Time_in_seconds":"Koha në sekonda","Title_bar_color":"color Title bar","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Për të instaluar Rocket.Chat LiveChat në web faqen tuaj, kopjoni dhe ngjisni këtë kod lart e fundit <strong></ body></strong> tag në faqen tuaj.","To_users":"të Përdoruesit","Topic":"temë","Travel_and_Places":"Travel & Places","Trigger_removed":"Trigger hequr","Trigger_Words":"Fjalët këmbëz","Triggers":"shkakton","True":"i vërtetë","Type":"lloj","Type_your_new_password":"Shkruaj fjalëkalimin tuaj të ri","Unarchive":"Hiq nga arkivi","Unmute_someone_in_room":"dikush unmute në dhomë","Unmute_user":"përdorues unmute","Unnamed":"i papërmendur","Unpin_Message":"Zhgozhdo mesazh","Unread_Rooms":"Dhoma palexuar","Unread_Rooms_Mode":"Dhoma palexuar Mode","Unstar_Message":"Hiq Star","Upload_file_question":"Ngarko fotografi?","Uploading_file":"Ngarkimi fotografi ...","Use_account_preference":"Përdorni llogarisë preferenca","Use_Emojis":"Përdorimi emojis","Use_initials_avatar":"Përdorni inicialet tënd Emri i përdoruesit","use_menu":"Përdorni menynë anësore për të hyrë në dhomat tuaja dhe biseda","Use_service_avatar":"Përdorni %s avatar","Use_this_username":"Përdoreni këtë emrin e përdoruesit","Use_uploaded_avatar":"Përdorni avatar ngarkuar","Use_url_for_avatar":"Përdorni url për avatar","User__username__is_now_a_moderator_of__room_name_":"User __username__ tani është një moderator i __room_name__","User__username__is_now_a_owner_of__room_name_":"User __username__ është tani një pronar i __room_name__","User__username__removed_from__room_name__moderators":"User __username__ hequr nga moderatorëve __room_name__","User__username__removed_from__room_name__owners":"User __username__ hequr nga pronarët __room_name__","User_added":"User shtuar","User_added_by":"Përdorues","User_added_successfully":"User shtua me sukses","User_Channels":"Kanalet e përdoruesit","User_doesnt_exist":"Asnjë përdorues ekziston me emrin e `@ %s`.","User_has_been_activated":"User është aktivizuar","User_has_been_deactivated":"User është çaktivizuar","User_has_been_deleted":"User është fshirë","User_has_been_muted_in_s":"User ka qenë i heshtur në %s","User_has_been_removed_from_s":"User është hequr nga %s","User_has_disconnected":"Përdoruesi ka shkëputur","User_Info":"Të dhëna Përdoruesi","User_is_no_longer_an_admin":"User nuk është më një admin","User_is_not_activated":"Përdoruesi nuk është aktivizuar","User_is_now_an_admin":"User tani është një admin","User_joined_channel":"Është bashkuar kanalit.","User_joined_channel_female":"Është bashkuar kanalit.","User_joined_channel_male":"Është bashkuar kanalit.","User_left":"Ka lënë kanalin.","User_left_female":"Ka lënë kanalin.","User_left_male":"Ka lënë kanalin.","User_logged_out":"Përdoruesi është regjistruar jashtë","User_management":"Menaxhimi User","User_muted_by":"User <em>__user_muted__</em> mbytur nga <em>__user_by__.</em>","User_muted_in_room":"User mbytur në dhomën e","User_not_found":"Përdoruesi nuk u gjet","User_not_found_or_incorrect_password":"Përdoruesi nuk u gjet ose fjalëkalim i gabuar","User_or_channel_name":"User ose kanal emrin","User_removed":"User hequr","User_removed_by":"Përdorues","User_removed_from_room":"Ky përdorues është hequr nga dhoma","User_Settings":"Përdoruesi Cilësimet","User_unmuted_by":"User <em>__user_unmuted__</em> aktivizua zëri nga <em>__user_by__.</em>","User_unmuted_in_room":"User aktivizua zëri në dhomën","User_updated_successfully":"User përditësua me sukses","Username":"Emri i përdoruesit","Username_and_message_must_not_be_empty":"Username dhe mesazhi nuk duhet të jetë bosh.","Username_cant_be_empty":"Emri i përdoruesit nuk mund të jetë bosh","Username_Change_Disabled":"Administratori juaj Rocket.Chat ka pezulluar ndryshimin e përdoruesve","Username_denied_the_OTR_session":"__username__ mohuar seancën OTR","Username_description":"Emri i përdoruesit është përdorur për të lejuar të tjerët për të përmendur ju në mesazhe.","Username_doesnt_exist":"emrin ` %s` nuk ekziston.","Username_ended_the_OTR_session":"__username__ përfundoi seancën OTR","Username_invalid":"<strong> %s</strong> nuk është një emër përdoruesi të vlefshme, <br/> përdorni vetëm shkronja, numra, pika, hyphens dhe nënvizon","Username_is_already_in_here":"`@ %s` është tashmë këtu.","Username_is_not_in_this_room":"Përdoruesi `# %s` nuk është në këtë dhomë.","Username_not_found":"Emri i përdoruesit nuk u gjet","Username_title":"Regjistrohu emrin","Username_unavaliable":"<strong> %s</strong> është tashmë në përdorim :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ dëshiron të fillojë OTR. A doni të pranoni?","Users":"përdoruesit","Users_in_role":"Përdoruesit në rolin","UTF8_Names_Slugify":"UTF8 Emrat Slugify","UTF8_Names_Validation":"UTF8 Emrat Validation","UTF8_Names_Validation_Description":"A nuk e lejojnë karaktere dhe hapësira të veçanta. Ju mund të përdorni - _ dhe. por jo në fund të emrit","Verification_email_sent":"email Verifikimi dërguar","View_All":"Shiko të gjitha","View_Logs":"Shiko Shkrime","Visibility":"dukshmëri","Visible":"i dukshëm","Visitor":"vizitor","Visitor_page_URL":"faqe Visitor URL","Visitor_time_on_site":"Ora Visitor në faqen","Wait_activation_warning":"Para se ju mund të identifikoheni, llogaria juaj duhet të aktivizohet me dorë nga një administrator.","We_are_offline_Sorry_for_the_inconvenience":"Ne jemi offline. Na vjen keq për bezdisjen.","We_have_sent_password_email":"Ne të dërguam ty një e-mail me udhëzime të rivendosur fjalëkalimin. Nëse ju nuk merrni një e-mail shpejti, ju lutem të ktheheni dhe provoni përsëri.","We_have_sent_registration_email":"Ne të dërguam ty një e-mail për të konfirmuar regjistrimin tuaj. Nëse ju nuk merrni një e-mail shpejti, ju lutem të ktheheni dhe provoni përsëri.","WebRTC_Enable_Channel":"Aktivizo për kanalet publike","WebRTC_Enable_Direct":"Aktivizo për mesazhe të drejtpërdrejta","WebRTC_Enable_Private":"Aktivizo për kanalet private","WebRTC_Servers":"Servers STUN / Java","WebRTC_Servers_Description":"Një listë e serverëve STUN dhe nga ana tjetër të ndara me presje. <br/> Emrin, fjalekalimin dhe port janë të lejuara në format `Fjalëkalimi @ shtanguar: host: port` apo` Përdoruesi: Fjalëkalimi @ kthesë: host: port`.","Welcome":"I mirëpritur","Welcome_to_the":"Mirë se vini në","will_be_able_to":"do të jetë në gjendje të","With_whom":"Me kë","Yes":"po","Yes_clear_all":"Po, qartë të gjitha!","Yes_delete_it":"Po, fshini atë!","Yes_hide_it":"Po, fshehin atë!","Yes_leave_it":"Po, të lënë atë!","Yes_mute_user":"Po, user memec!","Yes_remove_user":"Po, hiqni përdoruesit!","you_are_in_preview_mode_of":"Ju jeni në mënyrë preview e kanalit #","You_are_logged_in_as":"Ju jeni regjistruar si","You_are_not_authorized_to_view_this_page":"Ju nuk jeni i autorizuar për të parë këtë faqe.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Ti je pronari i fundit. Ju lutemi të vendosur pronari i ri para se të nisej në dhomë.","You_can_change_a_different_avatar_too":"Ju mund të pranoj avatar përdorur për të postuar nga ky integrim.","You_can_use_an_emoji_as_avatar":"Ju gjithashtu mund të përdorni një emoji si një avatar.","You_have_been_muted":"Ju keni qenë të mbytur dhe nuk mund të flas në këtë dhomë","You_have_not_verified_your_email":"Ju nuk e keni verifikuar email-it tuaj.","You_have_successfully_unsubscribed":"Ju jeni c'regjistruar me sukses nga Lista tonë mailling.","You_informed_an_invalid_FROM_address":"Ju informuar invalid NGA adresën.","You_must_provide_the_unsubscribe_link":"Ju duhet të sigurojë [unsubscribe] linkun.","You_need_confirm_email":"Ju duhet për të konfirmuar email-it tuaj të identifikoheni!","You_need_install_an_extension_to_allow_screen_sharing":"Ju duhet të instaloni një zgjatje të lejuar ndarjen e ekranit","You_need_to_change_your_password":"Ju duhet të ndryshoni fjalëkalimin tuaj","You_need_to_type_in_your_password_in_order_to_do_this":"Ju duhet të shkruani fjalëkalimin tuaj në mënyrë që të bëjë këtë!","You_need_to_type_in_your_username_in_order_to_do_this":"Ju duhet të shkruani emrin tuaj në mënyrë që të bëjë këtë!","You_need_to_verifiy_your_email_address_to_get_notications":"Ju duhet të verifiy adresën tuaj e-mail për të marrë njoftime","You_should_name_it_to_easily_manage_your_integrations":"Ju duhet përmendur se te menaxhoni me lehtësi integrimet tuaja.","You_will_not_be_able_to_recover":"Ju nuk do të jetë në gjendje të mbulojë këtë mesazh!","You_will_not_be_able_to_recover_file":"Ju nuk do të jetë në gjendje të mbulojë këtë fotografi!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Ju nuk do të merrni njoftime email sepse nuk e keni verifikuar email-it tuaj.","Your_email_has_been_queued_for_sending":"Emaili juaj ka qenë në radhë për dërgimin e","Your_entry_has_been_deleted":"Hyrja juaj është fshirë.","Your_file_has_been_deleted":"dosja juaj është fshirë.","Your_mail_was_sent_to_s":"maili juaj u dërgua në %s","Your_Open_Source_solution":"Vet Open Source chat zgjidhja juaj","Your_password_is_wrong":"Fjalëkalimi juaj është e gabuar!","Your_push_was_sent_to_s_devices":"shtytje juaj u dërgua në pajisjet %s"});
TAPi18n._registerServerTranslator("sq", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/sr.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["sr"] = ["Serbian","Српски језик"];                                                            // 8
if(_.isUndefined(TAPi18n.translations["sr"])) {                                                                        // 9
  TAPi18n.translations["sr"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["sr"][namespace])) {                                                             // 13
  TAPi18n.translations["sr"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["sr"][namespace], {"500":"Интернал Сервер Еррор","0_Errors_Only":"0 - Грешке Само","1_Errors_and_Information":"1 - Грешке и информације","2_Erros_Information_and_Debug":"2 - Еррос, информације и отклањање грешака","__username__was_set__role__by__user_by_":"__усернаме__ је постављен __роле__ од __усер_би__","__username__is_no_longer__role__defined_by__user_by_":"__усернаме__ више није __роле__, од __усер_би__","Access_not_authorized":"Приступ није овлашћен","Access_online_demo":"Приступ примеру на мрежи","Access_Online_Demo":"Приступ примеру на мрежи","Access_Token_URL":"УРЛ адреса токена приступа","Accounts":"рачуни","Accounts_AllowDeleteOwnAccount":"Омогућавају корисницима да избришете свој налог","Accounts_AllowedDomainsList":"Дозвољени домени Листа","Accounts_AllowedDomainsList_Description":"Зарезом одвојена листа дозвољених домена","Accounts_AllowEmailChange":"Дозволите Е-маил Цханге","Accounts_AllowPasswordChange":"Дозволи Пассворд Цханге","Accounts_AllowUserAvatarChange":"Дозволите Усер Аватар Цханге","Accounts_AllowUsernameChange":"Дозволи име Промена","Accounts_AllowUserProfileChange":"Дозволите Усер Профиле Цханге","Accounts_AvatarResize":"ресизе Аватари","Accounts_AvatarSize":"аватар величина","Accounts_AvatarStorePath":"Аватар складиштења Пут","Accounts_AvatarStoreType":"Аватар Стораге Типе:","Accounts_BlockedDomainsList":"Блокиран доменов","Accounts_BlockedDomainsList_Description":"Зарезом одвојена листа блокираних домена","Accounts_denyUnverifiedEmail":"Дени непроверене емаил","Accounts_EmailVerification":"Е-маил Верификација","Accounts_EmailVerification_Description":"Направи сте сигурни имали исправне поставке СМТП да користе ову функцију","Accounts_Enrollment_Email":"Упис е-маил","Accounts_Enrollment_Email_Description":"Можете користити [НАМЕ], [фнаме], [лнаме] за пуно име корисника, имену или презимену, респективно. <br /> Можете користити [емаил] е-поште корисника.","Accounts_Iframe_api_method":"апи Метод","Accounts_Iframe_api_url":"АПИ УРЛ","Accounts_iframe_enabled":"omogućeno","Accounts_iframe_url":"УРЛ адреса iframe","Accounts_LoginExpiration":"Пријава истека у данима","Accounts_ManuallyApproveNewUsers":"Ручно одобрава нове Корисници","Accounts_OAuth_Custom_Token_Sent_Via":"Токен послата преко","Accounts_OAuth_Custom_Authorize_Path":"овластити Патх","Accounts_OAuth_Custom_Button_Color":"дугме Боја","Accounts_OAuth_Custom_Button_Label_Color":"Дугме Боја текста","Accounts_OAuth_Custom_Button_Label_Text":"Текст дугмета","Accounts_OAuth_Custom_Enable":"омогућити","Accounts_OAuth_Custom_id":"ид","Accounts_OAuth_Custom_Identity_Path":"идентитет Пут","Accounts_OAuth_Custom_Login_Style":"Пријава Стил","Accounts_OAuth_Custom_Secret":"тајна","Accounts_OAuth_Custom_Token_Path":"токен Пут","Accounts_OAuth_Custom_URL":"УРЛ адреса","Accounts_OAuth_Facebook":"Фацебоок логин","Accounts_OAuth_Facebook_callback_url":"Фацебоок УРЛ за повратни позив","Accounts_OAuth_Facebook_id":"ИД фацебоок апликација","Accounts_OAuth_Facebook_secret":"фацебоок Тајна","Accounts_OAuth_Github":"ОАутх Омогућено","Accounts_OAuth_Github_callback_url":"Гитхуб УРЛ за повратни позив","Accounts_OAuth_GitHub_Enterprise":"ОАутх Омогућено","Accounts_OAuth_GitHub_Enterprise_callback_url":"ГитХуб предузећа УРЛ за повратни позив","Accounts_OAuth_GitHub_Enterprise_id":"ИД клијента","Accounts_OAuth_GitHub_Enterprise_secret":"klijent Тајна","Accounts_OAuth_Github_id":"ИД клијента","Accounts_OAuth_Github_secret":"klijent Тајна","Accounts_OAuth_Gitlab":"ОАутх Омогућено","Accounts_OAuth_Gitlab_callback_url":"ГитЛаб УРЛ за повратни позив","Accounts_OAuth_Gitlab_id":"ГитЛаб ИД","Accounts_OAuth_Gitlab_secret":"klijent Тајна","Accounts_OAuth_Google":"гоогле Пријава","Accounts_OAuth_Google_callback_url":"Гоогле УРЛ за повратни позив","Accounts_OAuth_Google_id":"гоогле ИД","Accounts_OAuth_Google_secret":"гоогле Тајна","Accounts_OAuth_Linkedin":"ЛинкедИн Пријава","Accounts_OAuth_Linkedin_callback_url":"ЛинкедИн УРЛ за повратни позив","Accounts_OAuth_Linkedin_id":"ЛинкедИн ИД","Accounts_OAuth_Linkedin_secret":"ЛинкедИн Тајна","Accounts_OAuth_Meteor":"метеор Пријава","Accounts_OAuth_Meteor_callback_url":"Метеор УРЛ за повратни позив","Accounts_OAuth_Meteor_id":"метеор ИД","Accounts_OAuth_Meteor_secret":"метеор Тајна","Accounts_OAuth_Twitter":"твиттер Пријава","Accounts_OAuth_Twitter_callback_url":"Твиттер УРЛ за повратни позив","Accounts_OAuth_Twitter_id":"Твиттер Број","Accounts_OAuth_Twitter_secret":"твиттер Тајна","Accounts_OAuth_Wordpress":"УордПресс Пријава","Accounts_OAuth_Wordpress_callback_url":"Вордпресс УРЛ за повратни позив","Accounts_OAuth_Wordpress_id":"ВордПресс ИД","Accounts_OAuth_Wordpress_secret":"УордПресс Тајна","Accounts_PasswordReset":"Ресетовање лозинке","Accounts_Registration_AuthenticationServices_Enabled":"Пријава са Аутхентицатион Сервицес","Accounts_RegistrationForm":"Образац за регистрацију","Accounts_RegistrationForm_Disabled":"онемогућен","Accounts_RegistrationForm_LinkReplacementText":"Образац за регистрацију Линк Замена Текст","Accounts_RegistrationForm_Public":"јавни","Accounts_RegistrationForm_Secret_URL":"сецрет УРЛ адреса","Accounts_RegistrationForm_SecretURL":"Образац за регистрацију Тајна УРЛ адреса","Accounts_RegistrationForm_SecretURL_Description":"Морате обезбедити случајни низ који ће бити додат на ваш регистрације УРЛ. Пример: хттпс://демо.роцкет.цхат/регистер/[сецрет_хасх]","Accounts_RegistrationRequired":"Регистратион рекуиред","Accounts_RequireNameForSignUp":"Захтевају Име За Сигнуп","Accounts_ShowFormLogin":"Схов образац заснован Пријава","Accounts_UseDefaultBlockedDomainsList":"Употреба Уобичајено блокираних домена Листа","Accounts_UseDNSDomainCheck":"Користи ДНС Домаин Цхецк","Activate":"Активирати","Activity":"Активност","Add":"додати","Add_agent":"Додај агент","Add_custom_oauth":"Додај прилагођени ОАутх","Add_manager":"Додај менаџера","Add_Members":"Додај Мемберс","Add_User":"Додај корисника","Add_user":"Додај корисника","Add_users":"Додај кориснике","Additional_emails":"Додатне Е-маил","Additional_Feedback":"Додатне Контакт","Administration":"администрација","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Након ОАутх2 аутентификације, корисници ће бити преусмерени на овај УРЛ","Agent_added":"агент додао","Agent_removed":"агент уклоњена","Alias":"псеудоним","All":"све","All_channels":"сви канали","All_logs":"sve историје","All_messages":"sve поруке","Allow_Invalid_SelfSigned_Certs":"Дозволите Погрешна селф-сигнед Цертс","Allow_Invalid_SelfSigned_Certs_Description":"Дозволите неважеће и само-потписан ССЛ сертификата за линк валидацију и прегледима.","and":"и","And_more":"И још __ленгтх __...","Animals_and_Nature":"Животиње и Природа","API":"АПИ за","API_Analytics":"аналитика","API_Embed":"ембед","API_EmbedDisabledFor":"Онемогући Додајте за кориснике","API_EmbedDisabledFor_Description":"Зарезом одвојена листа корисничких имена","API_GitHub_Enterprise_URL":"УРЛ сервер","API_GitHub_Enterprise_URL_Description":"Пример: хттп://домаин.цом (без косом цртом)","API_Gitlab_URL":"ГитЛаб УРЛ адреса","API_Wordpress_URL":"УордПресс УРЛ адреса","Appearance":"изглед","Application_added":"aplikacija је додао","Application_Name":"primena Име","Application_updated":"primena ажуриран","Apply_and_refresh_all_clients":"Нанесите и освежите све клијенте","Archive":"Архива","Archive_Unarchive":"Архив / Деархивирај","are_also_typing":"такође куцају","are_typing":"куцају","Are_you_sure":"Да ли сте сигурни?","Are_you_sure_you_want_to_delete_your_account":"Да ли сте сигурни да желите да избришете свој налог?","Authorization_URL":"овлашћење УРЛ адреса","Authorize":"овластити","AutoLinker_StripPrefix":"АутоЛинкер Стрип Префикс","AutoLinker_StripPrefix_Description":"Кратак приказ. нпр хттпс://роцкет.цхат => роцкет.цхат","AutoLinker_Urls":"АутоЛинкер УРЛ адреса","AutoLinker_UrlsRegExp":"АутоЛинкер УРЛ-Регулар Екпрессион","AutoLinker_Email":"АутоЛинкер Е-маил","AutoLinker_Phone":"АутоЛинкер телефона","AutoLinker_Phone_Description":"Аутоматски повезује на бројеве телефона. нпр `(123) 456-7890`","Auto_Load_Images":"Ауто Лоад слике","Available":"доступан","Available_agents":"слободни агенти","Avatar":"Промени аватара","Avatar_changed_successfully":"Аватар успешно промењен","Avatar_URL":"аватар УРЛ адреса","Avatar_url_invalid_or_error":"УРЛ адреса ако је неважећи или није доступна. Покушајте поново, али са различитим УРЛ.","away":"одсутан/на","Away":"Одсутан/на","away_female":"далеко","Away_female":"далеко","away_male":"далеко","Away_male":"далеко","Back":"Назад","Back_to_applications":"Назад на апликације","Back_to_integrations":"Назад на интеграција","Back_to_login":"Повратак на пријаву","Back_to_permissions":"Назад на дозвола","Body":"тело","bold":"одважан","busy":"заузет(а)","Busy":"Заузет(а)","busy_female":"Заузет","Busy_female":"Заузет","busy_male":"Заузет","Busy_male":"Заузет","Cancel":"Откажи","Cannot_delete_a_protected_role":"Не можете брисати заштићену улогу","Cannot_delete_role_because_its_in_use":"Не можете брисати улогу јер је у употреби","Cannot_invite_users_to_direct_rooms":"Не могу да позову друге кориснике да усмеравају собе","CDN_PREFIX":"ЦДН Префикс","Certificates_and_Keys":"Сертификати и тастери","Channel":"канал","Channel_doesnt_exist":"Канал `#% с` не постоји.","Channels":"Канали","Channels_list":"Списак јавних канала","Chat_Rooms":"Собе за ћаскање","Chatops_Enabled":"Омогући Цхатопс","Chatops_Title":"Цхатопс панел","Chatops_Username":"Цхатопс име","Choose_a_room":"Изаберите собу","Choose_messages":"Изаберите поруке","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Изаберите псеудоним који ће се појавити пред корисничко име у порукама.","Choose_the_username_that_this_integration_will_post_as":"Изаберите корисничко име које ће интеграција постављате као.","Clear_all_unreads_question":"Обришете све унреадс?","Client_ID":"ИД клијента","Client_Secret":"klijent Тајна","Clients_will_refresh_in_a_few_seconds":"Клијенти ће освежити за неколико секунди","close":"затвори","Closed":"zatvoreno","Collapse_Embedded_Media_By_Default":"Скупи уграђени медија по дефаулт-у","coming_soon":"ускоро долази","Commands":"komande","Compact_View":"компактан Погледај","Confirm_password":"Потврдите вашу лозинку","Contact":"Контакт","Conversation":"Разговор","Convert_Ascii_Emojis":"Претворити АСЦИИ у емоџи","Copied":"копирати","COPY_TO_CLIPBOARD":"Цопи То Цлипбоард","Copy_to_clipboard":"Цопи то цлипбоард","Count":"рачунати","Create":"створити","Create_new":"Створи ново","Created_at":"Направљено","Created_at_s_by_s":"Направљена <strong>у% с</strong> <strong>од% с</strong>","Custom_Fields":"Цустом Фиелдс","Custom_oauth_helper":"Када подешавате ОАутх провајдера, мораћете да обавести УРЛ за повратни позив. употреба <pre> % с </pre> .","Custom_oauth_unique_name":"Цустом ОАутх јединствено име","Custom_Script_Logged_In":"Цустом Сцрипт за пријављене кориснике","Custom_Script_Logged_Out":"Цустом Сцрипт за пријављени од корисника","Dashboard":"командна табла","days":"дани","Deactivate":"деактивирање","Debug_Level":"дебуг ниво","Default":"Уобичајено","Delete":"избрисати","Delete_my_account":"Обриши мој рачун","Delete_Room_Warning":"Брисање собу ће избрисати све поруке послате у соби. Ово се не може поништити.","Delete_User_Warning":"Брисање корисника ће обрисати све поруке из тог корисника као добро. Ово се не може поништити.","Deleted":"Делетед!","Department_not_found":"Одељење није пронађен","Department_removed":"Одељење уклоњена","Departments":"Катедре","Description":"опис","Desktop":"десктоп","Desktop_Notification_Test":"Обавештење тест десктоп","Desktop_Notifications":"Десктоп Обавештења","Desktop_Notifications_Disabled":"Десктоп Обавештења су искључени. Промените подешавања бровсера ако треба обавештења омогућене.","Desktop_Notifications_Enabled":"Десктоп Обавештења су омогућена","Direct_message_someone":"Директна порука неко","Direct_Messages":"Директне поруке","Direct_Messages_list":"директне поруке","Disable_Favorite_Rooms":"дисабле Омиљене","Disable_New_Message_Notification":"Онемогућити нову поруку Нотифицатион","Disable_New_Room_Notification":"Онемогућити нову собу Нотифицатион","Displays_action_text":"Приказује текст акције","Do_you_want_to_change_to_s_question":"Да ли желите да промените <strong>на% с?</strong>","Drop_to_upload_file":"Пасти на отпремити датотеку","Dry_run":"dry Рун","Dry_run_description":"Ће послати само један е-маил, на истој адреси као и од. Имејл морају припадати важећег корисника.","Duplicate_archived_channel_name":"Архивирана Канал са именом \"% с\" не постоји","Duplicate_archived_private_group_name":"Архивирана Приватна Група са именом \"% с\" не постоји","Duplicate_private_group_name":"Приватни Група са именом \"% с\" не постоји","E-mail":"Е-пошта","Edit":"едит","Edit_Custom_Field":"Измена прилагођеног поља","Edit_Department":"едит Одељење","edited":"измењено","Email":"емаил","Email_already_exists":"емаил већ постоји","Email_body":"Е-пошта тело","Email_Change_Disabled":"Ваш Роцкет.Цхат Администратор је онемогућио промену е-поште","Email_from":"од","Email_Notification_Mode":"Ван Емаил Обавештења","Email_Notification_Mode_All":"Свако помињање / ЗВ","Email_Notification_Mode_Disabled":"онемогућен","Email_or_username":"Е-адреса или корисничко име","Email_subject":"тема","Email_verified":"Е-адреса потврђена","Emoji":"Емоџији","Empty_title":"празан наслов","Enable":"омогућити","Enable_Desktop_Notifications":"Омогући Обавештења на радној површини","Enabled":"omogućeno","Encrypted_message":"шифровану поруку","End_OTR":"Крај ОТР","Enter_a_regex":"Унесите регек","Enter_a_room_name":"Унесите име собе","Enter_a_username":"Унесите корисничко име","Enter_info":"Унесите ваше податке","Enter_name_here":"Унесите име овде","Enter_to":"Ентер да","Error":"грешка","error-cant-invite-for-direct-room":"не могу позвати корисника директним соба","error-duplicate-channel-name":"Канал са именом \"% с\" не постоји","error-invalid-custom-field":"Неважећи прилагођено поље","error-invalid-custom-field-name":"Неважећи назив прилагођено поље. Користите само слова, бројеве, цртице и доње црте.","error-invalid-password":"Погрешна лозинка","error-invalid-room":"неважећи соба","error-invalid-room-name":"<strong>% с</strong> није исправан назив соба, <br/> користити само слова, бројеве, цртице и доња","error-invalid-user":"nevažeći корисник","error-invalid-username":"Погрешно корисничко име","error-not-allowed":"Није дозвољено","error-not-authorized":"није овлашћен","error-remove-last-owner":"Ово је последњи власник. Молимо подесите новог власника пре него што уклоните овај.","error-role-name-required":"Име улога је потребно","error-user-not-in-room":"Корисник није у овој соби","Error_changing_password":"Грешка приликом промене лозинке","Error_sending_confirmation_email":"Грешка при слању потврде емаил","Error_too_many_requests":"Грешка, превише захтева. Молим те успори. Морате да сачекате% с секунди пре него што покушате поново","Esc_to":"Есц да","Example_s":"Пример: <code class=\"inline\">%s</code>","False":"лажан","Favorites":"Омиљено","Field":"поље","Field_removed":"поље уклоњена","File_exceeds_allowed_size_of_bytes":"Филе прелази дозвољену величину __сизе__ бајтова","FileUpload":"file Уплоад","FileUpload_Enabled":"Филе уплоадс Омогућено","FileUpload_File_Empty":"Филе празна","FileUpload_FileSystemPath":"sistem Пут","FileUpload_MaxFileSize":"Максимална величина уплоад сизе (ин битес)","FileUpload_MediaType_NotAccepted":"Врсте медија Није прихваћено","FileUpload_MediaTypeWhiteList":"Прихваћени типови медија","FileUpload_MediaTypeWhiteListDescription":"Зарезом одвојена листа типова медија. Оставите га празно за прихватање свих врста медија.","FileUpload_ProtectFiles":"Протецт постављене датотеке","FileUpload_ProtectFilesDescription":"Једини аутентични корисници ће имати приступ","FileUpload_S3_Acl":"Амазон С3 АЦЛ","FileUpload_S3_AWSAccessKeyId":"Амазон С3 АВСАццессКеиИд","FileUpload_S3_AWSSecretAccessKey":"Амазон С3 АВССецретАццессКеи","FileUpload_S3_Bucket":"Амазон С3 кашика име","FileUpload_S3_BucketURL":"кашика УРЛ адреса","FileUpload_S3_CDN":"ЦДН домен за преузимање","FileUpload_S3_Region":"област","FileUpload_Storage_Type":"складиштење Тип","Flags":"Заставе","Follow_social_profiles":"Пратите наше друштвене профиле, форкујте нас на Гитхабу и поделите ваша мишљења о нашој rocket.chat апликацији на нашој Трело табли.","Food_and_Drink":"Храна пиће","For_your_security_you_must_re_enter_your_password_to_continue":"За вашу безбедност, морате поново унесите лозинку да бисте наставили","Force_SSL":"сила ССЛ","Force_SSL_Description":"* Опрез! * _Форце ССЛ_ никада не треба да се користи са обрнутим проки. Ако имате обрнути проки, требало би да уради преусмеравање ПОСТОЈИ. Ова опција постоји за распоређивања као Хероку, који не дозвољава конфигурацију преусмеравање на обрнутим проки.","Forgot_password":"Заборавили сте лозинку","Fork_it_on_github":"Форкуј на Гитхабу","Frequently_Used":"често коришћене","From":"од","From_Email":"od Емаил","From_email_is_required":"Од је потребно маил","From_email_warning":"<b>Упозорење:</b> Поље <b>Од</b> подлеже поставкама маил сервера.","General":"општи","Get_to_know_the_team":"Упознајте се Роцкет.Теам","github_no_public_email":"Немате ниједну е-адресу као јавну е-адресу на вашем Гитхаб налогу","Give_a_unique_name_for_the_custom_oauth":"Дати јединствено име за прилагођени ОАутх","Give_the_application_a_name_This_will_be_seen_by_your_users":"Дајте Апликација име. Ово ће бити виђена од својих корисника.","Global":"глобалан","GoogleTagManager_id":"Гоогле ИД менаџер ознака","Has_more":"има више","Have_your_own_chat":"Имајте ваше веб ћаскање. Направљено уз Meteor.com, Рокет чет је одлично решење за пројектанте који желе да изграде и унапреде сопствену платформу за ћаскање.","Header":"хеадер","Hidden":"Сакривен","Hide_Group_Warning":"Да ли сте сигурни да желите да сакријете групу \"% с\"?","Hide_Private_Warning":"Да ли сте сигурни да желите да сакријете разговор са \"% с\"?","Hide_room":"Сакриј собу","Hide_Room_Warning":"Да ли сте сигурни да желите да сакријете собу \"% с\"?","Highlights":"праменови","Highlights_How_To":"Да будете обавештени када неко помене реч или фразу, додајте га овде. Можете одвојити речи или фразе са зарезима. Хигхлигхт Речи се не разликују.","Highlights_List":"Хигхлигхт речи","History":"Историјат","hours":"сати","How_friendly_was_the_chat_agent":"Како пријатељски је био агент ћаскање?","How_knowledgeable_was_the_chat_agent":"Како знања је агент ћаскање?","How_responsive_was_the_chat_agent":"Како реагују био агент ћаскање?","How_satisfied_were_you_with_this_chat":"Колико сте задовољни су са овом разговору?","If_you_are_sure_type_in_your_password":"Ако сте сигурни унесите лозинку:","If_you_are_sure_type_in_your_username":"Ако сте сигурни тип ваше корисничко име:","Importer_Archived":"архивиране","Importer_done":"Увоз завршен!","Importer_finishing":"Завршава увоз.","Importer_From_Description":"Увоз __фром __ 'с подацима у Роцкет.Цхат.","Importer_import_cancelled":"Импорт отказан.","Importer_import_failed":"Дошло је до грешке док ради увоз.","Importer_importing_channels":"Увоз канала.","Importer_importing_messages":"Увоз поруке.","Importer_importing_started":"Покретање увоз.","Importer_importing_users":"Увоз кориснике.","Importer_not_defined_properly":"Увозник није правилно дефинисана, она недостаје за увоз класу.","Importer_not_in_progress":"Увозник је тренутно није покренут.","Importer_Prepare_Restart_Import":"рестарт Увоз","Importer_Prepare_Start_Import":"Старт Увоз","Importer_Prepare_Uncheck_Archived_Channels":"Поништите потврду Архивирани Канали","Importer_Prepare_Uncheck_Deleted_Users":"Искључи Делетед корисника","Importer_progress_error":"Није добио напредак за увоз.","Importer_setup_error":"Дошло је до грешке приликом подешавања увозника.","Incorrect_Password":"Погрешна лозинка","inline_code":"инлине_цоде","Install_Extension":"Инсталл Ектенсион","Install_FxOs":"Инсталирајте Роцкет.Цхат на Фирефок","Install_FxOs_done":"Велики! Сада можете да користите Роцкет.Цхат преко иконе на вашем почетном екрану. Забавите се са Роцкет.Цхат!","Install_FxOs_error":"Жао ми је, то се не ради како треба! Следећи грешка појавила:","Install_FxOs_follow_instructions":"Молимо потврдите инсталацију апликације на уређају (притисните \"Инсталл\" када то буде затражено).","Installation":"инсталација","Integration_added":"Интеграција је додао","Integration_Incoming_WebHook":"Инцоминг ВебХоок Интеграција","Integration_New":"Нови Интеграција","Integration_Outgoing_WebHook":"Одлазећи ВебХоок Интеграција","Integration_updated":"Интеграција је ажуриран","Integrations":"интеграције","Invalid_asset":"неважећи средства","Invalid_confirm_pass":"Лозинка из поља за потврду се не поклапа са првом лозинком","Invalid_email":"Унета е-адреса не неисправна","Invalid_Export_File":"Фајл уплоадед није исправан% с извоз датотека.","Invalid_file_height":"Неважећи висина фајл","Invalid_file_type":"Инвалид филе типе","Invalid_file_width":"Неважећи ширина фајл","Invalid_Import_File_Type":"Погрешна врста Увоз датотеке.","Invalid_name":"Корисничко име не сме бити празно","Invalid_notification_setting_s":"Инвалид подешавање обавештење% с","Invalid_pass":"Лозинка не сме бити празна","Invalid_room_name":"<strong>%s</strong> није исправно име канала,<br/> користите само слова, бројеве и цртице","Invalid_room_type":"<strong>% с</strong> није исправан тип соба.","Invalid_Secret_URL":"Неважећи тајни УРЛ адреса","Invalid_secret_URL_message":"УРЛ адреса обезбеђен је неважећи.","invisible":"невидљив(а)","Invisible":"Невидљив(а)","Invitation_HTML":"poziv ХТМЛ-","Invitation_Subject":"poziv Предмет","Invite_user_to_join_channel":"Позови једног корисника да се прикључе овој канал","Invite_Users":"Позови корисника","is_also_typing":"такође куца","is_also_typing_female":"је такође куцање","is_also_typing_male":"је такође куцање","is_typing":"куца","is_typing_female":"је куцање","is_typing_male":"је куцање","italics":"курзив","join":"Придружити","Join_audio_call":"Придружите аудио позив","Join_the_Community":"Придружи се заједници","Join_the_given_channel":"Придружите се дати канал","Join_video_call":"Придружите видео позив","Joined":"Придружио","Jump":"јумп","Jump_to_first_unread":"Скок на прву непрочитану","Jump_to_message":"Скочи на поруку","Jump_to_recent_messages":"Пребаци се на недавне поруке","Katex_Enabled":"Катек Омогућено","Label":"Етикета","Language":"језик","Language_Version":"Енглеска верзија","Last_login":"Последње пријављивање","Last_message":"Последња порука","Last_seen":"Последњи пут виђен","Layout":"распоред","Layout_Home_Body":"хоме telo","Layout_Home_Title":"хоме Наслов","Layout_Login_Terms":"Пријава Правила","Layout_Privacy_Policy":"Правила о приватности","Layout_Sidenav_Footer":"Сиде Навигација подножје","Layout_Sidenav_Footer_description":"Фоотер величина је 260 к 70пк","Layout_Terms_of_Service":"Услови коришћења","LDAP":"ЛДАП","LDAP_CA_Cert":"ЦА Церт","LDAP_Custom_Domain_Search":"Цустом Претрага домена","LDAP_Custom_Domain_Search_Description":"Парче ЈСОН који управља везују и повезивање информација и има облик: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Уобичајено Домен","LDAP_Description":"ЛДАП је хијерархијска база података која многе компаније користе да би обезбедили јединствени знак на - објекат за размену једну лозинку између више локација и услуга. За напредне информације о конфигурацији и примере, погледајте наш вики: хттпс://гитхуб.цом/РоцкетЦхат/Роцкет.Цхат/вики/ЛДАП-Аутхентицатион.","LDAP_Dn":"ЛДАП ДН","LDAP_Domain_Base":"domen База","LDAP_Domain_Base_Description":"Потпуно квалификовани препознатљивог имена (ДН) ЛДАП подстабла желите да тражите кориснике и групе. Можете додати колико год желите; Међутим, свака група мора бити дефинисана у истој бази домена као и корисницима који јој припадају. Ако наведете ограничене групе корисника, само корисници који припадају тим групама ће бити у обиму. Препоручујемо да наведете највиши ниво вашег ЛДАП стабла именика као домена базу и користите филтер за претрагу за контролу приступа.","LDAP_Domain_Search_Filter":"Домен Тражи филтер","LDAP_Domain_Search_Filter_Description":"Ако наведено, само корисници који одговарају овог филтера ће бити дозвољено да се пријавите. Ако није наведен филтера, сви корисници у оквиру наведеног домена базе ће моћи да се пријавите. <br/> Нпр за Ацтиве Дирецтори `мемберОф = ЦН = РОЦКЕТ_ЦХАТ, или = генерал Гроупс`. <br/> Нпр за ОпенЛДАП (прошириви меч претрага) 'или: ДН: = РОЦКЕТ_ЦХАТ`.","LDAP_Domain_Search_Object_Category":"Домен Претрага Предмет Категорија","LDAP_Domain_Search_Object_Category_Description":"Тхе * објецтЦатегори * да идентификују своје кориснике. <br/> Оставите празно за * ОпенЛДАП *. <br/> Нпр `персон`, итд","LDAP_Domain_Search_Object_Class":"Домен Класа Претрага Предмет","LDAP_Domain_Search_Object_Class_Description":"Тхе * објецтЦласс * да идентификују своје кориснике. <br/> Нпр `организатионалПерсон`,` усер`, `инетОргПерсон`, итд","LDAP_Domain_Search_Password":"Домен Тражи Лозинка","LDAP_Domain_Search_Password_Description":"Лозинка за корисника претраживање домена.","LDAP_Domain_Search_User":"Домен Тражи Корисник","LDAP_Domain_Search_User_Description":"ЛДАП корисник који обавља корисника лоокупс за проверу идентитета друге кориснике када се пријавите. <br/> Ово је типично рачун сервис специјално направљена за треће стране интеграције. Користите пуно име, као што су `цн = Администратор, ЦН = Усерс, ДЦ = пример, ДЦ = цом`.","LDAP_Domain_Search_User_ID":"Домен Тражи кориснику ИД","LDAP_Domain_Search_User_ID_Description":"ЛДАП атрибут који идентификује корисника ЛДАП који покушавају проверу идентитета. Ово поље треба да буде `сАМАццоунтНаме` за већину Ацтиве Дирецтори инсталацијама, али може бити` уид` за друге ЛДАП решења, као што је ОпенЛДАП. Можете користити `маил` идентификују кориснике путем е-маила или како атрибут хоћеш. <br> Можете користити више вредности одвојене зарезом да омогући корисницима да се пријавите користећи више идентификаторе као што су корисничко име или е-маилом.","LDAP_Enable":"омогућити","LDAP_Enable_Description":"Покушај да се користе ЛДАП за потврду идентитета.","LDAP_Encryption":"шифровање","LDAP_Encryption_Description":"Метод шифровања се користи да обезбеди комуникацију са ЛДАП серверу. Примери укључују `плаин` (но шифровање),` ССЛ / ЛДАПС` (шифрована од почетка), и `СтартТЛС` (упграде на шифровану комуникацију једном повезан).","LDAP_Host":"Домаћин","LDAP_Host_Description":"ЛДАП домаћина, на пример, `лдап.екампле.цом` или` 10.0.0.30`.","LDAP_Port":"лука","LDAP_Port_Description":"Порт за приступ ЛДАП. нпр: `389` или` 636` за ЛДАПС","LDAP_Reject_Unauthorized":"Одбаци Неовлашћено","LDAP_Sync_User_Avatar":"Синц Кориснички Аватар","LDAP_Sync_User_Data":"podaci синц","LDAP_Sync_User_Data_Description":"Имајте корисничких података у синхронизацију са сервером на логин (нпр: име, емаил).","LDAP_Sync_User_Data_FieldMap":"Корисник поља података Карта","LDAP_Sync_User_Data_FieldMap_Description":"Конфигуришете како се поља кориснички налог (као поште) насељено од рекордних у ЛДАП (једном фоунд). <br/> Као пример, `{\" ЦН \":\" Име \",\" пошта \":\" е \"}` ће изабрати човеку читљиву име особе из цн атрибута, и њихово емаил од атрибута поште. <br/> Поља која укључују `наме`, и` емаил`.","LDAP_Sync_Users":"Синц корисника","LDAP_Test_Connection":"тест везе","LDAP_Unique_Identifier_Field":"Јединствени идентификатор Поље","LDAP_Unique_Identifier_Field_Description":"Који поље ће се користити за повезивање корисника ЛДАП и корисника Роцкет.Цхат. Можете обавестити више вредности одвојене зарезом у покушају да добије вредност од ЛДАП записа. <br/> Дефаулт вредност је `објецтГУИД, ИБМ-ентриУУИД, ГУИД, доминоУНИД, нсуникуеИд, уидНумбер`","LDAP_Use_Custom_Domain_Search":"Користити прилагођени домен Сеарцх","LDAP_Use_Custom_Domain_Search_Description":"Напиши свој филтер за претрагу корисника у ЛДАП серверу.","LDAP_Username_Field":"корисничко име polje","LDAP_Username_Field_Description":"Који поље ће се користити као * корисничко име * за нове кориснике. Оставите празно да користи име информисани на пријаву. <br/> Можете користити темплате ознаке такође, као `# {ГивенНаме}. # {Лок}`. <br/> Дефаулт вредност је `сАМАццоунтНаме`.","Leave_Group_Warning":"Да ли сте сигурни да желите да напустите групу \"% с\"?","Leave_Private_Warning":"Да ли сте сигурни да желите да напустите дискусију са \"% с\"?","Leave_room":"Напусти собу","Leave_Room_Warning":"Да ли сте сигурни да желите да напустите просторију \"% с\"?","line":"линија","List_of_Direct_Messages":"Списак директне поруке","Live_sessions":"Ливе Сессионс","Livechat_agents":"ЛивеЦхат агенти","Livechat_Dashboard":"ЛивеЦхат Контролна табла","Livechat_enabled":"ЛивеЦхат омогућено","Livechat_Manager":"ЛивеЦхат директор","Livechat_managers":"ЛивеЦхат менаџери","Livechat_title":"ЛивеЦхат Наслов","Livechat_title_color":"ЛивеЦхат Наслов Боја позадине","Livechat_Users":"ЛивеЦхат корисника","Load_more":"Учитај још","Loading...":"Лоадинг ...","Loading_more_from_history":"Лоадинг више од историје","Loading_suggestion":"Учитавам предлоге...","Localization":"Локализација","Log_File":"Схов Филе и Лине","Log_Level":"лог Ниво","Log_Package":"схов Пакет","Log_View_Limit":"Лог Виев Лимит","Logged_out_of_other_clients_successfully":"Пријављени од других клијената успешно","Login":"Пријава","Login_with":"Пријави се са %s","login_with":"Или се пријавите директно са","Logout":"Одјави се","Logout_Others":"Одјавите Од осталих пријављени Локације","Mail_Message_Invalid_emails":"Које сте дали један или више неважећих е-поште:% с","Mail_Message_Missing_to":"Морате изабрати једну или више корисника или да обезбеди једну или више адреса е-поште, одвојене зарезима.","Mail_Message_No_messages_selected_select_all":"Нисте изабрали ниједну поруку. Да ли желите да <a href='#' class='select-all'>изаберете све</a> видљиве поруке?","Mail_Messages":"маил поруке","Mail_Messages_Instructions":"Изабрати које поруке желите да пошаљете путем е-маила тако што ћете кликнути поруке","Mail_Messages_Subject":"Овде је изабран део% с порука","Mailer":"маилер","Mailer_body_tags":"<b>Морате</b> користити [одјавити] за Унсубсцриптион линк. <br /> Можете користити [НАМЕ], [фнаме], [лнаме] за пуно име корисника, имену или презимену, респективно. <br /> Можете користити [емаил] е-поште корисника.","Make_Admin":"Маке Админ","Manager_added":"директор је додао","Manager_removed":"директор уклоњена","Mark_as_read":"Означи као прочитано","Markdown_Headers":"Маркдовн заглавља","Markdown_SupportSchemesForLink":"Маркдовн подрже шеме за Линк","Markdown_SupportSchemesForLink_Description":"Зарезом одвојена листа одобрених шема","Members_List":"Списак чланова","Mentions":"Ментионс","Mentions_default":"Помиње (стандардна)","Message":"порука","Message_AllowDeleting":"Дозволи порука Брисање","Message_AllowEditing":"Дозволи порука уређивање","Message_AllowEditing_BlockEditInMinutes":"Блок Порука Уређивање Афтер (н) Минутес","Message_AllowEditing_BlockEditInMinutesDescription":"Унесите 0 да искључите блокирање.","Message_AllowPinning":"Дозволи порука пиннинг","Message_AllowPinning_Description":"Допусти поруке се качи на било који од канала.","Message_AllowStarring":"Дозволи Порука Улоге","Message_AudioRecorderEnabled":"Аудио рекордер Омогућено","Message_AudioRecorderEnabledDescription":"Захтева 'аудио / ВАВ' фајлова да буде прихваћена врста медија у 'филе уплоад' подешавањима.","Message_DateFormat":"Формат датума","Message_DateFormat_Description":"Погледајте такође: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Момент.јс</a>","Message_deleting_not_allowed":"Порука брисање није дозвољено","Message_editing_blocked":"Ова порука не може бити измењено више","Message_editing_not_allowed":"уређивање порука није дозвољено","Message_GroupingPeriod":"Груписање Период (у секундама)","Message_GroupingPeriodDescription":"Поруке ће бити груписане у претходну поруку ако су оба из исте корисника и протекло време је мање од информисано време у секундама.","Message_KeepHistory":"Кееп Мессаге Хистори","Message_MaxAllowedSize":"Максимална дозвољена порука величина","Message_MaxAll":"Максимална величина канал за све поруке","Message_pinned":"Порука је закачена","Message_pinning_not_allowed":"Порука Пиннинг није дозвољено","Message_removed":"Порука уклоњена","Message_ShowDeletedStatus":"Схов Делетед статус","Message_ShowEditedStatus":"Схов Измењено Статус","Message_ShowFormattingTips":"Схов Савети за обликовање","Message_TimeFormat":"Формат времена","Message_TimeFormat_Description":"Погледајте такође: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Момент.јс</a>","Message_too_long":"Порука предуго","Messages":"Поруке","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Поруке које се шаљу Инцоминг ВебХоок ће бити овде постављен.","Meta":"мета","Meta_fb_app_id":"ИД фацебоок апликација","Meta_google-site-verification":"Гоогле сајт за верификацију","Meta_language":"језик","Meta_msvalidate01":"МСВалидате.01","Meta_robots":"Роботи","minutes":"минута","Mobile_push":"мобиле Пусх","More_channels":"Више канала","More_direct_messages":"Више директне поруке","More_groups":"Више приватне групе","More_unreads":"više унреадс","Msgs":"Поруке","multi":"више","Mute_someone_in_room":"Муте неко у соби","Mute_user":"муте корисника","Muted":"пригушен","My_Account":"Мој налог","n_messages":"%s порука","N_new_messages":"% с нових порука","Name":"Име","Name_cant_be_empty":"Име не може бити празна","Name_of_agent":"Име агента","Name_optional":"Име (опционо)","Navigation_History_20_last_pages":"Навигација Историја (20 последњих страница)","New_Application":"Нова апликација","New_Custom_Field":"Нови прилагођени поља","New_Department":"Нови Одељење","New_integration":"Нова интеграција","New_logs":"Нове евиденције","New_messages":"Нове поруке","New_password":"Нова лозинка","New_role":"Нова улога","No_channel_with_name_%s_was_found":"Нема канал са именом <strong>\"% с\"</strong> је пронађен!","No_channels_yet":"Нисте члан било ког канала још.","No_direct_messages_yet":"Нисте започели ниједан разговор још.","No_Encryption":"но шифровање","No_favorites_yet":"Нисте означили ништа омиљеним још.","No_group_with_name_%s_was_found":"Нема приватних група са именом <strong>\"% с\"</strong> је пронађен!","No_groups_yet":"Немате ниједну приватну групу за сада.","No_livechats":"Немате ливецхатс.","No_mentions_found":"Не помињу фоунд","No_permission_to_view_room":"Немате овлашћења да видите ову собу","No_pinned_messages":"Но закачене порука","No_results_found":"Нема резултата","No_starred_messages":"Но звездицом порука","no_tokens_for_this_user":"Нема токени за овај корисника","No_user_with_username_%s_was_found":"Не корисник са корисничким именом <strong>\"% с\"</strong> је пронађен!","Not_allowed":"Није дозвољено","Not_authorized":"није овлашћен","Not_Available":"Није доступно","Not_found_or_not_allowed":"Није нађено или није дозвољено","Nothing":"Ништа","Nothing_found":"Ништа није нађено","Notifications":"Обавештења","Notify_all_in_this_room":"Обавештава све у овој соби","Num_Agents":"# Агенти","Number_of_messages":"Број порука","OAuth_Application":"ОАутх Апликација","OAuth_Applications":"ОАутх Апликације","Objects":"objekti","Off_the_record_conversation":"Офф-тхе-рецорд Разговор","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Офф-тхе-рецорд разговор није доступан за ваш прегледач или уређај.","Offline_DM_Email":"[__сите__] Сте били директно поручио је __усер__","Offline_Mention_Email":"[__сите__] Сте је поменуо __усер__ у #__роом__","Old_and_new_password_must_be_different":"Нова лозинка мора бити различита од старе лозинке.","Old_and_new_password_required":"Потребно је да обезбеди и стару и нову лозинку за промену лозинке.","Online":"На мрежи","Only_errors":"samo грешке","Only_you_can_see_this_message":"Само ви можете видети ову поруку","Oops!":"Д","Open":"отворен","Opened":"Отворен","Opt_out_statistics":"Не шаљу своје статистике на Роцкет.Цхат","Opt_out_statistics_warning":"Слањем своје статистике, да ћете нам помоћи да утврдимо како су многи случајеви Роцкет.Цхат распоређен, као и колико је добар систем понаша, тако да може даље да побољша. Не брините, јер нема информације о кориснику се шаље и све информације које добијају се држи у тајности. Ако желите да наставите слати нам своје статистике, искључите горе потврду. Хвала вам.","optional":"опционо","Order":"ред","OS_Arch":"ОС Арцх","OS_Cpus":"ОС Процесор Точка","OS_Freemem":"ОС Слободна меморија","OS_Loadavg":"ОС лоад авераге","OS_Platform":"ОС платформе","OS_Release":"ОС Издање","OS_Totalmem":"ОС Укупно меморије","OS_Type":"тури","OS_Uptime":"ОС Уптиме","others":"други","OTR":"ОТР","OTR_is_only_available_when_both_users_are_online":"ОТР је доступна само ако оба корисника су онлине","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Замени УРЛ адреса за датотеке које су уплоадед. Овај УРЛ се користи за преузимање, осим ако ЦДН дат","Password":"Лозинка","Password_Change_Disabled":"Ваш Роцкет.Цхат Администратор је онемогућио промену лозинки","Password_changed_successfully":"Лозинка је успешно промењена","Payload":"корисна носивост","People":"Људи","Permissions":"Дозволе","Pin_Message":"пин порука","Pinned_a_message":"Пиннед поруку:","Pinned_Messages":"Пиннед поруке","Placeholder_for_email_or_username_login_field":"Плацехолдер фор емаил или корисничко име за пријаву области","Placeholder_for_password_login_field":"Плацехолдер за лозинку за пријаву области","Please_answer_survey":"Одвојите мало времена да одговори брзо анкету о овом разговору","Please_enter_value_for_url":"Унесите вриједност за УРЛ вашег аватара.","Please_enter_your_new_password_below":"Унесите нову лозинку испод:","Please_fill_a_label":"Молимо вас да попуните ознаку","Please_fill_a_name":"Молимо испуните име","Please_fill_a_username":"Молимо вас да попуните корисничко име","Please_fill_name_and_email":"Молимо вас да попуните име и емаил","Please_re_enter_your_password":"Поново унесите лозинку","Please_select_enabled_yes_or_no":"Молимо одаберите опцију за Омогућено","Please_wait":"Сачекајте","Please_wait_activation":"Сачекајте, ово може потрајати неко време.","Please_wait_statistics":"Сачекајте, статистика се генеришу.","Please_wait_while_OTR_is_being_established":"Сачекајте док ОТР се успоставља","Please_wait_while_your_account_is_being_deleted":"Сачекајте док ваш налог се брише ...","Please_wait_while_your_profile_is_being_saved":"Сачекајте док се профил се спасили ...","Post_as":"пост као","Post_to_Channel":"Пост на канал","Post_to_s_as_s":"<strong>Пост% с</strong> <strong>као% с</strong>","Powered_by":"Покреће","Preferences":"преференцес","Preferences_saved":"Подешавања су сачувана","Privacy":"Приватност","Private_Group":"Приватна Група","Private_Groups":"Приватне групе","Private_Groups_list":"Списак приватних група","Profile":"профил","Profile_saved_successfully":"Профил савед суццессфулли","Proudly_developed":"Поносно развијено користећи Метеор","Push":"Гурај","Push_apn_cert":"АПН Церт","Push_apn_dev_cert":"АПН Дев Церт","Push_apn_dev_key":"АПН Дев Кључ","Push_apn_dev_passphrase":"АПН Дев Приступна фраза","Push_apn_key":"АПН ključ","Push_apn_passphrase":"АПН приступна фраза","Push_debug":"дебуг","push_disabled":"Пусх онемогућен","Push_enable":"омогућити","Push_enable_gateway":"Омогући Гатеваи","Push_gateway":"пролаз","Push_gcm_api_key":"ГЦМ АПИ кључ","Push_gcm_project_number":"ГЦМ Број пројекта","Push_production":"производња","Push_show_message":"Показати поруку у обавештењу","Push_show_username_room":"Схов канал / група / корисничко име у обавештењу","Push_test_push":"тест","Query":"питање","Query_description":"Додатни услови за одређивање који корисницима да пошаље емаил. Одјавили корисници се аутоматски уклањају из упита. То мора бити важећи ЈСОН. Пример: \"{\" цреатедАт \": {\" $ ГТ \": {\" $ датум \":\" 2015-01-01Т00: 00: 00.000З \"}}}\"","Quick_Search":"Брза претрага","quote":"цитат","Reactions":"reakcije","Recents":"Скорашње","Record":"запис","Redirect_URI":"Редирецт УРИ","Refresh_keys":"рефресх тастери","Refresh_your_page_after_install_to_enable_screen_sharing":"Освежите своје странице након инсталирати да бисте омогућили дељење екрана","Register":"Направите нови налог","Registration_Succeeded":"регистрација Суццеедед","Remember_me":"Запамти ме","Remove":"Уклони","Remove_Admin":"ремове Админ","Remove_as_moderator":"Уклоните што модератор","Remove_as_owner":"Уклоните као власник","Remove_custom_oauth":"Ремове прилагођени ОАутх","Remove_from_room":"Уклоните из собе","Remove_someone_from_room":"Уклоните некога из собе","Removed":"uklonjena","Require_password_change":"Захтева промену лозинке","Resend_verification_email":"Поново пошаљи за верификацију","Reset":"Ресетовати","Reset_password":"Поново постави лозинку","Restart":"Поново покренути","Restart_the_server":"Поново покрените сервер","RocketBot_Enabled":"РоцкетБот Омогућено","RocketBot_Name":"РоцкетБот Име","RocketBot_Name_Description":"Име РоцкетБот мора бити валидна корисничко име регистрован на серверу.","Role":"улога","Role_Editing":"uloga Уређивање","Role_removed":"uloga уклоњена","Room":"Соба","Room_archivation_state":"Држава","Room_archivation_state_false":"активан","Room_archivation_state_true":"архивиране","Room_archived":"соба архивиране","room_changed_privacy":"Тип собе промењен у: <em>__роом_типе__</em> од <em>__усер_би__</em>","room_changed_topic":"Соба тему промењен у: <em>__роом_топиц__</em> од <em>__усер_би__</em>","Room_has_been_deleted":"Соба је избрисана","Room_Info":"соба информације","Room_name_changed":"Назив собе промењен у: <em>__room_name__</em> променио/ла <em>__user_by__</em>","Room_name_changed_successfully":"Име собе успешно промењено","Room_not_found":"Соба није пронађен","Room_topic_changed_successfully":"Соба тема је успешно промењен","Room_type_changed_successfully":"врста собе успешно промењен","Room_unarchived":"соба неархивирано","Room_uploaded_file_list":"files лист","Room_uploaded_file_list_empty":"Но фајлови производа.","room_user_count":"% с корисника","Rooms":"Собе","S_new_messages_since_s":"% с нових порука од% с","SAML":"САМЛ","SAML_Custom_Cert":"цустом Сертификат","SAML_Custom_Entry_point":"Цустом Ентри Поинт","SAML_Custom_Generate_Username":"генерисати име","SAML_Custom_Issuer":"цустом Издавач","SAML_Custom_Provider":"цустом провајдера","Save":"Сачувај","Save_changes":"Сачувај измене","Save_Mobile_Bandwidth":"Саве Мобилни Проток","Save_to_enable_this_action":"Саве то омогућили ову акцију","Saved":"saved","Saving":"Уштеда","Scope":"обим","Screen_Share":"екран Подели","Script_Enabled":"сцрипт Омогућено","Search":"Претрага","Search_by_username":"Претрага по корисничком имену","Search_Channels":"Сеарцх Цханнелс","Search_Direct_Messages":"Тражи директне поруке","Search_Messages":"Сеарцх Мессагес","Search_Private_Groups":"Тражи приватних група","Search_settings":"Сеарцх сеттингс","seconds":"секунде","See_all":"Погледај све","See_only_online":"Само на мрежи","Select_a_department":"Изаберите одељење","Select_an_avatar":"Изабери аватара","Select_file":"Изабери датотеку","Select_service_to_login":"Изаберите сервис за пријаву за учитавање слике или поставите једну директно са рачунара","Select_user":"Избор корисника","Select_users":"Избор корисника","Selected_agents":"Изабрани агенти","Selected_users":"Изабрани чланови","Send":"послати","Send_a_message":"Пошаљи поруку","Send_a_test_mail_to_my_user":"Послати тест поруку на моју корисника","Send_a_test_push_to_my_user":"Пошаљите тест притисни за мој корисника","Send_confirmation_email":"Пошаљи потврдну поруку","Send_data_into_RocketChat_in_realtime":"Слање података у Роцкет.Цхат у реалном времену.","Send_email":"Шаљи имејл","Send_invitation_email":"Пошаљи позивницу емаил","Send_invitation_email_error":"Ви нису пружили никакву валидну емаил адресу.","Send_invitation_email_info":"Можете послати позивнице више емаил одједном.","Send_invitation_email_success":"Успешно сте послали позивницу емаил на следеће адресе:","Send_invitation_email_warning":"Да бисте слали позивнице е-поште, прво морате да конфигуришете СМТП подешавања.","Send_Message":"Пошаљи поруку","Send_your_JSON_payloads_to_this_URL":"Пошаљите своје ЈСОН корисних за овај УРЛ.","Sending":"Сендинг ...","Set_as_moderator":"Сет ас модератор","Set_as_owner":"Постави као власник","Settings":"Подешавања","Settings_updated":"Подешавања су ажурирана","Should_be_a_URL_of_an_image":"Треба да буде УРЛ слике.","Should_exists_a_user_with_this_username":"Корисник мора да већ постоје.","Show_all":"Покажи све","Show_more":"схов море","Show_only_online":"Схов сети","Show_preregistration_form":"Показују образац пре-регистрације","Showing_archived_results":"<p> <b>Показујући% с</b> архивиране резултате </p>","Showing_online_users":"Приказујем <b>__total_showing__</b> од __total__ корисника","Showing_results":"<p>Приказујем <b>%s</b> резултата</p>","Silence":"Утишај","since_creation":"пре %s","Site_Name":"Назив сајт","Site_Url":"сите УРЛ","Site_Url_Description":"Пример: хттпс://цхат.домаин.цом/","Skip":"прескочити","Smileys_and_People":"Смилеис и људи","SMTP":"СМТП","SMTP_Host":"СМТП Хост","SMTP_Password":"СМТП лозинка","SMTP_Port":"СМТП порт","SMTP_Test_Button":"Тест СМТП подешавања","SMTP_Username":"СМТП име","Sound":"звук","Star_Message":"стар порука","Starred_Messages":"Поруке са звездицом","Start_audio_call":"Старт аудио позив","Start_Chat":"Почетак Чат","Start_of_conversation":"Почетак разговора","Start_OTR":"старт ОТР","Start_video_call":"Старт видео позив","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Почните са <code class=\"inline\">%s</code> за корисника или <code class=\"inline\">%s</code> за канал. Нпр: <code class=\"inline\">%s</code> или <code class=\"inline\">%s</code>","Statistics":"статистика","Stats_Active_Users":"Активни корисници","Stats_Avg_Channel_Users":"Просек на каналу корисника","Stats_Avg_Private_Group_Users":"Просечно Привате Гроуп корисника","Stats_Away_Users":"даље корисника","Stats_Max_Room_Users":"Мак Собе корисника","Stats_Non_Active_Users":"неактивних корисника","Stats_Offline_Users":"Ван корисника","Stats_Online_Users":"Онлине Усерс","Stats_Total_Channels":"Укупно канала","Stats_Total_Direct_Messages":"Укупне директне поруке соба","Stats_Total_Messages":"Укупно порука","Stats_Total_Private_Groups":"Укупно Приватни Групе","Stats_Total_Rooms":"Укупан број соба","Stats_Total_Users":"Укупно корисника","Stop_Recording":"стоп снимања","strike":"штрајк","Subject":"тема","Submit":"Пошаљи","Success":"успех","Survey":"Анкета","Survey_instructions":"Рате свако питање по својој задовољство, 1 значи да су потпуно незадовољни и 5 значи да сте потпуно задовољни.","Symbols":"simboli","Sync_success":"синц успех","Sync_Users":"Синц корисника","Test_Connection":"тест везе","Test_Desktop_Notifications":"Тест Десктоп Обавештења","Thank_you_for_your_feedback":"Хвала на повратним информацијама","The_application_name_is_required":"Име апликације је потребно","The_channel_name_is_required":"Име канала је потребно","The_emails_are_being_sent":"Е-маил поруке се шаљу.","The_field_is_required":"је обавезно поље% с.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Ресизе слика неће радити, јер не можемо открити ИмагеМагицк или грапхицсмагицк инсталиран на вашем серверу.","The_redirectUri_is_required":"РедирецтУри је потребна","The_server_will_restart_in_s_seconds":"Сервер ће се поново покренути у% с секунди","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Поставка% с</strong> конфигурисан <strong>да% с</strong> и приступате <strong>из% с!</strong>","The_user_will_be_removed_from_s":"Корисник ће бити уклоњен из% с","The_user_wont_be_able_to_type_in_s":"Корисник неће бити у могућности да уносите у% с","Theme":"тема","theme-color-action-buttons-color":"Акције дугмад Боја","theme-color-active-channel-background-color":"Активан канал Боја позадине","theme-color-active-channel-font-color":"Активан канал Боја фонта","theme-color-blockquote-background":"Блоцккуоте Боја позадине","theme-color-clean-buttons-color":"Цлеан дугмад Боја","theme-color-code-background":"Код Боја позадине","theme-color-code-border":"Код Боја оквира","theme-color-code-color":"шифра Боја","theme-color-content-background-color":"Садржај Боја позадине","theme-color-custom-scrollbar-color":"Цустом Сцроллбар Боја","theme-color-info-active-font-color":"Активан подаци Боја фонта","theme-color-info-font-color":"Инфо Боја фонта","theme-color-input-font-color":"Инпут Боја фонта","theme-color-link-font-color":"Линк Боја фонта","theme-color-message-hover-background-color":"Порука Ховер БГ Боја","theme-color-primary-background-color":"Примарна Боја позадине","theme-color-primary-font-color":"Примарна Боја фонта","theme-color-quaternary-font-color":"Квартар Боја фонта","theme-color-secondary-background-color":"Секундарна Боја позадине","theme-color-secondary-font-color":"Секундарна Боја фонта","theme-color-smallprint-font-color":"Мали Штампа Боја фонта","theme-color-smallprint-hover-color":"Мали Штампа Ховер Боја","theme-color-status-away":"Гост статус Боја","theme-color-status-busy":"Буси статус Боја","theme-color-status-offline":"Оффлине статус Боја","theme-color-status-online":"Онлине статус Боја","theme-color-tertiary-background-color":"Терцијарни Боја позадине","theme-color-tertiary-font-color":"Терцијарни Боја фонта","theme-color-unread-notification-color":"Непрочитану Обавештења Боја","theme-custom-css":"цустом ЦСС","There_are_no_agents_added_to_this_department_yet":"Нема додају у овом одељењу још агенти.","There_are_no_integrations":"Нема интеграције","There_are_no_users_in_this_role":"Нема корисника у овој улози.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ова адреса је већ коришћен и није потврђена. Молимо Вас да промените лозинку.","This_is_a_desktop_notification":"Ово је обавештење десктоп","This_is_a_push_test_messsage":"Ово је гурање теста Месссаге","Time_in_seconds":"Време у секундама","Title_bar_color":"Титле бар боја","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Да бисте инсталирали Роцкет.Цхат ливеЦхат у вашем сајту, цопи & пасте овај код изнад задњег <strong></ боди></strong> на свом сајту.","To_users":"korisnicima","Topic":"тема","Travel_and_Places":"Травел & Плацес","Trigger_removed":"триггер уклоњена","Trigger_Words":"Триггер вордс","Triggers":"окидачи","True":"Истина","Type":"Тип","Type_your_new_password":"Унесите нову лозинку","Unarchive":"Деархивирај","Unmute_someone_in_room":"Унмуте неко у соби","Unmute_user":"Укључи звук корисника","Unnamed":"неименован","Unpin_Message":"Откачи порука","Unread_Rooms":"unread соба","Unread_Rooms_Mode":"Унреад соба режим","Unstar_Message":"ремове Стар","Upload_file_question":"Отпреми датотеку?","Uploading_file":"Отпремање датотеке ...","Use_account_preference":"Користе налог предност","Use_Emojis":"Користите емоџија","Use_initials_avatar":"Користи иницијале корисничког","use_menu":"Користите бочну површ за приступи вашим собама и ћаскањима","Use_service_avatar":"Користи аватар %s ","Use_this_username":"Користи ово корисничко име","Use_uploaded_avatar":"Користи отпремљеног аватара","Use_url_for_avatar":"Користи УРЛ за аватар","User__username__is_now_a_moderator_of__room_name_":"Корисник __усернаме__ је сада модератор за __роом_наме__","User__username__is_now_a_owner_of__room_name_":"Корисник __усернаме__ је сада власник __роом_наме__","User__username__removed_from__room_name__moderators":"Корисник __усернаме__ уклоњен из модератори __роом_наме__","User__username__removed_from__room_name__owners":"Корисник __усернаме__ уклоњен из __роом_наме__ власницима","User_added":"Корисник/ца додат(а)","User_added_by":"Корисник/ца <em>__user_added__</em> је додат(а) од стране <em>__user_by__</em>.","User_added_successfully":"Корисник је успешно додат","User_Channels":"усер Канали","User_doesnt_exist":"Нема корисника постоји под именом `@% с`.","User_has_been_activated":"Корисник је активиран","User_has_been_deactivated":"Корисник је деактивиран","User_has_been_deleted":"Корисник је избрисан","User_has_been_muted_in_s":"Корисник је искључен у% с","User_has_been_removed_from_s":"Корисник је уклоњен из% с","User_has_disconnected":"Корисник је искључен","User_Info":"podaci о кориснику","User_is_no_longer_an_admin":"Корисник више није админ","User_is_not_activated":"Корисник није активиран","User_is_now_an_admin":"Корисник је сада Администратор","User_joined_channel":"Се придружио канал.","User_joined_channel_female":"Се придружио канал.","User_joined_channel_male":"Се придружио канал.","User_left":"је напустио/ла канал.","User_left_female":"Је напустио канал.","User_left_male":"Је напустио канал.","User_logged_out":"Корисник је одјављен","User_management":"Управљање корисницима","User_muted_by":"Корисник <em>__усер_мутед__</em> искључен од <em>__усер_би__.</em>","User_muted_in_room":"Корисник искључен у соби","User_not_found":"Корисник није пронађен","User_not_found_or_incorrect_password":"Корисник није пронађен или нетачно лозинка","User_or_channel_name":"Корисник или канал име","User_removed":"Корисник је уклонио","User_removed_by":"Корисник/ца <em>__user_removed__</em> је уклоњен од стране <em>__user_by__</em>.","User_removed_from_room":"Корисник је уклоњен из собе","User_Settings":"Усер Сеттингс","User_unmuted_by":"Корисник <em>__усер_унмутед__</em> демутиран од <em>__усер_би__.</em>","User_unmuted_in_room":"Корисник демутиран у соби","User_updated_successfully":"Корисник успешно ажурирана","Username":"Корисничко име","Username_and_message_must_not_be_empty":"Корисничко име и порука не сме бити празна.","Username_cant_be_empty":"Корисничко име не може бити празно","Username_Change_Disabled":"Ваш Роцкет.Цхат Администратор је онемогућио промену корисничких имена","Username_denied_the_OTR_session":"__усернаме__ негирао ОТР сесију","Username_description":"Корисничко име се користи да би други могли да вас спомињу у порукама.","Username_doesnt_exist":"Корисничко име `% с` не постоји.","Username_ended_the_OTR_session":"__усернаме__ завршио ОТР сесију","Username_invalid":"<strong>%s</strong> није исправно корисничко име,<br/> користите само слова, бројеве, тачке и повлаке","Username_is_already_in_here":"`@% С` је већ овде.","Username_is_not_in_this_room":"Корисник `#% с` није у овој соби.","Username_not_found":"Корисничко име није пронађено","Username_title":"Направите корисничко име","Username_unavaliable":"<strong>%s</strong> је већ у употреби :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__усернаме__ жели да почне ОТР. Да ли желите да прихватите?","Users":"усерс","Users_in_role":"Корисници у улози","UTF8_Names_Slugify":"УТФ8 имена Слугифи","UTF8_Names_Validation":"УТФ8 имена Провера","UTF8_Names_Validation_Description":"Не дозволите да специјалне карактере и размаке. Можете користити - _ и. али не на крај имена","Verification_email_sent":"Верификацију послат","View_All":"Погледај све","View_Logs":"Погледај протоколе","Visibility":"видљивост","Visible":"видљив","Visitor":"посетилац","Visitor_page_URL":"Посетилац веб страница","Visitor_time_on_site":"Посетилац време на сајту","Wait_activation_warning":"Пре него што се пријавите, ваш налог мора да буде ручно активиран од стране администратора.","We_are_offline_Sorry_for_the_inconvenience":"Ми смо онлине. Жао због непријатности.","We_have_sent_password_email":"Послали смо вам поруку на вашу е-адресу са упутством за поновно постављање лозинке. Ако не добијете поруку ускоро, вратите се и пробајте поново.","We_have_sent_registration_email":"Послали смо вам поруку на вашу е-адресу да бисте потврдили налог. Ако не добијете поруку ускоро, вратите се и пробајте поново.","WebRTC_Enable_Channel":"Омогући за јавним каналима","WebRTC_Enable_Direct":"Омогући за директне поруке","WebRTC_Enable_Private":"Омогући за приватним каналима","WebRTC_Servers":"СТУН / ТУРН Сервери","WebRTC_Servers_Description":"Листа СТУН и ТУРН сервера раздвојених зарезом. <br/> Корисничко име, лозинка и лука су дозвољени у формату `усернаме: пассворд @ омамљивање: домаћин: порт` или` корисничко име: лозинка @ ред: Хост: порт`.","Welcome":"Добродошли <em>%s</em>.","Welcome_to_the":"Добродошли у","will_be_able_to":"ће моћи да","With_whom":"Са ким","Yes":"да","Yes_clear_all":"Да, јасно све!","Yes_delete_it":"Да, избришите га!","Yes_hide_it":"Да, сакрити!","Yes_leave_it":"Да, остави га!","Yes_mute_user":"Да, нем корисник!","Yes_remove_user":"Да, уклонити корисника!","you_are_in_preview_mode_of":"Ви сте у режиму прегледа од канала # <strong>__роом_наме__</strong>","You_are_logged_in_as":"Пријављени сте као","You_are_not_authorized_to_view_this_page":"Нисте ауторизовани да видите ову страницу.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Ви сте последњи власник. Молимо поставите новог власника пре него што напусти просторију.","You_can_change_a_different_avatar_too":"Можете премостити аватар користити за постављање из ове интеграције.","You_can_use_an_emoji_as_avatar":"Такође можете да користите емотикона као аватар.","You_have_been_muted":"Ви сте искључен и не може говорити у овој соби","You_have_not_verified_your_email":"Нисте потврдили своју е-пошту.","You_have_successfully_unsubscribed":"Успешно сте пријаву на наше Маиллинг Лист.","You_informed_an_invalid_FROM_address":"обавестили сте инвалид ОД адресу.","You_must_provide_the_unsubscribe_link":"Морате навести [унсубсцрибе] линк.","You_need_confirm_email":"Потребно је да потврдите е-адресу да бисте се пријавили!","You_need_install_an_extension_to_allow_screen_sharing":"Треба ти инсталирати продужење како би дељење екрана","You_need_to_change_your_password":"Потребно је да промените лозинку","You_need_to_type_in_your_password_in_order_to_do_this":"Потребно је да унесете лозинку како би урадили!","You_need_to_type_in_your_username_in_order_to_do_this":"Потребно је да унесете своје корисничко име, како би то урадили!","You_need_to_verifiy_your_email_address_to_get_notications":"Потребно је да верифии Вашу емаил адресу и добијали обавештења","You_should_name_it_to_easily_manage_your_integrations":"Требало би име је да лако управљате интеграције.","You_will_not_be_able_to_recover":"Нећете моћи да се опорави ову поруку!","You_will_not_be_able_to_recover_file":"Нећете моћи да се опорави овај фајл!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Нећете добити обавештења поште јер нисте потврдили своју е-маил.","Your_email_has_been_queued_for_sending":"Ваша емаил је на чекању за слање","Your_entry_has_been_deleted":"Ваш унос је обрисан.","Your_file_has_been_deleted":"Ваша датотека је обрисана.","Your_mail_was_sent_to_s":"Ваш маил је послат на% с","Your_Open_Source_solution":"Ваше сопствено отворено решење за ћаскање","Your_password_is_wrong":"Ваша лозинка није у реду!","Your_push_was_sent_to_s_devices":"Ваш притиском је послат на% с уређајима"});
TAPi18n._registerServerTranslator("sr", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/sv.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["sv"] = ["Swedish","Svenska"];                                                                 // 8
if(_.isUndefined(TAPi18n.translations["sv"])) {                                                                        // 9
  TAPi18n.translations["sv"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["sv"][namespace])) {                                                             // 13
  TAPi18n.translations["sv"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["sv"][namespace], {"500":"internt serverfel","0_Errors_Only":"Endast fel - 0","1_Errors_and_Information":"1 - Fel och information","2_Erros_Information_and_Debug":"2 - erros, information och felsöknings","__username__was_set__role__by__user_by_":"__username__ sattes __role__ genom __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ är inte längre __role__, genom __user_by__","Access_not_authorized":"Tillgång som inte godkänts","Access_online_demo":"Gå till onlinedemo","Access_Online_Demo":"Gå till onlinedemo","Access_Token_URL":"Tillgång Token URL","Accounts":"Konton","Accounts_AllowDeleteOwnAccount":"Tillåt användare att radera egna konton","Accounts_AllowedDomainsList":"Tillåtet Domäner Lista","Accounts_AllowedDomainsList_Description":"Kommaseparerad list över tillåtna domäner","Accounts_AllowEmailChange":"Tillåt byte av e-postadress","Accounts_AllowPasswordChange":"Tillåt byte av lösenord","Accounts_AllowUserAvatarChange":"Tillåt byte av användaravatar","Accounts_AllowUsernameChange":"Tillåt användarnamn byte","Accounts_AllowUserProfileChange":"Tillåt byte av användarprofil","Accounts_AvatarResize":"Ändra storlek på avatarer","Accounts_AvatarSize":"Storlek på avatar","Accounts_AvatarStorePath":"Avatar Storage Path","Accounts_AvatarStoreType":"Avatar Storage Type","Accounts_BlockedDomainsList":"Blockerade domäner Lista","Accounts_BlockedDomainsList_Description":"Kommaseparerad lista över blockerade domäner","Accounts_denyUnverifiedEmail":"Neka okontrollerade e-postadresser","Accounts_EmailVerification":"E-postverifiering","Accounts_EmailVerification_Description":"Se till att du har korrekta SMTP-inställningar för att använda denna funktion","Accounts_Enrollment_Email":"Inskrivning E-post","Accounts_Enrollment_Email_Description":"Du kan använda [namn], [fname], [lname] för användarens fullständiga namn, förnamn eller efternamn, respektive. <br /> Du kan använda [email] för användarens e-post.","Accounts_Iframe_api_method":"api Metod","Accounts_Iframe_api_url":"api webbadress","Accounts_iframe_enabled":"Aktiverad","Accounts_iframe_url":"iframe Url","Accounts_LoginExpiration":"Logga Utgångs i dagar","Accounts_ManuallyApproveNewUsers":"Godkänn nya användare manuellt","Accounts_OAuth_Custom_Token_Sent_Via":"Token Sent Via","Accounts_OAuth_Custom_Authorize_Path":"tillåta Path","Accounts_OAuth_Custom_Button_Color":"knappfärg","Accounts_OAuth_Custom_Button_Label_Color":"Knapp Textfärg","Accounts_OAuth_Custom_Button_Label_Text":"Button Text","Accounts_OAuth_Custom_Enable":"Aktivera","Accounts_OAuth_Custom_id":"ID","Accounts_OAuth_Custom_Identity_Path":"identitet Path","Accounts_OAuth_Custom_Login_Style":"Logga in Style","Accounts_OAuth_Custom_Secret":"Hemlighet","Accounts_OAuth_Custom_Token_Path":"token Path","Accounts_OAuth_Custom_URL":"Webbadress","Accounts_OAuth_Facebook":"Facebook-inloggning","Accounts_OAuth_Facebook_callback_url":"Facebook Callback URL","Accounts_OAuth_Facebook_id":"Facebook App-ID","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"OAuth Aktiverad","Accounts_OAuth_Github_callback_url":"Github återuppringning URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Enterprise återuppringning URL","Accounts_OAuth_GitHub_Enterprise_id":"klient-ID","Accounts_OAuth_Github_id":"Klient-ID","Accounts_OAuth_Github_secret":"Klient Secret","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"GitLab återuppringning URL","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"klienthemligheten","Accounts_OAuth_Google":"Google-inloggning","Accounts_OAuth_Google_callback_url":"Google återuppringning URL","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google Secret","Accounts_OAuth_Linkedin":"LinkedIn-inloggning","Accounts_OAuth_Linkedin_callback_url":"Edin återuppringning URL","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Secret","Accounts_OAuth_Meteor":"Meteor-inloggning","Accounts_OAuth_Meteor_callback_url":"Meteor återuppringning URL","Accounts_OAuth_Meteor_id":"Meteor-Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter-inloggning","Accounts_OAuth_Twitter_callback_url":"Twitter Callback URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"Word Login","Accounts_OAuth_Wordpress_callback_url":"Wordpress återuppringning URL","Accounts_OAuth_Wordpress_id":"Word Id","Accounts_OAuth_Wordpress_secret":"Word Secret","Accounts_PasswordReset":"Nollställ lösenord","Accounts_Registration_AuthenticationServices_Enabled":"Registrering Authentication Services","Accounts_RegistrationForm":"Registreringsformulär","Accounts_RegistrationForm_Disabled":"Inaktiverad","Accounts_RegistrationForm_LinkReplacementText":"Anmälningsblankett Link Ersättnings Text","Accounts_RegistrationForm_Public":"Offentlig","Accounts_RegistrationForm_Secret_URL":"hemliga URL","Accounts_RegistrationForm_SecretURL":"Anmälningsblankett Secret URL","Accounts_RegistrationForm_SecretURL_Description":"Du måste ange en slumpmässig sträng som kommer att läggas till din registrering URL. Exempel: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Registrering krävs","Accounts_RequireNameForSignUp":"Kräv namn för registrering","Accounts_ShowFormLogin":"Visa form baserade logga","Accounts_UseDefaultBlockedDomainsList":"Använd standard Blockerad domäner Lista","Accounts_UseDNSDomainCheck":"Använd DNS Domain Check","Activate":"Aktivera","Activity":"Aktivitet","Add":"Lägg till","Add_agent":"lägga agent","Add_custom_oauth":"Lägg till anpassad oauth","Add_manager":"Lägg manager","Add_Members":"Lägg till medlemmar","Add_User":"Lägg till användare","Add_user":"Lägg till användare","Add_users":"Lägg till användare","Additional_emails":"Ytterligare e-post","Additional_Feedback":"Ytterligare feedback","Administration":"Administrering","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Efter OAuth2 autentisering, kommer användarna att omdirigeras till den här webbadressen","Agent_added":"medel som tillsätts","Agent_removed":"medlet avlägsnades","Alias":"Alias","All":"Alla","All_channels":"Alla kanaler","All_logs":"alla loggar","All_messages":"Alla meddelanden","Allow_Invalid_SelfSigned_Certs":"Tillåt Ogiltig självsignerat Cert","Allow_Invalid_SelfSigned_Certs_Description":"Tillåt ogiltiga och självsignerade SSL-certifikat är för länk validering och förhandsvisningar.","and":"och","And_more":"Och mer __length __...","Animals_and_Nature":"Djur & natur","API":"API","API_Analytics":"Analytics","API_Embed":"Inbäddad","API_EmbedDisabledFor":"Inaktivera Bädda för användare","API_EmbedDisabledFor_Description":"Kommaseparerad lista över användarnamn","API_GitHub_Enterprise_URL":"serveradress","API_GitHub_Enterprise_URL_Description":"Exempel: http://domain.com (exklusive snedstreck)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"Wordpress URL","Appearance":"Utseende","Application_added":"Applikation tillagd","Application_Name":"Applikationsnamn","Application_updated":"Application uppdaterad","Apply_and_refresh_all_clients":"Tillämpa och uppdatera alla klienter","Archive":"arkiv","Archive_Unarchive":"Arkiv / Hämta från arkiv","are_also_typing":"skriver också","are_typing":"skriver","Are_you_sure":"Är du säker?","Are_you_sure_you_want_to_delete_your_account":"Är du säker att du vill radera ditt konto?","Authorization_URL":"URL-auktorisering","Authorize":"Godkänn","AutoLinker_StripPrefix":"AutoLinker Strip Prefix","AutoLinker_StripPrefix_Description":"Kort. t.ex. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL reguljärt uttryck","AutoLinker_Email":"AutoLinker E","AutoLinker_Phone":"AutoLinker Phone","AutoLinker_Phone_Description":"Automatiskt kopplade till telefonnummer. t.ex. `(123) 456-7890`","Auto_Load_Images":"Ladda bilder automatiskt","Available":"Tillgängliga","Available_agents":"tillgängliga medel","Avatar":"Avatar","Avatar_changed_successfully":"Avataren har ändrats","Avatar_URL":"Webbadress för avatar","Avatar_url_invalid_or_error":"Denna webbadress är ogiltig eller inte tillgänglig. Försök igen, men med en annan webbadress.","away":"borta","Away":"Borta","away_female":"borta","Away_female":"Borta","away_male":"borta","Away_male":"Borta","Back":"Tillbaka","Back_to_applications":"Tillbaka till applikationer","Back_to_integrations":"Tillbaka till integrationer","Back_to_login":"Tillbaka till inloggningen","Back_to_permissions":"Tillbaka till tillstånd","Body":"Kropp","bold":"fetstil","busy":"upptagen","Busy":"Upptagen","busy_female":"upptagen","Busy_female":"Upptagen","busy_male":"upptagen","Busy_male":"Upptagen","Cancel":"Avbryt","Cannot_delete_a_protected_role":"Det går inte att radera en skyddad roll","Cannot_delete_role_because_its_in_use":"Det går inte att radera rollen eftersom den används","Cannot_invite_users_to_direct_rooms":"Det går inte att bjuda in användare att styra rum","CDN_PREFIX":"CDN Prefix","Certificates_and_Keys":"Certifikat och nycklar","Channel":"Kanal","Channel_doesnt_exist":"Kanalen `#%s`existerar inte.","Channels":"Kanaler","Channels_list":"Lista över offentliga kanaler","Chat_Rooms":"Chattrum","Chatops_Enabled":"aktivera Chatops","Chatops_Title":"Chatops Panel","Chatops_Username":"Chatops Användarnamn","Choose_a_room":"Välj ett rum","Choose_messages":"Välj meddelanden ","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Välj alias som ska visas före användarnamnet i meddelanden.","Choose_the_username_that_this_integration_will_post_as":"Välj det användarnamn som denna integration kommer att lägga upp som.","Clear_all_unreads_question":"Rensa alla olästa?","Client_ID":"kund-ID","Client_Secret":"klienthemligheten","Clients_will_refresh_in_a_few_seconds":"Kunderna kommer uppdateras inom några sekunder","close":"stäng","Closed":"Stängd","Collapse_Embedded_Media_By_Default":"Kollapsa inbäddade medier som standard","coming_soon":"kommer snart","Commands":"Kommandon","Compact_View":"Kompakt Vy","Confirm_password":"Bekräfta ditt lösenord","Contact":"Kontakta","Conversation":"Konversation","Convert_Ascii_Emojis":"Konvertera ASCII till Emoji","Copied":"kopieras","COPY_TO_CLIPBOARD":"Kopiera till Urklipp","Copy_to_clipboard":"Kopiera till urklipp","Count":"Räkna","Create":"Skapa","Create_new":"Skapa ny","Created_at":"Skapad ","Created_at_s_by_s":"Skapad vid <strong>%s</strong> av <strong>%s</strong>","Custom_Fields":"Anpassade fält","Custom_oauth_helper":"När du ställer in din OAuth leverantör, måste du informera en återuppringning webbadress. Användning <pre> %s </pre> .","Custom_oauth_unique_name":"Anpassad oauth unikt namn","Custom_Script_Logged_In":"Custom Script för inloggade användare","Custom_Script_Logged_Out":"Custom Script för utloggade användare","Dashboard":"instrumentbräda","days":"dagar","Deactivate":"Inaktivera","Debug_Level":"debug nivå","Default":"Standard","Delete":"Radera","Delete_my_account":"Radera mitt konto","Delete_Room_Warning":"Om man raderar ett rum, raderas alla postade meddelanden i det rummet. Denna åtgärd kan inte ångras.","Delete_User_Warning":"Radering av en användare kommer att radera alla meddelanden från den användaren. Detta kan inte göras ogjort.","Deleted":"Borttaget!","Department_not_found":"Avdelning inte hittad","Department_removed":"Avdelning borttagen","Departments":"Avdelningar","Description":"Beskrivning","Desktop":"Skrivbord","Desktop_Notification_Test":"Desktop notifierings test","Desktop_Notifications":"Skrivbordsnotifieringar","Desktop_Notifications_Disabled":"Skrivbordsnotifieringar är inaktiverade. Ändra dina webbläsarinställningar om du vill aktivera notifieringar","Desktop_Notifications_Enabled":"Skrivbordsnotifieringar är aktiverade.","Direct_message_someone":"Direktmeddelande någon","Direct_Messages":"Direktmeddelanden","Direct_Messages_list":"Direkt Meddelanden ","Disable_Favorite_Rooms":"Inaktivera favoriter","Disable_New_Message_Notification":"Avaktivera notifiering för nytt meddelande","Disable_New_Room_Notification":"Avaktivera notifiering för nytt rum ","Displays_action_text":"Displayer Texten","Do_you_want_to_change_to_s_question":"Vill du ändra till <strong>%s</strong>?","Drop_to_upload_file":"Släpp för att ladda upp filen","Dry_run":"Torrkörning","Dry_run_description":"Kommer endast att skicka ett e-postmeddelande, till samma adress som i Från. E-postadressen måste höra till en giltig användare.","Duplicate_archived_channel_name":"En arkiverad kanal med namnet '%s' existerar","Duplicate_archived_private_group_name":"En arkiverad privat grupp med namnet '%s' existerar.","Duplicate_private_group_name":"En privat grupp med namnet \\\"%s\\\" existerar redan","E-mail":"E-post","Edit":"Redigera","Edit_Custom_Field":"Redigera anpassat fält","Edit_Department":"Redigera avdelning","edited":"redigerad","Email":"E-post","Email_already_exists":"E-postadressen finns redan","Email_body":"E-post kropp","Email_Change_Disabled":"Din Rocket.Chatadministratör har inaktiverat möjligheten att byta e-postadress","Email_from":"Från","Email_Notification_Mode":"Offline Email Notifieringar","Email_Notification_Mode_All":"Alla Omnämningar/Direktmeddelanden ","Email_Notification_Mode_Disabled":"Inaktiverad","Email_or_username":"Epost eller användarnamn","Email_subject":"Ämne","Email_verified":"E-post verifierad","Emoji":"Emoji","Empty_title":"Tom titel","Enable":"Aktivera","Enable_Desktop_Notifications":"Aktivera skrivbordsnotifieringar","Enabled":"Aktiverad","Encrypted_message":"Krypterat meddelande","End_OTR":"änden OTR","Enter_a_regex":"Ange en regex","Enter_a_room_name":"In i ett rum namn","Enter_a_username":"Skriv ett användarnamn","Enter_info":"Fyll i dina uppgifter","Enter_name_here":"Ange namn här","Enter_to":"Enter för att","Error":"Fel","error-cant-invite-for-direct-room":"Det går inte att bjuda in användare till direkta rum","error-duplicate-channel-name":"En kanal med namnet \\\"%s\\\" existerar redan","error-invalid-custom-field":"Ogiltigt anpassat fält","error-invalid-custom-field-name":"Ogiltig anpassad fältnamn. Använd endast bokstäver, siffror, bindestreck och understreck.","error-invalid-password":"Felaktigt lösenord","error-invalid-room":"ogiltig room","error-invalid-room-name":"<strong> %s</strong> är inte ett giltigt rumsnamn, <br/> Använd endast bokstäver, siffror, bindestreck och understreck","error-invalid-user":"Ogiltig användare","error-invalid-username":"Ogiltigt användarnamn","error-not-allowed":"Inte tillåtet","error-not-authorized":"ej tillåtet","error-remove-last-owner":"Detta är den sista ägaren. Ställ in en ny ägare innan du tar bort detta.","error-role-name-required":"Roll namn krävs","error-user-not-in-room":"Användaren är inte i det här rummet","Error_changing_password":"Fel vid byte av lösenord","Error_sending_confirmation_email":"Fel att skicka e-postbekräftelse","Error_too_many_requests":"Varning, för många förfrågningar. Sakta ned. Du måste vänta %s sekunder innan du kan prova igen.","Esc_to":"Esc för","Example_s":"Exempel: <code class=\"inline\">%s</code>","False":"Falskt","Favorites":"Favoriter","Field":"Fält","Field_removed":"fältet avlägsnas","File_exceeds_allowed_size_of_bytes":"Filen överskrider tillåten storlek __size__ bytes","FileUpload":"Filuppladdning","FileUpload_Enabled":"Filuppladdningar aktiverade","FileUpload_File_Empty":"fil tom","FileUpload_FileSystemPath":"systemet Path","FileUpload_MaxFileSize":"Maximal filstorlek för uppladdning (i bytes)","FileUpload_MediaType_NotAccepted":"Icke accepterade mediatyper","FileUpload_MediaTypeWhiteList":"Accepterade mediatyper","FileUpload_MediaTypeWhiteListDescription":"Kommaseparerad lista över mediatyper. Lämna tomt för att acceptera alla mediatyper.","FileUpload_ProtectFiles":"Skydda uppladdade filer","FileUpload_ProtectFilesDescription":"Endast behöriga användare får tillgång","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket namnet","FileUpload_S3_BucketURL":"bucket URL","FileUpload_S3_CDN":"CDN domän för nedladdningar","FileUpload_S3_Region":"Område","FileUpload_Storage_Type":"lagring Typ","Flags":"flags","Follow_social_profiles":"Följ våra sociala mediakonton, forka oss på github och dela med dig av dina tankar om rocket.chatt på vår trello.","Food_and_Drink":"Mat & Dryck","For_your_security_you_must_re_enter_your_password_to_continue":"För din säkerhet måste du ange ditt lösenord igen för att fortsätta","Force_SSL":"force SSL","Force_SSL_Description":"* OBS! * _Force SSL_ ska aldrig användas med reverse proxy. Om du har en omvänd proxy, bör du göra omdirigeringen DET. Det här alternativet finns för installationer som Heroku, som inte tillåter konfiguration omdirigeringen på den omvända proxyservern.","Forgot_password":"Glömt ditt lösenord?","Fork_it_on_github":"Forka det på github","Frequently_Used":"Vanliga Används","From":"Från","From_Email":"Från e-postadress","From_email_is_required":"Från e-post krävs","From_email_warning":"<b>Varning:</b> Fältet <b>Från</b> är föremål för e-postserverinställningar.","General":"Allmänt","Get_to_know_the_team":"Lär känna teamet bakom Rocket.Chat","github_no_public_email":"Du har inte någon publik epost i ditt GitHub-konto","Give_a_unique_name_for_the_custom_oauth":"Ge ett unikt namn för den anpassade oauth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Ge applikationen ett namn. Detta kommer att ses av dina användare.","Global":"Global","GoogleTagManager_id":"Google Tagghanteraren Id","Has_more":"har mer","Have_your_own_chat":"Har din egen webbchatt. Utvecklad med Meteor.com är Rocket.Chat en bra lösning för utvecklare ser fram emot att bygga och utveckla sin egen chatt plattform.","Header":"Rubrik","Hidden":"Dolda","Hide_Group_Warning":"Är du säker att du vill dölja gruppen \"%s\"?","Hide_Private_Warning":"Är du säker att du vill dölja diskussionen med \"%s\"?","Hide_room":"Dölj rum","Hide_Room_Warning":"Är du säker att du vill dölja rummet \"%s\"?","Highlights":"Markeringar","Highlights_How_To":"För att bli meddelad när någon nämner ett ord eller en fras, lägg till ordet eller frasen här. Du kan separera ord eller fraser med kommatecken. Markerade ord är inte skiftlägeskänsliga.\n","Highlights_List":"Markera ord","History":"Historik","hours":"timmar","How_friendly_was_the_chat_agent":"Hur vänligt var chatten agent?","How_knowledgeable_was_the_chat_agent":"Hur kunnig var chatten agent?","How_responsive_was_the_chat_agent":"Hur reagerar var chatten agent?","How_satisfied_were_you_with_this_chat":"Hur nöjd var du med chatten?","If_you_are_sure_type_in_your_password":"Skriv ditt lösenord om du är säker:","If_you_are_sure_type_in_your_username":"Om du är säker på typ i ditt användarnamn:","Importer_Archived":"arkiveras","Importer_done":"Importering färdig!","Importer_finishing":"Avslutar importen.","Importer_From_Description":"Import __from __ 's data till Rocket.Chat.","Importer_import_cancelled":"Importering avbruten.","Importer_import_failed":"Ett fel uppstod under importen.","Importer_importing_channels":"Importerar kanalerna.","Importer_importing_messages":"Importerar meddelandena.","Importer_importing_started":"Startar importen.","Importer_importing_users":"Importerar användarna.","Importer_not_defined_properly":"Importören var inte korrekt definierade, det saknas Importera klassen.","Importer_not_in_progress":"Importören närvarande inte är igång.","Importer_Prepare_Restart_Import":"Starta om import","Importer_Prepare_Start_Import":"Börja importera","Importer_Prepare_Uncheck_Archived_Channels":"Avmarkera Arkiverade Kanaler","Importer_Prepare_Uncheck_Deleted_Users":"Avmarkera borttagna användare","Importer_progress_error":"Det gick inte att få framsteg för import.","Importer_setup_error":"Ett fel uppstod när inrätta importören.","Incorrect_Password":"Felaktigt lösenord","inline_code":"inline_kod","Install_Extension":"Installera tillägg","Install_FxOs":"Installera Rocket.Chat i Firefox","Install_FxOs_done":"Bra! Nu kan du använda Rocket.Chat via ikonen på startskärmen. Ha så kul med Rocket.Chat!","Install_FxOs_error":"Tyvärr, det där fungerade inte som det var tänkt! Följande fel dök upp:\n","Install_FxOs_follow_instructions":"Vänligen bekräfta appinstallationen på din enhet (klicka på \"Installera\" när det efterfrågas).","Installation":"Installation","Integration_added":"Integrationen har lagts","Integration_Incoming_WebHook":"Inkommande WebHook Integration","Integration_New":"Ny integrering","Integration_Outgoing_WebHook":"Utgående WebHook Integration","Integration_updated":"Integrationen har uppdaterats","Integrations":"Integreringar","Invalid_asset":"ogiltig tillgång","Invalid_confirm_pass":"Bekräftelsen matchar inte lösenordet","Invalid_email":"Den angivna epostadressen är ogiltig","Invalid_Export_File":"Filen laddas upp är inte en giltig %s exportfilen.","Invalid_file_height":"Felaktig filhöjd","Invalid_file_type":"Felaktig filtyp","Invalid_file_width":"Felaktig filbredd","Invalid_Import_File_Type":"Ogiltig Import filtyp.","Invalid_name":"Namnet får inte vara tomt","Invalid_notification_setting_s":"Felaktiga notifierings inställningar: %s","Invalid_pass":"Lösenordet får inte vara tomt","Invalid_room_name":"<strong>%s</strong> är inte ett giltigt rumsnamn,<br/> använd bara siffror, nummer och bindestreck","Invalid_room_type":"<strong> %s</strong> är inte en giltig rumstyp.","Invalid_Secret_URL":"Ogiltig Secret URL","Invalid_secret_URL_message":"Den angivna webbadressen är felaktig.","invisible":"osynlig","Invisible":"Osynlig","Invitation_HTML":"inbjudan HTML","Invitation_Subject":"inbjudan Ämne","Invite_user_to_join_channel":"Bjud in en användare till att ansluta till denna kanal.","Invite_Users":"Bjud in användare","is_also_typing":"skriver också","is_also_typing_female":"skriver också","is_also_typing_male":"skriver också","is_typing":"skriver","is_typing_female":"skriver","is_typing_male":"skriver","italics":"kursiv","join":"Gå med","Join_audio_call":"Gå med i ljudsamtal","Join_the_Community":"Gå med i communityt","Join_the_given_channel":"Gå med i den givna kanalen","Join_video_call":"Gå med i videosamtal","Joined":"Ansluten","Jump":"Hoppa","Jump_to_first_unread":"Hoppa till första olästa","Jump_to_message":"Hoppa till meddelande","Jump_to_recent_messages":"Hoppa till senaste meddelanden","Katex_Enabled":"Katex Enabled","Label":"Märka","Language":"Språk","Language_Version":"Svensk Version","Last_login":"Senaste inloggning","Last_message":"Senaste meddelande","Last_seen":"Senast sedd","Layout":"Layout","Layout_Home_Body":"Hem Body","Layout_Home_Title":"Hem Titel","Layout_Login_Terms":"inloggnings~~POS=TRUNC villkor~~POS=HEADCOMP","Layout_Privacy_Policy":"Integritetspolicy","Layout_Sidenav_Footer":"Navigeringen Footer","Layout_Sidenav_Footer_description":"Footerns storlek är 260 x 70px","Layout_Terms_of_Service":"Användarvillkor","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Anpassad Domain Search","LDAP_Custom_Domain_Search_Description":"En bit av JSON som styr binder och anslutningsinfo och har formen: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Standarddomän","LDAP_Description":"LDAP är en hierarkisk databas som många företag använder för att tillhandahålla enkel inloggning - en anläggning för att dela ett lösenord mellan flera webbplatser och tjänster. För avancerad konfiguration. information och exempel, kontakta vår wiki: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"domän Base","LDAP_Domain_Base_Description":"Den fullständiga unika namn (DN) på en LDAP träd som du vill söka efter användare och grupper. Du kan lägga till så många som du vill, emellertid måste definieras varje grupp i samma domän basen som de användare som hör till den. Om du anger begränsade användargrupper, kommer endast användare som tillhör dessa grupper vara i omfattning. Vi rekommenderar att du anger den översta nivån i LDAP-katalogträd som domänen bas och använda sökfunktionen filter för att kontrollera åtkomsten.","LDAP_Domain_Search_Filter":"Domän Filter","LDAP_Domain_Search_Filter_Description":"Om angivna endast användare som matchar detta filter kommer att tillåtas att logga in. Om inget filter anges kommer alla användare inom ramen för den angivna domänen bas kunna logga in. <br/> T.ex. för Active Directory `MEMBEROF = cn = ROCKET_CHAT, ou = General Groups`. <br/> T.ex. för OpenLDAP (extensible match ökning) `ou: DN: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Search kvalitetsklass","LDAP_Domain_Search_Object_Category_Description":"Den * objectcategory * som identifierar användarna. <br/> Lämna tomt för * OpenLDAP *. <br/> T.ex. `person`, etc.","LDAP_Domain_Search_Object_Class":"Domain Search Objektklass","LDAP_Domain_Search_Object_Class_Description":"Den * object * som identifierar användarna. <br/> T.ex. `organizationalPerson`, 'användare:,' inetOrgPerson`, etc.","LDAP_Domain_Search_Password":"Domän Sök Lösenord","LDAP_Domain_Search_Password_Description":"Lösenordet för domänen sökanvänd.","LDAP_Domain_Search_User":"Domän Sök användare","LDAP_Domain_Search_User_Description":"LDAP användare som utför användaruppslag att autentisera andra användare när de loggar in. <br/> Detta är typiskt ett servicekonto som skapats speciellt för tredjeparts integrationer. Använd ett fullständigt namn, såsom `cn = Administratör, cn = användare, dc = example, dc = com`.","LDAP_Domain_Search_User_ID":"Domain Search användar-ID","LDAP_Domain_Search_User_ID_Description":"LDAP-attribut som identifierar LDAP användare som försöker autentisering. Detta område bör vara `sAMAccountName` för de flesta Active Directory installationer, men det kan vara` uid` för andra LDAP lösningar, såsom OpenLDAP. Du kan använda `mail` att identifiera användare via e-post eller vad attribut du vill. <br> Du kan använda flera värden separerade med kommatecken för att tillåta användare att logga in med flera identifierare som användarnamn eller e-postadress.","LDAP_Enable":"Aktivera","LDAP_Enable_Description":"Försök att använda LDAP för autentisering.","LDAP_Encryption":"kryptering","LDAP_Encryption_Description":"Krypteringsmetod som används för att säkra kommunikationen till LDAP-servern. Som exempel kan nämnas `plain` (ingen kryptering),` SSL / LDAPS` (krypterad från början), och `StartTLS` (uppgradera till krypterad kommunikation när ansluten).","LDAP_Host":"Värd","LDAP_Host_Description":"LDAP värd, t.ex. `ldap.example.com` eller` 10.0.0.30`.","LDAP_Port":"Port","LDAP_Port_Description":"Port för att få tillgång till LDAP. t.ex. `389` eller` 636` för LDAPS","LDAP_Reject_Unauthorized":"Avvisa obehöriga","LDAP_Sync_User_Avatar":"Sync User Avatar","LDAP_Sync_User_Data":"Synka data","LDAP_Sync_User_Data_Description":"Håll användardata i synk med servern vid inloggning ( t.ex. namn, e-post ).","LDAP_Sync_User_Data_FieldMap":"Användardatafält Karta","LDAP_Sync_User_Data_FieldMap_Description":"Konfigurera hur användarkonto fält (som e-post) fylls från en post i LDAP (en gång hittade). <br/> Som ett exempel, `{\" cn \":\" namn \",\" post \":\" email \"} 'kommer att välja en persons mänskligt läsbar namn från cn attribut och deras e-post från e-postattribut. <br/> Tillgängliga fält inkluderar `name` och` email`.","LDAP_Sync_Users":"Synkronisera Användare","LDAP_Test_Connection":"Testa anslutning","LDAP_Unique_Identifier_Field":"Unique Identifier Field","LDAP_Unique_Identifier_Field_Description":"Vilket fält kommer att användas för att länka LDAP användare och Rocket.Chat användaren. Du kan informera flera värden separerade med kommatecken för att försöka få värdet från LDAP register. <br/> Standardvärdet är 'objectGUID, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Använd egen domän Sök","LDAP_Use_Custom_Domain_Search_Description":"Skriv ditt eget filter för att söka användare i LDAP-servern.","LDAP_Username_Field":"Användarnamn Field","LDAP_Username_Field_Description":"Vilket fält kommer att användas som * användarnamn * för nya användare. Lämna tomt för att använda användarnamn informerad om inloggningssidan. <br/> Du kan använda malltaggar också, som `# {givenname}. # {Sn}`. <br/> Standardvärdet är 'sAMAccountName`.","Leave_Group_Warning":"Är du säker att du vill lämna gruppen \"%s\"?","Leave_Private_Warning":"Är du säker att du vill lämna diskussionen med \"%s\"?","Leave_room":"Lämna rum","Leave_Room_Warning":"Är du säker att du vill lämna rummet \"%s\"?","line":"linje","List_of_Direct_Messages":"Lista över direktmeddelanden","Live_sessions":"Live sessioner","Livechat_agents":"Live medel","Livechat_Dashboard":"livechat instrumentpanel","Livechat_enabled":"Livechat aktiverat","Livechat_Manager":"livechat manager","Livechat_managers":"Live chefer","Livechat_title":"livechat Titel","Livechat_title_color":"Livechat Titel bakgrundsfärg","Livechat_Users":"Live Användare","Load_more":"Ladda mer","Loading...":"Laddar...","Loading_more_from_history":"Laddar mer från historiken","Loading_suggestion":"Laddar förslag...","Localization":"Lokalisering","Log_File":"Visa Arkiv och Linje","Log_Level":"Log Level","Log_Package":"Visa Package","Log_View_Limit":"Loggen Limit","Logged_out_of_other_clients_successfully":"Loggades framgångsrikt ut ur andra klienter","Login":"Logga in","Login_with":"Logga in med %s","login_with":"Eller logga in direkt med","Logout":"Logga Ut","Logout_Others":"Logga ut från andra inloggade platser","Mail_Message_Invalid_emails":"Du har angett ett eller flera ogiltiga e-postmeddelanden: %s","Mail_Message_Missing_to":"Du måste välja en eller flera användare eller tillhandahålla en eller flera e-postadresser, separerade med kommatecken.\n","Mail_Message_No_messages_selected_select_all":"Du har inte valt några meddelanden. Vill du <a href='#' class='selest-all'>välja alla</a> synliga meddelanden?","Mail_Messages":"E-posta meddelanden","Mail_Messages_Instructions":"Välj vilka meddelanden du vill skicka via e-post genom att klicka på dem","Mail_Messages_Subject":"Här är en utvald del av %s meddelanden","Mailer":"mailer","Mailer_body_tags":"Du <b>måste</b> använda [unsubscribe] för prenumeration länken. <br /> Du kan använda [namn], [fname], [lname] för användarens fullständiga namn, förnamn eller efternamn, respektive. <br /> Du kan använda [email] för användarens e-post.","Make_Admin":"Gör till administratör","Manager_added":"manager sattes","Manager_removed":"manager avlägsnades","Mark_as_read":"Markera som läst","Markdown_Headers":"Wiki rubriker","Markdown_SupportSchemesForLink":"Wiki stödsystem för Link","Markdown_SupportSchemesForLink_Description":"Kommaseparerad lista över tillåtna system","Members_List":"Medlemslista","Mentions":"Omnämningar ","Mentions_default":"Omnämningar (standard)","Message":"Meddelande","Message_AllowDeleting":"Tillåt radering av meddelanden","Message_AllowEditing":"Tillåt meddelanderedigering","Message_AllowEditing_BlockEditInMinutes":"Blockera redigering av meddelanden efter (n) minuter","Message_AllowEditing_BlockEditInMinutesDescription":"Skriv 0 för att inaktivera blockering.","Message_AllowPinning":"Tillåt pinnande av meddelanden","Message_AllowPinning_Description":"Tillåt meddelanden att bli pinnade i alla olika kanaler","Message_AllowStarring":"Tillåt stjärnmarkering av meddelanden.","Message_AudioRecorderEnabled":"Audio Recorder Enabled","Message_AudioRecorderEnabledDescription":"Kräver \"audio / wav\" filer att vara en accepterad mediatyp inom \"File Ladda upp\" inställningar.","Message_DateFormat":"Datumformat","Message_DateFormat_Description":"Se även: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Borttagning av meddelanden är inte tillåtet","Message_editing_blocked":"Detta meddelande kan inte redigeras längre","Message_editing_not_allowed":"Meddelanderedigering tillåts inte","Message_GroupingPeriod":"Gruppering Period (i sekunder)","Message_GroupingPeriodDescription":"Meddelanden kommer att grupperas med föregående meddelande om båda är från samma användare och förfluten tid var mindre än den angivna tiden i sekunder.","Message_KeepHistory":"Behåll meddelandehistorik","Message_MaxAllowedSize":"Största tillåtna meddelandestorlek","Message_MaxAll":"Maximal kanalstorlek för ALL meddelande","Message_pinned":"Meddelande pinnat","Message_pinning_not_allowed":"Pinna meddelande är inte tillåtet","Message_removed":"Meddelandet borttaget","Message_ShowDeletedStatus":"Visa borttagen status","Message_ShowEditedStatus":"Visa Redigerad status","Message_ShowFormattingTips":"Visa Formatera Tips","Message_TimeFormat":"Tidsformat","Message_TimeFormat_Description":"Se även: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Meddelande för långt","Messages":"Meddelanden","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Meddelanden som skickas till den inkommande WebHook kommer att publiceras här.","Meta":"Meta","Meta_fb_app_id":"Facebook App-ID","Meta_google-site-verification":"Google Site Verification","Meta_language":"Språk","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robots","minutes":"minuter","Mobile_push":"Mobila notifieringar","More_channels":"Fler kanaler","More_direct_messages":"Fler direkt meddelanden","More_groups":"Fler privata grupper","More_unreads":"Fler olästa","Msgs":"Meddelanden ","multi":"mång","Mute_someone_in_room":"Tysta någon i rummet","Mute_user":"mute användaren","Muted":"dämpad","My_Account":"Mitt Konto","n_messages":"%s meddelanden","N_new_messages":"%s nya meddelanden","Name":"Namn","Name_cant_be_empty":"Namn kan inte vara tomt","Name_of_agent":"Namn på agent","Name_optional":"Namn (valfritt)","Navigation_History_20_last_pages":"Navigationshistorik (de 20 senaste sidorna)","New_Application":"Ny applikation","New_Custom_Field":"New anpassat fält","New_Department":"Ny avdelning","New_integration":"Ny integrering","New_logs":"nya loggar","New_messages":"Nya meddelanden","New_password":"Nytt lösenord","New_role":"Ny roll","No_channel_with_name_%s_was_found":"Ingen kanal med namnet <strong>\"%s\"</strong> kunde hittas!","No_channels_yet":"Du är inte med i någon kanal ännu.","No_direct_messages_yet":"Du har inte startat några samtal än.","No_Encryption":"ingen kryptering","No_favorites_yet":"Du har inte lagt till några favoriter än.","No_group_with_name_%s_was_found":"Ingen privat grupp med namnet <strong>\"%s\"</strong> kunde hittas!\n","No_groups_yet":"Du har inga privata grupper än.","No_livechats":"Du har inga livechats.","No_mentions_found":"Inga Omnämningar hittade","No_permission_to_view_room":"Du har inte behörighet att visa detta rum","No_pinned_messages":"Inga pinnade meddelanden","No_results_found":"Inga resultat funna","No_starred_messages":"Inga stjärnmarkerade meddelanden","no_tokens_for_this_user":"Det finns inga polletter för användare","No_user_with_username_%s_was_found":"Ingen användare med användarnamnet <strong>\"%s\"</strong> kunde hittas!","Not_allowed":"Inte tillåten","Not_authorized":"Inte auktoriserad","Not_Available":"Inte tillgänglig","Not_found_or_not_allowed":"Inte hittad eller inte tillåten","Nothing":"Inget","Nothing_found":"Inget hittat","Notifications":"Notifikationer","Notify_all_in_this_room":"Meddela alla i det här rummet","Num_Agents":"# Agents","Number_of_messages":"Antal meddelanden","OAuth_Application":"OAuth Application","OAuth_Applications":"OAuth Tillämpningar","Objects":"Föremål","Off_the_record_conversation":"Off-the-record konversation","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-the-record konversationen finns inte tillgängligt för din webbläsare eller enhet.","Offline_DM_Email":"[__site__] Du har direkt messaged av __user__","Offline_Mention_Email":"[__site__] Du har nämnts av __user__ i #__room__","Old_and_new_password_must_be_different":"Det nya lösenordet måste vara annorlunda än det gamla lösenordet","Old_and_new_password_required":"Du måste ange både ditt gamla och nya lösenord för att kunna byta lösenord.","Online":"Online","Only_errors":"Endast fel","Only_you_can_see_this_message":"Bara du kan se detta meddelande","Oops!":"Oj","Open":"Öppen","Opened":"Öppnad","Opt_out_statistics":"Skicka inte min statistik till Rocket.Chat","Opt_out_statistics_warning":"Genom att skicka din statistik, kommer du hjälpa oss att identifiera hur många instanser av Rocket.Chat distribueras, samt hur bra systemet beter sig, så att vi kan förbättra det ytterligare. Oroa dig inte, ingen användarinformation skickas vidare och all den information vi får är konfidentiell. Om du vill fortsätta att skicka oss din statistik, avmarkera ovanstående kryssruta. Tack.\n","optional":"valfritt","Order":"Beställa","OS_Arch":"OS Arch","OS_Cpus":"OS CPU Count","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Genomsnittlig","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Totalt minne","OS_Type":"OS Typ","OS_Uptime":"OS Uptime","others":"andra","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR är endast tillgänglig när båda användarna är online","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Åsido URL till vilka filer som laddas upp. Denna url används också för nedladdning såvida inte en CDN ges","Password":"Lösenord","Password_Change_Disabled":"Din Rocket.Chatadministratör har inaktiverat lösenordsbyten","Password_changed_successfully":"Lösenordet ändrat","Payload":"nyttolast","People":"Folk","Permissions":"Tillstånd","Pin_Message":"Pinna Meddelande","Pinned_a_message":"Pinnade ett meddelande","Pinned_Messages":"Pinnade Meddelanden","Placeholder_for_email_or_username_login_field":"Platshållare för e-post- eller användarnamnsinloggningsfältet","Placeholder_for_password_login_field":"Platshållare för lösenordsinloggningsfältet","Please_answer_survey":"Vänligen ta en stund för att svara på en snabb enkät om chatten.","Please_enter_value_for_url":"Ange webbadressen till din avatar.","Please_enter_your_new_password_below":"Vänligen skriv in ditt nya lösenord här nedan:","Please_fill_a_label":"Vänligen fyll en etikett","Please_fill_a_name":"Vänligen fyll i ett namn","Please_fill_a_username":"Vänligen fyll i ett användarnamn","Please_fill_name_and_email":"Vänligen fyll i namn och e-postadress","Please_re_enter_your_password":"Vänligen ange ditt lösenord igen","Please_select_enabled_yes_or_no":"Välj ett alternativ för Enabled","Please_wait":"Vänligen vänta","Please_wait_activation":"Var vänlig och vänta, detta kan ta lite tid.","Please_wait_statistics":"Var vänlig och vänta, statistik blir genererad.","Please_wait_while_OTR_is_being_established":"Vänta medan OTR upprättas","Please_wait_while_your_account_is_being_deleted":"Vänligen vänta medan ditt konto raderas...","Please_wait_while_your_profile_is_being_saved":"Vänligen vänta medan din profil sparas...","Post_as":"Posta som","Post_to_Channel":"Posta till kanal","Post_to_s_as_s":"Posta till <strong>%s</strong> som <strong>%s</strong>","Powered_by":"Drivs av","Preferences":"Inställningar","Preferences_saved":"Inställningar sparade","Privacy":"Integritet","Private_Group":"Privat grupp","Private_Groups":"Privata Grupper","Private_Groups_list":"Lista över privata grupper","Profile":"Profil","Profile_saved_successfully":"Profilen sparad","Proudly_developed":"Stolt utvecklad med Meteor","Push":"Push","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Dev Cert","Push_apn_dev_key":"APN Dev Key","Push_apn_dev_passphrase":"APN Dev Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Debug","push_disabled":"Push avaktiverat","Push_enable":"Aktivera","Push_enable_gateway":"Aktivera Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API-nyckel","Push_gcm_project_number":"GCM projektnummer","Push_production":"Produktion","Push_show_message":"Visa meddelande i notifieringar","Push_show_username_room":"Visa kanal/grupp/användarnamn i notifieringar","Push_test_push":"Test","Query":"Fråga","Query_description":"Ytterligare villkor för att avgöra vilken användare att skicka e-post till. Användare som inte prenumererar tas automatiskt bort från frågan. Det måste vara ett giltigt JSON. Exempel: \"{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}\"","Quick_Search":"Snabbsökning","quote":"citat","Reactions":"Reaktioner","Recents":"Senaste","Record":"Spela in","Redirect_URI":"omdirigera URI","Refresh_keys":"refresh nycklar","Refresh_your_page_after_install_to_enable_screen_sharing":"Uppdatera sidan efter installationen för att aktivera skärmdelning","Register":"Registrera ett nytt konto","Registration_Succeeded":"Registreringen lyckades","Remember_me":"Kom ihåg mig","Remove":"Ta bort","Remove_Admin":"Ta bort administratör","Remove_as_moderator":"Ta bort som moderator","Remove_as_owner":"Ta bort som ägare","Remove_custom_oauth":"Ta bort anpassade oauth","Remove_from_room":"Ta bort från rum","Remove_someone_from_room":"Ta bort någon från detta rum","Removed":"Borttagen","Require_password_change":"Kräv byte av lösenord","Resend_verification_email":"Skicka verifieringsemail igen","Reset":"Nollställ","Reset_password":"Återställ lösenord","Restart":"Starta om","Restart_the_server":"Starta om servern","RocketBot_Enabled":"RocketBot aktiverad","RocketBot_Name":"RocketBot Namn","RocketBot_Name_Description":"RocketBot namn måste vara ett giltigt användarnamn registrerad på din server.","Role":"Roll","Role_Editing":"roll Redigering","Role_removed":"Roll borttagen","Room":"Rum","Room_archivation_state":"Status","Room_archivation_state_false":"Aktiv","Room_archivation_state_true":"Arkiverad","Room_archived":"Rum arkiverat","room_changed_privacy":"Typ rum ändras till: <em>__room_type__</em> av <em>__user_by__</em>","room_changed_topic":"Rummets ämne ändrat till: <em>__room_topic__</em> by <em>__user_by__</em","Room_has_been_deleted":"Rummet har raderats","Room_Info":"Rums info","Room_name_changed":"Rummets namn ändrat till :  <em>__room_name__</em> av <em>__user_by__</em>","Room_name_changed_successfully":"Rummets namn har ändrats ","Room_not_found":"Rummet kunde inte hittas","Room_topic_changed_successfully":"Rummets ämne har ändrats","Room_type_changed_successfully":"Rummets typ har ändrats","Room_unarchived":"rummet avarkiverats","Room_uploaded_file_list":"Fillista","Room_uploaded_file_list_empty":"Inga filer tillgängliga.","room_user_count":"%s användare","Rooms":"Rum","S_new_messages_since_s":"%s nya meddelanden sedan %s","SAML":"SAML","SAML_Custom_Cert":"beställnings Certificate","SAML_Custom_Entry_point":"Custom Entry Point","SAML_Custom_Generate_Username":"Skapa användarnamn","SAML_Custom_Issuer":"Custom Emittent","SAML_Custom_Provider":"anpassade Provider","Save":"Spara","Save_changes":"Spara ändringar","Save_Mobile_Bandwidth":"Spara Mobile Bandbredd","Save_to_enable_this_action":"Spara så att denna åtgärd","Saved":"Sparad","Saving":"Sparar","Scope":"Omfattning","Screen_Share":"Skärmdelning","Script_Enabled":"script Enabled","Search":"Sök","Search_by_username":"Sök på användarnamn","Search_Channels":"Sök kanaler","Search_Direct_Messages":"Sök bland Direkt Meddelanden ","Search_Messages":"Sök meddelanden","Search_Private_Groups":"Sök i privata grupper","Search_settings":"Sökinställningar","seconds":"sekunder","See_all":"Visa alla","See_only_online":"Bara online","Select_a_department":"Välj en avdelning","Select_an_avatar":"Välj en avatar","Select_file":"Välj fil","Select_service_to_login":"Välj en tjänst för att logga in för att välja din bild, eller ladda upp en direkt från din dator","Select_user":"Välj användaren","Select_users":"Välj användare","Selected_agents":"utvalda agenter","Selected_users":"Valda medlemmar","Send":"Skicka","Send_a_message":"Skicka ett meddelande","Send_a_test_mail_to_my_user":"Skicka ett testmail till min användare","Send_a_test_push_to_my_user":"Skicka ett testpushmeddelande till min användare","Send_confirmation_email":"Skicka e-postbekräftelse","Send_data_into_RocketChat_in_realtime":"Skicka data till Rocket.Chat i realtid.","Send_email":"Skicka e-post","Send_invitation_email":"Skicka e-postinbjudan","Send_invitation_email_error":"Du har inte angivit någon giltig e-postadress.","Send_invitation_email_info":"Du kan skicka flera e-postinbjudningar samtidigt.","Send_invitation_email_success":"Du har lyckats skicka en e-postinbjudan till följande adresser:","Send_invitation_email_warning":"För att kunna skicka e-postinbjudningar, måste du först konfigurera dina SMTP-inställningar.","Send_Message":"Skicka meddelande","Send_your_JSON_payloads_to_this_URL":"Skicka dina JSON nyttolaster till denna URL.","Sending":"Skickar...","Set_as_moderator":"Ange som moderator","Set_as_owner":"Ange som ägare","Settings":"Inställningar","Settings_updated":"Inställningar uppdaterade","Should_be_a_URL_of_an_image":"Ska vara en webbadress till en bild.","Should_exists_a_user_with_this_username":"Användaren måste existera redan.","Show_all":"Visa alla","Show_more":"Visa mer","Show_only_online":"Visa enbart online","Show_preregistration_form":"Visa förhandsregistreringsformulär","Showing_archived_results":"<p>Visar <b>%s</b> arkiverade resultat</p>","Showing_online_users":"Visar <b>__total_showing__</b> av __total__ users","Showing_results":"<p>Visar <b>%s</b> resultat</p>","Silence":"Tystnad","since_creation":"sedan %s","Site_Name":"Sidnamn","Site_Url":"webbadress","Site_Url_Description":"Example: https://chat.domain.com/","Skip":"Hoppa över","Smileys_and_People":"Smileys & Människor","SMTP":"SMTP","SMTP_Host":"SMTP-Host","SMTP_Password":"SMTP lösenord","SMTP_Port":"SMTP Port","SMTP_Test_Button":"Testa SMTP-inställningar","SMTP_Username":"SMTP Användarnamn","Sound":"Ljud","Star_Message":"Stjärnmarkera meddelande","Starred_Messages":"Stjärnmarkerade meddelanden","Start_audio_call":"Starta ljudsamtal","Start_Chat":"Starta chatt","Start_of_conversation":"Början av samtalet","Start_OTR":"start OTR","Start_video_call":"Starta videosamtal","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Starta med <code class=\"inline\">%s</code> för användare eller <code class=\"inline\">%s</code> för kanal. Ex: <code class=\"inline\">%s</code> eller <code class=\"inline\">%s</code>","Statistics":"Statistik","Stats_Active_Users":"Aktiva användare","Stats_Avg_Channel_Users":"Kanalens genomsnitt Användare","Stats_Avg_Private_Group_Users":"Genomsnittliga privata gruppen Användare","Stats_Away_Users":"bort Användare","Stats_Max_Room_Users":"Max Rum Användare","Stats_Non_Active_Users":"Inaktiva användare","Stats_Offline_Users":"Användare offline","Stats_Online_Users":"Användare online","Stats_Total_Channels":"Totala Kanaler","Stats_Total_Direct_Messages":"Totalt Direkta meddelande Rum","Stats_Total_Messages":"Totala meddelanden","Stats_Total_Private_Groups":"Totala Privata Grupper","Stats_Total_Rooms":"Totala Rum","Stats_Total_Users":"Totala användare","Stop_Recording":"Sluta spela in","strike":"strejk","Subject":"Ämne","Submit":"Skicka","Success":"Framgång","Survey":"Enkät","Survey_instructions":"Betygsätt varje fråga efter hur nöjd du är, 1 betyder att du inte alls är nöjd och 5 betyder att du är helt nöjd.\n","Symbols":"symboler","Sync_success":"synk framgång","Sync_Users":"Synkronisera Användare","Test_Connection":"Testa anslutningen","Test_Desktop_Notifications":"Testa Desktop notifiering","Thank_you_for_your_feedback":"Tack för din feedback","The_application_name_is_required":"Programnamnet krävs","The_channel_name_is_required":"Kanalnamnet krävs ","The_emails_are_being_sent":"E-postmeddelandena blir skickade.","The_field_is_required":"Fältet %s krävs.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Det kommer inte att gå att ändra storlek på bilden, eftersom vi inte kan hitta ImageMagick eller GraphicsMagick på din server.","The_redirectUri_is_required":"Den redirectUri krävs","The_server_will_restart_in_s_seconds":"Servern startas om om %s sekunder","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"Inställningen <strong>%s</strong> är konfigurerad till <strong>%s</strong> och du har tillgång från <strong>%s</strong>!","The_user_will_be_removed_from_s":"Användaren kommer att tas bort från %s","The_user_wont_be_able_to_type_in_s":"Användaren kommer inte att kunna skriva i %s","Theme":"Tema","theme-color-action-buttons-color":"Aktiviteter Knappar Färg","theme-color-active-channel-background-color":"Active Channel bakgrundsfärg","theme-color-active-channel-font-color":"Active Channel Font Color","theme-color-blockquote-background":"Blockquote bakgrundsfärg","theme-color-clean-buttons-color":"Rena Knappar Färg","theme-color-code-background":"Kod bakgrundsfärg","theme-color-code-border":"Kod Kantfärg","theme-color-code-color":"Kodfärg","theme-color-content-background-color":"Innehåll bakgrundsfärg","theme-color-custom-scrollbar-color":"Beställnings Scrollbar Färg","theme-color-info-active-font-color":"Aktiv Info Font Color","theme-color-info-font-color":"Info Font Color","theme-color-input-font-color":"Ingång Font Color","theme-color-link-font-color":"Länk Font Color","theme-color-message-hover-background-color":"Meddelande hover BG Färg","theme-color-primary-background-color":"Primära bakgrundsfärg","theme-color-primary-font-color":"Primär Font Color","theme-color-quaternary-font-color":"Quaternary Font Color","theme-color-secondary-background-color":"Sekundär bakgrundsfärg","theme-color-secondary-font-color":"Sekundär Teckenfärg","theme-color-smallprint-font-color":"Finstilta Font Color","theme-color-smallprint-hover-color":"Finstiltt hover Färg","theme-color-status-away":"Statusfärg för Borta","theme-color-status-busy":"Statusfärg för Upptagen","theme-color-status-offline":"Statusfärg för Offline","theme-color-status-online":"Statusfärg för Online","theme-color-tertiary-background-color":"Tertiary bakgrundsfärg","theme-color-tertiary-font-color":"Tertiary Teckenfärg","theme-color-unread-notification-color":"Olästa meddelanden Färg","theme-custom-css":"anpassade CSS","There_are_no_agents_added_to_this_department_yet":"Det finns inga medel har lagts till i avdelning ännu.","There_are_no_integrations":"Det finns inga integreringar","There_are_no_users_in_this_role":"Det finns inga användare med den rollen.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Denna e-postadress har redan använts och har inte blivit verifierad. Vänligen ändra ditt lösenord.","This_is_a_desktop_notification":"Det här en en desktop notifiering","This_is_a_push_test_messsage":"Detta är ett testpushmeddelande","Time_in_seconds":"Tid i sekunder","Title_bar_color":"Titel bar färg","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"För att installera Rocket.Chat Livechat på din webbplats, kopiera och koden ovanför den sista <strong></ body></strong> på din webbplats klistra.","To_users":"Till användare","Topic":"Ämne","Travel_and_Places":"Travel & Places","Trigger_removed":"trigger avlägsnades","Trigger_Words":"trigger ord","Triggers":"triggers","True":"Sant","Type":"Typ","Type_your_new_password":"Skriv in ditt nya lösenord","Unarchive":"unarchive","Unmute_someone_in_room":"Mikrofon på någon i rummet","Unmute_user":"Mikrofon på användaren","Unnamed":"Namnlös","Unpin_Message":"Ta bort pinnat meddelande","Unread_Rooms":"Olästa rum","Unread_Rooms_Mode":"Olästa Rum Läge","Unstar_Message":"Ta bort stjärnmarkering","Upload_file_question":"Ladda upp fil?","Uploading_file":"Laddar upp fil...","Use_account_preference":"Använd kontoinställningar","Use_Emojis":"Använd emojis","Use_initials_avatar":"Använd ditt användarnamns initialer","use_menu":"Använd sidomenyn för att få tillgång till dina rum och chattar","Use_service_avatar":"Använd %s avatar","Use_this_username":"Använd det här användarnamnet","Use_uploaded_avatar":"Använd uppladdad avatar","Use_url_for_avatar":"Använd webbadress för avatar","User__username__is_now_a_moderator_of__room_name_":"Användar __username__ är nu en moderator för __room_name__","User__username__is_now_a_owner_of__room_name_":"Användar __username__ är nu en ägare av __room_name__","User__username__removed_from__room_name__moderators":"Användar __username__ avlägsnas från __room_name__ moderatorer","User__username__removed_from__room_name__owners":"Användar __username__ avlägsnas från __room_name__ ägare","User_added":"Användare adderad ","User_added_by":"Användaren <em>__user_added__</em> tillagd av <em>__user_by__</em>.","User_added_successfully":"Användare framgångsrikt tillagd","User_Channels":"Användarkanaler","User_doesnt_exist":"Det existerar ingen användare med namnet `@%s`.","User_has_been_activated":"Användaren har aktiverats","User_has_been_deactivated":"Användaren har deaktiverats","User_has_been_deleted":"Användaren har blivit borttagen","User_has_been_muted_in_s":"Användaren har stängts av i %s","User_has_been_removed_from_s":"Användaren har blivit borttagen från %s","User_has_disconnected":"Användaren har kopplats bort","User_Info":"Användarinfo","User_is_no_longer_an_admin":"Användaren är inte längre administratör","User_is_not_activated":"Användaren är inte aktiverad","User_is_now_an_admin":"Användaren är nu administratör","User_joined_channel":"Har anslutit sig till kanalen.","User_joined_channel_female":"Har anslutit sig till kanalen.","User_joined_channel_male":"Har anslutit sig till kanalen.","User_left":"Har lämnat kanalen.","User_left_female":"Har lämnat kanalen.","User_left_male":"Har lämnat kanalen.","User_logged_out":"Användaren är utloggad","User_management":"Användarhantering","User_muted_by":"Användar <em>__user_muted__</em> avstängd av <em>__user_by__.</em>","User_muted_in_room":"Användar avstängd i rummet","User_not_found":"Användare inte hittad","User_not_found_or_incorrect_password":"Användaren hittades inte eller så är lösenordet felaktigt","User_or_channel_name":"Användare eller namn på kanal","User_removed":"Användare borttagen","User_removed_by":"Användaren <em>__user_removed__</em> avlägsnad av <em>__user_by__</em>.","User_removed_from_room":"Användaren har tagits bort från rummet","User_Settings":"Användarinställningar","User_unmuted_by":"Användar <em>__user_unmuted__</em> tystade av <em>__user_by__.</em>","User_unmuted_in_room":"Användar tystade i rummet","User_updated_successfully":"Användare framgångsrikt uppdaterad","Username":"Användarnamn","Username_and_message_must_not_be_empty":"Användarnamn och meddelande får inte vara tomma","Username_cant_be_empty":"Användarnamnet kan inte vara tomt","Username_Change_Disabled":"Din Rocket.Chatadministratör har avaktiverat byte av användarnamn","Username_denied_the_OTR_session":"__username__ förnekade OTR-session","Username_description":"Användarnamnet används för att låta andra nämna dig i meddelanden.","Username_doesnt_exist":"Användarnamnet `%s` finns inte.","Username_ended_the_OTR_session":"__username__ avslutade OTR-session","Username_invalid":"<strong>%s</strong> är inte ett giltigt användarnamn,<br/> använd bara bokstäver, siffror, punkter och bindestreck","Username_is_already_in_here":"`@%s` är redan här inne.","Username_is_not_in_this_room":"Användaren `#%s` är inte i rummet.","Username_not_found":"Användarnamn inte hittat","Username_title":"Registrera användarnamn","Username_unavaliable":"<strong>%s</strong> används redan :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ vill starta OTR. Vill du acceptera?","Users":"Användare","Users_in_role":"Användare i rollen","UTF8_Names_Slugify":"UTF8 Names Slugify","UTF8_Names_Validation":"UTF8 Names Validering","UTF8_Names_Validation_Description":"Tillåt inte specialtecken och mellanslag. Du kan använda - _ och . men inte i slutet av namnet","Verification_email_sent":"Verifieringsmeddelande har skickats","View_All":"Visa alla","View_Logs":"Visa Loggar","Visibility":"Synlighet","Visible":"Synlig","Visitor":"Besökare","Visitor_page_URL":"Visitor Sidans URL","Visitor_time_on_site":"Besökare tid på plats","Wait_activation_warning":"Innan du kan logga in måste ditt konto aktiveras manuellt av en administratör.","We_are_offline_Sorry_for_the_inconvenience":"Vi är offline. Vi beklagar olägenheten. ","We_have_sent_password_email":"Vi har skickat ett mail med instruktioner för återställande av lösenord. Om du inte får ett mail inom kort, kom tillbaka och försök igen.","We_have_sent_registration_email":"Vi har skickat ett mail för att bekräfta din registrering. Om du inte får ett mail inom kort, kom tillbaka och försök igen.","WebRTC_Enable_Channel":"Aktivera för publika kanaler\n","WebRTC_Enable_Direct":"Aktivera för direktmeddelanden\n","WebRTC_Enable_Private":"Aktivera för privata kanaler","WebRTC_Servers":"STUN / TURN-servrar","WebRTC_Servers_Description":"En lista över STUN och vrid servrar separerade med kommatecken. <br/> Användarnamn, lösenord och hamn är tillåtna i formatet `användarnamn: lösenord @ bedövar: värd: hamn: eller 'användarnamn: lösenord @ tur: värd: hamn:.","Welcome":"Välkommen <em>%s</em>.","Welcome_to_the":"Välkommen till","will_be_able_to":"kommer att kunna","With_whom":"Med vem","Yes":"Ja","Yes_clear_all":"Ja, rensa alla!","Yes_delete_it":"Ja, ta bort det!","Yes_hide_it":"Ja, dölj den!","Yes_leave_it":"Ja, lämna den!","Yes_mute_user":"Ja, mute användare!","Yes_remove_user":"Ja, ta bort användare!","you_are_in_preview_mode_of":"Du befinner dig i förhandsgranskningsläge i kanalen #<strong>__room_name__</strong>","You_are_logged_in_as":"Du är inloggad som","You_are_not_authorized_to_view_this_page":"Du är inte auktoriserad att se denna sida.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Du är den sista ägaren. Ställ ny ägare innan de lämnar rummet.","You_can_change_a_different_avatar_too":"Du kan åsidosätta avatar som används för att lägga upp från denna integration.\n","You_can_use_an_emoji_as_avatar":"Du kan också använda en emoji som avatar.","You_have_been_muted":"Du har stängts och inte kan tala i det här rummet","You_have_not_verified_your_email":"Du har inte bekräftat ditt e-post.","You_have_successfully_unsubscribed":"Du har blivit avregistrerad från vår e-postlista.","You_informed_an_invalid_FROM_address":"Dig informerad en ogiltig FRÅN adress.","You_must_provide_the_unsubscribe_link":"Du måste ge [unsubscribe] länk.","You_need_confirm_email":"Du måste bekräfta din e-postadress för att logga in!","You_need_install_an_extension_to_allow_screen_sharing":"Du måste installera ett tillägg för att kunna tillåta skärmdelning","You_need_to_change_your_password":"Du måste byta ditt lösenord","You_need_to_type_in_your_password_in_order_to_do_this":"Du måste skriva in ditt lösenord för att kunna göra detta!","You_need_to_type_in_your_username_in_order_to_do_this":"Du måste skriva in ditt användarnamn för att kunna göra detta!","You_need_to_verifiy_your_email_address_to_get_notications":"Du måste bekräfta din e-postadress för att få notifieringar","You_should_name_it_to_easily_manage_your_integrations":"Du bör namnge den för att enkelt kunna hantera dina integrationer .\n","You_will_not_be_able_to_recover":"Du kommer inte att kunna återskapa detta meddelande!","You_will_not_be_able_to_recover_file":"Du kommer inte att kunna återskapa den här filen!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Du kommer inte att få e-postmeddelanden eftersom du inte har verifierat din e-post.","Your_email_has_been_queued_for_sending":"Ditt e-postmeddelande har köats för att skickas","Your_entry_has_been_deleted":"Ditt meddelande har tagits bort.","Your_file_has_been_deleted":"Din fil har blivit raderad.","Your_mail_was_sent_to_s":"Ditt e-postmeddelande skickades till %s","Your_Open_Source_solution":"Din egen Open Source-chatlösning","Your_password_is_wrong":"Ditt lösenord är fel!","Your_push_was_sent_to_s_devices":"Din push skickades till %s enheter"});
TAPi18n._registerServerTranslator("sv", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ta-IN.i18n.json                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ta-IN"] = ["ta-IN","ta-IN"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["ta-IN"])) {                                                                     // 9
  TAPi18n.translations["ta-IN"] = {};                                                                                  // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ta-IN"][namespace])) {                                                          // 13
  TAPi18n.translations["ta-IN"][namespace] = {};                                                                       // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ta-IN"][namespace], {"500":"உள்ளக சர்வர் பிழை","0_Errors_Only":"0 - பிழைகளை மட்டும்","1_Errors_and_Information":"1 - பிழைகள் மற்றும் தகவல்","2_Erros_Information_and_Debug":"2 - Erros, தகவல் மற்றும் பிழை","__username__was_set__role__by__user_by_":"__username__ __user_by__ மூலம் __role__ அமைக்கப்பட்டது","__username__is_no_longer__role__defined_by__user_by_":"__username__ __user_by__ மூலம், __role__ இனி ஆகிறது","Access_not_authorized":"அணுகல் அதிகாரம் இல்லை","Access_online_demo":"ஆன்லைன் டெமோ அணுக","Access_Online_Demo":"ஆன்லைன் டெமோ அணுக","Access_Token_URL":"அணுகல் டோக்கன் URL","Accounts":"கணக்குகள்","Accounts_AllowDeleteOwnAccount":"செய்த சொந்த கணக்கை நீக்க அனுமதி","Accounts_AllowedDomainsList":"அனுமதிக்கப்பட்ட டொமைன்கள் பட்டியல்","Accounts_AllowedDomainsList_Description":"அனுமதி களங்களின் கமாவால் பிரிக்கப்பட்ட பட்டியல்","Accounts_AllowEmailChange":"மின்னஞ்சல் மாற்றம் அனுமதி","Accounts_AllowPasswordChange":"கடவுச்சொல் மாற்றம் அனுமதி","Accounts_AllowUserAvatarChange":"பதிவர் மாற்றம் அனுமதி","Accounts_AllowUsernameChange":"அனுமதி பயனர் பெயர் மாற்றம்","Accounts_AllowUserProfileChange":"பயனர் விவரம் மாற்றம் அனுமதி","Accounts_AvatarResize":"அவதாரங்களை அளவை","Accounts_AvatarSize":"avatar அளவு","Accounts_AvatarStorePath":"அவதார் சேமிப்பு பாதை","Accounts_AvatarStoreType":"அவதார் சேமிப்பு வகை","Accounts_BlockedDomainsList":"தடுக்கப்பட்ட களங்கள் பட்டியல்","Accounts_BlockedDomainsList_Description":"தடுக்கப்பட்டது களங்களின் கமாவால் பிரிக்கப்பட்ட பட்டியல்","Accounts_denyUnverifiedEmail":"சரிபார்க்கப்படாத மின்னஞ்சல் மறுக்க","Accounts_EmailVerification":"மின்னஞ்சல் சரிபார்ப்பு","Accounts_EmailVerification_Description":"நிச்சயமாக நீங்கள் இந்த வசதியை பயன்படுத்த சரியான SMTP அமைப்புகளை வைத்து கொள்ளுங்கள்","Accounts_Enrollment_Email":"பதிவு மின்னஞ்சல்","Accounts_Enrollment_Email_Description":"முறையே பயனர் முழு பெயர், முதல் பெயர் அல்லது கடைசி பெயரை நீங்கள் [பெயர்], [fname], பயன்படுத்தலாம் [lname]. <br /> நீங்கள் பயனர் மின்னஞ்சல் ஐந்து [மின்னஞ்சல்] பயன்படுத்தலாம்.","Accounts_Iframe_api_method":"API முறை","Accounts_Iframe_api_url":"API URL","Accounts_iframe_enabled":"இயக்கப்பட்டது","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"டேஸ் காலாவதி தேதி","Accounts_ManuallyApproveNewUsers":"கைமுறையாக புதிய பயனர்களுக்கு ஒப்புதல்","Accounts_OAuth_Custom_Token_Sent_Via":"டோக்கன் அனுப்பப்பட்டது வழியாக","Accounts_OAuth_Custom_Authorize_Path":"பாதை அங்கீகரி","Accounts_OAuth_Custom_Button_Color":"பட்டன் கலர்","Accounts_OAuth_Custom_Button_Label_Color":"பட்டன் உரை வண்ணம்","Accounts_OAuth_Custom_Button_Label_Text":"பட்டன் உரை","Accounts_OAuth_Custom_Enable":"இயக்கு","Accounts_OAuth_Custom_id":"அடையாளம்","Accounts_OAuth_Custom_Identity_Path":"அடையாள பாதை","Accounts_OAuth_Custom_Login_Style":"தேதி நடை","Accounts_OAuth_Custom_Secret":"இரகசிய","Accounts_OAuth_Custom_Token_Path":"டோக்கன் பாதை","Accounts_OAuth_Custom_URL":"URL ஐ","Accounts_OAuth_Facebook":"facebook தேதி","Accounts_OAuth_Facebook_callback_url":"பேஸ்புக் திரும்ப அழைப்பு URL","Accounts_OAuth_Facebook_id":"Facebook ஆப் ஐடி","Accounts_OAuth_Facebook_secret":"பேஸ்புக் இரகசிய","Accounts_OAuth_Github":"அறிந்திருந்தால் இயக்கப்பட்டது","Accounts_OAuth_Github_callback_url":"கிட்ஹப் திரும்ப அழைப்பு URL","Accounts_OAuth_GitHub_Enterprise":"அறிந்திருந்தால் இயக்கப்பட்டது","Accounts_OAuth_GitHub_Enterprise_callback_url":"மகிழ்ச்சியா நிறுவன திரும்ப அழைப்பு URL","Accounts_OAuth_GitHub_Enterprise_id":"வாடிக்கையாளர் ஐடி","Accounts_OAuth_GitHub_Enterprise_secret":"கிளையன்ட் சீக்ரெட்","Accounts_OAuth_Github_id":"வாடிக்கையாளர் ஐடி","Accounts_OAuth_Github_secret":"கிளையன்ட் சீக்ரெட்","Accounts_OAuth_Gitlab":"அறிந்திருந்தால் இயக்கப்பட்டது","Accounts_OAuth_Gitlab_callback_url":"GitLab திரும்ப அழைப்பு URL","Accounts_OAuth_Gitlab_id":"GitLab அடையாளம்","Accounts_OAuth_Gitlab_secret":"கிளையன்ட் சீக்ரெட்","Accounts_OAuth_Google":"Google உள்நுழைவு","Accounts_OAuth_Google_callback_url":"கூகிள் திரும்ப அழைப்பு URL","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"கூகிள் இரகசிய","Accounts_OAuth_Linkedin":"சென்டர் தேதி","Accounts_OAuth_Linkedin_callback_url":"சென்டர் திரும்ப அழைப்பு URL","Accounts_OAuth_Linkedin_id":"சென்டர் அடையாளம்","Accounts_OAuth_Linkedin_secret":"சென்டர் இரகசிய","Accounts_OAuth_Meteor":"விண்கற்கள் தேதி","Accounts_OAuth_Meteor_callback_url":"விண்கற்கள் திரும்ப அழைப்பு URL","Accounts_OAuth_Meteor_id":"விண்கற்கள் அடையாளம்","Accounts_OAuth_Meteor_secret":"விண்கற்கள் இரகசிய","Accounts_OAuth_Twitter":"ட்விட்டர் தேதி","Accounts_OAuth_Twitter_callback_url":"ட்விட்டர் திரும்ப அழைப்பு URL","Accounts_OAuth_Twitter_id":"ட்விட்டர் ஐடி","Accounts_OAuth_Twitter_secret":"ட்விட்டர் இரகசிய","Accounts_OAuth_Wordpress":"வேர்ட்பிரஸ் தேதி","Accounts_OAuth_Wordpress_callback_url":"வேர்ட்பிரஸ் திரும்ப அழைப்பு URL","Accounts_OAuth_Wordpress_id":"வேர்ட்பிரஸ் ஐடி","Accounts_OAuth_Wordpress_secret":"வேர்ட்பிரஸ் இரகசிய","Accounts_PasswordReset":"கடவுச்சொல்லை மீட்டமை","Accounts_Registration_AuthenticationServices_Enabled":"அங்கீகரிப்பு சேவைகள் பதிவு","Accounts_RegistrationForm":"பதிவு படிவம்","Accounts_RegistrationForm_Disabled":"முடக்கப்பட்டது","Accounts_RegistrationForm_LinkReplacementText":"பதிவு படிவம் இணைப்பு மாற்று உரை","Accounts_RegistrationForm_Public":"பொது","Accounts_RegistrationForm_Secret_URL":"இரகசிய URL ஐ","Accounts_RegistrationForm_SecretURL":"பதிவு படிவம் இரகசிய URL ஐ","Accounts_RegistrationForm_SecretURL_Description":"நீங்கள் உங்கள் பதிவு URL ஐ சேர்க்க வேண்டும் என்று ஒரு சீரற்ற சரமாக வழங்க வேண்டும். உதாரணம்: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"பதிவு தேவை","Accounts_RequireNameForSignUp":"இணைந்ததற்கு பெயர் தேவை","Accounts_ShowFormLogin":"காட்டு-சார்ந்த தேதி","Accounts_UseDefaultBlockedDomainsList":"பயன்பாட்டு இயல்புநிலை தடுக்கப்பட்ட களங்கள் பட்டியல்","Accounts_UseDNSDomainCheck":"டிஎன்எஸ் இணைய சோதனை பயன்படுத்தவும்","Activate":"செயல்படுத்த","Activity":"செயல்பாடு","Add":"கூட்டு","Add_agent":"முகவர் சேர்","Add_custom_oauth":"விருப்ப OAuth சேர்","Add_manager":"மேலாளர் சேர்","Add_Members":"உறுப்பினர் சேர்க்கவும்","Add_User":"பயனர் சேர்க்க","Add_user":"பயனர் சேர்","Add_users":"பயனர் சேர்க்க","Additional_emails":"கூடுதல் மின் அஞ்சல்","Additional_Feedback":"கூடுதல் கருத்துத்","Administration":"நிர்வாகம்","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2 ஐப் அங்கீகரித்த பின், பயனர்கள் இந்த URL திருப்பிவிடப்பட்டது","Agent_added":"முகவர் சேர்க்கப்பட்டது","Agent_removed":"அதிபர் நீக்கப்பட்டது","Alias":"அலைஸ்","All":"அனைத்து","All_channels":"அனைத்து சேனல்கள்","All_logs":"அனைத்து பதிவுகள்","All_messages":"அனைத்து செய்திகள்","Allow_Invalid_SelfSigned_Certs":"அனுமதி தவறான சுய கையொப்பம் சான்றிதழ்களையும்","Allow_Invalid_SelfSigned_Certs_Description":"இணைப்பு சரிபார்த்தல் மற்றும் முன்னோட்டங்கள் தவறான மற்றும் சுய கையொப்பம் SSL சான்றிதழ் தான் அனுமதி.","and":"மற்றும்","And_more":"மேலும் __length __...","Animals_and_Nature":"விலங்குகள் மற்றும் இயற்கை","API":"ஏபிஐ","API_Analytics":"அனலிட்டிக்ஸ்","API_Embed":"பதித்துள்ளது","API_EmbedDisabledFor":"பயனர்கள் பதித்துள்ளது முடக்கு","API_EmbedDisabledFor_Description":"பயனர்பெயர்களுக்குப் கமாவால் பிரிக்கப்பட்ட பட்டியல்","API_GitHub_Enterprise_URL":"சேவையக URL","API_GitHub_Enterprise_URL_Description":"உதாரணம்: http://domain.com (தவிர்த்து பின் சாய்வு)","API_Gitlab_URL":"GitLab URL ஐ","API_Wordpress_URL":"வேர்ட்பிரஸ் URL ஐ","Appearance":"தோற்றம்","Application_added":"விண்ணப்ப சேர்க்கப்பட்டது","Application_Name":"விண்ணப்ப பெயர்","Application_updated":"விண்ணப்ப மேம்படுத்தப்பட்டது","Apply_and_refresh_all_clients":"விண்ணப்பிக்க மற்றும் அனைத்து வாடிக்கையாளர்கள் புதுப்பிக்க","Archive":"காப்பகம்","Archive_Unarchive":"காப்பகம் / காப்பிடாதே","are_also_typing":"அவர்கள் தட்டச்சு செய்கிறார்கள்","are_typing":"அவர்கள் தட்டச்சு செய்கிறார்கள்","Are_you_sure":"நீ சொல்வது உறுதியா?","Are_you_sure_you_want_to_delete_your_account":"நீங்கள் உங்கள் கணக்கை நீக்க வேண்டும் நீங்கள் உறுதியாக இருக்கிறீர்களா?","Authorization_URL":"அங்கீகரிப்பு URL","Authorize":"அங்கீகரி","AutoLinker_StripPrefix":"AutoLinker கரை முன்னொட்டு","AutoLinker_StripPrefix_Description":"குறுகிய காட்சி. எ.கா. https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL ஐ","AutoLinker_UrlsRegExp":"AutoLinker URL ஐ வழக்கமான வெளிப்படு","AutoLinker_Email":"AutoLinker மின்னஞ்சல்","AutoLinker_Phone":"AutoLinker தொலைபேசி","AutoLinker_Phone_Description":"தொலைபேசி எண்கள் தானாகவே இணைக்கப்பட்ட. எ.கா.: (123) 456-7890`","Auto_Load_Images":"ஆட்டோ சுமை படங்கள்","Available":"கிடைக்கும்","Available_agents":"கிடைக்கும் முகவர்","Avatar":"அவதார்","Avatar_changed_successfully":"அவதார் வெற்றிகரமாக மாற்றப்பட்டது","Avatar_URL":"அவதார் URL ஐ","Avatar_url_invalid_or_error":"வழங்கிய url தவறான அல்லது அணுக முடியாது. மீண்டும் முயற்சி, ஆனால் வேறு ஒரு URL உடன் கொள்ளவும்.","away":"விட்டு","Away":"வெளிநாடு","away_female":"விட்டு","Away_female":"வெளிநாடு","away_male":"விட்டு","Away_male":"வெளிநாடு","Back":"மீண்டும்","Back_to_applications":"மீண்டும் பயன்பாடுகள் வேண்டும்","Back_to_integrations":"மீண்டும் ஒருங்கிணைவு வேண்டும்","Back_to_login":"மீண்டும் உள்நுழைய வேண்டும்","Back_to_permissions":"மீண்டும் அனுமதிகள்","Body":"உடல்","bold":"தைரியமான","busy":"பிஸியாக","Busy":"பிஸி","busy_female":"பிஸியாக","Busy_female":"பிஸி","busy_male":"பிஸியாக","Busy_male":"பிஸி","Cancel":"வேண்டாம்","Cannot_delete_a_protected_role":"பாதுகாக்கப்பட்ட பங்கு நீக்க முடியவில்லை","Cannot_delete_role_because_its_in_use":"இது பயன்பாட்டில் ஏனெனில் பங்கு நீக்க முடியவில்லை","Cannot_invite_users_to_direct_rooms":"அறைகள் இயக்கும் பயனர்களை அழைக்க முடியாது","CDN_PREFIX":"வலம்புரி முன்னொட்டு","Certificates_and_Keys":"சான்றிதழ்கள் மற்றும் விசைகளை","Channel":"சேனல்","Channel_doesnt_exist":"சேனல் `# %s` இல்லை.","Channels":"பொது குழுக்கள்","Channels_list":"பொது குழுக்களின் பட்டியல்","Chat_Rooms":"அரட்டை அறைகள்","Chatops_Enabled":"Chatops இயக்கு","Chatops_Title":"Chatops குழு","Chatops_Username":"Chatops பயனர்பெயர்","Choose_a_room":"ஒரு அறையில் தேர்வு","Choose_messages":"செய்திகளை தேர்வு","Choose_the_alias_that_will_appear_before_the_username_in_messages":"செய்திகளை பயனர்பெயர் முன் தோன்றும் என்று மாற்று தேர்வு.","Choose_the_username_that_this_integration_will_post_as":"இந்த ஒருங்கிணைப்பு பதிவு என்று பயனர் பெயரைத் தேர்வு.","Clear_all_unreads_question":"அனைத்து unreads அழிக்கவா?","Client_ID":"கிளையன்ட் ஐடி","Client_Secret":"கிளையன்ட் சீக்ரெட்","Clients_will_refresh_in_a_few_seconds":"வாடிக்கையாளர் ஒரு சில நொடிகளில் இளைப்பாறுதல் தருவேன்","close":"நெருக்கமான","Closed":"மூடப்பட்ட","Collapse_Embedded_Media_By_Default":"இயல்பாக பதிக்கப்பட்ட ஊடக சுருக்கு","coming_soon":"விரைவில்","Commands":"கட்டளைகள்","Compact_View":"சுருக்கமான காட்சி","Confirm_password":"உங்கள் கடவுச்சொல்லை உறுதிப்படுத்துக","Contact":"தொடர்பு","Conversation":"உரையாடல்","Convert_Ascii_Emojis":"ஈமோஜியில் ஆஸ்கி மாற்ற","Copied":"நகலெடுக்கப்பட்ட","COPY_TO_CLIPBOARD":"பிரதி கிளிப்போர்டில்","Copy_to_clipboard":"கிளிப்போர்டில் நகலெடு","Count":"எண்ண","Create":"உருவாக்கு","Create_new":"புதிய உருவாக்கவும்","Created_at":"மணிக்கு உருவாக்கப்பட்டது","Created_at_s_by_s":"<strong>% கள்</strong> <strong>மூலம் %s</strong> இல் உருவாக்கப்பட்டது","Custom_Fields":"விருப்ப புலங்கள்","Custom_oauth_helper":"உங்கள் அறிந்திருந்தால் வழங்குநர் அமைக்க போது, நீங்கள் ஒரு கோரிக்கை URL ஐ தெரிவிக்க வேண்டும். பயன்பாட்டு <pre> % கள் </pre> .","Custom_oauth_unique_name":"விருப்ப OAuth தனிப்பட்ட பெயர்","Custom_Script_Logged_In":"வழக்கமான ஸ்கிரிப்ட் பயனர்கள் வெளியேற்ற","Custom_Script_Logged_Out":"வழக்கமான ஸ்கிரிப்ட் வெளியேற்றப்படுவீர்கள் பயனர்கள்","Dashboard":"டாஷ்போர்டு","days":"நாட்களில்","Deactivate":"செயலிழக்க","Debug_Level":"பிழைதிருத்து நிலை","Default":"இயல்புநிலை","Delete":"அழி","Delete_my_account":"எனது கணக்கை நீக்கு","Delete_Room_Warning":"ஒரு அறையில் நீக்குதல் அனைத்து செய்திகள் அறையில் உள்ள posted நீக்கும். இதை முடிக்காமல் விட கூடாது.","Delete_User_Warning":"ஒரு பயனர் அழிப்பதை அதே பயனர் இருந்து அனைத்து செய்திகள் நீக்கும். இதை முடிக்காமல் விட கூடாது.","Deleted":"நீக்கப்பட்டது!","Department_not_found":"துறை இல்லை","Department_removed":"துறை நீக்கப்பட்டது","Departments":"திணைக்களங்கள்","Description":"விளக்கம்","Desktop":"டெஸ்க்டாப்","Desktop_Notification_Test":"டெஸ்க்டாப் அறிவித்தல் டெஸ்ட்","Desktop_Notifications":"டெஸ்க்டாப் அறிவிக்கைகள்","Desktop_Notifications_Disabled":"டெஸ்க்டாப் அறிவிப்புகள் முடக்கப்பட்டுள்ளது. நீங்கள் செயல்படுத்தப்படும் அறிவிப்புகள் வேண்டும் என்றால் உங்கள் உலாவி விருப்பத்தேர்வுகளை மாற்ற.","Desktop_Notifications_Enabled":"டெஸ்க்டாப் அறிவிப்புகள் இயக்கப்பட்டன","Direct_message_someone":"நேரடி செய்தி யாரோ","Direct_Messages":"நேரடி செய்திகள்","Direct_Messages_list":"நேரடி செய்திகள்","Disable_Favorite_Rooms":"பிடித்த முடக்கு","Disable_New_Message_Notification":"புதிய செய்தி அறிவித்தல் முடக்கு","Disable_New_Room_Notification":"புதிய அறை அறிவித்தல் முடக்கு","Displays_action_text":"காட்சிகள் நடவடிக்கை உரை","Do_you_want_to_change_to_s_question":"<strong>நீங்கள் %s</strong> க்கு மாற்ற விரும்புகிறீர்களா?","Drop_to_upload_file":"கோப்பை பதிவேற்ற கைவிட","Dry_run":"உலர்ந்த ஓட்டம்","Dry_run_description":"மட்டும் இருந்து அதே முகவரிக்கு, ஒரு மின்னஞ்சல் அனுப்ப வேண்டும். மின்னஞ்சல் சரியான பயனர் சேர்ந்தவை வேண்டும்.","Duplicate_archived_channel_name":"ஒரு ஆவண சேனல் பெயர் ' %s' என்ற உள்ளது","Duplicate_archived_private_group_name":"பெயர் ' %s' உள்ளது கொண்டு ஒரு ஆவண தனியார் குழு","Duplicate_private_group_name":"' %s' என்ற உள்ளது பெயருடன் ஒரு தனியார் குழு","E-mail":"மின்னஞ்சல்","Edit":"தொகு","Edit_Custom_Field":"வழக்கமான புலம் திருத்து","Edit_Department":"துறை திருத்து","edited":"திருத்தப்பட்டது","Email":"மின்னஞ்சல்","Email_already_exists":"மின்னஞ்சல் ஏற்கனவே உள்ளது","Email_body":"மின்னஞ்சல் உடல்","Email_Change_Disabled":"உங்கள் Rocket.Chat நிர்வாகி மின்னஞ்சல் மாறிவரும் முடக்கியுள்ளது","Email_from":"இருந்து","Email_Notification_Mode":"ஆஃப்லைன் மின்னஞ்சல் அறிவிப்புகள்","Email_Notification_Mode_All":"ஒவ்வொரு குறிப்பும் / டி.எம்","Email_Notification_Mode_Disabled":"முடக்கப்பட்டது","Email_or_username":"மின்னஞ்சல் அல்லது பயனர் பெயர்","Email_subject":"பொருள்","Email_verified":"மின்னஞ்சல் சரிபார்க்கப்பட்டது","Emoji":"ஈமோஜியில்","Empty_title":"காலியாக தலைப்பு","Enable":"இயக்கு","Enable_Desktop_Notifications":"டெஸ்க்டாப் அறிவிப்புகளை இயக்க","Enabled":"இயக்கப்பட்டது","Encrypted_message":"மறைக்கப்பட்ட செய்தி","End_OTR":"முடிவு OTR","Enter_a_regex":"ஒரு regex உள்ளிடவும்","Enter_a_room_name":"ஒரு அறையில் பெயரை உள்ளிடவும்","Enter_a_username":"ஒரு பயனர் பெயர் சேர்க்கவும்","Enter_info":"உங்கள் உள்நுழைவு தகவலை உள்ளிடவும்","Enter_name_here":"இங்கே பெயரை உள்ளிடுக","Enter_to":"க்கு சேர்க்கவும்","Error":"பிழை","error-cant-invite-for-direct-room":"நேரடி அறைகள் பயனரை அழைக்க முடியாது","error-duplicate-channel-name":"ஒரு சேனல் பெயர் ' %s' என்ற உள்ளது","error-invalid-custom-field":"தவறான விருப்ப துறையில்","error-invalid-custom-field-name":"தவறான விருப்ப துறையில் பெயர். எழுத்துக்கள், எண்கள், இணைப்புக்குறிகள் மற்றும் அடிக்கோடு பயன்படுத்தவும்.","error-invalid-password":"தவறான கடவுச்சொல்","error-invalid-room":"தவறான அறை","error-invalid-room-name":"<strong>% கள்,</strong> சரியான அறைப் பெயரை அல்ல <br/> எழுத்துக்கள், எண்கள், இணைப்புக்குறிகள் மற்றும் அடிக்கோடு பயன்படுத்த","error-invalid-user":"செல்லாத பயனர்","error-invalid-username":"தவறான பயனர்பெயர்","error-not-allowed":"அனுமதி இல்லை","error-not-authorized":"அங்கீகாரம் இல்லை","error-remove-last-owner":"இந்த கடைசி உரிமையாளர். இந்த மொழியை அகற்றுவதற்கு முன்னர் ஒரு புதிய உரிமையாளர் அமைக்க கொள்ளவும்.","error-role-name-required":"பங்கு பெயர் தேவை","error-user-not-in-room":"பயனர் இந்த அறையில் இல்லை","Error_changing_password":"கடவுச்சொல் மாற்றப்பட்டது","Error_sending_confirmation_email":"உறுதிப்படுத்தல் மின்னஞ்சல் அனுப்புவதில் பிழை","Error_too_many_requests":"பிழை, பல கோரிக்கைகள். மெதுவாக செய்யவும். மீண்டும் முயற்சிக்கும் முன் %s வினாடிகள் காத்திருக்க வேண்டும்","Esc_to":"esc விசையை","Example_s":"உதாரணம்: <code class=\"inline\">%s</code>","False":"தவறான","Favorites":"பிடித்தவை","Field":"களம்","Field_removed":"துறையில் நீக்கப்பட்டது","File_exceeds_allowed_size_of_bytes":"கோப்பு __size__ பைட்டுகள் அனுமதி அளவை விட அதிகமாக இருக்கிறது","FileUpload":"கோப்பு பதிவேற்றம்","FileUpload_Enabled":"கோப்பு பதிவேற்றங்கள் இயக்கப்பட்டது","FileUpload_File_Empty":"காலியாக கோப்பு","FileUpload_FileSystemPath":"கணினி பாதையில்","FileUpload_MaxFileSize":"அதிகபட்ச கோப்பை பதிவேற்ற அளவு (பைட்டுகள்)","FileUpload_MediaType_NotAccepted":"மீடியா வகைகள் ஏற்கவில்லை","FileUpload_MediaTypeWhiteList":"ஏற்றுக்கொள்ளப்பட்ட மீடியா வகைகள்","FileUpload_MediaTypeWhiteListDescription":"காற்புள்ளியால் பிரிக்கப்பட்ட ஊடக வகைகளின் பட்டியல். அது அனைத்து ஊடக வகையான ஏற்று விடுக.","FileUpload_ProtectFiles":"பதிவேற்றிய கோப்புகள் பாதுகாக்க","FileUpload_ProtectFilesDescription":"அங்கீகரிக்கப்படும் பயனர்களுக்கு மட்டுமே அணுகல் வேண்டும்","FileUpload_S3_Acl":"அமேசான் S3 ACL","FileUpload_S3_AWSAccessKeyId":"அமேசான் S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"அமேசான் S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"அமேசான் S3 வாளி பெயர்","FileUpload_S3_BucketURL":"பக்கெட் URL ஐ","FileUpload_S3_CDN":"இறக்கம் வலம்புரி டொமைன்","FileUpload_S3_Region":"பகுதி","FileUpload_Storage_Type":"சேமிப்பு வகை","Flags":"கொடிகள்","Follow_social_profiles":", எங்கள் சமூக சுயவிவரங்கள் பின்பற்றவும் எங்கள் Trello பலகையில் rocket.chat பயன்பாட்டை பற்றி மகிழ்ச்சியா எங்களுக்கு வலுவாக்க மற்றும் உங்கள் எண்ணங்களை பகிர்ந்து.","Food_and_Drink":"உணவு & குடி","For_your_security_you_must_re_enter_your_password_to_continue":"உங்கள் பாதுகாப்பு, நீங்கள் உங்கள் கடவுச்சொல்லை தொடர மீண்டும் நுழைய வேண்டும்","Force_SSL":"படை SSL","Force_SSL_Description":"* எச்சரிக்கை! * _Force SSL_ தலைகீழ் பதிலி பயன்படுத்த கூடாது. நீங்கள் ஒரு தலைகீழ் ப்ராக்ஸி வேண்டும் என்றால், நீங்கள் அங்கு திருப்பி செய்ய வேண்டும். இந்த விருப்பத்தை தலைகீழ் ப்ராக்ஸி மணிக்கு திருப்பி கட்டமைப்பு அனுமதிக்க முடியாது என்று Heroku, போன்ற ஆயத்தங்களும் உள்ளது.","Forgot_password":"உங்கள் கடவுச்சொல்லை மறந்து விட்டீர்களா","Fork_it_on_github":"மகிழ்ச்சியா அது போர்க்","Frequently_Used":"அடிக்கடி பயன்படுத்திய","From":"இருந்து","From_Email":"மின்னஞ்சல் இருந்து","From_email_is_required":"இருந்து மின்னஞ்சல் தேவை","From_email_warning":"<b>எச்சரிக்கை:</b> <b>இருந்து</b> துறையில் உங்கள் மின்னஞ்சல் சர்வர் அமைப்புகளை உட்பட்டது.","General":"பொது","Get_to_know_the_team":"Rocket.Team தெரிந்து கொள்ள","github_no_public_email":"நீங்கள் உங்கள் மகிழ்ச்சியா கணக்கில் பொது மின்னஞ்சல் என எந்த மின்னஞ்சல் இல்லை","Give_a_unique_name_for_the_custom_oauth":"விருப்ப OAuth ஒரு தனிப்பட்ட பெயரை கொடுங்கள்","Give_the_application_a_name_This_will_be_seen_by_your_users":"விண்ணப்ப ஒரு பெயர் கொடுக்க. இது உங்கள் பயனர் பார்க்க வேண்டும்.","Global":"குளோபல்","GoogleTagManager_id":"Google குறி மேலாளர் ஐடி","Has_more":"இன்னும் உள்ளது","Have_your_own_chat":"உங்கள் சொந்த இணைய அரட்டை வேண்டும். Meteor.com வளர்ந்த, Rocket.Chat உருவாக்க மற்றும் தங்கள் சொந்த அரட்டை மேடையில் கண்டுபிடிக்கலாம் எதிர்பார்த்து டெவலப்பர்கள் ஒரு சிறந்த தீர்வாக உள்ளது.","Header":"தலைப்பு","Hidden":"மறைக்கப்பட்ட","Hide_Group_Warning":"குழு \" %s\" பதில் மறைக்க வேண்டும் என்பதில் உறுதியாக இருக்கிறீர்களா?","Hide_Private_Warning":"நீங்கள் \" %s\" பதில் மூலம் விவாதம் மறைக்க விரும்பவில்லை நீங்கள் உறுதியாக இருக்கிறீர்களா?","Hide_room":"அறையை மறை","Hide_Room_Warning":"நீங்கள் அறையில் \" %s\" பதில் மறைக்க வேண்டும் என்பதில் உறுதியாக இருக்கிறீர்களா?","Highlights":"ஹைலைட்ஸ்","Highlights_How_To":"யாரோ, ஒரு சொல் அல்லது சொற்றொடர் குறிப்பிடுகிறார் இங்கே அதை சேர்க்க அறிவிக்கப்படும் வேண்டும். நீங்கள் அரைப்புள்ளியால் வார்த்தைகள் அல்லது சொற்றொடர்களை பிரிக்க முடியாது. சிறப்பம்சமாக சொற்கள் உணர்திறன் அற்றவை.","Highlights_List":"சிறப்பம்சமாக வார்த்தைகள்","History":"வரலாறு","hours":"மணி","How_friendly_was_the_chat_agent":"அரட்டை முகவர் எப்படி நட்பு இருந்தது?","How_knowledgeable_was_the_chat_agent":"அரட்டை முகவர் எப்படி அறிவு இருந்தது?","How_responsive_was_the_chat_agent":"அரட்டை முகவர் எப்படி பதிலளிக்க இருந்தது?","How_satisfied_were_you_with_this_chat":"இந்த அரட்டை, எவ்வளவு திருப்தியாக இருந்தன?","If_you_are_sure_type_in_your_password":"உங்கள் கடவுச்சொல்லை உறுதி வகை என்றால்:","If_you_are_sure_type_in_your_username":"நீங்கள் உங்கள் பயனர் பெயர் உறுதி வகை என்றால்:","Importer_Archived":"காப்பகப்படுத்தியவை","Importer_done":"முழுமையான இறக்குமதி!","Importer_finishing":"இறக்குமதி முடிக்கிறது.","Importer_From_Description":"இறக்குமதி Rocket.Chat ஒரு __ 'கள் தரவு __from.","Importer_import_cancelled":"இறக்குமதி ரத்துசெய்யப்பட்டது.","Importer_import_failed":"இறக்குமதி இயங்கும் போது ஒரு பிழை ஏற்பட்டது.","Importer_importing_channels":"சேனல்கள் இறக்குமதி.","Importer_importing_messages":"செய்திகளை இறக்குமதி செய்கிறது.","Importer_importing_started":"இறக்குமதி தொடங்கி.","Importer_importing_users":"பயனர்கள் இறக்குமதி.","Importer_not_defined_properly":"இறக்குமதியாளர் அது இறக்குமதி வர்க்கம் காணவில்லை, சரியாக வரையறுக்கப்படவில்லை.","Importer_not_in_progress":"இறக்குமதியாளர் தற்போது இயங்கவில்லை.","Importer_Prepare_Restart_Import":"மறுதொடக்கம் இறக்குமதி","Importer_Prepare_Start_Import":"இறக்குமதியைத் தொடங்கு","Importer_Prepare_Uncheck_Archived_Channels":"தேர்வுநீக்கி காப்பகப்படுத்தியவை சேனல்கள்","Importer_Prepare_Uncheck_Deleted_Users":"தேர்வுநீக்கி நீக்கப்பட்ட பயனர்கள்","Importer_progress_error":"இறக்குமதி முன்னேற்றம் பெற முடியவில்லை.","Importer_setup_error":"இறக்குமதியாளர் அமைக்க போது ஒரு பிழை நேர்ந்தது.","Incorrect_Password":"தவறான கடவுச்சொல்","inline_code":"inline_code","Install_Extension":"நீட்டிப்பை நிறுவு","Install_FxOs":"உங்கள் பயர்பாக்ஸ் Rocket.Chat நிறுவ","Install_FxOs_done":"கிரேட்! நீங்கள் இப்போது உங்கள் homescreen சின்னத்தை வழியாக Rocket.Chat பயன்படுத்த முடியும். Rocket.Chat வேடிக்கையாக இருக்கிறது!","Install_FxOs_error":"மன்னிக்கவும், நோக்கம் என வேலை செய்யவில்லை என்று! பின்வரும் பிழை தோன்றியது:","Install_FxOs_follow_instructions":"உங்கள் சாதனத்தில் பயன்பாட்டை நிறுவல் தயவுசெய்து உறுதிப்படுத்தவும் (பத்திரிகை கேட்கும் போது \"நிறுவு\").","Installation":"நிறுவல்","Integration_added":"ஒருங்கிணைப்பு சேர்க்கப்பட்டுள்ளது","Integration_Incoming_WebHook":"உள்வரும் WebHook ஒருங்கிணைப்பு","Integration_New":"புதிய ஒருங்கிணைப்பு","Integration_Outgoing_WebHook":"வெளிச்செல்லும் WebHook ஒருங்கிணைப்பு","Integration_updated":"ஒருங்கிணைப்பு மேம்படுத்தப்பட்டது","Integrations":"ஒருங்கிணைவுகளையும்-","Invalid_asset":"செல்லாத சொத்து","Invalid_confirm_pass":"கடவுச்சொல்லை உறுதிப்படுத்தும் கடவுச்சொல் பொருந்தவில்லை","Invalid_email":"உள்ளிட்ட மின்னஞ்சல் தவறானது","Invalid_Export_File":"பதிவேற்றிய கோப்பு ஒரு செல்லுபடியாகும்% கள் ஏற்றுமதி கோப்பு அல்ல.","Invalid_file_height":"தவறான கோப்பு உயரம்","Invalid_file_type":"தவறான கோப்பு வகை","Invalid_file_width":"தவறான கோப்பு அகலம்","Invalid_Import_File_Type":"தவறான இறக்குமதி கோப்பு வகை.","Invalid_name":"பெயர் காலியாக இருக்க கூடாது ","Invalid_notification_setting_s":"தவறான அறிவிப்பு அமைப்பைப் %s:","Invalid_pass":"கடவுச்சொல் காலியாக இருக்கக் கூடாது","Invalid_room_name":"<strong> %s</strong>தவறான அறை பெயர், <br / > எழுத்துகள், எண்கள் மற்றும் கோடுகளை பயன்படுத்துக","Invalid_room_type":"<strong> %s</strong> செல்லுபடியாகும் அறையில் வகை அல்ல.","Invalid_Secret_URL":"தவறான ரகசிய URL ஐ","Invalid_secret_URL_message":"வழங்கிய URL செல்லுபடியாகாது.","invisible":"கண்ணுக்கு தெரியாத","Invisible":"கண்ணுக்கு தெரியாத","Invitation_HTML":"அழைப்பிதழ், HTML","Invitation_Subject":"அழைப்பிதழ் பொருள்","Invite_user_to_join_channel":"இந்த சேனல் சேர ஒரு அழை","Invite_Users":"அழைக்கவும்","is_also_typing":"அவர்கள் தட்டச்சு செய்கிறார்கள்","is_also_typing_female":"மேலும் தட்டச்சு","is_also_typing_male":"மேலும் தட்டச்சு","is_typing":"அவர்கள் தட்டச்சு செய்கிறார்கள்","is_typing_female":"தட்டச்சு","is_typing_male":"தட்டச்சு","italics":"சாய்வு","join":"சேர","Join_audio_call":"ஆடியோ அழைப்பு சேர","Join_the_Community":"சமூகத்தில் சேர்","Join_the_given_channel":"கொடுக்கப்பட்ட சேனலுக்கு சேர","Join_video_call":"வீடியோ அழைப்பில் சேர்க","Joined":"Joined","Jump":"குதி","Jump_to_first_unread":"முதல் படிக்காத தாவிச்","Jump_to_message":"செய்தி தாவிச்","Jump_to_recent_messages":"சமீபத்திய செய்திகளின் செல்லவும்","Katex_Enabled":"Katex இயக்கப்பட்டது","Label":"லேபிள்","Language":"மொழி","Language_Version":"ஆங்கில பதிப்பு","Last_login":"கடைசி உள்நுழைவு","Last_message":"கடைசி செய்தி","Last_seen":"இறுதியாக பார்த்தது","Layout":"லேஅவுட்","Layout_Home_Body":"முகப்பு உடல்","Layout_Home_Title":"முகப்பு தலைப்பு","Layout_Login_Terms":"தேதி விதிமுறைகள்","Layout_Privacy_Policy":"தனியுரிமை கொள்கை","Layout_Sidenav_Footer":"பக்க ஊடுருவல் அடிக்குறிப்பு","Layout_Sidenav_Footer_description":"அடிக்குறிப்பு அளவு 260 X 70px உள்ளது","Layout_Terms_of_Service":"சேவை விதிமுறைகள்","LDAP":"LDAP,","LDAP_CA_Cert":"கலிபோர்னியா சான்றிதழ்","LDAP_Custom_Domain_Search":"விருப்ப இணைய தேடல்","LDAP_Custom_Domain_Search_Description":"ஜெர்மானிய மற்றும் இணைப்பு தகவல் நிர்வகிக்கிறது மற்றும் அந்த வடிவம் JSON ஒரு துண்டு: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"இயல்புநிலை களப்","LDAP_Description":"பல தளங்கள் மற்றும் சேவைகள் இடையே ஒரு கடவுச்சொல்லை பகிர்ந்து ஒரு வசதி - LDAP, பல நிறுவனங்கள் ஒற்றை அடையாளம் வழங்க பயன்படுத்த என்று ஒரு படிநிலை தரவுத்தள உள்ளது. https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication: மேம்பட்ட கட்டமைப்பு தகவல் மற்றும் உதாரணங்கள், எங்கள் விக்கி கலந்தாலோசிக்கவும்.","LDAP_Dn":"LDAP, டி.என்","LDAP_Domain_Base":"இணைய தளம்","LDAP_Domain_Base_Description":"பயனர்கள் மற்றும் குழுக்களுக்கு தேட வேண்டும் ஒரு LDAP உபபடிநிலை முழுவதும் தகுதியான டிஸ்டிங்கஷ்ட் நேம் (DN). நீங்கள் போன்ற பல சேர்க்க முடியும்; எனினும், ஒவ்வொரு குழு சேர்ந்தவை என்று பயனர்கள் அதே டொமைன் அடிப்படை வரையறுக்கப்பட்டிருக்க வேண்டும். நீங்கள் கட்டுப்படுத்தப்பட்ட பயனர் குழுக்கள் குறிப்பிட்டால், அந்த குழுக்கள் சேர்ந்தவை என்று பயனர்கள் மட்டுமே நோக்கம் இருக்கும். நாங்கள் உங்கள் டொமைன் தளமாக LDAP அடைவு கிளையின் மேல் நிலை குறிப்பிட மற்றும் அணுகல் கட்டுப்படுத்த தேடல் வடிகட்டி பயன்படுத்த பரிந்துரைக்கிறோம்.","LDAP_Domain_Search_Filter":"இணைய தேடல் வடிகட்டி","LDAP_Domain_Search_Filter_Description":"குறிப்பிட்ட, இந்த வடிகட்டி பொருந்தும் என்று பயனர்கள் மட்டுமே நுழைய அனுமதி வேண்டும் என்றால். எந்த வடிகட்டி குறிப்பிடப்பட்டால், குறிப்பிட்ட களப் அடிப்படை எல்லைக்குள் அனைத்து பயனர்கள் உள்நுழைய முடியும். <br/> ஆக்டிவ் டைரக்டரி எ.கா.: memberOf = CN = ROCKET_CHAT, OU = பொது Groups`. <br/> OpenLDAP ஆனது எ.கா (நீடிக்கவும் போட்டியில் தேடல்): OU: DN: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"இணைய தேடல் பொருள் வகை","LDAP_Domain_Search_Object_Category_Description":"உங்கள் பயனர் அடையாளம் என்று * objectCategory *. <br/> * OpenLDAP ஆனது * காலியாக விடவும். <br/> எ.கா: person`, முதலியன","LDAP_Domain_Search_Object_Class":"இணைய தேடல் பொருள் வகுப்பு","LDAP_Domain_Search_Object_Class_Description":"உங்கள் பயனர் அடையாளம் என்று * objectClass *. <br/> எ.கா: organizationalPerson`, `user`,` inetOrgPerson`, முதலியன","LDAP_Domain_Search_Password":"இணைய தேடல் கடவுச்சொல்","LDAP_Domain_Search_Password_Description":"டொமைன் தேடல் பயனர் கடவுச்சொல்லை.","LDAP_Domain_Search_User":"இணைய தேடல் பயனர்","LDAP_Domain_Search_User_Description":"அவர்கள் உள்நுழையும் போது மற்ற பயனாளிகள் அங்கீகரிக்க பயனர் தேடுதல்களும் செய்கிறது என்று, LDAP பயனர். <br/> இது பொதுவாக மூன்றாம் தரப்பு ஒருங்கிணைவு குறிப்பாக உருவாக்கப்பட்ட ஒரு சேவை கணக்கு உள்ளது. ஒரு முழு தகுதி பெயரை பயன்படுத்த, அத்தகைய CN = நிர்வாகி `என, cn = பயனர்கள், DC = example, dc = com`.","LDAP_Domain_Search_User_ID":"இணைய தேடல் பயனர் ஐடி","LDAP_Domain_Search_User_ID_Description":"அங்கீகார முயலும், LDAP பயனர் அடையாளம் என்று ஒரு LDAP பண்பு. இந்த துறையில் `மிக ஆக்டிவ் டைரக்டரி நிறுவலுக்கு sAMAccountName` இருக்க வேண்டும், ஆனால் இது போன்ற OpenLDAP ஆனது போல் மற்ற LDAP, தீர்வுகள், ரூபாய் uid` இருக்கலாம். நீங்கள் மின்னஞ்சல் அல்லது என்ன பண்பு நீங்கள் விரும்பும் மூலம் பயனர் அடையாளம்: mail` பயன்படுத்த முடியும். <br> நீங்கள் செய்த பயனர் பெயர் அல்லது மின்னஞ்சல் போன்ற பல அடையாளங்காட்டிகளானது பயன்படுத்தி உள்நுழைய அனுமதிக்க கமா பிரிக்கப்பட்ட பல மதிப்புகள் பயன்படுத்த முடியும்.","LDAP_Enable":"இயக்கு","LDAP_Enable_Description":"அங்கீகார க்கான LDAP பயன்படுத்த முயற்சிக்கும்.","LDAP_Encryption":"குறியாக்க","LDAP_Encryption_Description":"குறியாக்க முறையை LDAP சர்வரை பாதுகாப்பான தகவல் பயன்படுத்தப்படுகிறது. எடுத்துக்காட்டுகள்: plain` (எந்த குறியாக்க), `, SSL / LDAPS` (தொடக்கத்தில் இருந்து குறியாக்கம்), மற்றும்` StartTLS` (ஒருமுறை இணைக்கப்பட்ட மறைகுறியாக்கப்பட்ட தொடர்பு மேம்படுத்த) ஆகியவை அடங்கும்.","LDAP_Host":"தொகுப்பாளர்","LDAP_Host_Description":"LDAP, புரவலன், எ.கா.: ldap.example.com` அல்லது `10.0.0.30`.","LDAP_Port":"போர்ட்","LDAP_Port_Description":"போர்ட் என்பது LDAP அணுக. எ.கா.: `389` அல்லது` 636` LDAPS க்கான","LDAP_Reject_Unauthorized":"அங்கீகரிக்கப்படாத நிராகரி","LDAP_Sync_User_Avatar":"ஒத்திசைவு பதிவர்","LDAP_Sync_User_Data":"ஒத்திசைவு தரவு","LDAP_Sync_User_Data_Description":"உள்நுழைவு சர்வர் ஒத்திசைந்து பயனர் தரவை வைத்திருக்கவும் (எ.கா.: பெயர், மின்னஞ்சல்).","LDAP_Sync_User_Data_FieldMap":"பயனர் தகவல்கள் களம் வரைபடம்","LDAP_Sync_User_Data_FieldMap_Description":"பயனர் கணக்கு துறைகள் (மின்னஞ்சல் போன்ற) LDAP இல் ஒரு சாதனை இருந்து மக்கள் எப்படி கட்டமைக்க (ஒரு முறை காணப்படுகிறது). <br/> உதாரணமாக, `{\" cn \"என்பது:\" பெயர் \",\" மெயில் \":\" மின்னஞ்சல் \"}: CN பண்பு இருந்து ஒரு நபரின் மனித வாசிக்கக்கூடிய பெயர், மற்றும் மெயில் பண்பு தங்கள் மின்னஞ்சல் தேர்வு செய்யும். <br/> கிடைக்க துறைகள் name`, மற்றும் `email` அடங்கும்:.","LDAP_Sync_Users":"ஒத்திசைவு பயனர்கள்","LDAP_Test_Connection":"சோதனை இணைப்பு","LDAP_Unique_Identifier_Field":"தனித்துவ அடையாளங்காட்டி களம்","LDAP_Unique_Identifier_Field_Description":"எந்த துறையில், LDAP பயனர் மற்றும் Rocket.Chat பயனர் இணைக்க பயன்படுத்தப்படும். நீங்கள் ஒரு LDAP சாதனை இருந்து மதிப்பு பெற முயற்சி செய்ய கமா பிரிக்கப்பட்ட பல மதிப்புகள் தெரிவிக்க முடியும். <br/> இயல்புநிலை மதிப்பு `objectGUID, IBM-என்ட்ரி UUID, GUID அகம், dominoUNID, nsuniqueId, uidNumber` ஆகும்","LDAP_Use_Custom_Domain_Search":"விருப்ப இணைய தேடல் பயன்படுத்தவும்","LDAP_Use_Custom_Domain_Search_Description":"LDAP சர்வர் உள்ள பயனர்கள் தேட உங்கள் சொந்த வடிகட்டி எழுது.","LDAP_Username_Field":"பயனர்பெயர் துறையில்","LDAP_Username_Field_Description":"எந்த துறையில் * பயனர் பெயர் * புதிய பயனர்கள் பயன்படுத்தப்படும். உள்நுழைவு பக்கத்தில் தகவல் பயனர் பெயர் பயன்படுத்த காலியாக விடவும். <br/> நீங்கள் `# {givenName} போல், மிக டெம்ப்ளேட் குறிச்சொற்களை பயன்படுத்த முடியும். # {SN}:. <br/> இயல்புநிலை மதிப்பு `sAMAccountName` உள்ளது.","Leave_Group_Warning":"குழு \" %s\" பதில் விட்டு வெளியேற வேண்டும் என்பதில் உறுதியாக இருக்கிறீர்களா?","Leave_Private_Warning":"நீங்கள் \" %s\" பதில் மூலம் விவாதம் விட்டு வெளியேற வேண்டும் நீங்கள் உறுதியாக இருக்கிறீர்களா?","Leave_room":"அறையை விட்டுச்செல்","Leave_Room_Warning":"நீங்கள் அறையில் \" %s\" பதில் விட்டு வெளியேற வேண்டும் என்பதில் உறுதியாக இருக்கிறீர்களா?","line":"வரி","List_of_Direct_Messages":"நேரடி செய்திகள் பட்டியல்","Live_sessions":"நேரடி அமர்வுகள்","Livechat_agents":"livechat முகவர்","Livechat_Dashboard":"livechat டாஷ்போர்டு","Livechat_enabled":"livechat செயல்படுத்தப்படும்","Livechat_Manager":"livechat மேலாளர்","Livechat_managers":"livechat மேலாளர்கள்","Livechat_title":"livechat தலைப்பு","Livechat_title_color":"Livechat தலைப்பு பின்புல வண்ணம்","Livechat_Users":"livechat பயனர்கள்","Load_more":"மேலும் ஏற்றுக","Loading...":"ஏற்றுதல்...","Loading_more_from_history":"வரலாற்றில் இருந்து மேலும் ஏற்றுகிறது","Loading_suggestion":"பரிந்துரைகளை ஏற்றுகிறது ...","Localization":"பரவல்","Log_File":"கோப்பு மற்றும் வரி காட்டு","Log_Level":"பதிவு அளவு","Log_Package":"தொகுப்பு காட்டு","Log_View_Limit":"பார்வை வரம்பை உள்நுழைய","Logged_out_of_other_clients_successfully":"வெற்றிகரமாக மற்ற வாடிக்கையாளர்கள் வெளியேற்றப்படுவீர்கள்","Login":"உள் நுழை","Login_with":" %s கொண்டு உள்நுழை","login_with":"அல்லது நேரடியாக உள்நுழைய","Logout":"வெளியேறு","Logout_Others":"பிற வெளியேற்ற இருந்து வெளியேறு இடங்களில்","Mail_Message_Invalid_emails":"நீங்கள் இன்னும் ஒன்று அல்லது தவறான மின்னஞ்சல்கள் வழங்கிய %s:","Mail_Message_Missing_to":"நீங்கள் ஒன்று அல்லது அதற்கு மேற்பட்ட பயனர்கள் தேர்ந்தெடுத்து அல்லது ஒன்று அல்லது அதற்கு மேற்பட்ட மின்னஞ்சல் முகவரிகளை, பிரிக்கப்பட்ட வழங்க வேண்டும்.","Mail_Message_No_messages_selected_select_all":"நீங்கள் எந்த செய்திகளை தேர்ந்தெடுக்கவில்லை. நீங்கள் விரும்புகிறீர்களா <a href='#' class='select-all'>அனைத்து தேர்ந்தெடுக்க</a> தெரியும் செய்திகளை?","Mail_Messages":"மின்னஞ்சல் செய்திகளை","Mail_Messages_Instructions":"செய்திகள், கிளிக் செய்து நீங்கள் மின்னஞ்சல் வழியாக அனுப்ப வேண்டும் இது செய்திகளை தேர்வு","Mail_Messages_Subject":"இங்கே %s செய்திகள் ஒரு தேர்ந்தெடுத்த பகுதியை தான்","Mailer":"வரியாகும்","Mailer_body_tags":"நீங்கள் சந்தா இணைப்பு [சந்தாவிலகு] பயன்படுத்த <b>வேண்டும்.</b> <br /> முறையே பயனர் முழு பெயர், முதல் பெயர் அல்லது கடைசி பெயரை நீங்கள் [பெயர்], [fname], பயன்படுத்தலாம் [lname]. <br /> நீங்கள் பயனர் மின்னஞ்சல் ஐந்து [மின்னஞ்சல்] பயன்படுத்தலாம்.","Make_Admin":"நிர்வாகம் செய்ய","Manager_added":"மேலாளர் சேர்க்கப்பட்டது","Manager_removed":"மேலாளர் நீக்கப்பட்டது","Mark_as_read":"படித்ததாக","Markdown_Headers":"markdown தலைப்புகளிலும்","Markdown_SupportSchemesForLink":"இணைப்பு markdown ஆதரவு திட்டங்கள்","Markdown_SupportSchemesForLink_Description":"அனுமதி திட்டங்கள் கமாவால் பிரிக்கப்பட்ட பட்டியல்","Members_List":"உறுப்பினர்கள் பட்டியல்","Mentions":"குறிப்பிடுகிறார்","Mentions_default":"குறிப்பிடுகிறார் (இயல்புநிலை)","Message":"செய்தி","Message_AllowDeleting":"அனுமதி செய்தியை நீக்கும்போது","Message_AllowEditing":"அனுமதி செய்தி எடிட்டிங்","Message_AllowEditing_BlockEditInMinutes":"பிளாக் செய்தி எடிட்டிங் (N) நிமிடங்களுக்கு பிறகு","Message_AllowEditing_BlockEditInMinutesDescription":"தடுப்பதை முடக்க 0 உள்ளிடவும்.","Message_AllowPinning":"அனுமதி செய்தி பின் செய்வதனால்","Message_AllowPinning_Description":"அனுமதி செய்திகளை சேனல்களில் எந்த பொருத்தப்பட்டன வேண்டும்.","Message_AllowStarring":"செய்தி Starring அனுமதி","Message_AudioRecorderEnabled":"ஆடியோ ரெக்கார்டர் இயக்கப்பட்டது","Message_AudioRecorderEnabledDescription":"தேவைப்படுகிறது 'ஆடியோ / WAV' கோப்புகளை 'கோப்பு பதிவேற்றம்' அமைப்புகளில் உள்ள ஏற்றுக்கொள்ளப்பட்ட ஊடக வகை இருக்க வேண்டும்.","Message_DateFormat":"தேதி வடிவமைப்பு","Message_DateFormat_Description":"மேலும் காண்க: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">moment.js</a>","Message_deleting_not_allowed":"செய்தி அனுமதி இல்லை நீக்குகிறது","Message_editing_blocked":"இந்த செய்தி இனி திருத்த முடியாது","Message_editing_not_allowed":"செய்தி எடிட்டிங் அனுமதி இல்லை","Message_GroupingPeriod":"காலம் (விநாடிகளில்) தொகுத்தல்","Message_GroupingPeriodDescription":"இருவரும் ஒரே பயனர் இருந்து மற்றும் நேரம் கழிந்ததும் நொடிகளில் தகவலறிந்த நேரம் குறைவாக இருந்தால் செய்திகள் முந்தைய செய்தி குழுவாக வேண்டும்.","Message_KeepHistory":"செய்தி வரலாறு வைத்து","Message_MaxAllowedSize":"அனுமதிக்கப்பட்ட அதிகபட்ச செய்தி அளவு","Message_MaxAll":"அனைத்து செய்தி அதிகபட்ச சேனல் அளவு","Message_pinned":"செய்தி பொருத்தப்பட்டன","Message_pinning_not_allowed":"செய்தி அனுமதி இல்லை செய்வதில்","Message_removed":"செய்தி நீக்கப்பட்டது","Message_ShowDeletedStatus":"நீக்கப்பட்ட நிலையை காட்ட","Message_ShowEditedStatus":"திருத்தப்பட்ட நிலையை காட்ட","Message_ShowFormattingTips":"ஃபார்மாட்டிங் டிப்ஸ் காட்டு","Message_TimeFormat":"நேர வடிவம்","Message_TimeFormat_Description":"மேலும் காண்க: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">moment.js</a>","Message_too_long":"நீண்ட செய்தி","Messages":"செய்திகள்","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"உள்வரும் WebHook அனுப்பப்படும் என்று செய்திகள் இங்கே வெளியிடப்படும்.","Meta":"மெட்டா","Meta_fb_app_id":"Facebook ஆப் ஐடி","Meta_google-site-verification":"Google தள சரிபார்ப்பு","Meta_language":"மொழி","Meta_msvalidate01":"MSValidate.01","Meta_robots":"ரோபோக்கள்","minutes":"நிமிடங்கள்","Mobile_push":"மொபைல் மிகுதி","More_channels":"மேலும் பொது குழுக்கள்","More_direct_messages":"மேலும் நேரடி செய்திகளை","More_groups":"மேலும் தனியார் குழுக்கள்","More_unreads":"மேலும் unreads","Msgs":"செய்திகள்","multi":"பல","Mute_someone_in_room":"அறையில் முடக்கு யாரோ","Mute_user":"முடக்கு பயனர்","Muted":"முடக்கியது","My_Account":"என் கணக்கு","n_messages":"% செய்திகள்","N_new_messages":"% கள் புதிய செய்திகள்","Name":"பெயர்","Name_cant_be_empty":"பெயர் வெறுமையாக இருக்க முடியாது","Name_of_agent":"முகவர் பெயர்","Name_optional":"பெயர் (விரும்பினால்)","Navigation_History_20_last_pages":"வழிநடத்தல் வரலாறு (20 இறுதி பக்கங்களில்)","New_Application":"புதிய விண்ணப்ப","New_Custom_Field":"புதிய தனிபயன் துறையில்","New_Department":"புதிய துறை","New_integration":"புதிய ஒருங்கிணைப்பு","New_logs":"புதிய பதிவுகள்","New_messages":"புதிய செய்திகள்","New_password":"புதிய கடவுச்சொல்","New_role":"புதிய பங்கு","No_channel_with_name_%s_was_found":"பெயர் <strong>\" %s\" பதில்</strong> எதுவும் கிடைக்கவில்லை இருந்தது!","No_channels_yet":"நீங்கள் இதுவரை எந்த பொது குழுவிலும் இல்லை.","No_direct_messages_yet":"நீங்கள் இதுவரை எந்த உரையாடலும் ஆரம்பிக்கவே இல்லை.","No_Encryption":"மறைகுறியாக்கப்படவில்லை","No_favorites_yet":"நீங்கள் இதுவரை எந்த பிடித்தவையும் சேர்க்கவில்லை.","No_group_with_name_%s_was_found":"பெயர் <strong>\" %s\" பதில்</strong> கொண்டு தனியார் குழு கண்டுபிடிக்கப்பட்டது!","No_groups_yet":"நீங்கள் இதுவரை எந்த தனியார் குழுவிலும் இல்லை.","No_livechats":"நீங்கள் எந்த livechats வேண்டும்.","No_mentions_found":"எதுவும் இல்லை குறிப்பிடுகிறார்","No_permission_to_view_room":"நீங்கள் இந்த அறையில் பார்வையிட அனுமதி இல்லை","No_pinned_messages":"பொருத்தப்பட்டன செய்திகளை இல்லை","No_results_found":"முடிவுகள் எதுவும் இல்லை","No_starred_messages":"குறியிடப்பட்ட மின்னஞ்சலும் இல்லை","no_tokens_for_this_user":"இந்தப் பயனருக்கு டோக்கன்கள் உள்ளன","No_user_with_username_%s_was_found":"பயனர் பெயர் <strong>\" %s\" பதில்</strong> பயனர் எவரையும் கண்டுபிடிக்கப்பட்டது!","Not_allowed":"அனுமதி இல்லை","Not_authorized":"அங்கீகாரம் இல்லை","Not_Available":"கிடைக்கவில்லை","Not_found_or_not_allowed":"கிடைக்கவில்லை அல்லது அனுமதிக்க முடியாது","Nothing":"எதுவும்","Nothing_found":"எதுவும் காணப்படவில்லை","Notifications":"அறிவிப்புகள்","Notify_all_in_this_room":"இந்த அறையில் தெரிவி","Num_Agents":"# முகவர்கள்","Number_of_messages":"செய்திகளின் எண்ணிக்கை","OAuth_Application":"அறிந்திருந்தால் விண்ணப்ப","OAuth_Applications":"அறிந்திருந்தால் பயன்பாடுகள்","Objects":"பொருள்கள்","Off_the_record_conversation":"பதிவில் உரையாடல்","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"பதிவில் உரையாடல் உங்களது உலாவி அல்லது சாதனம் கிடைக்கவில்லை.","Offline_DM_Email":"[__site__] நீங்கள் நேரடி __user__ மூலம் குறுஞ்செய்தி வருகின்றன","Offline_Mention_Email":"[__site__] நீங்கள் #__room__ உள்ள __user__ குறிப்பிட்டுள்ள","Old_and_new_password_must_be_different":"புதிய கடவுச்சொல் பழைய கடவுச்சொல்லை வித்தியாசமாக இருக்க வேண்டும்.","Old_and_new_password_required":"உங்கள் கடவுச்சொல்லை மாற்றியதன் பழைய மற்றும் புதிய கடவுச்சொல்லை இரண்டு வழங்க வேண்டும்.","Online":"ஆன்லைன்","Only_errors":"பிழைகளை மட்டும்","Only_you_can_see_this_message":"நீ மட்டும் தான் இந்த செய்தியை பார்க்க முடியும்","Oops!":"அச்சச்சோ","Open":"திறந்த","Opened":"திறக்கப்பட்ட","Opt_out_statistics":"என் புள்ளி Rocket.Chat அனுப்ப வேண்டாம்","Opt_out_statistics_warning":"உங்கள் புள்ளிவிவரங்களை அனுப்புவதன் மூலம், நீங்கள் அமைப்பு நடந்துக்குறா.நீ எப்படி நல்ல போன்ற Rocket.Chat பல சந்தர்ப்பங்களில் அமைக்கப்படுகின்றன எப்படி நம்மை அடையாளம், அதே உதவ வேண்டும், நாம் அதை மேலும் மேம்படுத்த முடியும். எந்த பயனர் தகவல்கள் அனுப்பப்படும் நாம் பெறும் அனைத்து தகவல்கள் பாதுகாப்பாக வைக்கப்பட்டு, கவலைப்பட வேண்டாம். நீங்கள் எங்களுக்கு உங்கள் புள்ளிவிவரங்களை அனுப்புவதன் தொடர விரும்பினால், மேலுள்ள தேர்வு பெட்டியைத் தேர்ந்தெடுக்கவும். நன்றி.","optional":"விருப்ப","Order":"ஆணை","OS_Arch":"ஓஎஸ் ஆர்க்","OS_Cpus":"ஓஎஸ் சிபியு கவுண்ட்","OS_Freemem":"ஓஎஸ் இலவச நினைவகம்","OS_Loadavg":"ஓஎஸ் சுமை சராசரி","OS_Platform":"OS மேடையில்","OS_Release":"OS வெளியீட்டு","OS_Totalmem":"ஓஎஸ் மொத்த நினைவு","OS_Type":"ஓஎஸ் வகை","OS_Uptime":"ஓஎஸ் இயக்க","others":"மற்றவர்கள்","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"இரண்டு பயனர்கள் ஆன்லைனில் இருக்கும் போது OTR மட்டுமே உள்ளது","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"மீறு URL ஐ கோப்புகளை பதிவேற்றப்படும் வேண்டும். ஒரு வலம்புரி வரை இறக்கம் பயன்படுத்தப்படும் இந்த URL வழங்கப்படும்","Password":"கடவுச்சொல்","Password_Change_Disabled":"உங்கள் Rocket.Chat நிர்வாகி கடவுச்சொற்களை மாறிவரும் முடக்கியுள்ளது","Password_changed_successfully":"கடவுச்சொல் வெற்றிகரமாக மாற்றப்பட்டது","Payload":"பேலொட்","People":"மக்கள்","Permissions":"அனுமதிகள்","Pin_Message":"முள் செய்தி","Pinned_a_message":"ஒரு செய்தியை பொருத்தப்பட்டன:","Pinned_Messages":"பொருத்தப்பட்டன செய்திகள்","Placeholder_for_email_or_username_login_field":"மின்னஞ்சல் அல்லது பயனர் பெயர் உள்நுழைவு துறையில் பெட்டிக்கு","Placeholder_for_password_login_field":"கடவுச்சொல்லை உள்நுழைவு துறையில் பெட்டிக்கு","Please_answer_survey":"இந்த அரட்டை பற்றி ஒரு விரைவான கணக்கெடுப்பு பதில் ஒரு கணம் எடுத்து கொள்ளவும்","Please_enter_value_for_url":"தயவு செய்து உங்கள் சின்னம் URL ஐ ஒரு மதிப்பை உள்ளிடவும்.","Please_enter_your_new_password_below":"தயவு செய்து உங்கள் புதிய கடவுச்சொல்லை கீழே உள்ளிடவும்:","Please_fill_a_label":"ஒரு லேபிள் பூர்த்தி செய்து","Please_fill_a_name":"ஒரு பெயர் பூர்த்தி செய்து","Please_fill_a_username":"ஒரு பயனர் பெயர் பூர்த்தி செய்து","Please_fill_name_and_email":"பெயர் மற்றும் மின்னஞ்சல் பூர்த்தி செய்து","Please_re_enter_your_password":"தயவு செய்து உங்கள் கடவுச்சொல்லை மீண்டும் உள்ளிட","Please_select_enabled_yes_or_no":"இயக்கப்பட்டது ஒரு விருப்பத்தை தேர்ந்தெடுக்கவும்","Please_wait":"தயவு செய்து காத்திருக்கவும்","Please_wait_activation":"இந்த சில நேரம் ஆகலாம், தயவு செய்து காத்திருக்கவும்.","Please_wait_statistics":"காத்திருக்கவும், புள்ளிவிவரங்களை உருவாக்கமுடியும் வருகின்றன.","Please_wait_while_OTR_is_being_established":"OTR நிறுவப்பட உள்ளது தயவு செய்து காத்திருக்கவும்","Please_wait_while_your_account_is_being_deleted":"உங்கள் கணக்கு நீக்கப்படும் வரை காத்திருக்கவும் ...","Please_wait_while_your_profile_is_being_saved":"உங்கள் விவரங்களை சேமிக்க வருகிறது காத்திருக்கவும் ...","Post_as":"போஸ்ட் போன்ற","Post_to_Channel":"சேனல் பதவியை","Post_to_s_as_s":"<strong>போஸ்ட்% <strong>s%</strong></strong> <strong>கள்</strong>","Powered_by":"மூலம் இயக்கப்படுகிறது","Preferences":"விருப்பங்கள்","Preferences_saved":"விருப்பங்கள் சேமிக்கப்படும்","Privacy":"தனியுரிமை","Private_Group":"தனியார் குழு","Private_Groups":"தனியார் குழுக்கள்","Private_Groups_list":"தனியார் குழுக்கள் பட்டியல்","Profile":"பதிவு செய்தது","Profile_saved_successfully":"பதிவு செய்தது வெற்றிகரமாக சேமிக்க","Proudly_developed":"பெருமையுடன் விண்கற்கள் உருவாக்கப்பட்டது","Push":"புஷ்","Push_apn_cert":"APN ஆனது சான்றிதழ்","Push_apn_dev_cert":"APN ஆனது தேவ் சான்றிதழ்","Push_apn_dev_key":"APN ஆனது தேவ் முக்கிய","Push_apn_dev_passphrase":"APN ஆனது தேவ் கடவுச்சொற்றொடர்","Push_apn_key":"APN ஆனது முக்கிய","Push_apn_passphrase":"APN ஆனது கடவுச்சொற்றொடர்","Push_debug":"பிழைதிருத்து","push_disabled":"தள்ளு ஊனமுற்ற","Push_enable":"இயக்கு","Push_enable_gateway":"நுழைவாயில் செயல்படுத்த","Push_gateway":"நுழைவாயில்","Push_gcm_api_key":"GCM API விசை","Push_gcm_project_number":", GCM திட்ட எண்","Push_production":"உற்பத்தி","Push_show_message":"அறிவிப்பை செய்தி காட்டு","Push_show_username_room":"சேனல் / குழு / அறிவிப்பு பயனர்பெயர்","Push_test_push":"டெஸ்ட்","Query":"கேள்வி","Query_description":"மின்னஞ்சல் அனுப்ப செய்த தீர்மானிப்பதற்கான கூடுதல் நிலைமைகள். குழுவிலக்கப்பட்ட பயனர் தானாகவே கேள்வி நீக்கப்படும். அது சரியான JSON இருக்க வேண்டும். உதாரணம்: \"{\" createdAt \": {\" $ ஜிடி \": {\" $ தேதி \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"விரைவு தேடல்","quote":"மேற்கோள்","Reactions":"எதிர்வினைகள்","Recents":"சமீபத்தியவை","Record":"பதிவு","Redirect_URI":"URI இனை திருப்பி","Refresh_keys":"புதுப்பிப்பு விசைகளை","Refresh_your_page_after_install_to_enable_screen_sharing":"திரை பகிர்வு செயல்படுத்த நிறுவ பின்னர் உங்கள் பக்கம் புதுப்பிக்க","Register":"ஒரு புதிய கணக்கு பதிவு","Registration_Succeeded":"பதிவு முன்னவர்","Remember_me":"என்னை நினைவில் வை","Remove":"அகற்று","Remove_Admin":"நிர்வாகம் அகற்று","Remove_as_moderator":"நடுவராக நீக்க","Remove_as_owner":"உரிமையாளர் நீக்க","Remove_custom_oauth":"விருப்ப OAuth நீக்க","Remove_from_room":"அறையில் இருந்து நீக்க","Remove_someone_from_room":"அறையில் இருந்து யாரோ நீக்க","Removed":"நீக்கப்பட்ட","Require_password_change":"கடவுச்சொல் மாற்றம் தேவைப்படும்","Resend_verification_email":"சரிபார்ப்பு மின்னஞ்சலை மீண்டும் அனுப்புக","Reset":"மீட்டமை","Reset_password":"கடவுச்சொல்லை மீட்டமைக்க","Restart":"மறுதொடக்கம்","Restart_the_server":"சர்வர் மறுதொடக்கம்","RocketBot_Enabled":"RocketBot இயக்கப்பட்டது","RocketBot_Name":"RocketBot பெயர்","RocketBot_Name_Description":"RocketBot பெயர் உங்கள் சர்வரில் பதிவு சரியான பயனர் பெயர் இருக்க வேண்டும்.","Role":"பங்கு","Role_Editing":"பங்கு எடிட்டிங்","Role_removed":"பதவி நீக்கப்பட்டது","Room":"அறை","Room_archivation_state":"நிலை","Room_archivation_state_false":"செயலில்","Room_archivation_state_true":"காப்பகப்படுத்தியவை","Room_archived":"அறை காப்பகப்படுத்தப்படாது","room_changed_privacy":"<em>__user_by__</em> மூலம் <em>__room_type__:</em> அறை வகை மாற்ற","room_changed_topic":"<em>__user_by__</em> மூலம் <em>__room_topic__:</em> அறை தலைப்பை மாற்றப்பட்டது","Room_has_been_deleted":"அறை நீக்கப்பட்டுள்ளது","Room_Info":"அறை தகவல்","Room_name_changed":"அறை பெயர் மாற்றப்பட்டது: <em>__room_name__</em>மற்றியவர் <em>__user_by__</em>","Room_name_changed_successfully":"அறை பெயர் வெற்றிகரமாக மாற்றப்பட்டது","Room_not_found":"அறை இல்லை","Room_topic_changed_successfully":"அறை தலைப்பை வெற்றிகரமாக மாற்றப்பட்டது","Room_type_changed_successfully":"அறை வகை வெற்றிகரமாக மாற்றப்பட்டது","Room_unarchived":"மீட்டெடுக்கப்பட்டது அறை","Room_uploaded_file_list":"கோப்புகள் பட்டியல்","Room_uploaded_file_list_empty":"எந்த கோப்புகளை கிடைக்கும்.","room_user_count":"% பயனர்களால்","Rooms":"மனை","S_new_messages_since_s":"% கள் என்பதால்% கள் புதிய செய்திகள்","SAML":"SAML","SAML_Custom_Cert":"விருப்ப சான்றிதழ்","SAML_Custom_Entry_point":"விருப்ப நுழைவு புள்ளி","SAML_Custom_Generate_Username":"பயனர் பெயர் உருவாக்குதல்","SAML_Custom_Issuer":"விருப்ப வழங்குபவர்","SAML_Custom_Provider":"விருப்ப வழங்குநர்","Save":"சேமி","Save_changes":"மாற்றங்களை சேமியுங்கள்","Save_Mobile_Bandwidth":"மொபைல் அலைவரிசை சேமி","Save_to_enable_this_action":"இந்த நடவடிக்கை செயல்படுத்த சேமிக்கவும்","Saved":"சேமித்த","Saving":"சேமிப்பு","Scope":"நோக்கம்","Screen_Share":"திரையில் பகிர்ந்து","Script_Enabled":"ஸ்கிரிப்ட்","Search":"தேடு","Search_by_username":"பயனர் பெயர் மூலம் தேடல்","Search_Channels":"தேடல் சேனல்கள்","Search_Direct_Messages":"நேரடி செய்திகள் தேடல்","Search_Messages":"தேடல் செய்திகள்","Search_Private_Groups":"தனியார் குழுக்கள் தேடல்","Search_settings":"தேடல் அமைப்புகள்","seconds":"விநாடிகள்","See_all":"அனைத்தையும் பார்க்க","See_only_online":"ஆன்லைன் ","Select_a_department":"துறையைத் தேர்ந்தெடுக்கவும்","Select_an_avatar":"தோற்றத்தைத் தேர்ந்தெடுக்கவும்","Select_file":"கோப்பு தேர்வு","Select_service_to_login":"உங்கள் படத்தை ஏற்ற அல்லது உங்கள் கணினியில் இருந்து நேரடியாக ஒரு பதிவேற்ற உள்நுழைய சேவையைத் தேர்ந்தெடு","Select_user":"பயனர் தேர்வு","Select_users":"பயனர்கள் தேர்வு","Selected_agents":"தேர்ந்தெடுக்கப்பட்ட முகவர்","Selected_users":"தேர்ந்தெடுக்கப்பட்டவர்கள்","Send":"அனுப்பு","Send_a_message":"ஒரு செய்தியை அனுப்ப","Send_a_test_mail_to_my_user":"என் பயனர் ஒரு சோதனை மின்னஞ்சல் அனுப்பவும்","Send_a_test_push_to_my_user":"என் பயனர் ஒரு சோதனை மிகுதி அனுப்ப","Send_confirmation_email":"உறுதிப்படுத்தும் மின்னஞ்சல் அனுப்பவும்","Send_data_into_RocketChat_in_realtime":"நிகழ் நேரத்தில் ஒரு Rocket.Chat தரவு அனுப்பவும்.","Send_email":"மின்னஞ்சல் அனுப்பு","Send_invitation_email":"அழைப்பை மின்னஞ்சல் அனுப்பவும்","Send_invitation_email_error":"நீங்கள் எந்த சரியான மின்னஞ்சல் முகவரியை கொடுக்கவில்லை.","Send_invitation_email_info":"நீங்கள் ஒரே நேரத்தில் பல மின்னஞ்சல் அழைப்புகளை அனுப்ப முடியும்.","Send_invitation_email_success":"நீங்கள் வெற்றிகரமாக பின்வரும் முகவரிகள் ஒரு அழைப்பு மின்னஞ்சலை அனுப்பி விட்டோம்:","Send_invitation_email_warning":"அழைப்பை மின்னஞ்சல்களை அனுப்ப பொருட்டு, நீங்கள் முதல் SMTP அமைப்புகளை கட்டமைக்க வேண்டும்.","Send_Message":"செய்தியை அனுப்பவும்","Send_your_JSON_payloads_to_this_URL":"இந்த URL உங்கள் JSON தரவுகளைப் அனுப்பவும்.","Sending":"அனுப்புகிறது ...","Set_as_moderator":"மதிப்பீட்டாளர் அமை","Set_as_owner":"உரிமையாளர் அமை","Settings":"அமைப்புகள்","Settings_updated":"அமைப்புகள் மேம்படுத்தப்பட்டது","Should_be_a_URL_of_an_image":"ஒரு படத்தை ஒரு URL ஆக இருக்க வேண்டும்.","Should_exists_a_user_with_this_username":"பயனர் ஏற்கனவே இருக்க வேண்டும்.","Show_all":"அனைத்து காட்டு","Show_more":"மேலும் காட்ட","Show_only_online":"மட்டும் காட்டு ஆன்லைன்","Show_preregistration_form":"முன் பதிவு படிவத்தை காட்டு","Showing_archived_results":"<p> <b> %s</b> ஐக் காட்டுகிறது காப்பகப் முடிவுகள் </p>","Showing_online_users":"__total__ செய்த <b>__total_showing__</b> காட்டும்","Showing_results":"<p> <b> %s</b> ஐக் காட்டுகிறது முடிவுகள் </p>","Silence":"சைலன்ஸ்","since_creation":"%s முதல்","Site_Name":"தளத்தின் பெயர்","Site_Url":"தள URL","Site_Url_Description":"உதாரணம்: https://chat.domain.com/","Skip":"செல்க","Smileys_and_People":"ஸ்மைலிக்கள் மற்றும் மக்கள்","SMTP":"SMTP,","SMTP_Host":"SMTP கணினிக்கு","SMTP_Password":"SMTP, கடவுச்சொல்","SMTP_Port":"SMTP, போர்ட்","SMTP_Test_Button":"டெஸ்ட் SMTP அமைப்புகள்","SMTP_Username":"SMTP, பயனர் பெயர்","Sound":"ஒலி","Star_Message":"ஸ்டார் செய்தி","Starred_Messages":"நட்சத்திரமிட்ட செய்திகள்","Start_audio_call":"ஆடியோ அழைப்பைத் தொடங்கவும்","Start_Chat":"தொடக்க சேட்","Start_of_conversation":"உரையாடல் தொடக்கம்","Start_OTR":"தொடக்க OTR","Start_video_call":"வீடியோ அழைப்பைத் தொடங்கு","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"தொடங்க <code class=\"inline\">%s</code> பயனர் அல்லது <code class=\"inline\">%s</code> தடத்திற்கு. உ + ம்: <code class=\"inline\">%s</code> அல்லது <code class=\"inline\">%s</code>","Statistics":"புள்ளியியல்","Stats_Active_Users":"செயல்படும் பயனர்கள்","Stats_Avg_Channel_Users":"சராசரி சேனல் பயனர்கள்","Stats_Avg_Private_Group_Users":"சராசரி தனியார் குழு பயனர்கள்","Stats_Away_Users":"விட்டு பயனர்கள்","Stats_Max_Room_Users":"மேக்ஸ் மனை பயனர்கள்","Stats_Non_Active_Users":"செயல்படா பயனர்கள்","Stats_Offline_Users":"ஆஃப்லைன் பயனர்கள்","Stats_Online_Users":"ஆன்லைன் பயனர்கள்","Stats_Total_Channels":"மொத்த சேனல்கள்","Stats_Total_Direct_Messages":"மொத்த நேரடி செய்தி மனை","Stats_Total_Messages":"மொத்த செய்திகள்","Stats_Total_Private_Groups":"மொத்த தனியார் குழுக்கள்","Stats_Total_Rooms":"மொத்த மனை","Stats_Total_Users":"மொத்த பயனர்கள்","Stop_Recording":"பதிவுசெய்வதை நிறுத்து","strike":"வேலைநிறுத்தம்","Subject":"பொருள்","Submit":"சமர்ப்பிக்கவும்","Success":"வெற்றி","Survey":"சர்வே","Survey_instructions":"உங்கள் திருப்தி படி ஒவ்வொரு கேள்விக்கும் விகிதம், 1 நீங்கள் முற்றிலும் திருப்தி இருக்கும் பொருள் மற்றும் 5 நீங்கள் முழுமையாக திருப்தி அடைந்த பொருள்.","Symbols":"சின்னங்களில்","Sync_success":"ஒத்திசைவு வெற்றி","Sync_Users":"ஒத்திசைவு பயனர்கள்","Test_Connection":"சோதனை இணைப்பு","Test_Desktop_Notifications":"டெஸ்ட் டெஸ்க்டாப் அறிவிக்கைகள்","Thank_you_for_your_feedback":"உங்கள் கருத்துக்கு நன்றி","The_application_name_is_required":"விண்ணப்ப பெயர் தேவை","The_channel_name_is_required":"சேனல் பெயர் தேவைப்படுகிறது","The_emails_are_being_sent":"மின்னஞ்சல்களை அனுப்பி வைக்கப்படுகின்றனர்.","The_field_is_required":"துறையில்% கள் தேவை.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"நாங்கள் ImageMagick அல்லது GraphicsMagick உங்கள் சர்வரில் நிறுவப்பட்ட கண்டறிய முடியாது, ஏனெனில் படஅளவை இயங்காது.","The_redirectUri_is_required":"redirecturi தேவை","The_server_will_restart_in_s_seconds":"சர்வர் %s வினாடிகள் மீண்டும் தொடங்கும்","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>அமைப்பை% <strong>s%</strong></strong> <strong>s</strong> கட்டமைக்க மற்றும் <strong>நீங்கள் %s</strong> அணுகும்!","The_user_will_be_removed_from_s":"பயனர் %s இலிருந்து நீக்கப்படும்","The_user_wont_be_able_to_type_in_s":"பயனர் தட்டச்சு %s முடியாது","Theme":"தீம்","theme-color-action-buttons-color":"செயல்கள் பொத்தான்கள் நிறம்","theme-color-active-channel-background-color":"செயலில் சேனல் பின்னணி வண்ணம்","theme-color-active-channel-font-color":"செயலில் சேனல் எழுத்துரு வண்ணம்","theme-color-blockquote-background":"தொகுதி ஒதுக்கீடு பின்னணி வண்ணம்","theme-color-clean-buttons-color":"சுத்தமான பொத்தான்கள் நிறம்","theme-color-code-background":"குறியீடு பின்னணி நிறம்","theme-color-code-border":"குறியீடு வண்ணம்","theme-color-code-color":"குறியீடு கலர்","theme-color-content-background-color":"உள்ளடக்க பின்புல வண்ணம்","theme-color-custom-scrollbar-color":"விருப்ப சுருள் கலர்","theme-color-info-active-font-color":"நடப்பு தகவல் எழுத்துரு வண்ணம்","theme-color-info-font-color":"தகவல் எழுத்துரு வண்ணம்","theme-color-input-font-color":"உள்ளீடு எழுத்துரு வண்ணம்","theme-color-link-font-color":"இணைப்பு எழுத்துரு வண்ணம்","theme-color-message-hover-background-color":"செய்தி ஹோவர் பி.ஜி. நிறம்","theme-color-primary-background-color":"முதன்மை பின்னணி வண்ணம்","theme-color-primary-font-color":"முதன்மை எழுத்துரு வண்ணம்","theme-color-quaternary-font-color":"குவாட்டர்னி எழுத்துரு வண்ணம்","theme-color-secondary-background-color":"பின்னணி வண்ணமாக","theme-color-secondary-font-color":"இரண்டாம் எழுத்துரு வண்ணம்","theme-color-smallprint-font-color":"சிறிய அச்சு எழுத்துரு வண்ணம்","theme-color-smallprint-hover-color":"சிறிய அச்சு வண்ணம்","theme-color-status-away":"அவே நிலைமை கலர்","theme-color-status-busy":"பிஸி நிலை கலர்","theme-color-status-offline":"அந்தஸ்து கலர்","theme-color-status-online":"ஆன்லைன் அந்தஸ்து கலர்","theme-color-tertiary-background-color":"மூன்றாம் நிலை பின்னணி வண்ணம்","theme-color-tertiary-font-color":"மூன்றாம் நிலை எழுத்துரு வண்ணம்","theme-color-unread-notification-color":"படிக்காத அறிவிப்புகள் கலர்","theme-custom-css":"தனிப்பயன் CSS","There_are_no_agents_added_to_this_department_yet":"இன்னும் இந்த துறை சேர்க்கப்பட்டது எந்த முகவர் உள்ளன.","There_are_no_integrations":"எந்த ஒருங்கிணைவு உள்ளன","There_are_no_users_in_this_role":"இந்த பாத்திரத்தில் பயனர் எவரும் இல்லை.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"மின்னஞ்சல் ஏற்கனவே பயன்படுத்தப்பட்டு வருகிறது மற்றும் பரிசோதனை செய்யப்படவில்லை. உங்கள் கடவுச்சொல்லை மாற்றவும்.","This_is_a_desktop_notification":"இந்த ஒரு டெஸ்க்டாப் அறிவிப்பு","This_is_a_push_test_messsage":"இந்த ஒரு உந்துதல் சோதனை செய்தியையும் ஆகும்","Time_in_seconds":"வினாடிகளில் நேரம்","Title_bar_color":"தலைப்பு பட்டியில் நிறம்","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"உங்கள் இணையதளத்தில் Rocket.Chat livechat நிறுவ நகல் மற்றும் கடந்த <strong></ உடல்></strong> உங்கள் தளத்தில் டேக் மேலே இந்த குறியீடு ஒட்டவும்.","To_users":"பயனர்களுக்கு","Topic":"தலைப்பு","Travel_and_Places":"சுற்றுலா & இடங்கள்","Trigger_removed":"தூண்டல் நீக்கப்பட்டது","Trigger_Words":"தூண்டுதல் வார்த்தைகள்","Triggers":"தூண்டுதல்கள்","True":"உண்மை","Type":"வகை","Type_your_new_password":"உங்கள் புதிய கடவுச்சொல்லை உள்ளிடவும்","Unarchive":"காப்பிடாதே","Unmute_someone_in_room":"அறை இயக்கு யாரோ","Unmute_user":"பயனர் தடுப்புநீக்கு","Unnamed":"பெயரிடப்படாத","Unpin_Message":"பொருத்தப்படாத செய்தி","Unread_Rooms":"படிக்காத மனை","Unread_Rooms_Mode":"படிக்காத மனை முறை","Unstar_Message":"ஸ்டார் நீக்க","Upload_file_question":"கோப்பை பதிவேற்ற?","Uploading_file":"கோப்பு ஏற்றுகிறது ...","Use_account_preference":"கணக்கு விருப்பத்தேர்வு பயன்படுத்தவும்","Use_Emojis":"பயன்பாட்டு ஈமோஜிகள்","Use_initials_avatar":"உங்கள் பயனர் பெயர் முதலெழுத்துகள் பயன்படுத்தவும்","use_menu":"உங்கள் அறைகள் மற்றும் அரட்டைகள் அணுக பக்க மெனுவை பயன்படுத்தவும்","Use_service_avatar":" %s Avatar பயன்படுத்தவும்","Use_this_username":"இந்த பயனர் பெயரை பயன்படுத்தவும்","Use_uploaded_avatar":"பதிவேற்றிய சின்னம் பயன்படுத்த","Use_url_for_avatar":"சின்னம் URL ஐ பயன்படுத்த","User__username__is_now_a_moderator_of__room_name_":"பயனர் __username__ இப்போது __room_name__ ஒரு மதிப்பீட்டாளர்","User__username__is_now_a_owner_of__room_name_":"பயனர் __username__ இப்போது __room_name__ ஒரு உரிமையாளர் ஆவார்","User__username__removed_from__room_name__moderators":"பயனர் __username__ __room_name__ நடுவர்களின் நீக்கப்பட்டது","User__username__removed_from__room_name__owners":"பயனர் __username__ __room_name__ உரிமையாளர்கள் இருந்து நீக்கப்பட்டது","User_added":"பயனர் <em>__user_added__</em>சேர்க்கப்பட்டார்.","User_added_by":"பயனர் <em>__user_added__</em><em>__user_by__</em>மூலம் சேர்க்கப்பட்டார்.","User_added_successfully":"பயனர் வெற்றிகரமாக சேர்க்கப்பட்டது","User_Channels":"பயனர் சேனல்கள்","User_doesnt_exist":"இல்லை பயனர்: @ %s` பெயர் உள்ளது.","User_has_been_activated":"பயனர் செயல்படுத்தப்படுகிறது","User_has_been_deactivated":"பயனர் செயலிழக்கப்பட்டது","User_has_been_deleted":"பயனர் நீக்கப்பட்ட","User_has_been_muted_in_s":"பயனர் %s இல் ஒலிமுடக்கப்பட்டது","User_has_been_removed_from_s":"பயனர் %s நீக்கப்பட்டது","User_has_disconnected":"பயனர் துண்டித்துள்ளது","User_Info":"பயனர் தகவல்","User_is_no_longer_an_admin":"பயனர் இனி ஒரு நிர்வாகம் உள்ளது","User_is_not_activated":"பயனர் செயல்படுத்தப்படுகிறது","User_is_now_an_admin":"பயனர் இப்போது ஒரு நிர்வாகம் உள்ளது","User_joined_channel":"சேனல் சேர்ந்துள்ளார்.","User_joined_channel_female":"சேனல் சேர்ந்துள்ளார்.","User_joined_channel_male":"சேனல் சேர்ந்துள்ளார்.","User_left":"பயனர் <em>__user_left__</em>சென்றுவிட்டார்.","User_left_female":"சேனல் போய்விட்டார்.","User_left_male":"சேனல் போய்விட்டார்.","User_logged_out":"பயனர் வெளியேற்றப்படுவீர்கள்","User_management":"பயனர் மேலாண்மை","User_muted_by":"பயனர் <em>__user_muted__</em> <em>__user_by__</em> முடக்கியது.","User_muted_in_room":"பயனர் அறையில் முடக்கியது","User_not_found":"பயனர் கிடைக்கவில்லை","User_not_found_or_incorrect_password":"பயனர் காணப்படவில்லை அல்லது தவறான கடவுச்சொல் இல்லை","User_or_channel_name":"பயனர் அல்லது சேனல் பெயர்","User_removed":"பயனர் அகற்றினார்","User_removed_by":"பயனர் <em>__user_removed__</em><em>__user_by__</em>மூலம் அகற்றப்பட்டார்.","User_removed_from_room":"பயனர் அறையில் இருந்து நீக்கப்பட்டது","User_Settings":"பயனர் அமைப்புகள்","User_unmuted_by":"பயனர் <em>__user_unmuted__</em> <em>__user_by__</em> மூலம் ஒலியை.","User_unmuted_in_room":"அறையில் தடுப்புநீக்கம்ப்பட்டார் பயனர்","User_updated_successfully":"பயனர் வெற்றிகரமாக மேம்படுத்தப்பட்டது","Username":"பயனர் பெயர்","Username_and_message_must_not_be_empty":"பயனர் பெயர் மற்றும் செய்தி காலியாக இருக்கக் கூடாது.","Username_cant_be_empty":"பயனர்பெயர் வெறுமையாக இருக்க முடியாது","Username_Change_Disabled":"உங்கள் Rocket.Chat நிர்வாகி பயனர் பெயர்கள் மாறிவரும் முடக்கியுள்ளது","Username_denied_the_OTR_session":"__username__ OTR அமர்வு மறுத்தார்","Username_description":"பயனர்பெயர் மற்றவர்கள் செய்திகளை நீங்கள் குறிப்பிட அனுமதிக்கப் பயன்படுத்தப்படுகிறது.","Username_doesnt_exist":"பயனர் பெயர்: %s` இல்லை.","Username_ended_the_OTR_session":"__username__ OTR அமர்வு முடிவடைந்த","Username_invalid":"<strong> %s</strong>தவறானது பயனர் பெயர், <br / >பயன்படுத்த எழுத்துகள், எண்கள், புள்ளிகளும் கோடுகளும்","Username_is_already_in_here":"`@ %s` இங்கே ஏற்கனவே உள்ளது.","Username_is_not_in_this_room":"பயனர் `# %s` இந்த அறையில் இல்லை.","Username_not_found":"பயனர் பெயர் காணப்படவில்லை","Username_title":"பயனர் பெயரை பதிவுசெய்","Username_unavaliable":"<strong> %s</strong>ஏற்கனவே பயன்பாட்டில் உள்ளது :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ OTR தொடங்க விரும்புகிறது. நீங்கள் ஏற்க விரும்புகிறீர்களா?","Users":"பயனர்கள்","Users_in_role":"பாத்திரத்தில் பயனர்கள்","UTF8_Names_Slugify":"UTF8 பெயர்கள் Slugify","UTF8_Names_Validation":"UTF8 பெயர்கள் மதிப்பீட்டு","UTF8_Names_Validation_Description":"சிறப்பு எழுத்துக்கள் மற்றும் இடைவெளிகள் அனுமதிக்க வேண்டாம். நீங்கள் பயன்படுத்த முடியும் - _ மற்றும். ஆனால் பெயர் இறுதியில்","Verification_email_sent":"சரிபார்ப்பு மின்னஞ்சல் அனுப்பப்பட்டது","View_All":"அனைத்தையும் பார்க்க","View_Logs":"காண்க பதிவுகள்","Visibility":"ஈரப்பதம்","Visible":"தெரியும்","Visitor":"வருகையாளர்","Visitor_page_URL":"பார்வையாளர் பக்கம் URL","Visitor_time_on_site":"தளத்தில் பார்வையாளர் நேரம்","Wait_activation_warning":"நீங்கள் உள்நுழைய முடியும் முன், உங்கள் கணக்கு நிர்வாகியால் மூலம் செயல்படுத்தப்படுகிறது வேண்டும்.","We_are_offline_Sorry_for_the_inconvenience":"நாம் லைனில் உள்ளனர். சிரமத்திற்கு வருந்துகிறோம்.","We_have_sent_password_email":"நாம் பாஸ்வேர்ட் ரீசெட் வழிமுறைகளை நீங்கள் ஒரு மின்னஞ்சலை அனுப்பி விட்டோம். நீங்கள் ஒரு மின்னஞ்சலை விரைவில் பெறுவீர்கள் இல்லை என்றால், தயவு செய்து திரும்பி வந்து மீண்டும் முயற்சிக்கவும்.","We_have_sent_registration_email":"நாம் நீங்கள் உங்கள் பதிவை உறுதி ஒரு மின்னஞ்சல் அனுப்பினேன். நீங்கள் ஒரு மின்னஞ்சலை விரைவில் பெறுவீர்கள் இல்லை என்றால், தயவு செய்து திரும்பி வந்து மீண்டும் முயற்சிக்கவும்.","WebRTC_Enable_Channel":"பொது சேனல்கள் இயக்கு","WebRTC_Enable_Direct":"நேரடி செய்திகள் இயக்கு","WebRTC_Enable_Private":"தனியார் சேனல்கள் இயக்கு","WebRTC_Servers":"STUN / TURN சர்வர்கள்","WebRTC_Servers_Description":"கமா பிரிக்கப்பட்ட STUN மற்றும் இயக்கு சர்வர்கள் பட்டியல். <br/> கடவுச்சொல்லை @ ஸ்டன்: பயனர் பெயர், கடவுச்சொல் மற்றும் துறைமுக வடிவம்: பயனர் பெயர் அனுமதிக்கப்படுகிறது புரவலன்: port` அல்லது `பயனர்பெயர்: கடவுச்சொல் @ முறை: புரவலன்: port`.","Welcome":"<em> %s</em> உங்களை வரவேற்கிறோம்.","Welcome_to_the":"வரவேற்கிறோம்","will_be_able_to":"முடியும்","With_whom":"யாருடன்","Yes":"ஆம்","Yes_clear_all":"ஆமாம், தெளிவான அனைத்து!","Yes_delete_it":"ஆம், நீக்கு!","Yes_hide_it":"ஆம், அதை மறைக்க!","Yes_leave_it":"ஆமாம், விடுங்கள்!","Yes_mute_user":"ஆமாம், ஊமையாக பயனர்!","Yes_remove_user":"ஆமாம், பயனர் நீக்க!","you_are_in_preview_mode_of":"நீங்கள் சேனல் # <strong>__room_name__</strong> முன்னோட்ட முறையில் உள்ளன","You_are_logged_in_as":"நீங்கள் என பதிவு","You_are_not_authorized_to_view_this_page":"இந்த பக்கத்தை பார்க்க உங்களுக்கு அதிகாரம் இல்லை.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"நீங்கள் கடந்த உரிமையாளர். அறையை விட்டு முன் புதிய உரிமையாளர் அமைக்க கொள்ளவும்.","You_can_change_a_different_avatar_too":"இந்த ஒருங்கிணைப்பு இருந்து பதிவு செய்ய பயன்படுத்தப்படும் சின்னம் புறக்கணிக்க முடியாது.","You_can_use_an_emoji_as_avatar":"நீங்கள் ஒரு அவதாரமாக ஈமோஜியை பயன்படுத்த முடியும்.","You_have_been_muted":"நீங்கள் ஒலியடக்கப்பட்டுள்ளன இந்த அறையில் பேச முடியாது வேண்டும்","You_have_not_verified_your_email":"நீங்கள் உங்கள் மின்னஞ்சல் சரிபார்க்கப்படவில்லை.","You_have_successfully_unsubscribed":"நீங்கள் வெற்றிகரமாக எங்கள் Mailling பட்டியல் விலகியுள்ளீர்கள்.","You_informed_an_invalid_FROM_address":"நீங்கள் முகவரி செல்லாத தகவல்.","You_must_provide_the_unsubscribe_link":"நீங்கள் [சந்தாவிலகு] இணைப்பை வழங்க வேண்டும்.","You_need_confirm_email":"நீங்கள் உள்நுழைய உங்கள் மின்னஞ்சல் முகவரியை உறுதிப்படுத்த வேண்டும்!","You_need_install_an_extension_to_allow_screen_sharing":"நீங்கள் திரையில் பகிர்வு அனுமதிக்க ஒரு நீட்டிப்பு நிறுவ வேண்டும்","You_need_to_change_your_password":"நீங்கள் உங்கள் கடவுச்சொல்லை மாற்ற வேண்டும்","You_need_to_type_in_your_password_in_order_to_do_this":"நீங்கள் இதை செய்ய கடவுச் தட்டச்சு செய்ய வேண்டும்!","You_need_to_type_in_your_username_in_order_to_do_this":"நீங்கள் இதை செய்ய வேண்டும் உங்கள் பயனர் பெயர் தட்டச்சு செய்ய வேண்டும்!","You_need_to_verifiy_your_email_address_to_get_notications":"நீங்கள் அறிவிப்புகளை பெற உங்கள் மின்னஞ்சல் முகவரியை verifiy வேண்டும்","You_should_name_it_to_easily_manage_your_integrations":"நீங்கள் அதை எளிதாக உங்கள் ஒருங்கிணைவு நிர்வகிக்க பெயரிட வேண்டும்.","You_will_not_be_able_to_recover":"நீங்கள் மீட்க முடியாது!","You_will_not_be_able_to_recover_file":"நீங்கள் இந்தக் கோப்பை மீட்க முடியாது!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"உங்கள் மின்னஞ்சல் சரிபார்க்கப்பட்டது இல்லை, ஏனெனில் நீங்கள் மின்னஞ்சல் அறிவிப்புகளை பெற மாட்டேன்.","Your_email_has_been_queued_for_sending":"உங்கள் மின்னஞ்சல் அனுப்பும் வரிசைப்படுத்தப்பட்டுள்ளது","Your_entry_has_been_deleted":"உங்கள் உள்ளீடு நீக்கப்பட்டுவிட்டது.","Your_file_has_been_deleted":"உங்கள் கோப்பு நீக்கப்பட்டுள்ளது.","Your_mail_was_sent_to_s":"உங்கள் மெயில்% கள் அனுப்பப்பட்டது","Your_Open_Source_solution":"உங்கள் சொந்த திறந்த மூல அரட்டை தீர்வு","Your_password_is_wrong":"உங்கள் கடவுச்சொல் தவறு!","Your_push_was_sent_to_s_devices":"உங்கள் மிகுதி% கள் சாதனங்கள் அனுப்பப்பட்டது"});
TAPi18n._registerServerTranslator("ta-IN", namespace);                                                                 // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/tr.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["tr"] = ["Turkish","Türkçe"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["tr"])) {                                                                        // 9
  TAPi18n.translations["tr"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["tr"][namespace])) {                                                             // 13
  TAPi18n.translations["tr"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["tr"][namespace], {"500":"İç Sunucu Hatası","0_Errors_Only":"0 - Hatalar Sadece","1_Errors_and_Information":"1 - Hatalar ve Bilgi","2_Erros_Information_and_Debug":"2 - Erros, Bilgi ve hata ayıklama","__username__was_set__role__by__user_by_":"__username__ adlı __user_by__ ile __role__ ayarlandı","__username__is_no_longer__role__defined_by__user_by_":"__username__ adlı __user_by__ ile __role__ artık","Access_not_authorized":"Erişim yetkisi yok","Access_online_demo":"Canlı önizleme","Access_Online_Demo":"Canlı Önizleme","Access_Token_URL":"Erişim Jetonu URL","Accounts":"Hesaplar","Accounts_AllowDeleteOwnAccount":"Kullanıcıların kendi hesabını silmek için izin","Accounts_AllowedDomainsList":"İzin Alanlar Listesi","Accounts_AllowedDomainsList_Description":"izin verilen alanların virgülle ayrılmış listesi","Accounts_AllowEmailChange":"E-posta Değiştir izin","Accounts_AllowPasswordChange":"Şifre Değiştir izin ver","Accounts_AllowUserAvatarChange":"Kullanıcı avatarı Değişikliği izin","Accounts_AllowUsernameChange":"İzin Kullanıcı Değişim","Accounts_AllowUserProfileChange":"Kullanıcı Profili Değiştir izin ver","Accounts_AvatarResize":"Görseller yeniden boyutlandırma","Accounts_AvatarSize":"Avatar Boyutu","Accounts_AvatarStorePath":"Avatar Depolama Yolu","Accounts_AvatarStoreType":"Avatar Depolama Türü","Accounts_BlockedDomainsList":"Engellenen Alanlar Listesi","Accounts_BlockedDomainsList_Description":"Engellenen alanların virgülle ayrılmış listesi","Accounts_denyUnverifiedEmail":"doğrulanmamış e-posta inkar","Accounts_EmailVerification":"E-Posta Doğrulama","Accounts_EmailVerification_Description":"emin bu özelliği kullanmak için doğru SMTP ayarlarına sahip olun","Accounts_Enrollment_Email":"Kayıt e-posta","Accounts_Enrollment_Email_Description":"Sırasıyla, kullanıcının tam adı, ad veya soyadı için [lname], [isim], [fname] kullanabilirsiniz. <br /> Kullanıcının e-posta için [email] kullanabilirsiniz.","Accounts_Iframe_api_method":"Api Yöntemi","Accounts_Iframe_api_url":"Api URL","Accounts_iframe_enabled":"Etkin","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"Gün Aç sona erme","Accounts_ManuallyApproveNewUsers":"Yeni kullanıcıları onayla","Accounts_OAuth_Custom_Token_Sent_Via":"Jetonu Sent Via","Accounts_OAuth_Custom_Authorize_Path":"Path yetkilendir","Accounts_OAuth_Custom_Button_Color":"düğme Renk","Accounts_OAuth_Custom_Button_Label_Color":"Düğme Metin Rengi","Accounts_OAuth_Custom_Button_Label_Text":"düğme Metni","Accounts_OAuth_Custom_Enable":"etkinleştirme","Accounts_OAuth_Custom_id":"İD","Accounts_OAuth_Custom_Identity_Path":"kimlik Yolu","Accounts_OAuth_Custom_Login_Style":"Giriş Stili","Accounts_OAuth_Custom_Secret":"Gizli","Accounts_OAuth_Custom_Token_Path":"Jetonu Yolu","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook ile giriş","Accounts_OAuth_Facebook_callback_url":"Facebook geri arama URL","Accounts_OAuth_Facebook_id":"Facebook App Kimliği","Accounts_OAuth_Facebook_secret":"Facebook Gizli","Accounts_OAuth_Github":"GitHub ile giriş","Accounts_OAuth_Github_callback_url":"Github geri arama URL","Accounts_OAuth_GitHub_Enterprise":"OAuth Etkin","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub Kurumsal geri arama URL","Accounts_OAuth_GitHub_Enterprise_id":"Müşteri Kimliği","Accounts_OAuth_Github_id":"Müşteri Kimliği","Accounts_OAuth_Github_secret":"Müşteri Sırrı","Accounts_OAuth_Gitlab":"OAuth Etkin","Accounts_OAuth_Gitlab_callback_url":"GitLab geri arama URL","Accounts_OAuth_Gitlab_id":"GitLab Kimliği","Accounts_OAuth_Gitlab_secret":"Müşteri Sırrı","Accounts_OAuth_Google":"Google ile giriş","Accounts_OAuth_Google_callback_url":"Google geri arama URL","Accounts_OAuth_Google_id":"Google Kimliği","Accounts_OAuth_Google_secret":"Google Gizli","Accounts_OAuth_Linkedin":"LinkedIn ile giriş","Accounts_OAuth_Linkedin_callback_url":"Linkedin geri arama URL","Accounts_OAuth_Linkedin_id":"LinkedIn Kimliği","Accounts_OAuth_Linkedin_secret":"LinkedIn Gizli","Accounts_OAuth_Meteor":"Meteor ile giriş","Accounts_OAuth_Meteor_callback_url":"Meteor geri arama URL","Accounts_OAuth_Meteor_id":"meteor Kimliği","Accounts_OAuth_Meteor_secret":"meteor Gizli","Accounts_OAuth_Twitter":"Twitter ile giriş","Accounts_OAuth_Twitter_callback_url":"Heyecan geri arama URL","Accounts_OAuth_Twitter_id":"Twitter Kimliği","Accounts_OAuth_Twitter_secret":"Heyecan Gizli","Accounts_OAuth_Wordpress":"WordPress Girişi","Accounts_OAuth_Wordpress_callback_url":"Wordpress geri arama URL","Accounts_OAuth_Wordpress_id":"WordPress Kimliği","Accounts_OAuth_Wordpress_secret":"WordPress Gizli","Accounts_PasswordReset":"Parola sıfırlama","Accounts_Registration_AuthenticationServices_Enabled":"Kimlik Doğrulama Hizmetleri ile Kayıt","Accounts_RegistrationForm":"Kayıt formu","Accounts_RegistrationForm_Disabled":"engelli","Accounts_RegistrationForm_LinkReplacementText":"Kayıt Formu Bağlantı Değiştirme Metni","Accounts_RegistrationForm_Public":"kamu","Accounts_RegistrationForm_Secret_URL":"gizli URL","Accounts_RegistrationForm_SecretURL":"Kayıt Formu Gizli URL","Accounts_RegistrationForm_SecretURL_Description":"Sen kayıt URL'sini eklenecektir rasgele bir dize sağlamalısınız. Örnek: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"Kayıt Gerekli","Accounts_RequireNameForSignUp":"İçin Üye Olun Ad iste","Accounts_ShowFormLogin":"Göster form tabanlı Giriş","Accounts_UseDefaultBlockedDomainsList":"Kullanım Standart Engellenen Alanlar Listesi","Accounts_UseDNSDomainCheck":"DNS Alan Kontrolü kullanın","Activate":"etkinleştirmek","Activity":"etkinlik","Add":"eklemek","Add_agent":"ajanı eklemek","Add_custom_oauth":"Özel oauth ekle","Add_manager":"Yönetici ekle","Add_Members":"Üye ekle","Add_User":"Kullanıcı Ekle","Add_user":"Kullanıcı Ekle","Add_users":"Kullanıcı ekle","Additional_emails":"Ek E-posta","Additional_Feedback":"Ek geri bildirim","Administration":"Yönetim","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2 kimlik doğrulama sonra, kullanıcılar bu URL'ye yönlendirilir","Agent_added":"ajanı ilave","Agent_removed":"ajan kaldırıldı","Alias":"takma ad","All":"tüm","All_channels":"Daha fazla","All_logs":"Tüm kayıtlar","All_messages":"Tüm mesajlar","Allow_Invalid_SelfSigned_Certs":"İzin geçersiz Sertifikaları Kendinden İmzalı","Allow_Invalid_SelfSigned_Certs_Description":"bağlantı doğrulama ve önizleme için geçersiz ve kendinden imzalı SSL sertifikası 's izin verin.","and":"ve","And_more":"Ve daha __length __...","Animals_and_Nature":"Hayvanlar ve Doğa","API":"API","API_Analytics":"Analiz","API_Embed":"Embed","API_EmbedDisabledFor":"Kullanıcılar için devre dışı bırak Sitene","API_EmbedDisabledFor_Description":"adlarının virgülle ayrılmış listesi","API_GitHub_Enterprise_URL":"sunucu URL'si","API_GitHub_Enterprise_URL_Description":"Örnek: http://domain.com (hariç eğik çizgi)","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"Görünüm","Application_added":"uygulama eklendi","Application_Name":"Uygulama Adı","Application_updated":"uygulama güncellendi","Apply_and_refresh_all_clients":"Uygulayın ve tüm istemcilerin yenilemek","Archive":"Arşiv","Archive_Unarchive":"Arşiv / Arşivden çıkar","are_also_typing":"yazıyor","are_typing":"yazıyor","Are_you_sure":"Emin misiniz?","Are_you_sure_you_want_to_delete_your_account":"Hesabınızı silmek istediğinizden emin misiniz?","Authorization_URL":"yetkilendirme URL'si","Authorize":"Yetki vermek","AutoLinker_StripPrefix":"AutoLinker Şerit Önek","AutoLinker_StripPrefix_Description":"Kısa ekran. örneğin https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker URL","AutoLinker_UrlsRegExp":"AutoLinker URL Düzenli İfade","AutoLinker_Email":"AutoLinker E-posta","AutoLinker_Phone":"AutoLinker Telefon","AutoLinker_Phone_Description":"Otomatik olarak Telefon numaraları için bağlantılı. örneğin '(123) 456-7890`","Auto_Load_Images":"Otomatik Yük Görüntüleri","Available":"Mevcut","Available_agents":"mevcut maddeler","Avatar":"Avatarı değiştir","Avatar_changed_successfully":"Avatar başarıyla değiştirildi","Avatar_URL":"Avatar URL","Avatar_url_invalid_or_error":"sağlanan URL erişilebilir geçersiz veya değildir. Tekrar denemek, ama farklı bir url ile ulaşabilirsiniz.","away":"uzakta","Away":"Uzakta","away_female":"uzakta","Away_female":"Uzakta","away_male":"uzakta","Away_male":"Uzakta","Back":"Geri","Back_to_applications":"Geri uygulamalara","Back_to_integrations":"Geri entegrasyonlar için","Back_to_login":"Giriş sayfasına geri dön","Back_to_permissions":"Geri izinleri","Body":"vücut","bold":"kalın","busy":"meşgul","Busy":"Meşgul","busy_female":"meşgul","Busy_female":"Meşgul","busy_male":"meşgul","Busy_male":"Meşgul","Cancel":"Vazgeç","Cannot_delete_a_protected_role":"Korunan rol silinemiyor","Cannot_delete_role_because_its_in_use":"kullanımda olduğundan rol silinemiyor","Cannot_invite_users_to_direct_rooms":"Odalar doğrudan kullanıcıları davet edemezsiniz","CDN_PREFIX":"CDN Önek","Certificates_and_Keys":"Sertifikalar ve Anahtarlar","Channel":"Kanal","Channel_doesnt_exist":"Kanal `# %s` yok.","Channels":"Kanallar","Channels_list":"Kanallar","Chat_Rooms":"Sohbet Odaları","Chatops_Enabled":"CHATOPS etkinleştirme","Chatops_Title":"CHATOPS Paneli","Chatops_Username":"CHATOPS Adı","Choose_a_room":"bir oda seçin","Choose_messages":"mesajları seçin","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Mesajlarda kullanıcı adı önce görünecektir takma seçin.","Choose_the_username_that_this_integration_will_post_as":"Bu bütünleşme olarak yayınlayacağız adını seçin.","Clear_all_unreads_question":"Tüm unreads temizleyin?","Client_ID":"Müşteri Kimliği","Client_Secret":"Müşteri Sırrı","Clients_will_refresh_in_a_few_seconds":"Müşteriler birkaç saniye içinde yenilenir","close":"kapat","Closed":"Kapalı","Collapse_Embedded_Media_By_Default":"Varsayılan olarak gömülü medya kapa","coming_soon":"yakında","Commands":"komutları","Compact_View":"kompakt Görünüm","Confirm_password":"Parolanızı onaylayın","Contact":"İletişim","Conversation":"Direkt Mesaj","Convert_Ascii_Emojis":"Emojiye ASCII dönüştürmek","Copied":"kopyalanan","COPY_TO_CLIPBOARD":"PANOYA KOPYALA","Copy_to_clipboard":"Panoya kopyala","Count":"saymak","Create":"oluşturmak","Create_new":"Yeni oluştur","Created_at":"Oluşturulma saati","Created_at_s_by_s":"<strong> %s</strong> <strong>tarafından %s</strong> konumundaki düzenlendi","Custom_Fields":"Özel Alanlar","Custom_oauth_helper":"OAuth Provider kurarken, bir geri arama URL bilgilendirmek gerekir. kullanım <pre> %s </pre> .","Custom_oauth_unique_name":"Özel oauth benzersiz ad","Custom_Script_Logged_In":"Özel Senaryo kullanıcılar giriş için","Custom_Script_Logged_Out":"Özel Senaryo çıkış yapmış kullanıcılar için","Dashboard":"gösterge paneli","days":"gün","Deactivate":"devre dışı bırakmak","Debug_Level":"Hata ayıklama Seviye","Default":"Varsayılan","Delete":"Sil","Delete_my_account":"Hesabımı sil","Delete_Room_Warning":"Bir oda silme oda içinde gönderilen tüm mesajları silmek olacaktır. Bu geri alınamaz.","Delete_User_Warning":"Bu kullanıcıyı silerseniz tüm mesajları da beraberinde silinecektir! Bu işlemi bir daha geri alamazsınız.","Deleted":"Silinmiş!","Department_not_found":"Bölümü bulunamadı","Department_removed":"Bölüm kaldırıldı","Departments":"Bölümler","Description":"tanım","Desktop":"Masaüstü","Desktop_Notification_Test":"Masaüstü Bildirimi Testi","Desktop_Notifications":"Masaüstü Bildirimleri","Desktop_Notifications_Disabled":"Masaüstü Bildirimleri Devre Dışı. Eğer etkin Bildirimleri gerekirse tarayıcı tercihlerinizi değiştirin.","Desktop_Notifications_Enabled":"Masaüstü Bildirimleri Etkin edilir","Direct_message_someone":"Doğrudan mesaj birisi","Direct_Messages":"Direkt Mesajlar","Direct_Messages_list":"doğrudan Mesajlar","Disable_Favorite_Rooms":"devre dışı bırak Sık","Disable_New_Message_Notification":"Yeni Mesaj Bildirimini devre dışı bırakmak","Disable_New_Room_Notification":"Yeni Oda Bildirimini devre dışı bırakmak","Displays_action_text":"Görüntüler aksiyon metni","Do_you_want_to_change_to_s_question":"<strong> %s</strong> değiştirmek istiyor musunuz?","Drop_to_upload_file":"Dosya yüklemek için sürükle","Dry_run":"kuru çalışma","Dry_run_description":"Sadece itibaren aynı adrese bir e-posta göndereceğiz. E-posta geçerli bir kullanıcı ait olmalıdır.","Duplicate_archived_channel_name":"Arşivlenmiş Kanal adıyla ' %s' var","Duplicate_archived_private_group_name":"adı ' %s' var olan bir arşivlenmiş Özel Grup","Duplicate_private_group_name":"' %s' var isimde bir Özel Grup","E-mail":"E-posta","Edit":"Düzenle","Edit_Custom_Field":"Düzenleme Özel Alan","Edit_Department":"Düzenleme Bölümü","edited":"düzenlendi","Email":"E-posta","Email_already_exists":"Bu e-posta zaten var","Email_body":"E-posta gövdesi","Email_Change_Disabled":"Sizin Rocket.Chat yönetici e-posta değişen engellenmiştir","Email_from":"itibaren","Email_Notification_Mode":"Çevrimdışı E-posta Bildirimleri","Email_Notification_Mode_All":"Her Mansiyon / DM","Email_Notification_Mode_Disabled":"engelli","Email_or_username":"E-posta ya da kullanıcı adı","Email_subject":"konu","Email_verified":"E-posta doğrulandı","Emoji":"Emoji","Empty_title":"boş başlık","Enable":"etkinleştirme","Enable_Desktop_Notifications":"Masaüstü Bildirimleri etkinleştirme","Enabled":"Etkin","Encrypted_message":"şifreli mesaj","End_OTR":"bitiş OTR","Enter_a_regex":"Bir regex girin","Enter_a_room_name":"Bir oda adı girin","Enter_a_username":"Bir kullanıcı adı girin","Enter_info":"Giriş bilgilerinizi girin","Enter_name_here":"Burada adı girin","Enter_to":"için Enter","Error":"Hata","error-cant-invite-for-direct-room":"Doğrudan odalara kullanıcı davet edemez","error-duplicate-channel-name":"A Kanal adıyla ' %s' var","error-invalid-custom-field":"Geçersiz özel alan","error-invalid-custom-field-name":"Geçersiz özel alan adı. sadece harf, rakam, tire ve alt çizgi kullanın.","error-invalid-password":"Geçersiz şifre","error-invalid-room":"geçersiz oda","error-invalid-room-name":"<strong> %s</strong> geçerli <strong>bir</strong> oda adı değil, <br/> sadece harf, rakam, tire ve alt kullanmak","error-invalid-user":"Geçersiz kullanıcı","error-invalid-username":"Geçersiz kullanıcı adı","error-not-allowed":"İzin verilmedi","error-not-authorized":"Yetkili değil","error-remove-last-owner":"Bu son sahibidir. Bu kaldırmadan önce yeni bir sahibi ayarlayın.","error-role-name-required":"Rol adı gerekli","error-user-not-in-room":"Kullanıcı bu odada değil","Error_changing_password":"Şifre değiştirildi","Error_sending_confirmation_email":"Hata onay e-posta gönderme","Error_too_many_requests":"Hata, çok fazla istek. Lütfen yavaşla. Sen tekrar denemeden önce %s saniye beklemeniz gerekir","Esc_to":"Esc için","Example_s":"Örnek: <code class=\"inline\">%s</code>","False":"Yanlış","Favorites":"Favoriler","Field":"alan","Field_removed":"Alan çıkarıldı","File_exceeds_allowed_size_of_bytes":"Dosya __size__ bayt izin boyutunu aşıyor","FileUpload":"Dosya yükleme","FileUpload_Enabled":"Dosya Yükleme Etkin","FileUpload_File_Empty":"boş Dosya","FileUpload_FileSystemPath":"sistem Yolu","FileUpload_MaxFileSize":"Maksimum Dosya Yükleme boyutu (bayt)","FileUpload_MediaType_NotAccepted":"Ortam Türleri Kabul Edilmedi","FileUpload_MediaTypeWhiteList":"Kabul Ortam Türleri","FileUpload_MediaTypeWhiteListDescription":"ortam türleri virgülle ayrılmış listesi. tüm medya türlerini kabul etmek için boş bırakın.","FileUpload_ProtectFiles":"Yüklenen dosyaları koruyun","FileUpload_ProtectFilesDescription":"Sadece kimliği doğrulanmış kullanıcılar erişebilir","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 kova adı","FileUpload_S3_BucketURL":"Kepçe URL","FileUpload_S3_CDN":"yüklemeler için CDN alanı","FileUpload_S3_Region":"bölge","FileUpload_Storage_Type":"depolama Türü","Flags":"Bayraklar","Follow_social_profiles":"Bizi sosyal ağlardan takip edebilir, rocket.chat uygulaması hakkında düşüncelerinizi paylaşabilir ve uygulamayı github üzerinden çatallayabilirsiniz.","Food_and_Drink":"Yiyecek içecek","For_your_security_you_must_re_enter_your_password_to_continue":"Güvenliğiniz için, devam etmek şifrenizi yeniden girmeniz gerekir","Force_SSL":"kuvvet SSL","Force_SSL_Description":"* Dikkat! * _Force SSL_ ters proxy ile asla kullanılmamalıdır. Eğer ters proxy varsa, ORADA yönlendirme yapmak gerekir. Bu seçenek, ters vekil de yönlendirme yapılandırması izin vermez Heroku gibi dağıtımlar için var.","Forgot_password":"Şifrenizi mi unuttunuz","Fork_it_on_github":"Github üzerinde çatalla","Frequently_Used":"Sıklıkla kullanılan","From":"itibaren","From_Email":"E-posta Gönderen","From_email_is_required":"E-posta gerekli","From_email_warning":"<b>Uyarı:</b> <b>Nereden</b> alanı, posta sunucusu ayarlarını tabidir.","General":"Genel","Get_to_know_the_team":"Rocket.Team'ı tanıyın","github_no_public_email":"Sen GitHub hesabınızda kamu e-posta olarak herhangi bir e-posta yok","Give_a_unique_name_for_the_custom_oauth":"Özel OAuth için benzersiz bir ad verin","Give_the_application_a_name_This_will_be_seen_by_your_users":"Uygulamayı bir ad verin. Bu kullanıcılar tarafından görülecektir.","Global":"global","GoogleTagManager_id":"Google Etiket Yöneticisi Kimliği","Has_more":"Daha fazla var","Have_your_own_chat":"Rocket.Chat, açık kaynak gönüllülerinin bir araya gelerek Meteor ile geliştirdikleri sohbet uygulamasıdır.","Header":"üstbilgi","Hidden":"Gizli","Hide_Group_Warning":"Eğer grup \" %s\" gizlemek istediğinizden emin misiniz?","Hide_Private_Warning":"Eğer \" %s\" ile tartışma gizlemek istediğiniz emin misiniz?","Hide_room":"Odayı gizle","Hide_Room_Warning":"Eğer oda \" %s\" gizlemek istediğinizden emin misiniz?","Highlights":"Özeti","Highlights_How_To":"Birisi buradan ekleyebilirsiniz, bir kelime veya kelime öbeği bahseder haberdar edilecektir. Sen virgül ile kelimeleri veya cümleleri ayırabilirsiniz. Vurgu Kelimeler küçük harfe duyarlı değildir.","Highlights_List":"Vurgu sözler","History":"Geçmiş","hours":"saat","How_friendly_was_the_chat_agent":"Sohbet ajanı nasıl dost oldu?","How_knowledgeable_was_the_chat_agent":"Sohbet ajanı nasıl bilgili?","How_responsive_was_the_chat_agent":"Sohbet ajanı nasıl cevap veriyordu?","How_satisfied_were_you_with_this_chat":"Bu sohbet ile ne kadar memnun kaldınız?","If_you_are_sure_type_in_your_password":"Şifrenizin emin türü ise:","If_you_are_sure_type_in_your_username":"Eğer kullanıcı adınızı emin türü ise:","Importer_Archived":"arşivlenen","Importer_done":"Alma tamamlandığı!","Importer_finishing":"ithalat kadar bitirme.","Importer_From_Description":"İthalat Rocket.Chat içine __ 'in verileri __from.","Importer_import_cancelled":"İthalat iptal edildi.","Importer_import_failed":"ithalat çalışırken bir hata oluştu.","Importer_importing_channels":"kanalları İthalat.","Importer_importing_messages":"mesajlar içe.","Importer_importing_started":"ithalat başlatılıyor.","Importer_importing_users":"kullanıcıları içe.","Importer_not_defined_properly":"ithalatçı o İthalat sınıfı eksik, doğru tanımlanmış değildi.","Importer_not_in_progress":"ithalatçı şu anda çalışmıyor.","Importer_Prepare_Restart_Import":"Yeniden İthalat","Importer_Prepare_Start_Import":"İthalat başla","Importer_Prepare_Uncheck_Archived_Channels":"Işaretini kaldırın Arşivlenen Kanallar","Importer_Prepare_Uncheck_Deleted_Users":"Işaretini kaldırın Silinmiş Kullanıcıları","Importer_progress_error":"ithalat için ilerleme alınamadı.","Importer_setup_error":"ileti kurarken bir hata oluştu.","Incorrect_Password":"Yanlış parola","inline_code":"kod_satırı","Install_Extension":"Uzantısı yükleyin","Install_FxOs":"Firefox üzerinde Rocket.Chat yükleyin","Install_FxOs_done":"Büyük! Artık ekranı üzerindeki simge üzerinden Rocket.Chat kullanabilirsiniz. Rocket.Chat ile eğlenin!","Install_FxOs_error":"Maalesef, işe yaramadı amaçlandığı gibi! Aşağıdaki hata ortaya çıktı:","Install_FxOs_follow_instructions":"cihazınızda uygulama yüklemeyi onaylamak lütfen (basın \"Install\" istendiğinde).","Installation":"montaj","Integration_added":"Entegrasyon eklendi","Integration_Incoming_WebHook":"Gelen WebHook Entegrasyonu","Integration_New":"yeni Entegrasyon","Integration_Outgoing_WebHook":"Giden WebHook Entegrasyonu","Integration_updated":"Entegrasyon güncellendi","Integrations":"Entegrasyonlar","Invalid_asset":"geçersiz varlık","Invalid_confirm_pass":"Şifreler eşleşmiyor","Invalid_email":"Girilen e-posta geçersiz","Invalid_Export_File":"Yüklenen dosya geçerli bir %s ihracat dosyası değil.","Invalid_file_height":"Geçersiz dosya yüksekliği","Invalid_file_type":"Geçersiz dosya türü","Invalid_file_width":"Geçersiz dosya genişliği","Invalid_Import_File_Type":"Geçersiz İthalat dosya türü.","Invalid_name":"İsim boş bırakılamaz","Invalid_notification_setting_s":"Geçersiz bildirim ayarı: %s","Invalid_pass":"Parola boş bırakılamaz","Invalid_room_name":"<strong>%s</strong> geçersiz kanal adı,<br/> Lütfen sadece harfler, sayılar ve tireler kullanın","Invalid_room_type":"<strong> %s</strong> geçerli <strong>bir</strong> oda tipi değil.","Invalid_Secret_URL":"Geçersiz Gizli URL","Invalid_secret_URL_message":"sağlanan URL geçersiz.","invisible":"görünmez","Invisible":"Görünmez","Invitation_HTML":"Davet HTML","Invitation_Subject":"Davet Konusu","Invite_user_to_join_channel":"Bu kanala bir kullanıcı davet","Invite_Users":"kullanıcıları davet","is_also_typing":"yazıyor","is_also_typing_female":"Ayrıca yazmaya olduğunu","is_also_typing_male":"yazıyor","is_typing":"yazıyor","is_typing_female":"yazıyor","is_typing_male":"yazıyor","italics":"eğik","join":"Katıl","Join_audio_call":"ses görüşmesine katılın","Join_the_Community":"Topluluğa katıl","Join_the_given_channel":"Verilen kanala","Join_video_call":"video görüşmesine katılın","Joined":"Katılım","Jump":"Atlama","Jump_to_first_unread":"İlk okunmamış atla","Jump_to_message":"mesajı atlamak","Jump_to_recent_messages":"son mesajlara atla","Katex_Enabled":"Katex Etkin","Label":"Etiket","Language":"Dil","Language_Version":"İngilizce Versiyon","Last_login":"Son giriş","Last_message":"Son mesaj","Last_seen":"Son görülen","Layout":"düzen","Layout_Home_Body":"Vücut","Layout_Home_Title":"Anasayfa başlığı","Layout_Login_Terms":"Giriş Şartları","Layout_Privacy_Policy":"Gizlilik Politikası","Layout_Sidenav_Footer":"Yan Navigasyon Altbilgi","Layout_Sidenav_Footer_description":"Altbilgi boyutu 260 x 70 piksel olduğunu","Layout_Terms_of_Service":"Kullanım Koşulları","LDAP":"LDAP","LDAP_CA_Cert":"CA Sertifika","LDAP_Custom_Domain_Search":"Özel Alan Arama","LDAP_Custom_Domain_Search_Description":"bağlama ve bağlantı bilgileri yönetir ve form olan JSON bir parça: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"varsayılan Etki Alanı","LDAP_Description":"Birden çok site ve hizmetler arasında bir parola paylaşımı için bir tesis - LDAP birçok şirket üzerinde tek oturum sağlamak için kullanmak hiyerarşik veritabanı. https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication: gelişmiş yapılandırma bilgi ve örnekler için, bizim wiki danışın.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"Alan Bankası","LDAP_Domain_Base_Description":"Eğer kullanıcılar ve gruplar için aramak istediğiniz bir LDAP alt ağacının tam ayırt edici ad (DN). İstediğiniz kadar ekleyebilirsiniz; Ancak, her grup kendisine ait kullanıcılarıyla aynı etki tabanı tanımlanmış olmalıdır. Eğer kısıtlı kullanıcı grupları belirtirseniz, bu gruplara ait sadece kullanıcıların kapsamında olacak. Size etki temel olarak LDAP dizin ağacının üst düzeyini belirlemek ve erişim kontrolü için arama filtresi kullanmanızı öneririz.","LDAP_Domain_Search_Filter":"Domain Arama Filtresi","LDAP_Domain_Search_Filter_Description":"Bu filtreyle eşleşen belirtilen, sadece kullanıcıların oturum izin verilecek olursa filtre belirtilirse., belirtilen etki alanı tabanının kapsamındaki tüm kullanıcılar oturum mümkün olacak. <br/> Active Directory örneğin `memberOf = cn = ROCKET_CHAT, ou = Genel gruplarının iş. <br/> OpenLDAP için (örn genişletilebilir maç arama) `ou: dn: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Domain Arama Nesne Kategori","LDAP_Domain_Search_Object_Category_Description":"senin kullanıcıları tanımlamak * objectCategory *. <br/> * OpenLDAP * için boş bırakın. <br/> Örneğin, 'person` vs.","LDAP_Domain_Search_Object_Class":"Domain Arama nesne sınıfı","LDAP_Domain_Search_Object_Class_Description":"senin kullanıcıları tanımlamak * objectclass *. <br/> Örneğin, 'organizationalPerson`,' user`, 'inetOrgPerson` vs.","LDAP_Domain_Search_Password":"Domain Arama Şifre","LDAP_Domain_Search_Password_Description":"etki alanı arama kullanıcının parolası.","LDAP_Domain_Search_User":"Domain Arama Kullanıcı","LDAP_Domain_Search_User_Description":"oturum açtıklarında diğer kullanıcıların kimliğini doğrulamak için kullanıcı aramaları gerçekleştiren LDAP kullanıcı. <br/> Bu genellikle üçüncü parti entegrasyonları için özel olarak oluşturulan bir hizmet hesabıdır. Bir tam adını kullanın, örneğin cn = Yönetici 'olarak, cn Kullanıcıları, dc = Örnek, dc = com` =.","LDAP_Domain_Search_User_ID":"Domain Arama Kullanıcı Kimliği","LDAP_Domain_Search_User_ID_Description":"kimlik girişimleri LDAP kullanıcı tanımlayan LDAP özelliği. Bu alan `en Active Directory yüklemeleri için sAMAccountName` olmalı, ama böyle OpenLDAP gibi diğer LDAP çözümleri için` uid` olabilir. E-posta ya da her türlü özellik istediğiniz kullanıcıları tanımlamak için `mail` kullanabilirsiniz. <br> Kullanıcıların kullanıcı adı veya e-posta gibi çoklu tanımlayıcıları kullanarak giriş için izin virgülle ayrılmış birden fazla değer kullanabilirsiniz.","LDAP_Enable":"etkinleştirme","LDAP_Enable_Description":"Kimlik doğrulama için LDAP kullanmak için deneyin.","LDAP_Encryption":"Şifreleme","LDAP_Encryption_Description":"LDAP sunucusuna iletişim güvenliğini sağlamak için kullanılan şifreleme yöntemi. Örnekler `plain` (hiçbir şifreleme), (baştan şifreli)` SSL / LDAPS` ve `StartTLS` (şifreli iletişim için bir kez bağlı yükseltme) içerir.","LDAP_Host":"evsahibi","LDAP_Host_Description":"LDAP ana örneğin 'ldap.example.com` ya da' 10.0.0.30`.","LDAP_Port":"LDAP Port","LDAP_Port_Description":"Liman LDAP erişmek için. LDAPS için `389` ya da '636`: örneğin","LDAP_Reject_Unauthorized":"Yetkisiz Reddet","LDAP_Sync_User_Avatar":"Senkronizasyon Kullanıcı avatarı","LDAP_Sync_User_Data":"Sync Veri","LDAP_Sync_User_Data_Description":"girişte sunucu ile senkronize kullanıcı verilerini tutmak (örneğin: isim, e-posta).","LDAP_Sync_User_Data_FieldMap":"Kullanıcı Veri Alanı Haritası","LDAP_Sync_User_Data_FieldMap_Description":"Kullanıcı hesabı alanları (e-posta gibi) LDAP rekor doldurulur nasıl yapılandırma (bir kez bulundu). <br/> Bir örnek olarak, `{\" cn \":\" ad \",\" posta \":\" e-posta \"}` cn özniteliği bir kişinin insan okunabilir adı ve posta özniteliği kendi e-posta seçecektir. <br/> Mevcut alanları name` ve 'email`' içerir.","LDAP_Sync_Users":"Senkronizasyon Kullanıcılar","LDAP_Test_Connection":"Test bağlantısı","LDAP_Unique_Identifier_Field":"Benzersiz Tanımlayıcı Alan","LDAP_Unique_Identifier_Field_Description":"Hangi alan LDAP kullanıcı ve Rocket.Chat kullanıcıyı bağlamak için kullanılacaktır. LDAP kaydından değerini almak için denemek için virgülle ayrılmış birden fazla değer bilgilendirebilir. <br/> Varsayılan değer `Objectguıd, IBM-entryUUID, GUID, dominoUNID, nsuniqueId, uidNumber` olduğunu","LDAP_Use_Custom_Domain_Search":"Özel Alan Arama kullanın","LDAP_Use_Custom_Domain_Search_Description":"LDAP sunucusunda kullanıcıları aramak için kendi filtresini yazın.","LDAP_Username_Field":"Adı Alan","LDAP_Username_Field_Description":"Hangi alan yeni kullanıcılar için * kullanıcı adı * olarak kullanılacaktır. giriş sayfasında haberdar adını kullanmak için boş bırakın. <br/> Sen # {givenName} `gibi, çok şablon etiketlerini kullanabilirsiniz. # {Sn}`. <br/> Varsayılan değer `sAMAccountName` olduğunu.","Leave_Group_Warning":"Eğer grup \" %s\" ayrılmak istediğinize emin misiniz?","Leave_Private_Warning":"Eğer \" %s\" ile tartışma ayrılmak istiyorum emin misiniz?","Leave_room":"Odayı terket","Leave_Room_Warning":"Eğer oda \" %s\" ayrılmak istediğinize emin misiniz?","line":"satır","List_of_Direct_Messages":"Doğrudan Mesajlar listesi","Live_sessions":"Canlı oturumlar","Livechat_agents":"Canlı ajanlar","Livechat_Dashboard":"Canlı Dashboard","Livechat_enabled":"Canlı etkin","Livechat_Manager":"Canlı Yöneticisi","Livechat_managers":"Canlı yöneticileri","Livechat_title":"Canlı Başlık","Livechat_title_color":"Canlı Başlık Arka Plan Rengi","Livechat_Users":"Canlı Kullanıcılar","Load_more":"Daha fazla","Loading...":"Yükleniyor...","Loading_more_from_history":"Geçmişten daha fazla yükleniyor","Loading_suggestion":"Öneriler yükleniyor...","Localization":"yerelleştirme","Log_File":"Dosya ve Hattı göster","Log_Level":"Giriş Seviyesi","Log_Package":"Show Package","Log_View_Limit":"Görünüm Sınırı Log","Logged_out_of_other_clients_successfully":"başarılı bir şekilde diğer müşterilerin oturumu","Login":"Giriş yap","Login_with":"%s ile giriş yap","login_with":"Ya da doğrudan giriş","Logout":"Çıkış Yap","Logout_Others":"Yerler Diğer giriş itibaren logout","Mail_Message_Invalid_emails":"Bir veya daha fazla geçersiz e-posta sağladı: %s","Mail_Message_Missing_to":"Bir veya daha fazla kullanıcı seçmek ya da bir veya birden fazla e-posta adreslerini, virgülle ayırarak sağlamalıdır.","Mail_Message_No_messages_selected_select_all":"Herhangi bir mesaj seçmediniz. Eğer ister misiniz <a href='#' class='select-all'>tümünü seçin</a> görünür mesajları?","Mail_Messages":"posta iletileri","Mail_Messages_Instructions":"mesajlar tıklayarak e-posta yoluyla göndermek istediğiniz iletileri seçin","Mail_Messages_Subject":"İşte %s mesajların seçilen bir kısım var","Mailer":"posta gemisi","Mailer_body_tags":"Abonelik iptali bağlantı için [unsubscribe] kullanmanız <b>gerekir.</b> <br /> Sırasıyla, kullanıcının tam adı, ad veya soyadı için [lname], [isim], [fname] kullanabilirsiniz. <br /> Kullanıcının e-posta için [email] kullanabilirsiniz.","Make_Admin":"Yönetici Yap","Manager_added":"Yönetici eklendi","Manager_removed":"Yönetici kaldırıldı","Mark_as_read":"Okundu olarak işaretle","Markdown_Headers":"Markdown Başlıkları","Markdown_SupportSchemesForLink":"Bağlantı için Markdown Destek Programları","Markdown_SupportSchemesForLink_Description":"izin verilen programların virgülle ayrılmış listesi","Members_List":"Üye Listesi","Mentions":"söz","Mentions_default":"Söz (varsayılan)","Message":"Mesaj","Message_AllowDeleting":"Mesaj silmeye izin ver","Message_AllowEditing":"Mesaj düzenlemeye izin ver","Message_AllowEditing_BlockEditInMinutes":"Blok İleti Düzenleme (n) dakika sonra","Message_AllowEditing_BlockEditInMinutesDescription":"engelleme devre dışı bırakmak için 0 girin.","Message_AllowPinning":"İzin Mesaj İğneleme","Message_AllowPinning_Description":"İzin mesajları kanallardan herhangi tutturulmuş olması.","Message_AllowStarring":"İleti Oyuncular izin ver","Message_AudioRecorderEnabled":"Ses Kaydedici Etkin","Message_AudioRecorderEnabledDescription":"Gerektirir 'ses / wav' dosyaları 'Dosya Yükle' ayarları içinde kabul edilen bir ortam türü olmak.","Message_DateFormat":"Tarih formatı","Message_DateFormat_Description":"Ayrıca bkz: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Mesajların silinmesine izin verilmiyor","Message_editing_blocked":"Bu mesaj artık düzenlenemez","Message_editing_not_allowed":"Mesajların düzenlenmesine izin verilmiyor","Message_GroupingPeriod":"(Saniye) 'de periyodun gruplandırma","Message_GroupingPeriodDescription":"her ikisi de aynı kullanıcıya ait olduğunu ve geçen zaman saniye cinsinden bilinçli süreden daha az olsaydı iletiler önceki mesajla gruplandırılmış olacaktır.","Message_KeepHistory":"Mesaj geçmişini sakla","Message_MaxAllowedSize":"Maksimum İzin Mesaj Boyutu","Message_MaxAll":"TÜM mesaj için maksimum kanal boyutu","Message_pinned":"Mesaj sabitlendi","Message_pinning_not_allowed":"İleti izin verilmiyor iğneleme","Message_removed":"Mesaj kaldırıl","Message_ShowDeletedStatus":"Silinen Durumu Göster","Message_ShowEditedStatus":"Düzenlenen Durumu Göster","Message_ShowFormattingTips":"Biçimlendirme İpuçları göster","Message_TimeFormat":"Zaman formatı","Message_TimeFormat_Description":"Ayrıca bkz: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"çok uzun İleti","Messages":"Mesajlar","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Gelen WebHook gönderilen mesajları burada ilan edilecektir.","Meta":"Meta","Meta_fb_app_id":"Facebook App Kimliği","Meta_google-site-verification":"Google Site Doğrulama","Meta_language":"Dil","Meta_msvalidate01":"MSValidate.01","Meta_robots":"Robotlar","minutes":"dakika","Mobile_push":"Mobil itme","More_channels":"Daha fazla","More_direct_messages":"Daha direkt mesajlar","More_groups":"Daha özel gruplar","More_unreads":"Daha unreads","Msgs":"Msj","multi":"çoklu","Mute_someone_in_room":"Odada Sessiz birisi","Mute_user":"Sessiz kullanıcı","Muted":"sessiz","My_Account":"Hesabım","n_messages":"%s mesaj","N_new_messages":" %s yeni mesajlar","Name":"İsim","Name_cant_be_empty":"Ad boş olamaz","Name_of_agent":"maddenin adı","Name_optional":"İsim (isteğe bağlı)","Navigation_History_20_last_pages":"Navigasyon Tarihi (son 20 sayfa)","New_Application":"Yeni uygulama","New_Custom_Field":"Yeni Özel Alan","New_Department":"yeni Bölümü","New_integration":"yeni entegrasyon","New_logs":"yeni günlükleri","New_messages":"Yeni mesajlar","New_password":"Yeni şifre","New_role":"yeni rolü","No_channel_with_name_%s_was_found":"Adı <strong>\" %s\"</strong> ile hiçbir kanal bulunamadı!","No_channels_yet":"Henüz hiç bir kanala bağlı değilsiniz.","No_direct_messages_yet":"Maalesef henüz direkt mesajın bulunmuyor.","No_Encryption":"Şifreleme yok","No_favorites_yet":"Henüz favori bir kanalın yok.","No_group_with_name_%s_was_found":"Adı <strong>\" %s\"</strong> ile hiçbir özel grup bulundu!","No_groups_yet":"Henüz hiç bir özel gruba dahil değilsin.","No_livechats":"Hiç livechats var.","No_mentions_found":"Bulunamadı bahseder","No_permission_to_view_room":"Bu odayı görüntülemek için yeterli izniniz yok","No_pinned_messages":"Hayır sabitlenmiş mesajlar","No_results_found":"Sonuç bulunamadı","No_starred_messages":"Favori iletin yok","no_tokens_for_this_user":"Bu kullanıcı için belirteçleri vardır","No_user_with_username_%s_was_found":"Kullanıcı adı <strong>\" %s\"</strong> ile hiçbir kullanıcı bulundu!","Not_allowed":"Izin verilmedi","Not_authorized":"Yetkili değil","Not_Available":"Müsait değil","Not_found_or_not_allowed":"Bulunamadı veya izin verilmiyor","Nothing":"Hiçbir şey","Nothing_found":"Bulunamadı","Notifications":"Bildirimler","Notify_all_in_this_room":"Bu odadaki tüm bildirimleri göster","Num_Agents":"# Ajanlar","Number_of_messages":"Mesaj sayısı","OAuth_Application":"OAuth Uygulaması","OAuth_Applications":"OAuth Uygulamaları","Objects":"nesneler","Off_the_record_conversation":"Off-the-record Konuşma","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off-kayıt konuşma tarayıcınız veya aygıt için geçerli değildir.","Offline_DM_Email":"[__site__] Direkt __user__ tarafından mesajla edilmiştir","Offline_Mention_Email":"[__site__] Sen #__room__ içinde __user__ tarafından söz edilmiştir","Old_and_new_password_must_be_different":"Yeni şifre eski şifrenizden farklı olmalıdır.","Old_and_new_password_required":"Şifrenizi değiştirmek için eski ve yeni parola sağlamanız gerekir.","Online":"Çevrimiçi","Only_errors":"sadece hataları","Only_you_can_see_this_message":"Sadece bu mesajı görebilirsiniz","Oops!":"Hata","Open":"Açık","Opened":"Açıldı","Opt_out_statistics":"Rocket.Chat benim istatistiklerini göndermeyin","Opt_out_statistics_warning":"istatistiklerinizi göndererek, Rocket.Chat birçok örnekleri konuşlandırıldığı nasıl bize sistemin nasıl davrandığını iyi yanı sıra, tanımlamaya yardımcı olacak, bu yüzden daha da artırabilir. hiçbir kullanıcı bilgisi gönderilir ve aldığımız tüm bilgiler gizli tutulur olarak, endişe etmeyin. Bize istatistiklerini göndermeye devam etmek istiyorsanız, yukarıdaki onay kutusunun işaretini kaldırın. Teşekkür ederim.","optional":"isteğe bağlı","Order":"Sipariş","OS_Arch":"İşletim Arch","OS_Cpus":"OS İşlemci Sayısı","OS_Freemem":"OS Boş Bellek","OS_Loadavg":"İS Yük Ortalaması","OS_Platform":"İşletim Sistemi","OS_Release":"İşletim Sistemi Sürümü","OS_Totalmem":"İşletim sistemi belleği","OS_Type":"İşletim Sistemi Tipi","OS_Uptime":"İşletim Uptime","others":"Diğerleri","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"Her iki kullanıcı çevrimiçi olduğunda OTR yalnızca","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"dosyaların yüklendiği hangi geçersiz kıl URL. Ayrıca CDN sürece indirme için kullanılan bu url verilir","Password":"Şifre","Password_Change_Disabled":"Sizin Rocket.Chat yönetici şifreleri değişen engellenmiştir","Password_changed_successfully":"Şifre başarıyla değiştirildi","Payload":"Yükünü","People":"İnsanlar","Permissions":"İzinler","Pin_Message":"pim Mesajı","Pinned_a_message":"Bir mesaj tutturulmuş:","Pinned_Messages":"Sabitlenmiş Mesajlar","Placeholder_for_email_or_username_login_field":"E-posta veya kullanıcı adı giriş alanı için yer tutucu","Placeholder_for_password_login_field":"şifre giriş alanı için yer tutucu","Please_answer_survey":"Bu sohbet hakkında hızlı bir anketi yanıtlamak için bir dakikanızı ayırın","Please_enter_value_for_url":"senin avatar url için bir değer girin.","Please_enter_your_new_password_below":"Aşağıdaki Yeni şifrenizi girin:","Please_fill_a_label":"Bir etiket doldurunuz","Please_fill_a_name":"Bir isim doldurunuz","Please_fill_a_username":"Bir kullanıcı adı doldurunuz","Please_fill_name_and_email":"isim ve e-posta doldurunuz","Please_re_enter_your_password":"lütfen şifrenizi tekrar girin","Please_select_enabled_yes_or_no":"Etkin için bir seçenek seçiniz","Please_wait":"Lütfen bekleyin","Please_wait_activation":"Lütfen bekleyin, bu biraz zaman alabilir.","Please_wait_statistics":"Lütfen bekleyin, istatistikler oluşturuluyor.","Please_wait_while_OTR_is_being_established":"OTR kurulurken lütfen bekleyin","Please_wait_while_your_account_is_being_deleted":"Hesabınız silindikten edilirken lütfen bekleyiniz ...","Please_wait_while_your_profile_is_being_saved":"Profil kaydedilirken lütfen bekleyin ...","Post_as":"Mesaj olarak","Post_to_Channel":"Kanal yayın","Post_to_s_as_s":"<strong>Mesaj% <strong>s%</strong></strong> <strong>s</strong>","Powered_by":"Tarafından desteklenmektedir","Preferences":"Tercihler","Preferences_saved":"Tercihler kaydedildi","Privacy":"Gizlilik","Private_Group":"özel Grup","Private_Groups":"Özel Gruplar","Private_Groups_list":"Özel Gruplar listesi","Profile":"Profil","Profile_saved_successfully":"Profil başarıyla kaydedildi","Proudly_developed":"Meteor ile gururla geliştirildi","Push":"it","Push_apn_cert":"APN Sertifikası","Push_apn_dev_cert":"APN Geliştirici Sertifikası","Push_apn_dev_key":"APN Geliştirici Anahtarı","Push_apn_dev_passphrase":"APN Geliştirici Parolası","Push_apn_key":"APN Anahtarı","Push_apn_passphrase":"APN Parola","Push_debug":"Hata ayıklama","push_disabled":"engelli itin","Push_enable":"Etkin","Push_enable_gateway":"Ağ Geçidi etkinleştirme","Push_gateway":"geçit","Push_gcm_api_key":"GCM API Anahtarı","Push_gcm_project_number":"GCM Proje Numarası","Push_production":"Üretim","Push_show_message":"bildirim mesajı göster","Push_show_username_room":"Bildirimde göster kanal / grup / kullanıcı adı","Push_test_push":"Test","Query":"Sorgu","Query_description":"e-posta göndermek için hangi kullanıcıların belirlemek için ek şartlar. Abone olmayan kullanıcılar otomatik sorgudan kaldırılır. Bu geçerli bir JSON olmalıdır. Örnek: \"{\" createdAt \": {\" $ gt \": {\" $ tarihi \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Hızlı Arama","quote":"alıntı","Reactions":"Tepkiler","Recents":"Son","Record":"Kayıt","Redirect_URI":"URI yönlendir","Refresh_keys":"Yenile tuşları","Refresh_your_page_after_install_to_enable_screen_sharing":"Ekran paylaşımını etkinleştirmek için yükledikten sonra sayfayı yenileyin","Register":"Yeni hesap ","Registration_Succeeded":"Kayıt Başarılı","Remember_me":"Beni hatırla","Remove":"Kaldır","Remove_Admin":"Yönetici kaldır","Remove_as_moderator":"moderatör olarak kaldır","Remove_as_owner":"sahibi olarak kaldır","Remove_custom_oauth":"Özel oauth kaldır","Remove_from_room":"odadan kaldır","Remove_someone_from_room":"odadan birini çıkarın","Removed":"Kaldırılan","Require_password_change":"Şifre değişikliğini zorunlu","Resend_verification_email":"Doğrulama e-postasını tekrar gönder","Reset":"Reset","Reset_password":"Şifreyi sıfırla","Restart":"Tekrar başlat","Restart_the_server":"sunucuyu yeniden başlatın","RocketBot_Enabled":"RocketBot Etkin","RocketBot_Name":"RocketBot Adı","RocketBot_Name_Description":"RocketBot adı sunucuda kayıtlı geçerli bir kullanıcı adı olmalıdır.","Role":"rol","Role_Editing":"rol Düzenleme","Role_removed":"rol kaldırıldı","Room":"Oda","Room_archivation_state":"devlet","Room_archivation_state_false":"Aktif","Room_archivation_state_true":"arşivlenen","Room_archived":"Oda arşivlenen","room_changed_privacy":"<em>__user_by__</em> Tarafından <em>__room_type__:</em> Oda tipi değiştirildi","room_changed_topic":"<em>__user_by__</em> Tarafından <em>__room_topic__:</em> Oda konu olarak değiştirildi","Room_has_been_deleted":"Oda silindi","Room_Info":"Oda Bilgileri","Room_name_changed":"Oda adı <em>__user_by__</em> tarafından <em>__room_name__</em> olarak değiştirildi","Room_name_changed_successfully":"Oda adı başarıyla değiştirildi","Room_not_found":"Oda bulunamadı","Room_topic_changed_successfully":"Oda konu başarıyla değiştirildi","Room_type_changed_successfully":"Oda tipi başarıyla değiştirildi","Room_unarchived":"arşivden oda","Room_uploaded_file_list":"dosyalar listesi","Room_uploaded_file_list_empty":"Hiçbir dosya mevcut.","room_user_count":"%s kullanıcılar","Rooms":"Odalar","S_new_messages_since_s":" %s beri %s yeni mesajlar","SAML":"SAML","SAML_Custom_Cert":"özel Belgesi","SAML_Custom_Entry_point":"Özel Giriş Noktası","SAML_Custom_Generate_Username":"Adı oluşturmak","SAML_Custom_Issuer":"özel İhraççı","SAML_Custom_Provider":"özel Sağlayıcı","Save":"Kaydet","Save_changes":"Değişiklikleri kaydet","Save_Mobile_Bandwidth":"Kaydet Mobil Bant Genişliği","Save_to_enable_this_action":"Bu eylemi etkinleştirmek için Kaydet","Saved":"kaydedilmiş","Saving":"tasarruf","Scope":"kapsam","Screen_Share":"ekran Paylaşımı","Script_Enabled":"Senaryo Etkin","Search":"Ara","Search_by_username":"Kullanıcı adına göre ara","Search_Channels":"Kanal Arama","Search_Direct_Messages":"Doğrudan Mesajlar Arama","Search_Messages":"Mesajlarda ara","Search_Private_Groups":"Özel Gruplar Arama","Search_settings":"Arama ayarları","seconds":"saniye","See_all":"Tümünü gör","See_only_online":"Sadece çevrimiçi","Select_a_department":"Bir bölümü seçmek","Select_an_avatar":"Bir avatar seç","Select_file":"Dosya seç","Select_service_to_login":"Bilgisayarınızdan veya aşağıda ki servislerden birini kullanarak resim yükleyebilirsiniz","Select_user":"seç kullanıcı","Select_users":"seç kullanıcılar","Selected_agents":"seçilmiş maddeler","Selected_users":"Seçilen üyeler","Send":"göndermek","Send_a_message":"Bir mesaj göndermek","Send_a_test_mail_to_my_user":"benim kullanıcı için bir sınama posta göndermek","Send_a_test_push_to_my_user":"Benim kullanıcıya bir test itme gönder","Send_confirmation_email":"Doğrulama e-postası gönder","Send_data_into_RocketChat_in_realtime":"gerçek zamanlı Rocket.Chat içine veri gönderme.","Send_email":"Eposta gönder","Send_invitation_email":"davet e-postası gönder","Send_invitation_email_error":"Sen herhangi bir geçerli e-posta adresi sağlanmamıştır.","Send_invitation_email_info":"Bir seferde birden fazla e-posta davetiyeleri gönderebilirsiniz.","Send_invitation_email_success":"Başarıyla aşağıdaki adreslere davetiye e-posta gönderdiğiniz adres:","Send_invitation_email_warning":"davetiye e-postalar göndermek için, öncelikle SMTP ayarlarını yapılandırmanız gerekir.","Send_Message":"Mesaj Gönder","Send_your_JSON_payloads_to_this_URL":"Bu URL'ye JSON yüklerini gönderin.","Sending":"Gönderiliyor ...","Set_as_moderator":"moderatör olarak ayarla","Set_as_owner":"sahibi olarak ayarla","Settings":"Ayarlar","Settings_updated":"Ayarlar güncellendi","Should_be_a_URL_of_an_image":"Bir resmin URL olmalıdır.","Should_exists_a_user_with_this_username":"Kullanıcı zaten mevcut olması gerekir.","Show_all":"Tümünü göster","Show_more":"Daha fazla göster","Show_only_online":"yalnızca çevrimiçi göster","Show_preregistration_form":"ön kayıt formunu göster","Showing_archived_results":"<p> <b> %s</b> arşivlenmiş sonuçlar gösteriliyor </p>","Showing_online_users":"Gösterilen <b>__total_showing__</b>__Total__ kullanıcıların","Showing_results":"<p> <b>%s</b> kayıt bulundu</p>","Silence":"Sessizlik","since_creation":"tarih %s","Site_Name":"Site adı","Site_Url":"Site URL'si","Site_Url_Description":"Örnek: https://chat.domain.com/","Skip":"atlamak","Smileys_and_People":"Suratlar ve İnsanlar","SMTP":"SMTP","SMTP_Host":"SMTP Sunucusu","SMTP_Password":"SMTP Şifre","SMTP_Port":"SMTP Bağlantı Noktası(Port)","SMTP_Test_Button":"Test SMTP Ayarları","SMTP_Username":"SMTP Kullanıcı Adı","Sound":"Ses","Star_Message":"Favorilere ekle","Starred_Messages":"Favori İletilerim","Start_audio_call":"Ses aramayı başlatmak","Start_Chat":"Sohbete Başla","Start_of_conversation":"Konuşma Başladı","Start_OTR":"Başlangıç ​​OTR","Start_video_call":"Video araması başlatmak","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Ile başlayın <code class=\"inline\">%s</code> kullanıcı veya için <code class=\"inline\">%s</code> kanalı için. Örn: <code class=\"inline\">%s</code> veya <code class=\"inline\">%s</code>","Statistics":"istatistik","Stats_Active_Users":"Aktif Kullanıcılar","Stats_Avg_Channel_Users":"Ortalama Kanal Kullanıcıları","Stats_Avg_Private_Group_Users":"Ortalama Özel Grup Kullanıcıları","Stats_Away_Users":"Deplasman Kullanıcılar","Stats_Max_Room_Users":"Max Odalar Kullanıcılar","Stats_Non_Active_Users":"Aktif Olmayan Kullanıcılar","Stats_Offline_Users":"Çevrimdışı Kullanıcılar","Stats_Online_Users":"Çevrimiçi Kullanıcılar","Stats_Total_Channels":"Toplam Kanal","Stats_Total_Direct_Messages":"Toplam Direkt Mesajlar","Stats_Total_Messages":"Toplam İleti","Stats_Total_Private_Groups":"Toplam Özel Gruplar","Stats_Total_Rooms":"Toplam Kanal","Stats_Total_Users":"Toplam Kullanıcı","Stop_Recording":"Kaydı Durdur","strike":"üstü çizili","Subject":"konu","Submit":"Gönder","Success":"başarı","Survey":"anket","Survey_instructions":"Tamamen memnun anlam tamamen tatminsiz olan, yani sizi tatmin göre 1 her soruyu oranı ve 5.","Symbols":"semboller","Sync_success":"Senkronizasyon başarı","Sync_Users":"Senkronizasyon Kullanıcılar","Test_Connection":"Test bağlantısı","Test_Desktop_Notifications":"Deney Masaüstü Bildirimleri","Thank_you_for_your_feedback":"Görüşleriniz için teşekkür ederiz","The_application_name_is_required":"Uygulama adı gerekli","The_channel_name_is_required":"kanal adı gerekli","The_emails_are_being_sent":"e-postalar gönderiliyor.","The_field_is_required":"%s alanı zorunludur.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Biz ImageMagick veya GraphicsMagick sunucunuzda yüklü algılayamaz çünkü resim boyutlandırmak çalışmaz.","The_redirectUri_is_required":"redirectUri gereklidir","The_server_will_restart_in_s_seconds":"Sunucu %s saniye içinde yeniden başlayacak","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Ayar% <strong>s%</strong></strong> <strong>s</strong> yapılandırılır <strong>ve %s</strong> erişen!","The_user_will_be_removed_from_s":" %s kullanıcısı silinecektir","The_user_wont_be_able_to_type_in_s":" %s kullanıcısı yazmaya mümkün olmayacaktır","Theme":"Tema","theme-color-action-buttons-color":"Eylemler Düğmeler Renk","theme-color-active-channel-background-color":"Aktif Kanal Arka Plan Rengi","theme-color-active-channel-font-color":"Active Channel Yazı Rengi","theme-color-blockquote-background":"Blockquote Arka Plan Rengi","theme-color-clean-buttons-color":"Temiz Düğmeler Renk","theme-color-code-background":"Kod Arka Plan Rengi","theme-color-code-border":"Kod Çerçeve Rengi","theme-color-code-color":"kodu Renk","theme-color-content-background-color":"İçerik Arka Plan Rengi","theme-color-custom-scrollbar-color":"Özel Scrollbar Renk","theme-color-info-active-font-color":"Aktif Bilgi Yazı Rengi","theme-color-info-font-color":"Bilgi Yazı Rengi","theme-color-input-font-color":"Giriş Yazı Rengi","theme-color-link-font-color":"Bağlantı Yazı Rengi","theme-color-message-hover-background-color":"Mesaj Vurgusu BG Renk","theme-color-primary-background-color":"Birincil Arka Plan Rengi","theme-color-primary-font-color":"Birincil Yazı Rengi","theme-color-quaternary-font-color":"Kuvaterner Yazı Rengi","theme-color-secondary-background-color":"İkincil Arka Plan Rengi","theme-color-secondary-font-color":"İkincil Yazı Rengi","theme-color-smallprint-font-color":"Küçük Baskı Yazı Rengi","theme-color-smallprint-hover-color":"Küçük Baskı Vurgusu Rengi","theme-color-status-away":"Deplasman Durum Renk","theme-color-status-busy":"Meşgul Durum Renk","theme-color-status-offline":"Çevrimdışı Durum Renk","theme-color-status-online":"Çevrimiçi Durum Renk","theme-color-tertiary-background-color":"Tersiyer Arka Plan Rengi","theme-color-tertiary-font-color":"Tersiyer Yazı Rengi","theme-color-unread-notification-color":"Okunmamış Bildirimler Renk","theme-custom-css":"özel CSS","There_are_no_agents_added_to_this_department_yet":"Henüz bu bölüme eklenen herhangi bir etken vardır.","There_are_no_integrations":"Hiçbir entegrasyonlar vardır","There_are_no_users_in_this_role":"Bu rolü kullanıcı yok.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Bu e-posta zaten kullanıldı ve doğrulanmadı. Lütfen şifrenizi değiştirin.","This_is_a_desktop_notification":"Bu bir masaüstü bildirim","This_is_a_push_test_messsage":"Bu itme testi messsage olduğunu","Time_in_seconds":"Zaman, saniye olarak","Title_bar_color":"Başlık çubuğu rengi","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":", Web sitenize Rocket.Chat LIVECHAT yüklemek için kopyalayıp sitenizde son <strong></ body></strong> etiketinin üzerinde bu kodu yapıştırın.","To_users":"Kullanıcılara","Topic":"konu","Travel_and_Places":"Seyahat ve Yerler","Trigger_removed":"tetik kaldırıldı","Trigger_Words":"tetikleyici Kelimeler","Triggers":"tetikleyiciler","True":"Gerçek","Type":"tip","Type_your_new_password":"Yeni şifrenizi yazın","Unarchive":"Arşivden Çıkar","Unmute_someone_in_room":"Odada Sesi aç birisi","Unmute_user":"Sesi aç kullanıcı","Unnamed":"Adsız","Unpin_Message":"unpin Mesaj","Unread_Rooms":"okunmamış Odalar","Unread_Rooms_Mode":"Okunmamış Odalar Modu","Unstar_Message":"Yıldızı kaldır","Upload_file_question":"Dosya yükle","Uploading_file":"Dosya yükleniyor ...","Use_account_preference":"Hesap tercihi kullanın","Use_Emojis":"Kullanım emojiyi","Use_initials_avatar":"Kullanıcı adınızın ilk iki harfini kullanın","use_menu":"Kanallara ve direkt mesajlarınıza erişmek için menüyü kullanın","Use_service_avatar":"%s Avatar olarak kullan","Use_this_username":"Bu kullanıcı adını kullan","Use_uploaded_avatar":"Yüklenen avatarı kullanın","Use_url_for_avatar":"avatar için url kullanın","User__username__is_now_a_moderator_of__room_name_":"Kullanıcı __username__ adlı şimdi __room_name__ bir moderatör olduğunu","User__username__is_now_a_owner_of__room_name_":"Kullanıcı __username__ adlı şimdi __room_name__ bir sahibidir","User__username__removed_from__room_name__moderators":"Kullanıcı __username__ adlı __room_name__ moderatörler kaldırıldı","User__username__removed_from__room_name__owners":"Kullanıcı __username__ adlı __room_name__ sahipleri kaldırılır","User_added":"<em>__user_added__</em> eklendi.","User_added_by":"<em>__user_added__</em>,  <em>__user_by__</em> tarafından eklendi.","User_added_successfully":"Kullanıcı başarıyla eklendi","User_Channels":"kullanıcı Kanalları","User_doesnt_exist":"Hiçbir kullanıcı `@ %s` adıyla var.","User_has_been_activated":"Kullanıcı aktif edildi","User_has_been_deactivated":"Kullanıcı devre dışı bırakıldı","User_has_been_deleted":"Kullanıcı silindi","User_has_been_muted_in_s":"Kullanıcı %s sesi kapatıldı","User_has_been_removed_from_s":"Kullanıcı %s kaldırıldı","User_has_disconnected":"Kullanıcı bağlantısı kesildi","User_Info":"kullanıcı bilgisi","User_is_no_longer_an_admin":"Kullanıcı artık bir yönetici","User_is_not_activated":"Kullanıcı etkinleştirilmedi","User_is_now_an_admin":"Kullanıcı şimdi bir yönetici","User_joined_channel":"Kanala katıldı.","User_joined_channel_female":"Kanala katıldı.","User_joined_channel_male":"Kanala katıldı.","User_left":"Kullanıcı <em>__user_left__</em>bıraktı.","User_left_female":"kanal ayrıldı.","User_left_male":"kanal ayrıldı.","User_logged_out":"Kullanıcı dışarı kaydedilir","User_management":"Kullanıcı yönetimi","User_muted_by":"Kullanıcı <em>__user_muted__</em> <em>__user_by__</em> tarafından kapatıldı.","User_muted_in_room":"Kullanıcı odasında sessiz","User_not_found":"Kullanıcı bulunamadı","User_not_found_or_incorrect_password":"Kullanıcı bulunamadı veya yanlış parola değil","User_or_channel_name":"Kullanıcı veya kanal adı","User_removed":"kullanıcı kaldırıldı","User_removed_by":"<em>__user_removed__</em> <em>__user_by__</em> tarafından kaldırıldı.","User_removed_from_room":"kullanıcı odadan kaldırıldı","User_Settings":"Kullanıcı Ayarları","User_unmuted_by":"Kullanıcı <em>__user_unmuted__</em> <em>__user_by__</em> tarafından sesini açtı.","User_unmuted_in_room":"Odada sesi tekrar kullanıcı","User_updated_successfully":"Kullanıcı başarılı bir şekilde güncellendi","Username":"Kullanıcı adı","Username_and_message_must_not_be_empty":"Kullanıcı adı ve mesaj boş olmamalıdır.","Username_cant_be_empty":"kullanıcı adı boş bırakılamaz!","Username_Change_Disabled":"Sizin Rocket.Chat yönetici kullanıcı adları değişen engellenmiştir","Username_denied_the_OTR_session":"__username__ adlı OTR oturumu yalanladı","Username_description":"Kullanıcı adınızı, diğerleri mesajlarda sizi söz izin vermek için kullanılır.","Username_doesnt_exist":"Kullanıcı adı ` %s` yoktur.","Username_ended_the_OTR_session":"__username__ adlı OTR oturumu sona erdi","Username_invalid":"<strong>%s</strong> geçerli bir kullanıcı adı değil,<br/> Kullanıcı adınızı seçerken sadece harfler, sayılar, noktalar ve tireler kullanın","Username_is_already_in_here":"`@ %s` burada zaten.","Username_is_not_in_this_room":"Kullanıcı `# %s` bu odada değil.","Username_not_found":"Kullanıcı adı bulunamadı","Username_title":"Bir kullanıcı adı belirle","Username_unavaliable":"<strong>%s</strong> başka biri tarafından kullanılıyor :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ adlı OTR başlamak istiyor. kabul etmek istiyor musunuz?","Users":"Kullanıcılar","Users_in_role":"rolü Kullanıcılar","UTF8_Names_Slugify":"UTF8 İsimler Slugify","UTF8_Names_Validation":"UTF8 İsimler Doğrulama","UTF8_Names_Validation_Description":"özel karakterler ve boşluklar izin vermeyin. _ Ve - kullanabilirsiniz. ancak adının sonunda","Verification_email_sent":"Doğrulama e-postası gönderildi","View_All":"Hepsini Gör","View_Logs":"Görünüm Günlükleri","Visibility":"görünürlük","Visible":"görünür","Visitor":"Ziyaretçi","Visitor_page_URL":"Ziyaretçi sayfası URL'si","Visitor_time_on_site":"Sitede Ziyaretçi zamanı","Wait_activation_warning":"Giriş yapmadan önce, hesabınızın bir yönetici tarafından etkinleştirilmesi gerekiyor.","We_are_offline_Sorry_for_the_inconvenience":"Biz çevrimdışı. Rahatsızlıktan dolayı özür dileriz.","We_have_sent_password_email":"Parolanı sıfırlamak için sana bir e-posta gönderdik.. Eğer e-posta kısa bir süre içerisinde sana ulaşmazsa lütfen geri dön ve tekrar dene.","We_have_sent_registration_email":"Hesabını doğrulamamız için bir onay e-postası gönderdik. Eğer e-posta kısa bir süre içerisinde sana ulaşmazsa lütfen geri dön ve tekrar dene.","WebRTC_Enable_Channel":"Kamu Kanallar için etkinleştirme","WebRTC_Enable_Direct":"Doğrudan Mesajlar için etkinleştirme","WebRTC_Enable_Private":"Özel Kanallar için etkinleştirme","WebRTC_Servers":"STUN / DÖNÜŞ Sunucular","WebRTC_Servers_Description":"virgülle ayrılmış STUN ve TURN sunucularının listesi. <br/> şifre @ sersemletici: Kullanıcı adı, şifre ve port biçiminde `adı izin verilen konak: port` veya` kullanıcı adı: şifre @ dönüş: host: port`.","Welcome":"Hoşgeldin <em>%s</em>.","Welcome_to_the":"Hoşgeldiniz","will_be_able_to":"edebilecektir","With_whom":"Kiminle","Yes":"Evet","Yes_clear_all":"Evet, açık tüm!","Yes_delete_it":"Evet, bunu silin!","Yes_hide_it":"Evet, bunu gizlemek!","Yes_leave_it":"Evet, bırakın!","Yes_mute_user":"Evet, dilsiz kullanıcı!","Yes_remove_user":"Evet, kullanıcıyı kaldırmak!","you_are_in_preview_mode_of":"Kanal  #<strong>__room_name__</strong>","You_are_logged_in_as":"Sen olarak oturum","You_are_not_authorized_to_view_this_page":"Bu sayfayı görüntüleme yetkiniz yok.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Sen son sahibi. oda ayrılmadan önce yeni sahibini ayarlayın.","You_can_change_a_different_avatar_too":"Bu entegrasyondan göndermek için kullanılan avatar geçersiz kılabilirsiniz.","You_can_use_an_emoji_as_avatar":"Ayrıca bir avatar olarak emoji kullanabilirsiniz.","You_have_been_muted":"Sen yok sayıldı ve bu odada konuşamıyor","You_have_not_verified_your_email":"E-postanızı kontrol etmediniz.","You_have_successfully_unsubscribed":"Başarıyla listemize aboneliğinden çıktınız.","You_informed_an_invalid_FROM_address":"Eğer adresinden DAN geçersiz bilgilendirdi.","You_must_provide_the_unsubscribe_link":"Sen [abonelikten] bağlantısını sağlamalıdır.","You_need_confirm_email":"Giriş yapabilmek için öncelikle e-posta adresinizi onaylamanız gerekmektedir!","You_need_install_an_extension_to_allow_screen_sharing":"Ekran paylaşımını sağlamak için bir uzantı yüklemeye gerek","You_need_to_change_your_password":"Şifrenizi değiştirmek gerekir","You_need_to_type_in_your_password_in_order_to_do_this":"Bunu yapmak için şifrenizi yazmanız gerekir!","You_need_to_type_in_your_username_in_order_to_do_this":"Bunu yapmak için kullanıcı adınızı yazmanız gerekir!","You_need_to_verifiy_your_email_address_to_get_notications":"Sen bildirimleri almak için e-posta adresinizi doğrulanana gerekiyor","You_should_name_it_to_easily_manage_your_integrations":"Bunu kolayca entegrasyon yönetmek için isim olmalıdır.","You_will_not_be_able_to_recover":"Sen kurtarmak mümkün olmayacaktır!","You_will_not_be_able_to_recover_file":"Bu dosyayı kurtarmak mümkün olmayacaktır!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"E-postanızı kontrol etmediniz çünkü e-posta bildirimleri almayacaksınız.","Your_email_has_been_queued_for_sending":"E-posta göndermek için sıraya alındı","Your_entry_has_been_deleted":"Sizin kaydınız silindi.","Your_file_has_been_deleted":"Dosyanız silindi.","Your_mail_was_sent_to_s":"Posta %s gönderildi","Your_Open_Source_solution":"Açık Kaynak Sohbet Uygulaması","Your_password_is_wrong":"Parolanız yanlış!","Your_push_was_sent_to_s_devices":"Sizin itme %s cihazlara gönderildi"});
TAPi18n._registerServerTranslator("tr", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/ug.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["ug"] = ["Uighur","Uyƣurqə"];                                                                  // 8
if(_.isUndefined(TAPi18n.translations["ug"])) {                                                                        // 9
  TAPi18n.translations["ug"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["ug"][namespace])) {                                                             // 13
  TAPi18n.translations["ug"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["ug"][namespace], {"Access_online_demo":"توردىكى سىناق نۇسخىسىنى ئىشلىتىپ بېقىش","Access_Online_Demo":"توردىكى سىناق نۇسخىسىنى ئىشلىتىپ بېقىش","Add_Members":"قوللانچى قوشۇش","Add_users":"ئەزا قوشۇش","All_channels":"ھەممە قاناللار","and":"ۋە","are_also_typing":"يېزىۋاتىدۇ","are_typing":"يېزىۋاتىدۇ","Avatar":"باش رەسىم ئالماشتۇرۇش","away":"توردا يوق","Away":"توردا يوق","Back_to_login":"كىرىش بېتىگە قايتىش","bold":"توم","busy":"ئالدىراش","Busy":"ئالدىراش","Cancel":"ۋاز كېچىش","Channels":"قاناللار","Channels_list":"قاناللار","Chat_Rooms":"پاراڭخانىلار","close":"ئۆچۈرۈش","coming_soon":"ياسىلىۋاتىدۇ","Confirm_password":"پارول جەزملەشتۈرۈش","Contact":"ئالاقىلىشىش","Conversation":"پاراڭ","Create_new":"يېڭى","Created_at":"قۇرۇلغان","Direct_Messages":"ئۇدۇل ئۇچۇر يېزىش","edited":"تەھرىرلەنگەن","Email_or_username":"ئىلخەت ياكى ئەزا نامى","Email_verified":"ئىلخەت جەزملەندى","Enter_info":"ئەزا ئۇچۇرىڭىزنى كىرگۈزۈڭ","Error_changing_password":"پارول ئۆزگەرتىلدى.","Favorites":"خۇرجۇن","Forgot_password":"پارول ئۇنۇتتىڭىزمۇ","Fork_it_on_github":"githubدا fork قىلىش","Hide_room":"پاراڭخانىنى يوشۇرۇش","History":"تارىخ","inline_code":"inline_code","Invalid_confirm_pass":"ئىككى قېتىم كىرگۈزگەن پارول بىردەك ئەمەس","Invalid_email":"كىرگۈزگەن ئىلخەت ئادرېسى توغرا ئەمەس","Invalid_name":"ئەزا نامىنى چوقۇم كىرگۈزۈڭ","Invalid_pass":"پارولنى چوقۇم كىرگۈزۈڭ","Invalid_room_name":"<strong>%s</strong> مۇۋاپىق پاراڭخانا ئىسمى ئەمەسكەن,<br/> ھازىرچە لاتىنچە ھەرپ، سان ۋە ئاستى سىزىقنىلا قوللايدۇ.","invisible":"كۆرۈنمەيدىغان","Invisible":"كۆرۈنمەيدىغان","is_also_typing":"يېزىۋاتىدۇ","is_typing":"يېزىۋاتىدۇ","italics":"يانتۇ خەت","join":"قوشۇلۇش","Join_the_Community":"جامائەتكە قوشۇلۇش","Language":"تىل","Language_Version":"ئىنگلىزچە","Last_message":"ئاخىرقى خەت","Leave_room":"پاراڭخانىدىن چېكىنىش","line":"line","Livechat_enabled":"Livechat Enabled","Load_more":"تېخىمۇ كۆپ","Loading_suggestion":"تەۋسىيە يۈكلىنىۋاتىدۇ...","Login":"كىرىش","Login_with":"%s بىلەن كىرىش","login_with":"ياكى بىۋاسىتە كىرىش","Logout":"چېكىنىش","Members_List":"قوللانچىلار","More_channels":"باشقا قاناللار","Msgs":"خەتلەر","multi":"كۆپ","n_messages":"%s خەت","Name":"ئىسىم","New_messages":"يېڭى خەت","New_password":"يېڭى پارول","No_channels_yet":"سىز ھېچ قايسى قانالغا تەۋە ئەمەسكەنسىز.","No_direct_messages_yet":"سىز تېخى ھېچقانداق پاراڭ باشلىماپسىز.","No_favorites_yet":"خۇرجۇنغا ھېچنېمە سالماپسىز.","No_groups_yet":"سىزنىڭ تېخى مەخپىي گۇرۇپپىڭىز يوقكەن.","No_permission_to_view_room":"بۇ پاراڭخانىغا كىرىشكە ھوقۇقىڭىز يەتمەيدىكەن.","Not_allowed":"ھوقۇق يەتمىدى","Not_found_or_not_allowed":"تېپىلمىدى ياكى ھوقۇق يەتمىدى","Nothing_found":"تېپىلمىدى","Online":"توردا","Oops!":"ئاپلا","Password":"پارول","Please_wait":"ساقلاڭ","Powered_by":"Powered by","Privacy":"بىخەتەرلىك كېلىشىمى","Private_Groups":"مەخپىي گۇرۇپپىلار","Proudly_developed":"Proudly developed with Meteor","Quick_Search":"ئىزدەش","quote":"دەلىل كەلتۈرۈش","Recents":"يېقىنقىلىرى","Register":"يېڭى ئاكونت تىزىملىتىش","Remember_me":"ئېسىدە ساقلىسۇن","Remove":"ئۆچۈرۈش","Reset_password":"پارول يېڭىلاش","Room":"پاراڭخانا","Room_name_changed":"پاراڭخانا نامى <em>__user_by__</em> تەرىپىدىن <em>__room_name__</em> قىلىپ ئۆزگەرتىلدى ","Room_name_changed_successfully":"پاراڭخانا نامى مۇۋەپپەقىيەتلىك ئۆزگەرتىلدى","Save":"ساقلاش","Search":"ئىزدەش","See_all":"ھەممىنى كۆرۈش","See_only_online":"توردىكىلەرنىلا كۆرۈش","Select_an_avatar":"باش رەسىم تاللاش","Select_file":"ھۆججەت تاللاش","Selected_users":"تاللانغان قوللانچىلار","Send_confirmation_email":"جەزملەشتۈرۈش ئىلخىتى ئەۋەتىش","Send_Message":"خەت ئەۋەتىش","Settings":"تەڭشەكلەر","Showing_online_users":"__total__ ئەزانىڭ ئىچىدىكى <b>__total_showing__</b> كۆرسىتىلدى","Showing_results":"<p><b>%s</b> نەتىجە تېپىلدى</p>","Silence":"جىمجىت","since_creation":"%s باشلاپ","Start_Chat":"Start Chat","Start_of_conversation":"پاراڭ باشلاش","strike":"ئۇرۇش","Submit":"تاپشۇرۇش","The_field_is_required":"%s چوقۇم تولدۇرۇلىشى كېرەك.","Use_initials_avatar":"ئىسمىڭىزنىڭ باشلانغان ھەرپلىرىنى ئىشلىتىڭ","use_menu":"ياندىكى تىزىملىك ئارقىلىق پاراڭخانا ۋە پاراڭلارنى تېپىڭ","Use_service_avatar":"%s باش رەسىمنى ئىشلىتىش","Use_this_username":"بۇ ئىسىمنى ئىشلىتىڭ","Use_uploaded_avatar":"يۈكلەنگەن باش رەسىمنى ئىشلىتىش","User_added":"<em>__user_added__</em> ئەزا قوشۇلدى.","User_added_by":" <em>__user_by__</em> يېڭىدىن <em>__user_added__</em> دېگەن ئەزانى قوشتى.","User_joined_channel":"قانالغا قوشۇلدى.","User_left":"<em>__user_left__</em> پاراڭخانىدىن چېكىندى.","User_logged_out":"ئەزا سىستېمىدىن چېكىندى","User_removed_by":"<em>__user_by__</em>، <em>__user_removed__</em> دېگەن ئەزانى ئۆچۈردى.","Username":"ئەزا نامى","Username_cant_be_empty":"ئەزا نامى چوقۇم تولدۇرىلىشى كېرەك","Username_description":"ئەزا نامىڭىزنى باشقىلار پاراڭ ئارىلىقىدا @ قىلىش ئارقىلىق سىزنى پاراڭغا چاقىرىدۇ.","Username_invalid":"<strong>%s</strong> مۇۋاپىق ئەزا نامى ئەمەسكەن,<br/> ھازىرچە لاتىنچە ھەرپ، سان ۋە ئاستى سىزىقنىلا قوللايدۇ.","Username_title":"ئەزا تىزىملىتىش","Username_unavaliable":"<strong>%s</strong> دېگەن ئىسىمنى باشقىلار ئىشلىتىپ بوپتۇ :(","View_All":"ھەممىنى كۆرۈش","Welcome":"ئەسسالامۇ-ئەلەيكۇم <em>%s</em>.","Welcome_to_the":"كەلگىنىزگە مەرھابا","You_need_confirm_email":"ئىلخەتنى جەزملەشتۈرۈپ بولغاندىن كېيىن كىرەلەيسىز!","Your_Open_Source_solution":"ئۆزىڭىزنىڭ ئوچۇق كودلۇق پاراڭلىشىش ھەل قىلىش ئۇسۇلى"});
TAPi18n._registerServerTranslator("ug", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/uk.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["uk"] = ["Ukrainian","Українська"];                                                            // 8
if(_.isUndefined(TAPi18n.translations["uk"])) {                                                                        // 9
  TAPi18n.translations["uk"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["uk"][namespace])) {                                                             // 13
  TAPi18n.translations["uk"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["uk"][namespace], {"500":"Внутрішня помилка сервера","0_Errors_Only":"0 - Тільки помилки","1_Errors_and_Information":"1 - Помилки та інформації","2_Erros_Information_and_Debug":"2 - Erros, інформація та налагодження","__username__was_set__role__by__user_by_":"__username__ був встановлений __role__ по __user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__ більше не __role__, по __user_by__","Access_not_authorized":"Доступ не дозволяється","Access_online_demo":"Спробувати онлайн демо","Access_Online_Demo":"Спробувати демо-версію","Access_Token_URL":"URL Токен доступу","Accounts":"рахунки","Accounts_AllowDeleteOwnAccount":"Дозволити користувачам видаляти власний обліковий запис","Accounts_AllowedDomainsList":"Список дозволених доменів","Accounts_AllowedDomainsList_Description":"Розділених комами список дозволених доменів","Accounts_AllowEmailChange":"Дозволити E-mail Змінити","Accounts_AllowPasswordChange":"Дозволити зміну пароля","Accounts_AllowUserAvatarChange":"Дозволити Аватар користувача Зміна","Accounts_AllowUsernameChange":"Дозволити Ім'я користувача Зміна","Accounts_AllowUserProfileChange":"Дозволити Профіль користувача Зміна","Accounts_AvatarResize":"Зміна розміру аватари","Accounts_AvatarSize":"Аватар Розмір","Accounts_AvatarStorePath":"Шлях до аватарам","Accounts_AvatarStoreType":"Аватар для зберігання Тип","Accounts_BlockedDomainsList":"Заблоковані Список доменів","Accounts_BlockedDomainsList_Description":"Розділених комами список заблокованих доменів","Accounts_denyUnverifiedEmail":"Заборонити неперевірену електронну пошту","Accounts_EmailVerification":"Електронна пошта Перевірка","Accounts_EmailVerification_Description":"Переконайтеся, що у вас є правильні настройки SMTP, щоб використовувати цю функцію","Accounts_Enrollment_Email":"Зарахування Електронна пошта","Accounts_Enrollment_Email_Description":"Ви можете використовувати [ім'я], [Fname], [LNAME] повне ім'я користувача, ім'я або прізвище, відповідно. <br /> Ви можете використовувати [Email] для електронної пошти користувача.","Accounts_Iframe_api_method":"метод Апі","Accounts_Iframe_api_url":"Апі Url","Accounts_iframe_enabled":"включено","Accounts_iframe_url":"Iframe Url","Accounts_LoginExpiration":"Ввійти Дійсно в дні","Accounts_ManuallyApproveNewUsers":"Вручну затвердити нові користувачі","Accounts_OAuth_Custom_Token_Sent_Via":"Токен посланими через","Accounts_OAuth_Custom_Authorize_Path":"авторизуватися Шлях","Accounts_OAuth_Custom_Button_Color":"колір кнопки","Accounts_OAuth_Custom_Button_Label_Color":"Кнопка Колір тексту","Accounts_OAuth_Custom_Button_Label_Text":"текст кнопки","Accounts_OAuth_Custom_Enable":"включити","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"ідентичність Шлях","Accounts_OAuth_Custom_Login_Style":"Ввійти Стиль","Accounts_OAuth_Custom_Secret":"секрет","Accounts_OAuth_Custom_Token_Path":"токен Шлях","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook Ввійти","Accounts_OAuth_Facebook_callback_url":"URL facebook Зворотній дзвінок","Accounts_OAuth_Facebook_id":"Facebook App Id","Accounts_OAuth_Facebook_secret":"секретний facebook","Accounts_OAuth_Github":"OAuth Enabled","Accounts_OAuth_Github_callback_url":"URL Github Зворотній дзвінок","Accounts_OAuth_GitHub_Enterprise":"OAuth Enabled","Accounts_OAuth_GitHub_Enterprise_callback_url":"URL GitHub Enterprise Зворотній дзвінок","Accounts_OAuth_GitHub_Enterprise_id":"ідентифікатор клієнта","Accounts_OAuth_GitHub_Enterprise_secret":"клієнт Секретний","Accounts_OAuth_Github_id":"ідентифікатор клієнта","Accounts_OAuth_Github_secret":"клієнт Секретний","Accounts_OAuth_Gitlab":"OAuth Enabled","Accounts_OAuth_Gitlab_callback_url":"URL GitLab Зворотній дзвінок","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"клієнт Секретний","Accounts_OAuth_Google":"Google Ввійти","Accounts_OAuth_Google_callback_url":"URL Google Зворотній дзвінок","Accounts_OAuth_Google_id":"Id Google","Accounts_OAuth_Google_secret":"Google Секретний","Accounts_OAuth_Linkedin":"LinkedIn Ввійти","Accounts_OAuth_Linkedin_callback_url":"URL Linkedin Зворотній дзвінок","Accounts_OAuth_Linkedin_id":"LinkedIn Id","Accounts_OAuth_Linkedin_secret":"LinkedIn Секретний","Accounts_OAuth_Meteor":"Метеор Ввійти","Accounts_OAuth_Meteor_callback_url":"URL Метеор Зворотній дзвінок","Accounts_OAuth_Meteor_id":"Метеор Id","Accounts_OAuth_Meteor_secret":"Метеор секретно","Accounts_OAuth_Twitter":"Twitter Ввійти","Accounts_OAuth_Twitter_callback_url":"URL Twitter Зворотній дзвінок","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Секретний","Accounts_OAuth_Wordpress":"WordPress Увійти","Accounts_OAuth_Wordpress_callback_url":"URL Wordpress Зворотній дзвінок","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Секретний","Accounts_PasswordReset":"Скидання пароля","Accounts_Registration_AuthenticationServices_Enabled":"Реєстрація з Authentication Services","Accounts_RegistrationForm":"Реєстраційний формуляр","Accounts_RegistrationForm_Disabled":"інвалід","Accounts_RegistrationForm_LinkReplacementText":"Форма реєстрації Посилання Заміна тексту","Accounts_RegistrationForm_Public":"суспільного","Accounts_RegistrationForm_Secret_URL":"секретний URL","Accounts_RegistrationForm_SecretURL":"Форма реєстрації Секретний URL","Accounts_RegistrationForm_SecretURL_Description":"Ви повинні забезпечити випадкову рядок, яка буде додана до вашої реєстрації URL. Приклад: https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"потрібна реєстрація","Accounts_RequireNameForSignUp":"Вимагати ім'я для Signup","Accounts_ShowFormLogin":"Показати на основі форм Ввійти","Accounts_UseDefaultBlockedDomainsList":"Використовувати за замовчуванням Заблоковані Список доменів","Accounts_UseDNSDomainCheck":"Використання домену DNS Перевірка","Activate":"активувати","Activity":"діяльність","Add":"додавати","Add_agent":"Додати агент","Add_custom_oauth":"Додати призначені для користувача OAuth","Add_manager":"Додати менеджер","Add_Members":"Додавання учасників","Add_User":"Додати користувача","Add_user":"Додати користувача","Add_users":"Додати користувачів","Additional_emails":"Додаткові електронні листи","Additional_Feedback":"Додаткова зв'язок","Administration":"адміністрація","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"Після аутентифікації oauth2, користувачі будуть перенаправлятися на цей URL","Agent_added":"агент додав","Agent_removed":"агент видалений","Alias":"кличка","All":"всі","All_channels":"всі канали","All_logs":"всі журнали","All_messages":"всі повідомлення","Allow_Invalid_SelfSigned_Certs":"Дозволити Invalid Самоподпісним Certs","Allow_Invalid_SelfSigned_Certs_Description":"Дозволити недійсні і самозаверенние SSL свідоцтво, для перевірки посилань і попередніх переглядів.","and":"і","And_more":"І ще __length __...","Animals_and_Nature":"Тварини і Природа","API":"API","API_Analytics":"аналітика","API_Embed":"вбудовувати","API_EmbedDisabledFor":"Відключити Код для користувачів","API_EmbedDisabledFor_Description":"Розділених комами список імен користувачів","API_GitHub_Enterprise_URL":"URL-адресу сервера","API_GitHub_Enterprise_URL_Description":"Приклад: http://domain.com (за винятком косу риску)","API_Gitlab_URL":"URL GitLab","API_Wordpress_URL":"WordPress URL","Appearance":"зовнішній вигляд","Application_added":"додана Застосування","Application_Name":"ім'я програми","Application_updated":"застосування оновлення","Apply_and_refresh_all_clients":"Застосувати і оновлення всіх клієнтів","Archive":"архів","Archive_Unarchive":"Архів / Розархівувати","are_also_typing":"досі друкують","are_typing":"друкує","Are_you_sure":"Ти впевнений?","Are_you_sure_you_want_to_delete_your_account":"Ви впевнені, що хочете видалити свій аккаунт?","Authorization_URL":"URL авторизації","Authorize":"санкціонувати","AutoLinker_StripPrefix":"AutoLinker Газа префікс","AutoLinker_StripPrefix_Description":"Короткий екран. наприклад https://rocket.chat => rocket.chat","AutoLinker_Urls":"URL AutoLinker","AutoLinker_UrlsRegExp":"AutoLinker URL Regular Expression","AutoLinker_Email":"AutoLinker E-mail","AutoLinker_Phone":"AutoLinker Телефон","AutoLinker_Phone_Description":"Автоматично пов'язані для номерів телефонів. наприклад, `(123) 456-7890`","Auto_Load_Images":"Auto Load Images","Available":"наявний","Available_agents":"доступні агенти","Avatar":"Змінити аватар","Avatar_changed_successfully":"Аватар успішно змінений","Avatar_URL":"URL Аватар","Avatar_url_invalid_or_error":"URL-адресу є недійсною або недоступна. Будь ласка, спробуйте ще раз, але з іншого URL.","away":"відійшов","Away":"Відійшов","away_female":"геть","Away_female":"геть","away_male":"геть","Away_male":"геть","Back":"назад","Back_to_applications":"Назад до додатків","Back_to_integrations":"Повернутися до інтеграції","Back_to_login":"Повернутися до логіну","Back_to_permissions":"Повернутися до дозволів","Body":"тіло","bold":"напівжирний","busy":"зайнятий","Busy":"Зайнятий","busy_female":"зайнятий","Busy_female":"Зайнятий","busy_male":"зайнятий","Busy_male":"Зайнятий","Cancel":"Відміна","Cannot_delete_a_protected_role":"Неможливо видалити захищену роль","Cannot_delete_role_because_its_in_use":"Неможливо видалити роль, тому що це в використанні","Cannot_invite_users_to_direct_rooms":"Чи не можете запрошувати користувачів на прямі номери","CDN_PREFIX":"CDN Приставка","Certificates_and_Keys":"Сертифікати та ключі","Channel":"канал","Channel_doesnt_exist":"Канал `# %s` не існує.","Channels":"Канали","Channels_list":"Список публічних каналів","Chat_Rooms":"Чати","Chatops_Enabled":"включити Chatops","Chatops_Title":"Chatops панель","Chatops_Username":"Chatops Ім'я користувача","Choose_a_room":"Виберіть номер","Choose_messages":"вибрати повідомлення","Choose_the_alias_that_will_appear_before_the_username_in_messages":"Виберіть псевдонім, який буде відображатися перед ім'ям користувача в повідомленнях.","Choose_the_username_that_this_integration_will_post_as":"Виберіть ім'я користувача, що ця інтеграція буде розміщувати як.","Clear_all_unreads_question":"Очистити всі unreads?","Client_ID":"ідентифікатор клієнта","Client_Secret":"клієнт Секретний","Clients_will_refresh_in_a_few_seconds":"Клієнти будуть оновлювати протягом декількох секунд","close":"Закрити","Closed":"закрито","Collapse_Embedded_Media_By_Default":"Згорнути вбудований носій за замовчуванням","coming_soon":"Скоро...","Commands":"команди","Compact_View":"компактний вид","Confirm_password":"Підтвердіть ваш пароль","Contact":"Контакти","Conversation":"Розмова","Convert_Ascii_Emojis":"Перетворення ASCII в Emoji","Copied":"скопійований","COPY_TO_CLIPBOARD":"КОПІЮВАТИ В БУФЕР ОБМІНУ","Copy_to_clipboard":"Копіювати в буфер обміну","Count":"Рахувати","Create":"створити","Create_new":"Створити новий","Created_at":"Створено у","Created_at_s_by_s":"Створено <strong>в% <strong>s%</strong></strong> <strong>s</strong> по","Custom_Fields":"призначені для користувача поля","Custom_oauth_helper":"При налаштуванні OAuth постачальника, ви повинні будете повідомити Callback URL. використання <pre> %s </pre> ,","Custom_oauth_unique_name":"Призначені для користувача OAuth унікальне ім'я","Custom_Script_Logged_In":"Призначений для користувача скрипт для зареєстрованих користувачів","Custom_Script_Logged_Out":"Призначений для користувача скрипт для зареєстрованих користувачів з","Dashboard":"Панель приладів","days":"днів","Deactivate":"дезактивувати","Debug_Level":"рівень налагодження","Default":"дефолт","Delete":"видаляти","Delete_my_account":"Видалити мій акаунт","Delete_Room_Warning":"Видалення номера будуть видалені всі повідомлення, які розмістив в кімнаті. Це не може бути скасоване.","Delete_User_Warning":"Видалення користувача будуть видалені всі повідомлення від цього користувача, а також. Це не може бути скасоване.","Deleted":"Видаляється!","Department_not_found":"Департамент не найден","Department_removed":"Відділ видалений","Departments":"відомства","Description":"опис","Desktop":"робочий стіл","Desktop_Notification_Test":"Шпалери для робочого Повідомлення Тест","Desktop_Notifications":"Повідомлення на робочому столі","Desktop_Notifications_Disabled":"Шпалери для робочого повідомлення відключені. Зміна налаштувань браузера, якщо вам потрібно включена функція оповіщення.","Desktop_Notifications_Enabled":"Шпалери для робочого повідомлення включені","Direct_message_someone":"Пряме сполучення хтось","Direct_Messages":"Особисті повідомлення","Direct_Messages_list":"прямі повідомлення","Disable_Favorite_Rooms":"відключити обране","Disable_New_Message_Notification":"Відключити повідомлення про нову","Disable_New_Room_Notification":"Відключити оповіщення New Room","Displays_action_text":"Текст Показує дії","Do_you_want_to_change_to_s_question":"Ви хочете , щоб <strong>змінити %s?</strong>","Drop_to_upload_file":"Відкиньте завантажити файл","Dry_run":"всуху","Dry_run_description":"Чи буде відправити тільки одну адресу електронної пошти, за тією ж адресою, що і в С. Електронна пошта повинна належати дійсному користувачеві.","Duplicate_archived_channel_name":"В архіві каналу з ім'ям ' %s' існує","Duplicate_archived_private_group_name":"Архівний Приватна група з ім'ям ' %s' існує","Duplicate_private_group_name":"Приватна група з ім'ям ' %s' існує","E-mail":"Електронна пошта","Edit":"редагувати","Edit_Custom_Field":"Зміна призначеного для користувача поля","Edit_Department":"редагувати Відділ","edited":"відредаговано","Email":"E-mail","Email_already_exists":"E-mail вже існує","Email_body":"Електронна пошта тіла","Email_Change_Disabled":"Ваш Rocket.Chat адміністратор відключив зміна електронної пошти","Email_from":"з","Email_Notification_Mode":"Offline Повідомлення по електронній пошті","Email_Notification_Mode_All":"Кожен Згадка / DM","Email_Notification_Mode_Disabled":"інвалід","Email_or_username":"Емейл або логін","Email_subject":"суб'єкт","Email_verified":"Емейл підтверджено ","Emoji":"Emoji","Empty_title":"порожній заголовок","Enable":"включити","Enable_Desktop_Notifications":"Оповіщення на робочому столі","Enabled":"включено","Encrypted_message":"зашифроване повідомлення","End_OTR":"кінець ОТР","Enter_a_regex":"Введіть регулярний вираз","Enter_a_room_name":"Введіть назву кімнати","Enter_a_username":"Введіть ім'я користувача","Enter_info":"Введіть вашу облікову інформацію","Enter_name_here":"Введіть ім'я тут","Enter_to":"Введіть в","Error":"помилка","error-cant-invite-for-direct-room":"Не можна запросити користувача на прямі номери","error-duplicate-channel-name":"Канал з ім'ям ' %s' існує","error-invalid-custom-field":"неприпустиме поле","error-invalid-custom-field-name":"Неправильне ім'я призначене для користувача поле. Використовуйте тільки латинські букви, цифри, дефіс і підкреслення.","error-invalid-password":"неправильний пароль","error-invalid-room":"Невірний номер","error-invalid-room-name":"<strong> %s</strong> не є допустимим ім'ям кімнати, <br/> Використовуйте тільки латинські букви, цифри, дефіс і підкреслення","error-invalid-user":"невірний користувач","error-invalid-username":"Невірне ім'я користувача","error-not-allowed":"Не дозволено","error-not-authorized":"заборонено","error-remove-last-owner":"Це останній власник. Будь ласка, встановіть новий власник, перш ніж видалити цей.","error-role-name-required":"Ім'я ролі потрібно","error-user-not-in-room":"Нема в цій кімнаті","Error_changing_password":"Пароль змінено","Error_sending_confirmation_email":"Помилка при відправці по електронній пошті підтвердження","Error_too_many_requests":"Помилка, занадто багато запитів. Будь ласка сповільнитися. Ви повинні почекати %s секунд перед повторною спробою","Esc_to":"Esc, щоб","Example_s":"Приклад: <code class=\"inline\">%s</code>","False":"помилковий","Favorites":"Обрані","Field":"поле","Field_removed":"поле видалено","File_exceeds_allowed_size_of_bytes":"Файл перевищує допустимий розмір __size__ байт","FileUpload":"Завантаження файлів","FileUpload_Enabled":"Завантажених файлів Включено","FileUpload_File_Empty":"файл порожній","FileUpload_FileSystemPath":"система Шлях","FileUpload_MaxFileSize":"Максимальна Завантажити Розмір файлу (в байтах)","FileUpload_MediaType_NotAccepted":"Типи носіїв не приймаються","FileUpload_MediaTypeWhiteList":"Прийняті типи носіїв","FileUpload_MediaTypeWhiteListDescription":"Розділених комами список типів носіїв. Залиште це поле порожнім для прийому всіх типів носіїв.","FileUpload_ProtectFiles":"Захист завантажені файли","FileUpload_ProtectFilesDescription":"Тільки що пройшли перевірку автентичності користувачі матимуть доступ","FileUpload_S3_Acl":"Amazon S3 ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 ім'я відра","FileUpload_S3_BucketURL":"ківш URL","FileUpload_S3_CDN":"домен CDN для завантаження","FileUpload_S3_Region":"область","FileUpload_Storage_Type":"Тип зберігання","Flags":"прапори","Follow_social_profiles":"Додавайте нас у соціальних мережах, форкайте на github і пишіть свої відгуки про наш додаток у нас у trello.","Food_and_Drink":"Їжа & Напої","For_your_security_you_must_re_enter_your_password_to_continue":"Для вашої безпеки, необхідно повторно ввести пароль для продовження","Force_SSL":"Force SSL","Force_SSL_Description":"* Увага! * _FORCE SSL_ ніколи не слід використовувати з зворотним проксі-сервером. Якщо у вас є зворотний проксі-сервер, ви повинні зробити редирект ТАМ. Ця опція існує для розгортання як Heroku, який не допускає конфігурацію переадресації на зворотний проксі-сервер.","Forgot_password":"Забули пароль","Fork_it_on_github":"Вилка його на GitHub","Frequently_Used":"часто використовувані","From":"з","From_Email":"З адреси електронної пошти","From_email_is_required":"Від потрібно електронна пошта","From_email_warning":"<b>Попередження:</b> Поле <b>Від</b> підлягає налаштувань поштового сервера.","General":"загальний","Get_to_know_the_team":"Зустрітися з Rocket.Team","github_no_public_email":"В налаштуваннях GitHubвідсутній публічний e-mail","Give_a_unique_name_for_the_custom_oauth":"Дайте унікальне ім'я для призначеного для користувача OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"Дайте додатком ім'я. Це буде видно ваших користувачів.","Global":"глобальної","GoogleTagManager_id":"Google Id Диспетчер тегів","Has_more":"має більш","Have_your_own_chat":"Мати свій власний веб-чат. Розроблено з Meteor.com, Rocket.Chat є відмінним рішенням для розробників, вперед, щоб побудувати і розвинути свій власний чат платформи.","Header":"заголовок","Hidden":"прихований","Hide_Group_Warning":"Ви впевнені, що ви хочете, щоб приховати групу \" %s\"?","Hide_Private_Warning":"Ви впевнені, що хочете приховати дискусію з \" %s\"?","Hide_room":"Приховати кімнату","Hide_Room_Warning":"Ви впевнені, що ви хочете, щоб приховати номер \" %s\"?","Highlights":"мелірування","Highlights_How_To":"Для того, щоб отримувати повідомлення, коли хтось згадує слово або фразу, додайте його тут. Ви можете відокремити слова або фрази комами. Виділіть слова не чутливі до регістру.","Highlights_List":"виділення слів","History":"Історія","hours":"годин","How_friendly_was_the_chat_agent":"Як дружній був чат агент?","How_knowledgeable_was_the_chat_agent":"Наскільки добре був чат агент?","How_responsive_was_the_chat_agent":"Як реагувати був чат агент?","How_satisfied_were_you_with_this_chat":"Як ви задоволені цей чат?","If_you_are_sure_type_in_your_password":"Якщо ви впевнені, введіть свій пароль:","If_you_are_sure_type_in_your_username":"Якщо ви впевнені, введіть ваше ім'я користувача:","Importer_Archived":"Читальний зал","Importer_done":"Імпорт завершено!","Importer_finishing":"Завершення імпорту.","Importer_From_Description":"Імпорт даних __from __ 's в Rocket.Chat.","Importer_import_cancelled":"Імпорт скасований.","Importer_import_failed":"Сталася помилка під час виконання імпорту.","Importer_importing_channels":"Імпорт каналів.","Importer_importing_messages":"Імпорт повідомлень.","Importer_importing_started":"Запуск імпорту.","Importer_importing_users":"Імпорт користувачів.","Importer_not_defined_properly":"Імпортер не було визначено правильно, він відсутній клас імпорту.","Importer_not_in_progress":"Імпортер в даний момент не працює.","Importer_Prepare_Restart_Import":"перезапуск Імпорт","Importer_Prepare_Start_Import":"почати імпорт","Importer_Prepare_Uncheck_Archived_Channels":"Зніміть прапорець Архівні канали","Importer_Prepare_Uncheck_Deleted_Users":"Зніміть прапорець Віддалені користувачі","Importer_progress_error":"Не вдалося прогрес для імпорту.","Importer_setup_error":"Помилка при налаштуванні імпортера відбулося.","Incorrect_Password":"Невірний пароль","inline_code":"inline_code","Install_Extension":"встановити розширення","Install_FxOs":"Встановити Rocket.Chat на вашому Firefox","Install_FxOs_done":"Відмінно! Тепер ви можете використовувати Rocket.Chat через іконку на вашому робочому столі. Удачи з Rocket.Chat!","Install_FxOs_error":"На жаль, це не спрацювало як задумано! з'явилося наступне повідомлення про помилку:","Install_FxOs_follow_instructions":"Будь ласка, підтвердіть установку додатка на пристрої (натисніть кнопку \"Встановити\" при запиті).","Installation":"установка","Integration_added":"Інтеграція була додана","Integration_Incoming_WebHook":"WebHook Інтеграція надходження","Integration_New":"Нова інтеграція","Integration_Outgoing_WebHook":"Вихідний WebHook Інтеграція","Integration_updated":"Інтеграція була оновлена","Integrations":"інтеграції","Invalid_asset":"Invalid актив","Invalid_confirm_pass":"Підтвердження пароля не збігаються пароль","Invalid_email":"Невірний e-mail","Invalid_Export_File":"Файл завантажений не є коректним %s файл експорту.","Invalid_file_height":"Невірна висота файлу","Invalid_file_type":"Невірний тип файлу","Invalid_file_width":"Неприпустима ширина файлу","Invalid_Import_File_Type":"Невірний тип файлу імпорту.","Invalid_name":"Ім’я має бути заповненим","Invalid_notification_setting_s":"Неприпустима настройка сповіщення: %s","Invalid_pass":"Пароль не має бути пустим","Invalid_room_name":"<strong> %s</strong>не є допустимим ім'ям кімнати, <br / >використовувати тільки букви, цифри та тире","Invalid_room_type":"<strong> %s</strong> не є допустимим типом номера.","Invalid_Secret_URL":"Невірний Секретний URL","Invalid_secret_URL_message":"URL є недійсною.","invisible":"невидимий","Invisible":"Прихований","Invitation_HTML":"запрошення HTML","Invitation_Subject":"запрошення Тема","Invite_user_to_join_channel":"Запросити одного користувача приєднатися до цього каналу","Invite_Users":"Запросити користувачів","is_also_typing":"досі друкує","is_also_typing_female":"Крім того, набравши","is_also_typing_male":"Крім того, набравши","is_typing":"друкує","is_typing_female":"друкує","is_typing_male":"друкує","italics":"курсив","join":"приєднатися","Join_audio_call":"Реєстрація аудіо виклику","Join_the_Community":"Приєднуйтесь до спільноти","Join_the_given_channel":"Приєднуйтесь до даного каналу","Join_video_call":"Реєстрація відеодзвінка","Joined":"Реєстрація","Jump":"Перейти","Jump_to_first_unread":"Перейти до першого непрочитаного","Jump_to_message":"Перейти до повідомлення","Jump_to_recent_messages":"Перейти до недавніх повідомлень","Katex_Enabled":"Katex Enabled","Label":"етикетка","Language":"Мова","Language_Version":"Українська версія","Last_login":"Останній Ввійти","Last_message":"Останнє повідомлення","Last_seen":"Востаннє бачили","Layout":"розкладка","Layout_Home_Body":"Головна Body","Layout_Home_Title":"Головна Назва","Layout_Login_Terms":"Вхід Умови","Layout_Privacy_Policy":"Політика конфіденційності","Layout_Sidenav_Footer":"Бічна навігація Footer","Layout_Sidenav_Footer_description":"Розмір Нижній колонтитул може містити 260 х 70px","Layout_Terms_of_Service":"Умови обслуговування","LDAP":"LDAP","LDAP_CA_Cert":"CA Cert","LDAP_Custom_Domain_Search":"Пошук Персональний домен","LDAP_Custom_Domain_Search_Description":"Шматок JSON, який регулює прив'язку і підключення до інформації і має вигляд: <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"Домен за замовчуванням","LDAP_Description":"LDAP є ієрархічною базу даних, що багато компаній використовують для забезпечення єдиного входу - об'єкта для спільного використання одного пароля між декількома сайтами і послугами. Для отримання попередньої інформації про конфігурацію і приклади, будь ласка, зверніться до нашої вікі: https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication.","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"базовий домен","LDAP_Domain_Base_Description":"Повний відмітна ім'я (DN) з поддерева LDAP, який потрібно для пошуку користувачів і груп. Ви можете додати стільки, скільки вам подобається; Проте, кожна група повинна бути визначена в тому ж домені, що і базою користувачів, які належать до нього. Якщо вказати обмежені групи користувачів, тільки користувачі, що належать до цих груп буде знаходитися в області видимості. Ми рекомендуємо вам вказати верхній рівень вашого LDAP дерева каталогів в якості домену бази і використовувати фільтр пошуку для управління доступом.","LDAP_Domain_Search_Filter":"Фільтр пошуку домену","LDAP_Domain_Search_Filter_Description":"Якщо вказано, тільки ті користувачі, які відповідають цьому фільтру буде дозволено увійти в систему. Якщо не вказано ні один фільтр, всі користувачі в межах обсягу зазначеного домену бази матиме можливість увійти в систему. <br/> Наприклад, для Active Directory `memberOf = сп = ROCKET_CHAT, НУ = Загальні Groups`. <br/> Наприклад, для OpenLDAP (розширюваний пошук матчу) `НУ: дп: = ROCKET_CHAT`.","LDAP_Domain_Search_Object_Category":"Домен Об'єкт пошуку Категорія","LDAP_Domain_Search_Object_Category_Description":"* ObjectCategory *, які ідентифікують користувачів. <br/> Залиште порожнім * * OpenLDAP. <br/> Наприклад, `person` і т.д.","LDAP_Domain_Search_Object_Class":"Домен Клас Об'єкт пошуку","LDAP_Domain_Search_Object_Class_Description":"* ObjectClass *, які ідентифікують користувачів. <br/> Наприклад, `organizationalPerson`,` user`, `inetOrgPerson` і т.д.","LDAP_Domain_Search_Password":"Домен пошуку пароля","LDAP_Domain_Search_Password_Description":"Пароль для користувача пошуку домену.","LDAP_Domain_Search_User":"Домен Пошук користувача","LDAP_Domain_Search_User_Description":"Користувач LDAP, який виконує операцій пошуку користувачів для аутентифікації інших користувачів, коли вони підписують в. <br/> Як правило, це обліковий запис служби, створена спеціально для сторонніх інтеграції. Використовуйте повне ім'я, наприклад `CN = Administrator, CN = Users, DC = Example, DC = com`.","LDAP_Domain_Search_User_ID":"Пошук домена Ідентифікатор користувача","LDAP_Domain_Search_User_ID_Description":"Атрибут LDAP, який ідентифікує користувача LDAP, який намагається аутентифікацію. Це поле повинно бути `sAMAccountName` для установки найбільш Active Directory, але це може бить` uid` для інших рішень LDAP, таких як OpenLDAP. Ви можете використовувати `mail` для ідентифікації користувачів по електронній пошті або будь-який інший атрибут ви хочете. <br> Можна використовувати декілька значень, розділених комами, щоб дозволити користувачам увійти в систему, використовуючи кілька ідентифікаторів, таких як ім'я користувача або адресу електронної пошти.","LDAP_Enable":"включити","LDAP_Enable_Description":"Спроба використовувати LDAP для аутентифікації.","LDAP_Encryption":"шифрування","LDAP_Encryption_Description":"Метод шифрування, використовуваний для захисту зв'язку з сервером LDAP. Приклади не включають `plain` (без шифрування),` SSL / LDAPS` (зашифроване з самого початку), і `StartTLS` (оновлення до шифрованого зв'язку після підключення).","LDAP_Host":"господар","LDAP_Host_Description":"LDAP хоста, наприклад, `` ldap.example.com` або 10.0.0.30`.","LDAP_Port":"порт","LDAP_Port_Description":"Порт для доступу до LDAP. наприклад: `389` або` 636` для LDAPS","LDAP_Reject_Unauthorized":"відхилити Несанкціоноване","LDAP_Sync_User_Avatar":"Синхронізація Аватар користувача","LDAP_Sync_User_Data":"Синхронізація даних","LDAP_Sync_User_Data_Description":"Зберігати дані користувача в синхронізації з сервером при вході в систему (наприклад: ім'я, адреса електронної пошти).","LDAP_Sync_User_Data_FieldMap":"Дані користувача Карта Поле","LDAP_Sync_User_Data_FieldMap_Description":"Налаштування, як поля облікових записів користувачів (наприклад, електронної пошти) заповнюються із запису в LDAP (колись знайшла). <br/> Як приклад, `{\" сп \":\" ім'я \",\" пошта \":\" електронна пошта \"}` буде вибрати удобочитаем ім'я людини з атрибута CN, і їх електронну пошту від атрибута пошти. <br/> Доступні поля включають `name` і` email`.","LDAP_Sync_Users":"Синхронізація користувачів","LDAP_Test_Connection":"Пров.соед","LDAP_Unique_Identifier_Field":"Унікальний ідентифікатор поля","LDAP_Unique_Identifier_Field_Description":"Яке поле буде використовуватися для з'єднання користувача LDAP і користувач Rocket.Chat. Ви можете повідомити кілька значень, розділених комою, щоб спробувати отримати значення з записи LDAP. <br/> Значення за замовчуванням є `ObjectGUID, IBM-entryUUID, ідентифікатор GUID, dominoUNID, nsuniqueId, uidNumber`","LDAP_Use_Custom_Domain_Search":"Використовуйте Пошук користувальницьких доменів","LDAP_Use_Custom_Domain_Search_Description":"Напишіть свій власний фільтр для пошуку користувачів на сервері LDAP.","LDAP_Username_Field":"Ім'я користувача поле","LDAP_Username_Field_Description":"Яке поле буде використовуватися в якості * Ім'я користувача * для нових користувачів. Залиште порожнім, щоб використовувати ім'я користувача повідомляється на сторінці входу. <br/> Ви можете використовувати теги шаблонів теж, як `# {GivenName}. # {Зп}`. <br/> Значення за замовчуванням є `sAMAccountName`.","Leave_Group_Warning":"Ви впевнені, що хочете залишити групу \" %s\"?","Leave_Private_Warning":"Ви впевнені, що хочете залишити дискусію з \" %s\"?","Leave_room":"Покинути кімнату","Leave_Room_Warning":"Ви впевнені, що хочете вийти з кімнати \" %s\"?","line":"лінія","List_of_Direct_Messages":"Список прямих повідомлень","Live_sessions":"поточні сеанси","Livechat_agents":"Livechat агенти","Livechat_Dashboard":"Livechat Dashboard","Livechat_enabled":"Включений Livechat","Livechat_Manager":"Livechat менеджер","Livechat_managers":"менеджери Livechat","Livechat_title":"Livechat Назва","Livechat_title_color":"Livechat Назва Колір фону","Livechat_Users":"Livechat Користувачі","Load_more":"Показати більше","Loading...":"Loading ...","Loading_more_from_history":"Завантаження більше з історії","Loading_suggestion":"Завантаження інших...","Localization":"локалізація","Log_File":"Показати файл і лінії","Log_Level":"рівень Журналу","Log_Package":"Показати пакет","Log_View_Limit":"Log View Limit","Logged_out_of_other_clients_successfully":"Записаний з інших клієнтів успішно","Login":"Логін","Login_with":"Вхід з %s","login_with":"Або авторизуйтесь за допомогою","Logout":"Вийти","Logout_Others":"Вихід з інших Записаний в тих місцях,","Mail_Message_Invalid_emails":"Ви надали один або кілька неприпустимих листів: %s","Mail_Message_Missing_to":"Ви повинні вибрати одного або декількох користувачів або надати один або кілька адрес електронної пошти, розділених комами.","Mail_Message_No_messages_selected_select_all":"Ви не обрали жодного повідомлення. Ви хочете , щоб <a href='#' class='select-all'>вибрати всі</a> видимі повідомлення?","Mail_Messages":"поштові повідомлення","Mail_Messages_Instructions":"Виберіть, які повідомлення ви хочете відправити електронною поштою, натиснувши на повідомлення","Mail_Messages_Subject":"Ось обрана частина повідомлень %s","Mailer":"розсилка","Mailer_body_tags":"Ви <b>повинні</b> використовувати [відписки] для відписку посилання. <br /> Ви можете використовувати [ім'я], [Fname], [LNAME] повне ім'я користувача, ім'я або прізвище, відповідно. <br /> Ви можете використовувати [Email] для електронної пошти користувача.","Make_Admin":"зробити Адміністратор","Manager_added":"додав менеджер","Manager_removed":"Менеджер видалений","Mark_as_read":"Відзначити як прочитане","Markdown_Headers":"Markdown Заголовки","Markdown_SupportSchemesForLink":"Markdown Схеми підтримки для Link","Markdown_SupportSchemesForLink_Description":"Розділених комами список дозволених схем","Members_List":"Список учасників","Mentions":"згадки","Mentions_default":"Згадки (за замовчуванням)","Message":"повідомлення","Message_AllowDeleting":"Дозволити видалення повідомлень","Message_AllowEditing":"Дозволити Редагування повідомлень","Message_AllowEditing_BlockEditInMinutes":"Редагування блоку повідомлень Після того, як (п) хвилин","Message_AllowEditing_BlockEditInMinutesDescription":"Введіть 0, щоб відключити блокування.","Message_AllowPinning":"Дозволити повідомлення Pinning","Message_AllowPinning_Description":"Повідом повинні бути притиснуті до будь-якої з каналів.","Message_AllowStarring":"Дозволити повідомлення ролях","Message_AudioRecorderEnabled":"Audio Recorder Enabled","Message_AudioRecorderEnabledDescription":"Требуется '/ WAV аудіо файли \", щоб бути прийнятим тип носія в настройках\" File Upload \".","Message_DateFormat":"Формат дати","Message_DateFormat_Description":"Дивіться також: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"Повідомлень Видалення не допускається","Message_editing_blocked":"Це повідомлення не може бути відредагований більше","Message_editing_not_allowed":"редагування повідомлень не допускається","Message_GroupingPeriod":"Угруповання Період (у секундах)","Message_GroupingPeriodDescription":"Повідомлення будуть згруповані з попереднім повідомленням, якщо обидва з того ж користувача і минулий час було менше, ніж усвідомленого часу в секундах.","Message_KeepHistory":"Зберігати історію повідомлень","Message_MaxAllowedSize":"Максимальний допустимий розмір повідомлення","Message_MaxAll":"Максимальний розмір каналу для всіх повідомлень","Message_pinned":"повідомлення покладали","Message_pinning_not_allowed":"Повідомлення піннінга не допускається","Message_removed":"повідомлення видалено","Message_ShowDeletedStatus":"виключають Статус","Message_ShowEditedStatus":"Показати відредагованого стану","Message_ShowFormattingTips":"Показати Поради щодо форматування","Message_TimeFormat":"формат часу","Message_TimeFormat_Description":"Дивіться також: <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"Повідомлення занадто довго","Messages":"повідомлення","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"Повідомлення, відправлені до вхідного WebHook будуть опубліковані тут.","Meta":"Мета","Meta_fb_app_id":"Facebook App Id","Meta_google-site-verification":"Google Перевірка сайту","Meta_language":"Мова","Meta_msvalidate01":"MSValidate.01","Meta_robots":"роботи","minutes":"хвилин","Mobile_push":"мобільний поштовх","More_channels":"Більше каналів","More_direct_messages":"Інші прямі повідомлення","More_groups":"Більш приватні групи","More_unreads":"більше unreads","Msgs":"Повідомлення","multi":"багато","Mute_someone_in_room":"Mute хтось в кімнаті","Mute_user":"відключення користувача","Muted":"приглушений","My_Account":"Мій рахунок","n_messages":"%s повідомлень","N_new_messages":" %s нових повідомлень","Name":"Ім’я","Name_cant_be_empty":"Ім'я не може бути порожнім","Name_of_agent":"ім'я агента","Name_optional":"Ім'я (не обов'язково)","Navigation_History_20_last_pages":"Історія навігації (20 останніх сторінок)","New_Application":"нове застосування","New_Custom_Field":"Новий користувальницький поле","New_Department":"новий відділ","New_integration":"Нова інтеграція","New_logs":"нові журнали","New_messages":"Нове повідомлення","New_password":"Новий пароль","New_role":"Нова роль","No_channel_with_name_%s_was_found":"Ні один канал з ім'ям <strong>\" %s\"</strong> не було знайдено!","No_channels_yet":"Ви досі не частина одного з каналів.","No_direct_messages_yet":"Ви ще не почали ніяких розмов поки.","No_Encryption":"немає шифрування","No_favorites_yet":"Ви не додавали фаворитів ще.","No_group_with_name_%s_was_found":"Ні одна приватна група з ім'ям <strong>\" %s\"</strong> не було знайдено!","No_groups_yet":"Ви не маєте приватних груп.","No_livechats":"У вас немає livechats.","No_mentions_found":"Немає згадок знайдено","No_permission_to_view_room":"Ви не маєте прав для перегляду цієї кімнати","No_pinned_messages":"Ні покладали повідомлень","No_results_found":"Нічого не знайдено","No_starred_messages":"Немає позначених повідомлень","no_tokens_for_this_user":"Там немає лексеми для цього користувача","No_user_with_username_%s_was_found":"Ні один користувач з ім'ям користувача <strong>\" %s\"</strong> не було знайдено!","Not_allowed":"Не дозволено","Not_authorized":"заборонено","Not_Available":"Недоступний","Not_found_or_not_allowed":"Відсутній, або доступ заборонено","Nothing":"нічого","Nothing_found":"Нічого не знайдено ","Notifications":"повідомлення","Notify_all_in_this_room":"Повідомте все в цій кімнаті","Num_Agents":"# Агенти","Number_of_messages":"кількість повідомлень","OAuth_Application":"OAuth Застосування","OAuth_Applications":"OAuth Додатки","Objects":"об'єкти","Off_the_record_conversation":"Off-записувані Діалог","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"Off самого запису розмови не доступна для вашого браузера або пристрою.","Offline_DM_Email":"[__site__] Ви були прямим шляхом __user__ обмінювалися повідомленнями","Offline_Mention_Email":"[__site__] Ви були згадані __user__ в #__room__","Old_and_new_password_must_be_different":"Новий пароль повинен відрізнятися від старого пароля.","Old_and_new_password_required":"Ви повинні надати як старий і новий пароль для зміни пароля.","Online":"Онлайн","Only_errors":"тільки помилки","Only_you_can_see_this_message":"Тільки ви можете побачити це повідомлення","Oops!":"ой","Open":"відкритий","Opened":"відкритий","Opt_out_statistics":"Не посилайте свою статистику по Rocket.Chat","Opt_out_statistics_warning":"Відправляючи свою статистику, ви допоможете нам визначити, скільки примірників Rocket.Chat розгорнуті, а також наскільки добре поводиться система, таким чином, ми можемо додатково поліпшити його. Не турбуйтеся, оскільки ніякої інформації про користувача не передається і вся інформація, ми отримуємо конфіденційна. Якщо ви хочете продовжувати посилати нам свою статистику, зніміть прапорець вище. Дякую.","optional":"необов'язковий","Order":"замовлення","OS_Arch":"ОС Arch","OS_Cpus":"OS Кількість CPU","OS_Freemem":"OS Вільна пам'ять","OS_Loadavg":"OS Load Average","OS_Platform":"OS платформи","OS_Release":"OS-реліз","OS_Totalmem":"OS Спільна пам'ять","OS_Type":"Тип ОС","OS_Uptime":"OS Uptime","others":"інші","OTR":"ОТР","OTR_is_only_available_when_both_users_are_online":"OTR доступний тільки тоді, коли обидва користувачі знаходяться в мережі","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"Override URL, до якого файли завантажуються. Цей URL-адресу також використовується для завантаження, якщо тільки в CDN дається","Password":"Пароль","Password_Change_Disabled":"Ваш Rocket.Chat адміністратор відключив зміна паролів","Password_changed_successfully":"Пароль успішно змінений","Payload":"корисне навантаження","People":"Люди","Permissions":"Дозволи","Pin_Message":"Pin Message","Pinned_a_message":"Закріплені повідомлення:","Pinned_Messages":"закріплені повідомлення","Placeholder_for_email_or_username_login_field":"Заповнювач для електронної пошти або ім'я користувача для входу поле","Placeholder_for_password_login_field":"Заповнювач для пароля поле логіна","Please_answer_survey":"Будь ласка, знайдіть час, щоб відповісти на швидкий огляд про це чаті","Please_enter_value_for_url":"Будь ласка, введіть значення для URL вашого аватара.","Please_enter_your_new_password_below":"Будь ласка, введіть Ваш новий пароль нижче:","Please_fill_a_label":"Заповніть, будь ласка, мітку","Please_fill_a_name":"Будь ласка, заповніть ім'я","Please_fill_a_username":"Заповніть, будь ласка, ім'я користувача","Please_fill_name_and_email":"Заповніть, будь ласка, ім'я та адресу електронної пошти","Please_re_enter_your_password":"Будь ласка, повторно введіть пароль","Please_select_enabled_yes_or_no":"Будь ласка, виберіть опцію для Enabled","Please_wait":"Будь ласка, зачекайте","Please_wait_activation":"Будь ласка, зачекайте, це може зайняти деякий час.","Please_wait_statistics":"Будь ласка, зачекайте, статистика генерується.","Please_wait_while_OTR_is_being_established":"Будь ласка, зачекайте, поки ОТР створюється","Please_wait_while_your_account_is_being_deleted":"Будь ласка, зачекайте, поки ваш аккаунт віддаляється ...","Please_wait_while_your_profile_is_being_saved":"Будь ласка, зачекайте, поки ваш профіль зберігаються ...","Post_as":"повідомлення, як","Post_to_Channel":"Опублікувати в канал","Post_to_s_as_s":"<strong>Опублікувати %s</strong> <strong>в %s</strong>","Powered_by":"Реалізовано за допомогою","Preferences":"переваги","Preferences_saved":"налаштування збережені","Privacy":"Приватність","Private_Group":"рядовий Група","Private_Groups":"Приватні Групи","Private_Groups_list":"Список приватних груп","Profile":"профіль","Profile_saved_successfully":"Профіль успішно збережені","Proudly_developed":"З гордістю розроблено з Meteor","Push":"натиск","Push_apn_cert":"APN Cert","Push_apn_dev_cert":"APN Дев Cert","Push_apn_dev_key":"APN Дев Key","Push_apn_dev_passphrase":"APN Дев Passphrase","Push_apn_key":"APN Key","Push_apn_passphrase":"APN Passphrase","Push_debug":"Відлагоджувати","push_disabled":"натисніть відключений","Push_enable":"включити","Push_enable_gateway":"включити шлюз","Push_gateway":"шлюз","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Номер проекту","Push_production":"виробництво","Push_show_message":"Показати повідомлення повідомлення","Push_show_username_room":"Показати канал / група / ім'я користувача в повідомленні","Push_test_push":"тест","Query":"запит","Query_description":"Додаткові умови для визначення того, які користувачі можуть надіслати електронною поштою. Непідписаних користувачі автоматично видаляються з запиту. Він повинен бути дійсним в форматі JSON. Приклад: \"{\" createdAt \": {\" $ GT \": {\" дата $ \":\" 2015-01-01T00: 00: 00.000Z \"}}}\"","Quick_Search":"Швидкий пошук","quote":"цитата","Reactions":"реакції","Recents":"Недавні","Record":"запис","Redirect_URI":"перенаправлення URI","Refresh_keys":"оновити ключі","Refresh_your_page_after_install_to_enable_screen_sharing":"Оновлення сторінку після того, як встановити, щоб забезпечити загальний доступ до екрану","Register":"Зареєструвати новий обліковий запис ","Registration_Succeeded":"Реєстрація Наступник","Remember_me":"Запам'ятати мене","Remove":"Вилучити","Remove_Admin":"видалити Адміністратор","Remove_as_moderator":"Видалити в якості модератора","Remove_as_owner":"Видалити в якості власника","Remove_custom_oauth":"Видалити користувача OAuth","Remove_from_room":"Видалити з кімнати","Remove_someone_from_room":"Видалити когось із кімнати","Removed":"вилучені","Require_password_change":"Вимагати зміни пароля","Resend_verification_email":"Відправити лист з підтвердженням","Reset":"скидання","Reset_password":"Скинути пароль","Restart":"перезапуск","Restart_the_server":"перезапустіть сервер","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"ім'я RocketBot","RocketBot_Name_Description":"Ім'я RocketBot має бути дійсним ім'ям користувача, зареєстрованої на вашому сервері.","Role":"роль","Role_Editing":"роль Редагування","Role_removed":"роль видалена","Room":"Кімната","Room_archivation_state":"стан","Room_archivation_state_false":"активний","Room_archivation_state_true":"Читальний зал","Room_archived":"номер в архіві","room_changed_privacy":"Тип номера змінений: <em>__room_type__</em> по <em>__user_by__</em>","room_changed_topic":"Номер теми змінений на: <em>__room_topic__</em> по <em>__user_by__</em>","Room_has_been_deleted":"Номер був видалений","Room_Info":"опис номера","Room_name_changed":"Назва кімнати змінена: <em>__room_name__</em> користувачем <em>__user_by__</em>","Room_name_changed_successfully":"Назву кімнати змінено","Room_not_found":"Номер не знайдений","Room_topic_changed_successfully":"Номер теми успішно змінений","Room_type_changed_successfully":"Тип номера успішно змінений","Room_unarchived":"номер розархівувати","Room_uploaded_file_list":"список файлів","Room_uploaded_file_list_empty":"Немає доступних файлів.","room_user_count":" %s користувачів","Rooms":"кімнати","S_new_messages_since_s":" %s нових повідомлень з моменту %s","SAML":"SAML","SAML_Custom_Cert":"Призначений для користувача сертифікат","SAML_Custom_Entry_point":"Призначені для користувача точки входу","SAML_Custom_Generate_Username":"сформувати систему","SAML_Custom_Issuer":"призначені для користувача Емітент","SAML_Custom_Provider":"Призначений для користувача постачальник","Save":"Зберегти","Save_changes":"Зберегти зміни","Save_Mobile_Bandwidth":"Зберегти Мобільний Пропускна здатність","Save_to_enable_this_action":"Зберегти, щоб включити цю дію","Saved":"збережено","Saving":"економія","Scope":"сфера","Screen_Share":"екран Поділитися","Script_Enabled":"сценарій Включено","Search":"Пошук","Search_by_username":"Пошук по імені користувача","Search_Channels":"Пошук каналів","Search_Direct_Messages":"Пошук прямих повідомлень","Search_Messages":"Пошук повідомлень","Search_Private_Groups":"Пошук приватних груп","Search_settings":"настройки пошуку","seconds":"секунд","See_all":"Переглянути все","See_only_online":"Тільки онлайн","Select_a_department":"Виберіть відділ","Select_an_avatar":"Обрати аватар","Select_file":"Обрати файл","Select_service_to_login":"Виберіть послугу, щоб увійти в систему, щоб завантажити свою фотографію або завантажити один прямо з вашого комп'ютера","Select_user":"Виберіть користувача","Select_users":"вибір користувачів","Selected_agents":"обрані агенти","Selected_users":"Обрані члени","Send":"послати","Send_a_message":"Відправити повідомлення","Send_a_test_mail_to_my_user":"Надіслати тестову пошту на мій користувач","Send_a_test_push_to_my_user":"Відправити тестовий поштовх до мого користувачеві","Send_confirmation_email":"Надіслати електронною поштою підтвердження","Send_data_into_RocketChat_in_realtime":"Відправка даних в Rocket.Chat в режимі реального часу.","Send_email":"Відправити лист","Send_invitation_email":"Надіслати запрошення електронною поштою","Send_invitation_email_error":"Ви не надали ніякої дійсну адресу електронної пошти.","Send_invitation_email_info":"Ви можете відправити кілька запрошень по електронній пошті відразу.","Send_invitation_email_success":"Ви успішно відправили запрошення по електронній пошті за наступними адресами:","Send_invitation_email_warning":"Для того, щоб відправити повідомлення із запрошеннями, необхідно спочатку налаштувати параметри SMTP.","Send_Message":"Надіслати повідомлення","Send_your_JSON_payloads_to_this_URL":"Відправити ваші JSON корисне навантаження на цей URL.","Sending":"Посилка ...","Set_as_moderator":"Встановити в якості модератора","Set_as_owner":"Встановити в якості власника","Settings":"Налаштування","Settings_updated":"налаштування оновлені","Should_be_a_URL_of_an_image":"Повинно бути URL зображення.","Should_exists_a_user_with_this_username":"Користувач повинен вже існувати.","Show_all":"Покажи все","Show_more":"Показати більше","Show_only_online":"Показувати тільки онлайн","Show_preregistration_form":"Показати попередньо реєстраційну форму","Showing_archived_results":"<p> <b>Відображення %s</b> заархівовані результати </p>","Showing_online_users":"Показані <b>__total_showing__</b>з __total__ користувачів","Showing_results":"<p>Показано <b> %s</b>Результати</p>","Silence":"Тиша","since_creation":"з %s","Site_Name":"Назва сайту","Site_Url":"URL сайту","Site_Url_Description":"Приклад: https://chat.domain.com/","Skip":"скакати","Smileys_and_People":"Посмішки і люди","SMTP":"SMTP","SMTP_Host":"SMTP хост","SMTP_Password":"пароль SMTP","SMTP_Port":"порт SMTP","SMTP_Test_Button":"Параметри випробувань SMTP","SMTP_Username":"Ім'я користувача SMTP","Sound":"звук","Star_Message":"зірка повідомлення","Starred_Messages":"помічені повідомлення","Start_audio_call":"Початок аудіо виклику","Start_Chat":"Почати Чат","Start_of_conversation":"Початок розмови","Start_OTR":"Start ОТР","Start_video_call":"почати відеодзвінок","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"Почніть з <code class=\"inline\">%s</code> для користувача або <code class=\"inline\">%s</code> для каналу. Наприклад: <code class=\"inline\">%s</code> або <code class=\"inline\">%s</code>","Statistics":"статистика","Stats_Active_Users":"активні користувачі","Stats_Avg_Channel_Users":"Середні каналу користувачів","Stats_Avg_Private_Group_Users":"Середні Приватні групи користувачів","Stats_Away_Users":"Away Користувачі","Stats_Max_Room_Users":"Кількість кімнат користувачів","Stats_Non_Active_Users":"неактивні Користувачі","Stats_Offline_Users":"Offline Користувачі","Stats_Online_Users":"Користувачі на сайті","Stats_Total_Channels":"всього канали","Stats_Total_Direct_Messages":"Всього Пряме сполучення Номери","Stats_Total_Messages":"всього повідомлень","Stats_Total_Private_Groups":"Всього приватних груп","Stats_Total_Rooms":"кількість номерів","Stats_Total_Users":"всього користувачів","Stop_Recording":"зупинити запис","strike":"страйк","Subject":"суб'єкт","Submit":"Підтвердити","Success":"успіх","Survey":"обстеження","Survey_instructions":"Оцінити кожне питання відповідно до ваших задоволення, 1 означає, що ви повністю незадоволеним і 5 означає, що ви повністю задоволені.","Symbols":"символи","Sync_success":"Синхронізація успіху","Sync_Users":"Синхронізація користувачів","Test_Connection":"Пров.соед","Test_Desktop_Notifications":"Тест-повідомлень на робочому столі","Thank_you_for_your_feedback":"Спасибі за ваш відгук","The_application_name_is_required":"Ім'я програми потрібен","The_channel_name_is_required":"Назва каналу потрібно","The_emails_are_being_sent":"Електронні листи відправляються.","The_field_is_required":"Поле %s потрібно.","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"Зміни розміру зображення не буде працювати, тому що ми не можемо виявити ImageMagick або GraphicsMagick встановлений на вашому сервері.","The_redirectUri_is_required":"RedirectUri потрібно","The_server_will_restart_in_s_seconds":"Сервер буде перезавантажений через %s секунд","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>Параметр %s</strong> налаштований <strong>на %s</strong> , і ви звертаєтеся <strong>з %s!</strong>","The_user_will_be_removed_from_s":"Користувач буде видалений з %s","The_user_wont_be_able_to_type_in_s":"Користувач не зможе ввести в %s","Theme":"тема","theme-color-action-buttons-color":"Дії Кнопки Колір","theme-color-active-channel-background-color":"Активний канал Колір фону","theme-color-active-channel-font-color":"Активний канал Колір шрифту","theme-color-blockquote-background":"Blockquote Колір фону","theme-color-clean-buttons-color":"Чисті кнопки Колір","theme-color-code-background":"Код Колір фону","theme-color-code-border":"Код Колір рамки","theme-color-code-color":"кольорове маркування","theme-color-content-background-color":"Зміст Колір фону","theme-color-custom-scrollbar-color":"Призначені для користувача Scrollbar Колір","theme-color-info-active-font-color":"Активний Інформація Колір шрифту","theme-color-info-font-color":"Інформація Колір шрифту","theme-color-input-font-color":"Вхідні Колір шрифту","theme-color-link-font-color":"Посилання Колір шрифту","theme-color-message-hover-background-color":"Повідомлення Hover BG Колір","theme-color-primary-background-color":"Основний колір фону","theme-color-primary-font-color":"Первинний Колір шрифту","theme-color-quaternary-font-color":"Четвертинні Колір шрифту","theme-color-secondary-background-color":"Вторинний колір фону","theme-color-secondary-font-color":"Вторинний колір шрифту","theme-color-smallprint-font-color":"Малий друку Колір шрифту","theme-color-smallprint-hover-color":"Малий друку Hover Колір","theme-color-status-away":"Відсутня Колір Стан","theme-color-status-busy":"Зайнятий Колір Стан","theme-color-status-offline":"Offline Колір Статус","theme-color-status-online":"Інтернет Колір Статус","theme-color-tertiary-background-color":"Третинний Колір фону","theme-color-tertiary-font-color":"Третинний Колір шрифту","theme-color-unread-notification-color":"Непрочитана Повідомлення Колір","theme-custom-css":"призначені для користувача CSS","There_are_no_agents_added_to_this_department_yet":"Там немає доданих в цей відділ поки агенти.","There_are_no_integrations":"Там немає інтеграції","There_are_no_users_in_this_role":"Там немає користувачів в цій ролі.","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"Ця електронна пошта вже використовується і не було перевірено. Будь ласка, поміняйте пароль.","This_is_a_desktop_notification":"Це повідомлення на робочому столі","This_is_a_push_test_messsage":"Це поштовх тест messsage","Time_in_seconds":"Час в секундах","Title_bar_color":"Рядок заголовка колір","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"Щоб встановити Rocket.Chat Livechat на вашому сайті, скопіюйте і вставте цей код вище останнього <strong><тіла /></strong> тега на вашому сайті.","To_users":"для користувачів","Topic":"тема","Travel_and_Places":"Подорожі та Місця","Trigger_removed":"тригер видалений","Trigger_Words":"слова запуску","Triggers":"тригери","True":"правда","Type":"тип","Type_your_new_password":"Введіть новий пароль","Unarchive":"розархівувати","Unmute_someone_in_room":"Unmute хтось в кімнаті","Unmute_user":"Unmute користувач","Unnamed":"неназваний","Unpin_Message":"Відмінити закріплення повідомлення","Unread_Rooms":"непрочитані Номери","Unread_Rooms_Mode":"Режим Непрочитані Номери","Unstar_Message":"видалити позначку","Upload_file_question":"Завантажити файл?","Uploading_file":"Завантаження файлу ...","Use_account_preference":"Використовуйте переваги облікового запису","Use_Emojis":"використовуйте Emojis","Use_initials_avatar":"Використовуйте ваші ім'я користувача ініціали","use_menu":"Для доступу до ваших кімнат та чатів використовуйте бокове меню","Use_service_avatar":"Використовуйте% Аватар","Use_this_username":"Використовувати це ім'я користувача ","Use_uploaded_avatar":"Використовувати завантажений аватар","Use_url_for_avatar":"Використовуйте URL для аватара","User__username__is_now_a_moderator_of__room_name_":"__username__ Користувач тепер модератор __room_name__","User__username__is_now_a_owner_of__room_name_":"__username__ Користувач тепер власник __room_name__","User__username__removed_from__room_name__moderators":"__username__ Користувач вилучений з __room_name__ модераторів","User__username__removed_from__room_name__owners":"__username__ Користувач вилучений з __room_name__ власників","User_added":"Користувач <em>__user_added__</em> доданий.","User_added_by":"Користувач <em>__user_added__</em> даданий <em>__user_by__</em>.","User_added_successfully":"Користувач доданий успішно","User_Channels":"призначені для користувача канали","User_doesnt_exist":"Жоден користувач не існує під ім'ям @ ` %s`.","User_has_been_activated":"Користувач активований","User_has_been_deactivated":"Користувач деактивовано","User_has_been_deleted":"Користувач вилучений","User_has_been_muted_in_s":"Користувач був відключений в %s","User_has_been_removed_from_s":"Користувач був видалений з %s","User_has_disconnected":"Користувач відключив","User_Info":"Інформація про користувача","User_is_no_longer_an_admin":"Нема більше не адмін","User_is_not_activated":"Користувач не активовано","User_is_now_an_admin":"Користувач тепер адміністратор","User_joined_channel":"Приєднався до каналу.","User_joined_channel_female":"Приєднався до каналу.","User_joined_channel_male":"Приєднався до каналу.","User_left":"Користучач <em>__user_left__</em> вийшов.","User_left_female":"Пішла канал.","User_left_male":"Пішла канал.","User_logged_out":"Користувач вийшов з системи","User_management":"управління користувачами","User_muted_by":"<em>__user_muted__</em> Користувача приглушені <em>__user_by__.</em>","User_muted_in_room":"Користувач приглушений в кімнаті","User_not_found":"Користувач не знайдений","User_not_found_or_incorrect_password":"Користувач не знайдений або неправильний пароль","User_or_channel_name":"Користувач або назва каналу","User_removed":"Користувач вилучений","User_removed_by":"Користувач <em>__user_removed__</em>вилучений <em>__user_by__</em>.","User_removed_from_room":"Користувач був видалений з приміщення","User_Settings":"налаштування користувача","User_unmuted_by":"<em>__user_unmuted__</em> Користувача заглушені по <em>__user_by__.</em>","User_unmuted_in_room":"Користувач заглушені в кімнаті","User_updated_successfully":"Користувач успішно оновлений","Username":"Ім’я користувача","Username_and_message_must_not_be_empty":"Ім'я користувача і повідомлення не повинно бути порожнім.","Username_cant_be_empty":"Ім’я має бути заповненим","Username_Change_Disabled":"Ваш Rocket.Chat адміністратор відключив зміна імен користувачів","Username_denied_the_OTR_session":"__username__ заперечував сесію OTR","Username_description":"Ім'я користувача використовується, щоб дозволити іншим про вас в повідомленнях.","Username_doesnt_exist":"Ім'я користувача ` %s` не існує.","Username_ended_the_OTR_session":"__username__ завершив сесію OTR","Username_invalid":"<strong> %s</strong »не дійсне ім'я користувача, <br / >використовувати тільки букви, цифри, крапки і тире","Username_is_already_in_here":"`@ %s` вже тут.","Username_is_not_in_this_room":"Користувач `# %s` не в цій кімнаті.","Username_not_found":"Ім'я користувача не знайдено","Username_title":"Реєстрація користувача","Username_unavaliable":"<strong> %s</strong>вже використовується :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ хоче почати отр. Ви хочете взяти?","Users":"користувачів","Users_in_role":"Користувачі в ролі","UTF8_Names_Slugify":"UTF8 Імена Slugify","UTF8_Names_Validation":"UTF8 Імена Validation","UTF8_Names_Validation_Description":"Не допускати спеціальних символів і пробілів. Ви можете використовувати - _ і. але не в кінці імені","Verification_email_sent":"Лист з підтвердженням відправлено","View_All":"Показати все","View_Logs":"Перегляд журналів","Visibility":"видимість","Visible":"видимий","Visitor":"відвідувач","Visitor_page_URL":"сторінка відвідувачів URL","Visitor_time_on_site":"Час для відвідувачів на сайті","Wait_activation_warning":"Перед тим, як увійти, ваш обліковий запис повинен бути активована вручну адміністратором.","We_are_offline_Sorry_for_the_inconvenience":"Ми в автономному режимі. Вибачте за незручності.","We_have_sent_password_email":"Ми відправили вам по електронній пошті з інструкціями по зміні пароля. Якщо ви не отримуєте електронну пошту найближчим часом, будь ласка, повернутися і спробувати знову.","We_have_sent_registration_email":"Ми відправили вам по електронній пошті, щоб підтвердити свою реєстрацію. Якщо ви не отримуєте електронну пошту найближчим часом, будь ласка, повернутися і спробувати знову.","WebRTC_Enable_Channel":"Включити для загальнодоступних каналів","WebRTC_Enable_Direct":"Включити для прямих повідомлень","WebRTC_Enable_Private":"Включити для приватних каналів","WebRTC_Servers":"STUN / TURN Сервери","WebRTC_Servers_Description":"Список STUN і ПОВОРОТНИХ серверів, розділених комою. <br/> Ім'я користувача, пароль і порт дозволені в форматі `ім'я користувача: пароль @ оглушення: хост: port` або` ім'я користувача: пароль @ поворот: господар: port`.","Welcome":"Вітаємо, <em>%s</em>.","Welcome_to_the":"Ласкаво просимо в","will_be_able_to":"зможуть","With_whom":"З ким","Yes":"Так","Yes_clear_all":"Так, зрозуміло, все!","Yes_delete_it":"Так, видалити!","Yes_hide_it":"Так, це приховати!","Yes_leave_it":"Так, залиште його!","Yes_mute_user":"Так, відключення звуку користувач!","Yes_remove_user":"Так, видалити користувача!","you_are_in_preview_mode_of":"Ви перебуваєте в режимі попереднього перегляду каналу # <strong>__room_name__</strong>","You_are_logged_in_as":"Ви увійшли як","You_are_not_authorized_to_view_this_page":"Ви не авторизовані для перегляду цієї сторінки.","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"Ви останній власник. Будь ласка, встановіть новий власник перш ніж покинути кімнату.","You_can_change_a_different_avatar_too":"Ви можете змінити аватар використовуваний для відправки від цієї інтеграції.","You_can_use_an_emoji_as_avatar":"Ви можете також використовувати смайлик в якості аватара.","You_have_been_muted":"Ви були відключені і не можуть говорити в цій кімнаті","You_have_not_verified_your_email":"Ви не підтвердили свою електронну пошту.","You_have_successfully_unsubscribed":"Ви успішно відписалися від нашого списку Mailling.","You_informed_an_invalid_FROM_address":"Ви повідомили, інвалід адресу.","You_must_provide_the_unsubscribe_link":"Ви повинні надати [відписки] посилання.","You_need_confirm_email":"Для входу необхідно підтвердити e-mail!","You_need_install_an_extension_to_allow_screen_sharing":"Вам необхідно встановити розширення, щоб дозволити спільне використання екрану","You_need_to_change_your_password":"Ви повинні змінити свій пароль","You_need_to_type_in_your_password_in_order_to_do_this":"Ви повинні ввести свій пароль для того, щоб зробити це!","You_need_to_type_in_your_username_in_order_to_do_this":"Вам необхідно ввести ваше ім'я користувача для того, щоб зробити це!","You_need_to_verifiy_your_email_address_to_get_notications":"Вам необхідно verifiy свою адресу електронної пошти для отримання повідомлень","You_should_name_it_to_easily_manage_your_integrations":"Ви повинні назвати його легко управляти інтеграцій.","You_will_not_be_able_to_recover":"Ви не зможете відновити це повідомлення!","You_will_not_be_able_to_recover_file":"Ви не зможете відновити цей файл!","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"Ви не будете отримувати повідомлення по електронній пошті, тому що ви не підтвердили вашу електронну пошту.","Your_email_has_been_queued_for_sending":"Ваша електронна адреса був поставлений в чергу для відправки","Your_entry_has_been_deleted":"Ваша запис був видалений.","Your_file_has_been_deleted":"Ваш файл був видалений.","Your_mail_was_sent_to_s":"Ваш лист було відправлено в %s","Your_Open_Source_solution":"Ваш власний Open Source чат","Your_password_is_wrong":"Ваш невірний пароль!","Your_push_was_sent_to_s_devices":"Ваш поштовх був відправлений в %s пристроїв"});
TAPi18n._registerServerTranslator("uk", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/zh-HK.i18n.json                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["zh-HK"] = ["Chinese (Hong Kong)","繁体中文（香港）"];                                                 // 8
if(_.isUndefined(TAPi18n.translations["zh-HK"])) {                                                                     // 9
  TAPi18n.translations["zh-HK"] = {};                                                                                  // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["zh-HK"][namespace])) {                                                          // 13
  TAPi18n.translations["zh-HK"][namespace] = {};                                                                       // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["zh-HK"][namespace], {"Access_online_demo":"访问在线演示版本","Access_Online_Demo":"访问在线演示版本","Accounts":"帐户","Accounts_denyUnverifiedEmail":"拒绝未经验证的电子邮件","Accounts_EmailVerification":"邮件验证","Accounts_ManuallyApproveNewUsers":"手动审核新用户","Accounts_OAuth_Facebook":"Facebook 登入","Accounts_OAuth_Facebook_id":"Facebook应用程序ID","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_RegistrationRequired":"需要注册","Activate":"激活","Add_Members":"加入成员","Add_users":"添加用户","Administration":"管理","All_channels":"所有频道","Allow_Invalid_SelfSigned_Certs":"允许无效，自签名的SSL证书进行链路验证和预览","and":"和","API":"API","API_Analytics":"分析","API_Embed":"嵌入","are_also_typing":"也正在输入","are_typing":"正在输入","Are_you_sure":"你确定吗？","Auto_Load_Images":"自动载入图片","Avatar":"更改头像","Avatar_changed_successfully":"头像更新成功","away":"离开","Away":"离开","away_female":"离开","Away_female":"离开","away_male":"离开","Away_male":"离开","Back_to_login":"返回登录界面","bold":"粗体","busy":"忙","Busy":"忙","busy_female":"忙碌","Busy_female":"忙碌","busy_male":"忙碌","Busy_male":"忙碌","Cancel":"取消","Channels":"频道","Channels_list":"公共频道列表","Chat_Rooms":"聊天室","close":"关闭","coming_soon":"即将推出","Confirm_password":"确认密码","Contact":"联系人","Conversation":"谈话","Convert_Ascii_Emojis":"自动识别文字中的表情","Create_new":"新建","Created_at":"创建于","days":"天","Deactivate":"禁用","Delete":"删除","Delete_User_Warning":"删除用户将删除该用户的所有消息。这不能被撤消。","Deleted":"已删除！","Direct_Messages":"直接发送消息","Disable_New_Message_Notification":"禁用新消息通知","Disable_New_Room_Notification":"禁用新房间通知","Drop_to_upload_file":"拖放上传","Duplicate_private_group_name":"私有组 '%s' 已存在","E-mail":"电子邮件","Edit":"编辑","edited":"已编辑","Email_already_exists":"邮件已存在","Email_or_username":"电子邮件或用户名","Email_verified":"邮箱已验证","Enter_info":"输入您的信息","Enter_to":"进入","error-duplicate-channel-name":"频道 '%s' 已存在","Error_changing_password":"密码更改失败","Esc_to":"退出","False":"否","Favorites":"收藏","Follow_social_profiles":"关注我们的社交资讯，fork我们在github的项目或者在trello上分享你关于rocket.chat的想法。","Forgot_password":"忘记密码","Fork_it_on_github":"在Github上Fork它","From_Email":"从电子邮件","General":"通用","Get_to_know_the_team":"结识Rocket.Team","github_no_public_email":"在您的GitHub上帐户中，您没有设置任何电子邮件作为公共电子邮件地址。","Has_more":"有更多","Have_your_own_chat":"拥有自己的网络聊天。对于希望建立和发展自己的聊天平台的开发者而言，使用Meteor开发的Rocket.Chat是优秀的解决方案。","Hide_room":"隐藏聊天室","History":"历史","hours":"小时","Invalid_confirm_pass":"第二次密码输入与第一次不匹配","Invalid_email":"无效的电子邮件","Invalid_name":"用户名不能为空","Invalid_pass":"密码不能为空","Invalid_room_name":"<strong>%s</strong>不是一个有效的聊天室名称， <br/>只能使用字母，数字，.和_","invisible":"隐身","Invisible":"隐身","Invitation_HTML":"邀请邮件HTML","Invitation_Subject":"邀请邮件主题","Invite_Users":"邀请用户","is_also_typing":"也正在输入","is_also_typing_female":"正在输入","is_also_typing_male":"正在输入","is_typing":"正在输入","is_typing_female":"正在输入","is_typing_male":"正在输入","italics":"斜体","join":"加入","Join_the_Community":"加入社区","Language":"语言","Language_Version":"英语版本","Last_login":"上次登录","Last_message":"最新消息","Layout":"布局","Layout_Home_Body":"首页正文","Layout_Home_Title":"首页标题","Layout_Login_Terms":"登录条款","Layout_Privacy_Policy":"隐私政策","Layout_Sidenav_Footer":"侧面导航页脚","Layout_Terms_of_Service":"服务条款","LDAP":"LDAP","LDAP_Dn":"LDAP DN","LDAP_Port":"LDAP端口","Leave_room":"离开聊天室","Livechat_enabled":"在线咨询启用","Load_more":"加载更多","Loading...":"加载中...","Loading_more_from_history":"加载更多","Loading_suggestion":"载入建议中...","Login":"登录","Login_with":"使用%s登录","login_with":"或直接登录使用","Logout":"退出","Make_Admin":"设置为管理员","Mark_as_read":"标记为已读","Members_List":"成员列表","Message":"消息","Message_AllowDeleting":"允许删除消息","Message_AllowEditing":"允许编辑消息","Message_deleting_not_allowed":"不允许删除消息","Message_editing_not_allowed":"不允许编辑消息","Message_KeepHistory":"保存消息历史记录","Message_MaxAllowedSize":"消息最大允许大小","Message_MaxAll":"為ALL的消息最大通道尺寸","Message_removed":"消息已删除","Message_ShowDeletedStatus":"显示删除状态","Message_ShowEditedStatus":"显示编辑状态","Meta":"Meta","Meta_fb_app_id":"Facebook应用程序ID","Meta_google-site-verification":"谷歌网站验证","Meta_language":"语言","Meta_robots":"机器人","minutes":"分钟","More_channels":"更多频道","More_groups":"更多私有组","More_unreads":"更多未阅读","Msgs":"消息","My_Account":"我的账户","n_messages":"%s 条消息","Name":"姓名","New_messages":"新消息","New_password":"新密码","No_channel_with_name_%s_was_found":"未找到频道 <strong>\"%s\"</strong> !","No_channels_yet":"您尚未加入这个频道。","No_direct_messages_yet":"您还没有开始任何聊天。","No_favorites_yet":"您还没有添加任何收藏。","No_group_with_name_%s_was_found":"未找到私有组 <strong>\"%s\"</strong> !","No_groups_yet":"你还没有私有组。","No_permission_to_view_room":"您没有权限访问这个聊天室","No_user_with_username_%s_was_found":"未找到用户 <strong>\"%s\"</strong> !","Not_allowed":"不允许","Not_found_or_not_allowed":"未找到或者不允许","Nothing_found":"没有找到","Notify_all_in_this_room":"提醒房间中的所有人","Online":"在线","Only_you_can_see_this_message":"只有你能看到这条信息","Oops!":"哎呀","others":"其他","Password":"密码","Password_changed_successfully":"密码更改成功","Please_wait":"请稍候","Please_wait_activation":"请稍候，这可能需要一些时间。","Please_wait_statistics":"请稍等，正在生成统计数据。","Powered_by":"Powered by","Preferences":"偏好设置","Preferences_saved":"偏好设置已保存","Privacy":"隐私条款","Private_Groups":"私有组","Private_Groups_list":"私有组列表","Profile":"资料","Profile_saved_successfully":"资料保存成功","Proudly_developed":"使用Meteor开发","Push":"推送","Push_apn_cert":"APN证书","Push_apn_dev_cert":"APN Dev 证书 ","Push_apn_dev_key":"APN Dev 密钥","Push_apn_dev_passphrase":"APN DEV 口令","Push_apn_key":"APN密钥","Push_apn_passphrase":"APN密码短语","Push_debug":"调试","Push_enable":"启用","Push_production":"生产","Quick_Search":"快速搜索","quote":"引用","Recents":"最近","Register":"注册一个新帐号","Registration_Succeeded":"注册成功","Remember_me":"记住我","Remove":"移除","Remove_Admin":"取消管理员","Reset_password":"重设密码","Room":"聊天室","Room_name_changed":"聊天室名称更改为: <em>__room_name__</em> 由 <em>__user_by__</em> 更改","Room_name_changed_successfully":"聊天室名称变更成功","Room_not_found":"未找到房间","room_user_count":"%s 个用户","Rooms":"房间","S_new_messages_since_s":"%s 新消息，自从 %s","SAML":"SAML","Save":"保存","Save_changes":"保存修改","Save_Mobile_Bandwidth":"节约移动带宽","Search":"搜索","Search_Messages":"搜索消息","Search_settings":"搜索设置","seconds":"秒","See_all":"查看全部","See_only_online":"只查看在线用户","Select_an_avatar":"请选择一个头像","Select_file":"选择文件","Select_service_to_login":"选择服务登录加载您的头像，或直接从您的电脑上传一个","Selected_users":"选定的成员","Send":"发送","Send_confirmation_email":"已发送确认电子邮件","Send_invitation_email":"发送邀请电子邮件","Send_invitation_email_error":"您还没有提供任何有效的电子邮件地址。","Send_invitation_email_info":"您可以一次发送多个电子邮件邀请。","Send_invitation_email_success":"您已成功发送的邀请电子邮件至以下地址：","Send_invitation_email_warning":"为了发送邀请电子邮件，您必须先配置SMTP设置。","Send_Message":"发送","Settings":"设置","Settings_updated":"设置已更新","Showing_online_users":"显示 __total__ 位用户中的 <b>__total_showing__</b> 位","Showing_results":"<p>显示<b>%s</b>条结果</p>","Silence":"静音","since_creation":"自从%s","SMTP":"SMTP","SMTP_Host":"SMTP主机","SMTP_Password":"SMTP密码","SMTP_Port":"SMTP端口","SMTP_Username":"SMTP用户名","Sound":"声音","Start_Chat":"开始聊天","Start_of_conversation":"开始交谈","Statistics":"统计","Stats_Active_Users":"活跃​​用户","Stats_Avg_Channel_Users":"平均频道人数","Stats_Avg_Private_Group_Users":"平均私人组人数","Stats_Max_Room_Users":"最大的房间人数","Stats_Non_Active_Users":"非活动用户","Stats_Offline_Users":"脱机用户","Stats_Online_Users":"在线用户","Stats_Total_Channels":"频道总数","Stats_Total_Direct_Messages":"点对点发送消息房间数","Stats_Total_Private_Groups":"私有组数","Stats_Total_Rooms":"房间总数","Stats_Total_Users":"用户总数","strike":"划线","Submit":"提交","The_field_is_required":"字段 %s 必须填写。","True":"是","Unnamed":"未命名","Upload_file_question":"上传文件？","Use_Emojis":"使用表情","Use_initials_avatar":"使用您用户名的首字母缩写","use_menu":"使用侧边栏来访问你的聊天室","Use_service_avatar":"使用 %s 头像","Use_this_username":"使用此用户名","Use_uploaded_avatar":"使用上传头像","User_added":"已添加用户 <em>__user_added__</em> 。","User_added_by":" <em>__user_by__</em> 添加了 <em>__user_added__</em> 。","User_Channels":"用户频道","User_has_been_activated":"用户已经激活","User_has_been_deactivated":"用户已停用","User_has_been_deleted":"用户已被删除","User_Info":"用户信息","User_is_no_longer_an_admin":"用户已不再是管理员","User_is_not_activated":"用户未激活","User_is_now_an_admin":"用户已成为管理员","User_joined_channel":"加入了频道。","User_joined_channel_female":"加入了频道。","User_joined_channel_male":"加入了频道。","User_left":"用户 <em>__user_left__</em> 已离开。","User_left_female":"用户 <em>__user_left__</em> 已退出。","User_left_male":"用户 <em>__user_left__</em> 已退出。","User_logged_out":"用户已注销","User_removed_by":"用户 <em>__user_removed__</em> 已被 <em>__user_by__</em> 移除。","User_Settings":"用户设置","User_updated_successfully":"用户更新成功","Username":"用户名","Username_cant_be_empty":"用户名不能为空","Username_description":"这个用户名用于让别人在聊天消息中通知您。","Username_invalid":"<strong>%s</strong>不是一个有效的用户名， <br/>只能使用字母，数字，.和_","Username_title":"注册用户名","Username_unavaliable":"<strong>%s</strong>已被使用 :(","Users":"用户","View_All":"查看全部","Wait_activation_warning":"您的帐户必须由管理员手工启动后才能登录。","We_have_sent_password_email":"我们已经向您发送密码重置的电子邮件。如果您没有收到邮件，请重试。","We_have_sent_registration_email":"我们已经向您发出一封电子邮件，以确认您的注册。如果您没有收到邮件，请重试。","Welcome":"欢迎 <em>%s</em>","Welcome_to_the":"欢迎来到","With_whom":"对象","Yes_delete_it":"对的，删除！","you_are_in_preview_mode_of":"您正在预览频道 #<strong>__room_name__</strong>","You_need_confirm_email":"登录前请验证您的电子邮件！","You_will_not_be_able_to_recover":"您将无法恢复！","Your_entry_has_been_deleted":"您的项目已被删除。","Your_Open_Source_solution":"您自己的开源聊天解决方案"});
TAPi18n._registerServerTranslator("zh-HK", namespace);                                                                 // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/zh-TW.i18n.json                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["zh-TW"] = ["Chinese (Taiwan)","繁体中文（台湾）"];                                                    // 8
if(_.isUndefined(TAPi18n.translations["zh-TW"])) {                                                                     // 9
  TAPi18n.translations["zh-TW"] = {};                                                                                  // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["zh-TW"][namespace])) {                                                          // 13
  TAPi18n.translations["zh-TW"][namespace] = {};                                                                       // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["zh-TW"][namespace], {"500":"內部服務器錯誤","0_Errors_Only":"僅錯誤 -  0","1_Errors_and_Information":"1  - 錯誤信息","2_Erros_Information_and_Debug":"2  - 誤差修改，信息和調試","__username__was_set__role__by__user_by_":"__username__設置__role__由__user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__不再__role__，由__user_by__","Access_not_authorized":"訪問未授權","Access_online_demo":"访问在线演示版本","Access_Online_Demo":"访问在线演示版本","Access_Token_URL":"訪問令牌網址","Accounts":"帳戶","Accounts_AllowDeleteOwnAccount":"允許用戶刪除自己的帳戶","Accounts_AllowedDomainsList":"允許域列表","Accounts_AllowedDomainsList_Description":"允許域逗號分隔列表","Accounts_AllowEmailChange":"允許電子郵件更改","Accounts_AllowPasswordChange":"允許更改密碼","Accounts_AllowUserAvatarChange":"允許用戶更改頭像","Accounts_AllowUsernameChange":"允許用戶變更名稱","Accounts_AllowUserProfileChange":"允許用戶配置文件更改","Accounts_AvatarResize":"調整頭像","Accounts_AvatarSize":"頭像尺寸","Accounts_AvatarStorePath":"阿凡達存儲路徑","Accounts_AvatarStoreType":"阿凡達存儲類型","Accounts_BlockedDomainsList":"阻止域列表","Accounts_BlockedDomainsList_Description":"阻止域逗號分隔列表","Accounts_denyUnverifiedEmail":"拒絕尚未認證的電子郵件","Accounts_EmailVerification":"電子郵件驗證","Accounts_EmailVerification_Description":"請確保您有正確的SMTP設置使用此功能","Accounts_Enrollment_Email":"註冊郵箱","Accounts_Enrollment_Email_Description":"您可以使用[名]，[FNAME]，[LNAME]為用戶的全名，名字或姓氏，分別。 <br />您可以使用[郵件]為用戶的電子郵件。","Accounts_Iframe_api_method":"API方法","Accounts_Iframe_api_url":"API網址","Accounts_iframe_enabled":"啟用","Accounts_iframe_url":"iframe網址","Accounts_LoginExpiration":"在天登錄過期","Accounts_ManuallyApproveNewUsers":"手动审核新用户","Accounts_OAuth_Custom_Token_Sent_Via":"令牌通過發送","Accounts_OAuth_Custom_Authorize_Path":"授權路徑","Accounts_OAuth_Custom_Button_Color":"Button Color","Accounts_OAuth_Custom_Button_Label_Color":"Button Text Color","Accounts_OAuth_Custom_Button_Label_Text":"Button Text","Accounts_OAuth_Custom_Enable":"啟用","Accounts_OAuth_Custom_id":"Id","Accounts_OAuth_Custom_Identity_Path":"標識路徑","Accounts_OAuth_Custom_Login_Style":"登錄樣式","Accounts_OAuth_Custom_Secret":"Secret","Accounts_OAuth_Custom_Token_Path":"令牌路徑","Accounts_OAuth_Custom_URL":"URL","Accounts_OAuth_Facebook":"Facebook 登入","Accounts_OAuth_Facebook_callback_url":"Facebook的回調網址","Accounts_OAuth_Facebook_id":"Facebook應用程式ID","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"啟用的OAuth","Accounts_OAuth_Github_callback_url":"Github的回調URL","Accounts_OAuth_GitHub_Enterprise":"啟用的OAuth","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub的企業回調網址","Accounts_OAuth_GitHub_Enterprise_id":"Client Id","Accounts_OAuth_GitHub_Enterprise_secret":"Client Secret","Accounts_OAuth_Github_id":"客戶Id","Accounts_OAuth_Github_secret":"客戶端密鑰","Accounts_OAuth_Gitlab":"啟用的OAuth","Accounts_OAuth_Gitlab_callback_url":"GitLab回調網址","Accounts_OAuth_Gitlab_id":"GitLab Id","Accounts_OAuth_Gitlab_secret":"Client Secret","Accounts_OAuth_Google":"Google 登入","Accounts_OAuth_Google_callback_url":"谷歌回調網址","Accounts_OAuth_Google_id":"谷歌標識","Accounts_OAuth_Google_secret":"谷歌秘密","Accounts_OAuth_Linkedin":"LinkedIn 登入","Accounts_OAuth_Linkedin_callback_url":"LinkedIn回調網址","Accounts_OAuth_Linkedin_id":"LinkedIn標識","Accounts_OAuth_Linkedin_secret":"LinkedIn秘密","Accounts_OAuth_Meteor":"Meteor 登入","Accounts_OAuth_Meteor_callback_url":"流星回調網址","Accounts_OAuth_Meteor_id":"Meteor Id","Accounts_OAuth_Meteor_secret":"Meteor Secret","Accounts_OAuth_Twitter":"Twitter 登入","Accounts_OAuth_Twitter_callback_url":"Twitter的回調URL","Accounts_OAuth_Twitter_id":"Twitter Id","Accounts_OAuth_Twitter_secret":"Twitter Secret","Accounts_OAuth_Wordpress":"WordPress Login","Accounts_OAuth_Wordpress_callback_url":"WordPress的回調URL","Accounts_OAuth_Wordpress_id":"WordPress Id","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"密碼重設","Accounts_Registration_AuthenticationServices_Enabled":"登記認證服務","Accounts_RegistrationForm":"註冊表單","Accounts_RegistrationForm_Disabled":"殘","Accounts_RegistrationForm_LinkReplacementText":"登記表鏈接替換文本","Accounts_RegistrationForm_Public":"公開","Accounts_RegistrationForm_Secret_URL":"揭秘網址","Accounts_RegistrationForm_SecretURL":"登記表秘密網址","Accounts_RegistrationForm_SecretURL_Description":"您必須提供將被添加到您的註冊URL隨機字符串。例如：https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"需要註冊","Accounts_RequireNameForSignUp":"需要名稱對於註冊","Accounts_ShowFormLogin":"基於表單的顯示登入","Accounts_UseDefaultBlockedDomainsList":"使用默認阻止域列表","Accounts_UseDNSDomainCheck":"使用DNS域名查詢","Activate":"激活","Activity":"活動","Add":"加","Add_agent":"添加代理","Add_custom_oauth":"添加自定義的OAuth","Add_manager":"新增管理員","Add_Members":"加入成員","Add_User":"添加用戶","Add_user":"加入使用者","Add_users":"新增用戶","Additional_emails":"其他電子郵件","Additional_Feedback":"其他反饋","Administration":"管理","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"OAuth2用戶身份驗證後，用戶會被重定向到該網址","Agent_added":"添加代理","Agent_removed":"代理刪除","Alias":"別號","All":"所有","All_channels":"所有頻道","All_logs":"所有日誌","All_messages":"所有消息","Allow_Invalid_SelfSigned_Certs":"允许无效，自签名的SSL证书进行链路验证和预览","Allow_Invalid_SelfSigned_Certs_Description":"允許使用無效的和自簽署的SSL證書的鏈路驗證和預覽。","and":"和","And_more":"而更多的__length __...","Animals_and_Nature":"動物與自然","API":"API","API_Analytics":"分析","API_Embed":"嵌入","API_EmbedDisabledFor":"禁用對嵌入用戶","API_EmbedDisabledFor_Description":"用戶名的逗號分隔列表","API_GitHub_Enterprise_URL":"伺服器網址","API_GitHub_Enterprise_URL_Description":"例如：http://domain.com（不包括最後的斜線）","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress URL","Appearance":"出現","Application_added":"添加應用","Application_Name":"應用名稱","Application_updated":"應用更新","Apply_and_refresh_all_clients":"應用和刷新所有客戶端","Archive":"檔案","Archive_Unarchive":"存檔/取消存檔","are_also_typing":"也正在輸入","are_typing":"正在輸入","Are_you_sure":"你確定嗎？","Are_you_sure_you_want_to_delete_your_account":"你確定要刪除自己的帳戶？","Authorization_URL":"授權網址","Authorize":"授權","AutoLinker_StripPrefix":"AutoLinker帶前綴","AutoLinker_StripPrefix_Description":"簡短的顯示。如https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker網址","AutoLinker_UrlsRegExp":"AutoLinker URL正則表達式","AutoLinker_Email":"AutoLinker電子郵件","AutoLinker_Phone":"AutoLinker電話","AutoLinker_Phone_Description":"自動鏈接電話號碼。比如`（123）456-7890`","Auto_Load_Images":"自動載入圖片","Available":"可用的","Available_agents":"可用代理","Avatar":"更改头像","Avatar_changed_successfully":"大頭貼照更新成功","Avatar_URL":"頭像網址","Avatar_url_invalid_or_error":"提供的網址無效或無法訪問。請重試，但有不同的URL。","away":"離開","Away":"離開","away_female":"離開","Away_female":"離開","away_male":"離開","Away_male":"離開","Back":"返回","Back_to_applications":"返回應用","Back_to_integrations":"返回集成","Back_to_login":"返回登入畫面","Back_to_permissions":"回到權限","Body":"身體","bold":"粗體","busy":"忙碌","Busy":"忙碌","busy_female":"忙碌","Busy_female":"忙碌","busy_male":"忙碌","Busy_male":"忙碌","Cancel":"取消","Cannot_delete_a_protected_role":"無法刪除受保護的作用","Cannot_delete_role_because_its_in_use":"無法刪除的角色，因為它在使用","Cannot_invite_users_to_direct_rooms":"不能邀請用戶直接房","CDN_PREFIX":"CDN前綴","Certificates_and_Keys":"證書和密鑰","Channel":"頻道","Channel_doesnt_exist":"頻道 `#%s`不存在","Channels":"頻道","Channels_list":"公共頻道列表","Chat_Rooms":"聊天室","Chatops_Enabled":"啟用Chatops","Chatops_Title":"Chatops面板","Chatops_Username":"Chatops用戶名","Choose_a_room":"選擇一個房間","Choose_messages":"選擇信息","Choose_the_alias_that_will_appear_before_the_username_in_messages":"選擇將在消息中的用戶名前出現的別名。","Choose_the_username_that_this_integration_will_post_as":"選擇這種集成將發布作為用戶名。","Clear_all_unreads_question":"清除所有未讀訊息？","Client_ID":"客戶端ID","Client_Secret":"客戶端密鑰","Clients_will_refresh_in_a_few_seconds":"客戶端將在幾秒鐘刷新","close":"關閉","Closed":"關閉","Collapse_Embedded_Media_By_Default":"關閉默認的嵌入式媒體","coming_soon":"即將推出","Commands":"命令","Compact_View":"Compact View","Confirm_password":"確認密碼","Contact":"聯絡人","Conversation":"對話","Convert_Ascii_Emojis":"自動轉變文字為表情","Copied":"複製","COPY_TO_CLIPBOARD":"複製到剪貼板","Copy_to_clipboard":"複製到剪貼板","Count":"計數","Create":"創建","Create_new":"新建","Created_at":"建立於","Created_at_s_by_s":"被<strong><strong>％s％s</strong></strong>的創建","Custom_Fields":"自定義字段","Custom_oauth_helper":"當設置您的OAuth提供者，你必須告知回調URL。使用<pre> ％S </pre> 。","Custom_oauth_unique_name":"自OAuth的唯一名稱","Custom_Script_Logged_In":"針對登錄用戶自定義腳本","Custom_Script_Logged_Out":"自定義腳本用於註銷用戶","Dashboard":"儀表板","days":"天","Deactivate":"禁用","Debug_Level":"調試級別","Default":"默認","Delete":"刪除","Delete_my_account":"刪除我的賬戶","Delete_Room_Warning":"刪除房間會刪除該房間內發布的所有消息。這不能被撤消。","Delete_User_Warning":"刪除用戶將刪除該用戶所有訊息。這不能復原。","Deleted":"已刪除！","Department_not_found":"部未找到","Department_removed":"除去部","Departments":"部門","Description":"描述","Desktop":"桌面","Desktop_Notification_Test":"桌面通知測試","Desktop_Notifications":"桌面通知","Desktop_Notifications_Disabled":"桌面通知被禁用。如果您需要啟用通知更改瀏覽器偏好設置。","Desktop_Notifications_Enabled":"桌面啟用通知","Direct_message_someone":"直接留言人","Direct_Messages":"直接发送消息","Direct_Messages_list":"直接留言","Disable_Favorite_Rooms":"禁用收藏","Disable_New_Message_Notification":"禁用新消息通知","Disable_New_Room_Notification":"禁用新房間通知","Displays_action_text":"顯示文字行動","Do_you_want_to_change_to_s_question":"你想更改為<strong>％s</strong>嗎？","Drop_to_upload_file":"拖拉上傳","Dry_run":"空運行","Dry_run_description":"將只發送一封電子郵件，以相同的地址從。電子郵件必須屬於一個有效的用戶。","Duplicate_archived_channel_name":"存檔的頻道名稱為'％s'的存在","Duplicate_archived_private_group_name":"存檔的私人團體名為'％s'的存在","Duplicate_private_group_name":"私有群組 '%s' 已存在","E-mail":"電子郵件","Edit":"編輯","Edit_Custom_Field":"編輯自定義字段","Edit_Department":"編輯部","edited":"已編輯","Email":"電子郵件","Email_already_exists":"電子郵件已存在","Email_body":"電子郵件正文","Email_Change_Disabled":"您Rocket.Chat管理員禁用電子郵件的變化","Email_from":"從","Email_Notification_Mode":"離線電子郵件通知","Email_Notification_Mode_All":"每當提及/ DM","Email_Notification_Mode_Disabled":"殘","Email_or_username":"電子郵件或用户名","Email_subject":"學科","Email_verified":"電子郵件已驗證","Emoji":"表情符號","Empty_title":"空標題","Enable":"啟用","Enable_Desktop_Notifications":"啟用桌面通知","Enabled":"啟用","Encrypted_message":"加密消息","End_OTR":"結束OTR","Enter_a_regex":"輸入一個正則表達式","Enter_a_room_name":"進入一個房間名稱","Enter_a_username":"輸入用戶名","Enter_info":"輸入你的資料","Enter_name_here":"在這裡輸入姓名","Enter_to":"進入","Error":"錯誤","error-cant-invite-for-direct-room":"不能邀請用戶直接房","error-duplicate-channel-name":"頻道 '%s' 已存在","error-invalid-custom-field":"無效的自定義字段","error-invalid-custom-field-name":"無效的自定義字段名稱。只能使用字母，數字，連字符和下劃線。","error-invalid-password":"無效的密碼","error-invalid-room":"房間無效","error-invalid-room-name":"<strong>％s</strong>不是一個有效的房間名稱， <br/>只能使用字母，數字，連字符和下劃線","error-invalid-user":"無效的用戶","error-invalid-username":"無效的用戶名","error-not-allowed":"不允許","error-not-authorized":"未經授權","error-remove-last-owner":"這是最後的主人。請刪除此人之前設置一個新的所有者。","error-role-name-required":"角色名是必需的","error-user-not-in-room":"用戶不是在這個房間","Error_changing_password":"密碼變更失敗","Error_sending_confirmation_email":"發送錯誤的確認電子郵件","Error_too_many_requests":"錯誤，太多的請求。請減速慢行。重試前必須等待％S秒","Esc_to":"退出","Example_s":"例如： <code class=\"inline\">%s</code>","False":"否","Favorites":"收藏","Field":"領域","Field_removed":"現場拆除","File_exceeds_allowed_size_of_bytes":"文件超過__size__字節允許大小","FileUpload":"檔案上傳","FileUpload_Enabled":"文件上傳啟用","FileUpload_File_Empty":"文件中的空","FileUpload_FileSystemPath":"系統路徑","FileUpload_MaxFileSize":"最大的檔案上傳大小(in bytes)","FileUpload_MediaType_NotAccepted":"媒體類型不接受","FileUpload_MediaTypeWhiteList":"接受媒體類型","FileUpload_MediaTypeWhiteListDescription":"逗號分隔的媒體類型列表。它留空接受所有媒體類型。","FileUpload_ProtectFiles":"保護上傳的文件","FileUpload_ProtectFilesDescription":"只有經過身份驗證的用戶將有機會獲得","FileUpload_S3_Acl":"Amazon S3的ACL","FileUpload_S3_AWSAccessKeyId":"Amazon S3的AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3的AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3的桶名稱","FileUpload_S3_BucketURL":"鬥網址","FileUpload_S3_CDN":"CDN域下載","FileUpload_S3_Region":"地區","FileUpload_Storage_Type":"存儲類型","Flags":"旗","Follow_social_profiles":"关注我们的社交资讯，fork我们在github的项目或者在trello上分享你关于rocket.chat的想法。","Food_and_Drink":"食物和飲料","For_your_security_you_must_re_enter_your_password_to_continue":"為了您的安全，您必須重新輸入密碼才能繼續","Force_SSL":"強制SSL","Force_SSL_Description":"*注意！* _Force SSL_不應該與反向代理使用。如果你有一個反向代理，你如果真有這樣做的重定向。這個選項存在像Heroku的，不允許在反向代理重定向配置部署。","Forgot_password":"忘記密碼","Fork_it_on_github":"在Github上Fork它","Frequently_Used":"常用","From":"從","From_Email":"從電子郵件","From_email_is_required":"從需要的電子郵件","From_email_warning":"<b>警告</b> ：本場<b>從</b>受您的郵件服務器設置。","General":"通用","Get_to_know_the_team":"Rocket.Team","github_no_public_email":"您沒有設置任何電子郵件作為公共電子郵件地址，在你的Github帳戶上","Give_a_unique_name_for_the_custom_oauth":"舉一個唯一的名稱自定義的OAuth","Give_the_application_a_name_This_will_be_seen_by_your_users":"給應用程序的名稱。這將被用戶看到。","Global":"全球","GoogleTagManager_id":"谷歌代碼管理標識","Has_more":"有更多","Have_your_own_chat":"拥有自己的网络聊天。对于希望建立和发展自己的聊天平台的开发者而言，使用Meteor开发的Rocket.Chat是优秀的解决方案。","Header":"頭","Hidden":"隱","Hide_Group_Warning":"您確定要隱藏組“％s”嗎？","Hide_Private_Warning":"你確定你要隱藏用“％S”的討論？","Hide_room":"隱藏聊天室","Hide_Room_Warning":"你確定你要隱藏的房間“％s”嗎？","Highlights":"亮點","Highlights_How_To":"當有人提到了一個詞或短語，在這裡將其添加到被通知。您可以用逗號分隔的單詞或短語。高亮詞不區分大小寫。","Highlights_List":"高亮的話","History":"歷史","hours":"小時","How_friendly_was_the_chat_agent":"如何友好是聊天劑？","How_knowledgeable_was_the_chat_agent":"如何懂行是聊天劑？","How_responsive_was_the_chat_agent":"如何響應是聊天劑？","How_satisfied_were_you_with_this_chat":"如何滿足於此聊天是你？","If_you_are_sure_type_in_your_password":"如果您確定鍵入您的密碼：","If_you_are_sure_type_in_your_username":"如果您確定鍵入您的用戶名：","Importer_Archived":"存檔","Importer_done":"導入完成！","Importer_finishing":"完成了進口。","Importer_From_Description":"進口__from __的數據轉換成Rocket.Chat。","Importer_import_cancelled":"導入已取消。","Importer_import_failed":"在運行輸入時出錯。","Importer_importing_channels":"導入通道。","Importer_importing_messages":"導入的消息。","Importer_importing_started":"開始導入。","Importer_importing_users":"導入用戶。","Importer_not_defined_properly":"進口商沒有正確定義，它缺少導入類。","Importer_not_in_progress":"進口商目前沒有運行。","Importer_Prepare_Restart_Import":"重啟進口","Importer_Prepare_Start_Import":"開始導入","Importer_Prepare_Uncheck_Archived_Channels":"取消選中存檔通道","Importer_Prepare_Uncheck_Deleted_Users":"取消選中刪除用戶","Importer_progress_error":"無法獲得進口進度。","Importer_setup_error":"在設置進口商出錯。","Incorrect_Password":"密碼不正確","inline_code":"inline_code","Install_Extension":"安裝擴充功能","Install_FxOs":"在你的Firefox上安裝Rocket.Chat","Install_FxOs_done":"大！現在，您可以通過在主屏幕的圖標Rocket.Chat。有樂趣Rocket.Chat！","Install_FxOs_error":"對不起，沒有工作的打算！以下錯誤出現：","Install_FxOs_follow_instructions":"請確認您的設備上的應用程序安裝（按“安裝”提示時）。","Installation":"安裝","Integration_added":"整合已添加","Integration_Incoming_WebHook":"傳入網絡掛接整合","Integration_New":"新的集成","Integration_Outgoing_WebHook":"即將離任的網絡掛接整合","Integration_updated":"集成已更新","Integrations":"集成","Invalid_asset":"資產無效","Invalid_confirm_pass":"確認密碼與密碼不相符","Invalid_email":"電子郵件無效","Invalid_Export_File":"上傳的文件是不是有效％的出口文件。","Invalid_file_height":"檔案高度不合法","Invalid_file_type":"檔案類型不合法","Invalid_file_width":"檔案寬度不合法","Invalid_Import_File_Type":"無效的導入文件類型。","Invalid_name":"用戶名不能為空","Invalid_notification_setting_s":"無效的通知設置：％s的","Invalid_pass":"密碼不能為空","Invalid_room_name":"<strong>%s</strong>不是一個合法的聊天室名稱， <br/>只能使用字母，數字，.和_","Invalid_room_type":"<strong>％s</strong>不是一個有效的房型。","Invalid_Secret_URL":"無效的秘密網址","Invalid_secret_URL_message":"提供的網址無效。","invisible":"隱藏","Invisible":"隱藏","Invitation_HTML":"邀请邮件HTML","Invitation_Subject":"邀请郵件主題","Invite_user_to_join_channel":"邀請用戶加入此頻道","Invite_Users":"邀請用戶","is_also_typing":"也正在輸入","is_also_typing_female":"正在輸入","is_also_typing_male":"正在輸入","is_typing":"正在輸入","is_typing_female":"正在輸入","is_typing_male":"正在輸入","italics":"斜體","join":"加入","Join_audio_call":"加入音頻呼叫","Join_the_Community":"加入社区","Join_the_given_channel":"加入現有頻道","Join_video_call":"加入視頻通話","Joined":"加盟","Jump":"跳","Jump_to_first_unread":"跳轉首個未讀","Jump_to_message":"跳轉到消息","Jump_to_recent_messages":"跳轉至最近的消息","Katex_Enabled":"Katex公司啟用","Label":"標籤","Language":"語言","Language_Version":"英語版本","Last_login":"上次登入","Last_message":"最新訊息","Last_seen":"最後一次露面","Layout":"介面","Layout_Home_Body":"首頁正文","Layout_Home_Title":"首頁標題","Layout_Login_Terms":"登入條款","Layout_Privacy_Policy":"隱私政策","Layout_Sidenav_Footer":"侧面导航页脚","Layout_Sidenav_Footer_description":"頁腳大小為260點¯x70像素","Layout_Terms_of_Service":"服務條款","LDAP":"LDAP","LDAP_CA_Cert":"CA證書","LDAP_Custom_Domain_Search":"自定義域搜索","LDAP_Custom_Domain_Search_Description":"一塊JSON的管轄綁定和連接信息，並為下面的形式： <br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"默認域","LDAP_Description":"LDAP的是，許多公司都使用上提供單點登錄層次數據庫 - 設施的多個站點和服務之間共享一個密碼。對於高級配置信息和示例，請諮詢我們的wiki：https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication。","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"域基","LDAP_Domain_Base_Description":"要搜索用戶和組的LDAP子樹的完全合格的名稱（DN）。您可以添加你喜歡的盡可能多的;然而，每一組必須在相同的域中鹼作為屬於它的用戶來定義。如果指定了受限制的用戶群體，只有屬於這些組的用戶將在範圍內。我們建議您指定的LDAP目錄樹的頂層為您的域名基地，並使用搜索過濾器來控制訪問。","LDAP_Domain_Search_Filter":"域搜索過濾器","LDAP_Domain_Search_Filter_Description":"如果指定，只有符合此過濾器，用戶將被允許登錄。如果沒有指定過濾器，指定域的基本範圍內的所有用戶都將能夠登錄。 <br/>例如，對於Active Directory的`的memberOf = CN = ROCKET_CHAT，OU =一般Groups`。 <br/>例如，OpenLDAP（可擴展匹配搜索）`OU：DN：= ROCKET_CHAT`。","LDAP_Domain_Search_Object_Category":"域名查詢對象類別","LDAP_Domain_Search_Object_Category_Description":"在* objectCategory屬性*標識用戶。 <br/>留空為* OpenLDAP的*。 <br/>比如`person`等。","LDAP_Domain_Search_Object_Class":"域名查詢對象類","LDAP_Domain_Search_Object_Class_Description":"在* *對象類標識用戶。 <br/>比如`organizationalPerson`，`user`，`inetOrgPerson`等。","LDAP_Domain_Search_Password":"域名查詢密碼","LDAP_Domain_Search_Password_Description":"密碼域搜索用戶。","LDAP_Domain_Search_User":"域名搜索用戶","LDAP_Domain_Search_User_Description":"執行用戶查找驗證其他用戶在登錄的LDAP用戶。 <br/>這通常是專為第三方集成創建一個服務帳戶。使用一個完全合格的名稱，比如'CN =管理員，CN =用戶，DC =示例，DC = com`。","LDAP_Domain_Search_User_ID":"域名查詢用戶ID","LDAP_Domain_Search_User_ID_Description":"標識誰試圖驗證的LDAP用戶的LDAP屬性。這個字段應`sAMAccountName`對於大多數活動目錄的安裝，但也可以是對其他LDAP解決方案，如OpenLDAP的`uid`。你可以用`mail`通過電子郵件或任何屬性要識別用戶。 <br>您可以使用逗號分隔的多個值，以允許用戶使用多個標識符喜歡的用戶名或郵箱登錄。","LDAP_Enable":"啟用","LDAP_Enable_Description":"嘗試利用LDAP進行身份驗證。","LDAP_Encryption":"加密","LDAP_Encryption_Description":"用來保護通信到LDAP服務器的加密方法。例子包括`plain`（不加密），`SSL / LDAPS`（從一開始加密）和`StartTLS`（升級到加密通信一旦連接）。","LDAP_Host":"主辦","LDAP_Host_Description":"LDAP主機，例如`ldap.example.com`或`10.0.0.30`。","LDAP_Port":"LDAP端口","LDAP_Port_Description":"端口訪問LDAP。例如：`389`或`636`的LDAPS","LDAP_Reject_Unauthorized":"未經授權拒絕","LDAP_Sync_User_Avatar":"同步用戶頭像","LDAP_Sync_User_Data":"同步數據","LDAP_Sync_User_Data_Description":"保持用戶數據同步與服務器上登錄（如：姓名，電子郵件）。","LDAP_Sync_User_Data_FieldMap":"用戶數據字段映射","LDAP_Sync_User_Data_FieldMap_Description":"如何配置用戶帳戶字段（如電子郵件）是從LDAP記錄填充（一旦發現）。 <br/>作為一個例子，`{“CN”：“姓名”，“郵件”：“電子郵件”}`會選擇從cn屬性一個人的人類可讀的名稱，然後從郵件屬性他們的電子郵件。 <br/>可用字段包括`name`和`email`。","LDAP_Sync_Users":"同步用戶","LDAP_Test_Connection":"測試連接","LDAP_Unique_Identifier_Field":"唯一標識符字段","LDAP_Unique_Identifier_Field_Description":"哪個字段將被用於向LDAP用戶和Rocket.Chat用戶聯繫起來。您可以告知以逗號分隔的多個值，從而嘗試從LDAP記錄的值。 <br/>默認值是`的objectGUID，IBM-entryUUID，GUID，dominoUNID，nsuniqueId，uidNumber`","LDAP_Use_Custom_Domain_Search":"使用自定義域名查詢","LDAP_Use_Custom_Domain_Search_Description":"寫自己的過濾器來搜索用戶在LDAP服務器中。","LDAP_Username_Field":"用戶名現場","LDAP_Username_Field_Description":"這將被用於為*用戶名*為新用戶。留空使用的用戶名告知登錄頁面上。 <br/>您可以使用模板標籤太像`＃{}給定名稱＃{SN}`。 <br/>默認值是`sAMAccountName`。","Leave_Group_Warning":"你確定你要離開組“％s”嗎？","Leave_Private_Warning":"你確定要留下“％S”的討論？","Leave_room":"離開聊天室","Leave_Room_Warning":"您確定要離開房間“％s”嗎？","line":"線","List_of_Direct_Messages":"直接信息一覽","Live_sessions":"現場會議","Livechat_agents":"評價等級代理商","Livechat_Dashboard":"評價等級儀表板","Livechat_enabled":"在线咨询启用","Livechat_Manager":"Livechat管理員","Livechat_managers":"評價等級管理","Livechat_title":"Livechat 標題","Livechat_title_color":"Livechat 標題背景顏色","Livechat_Users":"ID登錄用戶","Load_more":"載入更多","Loading...":"載入中...","Loading_more_from_history":"載入更多","Loading_suggestion":"載入建議中...","Localization":"本土化","Log_File":"顯示文件和行","Log_Level":"日誌級別","Log_Package":"顯示包","Log_View_Limit":"日誌查看限制","Logged_out_of_other_clients_successfully":"註銷其他客戶成功","Login":"登入","Login_with":"使用%s登入","login_with":"或直接登入使用","Logout":"登出","Logout_Others":"從其他已登錄註銷的地點","Mail_Message_Invalid_emails":"您提供一個或多個無效的電子郵件：％s的","Mail_Message_Missing_to":"你必須選擇一個或多個用戶或提供一個或多個電子郵件地址，以逗號分隔。","Mail_Message_No_messages_selected_select_all":"您還沒有選擇任何消息。你想<a href='#' class='select-all'>選擇所有</a>可見的消息？","Mail_Messages":"郵件","Mail_Messages_Instructions":"選擇您要通過電子郵件發送哪些信息通過點擊消息","Mail_Messages_Subject":"這裡的％S消息的選定部分","Mailer":"信封","Mailer_body_tags":"您<b>必須</b>使用[退訂]的退訂鏈接。 <br />您可以使用[名]，[FNAME]，[LNAME]為用戶的全名，名字或姓氏，分別。 <br />您可以使用[郵件]為用戶的電子郵件。","Make_Admin":"設為管理員","Manager_added":"經理加入","Manager_removed":"Manager中刪除","Mark_as_read":"標記為已讀","Markdown_Headers":"降價頭","Markdown_SupportSchemesForLink":"對於鏈接降價支援計劃","Markdown_SupportSchemesForLink_Description":"允許計劃的逗號分隔列表","Members_List":"成員列表","Mentions":"提及","Mentions_default":"提及（默認）","Message":"訊息","Message_AllowDeleting":"允許刪除訊息","Message_AllowEditing":"允許編輯訊息","Message_AllowEditing_BlockEditInMinutes":"塊消息後編輯（N）分","Message_AllowEditing_BlockEditInMinutesDescription":"輸入0可禁用阻塞。","Message_AllowPinning":"允許訊息釘選","Message_AllowPinning_Description":"允許將郵件被固定到任何通道。","Message_AllowStarring":"允許留言主演","Message_AudioRecorderEnabled":"錄音機啟用","Message_AudioRecorderEnabledDescription":"要求“音頻/ WAV'文件是在'文件上傳'設置的接受了媒體的類型。","Message_DateFormat":"日期格式","Message_DateFormat_Description":"參見： <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_deleting_not_allowed":"不允許刪除訊息","Message_editing_blocked":"該消息不能再編輯","Message_editing_not_allowed":"不允許編輯訊息","Message_GroupingPeriod":"分組週期（以秒為單位）","Message_GroupingPeriodDescription":"消息將與以前的消息，如果兩者都來自同一用戶和經過時間小於以秒知情時間進行分組。","Message_KeepHistory":"保存訊息歷史紀錄","Message_MaxAllowedSize":"允許訊息最大則數","Message_MaxAll":"为ALL的消息最大通道尺寸","Message_pinned":"訊息已被釘選","Message_pinning_not_allowed":"不允許訊息釘選","Message_removed":"訊息已刪除","Message_ShowDeletedStatus":"顯示刪除狀態","Message_ShowEditedStatus":"顯示編輯狀態","Message_ShowFormattingTips":"顯示格式提示","Message_TimeFormat":"時間格式","Message_TimeFormat_Description":"參見： <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"消息太長","Messages":"訊息","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"發送到傳入的網絡掛接的消息將被張貼在這裡。","Meta":"Meta","Meta_fb_app_id":"Facebook應用程式ID","Meta_google-site-verification":"Google網站驗證","Meta_language":"語言","Meta_msvalidate01":"MSValidate.01","Meta_robots":"機器人","minutes":"分鐘","Mobile_push":"移動推送","More_channels":"更多頻道","More_direct_messages":"更直接的訊息","More_groups":"更多私有群組","More_unreads":"更多未閱讀","Msgs":"消息","multi":"多","Mute_someone_in_room":"靜音有人在房間","Mute_user":"靜音用戶","Muted":"靜音","My_Account":"我的帳戶","n_messages":"%s 則消息","N_new_messages":"％新訊息","Name":"姓名","Name_cant_be_empty":"姓名不能為空","Name_of_agent":"代理的名稱","Name_optional":"名稱（可選）","Navigation_History_20_last_pages":"導航歷史記錄（去年20頁）","New_Application":"新應用","New_Custom_Field":"新的自定義字段","New_Department":"新科","New_integration":"新的集成","New_logs":"新日誌","New_messages":"新訊息","New_password":"新密碼","New_role":"新角色","No_channel_with_name_%s_was_found":"沒有此頻道 <strong>\"%s\"</strong> !","No_channels_yet":"您尚未加入此頻道。","No_direct_messages_yet":"您還没有開始任何聊天。","No_Encryption":"無加密","No_favorites_yet":"您没有新增任何收藏。","No_group_with_name_%s_was_found":"沒有此私有群組 <strong>\"%s\"</strong> !","No_groups_yet":"你尚未擁有私有群組","No_livechats":"你有沒有livechats。","No_mentions_found":"沒有提到發現","No_permission_to_view_room":"您沒有權限訪問這個聊天室","No_pinned_messages":"尚未釘選訊息","No_results_found":"未找到結果","No_starred_messages":"不加星標的郵件","no_tokens_for_this_user":"有該用戶沒有令牌","No_user_with_username_%s_was_found":"沒有此用戶 <strong>\"%s\"</strong> !","Not_allowed":"不允許","Not_authorized":"未經授權","Not_Available":"不可用","Not_found_or_not_allowed":"未找到或者不允許","Nothing":"沒有","Nothing_found":"沒有找到","Notifications":"通知","Notify_all_in_this_room":"提醒聊天室中的所有人","Num_Agents":"＃代理","Number_of_messages":"消息數","OAuth_Application":"OAuth的應用","OAuth_Applications":"OAuth的應用","Objects":"對象","Off_the_record_conversation":"現成的通話記錄","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"現成的記錄談話不適用於您的瀏覽器或設備。","Offline_DM_Email":"[__site__]您已通過__user__被直接傳遞消息","Offline_Mention_Email":"[__site__]你已經在#__room__ __user__提到","Old_and_new_password_must_be_different":"新密碼必須與舊密碼不同。","Old_and_new_password_required":"你必須提供舊密碼與新密碼來變更你的密碼","Online":"在线","Only_errors":"只有錯誤","Only_you_can_see_this_message":"只有你能看到這則訊息","Oops!":"哎呀","Open":"打開","Opened":"開業","Opt_out_statistics":"不要傳送統計資料到Rocket.Chat","Opt_out_statistics_warning":"通過發送您的統計，你會幫助我們確定如何Rocket.Chat許多實例部署，以及系統是如何表現不錯，所以我們可以進一步改進。不要擔心，因為沒有用戶信息的發送和收到的所有信息都是保密的。如果你想繼續發送您的統計，取消上述複選框。謝謝。","optional":"自選","Order":"訂購","OS_Arch":"OS拱","OS_Cpus":"作業系統處理器數量","OS_Freemem":"OS Free Memory","OS_Loadavg":"OS Load Average","OS_Platform":"OS Platform","OS_Release":"OS Release","OS_Totalmem":"OS Total Memory","OS_Type":"OS Type","OS_Uptime":"OS Uptime","others":"其他","OTR":"OTR","OTR_is_only_available_when_both_users_are_online":"OTR僅當兩個用戶是否在線","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"哪些文件被上傳覆蓋URL。該網址也可用於下載，除非CDN給出","Password":"密碼","Password_Change_Disabled":"您Rocket.Chat管理員禁用密碼的變化","Password_changed_successfully":"密碼變更成功","Payload":"有效載荷","People":"人","Permissions":"權限","Pin_Message":"釘選訊息","Pinned_a_message":"固定的消息：","Pinned_Messages":"已被釘選訊息","Placeholder_for_email_or_username_login_field":"佔位符電子郵件或用戶名登錄字段","Placeholder_for_password_login_field":"佔位符密碼登錄字段","Please_answer_survey":"請花一點時間來回答這個聊天快速調查","Please_enter_value_for_url":"請輸入您的頭像的URL值。","Please_enter_your_new_password_below":"請輸入您的新密碼：","Please_fill_a_label":"請填寫標籤","Please_fill_a_name":"請輸入姓名","Please_fill_a_username":"請填入姓名","Please_fill_name_and_email":"請輸入名字或電子郵件","Please_re_enter_your_password":"請重新輸入你的密碼","Please_select_enabled_yes_or_no":"請選擇一個選項啟用","Please_wait":"請稍候","Please_wait_activation":"請稍候，這可能需要一些時間。","Please_wait_statistics":"請稍候，正在產生統計數據。","Please_wait_while_OTR_is_being_established":"請稍候，正在建立OTR","Please_wait_while_your_account_is_being_deleted":"請稍候，您的帳戶被刪除...","Please_wait_while_your_profile_is_being_saved":"請稍候，您的個人資料被保存...","Post_as":"作為後","Post_to_Channel":"發布頻道","Post_to_s_as_s":"張貼到<strong><strong>％s％s</strong></strong>的身分","Powered_by":"Powered by","Preferences":"偏好設定","Preferences_saved":"偏好設定已保存","Privacy":"隱私條款","Private_Group":"私有群組","Private_Groups":"私有群組","Private_Groups_list":"私有群組清單","Profile":"個人資料","Profile_saved_successfully":"資料保存成功","Proudly_developed":"使用Meteor開發","Push":"推播","Push_apn_cert":"APN证书","Push_apn_dev_cert":"APN Dev 证书 ","Push_apn_dev_key":"APN Dev 金鑰","Push_apn_dev_passphrase":"APN DEV 口令","Push_apn_key":"APN金鑰","Push_apn_passphrase":"APN密码短语","Push_debug":"除錯","push_disabled":"禁用推","Push_enable":"啟用","Push_enable_gateway":"啟用網關","Push_gateway":"網關","Push_gcm_api_key":"GCM API Key","Push_gcm_project_number":"GCM Project Number","Push_production":"生产","Push_show_message":"在顯示通知消息","Push_show_username_room":"顯示通道/組/用戶名的通知","Push_test_push":"測試","Query":"詢問","Query_description":"確定將電子郵件發送給哪些用戶附加條件。退訂用戶將自動從查詢中刪除。它必須是一個有效的JSON。例如：“{”createdAt“：{”$ GT“：{”$日期“：”2015-01-01T00：00：00.000Z“}}}”","Quick_Search":"快速搜尋","quote":"引用","Reactions":"反應","Recents":"最近","Record":"錄音","Redirect_URI":"重定向URI","Refresh_keys":"刷新鍵","Refresh_your_page_after_install_to_enable_screen_sharing":"刷新頁面設置，使屏幕共享後，","Register":"註冊一個新帳號","Registration_Succeeded":"註冊成功","Remember_me":"記住我","Remove":"移除","Remove_Admin":"取消管理員","Remove_as_moderator":"刪除主持人","Remove_as_owner":"刪除作為所有者","Remove_custom_oauth":"刪除自定義的OAuth","Remove_from_room":"從房間取出","Remove_someone_from_room":"從房間中刪除某人","Removed":"去除","Require_password_change":"需要更改密碼","Resend_verification_email":"重新發送驗證郵件","Reset":"重置","Reset_password":"重設密碼","Restart":"重新啟動","Restart_the_server":"重新啟動伺服器","RocketBot_Enabled":"RocketBot Enabled","RocketBot_Name":"RocketBot Name","RocketBot_Name_Description":"RocketBot名稱必須是您的服務器上註冊的有效用戶名。","Role":"角色","Role_Editing":"角色編輯","Role_removed":"角色中刪除","Room":"聊天室","Room_archivation_state":"州","Room_archivation_state_false":"活性","Room_archivation_state_true":"存檔","Room_archived":"室歸檔","room_changed_privacy":"通過<em>__user_by__</em> <em>__room_type__：</em>房間類型變更為","room_changed_topic":"房間話題改為<em>：__room_topic__</em>由<em>__user_by__</em>","Room_has_been_deleted":"聊天室已經被刪除","Room_Info":"客房信息","Room_name_changed":"聊天室名稱更改為: <em>__room_name__</em> 由 <em>__user_by__</em> 更改","Room_name_changed_successfully":"聊天室名稱變更成功","Room_not_found":"沒有此聊天室","Room_topic_changed_successfully":"房間話題成功更改","Room_type_changed_successfully":"房間類型成功更改","Room_unarchived":"未存檔室","Room_uploaded_file_list":"檔案清單","Room_uploaded_file_list_empty":"沒有文件可用。","room_user_count":"%s 個用戶","Rooms":"聊天室","S_new_messages_since_s":"%s 新消息，來自 %s","SAML":"SAML","SAML_Custom_Cert":"自定義證書","SAML_Custom_Entry_point":"自定義入口點","SAML_Custom_Generate_Username":"生成用戶名","SAML_Custom_Issuer":"自發行人","SAML_Custom_Provider":"自定義提供商","Save":"儲存","Save_changes":"保存變更","Save_Mobile_Bandwidth":"节约移动带宽","Save_to_enable_this_action":"保存啟用此動作","Saved":"保存","Saving":"保存","Scope":"範圍","Screen_Share":"畫面分享","Script_Enabled":"腳本已啟用","Search":"搜尋","Search_by_username":"通過用戶名搜索","Search_Channels":"搜索頻道","Search_Direct_Messages":"搜索直接信息","Search_Messages":"搜尋訊息","Search_Private_Groups":"搜查私人組","Search_settings":"搜索設定","seconds":"秒","See_all":"查看全部","See_only_online":"只查看在线用户","Select_a_department":"選擇一個部門","Select_an_avatar":"請選擇一張大頭貼照","Select_file":"選擇檔案","Select_service_to_login":"选择服务登录加载您的头像，或直接从您的电脑上传一个","Select_user":"選擇用戶","Select_users":"選擇用戶","Selected_agents":"選定代理","Selected_users":"選取的成員","Send":"發送","Send_a_message":"發送一則訊息","Send_a_test_mail_to_my_user":"發送測試郵件到我的用戶","Send_a_test_push_to_my_user":"發送推播測試給自己","Send_confirmation_email":"已傳送確認電子郵件","Send_data_into_RocketChat_in_realtime":"發送數據到Rocket.Chat實時。","Send_email":"發送電子郵件","Send_invitation_email":"發送邀請電子郵件","Send_invitation_email_error":"您尚未提供任何有效的電子郵件地址。","Send_invitation_email_info":"您可以一次發送多個電子郵件邀請。","Send_invitation_email_success":"您已成功發送邀请電子郵件到以下地址：","Send_invitation_email_warning":"為了發送邀請電子郵件，您必須先設定SMTP。","Send_Message":"發送","Send_your_JSON_payloads_to_this_URL":"請將您的JSON有效載荷這個URL。","Sending":"發送中...","Set_as_moderator":"設為主持人","Set_as_owner":"設置為所有者","Settings":"設定","Settings_updated":"設定已更新","Should_be_a_URL_of_an_image":"應的圖像的一個網址。","Should_exists_a_user_with_this_username":"用戶必須已經存在。","Show_all":"顯示所有","Show_more":"展示更多","Show_only_online":"只顯示在線","Show_preregistration_form":"顯示預登記表","Showing_archived_results":"<p>顯示<b>％s的</b>存檔結果</p>","Showing_online_users":"顯示 __total__ 位用户中的 <b>__total_showing__</b> 位","Showing_results":"<p>顯示<b>%s</b>則結果</p>","Silence":"靜音","since_creation":"來自%s","Site_Name":"網站名稱","Site_Url":"Site URL","Site_Url_Description":"Example: https://chat.domain.com/","Skip":"跳躍","Smileys_and_People":"表情與人","SMTP":"SMTP","SMTP_Host":"SMTP主機","SMTP_Password":"SMTP密碼","SMTP_Port":"SMTP端口","SMTP_Test_Button":"測試SMTP設置","SMTP_Username":"SMTP用戶名稱","Sound":"聲音","Star_Message":"明星留言","Starred_Messages":"加星標的郵件","Start_audio_call":"啟動音頻呼叫","Start_Chat":"开始聊天","Start_of_conversation":"開始對話","Start_OTR":"啟動OTR","Start_video_call":"開始視頻通話","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"先從<code class=\"inline\">%s</code>的用戶或<code class=\"inline\">%s</code>信道。例如： <code class=\"inline\">%s</code>或<code class=\"inline\">%s</code>","Statistics":"統計","Stats_Active_Users":"活跃用户","Stats_Avg_Channel_Users":"平均頻道人數","Stats_Avg_Private_Group_Users":"平均私有群組人數","Stats_Away_Users":"客場用戶","Stats_Max_Room_Users":"最大的聊天室人數","Stats_Non_Active_Users":"非活躍用戶","Stats_Offline_Users":"離線用戶","Stats_Online_Users":"在线用户","Stats_Total_Channels":"頻道總數","Stats_Total_Direct_Messages":"点对点发送消息房间数","Stats_Total_Messages":"總共訊息量","Stats_Total_Private_Groups":"私有群組總數","Stats_Total_Rooms":"聊天室總數","Stats_Total_Users":"用戶總數","Stop_Recording":"停止錄音","strike":"划线","Subject":"學科","Submit":"提交","Success":"成功","Survey":"調查","Survey_instructions":"根據您的滿意率每一個問題，1這意味著你完全不滿意和5這意味著你完全滿意。","Symbols":"符號","Sync_success":"同步成功","Sync_Users":"同步用戶","Test_Connection":"測試連接","Test_Desktop_Notifications":"測試桌面通知","Thank_you_for_your_feedback":"感謝您寶貴的意見","The_application_name_is_required":"應用程序名稱是必需的","The_channel_name_is_required":"通道名稱是必需的","The_emails_are_being_sent":"電子郵件傳送中","The_field_is_required":"字段 %s 必填","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"圖像大小調整不會起作用，因為在服務器上安裝的ImageMagick或GraphicsMagick工具，我們無法察覺。","The_redirectUri_is_required":"該redirectUri是必需的","The_server_will_restart_in_s_seconds":"伺服器將在 %s 秒後重新啟動","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"設置<strong>％S</strong>被配置為<strong>％s</strong>和你是從<strong>％s的</strong>訪問！","The_user_will_be_removed_from_s":"用戶將來自％s被刪除","The_user_wont_be_able_to_type_in_s":"用戶將不能夠鍵入在％s","Theme":"主題","theme-color-action-buttons-color":"操作按鈕顏色","theme-color-active-channel-background-color":"活動頻道背景顏色","theme-color-active-channel-font-color":"活動頻道字體顏色","theme-color-blockquote-background":"大段引用背景顏色","theme-color-clean-buttons-color":"乾淨的按鈕顏色","theme-color-code-background":"代碼背景顏色","theme-color-code-border":"代碼邊框顏色","theme-color-code-color":"顏色代碼","theme-color-content-background-color":"內容背景顏色","theme-color-custom-scrollbar-color":"自定義顏色滾動條","theme-color-info-active-font-color":"活動信息字體顏色","theme-color-info-font-color":"信息字體顏色","theme-color-input-font-color":"輸入字體顏色","theme-color-link-font-color":"鏈接字體顏色","theme-color-message-hover-background-color":"消息懸停背景色","theme-color-primary-background-color":"主要背景顏色","theme-color-primary-font-color":"主要字體顏色","theme-color-quaternary-font-color":"第四紀字體顏色","theme-color-secondary-background-color":"二級背景顏色","theme-color-secondary-font-color":"二級字體顏色","theme-color-smallprint-font-color":"小打印字體顏色","theme-color-smallprint-hover-color":"小字懸停顏色","theme-color-status-away":"客場狀態顏色","theme-color-status-busy":"忙碌狀態顏色","theme-color-status-offline":"離線狀態顏色","theme-color-status-online":"在線狀態顏色","theme-color-tertiary-background-color":"第三背景顏色","theme-color-tertiary-font-color":"第三字體顏色","theme-color-unread-notification-color":"未讀通知顏色","theme-custom-css":"自定義CSS","There_are_no_agents_added_to_this_department_yet":"有沒有加入到這個部門還沒有代理商。","There_are_no_integrations":"有沒有集成","There_are_no_users_in_this_role":"有這個角色沒有用戶。","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"此電子郵件已經被使用並沒有得到證實。請更改您的密碼。","This_is_a_desktop_notification":"這是一個桌面通知","This_is_a_push_test_messsage":"這是一則推播測試訊息","Time_in_seconds":"時間（秒）","Title_bar_color":"標題欄顏色","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"要在您的網站上安裝Rocket.Chat評價等級，複製和粘貼的最後一個<strong></ BODY></strong>網站上的標籤之上的代碼。","To_users":"為了用戶","Topic":"話題","Travel_and_Places":"旅遊與地方","Trigger_removed":"觸發刪除","Trigger_Words":"觸發詞","Triggers":"觸發器","True":"是","Type":"類型","Type_your_new_password":"輸入新密碼","Unarchive":"取消封存","Unmute_someone_in_room":"取消靜音有人在房間","Unmute_user":"用戶取消靜音","Unnamed":"未命名","Unpin_Message":"解除釘選訊息","Unread_Rooms":"訊息未讀聊天室","Unread_Rooms_Mode":"訊息未讀模式","Unstar_Message":"刪除星","Upload_file_question":"上傳檔案？","Uploading_file":"檔案上傳中...","Use_account_preference":"使用帳戶偏好","Use_Emojis":"使用表情","Use_initials_avatar":"使用您用戶名稱的字母開頭作為縮寫","use_menu":"使用侧边栏来访问你的聊天室","Use_service_avatar":"使用 %s 头像","Use_this_username":"使用此用戶名","Use_uploaded_avatar":"使用已上傳大頭貼照","Use_url_for_avatar":"使用網址為頭像","User__username__is_now_a_moderator_of__room_name_":"用戶現在__username__是__room_name__的主持人","User__username__is_now_a_owner_of__room_name_":"用戶現在__username__是__room_name__的主人","User__username__removed_from__room_name__moderators":"用戶從__username__版主__room_name__刪除","User__username__removed_from__room_name__owners":"用戶從__username__業主__room_name__刪除","User_added":"已新增用戶 <em>__user_added__</em> 。","User_added_by":" <em>__user_by__</em> 新增了 <em>__user_added__</em> 。","User_added_successfully":"用戶成功添加","User_Channels":"用戶頻道","User_doesnt_exist":"沒有用戶通過`@％s`的名稱存​​在。","User_has_been_activated":"用戶已經啟用","User_has_been_deactivated":"用戶已停用","User_has_been_deleted":"用戶已被刪除","User_has_been_muted_in_s":"用戶已靜音在％s","User_has_been_removed_from_s":"用戶已從％s的刪除","User_has_disconnected":"用戶已斷開連接","User_Info":"用戶資料","User_is_no_longer_an_admin":"用戶不再是管理員","User_is_not_activated":"用戶尚未繳活","User_is_now_an_admin":"用戶已成為管理員","User_joined_channel":"加入了頻道。","User_joined_channel_female":"加入了頻道。","User_joined_channel_male":"加入了頻道。","User_left":"用户 <em>__user_left__</em> 已離開。","User_left_female":"用戶 <em>__user_left__</em> 已退出。","User_left_male":"用戶 <em>__user_left__</em> 已退出。","User_logged_out":"用户已注销","User_management":"用戶管理","User_muted_by":"用戶通過<em>__user_muted__</em>靜音<em>__user_by__。</em>","User_muted_in_room":"用戶在室內靜音","User_not_found":"用戶未找到","User_not_found_or_incorrect_password":"找不到用戶或密碼不正確","User_or_channel_name":"用戶或頻道名稱","User_removed":"用戶刪除","User_removed_by":"用户 <em>__user_removed__</em> 已被 <em>__user_by__</em> 移除。","User_removed_from_room":"該用戶已被從房間中刪除","User_Settings":"用戶設定","User_unmuted_by":"用戶通過<em>__user_unmuted__</em>取消靜音<em>__user_by__。</em>","User_unmuted_in_room":"用戶在室內靜音","User_updated_successfully":"用戶更新成功","Username":"用戶名","Username_and_message_must_not_be_empty":"用戶名和郵件不能為空。","Username_cant_be_empty":"用戶名稱不能為空","Username_Change_Disabled":"您Rocket.Chat管理員禁用用戶名的變化","Username_denied_the_OTR_session":"__username__否認OTR會議","Username_description":"这个用户名用于让别人在聊天消息中通知您。","Username_doesnt_exist":"用戶名`％s`不存在。","Username_ended_the_OTR_session":"__username__結束了OTR會議","Username_invalid":"<strong>%s</strong>不是一個合法的用戶名稱， <br/>只能使用字母，數字，.和_","Username_is_already_in_here":"`@％s`已經在這裡了。","Username_is_not_in_this_room":"用戶`＃％s`是不是在這個房間。","Username_not_found":"未找到用戶名","Username_title":"註冊用戶名","Username_unavaliable":"<strong>%s</strong>已被使用 :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__想要啟動OTR。你想接受嗎？","Users":"用戶","Users_in_role":"在角色的用戶","UTF8_Names_Slugify":"UTF8名稱Slugify","UTF8_Names_Validation":"UTF8名驗證","UTF8_Names_Validation_Description":"不要讓特殊字符和空格。您可以使用 -  _和。但不是在名稱的末尾","Verification_email_sent":"驗證郵件已發送","View_All":"查看全部","View_Logs":"查看日誌","Visibility":"能見度","Visible":"可見","Visitor":"遊客","Visitor_page_URL":"訪客頁面URL","Visitor_time_on_site":"訪問者網站停留時間","Wait_activation_warning":"您的帳號必須由管理員手動啟用後才能登入。","We_are_offline_Sorry_for_the_inconvenience":"離線中，造成您的不便","We_have_sent_password_email":"我們已經送出密碼重置的電子郵件。如果您沒有收到，請重試。","We_have_sent_registration_email":"我們已經送出一封電子郵件，以確認你的註冊。如果您沒有收到，請重試。","WebRTC_Enable_Channel":"允許公共頻道","WebRTC_Enable_Direct":"啟用直接信息","WebRTC_Enable_Private":"允許私人頻道","WebRTC_Servers":"STUN / TURN服務器","WebRTC_Servers_Description":"用逗號分隔STUN和TURN服務器的列表。 <br/>用戶名，密碼和端口被允許在格式`用戶名：密碼@眩暈：主持人：port`或'用戶名：密碼@轉：主持人：port`。","Welcome":"歡迎 <em>%s</em>","Welcome_to_the":"歡迎來到","will_be_able_to":"將能","With_whom":"對象","Yes":"是","Yes_clear_all":"是，清除所有","Yes_delete_it":"是的，刪除！","Yes_hide_it":"是的，隱藏它！","Yes_leave_it":"是的，離開它！","Yes_mute_user":"是的，靜音的用戶！","Yes_remove_user":"是的，刪除用戶！","you_are_in_preview_mode_of":"您正在預覽頻道 #<strong>__room_name__</strong>","You_are_logged_in_as":"您登錄為","You_are_not_authorized_to_view_this_page":"您無權查看此頁。","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"你是最後的主人。請離開房間之前設置的新主人。","You_can_change_a_different_avatar_too":"您可以覆蓋從這次整合後的分身。","You_can_use_an_emoji_as_avatar":"您還可以使用表情符號作為頭像。","You_have_been_muted":"你已經靜音，並在這個房間裡不能發言","You_have_not_verified_your_email":"您尚未驗證您的電子郵件。","You_have_successfully_unsubscribed":"您已成功地從我們的名單Mailling取消訂閱。","You_informed_an_invalid_FROM_address":"通知您一個無效的發件人地址。","You_must_provide_the_unsubscribe_link":"您必須提供[退訂]鏈接。","You_need_confirm_email":"登入前你必須驗證你的電子郵件","You_need_install_an_extension_to_allow_screen_sharing":"你必須安裝擴充功能才能分享畫面","You_need_to_change_your_password":"您需要更改您的密碼","You_need_to_type_in_your_password_in_order_to_do_this":"您需要在您的密碼，才能做到這一點打字！","You_need_to_type_in_your_username_in_order_to_do_this":"您需要在您的用戶名，為了做到這一點打字！","You_need_to_verifiy_your_email_address_to_get_notications":"您需要verifiy您的電子郵件地址收到通知","You_should_name_it_to_easily_manage_your_integrations":"你應該將其命名為輕鬆管理您的集成。","You_will_not_be_able_to_recover":"您將無法恢復這則訊息！","You_will_not_be_able_to_recover_file":"您將無法恢復這個文件！","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"因為你還沒有確認電子郵件，您將不會收到電子郵件通知。","Your_email_has_been_queued_for_sending":"您的電子郵件已排隊等待發送","Your_entry_has_been_deleted":"您的項目已被刪除","Your_file_has_been_deleted":"您的文件已被刪除。","Your_mail_was_sent_to_s":"您的郵件已發送到％s","Your_Open_Source_solution":"您自己的開源聊天軟體","Your_password_is_wrong":"您的密碼是錯誤的！","Your_push_was_sent_to_s_devices":"你的推播被送到 %s 裝置"});
TAPi18n._registerServerTranslator("zh-TW", namespace);                                                                 // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/rocketchat_lib/packages/rocketchat_libi18n/zh.i18n.json                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _ = Package.underscore._,                                                                                          // 1
    package_name = "project",                                                                                          // 2
    namespace = "project";                                                                                             // 3
                                                                                                                       // 4
if (package_name != "project") {                                                                                       // 5
    namespace = TAPi18n.packages[package_name].namespace;                                                              // 6
}                                                                                                                      // 7
TAPi18n.languages_names["zh"] = ["Chinese","中文"];                                                                      // 8
if(_.isUndefined(TAPi18n.translations["zh"])) {                                                                        // 9
  TAPi18n.translations["zh"] = {};                                                                                     // 10
}                                                                                                                      // 11
                                                                                                                       // 12
if(_.isUndefined(TAPi18n.translations["zh"][namespace])) {                                                             // 13
  TAPi18n.translations["zh"][namespace] = {};                                                                          // 14
}                                                                                                                      // 15
                                                                                                                       // 16
_.extend(TAPi18n.translations["zh"][namespace], {"500":"内部服务器错误","0_Errors_Only":"0 - 仅错误 ","1_Errors_and_Information":"1 - 错误和信息","2_Erros_Information_and_Debug":"2 - 错误、信息和调试信息","__username__was_set__role__by__user_by_":"__username__设置__role__由__user_by__","__username__is_no_longer__role__defined_by__user_by_":"__username__不再__role__，由__user_by__","Access_not_authorized":"未活得访问授权","Access_online_demo":"访问在线演示版本","Access_Online_Demo":"访问在线演示版本","Access_Token_URL":"Access Token URL","Accounts":"帐户","Accounts_AllowDeleteOwnAccount":"允许用户删除自己的帐号","Accounts_AllowedDomainsList":"允许的域名列表","Accounts_AllowedDomainsList_Description":"以逗号分隔的合法域名列表","Accounts_AllowEmailChange":"允许修改邮件地址","Accounts_AllowPasswordChange":"允许修改密码","Accounts_AllowUserAvatarChange":"允许用户修改头像","Accounts_AllowUsernameChange":"允许修改用户名","Accounts_AllowUserProfileChange":"允许用户修改个人资料","Accounts_AvatarResize":"调整头像大小","Accounts_AvatarSize":"头像大小","Accounts_AvatarStorePath":"头像存储路径","Accounts_AvatarStoreType":"头像存储类型","Accounts_BlockedDomainsList":"已屏蔽域名列表","Accounts_BlockedDomainsList_Description":"以分号分割的屏蔽域名列表","Accounts_denyUnverifiedEmail":"拒绝未经验证的电子邮件","Accounts_EmailVerification":"邮件验证","Accounts_EmailVerification_Description":"使用此功能时，请确保SMTP设置的正确性","Accounts_Enrollment_Email":"注册 E-mail","Accounts_Enrollment_Email_Description":"你可以使用姓名 [name]、名字 [fname] 或者姓氏 [lname] 作为用户的全名。<br />你可以使用 [email] 作为用户的 E-mail。","Accounts_Iframe_api_method":"Api方法","Accounts_Iframe_api_url":"Api Url","Accounts_iframe_enabled":"已启用","Accounts_iframe_url":"iframe URL","Accounts_LoginExpiration":"登录失效事件","Accounts_ManuallyApproveNewUsers":"手动审核新用户","Accounts_OAuth_Custom_Token_Sent_Via":"令牌通过发送","Accounts_OAuth_Custom_Authorize_Path":"自定义 OAuth 的认证地址 ","Accounts_OAuth_Custom_Button_Color":"自定义 OAuth 登录底部颜色","Accounts_OAuth_Custom_Button_Label_Color":"自定义 OAuth 登录底部文字颜色","Accounts_OAuth_Custom_Button_Label_Text":"自定义 OAuth 底部文字","Accounts_OAuth_Custom_Enable":"启用自定义 OAuth","Accounts_OAuth_Custom_id":"ID","Accounts_OAuth_Custom_Identity_Path":"自定义 OAuth 帐号证书路径","Accounts_OAuth_Custom_Login_Style":"登录样式","Accounts_OAuth_Custom_Secret":"自定义 OAuth 帐号密钥","Accounts_OAuth_Custom_Token_Path":"自定义 OAuth token 地址","Accounts_OAuth_Custom_URL":"自定义 OAuth 帐号 URL","Accounts_OAuth_Facebook":"Facebook OAuth 登录","Accounts_OAuth_Facebook_callback_url":"Facebook 回调 URL","Accounts_OAuth_Facebook_id":"Facebook 应用程序 ID","Accounts_OAuth_Facebook_secret":"Facebook Secret","Accounts_OAuth_Github":"启用 OAuth 登录","Accounts_OAuth_Github_callback_url":"Github 回调 URL","Accounts_OAuth_GitHub_Enterprise":"已启用 GitHub 企业帐号登录","Accounts_OAuth_GitHub_Enterprise_callback_url":"GitHub 企业版回调 URL","Accounts_OAuth_GitHub_Enterprise_id":"客户端 ID","Accounts_OAuth_GitHub_Enterprise_secret":"客户端 Secret","Accounts_OAuth_Github_id":"客户端 ID","Accounts_OAuth_Github_secret":"客户端密钥","Accounts_OAuth_Gitlab":"启用 GitLab OAuth 登录","Accounts_OAuth_Gitlab_callback_url":"GitLab 回调 URL","Accounts_OAuth_Gitlab_id":"GitLab ID","Accounts_OAuth_Gitlab_secret":"GitLab OAuth 客户端密钥","Accounts_OAuth_Google":"使用 Google 帐号登录","Accounts_OAuth_Google_callback_url":"Google 回调 URL","Accounts_OAuth_Google_id":"Google ID","Accounts_OAuth_Google_secret":"Google 密钥","Accounts_OAuth_Linkedin":"LinkedIn 帐号登录","Accounts_OAuth_Linkedin_callback_url":"Linkedin 回调 URL","Accounts_OAuth_Linkedin_id":"LinkedIn ID","Accounts_OAuth_Linkedin_secret":"LinkedIn 密钥","Accounts_OAuth_Meteor":"Meteor 帐号登录","Accounts_OAuth_Meteor_callback_url":"Meteor 回调 URL","Accounts_OAuth_Meteor_id":"Meteor ID","Accounts_OAuth_Meteor_secret":"Meteor 密钥","Accounts_OAuth_Twitter":"Twitter 帐号登录","Accounts_OAuth_Twitter_callback_url":"Twitter 回调 URL","Accounts_OAuth_Twitter_id":"Twitter ID","Accounts_OAuth_Twitter_secret":"Twitter 密钥","Accounts_OAuth_Wordpress":"WordPress 帐号登录","Accounts_OAuth_Wordpress_callback_url":"Wordpress 回调 URL","Accounts_OAuth_Wordpress_id":"WordPress ID","Accounts_OAuth_Wordpress_secret":"WordPress Secret","Accounts_PasswordReset":"重置密码","Accounts_Registration_AuthenticationServices_Enabled":"使用认证服务注册","Accounts_RegistrationForm":"注册表单","Accounts_RegistrationForm_Disabled":"已禁用","Accounts_RegistrationForm_LinkReplacementText":"注册表单链接的文字标题","Accounts_RegistrationForm_Public":"公开","Accounts_RegistrationForm_Secret_URL":"私密地址","Accounts_RegistrationForm_SecretURL":"私密注册表单 ","Accounts_RegistrationForm_SecretURL_Description":"必须提供一个随机的字符串，该字符串将添加到你的注册URL中，例如：https://demo.rocket.chat/register/[secret_hash]","Accounts_RegistrationRequired":"需要注册","Accounts_RequireNameForSignUp":"需要填写姓名才能注册","Accounts_ShowFormLogin":"限制登录表单","Accounts_UseDefaultBlockedDomainsList":"使用默认的屏蔽域名列表","Accounts_UseDNSDomainCheck":"使用 DNS 域名验证","Activate":"激活","Activity":"活动","Add":"添加","Add_agent":"添加客服","Add_custom_oauth":"添加自定义 OAuth ","Add_manager":"添加管理员","Add_Members":"加入成员","Add_User":"添加用户","Add_user":"新增用户","Add_users":"添加用户","Additional_emails":"其它 E-mail 地址","Additional_Feedback":"其它反馈","Administration":"管理","After_OAuth2_authentication_users_will_be_redirected_to_this_URL":"通过 OAuth2 认证后，用户页面将重定向至此 URL","Agent_added":"已添加客服","Agent_removed":"已删除客服","Alias":"别名","All":"全部","All_channels":"所有频道","All_logs":"所有日志","All_messages":"所有信息","Allow_Invalid_SelfSigned_Certs":"允许无效的自签名SSL证书进行链路验证和预览","Allow_Invalid_SelfSigned_Certs_Description":"允许验证和预览 SSL 证书无效或自签名的链接。","and":"和","And_more":"以及其它 __length__ 条……","Animals_and_Nature":"动物与自然","API":"API","API_Analytics":"分析","API_Embed":"嵌入","API_EmbedDisabledFor":"禁止用户嵌入使用","API_EmbedDisabledFor_Description":"以逗号分隔的用户名列表","API_GitHub_Enterprise_URL":"GitHub 企业版地址","API_GitHub_Enterprise_URL_Description":"例如：http://domain.com （不需要结尾的斜线）","API_Gitlab_URL":"GitLab URL","API_Wordpress_URL":"WordPress API URL","Appearance":"外观","Application_added":"已添加应用","Application_Name":"应用名称","Application_updated":"已更新应用","Apply_and_refresh_all_clients":"应用和刷新所有客户端","Archive":"归档","Archive_Unarchive":"归档/取消归档","are_also_typing":"也正在输入","are_typing":"正在输入","Are_you_sure":"你确定吗？","Are_you_sure_you_want_to_delete_your_account":"确定要删除你的帐号吗？","Authorization_URL":"Authorization URL","Authorize":"授权","AutoLinker_StripPrefix":"AutoLinker带前缀","AutoLinker_StripPrefix_Description":"简短的显示。如https://rocket.chat => rocket.chat","AutoLinker_Urls":"AutoLinker网址","AutoLinker_UrlsRegExp":"AutoLinker URL正则表达式","AutoLinker_Email":"AutoLinker电子邮件","AutoLinker_Phone":"AutoLinker电话","AutoLinker_Phone_Description":"自动链接电话号码。比如`（123）456-7890`","Auto_Load_Images":"自动载入图片","Available":"可用的","Available_agents":"空闲客服","Avatar":"更改头像","Avatar_changed_successfully":"头像更新成功","Avatar_URL":"头像地址","Avatar_url_invalid_or_error":"您提供的 URL 无效，请使用不用的 URL 重试一次。","away":"离开","Away":"离开","away_female":"离开","Away_female":"离开","away_male":"离开","Away_male":"离开","Back":"返回","Back_to_applications":"返回应用","Back_to_integrations":"返回集成页","Back_to_login":"返回登录界面","Back_to_permissions":"返回权限页","Body":"主体","bold":"粗体","busy":"忙","Busy":"忙","busy_female":"忙碌","Busy_female":"忙碌","busy_male":"忙碌","Busy_male":"忙碌","Cancel":"取消","Cannot_delete_a_protected_role":"禁止删除受保护的角色","Cannot_delete_role_because_its_in_use":"禁止删除该角色，因为它正在使用中","Cannot_invite_users_to_direct_rooms":"不能邀请用户加入私聊房间","CDN_PREFIX":"CDN 前缀","Certificates_and_Keys":"证书和密钥","Channel":"频道","Channel_doesnt_exist":"不存在 `#%s` 频道。","Channels":"频道","Channels_list":"公共频道列表","Chat_Rooms":"聊天室","Chatops_Enabled":"启用视频会议","Chatops_Title":"视频会议面版","Chatops_Username":"视频会议用户名","Choose_a_room":"选择一个房间","Choose_messages":"选择信息","Choose_the_alias_that_will_appear_before_the_username_in_messages":"选择将在消息中的用户名前出现的别名。","Choose_the_username_that_this_integration_will_post_as":"选择该集成工具以什么用户名身份发布信息","Clear_all_unreads_question":"清除所有未读标记？","Client_ID":"客户端 ID","Client_Secret":"客户端密钥","Clients_will_refresh_in_a_few_seconds":"客户端将在几秒钟刷新","close":"关闭","Closed":"已关闭","Collapse_Embedded_Media_By_Default":"关闭默认的嵌入式媒体","coming_soon":"即将推出","Commands":"指令","Compact_View":"预览","Confirm_password":"确认密码","Contact":"联系人","Conversation":"谈话","Convert_Ascii_Emojis":"自动识别文字中的表情","Copied":"复制","COPY_TO_CLIPBOARD":"复制到剪贴板","Copy_to_clipboard":"复制到剪贴板","Count":"计数","Create":"创建","Create_new":"新建","Created_at":"创建于","Created_at_s_by_s":"创建于 <strong>%s</strong>，创建者 <strong>%s</strong>","Custom_Fields":"自定义字段","Custom_oauth_helper":"设置完 OAuth 提供者之后，你还需要设置回调 URL。请使用 <pre>%s</pre>。","Custom_oauth_unique_name":"自定义 OAuth 唯一名称 ","Custom_Script_Logged_In":"为已登录用户准备的自定义脚本","Custom_Script_Logged_Out":"为已登出用户准备的自定义脚本","Dashboard":"控制面板","days":"天","Deactivate":"禁用","Debug_Level":"调试级别","Default":"默认","Delete":"删除","Delete_my_account":"删除我的帐号","Delete_Room_Warning":"删除房间会同时删除房间内的所有信息并不可恢复。","Delete_User_Warning":"删除用户将删除该用户的所有消息。这不能被撤消。","Deleted":"已删除！","Department_not_found":"不存在该部门","Department_removed":"部门已删除","Departments":"部门","Description":"描述","Desktop":"桌面","Desktop_Notification_Test":"桌面通知测试","Desktop_Notifications":"桌面通知","Desktop_Notifications_Disabled":"桌面通知被禁用。如需要桌面通知请修改浏览器设置。","Desktop_Notifications_Enabled":"已启用桌面通知","Direct_message_someone":"来自某人的直接信息","Direct_Messages":"直接发送消息","Direct_Messages_list":"私聊","Disable_Favorite_Rooms":"禁用最喜爱的房间功能","Disable_New_Message_Notification":"禁用新消息通知","Disable_New_Room_Notification":"禁用新房间通知","Displays_action_text":"显示动作文字","Do_you_want_to_change_to_s_question":"你是否是想改为<strong>%s</strong>？","Drop_to_upload_file":"拖放上传","Dry_run":"发送测试","Dry_run_description":"表单中的 E-mail 都只会收到一封邮件。邮件必须对应有效用户。","Duplicate_archived_channel_name":"已存在名为“%s”的归档频道","Duplicate_archived_private_group_name":"已存在名为“%s”的私有组","Duplicate_private_group_name":"私有组 '%s' 已存在","E-mail":"电子邮件","Edit":"编辑","Edit_Custom_Field":"编辑自定义字段","Edit_Department":"编辑部门信息","edited":"已编辑","Email":"E-mail","Email_already_exists":"邮件已存在","Email_body":"E-mail 正文","Email_Change_Disabled":"Rocket.Chat 管理员已禁止修改邮件","Email_from":"从","Email_Notification_Mode":"离线邮件信息","Email_Notification_Mode_All":"所有提及／直接提及","Email_Notification_Mode_Disabled":"已禁用","Email_or_username":"电子邮件或用户名","Email_subject":"E-mail 标题","Email_verified":"邮箱已验证","Emoji":"颜文字","Empty_title":"空标题","Enable":"启用","Enable_Desktop_Notifications":"启用桌面通知","Enabled":"已启用","Encrypted_message":"加密的消息","End_OTR":"结束“无记录对话”","Enter_a_regex":"输入正则表达式","Enter_a_room_name":"请在这里输入房间名","Enter_a_username":"请输入用户名","Enter_info":"输入您的信息","Enter_name_here":"请在这里输入名字","Enter_to":"进入","Error":"错误","error-cant-invite-for-direct-room":"不能邀请用户直接房","error-duplicate-channel-name":"频道 '%s' 已存在","error-invalid-custom-field":"无效的自定义字段","error-invalid-custom-field-name":"无效的自定义字段名称。只能使用字母，数字，连字符和下划线。","error-invalid-password":"无效的密码","error-invalid-room":"房间无效","error-invalid-room-name":"<strong>%s</strong>不是合法的房间名，<br>仅可以使用字母、数字以及下划线","error-invalid-user":"无效的用户","error-invalid-username":"无效的用户名","error-not-allowed":"不允许","error-not-authorized":"未经授权","error-remove-last-owner":"这是最后的主人。请删除此人之前设置一个新的所有者。","error-role-name-required":"请输入角色名","error-user-not-in-room":"用户不是在这个房间","Error_changing_password":"密码更改失败","Error_sending_confirmation_email":"发送确认邮件出错","Error_too_many_requests":"发生错误：请求过多。请平静下来 %s 秒后重试","Esc_to":"退出","Example_s":"例如：<code class=\"inline\">%s</code>","False":"否","Favorites":"收藏","Field":"领域","Field_removed":"现场拆除","File_exceeds_allowed_size_of_bytes":"文件大小超过 __size__ bytes","FileUpload":"文件上传","FileUpload_Enabled":"已启用文件上传","FileUpload_File_Empty":"文件为空","FileUpload_FileSystemPath":"系统路径","FileUpload_MaxFileSize":"文件上传大小限制（以字节为单位）","FileUpload_MediaType_NotAccepted":"不支持该类型媒体文件","FileUpload_MediaTypeWhiteList":"支持的媒体类型","FileUpload_MediaTypeWhiteListDescription":"以逗号分隔媒体类型列表。如需要允许所有类型请留空。","FileUpload_ProtectFiles":"保护上传的文件","FileUpload_ProtectFilesDescription":"只有已登录的用户才可以访问","FileUpload_S3_Acl":"Amazon S3 acl","FileUpload_S3_AWSAccessKeyId":"Amazon S3 AWSAccessKeyId","FileUpload_S3_AWSSecretAccessKey":"Amazon S3 AWSSecretAccessKey","FileUpload_S3_Bucket":"Amazon S3 bucket name","FileUpload_S3_BucketURL":"Bucket URL","FileUpload_S3_CDN":"下载用CDN域名","FileUpload_S3_Region":"Region","FileUpload_Storage_Type":"存储类型","Flags":"旗帜","Follow_social_profiles":"关注我们的社交资讯，fork我们在github的项目或者在trello上分享你关于rocket.chat的想法。","Food_and_Drink":"饮食","For_your_security_you_must_re_enter_your_password_to_continue":"出于安全原因，请重新输入您的密码以继续","Force_SSL":"强制 SSL","Force_SSL_Description":"*注意！* _Force SSL_不应该与反向代理使用。如果你有一个反向代理，你如果真有这样做的重定向。这个选项存在像Heroku的，不允许在反向代理重定向配置部署。","Forgot_password":"忘记密码","Fork_it_on_github":"在Github上Fork它","Frequently_Used":"常用","From":"来自于","From_Email":"从电子邮件","From_email_is_required":"From 字段是必填项","From_email_warning":"<b>警告</b>：<b>From</b>字段来自于邮件服务器的设置。","General":"通用","Get_to_know_the_team":"结识 Rocket.Chat 团队","github_no_public_email":"在您的GitHub上帐户中，您没有设置任何电子邮件作为公共电子邮件地址。","Give_a_unique_name_for_the_custom_oauth":"请给自定义 OAuth 设置一个唯一的名称","Give_the_application_a_name_This_will_be_seen_by_your_users":"设置应用名称，这将对你的用户可见。","Global":"全球","GoogleTagManager_id":"Google Tag Manager ID","Has_more":"有更多","Have_your_own_chat":"拥有自己的网络聊天。对于希望建立和发展自己的聊天平台的开发者而言，使用Meteor开发的Rocket.Chat是优秀的解决方案。","Header":"头","Hidden":"已隐藏","Hide_Group_Warning":"确定隐藏用户组“%s”？","Hide_Private_Warning":"确定隐藏和“%s”的会话？","Hide_room":"隐藏聊天室","Hide_Room_Warning":"确认隐藏房间“%s”？","Highlights":"高亮","Highlights_How_To":"当其他人发出的消息中包含此处的关键词时，你会收到提醒。请使用逗号分隔多个关键词。不区分大小写。","Highlights_List":"高亮词语","History":"历史","hours":"小时","How_friendly_was_the_chat_agent":"在线客服的友善度如何？","How_knowledgeable_was_the_chat_agent":"在线客服的知识储备如何","How_responsive_was_the_chat_agent":"在线客服的反应速度如何？","How_satisfied_were_you_with_this_chat":"您是否满意这次聊天？","If_you_are_sure_type_in_your_password":"请输入您的密码以确认：","If_you_are_sure_type_in_your_username":"如果您确定键入您的用户名：","Importer_Archived":"已归档","Importer_done":"已完成导入！","Importer_finishing":"导入即将完成。","Importer_From_Description":"将 __from__ 数据导入 Rocket.Chat。","Importer_import_cancelled":"已取消导入","Importer_import_failed":"导入过程中发生错误！","Importer_importing_channels":"导入频道。","Importer_importing_messages":"倒入信息。","Importer_importing_started":"开始导入。","Importer_importing_users":"导入用户。","Importer_not_defined_properly":"导入所用帐号错误，未指定导入class。","Importer_not_in_progress":"导入工具没有正常运行。","Importer_Prepare_Restart_Import":"重新导入","Importer_Prepare_Start_Import":"开始导入","Importer_Prepare_Uncheck_Archived_Channels":"取消选中已归档的频道","Importer_Prepare_Uncheck_Deleted_Users":"取消选中已删除的用户","Importer_progress_error":"无法获得进口进度。","Importer_setup_error":"设置导入工具时发生了错误。","Incorrect_Password":"密码错误","inline_code":"inline_code","Install_Extension":"安装扩展程序","Install_FxOs":"在火狐浏览器中安装 Rocket.Chat","Install_FxOs_done":"干得漂亮！你现在只需要点击桌面上的图标就可以使用 Rocket.Chat。祝您使用愉快！","Install_FxOs_error":"抱歉，和预期的优点不一样！出现了下面的错误：","Install_FxOs_follow_instructions":"请在设备上确认安装应用（根据提示点击“安装”）","Installation":"安装","Integration_added":"已添加该集成功能","Integration_Incoming_WebHook":"即将支持的 WebHook 集成","Integration_New":"新的功能集成","Integration_Outgoing_WebHook":"即将离任的网络挂接整合","Integration_updated":"已更新该集成功能","Integrations":"集成功能","Invalid_asset":"无效数据","Invalid_confirm_pass":"第二次密码输入与第一次不匹配","Invalid_email":"无效的电子邮件","Invalid_Export_File":"上传的文件不是有效的导出文件。","Invalid_file_height":"无效的文件高度","Invalid_file_type":"无效的文件类型","Invalid_file_width":"无效的文件宽度","Invalid_Import_File_Type":"无效的导入文件类型。","Invalid_name":"用户名不能为空","Invalid_notification_setting_s":"无效的通知设置：%s","Invalid_pass":"密码不能为空","Invalid_room_name":"<strong>%s</strong>不是一个有效的聊天室名称， <br/>只能使用字母，数字，.和_","Invalid_room_type":"<strong>%s</strong>不是一个有效的房间名。","Invalid_Secret_URL":"无效的密钥 URL","Invalid_secret_URL_message":"URL 无效。","invisible":"隐身","Invisible":"隐身","Invitation_HTML":"邀请邮件HTML","Invitation_Subject":"邀请邮件主题","Invite_user_to_join_channel":"邀请一位用户加入频道","Invite_Users":"邀请用户","is_also_typing":"也正在输入","is_also_typing_female":"正在输入","is_also_typing_male":"正在输入","is_typing":"正在输入","is_typing_female":"正在输入","is_typing_male":"正在输入","italics":"斜体","join":"加入","Join_audio_call":"加入音频对话","Join_the_Community":"加入社区","Join_the_given_channel":"加入该频道","Join_video_call":"加入视频会话","Joined":"已加入","Jump":"跳转","Jump_to_first_unread":"跳到第一条未读信息","Jump_to_message":"跳转至信息","Jump_to_recent_messages":"跳转至最近信息","Katex_Enabled":"已启用 Katex","Label":"标签","Language":"语言","Language_Version":"英语版本","Last_login":"上次登录","Last_message":"最新消息","Last_seen":"上次遇见","Layout":"布局","Layout_Home_Body":"首页正文","Layout_Home_Title":"首页标题","Layout_Login_Terms":"登录条款","Layout_Privacy_Policy":"隐私政策","Layout_Sidenav_Footer":"侧面导航页脚","Layout_Sidenav_Footer_description":"页脚大小为 260 x 70px","Layout_Terms_of_Service":"服务条款","LDAP":"LDAP","LDAP_CA_Cert":"CA 证书","LDAP_Custom_Domain_Search":"自定义域搜索条件","LDAP_Custom_Domain_Search_Description":"这样管理信息绑定和连接的 JSON 数据：<br/> <code>{\"filter\": \"(&(objectCategory=person)(objectclass=user)(memberOf=CN=ROCKET_ACCESS,CN=Users,DC=domain,DC=com)(sAMAccountName=#{username}))\", \"scope\": \"sub\", \"userDN\": \"rocket.service@domain.com\", \"password\": \"urpass\"}</code>","LDAP_Default_Domain":"默认域名","LDAP_Description":"LDAP(轻量目录访问协议)是一种层次数据库，常被企业用于提供单点登录机制——该机制允许用户使用同一套帐号密码登录多个网站或服务。想要了解LDAP认证的设置及示例，可参考我们的wiki页： https://github.com/RocketChat/Rocket.Chat/wiki/LDAP-Authentication","LDAP_Dn":"LDAP DN","LDAP_Domain_Base":"基础域","LDAP_Domain_Base_Description":"请填写有效的 DN 作为基础域（Domain Base），以便在该DN指向的 LDAP 子树中检索用户和组。您可添加多个DN，但组与组内用户必须定义在同一个基础域中。若您限定了某些 DN 作为基础域，则只能检索到这些DN下的用户。建议使用 LDAP 中的顶级目录作为基础域，配合下面的“自定义域搜索”筛选条件来进行用户的限制。","LDAP_Domain_Search_Filter":"筛选条件","LDAP_Domain_Search_Filter_Description":"若在此处指定了筛选条件，则仅有符合条件的用户方可登录。若为指定筛选条件，则 domain base 中的所有用户均可登录。<br/>举例：<br/>Windows AD域 `memberOf=cn=ROCKET_CHAT,ou=General Groups`。<br/>OpenLDAP (extensible match search) `ou:dn:=ROCKET_CHAT`。","LDAP_Domain_Search_Object_Category":"检索用户所用的objectCategory ","LDAP_Domain_Search_Object_Category_Description":"请输入 LDAP 中用以识别用户的*objectCategory*。<br/>若使用 *OpenLDAP* 则此项留空。<br/>举例：对于Windows AD，常用分类为`person`。","LDAP_Domain_Search_Object_Class":"检索用户所用的objectclass","LDAP_Domain_Search_Object_Class_Description":"请输入 LDAP 中用以识别用户的*objectclass*。<br/>例如：`user`，`organizationalPerson`，`inetOrgPerson`等。","LDAP_Domain_Search_Password":"域管理员密码","LDAP_Domain_Search_Password_Description":"域管理员登录 LDAP 的密码","LDAP_Domain_Search_User":"域管理员","LDAP_Domain_Search_User_Description":"该LDAP用户将在其他用户登录时被用于在 LDAP 中执行检索和认证。<br/>通常情况下，该用户是在 LDAP 中特地为第三方集成而创建的帐号。请使用有效的全名，如`cn=Administrator,cn=Users,dc=Example,dc=com`。","LDAP_Domain_Search_User_ID":"帐号认证字段","LDAP_Domain_Search_User_ID_Description":"该 LDAP 属性是用于识别登录者的字段。对于 Windows AD，通常应使用 `sAMAccountName` 字段，而其他 LDAP 方案（如 OpenLDAP）可能使用 `uid` 字段。假如要使用邮箱地址作为帐号，可使用 `mail` 之类的字段。<br>若要同时使用多种认证字段，可通过逗号分隔字段名。<br>举例：若要同时使用用户名和邮箱作为认证帐号，可使用`sAMAccountName,mail`。","LDAP_Enable":"启用 LDAP","LDAP_Enable_Description":"使用 LDAP 认证","LDAP_Encryption":"加密方法","LDAP_Encryption_Description":"请指定与 LDAP 服务器通信时，使用何种加密方法。可选方法包括：`不使用加密`，`SSL/LDAPS`（全程启用加密）和`StartTLS`（建立连接后启用加密）","LDAP_Host":"LDAP 服务器","LDAP_Host_Description":"LDAP服务器的域名或 IP，如 `ldap.example.com` 或 `10.0.0.30`。","LDAP_Port":"LDAP 端口","LDAP_Port_Description":"LDAP 端口。比如：`389` 或 `636`","LDAP_Reject_Unauthorized":"拒绝认证","LDAP_Sync_User_Avatar":"同步用户头像","LDAP_Sync_User_Data":"同步数据","LDAP_Sync_User_Data_Description":"登录时保持用户数据和服务器同步（比如：姓名、E-mail）。","LDAP_Sync_User_Data_FieldMap":"用户数据字段映射","LDAP_Sync_User_Data_FieldMap_Description":"设置用户数据字段（比如 E-mail）来自 LDAP 何处（如果能找到）。 <br/>；例如：`{\"cn\":\"name\", \"mail\":\"email\"}` 会从属性 cn 中取出名字字段，从 mail 属性中取出 email 字段。<br/>有效字段包括 `name` 和 `email`。","LDAP_Sync_Users":"同步用户","LDAP_Test_Connection":"测试连接","LDAP_Unique_Identifier_Field":"唯一识别字段","LDAP_Unique_Identifier_Field_Description":"使用哪个字段来连接 LDAP 和 Rocket.Chat 的用户信息。可使用逗号分隔的多个字段。<br/>默认值： `objectGUID,ibm-entryUUID,GUID,dominoUNID,nsuniqueId,uidNumber`","LDAP_Use_Custom_Domain_Search":"使用自定义的域搜索","LDAP_Use_Custom_Domain_Search_Description":"请输入在 LDAP 服务器中搜索用户时的筛选条件","LDAP_Username_Field":"用户名字段","LDAP_Username_Field_Description":"指定新用户登录时，使用 LDAP 中哪个字段的值作为*用户名*。若要使用登录页面所用的用户名，请留空。<br/>可使用模版标签，比如 `#{givenName}.#{sn}`。<br/>默认字段为 `sAMAccountName`。","Leave_Group_Warning":"确定要离开用户组“%s”吗？","Leave_Private_Warning":"确定要结束和“%s”的讨论吗？","Leave_room":"离开聊天室","Leave_Room_Warning":"确定要离开“%s”房间吗？","line":"线","List_of_Direct_Messages":"直接对话列表","Live_sessions":"在线会话","Livechat_agents":"在线客服","Livechat_Dashboard":"在闲客服控制面板","Livechat_enabled":"即时聊天启用","Livechat_Manager":"在线聊天管理员","Livechat_managers":"在线聊天管理员","Livechat_title":"在线聊天标题","Livechat_title_color":"在线聊天标题背景色","Livechat_Users":"在线聊天用户","Load_more":"加载更多","Loading...":"加载中...","Loading_more_from_history":"加载更多","Loading_suggestion":"载入建议中...","Localization":"本地化","Log_File":"显示文件和行数","Log_Level":"日志等级","Log_Package":"日志包","Log_View_Limit":"日志展示上限","Logged_out_of_other_clients_successfully":"成功取消其它设备登录状态","Login":"登录","Login_with":"使用 %s 登录","login_with":"或直接登录使用","Logout":"退出","Logout_Others":"取消其它设备登录状态","Mail_Message_Invalid_emails":"你需要提供至少一个有效邮件地址：%s","Mail_Message_Missing_to":"必须选中一个以上的用户，或者提供一个以上的邮箱地址（邮箱地址之间使用逗号分隔）。","Mail_Message_No_messages_selected_select_all":"未选中任何消息。是否需要 <a href='#' class='select-all'>全选</a>可见的消息？","Mail_Messages":"发送邮件","Mail_Messages_Instructions":"点击以选择您希望通过邮件发送的消息","Mail_Messages_Subject":"%s 条消息中的一部分","Mailer":"发件人","Mailer_body_tags":"你<b>必须</b>使用 [unsubscribe] 作为取消订阅的链接。<br >你可以使用 [name]、[fname] 和 [lname] 作为用户全名。<br>你可以使用 [email] 用作用户的 E-mail。","Make_Admin":"设置为管理员","Manager_added":"已添加管理员","Manager_removed":"已删除管理员","Mark_as_read":"标记为已读","Markdown_Headers":"Markdown 标题","Markdown_SupportSchemesForLink":"对于链接降价支援计划","Markdown_SupportSchemesForLink_Description":"允许计划的逗号分隔列表","Members_List":"成员列表","Mentions":"提及","Mentions_default":"通知（默认）","Message":"消息","Message_AllowDeleting":"允许删除消息","Message_AllowEditing":"允许编辑消息","Message_AllowEditing_BlockEditInMinutes":"允许编辑（n）分钟内发布的消息","Message_AllowEditing_BlockEditInMinutesDescription":"禁用屏蔽功能请输入 0","Message_AllowPinning":"允许信息固定","Message_AllowPinning_Description":"允许信息固定在频道顶部。","Message_AllowStarring":"允许标记信息","Message_AudioRecorderEnabled":"启用音频录制","Message_AudioRecorderEnabledDescription":"需要在“文件上传”中设置“audio/wav”为可接受媒体类型。","Message_DateFormat":"日期格式","Message_deleting_not_allowed":"不允许删除消息","Message_editing_blocked":"该信息已不允许再被编辑","Message_editing_not_allowed":"不允许编辑消息","Message_GroupingPeriod":"合并多长时间内的信息（以秒为单位）","Message_GroupingPeriodDescription":"同一用户规定秒数内发表的信息将被合并。","Message_KeepHistory":"保存消息历史记录","Message_MaxAllowedSize":"消息最大允许大小","Message_MaxAll":"為ALL的消息最大通道尺寸","Message_pinned":"已固定的信息","Message_pinning_not_allowed":"禁止信息固定","Message_removed":"消息已删除","Message_ShowDeletedStatus":"显示删除状态","Message_ShowEditedStatus":"显示编辑状态","Message_ShowFormattingTips":"显示格式化秘诀","Message_TimeFormat":"时间格式","Message_TimeFormat_Description":"参见： <a href=\"http://momentjs.com/docs/#/displaying/format/\" target=\"momemt\">Moment.js</a>","Message_too_long":"消息过长","Messages":"信息","Messages_that_are_sent_to_the_Incoming_WebHook_will_be_posted_here":"发送到输入钩子（Incoming WebHook）的消息会发布到这里","Meta":"Meta","Meta_fb_app_id":"Facebook 应用 ID","Meta_google-site-verification":"谷歌网站验证","Meta_language":"语言","Meta_msvalidate01":"MSValidate.01","Meta_robots":"机器人","minutes":"分钟","Mobile_push":"移动端推送","More_channels":"更多频道","More_direct_messages":"更多对话","More_groups":"更多私有组","More_unreads":"更多未阅读","Msgs":"消息","multi":"多","Mute_someone_in_room":"禁止房间中的某人发言","Mute_user":"禁止用户发言","Muted":"已禁止发言","My_Account":"我的账户","n_messages":"%s 条消息","N_new_messages":"%s 条新消息","Name":"名字","Name_cant_be_empty":"名字不可以为空","Name_of_agent":"客服的名称","Name_optional":"名称（可选）","Navigation_History_20_last_pages":"导航历史（最近 20 页）","New_Application":"新应用","New_Custom_Field":"新的自定义字段","New_Department":"新部门","New_integration":"新的集成功能","New_logs":"新日志","New_messages":"新消息","New_password":"新密码","New_role":"新角色","No_channel_with_name_%s_was_found":"未找到频道 <strong>\"%s\"</strong> !","No_channels_yet":"您尚未加入这个频道。","No_direct_messages_yet":"您还没有开始任何聊天。","No_Encryption":"未使用加密","No_favorites_yet":"您还没有添加任何收藏。","No_group_with_name_%s_was_found":"未找到私有组 <strong>\"%s\"</strong> !","No_groups_yet":"你还没有私有组。","No_livechats":"你没有任何在线聊天会话","No_mentions_found":"没有发现任何提及","No_permission_to_view_room":"您没有权限访问这个聊天室","No_pinned_messages":"未固定的信息","No_results_found":"无结果","No_starred_messages":"未标记的信息","no_tokens_for_this_user":"该用户没有相应 token","No_user_with_username_%s_was_found":"未找到用户 <strong>\"%s\"</strong> !","Not_allowed":"不允许","Not_authorized":"为认证","Not_Available":"不可用","Not_found_or_not_allowed":"未找到或者不允许","Nothing":"什么也没有","Nothing_found":"没有找到","Notifications":"通知","Notify_all_in_this_room":"提醒房间中的所有人","Num_Agents":"# 客服","Number_of_messages":"消息条数","OAuth_Application":"OAuth 应用","OAuth_Applications":"OAuth 应用","Objects":"物件","Off_the_record_conversation":"“无记录对话”","Off_the_record_conversation_is_not_available_for_your_browser_or_device":"您的浏览器或设备不支持“无记录对话”。","Offline_DM_Email":"[__site__] __user__ 请求和你直接对话","Offline_Mention_Email":"[__site__] __user__ 在房间 #__room__ 中提到了你","Old_and_new_password_must_be_different":"新密码不可以和旧密码相同。","Old_and_new_password_required":"你需要同时提供新、旧密码才能够修改密码。","Online":"在线","Only_errors":"仅错误","Only_you_can_see_this_message":"只有你能看到这条信息","Oops!":"哎呀","Open":"打开","Opened":"已开启","Opt_out_statistics":"不要发送我的统计信息到","Opt_out_statistics_warning":"发送你的统计数据以便我们了解 Rocket.Chat 的部署情况，包括实例部署数量、运行情况等，这些数据有助于我们进一步改进 Rocket.Chat。别担心， 此过程不收集任何用户信息，你发送的统计信息将会得到保密。如果你仍然愿意向我们发送统计数据，请取消选中上面的复选框。谢谢。","optional":"可选","Order":"订购","OS_Arch":"OS 架构","OS_Cpus":"OS CPU 总数 ","OS_Freemem":"OS 空闲内存 ","OS_Loadavg":"平均负载","OS_Platform":"OS 平台 ","OS_Release":"OS 发行版 ","OS_Totalmem":"OS 内存总量","OS_Type":"OS 类型","OS_Uptime":"OS 启动时间","others":"其它","OTR":"无记录对话","OTR_is_only_available_when_both_users_are_online":"仅当双方均在线时才可以开启“无记录对话”","Override_URL_to_which_files_are_uploaded_This_url_also_used_for_downloads_unless_a_CDN_is_given":"重写 URL 为文件上传地址。如果没有设置 CDN，url 也会被当作下载链接。","Password":"密码","Password_Change_Disabled":"Rocket.Chat 禁止了修改密码功能。 ","Password_changed_successfully":"密码更改成功","Payload":"有效载荷","People":"用户","Permissions":"权限","Pin_Message":"固定信息","Pinned_a_message":"已固定信息：","Pinned_Messages":"已固定的信息","Placeholder_for_email_or_username_login_field":"登录窗 E-mail 或用户的占位符","Placeholder_for_password_login_field":"登录窗中密码的占位符","Please_answer_survey":"请花费几分钟来反馈这次交谈的体验","Please_enter_value_for_url":"请输入头像的 URL。","Please_enter_your_new_password_below":"请在下方输入新密码：","Please_fill_a_label":"请填写标签","Please_fill_a_name":"请填写名字","Please_fill_a_username":"请填写用户名","Please_fill_name_and_email":"请填写姓名和 E-mail","Please_re_enter_your_password":"请重新弄输入密码","Please_select_enabled_yes_or_no":"请选择要启用的项","Please_wait":"请稍候","Please_wait_activation":"请稍候，这可能需要一些时间。","Please_wait_statistics":"请稍等，正在生成统计数据。","Please_wait_while_OTR_is_being_established":"请稍候，正在建立 OTR 连接","Please_wait_while_your_account_is_being_deleted":"您的帐号正被删除，请稍候……","Please_wait_while_your_profile_is_being_saved":"请稍候，正在保存您的信息","Post_as":"以该身份发送","Post_to_Channel":"向该频道发送","Post_to_s_as_s":"向 <strong>%s</strong> 推送，以 <strong>%s</strong> 的身份","Powered_by":"Powered by","Preferences":"偏好设置","Preferences_saved":"偏好设置已保存","Privacy":"隐私条款","Private_Group":"私有组","Private_Groups":"私有组","Private_Groups_list":"私有组列表","Profile":"资料","Profile_saved_successfully":"资料保存成功","Proudly_developed":"使用 Meteor 开发","Push":"推送","Push_apn_cert":"APN 证书","Push_apn_dev_cert":"APN Dev 证书 ","Push_apn_dev_key":"APN Dev 密钥","Push_apn_dev_passphrase":"APN Dev 口令","Push_apn_key":"APN 密钥","Push_apn_passphrase":"APN 密码短语","Push_debug":"调试","push_disabled":"已禁用推送","Push_enable":"启用","Push_enable_gateway":"启用 Gateway","Push_gateway":"Gateway","Push_gcm_api_key":"GCM API key","Push_gcm_project_number":"GCM 项目数字","Push_production":"生产","Push_show_message":"在通知中显示信息","Push_show_username_room":"在通知中显示频道/群组/用户名","Push_test_push":"测试推送","Query":"请求","Query_description":"决定向哪些用户发送电子邮件的其它选项。取消订阅的用户会自动从请求中删除。这必须是有效的 JSON 数据，例如：`{\"createdAt\":{\"$gt\":{\"$date\": \"2015-01-01T00:00:00.000Z\"}}}`。","Quick_Search":"快速搜索","quote":"引用","Reactions":"反应","Recents":"最近","Record":"开始录制","Redirect_URI":"跳转 URI","Refresh_keys":"刷新 key","Refresh_your_page_after_install_to_enable_screen_sharing":"安装完成后需要刷新页面才能支持屏幕共享","Register":"注册一个新帐号","Registration_Succeeded":"注册成功","Remember_me":"记住我","Remove":"移除","Remove_Admin":"取消管理员","Remove_as_moderator":"取消会议主席身份","Remove_as_owner":"从所有者中删除","Remove_custom_oauth":"删除自定义 OAuth ","Remove_from_room":"从房间中删除","Remove_someone_from_room":"将某人从房间中删除","Removed":"已删除","Require_password_change":"要求修改密码","Resend_verification_email":"重新发送确认邮件","Reset":"重制","Reset_password":"重设密码","Restart":"重启","Restart_the_server":"重启服务器","RocketBot_Enabled":"启用 RocketBot","RocketBot_Name":"RocketBot 名称","RocketBot_Name_Description":"RocketBot 的名称必须为你服务器上注册的合法用户名","Role":"角色","Role_Editing":"编辑角色","Role_removed":"角色已删除","Room":"聊天室","Room_archivation_state":"状态","Room_archivation_state_false":"活跃","Room_archivation_state_true":"已归档","Room_archived":"已归档房间","room_changed_privacy":"<em>__user_by__</em>将房间类型修改为了：<em>__room_type__</em>","room_changed_topic":"<em>__user_by__</em>将房间主题修改为了：<em>__room_topic__</em>","Room_has_been_deleted":"房间已删除","Room_Info":"房间信息","Room_name_changed":"聊天室名称更改为: <em>__room_name__</em> 由 <em>__user_by__</em> 更改","Room_name_changed_successfully":"聊天室名称变更成功","Room_not_found":"未找到房间","Room_topic_changed_successfully":"已成功修改房间话题","Room_type_changed_successfully":"已成功修改房间类型","Room_unarchived":"已取消房间归档状态","Room_uploaded_file_list":"该房间上传的文件列表","Room_uploaded_file_list_empty":"没有任何文件。","room_user_count":"%s 个用户","Rooms":"房间","S_new_messages_since_s":"%s 新消息，自从 %s","SAML":"SAML","SAML_Custom_Cert":"自定义凭证","SAML_Custom_Entry_point":"自定义入口","SAML_Custom_Generate_Username":"生成用户名","SAML_Custom_Issuer":"自定义 Issuer","SAML_Custom_Provider":"自定义供应商","Save":"保存","Save_changes":"保存修改","Save_Mobile_Bandwidth":"节约移动带宽","Save_to_enable_this_action":"保存以启用该操作","Saved":"已保存","Saving":"保存中","Scope":"范围","Screen_Share":"屏幕共享","Script_Enabled":"启用脚本","Search":"搜索","Search_by_username":"根据用户名搜索","Search_Channels":"搜索频道","Search_Direct_Messages":"搜索直接对话","Search_Messages":"搜索消息","Search_Private_Groups":"搜索私有组","Search_settings":"搜索设置","seconds":"秒","See_all":"查看全部","See_only_online":"只查看在线用户","Select_a_department":"请选择部门","Select_an_avatar":"请选择一个头像","Select_file":"选择文件","Select_service_to_login":"选择服务登录加载您的头像，或直接从您的电脑上传一个","Select_user":"选择用户","Select_users":"选择用户","Selected_agents":"已选择的客服","Selected_users":"选定的成员","Send":"发送","Send_a_message":"发送信息","Send_a_test_mail_to_my_user":"向用户发送测试邮件","Send_a_test_push_to_my_user":"向用户推送测试信息","Send_confirmation_email":"已发送确认电子邮件","Send_data_into_RocketChat_in_realtime":"实时向 Rocket.Chat 发送数据。","Send_email":"发送 E-mail","Send_invitation_email":"发送邀请电子邮件","Send_invitation_email_error":"您还没有提供任何有效的电子邮件地址。","Send_invitation_email_info":"您可以一次发送多个电子邮件邀请。","Send_invitation_email_success":"您已成功发送的邀请电子邮件至以下地址：","Send_invitation_email_warning":"为了发送邀请电子邮件，您必须先配置SMTP设置。","Send_Message":"发送","Send_your_JSON_payloads_to_this_URL":"将你的 JSON 信息发送到这个 URL。","Sending":"发送中","Set_as_moderator":"设置为会议主席","Set_as_owner":"设置为所有者","Settings":"设置","Settings_updated":"设置已更新","Should_be_a_URL_of_an_image":"应当是图片地址。","Should_exists_a_user_with_this_username":"用户必须已存在。","Show_all":"显示全部","Show_more":"显示更多","Show_only_online":"只显示在线用户","Show_preregistration_form":"显示登录前的表单","Showing_archived_results":"<p>显示 <b>%s</b> 已归档结果</p>","Showing_online_users":"显示 __total__ 位用户中的 <b>__total_showing__</b> 位","Showing_results":"<p>显示<b>%s</b>条结果</p>","Silence":"静音","since_creation":"自从 %s","Site_Name":"网站名称","Site_Url":"网站 URL","Site_Url_Description":"例如：https://chat.domain.com/","Skip":"跳过","Smileys_and_People":"笑脸与人像","SMTP":"SMTP","SMTP_Host":"SMTP 主机","SMTP_Password":"SMTP 密码","SMTP_Port":"SMTP 端口","SMTP_Test_Button":"测试 SMTP 设置","SMTP_Username":"SMTP 用户名","Sound":"声音","Star_Message":"标记信息","Starred_Messages":"已标记的信息","Start_audio_call":"开始音频对话","Start_Chat":"开始聊天","Start_of_conversation":"开始交谈","Start_OTR":"开启“无记录对话”","Start_video_call":"开始视频会话","Start_with_s_for_user_or_s_for_channel_Eg_s_or_s":"对于用户，请用 <code class=\"inline\">%s</code> 作为开头；对于频道，请用<code class=\"inline\">%s</code> 作为开头。 示例： <code class=\"inline\">%s</code> or <code class=\"inline\">%s</code>","Statistics":"统计","Stats_Active_Users":"活跃​​用户","Stats_Avg_Channel_Users":"平均频道人数","Stats_Avg_Private_Group_Users":"平均私人组人数","Stats_Away_Users":"离线用户","Stats_Max_Room_Users":"最大的房间人数","Stats_Non_Active_Users":"非活动用户","Stats_Offline_Users":"脱机用户","Stats_Online_Users":"在线用户","Stats_Total_Channels":"频道总数","Stats_Total_Direct_Messages":"点对点发送消息房间数","Stats_Total_Messages":"信息总数","Stats_Total_Private_Groups":"私有组数","Stats_Total_Rooms":"房间总数","Stats_Total_Users":"用户总数","Stop_Recording":"停止录制","strike":"划线","Subject":"标题","Submit":"提交","Success":"成功","Survey":"进行评价","Survey_instructions":"根据问题填写您的满意度，1 代表完全不满意，5 代表非常满意。","Symbols":"符号","Sync_success":"同步成功","Sync_Users":"同步用户","Test_Connection":"测试连接","Test_Desktop_Notifications":"测试桌面通知","Thank_you_for_your_feedback":"非常感谢您的反馈","The_application_name_is_required":"应用名是必填项","The_channel_name_is_required":"频道名是必填项","The_emails_are_being_sent":"已发送 E-mail。","The_field_is_required":"字段 %s 是必填项","The_image_resize_will_not_work_because_we_can_not_detect_ImageMagick_or_GraphicsMagick_installed_in_your_server":"无法裁剪图片，因为没有在服务器上发现 ImageMagick 或者 GraphicsMagick。","The_redirectUri_is_required":"跳转 URI 是必须的","The_server_will_restart_in_s_seconds":"服务器将在 %s 秒后重启","The_setting_s_is_configured_to_s_and_you_are_accessing_from_s":"<strong>%s</strong>已被设置为<strong>%s</strong>。你来自于<strong>%s</strong>！","The_user_will_be_removed_from_s":"该用户将从 %s 中删除","The_user_wont_be_able_to_type_in_s":"该用户将被禁止在 %s房间中发言","Theme":"主题","theme-color-action-buttons-color":"行动按钮颜色","theme-color-active-channel-background-color":"活跃频道背景颜色","theme-color-active-channel-font-color":"活跃频道字体颜色","theme-color-blockquote-background":"引用文本的背景颜色","theme-color-clean-buttons-color":"清楚按钮颜色","theme-color-code-background":"代码块的背景颜色","theme-color-code-border":"代码块的边框颜色","theme-color-code-color":"代码颜色","theme-color-content-background-color":"内容的背景色","theme-color-custom-scrollbar-color":"定制滚动条颜色","theme-color-info-active-font-color":"活跃信息的字体颜色","theme-color-info-font-color":"信息的字体颜色","theme-color-input-font-color":"输入框文字的字体颜色","theme-color-link-font-color":"链接的字体颜色","theme-color-message-hover-background-color":"信息悬停背景色","theme-color-primary-background-color":"主背景色","theme-color-primary-font-color":"主要字体颜色","theme-color-quaternary-font-color":"第四级字体颜色","theme-color-secondary-background-color":"第二背景色","theme-color-secondary-font-color":"第二字体颜色","theme-color-smallprint-font-color":"小号打印字体颜色","theme-color-smallprint-hover-color":"小号打印字体悬停颜色","theme-color-status-away":"离开状态颜色","theme-color-status-busy":"忙碌状态颜色","theme-color-status-offline":"离线状态颜色","theme-color-status-online":"在线状态颜色","theme-color-tertiary-background-color":"第三背景颜色","theme-color-tertiary-font-color":"第三字体颜色","theme-color-unread-notification-color":"未读消息颜色","theme-custom-css":"自定义 CSS","There_are_no_agents_added_to_this_department_yet":"该部门尚未分配任何客服。","There_are_no_integrations":"没有集成功能","There_are_no_users_in_this_role":"该角色没有对应用户。","This_email_has_already_been_used_and_has_not_been_verified__Please_change_your_password":"此邮箱已被使用但未经验证，请修改您的密码。","This_is_a_desktop_notification":"这是一条桌面通知","This_is_a_push_test_messsage":"这是一条测试信息","Time_in_seconds":"以秒记的事件","Title_bar_color":"标题栏颜色","To_install_RocketChat_Livechat_in_your_website_copy_paste_this_code_above_the_last_body_tag_on_your_site":"要在您的网页中使用Rocket.Chat Livechat，请将以下代码复制到您的网页代码中最后一个 <strong>&lt;/body&gt;</strong> 标签之上。","To_users":"为了用户","Topic":"话题","Travel_and_Places":"旅游与地方","Trigger_removed":"已删除触发器","Trigger_Words":"触发词","Triggers":"触发器","True":"是","Type":"类型","Type_your_new_password":"设置新密码","Unarchive":"取消归档","Unmute_someone_in_room":"取消对房间内某人的忽略","Unmute_user":"取消忽略用户","Unnamed":"未命名","Unpin_Message":"取消固定","Unread_Rooms":"未读房间","Unread_Rooms_Mode":"未读房间模式","Unstar_Message":"取消标记","Upload_file_question":"上传文件？","Uploading_file":"文件上传中……","Use_account_preference":"使用账户特性","Use_Emojis":"使用表情","Use_initials_avatar":"使用您用户名的首字母缩写","use_menu":"使用侧边栏来访问你的聊天室","Use_service_avatar":"使用 %s 头像","Use_this_username":"使用此用户名","Use_uploaded_avatar":"使用上传头像","Use_url_for_avatar":"允许头像链接","User__username__is_now_a_moderator_of__room_name_":"用户__username__已经是__room_name__中的会议主席了","User__username__is_now_a_owner_of__room_name_":"用户__username__现在是__room_name__房间的所有者了","User__username__removed_from__room_name__moderators":"已将用户__username__从__room_name__房间会议主席中删除","User__username__removed_from__room_name__owners":"用户已从__room_name__房间的所有者中删除","User_added":"已添加用户 <em>__user_added__</em> 。","User_added_by":" <em>__user_by__</em> 添加了 <em>__user_added__</em> 。","User_added_successfully":"成功添加新用户","User_Channels":"用户频道","User_doesnt_exist":"不存在名为 `@%s` 的用户。","User_has_been_activated":"用户已经激活","User_has_been_deactivated":"用户已停用","User_has_been_deleted":"用户已被删除","User_has_been_muted_in_s":"该用户已在 %s 中被禁言","User_has_been_removed_from_s":"该用户已从 %s 中删除","User_has_disconnected":"用户已离线","User_Info":"用户信息","User_is_no_longer_an_admin":"用户已不再是管理员","User_is_not_activated":"用户未激活","User_is_now_an_admin":"用户已成为管理员","User_joined_channel":"加入了频道。","User_joined_channel_female":"加入了频道。","User_joined_channel_male":"加入了频道。","User_left":"已离开频道。","User_left_female":"用户<em>__user_left__</em>已退出本频道。","User_left_male":"用户<em>__user_left__</em>已退出本频道。","User_logged_out":"用户已注销","User_management":"用户管理","User_muted_by":"用户 <em>__user_muted__</em> 已被 <em>__user_by__</em> 禁止发言。","User_muted_in_room":"已在房间禁止该用户发言","User_not_found":"用户不存在","User_not_found_or_incorrect_password":"用户不存在或密码错误","User_or_channel_name":"用户或者频道名称","User_removed":"用户已被删除","User_removed_by":"用户 <em>__user_removed__</em> 已被 <em>__user_by__</em> 移除。","User_removed_from_room":"用户已从房间中删除","User_Settings":"用户设置","User_unmuted_by":"用户 <em>__user_unmuted__</em> 已被 <em>__user_by__</em> 解除禁言。","User_unmuted_in_room":"已在房间内取消对该用户的忽略","User_updated_successfully":"用户更新成功","Username":"用户名","Username_and_message_must_not_be_empty":"用户名和信息内容都不可为空。","Username_cant_be_empty":"用户名不能为空","Username_Change_Disabled":"Rocket.Chat 服务器的管理员禁止了修改用户名","Username_denied_the_OTR_session":"__username__ 拒绝了“无记录对话”","Username_description":"这个用户名用于让别人在聊天消息中通知您。","Username_doesnt_exist":"用户名 `%s` 不存在。","Username_ended_the_OTR_session":"__username__ 结束了“无记录对话”","Username_invalid":"<strong>%s</strong>不是一个有效的用户名， <br/>只能使用字母，数字，.和_","Username_is_already_in_here":"用户 `@%s` 已存在。","Username_is_not_in_this_room":"用户 `#%s` 不在房间中。","Username_not_found":"用户名不存在","Username_title":"注册用户名","Username_unavaliable":"<strong>%s</strong>已被使用 :(","Username_wants_to_start_otr_Do_you_want_to_accept":"__username__ 要与您开启“无记录对话”，是否接受？","Users":"用户","Users_in_role":"用户存在于该角色","UTF8_Names_Slugify":"着重显示 UTF-8 名字","UTF8_Names_Validation":"UTF-8 姓名验证","UTF8_Names_Validation_Description":"禁止特殊字符和空格。你可以在名字末尾以为的地方使用 -、_ 和 . 。","Verification_email_sent":"已发送确认邮件","View_All":"查看全部","View_Logs":"访问日志","Visibility":"能见度","Visible":"可见","Visitor":"游客","Visitor_page_URL":"访客页面 ","Visitor_time_on_site":"访客的网站浏览时间","Wait_activation_warning":"您的帐户必须由管理员手工启动后才能登录。","We_are_offline_Sorry_for_the_inconvenience":"现在没有人在线，带来不便请您谅解。","We_have_sent_password_email":"我们已经向您发送密码重置的电子邮件。如果您没有收到邮件，请重试。","We_have_sent_registration_email":"我们已经向您发出一封电子邮件，以确认您的注册。如果您没有收到邮件，请重试。","WebRTC_Enable_Channel":"允许公共频道","WebRTC_Enable_Direct":"允许直接信息","WebRTC_Enable_Private":"允许私有频道","WebRTC_Servers":"STUN/TURN 服务器 ","WebRTC_Servers_Description":"用逗号分隔STUN和TURN服务器的列表。 <br/>用户名，密码和端口被允许在格式`用户名：密码@眩晕：主持人：port`或'用户名：密码@转：主持人：port`。","Welcome":"欢迎 <em>%s</em>","Welcome_to_the":"欢迎来到","will_be_able_to":"将能","With_whom":"对象","Yes":"是","Yes_clear_all":"确定清楚所有！","Yes_delete_it":"对的，删除！","Yes_hide_it":"确定，请隐藏！","Yes_leave_it":"确定，现在就离开！","Yes_mute_user":"禁止该用户发言！","Yes_remove_user":"确定删除该用户","you_are_in_preview_mode_of":"您正在预览频道 #<strong>__room_name__</strong>","You_are_logged_in_as":"您已登录为","You_are_not_authorized_to_view_this_page":"您无权查看此页面。","You_are_the_last_owner_Please_set_new_owner_before_leaving_the_room":"你是房间当前的拥有者，想用离开房间请先重设拥有者。","You_can_change_a_different_avatar_too":"您可以覆盖从这次整合后的分身。","You_can_use_an_emoji_as_avatar":"你也可以使用表情符号作为头像。","You_have_been_muted":"你已被禁止发言，因此不能在房间内说话","You_have_not_verified_your_email":"你尚未验证邮箱。","You_have_successfully_unsubscribed":"您已经成功从邮件列表中取消订阅。","You_informed_an_invalid_FROM_address":"您的 FROM 地址无效。","You_must_provide_the_unsubscribe_link":"必须提供［取消订阅］的链接。","You_need_confirm_email":"登录前请验证您的电子邮件！","You_need_install_an_extension_to_allow_screen_sharing":"你需要安装扩展程序才能支持屏幕共享","You_need_to_change_your_password":"你需要修改密码","You_need_to_type_in_your_password_in_order_to_do_this":"执行此操作需要输入您的密码！","You_need_to_type_in_your_username_in_order_to_do_this":"您需要在您的用户名，为了做到这一点打字！","You_need_to_verifiy_your_email_address_to_get_notications":"你需要验证 E-mail 才能收到通知","You_should_name_it_to_easily_manage_your_integrations":"为了方便管理，请给集成功能命名。","You_will_not_be_able_to_recover":"您将无法恢复此信息！","You_will_not_be_able_to_recover_file":"文件将无法恢复！","You_wont_receive_email_notifications_because_you_have_not_verified_your_email":"你还没有验证邮箱，所以将无法收到邮件通知。","Your_email_has_been_queued_for_sending":"您的邮件已发送或正在发送队列中","Your_entry_has_been_deleted":"您的项目已被删除。","Your_file_has_been_deleted":"文件已删除。","Your_mail_was_sent_to_s":"您的邮件发送至 %s","Your_Open_Source_solution":"您自己的开源聊天解决方案","Your_password_is_wrong":"密码错误！","Your_push_was_sent_to_s_devices":"成功向 %s 台设备推送"});
TAPi18n._registerServerTranslator("zh", namespace);                                                                    // 18
                                                                                                                       // 19
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['rocketchat:lib'] = {
  RocketChat: RocketChat
};

})();

//# sourceMappingURL=rocketchat_lib.js.map
